/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/path","vs/base/common/errors","vs/base/common/uri","vs/base/common/network","vs/base/common/event","vs/base/common/types","vs/base/common/platform","vs/base/node/pfs","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/base/common/arrays","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/cancellation","vs/platform/registry/common/platform","vs/platform/configuration/common/configuration","vs/base/common/strings","vs/base/common/errorMessage","vs/base/common/process","vs/platform/telemetry/common/telemetry","vs/base/common/uuid","vs/platform/product/common/productService","vs/platform/configuration/common/configurationRegistry","os","vs/platform/files/common/watcher","vs/platform/telemetry/common/telemetryUtils","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/stream","vs/base/parts/ipc/common/ipc","child_process","vs/platform/instantiation/common/descriptors","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/node/zip","vs/base/common/decorators","vs/base/common/extpath","fs","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/base/common/assert","vs/base/common/json","vs/base/common/processes","vs/base/common/skipList","vs/base/common/console","vs/base/common/marshalling","vs/base/common/labels","vs/base/node/decoder","vs/base/node/extpath","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/parcel/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/map","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/node/spdlogLog","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","path","vs/platform/environment/node/argvHelper","vs/base/node/watcher","vs/base/common/iterator","graceful-fs","crypto","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Y=function(z){for(var t=[],L=0,I=z.length;L<I;L++)t[L]=J[z[L]];return t};define(J[56],Y([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function L(I,b){if(!I)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}t.ok=L}),define(J[46],Y([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function L(T){return(S,l,d)=>{let p=null,C=null;if(typeof d.value=="function"?(p="value",C=d.value):typeof d.get=="function"&&(p="get",C=d.get),!C)throw new Error("not supported");d[p]=T(C,l)}}t.createDecorator=L;function I(T,S,l){let d=null,p=null;if(typeof l.value=="function"?(d="value",p=l.value,p.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(d="get",p=l.get),!p)throw new Error("not supported");const C=`$memoize$${S}`;l[d]=function(...c){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:p.apply(this,c)}),this[C]}}t.memoize=I;function b(T,S,l){return L((d,p)=>{const C=`$debounce$${p}`,c=`$debounce$result$${p}`;return function(...w){this[c]||(this[c]=l?l():void 0),clearTimeout(this[C]),S&&(this[c]=S(this[c],...w),w=[this[c]]),this[C]=setTimeout(()=>{d.apply(this,w),this[c]=l?l():void 0},T)}})}t.debounce=b;function D(T,S,l){return L((d,p)=>{const C=`$throttle$timer$${p}`,c=`$throttle$result$${p}`,w=`$throttle$lastRun$${p}`,u=`$throttle$pending$${p}`;return function(...h){if(this[c]||(this[c]=l?l():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),S&&(this[c]=S(this[c],...h)),this[u])return;const v=this[w]+T;v<=Date.now()?(this[w]=Date.now(),d.apply(this,[this[c]]),this[c]=l?l():void 0):(this[u]=!0,this[C]=setTimeout(()=>{this[u]=!1,this[w]=Date.now(),d.apply(this,[this[c]]),this[c]=l?l():void 0},v-Date.now()))}})}t.throttle=D}),define(J[57],Y([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var L;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(L=t.ScanError||(t.ScanError={}));var I;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(I=t.SyntaxKind||(t.SyntaxKind={}));var b;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(b=t.ParseErrorCode||(t.ParseErrorCode={}));var D;(function(e){e.DEFAULT={allowTrailingComma:!0}})(D=t.ParseOptions||(t.ParseOptions={}));function T(e,r=!1){let i=0,n=e.length,a="",g=0,y=16,R=0;function P(ne){let de=0,x=0;for(;de<ne;){const H=e.charCodeAt(i);if(H>=48&&H<=57)x=x*16+H-48;else if(H>=65&&H<=70)x=x*16+H-65+10;else if(H>=97&&H<=102)x=x*16+H-97+10;else break;i++,de++}return de<ne&&(x=-1),x}function O(ne){i=ne,a="",g=0,y=16,R=0}function U(){const ne=i;if(e.charCodeAt(i)===48)i++;else for(i++;i<e.length&&d(e.charCodeAt(i));)i++;if(i<e.length&&e.charCodeAt(i)===46)if(i++,i<e.length&&d(e.charCodeAt(i)))for(i++;i<e.length&&d(e.charCodeAt(i));)i++;else return R=3,e.substring(ne,i);let de=i;if(i<e.length&&(e.charCodeAt(i)===69||e.charCodeAt(i)===101))if(i++,(i<e.length&&e.charCodeAt(i)===43||e.charCodeAt(i)===45)&&i++,i<e.length&&d(e.charCodeAt(i))){for(i++;i<e.length&&d(e.charCodeAt(i));)i++;de=i}else R=3;return e.substring(ne,de)}function q(){let ne="",de=i;for(;;){if(i>=n){ne+=e.substring(de,i),R=2;break}const x=e.charCodeAt(i);if(x===34){ne+=e.substring(de,i),i++;break}if(x===92){if(ne+=e.substring(de,i),i++,i>=n){R=2;break}switch(e.charCodeAt(i++)){case 34:ne+='"';break;case 92:ne+="\\";break;case 47:ne+="/";break;case 98:ne+="\b";break;case 102:ne+="\f";break;case 110:ne+=`
`;break;case 114:ne+="\r";break;case 116:ne+="	";break;case 117:const re=P(4);re>=0?ne+=String.fromCharCode(re):R=4;break;default:R=5}de=i;continue}if(x>=0&&x<=31)if(l(x)){ne+=e.substring(de,i),R=2;break}else R=6;i++}return ne}function te(){if(a="",R=0,g=i,i>=n)return g=n,y=17;let ne=e.charCodeAt(i);if(S(ne)){do i++,a+=String.fromCharCode(ne),ne=e.charCodeAt(i);while(S(ne));return y=15}if(l(ne))return i++,a+=String.fromCharCode(ne),ne===13&&e.charCodeAt(i)===10&&(i++,a+=`
`),y=14;switch(ne){case 123:return i++,y=1;case 125:return i++,y=2;case 91:return i++,y=3;case 93:return i++,y=4;case 58:return i++,y=6;case 44:return i++,y=5;case 34:return i++,a=q(),y=10;case 47:const de=i-1;if(e.charCodeAt(i+1)===47){for(i+=2;i<n&&!l(e.charCodeAt(i));)i++;return a=e.substring(de,i),y=12}if(e.charCodeAt(i+1)===42){i+=2;const x=n-1;let H=!1;for(;i<x;){if(e.charCodeAt(i)===42&&e.charCodeAt(i+1)===47){i+=2,H=!0;break}i++}return H||(i++,R=1),a=e.substring(de,i),y=13}return a+=String.fromCharCode(ne),i++,y=16;case 45:if(a+=String.fromCharCode(ne),i++,i===n||!d(e.charCodeAt(i)))return y=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=U(),y=11;default:for(;i<n&&ce(ne);)i++,ne=e.charCodeAt(i);if(g!==i){switch(a=e.substring(g,i),a){case"true":return y=8;case"false":return y=9;case"null":return y=7}return y=16}return a+=String.fromCharCode(ne),i++,y=16}}function ce(ne){if(S(ne)||l(ne))return!1;switch(ne){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function le(){let ne;do ne=te();while(ne>=12&&ne<=15);return ne}return{setPosition:O,getPosition:()=>i,scan:r?le:te,getToken:()=>y,getTokenValue:()=>a,getTokenOffset:()=>g,getTokenLength:()=>i-g,getTokenError:()=>R}}t.createScanner=T;function S(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function l(e){return e===10||e===13||e===8232||e===8233}function d(e){return e>=48&&e<=57}var p;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(p||(p={}));function C(e,r){const i=[],n=new Object;let a;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let y=!1;function R(P,O,U,q){g.value=P,g.offset=O,g.length=U,g.type=q,g.colonOffset=void 0,a=g}try{f(e,{onObjectBegin:(P,O)=>{if(r<=P)throw n;a=void 0,y=r>P,i.push("")},onObjectProperty:(P,O,U)=>{if(r<O||(R(P,O,U,"property"),i[i.length-1]=P,r<=O+U))throw n},onObjectEnd:(P,O)=>{if(r<=P)throw n;a=void 0,i.pop()},onArrayBegin:(P,O)=>{if(r<=P)throw n;a=void 0,i.push(0)},onArrayEnd:(P,O)=>{if(r<=P)throw n;a=void 0,i.pop()},onLiteralValue:(P,O,U)=>{if(r<O||(R(P,O,U,o(P)),r<=O+U))throw n},onSeparator:(P,O,U)=>{if(r<=O)throw n;if(P===":"&&a&&a.type==="property")a.colonOffset=O,y=!1,a=void 0;else if(P===","){const q=i[i.length-1];typeof q=="number"?i[i.length-1]=q+1:(y=!0,i[i.length-1]=""),a=void 0}}})}catch(P){if(P!==n)throw P}return{path:i,previousNode:a,isAtPropertyKey:y,matches:P=>{let O=0;for(let U=0;O<P.length&&U<i.length;U++)if(P[O]===i[U]||P[O]==="*")O++;else if(P[O]!=="**")return!1;return O===P.length}}}t.getLocation=C;function c(e,r=[],i=D.DEFAULT){let n=null,a=[];const g=[];function y(P){Array.isArray(a)?a.push(P):n!==null&&(a[n]=P)}return f(e,{onObjectBegin:()=>{const P={};y(P),g.push(a),a=P,n=null},onObjectProperty:P=>{n=P},onObjectEnd:()=>{a=g.pop()},onArrayBegin:()=>{const P=[];y(P),g.push(a),a=P,n=null},onArrayEnd:()=>{a=g.pop()},onLiteralValue:y,onError:(P,O,U)=>{r.push({error:P,offset:O,length:U})}},i),a[0]}t.parse=c;function w(e,r=[],i=D.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(P){n.type==="property"&&(n.length=P-n.offset,n=n.parent)}function g(P){return n.children.push(P),P}f(e,{onObjectBegin:P=>{n=g({type:"object",offset:P,length:-1,parent:n,children:[]})},onObjectProperty:(P,O,U)=>{n=g({type:"property",offset:O,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:P,offset:O,length:U,parent:n})},onObjectEnd:(P,O)=>{n.length=P+O-n.offset,n=n.parent,a(P+O)},onArrayBegin:(P,O)=>{n=g({type:"array",offset:P,length:-1,parent:n,children:[]})},onArrayEnd:(P,O)=>{n.length=P+O-n.offset,n=n.parent,a(P+O)},onLiteralValue:(P,O,U)=>{g({type:o(P),offset:O,length:U,parent:n,value:P}),a(O+U)},onSeparator:(P,O,U)=>{n.type==="property"&&(P===":"?n.colonOffset=O:P===","&&a(O))},onError:(P,O,U)=>{r.push({error:P,offset:O,length:U})}},i);const R=n.children[0];return R&&delete R.parent,R}t.parseTree=w;function u(e,r){if(!e)return;let i=e;for(let n of r)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let a=!1;for(const g of i.children)if(Array.isArray(g.children)&&g.children[0].value===n){i=g.children[1],a=!0;break}if(!a)return}else{const a=n;if(i.type!=="array"||a<0||!Array.isArray(i.children)||a>=i.children.length)return;i=i.children[a]}return i}t.findNodeAtLocation=u;function h(e){if(!e.parent||!e.parent.children)return[];const r=h(e.parent);if(e.parent.type==="property"){const i=e.parent.children[0].value;r.push(i)}else if(e.parent.type==="array"){const i=e.parent.children.indexOf(e);i!==-1&&r.push(i)}return r}t.getNodePath=h;function v(e){switch(e.type){case"array":return e.children.map(v);case"object":const r=Object.create(null);for(let i of e.children){const n=i.children[1];n&&(r[i.children[0].value]=v(n))}return r;case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=v;function m(e,r,i=!1){return r>=e.offset&&r<e.offset+e.length||i&&r===e.offset+e.length}t.contains=m;function E(e,r,i=!1){if(m(e,r,i)){const n=e.children;if(Array.isArray(n))for(let a=0;a<n.length&&n[a].offset<=r;a++){const g=E(n[a],r,i);if(g)return g}return e}}t.findNodeAtOffset=E;function f(e,r,i=D.DEFAULT){const n=T(e,!1);function a(X){return X?()=>X(n.getTokenOffset(),n.getTokenLength()):()=>!0}function g(X){return X?Z=>X(Z,n.getTokenOffset(),n.getTokenLength()):()=>!0}const y=a(r.onObjectBegin),R=g(r.onObjectProperty),P=a(r.onObjectEnd),O=a(r.onArrayBegin),U=a(r.onArrayEnd),q=g(r.onLiteralValue),te=g(r.onSeparator),ce=a(r.onComment),le=g(r.onError),ne=i&&i.disallowComments,de=i&&i.allowTrailingComma;function x(){for(;;){const X=n.scan();switch(n.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:ne||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(X){case 12:case 13:ne?H(10):ce();break;case 16:H(1);break;case 15:case 14:break;default:return X}}}function H(X,Z=[],_=[]){if(le(X),Z.length+_.length>0){let N=n.getToken();for(;N!==17;){if(Z.indexOf(N)!==-1){x();break}else if(_.indexOf(N)!==-1)break;N=x()}}}function re(X){const Z=n.getTokenValue();return X?q(Z):R(Z),x(),!0}function M(){switch(n.getToken()){case 11:let X=0;try{X=JSON.parse(n.getTokenValue()),typeof X!="number"&&(H(2),X=0)}catch(Z){H(2)}q(X);break;case 7:q(null);break;case 8:q(!0);break;case 9:q(!1);break;default:return!1}return x(),!0}function k(){return n.getToken()!==10?(H(3,[],[2,5]),!1):(re(!1),n.getToken()===6?(te(":"),x(),ee()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function W(){y(),x();let X=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(X||H(4,[],[]),te(","),x(),n.getToken()===2&&de)break}else X&&H(6,[],[]);k()||H(4,[],[2,5]),X=!0}return P(),n.getToken()!==2?H(7,[2],[]):x(),!0}function G(){O(),x();let X=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(X||H(4,[],[]),te(","),x(),n.getToken()===4&&de)break}else X&&H(6,[],[]);ee()||H(4,[],[4,5]),X=!0}return U(),n.getToken()!==4?H(8,[4],[]):x(),!0}function ee(){switch(n.getToken()){case 3:return G();case 1:return W();case 10:return re(!0);default:return M()}}return x(),n.getToken()===17?i.allowEmptyContent?!0:(H(4,[],[]),!1):ee()?(n.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}t.visit=f;function s(e,r){let i=T(e),n=[],a,g=0,y;do switch(y=i.getPosition(),a=i.scan(),a){case 12:case 13:case 17:g!==y&&n.push(e.substring(g,y)),r!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,r)),g=i.getPosition();break}while(a!==17);return n.join("")}t.stripComments=s;function o(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=o}),function(){function z(b){const D=[];typeof b=="number"&&D.push("code/timeOrigin",b);function T(l){D.push(l,Date.now())}function S(){const l=[];for(let d=0;d<D.length;d+=2)l.push({name:D[d],startTime:D[d+1]});return l}return{mark:T,getMarks:S}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?z():{mark(b){performance.mark(b)},getMarks(){let b=performance.timeOrigin;typeof b!="number"&&(b=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(b)}];for(const T of performance.getEntriesByType("mark"))D.push({name:T.name,startTime:Math.round(b+T.startTime)});return D}};if(typeof process=="object"){const b=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return z(b)}else return console.trace("perf-util loaded in UNKNOWN environment"),z()}function L(b){return b.MonacoPerformanceMarks||(b.MonacoPerformanceMarks=t()),b.MonacoPerformanceMarks}var I;typeof global=="object"?I=global:typeof self=="object"?I=self:I={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(I)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(I):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),I.perf=L(I))}(),define(J[58],Y([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.sanitizeProcessEnvironment=t.TerminateResponseCode=t.Source=void 0;var L;(function(D){D[D.stdout=0]="stdout",D[D.stderr=1]="stderr"})(L=t.Source||(t.Source={}));var I;(function(D){D[D.Success=0]="Success",D[D.Unknown=1]="Unknown",D[D.AccessDenied=2]="AccessDenied",D[D.ProcessNotFound=3]="ProcessNotFound"})(I=t.TerminateResponseCode||(t.TerminateResponseCode={}));function b(D,...T){const S=T.reduce((p,C)=>(p[C]=!0,p),{}),l=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(D).filter(p=>!S[p]).forEach(p=>{for(let C=0;C<l.length;C++)if(p.search(l[C])!==-1){delete D[p];break}})}t.sanitizeProcessEnvironment=b}),function(z,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var L=t();for(var I in L)(typeof exports=="object"?exports:z)[I]=L[I]}}(typeof self!="undefined"?self:this,function(){return function(z){var t={};function L(I){if(t[I])return t[I].exports;var b=t[I]={i:I,l:!1,exports:{}};return z[I].call(b.exports,b,b.exports,L),b.l=!0,b.exports}return L.m=z,L.c=t,L.d=function(I,b,D){L.o(I,b)||Object.defineProperty(I,b,{enumerable:!0,get:D})},L.r=function(I){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(I,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(I,"__esModule",{value:!0})},L.t=function(I,b){if(1&b&&(I=L(I)),8&b||4&b&&typeof I=="object"&&I&&I.__esModule)return I;var D=Object.create(null);if(L.r(D),Object.defineProperty(D,"default",{enumerable:!0,value:I}),2&b&&typeof I!="string")for(var T in I)L.d(D,T,function(S){return I[S]}.bind(null,T));return D},L.n=function(I){var b=I&&I.__esModule?function(){return I.default}:function(){return I};return L.d(b,"a",b),b},L.o=function(I,b){return Object.prototype.hasOwnProperty.call(I,b)},L.p="",L(L.s=0)}([function(z,t,L){(function(I){var b;t=z.exports=_,b=typeof I=="object"&&I.env&&I.env.NODE_DEBUG&&/\bsemver\b/i.test(I.env.NODE_DEBUG)?function(){var F=Array.prototype.slice.call(arguments,0);F.unshift("SEMVER"),console.log.apply(console,F)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var D=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,S=t.re=[],l=t.src=[],d=0,p=d++;l[p]="0|[1-9]\\d*";var C=d++;l[C]="[0-9]+";var c=d++;l[c]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=d++;l[w]="("+l[p]+")\\.("+l[p]+")\\.("+l[p]+")";var u=d++;l[u]="("+l[C]+")\\.("+l[C]+")\\.("+l[C]+")";var h=d++;l[h]="(?:"+l[p]+"|"+l[c]+")";var v=d++;l[v]="(?:"+l[C]+"|"+l[c]+")";var m=d++;l[m]="(?:-("+l[h]+"(?:\\."+l[h]+")*))";var E=d++;l[E]="(?:-?("+l[v]+"(?:\\."+l[v]+")*))";var f=d++;l[f]="[0-9A-Za-z-]+";var s=d++;l[s]="(?:\\+("+l[f]+"(?:\\."+l[f]+")*))";var o=d++,e="v?"+l[w]+l[m]+"?"+l[s]+"?";l[o]="^"+e+"$";var r="[v=\\s]*"+l[u]+l[E]+"?"+l[s]+"?",i=d++;l[i]="^"+r+"$";var n=d++;l[n]="((?:<|>)?=?)";var a=d++;l[a]=l[C]+"|x|X|\\*";var g=d++;l[g]=l[p]+"|x|X|\\*";var y=d++;l[y]="[v=\\s]*("+l[g]+")(?:\\.("+l[g]+")(?:\\.("+l[g]+")(?:"+l[m]+")?"+l[s]+"?)?)?";var R=d++;l[R]="[v=\\s]*("+l[a]+")(?:\\.("+l[a]+")(?:\\.("+l[a]+")(?:"+l[E]+")?"+l[s]+"?)?)?";var P=d++;l[P]="^"+l[n]+"\\s*"+l[y]+"$";var O=d++;l[O]="^"+l[n]+"\\s*"+l[R]+"$";var U=d++;l[U]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var q=d++;l[q]="(?:~>?)";var te=d++;l[te]="(\\s*)"+l[q]+"\\s+",S[te]=new RegExp(l[te],"g");var ce=d++;l[ce]="^"+l[q]+l[y]+"$";var le=d++;l[le]="^"+l[q]+l[R]+"$";var ne=d++;l[ne]="(?:\\^)";var de=d++;l[de]="(\\s*)"+l[ne]+"\\s+",S[de]=new RegExp(l[de],"g");var x=d++;l[x]="^"+l[ne]+l[y]+"$";var H=d++;l[H]="^"+l[ne]+l[R]+"$";var re=d++;l[re]="^"+l[n]+"\\s*("+r+")$|^$";var M=d++;l[M]="^"+l[n]+"\\s*("+e+")$|^$";var k=d++;l[k]="(\\s*)"+l[n]+"\\s*("+r+"|"+l[y]+")",S[k]=new RegExp(l[k],"g");var W=d++;l[W]="^\\s*("+l[y]+")\\s+-\\s+("+l[y]+")\\s*$";var G=d++;l[G]="^\\s*("+l[R]+")\\s+-\\s+("+l[R]+")\\s*$";var ee=d++;l[ee]="(<|>)?=?\\s*\\*";for(var X=0;X<35;X++)b(X,l[X]),S[X]||(S[X]=new RegExp(l[X]));function Z(F,j){if(F instanceof _)return F;if(typeof F!="string"||F.length>D||!(j?S[i]:S[o]).test(F))return null;try{return new _(F,j)}catch($){return null}}function _(F,j){if(F instanceof _){if(F.loose===j)return F;F=F.version}else if(typeof F!="string")throw new TypeError("Invalid Version: "+F);if(F.length>D)throw new TypeError("version is longer than "+D+" characters");if(!(this instanceof _))return new _(F,j);b("SemVer",F,j),this.loose=j;var $=F.trim().match(j?S[i]:S[o]);if(!$)throw new TypeError("Invalid Version: "+F);if(this.raw=F,this.major=+$[1],this.minor=+$[2],this.patch=+$[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");$[4]?this.prerelease=$[4].split(".").map(function(ae){if(/^[0-9]+$/.test(ae)){var fe=+ae;if(fe>=0&&fe<T)return fe}return ae}):this.prerelease=[],this.build=$[5]?$[5].split("."):[],this.format()}t.parse=Z,t.valid=function(F,j){var $=Z(F,j);return $?$.version:null},t.clean=function(F,j){var $=Z(F.trim().replace(/^[=v]+/,""),j);return $?$.version:null},t.SemVer=_,_.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},_.prototype.toString=function(){return this.version},_.prototype.compare=function(F){return b("SemVer.compare",this.version,this.loose,F),F instanceof _||(F=new _(F,this.loose)),this.compareMain(F)||this.comparePre(F)},_.prototype.compareMain=function(F){return F instanceof _||(F=new _(F,this.loose)),A(this.major,F.major)||A(this.minor,F.minor)||A(this.patch,F.patch)},_.prototype.comparePre=function(F){if(F instanceof _||(F=new _(F,this.loose)),this.prerelease.length&&!F.prerelease.length)return-1;if(!this.prerelease.length&&F.prerelease.length)return 1;if(!this.prerelease.length&&!F.prerelease.length)return 0;var j=0;do{var $=this.prerelease[j],ae=F.prerelease[j];if(b("prerelease compare",j,$,ae),$===void 0&&ae===void 0)return 0;if(ae===void 0)return 1;if($===void 0)return-1;if($!==ae)return A($,ae)}while(++j)},_.prototype.inc=function(F,j){switch(F){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",j);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",j);break;case"prepatch":this.prerelease.length=0,this.inc("patch",j),this.inc("pre",j);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",j),this.inc("pre",j);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var $=this.prerelease.length;--$>=0;)typeof this.prerelease[$]=="number"&&(this.prerelease[$]++,$=-2);$===-1&&this.prerelease.push(0)}j&&(this.prerelease[0]===j?isNaN(this.prerelease[1])&&(this.prerelease=[j,0]):this.prerelease=[j,0]);break;default:throw new Error("invalid increment argument: "+F)}return this.format(),this.raw=this.version,this},t.inc=function(F,j,$,ae){typeof $=="string"&&(ae=$,$=void 0);try{return new _(F,$).inc(j,ae).version}catch(fe){return null}},t.diff=function(F,j){if(Q(F,j))return null;var $=Z(F),ae=Z(j);if($.prerelease.length||ae.prerelease.length){for(var fe in $)if((fe==="major"||fe==="minor"||fe==="patch")&&$[fe]!==ae[fe])return"pre"+fe;return"prerelease"}for(var fe in $)if((fe==="major"||fe==="minor"||fe==="patch")&&$[fe]!==ae[fe])return fe},t.compareIdentifiers=A;var N=/^[0-9]+$/;function A(F,j){var $=N.test(F),ae=N.test(j);return $&&ae&&(F=+F,j=+j),$&&!ae?-1:ae&&!$?1:F<j?-1:F>j?1:0}function B(F,j,$){return new _(F,$).compare(new _(j,$))}function V(F,j,$){return B(F,j,$)>0}function K(F,j,$){return B(F,j,$)<0}function Q(F,j,$){return B(F,j,$)===0}function se(F,j,$){return B(F,j,$)!==0}function ie(F,j,$){return B(F,j,$)>=0}function me(F,j,$){return B(F,j,$)<=0}function ye(F,j,$,ae){var fe;switch(j){case"===":typeof F=="object"&&(F=F.version),typeof $=="object"&&($=$.version),fe=F===$;break;case"!==":typeof F=="object"&&(F=F.version),typeof $=="object"&&($=$.version),fe=F!==$;break;case"":case"=":case"==":fe=Q(F,$,ae);break;case"!=":fe=se(F,$,ae);break;case">":fe=V(F,$,ae);break;case">=":fe=ie(F,$,ae);break;case"<":fe=K(F,$,ae);break;case"<=":fe=me(F,$,ae);break;default:throw new TypeError("Invalid operator: "+j)}return fe}function ue(F,j){if(F instanceof ue){if(F.loose===j)return F;F=F.value}if(!(this instanceof ue))return new ue(F,j);b("comparator",F,j),this.loose=j,this.parse(F),this.semver===Ie?this.value="":this.value=this.operator+this.semver.version,b("comp",this)}t.rcompareIdentifiers=function(F,j){return A(j,F)},t.major=function(F,j){return new _(F,j).major},t.minor=function(F,j){return new _(F,j).minor},t.patch=function(F,j){return new _(F,j).patch},t.compare=B,t.compareLoose=function(F,j){return B(F,j,!0)},t.rcompare=function(F,j,$){return B(j,F,$)},t.sort=function(F,j){return F.sort(function($,ae){return t.compare($,ae,j)})},t.rsort=function(F,j){return F.sort(function($,ae){return t.rcompare($,ae,j)})},t.gt=V,t.lt=K,t.eq=Q,t.neq=se,t.gte=ie,t.lte=me,t.cmp=ye,t.Comparator=ue;var Ie={};function ve(F,j){if(F instanceof ve)return F.loose===j?F:new ve(F.raw,j);if(F instanceof ue)return new ve(F.value,j);if(!(this instanceof ve))return new ve(F,j);if(this.loose=j,this.raw=F,this.set=F.split(/\s*\|\|\s*/).map(function($){return this.parseRange($.trim())},this).filter(function($){return $.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+F);this.format()}function Ee(F){return!F||F.toLowerCase()==="x"||F==="*"}function Fe(F,j,$,ae,fe,Ce,we,Oe,Pe,Re,Ne,De,Te){return((j=Ee($)?"":Ee(ae)?">="+$+".0.0":Ee(fe)?">="+$+"."+ae+".0":">="+j)+" "+(Oe=Ee(Pe)?"":Ee(Re)?"<"+(+Pe+1)+".0.0":Ee(Ne)?"<"+Pe+"."+(+Re+1)+".0":De?"<="+Pe+"."+Re+"."+Ne+"-"+De:"<="+Oe)).trim()}function Me(F,j){for(var $=0;$<F.length;$++)if(!F[$].test(j))return!1;if(j.prerelease.length){for($=0;$<F.length;$++)if(b(F[$].semver),F[$].semver!==Ie&&F[$].semver.prerelease.length>0){var ae=F[$].semver;if(ae.major===j.major&&ae.minor===j.minor&&ae.patch===j.patch)return!0}return!1}return!0}function ze(F,j,$){try{j=new ve(j,$)}catch(ae){return!1}return j.test(F)}function xe(F,j,$,ae){var fe,Ce,we,Oe,Pe;switch(F=new _(F,ae),j=new ve(j,ae),$){case">":fe=V,Ce=me,we=K,Oe=">",Pe=">=";break;case"<":fe=K,Ce=ie,we=V,Oe="<",Pe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(F,j,ae))return!1;for(var Re=0;Re<j.set.length;++Re){var Ne=j.set[Re],De=null,Te=null;if(Ne.forEach(function(ke){ke.semver===Ie&&(ke=new ue(">=0.0.0")),De=De||ke,Te=Te||ke,fe(ke.semver,De.semver,ae)?De=ke:we(ke.semver,Te.semver,ae)&&(Te=ke)}),De.operator===Oe||De.operator===Pe||(!Te.operator||Te.operator===Oe)&&Ce(F,Te.semver)||Te.operator===Pe&&we(F,Te.semver))return!1}return!0}ue.prototype.parse=function(F){var j=this.loose?S[re]:S[M],$=F.match(j);if(!$)throw new TypeError("Invalid comparator: "+F);this.operator=$[1],this.operator==="="&&(this.operator=""),$[2]?this.semver=new _($[2],this.loose):this.semver=Ie},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(F){return b("Comparator.test",F,this.loose),this.semver===Ie||(typeof F=="string"&&(F=new _(F,this.loose)),ye(F,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(F,j){if(!(F instanceof ue))throw new TypeError("a Comparator is required");var $;if(this.operator==="")return $=new ve(F.value,j),ze(this.value,$,j);if(F.operator==="")return $=new ve(this.value,j),ze(F.semver,$,j);var ae=!(this.operator!==">="&&this.operator!==">"||F.operator!==">="&&F.operator!==">"),fe=!(this.operator!=="<="&&this.operator!=="<"||F.operator!=="<="&&F.operator!=="<"),Ce=this.semver.version===F.semver.version,we=!(this.operator!==">="&&this.operator!=="<="||F.operator!==">="&&F.operator!=="<="),Oe=ye(this.semver,"<",F.semver,j)&&(this.operator===">="||this.operator===">")&&(F.operator==="<="||F.operator==="<"),Pe=ye(this.semver,">",F.semver,j)&&(this.operator==="<="||this.operator==="<")&&(F.operator===">="||F.operator===">");return ae||fe||Ce&&we||Oe||Pe},t.Range=ve,ve.prototype.format=function(){return this.range=this.set.map(function(F){return F.join(" ").trim()}).join("||").trim(),this.range},ve.prototype.toString=function(){return this.range},ve.prototype.parseRange=function(F){var j=this.loose;F=F.trim(),b("range",F,j);var $=j?S[G]:S[W];F=F.replace($,Fe),b("hyphen replace",F),F=F.replace(S[k],"$1$2$3"),b("comparator trim",F,S[k]),F=(F=(F=F.replace(S[te],"$1~")).replace(S[de],"$1^")).split(/\s+/).join(" ");var ae=j?S[re]:S[M],fe=F.split(" ").map(function(Ce){return function(we,Oe){return b("comp",we),we=function(Pe,Re){return Pe.trim().split(/\s+/).map(function(Ne){return function(De,Te){b("caret",De,Te);var ke=Te?S[H]:S[x];return De.replace(ke,function(Ae,ge,pe,Se,be){var Le;return b("caret",De,Ae,ge,pe,Se,be),Ee(ge)?Le="":Ee(pe)?Le=">="+ge+".0.0 <"+(+ge+1)+".0.0":Ee(Se)?Le=ge==="0"?">="+ge+"."+pe+".0 <"+ge+"."+(+pe+1)+".0":">="+ge+"."+pe+".0 <"+(+ge+1)+".0.0":be?(b("replaceCaret pr",be),be.charAt(0)!=="-"&&(be="-"+be),Le=ge==="0"?pe==="0"?">="+ge+"."+pe+"."+Se+be+" <"+ge+"."+pe+"."+(+Se+1):">="+ge+"."+pe+"."+Se+be+" <"+ge+"."+(+pe+1)+".0":">="+ge+"."+pe+"."+Se+be+" <"+(+ge+1)+".0.0"):(b("no pr"),Le=ge==="0"?pe==="0"?">="+ge+"."+pe+"."+Se+" <"+ge+"."+pe+"."+(+Se+1):">="+ge+"."+pe+"."+Se+" <"+ge+"."+(+pe+1)+".0":">="+ge+"."+pe+"."+Se+" <"+(+ge+1)+".0.0"),b("caret return",Le),Le})}(Ne,Re)}).join(" ")}(we,Oe),b("caret",we),we=function(Pe,Re){return Pe.trim().split(/\s+/).map(function(Ne){return function(De,Te){var ke=Te?S[le]:S[ce];return De.replace(ke,function(Ae,ge,pe,Se,be){var Le;return b("tilde",De,Ae,ge,pe,Se,be),Ee(ge)?Le="":Ee(pe)?Le=">="+ge+".0.0 <"+(+ge+1)+".0.0":Ee(Se)?Le=">="+ge+"."+pe+".0 <"+ge+"."+(+pe+1)+".0":be?(b("replaceTilde pr",be),be.charAt(0)!=="-"&&(be="-"+be),Le=">="+ge+"."+pe+"."+Se+be+" <"+ge+"."+(+pe+1)+".0"):Le=">="+ge+"."+pe+"."+Se+" <"+ge+"."+(+pe+1)+".0",b("tilde return",Le),Le})}(Ne,Re)}).join(" ")}(we,Oe),b("tildes",we),we=function(Pe,Re){return b("replaceXRanges",Pe,Re),Pe.split(/\s+/).map(function(Ne){return function(De,Te){De=De.trim();var ke=Te?S[O]:S[P];return De.replace(ke,function(Ae,ge,pe,Se,be,Le){b("xRange",De,Ae,ge,pe,Se,be,Le);var We=Ee(pe),Ve=We||Ee(Se),je=Ve||Ee(be);return ge==="="&&je&&(ge=""),We?Ae=ge===">"||ge==="<"?"<0.0.0":"*":ge&&je?(Ve&&(Se=0),je&&(be=0),ge===">"?(ge=">=",Ve?(pe=+pe+1,Se=0,be=0):je&&(Se=+Se+1,be=0)):ge==="<="&&(ge="<",Ve?pe=+pe+1:Se=+Se+1),Ae=ge+pe+"."+Se+"."+be):Ve?Ae=">="+pe+".0.0 <"+(+pe+1)+".0.0":je&&(Ae=">="+pe+"."+Se+".0 <"+pe+"."+(+Se+1)+".0"),b("xRange return",Ae),Ae})}(Ne,Re)}).join(" ")}(we,Oe),b("xrange",we),we=function(Pe,Re){return b("replaceStars",Pe,Re),Pe.trim().replace(S[ee],"")}(we,Oe),b("stars",we),we}(Ce,j)}).join(" ").split(/\s+/);return this.loose&&(fe=fe.filter(function(Ce){return!!Ce.match(ae)})),fe=fe.map(function(Ce){return new ue(Ce,j)})},ve.prototype.intersects=function(F,j){if(!(F instanceof ve))throw new TypeError("a Range is required");return this.set.some(function($){return $.every(function(ae){return F.set.some(function(fe){return fe.every(function(Ce){return ae.intersects(Ce,j)})})})})},t.toComparators=function(F,j){return new ve(F,j).set.map(function($){return $.map(function(ae){return ae.value}).join(" ").trim().split(" ")})},ve.prototype.test=function(F){if(!F)return!1;typeof F=="string"&&(F=new _(F,this.loose));for(var j=0;j<this.set.length;j++)if(Me(this.set[j],F))return!0;return!1},t.satisfies=ze,t.maxSatisfying=function(F,j,$){var ae=null,fe=null;try{var Ce=new ve(j,$)}catch(we){return null}return F.forEach(function(we){Ce.test(we)&&(ae&&fe.compare(we)!==-1||(fe=new _(ae=we,$)))}),ae},t.minSatisfying=function(F,j,$){var ae=null,fe=null;try{var Ce=new ve(j,$)}catch(we){return null}return F.forEach(function(we){Ce.test(we)&&(ae&&fe.compare(we)!==1||(fe=new _(ae=we,$)))}),ae},t.validRange=function(F,j){try{return new ve(F,j).range||"*"}catch($){return null}},t.ltr=function(F,j,$){return xe(F,j,"<",$)},t.gtr=function(F,j,$){return xe(F,j,">",$)},t.outside=xe,t.prerelease=function(F,j){var $=Z(F,j);return $&&$.prerelease.length?$.prerelease:null},t.intersects=function(F,j,$){return F=new ve(F,$),j=new ve(j,$),F.intersects(j)},t.coerce=function(F){if(F instanceof _)return F;if(typeof F!="string")return null;var j=F.match(S[U]);return j==null?null:Z((j[1]||"0")+"."+(j[2]||"0")+"."+(j[3]||"0"))}}).call(this,L(1))},function(z,t){var L,I,b=z.exports={};function D(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function S(v){if(L===setTimeout)return setTimeout(v,0);if((L===D||!L)&&setTimeout)return L=setTimeout,setTimeout(v,0);try{return L(v,0)}catch(m){try{return L.call(null,v,0)}catch(E){return L.call(this,v,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:D}catch(v){L=D}try{I=typeof clearTimeout=="function"?clearTimeout:T}catch(v){I=T}})();var l,d=[],p=!1,C=-1;function c(){p&&l&&(p=!1,l.length?d=l.concat(d):C=-1,d.length&&w())}function w(){if(!p){var v=S(c);p=!0;for(var m=d.length;m;){for(l=d,d=[];++C<m;)l&&l[C].run();C=-1,m=d.length}l=null,p=!1,function(E){if(I===clearTimeout)return clearTimeout(E);if((I===T||!I)&&clearTimeout)return I=clearTimeout,clearTimeout(E);try{I(E)}catch(f){try{return I.call(null,E)}catch(s){return I.call(this,E)}}}(v)}}function u(v,m){this.fun=v,this.array=m}function h(){}b.nextTick=function(v){var m=new Array(arguments.length-1);if(arguments.length>1)for(var E=1;E<arguments.length;E++)m[E-1]=arguments[E];d.push(new u(v,m)),d.length!==1||p||S(w)},u.prototype.run=function(){this.fun.apply(null,this.array)},b.title="browser",b.browser=!0,b.env={},b.argv=[],b.version="",b.versions={},b.on=h,b.addListener=h,b.once=h,b.off=h,b.removeListener=h,b.removeAllListeners=h,b.emit=h,b.prependListener=h,b.prependOnceListener=h,b.listeners=function(v){return[]},b.binding=function(v){throw new Error("process.binding is not supported")},b.cwd=function(){return"/"},b.chdir=function(v){throw new Error("process.chdir is not supported")},b.umask=function(){return 0}}])}),define(J[59],Y([0,1]),function(z,t){"use strict";var L;Object.defineProperty(t,"__esModule",{value:!0}),t.SkipList=void 0;class I{constructor(S,l,d){this.level=S,this.key=l,this.value=d,this.forward=[]}}const b=void 0;class D{constructor(S,l=2**16){this.comparator=S,this[L]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(l)|0),this._header=new I(this._maxLevel,b,b)}get size(){return this._size}clear(){this._header=new I(this._maxLevel,b,b)}has(S){return Boolean(D._search(this,S,this.comparator))}get(S){return D._search(this,S,this.comparator)?.value}set(S,l){return D._insert(this,S,l,this.comparator)&&(this._size+=1),this}delete(S){const l=D._delete(this,S,this.comparator);return l&&(this._size-=1),l}forEach(S,l){let d=this._header.forward[0];for(;d;)S.call(l,d.value,d.key,this),d=d.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let S=this._header.forward[0];for(;S;)yield[S.key,S.value],S=S.forward[0]}*keys(){let S=this._header.forward[0];for(;S;)yield S.key,S=S.forward[0]}*values(){let S=this._header.forward[0];for(;S;)yield S.value,S=S.forward[0]}toString(){let S="[SkipList]:",l=this._header.forward[0];for(;l;)S+=`node(${l.key}, ${l.value}, lvl:${l.level})`,l=l.forward[0];return S}static _search(S,l,d){let p=S._header;for(let C=S._level-1;C>=0;C--)for(;p.forward[C]&&d(p.forward[C].key,l)<0;)p=p.forward[C];if(p=p.forward[0],p&&d(p.key,l)===0)return p}static _insert(S,l,d,p){let C=[],c=S._header;for(let w=S._level-1;w>=0;w--){for(;c.forward[w]&&p(c.forward[w].key,l)<0;)c=c.forward[w];C[w]=c}if(c=c.forward[0],c&&p(c.key,l)===0)return c.value=d,!1;{let w=D._randomLevel(S);if(w>S._level){for(let u=S._level;u<w;u++)C[u]=S._header;S._level=w}c=new I(w,l,d);for(let u=0;u<w;u++)c.forward[u]=C[u].forward[u],C[u].forward[u]=c;return!0}}static _randomLevel(S,l=.5){let d=1;for(;Math.random()<l&&d<S._maxLevel;)d+=1;return d}static _delete(S,l,d){let p=[],C=S._header;for(let c=S._level-1;c>=0;c--){for(;C.forward[c]&&d(C.forward[c].key,l)<0;)C=C.forward[c];p[c]=C}if(C=C.forward[0],!C||d(C.key,l)!==0)return!1;for(let c=0;c<S._level&&p[c].forward[c]===C;c++)p[c].forward[c]=C.forward[c];for(;S._level>0&&S._header.forward[S._level-1]===b;)S._level-=1;return!0}}t.SkipList=D}),define(J[38],Y([0,1,7,2]),function(z,t,L,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function b(f){const s=f;return s?[s.on,s.pause,s.resume,s.destroy].every(o=>typeof o=="function"):!1}t.isReadableStream=b;function D(f){const s=f;return s?b(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}t.isReadableBufferedStream=D;function T(f,s){return new S(f,s)}t.newWriteableStream=T;class S{constructor(s,o){this.reducer=s,this.options=o,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(o=>this.pendingWritePromises.push(o))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s!="undefined"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(o=>o(s))}emitError(s){this.listeners.error.length===0?(0,L.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(o=>o(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,o){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(o),this.resume();break;case"end":this.listeners.end.push(o),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(o),this.state.flowing&&this.flowErrors();break}}removeListener(s,o){if(this.state.destroyed)return;let e;switch(s){case"data":e=this.listeners.data;break;case"end":e=this.listeners.end;break;case"error":e=this.listeners.error;break}if(e){const r=e.indexOf(o);r>=0&&e.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const o=[...this.pendingWritePromises];this.pendingWritePromises.length=0,o.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function l(f,s){const o=[];let e;for(;(e=f.read())!==null;)o.push(e);return s(o)}t.consumeReadable=l;function d(f,s,o){const e=[];let r;for(;(r=f.read())!==null&&e.length<o;)e.push(r);return r===null&&e.length>0?s(e):{read:()=>{if(e.length>0)return e.shift();if(typeof r!="undefined"){const i=r;return r=void 0,i}return f.read()}}}t.peekReadable=d;function p(f,s){return new Promise((o,e)=>{const r=[];C(f,{onData:i=>{s&&r.push(i)},onError:i=>{s?e(i):o(void 0)},onEnd:()=>{o(s?s(r):void 0)}})})}t.consumeStream=p;function C(f,s){f.on("error",o=>s.onError(o)),f.on("end",()=>s.onEnd()),f.on("data",o=>s.onData(o))}t.listenStream=C;function c(f,s){return new Promise((o,e)=>{const r=new I.DisposableStore,i=[],n=y=>{if(i.push(y),i.length>s)return r.dispose(),f.pause(),o({stream:f,buffer:i,ended:!1})},a=y=>e(y),g=()=>o({stream:f,buffer:i,ended:!0});r.add((0,I.toDisposable)(()=>f.removeListener("error",a))),f.on("error",a),r.add((0,I.toDisposable)(()=>f.removeListener("end",g))),f.on("end",g),r.add((0,I.toDisposable)(()=>f.removeListener("data",n))),f.on("data",n)})}t.peekStream=c;function w(f,s){const o=T(s);return o.end(f),o}t.toStream=w;function u(){const f=T(()=>{throw new Error("not supported")});return f.end(),f}t.emptyStream=u;function h(f){let s=!1;return{read:()=>s?null:(s=!0,f)}}t.toReadable=h;function v(f,s,o){const e=T(o);return C(f,{onData:r=>e.write(s.data(r)),onError:r=>e.error(s.error?s.error(r):r),onEnd:()=>e.end()}),e}t.transform=v;function m(f,s,o){let e=!1;return{read:()=>{const r=s.read();return e?r:(e=!0,r!==null?o([f,r]):f)}}}t.prefixedReadable=m;function E(f,s,o){let e=!1;const r=T(o);return C(s,{onData:i=>e?r.write(i):(e=!0,r.write(o([f,i]))),onError:i=>r.error(i),onEnd:()=>{e||(e=!0,r.write(f)),r.end()}}),r}t.prefixedStream=E}),define(J[17],Y([0,1,38]),function(z,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const I=typeof Buffer!="undefined";let b,D;class T{constructor(n){this.buffer=n,this.byteLength=this.buffer.byteLength}static alloc(n){return I?new T(Buffer.allocUnsafe(n)):new T(new Uint8Array(n))}static wrap(n){return I&&!Buffer.isBuffer(n)&&(n=Buffer.from(n.buffer,n.byteOffset,n.byteLength)),new T(n)}static fromString(n,a){return!(a?.dontUseNodeBuffer||!1)&&I?new T(Buffer.from(n)):(b||(b=new TextEncoder),new T(b.encode(n)))}static concat(n,a){if(typeof a=="undefined"){a=0;for(let R=0,P=n.length;R<P;R++)a+=n[R].byteLength}const g=T.alloc(a);let y=0;for(let R=0,P=n.length;R<P;R++){const O=n[R];g.set(O,y),y+=O.byteLength}return g}toString(){return I?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(n,a){return new T(this.buffer.subarray(n,a))}set(n,a){n instanceof T?this.buffer.set(n.buffer,a):this.buffer.set(n,a)}readUInt32BE(n){return d(this.buffer,n)}writeUInt32BE(n,a){p(this.buffer,n,a)}readUInt32LE(n){return C(this.buffer,n)}writeUInt32LE(n,a){c(this.buffer,n,a)}readUInt8(n){return w(this.buffer,n)}writeUInt8(n,a){u(this.buffer,n,a)}}t.VSBuffer=T;function S(i,n){return i[n+0]<<0>>>0|i[n+1]<<8>>>0}t.readUInt16LE=S;function l(i,n,a){i[a+0]=n&255,n=n>>>8,i[a+1]=n&255}t.writeUInt16LE=l;function d(i,n){return i[n]*2**24+i[n+1]*2**16+i[n+2]*2**8+i[n+3]}t.readUInt32BE=d;function p(i,n,a){i[a+3]=n,n=n>>>8,i[a+2]=n,n=n>>>8,i[a+1]=n,n=n>>>8,i[a]=n}t.writeUInt32BE=p;function C(i,n){return i[n+0]<<0>>>0|i[n+1]<<8>>>0|i[n+2]<<16>>>0|i[n+3]<<24>>>0}t.readUInt32LE=C;function c(i,n,a){i[a+0]=n&255,n=n>>>8,i[a+1]=n&255,n=n>>>8,i[a+2]=n&255,n=n>>>8,i[a+3]=n&255}t.writeUInt32LE=c;function w(i,n){return i[n]}t.readUInt8=w;function u(i,n,a){i[a]=n}t.writeUInt8=u;function h(i){return L.consumeReadable(i,n=>T.concat(n))}t.readableToBuffer=h;function v(i){return L.toReadable(i)}t.bufferToReadable=v;function m(i){return L.consumeStream(i,n=>T.concat(n))}t.streamToBuffer=m;async function E(i){return i.ended?T.concat(i.buffer):T.concat([...i.buffer,await m(i.stream)])}t.bufferedStreamToBuffer=E;function f(i){return L.toStream(i,n=>T.concat(n))}t.bufferToStream=f;function s(i){return L.transform(i,{data:n=>typeof n=="string"?T.fromString(n):T.wrap(n)},n=>T.concat(n))}t.streamToBufferReadableStream=s;function o(i){return L.newWriteableStream(n=>T.concat(n),i)}t.newWriteableBufferStream=o;function e(i,n){return L.prefixedReadable(i,n,a=>T.concat(a))}t.prefixedBufferReadable=e;function r(i,n){return L.prefixedStream(i,n,a=>T.concat(a))}t.prefixedBufferStream=r}),define(J[18],Y([0,1,11]),function(z,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function I(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const v=Array.isArray(h)?[]:{};return Object.keys(h).forEach(m=>{h[m]&&typeof h[m]=="object"?v[m]=I(h[m]):v[m]=h[m]}),v}t.deepClone=I;function b(h){if(!h||typeof h!="object")return h;const v=[h];for(;v.length>0;){const m=v.shift();Object.freeze(m);for(const E in m)if(D.call(m,E)){const f=m[E];typeof f=="object"&&!Object.isFrozen(f)&&v.push(f)}}return h}t.deepFreeze=b;const D=Object.prototype.hasOwnProperty;function T(h,v){return S(h,v,new Set)}t.cloneAndChange=T;function S(h,v,m){if((0,L.isUndefinedOrNull)(h))return h;const E=v(h);if(typeof E!="undefined")return E;if((0,L.isArray)(h)){const f=[];for(const s of h)f.push(S(s,v,m));return f}if((0,L.isObject)(h)){if(m.has(h))throw new Error("Cannot clone recursive data-structure");m.add(h);const f={};for(let s in h)D.call(h,s)&&(f[s]=S(h[s],v,m));return m.delete(h),f}return h}function l(h,v,m=!0){return(0,L.isObject)(h)?((0,L.isObject)(v)&&Object.keys(v).forEach(E=>{E in h?m&&((0,L.isObject)(h[E])&&(0,L.isObject)(v[E])?l(h[E],v[E],m):h[E]=v[E]):h[E]=v[E]}),h):v}t.mixin=l;function d(h,v){if(h===v)return!0;if(h==null||v===null||v===void 0||typeof h!=typeof v||typeof h!="object"||Array.isArray(h)!==Array.isArray(v))return!1;let m,E;if(Array.isArray(h)){if(h.length!==v.length)return!1;for(m=0;m<h.length;m++)if(!d(h[m],v[m]))return!1}else{const f=[];for(E in h)f.push(E);f.sort();const s=[];for(E in v)s.push(E);if(s.sort(),!d(f,s))return!1;for(m=0;m<f.length;m++)if(!d(h[f[m]],v[f[m]]))return!1}return!0}t.equals=d;function p(h){const v=new Set;return JSON.stringify(h,(m,E)=>{if((0,L.isObject)(E)||Array.isArray(E)){if(v.has(E))return"[Circular]";v.add(E)}return E})}t.safeStringify=p;function C(h,v,m){const E=v(h);return typeof E=="undefined"?m:E}t.getOrDefault=C;function c(h,v){const m=Object.create(null);return!h||!v||Object.keys(v).forEach(f=>{const s=h[f],o=v[f];d(s,o)||(m[f]=o)}),m}t.distinct=c;function w(h,v){const m=v.toLowerCase(),E=Object.keys(h).find(f=>f.toLowerCase()===m);return E?h[E]:h[v]}t.getCaseInsensitive=w;function u(h,v){const m=Object.create(null);for(const E of Object.keys(h))v(E,h[E])&&(m[E]=h[E]);return m}t.filter=u}),define(J[60],Y([0,1,8]),function(z,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function I(d){const p=d;return p&&typeof p.type=="string"&&typeof p.severity=="string"}t.isRemoteConsoleLog=I;function b(d){const p=[];let C;try{const c=JSON.parse(d.arguments),w=c[c.length-1];w&&w.__$stack&&(c.pop(),C=w.__$stack),p.push(...c)}catch(c){p.push("Unable to log remote console arguments",d.arguments)}return{args:p,stack:C}}t.parse=b;function D(d){if(typeof d!="string")return D(b(d).stack);const p=d;if(p){const C=T(p),c=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(c&&c.length===4)return{uri:L.URI.file(c[1]),line:Number(c[2]),column:Number(c[3])}}}t.getFirstFrame=D;function T(d){if(!d)return d;const p=d.indexOf(`
`);return p===-1?d:d.substring(0,p)}function S(d,p){const{args:C,stack:c}=b(d),w=typeof C[0]=="string"&&C.length===1;let u=T(c);u&&(u=`(${u.trim()})`);let h=[];if(typeof C[0]=="string"?u&&w?h=[`%c[${p}] %c${C[0]} %c${u}`,l("blue"),l(""),l("grey")]:h=[`%c[${p}] %c${C[0]}`,l("blue"),l(""),...C.slice(1)]:h=[`%c[${p}]%`,l("blue"),...C],u&&!w&&h.push(u),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,h)}t.log=S;function l(d){return`color: ${d}`}}),define(J[61],Y([0,1,17,27,8]),function(z,t,L,I,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.MarshalledId=t.parse=t.stringify=void 0;function D(p){return JSON.stringify(p,l)}t.stringify=D;function T(p){let C=JSON.parse(p);return C=d(C),C}t.parse=T;var S;(function(p){p[p.Uri=1]="Uri",p[p.Regexp=2]="Regexp",p[p.ScmResource=3]="ScmResource",p[p.ScmResourceGroup=4]="ScmResourceGroup",p[p.ScmProvider=5]="ScmProvider",p[p.CommentController=6]="CommentController",p[p.CommentThread=7]="CommentThread",p[p.CommentThreadReply=8]="CommentThreadReply",p[p.CommentNode=9]="CommentNode",p[p.CommentThreadNode=10]="CommentThreadNode",p[p.TimelineActionContext=11]="TimelineActionContext",p[p.NotebookCellActionContext=12]="NotebookCellActionContext",p[p.TestItemContext=13]="TestItemContext"})(S=t.MarshalledId||(t.MarshalledId={}));function l(p,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,I.regExpFlags)(C)}:C}function d(p,C=0){if(!p||C>200)return p;if(typeof p=="object"){switch(p.$mid){case 1:return b.URI.revive(p);case 2:return new RegExp(p.source,p.flags)}if(p instanceof L.VSBuffer||p instanceof Uint8Array)return p;if(Array.isArray(p))for(let c=0;c<p.length;++c)p[c]=d(p[c],C+1);else for(const c in p)Object.hasOwnProperty.call(p,c)&&(p[c]=d(p[c],C+1))}return p}t.revive=d}),define(J[62],Y([0,1,47,9,6,12,19,27,8]),function(z,t,L,I,b,D,T,S,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function d(n,a,g){if(typeof n=="string"&&(n=l.URI.file(n)),g){const R=g.getWorkspaceFolder(n);if(R){const P=g.getWorkspace().folders.length>1;let O;if((0,T.isEqual)(R.uri,n)?O="":O=(0,T.relativePath)(R.uri,n),P){const U=R.name?R.name:(0,T.basename)(R.uri);O=O?U+" \u2022 "+O:U}return O}}if(n.scheme!==I.Schemas.file&&n.scheme!==I.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if((0,L.hasDriveLetter)(n.fsPath))return(0,b.normalize)(C(n.fsPath));let y=(0,b.normalize)(n.fsPath);return!D.isWindows&&a?.userHome&&(y=w(y,a.userHome.fsPath)),y}t.getPathLabel=d;function p(n){if(!n)return;typeof n=="string"&&(n=l.URI.file(n));const a=(0,T.basename)(n)||(n.scheme===I.Schemas.file?n.fsPath:n.path);return D.isWindows&&(0,L.isRootOrDriveLetter)(a)?C(a):a}t.getBaseLabel=p;function C(n,a){return(0,L.hasDriveLetter)(n,a)?n.charAt(0).toUpperCase()+n.slice(1):n}t.normalizeDriveLetter=C;let c=Object.create(null);function w(n,a){if(D.isWindows||!n||!a)return n;let g=c.original===a?c.normalized:void 0;return g||(g=`${(0,S.rtrim)(a,b.posix.sep)}${b.posix.sep}`,c={original:a,normalized:g}),(D.isLinux?n.startsWith(g):(0,S.startsWithIgnoreCase)(n,g))&&(n=`~/${n.substr(g.length)}`),n}t.tildify=w;function u(n,a){return n.replace(/^~($|\/|\\)/,`${a}$1`)}t.untildify=u;const h="\u2026",v="\\\\",m="~";function E(n,a=b.sep){const g=new Array(n.length);let y=!1;for(let R=0;R<n.length;R++){let P=n[R];if(P===""){g[R]=`.${a}`;continue}if(!P){g[R]=P;continue}y=!0;let O="";P.indexOf(v)===0?(O=P.substr(0,P.indexOf(v)+v.length),P=P.substr(P.indexOf(v)+v.length)):P.indexOf(a)===0?(O=P.substr(0,P.indexOf(a)+a.length),P=P.substr(P.indexOf(a)+a.length)):P.indexOf(m)===0&&(O=P.substr(0,P.indexOf(m)+m.length),P=P.substr(P.indexOf(m)+m.length));const U=P.split(a);for(let q=1;y&&q<=U.length;q++)for(let te=U.length-q;y&&te>=0;te--){y=!1;let ce=U.slice(te,te+q).join(a);for(let le=0;!y&&le<n.length;le++)if(le!==R&&n[le]&&n[le].indexOf(ce)>-1){const ne=te+q===U.length,de=te>0&&n[le].indexOf(a)>-1?a+ce:ce,x=n[le].endsWith(de);y=!ne||x}if(!y){let le="";(U[0].endsWith(":")||O!=="")&&(te===1&&(te=0,q++,ce=U[0]+a+ce),te>0&&(le=U[0]+a),le=O+le),te>0&&(le=le+h+a),le=le+ce,te+q<U.length&&(le=le+a+h),g[R]=le}}y&&(g[R]=P)}return g}t.shorten=E;var f;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function s(n,a=Object.create(null)){const g=[];let y=!1,R="";for(const P of n)if(P==="$"||y&&P==="{")R&&g.push({value:R,type:f.TEXT}),R="",y=!0;else if(P==="}"&&y){const O=a[R];if(typeof O=="string")O.length&&g.push({value:O,type:f.VARIABLE});else if(O){const U=g[g.length-1];(!U||U.type!==f.SEPARATOR)&&g.push({value:O.label,type:f.SEPARATOR})}R="",y=!1}else R+=P;return R&&!y&&g.push({value:R,type:f.TEXT}),g.filter((P,O)=>{if(P.type===f.SEPARATOR){const U=g[O-1],q=g[O+1];return[U,q].every(te=>te&&(te.type===f.VARIABLE||te.type===f.TEXT)&&te.value.length>0)}return!0}).map(P=>P.value).join("")}t.template=s;function o(n,a){return D.isMacintosh||a?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.isMacintosh?"&":"&&"):n.replace(/&&|&/g,g=>g==="&"?"&&":"&")}t.mnemonicMenuLabel=o;function e(n,a){return D.isMacintosh||a?n.replace(/\(&&\w\)|&&/g,""):D.isWindows?n.replace(/&&|&/g,g=>g==="&"?"&&":"&"):n.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function r(n){return n.replace(/&/g,"&&")}t.unmnemonicLabel=r;function i(n){const a=n.indexOf("/")!==-1?b.posix:b.win32,g=a.basename(n),y=a.dirname(n);return g.length?{name:g,parentPath:y}:{name:y,parentPath:""}}t.splitName=i}),define(J[63],Y([0,1,131]),function(z,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class I{constructor(D="utf8"){this.stringDecoder=new L.StringDecoder(D),this.remaining=null}write(D){const T=[],S=this.remaining?this.remaining+this.stringDecoder.write(D):this.stringDecoder.write(D);if(S.length<1)return T;let l=0,d,p=l;for(;p<S.length;)if(d=S.charCodeAt(p),d===13||d===10){if(T.push(S.substring(l,p)),p++,p<S.length){const C=d;d=S.charCodeAt(p),(C===13&&d===10||C===10&&d===13)&&p++}l=p}else p++;return this.remaining=l<S.length?S.substr(l):null,T}end(){return this.remaining}}t.LineDecoder=I}),define(J[64],Y([0,1,48,6,27,13]),function(z,t,L,I,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0;function T(p){const C=(0,I.dirname)(p);if(p===C)return p;const c=((0,I.basename)(p)||p).toLowerCase();try{const u=(0,D.readdirSync)(C).filter(h=>h.toLowerCase()===c);if(u.length===1){const h=T(C);if(h)return(0,I.join)(h,u[0])}else if(u.length>1){const h=u.indexOf(c);if(h>=0){const v=T(C);if(v)return(0,I.join)(v,u[h])}}}catch(w){}return null}t.realcaseSync=T;async function S(p){try{return await D.Promises.realpath(p)}catch(C){const c=d(p);return await D.Promises.access(c,L.constants.R_OK),c}}t.realpath=S;function l(p){try{return L.realpathSync(p)}catch(C){const c=d(p);return L.accessSync(c,L.constants.R_OK),c}}t.realpathSync=l;function d(p){return(0,b.rtrim)((0,I.normalize)(p),I.sep)}}),define(J[65],Y([0,1,34,6,13]),function(z,t,L,I,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const D=/^\d+$/,T=/^Microsoft.PowerShell_.*/,S=/^Microsoft.PowerShellPreview_.*/;var l;(function(s){s[s.x64=0]="x64",s[s.x86=1]="x86",s[s.ARM=2]="ARM"})(l||(l={}));let d;switch(process.arch){case"ia32":case"x32":d=1;break;case"arm":case"arm64":d=2;break;default:d=0;break}let p;process.env.PROCESSOR_ARCHITEW6432?p=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?p=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?p=1:p=0;class C{constructor(o,e,r){this.exePath=o,this.displayName=e,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await b.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function c({useAlternateBitness:s=!1}={}){return s?d===0?process.env["ProgramFiles(x86)"]||null:p===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function w({useAlternateBitness:s=!1,findPreview:o=!1}={}){const e=c({useAlternateBitness:s});if(!e)return null;const r=I.join(e,"PowerShell");if(!await b.SymlinkSupport.existsDirectory(r))return null;let i=-1,n=null;for(const y of await b.Promises.readdir(r)){let R=-1;if(o){const O=y.indexOf("-");if(O<0)continue;const U=y.substring(0,O);if(!D.test(U)||y.substring(O+1)!=="preview")continue;R=parseInt(U,10)}else{if(!D.test(y))continue;R=parseInt(y,10)}if(R<=i)continue;const P=I.join(r,y,"pwsh.exe");!await b.SymlinkSupport.existsFile(P)||(n=P,i=R)}if(!n)return null;const a=e.includes("x86")?" (x86)":"",g=o?" Preview":"";return new C(n,`PowerShell${g}${a}`,!0)}async function u({findPreview:s}={}){if(!process.env.LOCALAPPDATA)return null;const o=I.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await b.SymlinkSupport.existsDirectory(o))return null;const{pwshMsixDirRegex:e,pwshMsixName:r}=s?{pwshMsixDirRegex:S,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const i of await b.Promises.readdir(o))if(e.test(i)){const n=I.join(o,i,"pwsh.exe");return new C(n,r)}return null}function h(){const s=I.join(L.homedir(),".dotnet","tools","pwsh.exe");return new C(s,".NET Core PowerShell Global Tool")}function v(){const s=I.join(process.env.windir,d===1&&p!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(s,"Windows PowerShell",!0)}async function*m(){let s=await w();s&&(yield s),s=await w({useAlternateBitness:!0}),s&&(yield s),s=await u(),s&&(yield s),s=h(),s&&(yield s),s=await w({findPreview:!0}),s&&(yield s),s=await u({findPreview:!0}),s&&(yield s),s=await w({useAlternateBitness:!0,findPreview:!0}),s&&(yield s),s=v(),s&&(yield s)}async function*E(){for await(const s of m())await s.exists()&&(yield s)}t.enumeratePowerShellInstallations=E;async function f(){for await(const s of E())return s;return null}t.getFirstAvailablePowerShellInstallation=f});var he=this&&this.__decorate||function(z,t,L,I){var b=arguments.length,D=b<3?t:I===null?I=Object.getOwnPropertyDescriptor(t,L):I,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(z,t,L,I);else for(var S=z.length-1;S>=0;S--)(T=z[S])&&(D=(b<3?T(D):b>3?T(t,L,D):T(t,L))||D);return b>3&&D&&Object.defineProperty(t,L,D),D};define(J[39],Y([0,1,20,3,17,24,46,7,10,2,61,27,11]),function(z,t,L,I,b,D,T,S,l,d,p,C,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var w;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(w=t.RequestType||(t.RequestType={}));function u(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(h=t.ResponseType||(t.ResponseType={}));function v(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(m||(m={}));class E{constructor(k){this.buffer=k,this.pos=0}read(k){const W=this.buffer.slice(this.pos,this.pos+k);return this.pos+=W.byteLength,W}}class f{constructor(){this.buffers=[]}get buffer(){return b.VSBuffer.concat(this.buffers)}write(k){this.buffers.push(k)}}var s;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(s||(s={}));function o(M){const k=b.VSBuffer.alloc(4);return k.writeUInt32BE(M,0),k}function e(M){return M.read(4).readUInt32BE(0)}function r(M){const k=b.VSBuffer.alloc(1);return k.writeUInt8(M,0),k}const i={Undefined:r(s.Undefined),String:r(s.String),Buffer:r(s.Buffer),VSBuffer:r(s.VSBuffer),Array:r(s.Array),Object:r(s.Object)},n=typeof Buffer!="undefined";function a(M,k){if(typeof k=="undefined")M.write(i.Undefined);else if(typeof k=="string"){const W=b.VSBuffer.fromString(k);M.write(i.String),M.write(o(W.byteLength)),M.write(W)}else if(n&&Buffer.isBuffer(k)){const W=b.VSBuffer.wrap(k);M.write(i.Buffer),M.write(o(W.byteLength)),M.write(W)}else if(k instanceof b.VSBuffer)M.write(i.VSBuffer),M.write(o(k.byteLength)),M.write(k);else if(Array.isArray(k)){M.write(i.Array),M.write(o(k.length));for(const W of k)a(M,W)}else{const W=b.VSBuffer.fromString(JSON.stringify(k));M.write(i.Object),M.write(o(W.byteLength)),M.write(W)}}function g(M){switch(M.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return M.read(e(M)).toString();case s.Buffer:return M.read(e(M)).buffer;case s.VSBuffer:return M.read(e(M));case s.Array:{const W=e(M),G=[];for(let ee=0;ee<W;ee++)G.push(g(M));return G}case s.Object:return JSON.parse(M.read(e(M)).toString())}}class y{constructor(k,W,G=null,ee=1e3){this.protocol=k,this.ctx=W,this.logger=G,this.timeoutDelay=ee,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(X=>this.onRawMessage(X)),this.sendResponse({type:200})}registerChannel(k,W){this.channels.set(k,W),setTimeout(()=>this.flushPendingRequests(k),0)}sendResponse(k){switch(k.type){case 200:{const W=this.send([k.type]);this.logger&&this.logger.logOutgoing(W,0,1,v(k.type));return}case 201:case 202:case 204:case 203:{const W=this.send([k.type,k.id],k.data);this.logger&&this.logger.logOutgoing(W,k.id,1,v(k.type),k.data);return}}}send(k,W=void 0){const G=new f;return a(G,k),a(G,W),this.sendBuffer(G.buffer)}sendBuffer(k){try{return this.protocol.send(k),k.byteLength}catch(W){return 0}}onRawMessage(k){const W=new E(k),G=g(W),ee=g(W),X=G[0];switch(X){case 100:return this.logger&&this.logger.logIncoming(k.byteLength,G[1],1,`${u(X)}: ${G[2]}.${G[3]}`,ee),this.onPromise({type:X,id:G[1],channelName:G[2],name:G[3],arg:ee});case 102:return this.logger&&this.logger.logIncoming(k.byteLength,G[1],1,`${u(X)}: ${G[2]}.${G[3]}`,ee),this.onEventListen({type:X,id:G[1],channelName:G[2],name:G[3],arg:ee});case 101:return this.logger&&this.logger.logIncoming(k.byteLength,G[1],1,`${u(X)}`),this.disposeActiveRequest({type:X,id:G[1]});case 103:return this.logger&&this.logger.logIncoming(k.byteLength,G[1],1,`${u(X)}`),this.disposeActiveRequest({type:X,id:G[1]})}}onPromise(k){const W=this.channels.get(k.channelName);if(!W){this.collectPendingRequest(k);return}const G=new D.CancellationTokenSource;let ee;try{ee=W.call(this.ctx,k.name,k.arg,G.token)}catch(_){ee=Promise.reject(_)}const X=k.id;ee.then(_=>{this.sendResponse({id:X,data:_,type:201}),this.activeRequests.delete(k.id)},_=>{_ instanceof Error?this.sendResponse({id:X,data:{message:_.message,name:_.name,stack:_.stack?_.stack.split?_.stack.split(`
`):_.stack:void 0},type:202}):this.sendResponse({id:X,data:_,type:203}),this.activeRequests.delete(k.id)});const Z=(0,d.toDisposable)(()=>G.cancel());this.activeRequests.set(k.id,Z)}onEventListen(k){const W=this.channels.get(k.channelName);if(!W){this.collectPendingRequest(k);return}const G=k.id,X=W.listen(this.ctx,k.name,k.arg)(Z=>this.sendResponse({id:G,data:Z,type:204}));this.activeRequests.set(k.id,X)}disposeActiveRequest(k){const W=this.activeRequests.get(k.id);W&&(W.dispose(),this.activeRequests.delete(k.id))}collectPendingRequest(k){let W=this.pendingRequests.get(k.channelName);W||(W=[],this.pendingRequests.set(k.channelName,W));const G=setTimeout(()=>{console.error(`Unknown channel: ${k.channelName}`),k.type===100&&this.sendResponse({id:k.id,data:{name:"Unknown channel",message:`Channel name '${k.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);W.push({request:k,timeoutTimer:G})}flushPendingRequests(k){const W=this.pendingRequests.get(k);if(W){for(const G of W)switch(clearTimeout(G.timeoutTimer),G.request.type){case 100:this.onPromise(G.request);break;case 102:this.onEventListen(G.request);break}this.pendingRequests.delete(k)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(k=>k.dispose()),this.activeRequests.clear()}}t.ChannelServer=y;var R;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(R=t.RequestInitiator||(t.RequestInitiator={}));class P{constructor(k,W=null){this.protocol=k,this.isDisposed=!1,this.state=m.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new l.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(G=>this.onBuffer(G)),this.logger=W}getChannel(k){const W=this;return{call(G,ee,X){return W.isDisposed?Promise.reject(S.canceled()):W.requestPromise(k,G,ee,X)},listen(G,ee){return W.isDisposed?Promise.reject(S.canceled()):W.requestEvent(k,G,ee)}}}requestPromise(k,W,G,ee=D.CancellationToken.None){const X=this.lastRequestId++,_={id:X,type:100,channelName:k,name:W,arg:G};if(ee.isCancellationRequested)return Promise.reject(S.canceled());let N;return new Promise((B,V)=>{if(ee.isCancellationRequested)return V(S.canceled());const K=()=>{const me=ye=>{switch(ye.type){case 201:this.handlers.delete(X),B(ye.data);break;case 202:this.handlers.delete(X);const ue=new Error(ye.data.message);ue.stack=ye.data.stack,ue.name=ye.data.name,V(ue);break;case 203:this.handlers.delete(X),V(ye.data);break}};this.handlers.set(X,me),this.sendRequest(_)};let Q=null;this.state===m.Idle?K():(Q=(0,I.createCancelablePromise)(me=>this.whenInitialized()),Q.then(()=>{Q=null,K()}));const se=()=>{Q?(Q.cancel(),Q=null):this.sendRequest({id:X,type:101}),V(S.canceled())},ie=ee.onCancellationRequested(se);N=(0,d.combinedDisposable)((0,d.toDisposable)(se),ie),this.activeRequests.add(N)}).finally(()=>{this.activeRequests.delete(N)})}requestEvent(k,W,G){const ee=this.lastRequestId++,Z={id:ee,type:102,channelName:k,name:W,arg:G};let _=null;const N=new l.Emitter({onFirstListenerAdd:()=>{_=(0,I.createCancelablePromise)(B=>this.whenInitialized()),_.then(()=>{_=null,this.activeRequests.add(N),this.sendRequest(Z)})},onLastListenerRemove:()=>{_?(_.cancel(),_=null):(this.activeRequests.delete(N),this.sendRequest({id:ee,type:103}))}}),A=B=>N.fire(B.data);return this.handlers.set(ee,A),N.event}sendRequest(k){switch(k.type){case 100:case 102:{const W=this.send([k.type,k.id,k.channelName,k.name],k.arg);this.logger&&this.logger.logOutgoing(W,k.id,0,`${u(k.type)}: ${k.channelName}.${k.name}`,k.arg);return}case 101:case 103:{const W=this.send([k.type,k.id]);this.logger&&this.logger.logOutgoing(W,k.id,0,u(k.type));return}}}send(k,W=void 0){const G=new f;return a(G,k),a(G,W),this.sendBuffer(G.buffer)}sendBuffer(k){try{return this.protocol.send(k),k.byteLength}catch(W){return 0}}onBuffer(k){const W=new E(k),G=g(W),ee=g(W),X=G[0];switch(X){case 200:return this.logger&&this.logger.logIncoming(k.byteLength,0,0,v(X)),this.onResponse({type:G[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(k.byteLength,G[1],0,v(X),ee),this.onResponse({type:G[0],id:G[1],data:ee})}}onResponse(k){if(k.type===200){this.state=m.Idle,this._onDidInitialize.fire();return}const W=this.handlers.get(k.id);W&&W(k)}get onDidInitializePromise(){return l.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(k=>k.dispose()),this.activeRequests.clear()}}he([T.memoize],P.prototype,"onDidInitializePromise",null),t.ChannelClient=P;class O{constructor(k){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new l.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new l.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,k(({protocol:W,onDidClientDisconnect:G})=>{l.Event.once(W.onMessage)(X=>{const Z=new E(X),_=g(Z),N=new y(W,_),A=new P(W);this.channels.forEach((V,K)=>N.registerChannel(K,V));const B={channelServer:N,channelClient:A,ctx:_};this._connections.add(B),this._onDidAddConnection.fire(B),G(()=>{N.dispose(),A.dispose(),this._connections.delete(B),this._onDidRemoveConnection.fire(B)})})})}get connections(){const k=[];return this._connections.forEach(W=>k.push(W)),k}getChannel(k,W){const G=this;return{call(ee,X,Z){let _;if((0,c.isFunction)(W)){let A=(0,L.getRandomElement)(G.connections.filter(W));_=A?Promise.resolve(A):l.Event.toPromise(l.Event.filter(G.onDidAddConnection,W))}else _=W.routeCall(G,ee,X);const N=_.then(A=>A.channelClient.getChannel(k));return q(N).call(ee,X,Z)},listen(ee,X){if((0,c.isFunction)(W))return G.getMulticastEvent(k,W,ee,X);const Z=W.routeEvent(G,ee,X).then(_=>_.channelClient.getChannel(k));return q(Z).listen(ee,X)}}}getMulticastEvent(k,W,G,ee){const X=this;let Z=new d.DisposableStore;const _=new l.Emitter({onFirstListenerAdd:()=>{Z=new d.DisposableStore;const N=new l.EventMultiplexer,A=new Map,B=K=>{const se=K.channelClient.getChannel(k).listen(G,ee),ie=N.add(se);A.set(K,ie)},V=K=>{const Q=A.get(K);!Q||(Q.dispose(),A.delete(K))};X.connections.filter(W).forEach(B),l.Event.filter(X.onDidAddConnection,W)(B,void 0,Z),X.onDidRemoveConnection(V,void 0,Z),N.event(_.fire,_,Z),Z.add(N)},onLastListenerRemove:()=>{Z.dispose()}});return _.event}registerChannel(k,W){this.channels.set(k,W),this._connections.forEach(G=>{G.channelServer.registerChannel(k,W)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=O;class U{constructor(k,W,G=null){const ee=new f;a(ee,W),k.send(ee.buffer),this.channelClient=new P(k,G),this.channelServer=new y(k,W,G)}getChannel(k){return this.channelClient.getChannel(k)}registerChannel(k,W){this.channelServer.registerChannel(k,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=U;function q(M){return{call(k,W,G){return M.then(ee=>ee.call(k,W,G))},listen(k,W){const G=new l.Relay;return M.then(ee=>G.input=ee.listen(k,W)),G.event}}}t.getDelayedChannel=q;function te(M){let k=!1;return{call(W,G,ee){return k?M.call(W,G,ee):(0,I.timeout)(0).then(()=>k=!0).then(()=>M.call(W,G,ee))},listen(W,G){if(k)return M.listen(W,G);const ee=new l.Relay;return(0,I.timeout)(0).then(()=>k=!0).then(()=>ee.input=M.listen(W,G)),ee.event}}}t.getNextTickChannel=te;class ce{constructor(k){this.fn=k}routeCall(k){return this.route(k)}routeEvent(k){return this.route(k)}async route(k){for(const W of k.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await l.Event.toPromise(k.onDidAddConnection),await this.route(k)}}t.StaticRouter=ce;var le;(function(M){function k(X,Z){const _=X,N=Z&&Z.disableMarshalling,A=new Map;for(const B in _)G(B)&&A.set(B,l.Event.buffer(_[B],!0));return new class{listen(B,V,K){const Q=A.get(V);if(Q)return Q;if(ee(V)){const se=_[V];if(typeof se=="function")return se.call(_,K)}throw new Error(`Event not found: ${V}`)}call(B,V,K){const Q=_[V];if(typeof Q=="function"){if(!N&&Array.isArray(K))for(let se=0;se<K.length;se++)K[se]=(0,p.revive)(K[se]);return Q.apply(_,K)}throw new Error(`Method not found: ${V}`)}}}M.fromService=k;function W(X,Z){const _=Z&&Z.disableMarshalling;return new Proxy({},{get(N,A){if(typeof A=="string")return Z?.properties?.has(A)?Z.properties.get(A):ee(A)?function(B){return X.listen(A,B)}:G(A)?X.listen(A):async function(...B){let V;Z&&!(0,c.isUndefinedOrNull)(Z.context)?V=[Z.context,...B]:V=B;const K=await X.call(A,V);return _?K:(0,p.revive)(K)};throw new Error(`Property not found: ${String(A)}`)}})}M.toService=W;function G(X){return X[0]==="o"&&X[1]==="n"&&C.isUpperAsciiLetter(X.charCodeAt(2))}function ee(X){return/^onDynamic/.test(X)&&C.isUpperAsciiLetter(X.charCodeAt(9))}})(le=t.ProxyChannel||(t.ProxyChannel={}));const ne=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function de(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){let k=M.toString();if(k!=="[object Object]")return k}return M}function x(M){return Array.isArray(M)?M.map(de):de(M)}function H(M,k,W,G,ee,X,Z){Z=x(Z);const _=ne[ee],N=_[G%_.length];let A=[`%c[${M}]%c[${String(k).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(G).padStart(5," ")} - ${X}`,"color: darkgreen","color: grey","color: grey",`color: ${N}`];/\($/.test(X)?(A=A.concat(Z),A.push(")")):A.push(Z),console.log.apply(console,A)}t.logWithColors=H;class re{constructor(k,W){this._outgoingPrefix=k,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(k,W,G,ee,X){this._totalOutgoing+=k,H(this._outgoingPrefix,this._totalOutgoing,k,W,G,ee,X)}logIncoming(k,W,G,ee,X){this._totalIncoming+=k,H(this._incomingPrefix,this._totalIncoming,k,W,G,ee,X)}}t.IPCLogger=re}),define(J[66],Y([0,1,3,10,2,11]),function(z,t,L,I,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.isStorageItemsChangeEvent=t.StorageHint=void 0;var T;(function(C){C[C.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(T=t.StorageHint||(t.StorageHint={}));function S(C){const c=C;return c?.changed instanceof Map||c?.deleted instanceof Set}t.isStorageItemsChangeEvent=S;var l;(function(C){C[C.None=0]="None",C[C.Initialized=1]="Initialized",C[C.Closed=2]="Closed"})(l||(l={}));class d extends b.Disposable{constructor(c,w=Object.create(null)){super();this.database=c,this.options=w,this._onDidChangeStorage=this._register(new I.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=l.None,this.cache=new Map,this.flushDelayer=new L.ThrottledDelayer(d.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(c=>this.onDidChangeItemsExternal(c)))}onDidChangeItemsExternal(c){c.changed?.forEach((w,u)=>this.accept(u,w)),c.deleted?.forEach(w=>this.accept(w,void 0))}accept(c,w){if(this.state===l.Closed)return;let u=!1;(0,D.isUndefinedOrNull)(w)?u=this.cache.delete(c):this.cache.get(c)!==w&&(this.cache.set(c,w),u=!0),u&&this._onDidChangeStorage.fire(c)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===l.None&&(this.state=l.Initialized,this.options.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(c,w){const u=this.cache.get(c);return(0,D.isUndefinedOrNull)(u)?w:u}getBoolean(c,w){const u=this.get(c);return(0,D.isUndefinedOrNull)(u)?w:u==="true"}getNumber(c,w){const u=this.get(c);return(0,D.isUndefinedOrNull)(u)?w:parseInt(u,10)}async set(c,w){if(this.state===l.Closed)return;if((0,D.isUndefinedOrNull)(w))return this.delete(c);const u=String(w);if(this.cache.get(c)!==u)return this.cache.set(c,u),this.pendingInserts.set(c,u),this.pendingDeletes.delete(c),this._onDidChangeStorage.fire(c),this.doFlush()}async delete(c){if(!(this.state===l.Closed||!this.cache.delete(c)))return this.pendingDeletes.has(c)||this.pendingDeletes.add(c),this.pendingInserts.delete(c),this._onDidChangeStorage.fire(c),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=l.Closed;try{await this.doFlush(0)}catch(c){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const c={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(c).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(c){if(!!this.hasPending)return this.doFlush(c)}async doFlush(c){return this.flushDelayer.trigger(()=>this.flushPending(),c)}async whenFlushed(){if(!!this.hasPending)return new Promise(c=>this.whenFlushedCallbacks.push(c))}dispose(){this.flushDelayer.dispose(),super.dispose()}}t.Storage=d,d.DEFAULT_FLUSH_DELAY=100;class p{constructor(){this.onDidChangeItemsExternal=I.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(c){c.insert&&c.insert.forEach((w,u)=>this.items.set(u,w)),c.delete&&c.delete.forEach(w=>this.items.delete(w))}async close(){}}t.InMemoryStorageDatabase=p}),define(J[67],Y([4,5]),function(z,t){return z.create("vs/base/common/date",t)}),define(J[68],Y([0,1,67]),function(z,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const I=60,b=I*60,D=b*24,T=D*7,S=D*30,l=D*365;function d(C,c){typeof C!="number"&&(C=C.getTime());const w=Math.round((new Date().getTime()-C)/1e3);if(w<-30)return(0,L.localize)(0,null,d(new Date().getTime()+w*1e3,!1));if(w<30)return(0,L.localize)(1,null);let u;return w<I?(u=w,c?u===1?(0,L.localize)(2,null,u):(0,L.localize)(3,null,u):u===1?(0,L.localize)(4,null,u):(0,L.localize)(5,null,u)):w<b?(u=Math.floor(w/I),c?u===1?(0,L.localize)(6,null,u):(0,L.localize)(7,null,u):u===1?(0,L.localize)(8,null,u):(0,L.localize)(9,null,u)):w<D?(u=Math.floor(w/b),c?u===1?(0,L.localize)(10,null,u):(0,L.localize)(11,null,u):u===1?(0,L.localize)(12,null,u):(0,L.localize)(13,null,u)):w<T?(u=Math.floor(w/D),c?u===1?(0,L.localize)(14,null,u):(0,L.localize)(15,null,u):u===1?(0,L.localize)(16,null,u):(0,L.localize)(17,null,u)):w<S?(u=Math.floor(w/T),c?u===1?(0,L.localize)(18,null,u):(0,L.localize)(19,null,u):u===1?(0,L.localize)(20,null,u):(0,L.localize)(21,null,u)):w<l?(u=Math.floor(w/S),c?u===1?(0,L.localize)(22,null,u):(0,L.localize)(23,null,u):u===1?(0,L.localize)(24,null,u):(0,L.localize)(25,null,u)):(u=Math.floor(w/l),c?u===1?(0,L.localize)(26,null,u):(0,L.localize)(27,null,u):u===1?(0,L.localize)(28,null,u):(0,L.localize)(29,null,u))}t.fromNow=d;function p(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=p}),define(J[69],Y([4,5]),function(z,t){return z.create("vs/base/common/errorMessage",t)}),define(J[28],Y([0,1,20,11,69]),function(z,t,L,I,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function D(d,p){return p&&(d.stack||d.stacktrace)?b.localize(0,null,S(d),T(d.stack)||T(d.stacktrace)):S(d)}function T(d){return Array.isArray(d)?d.join(`
`):d}function S(d){return typeof d.code=="string"&&typeof d.errno=="number"&&typeof d.syscall=="string"?b.localize(1,null,d.message):d.message||b.localize(2,null)}function l(d=null,p=!1){if(!d)return b.localize(3,null);if(Array.isArray(d)){const C=L.coalesce(d),c=l(C[0],p);return C.length>1?b.localize(4,null,c,C.length):c}if(I.isString(d))return d;if(d.detail){const C=d.detail;if(C.error)return D(C.error,p);if(C.exception)return D(C.exception,p)}return d.stack?D(d,p):d.message?d.message:b.localize(5,null)}t.toErrorMessage=l}),define(J[70],Y([4,5]),function(z,t){return z.create("vs/base/node/processes",t)}),define(J[49],Y([0,1,40,47,9,18,6,12,29,58,11,63,13,70]),function(z,t,L,I,b,D,T,S,l,d,p,C,c,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.removeDangerousEnvVariables=t.TerminateResponseCode=t.Source=void 0,Object.defineProperty(t,"Source",{enumerable:!0,get:function(){return d.Source}}),Object.defineProperty(t,"TerminateResponseCode",{enumerable:!0,get:function(){return d.TerminateResponseCode}});function u(e){switch(e){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function h(e,r){if(S.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};r&&(i.cwd=r);const n=L.execFile("taskkill",["/T","/F","/PID",e.pid.toString()],i);return new Promise(a=>{n.once("error",g=>{a({success:!1,error:g})}),n.once("exit",(g,y)=>{a(g===0?{success:!0}:{success:!1,code:g!==null?g:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?u(i.status):1})}else if(S.isLinux||S.isMacintosh)try{const i=b.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",z).fsPath;return new Promise(n=>{L.execFile(i,[e.pid.toString()],{encoding:"utf8",shell:!0},(a,g,y)=>{n(a?{success:!1,error:a}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else e.kill("SIGKILL");return Promise.resolve({success:!0})}function v(e){!e||(delete e.DEBUG,S.isMacintosh&&delete e.DYLD_LIBRARY_PATH,S.isLinux&&delete e.LD_PRELOAD)}t.removeDangerousEnvVariables=v;function m(e=l.env){return e.comspec||"cmd.exe"}t.getWindowsShell=m;class E{constructor(r,i,n,a){if(i!==void 0&&n!==void 0&&a!==void 0)this.cmd=r,this.args=i,this.shell=n,this.options=a;else{const g=r;this.cmd=g.command,this.shell=g.isShellCommand,this.args=g.args.slice(0),this.options=g.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const g=Object.create(null);Object.keys(l.env).forEach(y=>{g[y]=l.env[y]}),Object.keys(this.options.env).forEach(y=>{g[y]=this.options.env[y]}),this.options.env=g}}getSanitizedCommand(){let r=this.cmd.toLowerCase();const i=r.lastIndexOf(T.sep);return i!==-1&&(r=r.substring(i+1)),E.WellKnowCommands[r]?r:"other"}start(r){return S.isWindows&&(this.options&&this.options.cwd&&I.isUNC(this.options.cwd)||!this.options&&I.isUNC(l.cwd()))?Promise.reject(new Error(w.localize(0,null))):this.useExec().then(i=>{let n,a;const g=new Promise((y,R)=>{n=y,a=R});if(i){let y=this.cmd;this.args&&(y=y+" "+this.args.join(" ")),this.childProcess=L.exec(y,this.options,(R,P,O)=>{this.childProcess=null;const U=R;U&&U.killed?a({killed:this.terminateRequested,stdout:P.toString(),stderr:O.toString()}):this.handleExec(n,r,R,P,O)})}else{let y=null;const R=P=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(P,n,r,a);const O={terminated:this.terminateRequested};p.isNumber(P)&&(O.cmdCode=P),n(O)};if(this.shell&&S.isWindows){const P=D.deepClone(this.options);P.windowsVerbatimArguments=!0,P.detached=!1;let O=!1,U=!1;const q=[];let te=this.ensureQuotes(this.cmd);q.push(te.value),O=te.quoted,this.args&&this.args.forEach(le=>{te=this.ensureQuotes(le),q.push(te.value),U=U&&te.quoted});const ce=["/s","/c"];O?U?ce.push('"'+q.join(" ")+'"'):q.length>1?ce.push('"'+q[0]+'" '+q.slice(1).join(" ")):ce.push('"'+q[0]+'"'):ce.push(q.join(" ")),y=L.spawn(m(),ce,P)}else this.cmd&&(y=L.spawn(this.cmd,this.args,this.options));y&&(this.childProcess=y,this.childProcessPromise=Promise.resolve(y),this.pidResolve&&(this.pidResolve(p.isNumber(y.pid)?y.pid:-1),this.pidResolve=void 0),y.on("error",P=>{this.childProcess=null,a({terminated:this.terminateRequested,error:P})}),y.pid&&(this.childProcess.on("close",R),this.handleSpawn(y,n,r,a,!0)))}return g})}handleClose(r,i,n,a){}ensureQuotes(r){return E.regexp.test(r)?{value:'"'+r+'"',quoted:!0}:{value:r,quoted:r.length>0&&r[0]==='"'&&r[r.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(r=>r.pid,r=>-1):new Promise(r=>{this.pidResolve=r})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(r=>(this.terminateRequested=!0,h(r,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),r=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(r=>{if(!this.shell||!S.isWindows)return r(!1);const i=L.spawn(m(),["/s","/c"]);i.on("error",n=>r(!0)),i.on("exit",n=>r(!1))})}}t.AbstractProcess=E,E.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},E.regexp=/^[^"].* .*[^"]/;class f extends E{constructor(r,i,n,a){super(r,i,n,a);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(r,i,n,a,g){[a,g].forEach((y,R)=>{const P=new C.LineDecoder;P.write(y).forEach(q=>{i({line:q,source:R===0?0:1})});const U=P.end();U&&i({line:U,source:R===0?0:1})}),r({terminated:this.terminateRequested,error:n})}handleSpawn(r,i,n,a,g){const y=new C.LineDecoder,R=new C.LineDecoder;r.stdout.on("data",P=>{y.write(P).forEach(U=>n({line:U,source:0}))}),r.stderr.on("data",P=>{R.write(P).forEach(U=>n({line:U,source:1}))}),this.stdoutLineDecoder=y,this.stderrLineDecoder=R}handleClose(r,i,n,a){const g=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;g&&n({line:g,source:0});const y=this.stderrLineDecoder?this.stderrLineDecoder.end():null;y&&n({line:y,source:1})}}t.LineProcess=f;function s(e){let r=[],i=!1;const n=function(a){if(i){r.push(a);return}(!e.send(a,y=>{if(y&&console.error(y),i=!1,r.length>0){const R=r.slice(0);r=[],R.forEach(P=>n(P))}})||S.isWindows)&&(i=!0)};return{send:n}}t.createQueuedSender=s;var o;(function(e){async function r(i,n,a){if(T.isAbsolute(i))return i;if(n===void 0&&(n=l.cwd()),T.dirname(i)!=="."||(a===void 0&&p.isString(l.env.PATH)&&(a=l.env.PATH.split(T.delimiter)),a===void 0||a.length===0))return T.join(n,i);async function y(R){if(await c.Promises.exists(R)){let P;try{P=await c.Promises.stat(R)}catch(O){O.message.startsWith("EACCES")&&(P=await c.Promises.lstat(R))}return P?!P.isDirectory():!1}return!1}for(let R of a){let P;if(T.isAbsolute(R)?P=T.join(R,i):P=T.join(n,R,i),await y(P))return P;let O=P+".com";if(await y(O)||(O=P+".exe",await y(O)))return O}return T.join(n,i)}e.findExecutable=r})(o=t.win32||(t.win32={}))}),define(J[71],Y([0,1,34,12,65,49]),function(z,t,L,I,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function T(w,u){return w===1?I.isWindows?C():D.getWindowsShell(u):d(w,u)}t.getSystemShell=T;function S(w,u){return w===1?I.isWindows?c(u):D.getWindowsShell(u):d(w,u)}t.getSystemShellSync=S;let l=null;function d(w,u){if(I.isLinux&&w===2||I.isMacintosh&&w===3)return"/bin/bash";if(!l){let h;if(I.isWindows)h="/bin/bash";else{if(h=u.SHELL,!h)try{h=(0,L.userInfo)().shell}catch(v){}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}l=h}return l}let p=null;async function C(){return p||(p=(await(0,b.getFirstAvailablePowerShellInstallation)()).exePath),p}function c(w){if(p)return p;const u=I.isWindows&&parseFloat((0,L.release)())>=10,h=w.hasOwnProperty("PROCESSOR_ARCHITEW6432"),v=`${w.windir}\\${h?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return u?v:D.getWindowsShell(w)}}),define(J[50],Y([0,1,40,3,17,24,60,7,10,2,18,49,39]),function(z,t,L,I,b,D,T,S,l,d,p,C,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class w extends c.ChannelServer{constructor(v){super({send:m=>{try{process.send&&process.send(m.buffer.toString("base64"))}catch(E){}},onMessage:l.Event.fromNodeEventEmitter(process,"message",m=>b.VSBuffer.wrap(Buffer.from(m,"base64")))},v);process.once("disconnect",()=>this.dispose())}}t.Server=w;class u{constructor(v,m){this.modulePath=v,this.options=m,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new l.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const E=m&&m.timeout?m.timeout:6e4;this.disposeDelayer=new I.Delayer(E),this.child=null,this._client=null}getChannel(v){const m=this;return{call(E,f,s){return m.requestPromise(v,E,f,s)},listen(E,f){return m.requestEvent(v,E,f)}}}requestPromise(v,m,E,f=D.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(S.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(v),o=(0,I.createCancelablePromise)(i=>s.call(m,E,i)),e=f.onCancellationRequested(()=>o.cancel()),r=(0,d.toDisposable)(()=>o.cancel());return this.activeRequests.add(r),o.finally(()=>{e.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),o}requestEvent(v,m,E){if(!this.disposeDelayer)return l.Event.None;this.disposeDelayer.cancel();let f;const s=new l.Emitter({onFirstListenerAdd:()=>{f=this.getCachedChannel(v).listen(m,E)(s.fire,s),this.activeRequests.add(f)},onLastListenerRemove:()=>{this.activeRequests.delete(f),f.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const v=this.options&&this.options.args?this.options.args:[],m=Object.create(null);m.env={...(0,p.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(m.env={...m.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(m.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n))),(0,C.removeDangerousEnvVariables)(m.env),this.child=(0,L.fork)(this.modulePath,v,m);const E=new l.Emitter;l.Event.fromNodeEventEmitter(this.child,"message",n=>n)(n=>{if((0,T.isRemoteConsoleLog)(n)){(0,T.log)(n,`IPC Library: ${this.options.serverName}`);return}E.fire(b.VSBuffer.wrap(Buffer.from(n,"base64")))});const s=this.options.useQueue?(0,C.createQueuedSender)(this.child):this.child,o=n=>this.child&&this.child.connected&&s.send(n.buffer.toString("base64")),e=E.event,r={send:o,onMessage:e};this._client=new c.ChannelClient(r);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",n=>console.warn('IPC "'+this.options.serverName+'" errored with '+n)),this.child.on("exit",(n,a)=>{process.removeListener("exit",i),this.activeRequests.forEach(g=>(0,d.dispose)(g)),this.activeRequests.clear(),n!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+n+" and signal "+a),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:n,signal:a})})}return this._client}getCachedChannel(v){let m=this.channels.get(v);return m||(m=this.client.getChannel(v),this.channels.set(v,m)),m}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=u}),define(J[72],Y([4,5]),function(z,t){return z.create("vs/base/node/zip",t)}),define(J[73],Y([4,5]),function(z,t){return z.create("vs/platform/configuration/common/configurationRegistry",t)}),define(J[74],Y([4,5]),function(z,t){return z.create("vs/platform/environment/node/shellEnv",t)}),define(J[75],Y([4,5]),function(z,t){return z.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",t)}),define(J[76],Y([4,5]),function(z,t){return z.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(J[77],Y([4,5]),function(z,t){return z.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(J[78],Y([4,5]),function(z,t){return z.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(J[79],Y([4,5]),function(z,t){return z.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(J[80],Y([4,5]),function(z,t){return z.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(J[81],Y([4,5]),function(z,t){return z.create("vs/platform/extensions/common/extensionValidator",t)}),define(J[82],Y([4,5]),function(z,t){return z.create("vs/platform/files/common/fileService",t)}),define(J[83],Y([4,5]),function(z,t){return z.create("vs/platform/files/common/io",t)}),define(J[84],Y([4,5]),function(z,t){return z.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(J[85],Y([4,5]),function(z,t){return z.create("vs/platform/request/common/request",t)}),define(J[86],Y([4,5]),function(z,t){return z.create("vs/platform/telemetry/common/telemetryService",t)}),define(J[87],Y([0,1,68,46,9,6,29,19,8]),function(z,t,L,I,b,D,T,S,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parsePtyHostPort=t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class d{constructor(h,v,m){this._args=h,this.paths=v,this.productService=m}get appRoot(){return(0,D.dirname)(b.FileAccess.asFileUri("",z).fsPath)}get userHome(){return l.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return l.URI.file((0,D.join)(this.userDataPath,"User"))}get tmpDir(){return l.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,S.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,S.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const h=(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.join)(this.userDataPath,"logs",h)}return this.args.logsPath}get userDataSyncLogResource(){return l.URI.file((0,D.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,S.joinPath)(l.URI.file((0,D.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return l.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return l.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,S.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,S.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=T.env.VSCODE_PORTABLE;return h?l.URI.file((0,D.join)(h,"argv.json")):(0,S.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,S.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return l.URI.file((0,D.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,D.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,D.resolve)(h):(0,D.normalize)((0,D.join)(b.FileAccess.asFileUri("",z).fsPath,"..","extensions"))}get extensionsDownloadPath(){const h=this.args["extensions-download-dir"];return h?(0,D.resolve)(h):(0,D.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,D.resolve)(h);const v=T.env.VSCODE_EXTENSIONS;if(v)return v;const m=T.env.VSCODE_PORTABLE;return m?(0,D.join)(m,"extensions"):(0,S.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(v=>/^[^:/?#]+?:\/\//.test(v)?l.URI.parse(v):l.URI.file((0,D.normalize)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?l.URI.parse(h):l.URI.file((0,D.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return p(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,S.joinPath)(l.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return l.URI.file((0,D.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([I.memoize],d.prototype,"appRoot",null),he([I.memoize],d.prototype,"userHome",null),he([I.memoize],d.prototype,"userDataPath",null),he([I.memoize],d.prototype,"appSettingsHome",null),he([I.memoize],d.prototype,"tmpDir",null),he([I.memoize],d.prototype,"userRoamingDataHome",null),he([I.memoize],d.prototype,"settingsResource",null),he([I.memoize],d.prototype,"userDataSyncHome",null),he([I.memoize],d.prototype,"userDataSyncLogResource",null),he([I.memoize],d.prototype,"sync",null),he([I.memoize],d.prototype,"machineSettingsResource",null),he([I.memoize],d.prototype,"globalStorageHome",null),he([I.memoize],d.prototype,"workspaceStorageHome",null),he([I.memoize],d.prototype,"keybindingsResource",null),he([I.memoize],d.prototype,"keyboardLayoutResource",null),he([I.memoize],d.prototype,"argvResource",null),he([I.memoize],d.prototype,"snippetsHome",null),he([I.memoize],d.prototype,"isExtensionDevelopment",null),he([I.memoize],d.prototype,"untitledWorkspacesHome",null),he([I.memoize],d.prototype,"installSourcePath",null),he([I.memoize],d.prototype,"builtinExtensionsPath",null),he([I.memoize],d.prototype,"extensionsPath",null),he([I.memoize],d.prototype,"extensionDevelopmentLocationURI",null),he([I.memoize],d.prototype,"extensionDevelopmentKind",null),he([I.memoize],d.prototype,"extensionTestsLocationURI",null),he([I.memoize],d.prototype,"debugExtensionHost",null),he([I.memoize],d.prototype,"serviceMachineIdResource",null),he([I.memoize],d.prototype,"telemetryLogResource",null),he([I.memoize],d.prototype,"disableWorkspaceTrust",null),t.AbstractNativeEnvironmentService=d;function p(u,h){return w(u["inspect-extensions"],u["inspect-brk-extensions"],5870,h,u.debugId,u.extensionEnvironment)}t.parseExtensionHostPort=p;function C(u,h){return w(u["inspect-search"],u["inspect-brk-search"],5876,h,u.extensionEnvironment)}t.parseSearchPort=C;function c(u,h){return w(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,h,u.extensionEnvironment)}t.parsePtyHostPort=c;function w(u,h,v,m,E,f){const o=Number(h||u)||(m?null:v),e=o?Boolean(!!h):!1;let r;if(f)try{r=JSON.parse(f)}catch{}return{port:o,break:e,debugId:E,env:r}}}),function(){"use strict";function z(t,L,I,b){function D(S){const l=T(S),d=[l];return t.isAbsolute(l)||d.unshift(b),t.resolve(...d)}function T(S){const l=process.env.VSCODE_PORTABLE;if(l)return t.join(l,"user-data");let d=process.env.VSCODE_APPDATA;if(d)return t.join(d,I);const p=S["user-data-dir"];if(p)return p;switch(process.platform){case"win32":if(d=process.env.APPDATA,!d){const C=process.env.USERPROFILE;if(typeof C!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");d=t.join(C,"AppData","Roaming")}break;case"darwin":d=t.join(L.homedir(),"Library","Application Support");break;case"linux":d=process.env.XDG_CONFIG_HOME||t.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(d,I)}return{getUserDataPath:D}}if(typeof define=="function")define(J[88],Y([0,132,34,9,19,29]),function(t,L,I,b,D,T){const S=D.dirname(b.FileAccess.asFileUri("",t)),l=t.__$__nodeRequire(D.joinPath(S,"package.json").fsPath);return z(L,I,l.name,T.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),L=require("path"),I=require("os");module.exports=z(L,I,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(J[89],Y([0,1,34,87,88]),function(z,t,L,I,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class D extends I.AbstractNativeEnvironmentService{constructor(S,l){super(S,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,b.getUserDataPath)(S)},l)}}t.NativeEnvironmentService=D}),define(J[90],Y([0,1,18]),function(z,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const I=/^%([\w\d.-]+)%$/i;function b(D,T){const S=l=>{if(typeof l!="string")return;const d=I.exec(l);if(!d)return;const p=T[d[1]]??l;return typeof p=="string"?p:typeof p.message=="string"?p.message:l};return(0,L.cloneAndChange)(D,S)}t.localizeManifest=b}),define(J[51],Y([0,1,81]),function(z,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function D(c){return c=c.trim(),c==="*"||I.test(c)}t.isValidVersionStr=D;function T(c){if(!D(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let w=c.match(I);return w?{hasCaret:w[1]==="^",hasGreaterEquals:w[1]===">=",majorBase:w[2]==="x"?0:parseInt(w[2],10),majorMustEqual:w[2]!=="x",minorBase:w[4]==="x"?0:parseInt(w[4],10),minorMustEqual:w[4]!=="x",patchBase:w[6]==="x"?0:parseInt(w[6],10),patchMustEqual:w[6]!=="x",preRelease:w[8]||null}:null}t.parseVersion=T;function S(c){if(!c)return null;let w=c.majorBase,u=c.majorMustEqual,h=c.minorBase,v=c.minorMustEqual,m=c.patchBase,E=c.patchMustEqual;c.hasCaret&&(w===0||(v=!1),E=!1);let f=0;if(c.preRelease){const s=b.exec(c.preRelease);if(s){const[,o,e,r]=s;f=Date.UTC(Number(o),Number(e)-1,Number(r))}}return{majorBase:w,majorMustEqual:u,minorBase:h,minorMustEqual:v,patchBase:m,patchMustEqual:E,isMinimum:c.hasGreaterEquals,notBefore:f}}t.normalizeVersion=S;function l(c,w,u){let h;typeof c=="string"?h=S(T(c)):h=c;let v;w instanceof Date?v=w.getTime():typeof w=="string"&&(v=new Date(w).getTime());let m;if(typeof u=="string"?m=S(T(u)):m=u,!h||!m)return!1;let E=h.majorBase,f=h.minorBase,s=h.patchBase,o=m.majorBase,e=m.minorBase,r=m.patchBase,i=m.notBefore,n=m.majorMustEqual,a=m.minorMustEqual,g=m.patchMustEqual;return m.isMinimum?E>o?!0:E<o?!1:f>e?!0:f<e||v&&v<i?!1:s>=r:(E===1&&o===0&&(!n||!a||!g)&&(o=1,e=0,r=0,n=!0,a=!1,g=!1),E<o?!1:E>o?!n:f<e?!1:f>e?!a:s<r?!1:s>r?!g:!(v&&v<i))}t.isValidVersion=l;function d(c,w,u,h){return u.isBuiltin||typeof u.main=="undefined"?!0:C(c,w,u.engines.vscode,h)}t.isValidExtensionVersion=d;function p(c,w,u){return c==="*"||C(w,u,c)}t.isEngineValid=p;function C(c,w,u,h=[]){let v=S(T(u));if(!v)return h.push(L.localize(0,null,u)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return h.push(L.localize(1,null,u)),!1}else if(!v.majorMustEqual)return h.push(L.localize(2,null,u)),!1;return l(c,w,v)?!0:(h.push(L.localize(3,null,c,u)),!1)}}),define(J[41],Y([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class L{constructor(b,D=[],T=!1){this.ctor=b,this.staticArguments=D,this.supportsDelayedInstantiation=T}}t.SyncDescriptor=L}),define(J[91],Y([0,1,41]),function(z,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSingletonServiceDescriptors=t.registerSingleton=void 0;const I=[];function b(T,S,l){S instanceof L.SyncDescriptor||(S=new L.SyncDescriptor(S,[],l)),I.push([T,S])}t.registerSingleton=b;function D(){return I}t.getSingletonServiceDescriptors=D}),define(J[92],Y([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class L{constructor(D){this.incoming=new Map,this.outgoing=new Map,this.data=D}}t.Node=L;class I{constructor(D){this._hashFn=D,this._nodes=new Map}roots(){const D=[];for(let T of this._nodes.values())T.outgoing.size===0&&D.push(T);return D}insertEdge(D,T){const S=this.lookupOrInsertNode(D),l=this.lookupOrInsertNode(T);S.outgoing.set(this._hashFn(T),l),l.incoming.set(this._hashFn(D),S)}removeNode(D){const T=this._hashFn(D);this._nodes.delete(T);for(let S of this._nodes.values())S.outgoing.delete(T),S.incoming.delete(T)}lookupOrInsertNode(D){const T=this._hashFn(D);let S=this._nodes.get(T);return S||(S=new L(D),this._nodes.set(T,S)),S}lookup(D){return this._nodes.get(this._hashFn(D))}isEmpty(){return this._nodes.size===0}toString(){let D=[];for(let[T,S]of this._nodes)D.push(`${T}, (incoming)[${[...S.incoming.keys()].join(", ")}], (outgoing)[${[...S.outgoing.keys()].join(",")}]`);return D.join(`
`)}findCycleSlow(){for(let[D,T]of this._nodes){const S=new Set([D]),l=this._findCycle(T,S);if(l)return l}}_findCycle(D,T){for(let[S,l]of D.outgoing){if(T.has(S))return[...T,S].join(" -> ");T.add(S);const d=this._findCycle(l,T);if(d)return d;T.delete(S)}}}t.Graph=I}),define(J[52],Y([0,1,14]),function(z,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,L.createDecorator)("downloadService")}),define(J[21],Y([0,1,14]),function(z,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,L.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,L.refineServiceDecorator)(t.IEnvironmentService)}),define(J[22],Y([0,1,9,76,14]),function(z,t,L,I,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.ExtensionManagementErrorCode=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.getFallbackTargetPlarforms=t.isTargetPlatformCompatible=t.isNotWebExtensionInWebTargetPlatform=t.getTargetPlatform=t.toTargetPlatform=t.TargetPlatformToString=t.TargetPlatform=t.WEB_EXTENSION_TAG=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.WEB_EXTENSION_TAG="__web_extension";var D;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(D=t.TargetPlatform||(t.TargetPlatform={}));function T(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}t.TargetPlatformToString=T;function S(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}t.toTargetPlatform=S;function l(f,s){switch(f){case 3:return s==="x64"?"win32-x64":s==="ia32"?"win32-ia32":s==="arm64"?"win32-arm64":"unknown";case 2:return s==="x64"?"linux-x64":s==="arm64"?"linux-arm64":s==="arm"?"linux-armhf":"unknown";case"alpine":return s==="x64"?"alpine-x64":s==="arm64"?"alpine-arm64":"unknown";case 1:return s==="x64"?"darwin-x64":s==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}t.getTargetPlatform=l;function d(f,s){return s==="web"&&!f.includes("web")}t.isNotWebExtensionInWebTargetPlatform=d;function p(f,s,o){return d(s,o)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===o?!0:C(o).includes(f)}t.isTargetPlatformCompatible=p;function C(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}t.getFallbackTargetPlarforms=C;function c(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}t.isIExtensionIdentifier=c;var w;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(w=t.SortBy||(t.SortBy={}));var u;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(u=t.SortOrder||(t.SortOrder={}));var h;(function(f){f.Install="install",f.Uninstall="uninstall"})(h=t.StatisticType||(t.StatisticType={}));var v;(function(f){f[f.None=0]="None",f[f.Install=1]="Install",f[f.Update=2]="Update"})(v=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,b.createDecorator)("extensionGalleryService");var m;(function(f){f.Unsupported="Unsupported",f.Malicious="Malicious",f.Incompatible="Incompatible",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Internal="Internal"})(m=t.ExtensionManagementErrorCode||(t.ExtensionManagementErrorCode={}));class E extends Error{constructor(s,o){super(s);this.code=o,this.name=o}}t.ExtensionManagementError=E,t.IExtensionManagementService=(0,b.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,b.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,b.createDecorator)("IExtensionTipsService"),t.DefaultIconPath=L.FileAccess.asBrowserUri("./media/defaultIcon.png",z).toString(!0),t.ExtensionsLabel=(0,I.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,I.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,b.createDecorator)("IExtensionManagementCLIService")}),define(J[93],Y([0,1,40,6,74,24,28,7,12,31,71,133,3]),function(z,t,L,I,b,D,T,S,l,d,p,C,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveShellEnv=void 0;const w=1e4;let u;async function h(m,E,f){return E["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):l.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,C.isLaunchedFromCli)(f)&&!E["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,C.isLaunchedFromCli)(f)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),u||(u=c.Promises.withAsyncBody(async(s,o)=>{const e=new D.CancellationTokenSource,r=setTimeout(()=>{e.dispose(!0),o(new Error((0,b.localize)(0,null)))},w);try{s(await v(m,e.token))}catch(i){!(0,S.isPromiseCanceledError)(i)&&!e.token.isCancellationRequested?o(new Error((0,b.localize)(1,null,(0,T.toErrorMessage)(i)))):s({})}finally{clearTimeout(r),e.dispose()}})),u)}t.resolveShellEnv=h;async function v(m,E){const f=process.env.ELECTRON_RUN_AS_NODE;m.trace("getUnixShellEnvironment#runAsNode",f);const s=process.env.ELECTRON_NO_ATTACH_CONSOLE;m.trace("getUnixShellEnvironment#noAttach",s);const o=(0,d.generateUuid)().replace(/-/g,"").substr(0,12),e=new RegExp(o+"(.*)"+o),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};m.trace("getUnixShellEnvironment#env",r);const i=await(0,p.getSystemShell)(l.OS,r);return m.trace("getUnixShellEnvironment#shell",i),new Promise((n,a)=>{if(E.isCancellationRequested)return a((0,S.canceled)());const g=(0,I.basename)(i);let y,R;/^pwsh(-preview)?$/.test(g)?(y=`& '${process.execPath}' -p '''${o}'' + JSON.stringify(process.env) + ''${o}'''`,R=["-Login","-Command"]):(y=`'${process.execPath}' -p '"${o}" + JSON.stringify(process.env) + "${o}"'`,g==="tcsh"?R=["-ic"]:R=["-ilc"]),m.trace("getUnixShellEnvironment#spawn",JSON.stringify(R),y);const P=(0,L.spawn)(i,[...R,y],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});E.onCancellationRequested(()=>(P.kill(),a((0,S.canceled)()))),P.on("error",q=>{m.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(q)),a(q)});const O=[];P.stdout.on("data",q=>O.push(q));const U=[];P.stderr.on("data",q=>U.push(q)),P.on("close",(q,te)=>{const ce=Buffer.concat(O).toString("utf8");m.trace("getUnixShellEnvironment#raw",ce);const le=Buffer.concat(U).toString("utf8");if(le.trim()&&m.trace("getUnixShellEnvironment#stderr",le),q||te)return a(new Error((0,b.localize)(2,null,q,te)));const ne=e.exec(ce),de=ne?ne[1]:"{}";try{const x=JSON.parse(de);f?x.ELECTRON_RUN_AS_NODE=f:delete x.ELECTRON_RUN_AS_NODE,s?x.ELECTRON_NO_ATTACH_CONSOLE=s:delete x.ELECTRON_NO_ATTACH_CONSOLE,delete x.XDG_RUNTIME_DIR,m.trace("getUnixShellEnvironment#result",x),n(x)}catch(x){m.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(x)),a(x)}})})}}),define(J[53],Y([0,1,17,7,83,16]),function(z,t,L,I,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function T(p,C,c,w,u,h){let v;try{await S(p,C,c,w,u,h)}catch(m){v=m}finally{v&&u.errorTransformer&&(v=u.errorTransformer(v)),typeof v!="undefined"&&c.error(v),c.end()}}t.readFileIntoStream=T;async function S(p,C,c,w,u,h){l(h);const v=await p.open(C,{create:!1});try{l(h);let m=0,E=0,f=u&&typeof u.length=="number"?u.length:void 0,s=L.VSBuffer.alloc(Math.min(u.bufferSize,typeof f=="number"?f:u.bufferSize)),o=u&&typeof u.position=="number"?u.position:0,e=0;do E=await p.read(v,o,s.buffer,e,s.byteLength-e),o+=E,e+=E,m+=E,typeof f=="number"&&(f-=E),e===s.byteLength&&(await c.write(w(s)),s=L.VSBuffer.alloc(Math.min(u.bufferSize,typeof f=="number"?f:u.bufferSize)),e=0);while(E>0&&(typeof f!="number"||f>0)&&l(h)&&d(m,u));if(e>0){let r=e;typeof f=="number"&&(r=Math.min(e,f)),c.write(w(s.slice(0,r)))}}catch(m){throw(0,D.ensureFileSystemProviderError)(m)}finally{await p.close(v)}}function l(p){if(p.isCancellationRequested)throw(0,I.canceled)();return!0}function d(p,C){if(C?.limits){if(typeof C.limits.memory=="number"&&p>C.limits.memory)throw(0,D.createFileSystemProviderError)((0,b.localize)(0,null),D.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof C.limits.size=="number"&&p>C.limits.size)throw(0,D.createFileSystemProviderError)((0,b.localize)(1,null),D.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(J[35],Y([0,1,2,12,8,16]),function(z,t,L,I,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=t.WatcherService=t.AbstractWatcherService=void 0;class T extends L.Disposable{constructor(c,w,u){super();this.onFileChanges=c,this.onLogMessage=w,this.verboseLogging=u,this.serviceDisposables=this._register(new L.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const c=new L.DisposableStore;this.serviceDisposables.value=c,this.service=this.createService(c),this.service.setVerboseLogging(this.verboseLogging),c.add(this.service.onDidChangeFile(w=>this.onFileChanges(w))),c.add(this.service.onDidLogMessage(w=>this.onLogMessage(w))),c.add(this.service.onDidError(w=>this.onError(w)))}onError(c){this.restartCounter<T.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${c}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${c}`)}restart(c){this.restartCounter++,this.init(),this.watch(c)}async watch(c){this.requests=c,await this.service?.watch(c)}async setVerboseLogging(c){this.verboseLogging=c,await this.service?.setVerboseLogging(c)}error(c){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${c}`})}dispose(){return this.service=void 0,super.dispose()}}t.AbstractWatcherService=T,T.MAX_RESTARTS=5;class S extends L.Disposable{}t.WatcherService=S;function l(C){return C.map(c=>({type:c.type,resource:b.URI.file(c.path)}))}t.toFileChanges=l;function d(C){const c=new p;for(const w of C)c.processEvent(w);return c.normalize()}t.normalizeFileChanges=d;class p{constructor(){this.normalized=new Set,this.mapPathToChange=new Map}toKey(c){return I.isLinux?c.path:c.path.toLowerCase()}processEvent(c){const w=this.mapPathToChange.get(this.toKey(c));let u=!1;if(w){const h=w.type,v=c.type;w.path!==c.path&&c.type===2?u=!0:h===1&&v===2?(this.mapPathToChange.delete(this.toKey(c)),this.normalized.delete(w)):h===2&&v===1?w.type=0:h===1&&v===0||(w.type=v)}else u=!0;u&&(this.normalized.add(c),this.mapPathToChange.set(this.toKey(c),c))}normalize(){const c=[],w=[];return Array.from(this.normalized).filter(u=>u.type!==2?(c.push(u),!1):!0).sort((u,h)=>u.path.length-h.path.length).filter(u=>w.some(h=>(0,D.isParent)(u.path,h,!I.isLinux))?!1:(w.push(u.path),!0)).concat(c)}}}),define(J[94],Y([0,1,3,2,6,64,13,134,35]),function(z,t,L,I,b,D,T,S,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class d extends I.Disposable{constructor(C,c,w,u){super();this.path=C,this.onDidFilesChange=c,this.onLogMessage=w,this.verboseLogging=u,this.fileChangesDelayer=this._register(new L.ThrottledDelayer(S.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(C){this.verboseLogging=C}async startWatching(){try{const{stat:C,symbolicLink:c}=await T.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let w=this.path;if(c)try{w=await(0,D.realpath)(w)}catch(u){if(this.onError(u),c.dangling)return}C.isDirectory()?this._register((0,S.watchFolder)(w,(u,h)=>{this.onFileChange({type:u==="changed"?0:u==="added"?1:2,path:(0,b.join)(this.path,(0,b.basename)(h))})},u=>this.onError(u))):this._register((0,S.watchFile)(w,u=>{this.onFileChange({type:u==="changed"?0:2,path:this.path})},u=>this.onError(u)))}catch(C){C.code!=="ENOENT"&&this.onError(C)}}onFileChange(C){this.fileChangesBuffer.push(C),this.verboseLogging&&this.onVerbose(`${C.type===1?"[ADDED]":C.type===2?"[DELETED]":"[CHANGED]"} ${C.path}`),this.fileChangesDelayer.trigger(async()=>{const c=this.fileChangesBuffer;this.fileChangesBuffer=[];const w=(0,l.normalizeFileChanges)(c);if(this.verboseLogging)for(const u of w)this.onVerbose(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`);w.length>0&&this.onDidFilesChange(w)})}onError(C){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${C}`})}onVerbose(C){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${C}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=d}),define(J[95],Y([0,1,9,39,50,35]),function(z,t,L,I,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class T extends D.WatcherService{constructor(l,d,p){super();this.onDidFilesChange=l,this.onLogMessage=d,this.verboseLogging=p,this.isDisposed=!1,this.startWatching()}startWatching(){const l=this._register(new b.Client(L.FileAccess.asFileUri("bootstrap-fork",z).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherServiceNSFW"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this.service=I.ProxyChannel.toService((0,I.getNextTickChannel)(l.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(d=>!this.isDisposed&&this.onDidFilesChange(d))),this._register(this.service.onDidLogMessage(d=>this.onLogMessage(d)))}async setVerboseLogging(l){this.verboseLogging=l,this.isDisposed||await this.service?.setVerboseLogging(l)}error(l){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${l}`})}async watch(l){this.isDisposed||await this.service?.watch(l)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=T}),define(J[96],Y([0,1,9,39,50,35]),function(z,t,L,I,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class T extends D.AbstractWatcherService{constructor(l,d,p){super(l,d,p);this.init()}createService(l){const d=l.add(new b.Client(L.FileAccess.asFileUri("bootstrap-fork",z).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=watcherServiceParcel"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return l.add(d.onDidProcessExit(({code:p,signal:C})=>this.onError(`terminated by itself with code ${p}, signal: ${C}`))),I.ProxyChannel.toService((0,I.getNextTickChannel)(d.getChannel("watcher")))}}t.FileWatcher=T}),define(J[54],Y([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class L{constructor(...b){this._entries=new Map;for(let[D,T]of b)this.set(D,T)}set(b,D){const T=this._entries.get(b);return this._entries.set(b,D),T}has(b){return this._entries.has(b)}get(b){return this._entries.get(b)}}t.ServiceCollection=L}),define(J[97],Y([0,1,3,7,41,92,14,54]),function(z,t,L,I,b,D,T,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const l=!1;class d extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class p{constructor(u=new S.ServiceCollection,h=!1,v){this._activeInstantiations=new Set,this._services=u,this._strict=h,this._parent=v,this._services.set(T.IInstantiationService,this)}createChild(u){return new p(u,this._strict,this)}invokeFunction(u,...h){let v=c.traceInvocation(u),m=!1;try{return u({get:f=>{if(m)throw(0,I.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(f,v);if(!s)throw new Error(`[invokeFunction] unknown service '${f}'`);return s}},...h)}finally{m=!0,v.stop()}}createInstance(u,...h){let v,m;return u instanceof b.SyncDescriptor?(v=c.traceCreation(u.ctor),m=this._createInstance(u.ctor,u.staticArguments.concat(h),v)):(v=c.traceCreation(u),m=this._createInstance(u,h,v)),v.stop(),m}_createInstance(u,h=[],v){let m=T._util.getServiceDependencies(u).sort((s,o)=>s.index-o.index),E=[];for(const s of m){let o=this._getOrCreateServiceInstance(s.id,v);if(!o&&this._strict&&!s.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${s.id}.`);E.push(o)}let f=m.length>0?m[0].index:h.length;if(h.length!==f){console.warn(`[createInstance] First service dependency of ${u.name} at position ${f+1} conflicts with ${h.length} static arguments`);let s=f-h.length;s>0?h=h.concat(new Array(s)):h=h.slice(0,f)}return new u(...[...h,...E])}_setServiceInstance(u,h){if(this._services.get(u)instanceof b.SyncDescriptor)this._services.set(u,h);else if(this._parent)this._parent._setServiceInstance(u,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let h=this._services.get(u);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):h}_getOrCreateServiceInstance(u,h){let v=this._getServiceInstanceOrDescriptor(u);return v instanceof b.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,v,h.branch(u,!0)):(h.branch(u,!1),v)}_safeCreateAndCacheServiceInstance(u,h,v){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,h,v)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,h,v){const m=new D.Graph(s=>s.id.toString());let E=0;const f=[{id:u,desc:h,_trace:v}];for(;f.length;){const s=f.pop();if(m.lookupOrInsertNode(s),E++>1e3)throw new d(m);for(let o of T._util.getServiceDependencies(s.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(o.id);if(!e&&!o.optional&&console.warn(`[createInstance] ${u} depends on ${o.id} which is NOT registered.`),e instanceof b.SyncDescriptor){const r={id:o.id,desc:e,_trace:s._trace.branch(o.id,!0)};m.insertEdge(s,r),f.push(r)}}}for(;;){const s=m.roots();if(s.length===0){if(!m.isEmpty())throw new d(m);break}for(const{data:o}of s){if(this._getServiceInstanceOrDescriptor(o.id)instanceof b.SyncDescriptor){const r=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,r)}m.removeNode(o)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,h,v=[],m,E){if(this._services.get(u)instanceof b.SyncDescriptor)return this._createServiceInstance(h,v,m,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,h,v,m,E);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(u,h=[],v,m){if(v){const E=new L.IdleValue(()=>this._createInstance(u,h,m));return new Proxy(Object.create(null),{get(f,s){if(s in f)return f[s];let o=E.value,e=o[s];return typeof e!="function"||(e=e.bind(o),f[s]=e),e},set(f,s,o){return E.value[s]=o,!0}})}else return this._createInstance(u,h,m)}}t.InstantiationService=p;var C;(function(w){w[w.Creation=0]="Creation",w[w.Invocation=1]="Invocation",w[w.Branch=2]="Branch"})(C||(C={}));class c{constructor(u,h){this.type=u,this.name=h,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return l?new c(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):c._None}static traceCreation(u){return l?new c(0,u.name):c._None}branch(u,h){let v=new c(2,u.toString());return this._dep.push([u,h,v]),v}stop(){let u=Date.now()-this._start;c._totals+=u;let h=!1;function v(E,f){let s=[],o=new Array(E+1).join("	");for(const[e,r,i]of f._dep)if(r&&i){h=!0,s.push(`${o}CREATES -> ${e}`);let n=v(E+1,i);n&&s.push(n)}else s.push(`${o}uses -> ${e}`);return s.join(`
`)}let m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${c._totals.toFixed(2)}ms)`];(u>2||h)&&console.log(m.join(`
`))}}c._None=new class extends c{constructor(){super(-1,null)}stop(){}branch(){return this}},c._totals=0}),define(J[55],Y([0,1,14]),function(z,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=(0,L.createDecorator)("localizationsService");function I(b){if(typeof b.languageId!="string"||!Array.isArray(b.translations)||b.translations.length===0)return!1;for(const D of b.translations)if(typeof D.id!="string"||typeof D.path!="string")return!1;return!(b.languageName&&typeof b.languageName!="string"||b.localizedLanguageName&&typeof b.localizedLanguageName!="string")}t.isValidLocalization=I}),define(J[15],Y([0,1,28,10,2,12,14]),function(z,t,L,I,b,D,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.format=t.log=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,T.createDecorator)("logService"),t.ILoggerService=(0,T.createDecorator)("loggerService");function S(){return new Date().toISOString()}var l;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(l=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=l.Info;function d(r,i,n){switch(i){case l.Trace:r.trace(n);break;case l.Debug:r.debug(n);break;case l.Info:r.info(n);break;case l.Warning:r.warn(n);break;case l.Error:r.error(n);break;case l.Critical:r.critical(n);break;default:throw new Error("Invalid log level")}}t.log=d;function p(r){let i="";for(let n=0;n<r.length;n++){let a=r[n];if(typeof a=="object")try{a=JSON.stringify(a)}catch(g){}i+=(n>0?" ":"")+a}return i}t.format=p;class C extends b.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new I.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=C;class c extends C{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...n){this.checkLogLevel(l.Trace)&&this.log(l.Trace,p([i,...n]))}debug(i,...n){this.checkLogLevel(l.Debug)&&this.log(l.Debug,p([i,...n]))}info(i,...n){this.checkLogLevel(l.Info)&&this.log(l.Info,p([i,...n]))}warn(i,...n){this.checkLogLevel(l.Warning)&&this.log(l.Warning,p([i,...n]))}error(i,...n){if(this.checkLogLevel(l.Error))if(i instanceof Error){const a=Array.prototype.slice.call(arguments);a[0]=i.stack,this.log(l.Error,p(a))}else this.log(l.Error,p([i,...n]))}critical(i,...n){this.checkLogLevel(l.Critical)&&this.log(l.Critical,p([i,...n]))}flush(){}}t.AbstractMessageLogger=c;class w extends C{constructor(i=t.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!D.isWindows}trace(i,...n){this.getLevel()<=l.Trace&&(this.useColors?console.log(`[90m[main ${S()}][0m`,i,...n):console.log(`[main ${S()}]`,i,...n))}debug(i,...n){this.getLevel()<=l.Debug&&(this.useColors?console.log(`[90m[main ${S()}][0m`,i,...n):console.log(`[main ${S()}]`,i,...n))}info(i,...n){this.getLevel()<=l.Info&&(this.useColors?console.log(`[90m[main ${S()}][0m`,i,...n):console.log(`[main ${S()}]`,i,...n))}warn(i,...n){this.getLevel()<=l.Warning&&(this.useColors?console.warn(`[93m[main ${S()}][0m`,i,...n):console.warn(`[main ${S()}]`,i,...n))}error(i,...n){this.getLevel()<=l.Error&&(this.useColors?console.error(`[91m[main ${S()}][0m`,i,...n):console.error(`[main ${S()}]`,i,...n))}critical(i,...n){this.getLevel()<=l.Critical&&(this.useColors?console.error(`[90m[main ${S()}][0m`,i,...n):console.error(`[main ${S()}]`,i,...n))}dispose(){}flush(){}}t.ConsoleMainLogger=w;class u extends C{constructor(i=t.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...n){this.getLevel()<=l.Trace&&console.log("%cTRACE","color: #888",i,...n)}debug(i,...n){this.getLevel()<=l.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...n)}info(i,...n){this.getLevel()<=l.Info&&console.log("%c INFO","color: #33f",i,...n)}warn(i,...n){this.getLevel()<=l.Warning&&console.log("%c WARN","color: #993",i,...n)}error(i,...n){this.getLevel()<=l.Error&&console.log("%c  ERR","color: #f33",i,...n)}critical(i,...n){this.getLevel()<=l.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...n)}dispose(){}flush(){}}t.ConsoleLogger=u;class h extends C{constructor(i,n=t.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(n)}trace(i,...n){this.getLevel()<=l.Trace&&this.adapter.log(l.Trace,[this.extractMessage(i),...n])}debug(i,...n){this.getLevel()<=l.Debug&&this.adapter.log(l.Debug,[this.extractMessage(i),...n])}info(i,...n){this.getLevel()<=l.Info&&this.adapter.log(l.Info,[this.extractMessage(i),...n])}warn(i,...n){this.getLevel()<=l.Warning&&this.adapter.log(l.Warning,[this.extractMessage(i),...n])}error(i,...n){this.getLevel()<=l.Error&&this.adapter.log(l.Error,[this.extractMessage(i),...n])}critical(i,...n){this.getLevel()<=l.Critical&&this.adapter.log(l.Critical,[this.extractMessage(i),...n])}extractMessage(i){return typeof i=="string"?i:(0,L.toErrorMessage)(i,this.getLevel()<=l.Trace)}dispose(){}flush(){}}t.AdapterLogger=h;class v extends C{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const n of this.logServices)n.setLevel(i);super.setLevel(i)}trace(i,...n){for(const a of this.logServices)a.trace(i,...n)}debug(i,...n){for(const a of this.logServices)a.debug(i,...n)}info(i,...n){for(const a of this.logServices)a.info(i,...n)}warn(i,...n){for(const a of this.logServices)a.warn(i,...n)}error(i,...n){for(const a of this.logServices)a.error(i,...n)}critical(i,...n){for(const a of this.logServices)a.critical(i,...n)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}t.MultiplexLogService=v;class m extends b.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...n){this.logger.trace(i,...n)}debug(i,...n){this.logger.debug(i,...n)}info(i,...n){this.logger.info(i,...n)}warn(i,...n){this.logger.warn(i,...n)}error(i,...n){this.logger.error(i,...n)}critical(i,...n){this.logger.critical(i,...n)}flush(){this.logger.flush()}}t.LogService=m;class E extends b.Disposable{constructor(i,n){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(a=>{this.logLevel=a,this.logLevelChangeableLoggers.forEach(g=>g.setLevel(a))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,n){let a=this.loggers.get(i.toString());return a||(a=this.doCreateLogger(i,n?.always?l.Trace:this.logLevel,n),this.loggers.set(i.toString(),a),n?.always||this.logLevelChangeableLoggers.push(a)),a}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=E;class f{constructor(){this.onDidChangeLogLevel=new I.Emitter().event}setLevel(i){}getLevel(){return l.Info}trace(i,...n){}debug(i,...n){}info(i,...n){}warn(i,...n){}error(i,...n){}critical(i,...n){}dispose(){}flush(){}}t.NullLogService=f;function s(r){if(r.verbose)return l.Trace;if(typeof r.logLevel=="string"){const i=o(r.logLevel.toLowerCase());if(i!==void 0)return i}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=s;function o(r){switch(r){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Critical;case"off":return l.Off}}t.parseLogLevel=o;function e(r){switch(r){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Critical:return"critical";case l.Off:return"off"}}t.LogLevelToString=e});var oe=this&&this.__param||function(z,t){return function(L,I){t(L,I,z)}};define(J[98],Y([0,1,40,3,28,10,2,9,6,13,21,15]),function(z,t,L,I,b,D,T,S,l,d,p,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let c=class extends T.Disposable{constructor(u,h){super();this.environmentService=u,this.logService=h,this.processesLimiter=new I.Limiter(5)}async postUninstall(u){const h=this.parseScript(u,"uninstall");return h&&(this.logService.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(h.script,"uninstall",h.args,!0,u).then(()=>this.logService.info(u.identifier.id,u.manifest.version,"Finished running post uninstall script"),v=>this.logService.error(u.identifier.id,u.manifest.version,`Failed to run post uninstall script: ${v}`)))),d.Promises.rm(this.getExtensionStoragePath(u)).then(void 0,v=>this.logService.error("Error while removing extension storage path",v))}parseScript(u,h){const v=`vscode:${h}`;if(u.location.scheme===S.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[v]=="string"){const m=u.manifest.scripts[v].split(" ");return m.length<2||m[0]!=="node"||!m[1]?(this.logService.warn(u.identifier.id,u.manifest.version,`${v} should be a node script`),null):{script:(0,l.join)(u.location.fsPath,m[1]),args:m.slice(2)||[]}}return null}runLifecycleHook(u,h,v,m,E){return new Promise((f,s)=>{const o=this.start(u,h,v,E);let e;const r=i=>{e&&(clearTimeout(e),e=null),i?s(i):f(void 0)};o.on("error",i=>{r((0,b.toErrorMessage)(i)||"Unknown")}),o.on("exit",(i,n)=>{r(i?`post-${h} process exited with code ${i}`:void 0)}),m&&(e=setTimeout(()=>{e=null,o.kill(),s("timed out")},5e3))})}start(u,h,v,m){const E={silent:!0,execArgv:void 0},f=(0,L.fork)(u,[`--type=extension-post-${h}`,...v],E);f.stdout.setEncoding("utf8"),f.stderr.setEncoding("utf8");const s=D.Event.fromNodeEventEmitter(f.stdout,"data"),o=D.Event.fromNodeEventEmitter(f.stderr,"data");s(i=>this.logService.info(m.identifier.id,m.manifest.version,`post-${h}`,i)),o(i=>this.logService.error(m.identifier.id,m.manifest.version,`post-${h}`,i));const e=D.Event.any(D.Event.map(s,i=>({data:`%c${i}`,format:[""]})),D.Event.map(o,i=>({data:`%c${i}`,format:["color: red"]})));return D.Event.debounce(e,(i,n)=>i?{data:i.data+n.data,format:[...i.format,...n.format]}:{data:n.data,format:n.format},100)(i=>{console.group(m.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),f}getExtensionStoragePath(u){return(0,l.join)(this.environmentService.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};c=he([oe(0,p.IEnvironmentService),oe(1,C.ILogService)],c),t.ExtensionsLifecycle=c}),define(J[99],Y([0,1,20,3,7,10,2,6,35,15]),function(z,t,L,I,b,D,T,S,l,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractDiskFileSystemProvider=void 0;class p extends T.Disposable{constructor(c){super();this.logService=c,this._onDidErrorOccur=this._register(new D.Emitter),this.onDidErrorOccur=this._onDidErrorOccur.event,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new I.ThrottledDelayer(0))}watch(c,w){return w.recursive?this.watchRecursive(c,w):this.watchNonRecursive(c)}watchRecursive(c,w){const u={path:this.toFilePath(c),excludes:w.excludes},h=(0,L.insert)(this.recursiveFoldersToWatch,u);return this.refreshRecursiveWatchers(),(0,T.toDisposable)(()=>{h(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(c=>(0,b.onUnexpectedError)(c))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(c=>this._onDidChangeFile.fire((0,l.toFileChanges)(c)),c=>this.onWatcherLogMessage(c),this.logService.getLevel()===d.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===d.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(c,w){return c.watch(w)}watchNonRecursive(c){const w=this.createNonRecursiveWatcher(this.toFilePath(c),h=>this._onDidChangeFile.fire((0,l.toFileChanges)(h)),h=>this.onWatcherLogMessage(h),this.logService.getLevel()===d.LogLevel.Trace),u=this.logService.onDidChangeLogLevel(()=>{w.setVerboseLogging(this.logService.getLevel()===d.LogLevel.Trace)});return(0,T.combinedDisposable)(w,u)}onWatcherLogMessage(c){c.type==="error"&&this._onDidErrorOccur.fire(c.message),this.logService[c.type](c.message)}toFilePath(c){return(0,S.normalize)(c.fsPath)}}t.AbstractDiskFileSystemProvider=p}),define(J[100],Y([0,1,20,3,17,24,10,135,2,101,9,102,19,38,82,16,53,15]),function(z,t,L,I,b,D,T,S,l,d,p,C,c,w,u,h,v,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let E=class Ue extends l.Disposable{constructor(s){super();this.logService=s,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new T.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new T.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new I.ThrottledWorker(Ue.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ue.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ue.FILE_EVENTS_THROTTLING.coolDownDelay,o=>this._onDidFilesChange.fire(new h.FileChangesEvent(o,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new I.ThrottledWorker(Ue.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ue.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ue.FILE_EVENTS_THROTTLING.coolDownDelay,o=>this._onDidFilesChange.fire(new h.FileChangesEvent(o,!0)))),this.watchedResources=d.TernarySearchTree.forUris(o=>{const e=this.getProvider(o.scheme);return e?!this.isPathCaseSensitive(e):!1}),this.writeQueue=this._register(new I.ResourceQueue)}registerProvider(s,o){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,C.mark)(`code/registerFilesystem/${s}`),this.provider.set(s,o),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:o});const e=new l.DisposableStore;return e.add(o.onDidChangeFile(r=>this.onDidChangeFile(r,this.isPathCaseSensitive(o)))),e.add(o.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:o,scheme:s}))),typeof o.onDidErrorOccur=="function"&&e.add(o.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),(0,l.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:o}),this.provider.delete(s),(0,l.dispose)(e)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const o=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(e){o.push(e)}}),!this.provider.has(s)&&await I.Promises.settled(o)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.provider.has(s.scheme)}hasCapability(s,o){const e=this.provider.get(s.scheme);return!!(e&&e.capabilities&o)}listCapabilities(){return S.Iterable.map(this.provider,([s,o])=>({scheme:s,capabilities:o.capabilities}))}async withProvider(s){if(!(0,c.isAbsolutePath)(s))throw new h.FileOperationError((0,u.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const o=this.provider.get(s.scheme);if(!o){const e=new Error;throw e.name="ENOPRO",e.message=(0,u.localize)(1,null,s.toString()),e}return o}async withReadProvider(s){const o=await this.withProvider(s);if((0,h.hasOpenReadWriteCloseCapability)(o)||(0,h.hasReadWriteCapability)(o)||(0,h.hasFileReadStreamCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const o=await this.withProvider(s);if((0,h.hasOpenReadWriteCloseCapability)(o)||(0,h.hasReadWriteCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,o){try{return await this.doResolveFile(s,o)}catch(e){throw(0,h.toFileSystemProviderErrorCode)(e)===h.FileSystemProviderErrorCode.FileNotFound?new h.FileOperationError((0,u.localize)(2,null,this.resourceForError(s)),1):(0,h.ensureFileSystemProviderError)(e)}}async doResolveFile(s,o){const e=await this.withProvider(s),r=this.isPathCaseSensitive(e),i=o?.resolveTo,n=o?.resolveSingleChildDescendants,a=o?.resolveMetadata,g=await e.stat(s);let y;return this.toFileStat(e,s,g,void 0,!!a,(R,P)=>(y||(y=d.TernarySearchTree.forUris(()=>!r),y.set(s,!0),i&&y.fill(!0,i)),y.get(R.resource)||y.findSuperstr(R.resource.with({query:null,fragment:null}))?!0:R.isDirectory&&n?P===1:!1))}async toFileStat(s,o,e,r,i,n){const{providerExtUri:a}=this.getExtUri(s),g={resource:o,name:a.basename(o),isFile:(e.type&h.FileType.File)!=0,isDirectory:(e.type&h.FileType.Directory)!=0,isSymbolicLink:(e.type&h.FileType.SymbolicLink)!=0,mtime:e.mtime,ctime:e.ctime,size:e.size,readonly:Boolean((e.permissions??0)&h.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:(0,h.etag)({mtime:e.mtime,size:e.size})};if(g.isDirectory&&n(g,r)){try{const y=await s.readdir(o),R=await I.Promises.settled(y.map(async([P,O])=>{try{const U=a.joinPath(o,P),q=i?await s.stat(U):{type:O};return await this.toFileStat(s,U,q,y.length,i,n)}catch(U){return this.logService.trace(U),null}}));g.children=(0,L.coalesce)(R)}catch(y){this.logService.trace(y),g.children=[]}return g}return g}async resolveAll(s){return I.Promises.settled(s.map(async o=>{try{return{stat:await this.doResolveFile(o.resource,o.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(s){const o=await this.withProvider(s);try{return!!await o.stat(s)}catch(e){return!1}}async canCreateFile(s,o){try{await this.doValidateCreateFile(s,o)}catch(e){return e}return!0}async doValidateCreateFile(s,o){if(!o?.overwrite&&await this.exists(s))throw new h.FileOperationError((0,u.localize)(3,null,this.resourceForError(s)),3,o)}async createFile(s,o=b.VSBuffer.fromString(""),e){await this.doValidateCreateFile(s,e);const r=await this.writeFile(s,o);return this._onDidRunOperation.fire(new h.FileOperationEvent(s,0,r)),r}async writeFile(s,o,e){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:i}=this.getExtUri(r);try{await this.validateWriteFile(r,s,e)||await this.mkdirp(r,i.dirname(s));let a;if((0,h.hasReadWriteCapability)(r)&&!(o instanceof b.VSBuffer))if((0,w.isReadableStream)(o)){const g=await(0,w.peekStream)(o,3);g.ended?a=b.VSBuffer.concat(g.buffer):a=g}else a=(0,w.peekReadable)(o,g=>b.VSBuffer.concat(g),3);else a=o;!(0,h.hasOpenReadWriteCloseCapability)(r)||(0,h.hasReadWriteCapability)(r)&&a instanceof b.VSBuffer?await this.doWriteUnbuffered(r,s,e,a):await this.doWriteBuffered(r,s,e,a instanceof b.VSBuffer?(0,b.bufferToReadable)(a):a)}catch(n){throw new h.FileOperationError((0,u.localize)(4,null,this.resourceForError(s),(0,h.ensureFileSystemProviderError)(n).toString()),(0,h.toFileOperationResult)(n),e)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,o,e){if(!!e?.unlock&&!(s.capabilities&8192))throw new Error((0,u.localize)(5,null,this.resourceForError(o)));let i;try{i=await s.stat(o)}catch(n){return}if((i.type&h.FileType.Directory)!=0)throw new h.FileOperationError((0,u.localize)(6,null,this.resourceForError(o)),0,e);if(this.throwIfFileIsReadonly(o,i),typeof e?.mtime=="number"&&typeof e.etag=="string"&&e.etag!==h.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&e.mtime<i.mtime&&e.etag!==(0,h.etag)({mtime:e.mtime,size:i.size}))throw new h.FileOperationError((0,u.localize)(7,null),3,e);return i}async readFile(s,o){const e=await this.withReadProvider(s);return o?.atomic?this.doReadFileAtomic(e,s,o):this.doReadFile(e,s,o)}async doReadFileAtomic(s,o,e){return new Promise((r,i)=>{this.writeQueue.queueFor(o,this.getExtUri(s).providerExtUri).queue(async()=>{try{const n=await this.doReadFile(s,o,e);r(n)}catch(n){i(n)}})})}async doReadFile(s,o,e){const r=await this.doReadFileStream(s,o,{...e,preferUnbuffered:!0});return{...r,value:await(0,b.streamToBuffer)(r.value)}}async readFileStream(s,o){const e=await this.withReadProvider(s);return this.doReadFileStream(e,s,o)}async doReadFileStream(s,o,e){const r=new D.CancellationTokenSource,i=this.validateReadFile(o,e).then(a=>a,a=>{throw r.cancel(),a});let n;try{return typeof e?.etag=="string"&&e.etag!==h.ETAG_DISABLED&&await i,!((0,h.hasOpenReadWriteCloseCapability)(s)||(0,h.hasFileReadStreamCapability)(s))||(0,h.hasReadWriteCapability)(s)&&e?.preferUnbuffered?n=this.readFileUnbuffered(s,o,e):(0,h.hasFileReadStreamCapability)(s)?n=this.readFileStreamed(s,o,r.token,e):n=this.readFileBuffered(s,o,r.token,e),{...await i,value:n}}catch(a){n&&await(0,w.consumeStream)(n);const g=(0,u.localize)(8,null,this.resourceForError(o),(0,h.ensureFileSystemProviderError)(a).toString());throw a instanceof h.NotModifiedSinceFileOperationError?new h.NotModifiedSinceFileOperationError(g,a.stat,e):new h.FileOperationError(g,(0,h.toFileOperationResult)(a),e)}}readFileStreamed(s,o,e,r=Object.create(null)){const i=s.readFileStream(o,r,e);return(0,w.transform)(i,{data:n=>n instanceof b.VSBuffer?n:b.VSBuffer.wrap(n),error:n=>new h.FileOperationError((0,u.localize)(9,null,this.resourceForError(o),(0,h.ensureFileSystemProviderError)(n).toString()),(0,h.toFileOperationResult)(n),r)},n=>b.VSBuffer.concat(n))}readFileBuffered(s,o,e,r=Object.create(null)){const i=(0,b.newWriteableBufferStream)();return(0,v.readFileIntoStream)(s,o,i,n=>n,{...r,bufferSize:this.BUFFER_SIZE,errorTransformer:n=>new h.FileOperationError((0,u.localize)(10,null,this.resourceForError(o),(0,h.ensureFileSystemProviderError)(n).toString()),(0,h.toFileOperationResult)(n),r)},e),i}readFileUnbuffered(s,o,e){const r=(0,w.newWriteableStream)(i=>b.VSBuffer.concat(i));return(async()=>{try{let i=await s.readFile(o);typeof e?.position=="number"&&(i=i.slice(e.position)),typeof e?.length=="number"&&(i=i.slice(0,e.length)),this.validateReadFileLimits(o,i.byteLength,e),r.end(b.VSBuffer.wrap(i))}catch(i){r.error(i),r.end()}})(),r}async validateReadFile(s,o){const e=await this.resolve(s,{resolveMetadata:!0});if(e.isDirectory)throw new h.FileOperationError((0,u.localize)(11,null,this.resourceForError(s)),0,o);if(typeof o?.etag=="string"&&o.etag!==h.ETAG_DISABLED&&o.etag===e.etag)throw new h.NotModifiedSinceFileOperationError((0,u.localize)(12,null),e,o);return this.validateReadFileLimits(s,e.size,o),e}validateReadFileLimits(s,o,e){if(e?.limits){let r;if(typeof e.limits.memory=="number"&&o>e.limits.memory&&(r=9),typeof e.limits.size=="number"&&o>e.limits.size&&(r=7),typeof r=="number")throw new h.FileOperationError((0,u.localize)(13,null,this.resourceForError(s)),r)}}async canMove(s,o,e){return this.doCanMoveCopy(s,o,"move",e)}async canCopy(s,o,e){return this.doCanMoveCopy(s,o,"copy",e)}async doCanMoveCopy(s,o,e,r){if(s.toString()!==o.toString())try{const i=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);await this.doValidateMoveCopy(i,s,n,o,e,r)}catch(i){return i}return!0}async move(s,o,e){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),n=await this.doMoveCopy(r,s,i,o,"move",!!e),a=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new h.FileOperationEvent(s,n==="move"?2:3,a)),a}async copy(s,o,e){const r=await this.withReadProvider(s),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),n=await this.doMoveCopy(r,s,i,o,"copy",!!e),a=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new h.FileOperationEvent(s,n==="copy"?3:2,a)),a}async doMoveCopy(s,o,e,r,i,n){if(o.toString()===r.toString())return i;const{exists:a,isSameResourceWithDifferentPathCase:g}=await this.doValidateMoveCopy(s,o,e,r,i,n);if(a&&!g&&n&&await this.del(r,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(r)),i==="copy"){if(s===e&&(0,h.hasFileFolderCopyCapability)(s))await s.copy(o,r,{overwrite:n});else{const y=await this.resolve(o);y.isDirectory?await this.doCopyFolder(s,y,e,r):await this.doCopyFile(s,o,e,r)}return i}else return s===e?(await s.rename(o,r,{overwrite:n}),i):(await this.doMoveCopy(s,o,e,r,"copy",n),await this.del(o,{recursive:!0}),"copy")}async doCopyFile(s,o,e,r){if((0,h.hasOpenReadWriteCloseCapability)(s)&&(0,h.hasOpenReadWriteCloseCapability)(e))return this.doPipeBuffered(s,o,e,r);if((0,h.hasOpenReadWriteCloseCapability)(s)&&(0,h.hasReadWriteCapability)(e))return this.doPipeBufferedToUnbuffered(s,o,e,r);if((0,h.hasReadWriteCapability)(s)&&(0,h.hasOpenReadWriteCloseCapability)(e))return this.doPipeUnbufferedToBuffered(s,o,e,r);if((0,h.hasReadWriteCapability)(s)&&(0,h.hasReadWriteCapability)(e))return this.doPipeUnbuffered(s,o,e,r)}async doCopyFolder(s,o,e,r){await e.mkdir(r),Array.isArray(o.children)&&await I.Promises.settled(o.children.map(async i=>{const n=this.getExtUri(e).providerExtUri.joinPath(r,i.name);return i.isDirectory?this.doCopyFolder(s,await this.resolve(i.resource),e,n):this.doCopyFile(s,i.resource,e,n)}))}async doValidateMoveCopy(s,o,e,r,i,n){let a=!1;if(s===e){const{providerExtUri:y,isPathCaseSensitive:R}=this.getExtUri(s);if(R||(a=y.isEqual(o,r)),a&&i==="copy")throw new Error((0,u.localize)(14,null,this.resourceForError(o),this.resourceForError(r)));if(!a&&y.isEqualOrParent(r,o))throw new Error((0,u.localize)(15,null,this.resourceForError(o),this.resourceForError(r)))}const g=await this.exists(r);if(g&&!a){if(!n)throw new h.FileOperationError((0,u.localize)(16,null,this.resourceForError(o),this.resourceForError(r)),4);if(s===e){const{providerExtUri:y}=this.getExtUri(s);if(y.isEqualOrParent(o,r))throw new Error((0,u.localize)(17,null,this.resourceForError(o),this.resourceForError(r)))}}return{exists:g,isSameResourceWithDifferentPathCase:a}}getExtUri(s){const o=this.isPathCaseSensitive(s);return{providerExtUri:o?c.extUri:c.extUriIgnorePathCase,isPathCaseSensitive:o}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(o,s);const e=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new h.FileOperationEvent(s,0,e)),e}async mkdirp(s,o){const e=[],{providerExtUri:r}=this.getExtUri(s);for(;!r.isEqual(o,r.dirname(o));)try{if(((await s.stat(o)).type&h.FileType.Directory)==0)throw new Error((0,u.localize)(18,null,this.resourceForError(o)));break}catch(i){if((0,h.toFileSystemProviderErrorCode)(i)!==h.FileSystemProviderErrorCode.FileNotFound)throw i;e.push(r.basename(o)),o=r.dirname(o)}for(let i=e.length-1;i>=0;i--){o=r.joinPath(o,e[i]);try{await s.mkdir(o)}catch(n){if((0,h.toFileSystemProviderErrorCode)(n)!==h.FileSystemProviderErrorCode.FileExists)throw n}}}async canDelete(s,o){try{await this.doValidateDelete(s,o)}catch(e){return e}return!0}async doValidateDelete(s,o){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!o?.useTrash&&!(e.capabilities&4096))throw new Error((0,u.localize)(19,null,this.resourceForError(s)));let i;try{i=await e.stat(s)}catch(a){}if(i)this.throwIfFileIsReadonly(s,i);else throw new h.FileOperationError((0,u.localize)(20,null,this.resourceForError(s)),1);if(!!!o?.recursive){const a=await this.resolve(s);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,u.localize)(21,null,this.resourceForError(s)))}return e}async del(s,o){const e=await this.doValidateDelete(s,o),r=!!o?.useTrash,i=!!o?.recursive;await e.delete(s,{recursive:i,useTrash:r}),this._onDidRunOperation.fire(new h.FileOperationEvent(s,1))}onDidChangeFile(s,o){this._onDidChangeFilesRaw.fire({changes:s});let e,r;{for(const i of s)this.watchedResources.has(i.resource)?(e||(e=[]),e.push(i)):(r||(r=[]),r.push(i));e&&this._onDidFilesChange.fire(new h.FileChangesEvent(e,!o))}if(r){const i=o?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!i.work(r)&&Ue.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${r.length}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),i.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${i.pending}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(s,o={recursive:!1,excludes:[]}){const e=new l.DisposableStore;let r=!1,i=()=>{r=!0};return e.add((0,l.toDisposable)(()=>i())),this.doWatch(s,o).then(n=>{r?(0,l.dispose)(n):i=()=>(0,l.dispose)(n)},n=>this.logService.error(n)),o.recursive||(this.watchedResources.set(s,(this.watchedResources.get(s)??0)+1),e.add((0,l.toDisposable)(()=>{const n=this.watchedResources.get(s);typeof n=="number"&&(n<=1?this.watchedResources.delete(s):this.watchedResources.set(s,n-1))}))),e}async doWatch(s,o){const e=await this.withProvider(s),r=this.toWatchKey(e,s,o);let i=this.activeWatchers.get(r);return i||(i={count:0,disposable:e.watch(s,o)},this.activeWatchers.set(r,i)),i.count+=1,(0,l.toDisposable)(()=>{i&&(i.count--,i.count===0&&((0,l.dispose)(i.disposable),this.activeWatchers.delete(r)))})}toWatchKey(s,o,e){const{providerExtUri:r}=this.getExtUri(s);return[r.getComparisonKey(o),String(e.recursive),e.excludes.join()].join()}dispose(){super.dispose();for(const[,s]of this.activeWatchers)(0,l.dispose)(s.disposable);this.activeWatchers.clear()}async doWriteBuffered(s,o,e,r){return this.writeQueue.queueFor(o,this.getExtUri(s).providerExtUri).queue(async()=>{const i=await s.open(o,{create:!0,unlock:e?.unlock??!1});try{(0,w.isReadableStream)(r)||(0,w.isReadableBufferedStream)(r)?await this.doWriteStreamBufferedQueued(s,i,r):await this.doWriteReadableBufferedQueued(s,i,r)}catch(n){throw(0,h.ensureFileSystemProviderError)(n)}finally{await s.close(i)}})}async doWriteStreamBufferedQueued(s,o,e){let r=0,i;if((0,w.isReadableBufferedStream)(e)){if(e.buffer.length>0){const n=b.VSBuffer.concat(e.buffer);await this.doWriteBuffer(s,o,n,n.byteLength,r,0),r+=n.byteLength}if(e.ended)return;i=e.stream}else i=e;return new Promise((n,a)=>{(0,w.listenStream)(i,{onData:async g=>{i.pause();try{await this.doWriteBuffer(s,o,g,g.byteLength,r,0)}catch(y){return a(y)}r+=g.byteLength,setTimeout(()=>i.resume())},onError:g=>a(g),onEnd:()=>n()})})}async doWriteReadableBufferedQueued(s,o,e){let r=0,i;for(;(i=e.read())!==null;)await this.doWriteBuffer(s,o,i,i.byteLength,r,0),r+=i.byteLength}async doWriteBuffer(s,o,e,r,i,n){let a=0;for(;a<r;)a+=await s.write(o,i+a,e.buffer,n+a,r-a)}async doWriteUnbuffered(s,o,e,r){return this.writeQueue.queueFor(o,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,o,e,r))}async doWriteUnbufferedQueued(s,o,e,r){let i;r instanceof b.VSBuffer?i=r:(0,w.isReadableStream)(r)?i=await(0,b.streamToBuffer)(r):(0,w.isReadableBufferedStream)(r)?i=await(0,b.bufferedStreamToBuffer)(r):i=(0,b.readableToBuffer)(r),await s.writeFile(o,i.buffer,{create:!0,overwrite:!0,unlock:e?.unlock??!1})}async doPipeBuffered(s,o,e,r){return this.writeQueue.queueFor(r,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,o,e,r))}async doPipeBufferedQueued(s,o,e,r){let i,n;try{i=await s.open(o,{create:!1}),n=await e.open(r,{create:!0,unlock:!1});const a=b.VSBuffer.alloc(this.BUFFER_SIZE);let g=0,y=0,R=0;do R=await s.read(i,g,a.buffer,y,a.byteLength-y),await this.doWriteBuffer(e,n,a,R,g,y),g+=R,y+=R,y===a.byteLength&&(y=0);while(R>0)}catch(a){throw(0,h.ensureFileSystemProviderError)(a)}finally{await I.Promises.settled([typeof i=="number"?s.close(i):Promise.resolve(),typeof n=="number"?e.close(n):Promise.resolve()])}}async doPipeUnbuffered(s,o,e,r){return this.writeQueue.queueFor(r,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,o,e,r))}async doPipeUnbufferedQueued(s,o,e,r){return e.writeFile(r,await s.readFile(o),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,o,e,r){return this.writeQueue.queueFor(r,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,o,e,r))}async doPipeUnbufferedToBufferedQueued(s,o,e,r){const i=await e.open(r,{create:!0,unlock:!1});try{const n=await s.readFile(o);await this.doWriteBuffer(e,i,b.VSBuffer.wrap(n),n.byteLength,0,0)}catch(n){throw(0,h.ensureFileSystemProviderError)(n)}finally{await e.close(i)}}async doPipeBufferedToUnbuffered(s,o,e,r){const i=await(0,b.streamToBuffer)(this.readFileBuffered(s,o,D.CancellationToken.None));await this.doWriteUnbuffered(e,r,void 0,i)}throwIfFileSystemIsReadonly(s,o){if(s.capabilities&2048)throw new h.FileOperationError((0,u.localize)(22,null,this.resourceForError(o)),6);return s}throwIfFileIsReadonly(s,o){if((o.permissions??0)&h.FilePermission.Readonly)throw new h.FileOperationError((0,u.localize)(23,null,this.resourceForError(s)),6)}resourceForError(s){return s.scheme===p.Schemas.file?s.fsPath:s.toString(!0)}};E.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},E=he([oe(0,m.ILogService)],E),t.FileService=E}),define(J[103],Y([0,1,48,136,3,17,10,47,6,12,19,38,13,84,16,53,94,95,96,99,28]),function(z,t,L,I,b,D,T,S,l,d,p,C,c,w,u,h,v,m,E,f,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0,(()=>{try{(0,I.gracefulify)(L)}catch(e){console.error(`Error enabling graceful-fs: ${(0,s.toErrorMessage)(e)}`)}})();class o extends f.AbstractDiskFileSystemProvider{constructor(r,i){super(r);this.options=i,this.onDidChangeCapabilities=T.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,d.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:i,symbolicLink:n}=await c.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.toFileSystemProviderError(i)}}async readdir(r){try{const i=await c.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async a=>{try{let g;a.isSymbolicLink()?g=(await this.stat((0,p.joinPath)(r,a.name))).type:g=this.toType(a),n.push([a.name,g])}catch(g){this.logService.trace(g)}})),n}catch(i){throw this.toFileSystemProviderError(i)}}toType(r,i){let n;return i?.dangling?n=u.FileType.Unknown:r.isFile()?n=u.FileType.File:r.isDirectory()?n=u.FileType.Directory:n=u.FileType.Unknown,i&&(n|=u.FileType.SymbolicLink),n}async readFile(r){try{const i=this.toFilePath(r);return await c.Promises.readFile(i)}catch(i){throw this.toFileSystemProviderError(i)}}readFileStream(r,i,n){const a=(0,C.newWriteableStream)(g=>D.VSBuffer.concat(g.map(y=>D.VSBuffer.wrap(y))).buffer);return(0,h.readFileIntoStream)(this,r,a,g=>g.buffer,{...i,bufferSize:256*1024},n),a}async writeFile(r,i,n){let a;try{const g=this.toFilePath(r);if(!n.create||!n.overwrite){if(await c.Promises.exists(g)){if(!n.overwrite)throw(0,u.createFileSystemProviderError)((0,w.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,u.createFileSystemProviderError)((0,w.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(r,{create:!0,unlock:n.unlock}),await this.write(a,0,i,0,i.byteLength)}catch(g){throw await this.toFileSystemProviderWriteError(r,g)}finally{typeof a=="number"&&await this.close(a)}}async open(r,i){try{const n=this.toFilePath(r);if((0,u.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:y}=await c.SymlinkSupport.stat(n);y.mode&128||await c.Promises.chmod(n,y.mode|128)}catch(y){this.logService.trace(y)}let a;if((0,u.isFileOpenForWriteOptions)(i)){if(d.isWindows)try{await c.Promises.truncate(n,0),a="r+"}catch(y){y.code!=="ENOENT"&&this.logService.trace(y)}a||(a="w")}else a="r";const g=await c.Promises.open(n,a);return this.mapHandleToPos.set(g,0),(0,u.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(g,r),g}catch(n){throw(0,u.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(r,n):this.toFileSystemProviderError(n)}}async close(r){try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await c.Promises.fdatasync(r)}catch(i){this.canFlush=!1,this.logService.error(i)}return await c.Promises.close(r)}catch(i){throw this.toFileSystemProviderError(i)}}async read(r,i,n,a,g){const y=this.normalizePos(r,i);let R=null;try{const P=await c.Promises.read(r,n,a,g,y);return typeof P=="number"?R=P:R=P.bytesRead,R}catch(P){throw this.toFileSystemProviderError(P)}finally{this.updatePos(r,y,R)}}normalizePos(r,i){return i===this.mapHandleToPos.get(r)?null:i}updatePos(r,i,n){const a=this.mapHandleToPos.get(r);typeof a=="number"&&(typeof i=="number"||(typeof n=="number"?this.mapHandleToPos.set(r,a+n):this.mapHandleToPos.delete(r)))}async write(r,i,n,a,g){return(0,b.retry)(()=>this.doWrite(r,i,n,a,g),100,3)}async doWrite(r,i,n,a,g){const y=this.normalizePos(r,i);let R=null;try{const P=await c.Promises.write(r,n,a,g,y);return typeof P=="number"?R=P:R=P.bytesWritten,R}catch(P){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),P)}finally{this.updatePos(r,y,R)}}async mkdir(r){try{await c.Promises.mkdir(this.toFilePath(r))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(r,i){try{const n=this.toFilePath(r);await this.doDelete(n,i)}catch(n){throw this.toFileSystemProviderError(n)}}async doDelete(r,i){i.recursive?await c.Promises.rm(r,c.RimRafMode.MOVE):await c.Promises.unlink(r)}async rename(r,i,n){const a=this.toFilePath(r),g=this.toFilePath(i);if(a!==g)try{await this.validateTargetDeleted(r,i,"move",n.overwrite),await c.Promises.move(a,g)}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,w.localize)(2,null,(0,l.basename)(a),(0,l.basename)((0,l.dirname)(g)),y.toString()))),this.toFileSystemProviderError(y)}}async copy(r,i,n){const a=this.toFilePath(r),g=this.toFilePath(i);if(a!==g)try{await this.validateTargetDeleted(r,i,"copy",n.overwrite),await c.Promises.copy(a,g,{preserveSymlinks:!0})}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,w.localize)(3,null,(0,l.basename)(a),(0,l.basename)((0,l.dirname)(g)),y.toString()))),this.toFileSystemProviderError(y)}}async validateTargetDeleted(r,i,n,a){const g=this.toFilePath(r),y=this.toFilePath(i);let R=!1;if(!!(this.capabilities&1024)||(R=(0,S.isEqual)(g,y,!0)),R&&n==="copy")throw(0,u.createFileSystemProviderError)((0,w.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(!R&&await c.Promises.exists(y)){if(!a)throw(0,u.createFileSystemProviderError)((0,w.localize)(5,null),u.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(r,i,n){let a,g=!1;return this.options?.watcher?.usePolling?g=!1:g=this.options?.legacyWatcher==="on",g?a=m.FileWatcher:a=E.FileWatcher,new a(y=>r(y),y=>i(y),n,this.options?.watcher)}doWatch(r,i){const n=this.options?.watcher?.usePolling;if(n===!0)for(const a of i)a.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(n))for(const a of i)n.includes(a.path)&&(a.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(r,i)}createNonRecursiveWatcher(r,i,n,a){return new v.FileWatcher(r,g=>i(g),g=>n(g),a)}toFileSystemProviderError(r){if(r instanceof u.FileSystemProviderError)return r;let i;switch(r.code){case"ENOENT":i=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=u.FileSystemProviderErrorCode.NoPermissions;break;default:i=u.FileSystemProviderErrorCode.Unknown}return(0,u.createFileSystemProviderError)(r,i)}async toFileSystemProviderWriteError(r,i){let n=this.toFileSystemProviderError(i);if(r&&n.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await c.SymlinkSupport.stat(this.toFilePath(r));a.mode&128||(n=(0,u.createFileSystemProviderError)(i,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.logService.trace(a)}return n}}t.DiskFileSystemProvider=o}),define(J[104],Y([0,1,16,15]),function(z,t,L,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=t.createRotatingLogger=void 0;async function b(l,d,p,C){try{const c=await new Promise((w,u)=>{z(["spdlog"],w,u)});return c.setFlushOn(I.LogLevel.Trace),c.createAsyncRotatingLogger(l,d,p,C)}catch(c){console.error(c)}return null}function D(l,d,p,C){const c=z.__$__nodeRequire("spdlog");return c.setFlushOn(I.LogLevel.Trace),c.createRotatingLogger(l,d,p,C)}t.createRotatingLogger=D;function T(l,d,p){switch(d){case I.LogLevel.Trace:l.trace(p);break;case I.LogLevel.Debug:l.debug(p);break;case I.LogLevel.Info:l.info(p);break;case I.LogLevel.Warning:l.warn(p);break;case I.LogLevel.Error:l.error(p);break;case I.LogLevel.Critical:l.critical(p);break;default:throw new Error("Invalid log level")}}class S extends I.AbstractMessageLogger{constructor(d,p,C,c){super();this.name=d,this.filepath=p,this.rotating=C,this.buffer=[],this.setLevel(c),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(w=>{this._logger&&this._logger.setLevel(w)}))}_createSpdLogLogger(){const d=this.rotating?6:1,p=30/d*L.ByteSize.MB;return b(this.name,this.filepath,p,d).then(C=>{if(C){this._logger=C,this._logger.setLevel(this.getLevel());for(const{level:c,message:w}of this.buffer)T(this._logger,c,w);this.buffer=[]}})}log(d,p){this._logger?T(this._logger,d,p):this.getLevel()<=d&&this.buffer.push({level:d,message:p})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=S}),define(J[32],Y([0,1,14]),function(z,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=(0,L.createDecorator)("productService")}),define(J[25],Y([0,1,56,11]),function(z,t,L,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class b{constructor(){this.data=new Map}add(T,S){L.ok(I.isString(T)),L.ok(I.isObject(S)),L.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,S)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}t.Registry=new b}),define(J[105],Y([0,1,10,25]),function(z,t,L,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function b(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class D{constructor(){this._onDidChangeSchema=new L.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(l,d){this.schemasById[b(l)]=d,this._onDidChangeSchema.fire(l)}notifySchemaChanged(l){this._onDidChangeSchema.fire(l)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new D;I.Registry.add(t.Extensions.JSONContribution,T)}),define(J[33],Y([0,1,20,10,11,73,105,25]),function(z,t,L,I,b,D,T,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=t.EditPresentationTypes=void 0;var l;(function(E){E.Multiline="multilineText",E.Singleline="singlelineText"})(l=t.EditPresentationTypes||(t.EditPresentationTypes={})),t.Extensions={Configuration:"base.contributions.configuration"};var d;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.MACHINE=2]="MACHINE",E[E.WINDOW=3]="WINDOW",E[E.RESOURCE=4]="RESOURCE",E[E.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",E[E.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(d=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const p=S.Registry.as(T.Extensions.JSONContribution);class C{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new I.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new I.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},p.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(f,s=!0){this.registerConfigurations([f],s)}registerConfigurations(f,s=!0){const o=this.doRegisterConfigurations(f,s);p.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterConfigurations(f){const s=this.doDeregisterConfigurations(f);p.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}updateConfigurations({add:f,remove:s}){const o=[];o.push(...this.doDeregisterConfigurations(s)),o.push(...this.doRegisterConfigurations(f,!1)),p.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,L.distinct)(o))}registerDefaultConfigurations(f){const s=[],o=[];for(const e of f)for(const r in e)if(s.push(r),t.OVERRIDE_PROPERTY_PATTERN.test(r)){this.defaultValues[r]={...this.defaultValues[r]||{},...e[r]};const i={type:"object",default:this.defaultValues[r],description:D.localize(1,null,r),$ref:t.resourceLanguageSettingsSchemaId};o.push(w(r)),this.configurationProperties[r]=i,this.defaultLanguageConfigurationOverridesNode.properties[r]=i}else{this.defaultValues[r]=e[r];const i=this.configurationProperties[r];i&&(this.updatePropertyDefaultValue(r,i),this.updateSchema(r,i))}this.registerOverrideIdentifiers(o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}deregisterDefaultConfigurations(f){const s=[];for(const o of f)for(const e in o)if(s.push(e),delete this.defaultValues[e],t.OVERRIDE_PROPERTY_PATTERN.test(e))delete this.configurationProperties[e],delete this.defaultLanguageConfigurationOverridesNode.properties[e];else{const r=this.configurationProperties[e];r&&(this.updatePropertyDefaultValue(e,r),this.updateSchema(e,r))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}notifyConfigurationSchemaUpdated(...f){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(f){for(const s of f)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(f,s){const o=[];return f.forEach(e=>{o.push(...this.validateAndRegisterProperties(e,s,e.extensionInfo)),this.configurationContributors.push(e),this.registerJSONConfiguration(e)}),o}doDeregisterConfigurations(f){const s=[],o=e=>{if(e.properties)for(const r in e.properties)s.push(r),delete this.configurationProperties[r],this.removeFromSchema(r,e.properties[r]);e.allOf&&e.allOf.forEach(r=>o(r))};for(const e of f){o(e);const r=this.configurationContributors.indexOf(e);r!==-1&&this.configurationContributors.splice(r,1)}return s}validateAndRegisterProperties(f,s=!0,o,e=3){e=b.isUndefinedOrNull(f.scope)?e:f.scope;let r=[],i=f.properties;if(i)for(let a in i){if(s&&v(a)){delete i[a];continue}const g=i[a];if(this.updatePropertyDefaultValue(a,g),t.OVERRIDE_PROPERTY_PATTERN.test(a)?g.scope=void 0:(g.scope=b.isUndefinedOrNull(g.scope)?e:g.scope,g.restricted=b.isUndefinedOrNull(g.restricted)?!!o?.restrictedConfigurations?.includes(a):g.restricted),i[a].hasOwnProperty("included")&&!i[a].included){this.excludedConfigurationProperties[a]=i[a],delete i[a];continue}else this.configurationProperties[a]=i[a];!i[a].deprecationMessage&&i[a].markdownDeprecationMessage&&(i[a].deprecationMessage=i[a].markdownDeprecationMessage),r.push(a)}let n=f.allOf;if(n)for(let a of n)r.push(...this.validateAndRegisterProperties(a,s,o,e));return r}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(f){const s=o=>{let e=o.properties;if(e)for(const i in e)this.updateSchema(i,e[i]);let r=o.allOf;r&&r.forEach(s)};s(f)}updateSchema(f,s){switch(t.allSettings.properties[f]=s,s.scope){case 1:t.applicationSettings.properties[f]=s;break;case 2:t.machineSettings.properties[f]=s;break;case 6:t.machineOverridableSettings.properties[f]=s;break;case 3:t.windowSettings.properties[f]=s;break;case 4:t.resourceSettings.properties[f]=s;break;case 5:t.resourceSettings.properties[f]=s,this.resourceLanguageSettingsSchema.properties[f]=s;break}}removeFromSchema(f,s){switch(delete t.allSettings.properties[f],s.scope){case 1:delete t.applicationSettings.properties[f];break;case 2:delete t.machineSettings.properties[f];break;case 6:delete t.machineOverridableSettings.properties[f];break;case 3:delete t.windowSettings.properties[f];break;case 4:case 5:delete t.resourceSettings.properties[f];break}}updateOverridePropertyPatternKey(){for(const f of this.overrideIdentifiers.values()){const s=`[${f}]`,o={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,o),t.allSettings.properties[s]=o,t.applicationSettings.properties[s]=o,t.machineSettings.properties[s]=o,t.machineOverridableSettings.properties[s]=o,t.windowSettings.properties[s]=o,t.resourceSettings.properties[s]=o}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(f,s){let o=this.defaultValues[f];b.isUndefined(o)&&(o=s.default),b.isUndefined(o)&&(o=u(s.type)),s.default=o}}const c="\\[.*\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(c);function w(E){return E.substring(1,E.length-1)}t.overrideIdentifierFromKey=w;function u(E){switch(Array.isArray(E)?E[0]:E){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=u;const h=new C;S.Registry.add(t.Extensions.Configuration,h);function v(E){return E.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(E)?D.localize(5,null,E):h.getConfigurationProperties()[E]!==void 0?D.localize(6,null,E):null:D.localize(4,null)}t.validateProperty=v;function m(){const E=[],f=h.getConfigurationProperties();for(const s of Object.keys(f))E.push([s,f[s].scope]);return E.push(["launch",4]),E.push(["task",4]),E}t.getScopes=m}),define(J[26],Y([0,1,18,11,8,33,14,25]),function(z,t,L,I,b,D,T,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,T.createDecorator)("configurationService");function l(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof b.URI)}t.isConfigurationOverrides=l;var d;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(d=t.ConfigurationTarget||(t.ConfigurationTarget={}));function p(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=p;function C(r,i){const n=i?r?i.keys.filter(U=>r.keys.indexOf(U)===-1):[...i.keys]:[],a=r?i?r.keys.filter(U=>i.keys.indexOf(U)===-1):[...r.keys]:[],g=[];if(i&&r){for(const U of r.keys)if(i.keys.indexOf(U)!==-1){const q=m(r.contents,U),te=m(i.contents,U);L.equals(q,te)||g.push(U)}}const y=[],R=U=>{const q={};for(const te of U)for(const ce of te.identifiers)q[o(ce)]=te;return q},P=i?R(i.overrides):{},O=r?R(r.overrides):{};if(Object.keys(P).length)for(const U of n){const q=P[U];q&&y.push([(0,D.overrideIdentifierFromKey)(U),q.keys])}if(Object.keys(O).length)for(const U of a){const q=O[U];q&&y.push([(0,D.overrideIdentifierFromKey)(U),q.keys])}if(Object.keys(P).length&&Object.keys(O).length)for(const U of g){const q=O[U],te=P[U];if(q&&te){const ce=C({contents:q.contents,keys:q.keys,overrides:[]},{contents:te.contents,keys:te.keys,overrides:[]});y.push([(0,D.overrideIdentifierFromKey)(U),[...ce.added,...ce.removed,...ce.updated]])}}return{added:n,removed:a,updated:g,overrides:y}}t.compare=C;function c(r,i){const n=[];for(const a of Object.keys(r))if(D.OVERRIDE_PROPERTY_PATTERN.test(a)){const g={};for(const y in r[a])g[y]=r[a][y];n.push({identifiers:[(0,D.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(g),contents:w(g,i)})}return n}t.toOverrides=c;function w(r,i){const n=Object.create(null);for(let a in r)u(n,a,r[a],i);return n}t.toValuesTree=w;function u(r,i,n,a){const g=i.split("."),y=g.pop();let R=r;for(let P=0;P<g.length;P++){let O=g[P],U=R[O];switch(typeof U){case"undefined":U=R[O]=Object.create(null);break;case"object":break;default:a(`Ignoring ${i} as ${g.slice(0,P+1).join(".")} is ${JSON.stringify(U)}`);return}R=U}if(typeof R=="object"&&R!==null)try{R[y]=n}catch(P){a(`Ignoring ${i} as ${g.join(".")} is ${JSON.stringify(R)}`)}else a(`Ignoring ${i} as ${g.join(".")} is ${JSON.stringify(R)}`)}t.addToValueTree=u;function h(r,i){const n=i.split(".");v(r,n)}t.removeFromValueTree=h;function v(r,i){const n=i.shift();if(i.length===0){delete r[n];return}if(Object.keys(r).indexOf(n)!==-1){const a=r[n];typeof a=="object"&&!Array.isArray(a)&&(v(a,i),Object.keys(a).length===0&&delete r[n])}}function m(r,i,n){function a(R,P){let O=R;for(const U of P){if(typeof O!="object"||O===null)return;O=O[U]}return O}const g=i.split("."),y=a(r,g);return typeof y=="undefined"?n:y}t.getConfigurationValue=m;function E(r,i,n){Object.keys(i).forEach(a=>{a!=="__proto__"&&(a in r?I.isObject(r[a])&&I.isObject(i[a])?E(r[a],i[a],n):n&&(r[a]=i[a]):r[a]=i[a])})}t.merge=E;function f(){const r=S.Registry.as(D.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}t.getConfigurationKeys=f;function s(){const r=Object.create(null),i=S.Registry.as(D.Extensions.Configuration).getConfigurationProperties();for(let n in i){let a=i[n].default;u(r,n,a,g=>console.error(`Conflict in default settings: ${g}`))}return r}t.getDefaultValues=s;function o(r){return`[${r}]`}t.keyFromOverrideIdentifier=o;function e(r,i,n){const a=r.inspect(i),g=r.inspect(n);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof g.userValue!="undefined"||typeof g.workspaceValue!="undefined"||typeof g.workspaceFolderValue!="undefined"?g.value:a.defaultValue}t.getMigratedSettingValue=e}),define(J[106],Y([0,1,20,10,57,2,101,18,11,8,26,33,25]),function(z,t,L,I,b,D,T,S,l,d,p,C,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class w{constructor(e={},r=[],i=[]){this._contents=e,this._keys=r,this._overrides=i,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,p.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,r){const i=this.getContentsForOverrideIdentifer(r);return i?e?(0,p.getConfigurationValue)(i,e):i:void 0}getKeysForOverrideIdentifier(e){for(const r of this.overrides)if(r.identifiers.indexOf(e)!==-1)return r.keys;return[]}override(e){let r=this.overrideConfigurations.get(e);return r||(r=this.createOverrideConfigurationModel(e),this.overrideConfigurations.set(e,r)),r}merge(...e){const r=S.deepClone(this.contents),i=S.deepClone(this.overrides),n=[...this.keys];for(const a of e){this.mergeContents(r,a.contents);for(const g of a.overrides){const[y]=i.filter(R=>L.equals(R.identifiers,g.identifiers));y?this.mergeContents(y.contents,g.contents):i.push(S.deepClone(g))}for(const g of a.keys)n.indexOf(g)===-1&&n.push(g)}return new w(r,n,i)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(e){const r=this.getContentsForOverrideIdentifer(e);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let i={};for(const n of L.distinct([...Object.keys(this.contents),...Object.keys(r)])){let a=this.contents[n],g=r[n];g&&(typeof a=="object"&&typeof g=="object"?(a=S.deepClone(a),this.mergeContents(a,g)):a=g),i[n]=a}return new w(i,this.keys,this.overrides)}mergeContents(e,r){for(const i of Object.keys(r)){if(i in e&&l.isObject(e[i])&&l.isObject(r[i])){this.mergeContents(e[i],r[i]);continue}e[i]=S.deepClone(r[i])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?S.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const r of this.overrides)if(r.identifiers.indexOf(e)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,r){this.addKey(e),(0,p.addToValueTree)(this.contents,e,r,i=>{throw new Error(i)})}removeValue(e){this.removeKey(e)&&(0,p.removeFromValueTree)(this.contents,e)}addKey(e){let r=this.keys.length;for(let i=0;i<r;i++)e.indexOf(this.keys[i])===0&&(r=i);this.keys.splice(r,1,e)}removeKey(e){let r=this.keys.indexOf(e);return r!==-1?(this.keys.splice(r,1),!0):!1}}t.ConfigurationModel=w;class u extends w{constructor(){const e=(0,p.getDefaultValues)(),r=(0,p.getConfigurationKeys)(),i=[];for(const n of Object.keys(e))C.OVERRIDE_PROPERTY_PATTERN.test(n)&&i.push({identifiers:[(0,C.overrideIdentifierFromKey)(n).trim()],keys:Object.keys(e[n]),contents:(0,p.toValuesTree)(e[n],a=>console.error(`Conflict in default settings file: ${a}`))});super(e,r,i)}}t.DefaultConfigurationModel=u;class h{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new w}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,r){if(!l.isUndefinedOrNull(e)){const i=this.doParseContent(e);this.parseRaw(i,r)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,r){this._raw=e;const{contents:i,keys:n,overrides:a,restricted:g}=this.doParseRaw(e,r);this._configurationModel=new w(i,n,a),this._restrictedConfigurations=g||[]}doParseContent(e){let r={},i=null,n=[],a=[],g=[];function y(P){Array.isArray(n)?n.push(P):i!==null&&(n[i]=P)}let R={onObjectBegin:()=>{let P={};y(P),a.push(n),n=P,i=null},onObjectProperty:P=>{i=P},onObjectEnd:()=>{n=a.pop()},onArrayBegin:()=>{let P=[];y(P),a.push(n),n=P,i=null},onArrayEnd:()=>{n=a.pop()},onLiteralValue:y,onError:(P,O,U)=>{g.push({error:P,offset:O,length:U})}};if(e)try{b.visit(e,R),r=n[0]||{}}catch(P){console.error(`Error while parsing settings file ${this._name}: ${P}`),this._parseErrors=[P]}return r}doParseRaw(e,r){const i=c.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),n=this.filter(e,i,!0,r);e=n.raw;const a=(0,p.toValuesTree)(e,R=>console.error(`Conflict in settings file ${this._name}: ${R}`)),g=Object.keys(e),y=(0,p.toOverrides)(e,R=>console.error(`Conflict in settings file ${this._name}: ${R}`));return{contents:a,keys:g,overrides:y,restricted:n.restricted}}filter(e,r,i,n){if(!n?.scopes&&!n?.skipRestricted)return{raw:e,restricted:[]};const a={},g=[];for(let y in e)if(C.OVERRIDE_PROPERTY_PATTERN.test(y)&&i){const R=this.filter(e[y],r,!1,n);a[y]=R.raw,g.push(...R.restricted)}else{const R=r[y],P=R?typeof R.scope!="undefined"?R.scope:3:void 0;R?.restricted&&g.push(y),(P===void 0||n.scopes===void 0||n.scopes.includes(P))&&(n.skipRestricted&&R?.restricted||(a[y]=e[y]))}return{raw:a,restricted:g}}}t.ConfigurationModelParser=h;class v extends D.Disposable{constructor(e,r,i,n){super();this.userSettingsResource=e,this.scopes=r,this.fileService=n,this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(I.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(e){return new w}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=v;class m{constructor(e,r,i=new w,n=new w,a=new T.ResourceMap,g=new w,y=new T.ResourceMap,R=!0){this._defaultConfiguration=e,this._localUserConfiguration=r,this._remoteUserConfiguration=i,this._workspaceConfiguration=n,this._folderConfigurations=a,this._memoryConfiguration=g,this._memoryConfigurationByResource=y,this._freeze=R,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(e,r,i){return this.getConsolidateConfigurationModel(r,i).getValue(e)}updateValue(e,r,i={}){let n;i.resource?(n=this._memoryConfigurationByResource.get(i.resource),n||(n=new w,this._memoryConfigurationByResource.set(i.resource,n))):n=this._memoryConfiguration,r===void 0?n.removeValue(e):n.setValue(e,r),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,r,i){const n=this.getConsolidateConfigurationModel(r,i),a=this.getFolderConfigurationModelForResource(r.resource,i),g=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,y=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),R=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),P=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),O=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),U=i?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,q=a?r.overrideIdentifier?a.freeze().override(r.overrideIdentifier).getValue(e):a.freeze().getValue(e):void 0,te=r.overrideIdentifier?g.override(r.overrideIdentifier).getValue(e):g.getValue(e),ce=n.getValue(e),le=L.distinct(L.flatten(n.overrides.map(ne=>ne.identifiers))).filter(ne=>n.getOverrideValue(e,ne)!==void 0);return{defaultValue:y,userValue:R,userLocalValue:P,userRemoteValue:O,workspaceValue:U,workspaceFolderValue:q,memoryValue:te,value:ce,default:y!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,r.overrideIdentifier):void 0}:void 0,user:R!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,r.overrideIdentifier):void 0}:void 0,userLocal:P!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,r.overrideIdentifier):void 0}:void 0,userRemote:O!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,r.overrideIdentifier):void 0}:void 0,workspace:U!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,r.overrideIdentifier):void 0}:void 0,workspaceFolder:q!==void 0?{value:a?.freeze().getValue(e),override:r.overrideIdentifier?a?.freeze().getOverrideValue(e,r.overrideIdentifier):void 0}:void 0,memory:te!==void 0?{value:g.getValue(e),override:r.overrideIdentifier?g.getOverrideValue(e,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:le.length?le:void 0}}keys(e){const r=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,r){this._folderConfigurations.set(e,r),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,r){const i=r.filter(n=>C.OVERRIDE_PROPERTY_PATTERN.test(n)).map(n=>{const a=(0,C.overrideIdentifierFromKey)(n),g=this._defaultConfiguration.getKeysForOverrideIdentifier(a),y=e.getKeysForOverrideIdentifier(a),R=[...y.filter(P=>g.indexOf(P)===-1),...g.filter(P=>y.indexOf(P)===-1),...g.filter(P=>!S.equals(this._defaultConfiguration.override(a).getValue(P),e.override(a).getValue(P)))];return[a,R]});return this.updateDefaultConfiguration(e),{keys:r,overrides:i}}compareAndUpdateLocalUserConfiguration(e){const{added:r,updated:i,removed:n,overrides:a}=(0,p.compare)(this.localUserConfiguration,e),g=[...r,...i,...n];return g.length&&this.updateLocalUserConfiguration(e),{keys:g,overrides:a}}compareAndUpdateRemoteUserConfiguration(e){const{added:r,updated:i,removed:n,overrides:a}=(0,p.compare)(this.remoteUserConfiguration,e);let g=[...r,...i,...n];return g.length&&this.updateRemoteUserConfiguration(e),{keys:g,overrides:a}}compareAndUpdateWorkspaceConfiguration(e){const{added:r,updated:i,removed:n,overrides:a}=(0,p.compare)(this.workspaceConfiguration,e);let g=[...r,...i,...n];return g.length&&this.updateWorkspaceConfiguration(e),{keys:g,overrides:a}}compareAndUpdateFolderConfiguration(e,r){const i=this.folderConfigurations.get(e),{added:n,updated:a,removed:g,overrides:y}=(0,p.compare)(i,r);let R=[...n,...a,...g];return(R.length||!i)&&this.updateFolderConfiguration(e,r),{keys:R,overrides:y}}compareAndDeleteFolderConfiguration(e){const r=this.folderConfigurations.get(e);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:i,updated:n,removed:a,overrides:g}=(0,p.compare)(r,void 0);return{keys:[...i,...n,...a],overrides:g}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,r){let i=this.getConsolidatedConfigurationModelForResource(e,r);return e.overrideIdentifier?i.override(e.overrideIdentifier):i}getConsolidatedConfigurationModelForResource({resource:e},r){let i=this.getWorkspaceConsolidatedConfiguration();if(r&&e){const n=r.getFolder(e);n&&(i=this.getFolderConsolidatedConfiguration(n.uri)||i);const a=this._memoryConfigurationByResource.get(e);a&&(i=i.merge(a))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let r=this._foldersConsolidatedConfigurations.get(e);if(!r){const i=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(e);n?(r=i.merge(n),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(e,r)):r=i}return r}getFolderConfigurationModelForResource(e,r){if(r&&e){const i=r.getFolder(e);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,r)=>{const{contents:i,overrides:n,keys:a}=this._folderConfigurations.get(r);return e.push([r,{contents:i,overrides:n,keys:a}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>e.add(r)),this.userConfiguration.freeze().keys.forEach(r=>e.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>e.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(i=>e.add(i))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(i=>r.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(i=>r.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(e).forEach(n=>r.add(n))),[...r.values()]}static parse(e){const r=this.parseConfigurationModel(e.defaults),i=this.parseConfigurationModel(e.user),n=this.parseConfigurationModel(e.workspace),a=e.folders.reduce((g,y)=>(g.set(d.URI.revive(y[0]),this.parseConfigurationModel(y[1])),g),new T.ResourceMap);return new m(r,i,new w,n,a,new w,new T.ResourceMap,!1)}static parseConfigurationModel(e){return new w(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=m;function E(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const e=new Set,r=new Map;for(const n of o)n.keys.forEach(a=>e.add(a)),n.overrides.forEach(([a,g])=>{const y=(0,T.getOrSet)(r,a,new Set);g.forEach(R=>y.add(R))});const i=[];return r.forEach((n,a)=>i.push([a,[...n.values()]])),{keys:[...e.values()],overrides:i}}t.mergeChanges=E;class f{constructor(e,r,i,n){this.change=e,this.previous=r,this.currentConfiguraiton=i,this.currentWorkspace=n,this._previousConfiguration=void 0;const a=new Set;e.keys.forEach(y=>a.add(y)),e.overrides.forEach(([,y])=>y.forEach(R=>a.add(R))),this.affectedKeys=[...a.values()];const g=new w;this.affectedKeys.forEach(y=>g.setValue(y,{})),this.affectedKeysTree=g.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(r){const i=this.previousConfiguration?this.previousConfiguration.getValue(e,r,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(e,r,this.currentWorkspace);return!S.equals(i,n)}return!0}return!1}doesAffectedKeysTreeContains(e,r){let i=(0,p.toValuesTree)({[r]:!0},()=>{}),n;for(;typeof i=="object"&&(n=Object.keys(i)[0]);){if(e=e[n],!e)return!1;i=i[n]}return!0}}t.ConfigurationChangeEvent=f;class s extends f{constructor(e,r,i,n){super({keys:e.allKeys(),overrides:[]},void 0,e,r);this.source=i,this.sourceConfig=n}}t.AllKeysConfigurationChangeEvent=s}),define(J[107],Y([0,1,3,10,2,19,26,106,33,25]),function(z,t,L,I,b,D,T,S,l,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class p extends b.Disposable{constructor(c,w){super();this.settingsResource=c,this._onDidChangeConfiguration=this._register(new I.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new S.UserSettings(this.settingsResource,void 0,D.extUriBiasedIgnorePathCase,w)),this.configuration=new S.Configuration(new S.DefaultConfigurationModel,new S.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new L.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(d.Registry.as(l.Extensions.Configuration).onDidUpdateConfiguration(u=>this.onDidDefaultConfigurationChange(u))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const c=await this.userConfiguration.loadConfiguration();this.configuration=new S.Configuration(new S.DefaultConfigurationModel,c)}getConfigurationData(){return this.configuration.toData()}getValue(c,w){const u=typeof c=="string"?c:void 0,h=(0,T.isConfigurationOverrides)(c)?c:(0,T.isConfigurationOverrides)(w)?w:{};return this.configuration.getValue(u,h,void 0)}updateValue(c,w,u,h){return Promise.reject(new Error("not supported"))}inspect(c){return this.configuration.inspect(c,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const c=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(c)}onDidChangeUserConfiguration(c){const w=this.configuration.toData(),u=this.configuration.compareAndUpdateLocalUserConfiguration(c);this.trigger(u,w,1)}onDidDefaultConfigurationChange(c){const w=this.configuration.toData(),u=this.configuration.compareAndUpdateDefaultConfiguration(new S.DefaultConfigurationModel,c);this.trigger(u,w,6)}trigger(c,w,u){const h=new S.ConfigurationChangeEvent(c,{data:w},this.configuration);h.source=u,h.sourceConfig=this.getTargetConfiguration(u),this._onDidChangeConfiguration.fire(h)}getTargetConfiguration(c){switch(c){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=p}),define(J[108],Y([0,1,9]),function(z,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isVirtualWorkspace=t.getVirtualWorkspaceScheme=t.getVirtualWorkspaceLocation=t.isVirtualResource=t.getRemoteName=t.getRemoteAuthority=void 0;function I(d){return d.scheme===L.Schemas.vscodeRemote?d.authority:void 0}t.getRemoteAuthority=I;function b(d){if(!d)return;const p=d.indexOf("+");return p<0?d:d.substr(0,p)}t.getRemoteName=b;function D(d){return d.scheme!==L.Schemas.file&&d.scheme!==L.Schemas.vscodeRemote}t.isVirtualResource=D;function T(d){if(d.folders.length)return d.folders.every(p=>D(p.uri))?d.folders[0].uri:void 0;if(d.configuration&&D(d.configuration))return d.configuration}t.getVirtualWorkspaceLocation=T;function S(d){return T(d)?.scheme}t.getVirtualWorkspaceScheme=S;function l(d){return T(d)!==void 0}t.isVirtualWorkspace=l}),define(J[42],Y([0,1,27,14,108]),function(z,t,L,I,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isResolverExtension=t.isAuthenticationProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.getWorkspaceSupportTypeMessage=t.ALL_EXTENSION_KINDS=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin",t.ALL_EXTENSION_KINDS=["ui","workspace","web"];function D(c){if(typeof c=="object"&&c!==null&&c.supported!==!0)return c.description}t.getWorkspaceSupportTypeMessage=D;function T(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}t.isIExtensionIdentifier=T,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var S;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(S=t.ExtensionType||(t.ExtensionType={}));class l{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,u){if(typeof w=="undefined"||w===null)return typeof u=="undefined"||u===null;if(typeof u=="undefined"||u===null)return!1;if(typeof w=="string"||typeof u=="string"){let h=typeof w=="string"?w:w.value,v=typeof u=="string"?u:u.value;return L.equalsIgnoreCase(h,v)}return w._lower===u._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}t.ExtensionIdentifier=l;function d(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}t.isLanguagePackExtension=d;function p(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}t.isAuthenticationProviderExtension=p;function C(c,w){if(w&&c.enableProposedApi){const u=`onResolveRemoteAuthority:${(0,b.getRemoteName)(w)}`;return c.activationEvents?.indexOf(u)!==-1}return!1}t.isResolverExtension=C,t.IBuiltinExtensionsScannerService=(0,I.createDecorator)("IBuiltinExtensionsScannerService")}),define(J[23],Y([0,1,27,42]),function(z,t,L,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getExtensionDependencies=t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function b(u,h){return u.uuid&&h.uuid?u.uuid===h.uuid:u.id===h.id?!0:(0,L.compareIgnoreCase)(u.id,h.id)===0}t.areSameExtensions=b;class D{constructor(h,v){this.version=v,this.id=h.id,this.uuid=h.uuid}key(){return`${this.id}-${this.version}`}equals(h){return h instanceof D?b(this,h)&&this.version===h.version:!1}}t.ExtensionIdentifierWithVersion=D;function T(u,h){return`${u}.${h}`}t.getExtensionId=T;function S(u){return u.toLocaleLowerCase()}t.adoptToGalleryExtensionId=S;function l(u,h){return S(T(u,h))}t.getGalleryExtensionId=l;function d(u,h){const v=[],m=E=>{for(const f of v)if(f.some(s=>b(h(s),h(E))))return f;return null};for(const E of u){const f=m(E);f?f.push(E):v.push([E])}return v}t.groupByExtension=d;function p(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=p;function C(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}t.getGalleryExtensionTelemetryData=C,t.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function c(u){const h=new Set;for(const v of u)v.malicious&&h.add(v.id.id);return h}t.getMaliciousExtensionsSet=c;function w(u,h){const v=[],m=h.manifest.extensionDependencies?.slice(0)??[];for(;m.length;){const E=m.shift();if(E&&v.every(f=>!b(f.identifier,{id:E}))){const f=u.filter(s=>b(s.identifier,{id:E}));f.length===1&&(v.push(f[0]),m.push(...f[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}t.getExtensionDependencies=w}),define(J[109],Y([0,1,24,7,62,9,43,8,77,22,23,42]),function(z,t,L,I,b,D,T,S,l,d,p,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const c=E=>(0,l.localize)(0,null,E),w=(0,l.localize)(1,null,"ms-dotnettools.csharp");function u(E,f){return f?`${E.publisher}.${E.name}@${E.version}`:`${E.publisher}.${E.name}`}const h=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function v(E){const f=h.exec(E);return f&&f[1]?[(0,p.adoptToGalleryExtensionId)(f[1]),f[2]]:[(0,p.adoptToGalleryExtensionId)(E),void 0]}t.getIdAndVersion=v;let m=class{constructor(f,s){this.extensionManagementService=f,this.extensionGalleryService=s}get location(){}async listExtensions(f,s,o=console){let e=await this.extensionManagementService.getInstalled(1);const r=C.EXTENSION_CATEGORIES.map(n=>n.toLowerCase());if(s&&s!==""){if(r.indexOf(s.toLowerCase())<0){o.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}e=e.filter(n=>n.manifest.categories?n.manifest.categories.map(g=>g.toLowerCase()).indexOf(s.toLowerCase())>-1:!1)}else if(s===""){o.log("Possible Categories: "),r.forEach(n=>{o.log(n)});return}this.location&&o.log((0,l.localize)(2,null,this.location)),e=e.sort((n,a)=>n.identifier.id.localeCompare(a.identifier.id));let i;for(let n of e)i!==n.identifier.id&&(i=n.identifier.id,o.log(u(n.manifest,f)))}async installExtensions(f,s,o,e,r=console){const i=[],n=[];f.length&&r.log(this.location?(0,l.localize)(3,null,this.location):(0,l.localize)(4,null));const a=await this.extensionManagementService.getInstalled(1),g=(P,O)=>{const U=a.find(q=>(0,p.areSameExtensions)(q.identifier,{id:P}));if(U){if(!O&&!e)return r.log((0,l.localize)(5,null,P,U.manifest.version,P)),!1;if(O&&U.manifest.version===O)return r.log((0,l.localize)(6,null,`${P}@${O}`)),!1}return!0},y=[],R=[];for(const P of f)if(P instanceof S.URI)y.push(P);else{const[O,U]=v(P);g(O,U)&&R.push({id:O,version:U,installOptions:{isBuiltin:!1,isMachineScoped:o}})}for(const P of s){const[O,U]=v(P);g(O,U)&&R.push({id:O,version:U,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(y.length&&await Promise.all(y.map(async P=>{try{const O=await this.installVSIX(P,{isBuiltin:!1,isMachineScoped:o},e,r);O&&n.push(O)}catch(O){r.error(O.message||O.stack||O),i.push(P.toString())}})),R.length){const P=await this.getGalleryExtensions(R);await Promise.all(R.map(async O=>{const U=P.get(O.id.toLowerCase());if(U)try{const q=await this.installFromGallery(O,U,a,e,r);q&&n.push(q)}catch(q){r.error(q.message||q.stack||q),i.push(O.id)}else r.error(`${c(O.version?`${O.id}@${O.version}`:O.id)}
${w}`),i.push(O.id)}))}if(i.length)throw new Error((0,l.localize)(7,null,i.join(", ")))}async installVSIX(f,s,o,e){const r=await this.extensionManagementService.getManifest(f);if(!r)throw new Error("Invalid vsix");if(await this.validateVSIX(r,o,e))try{return await this.extensionManagementService.install(f,s),e.log((0,l.localize)(8,null,(0,b.getBaseLabel)(f))),r}catch(n){if((0,I.isPromiseCanceledError)(n))return e.log((0,l.localize)(9,null,(0,b.getBaseLabel)(f))),null;throw n}return null}async getGalleryExtensions(f){const s=new Map,o=await this.extensionGalleryService.getExtensions(f,L.CancellationToken.None);for(const e of o)s.set(e.identifier.id.toLowerCase(),e);return s}async installFromGallery({id:f,version:s,installOptions:o},e,r,i,n){const a=await this.extensionGalleryService.getManifest(e,L.CancellationToken.None);if(a&&!this.validateExtensionKind(a,n))return null;const g=r.find(y=>(0,p.areSameExtensions)(y.identifier,e.identifier));if(g){if(e.version===g.manifest.version)return n.log((0,l.localize)(10,null,s?`${f}@${s}`:f)),null;n.log((0,l.localize)(11,null,f,e.version))}try{return o.isBuiltin?n.log(s?(0,l.localize)(12,null,f,s):(0,l.localize)(13,null,f)):n.log(s?(0,l.localize)(14,null,f,s):(0,l.localize)(15,null,f)),await this.extensionManagementService.installFromGallery(e,{...o,installGivenVersion:!!s}),n.log((0,l.localize)(16,null,f,e.version)),a}catch(y){if((0,I.isPromiseCanceledError)(y))return n.log((0,l.localize)(17,null,f)),null;throw y}}validateExtensionKind(f,s){return!0}async validateVSIX(f,s,o){const e={id:(0,p.getGalleryExtensionId)(f.publisher,f.name)},i=(await this.extensionManagementService.getInstalled(1)).find(n=>(0,p.areSameExtensions)(e,n.identifier)&&(0,T.gt)(n.manifest.version,f.version));return i&&!s?(o.log((0,l.localize)(18,null,i.identifier.id,i.manifest.version,f.version)),!1):this.validateExtensionKind(f,o)}async uninstallExtensions(f,s,o=console){const e=async i=>{if(i instanceof S.URI){const n=await this.extensionManagementService.getManifest(i);return u(n)}return i},r=[];for(const i of f){const n=await e(i),g=(await this.extensionManagementService.getInstalled()).filter(y=>(0,p.areSameExtensions)(y.identifier,{id:n}));if(!g.length)throw new Error(`${this.notInstalled(n)}
${w}`);if(g.some(y=>y.type===0)){o.log((0,l.localize)(19,null,n));return}if(!s&&g.some(y=>y.isBuiltin)){o.log((0,l.localize)(20,null,n));return}o.log((0,l.localize)(21,null,n));for(const y of g)await this.extensionManagementService.uninstall(y),r.push(y);this.location?o.log((0,l.localize)(22,null,n,this.location)):o.log((0,l.localize)(23,null,n))}}async locateExtension(f,s=console){const o=await this.extensionManagementService.getInstalled();f.forEach(e=>{o.forEach(r=>{if(r.identifier.id===e&&r.location.scheme===D.Schemas.file){s.log(r.location.fsPath);return}})})}notInstalled(f){return this.location?(0,l.localize)(24,null,f,this.location):(0,l.localize)(25,null,f)}};m=he([oe(0,d.IExtensionManagementService),oe(1,d.IExtensionGalleryService)],m),t.ExtensionManagementCLIService=m}),define(J[110],Y([0,1,3,7,2,12,19,43,8,31,13,21,22,23,16,15]),function(z,t,L,I,b,D,T,S,l,d,p,C,c,w,u,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let m=class extends b.Disposable{constructor(f,s,o,e){super();this.fileService=s,this.extensionGalleryService=o,this.logService=e,this.extensionsDownloadDir=l.URI.file(f.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(f,s){await this.cleanUpPromise;const o=this.getName(f),e=(0,T.joinPath)(this.extensionsDownloadDir,o);if(!await this.fileService.exists(e)){const r=(0,T.joinPath)(this.extensionsDownloadDir,`.${(0,d.generateUuid)()}`);await this.fileService.exists(r)||await this.extensionGalleryService.download(f,r,s);try{await this.rename(r,e,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(r)}catch(n){}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",f.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,I.getErrorMessage)(i)}. Deleted the vsix from downloaded location`,r.path),i}}return e}async delete(f){await this.cleanUpPromise,await this.fileService.del(f)}async rename(f,s,o){try{await p.Promises.rename(f.fsPath,s.fsPath)}catch(e){if(D.isWindows&&e&&e.code==="EPERM"&&Date.now()<o)return this.logService.info(`Failed renaming ${f} to ${s} with 'EPERM' error. Trying again...`),this.rename(f,s,o);throw e}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const f=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(f.children){const s=[],o=[];for(const i of f.children){const n=this.parse(i.name);n&&o.push([n,i])}const e=(0,w.groupByExtension)(o,([i])=>i),r=[];for(const i of e)i.sort((n,a)=>S.rcompare(n[0].version,a[0].version)),s.push(...i.slice(1).map(n=>n[1].resource)),r.push(i[0][1]);r.sort((i,n)=>i.mtime-n.mtime),s.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(i=>i.resource)),await L.Promises.settled(s.map(i=>(this.logService.trace("Deleting vsix from cache",i.path),this.fileService.del(i))))}}catch(f){this.logService.error(f)}}getName(f){return this.cache?`${new w.ExtensionIdentifierWithVersion(f.identifier,f.version).key().toLowerCase()}${f.properties.targetPlatform!=="undefined"?`-${f.properties.targetPlatform}`:""}`:(0,d.generateUuid)()}parse(f){const s=v.exec(f);return s&&s[1]&&s[2]?new w.ExtensionIdentifierWithVersion({id:s[1]},s[2]):null}};m=he([oe(0,C.INativeEnvironmentService),oe(1,u.IFileService),oe(2,c.IExtensionGalleryService),oe(3,h.ILogService)],m),t.ExtensionsDownloader=m}),define(J[111],Y([0,1,2,6,13,42]),function(z,t,L,I,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class T extends L.Disposable{constructor(l,d){super();this.environmentService=l,this.extensionsManifestCache=(0,I.join)(this.environmentService.userDataPath,D.MANIFEST_CACHE_FOLDER,D.USER_MANIFEST_CACHE_FILE),this._register(d.onDidInstallExtensions(p=>this.onDidInstallExtensions(p))),this._register(d.onDidUninstallExtension(p=>this.onDidUnInstallExtension(p)))}onDidInstallExtensions(l){l.some(d=>!!d.local)&&this.invalidate()}onDidUnInstallExtension(l){l.error||this.invalidate()}invalidate(){b.Promises.rm(this.extensionsManifestCache,b.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=T}),define(J[112],Y([0,1,137,20,3,2,9,6,13,21,22,23,55,15]),function(z,t,L,I,b,D,T,S,l,d,p,C,c,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let u=class extends D.Disposable{constructor(m,E,f){super();this.extensionManagementService=m,this.logService=f,this.cache=this._register(new h(E,f)),this.extensionManagementService.registerParticipant({postInstall:async s=>this.postInstallExtension(s),postUninstall:async s=>this.postUninstallExtension(s)})}async getLanguageIds(){const m=await this.cache.getLanguagePacks(),E=["en",...Object.keys(m)];return(0,I.distinct)(E)}async postInstallExtension(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",m.identifier.id),await this.update())}async postUninstallExtension(m){const E=await this.cache.getLanguagePacks();Object.keys(E).some(f=>E[f]&&E[f].extensions.some(s=>(0,C.areSameExtensions)(s.extensionIdentifier,m.identifier)))&&(this.logService.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,E]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),f=await this.cache.update(E);return!(0,I.equals)(Object.keys(m),Object.keys(f))}};u=he([oe(0,p.IExtensionManagementService),oe(1,d.INativeEnvironmentService),oe(2,w.ILogService)],u),t.LocalizationsService=u;let h=class extends D.Disposable{constructor(m,E){super();this.logService=E,this.languagePacks={},this.languagePacksFilePath=(0,S.join)(m.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new b.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(m){return this.withLanguagePacks(E=>{Object.keys(E).forEach(f=>delete E[f]),this.createLanguagePacksFromExtensions(E,...m)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(m,...E){for(const f of E)f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(m,f);Object.keys(m).forEach(f=>this.updateHash(m[f]))}createLanguagePacksFromExtension(m,E){const f=E.identifier,s=E.manifest.contributes&&E.manifest.contributes.localizations?E.manifest.contributes.localizations:[];for(const o of s)if(E.location.scheme===T.Schemas.file&&(0,c.isValidLocalization)(o)){let e=m[o.languageId];e||(e={hash:"",extensions:[],translations:{}},m[o.languageId]=e);let r=e.extensions.filter(i=>(0,C.areSameExtensions)(i.extensionIdentifier,f))[0];r?r.version=E.manifest.version:e.extensions.push({extensionIdentifier:f,version:E.manifest.version});for(const i of o.translations)e.translations[i.id]=(0,S.join)(E.location.fsPath,i.path)}}updateHash(m){if(m){const E=(0,L.createHash)("md5");for(const f of m.extensions)E.update(f.extensionIdentifier.uuid||f.extensionIdentifier.id).update(f.version);m.hash=E.digest("hex")}}withLanguagePacks(m=()=>null){return this.languagePacksFileLimiter.queue(()=>{let E=null;return l.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,f=>f.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(f)).then(f=>{try{return JSON.parse(f)}catch(s){return{}}}).then(f=>(E=m(f),f)).then(f=>{for(const o of Object.keys(f))f[o]||delete f[o];this.languagePacks=f,this.initializedCache=!0;const s=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",s),l.Promises.writeFile(this.languagePacksFilePath,s)}).then(()=>E,f=>this.logService.error(f))})}};h=he([oe(0,d.INativeEnvironmentService),oe(1,w.ILogService)],h)}),define(J[44],Y([0,1,17,85,33,14,25]),function(z,t,L,I,b,D,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,D.createDecorator)("requestService");function S(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}t.isSuccess=S;function l(u){return u.res.statusCode===204}async function d(u){if(!S(u))throw new Error("Server returned "+u.res.statusCode);return l(u)?null:(await(0,L.streamToBuffer)(u.stream)).toString()}t.asText=d;async function p(u){if(!S(u))throw new Error("Server returned "+u.res.statusCode);if(l(u))return null;const v=(await(0,L.streamToBuffer)(u.stream)).toString();try{return JSON.parse(v)}catch(m){throw m.message+=`:
`+v,m}}t.asJson=p;function C(u){w(u)}t.updateProxyConfigurationsScope=C;let c;function w(u){const h=T.Registry.as(b.Extensions.Configuration),v=c;c={id:"http",order:15,title:(0,I.localize)(0,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,I.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,I.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,I.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,I.localize)(4,null),(0,I.localize)(5,null),(0,I.localize)(6,null),(0,I.localize)(7,null)],default:"override",description:(0,I.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,I.localize)(9,null),restricted:!0}}},h.updateConfigurations({add:[c],remove:v?[v]:[]})}w(2)}),define(J[113],Y([0,1,24,9,16,44]),function(z,t,L,I,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DownloadService=void 0;let T=class{constructor(l,d){this.requestService=l,this.fileService=d}async download(l,d,p=L.CancellationToken.None){if(l.scheme===I.Schemas.file||l.scheme===I.Schemas.vscodeRemote){await this.fileService.copy(l,d);return}const C={type:"GET",url:l.toString()},c=await this.requestService.request(C,p);if(c.res.statusCode===200)await this.fileService.writeFile(d,c.stream);else{const w=await(0,D.asText)(c);throw new Error(`Expected 200, got back ${c.res.statusCode} instead.

${w}`)}}};T=he([oe(0,D.IRequestService),oe(1,b.IFileService)],T),t.DownloadService=T}),define(J[114],Y([0,1,115,11]),function(z,t,L,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function b(T,S){return T.protocol==="http:"?S.HTTP_PROXY||S.http_proxy||null:T.protocol==="https:"&&(S.HTTPS_PROXY||S.https_proxy||S.HTTP_PROXY||S.http_proxy)||null}async function D(T,S,l={}){const d=(0,L.parse)(T),p=l.proxyUrl||b(d,S);if(!p)return null;const C=(0,L.parse)(p);if(!/^https?:$/.test(C.protocol||""))return null;const c={host:C.hostname||"",port:C.port||(C.protocol==="https"?"443":"80"),auth:C.auth,rejectUnauthorized:(0,I.isBoolean)(l.strictSSL)?l.strictSSL:!0};return d.protocol==="http:"?new(await new Promise((w,u)=>{z(["http-proxy-agent"],w,u)}))(c):new(await new Promise((w,u)=>{z(["https-proxy-agent"],w,u)}))(c)}t.getProxyAgent=D}),define(J[116],Y([0,1,17,31]),function(z,t,L,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function b(D,T,S){let l=S&&S.get("storage.serviceMachineId",0)||null;if(l)return l;try{const p=(await T.readFile(D.serviceMachineIdResource)).value.toString();l=(0,I.isUUID)(p)?p:null}catch(d){l=null}if(!l){l=(0,I.generateUuid)();try{await T.writeFile(D.serviceMachineIdResource,L.VSBuffer.fromString(l))}catch(d){}}return S&&S.store("storage.serviceMachineId",l,0,1),l}t.getServiceMachineId=b}),define(J[117],Y([0,1,3,10,2,102,11,66,14]),function(z,t,L,I,b,D,T,S,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const d="__$__targetStorageMarker";t.IStorageService=(0,l.createDecorator)("storageService");var p;(function(v){v[v.NONE=0]="NONE",v[v.SHUTDOWN=1]="SHUTDOWN"})(p=t.WillSaveStateReason||(t.WillSaveStateReason={}));var C;(function(v){v[v.GLOBAL=0]="GLOBAL",v[v.WORKSPACE=1]="WORKSPACE"})(C=t.StorageScope||(t.StorageScope={}));var c;(function(v){v[v.USER=0]="USER",v[v.MACHINE=1]="MACHINE"})(c=t.StorageTarget||(t.StorageTarget={}));class w extends b.Disposable{constructor(m={flushInterval:w.DEFAULT_FLUSH_INTERVAL}){super();this.options=m,this._onDidChangeValue=this._register(new I.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new I.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new I.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new L.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new b.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,L.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,b.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,D.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,D.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(m,E){E===d?(m===0?this._globalKeyTargets=void 0:m===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:m})):this._onDidChangeValue.fire({scope:m,key:E,target:this.getKeyTargets(m)[E]})}emitWillSaveState(m){this._onWillSaveState.fire({reason:m})}get(m,E,f){return this.getStorage(E)?.get(m,f)}getBoolean(m,E,f){return this.getStorage(E)?.getBoolean(m,f)}getNumber(m,E,f){return this.getStorage(E)?.getNumber(m,f)}store(m,E,f,s){if((0,T.isUndefinedOrNull)(E)){this.remove(m,f);return}this.withPausedEmitters(()=>{this.updateKeyTarget(m,f,s),this.getStorage(f)?.set(m,E)})}remove(m,E){this.withPausedEmitters(()=>{this.updateKeyTarget(m,E,void 0),this.getStorage(E)?.delete(m)})}withPausedEmitters(m){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{m()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(m,E){const f=[],s=this.getKeyTargets(m);for(const o of Object.keys(s))s[o]===E&&f.push(o);return f}updateKeyTarget(m,E,f){const s=this.getKeyTargets(E);typeof f=="number"?s[m]!==f&&(s[m]=f,this.getStorage(E)?.set(d,JSON.stringify(s))):typeof s[m]=="number"&&(delete s[m],this.getStorage(E)?.set(d,JSON.stringify(s)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(m){return m===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(m){const E=this.get(d,m);if(E)try{return JSON.parse(E)}catch(f){}return Object.create(null)}isNew(m){return this.getBoolean(t.IS_NEW_KEY,m)===!0}async flush(m=p.NONE){this._onWillSaveState.fire({reason:m});const E=this.getStorage(0),f=this.getStorage(1);switch(m){case p.NONE:await L.Promises.settled([E?.whenFlushed()??Promise.resolve(),f?.whenFlushed()??Promise.resolve()]);break;case p.SHUTDOWN:await L.Promises.settled([E?.flush(0)??Promise.resolve(),f?.flush(0)??Promise.resolve()]);break}}async logStorage(){const m=this.getStorage(0)?.items??new Map,E=this.getStorage(1)?.items??new Map;return h(m,E,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}t.AbstractStorageService=w,w.DEFAULT_FLUSH_INTERVAL=60*1e3;class u extends w{constructor(){super();this.globalStorage=this._register(new S.Storage(new S.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new S.Storage(new S.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(m=>this.emitDidChangeValue(1,m))),this._register(this.globalStorage.onDidChangeStorage(m=>this.emitDidChangeValue(0,m)))}getStorage(m){return m===0?this.globalStorage:this.workspaceStorage}getLogDetails(m){return m===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(m){}}t.InMemoryStorageService=u;async function h(v,m,E,f){const s=g=>{try{return JSON.parse(g)}catch(y){return g}},o=new Map,e=new Map;v.forEach((g,y)=>{o.set(y,g),e.set(y,s(g))});const r=new Map,i=new Map;m.forEach((g,y)=>{r.set(y,g),i.set(y,s(g))}),console.group(`Storage: Global (path: ${E})`);let n=[];o.forEach((g,y)=>{n.push({key:y,value:g})}),console.table(n),console.groupEnd(),console.log(e),console.group(`Storage: Workspace (path: ${f})`);let a=[];r.forEach((g,y)=>{a.push({key:y,value:g})}),console.table(a),console.groupEnd(),console.log(i)}t.logStorage=h}),define(J[118],Y([0,1,12,29,8,31]),function(z,t,L,I,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function T(d){if(L.platform===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}async function S(d,p,C,c,w,u,h,v,m,E){const f=Object.create(null);f["common.machineId"]=h,f.sessionID=(0,D.generateUuid)()+Date.now(),f.commitHash=w,f.version=u,f["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,L.PlatformToString)(L.platform),f["common.nodePlatform"]=I.platform,f["common.nodeArch"]=c,f["common.product"]=E||"desktop";const s=l(v||[]);s&&(f["common.msftInternal"]=s);let o=0;const e=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-e,enumerable:!0},"common.sequence":{get:()=>o++,enumerable:!0}}),L.isLinuxSnap&&(f["common.snap"]="true");const r=T(C);r&&(f["common.platformDetail"]=r);try{const i=await d.readFile(b.URI.file(m));f["common.source"]=i.value.toString().slice(0,30)}catch(i){}return f}t.resolveCommonProperties=S;function l(d){const p=I.env.USERDNSDOMAIN;if(!p)return!1;const C=p.toLowerCase();return d.some(c=>C===c)}t.verifyMicrosoftInternalDomain=l}),define(J[30],Y([0,1,14]),function(z,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryConfiguration=t.TelemetryLevel=t.TELEMETRY_OLD_SETTING_ID=t.TELEMETRY_SETTING_ID=t.TELEMETRY_SECTION_ID=t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,L.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,L.createDecorator)("customEndpointTelemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId",t.TELEMETRY_SECTION_ID="telemetry",t.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",t.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var I;(function(D){D[D.NONE=0]="NONE",D[D.CRASH=1]="CRASH",D[D.ERROR=2]="ERROR",D[D.USAGE=3]="USAGE"})(I=t.TelemetryLevel||(t.TelemetryLevel={}));var b;(function(D){D.OFF="off",D.CRASH="crash",D.ERROR="error",D.ON="all"})(b=t.TelemetryConfiguration||(t.TelemetryConfiguration={}))}),define(J[119],Y([0,1,20,3,24,7,10,2,12,8,75,22,23,15,32,30]),function(z,t,L,I,b,D,T,S,l,d,p,C,c,w,u,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractExtensionTask=t.reportTelemetry=t.joinErrors=t.AbstractExtensionManagementService=void 0;let v=class extends S.Disposable{constructor(o,e,r,i){super();this.galleryService=o,this.telemetryService=e,this.logService=r,this.productService=i,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new T.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new T.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new T.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new T.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,S.toDisposable)(()=>{this.installingExtensions.forEach(n=>n.cancel()),this.uninstallingExtensions.forEach(n=>n.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(o){const e=await this.getTargetPlatform();return o.allTargetPlatforms.some(r=>(0,C.isTargetPlatformCompatible)(r,o.allTargetPlatforms,e))}async installFromGallery(o,e={}){if(!this.galleryService.isEnabled())throw new C.ExtensionManagementError(p.localize(0,null),C.ExtensionManagementErrorCode.Internal);if(!await this.canInstall(o)){const i=await this.getTargetPlatform(),n=new C.ExtensionManagementError(p.localize(1,null,o.identifier.id,this.productService.nameLong,(0,C.TargetPlatformToString)(i)),C.ExtensionManagementErrorCode.Incompatible);throw this.logService.error("Cannot install extension.",o.identifier.id,n.message),E(this.telemetryService,"extensionGallery:install",(0,c.getGalleryExtensionTelemetryData)(o),void 0,n),n}try{o=await this.checkAndGetCompatibleVersion(o,!e.installGivenVersion)}catch(i){throw this.logService.error((0,D.getErrorMessage)(i)),E(this.telemetryService,"extensionGallery:install",(0,c.getGalleryExtensionTelemetryData)(o),void 0,i),i}const r=await this.galleryService.getManifest(o,b.CancellationToken.None);if(r===null){const i=new C.ExtensionManagementError(`Missing manifest for extension ${o.identifier.id}`,C.ExtensionManagementErrorCode.Invalid);throw this.logService.error("Failed to install extension:",o.identifier.id,i.message),E(this.telemetryService,"extensionGallery:install",(0,c.getGalleryExtensionTelemetryData)(o),void 0,i),i}if(r.version!==o.version){const i=new C.ExtensionManagementError(`Cannot install '${o.identifier.id}' extension because of version mismatch in Marketplace`,C.ExtensionManagementErrorCode.Invalid);throw this.logService.error(i.message),E(this.telemetryService,"extensionGallery:install",(0,c.getGalleryExtensionTelemetryData)(o),void 0,i),i}return this.installExtension(r,o,e)}async uninstall(o,e={}){return this.logService.trace("ExtensionManagementService#uninstall",o.identifier.id),this.unininstallExtension(o,e)}async reinstallFromGallery(o){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",o.identifier.id),!this.galleryService.isEnabled())throw new Error(p.localize(2,null));const e=await this.findGalleryExtension(o);if(!e)throw new Error(p.localize(3,null));await this.createUninstallExtensionTask(o,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(e)}getExtensionsReport(){const o=new Date().getTime();return(!this.reportedExtensions||o-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=o),this.reportedExtensions}registerParticipant(o){this.participants.push(o)}async installExtension(o,e,r){if(!d.URI.isUri(e)){let y=this.installingExtensions.get(new c.ExtensionIdentifierWithVersion(e.identifier,e.version).key());if(y)return this.logService.info("Extensions is already requested to install",e.identifier.id),y.waitUntilTaskIsFinished();r={...r,installOnlyNewlyAddedFromExtensionPack:!0}}const i=[],n=[],a=this.createInstallExtensionTask(o,e,r);d.URI.isUri(e)||this.installingExtensions.set(new c.ExtensionIdentifierWithVersion(a.identifier,o.version).key(),a),this._onInstallExtension.fire({identifier:a.identifier,source:e}),this.logService.info("Installing extension:",a.identifier.id),i.push({task:a,manifest:o});let g=!1;try{if(r.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",a.identifier.id);else try{const R=await this.getAllDepsAndPackExtensionsToInstall(a.identifier,o,!!r.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:P,manifest:O}of R)if(g=g||!!O.extensionDependencies?.some(U=>(0,c.areSameExtensions)({id:U},a.identifier)),this.installingExtensions.has(new c.ExtensionIdentifierWithVersion(P.identifier,P.version).key()))this.logService.info("Extension is already requested to install",P.identifier.id);else{const U=this.createInstallExtensionTask(O,P,{...r,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new c.ExtensionIdentifierWithVersion(U.identifier,O.version).key(),U),this._onInstallExtension.fire({identifier:U.identifier,source:P}),this.logService.info("Installing extension:",U.identifier.id),i.push({task:U,manifest:O})}}catch(R){if(d.URI.isUri(a.source))(0,L.isNonEmptyArray)(o.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",a.identifier.id,R.message),(0,L.isNonEmptyArray)(o.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",a.identifier.id,R.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",a.identifier.id),this.logService.error(R),R}const y=i.reduce((R,{task:P,manifest:O})=>(R.set(P.identifier.id.toLowerCase(),{task:P,manifest:O}),R),new Map);for(;y.size;){let R;const P=[...y.values()].filter(({manifest:O})=>!O.extensionDependencies?.some(U=>y.has(U.toLowerCase())));P.length?R=y.size===1?P:P.filter(({task:O})=>!(O===a&&!g)):(this.logService.info("Found extensions with circular dependencies",P.map(({task:O})=>O.identifier.id)),R=[...y.values()]),await this.joinAllSettled(R.map(async({task:O})=>{const U=new Date().getTime();try{const q=await O.run();if(await this.joinAllSettled(this.participants.map(te=>te.postInstall(q,O.source,r,b.CancellationToken.None))),!d.URI.isUri(O.source)&&(E(this.telemetryService,O.operation===2?"extensionGallery:update":"extensionGallery:install",(0,c.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-U,void 0),l.isWeb&&O.operation===1))try{await this.galleryService.reportStatistic(q.manifest.publisher,q.manifest.name,q.manifest.version,"install")}catch(te){}n.push({local:q,identifier:O.identifier,operation:O.operation,source:O.source})}catch(q){throw d.URI.isUri(O.source)||E(this.telemetryService,O.operation===2?"extensionGallery:update":"extensionGallery:install",(0,c.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-U,q),this.logService.error("Error while installing the extension:",O.identifier.id),this.logService.error(q),q}finally{y.delete(O.identifier.id.toLowerCase())}}))}return n.forEach(({identifier:R})=>this.logService.info("Extension installed successfully:",R.id)),this._onDidInstallExtensions.fire(n),n.filter(({identifier:R})=>(0,c.areSameExtensions)(R,a.identifier))[0].local}catch(y){if(i.forEach(({task:R})=>R.cancel()),n.length)try{const R=await Promise.allSettled(n.map(({local:P})=>this.createUninstallExtensionTask(P,{versionOnly:!0}).run()));for(let P=0;P<R.length;P++){const O=R[P],{identifier:U}=n[P];O.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",U.id):this.logService.warn("Rollback: Error while uninstalling extension",U.id,(0,D.getErrorMessage)(O.reason))}}catch(R){this.logService.warn("Error while rolling back extensions",(0,D.getErrorMessage)(R),n.map(({identifier:P})=>P.id))}throw this.logService.error("Failed to install extension:",a.identifier.id,(0,D.getErrorMessage)(y)),this._onDidInstallExtensions.fire(i.map(({task:R})=>({identifier:R.identifier,operation:1,source:R.source}))),y instanceof Error&&(y.name=y&&y.code?y.code:C.ExtensionManagementErrorCode.Internal),y}finally{for(const{task:y,manifest:R}of i)if(!d.URI.isUri(y.source)){const P=new c.ExtensionIdentifierWithVersion(y.identifier,R.version).key();this.installingExtensions.delete(P)||this.logService.warn("Installation task is not found in the cache",P)}}}async joinAllSettled(o){const e=[],r=[],i=await Promise.allSettled(o);for(const n of i)n.status==="fulfilled"?e.push(n.value):r.push(n.reason);if(r.length)throw m(r);return e}async getAllDepsAndPackExtensionsToInstall(o,e,r){if(!this.galleryService.isEnabled())return[];let i=await this.getInstalled();const n=[o,...i.map(y=>y.identifier)],a=[],g=async(y,R)=>{const P=R.extensionDependencies||[],O=[...P];if(R.extensionPack){const U=r?i.find(q=>(0,c.areSameExtensions)(q.identifier,y)):void 0;for(const q of R.extensionPack)U&&U.manifest.extensionPack&&U.manifest.extensionPack.some(te=>(0,c.areSameExtensions)({id:te},{id:q}))||O.every(te=>!(0,c.areSameExtensions)({id:te},{id:q}))&&O.push(q)}if(O.length){const U=[...n,...a.map(te=>te.gallery.identifier)],q=O.filter(te=>U.every(ce=>!(0,c.areSameExtensions)(ce,{id:te})));if(q.length){const te=await this.galleryService.query({names:q,pageSize:O.length},b.CancellationToken.None);for(const ce of te.firstPage){if(U.find(x=>(0,c.areSameExtensions)(x,ce.identifier)))continue;if(!P.some(x=>(0,c.areSameExtensions)({id:x},ce.identifier))&&!await this.canInstall(ce)){this.logService.info("Skipping the packed extension as it cannot be installed",ce.identifier.id);continue}const ne=await this.checkAndGetCompatibleVersion(ce,!0),de=await this.galleryService.getManifest(ne,b.CancellationToken.None);if(de===null)throw new C.ExtensionManagementError(`Missing manifest for extension ${ne.identifier.id}`,C.ExtensionManagementErrorCode.Invalid);a.push({gallery:ne,manifest:de}),await g(ne.identifier,de)}}}};return await g(o,e),i=await this.getInstalled(),a.filter(y=>!i.some(R=>(0,c.areSameExtensions)(R.identifier,y.gallery.identifier)))}async checkAndGetCompatibleVersion(o,e){if(await this.isMalicious(o))throw new C.ExtensionManagementError(p.localize(4,null,o.identifier.id),C.ExtensionManagementErrorCode.Malicious);const r=await this.getCompatibleVersion(o,e);if(!r)throw new C.ExtensionManagementError(p.localize(5,null,o.identifier.id,this.productService.nameLong,this.productService.version),C.ExtensionManagementErrorCode.Incompatible);return r}async getCompatibleVersion(o,e){const r=await this.getTargetPlatform();let i=null;return await this.galleryService.isExtensionCompatible(o,r)&&(i=o),!i&&e&&(i=await this.galleryService.getCompatibleExtension(o,r)),i}async isMalicious(o){const e=await this.getExtensionsReport();return(0,c.getMaliciousExtensionsSet)(e).has(o.identifier.id)}async unininstallExtension(o,e){const r=this.uninstallingExtensions.get(o.identifier.id.toLowerCase());if(r)return this.logService.info("Extensions is already requested to uninstall",o.identifier.id),r.waitUntilTaskIsFinished();const i=(y,R)=>{const P=this.createUninstallExtensionTask(y,R);return this.uninstallingExtensions.set(P.extension.identifier.id.toLowerCase(),P),this.logService.info("Uninstalling extension:",y.identifier.id),this._onUninstallExtension.fire(y.identifier),P},n=(y,R)=>{R?this.logService.error("Failed to uninstall extension:",y.identifier.id,R.message):this.logService.info("Successfully uninstalled extension:",y.identifier.id),E(this.telemetryService,"extensionGallery:uninstall",(0,c.getLocalExtensionTelemetryData)(y),void 0,R),this._onDidUninstallExtension.fire({identifier:y.identifier,error:R?.code})},a=[],g=[];try{a.push(i(o,{}));const y=await this.getInstalled(1);if(e.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",o.identifier.id);else{const R=this.getAllPackExtensionsToUninstall(o,y);for(const P of R)this.uninstallingExtensions.has(P.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",P.identifier.id):a.push(i(P,{}))}e.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",o.identifier.id):this.checkForDependents(a.map(R=>R.extension),y,o),await this.joinAllSettled(a.map(async R=>{try{if(await R.run(),await this.joinAllSettled(this.participants.map(P=>P.postUninstall(R.extension,e,b.CancellationToken.None))),R.extension.identifier.uuid)try{await this.galleryService.reportStatistic(R.extension.manifest.publisher,R.extension.manifest.name,R.extension.manifest.version,"uninstall")}catch(P){}n(R.extension)}catch(P){const O=P instanceof C.ExtensionManagementError?P:new C.ExtensionManagementError((0,D.getErrorMessage)(P),C.ExtensionManagementErrorCode.Internal);throw n(R.extension,O),O}finally{g.push(R)}}))}catch(y){const R=y instanceof C.ExtensionManagementError?y:new C.ExtensionManagementError((0,D.getErrorMessage)(y),C.ExtensionManagementErrorCode.Internal);for(const P of a){try{P.cancel()}catch(O){}g.includes(P)||n(P.extension,R)}throw R}finally{for(const y of a)this.uninstallingExtensions.delete(y.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",y.extension.identifier.id)}}checkForDependents(o,e,r){for(const i of o){const n=this.getDependents(i,e);if(n.length){const a=n.filter(g=>!o.some(y=>(0,c.areSameExtensions)(y.identifier,g.identifier)));if(a.length)throw new Error(this.getDependentsErrorMessage(i,a,r))}}}getDependentsErrorMessage(o,e,r){return r===o?e.length===1?p.localize(6,null,r.manifest.displayName||r.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?p.localize(7,null,r.manifest.displayName||r.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):p.localize(8,null,r.manifest.displayName||r.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):e.length===1?p.localize(9,null,r.manifest.displayName||r.manifest.name,o.manifest.displayName||o.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?p.localize(10,null,r.manifest.displayName||r.manifest.name,o.manifest.displayName||o.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):p.localize(11,null,r.manifest.displayName||r.manifest.name,o.manifest.displayName||o.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name)}getAllPackExtensionsToUninstall(o,e,r=[]){if(r.indexOf(o)!==-1)return[];r.push(o);const i=o.manifest.extensionPack?o.manifest.extensionPack:[];if(i.length){const n=e.filter(g=>!g.isBuiltin&&i.some(y=>(0,c.areSameExtensions)({id:y},g.identifier))),a=[];for(const g of n)a.push(...this.getAllPackExtensionsToUninstall(g,e,r));return[...n,...a]}return[]}getDependents(o,e){return e.filter(r=>r.manifest.extensionDependencies&&r.manifest.extensionDependencies.some(i=>(0,c.areSameExtensions)({id:i},o.identifier)))}async findGalleryExtension(o){if(o.identifier.uuid){const e=await this.findGalleryExtensionById(o.identifier.uuid);return e||this.findGalleryExtensionByName(o.identifier.id)}return this.findGalleryExtensionByName(o.identifier.id)}async findGalleryExtensionById(o){return(await this.galleryService.query({ids:[o],pageSize:1},b.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(o){return(await this.galleryService.query({names:[o],pageSize:1},b.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const o=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${o.length} reported extensions from service`),o}catch(o){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};v=he([oe(0,C.IExtensionGalleryService),oe(1,h.ITelemetryService),oe(2,w.ILogService),oe(3,u.IProductService)],v),t.AbstractExtensionManagementService=v;function m(s){const o=Array.isArray(s)?s:[s];return o.length===1?o[0]instanceof Error?o[0]:new Error(o[0]):o.reduce((e,r)=>new Error(`${e.message}${e.message?",":""}${r instanceof Error?r.message:r}`),new Error(""))}t.joinErrors=m;function E(s,o,e,r,i){const n=i?i instanceof C.ExtensionManagementError?i.code:C.ExtensionManagementErrorCode.Internal:void 0;s.publicLogError(o,{...e,success:!i,duration:r,errorcode:n})}t.reportTelemetry=E;class f{constructor(){this.barrier=new I.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,I.createCancelablePromise)(o=>this.doRun(o))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,I.createCancelablePromise)(o=>new Promise((e,r)=>{const i=o.onCancellationRequested(()=>{i.dispose(),r((0,D.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}t.AbstractExtensionTask=f}),define(J[36],Y([0,1,18,11,26,30]),function(z,t,L,I,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.getTelemetryLevel=t.supportsTelemetry=t.configurationTelemetry=t.NullAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=t.NullTelemetryServiceShape=void 0;class T{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(m,E){return Promise.resolve(void 0)}publicLog2(m,E){return this.publicLog(m,E)}publicLogError(m,E){return Promise.resolve(void 0)}publicLogError2(m,E){return this.publicLogError(m,E)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}t.NullTelemetryServiceShape=T,t.NullTelemetryService=new T;class S{async publicLog(m,E,f){}async publicLogError(m,E,f){}}t.NullEndpointTelemetryService=S,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function l(v,m){return m.onDidChangeConfiguration(E=>{E.source!==6&&v.publicLog2("updateConfiguration",{configurationSource:(0,b.ConfigurationTargetToString)(E.source),configurationKeys:u(E.sourceConfig)})})}t.configurationTelemetry=l;function d(v,m){return!(m.disableTelemetry||!v.enableTelemetry)}t.supportsTelemetry=d;function p(v){const m=v.getValue(D.TELEMETRY_SETTING_ID),E=v.getValue("telemetry.enableCrashReporter");if(v.getValue(D.TELEMETRY_OLD_SETTING_ID)===!1||E===!1)return 0;switch(m??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}t.getTelemetryLevel=p;function C(v){const m=Object.create(null),E=Object.create(null),f=Object.create(null);w(v,f);for(let s in f){s=s.length>150?s.substr(s.length-149):s;const o=f[s];typeof o=="number"?E[s]=o:typeof o=="boolean"?E[s]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${o.length}`),m[s]=o.substring(0,8191)):typeof o!="undefined"&&o!==null&&(m[s]=o)}return{properties:m,measurements:E}}t.validateTelemetryData=C;function c(v){if(!v)return"none";let m="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(f=>{v.indexOf(`${f}+`)===0&&(m=f)}),m}t.cleanRemoteAuthority=c;function w(v,m,E=0,f){if(!!v)for(let s of Object.getOwnPropertyNames(v)){const o=v[s],e=f?f+s:s;Array.isArray(o)?m[e]=(0,L.safeStringify)(o):o instanceof Date?m[e]=o.toISOString():(0,I.isObject)(o)?E<2?w(o,m,E+1,e+"."):m[e]=(0,L.safeStringify)(o):m[e]=o}}function u(v){if(!v)return[];const m=[];return h(m,"",v),m}function h(v,m,E){E&&typeof E=="object"&&!Array.isArray(E)?Object.keys(E).forEach(f=>h(v,m?`${m}.${f}`:f,E[f])):v.push(m)}}),define(J[120],Y([0,1,20,24,7,18,12,29,8,26,21,22,23,51,16,15,32,44,116,117,30,36]),function(z,t,L,I,b,D,T,S,l,d,p,C,c,w,u,h,v,m,E,f,s,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryServiceWithNoStorageService=t.ExtensionGalleryService=t.sortExtensionVersions=void 0;const e=T.isWeb?"web":(0,C.getTargetPlatform)(T.platform,S.arch);var r;(function(N){N[N.None=0]="None",N[N.IncludeVersions=1]="IncludeVersions",N[N.IncludeFiles=2]="IncludeFiles",N[N.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",N[N.IncludeSharedAccounts=8]="IncludeSharedAccounts",N[N.IncludeVersionProperties=16]="IncludeVersionProperties",N[N.ExcludeNonValidated=32]="ExcludeNonValidated",N[N.IncludeInstallationTargets=64]="IncludeInstallationTargets",N[N.IncludeAssetUri=128]="IncludeAssetUri",N[N.IncludeStatistics=256]="IncludeStatistics",N[N.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",N[N.Unpublished=4096]="Unpublished"})(r||(r={}));function i(...N){return String(N.reduce((A,B)=>A|B,0))}var n;(function(N){N[N.Tag=1]="Tag",N[N.ExtensionId=4]="ExtensionId",N[N.Category=5]="Category",N[N.ExtensionName=7]="ExtensionName",N[N.Target=8]="Target",N[N.Featured=9]="Featured",N[N.SearchText=10]="SearchText",N[N.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},g={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},R={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:r.None,criteria:[],assetTypes:[]};class P{constructor(A=R){this.state=A}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(A,B=this.state.pageSize){return new P({...this.state,pageNumber:A,pageSize:B})}withFilter(A,...B){const V=[...this.state.criteria,...B.length?B.map(K=>({filterType:A,value:K})):[{filterType:A}]];return new P({...this.state,criteria:V})}withSortBy(A){return new P({...this.state,sortBy:A})}withSortOrder(A){return new P({...this.state,sortOrder:A})}withFlags(...A){return new P({...this.state,flags:A.reduce((B,V)=>B|V,0)})}withAssetTypes(...A){return new P({...this.state,assetTypes:A})}get raw(){const{criteria:A,pageNumber:B,pageSize:V,sortBy:K,sortOrder:Q,flags:se,assetTypes:ie}=this.state;return{filters:[{criteria:A,pageNumber:B,pageSize:V,sortBy:K,sortOrder:Q}],assetTypes:ie,flags:se}}get searchText(){const A=this.state.criteria.filter(B=>B.filterType===n.SearchText)[0];return A&&A.value?A.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(A=>String(A.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function O(N,A){const B=(N||[]).filter(V=>V.statisticName===A)[0];return B?B.value:0}function U(N){const A="Microsoft.VisualStudio.Code.Translation.";return N.files.filter(V=>V.assetType.indexOf(A)===0).reduce((V,K)=>{const Q=le(N,K.assetType);return Q&&V.push([K.assetType.substring(A.length),Q]),V},[])}function q(N){if(N.properties){const A=N.properties.filter(K=>K.key===a.Repository),B=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),V=A.filter(K=>B.test(K.value))[0];return V?{uri:V.value,fallbackUri:V.value}:null}return le(N,a.Repository)}function te(N){return{uri:`${N.fallbackAssetUri}/${a.VSIX}?redirect=true${N.targetPlatform?`&targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${a.VSIX}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}}function ce(N){const A=le(N,a.Icon);if(A)return A;const B=C.DefaultIconPath;return{uri:B,fallbackUri:B}}function le(N,A){return N.files.filter(V=>V.assetType===A)[0]?{uri:`${N.assetUri}/${A}`,fallbackUri:`${N.fallbackAssetUri}/${A}`}:null}function ne(N,A){const B=N.properties?N.properties.filter(K=>K.key===A):[],V=B.length>0&&B[0].value;return V?V.split(",").map(K=>(0,c.adoptToGalleryExtensionId)(K)):[]}function de(N){const A=N.properties?N.properties.filter(B=>B.key===g.Engine):[];return A.length>0&&A[0].value||""}function x(N){const A=N.properties?N.properties.filter(V=>V.key===g.LocalizedLanguages):[],B=A.length>0&&A[0].value||"";return B?B.split(","):[]}function H(N){return N.indexOf("preview")!==-1}function re(N){return N.targetPlatform?(0,C.toTargetPlatform)(N.targetPlatform):"undefined"}function M(N){const A=(0,L.distinct)(N.versions.map(re)),B=!!N.tags?.includes(C.WEB_EXTENSION_TAG),V=A.indexOf("web");return B?V===-1&&A.push("web"):V!==-1&&A.splice(V,1),A}function k(N,A){const B=(0,C.getFallbackTargetPlarforms)(A);for(let V=0;V<N.length;V++){const K=N[V];if(K.version===N[V-1]?.version){let Q=V;const se=re(K);if(se===A)for(;Q>0&&N[Q-1].version===K.version;)Q--;else if(B.includes(se))for(;Q>0&&N[Q-1].version===K.version&&re(N[Q-1])!==A;)Q--;Q!==V&&(N.splice(V,1),N.splice(Q,0,K))}}return N}t.sortExtensionVersions=k;function W(N,A,B,V,K){const Q=M(N);let se=N.versions[0];return se=N.versions.find(ie=>ie.version===se.version&&(0,C.isTargetPlatformCompatible)(re(ie),Q,K))||se,G(N,se,Q,A,B,V)}function G(N,A,B,V,K,Q){const se={manifest:le(A,a.Manifest),readme:le(A,a.Details),changelog:le(A,a.Changelog),license:le(A,a.License),repository:q(A),download:te(A),icon:ce(A),coreTranslations:U(A)};return{identifier:{id:(0,c.getGalleryExtensionId)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},name:N.extensionName,version:A.version,displayName:N.displayName,publisherId:N.publisher.publisherId,publisher:N.publisher.publisherName,publisherDisplayName:N.publisher.displayName,publisherDomain:N.publisher.domain?{link:N.publisher.domain,verified:!!N.publisher.isDomainVerified}:void 0,description:N.shortDescription||"",installCount:O(N.statistics,"install"),rating:O(N.statistics,"averagerating"),ratingCount:O(N.statistics,"ratingcount"),categories:N.categories||[],tags:N.tags||[],releaseDate:Date.parse(N.releaseDate),lastUpdated:Date.parse(N.lastUpdated),allTargetPlatforms:B,assets:se,properties:{dependencies:ne(A,g.Dependency),extensionPack:ne(A,g.ExtensionPack),engine:de(A),localizedLanguages:x(A),targetPlatform:re(A)},preview:H(N.flags),telemetryData:{index:(K.pageNumber-1)*K.pageSize+V,querySource:Q}}}let ee=class{constructor(A,B,V,K,Q,se,ie,me){this.requestService=B,this.logService=V,this.environmentService=K,this.telemetryService=Q,this.fileService=se,this.productService=ie,this.configurationService=me;const ye=ie.extensionsGallery;this.extensionsGalleryUrl=ye&&ye.serviceUrl,this.extensionsControlUrl=ye&&ye.controlUrl,this.commonHeadersPromise=_(ie.version,ie,this.environmentService,this.configurationService,this.fileService,A)}api(A=""){return`${this.extensionsGalleryUrl}${A}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(A,B){const V=[];let K=new P().withFlags(r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,A.length).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExtensionName,...A.map(({id:se})=>se.toLowerCase()));A.every(se=>!se.version)&&(K=K.withFlags(r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties,r.IncludeLatestVersionOnly));const{galleryExtensions:Q}=await this.queryGallery(K,e,I.CancellationToken.None);for(let se=0;se<Q.length;se++){const ie=Q[se];if(!ie.versions.length)continue;const me=(0,c.getGalleryExtensionId)(ie.publisher.publisherName,ie.extensionName),ye=A.find(ue=>(0,c.areSameExtensions)(ue,{id:me}))?.version;if(ye){const ue=ie.versions.find(Ie=>Ie.version===ye);ue&&V.push(G(ie,ue,M(ie),se,K))}else V.push(W(ie,se,K,void 0,e))}return V}async getCompatibleExtension(A,B){const V=(0,C.isIExtensionIdentifier)(A)?null:A;if(V){if((0,C.isNotWebExtensionInWebTargetPlatform)(V.allTargetPlatforms,B))return null;if(await this.isExtensionCompatible(V,B))return V}const{id:K,uuid:Q}=V?V.identifier:A;let se=new P().withFlags(r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1).withFilter(n.Target,"Microsoft.VisualStudio.Code");Q?se=se.withFilter(n.ExtensionId,Q):se=se.withFilter(n.ExtensionName,K);const{galleryExtensions:ie}=await this.queryGallery(se,B,I.CancellationToken.None),[me]=ie;if(!me||!me.versions.length)return null;const ye=M(me);if((0,C.isNotWebExtensionInWebTargetPlatform)(ye,B))return null;for(let ue of me.versions){if(!de(ue)){const Ie=await this.getEngine(ue);ue={...ue,properties:[...ue.properties||[],{key:g.Engine,value:Ie}]}}if(await this.isRawExtensionVersionCompatible(ue,ye,B))return G(me,ue,ye,0,se)}return null}async isExtensionCompatible(A,B){if(!(0,C.isTargetPlatformCompatible)(A.properties.targetPlatform,A.allTargetPlatforms,B))return!1;let V=A.properties.engine;if(!V){const K=await this.getManifest(A,I.CancellationToken.None);if(!K)throw new Error("Manifest was not found");V=K.engines.vscode}return(0,w.isEngineValid)(V,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(A,B,V){if(!(0,C.isTargetPlatformCompatible)(re(A),B,V))return!1;const K=await this.getEngine(A);return(0,w.isEngineValid)(K,this.productService.version,this.productService.date)}async query(A,B){const V=I.CancellationToken.isCancellationToken(A)?{}:A,K=I.CancellationToken.isCancellationToken(A)?A:B;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let Q=V.text||"";const se=(0,D.getOrDefault)(V,ve=>ve.pageSize,50);let ie=new P().withFlags(r.IncludeLatestVersionOnly,r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,se).withFilter(n.Target,"Microsoft.VisualStudio.Code");Q?(Q=Q.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ve,Ee,Fe)=>(ie=ie.withFilter(n.Category,Fe||Ee),"")),Q=Q.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ve,Ee,Fe)=>(ie=ie.withFilter(n.Tag,Fe||Ee),"")),Q=Q.replace(/\bfeatured(\s+|\b|$)/g,()=>(ie=ie.withFilter(n.Featured),"")),Q=Q.trim(),Q&&(Q=Q.length<200?Q:Q.substring(0,200),ie=ie.withFilter(n.SearchText,Q)),ie=ie.withSortBy(0)):V.ids?ie=ie.withFilter(n.ExtensionId,...V.ids):V.names?ie=ie.withFilter(n.ExtensionName,...V.names):ie=ie.withSortBy(4),typeof V.sortBy=="number"&&(ie=ie.withSortBy(V.sortBy)),typeof V.sortOrder=="number"&&(ie=ie.withSortOrder(V.sortOrder));const{galleryExtensions:me,total:ye}=await this.queryGallery(ie,e,K),ue=me.map((ve,Ee)=>W(ve,Ee,ie,V.source,e)),Ie=async(ve,Ee)=>{if(Ee.isCancellationRequested)throw(0,b.canceled)();const Fe=ie.withPage(ve+1),{galleryExtensions:Me}=await this.queryGallery(Fe,e,Ee);return Me.map((ze,xe)=>W(ze,xe,Fe,V.source,e))};return{firstPage:ue,total:ye,pageSize:ie.pageSize,getPage:Ie}}async queryGallery(A,B,V){if(!this.isEnabled())throw new Error("No extension gallery service configured.");A=A.withFlags(A.flags,r.ExcludeNonValidated).withFilter(n.ExcludeWithFlags,i(r.Unpublished));const K=await this.commonHeadersPromise,Q=JSON.stringify(A.raw),se={...K,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Q.length)},ie=new Date().getTime();let me,ye,ue=0;try{if(me=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:Q,headers:se},V),me.res.statusCode&&me.res.statusCode>=400&&me.res.statusCode<500)return{galleryExtensions:[],total:ue};const Ie=await(0,m.asJson)(me);if(Ie){const ve=Ie.results[0],Ee=ve.extensions;Ee.forEach(Me=>k(Me.versions,B));const Fe=ve.resultMetadata&&ve.resultMetadata.filter(Me=>Me.metadataType==="ResultCount")[0];return ue=Fe&&Fe.metadataItems.filter(Me=>Me.name==="TotalCount")[0].count||0,{galleryExtensions:Ee,total:ue}}return{galleryExtensions:[],total:ue}}catch(Ie){throw ye=Ie,Ie}finally{this.telemetryService.publicLog2("galleryService:query",{...A.telemetryData,requestBodySize:String(Q.length),duration:new Date().getTime()-ie,success:!!me&&(0,m.isSuccess)(me),responseBodySize:me?.res.headers["Content-Length"],statusCode:me?String(me.res.statusCode):void 0,errorCode:ye?(0,b.isPromiseCanceledError)(ye)?"canceled":(0,b.getErrorMessage)(ye).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ue)})}}async reportStatistic(A,B,V,K){if(!this.isEnabled())return;const Q=T.isWeb?this.api(`/itemName/${A}.${B}/version/${V}/statType/${K==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${A}/extensions/${B}/${V}/stats?statType=${K}`),se=T.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",me={...await this.commonHeadersPromise,Accept:se};try{await this.requestService.request({type:"POST",url:Q,headers:me},I.CancellationToken.None)}catch(ye){}}async download(A,B,V){this.logService.trace("ExtensionGalleryService#download",A.identifier.id);const K=(0,c.getGalleryExtensionTelemetryData)(A),Q=new Date().getTime(),se=ue=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...K,duration:ue}),ie=V===1?"install":V===2?"update":"",me=ie?{uri:`${A.assets.download.uri}${l.URI.parse(A.assets.download.uri).query?"&":"?"}${ie}=true`,fallbackUri:`${A.assets.download.fallbackUri}${l.URI.parse(A.assets.download.fallbackUri).query?"&":"?"}${ie}=true`}:A.assets.download,ye=await this.getAsset(me);await this.fileService.writeFile(B,ye.stream),se(new Date().getTime()-Q)}async getReadme(A,B){if(A.assets.readme){const V=await this.getAsset(A.assets.readme,{},B);return await(0,m.asText)(V)||""}return""}async getManifest(A,B){if(A.assets.manifest){const V=await this.getAsset(A.assets.manifest,{},B),K=await(0,m.asText)(V);return K?JSON.parse(K):null}return null}async getManifestFromRawExtensionVersion(A,B){const V=le(A,a.Manifest);if(!V)throw new Error("Manifest was not found");const K={"Accept-Encoding":"gzip"},Q=await this.getAsset(V,{headers:K});return await(0,m.asJson)(Q)}async getCoreTranslation(A,B){const V=A.assets.coreTranslations.filter(K=>K[0]===B.toUpperCase())[0];if(V){const K=await this.getAsset(V[1]),Q=await(0,m.asText)(K);return Q?JSON.parse(Q):null}return null}async getChangelog(A,B){if(A.assets.changelog){const V=await this.getAsset(A.assets.changelog,{},B);return await(0,m.asText)(V)||""}return""}async getAllCompatibleVersions(A,B){let V=new P().withFlags(r.IncludeVersions,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1).withFilter(n.Target,"Microsoft.VisualStudio.Code");A.identifier.uuid?V=V.withFilter(n.ExtensionId,A.identifier.uuid):V=V.withFilter(n.ExtensionName,A.identifier.id);const{galleryExtensions:K}=await this.queryGallery(V,B,I.CancellationToken.None);if(!K.length)return[];const Q=M(K[0]);if((0,C.isNotWebExtensionInWebTargetPlatform)(Q,B))return[];const se=[];for(const ie of K[0].versions)try{se[se.length-1]?.version!==ie.version&&await this.isRawExtensionVersionCompatible(ie,Q,B)&&se.push({version:ie.version,date:ie.lastUpdated})}catch(me){}return se}async getAsset(A,B={},V=I.CancellationToken.None){const K=await this.commonHeadersPromise,Q={type:"GET"},se={...K,...B.headers||{}};B={...B,...Q,headers:se};const ie=A.uri,me=A.fallbackUri,ye={...B,url:ie};try{const ue=await this.requestService.request(ye,V);if(ue.res.statusCode===200)return ue;const Ie=await(0,m.asText)(ue);throw new Error(`Expected 200, got back ${ue.res.statusCode} instead.

${Ie}`)}catch(ue){if((0,b.isPromiseCanceledError)(ue))throw ue;const Ie=(0,b.getErrorMessage)(ue);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ie,message:Ie});const ve={...B,url:me};return this.requestService.request(ve,V)}}async getEngine(A){let B=de(A);if(!B){const V=await this.getManifestFromRawExtensionVersion(A,I.CancellationToken.None);if(!V)throw new Error("Manifest was not found");B=V.engines.vscode}return B}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const A=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},I.CancellationToken.None);if(A.res.statusCode!==200)throw new Error("Could not get extensions report.");const B=await(0,m.asJson)(A),V=new Map;if(B)for(const K of B.malicious){const Q=V.get(K)||{id:{id:K},malicious:!0,slow:!1};Q.malicious=!0,V.set(K,Q)}return[...V.values()]}};ee=he([oe(1,m.IRequestService),oe(2,h.ILogService),oe(3,p.IEnvironmentService),oe(4,s.ITelemetryService),oe(5,u.IFileService),oe(6,v.IProductService),oe(7,d.IConfigurationService)],ee);let X=class extends ee{constructor(A,B,V,K,Q,se,ie,me){super(A,B,V,K,Q,se,ie,me)}};X=he([oe(0,f.IStorageService),oe(1,m.IRequestService),oe(2,h.ILogService),oe(3,p.IEnvironmentService),oe(4,s.ITelemetryService),oe(5,u.IFileService),oe(6,v.IProductService),oe(7,d.IConfigurationService)],X),t.ExtensionGalleryService=X;let Z=class extends ee{constructor(A,B,V,K,Q,se,ie){super(void 0,A,B,V,K,Q,se,ie)}};Z=he([oe(0,m.IRequestService),oe(1,h.ILogService),oe(2,p.IEnvironmentService),oe(3,s.ITelemetryService),oe(4,u.IFileService),oe(5,v.IProductService),oe(6,d.IConfigurationService)],Z),t.ExtensionGalleryServiceWithNoStorageService=Z;async function _(N,A,B,V,K,Q){const se={"X-Market-Client-Id":`VSCode ${N}`,"User-Agent":`VSCode ${N}`},ie=await(0,E.getServiceMachineId)(B,K,Q);return(0,o.supportsTelemetry)(A,B)&&(0,o.getTelemetryLevel)(V)===3&&(se["X-Market-User-Id"]=ie),se}t.resolveMarketplaceHeaders=_}),define(J[121],Y([0,1,2,18,12,27,86,26,33,122,25,30,36]),function(z,t,L,I,b,D,T,S,l,d,p,C,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let w=class{constructor(v,m){this._configurationService=m,this._experimentProperties={},this._disposables=new L.DisposableStore,this._cleanupPatterns=[],this._appenders=v.appenders,this._commonProperties=v.commonProperties||Promise.resolve({}),this._piiPaths=v.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!v.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let E of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,D.escapeRegExpCharacters)(E),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(E=>{const f=/^[a-f0-9]+$/i.test(E["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!f})})}setExperimentProperty(v,m){this._experimentProperties[v]=m}_updateTelemetryLevel(){this._telemetryLevel=(0,c.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const v=await this._commonProperties;let m=v.sessionID,E=v["common.instanceId"],f=v["common.machineId"],s=v["common.firstSessionDate"],o=v["common.msftInternal"];return{sessionId:m,instanceId:E,machineId:f,firstSessionDate:s,msftInternal:o}}dispose(){this._disposables.dispose()}_log(v,m,E,f){return this.telemetryLevel<m?Promise.resolve(void 0):this._commonProperties.then(s=>{E=(0,I.mixin)(E,s),E=(0,I.mixin)(E,this._experimentProperties),E=(0,I.cloneAndChange)(E,o=>{if(typeof o=="string")return this._cleanupInfo(o,f)}),this._appenders.forEach(o=>o.log(v,E))},s=>{console.error(s)})}publicLog(v,m,E){return this._log(v,3,m,E)}publicLog2(v,m,E){return this.publicLog(v,m,E)}publicLogError(v,m){return this.sendErrorTelemetry?this._log(v,2,m,!0):Promise.resolve(void 0)}publicLogError2(v,m){return this.publicLogError(v,m)}_anonymizeFilePaths(v){let m=v;const E=[];for(let e of this._cleanupPatterns)for(;;){const r=e.exec(v);if(!r)break;E.push([r.index,e.lastIndex])}const f=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,s=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(m="";;){const e=s.exec(v);if(!e)break;!f.test(e[0])&&E.every(([r,i])=>e.index<r||e.index>=i)&&(m+=v.substring(o,e.index)+"<REDACTED: user-file-path>",o=s.lastIndex)}return o<v.length&&(m+=v.substr(o)),m}_removePropertiesWithPossibleUserInfo(v){if(!v)return v;const m=v.toLowerCase(),E=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(m)?"<REDACTED: secret>":E.test(m)?"<REDACTED: email>":v}_cleanupInfo(v,m){let E=v;m&&(E=this._anonymizeFilePaths(E));for(let f of this._cleanupPatterns)E=E.replace(f,"");return E=this._removePropertiesWithPossibleUserInfo(E),E}};w.IDLE_START_EVENT_NAME="UserIdleStart",w.IDLE_STOP_EVENT_NAME="UserIdleStop",w=he([oe(1,S.IConfigurationService)],w),t.TelemetryService=w;function u(){const h=(0,T.localize)(0,null,d.default.nameLong),v=d.default.privacyStatementUrl?(0,T.localize)(2,null,"https://aka.ms/vscode-telemetry",d.default.privacyStatementUrl):(0,T.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=b.isWeb?"":(0,T.localize)(3,null),E=(0,T.localize)(4,null),f=(0,T.localize)(5,null),s=(0,T.localize)(6,null),o=(0,T.localize)(7,null),e=`
|       | ${E} | ${f} | ${s} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,T.localize)(8,null);return`
${h} ${v} ${m}

&nbsp;

${o}
${e}

&nbsp;

${r}
`}p.Registry.as(l.Extensions.Configuration).registerConfiguration({id:C.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(9,null),properties:{[C.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,T.localize)(10,null),(0,T.localize)(11,null),(0,T.localize)(12,null),(0,T.localize)(13,null)],markdownDescription:u(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),p.Registry.as(l.Extensions.Configuration).registerConfiguration({id:C.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(14,null),properties:{[C.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:d.default.privacyStatementUrl?(0,T.localize)(16,null,d.default.nameLong,d.default.privacyStatementUrl):(0,T.localize)(15,null,d.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,T.localize)(17,null,`\`#${C.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(J[123],Y([0,1,7,18,36]),function(z,t,L,I,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function D(S,l){const d=await new Promise((C,c)=>{z(["applicationinsights"],C,c)});let p;return d.defaultClient?(p=new d.TelemetryClient(S),p.channel.setUseDiskRetryCaching(!0)):(d.setup(S).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),p=d.defaultClient),S.indexOf("AIF-")===0&&(p.config.endpointUrl=l?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),p}class T{constructor(l,d,p,C,c){this._eventPrefix=l,this._defaultData=d,this.testCollector=C,this.mirrored=c,this._defaultData||(this._defaultData=Object.create(null)),typeof p=="function"?this._aiClient=p():this._aiClient=p,this._asyncAIClient=null}_withAIClient(l){if(!!this._aiClient){if(typeof this._aiClient!="string"){l(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=D(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(d=>{l(d)},d=>{(0,L.onUnexpectedError)(d),console.error(d)})}}log(l,d){!this._aiClient||(d=(0,I.mixin)(d,this._defaultData),d=(0,b.validateTelemetryData)(d),this.testCollector&&(d.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++"),this._withAIClient(p=>p.trackEvent({name:this._eventPrefix+"/"+l,properties:d.properties,measurements:d.measurements})))}flush(){return this._aiClient?new Promise(l=>{this._withAIClient(d=>{d.flush({callback:()=>{this._aiClient=void 0,l(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=T}),define(J[124],Y([0,1,6,13]),function(z,t,L,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;async function b(D,T){const S=Object.create(null),l=(p,C)=>{const c=JSON.parse(p);S[C]=c};if(T){const p=[],C=await I.Promises.readdir(T);for(const w of C)try{(await I.Promises.stat((0,L.join)(T,w))).isDirectory()&&p.push(w)}catch{}const c=[];for(const w of p)(await I.Promises.readdir((0,L.join)(T,w))).filter(h=>h==="telemetry.json").length===1&&c.push(w);for(const w of c){const u=(await I.Promises.readFile((0,L.join)(T,w,"telemetry.json"))).toString();l(u,w)}}let d=(await I.Promises.readFile((0,L.join)(D,"telemetry-core.json"))).toString();return l(d,"vscode-core"),d=(await I.Promises.readFile((0,L.join)(D,"telemetry-extensions.json"))).toString(),l(d,"vscode-extensions"),JSON.stringify(S,null,4)}t.buildTelemetryMessage=b}),define(J[37],Y([0,1,14]),function(z,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IUriIdentityService=void 0,t.IUriIdentityService=(0,L.createDecorator)("IUriIdentityService")}),define(J[125],Y([0,1,10,2,8,21,23,16,15,37]),function(z,t,L,I,b,D,T,S,l,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let p=class extends I.Disposable{constructor(c,w,u,h,v){super();this.extensionsManagementService=c,this.logService=h,this.uriIdentityService=v,this._onDidChangeExtensionsByAnotherSource=this._register(new L.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(E=>{this.installedExtensions=E.map(f=>f.identifier),this.startTimestamp=Date.now()}),this._register(c.onInstallExtension(E=>this.onInstallExtension(E))),this._register(c.onDidInstallExtensions(E=>this.onDidInstallExtensions(E))),this._register(c.onDidUninstallExtension(E=>this.onDidUninstallExtension(E)));const m=b.URI.file(u.extensionsPath);this._register(w.watch(m)),this._register(L.Event.filter(w.onDidChangeFilesRaw,E=>E.changes.some(f=>this.doesChangeAffects(f,m)))(()=>this.onDidChange()))}doesChangeAffects(c,w){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(c.resource),w)?this.uriIdentityService.extUri.isEqual(c.resource,this.uriIdentityService.extUri.joinPath(w,".obsolete"))?!0:!(c.type!==1&&c.type!==2||this.uriIdentityService.extUri.basename(c.resource).startsWith(".")):!1}onInstallExtension(c){this.addInstallingExtension(c.identifier)}onDidInstallExtensions(c){for(const w of c)this.removeInstallingExtension(w.identifier),w.local&&this.addInstalledExtension(w.identifier)}onDidUninstallExtension(c){c.error||this.removeInstalledExtension(c.identifier)}addInstallingExtension(c){this.removeInstallingExtension(c),this.installingExtensions.push(c)}removeInstallingExtension(c){this.installingExtensions=this.installingExtensions.filter(w=>!(0,T.areSameExtensions)(w,c))}addInstalledExtension(c){this.installedExtensions&&(this.removeInstalledExtension(c),this.installedExtensions.push(c))}removeInstalledExtension(c){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(w=>!(0,T.areSameExtensions)(w,c)))}async onDidChange(){if(this.installedExtensions){const c=await this.extensionsManagementService.getInstalled(1),w=c.filter(h=>[...this.installingExtensions,...this.installedExtensions].some(v=>(0,T.areSameExtensions)(v,h.identifier))?!1:h.installedTimestamp&&h.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",h.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",h.identifier.id),!1)),u=this.installedExtensions.filter(h=>this.installingExtensions.some(v=>(0,T.areSameExtensions)(v,h))?!1:c.every(v=>!(0,T.areSameExtensions)(v.identifier,h))?(this.logService.info("Detected extension removed from another source",h.id),!0):!1);this.installedExtensions=c.map(h=>h.identifier),(w.length||u.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:w,removed:u})}}};p=he([oe(1,S.IFileService),oe(2,D.INativeEnvironmentService),oe(3,l.ILogService),oe(4,d.IUriIdentityService)],p),t.ExtensionsWatcher=p}),define(J[126],Y([0,1,37,91,16,19,59,10,2]),function(z,t,L,I,b,D,T,S,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UriIdentityService=void 0;class d{constructor(c){this.uri=c,this.time=d._clock++}touch(){return this.time=d._clock++,this}}d._clock=0;let p=class{constructor(c){this._fileService=c,this._dispooables=new l.DisposableStore,this._limit=2**16;const w=new Map,u=h=>{let v=w.get(h.scheme);return v===void 0&&(v=c.hasProvider(h)&&!this._fileService.hasCapability(h,1024),w.set(h.scheme,v)),v};this._dispooables.add(S.Event.any(c.onDidChangeFileSystemProviderRegistrations,c.onDidChangeFileSystemProviderCapabilities)(h=>{w.delete(h.scheme)})),this.extUri=new D.ExtUri(u),this._canonicalUris=new T.SkipList((h,v)=>this.extUri.compare(h,v,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(c){this._fileService.hasProvider(c)&&(c=(0,D.normalizePath)(c));let w=this._canonicalUris.get(c);return w?w.touch().uri.with({fragment:c.fragment}):(this._canonicalUris.set(c,new d(c)),this._checkTrim(),c)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const c=[...this._canonicalUris.entries()].sort((u,h)=>u[1].touch<h[1].touch?1:u[1].touch>h[1].touch?-1:0);d._clock=0,this._canonicalUris.clear();const w=this._limit*.5;for(let u=0;u<w;u++)this._canonicalUris.set(c[u][0],c[u][1].touch())}};p=he([oe(0,b.IFileService)],p),t.UriIdentityService=p,(0,I.registerSingleton)(L.IUriIdentityService,p,!0)}),define(J[45],Y([0,1,48,3,6,11,13,72,138,139]),function(z,t,L,I,b,D,T,S,l,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class p extends Error{constructor(e,r){let i=r.message;switch(e){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=e,this.cause=r}}t.ExtractError=p;function C(o){const e=o.externalFileAttributes>>16||33188;return[448,56,7].map(r=>e&r).reduce((r,i)=>r+i,e&61440)}function c(o){if(o instanceof p)return o;let e;return/end of central directory record signature not found/.test(o.message)&&(e="CorruptZip"),new p(e,o)}function w(o,e,r,i,n,a){const g=b.dirname(e),y=b.join(i,g);if(!y.startsWith(i))return Promise.reject(new Error(S.localize(0,null,e)));const R=b.join(i,e);let P;return a.onCancellationRequested(()=>{P&&P.destroy()}),Promise.resolve(T.Promises.mkdir(y,{recursive:!0})).then(()=>new Promise((O,U)=>{if(!a.isCancellationRequested)try{P=(0,L.createWriteStream)(R,{mode:r}),P.once("close",()=>O()),P.once("error",U),o.once("error",U),o.pipe(P)}catch(q){U(q)}}))}function u(o,e,r,i){let n=(0,I.createCancelablePromise)(()=>Promise.resolve()),a=0;return i.onCancellationRequested(()=>{n.cancel(),o.close()}),new Promise((g,y)=>{const R=new I.Sequencer,P=O=>{O.isCancellationRequested||(a++,o.readEntry())};o.once("error",y),o.once("close",()=>n.then(()=>{i.isCancellationRequested||o.entryCount===a?g():y(new p("Incomplete",new Error(S.localize(1,null,a,o.entryCount))))},y)),o.readEntry(),o.on("entry",O=>{if(i.isCancellationRequested)return;if(!r.sourcePathRegex.test(O.fileName)){P(i);return}const U=O.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(U)){const ce=b.join(e,U);n=(0,I.createCancelablePromise)(le=>T.Promises.mkdir(ce,{recursive:!0}).then(()=>P(le)).then(void 0,y));return}const q=v(o,O),te=C(O);n=(0,I.createCancelablePromise)(ce=>R.queue(()=>q.then(le=>w(le,U,te,e,r,ce).then(()=>P(ce)))).then(null,y))})})}function h(o,e=!1){return new Promise((r,i)=>{(0,l.open)(o,e?{lazyEntries:!0}:void 0,(n,a)=>{n?i(c(n)):r((0,D.assertIsDefined)(a))})})}function v(o,e){return new Promise((r,i)=>{o.openReadStream(e,(n,a)=>{n?i(c(n)):r((0,D.assertIsDefined)(a))})})}function m(o,e){return new Promise((r,i)=>{const n=new d.ZipFile;e.forEach(g=>{g.contents?n.addBuffer(typeof g.contents=="string"?Buffer.from(g.contents,"utf8"):g.contents,g.path):g.localPath&&n.addFile(g.localPath,g.path)}),n.end();const a=(0,L.createWriteStream)(o);n.outputStream.pipe(a),n.outputStream.once("error",i),a.once("error",i),a.once("finish",()=>r(o))})}t.zip=m;function E(o,e,r={},i){const n=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let a=h(o,!0);return r.overwrite&&(a=a.then(g=>T.Promises.rm(e).then(()=>g))),a.then(g=>u(g,e,{sourcePathRegex:n},i))}t.extract=E;function f(o,e){return h(o).then(r=>new Promise((i,n)=>{r.on("entry",a=>{a.fileName===e&&v(r,a).then(g=>i(g),g=>n(g))}),r.once("close",()=>n(new Error(S.localize(2,null,e))))}))}function s(o,e){return f(o,e).then(r=>new Promise((i,n)=>{const a=[];r.once("error",n),r.on("data",g=>a.push(g)),r.on("end",()=>i(Buffer.concat(a)))}))}t.buffer=s}),define(J[127],Y([0,1,45,79]),function(z,t,L,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function b(D){return(0,L.buffer)(D,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch(S){throw new Error((0,I.localize)(0,null))}})}t.getManifest=b}),define(J[128],Y([0,1,20,3,7,2,9,6,12,19,43,8,31,13,45,80,21,22,23,90,16,15,32]),function(z,t,L,I,b,D,T,S,l,d,p,C,c,w,u,h,v,m,E,f,s,o,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;let r=class extends D.Disposable{constructor(n,a,g,y,R){super();this.beforeRemovingExtension=n,this.fileService=a,this.logService=g,this.environmentService=y,this.productService=R,this._devSystemExtensionsPath=null,this.systemExtensionsPath=y.builtinExtensionsPath,this.extensionsPath=y.extensionsPath,this.uninstalledPath=S.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new I.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(n){const a=[];(n===null||n===0)&&a.push(this.scanSystemExtensions().then(null,g=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(g).message,m.ExtensionManagementErrorCode.Internal)))),(n===null||n===1)&&a.push(this.scanUserExtensions(!0).then(null,g=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(g).message,m.ExtensionManagementErrorCode.Internal))));try{const g=await Promise.all(a);return(0,L.flatten)(g)}catch(g){throw this.joinErrors(g)}}async scanUserExtensions(n){this.logService.trace("Started scanning user extensions");let[a,g]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return g=g.filter(y=>!a[new E.ExtensionIdentifierWithVersion(y.identifier,y.manifest.version).key()]),n&&(g=(0,E.groupByExtension)(g,R=>R.identifier).map(R=>R.sort((P,O)=>p.rcompare(P.manifest.version,O.manifest.version))[0])),this.logService.trace("Scanned user extensions:",g.length),g}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(n,a,g,y){const R=n.key(),P=S.join(this.extensionsPath,`.${(0,c.generateUuid)()}`),O=S.join(this.extensionsPath,R);try{await w.Promises.rm(O)}catch(q){try{await w.Promises.rm(O)}catch(te){}throw new m.ExtensionManagementError((0,h.localize)(0,null,O,n.id),m.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(n,a,P,y);let U=await this.scanExtension(C.URI.file(P),1);if(!U)throw new Error((0,h.localize)(1,null,P));await this.storeMetadata(U,{...g,installedTimestamp:Date.now()});try{await this.rename(n,P,O,Date.now()+2*60*1e3),this.logService.info("Renamed to",O)}catch(q){try{await w.Promises.rm(P)}catch(te){}if(q.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",n.id);else throw this.logService.info(`Rename failed because of ${(0,b.getErrorMessage)(q)}. Deleted from extracted location`,P),q}try{U=await this.scanExtension(C.URI.file(O),1)}catch(q){}if(U)return U;throw new Error((0,h.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(n,a){return this.setMetadata(n,a),await this.storeMetadata(n,{...a,installedTimestamp:n.installedTimestamp}),n}async storeMetadata(n,a){a.isMachineScoped=a.isMachineScoped||void 0,a.isBuiltin=a.isBuiltin||void 0,a.installedTimestamp=a.installedTimestamp||void 0;const g=S.join(n.location.fsPath,"package.json"),y=await w.Promises.readFile(g,"utf8"),{manifest:R}=await this.parseManifest(y);return R.__metadata=a,await w.Promises.writeFile(g,JSON.stringify(R,null,"	")),n}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...n){const a=n.map(g=>new E.ExtensionIdentifierWithVersion(g.identifier,g.manifest.version));await this.withUninstalledExtensions(g=>{a.forEach(y=>g[y.key()]=!0)})}async setInstalled(n){await this.withUninstalledExtensions(y=>delete y[n.key()]);const g=(await this.scanExtensions(1)).find(y=>new E.ExtensionIdentifierWithVersion(y.identifier,y.manifest.version).equals(n))||null;return g?(await this.storeMetadata(g,{installedTimestamp:Date.now()}),this.scanExtension(g.location,1)):null}async withUninstalledExtensions(n){return this.uninstalledFileLimiter.queue(async()=>{let a;try{a=await w.Promises.readFile(this.uninstalledPath,"utf8")}catch(y){if(y.code!=="ENOENT")throw y}let g={};if(a)try{g=JSON.parse(a)}catch(y){}return n&&(n(g),Object.keys(g).length?await w.Promises.writeFile(this.uninstalledPath,JSON.stringify(g)):await w.Promises.rm(this.uninstalledPath)),g})}async removeExtension(n,a){this.logService.trace(`Deleting ${a} extension from disk`,n.identifier.id,n.location.fsPath),await w.Promises.rm(n.location.fsPath),this.logService.info("Deleted from disk",n.identifier.id,n.location.fsPath)}async removeUninstalledExtension(n){await this.removeExtension(n,"uninstalled"),await this.withUninstalledExtensions(a=>delete a[new E.ExtensionIdentifierWithVersion(n.identifier,n.manifest.version).key()])}async extractAtLocation(n,a,g,y){this.logService.trace(`Started extracting the extension from ${a} to ${g}`);try{await w.Promises.rm(g)}catch(R){throw new m.ExtensionManagementError(this.joinErrors(R).message,m.ExtensionManagementErrorCode.Delete)}try{await(0,u.extract)(a,g,{sourcePath:"extension",overwrite:!0},y),this.logService.info(`Extracted extension to ${g}:`,n.id)}catch(R){try{await w.Promises.rm(g)}catch(O){}let P=m.ExtensionManagementErrorCode.Extract;throw R instanceof u.ExtractError&&(R.type==="CorruptZip"?P=m.ExtensionManagementErrorCode.CorruptZip:R.type==="Incomplete"&&(P=m.ExtensionManagementErrorCode.IncompleteZip)),new m.ExtensionManagementError(R.message,P)}}async rename(n,a,g,y){try{await w.Promises.rename(a,g)}catch(R){if(l.isWindows&&R&&R.code==="EPERM"&&Date.now()<y)return this.logService.info(`Failed renaming ${a} to ${g} with 'EPERM' error. Trying again...`,n.id),this.rename(n,a,g,y);throw new m.ExtensionManagementError(R.message||(0,h.localize)(3,null,a,g),R.code||m.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const n=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return n;const a=this.scanDevSystemExtensions(),[g,y]=await Promise.all([n,a]);return[...g,...y]}async scanExtensionsInDir(n,a){const g=new I.Limiter(10),y=await this.fileService.resolve(C.URI.file(n));return y.children?(await Promise.all(y.children.filter(P=>P.isDirectory).map(P=>g.queue(async()=>a===1&&(0,d.basename)(P.resource).indexOf(".")===0?null:this.scanExtension(P.resource,a))))).filter(P=>P&&P.identifier):[]}async scanExtension(n,a){try{const g=await this.fileService.resolve(n);if(g.children){const{manifest:y,metadata:R}=await this.readManifest(n.fsPath),P=g.children.find(({name:te})=>/^readme(\.txt|\.md|)$/i.test(te))?.resource,O=g.children.find(({name:te})=>/^changelog(\.txt|\.md|)$/i.test(te))?.resource,U={id:(0,E.getGalleryExtensionId)(y.publisher,y.name)},q={type:a,identifier:U,manifest:y,location:n,readmeUrl:P,changelogUrl:O,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:a===0};return R&&(this.setMetadata(q,R),q.installedTimestamp=R.installedTimestamp),q}}catch(g){a!==0&&this.logService.trace(g)}return null}async scanDefaultSystemExtensions(){const n=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",n.length),n}async scanDevSystemExtensions(){const n=this.getDevSystemExtensionsList();if(n.length){const a=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",a.length),a.filter(g=>n.some(y=>(0,E.areSameExtensions)(g.identifier,{id:y})))}else return[]}setMetadata(n,a){n.publisherDisplayName=a.publisherDisplayName||null,n.publisherId=a.publisherId||null,n.identifier.uuid=a.id,n.isMachineScoped=!!a.isMachineScoped,n.isBuiltin=n.type===0||!!a.isBuiltin}async removeUninstalledExtensions(){const n=await this.getUninstalledExtensions(),a=await this.scanAllUserExtensions(),g=new Set;for(const P of a)n[new E.ExtensionIdentifierWithVersion(P.identifier,P.manifest.version).key()]||g.add(P.identifier.id.toLowerCase());const y=(0,E.groupByExtension)(a,P=>P.identifier);await I.Promises.settled(y.map(async P=>{const O=P.sort((U,q)=>p.rcompare(U.manifest.version,q.manifest.version))[0];g.has(O.identifier.id.toLowerCase())||await this.beforeRemovingExtension(O)}));const R=a.filter(P=>n[new E.ExtensionIdentifierWithVersion(P.identifier,P.manifest.version).key()]);await I.Promises.settled(R.map(P=>this.removeUninstalledExtension(P)))}async removeOutdatedExtensions(){const n=await this.scanAllUserExtensions(),a=[],g=(0,E.groupByExtension)(n,y=>y.identifier);a.push(...(0,L.flatten)(g.map(y=>y.sort((R,P)=>p.rcompare(R.manifest.version,P.manifest.version)).slice(1)))),await I.Promises.settled(a.map(y=>this.removeExtension(y,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(n=>n.name)}joinErrors(n){const a=Array.isArray(n)?n:[n];return a.length===1?a[0]instanceof Error?a[0]:new Error(a[0]):a.reduce((g,y)=>new Error(`${g.message}${g.message?",":""}${y instanceof Error?y.message:y}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=S.normalize(S.join(T.FileAccess.asFileUri("",z).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(n){const a=[w.Promises.readFile(S.join(n,"package.json"),"utf8").then(P=>this.parseManifest(P)),w.Promises.readFile(S.join(n,"package.nls.json"),"utf8").then(void 0,P=>P.code!=="ENOENT"?Promise.reject(P):"{}").then(P=>JSON.parse(P))],[{manifest:g,metadata:y},R]=await Promise.all(a);return{manifest:(0,f.localizeManifest)(g,R),metadata:y}}parseManifest(n){return new Promise((a,g)=>{try{const y=JSON.parse(n),R=y.__metadata||null;a({manifest:y,metadata:R})}catch(y){g(new Error((0,h.localize)(4,null)))}})}};r=he([oe(1,s.IFileService),oe(2,o.ILogService),oe(3,v.INativeEnvironmentService),oe(4,e.IProductService)],r),t.ExtensionsScanner=r}),define(J[129],Y([0,1,28,7,9,6,12,29,19,43,8,31,13,45,78,52,21,119,22,23,110,98,127,111,128,125,51,16,14,15,32,30,37]),function(z,t,L,I,b,D,T,S,l,d,p,C,c,w,u,h,v,m,E,f,s,o,e,r,i,n,a,g,y,R,P,O,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;let q=class extends m.AbstractExtensionManagementService{constructor(x,H,re,M,k,W,G,ee,X){super(x,H,re,ee);this.environmentService=M,this.downloadService=k,this.fileService=G;const Z=this._register(W.createInstance(o.ExtensionsLifecycle));this.extensionsScanner=this._register(W.createInstance(i.ExtensionsScanner,N=>Z.postUninstall(N))),this.manifestCache=this._register(new r.ExtensionsManifestCache(M,this)),this.extensionsDownloader=this._register(W.createInstance(s.ExtensionsDownloader));const _=this._register(new n.ExtensionsWatcher(this,G,M,re,X));this._register(_.onDidChangeExtensionsByAnotherSource(({added:N,removed:A})=>{N.length&&this._onDidInstallExtensions.fire(N.map(B=>({identifier:B.identifier,operation:0,local:B}))),A.forEach(B=>this._onDidUninstallExtension.fire({identifier:B}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const x=await this.isAlpineLinux(),H=(0,E.getTargetPlatform)(x?"alpine":T.platform,S.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",H),H})()),this._targetPlatformPromise}async isAlpineLinux(){if(!T.isLinux)return!1;let x;try{x=(await this.fileService.readFile(p.URI.file("/etc/os-release"))).value.toString()}catch(H){try{x=(await this.fileService.readFile(p.URI.file("/usr/lib/os-release"))).value.toString()}catch(re){this.logService.debug("Error while getting the os-release file.",(0,I.getErrorMessage)(re))}}return!!x&&(x.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(x){this.logService.trace("ExtensionManagementService#zip",x.identifier.id);const H=await this.collectFiles(x),re=await(0,w.zip)((0,l.joinPath)(this.environmentService.tmpDir,(0,C.generateUuid)()).fsPath,H);return p.URI.file(re)}async unzip(x){return this.logService.trace("ExtensionManagementService#unzip",x.toString()),(await this.install(x)).identifier}async getManifest(x){const H=await this.downloadVsix(x),re=D.resolve(H.fsPath);return(0,e.getManifest)(re)}getInstalled(x=null){return this.extensionsScanner.scanExtensions(x)}async install(x,H={}){this.logService.trace("ExtensionManagementService#install",x.toString());const re=await this.downloadVsix(x),M=await(0,e.getManifest)(D.resolve(re.fsPath));if(M.engines&&M.engines.vscode&&!(0,a.isEngineValid)(M.engines.vscode,this.productService.version,this.productService.date))throw new Error(u.localize(0,null,(0,f.getGalleryExtensionId)(M.publisher,M.name),this.productService.version));return this.installExtension(M,re,H)}async updateMetadata(x,H){return this.logService.trace("ExtensionManagementService#updateMetadata",x.identifier.id),x=await this.extensionsScanner.saveMetadataForLocalExtension(x,{...x.manifest.__metadata||{},...H}),this.manifestCache.invalidate(),x}async updateExtensionScope(x,H){return this.logService.trace("ExtensionManagementService#updateExtensionScope",x.identifier.id),x=await this.extensionsScanner.saveMetadataForLocalExtension(x,{...x.manifest.__metadata||{},isMachineScoped:H}),this.manifestCache.invalidate(),x}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(x){if(x.scheme===b.Schemas.file)return x;const H=(0,l.joinPath)(this.environmentService.tmpDir,(0,C.generateUuid)());return await this.downloadService.download(x,H),H}createInstallExtensionTask(x,H,re){return p.URI.isUri(H)?new le(x,H,re,this.galleryService,this.extensionsScanner,this.logService):new ce(H,re,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(x,H){return new ne(x,H,this.extensionsScanner)}async collectFiles(x){const H=async M=>{let k=await c.Promises.readdir(M);k=k.map(ee=>D.join(M,ee));const W=await Promise.all(k.map(ee=>c.Promises.stat(ee)));let G=Promise.resolve([]);return W.forEach((ee,X)=>{const Z=k[X];ee.isFile()&&(G=G.then(_=>[..._,Z])),ee.isDirectory()&&(G=G.then(_=>H(Z).then(N=>[..._,...N])))}),G};return(await H(x.location.fsPath)).map(M=>({path:`extension/${D.relative(x.location.fsPath,M)}`,localPath:M}))}};q=he([oe(0,E.IExtensionGalleryService),oe(1,O.ITelemetryService),oe(2,R.ILogService),oe(3,v.INativeEnvironmentService),oe(4,h.IDownloadService),oe(5,y.IInstantiationService),oe(6,g.IFileService),oe(7,P.IProductService),oe(8,U.IUriIdentityService)],q),t.ExtensionManagementService=q;class te extends m.AbstractExtensionTask{constructor(x,H,re,M){super();this.identifier=x,this.source=H,this.extensionsScanner=re,this.logService=M,this._operation=1}get operation(){return this._operation}async installExtension(x,H){try{const re=await this.unsetUninstalledAndGetLocal(x.identifierWithVersion);if(re)return x.metadata?this.extensionsScanner.saveMetadataForLocalExtension(re,x.metadata):re}catch(re){throw T.isMacintosh?new E.ExtensionManagementError(u.localize(1,null),E.ExtensionManagementErrorCode.Internal):new E.ExtensionManagementError(u.localize(2,null),E.ExtensionManagementErrorCode.Internal)}return this.extract(x,H)}async unsetUninstalledAndGetLocal(x){if(!await this.isUninstalled(x))return null;this.logService.trace("Removing the extension from uninstalled list:",x.id);const re=await this.extensionsScanner.setInstalled(x);return this.logService.info("Removed the extension from uninstalled list:",x.id),re}async isUninstalled(x){return!!(await this.extensionsScanner.getUninstalledExtensions())[x.key()]}async extract({zipPath:x,identifierWithVersion:H,metadata:re},M){let k=await this.extensionsScanner.extractUserExtension(H,x,re,M);return this.logService.info("Extracting completed.",H.id),k}}class ce extends te{constructor(x,H,re,M,k){super(x.identifier,x,M,k);this.gallery=x,this.options=H,this.extensionsDownloader=re}async doRun(x){const re=(await this.extensionsScanner.scanExtensions(null)).find(k=>(0,f.areSameExtensions)(k.identifier,this.gallery.identifier));re&&(this._operation=2);const M=await this.downloadInstallableExtension(this.gallery,this._operation);M.metadata.isMachineScoped=this.options.isMachineScoped||re?.isMachineScoped,M.metadata.isBuiltin=this.options.isBuiltin||re?.isBuiltin;try{const k=await this.installExtension(M,x);return re&&d.neq(re.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(re),k}catch(k){throw await this.deleteDownloadedVSIX(M.zipPath),k}}async deleteDownloadedVSIX(x){try{await this.extensionsDownloader.delete(p.URI.file(x))}catch(H){this.logService.warn("Error while deleting the downloaded vsix",x.toString(),(0,I.getErrorMessage)(H))}}async downloadInstallableExtension(x,H){const re={id:x.identifier.uuid,publisherId:x.publisherId,publisherDisplayName:x.publisherDisplayName};let M;try{this.logService.trace("Started downloading extension:",x.identifier.id),M=(await this.extensionsDownloader.downloadExtension(x,H)).fsPath,this.logService.info("Downloaded extension:",x.identifier.id,M)}catch(k){throw new E.ExtensionManagementError((0,m.joinErrors)(k).message,E.ExtensionManagementErrorCode.Download)}try{const k=await(0,e.getManifest)(M);return{zipPath:M,identifierWithVersion:new f.ExtensionIdentifierWithVersion(x.identifier,k.version),metadata:re}}catch(k){throw await this.deleteDownloadedVSIX(M),new E.ExtensionManagementError((0,m.joinErrors)(k).message,E.ExtensionManagementErrorCode.Invalid)}}}class le extends te{constructor(x,H,re,M,k,W){super({id:(0,f.getGalleryExtensionId)(x.publisher,x.name)},H,k,W);this.manifest=x,this.location=H,this.options=re,this.galleryService=M}async doRun(x){const H=new f.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),M=(await this.extensionsScanner.scanExtensions(1)).find(W=>(0,f.areSameExtensions)(this.identifier,W.identifier)),k=await this.getMetadata(this.identifier.id,x);if(k.isMachineScoped=this.options.isMachineScoped||M?.isMachineScoped,k.isBuiltin=this.options.isBuiltin||M?.isBuiltin,M)if(this._operation=2,H.equals(new f.ExtensionIdentifierWithVersion(M.identifier,M.manifest.version)))try{await this.extensionsScanner.removeExtension(M,"existing")}catch(W){throw new Error(u.localize(3,null,this.manifest.displayName||this.manifest.name))}else d.gt(M.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(M);else{const W=await this.unsetUninstalledAndGetLocal(H);if(W)try{await this.extensionsScanner.removeExtension(W,"existing")}catch(G){throw new Error(u.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:D.resolve(this.location.fsPath),identifierWithVersion:H,metadata:k},x)}async getMetadata(x,H){try{const re=(await this.galleryService.query({names:[x],pageSize:1},H)).firstPage[0];if(re)return{id:re.identifier.uuid,publisherDisplayName:re.publisherDisplayName,publisherId:re.publisherId}}catch(re){}return{}}}class ne extends m.AbstractExtensionTask{constructor(x,H,re){super();this.extension=x,this.options=H,this.extensionsScanner=re}async doRun(x){const H=[],re=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const M=new f.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);H.push(...re.filter(k=>M.equals(new f.ExtensionIdentifierWithVersion(k.identifier,k.manifest.version))))}else H.push(...re.filter(M=>(0,f.areSameExtensions)(M.identifier,this.extension.identifier)));if(!H.length)throw new Error(u.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...H),this.options.remove)for(const M of H)try{x.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(M)}catch(k){throw new Error(u.localize(6,null,(0,L.toErrorMessage)(k)))}}}}),define(J[130],Y([0,1,115,3,17,7,2,11,26,21,93,15,114,140]),function(z,t,L,I,b,D,T,S,l,d,p,C,c,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let u=class extends T.Disposable{constructor(v,m,E){super();this.environmentService=m,this.logService=E,this.configure(v.getValue()),this._register(v.onDidChangeConfiguration(()=>this.configure(v.getValue()),this))}configure(v){this.proxyUrl=v.http&&v.http.proxy,this.strictSSL=!!(v.http&&v.http.proxyStrictSSL),this.authorization=v.http&&v.http.proxyAuthorization}async request(v,m){this.logService.trace("RequestService#request",v.url);const{proxyUrl:E,strictSSL:f}=this;let s;try{s=await(0,p.resolveShellEnv)(this.logService,this.environmentService.args,process.env)}catch(r){this.logService.error("RequestService#request resolving shell environment failed",r)}const o={...process.env,...s},e=v.agent?v.agent:await(0,c.getProxyAgent)(v.url||"",o,{proxyUrl:E,strictSSL:f});return v.agent=e,v.strictSSL=f,this.authorization&&(v.headers={...v.headers||{},"Proxy-Authorization":this.authorization}),this._request(v,m)}async getNodeRequest(v){return((0,L.parse)(v.url).protocol==="https:"?await new Promise((f,s)=>{z(["https"],f,s)}):await new Promise((f,s)=>{z(["http"],f,s)})).request}_request(v,m){return I.Promises.withAsyncBody(async(E,f)=>{let s;const o=(0,L.parse)(v.url),e=v.getRawRequest?v.getRawRequest(v):await this.getNodeRequest(v),r={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:v.type||"GET",headers:v.headers,agent:v.agent,rejectUnauthorized:(0,S.isBoolean)(v.strictSSL)?v.strictSSL:!0};v.user&&v.password&&(r.auth=v.user+":"+v.password),s=e(r,i=>{const n=(0,S.isNumber)(v.followRedirects)?v.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request({...v,url:i.headers.location,followRedirects:n-1},m).then(E,f);else{let a=i;i.headers["content-encoding"]==="gzip"&&(a=i.pipe((0,w.createGunzip)())),E({res:i,stream:(0,b.streamToBufferReadableStream)(a)})}}),s.on("error",f),v.timeout&&s.setTimeout(v.timeout),v.data&&typeof v.data=="string"&&s.write(v.data),s.end(),m.onCancellationRequested(()=>{s.abort(),f((0,D.canceled)())})})}async resolveProxy(v){}};u=he([oe(0,l.IConfigurationService),oe(1,d.INativeEnvironmentService),oe(2,C.ILogService)],u),t.RequestService=u}),define(J[141],Y([0,1,34,3,17,28,7,2,9,6,29,8,13,26,107,52,113,21,89,120,22,109,129,16,100,103,41,97,54,55,112,15,104,122,32,44,130,118,30,121,36,123,124,37,126]),function(z,t,L,I,b,D,T,S,l,d,p,C,c,w,u,h,v,m,E,f,s,o,e,r,i,n,a,g,y,R,P,O,U,q,te,ce,le,ne,de,x,H,re,M,k,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class G extends S.Disposable{constructor(Z){super();this.argv=Z,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[Z,_]=await this.initServices();return Z.invokeFunction(async N=>{const A=N.get(O.ILogService),B=N.get(r.IFileService),V=N.get(m.INativeEnvironmentService),K=N.get(s.IExtensionManagementCLIService);A.info("CLI main",this.argv),this.registerErrorHandler(A),await this.doRun(V,K,B),await Promise.all(_.map(Q=>{(0,I.raceTimeout)(Q.flush(),1e3)}))})}async initServices(){const Z=new y.ServiceCollection,_={_serviceBrand:void 0,...q.default};Z.set(te.IProductService,_);const N=new E.NativeEnvironmentService(this.argv,_);Z.set(m.INativeEnvironmentService,N),await Promise.all([N.appSettingsHome.fsPath,N.extensionsPath].map(me=>me?c.Promises.mkdir(me,{recursive:!0}):void 0));const A=(0,O.getLogLevel)(N),B=[];B.push(new U.SpdLogLogger("cli",(0,d.join)(N.logsPath,"cli.log"),!0,A)),A===O.LogLevel.Trace&&B.push(new O.ConsoleLogger(A));const V=this._register(new O.MultiplexLogService(B));Z.set(O.ILogService,V);const K=this._register(new i.FileService(V));Z.set(r.IFileService,K);const Q=this._register(new n.DiskFileSystemProvider(V));K.registerProvider(l.Schemas.file,Q);const se=this._register(new u.ConfigurationService(N.settingsResource,K));Z.set(w.IConfigurationService,se),await se.initialize(),Z.set(k.IUriIdentityService,new W.UriIdentityService(K)),Z.set(ce.IRequestService,new a.SyncDescriptor(le.RequestService)),Z.set(h.IDownloadService,new a.SyncDescriptor(v.DownloadService)),Z.set(s.IExtensionManagementService,new a.SyncDescriptor(e.ExtensionManagementService)),Z.set(s.IExtensionGalleryService,new a.SyncDescriptor(f.ExtensionGalleryServiceWithNoStorageService)),Z.set(s.IExtensionManagementCLIService,new a.SyncDescriptor(o.ExtensionManagementCLIService)),Z.set(R.ILocalizationsService,new a.SyncDescriptor(P.LocalizationsService));const ie=[];if((0,H.supportsTelemetry)(_,N)){_.aiConfig&&_.aiConfig.asimovKey&&ie.push(new re.AppInsightsAppender("monacoworkbench",null,_.aiConfig.asimovKey));const{appRoot:me,extensionsPath:ye,installSourcePath:ue}=N,Ie={appenders:ie,sendErrorTelemetry:!1,commonProperties:(async()=>{let ve;try{const Ee=await c.Promises.readFile((0,d.join)(N.userDataPath,"storage.json"));ve=JSON.parse(Ee.toString())[de.machineIdKey]}catch(Ee){Ee.code!=="ENOENT"&&V.error(Ee)}return(0,ne.resolveCommonProperties)(K,(0,L.release)(),(0,L.hostname)(),process.arch,_.commit,_.version,ve,_.msftInternalDomains,ue)})(),piiPaths:[me,ye]};Z.set(de.ITelemetryService,new a.SyncDescriptor(x.TelemetryService,[Ie]))}else Z.set(de.ITelemetryService,H.NullTelemetryService);return[new g.InstantiationService(Z),ie]}registerErrorHandler(Z){(0,T.setUnexpectedErrorHandler)(_=>{const N=(0,D.toErrorMessage)(_,!0);!N||Z.error(`[uncaught exception in CLI]: ${N}`)}),process.on("uncaughtException",_=>(0,T.onUnexpectedError)(_)),process.on("unhandledRejection",_=>(0,T.onUnexpectedError)(_))}async doRun(Z,_,N){if(this.argv["install-source"])return this.setInstallSource(Z,N,this.argv["install-source"]);if(this.argv["list-extensions"])return _.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return _.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return _.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return _.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,M.buildTelemetryMessage)(Z.appRoot,Z.extensionsPath))}asExtensionIdOrVSIX(Z){return Z.map(_=>/\.vsix$/i.test(_)?C.URI.file((0,d.isAbsolute)(_)?_:(0,d.join)((0,p.cwd)(),_)):_)}async setInstallSource(Z,_,N){await _.writeFile(C.URI.file(Z.installSourcePath),b.VSBuffer.fromString(N.slice(0,30)))}}async function ee(X){const Z=new G(X);try{await Z.run()}finally{Z.dispose()}}t.main=ee})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b614fb5db84b3ac07fc3e8b12c69c1dd581924ce/core/vs/code/node/cliProcessMain.js.map
