/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var fe=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/platform/log/common/log","vs/base/common/platform","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/async","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/map","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/base/node/pfs","vs/base/common/extpath","vs/base/common/glob","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostTerminalService","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","child_process","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/hash","vs/base/common/severity","vs/editor/common/core/position","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/collections","vs/base/common/decorators","vs/base/common/json","vs/base/common/marshalling","fs","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/normalization","vs/base/common/labels","os","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/cache","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/stream","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/uint","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],me=function(Y){for(var e=[],g=0,L=Y.length;g<L;g++)e[g]=fe[Y[g]];return e};define(fe[58],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function g(L,D){if(!L)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=g}),define(fe[59],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const g=Object.prototype.hasOwnProperty;function L(i){const I=[];for(let a in i)g.call(i,a)&&I.push(i[a]);return I}e.values=L;function D(i,I){for(let a in i)if(g.call(i,a)&&I({key:a,value:i[a]},function(){delete i[a]})===!1)return}e.forEach=D;function S(i,I){const a=Object.create(null);for(const p of i){const h=I(p);let w=a[h];w||(w=a[h]=[]),w.push(p)}return a}e.groupBy=S;function T(i){const I=Object.create(null);return i&&i.forEach((a,p)=>{I[p]=a}),I}e.fromMap=T;function C(i,I){const a=[],p=[];for(let h of i)I.has(h)||a.push(h);for(let h of I)i.has(h)||p.push(h);return{removed:a,added:p}}e.diffSets=C;function E(i,I){const a=[],p=[];for(let[h,w]of i)I.has(h)||a.push(w);for(let[h,w]of I)i.has(h)||p.push(w);return{removed:a,added:p}}e.diffMaps=E;class k{constructor(){this.map=new Map}add(I,a){let p=this.map.get(I);p||(p=new Set,this.map.set(I,p)),p.add(a)}delete(I,a){const p=this.map.get(I);!p||(p.delete(a),p.size===0&&this.map.delete(I))}forEach(I,a){const p=this.map.get(I);!p||p.forEach(a)}}e.SetMap=k}),define(fe[60],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function g(T){return(C,E,k)=>{let i=null,I=null;if(typeof k.value=="function"?(i="value",I=k.value):typeof k.get=="function"&&(i="get",I=k.get),!I)throw new Error("not supported");k[i]=T(I,E)}}e.createDecorator=g;function L(T,C,E){let k=null,i=null;if(typeof E.value=="function"?(k="value",i=E.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(k="get",i=E.get),!i)throw new Error("not supported");const I=`$memoize$${C}`;E[k]=function(...a){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,a)}),this[I]}}e.memoize=L;function D(T,C,E){return g((k,i)=>{const I=`$debounce$${i}`,a=`$debounce$result$${i}`;return function(...p){this[a]||(this[a]=E?E():void 0),clearTimeout(this[I]),C&&(this[a]=C(this[a],...p),p=[this[a]]),this[I]=setTimeout(()=>{k.apply(this,p),this[a]=E?E():void 0},T)}})}e.debounce=D;function S(T,C,E){return g((k,i)=>{const I=`$throttle$timer$${i}`,a=`$throttle$result$${i}`,p=`$throttle$lastRun$${i}`,h=`$throttle$pending$${i}`;return function(...w){if(this[a]||(this[a]=E?E():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),C&&(this[a]=C(this[a],...w)),this[h])return;const y=this[p]+T;y<=Date.now()?(this[p]=Date.now(),k.apply(this,[this[a]]),this[a]=E?E():void 0):(this[h]=!0,this[I]=setTimeout(()=>{this[h]=!1,this[p]=Date.now(),k.apply(this,[this[a]]),this[a]=E?E():void 0},y-Date.now()))}})}e.throttle=S}),define(fe[18],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class g{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(f=>{f(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}e.ErrorHandler=g,e.errorHandler=new g;function L(v){e.errorHandler.setUnexpectedErrorHandler(v)}e.setUnexpectedErrorHandler=L;function D(v){E(v)||e.errorHandler.onUnexpectedError(v)}e.onUnexpectedError=D;function S(v){E(v)||e.errorHandler.onUnexpectedExternalError(v)}e.onUnexpectedExternalError=S;function T(v){if(v instanceof Error){let{name:n,message:f}=v;const r=v.stacktrace||v.stack;return{$isError:!0,name:n,message:f,stack:r}}return v}e.transformErrorForSerialization=T;const C="Canceled";function E(v){return v instanceof Error&&v.name===C&&v.message===C}e.isPromiseCanceledError=E;class k extends Error{constructor(){super(C);this.name=this.message}}e.CancellationError=k;function i(){const v=new Error(C);return v.name=v.message,v}e.canceled=i;function I(v){return v?new Error(`Illegal argument: ${v}`):new Error("Illegal argument")}e.illegalArgument=I;function a(v){return v?new Error(`Illegal state: ${v}`):new Error("Illegal state")}e.illegalState=a;function p(v){return v?new Error(`readonly property '${v} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function h(v){const n=new Error(`${v} has been disposed`);return n.name="DISPOSED",n}e.disposed=h;function w(v){return v?v.message?v.message:v.stack?v.stack.split(`
`)[0]:String(v):"Error"}e.getErrorMessage=w;class y extends Error{constructor(n){super("NotImplemented");n&&(this.message=n)}}e.NotImplementedError=y;class P extends Error{constructor(n){super("NotSupported");n&&(this.message=n)}}e.NotSupportedError=P;class b extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=b;function o(v){const n=v;return n instanceof Error&&Array.isArray(n.actions)}e.isErrorWithActions=o;function s(v,n=Object.create(null)){const f=new Error(v);return n.actions&&(f.actions=n.actions),f}e.createErrorWithActions=s}),define(fe[15],me([0,1,18]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(W,X=0){return W[W.length-(1+X)]}e.tail=L;function D(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}e.tail2=D;function S(W,X,Q=(de,_e)=>de===_e){if(W===X)return!0;if(!W||!X||W.length!==X.length)return!1;for(let de=0,_e=W.length;de<_e;de++)if(!Q(W[de],X[de]))return!1;return!0}e.equals=S;function T(W,X,Q){let de=0,_e=W.length-1;for(;de<=_e;){const Ce=(de+_e)/2|0,Pe=Q(W[Ce],X);if(Pe<0)de=Ce+1;else if(Pe>0)_e=Ce-1;else return Ce}return-(de+1)}e.binarySearch=T;function C(W,X){let Q=0,de=W.length;if(de===0)return 0;for(;Q<de;){const _e=Math.floor((Q+de)/2);X(W[_e])?de=_e:Q=_e+1}return Q}e.findFirstInSorted=C;function E(W,X,Q){if(W=W|0,W>=X.length)throw new TypeError("invalid index");let de=X[Math.floor(X.length*Math.random())],_e=[],Ce=[],Pe=[];for(let Be of X){const We=Q(Be,de);We<0?_e.push(Be):We>0?Ce.push(Be):Pe.push(Be)}return W<_e.length?E(W,_e,Q):W<_e.length+Pe.length?Pe[0]:E(W-(_e.length+Pe.length),Ce,Q)}e.quickSelect=E;function k(W,X){const Q=[];let de;for(const _e of W.slice(0).sort(X))!de||X(de[0],_e)!==0?(de=[_e],Q.push(de)):de.push(_e);return Q}e.groupBy=k;function i(W,X,Q){const de=[];function _e(Be,We,He){if(We===0&&He.length===0)return;const G=de[de.length-1];G&&G.start+G.deleteCount===Be?(G.deleteCount+=We,G.toInsert.push(...He)):de.push({start:Be,deleteCount:We,toInsert:He})}let Ce=0,Pe=0;for(;;){if(Ce===W.length){_e(Ce,0,X.slice(Pe));break}if(Pe===X.length){_e(Ce,W.length-Ce,[]);break}const Be=W[Ce],We=X[Pe],He=Q(Be,We);He===0?(Ce+=1,Pe+=1):He<0?(_e(Ce,1,[]),Ce+=1):He>0&&(_e(Ce,0,[We]),Pe+=1)}return de}e.sortedDiff=i;function I(W,X,Q){const de=i(W,X,Q),_e=[],Ce=[];for(const Pe of de)_e.push(...W.slice(Pe.start,Pe.start+Pe.deleteCount)),Ce.push(...Pe.toInsert);return{removed:_e,added:Ce}}e.delta=I;function a(W,X,Q){if(Q===0)return[];const de=W.slice(0,Q).sort(X);return h(W,X,de,Q,W.length),de}e.top=a;function p(W,X,Q,de,_e){return Q===0?Promise.resolve([]):new Promise((Ce,Pe)=>{(async()=>{const Be=W.length,We=W.slice(0,Q).sort(X);for(let He=Q,G=Math.min(Q+de,Be);He<Be;He=G,G=Math.min(G+de,Be)){if(He>Q&&await new Promise(ee=>setTimeout(ee)),_e&&_e.isCancellationRequested)throw(0,g.canceled)();h(W,X,We,He,G)}return We})().then(Ce,Pe)})}e.topAsync=p;function h(W,X,Q,de,_e){for(const Ce=Q.length;de<_e;de++){const Pe=W[de];if(X(Pe,Q[Ce-1])<0){Q.pop();const Be=C(Q,We=>X(Pe,We)<0);Q.splice(Be,0,Pe)}}}function w(W){return W.filter(X=>!!X)}e.coalesce=w;function y(W){let X=0;for(let Q=0;Q<W.length;Q++)W[Q]&&(W[X]=W[Q],X+=1);W.length=X}e.coalesceInPlace=y;function P(W,X,Q){W.splice(Q,0,W.splice(X,1)[0])}e.move=P;function b(W){return!Array.isArray(W)||W.length===0}e.isFalsyOrEmpty=b;function o(W){return Array.isArray(W)&&W.length>0}e.isNonEmptyArray=o;function s(W,X=Q=>Q){const Q=new Set;return W.filter(de=>{const _e=X(de);return Q.has(_e)?!1:(Q.add(_e),!0)})}e.distinct=s;function v(W){const X=Object.create(null);return Q=>{const de=W(Q);return X[de]?!1:(X[de]=!0,!0)}}e.uniqueFilter=v;function n(W,X){const Q=f(W,X);if(Q!==-1)return W[Q]}e.findLast=n;function f(W,X){for(let Q=W.length-1;Q>=0;Q--){const de=W[Q];if(X(de))return Q}return-1}e.lastIndex=f;function r(W,X){return W.length>0?W[0]:X}e.firstOrDefault=r;function t(W,X,Q=(de,_e)=>de===_e){let de=0;for(let _e=0,Ce=Math.min(W.length,X.length);_e<Ce&&Q(W[_e],X[_e]);_e++)de++;return de}e.commonPrefixLength=t;function u(W){return[].concat(...W)}e.flatten=u;function l(W,X){let Q=typeof X=="number"?W:0;typeof X=="number"?Q=W:(Q=0,X=W);const de=[];if(Q<=X)for(let _e=Q;_e<X;_e++)de.push(_e);else for(let _e=Q;_e>X;_e--)de.push(_e);return de}e.range=l;function c(W,X,Q){return W.reduce((de,_e)=>(de[X(_e)]=Q?Q(_e):_e,de),Object.create(null))}e.index=c;function m(W,X){return W.push(X),()=>d(W,X)}e.insert=m;function d(W,X){const Q=W.indexOf(X);if(Q>-1)return W.splice(Q,1),X}e.remove=d;function _(W,X,Q){const de=W.slice(0,X),_e=W.slice(X);return de.concat(Q,_e)}e.arrayInsert=_;function A(W,X){let Q;if(typeof X=="number"){let de=X;Q=()=>{const _e=Math.sin(de++)*179426549;return _e-Math.floor(_e)}}else Q=Math.random;for(let de=W.length-1;de>0;de-=1){const _e=Math.floor(Q()*(de+1)),Ce=W[de];W[de]=W[_e],W[_e]=Ce}}e.shuffle=A;function R(W,X){const Q=W.indexOf(X);Q>-1&&(W.splice(Q,1),W.unshift(X))}e.pushToStart=R;function B(W,X){const Q=W.indexOf(X);Q>-1&&(W.splice(Q,1),W.push(X))}e.pushToEnd=B;function U(W,X){return Array.isArray(W)?W.map(X):X(W)}e.mapArrayOrNot=U;function F(W){return Array.isArray(W)?W:[W]}e.asArray=F;function $(W){return W[Math.floor(Math.random()*W.length)]}e.getRandomElement=$;function M(W,X){for(const Q of W){const de=X(Q);if(de!==void 0)return de}}e.mapFind=M;function z(W,X,Q){const de=x(W,X),_e=W.length,Ce=Q.length;W.length=_e+Ce;for(let Pe=_e-1;Pe>=de;Pe--)W[Pe+Ce]=W[Pe];for(let Pe=0;Pe<Ce;Pe++)W[Pe+de]=Q[Pe]}e.insertInto=z;function N(W,X,Q,de){const _e=x(W,X),Ce=W.splice(_e,Q);return z(W,_e,de),Ce}e.splice=N;function x(W,X){return X<0?Math.max(X+W.length,0):Math.min(X,W.length)}function j(W,X){let Q=Number.MAX_SAFE_INTEGER,de=0;return W.forEach((_e,Ce)=>{const Pe=X(_e);Pe<Q&&(Q=Pe,de=Ce)}),de}e.minIndex=j;function O(W,X){let Q=Number.MIN_SAFE_INTEGER,de=0;return W.forEach((_e,Ce)=>{const Pe=X(_e);Pe>Q&&(Q=Pe,de=Ce)}),de}e.maxIndex=O;class H{constructor(X){this.items=X,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(X){let Q=this.firstIdx;for(;Q<this.items.length&&X(this.items[Q]);)Q++;const de=Q===this.firstIdx?null:this.items.slice(this.firstIdx,Q);return this.firstIdx=Q,de}takeFromEndWhile(X){let Q=this.lastIdx;for(;Q>=0&&X(this.items[Q]);)Q--;const de=Q===this.lastIdx?null:this.items.slice(Q+1,this.lastIdx+1);return this.lastIdx=Q,de}peek(){return this.items[this.firstIdx]}dequeue(){const X=this.items[this.firstIdx];return this.firstIdx++,X}takeCount(X){const Q=this.items.slice(this.firstIdx,this.firstIdx+X);return this.firstIdx+=X,Q}}e.ArrayQueue=H}),define(fe[76],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function g(L){const D=this;let S=!1,T;return function(){return S||(S=!0,T=L.apply(D,arguments)),T}}e.once=g}),define(fe[77],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class g{constructor(D){this._prefix=D,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=g,e.defaultGenerator=new g("id#")}),define(fe[78],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var g;(function(L){function D(v){return v&&typeof v=="object"&&typeof v[Symbol.iterator]=="function"}L.is=D;const S=Object.freeze([]);function T(){return S}L.empty=T;function*C(v){yield v}L.single=C;function E(v){return v||S}L.from=E;function k(v){return!v||v[Symbol.iterator]().next().done===!0}L.isEmpty=k;function i(v){return v[Symbol.iterator]().next().value}L.first=i;function I(v,n){for(const f of v)if(n(f))return!0;return!1}L.some=I;function a(v,n){for(const f of v)if(n(f))return f}L.find=a;function*p(v,n){for(const f of v)n(f)&&(yield f)}L.filter=p;function*h(v,n){let f=0;for(const r of v)yield n(r,f++)}L.map=h;function*w(...v){for(const n of v)for(const f of n)yield f}L.concat=w;function*y(v){for(const n of v)for(const f of n)yield f}L.concatNested=y;function P(v,n,f){let r=f;for(const t of v)r=n(r,t);return r}L.reduce=P;function*b(v,n,f=v.length){for(n<0&&(n+=v.length),f<0?f+=v.length:f>v.length&&(f=v.length);n<f;n++)yield v[n]}L.slice=b;function o(v,n=Number.POSITIVE_INFINITY){const f=[];if(n===0)return[f,v];const r=v[Symbol.iterator]();for(let t=0;t<n;t++){const u=r.next();if(u.done)return[f,L.empty()];f.push(u.value)}return[f,{[Symbol.iterator](){return r}}]}L.consume=o;function s(v,n,f=(r,t)=>r===t){const r=v[Symbol.iterator](),t=n[Symbol.iterator]();for(;;){const u=r.next(),l=t.next();if(u.done!==l.done)return!1;if(u.done)return!0;if(!f(u.value,l.value))return!1}}L.equals=s})(g=e.Iterable||(e.Iterable={}))}),define(fe[61],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var g;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(g=e.ScanError||(e.ScanError={}));var L;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var S;(function(n){n.DEFAULT={allowTrailingComma:!0}})(S=e.ParseOptions||(e.ParseOptions={}));function T(n,f=!1){let r=0,t=n.length,u="",l=0,c=16,m=0;function d($){let M=0,z=0;for(;M<$;){const N=n.charCodeAt(r);if(N>=48&&N<=57)z=z*16+N-48;else if(N>=65&&N<=70)z=z*16+N-65+10;else if(N>=97&&N<=102)z=z*16+N-97+10;else break;r++,M++}return M<$&&(z=-1),z}function _($){r=$,u="",l=0,c=16,m=0}function A(){const $=r;if(n.charCodeAt(r)===48)r++;else for(r++;r<n.length&&k(n.charCodeAt(r));)r++;if(r<n.length&&n.charCodeAt(r)===46)if(r++,r<n.length&&k(n.charCodeAt(r)))for(r++;r<n.length&&k(n.charCodeAt(r));)r++;else return m=3,n.substring($,r);let M=r;if(r<n.length&&(n.charCodeAt(r)===69||n.charCodeAt(r)===101))if(r++,(r<n.length&&n.charCodeAt(r)===43||n.charCodeAt(r)===45)&&r++,r<n.length&&k(n.charCodeAt(r))){for(r++;r<n.length&&k(n.charCodeAt(r));)r++;M=r}else m=3;return n.substring($,M)}function R(){let $="",M=r;for(;;){if(r>=t){$+=n.substring(M,r),m=2;break}const z=n.charCodeAt(r);if(z===34){$+=n.substring(M,r),r++;break}if(z===92){if($+=n.substring(M,r),r++,r>=t){m=2;break}switch(n.charCodeAt(r++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:const x=d(4);x>=0?$+=String.fromCharCode(x):m=4;break;default:m=5}M=r;continue}if(z>=0&&z<=31)if(E(z)){$+=n.substring(M,r),m=2;break}else m=6;r++}return $}function B(){if(u="",m=0,l=r,r>=t)return l=t,c=17;let $=n.charCodeAt(r);if(C($)){do r++,u+=String.fromCharCode($),$=n.charCodeAt(r);while(C($));return c=15}if(E($))return r++,u+=String.fromCharCode($),$===13&&n.charCodeAt(r)===10&&(r++,u+=`
`),c=14;switch($){case 123:return r++,c=1;case 125:return r++,c=2;case 91:return r++,c=3;case 93:return r++,c=4;case 58:return r++,c=6;case 44:return r++,c=5;case 34:return r++,u=R(),c=10;case 47:const M=r-1;if(n.charCodeAt(r+1)===47){for(r+=2;r<t&&!E(n.charCodeAt(r));)r++;return u=n.substring(M,r),c=12}if(n.charCodeAt(r+1)===42){r+=2;const z=t-1;let N=!1;for(;r<z;){if(n.charCodeAt(r)===42&&n.charCodeAt(r+1)===47){r+=2,N=!0;break}r++}return N||(r++,m=1),u=n.substring(M,r),c=13}return u+=String.fromCharCode($),r++,c=16;case 45:if(u+=String.fromCharCode($),r++,r===t||!k(n.charCodeAt(r)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=A(),c=11;default:for(;r<t&&U($);)r++,$=n.charCodeAt(r);if(l!==r){switch(u=n.substring(l,r),u){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return u+=String.fromCharCode($),r++,c=16}}function U($){if(C($)||E($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let $;do $=B();while($>=12&&$<=15);return $}return{setPosition:_,getPosition:()=>r,scan:f?F:B,getToken:()=>c,getTokenValue:()=>u,getTokenOffset:()=>l,getTokenLength:()=>r-l,getTokenError:()=>m}}e.createScanner=T;function C(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function E(n){return n===10||n===13||n===8232||n===8233}function k(n){return n>=48&&n<=57}var i;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(i||(i={}));function I(n,f){const r=[],t=new Object;let u;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function m(d,_,A,R){l.value=d,l.offset=_,l.length=A,l.type=R,l.colonOffset=void 0,u=l}try{o(n,{onObjectBegin:(d,_)=>{if(f<=d)throw t;u=void 0,c=f>d,r.push("")},onObjectProperty:(d,_,A)=>{if(f<_||(m(d,_,A,"property"),r[r.length-1]=d,f<=_+A))throw t},onObjectEnd:(d,_)=>{if(f<=d)throw t;u=void 0,r.pop()},onArrayBegin:(d,_)=>{if(f<=d)throw t;u=void 0,r.push(0)},onArrayEnd:(d,_)=>{if(f<=d)throw t;u=void 0,r.pop()},onLiteralValue:(d,_,A)=>{if(f<_||(m(d,_,A,v(d)),f<=_+A))throw t},onSeparator:(d,_,A)=>{if(f<=_)throw t;if(d===":"&&u&&u.type==="property")u.colonOffset=_,c=!1,u=void 0;else if(d===","){const R=r[r.length-1];typeof R=="number"?r[r.length-1]=R+1:(c=!0,r[r.length-1]=""),u=void 0}}})}catch(d){if(d!==t)throw d}return{path:r,previousNode:u,isAtPropertyKey:c,matches:d=>{let _=0;for(let A=0;_<d.length&&A<r.length;A++)if(d[_]===r[A]||d[_]==="*")_++;else if(d[_]!=="**")return!1;return _===d.length}}}e.getLocation=I;function a(n,f=[],r=S.DEFAULT){let t=null,u=[];const l=[];function c(d){Array.isArray(u)?u.push(d):t!==null&&(u[t]=d)}return o(n,{onObjectBegin:()=>{const d={};c(d),l.push(u),u=d,t=null},onObjectProperty:d=>{t=d},onObjectEnd:()=>{u=l.pop()},onArrayBegin:()=>{const d=[];c(d),l.push(u),u=d,t=null},onArrayEnd:()=>{u=l.pop()},onLiteralValue:c,onError:(d,_,A)=>{f.push({error:d,offset:_,length:A})}},r),u[0]}e.parse=a;function p(n,f=[],r=S.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(d){t.type==="property"&&(t.length=d-t.offset,t=t.parent)}function l(d){return t.children.push(d),d}o(n,{onObjectBegin:d=>{t=l({type:"object",offset:d,length:-1,parent:t,children:[]})},onObjectProperty:(d,_,A)=>{t=l({type:"property",offset:_,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:d,offset:_,length:A,parent:t})},onObjectEnd:(d,_)=>{t.length=d+_-t.offset,t=t.parent,u(d+_)},onArrayBegin:(d,_)=>{t=l({type:"array",offset:d,length:-1,parent:t,children:[]})},onArrayEnd:(d,_)=>{t.length=d+_-t.offset,t=t.parent,u(d+_)},onLiteralValue:(d,_,A)=>{l({type:v(d),offset:_,length:A,parent:t,value:d}),u(_+A)},onSeparator:(d,_,A)=>{t.type==="property"&&(d===":"?t.colonOffset=_:d===","&&u(_))},onError:(d,_,A)=>{f.push({error:d,offset:_,length:A})}},r);const m=t.children[0];return m&&delete m.parent,m}e.parseTree=p;function h(n,f){if(!n)return;let r=n;for(let t of f)if(typeof t=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let u=!1;for(const l of r.children)if(Array.isArray(l.children)&&l.children[0].value===t){r=l.children[1],u=!0;break}if(!u)return}else{const u=t;if(r.type!=="array"||u<0||!Array.isArray(r.children)||u>=r.children.length)return;r=r.children[u]}return r}e.findNodeAtLocation=h;function w(n){if(!n.parent||!n.parent.children)return[];const f=w(n.parent);if(n.parent.type==="property"){const r=n.parent.children[0].value;f.push(r)}else if(n.parent.type==="array"){const r=n.parent.children.indexOf(n);r!==-1&&f.push(r)}return f}e.getNodePath=w;function y(n){switch(n.type){case"array":return n.children.map(y);case"object":const f=Object.create(null);for(let r of n.children){const t=r.children[1];t&&(f[r.children[0].value]=y(t))}return f;case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=y;function P(n,f,r=!1){return f>=n.offset&&f<n.offset+n.length||r&&f===n.offset+n.length}e.contains=P;function b(n,f,r=!1){if(P(n,f,r)){const t=n.children;if(Array.isArray(t))for(let u=0;u<t.length&&t[u].offset<=f;u++){const l=b(t[u],f,r);if(l)return l}return n}}e.findNodeAtOffset=b;function o(n,f,r=S.DEFAULT){const t=T(n,!1);function u(Q){return Q?()=>Q(t.getTokenOffset(),t.getTokenLength()):()=>!0}function l(Q){return Q?de=>Q(de,t.getTokenOffset(),t.getTokenLength()):()=>!0}const c=u(f.onObjectBegin),m=l(f.onObjectProperty),d=u(f.onObjectEnd),_=u(f.onArrayBegin),A=u(f.onArrayEnd),R=l(f.onLiteralValue),B=l(f.onSeparator),U=u(f.onComment),F=l(f.onError),$=r&&r.disallowComments,M=r&&r.allowTrailingComma;function z(){for(;;){const Q=t.scan();switch(t.getTokenError()){case 4:N(14);break;case 5:N(15);break;case 3:N(13);break;case 1:$||N(11);break;case 2:N(12);break;case 6:N(16);break}switch(Q){case 12:case 13:$?N(10):U();break;case 16:N(1);break;case 15:case 14:break;default:return Q}}}function N(Q,de=[],_e=[]){if(F(Q),de.length+_e.length>0){let Ce=t.getToken();for(;Ce!==17;){if(de.indexOf(Ce)!==-1){z();break}else if(_e.indexOf(Ce)!==-1)break;Ce=z()}}}function x(Q){const de=t.getTokenValue();return Q?R(de):m(de),z(),!0}function j(){switch(t.getToken()){case 11:let Q=0;try{Q=JSON.parse(t.getTokenValue()),typeof Q!="number"&&(N(2),Q=0)}catch(de){N(2)}R(Q);break;case 7:R(null);break;case 8:R(!0);break;case 9:R(!1);break;default:return!1}return z(),!0}function O(){return t.getToken()!==10?(N(3,[],[2,5]),!1):(x(!1),t.getToken()===6?(B(":"),z(),X()||N(4,[],[2,5])):N(5,[],[2,5]),!0)}function H(){c(),z();let Q=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(Q||N(4,[],[]),B(","),z(),t.getToken()===2&&M)break}else Q&&N(6,[],[]);O()||N(4,[],[2,5]),Q=!0}return d(),t.getToken()!==2?N(7,[2],[]):z(),!0}function W(){_(),z();let Q=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(Q||N(4,[],[]),B(","),z(),t.getToken()===4&&M)break}else Q&&N(6,[],[]);X()||N(4,[],[4,5]),Q=!0}return A(),t.getToken()!==4?N(8,[4],[]):z(),!0}function X(){switch(t.getToken()){case 3:return W();case 1:return H();case 10:return x(!0);default:return j()}}return z(),t.getToken()===17?r.allowEmptyContent?!0:(N(4,[],[]),!1):X()?(t.getToken()!==17&&N(9,[],[]),!0):(N(4,[],[]),!1)}e.visit=o;function s(n,f){let r=T(n),t=[],u,l=0,c;do switch(c=r.getPosition(),u=r.scan(),u){case 12:case 13:case 17:l!==c&&t.push(n.substring(l,c)),f!==void 0&&t.push(r.getTokenValue().replace(/[^\r\n]/g,f)),l=r.getPosition();break}while(u!==17);return t.join("")}e.stripComments=s;function v(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=v}),define(fe[139],me([0,1,61]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(E,k,i){let I,a,p,h,w;if(k){for(h=k.offset,w=h+k.length,p=h;p>0&&!C(E,p-1);)p--;let l=w;for(;l<E.length&&!C(E,l);)l++;a=E.substring(p,l),I=S(a,i)}else a=E,I=0,p=0,h=0,w=E.length;const y=T(i,E);let P=!1,b=0,o;i.insertSpaces?o=D(" ",i.tabSize||4):o="	";const s=(0,g.createScanner)(a,!1);let v=!1;function n(){return y+D(o,I+b)}function f(){let l=s.scan();for(P=!1;l===15||l===14;)P=P||l===14,l=s.scan();return v=l===16||s.getTokenError()!==0,l}const r=[];function t(l,c,m){!v&&c<w&&m>h&&E.substring(c,m)!==l&&r.push({offset:c,length:m-c,content:l})}let u=f();if(u!==17){const l=s.getTokenOffset()+p,c=D(o,I);t(c,p,l)}for(;u!==17;){let l=s.getTokenOffset()+s.getTokenLength()+p,c=f(),m="";for(;!P&&(c===12||c===13);){const _=s.getTokenOffset()+p;t(" ",l,_),l=s.getTokenOffset()+s.getTokenLength()+p,m=c===12?n():"",c=f()}if(c===2)u!==1&&(b--,m=n());else if(c===4)u!==3&&(b--,m=n());else{switch(u){case 3:case 1:b++,m=n();break;case 5:case 12:m=n();break;case 13:P?m=n():m=" ";break;case 6:m=" ";break;case 10:if(c===6){m="";break}case 7:case 8:case 9:case 11:case 2:case 4:c===12||c===13?m=" ":c!==5&&c!==17&&(v=!0);break;case 16:v=!0;break}P&&(c===12||c===13)&&(m=n())}const d=s.getTokenOffset()+p;t(m,l,d),u=c}return r}e.format=L;function D(E,k){let i="";for(let I=0;I<k;I++)i+=E;return i}function S(E,k){let i=0,I=0;const a=k.tabSize||4;for(;i<E.length;){const p=E.charAt(i);if(p===" ")I++;else if(p==="	")I+=a;else break;i++}return Math.floor(I/a)}function T(E,k){for(let i=0;i<k.length;i++){const I=k.charAt(i);if(I==="\r")return i+1<k.length&&k.charAt(i+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return E&&E.eol||`
`}e.getEOL=T;function C(E,k){return`\r
`.indexOf(E.charAt(k))!==-1}e.isEOL=C}),define(fe[140],me([0,1,61,139]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(k,i,I){return S(k,i,void 0,I)}e.removeProperty=D;function S(k,i,I,a,p){const h=i.slice(),w=[],y=(0,g.parseTree)(k,w);let P,b;for(;h.length>0&&(b=h.pop(),P=(0,g.findNodeAtLocation)(y,h),P===void 0&&I!==void 0);)typeof b=="string"?I={[b]:I}:I=[I];if(P)if(P.type==="object"&&typeof b=="string"&&Array.isArray(P.children)){const o=(0,g.findNodeAtLocation)(P,[b]);if(o!==void 0)if(I===void 0){if(!o.parent)throw new Error("Malformed AST");const s=P.children.indexOf(o.parent);let v,n=o.parent.offset+o.parent.length;if(s>0){const f=P.children[s-1];v=f.offset+f.length}else v=P.offset+1,P.children.length>1&&(n=P.children[1].offset);return T(k,{offset:v,length:n-v,content:""},a)}else return T(k,{offset:o.offset,length:o.length,content:JSON.stringify(I)},a);else{if(I===void 0)return[];const s=`${JSON.stringify(b)}: ${JSON.stringify(I)}`,v=p?p(P.children.map(f=>f.children[0].value)):P.children.length;let n;if(v>0){const f=P.children[v-1];n={offset:f.offset+f.length,length:0,content:","+s}}else P.children.length===0?n={offset:P.offset+1,length:0,content:s}:n={offset:P.offset+1,length:0,content:s+","};return T(k,n,a)}}else if(P.type==="array"&&typeof b=="number"&&Array.isArray(P.children))if(I!==void 0){const o=`${JSON.stringify(I)}`;let s;if(P.children.length===0||b===0)s={offset:P.offset+1,length:0,content:P.children.length===0?o:o+","};else{const v=b===-1||b>P.children.length?P.children.length:b,n=P.children[v-1];s={offset:n.offset+n.length,length:0,content:","+o}}return T(k,s,a)}else{const o=b,s=P.children[o];let v;if(P.children.length===1)v={offset:P.offset+1,length:P.length-2,content:""};else if(P.children.length-1===o){const n=P.children[o-1],f=n.offset+n.length,r=P.offset+P.length;v={offset:f,length:r-2-f,content:""}}else v={offset:s.offset,length:P.children[o+1].offset-s.offset,content:""};return T(k,v,a)}else throw new Error(`Can not add ${typeof b!="number"?"index":"property"} to parent of type ${P.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return T(k,{offset:y?y.offset:0,length:y?y.length:0,content:JSON.stringify(I)},a)}}e.setProperty=S;function T(k,i,I){let a=C(k,i),p=i.offset,h=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;p>0&&!(0,L.isEOL)(a,p-1);)p--;for(;h<a.length&&!(0,L.isEOL)(a,h);)h++}const w=(0,L.format)(a,{offset:p,length:h-p},I);for(let P=w.length-1;P>=0;P--){const b=w[P];a=C(a,b),p=Math.min(p,b.offset),h=Math.max(h,b.offset+b.length),h+=b.content.length-b.length}const y=k.length-(a.length-h)-p;return[{offset:p,length:y,content:a.substring(p,h)}]}e.withFormatting=T;function C(k,i){return k.substring(0,i.offset)+i.content+k.substring(i.offset+i.length)}e.applyEdit=C;function E(k,i){let I=i.slice(0).sort((p,h)=>{const w=p.offset-h.offset;return w===0?p.length-h.length:w}),a=k.length;for(let p=I.length-1;p>=0;p--){let h=I[p];if(h.offset+h.length<=a)k=C(k,h);else throw new Error("Overlapping edit");a=h.offset}return k}e.applyEdits=E}),define(fe[141],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class g{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new g(()=>D(this.getValue()))}}e.Lazy=g}),define(fe[6],me([0,1,76,78]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let S=null;function T(t){S=t}if(e.setDisposableTracker=T,D){const t="__is_disposable_tracked__";T(new class{trackDisposable(u){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{u[t]||console.log(l)},3e3)}setParent(u,l){if(u&&u!==b.None)try{u[t]=!0}catch{}}markAsDisposed(u){if(u&&u!==b.None)try{u[t]=!0}catch{}}markAsSingleton(u){}})}function C(t){return S?.trackDisposable(t),t}function E(t){S?.markAsDisposed(t)}function k(t,u){S?.setParent(t,u)}function i(t,u){if(!!S)for(const l of t)S.setParent(l,u)}function I(t){return S?.markAsSingleton(t),t}e.markAsSingleton=I;class a extends Error{constructor(u){super(`Encountered errors while disposing of store. Errors: [${u.join(", ")}]`);this.errors=u}}e.MultiDisposeError=a;function p(t){return typeof t.dispose=="function"&&t.dispose.length===0}e.isDisposable=p;function h(t){if(L.Iterable.is(t)){let u=[];for(const l of t)if(l)try{l.dispose()}catch(c){u.push(c)}if(u.length===1)throw u[0];if(u.length>1)throw new a(u);return Array.isArray(t)?[]:t}else if(t)return t.dispose(),t}e.dispose=h;function w(...t){const u=y(()=>h(t));return i(t,u),u}e.combinedDisposable=w;function y(t){const u=C({dispose:(0,g.once)(()=>{E(u),t()})});return u}e.toDisposable=y;class P{constructor(){this._toDispose=new Set,this._isDisposed=!1,C(this)}dispose(){this._isDisposed||(E(this),this._isDisposed=!0,this.clear())}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(u){if(!u)return u;if(u===this)throw new Error("Cannot register a disposable on itself!");return k(u,this),this._isDisposed?P.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(u),u}}e.DisposableStore=P,P.DISABLE_DISPOSED_WARNING=!1;class b{constructor(){this._store=new P,C(this),k(this._store,this)}dispose(){E(this),this._store.dispose()}_register(u){if(u===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(u)}}e.Disposable=b,b.None=Object.freeze({dispose(){}});class o{constructor(){this._isDisposed=!1,C(this)}get value(){return this._isDisposed?void 0:this._value}set value(u){this._isDisposed||u===this._value||(this._value?.dispose(),u&&k(u,this),this._value=u)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,E(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const u=this._value;return this._value=void 0,u&&k(u,null),u}}e.MutableDisposable=o;class s{constructor(u){this._disposable=u,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=s;class v{constructor(){this.references=new Map}acquire(u,...l){let c=this.references.get(u);c||(c={counter:0,object:this.createReferencedObject(u,...l)},this.references.set(u,c));const{object:m}=c,d=(0,g.once)(()=>{--c.counter==0&&(this.destroyReferencedObject(u,c.object),this.references.delete(u))});return c.counter++,{object:m,dispose:d}}}e.ReferenceCollection=v;class n{constructor(u){this.referenceCollection=u}async acquire(u,...l){const c=this.referenceCollection.acquire(u,...l);try{return{object:await c.object,dispose:()=>c.dispose()}}catch(m){throw c.dispose(),m}}}e.AsyncReferenceCollection=n;class f{constructor(u){this.object=u}dispose(){}}e.ImmortalReference=f;function r(t){const u=new P;try{t(u)}finally{u.dispose()}}e.disposeOnReturn=r}),define(fe[94],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class g{constructor(S){this.element=S,this.next=g.Undefined,this.prev=g.Undefined}}g.Undefined=new g(void 0);class L{constructor(){this._first=g.Undefined,this._last=g.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===g.Undefined}clear(){let S=this._first;for(;S!==g.Undefined;){const T=S.next;S.prev=g.Undefined,S.next=g.Undefined,S=T}this._first=g.Undefined,this._last=g.Undefined,this._size=0}unshift(S){return this._insert(S,!1)}push(S){return this._insert(S,!0)}_insert(S,T){const C=new g(S);if(this._first===g.Undefined)this._first=C,this._last=C;else if(T){const k=this._last;this._last=C,C.prev=k,k.next=C}else{const k=this._first;this._first=C,C.next=k,k.prev=C}this._size+=1;let E=!1;return()=>{E||(E=!0,this._remove(C))}}shift(){if(this._first!==g.Undefined){const S=this._first.element;return this._remove(this._first),S}}pop(){if(this._last!==g.Undefined){const S=this._last.element;return this._remove(this._last),S}}_remove(S){if(S.prev!==g.Undefined&&S.next!==g.Undefined){const T=S.prev;T.next=S.next,S.next.prev=T}else S.prev===g.Undefined&&S.next===g.Undefined?(this._first=g.Undefined,this._last=g.Undefined):S.next===g.Undefined?(this._last=this._last.prev,this._last.next=g.Undefined):S.prev===g.Undefined&&(this._first=this._first.next,this._first.prev=g.Undefined);this._size-=1}*[Symbol.iterator](){let S=this._first;for(;S!==g.Undefined;)yield S.element,S=S.next}}e.LinkedList=L}),function(Y,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Y=typeof globalThis!="undefined"?globalThis:Y||self,Y.marked=e())}(this,function(){"use strict";function Y(Re,De){for(var Te=0;Te<De.length;Te++){var se=De[Te];se.enumerable=se.enumerable||!1,se.configurable=!0,"value"in se&&(se.writable=!0),Object.defineProperty(Re,se.key,se)}}function e(Re,De,Te){return De&&Y(Re.prototype,De),Te&&Y(Re,Te),Re}function g(Re,De){if(!!Re){if(typeof Re=="string")return L(Re,De);var Te=Object.prototype.toString.call(Re).slice(8,-1);if(Te==="Object"&&Re.constructor&&(Te=Re.constructor.name),Te==="Map"||Te==="Set")return Array.from(Re);if(Te==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Te))return L(Re,De)}}function L(Re,De){(De==null||De>Re.length)&&(De=Re.length);for(var Te=0,se=new Array(De);Te<De;Te++)se[Te]=Re[Te];return se}function D(Re,De){var Te=typeof Symbol!="undefined"&&Re[Symbol.iterator]||Re["@@iterator"];if(Te)return(Te=Te.call(Re)).next.bind(Te);if(Array.isArray(Re)||(Te=g(Re))||De&&Re&&typeof Re.length=="number"){Te&&(Re=Te);var se=0;return function(){return se>=Re.length?{done:!0}:{done:!1,value:Re[se++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var S={exports:{}};function T(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function C(Re){S.exports.defaults=Re}S.exports={defaults:T(),getDefaults:T,changeDefaults:C};var E=/[&<>"']/,k=/[&<>"']/g,i=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,a={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(De){return a[De]};function h(Re,De){if(De){if(E.test(Re))return Re.replace(k,p)}else if(i.test(Re))return Re.replace(I,p);return Re}var w=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function y(Re){return Re.replace(w,function(De,Te){return Te=Te.toLowerCase(),Te==="colon"?":":Te.charAt(0)==="#"?Te.charAt(1)==="x"?String.fromCharCode(parseInt(Te.substring(2),16)):String.fromCharCode(+Te.substring(1)):""})}var P=/(^|[^\[])\^/g;function b(Re,De){Re=Re.source||Re,De=De||"";var Te={replace:function(ue,we){return we=we.source||we,we=we.replace(P,"$1"),Re=Re.replace(ue,we),Te},getRegex:function(){return new RegExp(Re,De)}};return Te}var o=/[^\w:]/g,s=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function v(Re,De,Te){if(Re){var se;try{se=decodeURIComponent(y(Te)).replace(o,"").toLowerCase()}catch(ue){return null}if(se.indexOf("javascript:")===0||se.indexOf("vbscript:")===0||se.indexOf("data:")===0)return null}De&&!s.test(Te)&&(Te=u(De,Te));try{Te=encodeURI(Te).replace(/%25/g,"%")}catch(ue){return null}return Te}var n={},f=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,t=/^([^:]+:\/*[^/]*)[\s\S]*$/;function u(Re,De){n[" "+Re]||(f.test(Re)?n[" "+Re]=Re+"/":n[" "+Re]=d(Re,"/",!0)),Re=n[" "+Re];var Te=Re.indexOf(":")===-1;return De.substring(0,2)==="//"?Te?De:Re.replace(r,"$1")+De:De.charAt(0)==="/"?Te?De:Re.replace(t,"$1")+De:Re+De}var l={exec:function(){}};function c(Re){for(var De=1,Te,se;De<arguments.length;De++){Te=arguments[De];for(se in Te)Object.prototype.hasOwnProperty.call(Te,se)&&(Re[se]=Te[se])}return Re}function m(Re,De){var Te=Re.replace(/\|/g,function(we,ve,Fe){for(var qe=!1,ze=ve;--ze>=0&&Fe[ze]==="\\";)qe=!qe;return qe?"|":" |"}),se=Te.split(/ \|/),ue=0;if(se[0].trim()||se.shift(),se[se.length-1].trim()||se.pop(),se.length>De)se.splice(De);else for(;se.length<De;)se.push("");for(;ue<se.length;ue++)se[ue]=se[ue].trim().replace(/\\\|/g,"|");return se}function d(Re,De,Te){var se=Re.length;if(se===0)return"";for(var ue=0;ue<se;){var we=Re.charAt(se-ue-1);if(we===De&&!Te)ue++;else if(we!==De&&Te)ue++;else break}return Re.substr(0,se-ue)}function _(Re,De){if(Re.indexOf(De[1])===-1)return-1;for(var Te=Re.length,se=0,ue=0;ue<Te;ue++)if(Re[ue]==="\\")ue++;else if(Re[ue]===De[0])se++;else if(Re[ue]===De[1]&&(se--,se<0))return ue;return-1}function A(Re){Re&&Re.sanitize&&!Re.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(Re,De){if(De<1)return"";for(var Te="";De>1;)De&1&&(Te+=Re),De>>=1,Re+=Re;return Te+Re}var B={escape:h,unescape:y,edit:b,cleanUrl:v,resolveUrl:u,noopTest:l,merge:c,splitCells:m,rtrim:d,findClosingBracket:_,checkSanitizeDeprecation:A,repeatString:R},U=S.exports.defaults,F=B.rtrim,$=B.splitCells,M=B.escape,z=B.findClosingBracket;function N(Re,De,Te,se){var ue=De.href,we=De.title?M(De.title):null,ve=Re[1].replace(/\\([\[\]])/g,"$1");if(Re[0].charAt(0)!=="!"){se.state.inLink=!0;var Fe={type:"link",raw:Te,href:ue,title:we,text:ve,tokens:se.inlineTokens(ve,[])};return se.state.inLink=!1,Fe}else return{type:"image",raw:Te,href:ue,title:we,text:M(ve)}}function x(Re,De){var Te=Re.match(/^(\s+)(?:```)/);if(Te===null)return De;var se=Te[1];return De.split(`
`).map(function(ue){var we=ue.match(/^\s+/);if(we===null)return ue;var ve=we[0];return ve.length>=se.length?ue.slice(se.length):ue}).join(`
`)}var j=function(){function Re(Te){this.options=Te||U}var De=Re.prototype;return De.space=function(se){var ue=this.rules.block.newline.exec(se);if(ue)return ue[0].length>1?{type:"space",raw:ue[0]}:{raw:`
`}},De.code=function(se){var ue=this.rules.block.code.exec(se);if(ue){var we=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?we:F(we,`
`)}}},De.fences=function(se){var ue=this.rules.block.fences.exec(se);if(ue){var we=ue[0],ve=x(we,ue[3]||"");return{type:"code",raw:we,lang:ue[2]?ue[2].trim():ue[2],text:ve}}},De.heading=function(se){var ue=this.rules.block.heading.exec(se);if(ue){var we=ue[2].trim();if(/#$/.test(we)){var ve=F(we,"#");(this.options.pedantic||!ve||/ $/.test(ve))&&(we=ve.trim())}var Fe={type:"heading",raw:ue[0],depth:ue[1].length,text:we,tokens:[]};return this.lexer.inline(Fe.text,Fe.tokens),Fe}},De.hr=function(se){var ue=this.rules.block.hr.exec(se);if(ue)return{type:"hr",raw:ue[0]}},De.blockquote=function(se){var ue=this.rules.block.blockquote.exec(se);if(ue){var we=ue[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ue[0],tokens:this.lexer.blockTokens(we,[]),text:we}}},De.list=function(se){var ue=this.rules.block.list.exec(se);if(ue){var we,ve,Fe,qe,ze,Ye,lt,xe,ge,be,ae=ue[1].trim(),K=ae.length>1,Se={type:"list",raw:"",ordered:K,start:K?+ae.slice(0,-1):"",loose:!1,items:[]};ae=K?"\\d{1,9}\\"+ae.slice(-1):"\\"+ae,this.options.pedantic&&(ae=K?ae:"[*+-]");for(var Le=new RegExp("^( {0,3}"+ae+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");se&&!(this.rules.block.hr.test(se)||!(ue=Le.exec(se)));){ge=ue[2].split(`
`),this.options.pedantic?(qe=2,be=ge[0].trimLeft()):(qe=ue[2].search(/[^ ]/),qe=ue[1].length+(qe>4?1:qe),be=ge[0].slice(qe-ue[1].length)),Ye=!1,we=ue[0],!ge[0]&&/^ *$/.test(ge[1])&&(we=ue[1]+ge.slice(0,2).join(`
`)+`
`,Se.loose=!0,ge=[]);var it=new RegExp("^ {0,"+Math.min(3,qe-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(ze=1;ze<ge.length;ze++){if(xe=ge[ze],this.options.pedantic&&(xe=xe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),it.test(xe)){we=ue[1]+ge.slice(0,ze).join(`
`)+`
`;break}if(!Ye){xe.trim()||(Ye=!0),xe.search(/[^ ]/)>=qe?be+=`
`+xe.slice(qe):be+=`
`+xe;continue}if(xe.search(/[^ ]/)>=qe||!xe.trim()){be+=`
`+xe.slice(qe);continue}else{we=ue[1]+ge.slice(0,ze).join(`
`)+`
`;break}}Se.loose||(lt?Se.loose=!0:/\n *\n *$/.test(we)&&(lt=!0)),this.options.gfm&&(ve=/^\[[ xX]\] /.exec(be),ve&&(Fe=ve[0]!=="[ ] ",be=be.replace(/^\[[ xX]\] +/,""))),Se.items.push({type:"list_item",raw:we,task:!!ve,checked:Fe,loose:!1,text:be}),Se.raw+=we,se=se.slice(we.length)}Se.items[Se.items.length-1].raw=we.trimRight(),Se.items[Se.items.length-1].text=be.trimRight(),Se.raw=Se.raw.trimRight();var Ge=Se.items.length;for(ze=0;ze<Ge;ze++)this.lexer.state.top=!1,Se.items[ze].tokens=this.lexer.blockTokens(Se.items[ze].text,[]),Se.items[ze].tokens.some(function(mt){return mt.type==="space"})&&(Se.loose=!0,Se.items[ze].loose=!0);return Se}},De.html=function(se){var ue=this.rules.block.html.exec(se);if(ue){var we={type:"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:ue[0]};return this.options.sanitize&&(we.type="paragraph",we.text=this.options.sanitizer?this.options.sanitizer(ue[0]):M(ue[0]),we.tokens=[],this.lexer.inline(we.text,we.tokens)),we}},De.def=function(se){var ue=this.rules.block.def.exec(se);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var we=ue[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:we,raw:ue[0],href:ue[2],title:ue[3]}}},De.table=function(se){var ue=this.rules.block.table.exec(se);if(ue){var we={type:"table",header:$(ue[1]).map(function(lt){return{text:lt}}),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[]};if(we.header.length===we.align.length){we.raw=ue[0];var ve=we.align.length,Fe,qe,ze,Ye;for(Fe=0;Fe<ve;Fe++)/^ *-+: *$/.test(we.align[Fe])?we.align[Fe]="right":/^ *:-+: *$/.test(we.align[Fe])?we.align[Fe]="center":/^ *:-+ *$/.test(we.align[Fe])?we.align[Fe]="left":we.align[Fe]=null;for(ve=we.rows.length,Fe=0;Fe<ve;Fe++)we.rows[Fe]=$(we.rows[Fe],we.header.length).map(function(lt){return{text:lt}});for(ve=we.header.length,qe=0;qe<ve;qe++)we.header[qe].tokens=[],this.lexer.inlineTokens(we.header[qe].text,we.header[qe].tokens);for(ve=we.rows.length,qe=0;qe<ve;qe++)for(Ye=we.rows[qe],ze=0;ze<Ye.length;ze++)Ye[ze].tokens=[],this.lexer.inlineTokens(Ye[ze].text,Ye[ze].tokens);return we}}},De.lheading=function(se){var ue=this.rules.block.lheading.exec(se);if(ue){var we={type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1],tokens:[]};return this.lexer.inline(we.text,we.tokens),we}},De.paragraph=function(se){var ue=this.rules.block.paragraph.exec(se);if(ue){var we={type:"paragraph",raw:ue[0],text:ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1],tokens:[]};return this.lexer.inline(we.text,we.tokens),we}},De.text=function(se){var ue=this.rules.block.text.exec(se);if(ue){var we={type:"text",raw:ue[0],text:ue[0],tokens:[]};return this.lexer.inline(we.text,we.tokens),we}},De.escape=function(se){var ue=this.rules.inline.escape.exec(se);if(ue)return{type:"escape",raw:ue[0],text:M(ue[1])}},De.tag=function(se){var ue=this.rules.inline.tag.exec(se);if(ue)return!this.lexer.state.inLink&&/^<a /i.test(ue[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ue[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ue[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ue[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ue[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):M(ue[0]):ue[0]}},De.link=function(se){var ue=this.rules.inline.link.exec(se);if(ue){var we=ue[2].trim();if(!this.options.pedantic&&/^</.test(we)){if(!/>$/.test(we))return;var ve=F(we.slice(0,-1),"\\");if((we.length-ve.length)%2==0)return}else{var Fe=z(ue[2],"()");if(Fe>-1){var qe=ue[0].indexOf("!")===0?5:4,ze=qe+ue[1].length+Fe;ue[2]=ue[2].substring(0,Fe),ue[0]=ue[0].substring(0,ze).trim(),ue[3]=""}}var Ye=ue[2],lt="";if(this.options.pedantic){var xe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ye);xe&&(Ye=xe[1],lt=xe[3])}else lt=ue[3]?ue[3].slice(1,-1):"";return Ye=Ye.trim(),/^</.test(Ye)&&(this.options.pedantic&&!/>$/.test(we)?Ye=Ye.slice(1):Ye=Ye.slice(1,-1)),N(ue,{href:Ye&&Ye.replace(this.rules.inline._escapes,"$1"),title:lt&&lt.replace(this.rules.inline._escapes,"$1")},ue[0],this.lexer)}},De.reflink=function(se,ue){var we;if((we=this.rules.inline.reflink.exec(se))||(we=this.rules.inline.nolink.exec(se))){var ve=(we[2]||we[1]).replace(/\s+/g," ");if(ve=ue[ve.toLowerCase()],!ve||!ve.href){var Fe=we[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return N(we,ve,we[0],this.lexer)}},De.emStrong=function(se,ue,we){we===void 0&&(we="");var ve=this.rules.inline.emStrong.lDelim.exec(se);if(!!ve&&!(ve[3]&&we.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=ve[1]||ve[2]||"";if(!Fe||Fe&&(we===""||this.rules.inline.punctuation.exec(we))){var qe=ve[0].length-1,ze,Ye,lt=qe,xe=0,ge=ve[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ge.lastIndex=0,ue=ue.slice(-1*se.length+qe);(ve=ge.exec(ue))!=null;)if(ze=ve[1]||ve[2]||ve[3]||ve[4]||ve[5]||ve[6],!!ze){if(Ye=ze.length,ve[3]||ve[4]){lt+=Ye;continue}else if((ve[5]||ve[6])&&qe%3&&!((qe+Ye)%3)){xe+=Ye;continue}if(lt-=Ye,!(lt>0)){if(Ye=Math.min(Ye,Ye+lt+xe),Math.min(qe,Ye)%2){var be=se.slice(1,qe+ve.index+Ye);return{type:"em",raw:se.slice(0,qe+ve.index+Ye+1),text:be,tokens:this.lexer.inlineTokens(be,[])}}var ae=se.slice(2,qe+ve.index+Ye-1);return{type:"strong",raw:se.slice(0,qe+ve.index+Ye+1),text:ae,tokens:this.lexer.inlineTokens(ae,[])}}}}}},De.codespan=function(se){var ue=this.rules.inline.code.exec(se);if(ue){var we=ue[2].replace(/\n/g," "),ve=/[^ ]/.test(we),Fe=/^ /.test(we)&&/ $/.test(we);return ve&&Fe&&(we=we.substring(1,we.length-1)),we=M(we,!0),{type:"codespan",raw:ue[0],text:we}}},De.br=function(se){var ue=this.rules.inline.br.exec(se);if(ue)return{type:"br",raw:ue[0]}},De.del=function(se){var ue=this.rules.inline.del.exec(se);if(ue)return{type:"del",raw:ue[0],text:ue[2],tokens:this.lexer.inlineTokens(ue[2],[])}},De.autolink=function(se,ue){var we=this.rules.inline.autolink.exec(se);if(we){var ve,Fe;return we[2]==="@"?(ve=M(this.options.mangle?ue(we[1]):we[1]),Fe="mailto:"+ve):(ve=M(we[1]),Fe=ve),{type:"link",raw:we[0],text:ve,href:Fe,tokens:[{type:"text",raw:ve,text:ve}]}}},De.url=function(se,ue){var we;if(we=this.rules.inline.url.exec(se)){var ve,Fe;if(we[2]==="@")ve=M(this.options.mangle?ue(we[0]):we[0]),Fe="mailto:"+ve;else{var qe;do qe=we[0],we[0]=this.rules.inline._backpedal.exec(we[0])[0];while(qe!==we[0]);ve=M(we[0]),we[1]==="www."?Fe="http://"+ve:Fe=ve}return{type:"link",raw:we[0],text:ve,href:Fe,tokens:[{type:"text",raw:ve,text:ve}]}}},De.inlineText=function(se,ue){var we=this.rules.inline.text.exec(se);if(we){var ve;return this.lexer.state.inRawBlock?ve=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(we[0]):M(we[0]):we[0]:ve=M(this.options.smartypants?ue(we[0]):we[0]),{type:"text",raw:we[0],text:ve}}},Re}(),O=B.noopTest,H=B.edit,W=B.merge,X={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:O,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};X._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,X._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,X.def=H(X.def).replace("label",X._label).replace("title",X._title).getRegex(),X.bullet=/(?:[*+-]|\d{1,9}[.)])/,X.listItemStart=H(/^( *)(bull) */).replace("bull",X.bullet).getRegex(),X.list=H(X.list).replace(/bull/g,X.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+X.def.source+")").getRegex(),X._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",X._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,X.html=H(X.html,"i").replace("comment",X._comment).replace("tag",X._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),X.paragraph=H(X._paragraph).replace("hr",X.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",X._tag).getRegex(),X.blockquote=H(X.blockquote).replace("paragraph",X.paragraph).getRegex(),X.normal=W({},X),X.gfm=W({},X.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),X.gfm.table=H(X.gfm.table).replace("hr",X.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",X._tag).getRegex(),X.pedantic=W({},X.normal,{html:H(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",X._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:O,paragraph:H(X.normal._paragraph).replace("hr",X.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",X.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var Q={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:O,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:O,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};Q._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",Q.punctuation=H(Q.punctuation).replace(/punctuation/g,Q._punctuation).getRegex(),Q.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,Q.escapedEmSt=/\\\*|\\_/g,Q._comment=H(X._comment).replace("(?:-->|$)","-->").getRegex(),Q.emStrong.lDelim=H(Q.emStrong.lDelim).replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimAst=H(Q.emStrong.rDelimAst,"g").replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimUnd=H(Q.emStrong.rDelimUnd,"g").replace(/punct/g,Q._punctuation).getRegex(),Q._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,Q._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,Q._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,Q.autolink=H(Q.autolink).replace("scheme",Q._scheme).replace("email",Q._email).getRegex(),Q._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,Q.tag=H(Q.tag).replace("comment",Q._comment).replace("attribute",Q._attribute).getRegex(),Q._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Q._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,Q._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,Q.link=H(Q.link).replace("label",Q._label).replace("href",Q._href).replace("title",Q._title).getRegex(),Q.reflink=H(Q.reflink).replace("label",Q._label).getRegex(),Q.reflinkSearch=H(Q.reflinkSearch,"g").replace("reflink",Q.reflink).replace("nolink",Q.nolink).getRegex(),Q.normal=W({},Q),Q.pedantic=W({},Q.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:H(/^!?\[(label)\]\((.*?)\)/).replace("label",Q._label).getRegex(),reflink:H(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Q._label).getRegex()}),Q.gfm=W({},Q.normal,{escape:H(Q.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),Q.gfm.url=H(Q.gfm.url,"i").replace("email",Q.gfm._extended_email).getRegex(),Q.breaks=W({},Q.gfm,{br:H(Q.br).replace("{2,}","*").getRegex(),text:H(Q.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var de={block:X,inline:Q},_e=j,Ce=S.exports.defaults,Pe=de.block,Be=de.inline,We=B.repeatString;function He(Re){return Re.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function G(Re){var De="",Te,se,ue=Re.length;for(Te=0;Te<ue;Te++)se=Re.charCodeAt(Te),Math.random()>.5&&(se="x"+se.toString(16)),De+="&#"+se+";";return De}var ee=function(){function Re(Te){this.tokens=[],this.tokens.links=Object.create(null),this.options=Te||Ce,this.options.tokenizer=this.options.tokenizer||new _e,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var se={block:Pe.normal,inline:Be.normal};this.options.pedantic?(se.block=Pe.pedantic,se.inline=Be.pedantic):this.options.gfm&&(se.block=Pe.gfm,this.options.breaks?se.inline=Be.breaks:se.inline=Be.gfm),this.tokenizer.rules=se}Re.lex=function(se,ue){var we=new Re(ue);return we.lex(se)},Re.lexInline=function(se,ue){var we=new Re(ue);return we.inlineTokens(se)};var De=Re.prototype;return De.lex=function(se){se=se.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(se,this.tokens);for(var ue;ue=this.inlineQueue.shift();)this.inlineTokens(ue.src,ue.tokens);return this.tokens},De.blockTokens=function(se,ue){var we=this;ue===void 0&&(ue=[]),this.options.pedantic&&(se=se.replace(/^ +$/gm,""));for(var ve,Fe,qe,ze;se;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(lt){return(ve=lt.call({lexer:we},se,ue))?(se=se.substring(ve.raw.length),ue.push(ve),!0):!1}))){if(ve=this.tokenizer.space(se)){se=se.substring(ve.raw.length),ve.type&&ue.push(ve);continue}if(ve=this.tokenizer.code(se)){se=se.substring(ve.raw.length),Fe=ue[ue.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+ve.raw,Fe.text+=`
`+ve.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(ve);continue}if(ve=this.tokenizer.fences(se)){se=se.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.heading(se)){se=se.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.hr(se)){se=se.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.blockquote(se)){se=se.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.list(se)){se=se.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.html(se)){se=se.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.def(se)){se=se.substring(ve.raw.length),Fe=ue[ue.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+ve.raw,Fe.text+=`
`+ve.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[ve.tag]||(this.tokens.links[ve.tag]={href:ve.href,title:ve.title});continue}if(ve=this.tokenizer.table(se)){se=se.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.lheading(se)){se=se.substring(ve.raw.length),ue.push(ve);continue}if(qe=se,this.options.extensions&&this.options.extensions.startBlock&&function(){var lt=Infinity,xe=se.slice(1),ge=void 0;we.options.extensions.startBlock.forEach(function(be){ge=be.call({lexer:this},xe),typeof ge=="number"&&ge>=0&&(lt=Math.min(lt,ge))}),lt<Infinity&&lt>=0&&(qe=se.substring(0,lt+1))}(),this.state.top&&(ve=this.tokenizer.paragraph(qe))){Fe=ue[ue.length-1],ze&&Fe.type==="paragraph"?(Fe.raw+=`
`+ve.raw,Fe.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(ve),ze=qe.length!==se.length,se=se.substring(ve.raw.length);continue}if(ve=this.tokenizer.text(se)){se=se.substring(ve.raw.length),Fe=ue[ue.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+ve.raw,Fe.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(ve);continue}if(se){var Ye="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(Ye);break}else throw new Error(Ye)}}return this.state.top=!0,ue},De.inline=function(se,ue){this.inlineQueue.push({src:se,tokens:ue})},De.inlineTokens=function(se,ue){var we=this;ue===void 0&&(ue=[]);var ve,Fe,qe,ze=se,Ye,lt,xe;if(this.tokens.links){var ge=Object.keys(this.tokens.links);if(ge.length>0)for(;(Ye=this.tokenizer.rules.inline.reflinkSearch.exec(ze))!=null;)ge.includes(Ye[0].slice(Ye[0].lastIndexOf("[")+1,-1))&&(ze=ze.slice(0,Ye.index)+"["+We("a",Ye[0].length-2)+"]"+ze.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ye=this.tokenizer.rules.inline.blockSkip.exec(ze))!=null;)ze=ze.slice(0,Ye.index)+"["+We("a",Ye[0].length-2)+"]"+ze.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ye=this.tokenizer.rules.inline.escapedEmSt.exec(ze))!=null;)ze=ze.slice(0,Ye.index)+"++"+ze.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;se;)if(lt||(xe=""),lt=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ae){return(ve=ae.call({lexer:we},se,ue))?(se=se.substring(ve.raw.length),ue.push(ve),!0):!1}))){if(ve=this.tokenizer.escape(se)){se=se.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.tag(se)){se=se.substring(ve.raw.length),Fe=ue[ue.length-1],Fe&&ve.type==="text"&&Fe.type==="text"?(Fe.raw+=ve.raw,Fe.text+=ve.text):ue.push(ve);continue}if(ve=this.tokenizer.link(se)){se=se.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.reflink(se,this.tokens.links)){se=se.substring(ve.raw.length),Fe=ue[ue.length-1],Fe&&ve.type==="text"&&Fe.type==="text"?(Fe.raw+=ve.raw,Fe.text+=ve.text):ue.push(ve);continue}if(ve=this.tokenizer.emStrong(se,ze,xe)){se=se.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.codespan(se)){se=se.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.br(se)){se=se.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.del(se)){se=se.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.autolink(se,G)){se=se.substring(ve.raw.length),ue.push(ve);continue}if(!this.state.inLink&&(ve=this.tokenizer.url(se,G))){se=se.substring(ve.raw.length),ue.push(ve);continue}if(qe=se,this.options.extensions&&this.options.extensions.startInline&&function(){var ae=Infinity,K=se.slice(1),Se=void 0;we.options.extensions.startInline.forEach(function(Le){Se=Le.call({lexer:this},K),typeof Se=="number"&&Se>=0&&(ae=Math.min(ae,Se))}),ae<Infinity&&ae>=0&&(qe=se.substring(0,ae+1))}(),ve=this.tokenizer.inlineText(qe,He)){se=se.substring(ve.raw.length),ve.raw.slice(-1)!=="_"&&(xe=ve.raw.slice(-1)),lt=!0,Fe=ue[ue.length-1],Fe&&Fe.type==="text"?(Fe.raw+=ve.raw,Fe.text+=ve.text):ue.push(ve);continue}if(se){var be="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(be);break}else throw new Error(be)}}return ue},e(Re,null,[{key:"rules",get:function(){return{block:Pe,inline:Be}}}]),Re}(),ie=S.exports.defaults,ce=B.cleanUrl,Z=B.escape,re=function(){function Re(Te){this.options=Te||ie}var De=Re.prototype;return De.code=function(se,ue,we){var ve=(ue||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(se,ve);Fe!=null&&Fe!==se&&(we=!0,se=Fe)}return se=se.replace(/\n$/,"")+`
`,ve?'<pre><code class="'+this.options.langPrefix+Z(ve,!0)+'">'+(we?se:Z(se,!0))+`</code></pre>
`:"<pre><code>"+(we?se:Z(se,!0))+`</code></pre>
`},De.blockquote=function(se){return`<blockquote>
`+se+`</blockquote>
`},De.html=function(se){return se},De.heading=function(se,ue,we,ve){return this.options.headerIds?"<h"+ue+' id="'+this.options.headerPrefix+ve.slug(we)+'">'+se+"</h"+ue+`>
`:"<h"+ue+">"+se+"</h"+ue+`>
`},De.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},De.list=function(se,ue,we){var ve=ue?"ol":"ul",Fe=ue&&we!==1?' start="'+we+'"':"";return"<"+ve+Fe+`>
`+se+"</"+ve+`>
`},De.listitem=function(se){return"<li>"+se+`</li>
`},De.checkbox=function(se){return"<input "+(se?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},De.paragraph=function(se){return"<p>"+se+`</p>
`},De.table=function(se,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+se+`</thead>
`+ue+`</table>
`},De.tablerow=function(se){return`<tr>
`+se+`</tr>
`},De.tablecell=function(se,ue){var we=ue.header?"th":"td",ve=ue.align?"<"+we+' align="'+ue.align+'">':"<"+we+">";return ve+se+"</"+we+`>
`},De.strong=function(se){return"<strong>"+se+"</strong>"},De.em=function(se){return"<em>"+se+"</em>"},De.codespan=function(se){return"<code>"+se+"</code>"},De.br=function(){return this.options.xhtml?"<br/>":"<br>"},De.del=function(se){return"<del>"+se+"</del>"},De.link=function(se,ue,we){if(se=ce(this.options.sanitize,this.options.baseUrl,se),se===null)return we;var ve='<a href="'+Z(se)+'"';return ue&&(ve+=' title="'+ue+'"'),ve+=">"+we+"</a>",ve},De.image=function(se,ue,we){if(se=ce(this.options.sanitize,this.options.baseUrl,se),se===null)return we;var ve='<img src="'+se+'" alt="'+we+'"';return ue&&(ve+=' title="'+ue+'"'),ve+=this.options.xhtml?"/>":">",ve},De.text=function(se){return se},Re}(),pe=function(){function Re(){}var De=Re.prototype;return De.strong=function(se){return se},De.em=function(se){return se},De.codespan=function(se){return se},De.del=function(se){return se},De.html=function(se){return se},De.text=function(se){return se},De.link=function(se,ue,we){return""+we},De.image=function(se,ue,we){return""+we},De.br=function(){return""},Re}(),Me=function(){function Re(){this.seen={}}var De=Re.prototype;return De.serialize=function(se){return se.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},De.getNextSafeSlug=function(se,ue){var we=se,ve=0;if(this.seen.hasOwnProperty(we)){ve=this.seen[se];do ve++,we=se+"-"+ve;while(this.seen.hasOwnProperty(we))}return ue||(this.seen[se]=ve,this.seen[we]=0),we},De.slug=function(se,ue){ue===void 0&&(ue={});var we=this.serialize(se);return this.getNextSafeSlug(we,ue.dryrun)},Re}(),je=re,Ke=pe,Ze=Me,rt=S.exports.defaults,ct=B.unescape,ye=function(){function Re(Te){this.options=Te||rt,this.options.renderer=this.options.renderer||new je,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Ke,this.slugger=new Ze}Re.parse=function(se,ue){var we=new Re(ue);return we.parse(se)},Re.parseInline=function(se,ue){var we=new Re(ue);return we.parseInline(se)};var De=Re.prototype;return De.parse=function(se,ue){ue===void 0&&(ue=!0);var we="",ve,Fe,qe,ze,Ye,lt,xe,ge,be,ae,K,Se,Le,it,Ge,mt,yt,Et,gt,bt=se.length;for(ve=0;ve<bt;ve++){if(ae=se[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ae.type]&&(gt=this.options.extensions.renderers[ae.type].call({parser:this},ae),gt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ae.type))){we+=gt||"";continue}switch(ae.type){case"space":continue;case"hr":{we+=this.renderer.hr();continue}case"heading":{we+=this.renderer.heading(this.parseInline(ae.tokens),ae.depth,ct(this.parseInline(ae.tokens,this.textRenderer)),this.slugger);continue}case"code":{we+=this.renderer.code(ae.text,ae.lang,ae.escaped);continue}case"table":{for(ge="",xe="",ze=ae.header.length,Fe=0;Fe<ze;Fe++)xe+=this.renderer.tablecell(this.parseInline(ae.header[Fe].tokens),{header:!0,align:ae.align[Fe]});for(ge+=this.renderer.tablerow(xe),be="",ze=ae.rows.length,Fe=0;Fe<ze;Fe++){for(lt=ae.rows[Fe],xe="",Ye=lt.length,qe=0;qe<Ye;qe++)xe+=this.renderer.tablecell(this.parseInline(lt[qe].tokens),{header:!1,align:ae.align[qe]});be+=this.renderer.tablerow(xe)}we+=this.renderer.table(ge,be);continue}case"blockquote":{be=this.parse(ae.tokens),we+=this.renderer.blockquote(be);continue}case"list":{for(K=ae.ordered,Se=ae.start,Le=ae.loose,ze=ae.items.length,be="",Fe=0;Fe<ze;Fe++)Ge=ae.items[Fe],mt=Ge.checked,yt=Ge.task,it="",Ge.task&&(Et=this.renderer.checkbox(mt),Le?Ge.tokens.length>0&&Ge.tokens[0].type==="paragraph"?(Ge.tokens[0].text=Et+" "+Ge.tokens[0].text,Ge.tokens[0].tokens&&Ge.tokens[0].tokens.length>0&&Ge.tokens[0].tokens[0].type==="text"&&(Ge.tokens[0].tokens[0].text=Et+" "+Ge.tokens[0].tokens[0].text)):Ge.tokens.unshift({type:"text",text:Et}):it+=Et),it+=this.parse(Ge.tokens,Le),be+=this.renderer.listitem(it,yt,mt);we+=this.renderer.list(be,K,Se);continue}case"html":{we+=this.renderer.html(ae.text);continue}case"paragraph":{we+=this.renderer.paragraph(this.parseInline(ae.tokens));continue}case"text":{for(be=ae.tokens?this.parseInline(ae.tokens):ae.text;ve+1<bt&&se[ve+1].type==="text";)ae=se[++ve],be+=`
`+(ae.tokens?this.parseInline(ae.tokens):ae.text);we+=ue?this.renderer.paragraph(be):be;continue}default:{var vt='Token with "'+ae.type+'" type was not found.';if(this.options.silent){console.error(vt);return}else throw new Error(vt)}}}return we},De.parseInline=function(se,ue){ue=ue||this.renderer;var we="",ve,Fe,qe,ze=se.length;for(ve=0;ve<ze;ve++){if(Fe=se[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(qe=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),qe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){we+=qe||"";continue}switch(Fe.type){case"escape":{we+=ue.text(Fe.text);break}case"html":{we+=ue.html(Fe.text);break}case"link":{we+=ue.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,ue));break}case"image":{we+=ue.image(Fe.href,Fe.title,Fe.text);break}case"strong":{we+=ue.strong(this.parseInline(Fe.tokens,ue));break}case"em":{we+=ue.em(this.parseInline(Fe.tokens,ue));break}case"codespan":{we+=ue.codespan(Fe.text);break}case"br":{we+=ue.br();break}case"del":{we+=ue.del(this.parseInline(Fe.tokens,ue));break}case"text":{we+=ue.text(Fe.text);break}default:{var Ye='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(Ye);return}else throw new Error(Ye)}}}return we},Re}(),at=ee,J=ye,ne=j,Ee=re,Qe=pe,et=Me,le=B.merge,Ie=B.checkSanitizeDeprecation,Ne=B.escape,Xe=S.exports.getDefaults,nt=S.exports.changeDefaults,ft=S.exports.defaults;function tt(Re,De,Te){if(typeof Re=="undefined"||Re===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Re!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Re)+", string expected");if(typeof De=="function"&&(Te=De,De=null),De=le({},tt.defaults,De||{}),Ie(De),Te){var se=De.highlight,ue;try{ue=at.lex(Re,De)}catch(qe){return Te(qe)}var we=function(ze){var Ye;if(!ze)try{De.walkTokens&&tt.walkTokens(ue,De.walkTokens),Ye=J.parse(ue,De)}catch(lt){ze=lt}return De.highlight=se,ze?Te(ze):Te(null,Ye)};if(!se||se.length<3||(delete De.highlight,!ue.length))return we();var ve=0;tt.walkTokens(ue,function(qe){qe.type==="code"&&(ve++,setTimeout(function(){se(qe.text,qe.lang,function(ze,Ye){if(ze)return we(ze);Ye!=null&&Ye!==qe.text&&(qe.text=Ye,qe.escaped=!0),ve--,ve===0&&we()})},0))}),ve===0&&we();return}try{var Fe=at.lex(Re,De);return De.walkTokens&&tt.walkTokens(Fe,De.walkTokens),J.parse(Fe,De)}catch(qe){if(qe.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+Ne(qe.message+"",!0)+"</pre>";throw qe}}tt.options=tt.setOptions=function(Re){return le(tt.defaults,Re),nt(tt.defaults),tt},tt.getDefaults=Xe,tt.defaults=ft,tt.use=function(){for(var Re=this,De=arguments.length,Te=new Array(De),se=0;se<De;se++)Te[se]=arguments[se];var ue=le.apply(void 0,[{}].concat(Te)),we=tt.defaults.extensions||{renderers:{},childTokens:{}},ve;Te.forEach(function(Fe){if(Fe.extensions&&(ve=!0,Fe.extensions.forEach(function(ze){if(!ze.name)throw new Error("extension name required");if(ze.renderer){var Ye=we.renderers?we.renderers[ze.name]:null;Ye?we.renderers[ze.name]=function(){for(var lt=arguments.length,xe=new Array(lt),ge=0;ge<lt;ge++)xe[ge]=arguments[ge];var be=ze.renderer.apply(this,xe);return be===!1&&(be=Ye.apply(this,xe)),be}:we.renderers[ze.name]=ze.renderer}if(ze.tokenizer){if(!ze.level||ze.level!=="block"&&ze.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");we[ze.level]?we[ze.level].unshift(ze.tokenizer):we[ze.level]=[ze.tokenizer],ze.start&&(ze.level==="block"?we.startBlock?we.startBlock.push(ze.start):we.startBlock=[ze.start]:ze.level==="inline"&&(we.startInline?we.startInline.push(ze.start):we.startInline=[ze.start]))}ze.childTokens&&(we.childTokens[ze.name]=ze.childTokens)})),Fe.renderer&&function(){var ze=tt.defaults.renderer||new Ee,Ye=function(ge){var be=ze[ge];ze[ge]=function(){for(var ae=arguments.length,K=new Array(ae),Se=0;Se<ae;Se++)K[Se]=arguments[Se];var Le=Fe.renderer[ge].apply(ze,K);return Le===!1&&(Le=be.apply(ze,K)),Le}};for(var lt in Fe.renderer)Ye(lt);ue.renderer=ze}(),Fe.tokenizer&&function(){var ze=tt.defaults.tokenizer||new ne,Ye=function(ge){var be=ze[ge];ze[ge]=function(){for(var ae=arguments.length,K=new Array(ae),Se=0;Se<ae;Se++)K[Se]=arguments[Se];var Le=Fe.tokenizer[ge].apply(ze,K);return Le===!1&&(Le=be.apply(ze,K)),Le}};for(var lt in Fe.tokenizer)Ye(lt);ue.tokenizer=ze}(),Fe.walkTokens){var qe=tt.defaults.walkTokens;ue.walkTokens=function(ze){Fe.walkTokens.call(Re,ze),qe&&qe(ze)}}ve&&(ue.extensions=we),tt.setOptions(ue)})},tt.walkTokens=function(Re,De){for(var Te=function(){var ve=ue.value;switch(De(ve),ve.type){case"table":{for(var Fe=D(ve.header),qe;!(qe=Fe()).done;){var ze=qe.value;tt.walkTokens(ze.tokens,De)}for(var Ye=D(ve.rows),lt;!(lt=Ye()).done;)for(var xe=lt.value,ge=D(xe),be;!(be=ge()).done;){var ae=be.value;tt.walkTokens(ae.tokens,De)}break}case"list":{tt.walkTokens(ve.items,De);break}default:tt.defaults.extensions&&tt.defaults.extensions.childTokens&&tt.defaults.extensions.childTokens[ve.type]?tt.defaults.extensions.childTokens[ve.type].forEach(function(K){tt.walkTokens(ve[K],De)}):ve.tokens&&tt.walkTokens(ve.tokens,De)}},se=D(Re),ue;!(ue=se()).done;)Te()},tt.parseInline=function(Re,De){if(typeof Re=="undefined"||Re===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Re!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Re)+", string expected");De=le({},tt.defaults,De||{}),Ie(De);try{var Te=at.lexInline(Re,De);return De.walkTokens&&tt.walkTokens(Te,De.walkTokens),J.parseInline(Te,De)}catch(se){if(se.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+Ne(se.message+"",!0)+"</pre>";throw se}},tt.Parser=J,tt.parser=J.parse,tt.Renderer=Ee,tt.TextRenderer=Qe,tt.Lexer=at,tt.lexer=at.lex,tt.Tokenizer=ne,tt.Slugger=et,tt.parse=tt;var ut=tt;return ut}),define(fe[79],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function g(T,C,E){return Math.min(Math.max(T,C),E)}e.clamp=g;function L(T,C){return(C+T%C)%C}e.rot=L;class D{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=D;class S{constructor(){this._n=1,this._val=0}update(C){return this._val=this._val+(C-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=S}),function(){function Y(D){const S=[];typeof D=="number"&&S.push("code/timeOrigin",D);function T(E){S.push(E,Date.now())}function C(){const E=[];for(let k=0;k<S.length;k+=2)E.push({name:S[k],startTime:S[k+1]});return E}return{mark:T,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const S=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const T of performance.getEntriesByType("mark"))S.push({name:T.name,startTime:Math.round(D+T.startTime)});return S}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function g(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return g(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=g(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=g(L))}(),define(fe[12],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const g="en";let L=!1,D=!1,S=!1,T=!1,C=!1,E=!1,k=!1,i,I=g,a,p;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?h=e.globals.vscode.process:typeof process!="undefined"&&(h=process);const w=typeof h?.versions?.electron=="string"&&h.type==="renderer";if(e.isElectronSandboxed=w&&h?.sandboxed,typeof navigator=="object"&&!w)p=navigator.userAgent,L=p.indexOf("Windows")>=0,D=p.indexOf("Macintosh")>=0,k=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,S=p.indexOf("Linux")>=0,E=!0,i=navigator.language,I=i;else if(typeof h=="object"){L=h.platform==="win32",D=h.platform==="darwin",S=h.platform==="linux",T=S&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,i=g,I=g;const r=h.env.VSCODE_NLS_CONFIG;if(r)try{const t=JSON.parse(r),u=t.availableLanguages["*"];i=t.locale,I=u||g,a=t._translationsConfigFile}catch(t){}C=!0}else console.error("Unable to resolve platform.");var y;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(y=e.Platform||(e.Platform={}));function P(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=P;let b=0;D?b=1:L?b=3:S&&(b=2),e.isWindows=L,e.isMacintosh=D,e.isLinux=S,e.isLinuxSnap=T,e.isNative=C,e.isWeb=E,e.isIOS=k,e.platform=b,e.userAgent=p,e.language=I;var o;(function(r){function t(){return e.language}r.value=t;function u(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=u;function l(){return e.language==="en"}r.isDefault=l})(o=e.Language||(e.Language={})),e.locale=i,e.translationsConfigFile=a,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let u=[];e.globals.addEventListener("message",c=>{if(c.data&&c.data.vscodeSetImmediateId)for(let m=0,d=u.length;m<d;m++){const _=u[m];if(_.id===c.data.vscodeSetImmediateId){u.splice(m,1),_.callback();return}}});let l=0;return c=>{const m=++l;u.push({id:m,callback:c}),e.globals.postMessage({vscodeSetImmediateId:m},"*")}}if(typeof h?.nextTick=="function")return h.nextTick.bind(h);const t=Promise.resolve();return u=>t.then(u)}();var s;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(s=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||k?2:L?1:3;let v=!0,n=!1;function f(){if(!n){n=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,v=new Uint16Array(r.buffer)[0]===(2<<8)+1}return v}e.isLittleEndian=f}),define(fe[38],me([0,1,12]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof g.globals.vscode!="undefined"&&typeof g.globals.vscode.process!="undefined"){const D=g.globals.vscode.process;L={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()},nextTick(S){return(0,g.setImmediate)(S)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(D){return process.nextTick(D)}}:L={get platform(){return g.isWindows?"win32":g.isMacintosh?"darwin":"linux"},get arch(){},nextTick(D){return(0,g.setImmediate)(D)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick,e.arch=L.arch}),define(fe[9],me([0,1,38]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,D=97,S=90,T=122,C=46,E=47,k=92,i=58,I=63;class a extends Error{constructor(s,v,n){let f;typeof v=="string"&&v.indexOf("not ")===0?(f="must not be",v=v.replace(/^not /,"")):f="must be";const r=s.indexOf(".")!==-1?"property":"argument";let t=`The "${s}" ${r} ${f} of type ${v}`;t+=`. Received type ${typeof n}`,super(t),this.code="ERR_INVALID_ARG_TYPE"}}function p(o,s){if(typeof o!="string")throw new a(s,"string",o)}function h(o){return o===E||o===k}function w(o){return o===E}function y(o){return o>=L&&o<=S||o>=D&&o<=T}function P(o,s,v,n){let f="",r=0,t=-1,u=0,l=0;for(let c=0;c<=o.length;++c){if(c<o.length)l=o.charCodeAt(c);else{if(n(l))break;l=E}if(n(l)){if(!(t===c-1||u===1))if(u===2){if(f.length<2||r!==2||f.charCodeAt(f.length-1)!==C||f.charCodeAt(f.length-2)!==C){if(f.length>2){const m=f.lastIndexOf(v);m===-1?(f="",r=0):(f=f.slice(0,m),r=f.length-1-f.lastIndexOf(v)),t=c,u=0;continue}else if(f.length!==0){f="",r=0,t=c,u=0;continue}}s&&(f+=f.length>0?`${v}..`:"..",r=2)}else f.length>0?f+=`${v}${o.slice(t+1,c)}`:f=o.slice(t+1,c),r=c-t-1;t=c,u=0}else l===C&&u!==-1?++u:u=-1}return f}function b(o,s){if(s===null||typeof s!="object")throw new a("pathObject","Object",s);const v=s.dir||s.root,n=s.base||`${s.name||""}${s.ext||""}`;return v?v===s.root?`${v}${n}`:`${v}${o}${n}`:n}e.win32={resolve(...o){let s="",v="",n=!1;for(let f=o.length-1;f>=-1;f--){let r;if(f>=0){if(r=o[f],p(r,"path"),r.length===0)continue}else s.length===0?r=g.cwd():(r=g.env[`=${s}`]||g.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==s.toLowerCase()&&r.charCodeAt(2)===k)&&(r=`${s}\\`));const t=r.length;let u=0,l="",c=!1;const m=r.charCodeAt(0);if(t===1)h(m)&&(u=1,c=!0);else if(h(m))if(c=!0,h(r.charCodeAt(1))){let d=2,_=d;for(;d<t&&!h(r.charCodeAt(d));)d++;if(d<t&&d!==_){const A=r.slice(_,d);for(_=d;d<t&&h(r.charCodeAt(d));)d++;if(d<t&&d!==_){for(_=d;d<t&&!h(r.charCodeAt(d));)d++;(d===t||d!==_)&&(l=`\\\\${A}\\${r.slice(_,d)}`,u=d)}}}else u=1;else y(m)&&r.charCodeAt(1)===i&&(l=r.slice(0,2),u=2,t>2&&h(r.charCodeAt(2))&&(c=!0,u=3));if(l.length>0)if(s.length>0){if(l.toLowerCase()!==s.toLowerCase())continue}else s=l;if(n){if(s.length>0)break}else if(v=`${r.slice(u)}\\${v}`,n=c,c&&s.length>0)break}return v=P(v,!n,"\\",h),n?`${s}\\${v}`:`${s}${v}`||"."},normalize(o){p(o,"path");const s=o.length;if(s===0)return".";let v=0,n,f=!1;const r=o.charCodeAt(0);if(s===1)return w(r)?"\\":o;if(h(r))if(f=!0,h(o.charCodeAt(1))){let u=2,l=u;for(;u<s&&!h(o.charCodeAt(u));)u++;if(u<s&&u!==l){const c=o.slice(l,u);for(l=u;u<s&&h(o.charCodeAt(u));)u++;if(u<s&&u!==l){for(l=u;u<s&&!h(o.charCodeAt(u));)u++;if(u===s)return`\\\\${c}\\${o.slice(l)}\\`;u!==l&&(n=`\\\\${c}\\${o.slice(l,u)}`,v=u)}}}else v=1;else y(r)&&o.charCodeAt(1)===i&&(n=o.slice(0,2),v=2,s>2&&h(o.charCodeAt(2))&&(f=!0,v=3));let t=v<s?P(o.slice(v),!f,"\\",h):"";return t.length===0&&!f&&(t="."),t.length>0&&h(o.charCodeAt(s-1))&&(t+="\\"),n===void 0?f?`\\${t}`:t:f?`${n}\\${t}`:`${n}${t}`},isAbsolute(o){p(o,"path");const s=o.length;if(s===0)return!1;const v=o.charCodeAt(0);return h(v)||s>2&&y(v)&&o.charCodeAt(1)===i&&h(o.charCodeAt(2))},join(...o){if(o.length===0)return".";let s,v;for(let r=0;r<o.length;++r){const t=o[r];p(t,"path"),t.length>0&&(s===void 0?s=v=t:s+=`\\${t}`)}if(s===void 0)return".";let n=!0,f=0;if(typeof v=="string"&&h(v.charCodeAt(0))){++f;const r=v.length;r>1&&h(v.charCodeAt(1))&&(++f,r>2&&(h(v.charCodeAt(2))?++f:n=!1))}if(n){for(;f<s.length&&h(s.charCodeAt(f));)f++;f>=2&&(s=`\\${s.slice(f)}`)}return e.win32.normalize(s)},relative(o,s){if(p(o,"from"),p(s,"to"),o===s)return"";const v=e.win32.resolve(o),n=e.win32.resolve(s);if(v===n||(o=v.toLowerCase(),s=n.toLowerCase(),o===s))return"";let f=0;for(;f<o.length&&o.charCodeAt(f)===k;)f++;let r=o.length;for(;r-1>f&&o.charCodeAt(r-1)===k;)r--;const t=r-f;let u=0;for(;u<s.length&&s.charCodeAt(u)===k;)u++;let l=s.length;for(;l-1>u&&s.charCodeAt(l-1)===k;)l--;const c=l-u,m=t<c?t:c;let d=-1,_=0;for(;_<m;_++){const R=o.charCodeAt(f+_);if(R!==s.charCodeAt(u+_))break;R===k&&(d=_)}if(_!==m){if(d===-1)return n}else{if(c>m){if(s.charCodeAt(u+_)===k)return n.slice(u+_+1);if(_===2)return n.slice(u+_)}t>m&&(o.charCodeAt(f+_)===k?d=_:_===2&&(d=3)),d===-1&&(d=0)}let A="";for(_=f+d+1;_<=r;++_)(_===r||o.charCodeAt(_)===k)&&(A+=A.length===0?"..":"\\..");return u+=d,A.length>0?`${A}${n.slice(u,l)}`:(n.charCodeAt(u)===k&&++u,n.slice(u,l))},toNamespacedPath(o){if(typeof o!="string")return o;if(o.length===0)return"";const s=e.win32.resolve(o);if(s.length<=2)return o;if(s.charCodeAt(0)===k){if(s.charCodeAt(1)===k){const v=s.charCodeAt(2);if(v!==I&&v!==C)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(y(s.charCodeAt(0))&&s.charCodeAt(1)===i&&s.charCodeAt(2)===k)return`\\\\?\\${s}`;return o},dirname(o){p(o,"path");const s=o.length;if(s===0)return".";let v=-1,n=0;const f=o.charCodeAt(0);if(s===1)return h(f)?o:".";if(h(f)){if(v=n=1,h(o.charCodeAt(1))){let u=2,l=u;for(;u<s&&!h(o.charCodeAt(u));)u++;if(u<s&&u!==l){for(l=u;u<s&&h(o.charCodeAt(u));)u++;if(u<s&&u!==l){for(l=u;u<s&&!h(o.charCodeAt(u));)u++;if(u===s)return o;u!==l&&(v=n=u+1)}}}}else y(f)&&o.charCodeAt(1)===i&&(v=s>2&&h(o.charCodeAt(2))?3:2,n=v);let r=-1,t=!0;for(let u=s-1;u>=n;--u)if(h(o.charCodeAt(u))){if(!t){r=u;break}}else t=!1;if(r===-1){if(v===-1)return".";r=v}return o.slice(0,r)},basename(o,s){s!==void 0&&p(s,"ext"),p(o,"path");let v=0,n=-1,f=!0,r;if(o.length>=2&&y(o.charCodeAt(0))&&o.charCodeAt(1)===i&&(v=2),s!==void 0&&s.length>0&&s.length<=o.length){if(s===o)return"";let t=s.length-1,u=-1;for(r=o.length-1;r>=v;--r){const l=o.charCodeAt(r);if(h(l)){if(!f){v=r+1;break}}else u===-1&&(f=!1,u=r+1),t>=0&&(l===s.charCodeAt(t)?--t==-1&&(n=r):(t=-1,n=u))}return v===n?n=u:n===-1&&(n=o.length),o.slice(v,n)}for(r=o.length-1;r>=v;--r)if(h(o.charCodeAt(r))){if(!f){v=r+1;break}}else n===-1&&(f=!1,n=r+1);return n===-1?"":o.slice(v,n)},extname(o){p(o,"path");let s=0,v=-1,n=0,f=-1,r=!0,t=0;o.length>=2&&o.charCodeAt(1)===i&&y(o.charCodeAt(0))&&(s=n=2);for(let u=o.length-1;u>=s;--u){const l=o.charCodeAt(u);if(h(l)){if(!r){n=u+1;break}continue}f===-1&&(r=!1,f=u+1),l===C?v===-1?v=u:t!==1&&(t=1):v!==-1&&(t=-1)}return v===-1||f===-1||t===0||t===1&&v===f-1&&v===n+1?"":o.slice(v,f)},format:b.bind(null,"\\"),parse(o){p(o,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return s;const v=o.length;let n=0,f=o.charCodeAt(0);if(v===1)return h(f)?(s.root=s.dir=o,s):(s.base=s.name=o,s);if(h(f)){if(n=1,h(o.charCodeAt(1))){let d=2,_=d;for(;d<v&&!h(o.charCodeAt(d));)d++;if(d<v&&d!==_){for(_=d;d<v&&h(o.charCodeAt(d));)d++;if(d<v&&d!==_){for(_=d;d<v&&!h(o.charCodeAt(d));)d++;d===v?n=d:d!==_&&(n=d+1)}}}}else if(y(f)&&o.charCodeAt(1)===i){if(v<=2)return s.root=s.dir=o,s;if(n=2,h(o.charCodeAt(2))){if(v===3)return s.root=s.dir=o,s;n=3}}n>0&&(s.root=o.slice(0,n));let r=-1,t=n,u=-1,l=!0,c=o.length-1,m=0;for(;c>=n;--c){if(f=o.charCodeAt(c),h(f)){if(!l){t=c+1;break}continue}u===-1&&(l=!1,u=c+1),f===C?r===-1?r=c:m!==1&&(m=1):r!==-1&&(m=-1)}return u!==-1&&(r===-1||m===0||m===1&&r===u-1&&r===t+1?s.base=s.name=o.slice(t,u):(s.name=o.slice(t,r),s.base=o.slice(t,u),s.ext=o.slice(r,u))),t>0&&t!==n?s.dir=o.slice(0,t-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...o){let s="",v=!1;for(let n=o.length-1;n>=-1&&!v;n--){const f=n>=0?o[n]:g.cwd();p(f,"path"),f.length!==0&&(s=`${f}/${s}`,v=f.charCodeAt(0)===E)}return s=P(s,!v,"/",w),v?`/${s}`:s.length>0?s:"."},normalize(o){if(p(o,"path"),o.length===0)return".";const s=o.charCodeAt(0)===E,v=o.charCodeAt(o.length-1)===E;return o=P(o,!s,"/",w),o.length===0?s?"/":v?"./":".":(v&&(o+="/"),s?`/${o}`:o)},isAbsolute(o){return p(o,"path"),o.length>0&&o.charCodeAt(0)===E},join(...o){if(o.length===0)return".";let s;for(let v=0;v<o.length;++v){const n=o[v];p(n,"path"),n.length>0&&(s===void 0?s=n:s+=`/${n}`)}return s===void 0?".":e.posix.normalize(s)},relative(o,s){if(p(o,"from"),p(s,"to"),o===s||(o=e.posix.resolve(o),s=e.posix.resolve(s),o===s))return"";const v=1,n=o.length,f=n-v,r=1,t=s.length-r,u=f<t?f:t;let l=-1,c=0;for(;c<u;c++){const d=o.charCodeAt(v+c);if(d!==s.charCodeAt(r+c))break;d===E&&(l=c)}if(c===u)if(t>u){if(s.charCodeAt(r+c)===E)return s.slice(r+c+1);if(c===0)return s.slice(r+c)}else f>u&&(o.charCodeAt(v+c)===E?l=c:c===0&&(l=0));let m="";for(c=v+l+1;c<=n;++c)(c===n||o.charCodeAt(c)===E)&&(m+=m.length===0?"..":"/..");return`${m}${s.slice(r+l)}`},toNamespacedPath(o){return o},dirname(o){if(p(o,"path"),o.length===0)return".";const s=o.charCodeAt(0)===E;let v=-1,n=!0;for(let f=o.length-1;f>=1;--f)if(o.charCodeAt(f)===E){if(!n){v=f;break}}else n=!1;return v===-1?s?"/":".":s&&v===1?"//":o.slice(0,v)},basename(o,s){s!==void 0&&p(s,"ext"),p(o,"path");let v=0,n=-1,f=!0,r;if(s!==void 0&&s.length>0&&s.length<=o.length){if(s===o)return"";let t=s.length-1,u=-1;for(r=o.length-1;r>=0;--r){const l=o.charCodeAt(r);if(l===E){if(!f){v=r+1;break}}else u===-1&&(f=!1,u=r+1),t>=0&&(l===s.charCodeAt(t)?--t==-1&&(n=r):(t=-1,n=u))}return v===n?n=u:n===-1&&(n=o.length),o.slice(v,n)}for(r=o.length-1;r>=0;--r)if(o.charCodeAt(r)===E){if(!f){v=r+1;break}}else n===-1&&(f=!1,n=r+1);return n===-1?"":o.slice(v,n)},extname(o){p(o,"path");let s=-1,v=0,n=-1,f=!0,r=0;for(let t=o.length-1;t>=0;--t){const u=o.charCodeAt(t);if(u===E){if(!f){v=t+1;break}continue}n===-1&&(f=!1,n=t+1),u===C?s===-1?s=t:r!==1&&(r=1):s!==-1&&(r=-1)}return s===-1||n===-1||r===0||r===1&&s===n-1&&s===v+1?"":o.slice(s,n)},format:b.bind(null,"/"),parse(o){p(o,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return s;const v=o.charCodeAt(0)===E;let n;v?(s.root="/",n=1):n=0;let f=-1,r=0,t=-1,u=!0,l=o.length-1,c=0;for(;l>=n;--l){const m=o.charCodeAt(l);if(m===E){if(!u){r=l+1;break}continue}t===-1&&(u=!1,t=l+1),m===C?f===-1?f=l:c!==1&&(c=1):f!==-1&&(c=-1)}if(t!==-1){const m=r===0&&v?1:r;f===-1||c===0||c===1&&f===t-1&&f===r+1?s.base=s.name=o.slice(m,t):(s.name=o.slice(m,f),s.base=o.slice(m,t),s.ext=o.slice(f,t))}return r>0?s.dir=o.slice(0,r-1):v&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=g.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=g.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=g.platform==="win32"?e.win32.join:e.posix.join,e.resolve=g.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=g.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=g.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=g.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=g.platform==="win32"?e.win32.extname:e.posix.extname,e.format=g.platform==="win32"?e.win32.format:e.posix.format,e.parse=g.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=g.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=g.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=g.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(fe[95],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var g;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(g=e.Source||(e.Source={}));var L;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(S,...T){const C=T.reduce((i,I)=>(i[I]=!0,i),{}),E=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(i=>!C[i]).forEach(i=>{for(let I=0;I<E.length;I++)if(i.search(E[I])!==-1){delete S[i];break}})}e.sanitizeProcessEnvironment=D}),define(fe[47],me([0,1,12]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=g.globals.performance&&typeof g.globals.performance.now=="function";class D{constructor(T){this._highResolution=L&&T,this._startTime=this._now(),this._stopTime=-1}static create(T=!0){return new D(T)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?g.globals.performance.now():Date.now()}}e.StopWatch=D}),define(fe[3],me([0,1,18,76,6,94,47]),function(Y,e,g,L,D,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var C;(function(s){s.None=()=>D.Disposable.None;function v(M){return(z,N=null,x)=>{let j=!1,O;return O=M(H=>{if(!j)return O?O.dispose():j=!0,z.call(N,H)},null,x),j&&O.dispose(),O}}s.once=v;function n(M,z){return c((N,x=null,j)=>M(O=>N.call(x,z(O)),null,j))}s.map=n;function f(M,z){return c((N,x=null,j)=>M(O=>{z(O),N.call(x,O)},null,j))}s.forEach=f;function r(M,z){return c((N,x=null,j)=>M(O=>z(O)&&N.call(x,O),null,j))}s.filter=r;function t(M){return M}s.signal=t;function u(...M){return(z,N=null,x)=>(0,D.combinedDisposable)(...M.map(j=>j(O=>z.call(N,O),null,x)))}s.any=u;function l(M,z,N){let x=N;return n(M,j=>(x=z(x,j),x))}s.reduce=l;function c(M){let z;const N=new a({onFirstListenerAdd(){z=M(N.fire,N)},onLastListenerRemove(){z.dispose()}});return N.event}function m(M,z,N=100,x=!1,j){let O,H,W,X=0;const Q=new a({leakWarningThreshold:j,onFirstListenerAdd(){O=M(de=>{X++,H=z(H,de),x&&!W&&(Q.fire(H),H=void 0),clearTimeout(W),W=setTimeout(()=>{const _e=H;H=void 0,W=void 0,(!x||X>1)&&Q.fire(_e),X=0},N)})},onLastListenerRemove(){O.dispose()}});return Q.event}s.debounce=m;function d(M,z=(N,x)=>N===x){let N=!0,x;return r(M,j=>{const O=N||!z(j,x);return N=!1,x=j,O})}s.latch=d;function _(M,z){return[s.filter(M,z),s.filter(M,N=>!z(N))]}s.split=_;function A(M,z=!1,N=[]){let x=N.slice(),j=M(W=>{x?x.push(W):H.fire(W)});const O=()=>{x&&x.forEach(W=>H.fire(W)),x=null},H=new a({onFirstListenerAdd(){j||(j=M(W=>H.fire(W)))},onFirstListenerDidAdd(){x&&(z?setTimeout(O):O())},onLastListenerRemove(){j&&j.dispose(),j=null}});return H.event}s.buffer=A;class R{constructor(z){this.event=z}map(z){return new R(n(this.event,z))}forEach(z){return new R(f(this.event,z))}filter(z){return new R(r(this.event,z))}reduce(z,N){return new R(l(this.event,z,N))}latch(){return new R(d(this.event))}debounce(z,N=100,x=!1,j){return new R(m(this.event,z,N,x,j))}on(z,N,x){return this.event(z,N,x)}once(z,N,x){return v(this.event)(z,N,x)}}function B(M){return new R(M)}s.chain=B;function U(M,z,N=x=>x){const x=(...W)=>H.fire(N(...W)),j=()=>M.on(z,x),O=()=>M.removeListener(z,x),H=new a({onFirstListenerAdd:j,onLastListenerRemove:O});return H.event}s.fromNodeEventEmitter=U;function F(M,z,N=x=>x){const x=(...W)=>H.fire(N(...W)),j=()=>M.addEventListener(z,x),O=()=>M.removeEventListener(z,x),H=new a({onFirstListenerAdd:j,onLastListenerRemove:O});return H.event}s.fromDOMEventEmitter=F;function $(M){return new Promise(z=>v(M)(z))}s.toPromise=$})(C=e.Event||(e.Event={}));class E{constructor(v){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${v}_${E._idPool++}`}start(v){this._stopWatch=new T.StopWatch(!0),this._listenerCount=v}stop(){if(this._stopWatch){const v=this._stopWatch.elapsed();this._elapsedOverall+=v,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${v.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}E._idPool=0;let k=-1;function i(s){const v=k;return k=s,{dispose(){k=v}}}e.setGlobalLeakWarningThreshold=i;class I{constructor(v,n=Math.random().toString(18).slice(2,5)){this.customThreshold=v,this.name=n,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(v){let n=k;if(typeof this.customThreshold=="number"&&(n=this.customThreshold),n<=0||v<n)return;this._stacks||(this._stacks=new Map);const f=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(f)||0;if(this._stacks.set(f,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=n*.5;let t,u=0;for(const[l,c]of this._stacks)(!t||u<c)&&(t=l,u=c);console.warn(`[${this.name}] potential listener LEAK detected, having ${v} listeners already. MOST frequent listener (${u}):`),console.warn(t)}return()=>{const t=this._stacks.get(f)||0;this._stacks.set(f,t-1)}}}class a{constructor(v){this._disposed=!1,this._options=v,this._leakageMon=k>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new E(this._options._profName):void 0}get event(){return this._event||(this._event=(v,n,f)=>{this._listeners||(this._listeners=new S.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const t=this._listeners.push(n?[v,n]:v);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,v,n);const u=this._leakageMon?.check(this._listeners.size),l=(0,D.toDisposable)(()=>{u&&u(),this._disposed||(t(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return f instanceof D.DisposableStore?f.add(l):Array.isArray(f)&&f.push(l),l}),this._event}fire(v){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new S.LinkedList);for(let n of this._listeners)this._deliveryQueue.push([n,v]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[n,f]=this._deliveryQueue.shift();try{typeof n=="function"?n.call(void 0,f):n[0].call(n[1],f)}catch(r){(0,g.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=a;class p extends a{async fireAsync(v,n,f){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new S.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,v]);for(;this._asyncDeliveryQueue.size>0&&!n.isCancellationRequested;){const[r,t]=this._asyncDeliveryQueue.shift(),u=[],l={...t,waitUntil:c=>{if(Object.isFrozen(u))throw new Error("waitUntil can NOT be called asynchronous");f&&(c=f(c,typeof r=="function"?r:r[0])),u.push(c)}};try{typeof r=="function"?r.call(void 0,l):r[0].call(r[1],l)}catch(c){(0,g.onUnexpectedError)(c);continue}Object.freeze(u),await Promise.allSettled(u).then(c=>{for(const m of c)m.status==="rejected"&&(0,g.onUnexpectedError)(m.reason)})}}}}e.AsyncEmitter=p;class h extends a{constructor(v){super(v);this._isPaused=0,this._eventQueue=new S.LinkedList,this._mergeFn=v?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const v=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(v))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(v){this._listeners&&(this._isPaused!==0?this._eventQueue.push(v):super.fire(v))}}e.PauseableEmitter=h;class w extends h{constructor(v){super(v);this._delay=v.delay??100}fire(v){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(v)}}e.DebounceEmitter=w;class y extends a{constructor(v){super(v);this._queuedEvents=[],this._mergeFn=v?.merge}fire(v){this._queuedEvents.push(v),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(n=>super.fire(n)),this._queuedEvents=[]})}}e.MicrotaskEmitter=y;class P{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new a({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(v){const n={event:v,listener:null};this.events.push(n),this.hasListeners&&this.hook(n);const f=()=>{this.hasListeners&&this.unhook(n);const r=this.events.indexOf(n);this.events.splice(r,1)};return(0,D.toDisposable)((0,L.once)(f))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(v=>this.hook(v))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(v=>this.unhook(v))}hook(v){v.listener=v.event(n=>this.emitter.fire(n))}unhook(v){v.listener&&v.listener.dispose(),v.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=P;class b{constructor(){this.buffers=[]}wrapEvent(v){return(n,f,r)=>v(t=>{const u=this.buffers[this.buffers.length-1];u?u.push(()=>n.call(f,t)):n.call(f,t)},void 0,r)}bufferEvents(v){const n=[];this.buffers.push(n);const f=v();return this.buffers.pop(),n.forEach(r=>r()),f}}e.EventBufferer=b;class o{constructor(){this.listening=!1,this.inputEvent=C.None,this.inputEventListener=D.Disposable.None,this.emitter=new a({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(v){this.inputEvent=v,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=v(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=o}),define(fe[21],me([0,1,3]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(C,E){const k=setTimeout(C.bind(E),0);return{dispose(){clearTimeout(k)}}});var D;(function(C){function E(k){return k===C.None||k===C.Cancelled||k instanceof S?!0:!k||typeof k!="object"?!1:typeof k.isCancellationRequested=="boolean"&&typeof k.onCancellationRequested=="function"}C.isCancellationToken=E,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:g.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(D=e.CancellationToken||(e.CancellationToken={}));class S{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new g.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(E){this._token=void 0,this._parentListener=void 0,this._parentListener=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new S),this._token}cancel(){this._token?this._token instanceof S&&this._token.cancel():this._token=D.Cancelled}dispose(E=!1){E&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof S&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=T}),define(fe[48],me([0,1,3]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new g.Emitter}add(I){const a=this._icons.get(I.id);a?I.description?a.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const D=new L;e.iconRegistry=D;function S(i,I){return new C(i,I)}e.registerCodicon=S;function T(i){return i?i.replace(/\$\((.*?)\)/g,(I,a)=>` ${a} `).trim():""}e.getCodiconAriaLabel=T;class C{constructor(I,a,p){this.id=I,this.definition=a,this.description=p,D.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=C;function E(i,I){const a=["codicon","codicon-"+i];return I&&a.push("codicon-modifier-"+I),a}e.getClassNamesArray=E;var k;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+",i.iconNameCharacter="[A-Za-z0-9\\-~]";const I=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function a(w){if(w instanceof C)return["codicon","codicon-"+w.id];const y=I.exec(w.id);if(!y)return a(C.error);let[,P,b]=y;const o=["codicon","codicon-"+P];return b&&o.push("codicon-modifier-"+b.substr(1)),o}i.asClassNameArray=a;function p(w){return a(w).join(" ")}i.asClassName=p;function h(w){return"."+a(w).join(".")}i.asCSSSelector=h})(k=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"})}(C=e.Codicon||(e.Codicon={}))}),define(fe[96],me([0,1,18,6]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(o){const s=o;return s?[s.on,s.pause,s.resume,s.destroy].every(v=>typeof v=="function"):!1}e.isReadableStream=D;function S(o){const s=o;return s?D(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}e.isReadableBufferedStream=S;function T(o,s){return new C(o,s)}e.newWriteableStream=T;class C{constructor(s,v){this.reducer=s,this.options=v,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(v=>this.pendingWritePromises.push(v))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s!="undefined"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(v=>v(s))}emitError(s){this.listeners.error.length===0?(0,g.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(v=>v(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,v){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(v),this.resume();break;case"end":this.listeners.end.push(v),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(v),this.state.flowing&&this.flowErrors();break}}removeListener(s,v){if(this.state.destroyed)return;let n;switch(s){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const f=n.indexOf(v);f>=0&&n.splice(f,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const v=[...this.pendingWritePromises];this.pendingWritePromises.length=0,v.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function E(o,s){const v=[];let n;for(;(n=o.read())!==null;)v.push(n);return s(v)}e.consumeReadable=E;function k(o,s,v){const n=[];let f;for(;(f=o.read())!==null&&n.length<v;)n.push(f);return f===null&&n.length>0?s(n):{read:()=>{if(n.length>0)return n.shift();if(typeof f!="undefined"){const r=f;return f=void 0,r}return o.read()}}}e.peekReadable=k;function i(o,s){return new Promise((v,n)=>{const f=[];I(o,{onData:r=>{s&&f.push(r)},onError:r=>{s?n(r):v(void 0)},onEnd:()=>{v(s?s(f):void 0)}})})}e.consumeStream=i;function I(o,s){o.on("error",v=>s.onError(v)),o.on("end",()=>s.onEnd()),o.on("data",v=>s.onData(v))}e.listenStream=I;function a(o,s){return new Promise((v,n)=>{const f=new L.DisposableStore,r=[],t=c=>{if(r.push(c),r.length>s)return f.dispose(),o.pause(),v({stream:o,buffer:r,ended:!1})},u=c=>n(c),l=()=>v({stream:o,buffer:r,ended:!0});f.add((0,L.toDisposable)(()=>o.removeListener("error",u))),o.on("error",u),f.add((0,L.toDisposable)(()=>o.removeListener("end",l))),o.on("end",l),f.add((0,L.toDisposable)(()=>o.removeListener("data",t))),o.on("data",t)})}e.peekStream=a;function p(o,s){const v=T(s);return v.end(o),v}e.toStream=p;function h(){const o=T(()=>{throw new Error("not supported")});return o.end(),o}e.emptyStream=h;function w(o){let s=!1;return{read:()=>s?null:(s=!0,o)}}e.toReadable=w;function y(o,s,v){const n=T(v);return I(o,{onData:f=>n.write(s.data(f)),onError:f=>n.error(s.error?s.error(f):f),onEnd:()=>n.end()}),n}e.transform=y;function P(o,s,v){let n=!1;return{read:()=>{const f=s.read();return n?f:(n=!0,f!==null?v([o,f]):o)}}}e.prefixedReadable=P;function b(o,s,v){let n=!1;const f=T(v);return I(s,{onData:r=>n?f.write(r):(n=!0,f.write(v([o,r]))),onError:r=>f.error(r),onEnd:()=>{n||(n=!0,f.write(o)),f.end()}}),f}e.prefixedStream=b}),define(fe[22],me([0,1,96]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let D,S;class T{constructor(t){this.buffer=t,this.byteLength=this.buffer.byteLength}static alloc(t){return L?new T(Buffer.allocUnsafe(t)):new T(new Uint8Array(t))}static wrap(t){return L&&!Buffer.isBuffer(t)&&(t=Buffer.from(t.buffer,t.byteOffset,t.byteLength)),new T(t)}static fromString(t,u){return!(u?.dontUseNodeBuffer||!1)&&L?new T(Buffer.from(t)):(D||(D=new TextEncoder),new T(D.encode(t)))}static concat(t,u){if(typeof u=="undefined"){u=0;for(let m=0,d=t.length;m<d;m++)u+=t[m].byteLength}const l=T.alloc(u);let c=0;for(let m=0,d=t.length;m<d;m++){const _=t[m];l.set(_,c),c+=_.byteLength}return l}toString(){return L?this.buffer.toString():(S||(S=new TextDecoder),S.decode(this.buffer))}slice(t,u){return new T(this.buffer.subarray(t,u))}set(t,u){t instanceof T?this.buffer.set(t.buffer,u):this.buffer.set(t,u)}readUInt32BE(t){return k(this.buffer,t)}writeUInt32BE(t,u){i(this.buffer,t,u)}readUInt32LE(t){return I(this.buffer,t)}writeUInt32LE(t,u){a(this.buffer,t,u)}readUInt8(t){return p(this.buffer,t)}writeUInt8(t,u){h(this.buffer,t,u)}}e.VSBuffer=T;function C(r,t){return r[t+0]<<0>>>0|r[t+1]<<8>>>0}e.readUInt16LE=C;function E(r,t,u){r[u+0]=t&255,t=t>>>8,r[u+1]=t&255}e.writeUInt16LE=E;function k(r,t){return r[t]*2**24+r[t+1]*2**16+r[t+2]*2**8+r[t+3]}e.readUInt32BE=k;function i(r,t,u){r[u+3]=t,t=t>>>8,r[u+2]=t,t=t>>>8,r[u+1]=t,t=t>>>8,r[u]=t}e.writeUInt32BE=i;function I(r,t){return r[t+0]<<0>>>0|r[t+1]<<8>>>0|r[t+2]<<16>>>0|r[t+3]<<24>>>0}e.readUInt32LE=I;function a(r,t,u){r[u+0]=t&255,t=t>>>8,r[u+1]=t&255,t=t>>>8,r[u+2]=t&255,t=t>>>8,r[u+3]=t&255}e.writeUInt32LE=a;function p(r,t){return r[t]}e.readUInt8=p;function h(r,t,u){r[u]=t}e.writeUInt8=h;function w(r){return g.consumeReadable(r,t=>T.concat(t))}e.readableToBuffer=w;function y(r){return g.toReadable(r)}e.bufferToReadable=y;function P(r){return g.consumeStream(r,t=>T.concat(t))}e.streamToBuffer=P;async function b(r){return r.ended?T.concat(r.buffer):T.concat([...r.buffer,await P(r.stream)])}e.bufferedStreamToBuffer=b;function o(r){return g.toStream(r,t=>T.concat(t))}e.bufferToStream=o;function s(r){return g.transform(r,{data:t=>typeof t=="string"?T.fromString(t):T.wrap(t)},t=>T.concat(t))}e.streamToBufferReadableStream=s;function v(r){return g.newWriteableStream(t=>T.concat(t),r)}e.newWriteableBufferStream=v;function n(r,t){return g.prefixedReadable(r,t,u=>T.concat(u))}e.prefixedBufferReadable=n;function f(r,t){return g.prefixedStream(r,t,u=>T.concat(u))}e.prefixedBufferStream=f}),define(fe[8],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function g(le){return!le||typeof le!="string"?!0:le.trim().length===0}e.isFalsyOrWhitespace=g;const L=/{(\d+)}/g;function D(le,...Ie){return Ie.length===0?le:le.replace(L,function(Ne,Xe){const nt=parseInt(Xe,10);return isNaN(nt)||nt<0||nt>=Ie.length?Ne:Ie[nt]})}e.format=D;const S=/{([^}]+)}/g;function T(le,Ie){return le.replace(S,(Ne,Xe)=>Ie[Xe]??Ne)}e.format2=T;function C(le){return le.replace(/[<>&]/g,function(Ie){switch(Ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ie}})}e.escape=C;function E(le){return le.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=E;function k(le,Ie){let Ne=0;const Xe=Ie.charCodeAt(0);for(let nt=le.length-1;nt>=0;nt--)le.charCodeAt(nt)===Xe&&Ne++;return Ne}e.count=k;function i(le,Ie,Ne="\u2026"){return le.length<=Ie?le:`${le.substr(0,Ie)}${Ne}`}e.truncate=i;function I(le,Ie=" "){const Ne=a(le,Ie);return p(Ne,Ie)}e.trim=I;function a(le,Ie){if(!le||!Ie)return le;const Ne=Ie.length;if(Ne===0||le.length===0)return le;let Xe=0;for(;le.indexOf(Ie,Xe)===Xe;)Xe=Xe+Ne;return le.substring(Xe)}e.ltrim=a;function p(le,Ie){if(!le||!Ie)return le;const Ne=Ie.length,Xe=le.length;if(Ne===0||Xe===0)return le;let nt=Xe,ft=-1;for(;ft=le.lastIndexOf(Ie,nt-1),!(ft===-1||ft+Ne!==nt);){if(ft===0)return"";nt=ft}return le.substring(0,nt)}e.rtrim=p;function h(le){return le.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function w(le){return le.replace(/\*/g,"")}e.stripWildcards=w;function y(le,Ie,Ne={}){if(!le)throw new Error("Cannot create regex from empty string");Ie||(le=E(le)),Ne.wholeWord&&(/\B/.test(le.charAt(0))||(le="\\b"+le),/\B/.test(le.charAt(le.length-1))||(le=le+"\\b"));let Xe="";return Ne.global&&(Xe+="g"),Ne.matchCase||(Xe+="i"),Ne.multiline&&(Xe+="m"),Ne.unicode&&(Xe+="u"),new RegExp(le,Xe)}e.createRegExp=y;function P(le){return le.source==="^"||le.source==="^$"||le.source==="$"||le.source==="^\\s*$"?!1:!!(le.exec("")&&le.lastIndex===0)}e.regExpLeadsToEndlessLoop=P;function b(le){return!!le.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=b;function o(le){return(le.global?"g":"")+(le.ignoreCase?"i":"")+(le.multiline?"m":"")+(le.unicode?"u":"")}e.regExpFlags=o;function s(le){return le.split(/\r\n|\r|\n/)}e.splitLines=s;function v(le){for(let Ie=0,Ne=le.length;Ie<Ne;Ie++){const Xe=le.charCodeAt(Ie);if(Xe!==32&&Xe!==9)return Ie}return-1}e.firstNonWhitespaceIndex=v;function n(le,Ie=0,Ne=le.length){for(let Xe=Ie;Xe<Ne;Xe++){const nt=le.charCodeAt(Xe);if(nt!==32&&nt!==9)return le.substring(Ie,Xe)}return le.substring(Ie,Ne)}e.getLeadingWhitespace=n;function f(le,Ie=le.length-1){for(let Ne=Ie;Ne>=0;Ne--){const Xe=le.charCodeAt(Ne);if(Xe!==32&&Xe!==9)return Ne}return-1}e.lastNonWhitespaceIndex=f;function r(le,Ie){return le<Ie?-1:le>Ie?1:0}e.compare=r;function t(le,Ie,Ne=0,Xe=le.length,nt=0,ft=Ie.length){for(;Ne<Xe&&nt<ft;Ne++,nt++){let Re=le.charCodeAt(Ne),De=Ie.charCodeAt(nt);if(Re<De)return-1;if(Re>De)return 1}const tt=Xe-Ne,ut=ft-nt;return tt<ut?-1:tt>ut?1:0}e.compareSubstring=t;function u(le,Ie){return l(le,Ie,0,le.length,0,Ie.length)}e.compareIgnoreCase=u;function l(le,Ie,Ne=0,Xe=le.length,nt=0,ft=Ie.length){for(;Ne<Xe&&nt<ft;Ne++,nt++){let Re=le.charCodeAt(Ne),De=Ie.charCodeAt(nt);if(Re===De)continue;if(Re>=128||De>=128)return t(le.toLowerCase(),Ie.toLowerCase(),Ne,Xe,nt,ft);c(Re)&&(Re-=32),c(De)&&(De-=32);const Te=Re-De;if(Te!==0)return Te}const tt=Xe-Ne,ut=ft-nt;return tt<ut?-1:tt>ut?1:0}e.compareSubstringIgnoreCase=l;function c(le){return le>=97&&le<=122}e.isLowerAsciiLetter=c;function m(le){return le>=65&&le<=90}e.isUpperAsciiLetter=m;function d(le,Ie){return le.length===Ie.length&&l(le,Ie)===0}e.equalsIgnoreCase=d;function _(le,Ie){const Ne=Ie.length;return Ie.length>le.length?!1:l(le,Ie,0,Ne)===0}e.startsWithIgnoreCase=_;function A(le,Ie){let Ne,Xe=Math.min(le.length,Ie.length);for(Ne=0;Ne<Xe;Ne++)if(le.charCodeAt(Ne)!==Ie.charCodeAt(Ne))return Ne;return Xe}e.commonPrefixLength=A;function R(le,Ie){let Ne,Xe=Math.min(le.length,Ie.length);const nt=le.length-1,ft=Ie.length-1;for(Ne=0;Ne<Xe;Ne++)if(le.charCodeAt(nt-Ne)!==Ie.charCodeAt(ft-Ne))return Ne;return Xe}e.commonSuffixLength=R;function B(le){return 55296<=le&&le<=56319}e.isHighSurrogate=B;function U(le){return 56320<=le&&le<=57343}e.isLowSurrogate=U;function F(le,Ie){return(le-55296<<10)+(Ie-56320)+65536}e.computeCodePoint=F;function $(le,Ie,Ne){const Xe=le.charCodeAt(Ne);if(B(Xe)&&Ne+1<Ie){const nt=le.charCodeAt(Ne+1);if(U(nt))return F(Xe,nt)}return Xe}e.getNextCodePoint=$;function M(le,Ie){const Ne=le.charCodeAt(Ie-1);if(U(Ne)&&Ie>1){const Xe=le.charCodeAt(Ie-2);if(B(Xe))return F(Xe,Ne)}return Ne}function z(le,Ie){const Ne=ye.getInstance(),Xe=Ie,nt=le.length,ft=$(le,nt,Ie);Ie+=ft>=65536?2:1;let tt=Ne.getGraphemeBreakType(ft);for(;Ie<nt;){const ut=$(le,nt,Ie),Re=Ne.getGraphemeBreakType(ut);if(rt(tt,Re))break;Ie+=ut>=65536?2:1,tt=Re}return Ie-Xe}e.nextCharLength=z;function N(le,Ie){const Ne=ye.getInstance(),Xe=Ie,nt=M(le,Ie);Ie-=nt>=65536?2:1;let ft=Ne.getGraphemeBreakType(nt);for(;Ie>0;){const tt=M(le,Ie),ut=Ne.getGraphemeBreakType(tt);if(rt(ut,ft))break;Ie-=tt>=65536?2:1,ft=ut}return Xe-Ie}e.prevCharLength=N;function x(le,Ie){const Ne=ye.getInstance(),Xe=le.length,nt=Ie,ft=$(le,Xe,Ie),tt=Ne.getGraphemeBreakType(ft);Ie+=ft>=65536?2:1;let ut=tt;for(;Ie<Xe;){const De=$(le,Xe,Ie),Te=Ne.getGraphemeBreakType(De);if(rt(ut,Te))break;Ie+=De>=65536?2:1,ut=Te}const Re=Ie;for(Ie=nt,ut=tt;Ie>0;){const De=M(le,Ie),Te=Ne.getGraphemeBreakType(De);if(rt(Te,ut))break;Ie-=De>=65536?2:1,ut=Te}return[Ie,Re]}function j(le,Ie){return Ie>0&&U(le.charCodeAt(Ie))?x(le,Ie-1):x(le,Ie)}e.getCharContainingOffset=j;const O=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function H(le){return O.test(le)}e.containsRTL=H;const W=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function X(le){return W.test(le)}e.containsEmoji=X;const Q=/^[\t\n\r\x20-\x7E]*$/;function de(le){return Q.test(le)}e.isBasicASCII=de,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function _e(le){return e.UNUSUAL_LINE_TERMINATORS.test(le)}e.containsUnusualLineTerminators=_e;function Ce(le){for(let Ie=0,Ne=le.length;Ie<Ne;Ie++)if(Pe(le.charCodeAt(Ie)))return!0;return!1}e.containsFullWidthCharacter=Ce;function Pe(le){return le>=11904&&le<=55215||le>=63744&&le<=64255||le>=65281&&le<=65374}e.isFullWidthCharacter=Pe;function Be(le){return le>=127462&&le<=127487||le===8986||le===8987||le===9200||le===9203||le>=9728&&le<=10175||le===11088||le===11093||le>=127744&&le<=128591||le>=128640&&le<=128764||le>=128992&&le<=129003||le>=129280&&le<=129535||le>=129648&&le<=129750}e.isEmojiImprecise=Be;function We(le,Ie){if(le.length<Ie)return le;const Ne=/\b/g;let Xe=0;for(;Ne.test(le)&&!(le.length-Ne.lastIndex<Ie);)Xe=Ne.lastIndex,Ne.lastIndex+=1;return le.substring(Xe).replace(/^\s/,"")}e.lcut=We;const He=/\x1B\x5B[12]?K/g,G=/\x1b\[\d+m/g,ee=/\x1b\[0?m/g;function ie(le){return le&&(le=le.replace(He,""),le=le.replace(G,""),le=le.replace(ee,"")),le}e.removeAnsiEscapeCodes=ie,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ce(le){return!!(le&&le.length>0&&le.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ce;function Z(le){return ce(le)?le.substr(1):le}e.stripUTF8BOM=Z;function re(le,Ie){if(!le||!Ie||le.length<Ie.length)return!1;const Ne=Ie.length,Xe=le.toLowerCase();let nt=0,ft=-1;for(;nt<Ne;){const tt=Xe.indexOf(Ie[nt],ft+1);if(tt<0)return!1;ft=tt,nt++}return!0}e.fuzzyContains=re;function pe(le,Ie=!1){return le?(Ie&&(le=le.replace(/\\./g,"")),le.toLowerCase()!==le):!1}e.containsUppercaseCharacter=pe;function Me(le){return le.charAt(0).toUpperCase()+le.slice(1)}e.uppercaseFirstLetter=Me;function je(le,Ie=1){if(Ie===0)return"";let Ne=-1;do Ne=le.indexOf(`
`,Ne+1),Ie--;while(Ie>0&&Ne>=0);return Ne===-1?le:(le[Ne-1]==="\r"&&Ne--,le.substr(0,Ne))}e.getNLines=je;function Ke(le){const Ie=90-65+1;return le=le%(2*Ie),le<Ie?String.fromCharCode(97+le):String.fromCharCode(65+le-Ie)}e.singleLetterHash=Ke;function Ze(le){return ye.getInstance().getGraphemeBreakType(le)}e.getGraphemeBreakType=Ze;function rt(le,Ie){return le===0?Ie!==5&&Ie!==7:le===2&&Ie===3?!1:le===4||le===2||le===3||Ie===4||Ie===2||Ie===3?!0:!(le===8&&(Ie===8||Ie===9||Ie===11||Ie===12)||(le===11||le===9)&&(Ie===9||Ie===10)||(le===12||le===10)&&Ie===10||Ie===5||Ie===13||Ie===7||le===1||le===13&&Ie===14||le===6&&Ie===6)}e.breakBetweenGraphemeBreakType=rt;var ct;(function(le){le[le.Other=0]="Other",le[le.Prepend=1]="Prepend",le[le.CR=2]="CR",le[le.LF=3]="LF",le[le.Control=4]="Control",le[le.Extend=5]="Extend",le[le.Regional_Indicator=6]="Regional_Indicator",le[le.SpacingMark=7]="SpacingMark",le[le.L=8]="L",le[le.V=9]="V",le[le.T=10]="T",le[le.LV=11]="LV",le[le.LVT=12]="LVT",le[le.ZWJ=13]="ZWJ",le[le.Extended_Pictographic=14]="Extended_Pictographic"})(ct=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ye{constructor(){this._data=at()}static getInstance(){return ye._INSTANCE||(ye._INSTANCE=new ye),ye._INSTANCE}getGraphemeBreakType(Ie){if(Ie<32)return Ie===10?3:Ie===13?2:4;if(Ie<127)return 0;const Ne=this._data,Xe=Ne.length/3;let nt=1;for(;nt<=Xe;)if(Ie<Ne[3*nt])nt=2*nt;else if(Ie>Ne[3*nt+1])nt=2*nt+1;else return Ne[3*nt+2];return 0}}ye._INSTANCE=null;function at(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function J(le,Ie){if(le===0)return 0;const Ne=ne(le,Ie);if(Ne!==void 0)return Ne;const Xe=M(Ie,le);return le-=Ee(Xe),le}e.getLeftDeleteOffset=J;function ne(le,Ie){let Ne=M(Ie,le);for(le-=Ee(Ne);Qe(Ne)||Ne===65039||Ne===8419;){if(le===0)return;Ne=M(Ie,le),le-=Ee(Ne)}if(!!Be(Ne)){if(le>=0){const Xe=M(Ie,le);Xe===8205&&(le-=Ee(Xe))}return le}}function Ee(le){return le>=65536?2:1}function Qe(le){return 127995<=le&&le<=127999}var et;(function(le){le[le.zwj=8205]="zwj",le[le.emojiVariantSelector=65039]="emojiVariantSelector",le[le.enclosingKeyCap=8419]="enclosingKeyCap"})(et||(et={}))}),define(fe[49],me([0,1,8]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(P){return D(P,0)}e.hash=L;function D(P,b){switch(typeof P){case"object":return P===null?S(349,b):Array.isArray(P)?E(P,b):k(P,b);case"string":return C(P,b);case"boolean":return T(P,b);case"number":return S(P,b);case"undefined":return S(937,b);default:return S(617,b)}}e.doHash=D;function S(P,b){return(b<<5)-b+P|0}e.numberHash=S;function T(P,b){return S(P?433:863,b)}function C(P,b){b=S(149417,b);for(let o=0,s=P.length;o<s;o++)b=S(P.charCodeAt(o),b);return b}e.stringHash=C;function E(P,b){return b=S(104579,b),P.reduce((o,s)=>D(s,o),b)}function k(P,b){return b=S(181387,b),Object.keys(P).sort().reduce((o,s)=>(o=C(s,o),D(P[s],o)),b)}class i{constructor(){this._value=0}get value(){return this._value}hash(b){return this._value=D(b,this._value),this._value}}e.Hasher=i;var I;(function(P){P[P.BLOCK_SIZE=64]="BLOCK_SIZE",P[P.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function a(P,b,o=32){const s=o-b,v=~((1<<s)-1);return(P<<b|(v&P)>>>s)>>>0}function p(P,b=0,o=P.byteLength,s=0){for(let v=0;v<o;v++)P[b+v]=s}function h(P,b,o="0"){for(;P.length<b;)P=o+P;return P}function w(P,b=32){return P instanceof ArrayBuffer?Array.from(new Uint8Array(P)).map(o=>o.toString(16).padStart(2,"0")).join(""):h((P>>>0).toString(16),b/4)}e.toHexString=w;class y{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(b){const o=b.length;if(o===0)return;const s=this._buff;let v=this._buffLen,n=this._leftoverHighSurrogate,f,r;for(n!==0?(f=n,r=-1,n=0):(f=b.charCodeAt(0),r=0);;){let t=f;if(g.isHighSurrogate(f))if(r+1<o){const u=b.charCodeAt(r+1);g.isLowSurrogate(u)?(r++,t=g.computeCodePoint(f,u)):t=65533}else{n=f;break}else g.isLowSurrogate(f)&&(t=65533);if(v=this._push(s,v,t),r++,r<o)f=b.charCodeAt(r);else break}this._buffLen=v,this._leftoverHighSurrogate=n}_push(b,o,s){return s<128?b[o++]=s:s<2048?(b[o++]=192|(s&1984)>>>6,b[o++]=128|(s&63)>>>0):s<65536?(b[o++]=224|(s&61440)>>>12,b[o++]=128|(s&4032)>>>6,b[o++]=128|(s&63)>>>0):(b[o++]=240|(s&1835008)>>>18,b[o++]=128|(s&258048)>>>12,b[o++]=128|(s&4032)>>>6,b[o++]=128|(s&63)>>>0),o>=64&&(this._step(),o-=64,this._totalLen+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),o}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),w(this._h0)+w(this._h1)+w(this._h2)+w(this._h3)+w(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const b=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(b/4294967296),!1),this._buffDV.setUint32(60,b%4294967296,!1),this._step()}_step(){const b=y._bigBlock32,o=this._buffDV;for(let c=0;c<64;c+=4)b.setUint32(c,o.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)b.setUint32(c,a(b.getUint32(c-12,!1)^b.getUint32(c-32,!1)^b.getUint32(c-56,!1)^b.getUint32(c-64,!1),1),!1);let s=this._h0,v=this._h1,n=this._h2,f=this._h3,r=this._h4,t,u,l;for(let c=0;c<80;c++)c<20?(t=v&n|~v&f,u=1518500249):c<40?(t=v^n^f,u=1859775393):c<60?(t=v&n|v&f|n&f,u=2400959708):(t=v^n^f,u=3395469782),l=a(s,5)+t+r+u+b.getUint32(c*4,!1)&4294967295,r=f,f=n,n=a(v,30),v=s,s=l;this._h0=this._h0+s&4294967295,this._h1=this._h1+v&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+f&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=y,y._bigBlock32=new DataView(new ArrayBuffer(320))});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,g):D?D.value=g:e.set(Y,g),g},Oe=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[24],me([0,1,15,8]),function(Y,e,g,L){"use strict";var D,S,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function C(r,t,u){let l=r.get(t);return l===void 0&&(l=u,r.set(t,l)),l}e.getOrSet=C;function E(r){const t=[];return r.forEach((u,l)=>{t.push(`${l} => ${u}`)}),`Map(${r.size}) {${t.join(", ")}}`}e.mapToString=E;function k(r){const t=[];return r.forEach(u=>{t.push(u)}),`Set(${r.size}) {${t.join(", ")}}`}e.setToString=k;class i{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const u=t.charCodeAt(0),l=this._value.charCodeAt(this._pos);return u-l}value(){return this._value[this._pos]}}e.StringIterator=i;class I{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,L.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class a{constructor(t=!0,u=!0){this._splitOnBackslash=t,this._caseSensitive=u}reset(t){return this._value=t.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++){const u=this._value.charCodeAt(this._to);if(u===47||this._splitOnBackslash&&u===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,L.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=a;var p;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(p||(p={}));class h{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new a(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,L.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(y||(y={}));class P{constructor(t){this._iter=t}static forUris(t=()=>!1){return new P(new h(t))}static forPaths(){return new P(new a)}static forStrings(){return new P(new i)}static forConfigKeys(){return new P(new I)}clear(){this._root=void 0}fill(t,u){if(u){const l=u.slice(0);(0,g.shuffle)(l);for(let c of l)this.set(c,t)}else{const l=t.slice(0);(0,g.shuffle)(l);for(let c of l)this.set(c[0],c[1])}}set(t,u){const l=this._iter.reset(t);let c;this._root||(this._root=new w,this._root.segment=l.value());const m=[];for(c=this._root;;){const _=l.cmp(c.segment);if(_>0)c.left||(c.left=new w,c.left.segment=l.value()),m.push([-1,c]),c=c.left;else if(_<0)c.right||(c.right=new w,c.right.segment=l.value()),m.push([1,c]),c=c.right;else if(l.hasNext())l.next(),c.mid||(c.mid=new w,c.mid.segment=l.value()),m.push([0,c]),c=c.mid;else break}const d=c.value;c.value=u,c.key=t;for(let _=m.length-1;_>=0;_--){const A=m[_][1];A.updateHeight();const R=A.balanceFactor();if(R<-1||R>1){const B=m[_][0],U=m[_+1][0];if(B===1&&U===1)m[_][1]=A.rotateLeft();else if(B===-1&&U===-1)m[_][1]=A.rotateRight();else if(B===1&&U===-1)A.right=m[_+1][1]=m[_+1][1].rotateRight(),m[_][1]=A.rotateLeft();else if(B===-1&&U===1)A.left=m[_+1][1]=m[_+1][1].rotateLeft(),m[_][1]=A.rotateRight();else throw new Error;if(_>0)switch(m[_-1][0]){case-1:m[_-1][1].left=m[_][1];break;case 1:m[_-1][1].right=m[_][1];break;case 0:m[_-1][1].mid=m[_][1];break}else this._root=m[0][1]}}return d}get(t){return this._getNode(t)?.value}_getNode(t){const u=this._iter.reset(t);let l=this._root;for(;l;){const c=u.cmp(l.segment);if(c>0)l=l.left;else if(c<0)l=l.right;else if(u.hasNext())u.next(),l=l.mid;else break}return l}has(t){const u=this._getNode(t);return!(u?.value===void 0&&u?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,u){const l=this._iter.reset(t),c=[];let m=this._root;for(;m;){const d=l.cmp(m.segment);if(d>0)c.push([-1,m]),m=m.left;else if(d<0)c.push([1,m]),m=m.right;else if(l.hasNext())l.next(),c.push([0,m]),m=m.mid;else break}if(!!m){if(u?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const d=this._min(m.right),{key:_,value:A,segment:R}=d;this._delete(d.key,!1),m.key=_,m.value=A,m.segment=R}else{const d=m.left??m.right;if(c.length>0){const[_,A]=c[c.length-1];switch(_){case-1:A.left=d;break;case 0:A.mid=d;break;case 1:A.right=d;break}}else this._root=d}for(let d=c.length-1;d>=0;d--){const _=c[d][1];_.updateHeight();const A=_.balanceFactor();if(A>1?(_.right.balanceFactor()>=0||(_.right=c[d+1][1]=c[d+1][1].rotateRight()),c[d][1]=_.rotateLeft()):A<-1&&(_.left.balanceFactor()<=0||(_.left=c[d+1][1]=c[d+1][1].rotateLeft()),c[d][1]=_.rotateRight()),d>0)switch(c[d-1][0]){case-1:c[d-1][1].left=c[d][1];break;case 1:c[d-1][1].right=c[d][1];break;case 0:c[d-1][1].mid=c[d][1];break}else this._root=c[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const u=this._iter.reset(t);let l=this._root,c;for(;l;){const m=u.cmp(l.segment);if(m>0)l=l.left;else if(m<0)l=l.right;else if(u.hasNext())u.next(),c=l.value||c,l=l.mid;else break}return l&&l.value||c}findSuperstr(t){const u=this._iter.reset(t);let l=this._root;for(;l;){const c=u.cmp(l.segment);if(c>0)l=l.left;else if(c<0)l=l.right;else if(u.hasNext())u.next(),l=l.mid;else return l.mid?this._entries(l.mid):void 0}}forEach(t){for(const[u,l]of this)t(l,u)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=u=>{if(!u)return!0;const l=u.balanceFactor();return l<-1||l>1?!1:t(u.left)&&t(u.right)};return t(this._root)}}e.TernarySearchTree=P;class b{constructor(t,u){this.uri=t,this.value=u}}class o{constructor(t,u){this[D]="ResourceMap",t instanceof o?(this.map=new Map(t.map),this.toKey=u??o.defaultToKey):(this.map=new Map,this.toKey=t??o.defaultToKey)}set(t,u){return this.map.set(this.toKey(t),new b(t,u)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,u){typeof u!="undefined"&&(t=t.bind(u));for(let[l,c]of this.map)t(c.value,c.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=o,o.defaultToKey=r=>r.toString();var s;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(s=e.Touch||(e.Touch={}));class v{constructor(){this[S]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,u=0){const l=this._map.get(t);if(!!l)return u!==0&&this.touch(l,u),l.value}set(t,u,l=0){let c=this._map.get(t);if(c)c.value=u,l!==0&&this.touch(c,l);else{switch(c={key:t,value:u,next:void 0,previous:void 0},l){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(t,c),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const u=this._map.get(t);if(!!u)return this._map.delete(t),this.removeItem(u),this._size--,u.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,u){const l=this._state;let c=this._head;for(;c;){if(u?t.bind(u)(c.value,c.key,this):t(c.value,c.key,this),this._state!==l)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const t=this,u=this._state;let l=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==u)throw new Error("LinkedMap got modified during iteration.");if(l){const m={value:l.key,done:!1};return l=l.next,m}else return{value:void 0,done:!0}}};return c}values(){const t=this,u=this._state;let l=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==u)throw new Error("LinkedMap got modified during iteration.");if(l){const m={value:l.value,done:!1};return l=l.next,m}else return{value:void 0,done:!0}}};return c}entries(){const t=this,u=this._state;let l=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==u)throw new Error("LinkedMap got modified during iteration.");if(l){const m={value:[l.key,l.value],done:!1};return l=l.next,m}else return{value:void 0,done:!0}}};return c}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let u=this._head,l=this.size;for(;u&&l>t;)this._map.delete(u.key),u=u.next,l--;this._head=u,this._size=l,u&&(u.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const u=t.next,l=t.previous;if(!u||!l)throw new Error("Invalid list");u.previous=l,l.next=u}t.next=void 0,t.previous=void 0,this._state++}touch(t,u){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(u!==1&&u!==2)){if(u===1){if(t===this._head)return;const l=t.next,c=t.previous;t===this._tail?(c.next=void 0,this._tail=c):(l.previous=c,c.next=l),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(u===2){if(t===this._tail)return;const l=t.next,c=t.previous;t===this._head?(l.previous=void 0,this._head=l):(l.previous=c,c.next=l),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((u,l)=>{t.push([l,u])}),t}fromJSON(t){this.clear();for(const[u,l]of t)this.set(u,l)}}e.LinkedMap=v;class n extends v{constructor(t,u=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,u),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,u=2){return super.get(t,u)}peek(t){return super.get(t,0)}set(t,u){return super.set(t,u,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=n;class f{constructor(t){T.set(this,void 0),st(this,T,t,"f")}get size(){return Oe(this,T,"f").size}forEach(t,u){Oe(this,T,"f").forEach(t,u)}get(t){return Oe(this,T,"f").get(t)}has(t){return Oe(this,T,"f").has(t)}entries(){return Oe(this,T,"f").entries()}keys(){return Oe(this,T,"f").keys()}values(){return Oe(this,T,"f").values()}[(T=new WeakMap,Symbol.iterator)](){return Oe(this,T,"f").entries()}}e.ReadonlyMapView=f}),define(fe[97],me([0,1,24,8]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function D(...Z){return function(re,pe){for(let Me=0,je=Z.length;Me<je;Me++){const Ke=Z[Me](re,pe);if(Ke)return Ke}return null}}e.or=D,e.matchesStrictPrefix=S.bind(void 0,!1),e.matchesPrefix=S.bind(void 0,!0);function S(Z,re,pe){if(!pe||pe.length<re.length)return null;let Me;return Z?Me=L.startsWithIgnoreCase(pe,re):Me=pe.indexOf(re)===0,Me?re.length>0?[{start:0,end:re.length}]:[]:null}function T(Z,re){const pe=re.toLowerCase().indexOf(Z.toLowerCase());return pe===-1?null:[{start:pe,end:pe+Z.length}]}e.matchesContiguousSubString=T;function C(Z,re){return E(Z.toLowerCase(),re.toLowerCase(),0,0)}e.matchesSubString=C;function E(Z,re,pe,Me){if(pe===Z.length)return[];if(Me===re.length)return null;if(Z[pe]===re[Me]){let je=null;return(je=E(Z,re,pe+1,Me+1))?P({start:Me,end:Me+1},je):null}return E(Z,re,pe,Me+1)}function k(Z){return 97<=Z&&Z<=122}function i(Z){return 65<=Z&&Z<=90}e.isUpper=i;function I(Z){return 48<=Z&&Z<=57}function a(Z){return Z===32||Z===9||Z===10||Z===13}const p=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Z=>p.add(Z.charCodeAt(0)));function h(Z){return a(Z)||p.has(Z)}function w(Z,re){return Z===re||h(Z)&&h(re)}function y(Z){return k(Z)||i(Z)||I(Z)}function P(Z,re){return re.length===0?re=[Z]:Z.end===re[0].start?re[0].start=Z.start:re.unshift(Z),re}function b(Z,re){for(let pe=re;pe<Z.length;pe++){const Me=Z.charCodeAt(pe);if(i(Me)||I(Me)||pe>0&&!y(Z.charCodeAt(pe-1)))return pe}return Z.length}function o(Z,re,pe,Me){if(pe===Z.length)return[];if(Me===re.length)return null;if(Z[pe]!==re[Me].toLowerCase())return null;{let je=null,Ke=Me+1;for(je=o(Z,re,pe+1,Me+1);!je&&(Ke=b(re,Ke))<re.length;)je=o(Z,re,pe+1,Ke),Ke++;return je===null?null:P({start:Me,end:Me+1},je)}}function s(Z){let re=0,pe=0,Me=0,je=0,Ke=0;for(let at=0;at<Z.length;at++)Ke=Z.charCodeAt(at),i(Ke)&&re++,k(Ke)&&pe++,y(Ke)&&Me++,I(Ke)&&je++;const Ze=re/Z.length,rt=pe/Z.length,ct=Me/Z.length,ye=je/Z.length;return{upperPercent:Ze,lowerPercent:rt,alphaPercent:ct,numericPercent:ye}}function v(Z){const{upperPercent:re,lowerPercent:pe}=Z;return pe===0&&re>.6}function n(Z){const{upperPercent:re,lowerPercent:pe,alphaPercent:Me,numericPercent:je}=Z;return pe>.2&&re<.8&&Me>.6&&je<.2}function f(Z){let re=0,pe=0,Me=0,je=0;for(let Ke=0;Ke<Z.length;Ke++)Me=Z.charCodeAt(Ke),i(Me)&&re++,k(Me)&&pe++,a(Me)&&je++;return(re===0||pe===0)&&je===0?Z.length<=30:re<=5}function r(Z,re){if(!re||(re=re.trim(),re.length===0)||!f(Z)||re.length>60)return null;const pe=s(re);if(!n(pe)){if(!v(pe))return null;re=re.toLowerCase()}let Me=null,je=0;for(Z=Z.toLowerCase();je<re.length&&(Me=o(Z,re,0,je))===null;)je=b(re,je+1);return Me}e.matchesCamelCase=r;function t(Z,re,pe=!1){if(!re||re.length===0)return null;let Me=null,je=0;for(Z=Z.toLowerCase(),re=re.toLowerCase();je<re.length&&(Me=u(Z,re,0,je,pe))===null;)je=l(re,je+1);return Me}e.matchesWords=t;function u(Z,re,pe,Me,je){if(pe===Z.length)return[];if(Me===re.length)return null;if(w(Z.charCodeAt(pe),re.charCodeAt(Me))){let Ke=null,Ze=Me+1;if(Ke=u(Z,re,pe+1,Me+1,je),!je)for(;!Ke&&(Ze=l(re,Ze))<re.length;)Ke=u(Z,re,pe+1,Ze,je),Ze++;return Ke===null?null:P({start:Me,end:Me+1},Ke)}else return null}function l(Z,re){for(let pe=re;pe<Z.length;pe++)if(h(Z.charCodeAt(pe))||pe>0&&h(Z.charCodeAt(pe-1)))return pe;return Z.length}const c=D(e.matchesPrefix,r,T),m=D(e.matchesPrefix,r,C),d=new g.LRUCache(1e4);function _(Z,re,pe=!1){if(typeof Z!="string"||typeof re!="string")return null;let Me=d.get(Z);Me||(Me=new RegExp(L.convertSimple2RegExpPattern(Z),"i"),d.set(Z,Me));const je=Me.exec(re);return je?[{start:je.index,end:je.index+je[0].length}]:pe?m(Z,re):c(Z,re)}e.matchesFuzzy=_;function A(Z,re){const pe=Be(Z,Z.toLowerCase(),0,re,re.toLowerCase(),0,!0);return pe?B(pe):null}e.matchesFuzzy2=A;function R(Z,re,pe,Me,je,Ke){const Ze=Math.min(13,Z.length);for(;pe<Ze;pe++){const rt=Be(Z,re,pe,Me,je,Ke,!1);if(rt)return rt}return[0,Ke]}e.anyScore=R;function B(Z){if(typeof Z=="undefined")return[];const re=[],pe=Z[1];for(let Me=Z.length-1;Me>1;Me--){const je=Z[Me]+pe,Ke=re[re.length-1];Ke&&Ke.end===je?Ke.end=je+1:re.push({start:je,end:je+1})}return re}e.createMatches=B;const U=128;function F(){const Z=[],re=[];for(let pe=0;pe<=U;pe++)re[pe]=0;for(let pe=0;pe<=U;pe++)Z.push(re.slice(0));return Z}function $(Z){const re=[];for(let pe=0;pe<=Z;pe++)re[pe]=0;return re}const M=$(2*U),z=$(2*U),N=F(),x=F(),j=F(),O=!1;function H(Z,re,pe,Me,je){function Ke(rt,ct,ye=" "){for(;rt.length<ct;)rt=ye+rt;return rt}let Ze=` |   |${Me.split("").map(rt=>Ke(rt,3)).join("|")}
`;for(let rt=0;rt<=pe;rt++)rt===0?Ze+=" |":Ze+=`${re[rt-1]}|`,Ze+=Z[rt].slice(0,je+1).map(ct=>Ke(ct.toString(),3)).join("|")+`
`;return Ze}function W(Z,re,pe,Me){Z=Z.substr(re),pe=pe.substr(Me),console.log(H(x,Z,Z.length,pe,pe.length)),console.log(H(j,Z,Z.length,pe,pe.length)),console.log(H(N,Z,Z.length,pe,pe.length))}function X(Z,re){if(re<0||re>=Z.length)return!1;const pe=Z.codePointAt(re);switch(pe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!L.isEmojiImprecise(pe)}}function Q(Z,re){if(re<0||re>=Z.length)return!1;switch(Z.charCodeAt(re)){case 32:case 9:return!0;default:return!1}}function de(Z,re,pe){return re[Z]!==pe[Z]}function _e(Z,re,pe,Me,je,Ke,Ze=!1){for(;re<pe&&je<Ke;)Z[re]===Me[je]&&(Ze&&(M[re]=je),re+=1),je+=1;return re===pe}e.isPatternInWord=_e;var Ce;(function(Z){Z[Z.Diag=1]="Diag",Z[Z.Left=2]="Left",Z[Z.LeftLeft=3]="LeftLeft"})(Ce||(Ce={}));var Pe;(function(Z){Z.Default=[-100,0];function re(pe){return!pe||pe.length===2&&pe[0]===-100&&pe[1]===0}Z.isDefault=re})(Pe=e.FuzzyScore||(e.FuzzyScore={}));function Be(Z,re,pe,Me,je,Ke,Ze){const rt=Z.length>U?U:Z.length,ct=Me.length>U?U:Me.length;if(pe>=rt||Ke>=ct||rt-pe>ct-Ke||!_e(re,pe,rt,je,Ke,ct,!0))return;We(rt,ct,pe,Ke,re,je);let ye=1,at=1,J=pe,ne=Ke;const Ee=[!1];for(ye=1,J=pe;J<rt;ye++,J++){const Ne=M[J],Xe=z[J],nt=J+1<rt?z[J+1]:ct;for(at=Ne-Ke+1,ne=Ne;ne<nt;at++,ne++){let ft=Number.MIN_SAFE_INTEGER,tt=!1;ne<=Xe&&(ft=He(Z,re,J,pe,Me,je,ne,ct,Ke,N[ye-1][at-1]===0,Ee));let ut=0;ft!==Number.MAX_SAFE_INTEGER&&(tt=!0,ut=ft+x[ye-1][at-1]);const Re=ne>Ne,De=Re?x[ye][at-1]+(N[ye][at-1]>0?-5:0):0,Te=ne>Ne+1&&N[ye][at-1]>0,se=Te?x[ye][at-2]+(N[ye][at-2]>0?-5:0):0;if(Te&&(!Re||se>=De)&&(!tt||se>=ut))x[ye][at]=se,j[ye][at]=3,N[ye][at]=0;else if(Re&&(!tt||De>=ut))x[ye][at]=De,j[ye][at]=2,N[ye][at]=0;else if(tt)x[ye][at]=ut,j[ye][at]=1,N[ye][at]=N[ye-1][at-1]+1;else throw new Error("not possible")}}if(O&&W(Z,pe,Me,Ke),!Ee[0]&&!Ze)return;ye--,at--;const Qe=[x[ye][at],Ke];let et=0,le=0;for(;ye>=1;){let Ne=at;do{const Xe=j[ye][Ne];if(Xe===3)Ne=Ne-2;else if(Xe===2)Ne=Ne-1;else break}while(Ne>=1);et>1&&re[pe+ye-1]===je[Ke+at-1]&&!de(Ne+Ke-1,Me,je)&&et+1>N[ye][Ne]&&(Ne=at),Ne===at?et++:et=1,le||(le=Ne),ye--,at=Ne-1,Qe.push(at)}ct===rt&&(Qe[0]+=2);const Ie=le-rt;return Qe[0]-=Ie,Qe}e.fuzzyScore=Be;function We(Z,re,pe,Me,je,Ke){let Ze=Z-1,rt=re-1;for(;Ze>=pe&&rt>=Me;)je[Ze]===Ke[rt]&&(z[Ze]=rt,Ze--),rt--}function He(Z,re,pe,Me,je,Ke,Ze,rt,ct,ye,at){if(re[pe]!==Ke[Ze])return Number.MIN_SAFE_INTEGER;let J=1,ne=!1;return Ze===pe-Me?J=Z[pe]===je[Ze]?7:5:de(Ze,je,Ke)&&(Ze===0||!de(Ze-1,je,Ke))?(J=Z[pe]===je[Ze]?7:5,ne=!0):X(Ke,Ze)&&(Ze===0||!X(Ke,Ze-1))?J=5:(X(Ke,Ze-1)||Q(Ke,Ze-1))&&(J=5,ne=!0),J>1&&pe===Me&&(at[0]=!0),ne||(ne=de(Ze,je,Ke)||X(Ke,Ze-1)||Q(Ke,Ze-1)),pe===Me?Ze>ct&&(J-=ne?3:5):ye?J+=ne?2:0:J+=ne?0:1,Ze+1===rt&&(J-=ne?3:5),J}function G(Z,re,pe,Me,je,Ke,Ze){return ie(Z,re,pe,Me,je,Ke,!0,Ze)}e.fuzzyScoreGracefulAggressive=G;function ee(Z,re,pe,Me,je,Ke,Ze){return ie(Z,re,pe,Me,je,Ke,!1,Ze)}e.fuzzyScoreGraceful=ee;function ie(Z,re,pe,Me,je,Ke,Ze,rt){let ct=Be(Z,re,pe,Me,je,Ke,rt);if(ct&&!Ze)return ct;if(Z.length>=3){const ye=Math.min(7,Z.length-1);for(let at=pe+1;at<ye;at++){const J=ce(Z,at);if(J){const ne=Be(J,J.toLowerCase(),pe,Me,je,Ke,rt);ne&&(ne[0]-=3,(!ct||ne[0]>ct[0])&&(ct=ne))}}}return ct}function ce(Z,re){if(re+1>=Z.length)return;const pe=Z[re],Me=Z[re+1];if(pe!==Me)return Z.slice(0,re)+Me+pe+Z.slice(re+2)}}),define(fe[142],me([0,1,48,97,8]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const S=new RegExp(`\\$\\(${g.CSSIcon.iconNameExpression}(?:${g.CSSIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(g.CSSIcon.iconNameCharacter),C=new RegExp(`(\\\\)?${S.source}`,"g");function E(y){return y.replace(C,(P,b)=>b?P:`\\${P}`)}e.escapeIcons=E;const k=new RegExp(`\\\\${S.source}`,"g");function i(y){return y.replace(k,P=>`\\${P}`)}e.markdownEscapeEscapedIcons=i;const I=new RegExp(`(\\s)?(\\\\)?${S.source}(\\s)?`,"g");function a(y){return y.indexOf(e.iconStartMarker)===-1?y:y.replace(I,(P,b,o,s)=>o?P:b||s||"")}e.stripIcons=a;function p(y){const P=y.indexOf(e.iconStartMarker);return P===-1?{text:y}:h(y,P)}e.parseLabelWithIcons=p;function h(y,P){const b=[];let o="";function s(c){if(c){o+=c;for(const m of c)b.push(f)}}let v=-1,n="",f=0,r,t,u=P;const l=y.length;for(s(y.substr(0,P));u<l;)r=y[u],t=y[u+1],r===e.iconStartMarker[0]&&t===e.iconStartMarker[1]?(v=u,s(n),n=e.iconStartMarker,u++):r===")"&&v!==-1?(f+=u-v+1,v=-1,n=""):v!==-1?T.test(r)?n+=r:(s(n),v=-1,n=""):s(r),u++;return s(n),{text:o,iconOffsets:b}}function w(y,P,b=!1){const{text:o,iconOffsets:s}=P;if(!s||s.length===0)return(0,L.matchesFuzzy)(y,o,b);const v=(0,D.ltrim)(o," "),n=o.length-v.length,f=(0,L.matchesFuzzy)(y,v,b);if(f)for(const r of f){const t=s[r.start+n]+n;r.start+=t,r.end+=t}return f}e.matchesFuzzyIconAware=w}),define(fe[98],me([0,1,18,142]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var D;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(D=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(p="",h=!1){if(this.value=p,typeof this.value!="string")throw(0,g.illegalArgument)("value");typeof h=="boolean"?(this.isTrusted=h,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=h.isTrusted??void 0,this.supportThemeIcons=h.supportThemeIcons??!1,this.supportHtml=h.supportHtml??!1)}appendText(p,h=0){return this.value+=k(this.supportThemeIcons?(0,L.escapeIcons)(p):p).replace(/([ \t]+)/g,(w,y)=>"&nbsp;".repeat(y.length)).replace(/\>/gm,"\\>").replace(/\n/g,h===1?`\\
`:`

`),this}appendMarkdown(p){return this.value+=p,this}appendCodeblock(p,h){return this.value+="\n```",this.value+=p,this.value+=`
`,this.value+=h,this.value+="\n```\n",this}}e.MarkdownString=S;function T(a){return C(a)?!a.value:Array.isArray(a)?a.every(T):!0}e.isEmptyMarkdownString=T;function C(a){return a instanceof S?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}e.isMarkdownString=C;function E(a,p){return a===p?!0:!a||!p?!1:a.value===p.value&&a.isTrusted===p.isTrusted&&a.supportThemeIcons===p.supportThemeIcons}e.markdownStringEqual=E;function k(a){return a.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=k;function i(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=i;function I(a){const p=[],h=a.split("|").map(y=>y.trim());a=h[0];const w=h[1];if(w){const y=/height=(\d+)/.exec(w),P=/width=(\d+)/.exec(w),b=y?y[1]:"",o=P?P[1]:"",s=isFinite(parseInt(o)),v=isFinite(parseInt(b));s&&p.push(`width="${o}"`),v&&p.push(`height="${b}"`)}return{href:a,dimensions:p}}e.parseHrefAndDimensions=I}),define(fe[80],me([0,1,24]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new g.LRUCache(1e4);function D(k){return E(k,"NFC",L)}e.normalizeNFC=D;const S=new g.LRUCache(1e4);function T(k){return E(k,"NFD",S)}e.normalizeNFD=T;const C=/[^\u0000-\u0080]/;function E(k,i,I){if(!k)return k;const a=I.get(k);if(a)return a;let p;return C.test(k)?p=k.normalize(i):p=k,I.set(k,p),p}e.removeAccents=function(){const k=/[\u0300-\u036f]/g;return function(i){return T(i).replace(k,"")}}()}),define(fe[50],me([0,1,8]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(L||(L={})),function(D){const S="error",T="warning",C="warn",E="info",k="ignore";function i(a){return a?g.equalsIgnoreCase(S,a)?D.Error:g.equalsIgnoreCase(T,a)||g.equalsIgnoreCase(C,a)?D.Warning:g.equalsIgnoreCase(E,a)?D.Info:D.Ignore:D.Ignore}D.fromValue=i;function I(a){switch(a){case D.Error:return S;case D.Warning:return T;case D.Info:return E;default:return k}}D.toString=I}(L||(L={})),e.default=L}),define(fe[13],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function g(m){return Array.isArray(m)}e.isArray=g;function L(m){return typeof m=="string"}e.isString=L;function D(m){return Array.isArray(m)&&m.every(d=>L(d))}e.isStringArray=D;function S(m){return typeof m=="object"&&m!==null&&!Array.isArray(m)&&!(m instanceof RegExp)&&!(m instanceof Date)}e.isObject=S;function T(m){return typeof m=="number"&&!isNaN(m)}e.isNumber=T;function C(m){return!!m&&typeof m[Symbol.iterator]=="function"}e.isIterable=C;function E(m){return m===!0||m===!1}e.isBoolean=E;function k(m){return typeof m=="undefined"}e.isUndefined=k;function i(m){return!I(m)}e.isDefined=i;function I(m){return k(m)||m===null}e.isUndefinedOrNull=I;function a(m,d){if(!m)throw new Error(d?`Unexpected type, expected '${d}'`:"Unexpected type")}e.assertType=a;function p(m){if(I(m))throw new Error("Assertion Failed: argument is undefined or null");return m}e.assertIsDefined=p;function h(...m){const d=[];for(let _=0;_<m.length;_++){const A=m[_];if(I(A))throw new Error(`Assertion Failed: argument at index ${_} is undefined or null`);d.push(A)}return d}e.assertAllDefined=h;const w=Object.prototype.hasOwnProperty;function y(m){if(!S(m))return!1;for(let d in m)if(w.call(m,d))return!1;return!0}e.isEmptyObject=y;function P(m){return typeof m=="function"}e.isFunction=P;function b(...m){return m.length>0&&m.every(P)}e.areFunctions=b;function o(m,d){const _=Math.min(m.length,d.length);for(let A=0;A<_;A++)s(m[A],d[A])}e.validateConstraints=o;function s(m,d){if(L(d)){if(typeof m!==d)throw new Error(`argument does not match constraint: typeof ${d}`)}else if(P(d)){try{if(m instanceof d)return}catch{}if(!I(m)&&m.constructor===d||d.length===1&&d.call(void 0,m)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=s;function v(m){let d=[],_=Object.getPrototypeOf(m);for(;Object.prototype!==_;)d=d.concat(Object.getOwnPropertyNames(_)),_=Object.getPrototypeOf(_);return d}e.getAllPropertyNames=v;function n(m){const d=[];for(const _ of v(m))typeof m[_]=="function"&&d.push(_);return d}e.getAllMethodNames=n;function f(m,d){const _=R=>function(){const B=Array.prototype.slice.call(arguments,0);return d(R,B)};let A={};for(const R of m)A[R]=_(R);return A}e.createProxyObject=f;function r(m){return m===null?void 0:m}e.withNullAsUndefined=r;function t(m){return typeof m=="undefined"?null:m}e.withUndefinedAsNull=t;function u(m){return class{constructor(){return new Proxy({},{get(d,_){if(d[_])return d[_];throw new Error(`Not Implemented: ${m}->${String(_)}`)}})}}}e.NotImplementedProxy=u;function l(m,d="Unreachable"){throw new Error(d)}e.assertNever=l;function c(m){return!!m&&typeof m.then=="function"&&typeof m.catch=="function"}e.isPromise=c}),define(fe[29],me([0,1,9,12,8,13]),function(Y,e,g,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(r){return r===47||r===92}e.isPathSeparator=T;function C(r){return r.replace(/[\\/]/g,g.posix.sep)}e.toSlashes=C;function E(r){return r.indexOf("/")===-1&&(r=C(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=E;function k(r,t=g.posix.sep){if(!r)return"";const u=r.length,l=r.charCodeAt(0);if(T(l)){if(T(r.charCodeAt(1))&&!T(r.charCodeAt(2))){let m=3;const d=m;for(;m<u&&!T(r.charCodeAt(m));m++);if(d!==m&&!T(r.charCodeAt(m+1))){for(m+=1;m<u;m++)if(T(r.charCodeAt(m)))return r.slice(0,m+1).replace(/[\\/]/g,t)}}return t}else if(P(l)&&r.charCodeAt(1)===58)return T(r.charCodeAt(2))?r.slice(0,2)+t:r.slice(0,2);let c=r.indexOf("://");if(c!==-1){for(c+=3;c<u;c++)if(T(r.charCodeAt(c)))return r.slice(0,c+1)}return""}e.getRoot=k;function i(r){if(!L.isWindows||!r||r.length<5)return!1;let t=r.charCodeAt(0);if(t!==92||(t=r.charCodeAt(1),t!==92))return!1;let u=2;const l=u;for(;u<r.length&&(t=r.charCodeAt(u),t!==92);u++);return!(l===u||(t=r.charCodeAt(u+1),isNaN(t)||t===92))}e.isUNC=i;const I=/[\\/:\*\?"<>\|]/g,a=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(r,t=L.isWindows){const u=t?I:a;return!(!r||r.length===0||/^\s+$/.test(r)||(u.lastIndex=0,u.test(r))||t&&p.test(r)||r==="."||r===".."||t&&r[r.length-1]==="."||t&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=h;function w(r,t,u){const l=r===t;return!u||l?l:!r||!t?!1:(0,D.equalsIgnoreCase)(r,t)}e.isEqual=w;function y(r,t,u,l=g.sep){if(r===t)return!0;if(!r||!t||t.length>r.length)return!1;if(u){if(!(0,D.startsWithIgnoreCase)(r,t))return!1;if(t.length===r.length)return!0;let m=t.length;return t.charAt(t.length-1)===l&&m--,r.charAt(m)===l}return t.charAt(t.length-1)!==l&&(t+=l),r.indexOf(t)===0}e.isEqualOrParent=y;function P(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=P;function b(r,t){return L.isWindows&&r.endsWith(":")&&(r+=g.sep),(0,g.isAbsolute)(r)||(r=(0,g.join)(t,r)),r=(0,g.normalize)(r),L.isWindows?(r=(0,D.rtrim)(r,g.sep),r.endsWith(":")&&(r+=g.sep)):(r=(0,D.rtrim)(r,g.sep),r||(r=g.sep)),r}e.sanitizeFilePath=b;function o(r){const t=(0,g.normalize)(r);return L.isWindows?r.length>3?!1:s(t)&&(r.length===2||t.charCodeAt(2)===92):t===g.posix.sep}e.isRootOrDriveLetter=o;function s(r,t){return(t!==void 0?t:L.isWindows)?P(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=s;function v(r){return s(r)?r[0]:void 0}e.getDriveLetter=v;function n(r,t,u){return t.length>r.length?-1:r===t?0:(u&&(r=r.toLowerCase(),t=t.toLowerCase()),r.indexOf(t))}e.indexOfPath=n;function f(r){const t=r.split(":");let u,l,c;if(t.forEach(m=>{const d=Number(m);(0,S.isNumber)(d)?l===void 0?l=d:c===void 0&&(c=d):u=u?[u,m].join(":"):m}),!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:l!==void 0?l:void 0,column:c!==void 0?c:l!==void 0?1:void 0}}e.parseLineAndColumnAware=f}),define(fe[25],me([0,1,13]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const y=Array.isArray(w)?[]:{};return Object.keys(w).forEach(P=>{w[P]&&typeof w[P]=="object"?y[P]=L(w[P]):y[P]=w[P]}),y}e.deepClone=L;function D(w){if(!w||typeof w!="object")return w;const y=[w];for(;y.length>0;){const P=y.shift();Object.freeze(P);for(const b in P)if(S.call(P,b)){const o=P[b];typeof o=="object"&&!Object.isFrozen(o)&&y.push(o)}}return w}e.deepFreeze=D;const S=Object.prototype.hasOwnProperty;function T(w,y){return C(w,y,new Set)}e.cloneAndChange=T;function C(w,y,P){if((0,g.isUndefinedOrNull)(w))return w;const b=y(w);if(typeof b!="undefined")return b;if((0,g.isArray)(w)){const o=[];for(const s of w)o.push(C(s,y,P));return o}if((0,g.isObject)(w)){if(P.has(w))throw new Error("Cannot clone recursive data-structure");P.add(w);const o={};for(let s in w)S.call(w,s)&&(o[s]=C(w[s],y,P));return P.delete(w),o}return w}function E(w,y,P=!0){return(0,g.isObject)(w)?((0,g.isObject)(y)&&Object.keys(y).forEach(b=>{b in w?P&&((0,g.isObject)(w[b])&&(0,g.isObject)(y[b])?E(w[b],y[b],P):w[b]=y[b]):w[b]=y[b]}),w):y}e.mixin=E;function k(w,y){if(w===y)return!0;if(w==null||y===null||y===void 0||typeof w!=typeof y||typeof w!="object"||Array.isArray(w)!==Array.isArray(y))return!1;let P,b;if(Array.isArray(w)){if(w.length!==y.length)return!1;for(P=0;P<w.length;P++)if(!k(w[P],y[P]))return!1}else{const o=[];for(b in w)o.push(b);o.sort();const s=[];for(b in y)s.push(b);if(s.sort(),!k(o,s))return!1;for(P=0;P<o.length;P++)if(!k(w[o[P]],y[o[P]]))return!1}return!0}e.equals=k;function i(w){const y=new Set;return JSON.stringify(w,(P,b)=>{if((0,g.isObject)(b)||Array.isArray(b)){if(y.has(b))return"[Circular]";y.add(b)}return b})}e.safeStringify=i;function I(w,y,P){const b=y(w);return typeof b=="undefined"?P:b}e.getOrDefault=I;function a(w,y){const P=Object.create(null);return!w||!y||Object.keys(y).forEach(o=>{const s=w[o],v=y[o];k(s,v)||(P[o]=v)}),P}e.distinct=a;function p(w,y){const P=y.toLowerCase(),b=Object.keys(w).find(o=>o.toLowerCase()===P);return b?w[b]:w[y]}e.getCaseInsensitive=p;function h(w,y){const P=Object.create(null);for(const b of Object.keys(w))y(b,w[b])&&(P[b]=w[b]);return P}e.filter=h}),define(fe[99],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var g;(function(S){S[S.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",S[S.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",S[S.MAX_UINT_8=255]="MAX_UINT_8",S[S.MAX_UINT_16=65535]="MAX_UINT_16",S[S.MAX_UINT_32=4294967295]="MAX_UINT_32",S[S.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(g=e.Constants||(e.Constants={}));function L(S){return S<0?0:S>255?255:S|0}e.toUint8=L;function D(S){return S<0?0:S>4294967295?4294967295:S|0}e.toUint32=D}),define(fe[2],me([0,1,9,12]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,S=/^\//,T=/^\/\//;function C(r,t){if(!r.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!D.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!S.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(r,t){return!r&&!t?"file":r}function k(r,t){switch(r){case"https":case"http":case"file":t?t[0]!==I&&(t=I+t):t=I;break}return t}const i="",I="/",a=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(t,u,l,c,m,d=!1){typeof t=="object"?(this.scheme=t.scheme||i,this.authority=t.authority||i,this.path=t.path||i,this.query=t.query||i,this.fragment=t.fragment||i):(this.scheme=E(t,d),this.authority=u||i,this.path=k(this.scheme,l||i),this.query=c||i,this.fragment=m||i,C(this,d))}static isUri(t){return t instanceof p?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return o(this,!1)}with(t){if(!t)return this;let{scheme:u,authority:l,path:c,query:m,fragment:d}=t;return u===void 0?u=this.scheme:u===null&&(u=i),l===void 0?l=this.authority:l===null&&(l=i),c===void 0?c=this.path:c===null&&(c=i),m===void 0?m=this.query:m===null&&(m=i),d===void 0?d=this.fragment:d===null&&(d=i),u===this.scheme&&l===this.authority&&c===this.path&&m===this.query&&d===this.fragment?this:new w(u,l,c,m,d)}static parse(t,u=!1){const l=a.exec(t);return l?new w(l[2]||i,f(l[4]||i),f(l[5]||i),f(l[7]||i),f(l[9]||i),u):new w(i,i,i,i,i)}static file(t){let u=i;if(L.isWindows&&(t=t.replace(/\\/g,I)),t[0]===I&&t[1]===I){const l=t.indexOf(I,2);l===-1?(u=t.substring(2),t=I):(u=t.substring(2,l),t=t.substring(l)||I)}return new w("file",u,t,i,i)}static from(t){const u=new w(t.scheme,t.authority,t.path,t.query,t.fragment);return C(u,!0),u}static joinPath(t,...u){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return L.isWindows&&t.scheme==="file"?l=p.file(g.win32.join(o(t,!0),...u)).path:l=g.posix.join(t.path,...u),t.with({path:l})}toString(t=!1){return s(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof p)return t;{const u=new w(t);return u._formatted=t.external,u._fsPath=t._sep===h?t.fsPath:null,u}}else return t}}e.URI=p;const h=L.isWindows?1:void 0;class w extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(t=!1){return t?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=h),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const y={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function P(r,t){let u,l=-1;for(let c=0;c<r.length;c++){const m=r.charCodeAt(c);if(m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57||m===45||m===46||m===95||m===126||t&&m===47)l!==-1&&(u+=encodeURIComponent(r.substring(l,c)),l=-1),u!==void 0&&(u+=r.charAt(c));else{u===void 0&&(u=r.substr(0,c));const d=y[m];d!==void 0?(l!==-1&&(u+=encodeURIComponent(r.substring(l,c)),l=-1),u+=d):l===-1&&(l=c)}}return l!==-1&&(u+=encodeURIComponent(r.substring(l))),u!==void 0?u:r}function b(r){let t;for(let u=0;u<r.length;u++){const l=r.charCodeAt(u);l===35||l===63?(t===void 0&&(t=r.substr(0,u)),t+=y[l]):t!==void 0&&(t+=r[u])}return t!==void 0?t:r}function o(r,t){let u;return r.authority&&r.path.length>1&&r.scheme==="file"?u=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?t?u=r.path.substr(1):u=r.path[1].toLowerCase()+r.path.substr(2):u=r.path,L.isWindows&&(u=u.replace(/\//g,"\\")),u}e.uriToFsPath=o;function s(r,t){const u=t?b:P;let l="",{scheme:c,authority:m,path:d,query:_,fragment:A}=r;if(c&&(l+=c,l+=":"),(m||c==="file")&&(l+=I,l+=I),m){let R=m.indexOf("@");if(R!==-1){const B=m.substr(0,R);m=m.substr(R+1),R=B.indexOf(":"),R===-1?l+=u(B,!1):(l+=u(B.substr(0,R),!1),l+=":",l+=u(B.substr(R+1),!1)),l+="@"}m=m.toLowerCase(),R=m.indexOf(":"),R===-1?l+=u(m,!1):(l+=u(m.substr(0,R),!1),l+=m.substr(R))}if(d){if(d.length>=3&&d.charCodeAt(0)===47&&d.charCodeAt(2)===58){const R=d.charCodeAt(1);R>=65&&R<=90&&(d=`/${String.fromCharCode(R+32)}:${d.substr(3)}`)}else if(d.length>=2&&d.charCodeAt(1)===58){const R=d.charCodeAt(0);R>=65&&R<=90&&(d=`${String.fromCharCode(R+32)}:${d.substr(2)}`)}l+=u(d,!0)}return _&&(l+="?",l+=u(_,!1)),A&&(l+="#",l+=t?A:P(A,!1)),l}function v(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+v(r.substr(3)):r}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function f(r){return r.match(n)?r.replace(n,t=>v(t)):r}}),define(fe[62],me([0,1,22,8,2]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function S(i){return JSON.stringify(i,E)}e.stringify=S;function T(i){let I=JSON.parse(i);return I=k(I),I}e.parse=T;var C;(function(i){i[i.Uri=1]="Uri",i[i.Regexp=2]="Regexp",i[i.ScmResource=3]="ScmResource",i[i.ScmResourceGroup=4]="ScmResourceGroup",i[i.ScmProvider=5]="ScmProvider",i[i.CommentController=6]="CommentController",i[i.CommentThread=7]="CommentThread",i[i.CommentThreadReply=8]="CommentThreadReply",i[i.CommentNode=9]="CommentNode",i[i.CommentThreadNode=10]="CommentThreadNode",i[i.TimelineActionContext=11]="TimelineActionContext",i[i.NotebookCellActionContext=12]="NotebookCellActionContext",i[i.TestItemContext=13]="TestItemContext"})(C=e.MarshalledId||(e.MarshalledId={}));function E(i,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,L.regExpFlags)(I)}:I}function k(i,I=0){if(!i||I>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return D.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof g.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let a=0;a<i.length;++a)i[a]=k(i[a],I+1);else for(const a in i)Object.hasOwnProperty.call(i,a)&&(i[a]=k(i[a],I+1))}return i}e.revive=k}),define(fe[10],me([0,1,12,2]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(C){C.inMemory="inmemory",C.vscode="vscode",C.internal="private",C.walkThrough="walkThrough",C.walkThroughSnippet="walkThroughSnippet",C.http="http",C.https="https",C.file="file",C.mailto="mailto",C.untitled="untitled",C.data="data",C.command="command",C.vscodeRemote="vscode-remote",C.vscodeRemoteResource="vscode-remote-resource",C.userData="vscode-userdata",C.vscodeCustomEditor="vscode-custom-editor",C.vscodeNotebook="vscode-notebook",C.vscodeNotebookCell="vscode-notebook-cell",C.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",C.vscodeNotebookCellOutput="vscode-notebook-cell-output",C.vscodeInteractive="vscode-interactive",C.vscodeInteractiveInput="vscode-interactive-input",C.vscodeSettings="vscode-settings",C.vscodeWorkspaceTrust="vscode-workspace-trust",C.vscodeTerminal="vscode-terminal",C.webviewPanel="webview-panel",C.vscodeWebview="vscode-webview",C.extension="extension",C.vscodeFileResource="vscode-file",C.tmp="tmp",C.vsls="vsls"})(D=e.Schemas||(e.Schemas={}));class S{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(E){this._preferredWebSchema=E}setDelegate(E){this._delegate=E}set(E,k,i){this._hosts[E]=k,this._ports[E]=i}setConnectionToken(E,k){this._connectionTokens[E]=k}rewrite(E){if(this._delegate)return this._delegate(E);const k=E.authority;let i=this._hosts[k];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const I=this._ports[k],a=this._connectionTokens[k];let p=`path=${encodeURIComponent(E.path)}`;return typeof a=="string"&&(p+=`&tkn=${encodeURIComponent(a)}`),L.URI.from({scheme:g.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${i}:${I}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new S;class T{asBrowserUri(E,k){const i=this.toUri(E,k);return i.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(i):i.scheme===D.file&&(g.isNative||typeof g.globals.importScripts=="function"&&g.globals.origin===`${D.vscodeFileResource}://${T.FALLBACK_AUTHORITY}`)?i.with({scheme:D.vscodeFileResource,authority:i.authority||T.FALLBACK_AUTHORITY,query:null,fragment:null}):i}asFileUri(E,k){const i=this.toUri(E,k);return i.scheme===D.vscodeFileResource?i.with({scheme:D.file,authority:i.authority!==T.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(E,k){return L.URI.isUri(E)?E:L.URI.parse(k.toUrl(E))}}T.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new T}),define(fe[23],me([0,1,29,10,9,12,8,2]),function(Y,e,g,L,D,S,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function E(p){return(0,C.uriToFsPath)(p,!0)}e.originalFSPath=E;class k{constructor(h){this._ignorePathCasing=h}compare(h,w,y=!1){return h===w?0:(0,T.compare)(this.getComparisonKey(h,y),this.getComparisonKey(w,y))}isEqual(h,w,y=!1){return h===w?!0:!h||!w?!1:this.getComparisonKey(h,y)===this.getComparisonKey(w,y)}getComparisonKey(h,w=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,w,y=!1){if(h.scheme===w.scheme){if(h.scheme===L.Schemas.file)return g.isEqualOrParent(E(h),E(w),this._ignorePathCasing(h))&&h.query===w.query&&(y||h.fragment===w.fragment);if((0,e.isEqualAuthority)(h.authority,w.authority))return g.isEqualOrParent(h.path,w.path,this._ignorePathCasing(h),"/")&&h.query===w.query&&(y||h.fragment===w.fragment)}return!1}joinPath(h,...w){return C.URI.joinPath(h,...w)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return D.posix.basename(h.path)}extname(h){return D.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let w;return h.scheme===L.Schemas.file?w=C.URI.file(D.dirname(E(h))).path:(w=D.posix.dirname(h.path),h.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),w="/")),h.with({path:w})}normalizePath(h){if(!h.path.length)return h;let w;return h.scheme===L.Schemas.file?w=C.URI.file(D.normalize(E(h))).path:w=D.posix.normalize(h.path),h.with({path:w})}relativePath(h,w){if(h.scheme!==w.scheme||!(0,e.isEqualAuthority)(h.authority,w.authority))return;if(h.scheme===L.Schemas.file){const b=D.relative(E(h),E(w));return S.isWindows?g.toSlashes(b):b}let y=h.path||"/",P=w.path||"/";if(this._ignorePathCasing(h)){let b=0;for(const o=Math.min(y.length,P.length);b<o&&!(y.charCodeAt(b)!==P.charCodeAt(b)&&y.charAt(b).toLowerCase()!==P.charAt(b).toLowerCase());b++);y=P.substr(0,b)+y.substr(b)}return D.posix.relative(y,P)}resolvePath(h,w){if(h.scheme===L.Schemas.file){const y=C.URI.file(D.resolve(E(h),w));return h.with({authority:y.authority,path:y.path})}return w=g.toPosixPath(w),h.with({path:D.posix.resolve(h.path,w)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,w){return h===w||h!==void 0&&w!==void 0&&(0,T.equalsIgnoreCase)(h,w)}hasTrailingPathSeparator(h,w=D.sep){if(h.scheme===L.Schemas.file){const y=E(h);return y.length>g.getRoot(y).length&&y[y.length-1]===w}else{const y=h.path;return y.length>1&&y.charCodeAt(y.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,w=D.sep){return(0,e.hasTrailingPathSeparator)(h,w)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,w=D.sep){let y=!1;if(h.scheme===L.Schemas.file){const P=E(h);y=P!==void 0&&P.length===g.getRoot(P).length&&P[P.length-1]===w}else{w="/";const P=h.path;y=P.length===1&&P.charCodeAt(P.length-1)===47}return!y&&!(0,e.hasTrailingPathSeparator)(h,w)?h.with({path:h.path+"/"}):h}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(p=>p.scheme===L.Schemas.file?!S.isLinux:!0),e.extUriIgnorePathCase=new k(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(p,h){const w=[];for(let y=0;y<p.length;y++){const P=h(p[y]);p.some((b,o)=>o===y?!1:(0,e.isEqualOrParent)(P,h(b)))||w.push(p[y])}return w}e.distinctParents=i;var I;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function h(w){const y=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(o=>{const[s,v]=o.split(":");s&&v&&y.set(s,v)});const b=w.path.substring(0,w.path.indexOf(";"));return b&&y.set(p.META_DATA_MIME,b),y}p.parseMetaData=h})(I=e.DataUri||(e.DataUri={}));function a(p,h,w){if(h){let y=p.path;return y&&y[0]!==D.posix.sep&&(y=D.posix.sep+y),p.with({scheme:w,authority:h,path:y})}return p.with({scheme:w})}e.toLocalResource=a}),define(fe[16],me([0,1,21,18,3,6,23]),function(Y,e,g,L,D,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function C(N){return!!N&&typeof N.then=="function"}e.isThenable=C;function E(N){const x=new g.CancellationTokenSource,j=N(x.token),O=new Promise((H,W)=>{const X=x.token.onCancellationRequested(()=>{X.dispose(),x.dispose(),W((0,L.canceled)())});Promise.resolve(j).then(Q=>{X.dispose(),x.dispose(),H(Q)},Q=>{X.dispose(),x.dispose(),W(Q)})});return new class{cancel(){x.cancel()}then(H,W){return O.then(H,W)}catch(H){return this.then(void 0,H)}finally(H){return O.finally(H)}}}e.createCancelablePromise=E;function k(N,x,j){return Promise.race([N,new Promise(O=>x.onCancellationRequested(()=>O(j)))])}e.raceCancellation=k;async function i(N){let x=-1;const j=N.map((H,W)=>H.then(X=>(x=W,X))),O=await Promise.race(j);return N.forEach((H,W)=>{W!==x&&H.cancel()}),O}e.raceCancellablePromises=i;function I(N,x,j){let O;const H=setTimeout(()=>{O?.(void 0),j?.()},x);return Promise.race([N.finally(()=>clearTimeout(H)),new Promise(W=>O=W)])}e.raceTimeout=I;function a(N){return new Promise((x,j)=>{const O=N();C(O)?O.then(x,j):x(O)})}e.asPromise=a;class p{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(x){if(this.activePromise){if(this.queuedPromiseFactory=x,!this.queuedPromise){const j=()=>{this.queuedPromise=null;const O=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,O};this.queuedPromise=new Promise(O=>{this.activePromise.then(j,j).then(O)})}return new Promise((j,O)=>{this.queuedPromise.then(j,O)})}return this.activePromise=x(),new Promise((j,O)=>{this.activePromise.then(H=>{this.activePromise=null,j(H)},H=>{this.activePromise=null,O(H)})})}}e.Throttler=p;class h{constructor(){this.current=Promise.resolve(null)}queue(x){return this.current=this.current.then(()=>x(),()=>x())}}e.Sequencer=h;class w{constructor(){this.promiseMap=new Map}queue(x,j){const H=(this.promiseMap.get(x)??Promise.resolve()).catch(()=>{}).then(j).finally(()=>{this.promiseMap.get(x)===H&&this.promiseMap.delete(x)});return this.promiseMap.set(x,H),H}}e.SequencerByKey=w;class y{constructor(x){this.defaultDelay=x,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(x,j=this.defaultDelay){return this.task=x,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((O,H)=>{this.doResolve=O,this.doReject=H}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const O=this.task;return this.task=null,O()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},j),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=y;class P{constructor(x){this.delayer=new y(x),this.throttler=new p}trigger(x,j){return this.delayer.trigger(()=>this.throttler.queue(x),j)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=P;class b{constructor(){this._isOpen=!1,this._promise=new Promise((x,j)=>{this._completePromise=x})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=b;class o extends b{constructor(x){super();this._timeout=setTimeout(()=>this.open(),x)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function s(N,x){return x?new Promise((j,O)=>{const H=setTimeout(()=>{W.dispose(),j()},N),W=x.onCancellationRequested(()=>{clearTimeout(H),W.dispose(),O((0,L.canceled)())})}):E(j=>s(N,j))}e.timeout=s;function v(N,x=0){const j=setTimeout(N,x);return(0,S.toDisposable)(()=>clearTimeout(j))}e.disposableTimeout=v;function n(N){const x=[];let j=0;const O=N.length;function H(){return j<O?N[j++]():null}function W(X){X!=null&&x.push(X);const Q=H();return Q?Q.then(W):Promise.resolve(x)}return Promise.resolve(null).then(W)}e.sequence=n;function f(N,x=O=>!!O,j=null){let O=0;const H=N.length,W=()=>{if(O>=H)return Promise.resolve(j);const X=N[O++];return Promise.resolve(X()).then(de=>x(de)?Promise.resolve(de):W())};return W()}e.first=f;function r(N,x=O=>!!O,j=null){if(N.length===0)return Promise.resolve(j);let O=N.length;const H=()=>{O=-1;for(const W of N)W.cancel?.()};return new Promise((W,X)=>{for(const Q of N)Q.then(de=>{--O>=0&&x(de)?(H(),W(de)):O===0&&W(j)}).catch(de=>{--O>=0&&(H(),X(de))})})}e.firstParallel=r;class t{constructor(x){this._size=0,this.maxDegreeOfParalellism=x,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(x){return this._size++,new Promise((j,O)=>{this.outstandingPromises.push({factory:x,c:j,e:O}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const x=this.outstandingPromises.shift();this.runningPromises++;const j=x.factory();j.then(x.c,x.e),j.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=t;class u extends t{constructor(){super(1)}}e.Queue=u;class l{constructor(){this.queues=new Map}queueFor(x,j=T.extUri){const O=j.getComparisonKey(x);let H=this.queues.get(O);return H||(H=new u,D.Event.once(H.onFinished)(()=>{H?.dispose(),this.queues.delete(O)}),this.queues.set(O,H)),H}dispose(){this.queues.forEach(x=>x.dispose()),this.queues.clear()}}e.ResourceQueue=l;class c{constructor(x,j){this._token=-1,typeof x=="function"&&typeof j=="number"&&this.setIfNotSet(x,j)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(x,j){this.cancel(),this._token=setTimeout(()=>{this._token=-1,x()},j)}setIfNotSet(x,j){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,x()},j))}}e.TimeoutTimer=c;class m{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(x,j){this.cancel(),this._token=setInterval(()=>{x()},j)}}e.IntervalTimer=m;class d{constructor(x,j){this.timeoutToken=-1,this.runner=x,this.timeout=j,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(x=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,x)}get delay(){return this.timeout}set delay(x){this.timeout=x}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=d;class _{constructor(x,j){j%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${j}ms is not a multiple of 1000ms.`),this.runner=x,this.timeout=j,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(x=this.timeout){x%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(x/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=_;class A extends d{constructor(x,j){super(x,j);this.units=[]}work(x){this.units.push(x),this.isScheduled()||this.schedule()}doRun(){const x=this.units;this.units=[],this.runner&&this.runner(x)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=A;class R extends S.Disposable{constructor(x,j,O,H){super();this.maxWorkChunkSize=x,this.maxPendingWork=j,this.throttleDelay=O,this.handler=H,this.pendingWork=[],this.throttler=this._register(new S.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(x){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+x.length>this.maxPendingWork)return!1}else if(this.pending+x.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...x),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new d(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=R,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=N=>{const x=setTimeout(()=>{const O=Date.now()+15;N(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let j=!1;return{dispose(){j||(j=!0,clearTimeout(x))}}}:e.runWhenIdle=(N,x)=>{const j=requestIdleCallback(N,typeof x=="number"?{timeout:x}:void 0);let O=!1;return{dispose(){O||(O=!0,cancelIdleCallback(j))}}}}();class B{constructor(x){this._didRun=!1,this._executor=()=>{try{this._value=x()}catch(j){this._error=j}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=B;async function U(N,x,j){let O;for(let H=0;H<j;H++)try{return await N()}catch(W){O=W,await s(x)}throw O}e.retry=U;class F{hasPending(x){return this._pending?typeof x=="number"?this._pending.taskId===x:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(x,j,O){return this._pending={taskId:x,cancel:()=>O?.(),promise:j},j.then(()=>this.donePending(x),()=>this.donePending(x)),j}donePending(x){this._pending&&x===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const x=this._next;this._next=void 0,x.run().then(x.promiseResolve,x.promiseReject)}}setNext(x){if(this._next)this._next.run=x;else{let j,O;const H=new Promise((W,X)=>{j=W,O=X});this._next={run:x,promise:H,promiseResolve:j,promiseReject:O}}return this._next.promise}}e.TaskSequentializer=F;class ${constructor(x){this.interval=x,this.lastIncrementTime=0,this.value=0}increment(){const x=Date.now();return x-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=x,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class M{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((x,j)=>{this.completeCallback=x,this.errorCallback=j})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(x){return new Promise(j=>{this.completeCallback(x),this.resolved=!0,j()})}error(x){return new Promise(j=>{this.errorCallback(x),this.rejected=!0,j()})}cancel(){new Promise(x=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,x()})}}e.DeferredPromise=M;var z;(function(N){async function x(O){let H;const W=await Promise.all(O.map(X=>X.then(Q=>Q,Q=>{H||(H=Q)})));if(typeof H!="undefined")throw H;return W}N.settled=x;function j(O){return new Promise(async(H,W)=>{try{await O(H,W)}catch(X){W(X)}})}N.withAsyncBody=j})(z=e.Promises||(e.Promises={}))}),define(fe[100],me([0,1,16,9]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const D=new g.IdleValue(()=>{const d=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:d,collatorIsNumeric:d.resolvedOptions().numeric}}),S=new g.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),T=new g.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function C(d,_,A=!1){const R=d||"",B=_||"",U=D.value.collator.compare(R,B);return D.value.collatorIsNumeric&&U===0&&R!==B?R<B?-1:1:U}e.compareFileNames=C;function E(d,_){const A=S.value.collator;return d=d||"",_=_||"",v(A,d,_)}e.compareFileNamesDefault=E;function k(d,_){const A=S.value.collator;return d=d||"",_=_||"",t(d,_)||v(A,d,_)}e.compareFileNamesUpper=k;function i(d,_){const A=S.value.collator;return d=d||"",_=_||"",r(d,_)||v(A,d,_)}e.compareFileNamesLower=i;function I(d,_){return d=d||"",_=_||"",d===_?0:d<_?-1:1}e.compareFileNamesUnicode=I;function a(d,_,A=!1){A||(d=d&&d.toLowerCase(),_=_&&_.toLowerCase());const[R,B]=o(d),[U,F]=o(_);return R!==U?R<U?-1:1:B===F?0:B<F?-1:1}e.noIntlCompareFileNames=a;function p(d,_){const[A,R]=o(d),[B,U]=o(_);let F=D.value.collator.compare(R,U);if(F===0){if(D.value.collatorIsNumeric&&R!==U)return R<U?-1:1;if(F=D.value.collator.compare(A,B),D.value.collatorIsNumeric&&F===0&&A!==B)return A<B?-1:1}return F}e.compareFileExtensions=p;function h(d,_){d=d||"",_=_||"";const A=s(d),R=s(_),B=S.value.collator,U=T.value.collator;return v(U,A,R)||v(B,d,_)}e.compareFileExtensionsDefault=h;function w(d,_){d=d||"",_=_||"";const A=s(d),R=s(_),B=S.value.collator,U=T.value.collator;return v(U,A,R)||t(d,_)||v(B,d,_)}e.compareFileExtensionsUpper=w;function y(d,_){d=d||"",_=_||"";const A=s(d),R=s(_),B=S.value.collator,U=T.value.collator;return v(U,A,R)||r(d,_)||v(B,d,_)}e.compareFileExtensionsLower=y;function P(d,_){d=d||"",_=_||"";const A=s(d).toLowerCase(),R=s(_).toLowerCase();return A!==R?A<R?-1:1:d!==_?d<_?-1:1:0}e.compareFileExtensionsUnicode=P;const b=/^(.*?)(\.([^.]*))?$/;function o(d,_=!1){const A=d?b.exec(d):[];let R=[A&&A[1]||"",A&&A[3]||""];return _&&(!R[0]&&R[1]||R[0]&&R[0].charAt(0)===".")&&(R=[R[0]+"."+R[1],""]),R}function s(d){const _=d?b.exec(d):[];return _&&_[1]&&_[1].charAt(0)!=="."&&_[3]||""}function v(d,_,A){let R=d.compare(_,A);return R!==0?R:_.length!==A.length?_.length<A.length?-1:1:0}function n(d){const _=d.charAt(0);return _.toLocaleUpperCase()!==_}function f(d){const _=d.charAt(0);return _.toLocaleLowerCase()!==_}function r(d,_){return n(d)&&f(_)?-1:f(d)&&n(_)?1:0}function t(d,_){return f(d)&&n(_)?-1:n(d)&&f(_)?1:0}function u(d,_,A=!1){return A||(d=d&&d.toLowerCase(),_=_&&_.toLowerCase()),d===_?0:d<_?-1:1}function l(d,_,A=!1){const R=d.split(L.sep),B=_.split(L.sep),U=R.length-1,F=B.length-1;let $,M;for(let z=0;;z++){if($=U===z,M=F===z,$&&M)return C(R[z],B[z],A);if($)return-1;if(M)return 1;const N=u(R[z],B[z],A);if(N!==0)return N}}e.comparePaths=l;function c(d,_,A){const R=d.toLowerCase(),B=_.toLowerCase(),U=m(d,_,A);if(U)return U;const F=R.endsWith(A),$=B.endsWith(A);if(F!==$)return F?-1:1;const M=C(R,B);return M!==0?M:R.localeCompare(B)}e.compareAnything=c;function m(d,_,A){const R=d.toLowerCase(),B=_.toLowerCase(),U=R.startsWith(A),F=B.startsWith(A);if(U!==F)return U?-1:1;if(U&&F){if(R.length<B.length)return-1;if(R.length>B.length)return 1}return 0}e.compareByPrefix=m}),define(fe[101],me([0,1,100,97,49,9,12,8]),function(Y,e,g,L,D,S,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const E=0,k=[E,[]];function i(N,x,j,O){if(!N||!x)return k;const H=N.length,W=x.length;if(H<W)return k;const X=N.toLowerCase();return I(x,j,W,N,X,H,O)}e.scoreFuzzy=i;function I(N,x,j,O,H,W,X){const Q=[],de=[];for(let Be=0;Be<j;Be++){const We=Be*W,He=We-W,G=Be>0,ee=N[Be],ie=x[Be];for(let ce=0;ce<W;ce++){const Z=ce>0,re=We+ce,pe=re-1,Me=He+ce-1,je=Z?Q[pe]:0,Ke=G&&Z?Q[Me]:0,Ze=G&&Z?de[Me]:0;let rt;!Ke&&G?rt=0:rt=a(ee,ie,O,H,ce,Ze),rt&&Ke+rt>=je&&(X||G||H.startsWith(x,ce))?(de[re]=Ze+1,Q[re]=Ke+rt):(de[re]=E,Q[re]=je)}}const _e=[];let Ce=j-1,Pe=W-1;for(;Ce>=0&&Pe>=0;){const Be=Ce*W+Pe;de[Be]===E||(_e.push(Pe),Ce--),Pe--}return[Q[j*W-1],_e.reverse()]}function a(N,x,j,O,H,W){let X=0;if(!p(x,O[H]))return X;if(X+=1,W>0&&(X+=W*5),N===j[H]&&(X+=1),H===0)X+=8;else{const Q=h(j.charCodeAt(H-1));Q?X+=Q:(0,L.isUpper)(j.charCodeAt(H))&&W===0&&(X+=2)}return X}function p(N,x){return N===x?!0:N==="/"||N==="\\"?x==="/"||x==="\\":!1}function h(N){switch(N){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const w=[void 0,[]];function y(N,x,j=0,O=0){const H=x;return H.values&&H.values.length>1?P(N,H.values,j,O):b(N,x,j,O)}e.scoreFuzzy2=y;function P(N,x,j,O){let H=0;const W=[];for(const X of x){const[Q,de]=b(N,X,j,O);if(typeof Q!="number")return w;H+=Q,W.push(...de)}return[H,m(W)]}function b(N,x,j,O){const H=(0,L.fuzzyScore)(x.original,x.originalLowercase,j,N,N.toLowerCase(),O,!0);return H?[H[0],(0,L.createMatches)(H)]:w}const o=Object.freeze({score:0}),s=1<<18,v=1<<17,n=1<<16;function f(N,x,j,O){const H=O.values?O.values:[O];return(0,D.hash)({[O.normalized]:{values:H.map(X=>({value:X.normalized,expectContiguousMatch:X.expectContiguousMatch})),label:N,description:x,allowNonContiguousMatches:j}})}function r(N,x,j,O,H){if(!N||!x.normalized)return o;const W=O.getItemLabel(N);if(!W)return o;const X=O.getItemDescription(N),Q=f(W,X,j,x),de=H[Q];if(de)return de;const _e=t(W,X,O.getItemPath(N),x,j);return H[Q]=_e,_e}e.scoreItemFuzzy=r;function t(N,x,j,O,H){const W=!j||!O.containsPathSeparator;return j&&(T.isLinux?O.pathNormalized===j:(0,C.equalsIgnoreCase)(O.pathNormalized,j))?{score:s,labelMatch:[{start:0,end:N.length}],descriptionMatch:x?[{start:0,end:x.length}]:void 0}:O.values&&O.values.length>1?u(N,x,j,O.values,W,H):l(N,x,j,O,W,H)}function u(N,x,j,O,H,W){let X=0;const Q=[],de=[];for(const _e of O){const{score:Ce,labelMatch:Pe,descriptionMatch:Be}=l(N,x,j,_e,H,W);if(Ce===E)return o;X+=Ce,Pe&&Q.push(...Pe),Be&&de.push(...Be)}return{score:X,labelMatch:m(Q),descriptionMatch:m(de)}}function l(N,x,j,O,H,W){if(H||!x){const[X,Q]=i(N,O.normalized,O.normalizedLowercase,W&&!O.expectContiguousMatch);if(X){const de=(0,L.matchesPrefix)(O.normalized,N);let _e;return de?(_e=v,_e+=Math.round(O.normalized.length/N.length*100)):_e=n,{score:_e+X,labelMatch:de||c(Q)}}}if(x){let X=x;j&&(X=`${x}${S.sep}`);const Q=X.length,de=`${X}${N}`,[_e,Ce]=i(de,O.normalized,O.normalizedLowercase,W&&!O.expectContiguousMatch);if(_e){const Pe=c(Ce),Be=[],We=[];return Pe.forEach(He=>{He.start<Q&&He.end>Q?(Be.push({start:0,end:He.end-Q}),We.push({start:He.start,end:Q})):He.start>=Q?Be.push({start:He.start-Q,end:He.end-Q}):We.push(He)}),{score:_e,labelMatch:Be,descriptionMatch:We}}}return o}function c(N){const x=[];if(!N)return x;let j;for(const O of N)j&&j.end===O?j.end+=1:(j={start:O,end:O+1},x.push(j));return x}function m(N){const x=N.sort((H,W)=>H.start-W.start),j=[];let O;for(const H of x)!O||!d(O,H)?(O=H,j.push(H)):(O.start=Math.min(O.start,H.start),O.end=Math.max(O.end,H.end));return j}function d(N,x){return!(N.end<x.start||x.end<N.start)}function _(N,x,j,O,H,W){const X=r(N,j,O,H,W),Q=r(x,j,O,H,W),de=X.score,_e=Q.score;if((de===s||_e===s)&&de!==_e)return de===s?-1:1;if(de>n||_e>n){if(de!==_e)return de>_e?-1:1;if(de<v&&_e<v){const ee=R(X.labelMatch,Q.labelMatch);if(ee!==0)return ee}const He=H.getItemLabel(N)||"",G=H.getItemLabel(x)||"";if(He.length!==G.length)return He.length-G.length}if(de!==_e)return de>_e?-1:1;const Ce=Array.isArray(X.labelMatch)&&X.labelMatch.length>0,Pe=Array.isArray(Q.labelMatch)&&Q.labelMatch.length>0;if(Ce&&!Pe)return-1;if(Pe&&!Ce)return 1;const Be=A(N,X,H),We=A(x,Q,H);return Be&&We&&Be!==We?We>Be?-1:1:B(N,x,j,H)}e.compareItemsByFuzzyScore=_;function A(N,x,j){let O=-1,H=-1;if(x.descriptionMatch&&x.descriptionMatch.length?O=x.descriptionMatch[0].start:x.labelMatch&&x.labelMatch.length&&(O=x.labelMatch[0].start),x.labelMatch&&x.labelMatch.length){if(H=x.labelMatch[x.labelMatch.length-1].end,x.descriptionMatch&&x.descriptionMatch.length){const W=j.getItemDescription(N);W&&(H+=W.length)}}else x.descriptionMatch&&x.descriptionMatch.length&&(H=x.descriptionMatch[x.descriptionMatch.length-1].end);return H-O}function R(N,x){if(!N&&!x||(!N||!N.length)&&(!x||!x.length))return 0;if(!x||!x.length)return-1;if(!N||!N.length)return 1;const j=N[0].start,H=N[N.length-1].end-j,W=x[0].start,Q=x[x.length-1].end-W;return H===Q?0:Q<H?1:-1}function B(N,x,j,O){const H=O.getItemLabel(N)||"",W=O.getItemLabel(x)||"",X=O.getItemDescription(N),Q=O.getItemDescription(x),de=H.length+(X?X.length:0),_e=W.length+(Q?Q.length:0);if(de!==_e)return de-_e;const Ce=O.getItemPath(N),Pe=O.getItemPath(x);return Ce&&Pe&&Ce.length!==Pe.length?Ce.length-Pe.length:H!==W?(0,g.compareAnything)(H,W,j.normalized):X&&Q&&X!==Q?(0,g.compareAnything)(X,Q,j.normalized):Ce&&Pe&&Ce!==Pe?(0,g.compareAnything)(Ce,Pe,j.normalized):0}function U(N){return N.startsWith('"')&&N.endsWith('"')}const F=" ";function $(N){typeof N!="string"&&(N="");const x=N.toLowerCase(),{pathNormalized:j,normalized:O,normalizedLowercase:H}=M(N),W=j.indexOf(S.sep)>=0,X=U(N);let Q;const de=N.split(F);if(de.length>1)for(const _e of de){const Ce=U(_e),{pathNormalized:Pe,normalized:Be,normalizedLowercase:We}=M(_e);Be&&(Q||(Q=[]),Q.push({original:_e,originalLowercase:_e.toLowerCase(),pathNormalized:Pe,normalized:Be,normalizedLowercase:We,expectContiguousMatch:Ce}))}return{original:N,originalLowercase:x,pathNormalized:j,normalized:O,normalizedLowercase:H,values:Q,containsPathSeparator:W,expectContiguousMatch:X}}e.prepareQuery=$;function M(N){let x;T.isWindows?x=N.replace(/\//g,S.sep):x=N.replace(/\\/g,S.sep);const j=(0,C.stripWildcards)(x).replace(/\s|"/g,"");return{pathNormalized:x,normalized:j,normalizedLowercase:j.toLowerCase()}}function z(N){return Array.isArray(N)?$(N.map(x=>x.original).join(F)):$(N.original)}e.pieceToQuery=z}),define(fe[30],me([0,1,16,29,24,9,8]),function(Y,e,g,L,D,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C;const E="**",k="/",i="[/\\\\]",I="[^/\\\\]",a=/\//g;function p(O){switch(O){case 0:return"";case 1:return`${I}*?`;default:return`(?:${i}|${I}+${i}|${i}${I}+)*?`}}function h(O,H){if(!O)return[];const W=[];let X=!1,Q=!1,de="";for(const _e of O){switch(_e){case H:if(!X&&!Q){W.push(de),de="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}de+=_e}return de&&W.push(de),W}e.splitGlobAware=h;function w(O){if(!O)return"";let H="";const W=h(O,k);if(W.every(X=>X===E))H=".*";else{let X=!1;W.forEach((Q,de)=>{if(Q===E){X||(H+=p(2),X=!0);return}let _e=!1,Ce="",Pe=!1,Be="";for(const We of Q){if(We!=="}"&&_e){Ce+=We;continue}if(Pe&&(We!=="]"||!Be)){let He;We==="-"?He=We:(We==="^"||We==="!")&&!Be?He="^":We===k?He="":He=T.escapeRegExpCharacters(We),Be+=He;continue}switch(We){case"{":_e=!0;continue;case"[":Pe=!0;continue;case"}":H+=`(?:${h(Ce,",").map(ee=>w(ee)).join("|")})`,_e=!1,Ce="";break;case"]":H+="["+Be+"]",Pe=!1,Be="";break;case"?":H+=I;continue;case"*":H+=p(1);continue;default:H+=T.escapeRegExpCharacters(We)}}de<W.length-1&&(W[de+1]!==E||de+2<W.length)&&(H+=i),X=!1})}return H}const y=/^\*\*\/\*\.[\w\.-]+$/,P=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,o=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,s=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new D.LRUCache(1e4),f=function(){return!1},r=function(){return null};function t(O,H){if(!O)return r;let W;typeof O!="string"?W=O.pattern:W=O,W=W.trim();const X=`${W}_${!!H.trimForExclusions}`;let Q=n.get(X);if(Q)return u(Q,O);let de;if(y.test(W)){const _e=W.substr(4);Q=function(Ce,Pe){return typeof Ce=="string"&&Ce.endsWith(_e)?W:null}}else(de=P.exec(l(W,H)))?Q=c(de[1],W):(H.trimForExclusions?o:b).test(W)?Q=m(W,H):(de=s.exec(l(W,H)))?Q=d(de[1].substr(1),W,!0):(de=v.exec(l(W,H)))?Q=d(de[1],W,!1):Q=_(W);return n.set(X,Q),u(Q,O)}function u(O,H){return typeof H=="string"?O:function(W,X){return L.isEqualOrParent(W,H.base)?O(S.relative(H.base,W),X):null}}function l(O,H){return H.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function c(O,H){const W=`/${O}`,X=`\\${O}`,Q=function(_e,Ce){return typeof _e!="string"?null:Ce?Ce===O?H:null:_e===O||_e.endsWith(W)||_e.endsWith(X)?H:null},de=[O];return Q.basenames=de,Q.patterns=[H],Q.allBasenames=de,Q}function m(O,H){const W=j(O.slice(1,-1).split(",").map(Ce=>t(Ce,H)).filter(Ce=>Ce!==r),O),X=W.length;if(!X)return r;if(X===1)return W[0];const Q=function(Ce,Pe){for(let Be=0,We=W.length;Be<We;Be++)if(W[Be](Ce,Pe))return O;return null},de=W.find(Ce=>!!Ce.allBasenames);de&&(Q.allBasenames=de.allBasenames);const _e=W.reduce((Ce,Pe)=>Pe.allPaths?Ce.concat(Pe.allPaths):Ce,[]);return _e.length&&(Q.allPaths=_e),Q}function d(O,H,W){const X=S.sep===S.posix.sep,Q=X?O:O.replace(a,S.sep),de=S.sep+Q,_e=S.posix.sep+O,Ce=W?function(Pe,Be){return typeof Pe=="string"&&(Pe===Q||Pe.endsWith(de)||!X&&(Pe===O||Pe.endsWith(_e)))?H:null}:function(Pe,Be){return typeof Pe=="string"&&(Pe===Q||!X&&Pe===O)?H:null};return Ce.allPaths=[(W?"*/":"./")+O],Ce}function _(O){try{const H=new RegExp(`^${w(O)}$`);return function(W){return H.lastIndex=0,typeof W=="string"&&H.test(W)?O:null}}catch(H){return r}}function A(O,H,W){return!O||typeof H!="string"?!1:R(O)(H,void 0,W)}e.match=A;function R(O,H={}){if(!O)return f;if(typeof O=="string"||$(O)){const W=t(O,H);if(W===r)return f;const X=function(Q,de){return!!W(Q,de)};return W.allBasenames&&(X.allBasenames=W.allBasenames),W.allPaths&&(X.allPaths=W.allPaths),X}return N(O,H)}e.parse=R;function B(O){if(!O)return;let H;return W=>(H||(H=(O()||Promise.resolve([])).then(X=>X?F(X):{})),H.then(X=>!!X[W]))}e.hasSiblingPromiseFn=B;function U(O){if(!O)return;let H;return W=>{if(!H){const X=O();H=X?F(X):{}}return!!H[W]}}e.hasSiblingFn=U;function F(O){const H={};for(const W of O)H[W]=!0;return H}function $(O){const H=O;return H&&typeof H.base=="string"&&typeof H.pattern=="string"}e.isRelativePattern=$;function M(O){return O.allBasenames||[]}e.getBasenameTerms=M;function z(O){return O.allPaths||[]}e.getPathTerms=z;function N(O,H){const W=j(Object.getOwnPropertyNames(O).map(Ce=>x(Ce,O[Ce],H)).filter(Ce=>Ce!==r)),X=W.length;if(!X)return r;if(!W.some(Ce=>!!Ce.requiresSiblings)){if(X===1)return W[0];const Ce=function(We,He){for(let G=0,ee=W.length;G<ee;G++){const ie=W[G](We,He);if(ie)return ie}return null},Pe=W.find(We=>!!We.allBasenames);Pe&&(Ce.allBasenames=Pe.allBasenames);const Be=W.reduce((We,He)=>He.allPaths?We.concat(He.allPaths):We,[]);return Be.length&&(Ce.allPaths=Be),Ce}const Q=function(Ce,Pe,Be){let We;for(let He=0,G=W.length;He<G;He++){const ee=W[He];ee.requiresSiblings&&Be&&(Pe||(Pe=S.basename(Ce)),We||(We=Pe.substr(0,Pe.length-S.extname(Ce).length)));const ie=ee(Ce,Pe,We,Be);if(ie)return ie}return null},de=W.find(Ce=>!!Ce.allBasenames);de&&(Q.allBasenames=de.allBasenames);const _e=W.reduce((Ce,Pe)=>Pe.allPaths?Ce.concat(Pe.allPaths):Ce,[]);return _e.length&&(Q.allPaths=_e),Q}function x(O,H,W){if(H===!1)return r;const X=t(O,W);if(X===r)return r;if(typeof H=="boolean")return X;if(H){const Q=H.when;if(typeof Q=="string"){const de=(_e,Ce,Pe,Be)=>{if(!Be||!X(_e,Ce))return null;const We=Q.replace("$(basename)",Pe),He=Be(We);return(0,g.isThenable)(He)?He.then(G=>G?O:null):He?O:null};return de.requiresSiblings=!0,de}}return X}function j(O,H){const W=O.filter(Ce=>!!Ce.basenames);if(W.length<2)return O;const X=W.reduce((Ce,Pe)=>{const Be=Pe.basenames;return Be?Ce.concat(Be):Ce},[]);let Q;if(H){Q=[];for(let Ce=0,Pe=X.length;Ce<Pe;Ce++)Q.push(H)}else Q=W.reduce((Ce,Pe)=>{const Be=Pe.patterns;return Be?Ce.concat(Be):Ce},[]);const de=function(Ce,Pe){if(typeof Ce!="string")return null;if(!Pe){let We;for(We=Ce.length;We>0;We--){const He=Ce.charCodeAt(We-1);if(He===47||He===92)break}Pe=Ce.substr(We)}const Be=X.indexOf(Pe);return Be!==-1?Q[Be]:null};de.basenames=X,de.patterns=Q,de.allBasenames=X;const _e=O.filter(Ce=>!Ce.basenames);return _e.push(de),_e}}),define(fe[81],me([0,1,29,10,9,12,23,8,2]),function(Y,e,g,L,D,S,T,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function k(t,u,l){if(typeof t=="string"&&(t=E.URI.file(t)),l){const m=l.getWorkspaceFolder(t);if(m){const d=l.getWorkspace().folders.length>1;let _;if((0,T.isEqual)(m.uri,t)?_="":_=(0,T.relativePath)(m.uri,t),d){const A=m.name?m.name:(0,T.basename)(m.uri);_=_?A+" \u2022 "+_:A}return _}}if(t.scheme!==L.Schemas.file&&t.scheme!==L.Schemas.untitled)return t.with({query:null,fragment:null}).toString(!0);if((0,g.hasDriveLetter)(t.fsPath))return(0,D.normalize)(I(t.fsPath));let c=(0,D.normalize)(t.fsPath);return!S.isWindows&&u?.userHome&&(c=p(c,u.userHome.fsPath)),c}e.getPathLabel=k;function i(t){if(!t)return;typeof t=="string"&&(t=E.URI.file(t));const u=(0,T.basename)(t)||(t.scheme===L.Schemas.file?t.fsPath:t.path);return S.isWindows&&(0,g.isRootOrDriveLetter)(u)?I(u):u}e.getBaseLabel=i;function I(t,u){return(0,g.hasDriveLetter)(t,u)?t.charAt(0).toUpperCase()+t.slice(1):t}e.normalizeDriveLetter=I;let a=Object.create(null);function p(t,u){if(S.isWindows||!t||!u)return t;let l=a.original===u?a.normalized:void 0;return l||(l=`${(0,C.rtrim)(u,D.posix.sep)}${D.posix.sep}`,a={original:u,normalized:l}),(S.isLinux?t.startsWith(l):(0,C.startsWithIgnoreCase)(t,l))&&(t=`~/${t.substr(l.length)}`),t}e.tildify=p;function h(t,u){return t.replace(/^~($|\/|\\)/,`${u}$1`)}e.untildify=h;const w="\u2026",y="\\\\",P="~";function b(t,u=D.sep){const l=new Array(t.length);let c=!1;for(let m=0;m<t.length;m++){let d=t[m];if(d===""){l[m]=`.${u}`;continue}if(!d){l[m]=d;continue}c=!0;let _="";d.indexOf(y)===0?(_=d.substr(0,d.indexOf(y)+y.length),d=d.substr(d.indexOf(y)+y.length)):d.indexOf(u)===0?(_=d.substr(0,d.indexOf(u)+u.length),d=d.substr(d.indexOf(u)+u.length)):d.indexOf(P)===0&&(_=d.substr(0,d.indexOf(P)+P.length),d=d.substr(d.indexOf(P)+P.length));const A=d.split(u);for(let R=1;c&&R<=A.length;R++)for(let B=A.length-R;c&&B>=0;B--){c=!1;let U=A.slice(B,B+R).join(u);for(let F=0;!c&&F<t.length;F++)if(F!==m&&t[F]&&t[F].indexOf(U)>-1){const $=B+R===A.length,M=B>0&&t[F].indexOf(u)>-1?u+U:U,z=t[F].endsWith(M);c=!$||z}if(!c){let F="";(A[0].endsWith(":")||_!=="")&&(B===1&&(B=0,R++,U=A[0]+u+U),B>0&&(F=A[0]+u),F=_+F),B>0&&(F=F+w+u),F=F+U,B+R<A.length&&(F=F+u+w),l[m]=F}}c&&(l[m]=d)}return l}e.shorten=b;var o;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(o||(o={}));function s(t,u=Object.create(null)){const l=[];let c=!1,m="";for(const d of t)if(d==="$"||c&&d==="{")m&&l.push({value:m,type:o.TEXT}),m="",c=!0;else if(d==="}"&&c){const _=u[m];if(typeof _=="string")_.length&&l.push({value:_,type:o.VARIABLE});else if(_){const A=l[l.length-1];(!A||A.type!==o.SEPARATOR)&&l.push({value:_.label,type:o.SEPARATOR})}m="",c=!1}else m+=d;return m&&!c&&l.push({value:m,type:o.TEXT}),l.filter((d,_)=>{if(d.type===o.SEPARATOR){const A=l[_-1],R=l[_+1];return[A,R].every(B=>B&&(B.type===o.VARIABLE||B.type===o.TEXT)&&B.value.length>0)}return!0}).map(d=>d.value).join("")}e.template=s;function v(t,u){return S.isMacintosh||u?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,S.isMacintosh?"&":"&&"):t.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.mnemonicMenuLabel=v;function n(t,u){return S.isMacintosh||u?t.replace(/\(&&\w\)|&&/g,""):S.isWindows?t.replace(/&&|&/g,l=>l==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.mnemonicButtonLabel=n;function f(t){return t.replace(/&/g,"&&")}e.unmnemonicLabel=f;function r(t){const u=t.indexOf("/")!==-1?D.posix:D.win32,l=u.basename(t),c=u.dirname(t);return l.length?{name:l,parentPath:c}:{name:c,parentPath:""}}e.splitName=r}),define(fe[102],me([0,1,30,10,9,23,8]),function(Y,e,g,L,D,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var C;(function(t){t.text="text/plain",t.binary="application/octet-stream",t.unknown="application/unknown",t.markdown="text/markdown",t.latex="text/latex"})(C=e.Mimes||(e.Mimes={}));let E=[],k=[],i=[];function I(t,u=!1){const l=a(t);E.push(l),l.userConfigured?i.push(l):k.push(l),u&&!l.userConfigured&&E.forEach(c=>{c.mime===l.mime||c.userConfigured||(l.extension&&c.extension===l.extension&&console.warn(`Overwriting extension <<${l.extension}>> to now point to mime <<${l.mime}>>`),l.filename&&c.filename===l.filename&&console.warn(`Overwriting filename <<${l.filename}>> to now point to mime <<${l.mime}>>`),l.filepattern&&c.filepattern===l.filepattern&&console.warn(`Overwriting filepattern <<${l.filepattern}>> to now point to mime <<${l.mime}>>`),l.firstline&&c.firstline===l.firstline&&console.warn(`Overwriting firstline <<${l.firstline}>> to now point to mime <<${l.mime}>>`))})}e.registerTextMime=I;function a(t){return{id:t.id,mime:t.mime,filename:t.filename,extension:t.extension,filepattern:t.filepattern,firstline:t.firstline,userConfigured:t.userConfigured,filenameLowercase:t.filename?t.filename.toLowerCase():void 0,extensionLowercase:t.extension?t.extension.toLowerCase():void 0,filepatternLowercase:t.filepattern?(0,g.parse)(t.filepattern.toLowerCase()):void 0,filepatternOnPath:t.filepattern?t.filepattern.indexOf(D.posix.sep)>=0:!1}}function p(t){t?(E=E.filter(u=>!u.userConfigured),i=[]):(E=[],k=[],i=[])}e.clearTextMimes=p;function h(t,u){let l;if(t)switch(t.scheme){case L.Schemas.file:l=t.fsPath;break;case L.Schemas.data:l=S.DataUri.parseMetaData(t).get(S.DataUri.META_DATA_LABEL);break;default:l=t.path}if(!l)return[C.unknown];l=l.toLowerCase();const c=(0,D.basename)(l),m=w(l,c,i);if(m)return[m,C.text];const d=w(l,c,k);if(d)return[d,C.text];if(u){const _=y(u);if(_)return[_,C.text]}return[C.unknown]}e.guessMimeTypes=h;function w(t,u,l){let c=null,m=null,d=null;for(let _=l.length-1;_>=0;_--){const A=l[_];if(u===A.filenameLowercase){c=A;break}if(A.filepattern&&(!m||A.filepattern.length>m.filepattern.length)){const R=A.filepatternOnPath?t:u;A.filepatternLowercase?.(R)&&(m=A)}A.extension&&(!d||A.extension.length>d.extension.length)&&u.endsWith(A.extensionLowercase)&&(d=A)}return c?c.mime:m?m.mime:d?d.mime:null}function y(t){if((0,T.startsWithUTF8BOM)(t)&&(t=t.substr(1)),t.length>0)for(let u=E.length-1;u>=0;u--){const l=E[u];if(!l.firstline)continue;const c=t.match(l.firstline);if(c&&c.length>0)return l.mime}return null}function P(t){return t?typeof t=="string"?t===C.binary||t===C.text||t===C.unknown:t.length===1&&P(t[0]):!0}e.isUnspecific=P;const b={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},o={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function s(t){const u=(0,D.extname)(t),l=b[u.toLowerCase()];return l!==void 0?l:v(t)}e.getMediaOrTextMime=s;function v(t){const u=(0,D.extname)(t);return o[u.toLowerCase()]}e.getMediaMime=v;function n(t){for(const u in o)if(o[u]===t)return u}e.getExtensionForMimeType=n;const f=/^(.+)\/(.+?)(;.+)?$/;function r(t,u){const l=f.exec(t);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:u?void 0:t}e.normalizeMimeType=r}),define(fe[103],me([0,1,2]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(i){return i.toJSON()}class D{constructor(I){this._uriTransformer=I}transformIncoming(I){const a=this._uriTransformer.transformIncoming(I);return a===I?I:L(g.URI.from(a))}transformOutgoing(I){const a=this._uriTransformer.transformOutgoing(I);return a===I?I:L(g.URI.from(a))}transformOutgoingURI(I){const a=this._uriTransformer.transformOutgoing(I);return a===I?I:g.URI.from(a)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function S(i,I,a){if(!i||a>200)return null;if(typeof i=="object"){if(i instanceof g.URI)return I.transformOutgoing(i);for(let p in i)if(Object.hasOwnProperty.call(i,p)){const h=S(i[p],I,a+1);h!==null&&(i[p]=h)}}return null}function T(i,I){const a=S(i,I,0);return a===null?i:a}e.transformOutgoingURIs=T;function C(i,I,a,p){if(!i||p>200)return null;if(typeof i=="object"){if(i.$mid===1)return a?g.URI.revive(I.transformIncoming(i)):I.transformIncoming(i);for(let h in i)if(Object.hasOwnProperty.call(i,h)){const w=C(i[h],I,a,p+1);w!==null&&(i[h]=w)}}return null}function E(i,I){const a=C(i,I,!1,0);return a===null?i:a}e.transformIncomingURIs=E;function k(i,I){const a=C(i,I,!0,0);return a===null?i:a}e.transformAndReviveIncomingURIs=k}),define(fe[31],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const g=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(E){return g.test(E)}e.isUUID=L;const D=new Uint8Array(16),S=[];for(let E=0;E<256;E++)S.push(E.toString(16).padStart(2,"0"));let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(E){for(let k=0;k<E.length;k++)E[k]=Math.floor(Math.random()*256);return E};function C(){T(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let E=0,k="";return k+=S[D[E++]],k+=S[D[E++]],k+=S[D[E++]],k+=S[D[E++]],k+="-",k+=S[D[E++]],k+=S[D[E++]],k+="-",k+=S[D[E++]],k+=S[D[E++]],k+="-",k+=S[D[E++]],k+=S[D[E++]],k+="-",k+=S[D[E++]],k+=S[D[E++]],k+=S[D[E++]],k+=S[D[E++]],k+=S[D[E++]],k+=S[D[E++]],k}e.generateUuid=C}),define(fe[143],me([0,1,104]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(S="utf8"){this.stringDecoder=new g.StringDecoder(S),this.remaining=null}write(S){const T=[],C=this.remaining?this.remaining+this.stringDecoder.write(S):this.stringDecoder.write(S);if(C.length<1)return T;let E=0,k,i=E;for(;i<C.length;)if(k=C.charCodeAt(i),k===13||k===10){if(T.push(C.substring(E,i)),i++,i<C.length){const I=k;k=C.charCodeAt(i),(I===13&&k===10||I===10&&k===13)&&i++}E=i}else i++;return this.remaining=E<C.length?C.substr(E):null,T}end(){return this.remaining}}e.LineDecoder=L}),define(fe[28],me([0,1,63,82,293,16,29,80,9,12,23,2,31]),function(Y,e,g,L,D,S,T,C,E,k,i,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function h(M,z=p.UNLINK){if((0,T.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return z===p.UNLINK?y(M):w(M)}async function w(M){try{const z=(0,E.join)((0,L.tmpdir)(),(0,a.generateUuid)());try{await e.Promises.rename(M,z)}catch(N){return y(M)}y(z).catch(N=>{})}catch(z){if(z.code!=="ENOENT")throw z}}async function y(M){return e.Promises.rmdir(M,{recursive:!0,maxRetries:3})}function P(M){if((0,T.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");g.rmdirSync(M,{recursive:!0})}e.rimrafSync=P;async function b(M,z){return v(await(z?o(M):(0,D.promisify)(g.readdir)(M)))}async function o(M){try{return await(0,D.promisify)(g.readdir)(M,{withFileTypes:!0})}catch(x){console.warn("[node.js fs] readdir with filetypes failed with error: ",x)}const z=[],N=await b(M);for(const x of N){let j=!1,O=!1,H=!1;try{const W=await e.Promises.lstat((0,E.join)(M,x));j=W.isFile(),O=W.isDirectory(),H=W.isSymbolicLink()}catch(W){console.warn("[node.js fs] unexpected error from lstat after readdir: ",W)}z.push({name:x,isFile:()=>j,isDirectory:()=>O,isSymbolicLink:()=>H})}return z}function s(M){return v(g.readdirSync(M))}e.readdirSync=s;function v(M){return M.map(z=>typeof z=="string"?k.isMacintosh?(0,C.normalizeNFC)(z):z:(z.name=k.isMacintosh?(0,C.normalizeNFC)(z.name):z.name,z))}async function n(M){const z=await b(M),N=[];for(const x of z)await r.existsDirectory((0,E.join)(M,x))&&N.push(x);return N}function f(M,z=1e3){return new Promise(N=>{let x=!1;const j=setInterval(()=>{x||(x=!0,g.access(M,O=>{x=!1,O&&(clearInterval(j),N(void 0))}))},z)})}e.whenDeleted=f;var r;(function(M){async function z(j){let O;try{if(O=await e.Promises.lstat(j),!O.isSymbolicLink())return{stat:O}}catch(H){}try{return{stat:await e.Promises.stat(j),symbolicLink:O?.isSymbolicLink()?{dangling:!1}:void 0}}catch(H){if(H.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};if(k.isWindows&&H.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(j)),symbolicLink:{dangling:!1}}}catch(W){if(W.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};throw W}throw H}}M.stat=z;async function N(j){try{const{stat:O,symbolicLink:H}=await M.stat(j);return O.isFile()&&H?.dangling!==!0}catch(O){}return!1}M.existsFile=N;async function x(j){try{const{stat:O,symbolicLink:H}=await M.stat(j);return O.isDirectory()&&H?.dangling!==!0}catch(O){}return!1}M.existsDirectory=x})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new S.ResourceQueue;function u(M,z,N){return t.queueFor(I.URI.file(M),i.extUriBiasedIgnorePathCase).queue(()=>{const x=d(N);return new Promise((j,O)=>c(M,z,x,H=>H?O(H):j()))})}let l=!0;function c(M,z,N,x){if(!l)return g.writeFile(M,z,{mode:N.mode,flag:N.flag},x);g.open(M,N.flag,N.mode,(j,O)=>{if(j)return x(j);g.writeFile(O,z,H=>{if(H)return g.close(O,()=>x(H));g.fdatasync(O,W=>(W&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",W),l=!1),g.close(O,X=>x(X))))})})}function m(M,z,N){const x=d(N);if(!l)return g.writeFileSync(M,z,{mode:x.mode,flag:x.flag});const j=g.openSync(M,x.flag,x.mode);try{g.writeFileSync(j,z);try{g.fdatasyncSync(j)}catch(O){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",O),l=!1}}finally{g.closeSync(j)}}e.writeFileSync=m;function d(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function _(M,z){if(M===z)return;async function N(x){try{const j=await e.Promises.lstat(x);if(j.isDirectory()||j.isSymbolicLink())return;await e.Promises.utimes(x,j.atime,new Date)}catch(j){}}try{await e.Promises.rename(M,z),await N(z)}catch(x){if(M.toLowerCase()!==z.toLowerCase()&&x.code==="EXDEV"||M.endsWith("."))await A(M,z,{preserveSymlinks:!1}),await h(M,p.MOVE),await N(z);else throw x}}async function A(M,z,N){return B(M,z,{root:{source:M,target:z},options:N,handledSourcePaths:new Set})}const R=511;async function B(M,z,N){if(N.handledSourcePaths.has(M))return;N.handledSourcePaths.add(M);const{stat:x,symbolicLink:j}=await r.stat(M);if(j){if(N.options.preserveSymlinks)try{return await $(M,z,N)}catch(O){console.warn("[node.js fs] copy of symlink failed: ",O)}if(j.dangling)return}return x.isDirectory()?U(M,z,x.mode&R,N):F(M,z,x.mode&R)}async function U(M,z,N,x){await e.Promises.mkdir(z,{recursive:!0,mode:N});const j=await b(M);for(const O of j)await B((0,E.join)(M,O),(0,E.join)(z,O),x)}async function F(M,z,N){await e.Promises.copyFile(M,z),await e.Promises.chmod(z,N)}async function $(M,z,N){let x=await e.Promises.readlink(M);(0,T.isEqualOrParent)(x,N.root.source,!k.isLinux)&&(x=(0,E.join)(N.root.target,x.substr(N.root.source.length+1))),await e.Promises.symlink(x,z)}e.Promises=new class{get access(){return(0,D.promisify)(g.access)}get stat(){return(0,D.promisify)(g.stat)}get lstat(){return(0,D.promisify)(g.lstat)}get utimes(){return(0,D.promisify)(g.utimes)}get read(){return(0,D.promisify)(g.read)}get readFile(){return(0,D.promisify)(g.readFile)}get write(){return(0,D.promisify)(g.write)}get appendFile(){return(0,D.promisify)(g.appendFile)}get fdatasync(){return(0,D.promisify)(g.fdatasync)}get truncate(){return(0,D.promisify)(g.truncate)}get rename(){return(0,D.promisify)(g.rename)}get copyFile(){return(0,D.promisify)(g.copyFile)}get open(){return(0,D.promisify)(g.open)}get close(){return(0,D.promisify)(g.close)}get symlink(){return(0,D.promisify)(g.symlink)}get readlink(){return(0,D.promisify)(g.readlink)}get chmod(){return(0,D.promisify)(g.chmod)}get mkdir(){return(0,D.promisify)(g.mkdir)}get unlink(){return(0,D.promisify)(g.unlink)}get rmdir(){return(0,D.promisify)(g.rmdir)}get realpath(){return(0,D.promisify)(g.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return b}get readDirsInDir(){return n}get writeFile(){return u}get rm(){return h}get move(){return _}get copy(){return A}}}),define(fe[105],me([0,1,63,9,8,28]),function(Y,e,g,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function T(i){const I=(0,L.dirname)(i);if(i===I)return i;const a=((0,L.basename)(i)||i).toLowerCase();try{const h=(0,S.readdirSync)(I).filter(w=>w.toLowerCase()===a);if(h.length===1){const w=T(I);if(w)return(0,L.join)(w,h[0])}else if(h.length>1){const w=h.indexOf(a);if(w>=0){const y=T(I);if(y)return(0,L.join)(y,h[w])}}}catch(p){}return null}e.realcaseSync=T;async function C(i){try{return await S.Promises.realpath(i)}catch(I){const a=k(i);return await S.Promises.access(a,g.constants.R_OK),a}}e.realpath=C;function E(i){try{return g.realpathSync(i)}catch(I){const a=k(i);return g.accessSync(a,g.constants.R_OK),a}}e.realpathSync=E;function k(i){return(0,D.rtrim)((0,L.normalize)(i),L.sep)}});var Ve=this&&this.__decorate||function(Y,e,g,L){var D=arguments.length,S=D<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,g):L,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")S=Reflect.decorate(Y,e,g,L);else for(var C=Y.length-1;C>=0;C--)(T=Y[C])&&(S=(D<3?T(S):D>3?T(e,g,S):T(e,g))||S);return D>3&&S&&Object.defineProperty(e,g,S),S};define(fe[106],me([0,1,15,16,22,21,60,18,3,6,62,8,13]),function(Y,e,g,L,D,S,T,C,E,k,i,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function(j){j[j.Promise=100]="Promise",j[j.PromiseCancel=101]="PromiseCancel",j[j.EventListen=102]="EventListen",j[j.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function h(j){switch(j){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(j){j[j.Initialize=200]="Initialize",j[j.PromiseSuccess=201]="PromiseSuccess",j[j.PromiseError=202]="PromiseError",j[j.PromiseErrorObj=203]="PromiseErrorObj",j[j.EventFire=204]="EventFire"})(w=e.ResponseType||(e.ResponseType={}));function y(j){switch(j){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var P;(function(j){j[j.Uninitialized=0]="Uninitialized",j[j.Idle=1]="Idle"})(P||(P={}));class b{constructor(O){this.buffer=O,this.pos=0}read(O){const H=this.buffer.slice(this.pos,this.pos+O);return this.pos+=H.byteLength,H}}class o{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(O){this.buffers.push(O)}}var s;(function(j){j[j.Undefined=0]="Undefined",j[j.String=1]="String",j[j.Buffer=2]="Buffer",j[j.VSBuffer=3]="VSBuffer",j[j.Array=4]="Array",j[j.Object=5]="Object"})(s||(s={}));function v(j){const O=D.VSBuffer.alloc(4);return O.writeUInt32BE(j,0),O}function n(j){return j.read(4).readUInt32BE(0)}function f(j){const O=D.VSBuffer.alloc(1);return O.writeUInt8(j,0),O}const r={Undefined:f(s.Undefined),String:f(s.String),Buffer:f(s.Buffer),VSBuffer:f(s.VSBuffer),Array:f(s.Array),Object:f(s.Object)},t=typeof Buffer!="undefined";function u(j,O){if(typeof O=="undefined")j.write(r.Undefined);else if(typeof O=="string"){const H=D.VSBuffer.fromString(O);j.write(r.String),j.write(v(H.byteLength)),j.write(H)}else if(t&&Buffer.isBuffer(O)){const H=D.VSBuffer.wrap(O);j.write(r.Buffer),j.write(v(H.byteLength)),j.write(H)}else if(O instanceof D.VSBuffer)j.write(r.VSBuffer),j.write(v(O.byteLength)),j.write(O);else if(Array.isArray(O)){j.write(r.Array),j.write(v(O.length));for(const H of O)u(j,H)}else{const H=D.VSBuffer.fromString(JSON.stringify(O));j.write(r.Object),j.write(v(H.byteLength)),j.write(H)}}function l(j){switch(j.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return j.read(n(j)).toString();case s.Buffer:return j.read(n(j)).buffer;case s.VSBuffer:return j.read(n(j));case s.Array:{const H=n(j),W=[];for(let X=0;X<H;X++)W.push(l(j));return W}case s.Object:return JSON.parse(j.read(n(j)).toString())}}class c{constructor(O,H,W=null,X=1e3){this.protocol=O,this.ctx=H,this.logger=W,this.timeoutDelay=X,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Q=>this.onRawMessage(Q)),this.sendResponse({type:200})}registerChannel(O,H){this.channels.set(O,H),setTimeout(()=>this.flushPendingRequests(O),0)}sendResponse(O){switch(O.type){case 200:{const H=this.send([O.type]);this.logger&&this.logger.logOutgoing(H,0,1,y(O.type));return}case 201:case 202:case 204:case 203:{const H=this.send([O.type,O.id],O.data);this.logger&&this.logger.logOutgoing(H,O.id,1,y(O.type),O.data);return}}}send(O,H=void 0){const W=new o;return u(W,O),u(W,H),this.sendBuffer(W.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(H){return 0}}onRawMessage(O){const H=new b(O),W=l(H),X=l(H),Q=W[0];switch(Q){case 100:return this.logger&&this.logger.logIncoming(O.byteLength,W[1],1,`${h(Q)}: ${W[2]}.${W[3]}`,X),this.onPromise({type:Q,id:W[1],channelName:W[2],name:W[3],arg:X});case 102:return this.logger&&this.logger.logIncoming(O.byteLength,W[1],1,`${h(Q)}: ${W[2]}.${W[3]}`,X),this.onEventListen({type:Q,id:W[1],channelName:W[2],name:W[3],arg:X});case 101:return this.logger&&this.logger.logIncoming(O.byteLength,W[1],1,`${h(Q)}`),this.disposeActiveRequest({type:Q,id:W[1]});case 103:return this.logger&&this.logger.logIncoming(O.byteLength,W[1],1,`${h(Q)}`),this.disposeActiveRequest({type:Q,id:W[1]})}}onPromise(O){const H=this.channels.get(O.channelName);if(!H){this.collectPendingRequest(O);return}const W=new S.CancellationTokenSource;let X;try{X=H.call(this.ctx,O.name,O.arg,W.token)}catch(_e){X=Promise.reject(_e)}const Q=O.id;X.then(_e=>{this.sendResponse({id:Q,data:_e,type:201}),this.activeRequests.delete(O.id)},_e=>{_e instanceof Error?this.sendResponse({id:Q,data:{message:_e.message,name:_e.name,stack:_e.stack?_e.stack.split?_e.stack.split(`
`):_e.stack:void 0},type:202}):this.sendResponse({id:Q,data:_e,type:203}),this.activeRequests.delete(O.id)});const de=(0,k.toDisposable)(()=>W.cancel());this.activeRequests.set(O.id,de)}onEventListen(O){const H=this.channels.get(O.channelName);if(!H){this.collectPendingRequest(O);return}const W=O.id,Q=H.listen(this.ctx,O.name,O.arg)(de=>this.sendResponse({id:W,data:de,type:204}));this.activeRequests.set(O.id,Q)}disposeActiveRequest(O){const H=this.activeRequests.get(O.id);H&&(H.dispose(),this.activeRequests.delete(O.id))}collectPendingRequest(O){let H=this.pendingRequests.get(O.channelName);H||(H=[],this.pendingRequests.set(O.channelName,H));const W=setTimeout(()=>{console.error(`Unknown channel: ${O.channelName}`),O.type===100&&this.sendResponse({id:O.id,data:{name:"Unknown channel",message:`Channel name '${O.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);H.push({request:O,timeoutTimer:W})}flushPendingRequests(O){const H=this.pendingRequests.get(O);if(H){for(const W of H)switch(clearTimeout(W.timeoutTimer),W.request.type){case 100:this.onPromise(W.request);break;case 102:this.onEventListen(W.request);break}this.pendingRequests.delete(O)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}e.ChannelServer=c;var m;(function(j){j[j.LocalSide=0]="LocalSide",j[j.OtherSide=1]="OtherSide"})(m=e.RequestInitiator||(e.RequestInitiator={}));class d{constructor(O,H=null){this.protocol=O,this.isDisposed=!1,this.state=P.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new E.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(W=>this.onBuffer(W)),this.logger=H}getChannel(O){const H=this;return{call(W,X,Q){return H.isDisposed?Promise.reject(C.canceled()):H.requestPromise(O,W,X,Q)},listen(W,X){return H.isDisposed?Promise.reject(C.canceled()):H.requestEvent(O,W,X)}}}requestPromise(O,H,W,X=S.CancellationToken.None){const Q=this.lastRequestId++,_e={id:Q,type:100,channelName:O,name:H,arg:W};if(X.isCancellationRequested)return Promise.reject(C.canceled());let Ce;return new Promise((Be,We)=>{if(X.isCancellationRequested)return We(C.canceled());const He=()=>{const ce=Z=>{switch(Z.type){case 201:this.handlers.delete(Q),Be(Z.data);break;case 202:this.handlers.delete(Q);const re=new Error(Z.data.message);re.stack=Z.data.stack,re.name=Z.data.name,We(re);break;case 203:this.handlers.delete(Q),We(Z.data);break}};this.handlers.set(Q,ce),this.sendRequest(_e)};let G=null;this.state===P.Idle?He():(G=(0,L.createCancelablePromise)(ce=>this.whenInitialized()),G.then(()=>{G=null,He()}));const ee=()=>{G?(G.cancel(),G=null):this.sendRequest({id:Q,type:101}),We(C.canceled())},ie=X.onCancellationRequested(ee);Ce=(0,k.combinedDisposable)((0,k.toDisposable)(ee),ie),this.activeRequests.add(Ce)}).finally(()=>{this.activeRequests.delete(Ce)})}requestEvent(O,H,W){const X=this.lastRequestId++,de={id:X,type:102,channelName:O,name:H,arg:W};let _e=null;const Ce=new E.Emitter({onFirstListenerAdd:()=>{_e=(0,L.createCancelablePromise)(Be=>this.whenInitialized()),_e.then(()=>{_e=null,this.activeRequests.add(Ce),this.sendRequest(de)})},onLastListenerRemove:()=>{_e?(_e.cancel(),_e=null):(this.activeRequests.delete(Ce),this.sendRequest({id:X,type:103}))}}),Pe=Be=>Ce.fire(Be.data);return this.handlers.set(X,Pe),Ce.event}sendRequest(O){switch(O.type){case 100:case 102:{const H=this.send([O.type,O.id,O.channelName,O.name],O.arg);this.logger&&this.logger.logOutgoing(H,O.id,0,`${h(O.type)}: ${O.channelName}.${O.name}`,O.arg);return}case 101:case 103:{const H=this.send([O.type,O.id]);this.logger&&this.logger.logOutgoing(H,O.id,0,h(O.type));return}}}send(O,H=void 0){const W=new o;return u(W,O),u(W,H),this.sendBuffer(W.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(H){return 0}}onBuffer(O){const H=new b(O),W=l(H),X=l(H),Q=W[0];switch(Q){case 200:return this.logger&&this.logger.logIncoming(O.byteLength,0,0,y(Q)),this.onResponse({type:W[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(O.byteLength,W[1],0,y(Q),X),this.onResponse({type:W[0],id:W[1],data:X})}}onResponse(O){if(O.type===200){this.state=P.Idle,this._onDidInitialize.fire();return}const H=this.handlers.get(O.id);H&&H(O)}get onDidInitializePromise(){return E.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===P.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}Ve([T.memoize],d.prototype,"onDidInitializePromise",null),e.ChannelClient=d;class _{constructor(O){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new E.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new E.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,O(({protocol:H,onDidClientDisconnect:W})=>{E.Event.once(H.onMessage)(Q=>{const de=new b(Q),_e=l(de),Ce=new c(H,_e),Pe=new d(H);this.channels.forEach((We,He)=>Ce.registerChannel(He,We));const Be={channelServer:Ce,channelClient:Pe,ctx:_e};this._connections.add(Be),this._onDidAddConnection.fire(Be),W(()=>{Ce.dispose(),Pe.dispose(),this._connections.delete(Be),this._onDidRemoveConnection.fire(Be)})})})}get connections(){const O=[];return this._connections.forEach(H=>O.push(H)),O}getChannel(O,H){const W=this;return{call(X,Q,de){let _e;if((0,a.isFunction)(H)){let Pe=(0,g.getRandomElement)(W.connections.filter(H));_e=Pe?Promise.resolve(Pe):E.Event.toPromise(E.Event.filter(W.onDidAddConnection,H))}else _e=H.routeCall(W,X,Q);const Ce=_e.then(Pe=>Pe.channelClient.getChannel(O));return R(Ce).call(X,Q,de)},listen(X,Q){if((0,a.isFunction)(H))return W.getMulticastEvent(O,H,X,Q);const de=H.routeEvent(W,X,Q).then(_e=>_e.channelClient.getChannel(O));return R(de).listen(X,Q)}}}getMulticastEvent(O,H,W,X){const Q=this;let de=new k.DisposableStore;const _e=new E.Emitter({onFirstListenerAdd:()=>{de=new k.DisposableStore;const Ce=new E.EventMultiplexer,Pe=new Map,Be=He=>{const ee=He.channelClient.getChannel(O).listen(W,X),ie=Ce.add(ee);Pe.set(He,ie)},We=He=>{const G=Pe.get(He);!G||(G.dispose(),Pe.delete(He))};Q.connections.filter(H).forEach(Be),E.Event.filter(Q.onDidAddConnection,H)(Be,void 0,de),Q.onDidRemoveConnection(We,void 0,de),Ce.event(_e.fire,_e,de),de.add(Ce)},onLastListenerRemove:()=>{de.dispose()}});return _e.event}registerChannel(O,H){this.channels.set(O,H),this._connections.forEach(W=>{W.channelServer.registerChannel(O,H)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=_;class A{constructor(O,H,W=null){const X=new o;u(X,H),O.send(X.buffer),this.channelClient=new d(O,W),this.channelServer=new c(O,H,W)}getChannel(O){return this.channelClient.getChannel(O)}registerChannel(O,H){this.channelServer.registerChannel(O,H)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=A;function R(j){return{call(O,H,W){return j.then(X=>X.call(O,H,W))},listen(O,H){const W=new E.Relay;return j.then(X=>W.input=X.listen(O,H)),W.event}}}e.getDelayedChannel=R;function B(j){let O=!1;return{call(H,W,X){return O?j.call(H,W,X):(0,L.timeout)(0).then(()=>O=!0).then(()=>j.call(H,W,X))},listen(H,W){if(O)return j.listen(H,W);const X=new E.Relay;return(0,L.timeout)(0).then(()=>O=!0).then(()=>X.input=j.listen(H,W)),X.event}}}e.getNextTickChannel=B;class U{constructor(O){this.fn=O}routeCall(O){return this.route(O)}routeEvent(O){return this.route(O)}async route(O){for(const H of O.connections)if(await Promise.resolve(this.fn(H.ctx)))return Promise.resolve(H);return await E.Event.toPromise(O.onDidAddConnection),await this.route(O)}}e.StaticRouter=U;var F;(function(j){function O(Q,de){const _e=Q,Ce=de&&de.disableMarshalling,Pe=new Map;for(const Be in _e)W(Be)&&Pe.set(Be,E.Event.buffer(_e[Be],!0));return new class{listen(Be,We,He){const G=Pe.get(We);if(G)return G;if(X(We)){const ee=_e[We];if(typeof ee=="function")return ee.call(_e,He)}throw new Error(`Event not found: ${We}`)}call(Be,We,He){const G=_e[We];if(typeof G=="function"){if(!Ce&&Array.isArray(He))for(let ee=0;ee<He.length;ee++)He[ee]=(0,i.revive)(He[ee]);return G.apply(_e,He)}throw new Error(`Method not found: ${We}`)}}}j.fromService=O;function H(Q,de){const _e=de&&de.disableMarshalling;return new Proxy({},{get(Ce,Pe){if(typeof Pe=="string")return de?.properties?.has(Pe)?de.properties.get(Pe):X(Pe)?function(Be){return Q.listen(Pe,Be)}:W(Pe)?Q.listen(Pe):async function(...Be){let We;de&&!(0,a.isUndefinedOrNull)(de.context)?We=[de.context,...Be]:We=Be;const He=await Q.call(Pe,We);return _e?He:(0,i.revive)(He)};throw new Error(`Property not found: ${String(Pe)}`)}})}j.toService=H;function W(Q){return Q[0]==="o"&&Q[1]==="n"&&I.isUpperAsciiLetter(Q.charCodeAt(2))}function X(Q){return/^onDynamic/.test(Q)&&I.isUpperAsciiLetter(Q.charCodeAt(9))}})(F=e.ProxyChannel||(e.ProxyChannel={}));const $=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function M(j){if(Array.isArray(j))return j;if(j&&typeof j=="object"&&typeof j.toString=="function"){let O=j.toString();if(O!=="[object Object]")return O}return j}function z(j){return Array.isArray(j)?j.map(M):M(j)}function N(j,O,H,W,X,Q,de){de=z(de);const _e=$[X],Ce=_e[W%_e.length];let Pe=[`%c[${j}]%c[${String(O).padStart(7," ")}]%c[len: ${String(H).padStart(5," ")}]%c${String(W).padStart(5," ")} - ${Q}`,"color: darkgreen","color: grey","color: grey",`color: ${Ce}`];/\($/.test(Q)?(Pe=Pe.concat(de),Pe.push(")")):Pe.push(de),console.log.apply(console,Pe)}e.logWithColors=N;class x{constructor(O,H){this._outgoingPrefix=O,this._incomingPrefix=H,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(O,H,W,X,Q){this._totalOutgoing+=O,N(this._outgoingPrefix,this._totalOutgoing,O,H,W,X,Q)}logIncoming(O,H,W,X,Q){this._totalIncoming+=O,N(this._incomingPrefix,this._totalIncoming,O,H,W,X,Q)}}e.IPCLogger=x}),define(fe[107],me([0,1,22,3,6,12,38,106]),function(Y,e,g,L,D,S,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var E;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(E=e.SocketCloseEventType||(e.SocketCloseEventType={}));let k=null;function i(){return k||(k=g.VSBuffer.alloc(0)),k}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(t){this._chunks.push(t),this._totalLength+=t.byteLength}read(t){return this._read(t,!0)}peek(t){return this._read(t,!1)}_read(t,u){if(t===0)return i();if(t>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===t){const d=this._chunks[0];return u&&(this._chunks.shift(),this._totalLength-=t),d}if(this._chunks[0].byteLength>t){const d=this._chunks[0].slice(0,t);return u&&(this._chunks[0]=this._chunks[0].slice(t),this._totalLength-=t),d}let l=g.VSBuffer.alloc(t),c=0,m=0;for(;t>0;){const d=this._chunks[m];if(d.byteLength>t){const _=d.slice(0,t);l.set(_,c),c+=t,u&&(this._chunks[m]=d.slice(t),this._totalLength-=t),t-=t}else l.set(d,c),c+=d.byteLength,u?(this._chunks.shift(),this._totalLength-=d.byteLength):m++,t-=d.byteLength}return l}}e.ChunkStream=I;var a;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(a||(a={}));var p;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(p=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(t,u,l,c){this.type=t,this.id=u,this.ack=l,this.data=c,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends D.Disposable{constructor(t){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=t,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(t);this._incomingData.byteLength>=this._state.readLen;){const u=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=u.readUInt32BE(9),this._state.messageType=u.readUInt8(0),this._state.id=u.readUInt32BE(1),this._state.ack=u.readUInt32BE(5);else{const l=this._state.messageType,c=this._state.id,m=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new h(l,c,m,u)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class y{constructor(t){this._isDisposed=!1,this._socket=t,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(t){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(t){if(this._isDisposed)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=g.VSBuffer.alloc(13);u.writeUInt8(t.type,0),u.writeUInt32BE(t.id,1),u.writeUInt32BE(t.ack,5),u.writeUInt32BE(t.data.byteLength,9),this._writeSoon(u,t.data)}_bufferAdd(t,u){const l=this._totalLength===0;return this._data.push(t,u),this._totalLength+=t.byteLength+u.byteLength,l}_bufferTake(){const t=g.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,t}_writeSoon(t,u){this._bufferAdd(t,u)&&S.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class P extends D.Disposable{constructor(t){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=t,this._socketWriter=this._register(new y(this._socket)),this._socketReader=this._register(new w(this._socket)),this._register(this._socketReader.onMessage(u=>{u.type===1&&this._onMessage.fire(u.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(t){this._socketWriter.write(new h(1,0,0,t))}}e.Protocol=P;class b extends C.IPCClient{constructor(t,u,l=null){super(t,u,l);this.protocol=t}static fromSocket(t,u){return new b(new P(t),u)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const t=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),t.end()}}e.Client=b;class o{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,T.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(t){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(t):this._emitter.fire(t):this._bufferedMessages.push(t)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=o;class s{constructor(t){this.data=t,this.next=null}}class v{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let t=[],u=0,l=this._first;for(;l;)t[u++]=l.data,l=l.next;return t}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(t){const u=new s(t);if(!this._first){this._first=u,this._last=u;return}this._last.next=u,this._last=u}}class n{constructor(){this.lastRuns=[];const t=Date.now();for(let u=0;u<n._HISTORY_LENGTH;u++)this.lastRuns[u]=t-1e3*u;setInterval(()=>{for(let u=n._HISTORY_LENGTH;u>=1;u--)this.lastRuns[u]=this.lastRuns[u-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return n._INSTANCE||(n._INSTANCE=new n),n._INSTANCE}load(){const t=Date.now(),u=(1+n._HISTORY_LENGTH)*1e3;let l=0;for(let c=0;c<n._HISTORY_LENGTH;c++)t-this.lastRuns[c]<=u&&l++;return 1-l/n._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}n._HISTORY_LENGTH=10,n._INSTANCE=null;class f{constructor(t,u=null,l=n.getInstance()){this._onControlMessage=new o,this.onControlMessage=this._onControlMessage.event,this._onMessage=new o,this.onMessage=this._onMessage.event,this._onDidDispose=new o,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new o,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new o,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=l,this._isReconnecting=!1,this._outgoingUnackMsg=new v,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=t,this._socketWriter=new y(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(c=>this._onSocketClose.fire(c))),u&&this._socketReader.acceptChunk(u),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const t=new h(5,0,0,i());this._socketWriter.write(t),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const t=Date.now()-this._socketWriter.lastWriteTime;if(t>=5e3){const u=new h(4,0,0,i());this._socketWriter.write(u),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-t+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const t=Date.now()-this._socketReader.lastReadTime;if(t>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-t,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(t,u){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=t,this._socketWriter=new y(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),this._socketReader.acceptChunk(u)}endAcceptReconnection(){this._isReconnecting=!1;const t=this._outgoingUnackMsg.toArray();for(let u=0,l=t.length;u<l;u++)this._socketWriter.write(t[u]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(t){if(t.ack>this._outgoingAckId){this._outgoingAckId=t.ack;do{const u=this._outgoingUnackMsg.peek();if(u&&u.id<=t.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(t.type===1){if(t.id>this._incomingMsgId)if(t.id!==this._incomingMsgId+1){const u=Date.now();u-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=u,this._socketWriter.write(new h(6,0,0,i())))}else this._incomingMsgId=t.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(t.data)}else if(t.type===2)this._onControlMessage.fire(t.data);else if(t.type===5)this._onDidDispose.fire();else if(t.type===6){const u=this._outgoingUnackMsg.toArray();for(let l=0,c=u.length;l<c;l++)this._socketWriter.write(u[l]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(t){const u=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const l=new h(1,u,this._incomingAckId,t);this._outgoingUnackMsg.push(l),this._isReconnecting||(this._socketWriter.write(l),this._recvAckCheck())}sendControl(t){const u=new h(2,0,0,t);this._socketWriter.write(u)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const t=Date.now()-this._incomingMsgLastTime;if(t>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-t+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const t=this._outgoingUnackMsg.peek(),u=Date.now()-t.writtenTime;if(u>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-u,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const t=new h(3,0,this._incomingAckId,i());this._socketWriter.write(t)}}e.PersistentProtocol=f}),define(fe[108],me([0,1,99]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class L{constructor(C){let E=(0,g.toUint8)(C);this._defaultValue=E,this._asciiMap=L._createAsciiMap(E),this._map=new Map}static _createAsciiMap(C){let E=new Uint8Array(256);for(let k=0;k<256;k++)E[k]=C;return E}set(C,E){let k=(0,g.toUint8)(E);C>=0&&C<256?this._asciiMap[C]=k:this._map.set(C,k)}get(C){return C>=0&&C<256?this._asciiMap[C]:this._map.get(C)||this._defaultValue}}e.CharacterClassifier=L;var D;(function(T){T[T.False=0]="False",T[T.True=1]="True"})(D||(D={}));class S{constructor(){this._actual=new L(0)}add(C){this._actual.set(C,1)}has(C){return this._actual.get(C)===1}}e.CharacterSet=S}),define(fe[144],me([0,1,108]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var L;(function(T){T[T.Regular=0]="Regular",T[T.Whitespace=1]="Whitespace",T[T.WordSeparator=2]="WordSeparator"})(L=e.WordCharacterClass||(e.WordCharacterClass={}));class D extends g.CharacterClassifier{constructor(C){super(0);for(let E=0,k=C.length;E<k;E++)this.set(C.charCodeAt(E),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=D;function S(T){let C={};return E=>(C.hasOwnProperty(E)||(C[E]=T(E)),C[E])}e.getMapForWordSeparators=S(T=>new D(T))}),define(fe[51],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class g{constructor(D,S){this.lineNumber=D,this.column=S}with(D=this.lineNumber,S=this.column){return D===this.lineNumber&&S===this.column?this:new g(D,S)}delta(D=0,S=0){return this.with(this.lineNumber+D,this.column+S)}equals(D){return g.equals(this,D)}static equals(D,S){return!D&&!S?!0:!!D&&!!S&&D.lineNumber===S.lineNumber&&D.column===S.column}isBefore(D){return g.isBefore(this,D)}static isBefore(D,S){return D.lineNumber<S.lineNumber?!0:S.lineNumber<D.lineNumber?!1:D.column<S.column}isBeforeOrEqual(D){return g.isBeforeOrEqual(this,D)}static isBeforeOrEqual(D,S){return D.lineNumber<S.lineNumber?!0:S.lineNumber<D.lineNumber?!1:D.column<=S.column}static compare(D,S){let T=D.lineNumber|0,C=S.lineNumber|0;if(T===C){let E=D.column|0,k=S.column|0;return E-k}return T-C}clone(){return new g(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(D){return new g(D.lineNumber,D.column)}static isIPosition(D){return D&&typeof D.lineNumber=="number"&&typeof D.column=="number"}}e.Position=g}),define(fe[42],me([0,1,51]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class L{constructor(S,T,C,E){S>C||S===C&&T>E?(this.startLineNumber=C,this.startColumn=E,this.endLineNumber=S,this.endColumn=T):(this.startLineNumber=S,this.startColumn=T,this.endLineNumber=C,this.endColumn=E)}isEmpty(){return L.isEmpty(this)}static isEmpty(S){return S.startLineNumber===S.endLineNumber&&S.startColumn===S.endColumn}containsPosition(S){return L.containsPosition(this,S)}static containsPosition(S,T){return!(T.lineNumber<S.startLineNumber||T.lineNumber>S.endLineNumber||T.lineNumber===S.startLineNumber&&T.column<S.startColumn||T.lineNumber===S.endLineNumber&&T.column>S.endColumn)}containsRange(S){return L.containsRange(this,S)}static containsRange(S,T){return!(T.startLineNumber<S.startLineNumber||T.endLineNumber<S.startLineNumber||T.startLineNumber>S.endLineNumber||T.endLineNumber>S.endLineNumber||T.startLineNumber===S.startLineNumber&&T.startColumn<S.startColumn||T.endLineNumber===S.endLineNumber&&T.endColumn>S.endColumn)}strictContainsRange(S){return L.strictContainsRange(this,S)}static strictContainsRange(S,T){return!(T.startLineNumber<S.startLineNumber||T.endLineNumber<S.startLineNumber||T.startLineNumber>S.endLineNumber||T.endLineNumber>S.endLineNumber||T.startLineNumber===S.startLineNumber&&T.startColumn<=S.startColumn||T.endLineNumber===S.endLineNumber&&T.endColumn>=S.endColumn)}plusRange(S){return L.plusRange(this,S)}static plusRange(S,T){let C,E,k,i;return T.startLineNumber<S.startLineNumber?(C=T.startLineNumber,E=T.startColumn):T.startLineNumber===S.startLineNumber?(C=T.startLineNumber,E=Math.min(T.startColumn,S.startColumn)):(C=S.startLineNumber,E=S.startColumn),T.endLineNumber>S.endLineNumber?(k=T.endLineNumber,i=T.endColumn):T.endLineNumber===S.endLineNumber?(k=T.endLineNumber,i=Math.max(T.endColumn,S.endColumn)):(k=S.endLineNumber,i=S.endColumn),new L(C,E,k,i)}intersectRanges(S){return L.intersectRanges(this,S)}static intersectRanges(S,T){let C=S.startLineNumber,E=S.startColumn,k=S.endLineNumber,i=S.endColumn,I=T.startLineNumber,a=T.startColumn,p=T.endLineNumber,h=T.endColumn;return C<I?(C=I,E=a):C===I&&(E=Math.max(E,a)),k>p?(k=p,i=h):k===p&&(i=Math.min(i,h)),C>k||C===k&&E>i?null:new L(C,E,k,i)}equalsRange(S){return L.equalsRange(this,S)}static equalsRange(S,T){return!!S&&!!T&&S.startLineNumber===T.startLineNumber&&S.startColumn===T.startColumn&&S.endLineNumber===T.endLineNumber&&S.endColumn===T.endColumn}getEndPosition(){return L.getEndPosition(this)}static getEndPosition(S){return new g.Position(S.endLineNumber,S.endColumn)}getStartPosition(){return L.getStartPosition(this)}static getStartPosition(S){return new g.Position(S.startLineNumber,S.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(S,T){return new L(this.startLineNumber,this.startColumn,S,T)}setStartPosition(S,T){return new L(S,T,this.endLineNumber,this.endColumn)}collapseToStart(){return L.collapseToStart(this)}static collapseToStart(S){return new L(S.startLineNumber,S.startColumn,S.startLineNumber,S.startColumn)}static fromPositions(S,T=S){return new L(S.lineNumber,S.column,T.lineNumber,T.column)}static lift(S){return S?new L(S.startLineNumber,S.startColumn,S.endLineNumber,S.endColumn):null}static isIRange(S){return S&&typeof S.startLineNumber=="number"&&typeof S.startColumn=="number"&&typeof S.endLineNumber=="number"&&typeof S.endColumn=="number"}static areIntersectingOrTouching(S,T){return!(S.endLineNumber<T.startLineNumber||S.endLineNumber===T.startLineNumber&&S.endColumn<T.startColumn||T.endLineNumber<S.startLineNumber||T.endLineNumber===S.startLineNumber&&T.endColumn<S.startColumn)}static areIntersecting(S,T){return!(S.endLineNumber<T.startLineNumber||S.endLineNumber===T.startLineNumber&&S.endColumn<=T.startColumn||T.endLineNumber<S.startLineNumber||T.endLineNumber===S.startLineNumber&&T.endColumn<=S.startColumn)}static compareRangesUsingStarts(S,T){if(S&&T){const k=S.startLineNumber|0,i=T.startLineNumber|0;if(k===i){const I=S.startColumn|0,a=T.startColumn|0;if(I===a){const p=S.endLineNumber|0,h=T.endLineNumber|0;if(p===h){const w=S.endColumn|0,y=T.endColumn|0;return w-y}return p-h}return I-a}return k-i}return(S?1:0)-(T?1:0)}static compareRangesUsingEnds(S,T){return S.endLineNumber===T.endLineNumber?S.endColumn===T.endColumn?S.startLineNumber===T.startLineNumber?S.startColumn-T.startColumn:S.startLineNumber-T.startLineNumber:S.endColumn-T.endColumn:S.endLineNumber-T.endLineNumber}static spansMultipleLines(S){return S.endLineNumber>S.startLineNumber}}e.Range=L}),define(fe[145],me([0,1,51,42]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var D;(function(T){T[T.LTR=0]="LTR",T[T.RTL=1]="RTL"})(D=e.SelectionDirection||(e.SelectionDirection={}));class S extends L.Range{constructor(C,E,k,i){super(C,E,k,i);this.selectionStartLineNumber=C,this.selectionStartColumn=E,this.positionLineNumber=k,this.positionColumn=i}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(C){return S.selectionsEqual(this,C)}static selectionsEqual(C,E){return C.selectionStartLineNumber===E.selectionStartLineNumber&&C.selectionStartColumn===E.selectionStartColumn&&C.positionLineNumber===E.positionLineNumber&&C.positionColumn===E.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(C,E){return this.getDirection()===0?new S(this.startLineNumber,this.startColumn,C,E):new S(C,E,this.startLineNumber,this.startColumn)}getPosition(){return new g.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new g.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(C,E){return this.getDirection()===0?new S(C,E,this.endLineNumber,this.endColumn):new S(this.endLineNumber,this.endColumn,C,E)}static fromPositions(C,E=C){return new S(C.lineNumber,C.column,E.lineNumber,E.column)}static fromRange(C,E){return E===0?new S(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn):new S(C.endLineNumber,C.endColumn,C.startLineNumber,C.startColumn)}static liftSelection(C){return new S(C.selectionStartLineNumber,C.selectionStartColumn,C.positionLineNumber,C.positionColumn)}static selectionsArrEqual(C,E){if(C&&!E||!C&&E)return!1;if(!C&&!E)return!0;if(C.length!==E.length)return!1;for(let k=0,i=C.length;k<i;k++)if(!this.selectionsEqual(C[k],E[k]))return!1;return!0}static isISelection(C){return C&&typeof C.selectionStartLineNumber=="number"&&typeof C.selectionStartColumn=="number"&&typeof C.positionLineNumber=="number"&&typeof C.positionColumn=="number"}static createWithDirection(C,E,k,i,I){return I===0?new S(C,E,k,i):new S(k,i,C,E)}}e.Selection=S}),define(fe[109],me([0,1,25]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.IndentGuideHorizontalLine=e.IndentGuide=e.HorizontalGuidesState=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var L;(function(b){b[b.Left=1]="Left",b[b.Center=2]="Center",b[b.Right=4]="Right",b[b.Full=7]="Full"})(L=e.OverviewRulerLane||(e.OverviewRulerLane={}));var D;(function(b){b[b.Inline=1]="Inline",b[b.Gutter=2]="Gutter"})(D=e.MinimapPosition||(e.MinimapPosition={}));var S;(function(b){b[b.TextDefined=0]="TextDefined",b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(S=e.EndOfLinePreference||(e.EndOfLinePreference={}));var T;(function(b){b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(T=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var C;(function(b){b[b.LF=0]="LF",b[b.CRLF=1]="CRLF"})(C=e.EndOfLineSequence||(e.EndOfLineSequence={}));class E{constructor(o){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,o.tabSize|0),this.indentSize=o.tabSize|0,this.insertSpaces=Boolean(o.insertSpaces),this.defaultEOL=o.defaultEOL|0,this.trimAutoWhitespace=Boolean(o.trimAutoWhitespace),this.bracketPairColorizationOptions=o.bracketPairColorizationOptions}equals(o){return this.tabSize===o.tabSize&&this.indentSize===o.indentSize&&this.insertSpaces===o.insertSpaces&&this.defaultEOL===o.defaultEOL&&this.trimAutoWhitespace===o.trimAutoWhitespace&&(0,g.equals)(this.bracketPairColorizationOptions,o.bracketPairColorizationOptions)}createChangeEvent(o){return{tabSize:this.tabSize!==o.tabSize,indentSize:this.indentSize!==o.indentSize,insertSpaces:this.insertSpaces!==o.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==o.trimAutoWhitespace}}}e.TextModelResolvedOptions=E;class k{constructor(o,s){this._findMatchBrand=void 0,this.range=o,this.matches=s}}e.FindMatch=k;var i;(function(b){b[b.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",b[b.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",b[b.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",b[b.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(i=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var I;(function(b){b[b.Disabled=0]="Disabled",b[b.EnabledForActive=1]="EnabledForActive",b[b.Enabled=2]="Enabled"})(I=e.HorizontalGuidesState||(e.HorizontalGuidesState={}));class a{constructor(o,s,v){this.visibleColumn=o,this.className=s,this.horizontalLine=v}}e.IndentGuide=a;class p{constructor(o,s){this.top=o,this.endColumn=s}}e.IndentGuideHorizontalLine=p;var h;(function(b){b[b.Left=0]="Left",b[b.Right=1]="Right",b[b.None=2]="None"})(h=e.PositionAffinity||(e.PositionAffinity={}));var w;(function(b){b[b.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(w=e.ModelConstants||(e.ModelConstants={}));class y{constructor(o,s,v,n,f,r){this.identifier=o,this.range=s,this.text=v,this.forceMoveMarkers=n,this.isAutoWhitespaceEdit=f,this._isTracked=r}}e.ValidAnnotatedEditOperation=y;class P{constructor(o,s,v){this.reverseEdits=o,this.changes=s,this.trimAutoWhitespaceLineNumbers=v}}e.ApplyEditsResult=P}),define(fe[146],me([0,1,8,144,51,42,109]),function(Y,e,g,L,D,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const C=999;class E{constructor(o,s,v,n){this.searchString=o,this.isRegex=s,this.matchCase=v,this.wordSeparators=n}parseSearchRequest(){if(this.searchString==="")return null;let o;this.isRegex?o=k(this.searchString):o=this.searchString.indexOf(`
`)>=0;let s=null;try{s=g.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:o,global:!0,unicode:!0})}catch(n){return null}if(!s)return null;let v=!this.isRegex&&!o;return v&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(v=this.matchCase),new i(s,this.wordSeparators?(0,L.getMapForWordSeparators)(this.wordSeparators):null,v?this.searchString:null)}}e.SearchParams=E;function k(b){if(!b||b.length===0)return!1;for(let o=0,s=b.length;o<s;o++)if(b.charCodeAt(o)===92){if(o++,o>=s)break;const n=b.charCodeAt(o);if(n===110||n===114||n===87)return!0}return!1}e.isMultilineRegexSource=k;class i{constructor(o,s,v){this.regex=o,this.wordSeparators=s,this.simpleSearch=v}}e.SearchData=i;function I(b,o,s){if(!s)return new T.FindMatch(b,null);let v=[];for(let n=0,f=o.length;n<f;n++)v[n]=o[n];return new T.FindMatch(b,v)}e.createFindMatch=I;class a{constructor(o){let s=[],v=0;for(let n=0,f=o.length;n<f;n++)o.charCodeAt(n)===10&&(s[v++]=n);this._lineFeedsOffsets=s}findLineFeedCountBeforeOffset(o){const s=this._lineFeedsOffsets;let v=0,n=s.length-1;if(n===-1||o<=s[0])return 0;for(;v<n;){const f=v+((n-v)/2>>0);s[f]>=o?n=f-1:s[f+1]>=o?(v=f,n=f):v=f+1}return v+1}}class p{static findMatches(o,s,v,n,f){const r=s.parseSearchRequest();return r?r.regex.multiline?this._doFindMatchesMultiline(o,v,new P(r.wordSeparators,r.regex),n,f):this._doFindMatchesLineByLine(o,v,r,n,f):[]}static _getMultilineMatchRange(o,s,v,n,f,r){let t,u=0;n?(u=n.findLineFeedCountBeforeOffset(f),t=s+f+u):t=s+f;let l;if(n){let _=n.findLineFeedCountBeforeOffset(f+r.length)-u;l=t+r.length+_}else l=t+r.length;const c=o.getPositionAt(t),m=o.getPositionAt(l);return new S.Range(c.lineNumber,c.column,m.lineNumber,m.column)}static _doFindMatchesMultiline(o,s,v,n,f){const r=o.getOffsetAt(s.getStartPosition()),t=o.getValueInRange(s,1),u=o.getEOL()===`\r
`?new a(t):null,l=[];let c=0,m;for(v.reset(0);m=v.next(t);)if(l[c++]=I(this._getMultilineMatchRange(o,r,t,u,m.index,m[0]),m,n),c>=f)return l;return l}static _doFindMatchesLineByLine(o,s,v,n,f){const r=[];let t=0;if(s.startLineNumber===s.endLineNumber){const l=o.getLineContent(s.startLineNumber).substring(s.startColumn-1,s.endColumn-1);return t=this._findMatchesInLine(v,l,s.startLineNumber,s.startColumn-1,t,r,n,f),r}const u=o.getLineContent(s.startLineNumber).substring(s.startColumn-1);t=this._findMatchesInLine(v,u,s.startLineNumber,s.startColumn-1,t,r,n,f);for(let l=s.startLineNumber+1;l<s.endLineNumber&&t<f;l++)t=this._findMatchesInLine(v,o.getLineContent(l),l,0,t,r,n,f);if(t<f){const l=o.getLineContent(s.endLineNumber).substring(0,s.endColumn-1);t=this._findMatchesInLine(v,l,s.endLineNumber,0,t,r,n,f)}return r}static _findMatchesInLine(o,s,v,n,f,r,t,u){const l=o.wordSeparators;if(!t&&o.simpleSearch){const d=o.simpleSearch,_=d.length,A=s.length;let R=-_;for(;(R=s.indexOf(d,R+_))!==-1;)if((!l||y(l,s,A,R,_))&&(r[f++]=new T.FindMatch(new S.Range(v,R+1+n,v,R+1+_+n),null),f>=u))return f;return f}const c=new P(o.wordSeparators,o.regex);let m;c.reset(0);do if(m=c.next(s),m&&(r[f++]=I(new S.Range(v,m.index+1+n,v,m.index+1+m[0].length+n),m,t),f>=u))return f;while(m);return f}static findNextMatch(o,s,v,n){const f=s.parseSearchRequest();if(!f)return null;const r=new P(f.wordSeparators,f.regex);return f.regex.multiline?this._doFindNextMatchMultiline(o,v,r,n):this._doFindNextMatchLineByLine(o,v,r,n)}static _doFindNextMatchMultiline(o,s,v,n){const f=new D.Position(s.lineNumber,1),r=o.getOffsetAt(f),t=o.getLineCount(),u=o.getValueInRange(new S.Range(f.lineNumber,f.column,t,o.getLineMaxColumn(t)),1),l=o.getEOL()===`\r
`?new a(u):null;v.reset(s.column-1);let c=v.next(u);return c?I(this._getMultilineMatchRange(o,r,u,l,c.index,c[0]),c,n):s.lineNumber!==1||s.column!==1?this._doFindNextMatchMultiline(o,new D.Position(1,1),v,n):null}static _doFindNextMatchLineByLine(o,s,v,n){const f=o.getLineCount(),r=s.lineNumber,t=o.getLineContent(r),u=this._findFirstMatchInLine(v,t,r,s.column,n);if(u)return u;for(let l=1;l<=f;l++){const c=(r+l-1)%f,m=o.getLineContent(c+1),d=this._findFirstMatchInLine(v,m,c+1,1,n);if(d)return d}return null}static _findFirstMatchInLine(o,s,v,n,f){o.reset(n-1);const r=o.next(s);return r?I(new S.Range(v,r.index+1,v,r.index+1+r[0].length),r,f):null}static findPreviousMatch(o,s,v,n){const f=s.parseSearchRequest();if(!f)return null;const r=new P(f.wordSeparators,f.regex);return f.regex.multiline?this._doFindPreviousMatchMultiline(o,v,r,n):this._doFindPreviousMatchLineByLine(o,v,r,n)}static _doFindPreviousMatchMultiline(o,s,v,n){const f=this._doFindMatchesMultiline(o,new S.Range(1,1,s.lineNumber,s.column),v,n,10*C);if(f.length>0)return f[f.length-1];const r=o.getLineCount();return s.lineNumber!==r||s.column!==o.getLineMaxColumn(r)?this._doFindPreviousMatchMultiline(o,new D.Position(r,o.getLineMaxColumn(r)),v,n):null}static _doFindPreviousMatchLineByLine(o,s,v,n){const f=o.getLineCount(),r=s.lineNumber,t=o.getLineContent(r).substring(0,s.column-1),u=this._findLastMatchInLine(v,t,r,n);if(u)return u;for(let l=1;l<=f;l++){const c=(f+r-l-1)%f,m=o.getLineContent(c+1),d=this._findLastMatchInLine(v,m,c+1,n);if(d)return d}return null}static _findLastMatchInLine(o,s,v,n){let f=null,r;for(o.reset(0);r=o.next(s);)f=I(new S.Range(v,r.index+1,v,r.index+1+r[0].length),r,n);return f}}e.TextModelSearch=p;function h(b,o,s,v,n){if(v===0)return!0;const f=o.charCodeAt(v-1);if(b.get(f)!==0||f===13||f===10)return!0;if(n>0){const r=o.charCodeAt(v);if(b.get(r)!==0)return!0}return!1}function w(b,o,s,v,n){if(v+n===s)return!0;const f=o.charCodeAt(v+n);if(b.get(f)!==0||f===13||f===10)return!0;if(n>0){const r=o.charCodeAt(v+n-1);if(b.get(r)!==0)return!0}return!1}function y(b,o,s,v,n){return h(b,o,s,v,n)&&w(b,o,s,v,n)}e.isValidMatch=y;class P{constructor(o,s){this._wordSeparators=o,this._searchRegex=s,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(o){this._searchRegex.lastIndex=o,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(o){const s=o.length;let v;do{if(this._prevMatchStartIndex+this._prevMatchLength===s||(v=this._searchRegex.exec(o),!v))return null;const n=v.index,f=v[0].length;if(n===this._prevMatchStartIndex&&f===this._prevMatchLength){if(f===0){g.getNextCodePoint(o,s,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=n,this._prevMatchLength=f,!this._wordSeparators||y(this._wordSeparators,o,s,n,f))return v}while(v);return null}}e.Searcher=P}),define(fe[110],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function g(C=""){let E="(-?\\d*\\.\\d\\w*)|([^";for(const k of e.USUAL_WORD_SEPARATORS)C.indexOf(k)>=0||(E+="\\"+k);return E+="\\s]+)",new RegExp(E,"g")}e.DEFAULT_WORD_REGEXP=g();function L(C){let E=e.DEFAULT_WORD_REGEXP;if(C&&C instanceof RegExp)if(C.global)E=C;else{let k="g";C.ignoreCase&&(k+="i"),C.multiline&&(k+="m"),C.unicode&&(k+="u"),E=new RegExp(C.source,k)}return E.lastIndex=0,E}e.ensureValidWordDefinition=L;const D={maxLen:1e3,windowSize:15,timeBudget:150};function S(C,E,k,i,I=D){if(k.length>I.maxLen){let y=C-I.maxLen/2;return y<0?y=0:i+=y,k=k.substring(y,C+I.maxLen/2),S(C,E,k,i,I)}const a=Date.now(),p=C-1-i;let h=-1,w=null;for(let y=1;!(Date.now()-a>=I.timeBudget);y++){const P=p-I.windowSize*y;E.lastIndex=Math.max(0,P);const b=T(E,k,p,h);if(!b&&w||(w=b,P<=0))break;h=P}if(w){let y={word:w[0],startColumn:i+1+w.index,endColumn:i+1+w.index+w[0].length};return E.lastIndex=0,y}return null}e.getWordAtText=S;function T(C,E,k,i){let I;for(;I=C.exec(E);){const a=I.index||0;if(a<=k&&C.lastIndex>=k)return I;if(i>0&&a>i)return null}return null}}),define(fe[147],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var g;(function(T){T[T.None=0]="None",T[T.Indent=1]="Indent",T[T.IndentOutdent=2]="IndentOutdent",T[T.Outdent=3]="Outdent"})(g=e.IndentAction||(e.IndentAction={}));class L{constructor(C){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=C.open,this.close=C.close,this._standardTokenMask=0,Array.isArray(C.notIn))for(let E=0,k=C.notIn.length;E<k;E++)switch(C.notIn[E]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(C){return(this._standardTokenMask&C)==0}}e.StandardAutoClosingPairConditional=L;class D{constructor(C){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of C)S(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),S(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),S(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),S(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&S(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.AutoClosingPairs=D;function S(T,C,E){T.has(C)?T.get(C).push(E):T.set(C,[E])}}),define(fe[83],me([0,1,30,9]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function D(S,T,C,E){if(Array.isArray(S)){let k=0;for(const i of S){const I=D(i,T,C,E);if(I===10)return I;I>k&&(k=I)}return k}else{if(typeof S=="string")return E?S==="*"?5:S===C?10:0:0;if(S){const{language:k,pattern:i,scheme:I,hasAccessToAllModels:a}=S;if(!E&&!a)return 0;let p=0;if(I)if(I===T.scheme)p=10;else if(I==="*")p=5;else return 0;if(k)if(k===C)p=10;else if(k==="*")p=Math.max(p,5);else return 0;if(i){let h;if(typeof i=="string"?h=i:h={...i,base:(0,L.normalize)(i.base)},h===T.fsPath||(0,g.match)(h,T.fsPath))p=10;else return 0}return p}else return 0}}e.score=D}),define(fe[148],me([0,1,108]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var L;(function(p){p[p.Invalid=0]="Invalid",p[p.Start=1]="Start",p[p.H=2]="H",p[p.HT=3]="HT",p[p.HTT=4]="HTT",p[p.HTTP=5]="HTTP",p[p.F=6]="F",p[p.FI=7]="FI",p[p.FIL=8]="FIL",p[p.BeforeColon=9]="BeforeColon",p[p.AfterColon=10]="AfterColon",p[p.AlmostThere=11]="AlmostThere",p[p.End=12]="End",p[p.Accept=13]="Accept",p[p.LastKnownState=14]="LastKnownState"})(L=e.State||(e.State={}));class D{constructor(h,w,y){const P=new Uint8Array(h*w);for(let b=0,o=h*w;b<o;b++)P[b]=y;this._data=P,this.rows=h,this.cols=w}get(h,w){return this._data[h*this.cols+w]}set(h,w,y){this._data[h*this.cols+w]=y}}e.Uint8Matrix=D;class S{constructor(h){let w=0,y=0;for(let b=0,o=h.length;b<o;b++){let[s,v,n]=h[b];v>w&&(w=v),s>y&&(y=s),n>y&&(y=n)}w++,y++;let P=new D(y,w,0);for(let b=0,o=h.length;b<o;b++){let[s,v,n]=h[b];P.set(s,v,n)}this._states=P,this._maxCharCode=w}nextState(h,w){return w<0||w>=this._maxCharCode?0:this._states.get(h,w)}}e.StateMachine=S;let T=null;function C(){return T===null&&(T=new S([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),T}var E;(function(p){p[p.None=0]="None",p[p.ForceTermination=1]="ForceTermination",p[p.CannotEndIn=2]="CannotEndIn"})(E||(E={}));let k=null;function i(){if(k===null){k=new g.CharacterClassifier(0);const p=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let w=0;w<p.length;w++)k.set(p.charCodeAt(w),1);const h=".,;";for(let w=0;w<h.length;w++)k.set(h.charCodeAt(w),2)}return k}class I{static _createLink(h,w,y,P,b){let o=b-1;do{const s=w.charCodeAt(o);if(h.get(s)!==2)break;o--}while(o>P);if(P>0){const s=w.charCodeAt(P-1),v=w.charCodeAt(o);(s===40&&v===41||s===91&&v===93||s===123&&v===125)&&o--}return{range:{startLineNumber:y,startColumn:P+1,endLineNumber:y,endColumn:o+2},url:w.substring(P,o+1)}}static computeLinks(h,w=C()){const y=i();let P=[];for(let b=1,o=h.getLineCount();b<=o;b++){const s=h.getLineContent(b),v=s.length;let n=0,f=0,r=0,t=1,u=!1,l=!1,c=!1,m=!1;for(;n<v;){let d=!1;const _=s.charCodeAt(n);if(t===13){let A;switch(_){case 40:u=!0,A=0;break;case 41:A=u?0:1;break;case 91:c=!0,l=!0,A=0;break;case 93:c=!1,A=l?0:1;break;case 123:m=!0,A=0;break;case 125:A=m?0:1;break;case 39:A=r===34||r===96?0:1;break;case 34:A=r===39||r===96?0:1;break;case 96:A=r===39||r===34?0:1;break;case 42:A=r===42?1:0;break;case 124:A=r===124?1:0;break;case 32:A=c?0:1;break;default:A=y.get(_)}A===1&&(P.push(I._createLink(y,s,b,f,n)),d=!0)}else if(t===12){let A;_===91?(l=!0,A=0):A=y.get(_),A===1?d=!0:t=13}else t=w.nextState(t,_),t===0&&(d=!0);d&&(t=1,u=!1,l=!1,m=!1,f=n+1,r=_),n++}t===13&&P.push(I._createLink(y,s,b,f,v))}return P}}e.LinkComputer=I;function a(p){return!p||typeof p.getLineCount!="function"||typeof p.getLineContent!="function"?[]:I.computeLinks(p)}e.computeLinks=a}),define(fe[149],me([0,1,3,6]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class D{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new g.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(T){this._onDidChange.fire({changedLanguages:T,changedColorMap:!1})}register(T,C){return this._map.set(T,C),this.fire([T]),(0,L.toDisposable)(()=>{this._map.get(T)===C&&(this._map.delete(T),this.fire([T]))})}registerPromise(T,C){let E=null,k=!1;return this._promises.set(T,C.then(i=>{this._promises.delete(T),!(k||!i)&&(E=this.register(T,i))})),(0,L.toDisposable)(()=>{k=!0,E&&E.dispose()})}getPromise(T){const C=this.get(T);if(C)return Promise.resolve(C);const E=this._promises.get(T);return E?E.then(k=>this.get(T)):null}get(T){return this._map.get(T)||null}setColorMap(T){this._colorMap=T,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=D}),define(fe[111],me([0,1,22,12]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var D;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(D||(D={}));function S(I){for(let a=0,p=I.length;a<p;a+=4){const h=I[a+0],w=I[a+1],y=I[a+2],P=I[a+3];I[a+0]=P,I[a+1]=y,I[a+2]=w,I[a+3]=h}}function T(I){const a=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return L.isLittleEndian()||S(a),g.VSBuffer.wrap(a)}function C(I){const a=I.buffer;if(L.isLittleEndian()||S(a),a.byteOffset%4==0)return new Uint32Array(a.buffer,a.byteOffset,a.length/4);{const p=new Uint8Array(a.byteLength);return p.set(a),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function E(I){const a=new Uint32Array(k(I));let p=0;if(a[p++]=I.id,I.type==="full")a[p++]=1,a[p++]=I.data.length,a.set(I.data,p),p+=I.data.length;else{a[p++]=2,a[p++]=I.deltas.length;for(const h of I.deltas)a[p++]=h.start,a[p++]=h.deleteCount,h.data?(a[p++]=h.data.length,a.set(h.data,p),p+=h.data.length):a[p++]=0}return T(a)}e.encodeSemanticTokensDto=E;function k(I){let a=0;if(a+=1+1,I.type==="full")a+=1+I.data.length;else{a+=1,a+=(1+1+1)*I.deltas.length;for(const p of I.deltas)p.data&&(a+=p.data.length)}return a}function i(I){const a=C(I);let p=0;const h=a[p++];if(a[p++]===1){const b=a[p++],o=a.subarray(p,p+b);return p+=b,{id:h,type:"full",data:o}}const y=a[p++];let P=[];for(let b=0;b<y;b++){const o=a[p++],s=a[p++],v=a[p++];let n;v>0&&(n=a.subarray(p,p+v),p+=v),P[b]={start:o,deleteCount:s,data:n}}return{id:h,type:"delta",deltas:P}}e.decodeSemanticTokensDto=i}),define(fe[112],me([0,1,15,99]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class D{constructor(E){this.values=E,this.prefixSum=new Uint32Array(E.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(E,k){E=(0,L.toUint32)(E);const i=this.values,I=this.prefixSum,a=k.length;return a===0?!1:(this.values=new Uint32Array(i.length+a),this.values.set(i.subarray(0,E),0),this.values.set(i.subarray(E),E+a),this.values.set(k,E),E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(E,k){return E=(0,L.toUint32)(E),k=(0,L.toUint32)(k),this.values[E]===k?!1:(this.values[E]=k,E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),!0)}removeValues(E,k){E=(0,L.toUint32)(E),k=(0,L.toUint32)(k);const i=this.values,I=this.prefixSum;if(E>=i.length)return!1;let a=i.length-E;return k>=a&&(k=a),k===0?!1:(this.values=new Uint32Array(i.length-k),this.values.set(i.subarray(0,E),0),this.values.set(i.subarray(E+k),E),this.prefixSum=new Uint32Array(this.values.length),E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(E){return E<0?0:(E=(0,L.toUint32)(E),this._getPrefixSum(E))}_getPrefixSum(E){if(E<=this.prefixSumValidIndex[0])return this.prefixSum[E];let k=this.prefixSumValidIndex[0]+1;k===0&&(this.prefixSum[0]=this.values[0],k++),E>=this.values.length&&(E=this.values.length-1);for(let i=k;i<=E;i++)this.prefixSum[i]=this.prefixSum[i-1]+this.values[i];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],E),this.prefixSum[E]}getIndexOf(E){E=Math.floor(E),this.getTotalSum();let k=0,i=this.values.length-1,I=0,a=0,p=0;for(;k<=i;)if(I=k+(i-k)/2|0,a=this.prefixSum[I],p=a-this.values[I],E<p)i=I-1;else if(E>=a)k=I+1;else break;return new T(I,E-p)}}e.PrefixSumComputer=D;class S{constructor(E){this._values=E,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(E){return this._ensureValid(),E===0?0:this._prefixSum[E-1]}getIndexOf(E){this._ensureValid();const k=this._indexBySum[E],i=k>0?this._prefixSum[k-1]:0;return new T(k,E-i)}removeValues(E,k){this._values.splice(E,k),this._invalidate(E)}insertValues(E,k){this._values=(0,g.arrayInsert)(this._values,E,k),this._invalidate(E)}_invalidate(E){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,E-1)}_ensureValid(){if(!this._isValid){for(let E=this._validEndIndex+1,k=this._values.length;E<k;E++){const i=this._values[E],I=E>0?this._prefixSum[E-1]:0;this._prefixSum[E]=I+i;for(let a=0;a<i;a++)this._indexBySum[I+a]=E}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(E,k){this._values[E]!==k&&(this._values[E]=k,this._invalidate(E))}}e.ConstantTimePrefixSumComputer=S;class T{constructor(E,k){this.index=E,this.remainder=k,this._prefixSumIndexOfResultBrand=void 0,this.index=E,this.remainder=k}}e.PrefixSumIndexOfResult=T}),define(fe[150],me([0,1,8,51,112]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class S{constructor(C,E,k,i){this._uri=C,this._lines=E,this._eol=k,this._versionId=i,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(C){C.eol&&C.eol!==this._eol&&(this._eol=C.eol,this._lineStarts=null);const E=C.changes;for(const k of E)this._acceptDeleteRange(k.range),this._acceptInsertText(new L.Position(k.range.startLineNumber,k.range.startColumn),k.text);this._versionId=C.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const C=this._eol.length,E=this._lines.length,k=new Uint32Array(E);for(let i=0;i<E;i++)k[i]=this._lines[i].length+C;this._lineStarts=new D.PrefixSumComputer(k)}}_setLineText(C,E){this._lines[C]=E,this._lineStarts&&this._lineStarts.setValue(C,this._lines[C].length+this._eol.length)}_acceptDeleteRange(C){if(C.startLineNumber===C.endLineNumber){if(C.startColumn===C.endColumn)return;this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.startLineNumber-1].substring(C.endColumn-1));return}this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.endLineNumber-1].substring(C.endColumn-1)),this._lines.splice(C.startLineNumber,C.endLineNumber-C.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(C.startLineNumber,C.endLineNumber-C.startLineNumber)}_acceptInsertText(C,E){if(E.length===0)return;let k=(0,g.splitLines)(E);if(k.length===1){this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+k[0]+this._lines[C.lineNumber-1].substring(C.column-1));return}k[k.length-1]+=this._lines[C.lineNumber-1].substring(C.column-1),this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+k[0]);let i=new Uint32Array(k.length-1);for(let I=1;I<k.length;I++)this._lines.splice(C.lineNumber+I-1,0,k[I]),i[I-1]=k[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(C.lineNumber,i)}}e.MirrorTextModel=S}),define(fe[151],me([19,20]),function(Y,e){return Y.create("vs/base/common/date",e)}),define(fe[152],me([0,1,151]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,D=L*60,S=D*24,T=S*7,C=S*30,E=S*365;function k(I,a){typeof I!="number"&&(I=I.getTime());const p=Math.round((new Date().getTime()-I)/1e3);if(p<-30)return(0,g.localize)(0,null,k(new Date().getTime()+p*1e3,!1));if(p<30)return(0,g.localize)(1,null);let h;return p<L?(h=p,a?h===1?(0,g.localize)(2,null,h):(0,g.localize)(3,null,h):h===1?(0,g.localize)(4,null,h):(0,g.localize)(5,null,h)):p<D?(h=Math.floor(p/L),a?h===1?(0,g.localize)(6,null,h):(0,g.localize)(7,null,h):h===1?(0,g.localize)(8,null,h):(0,g.localize)(9,null,h)):p<S?(h=Math.floor(p/D),a?h===1?(0,g.localize)(10,null,h):(0,g.localize)(11,null,h):h===1?(0,g.localize)(12,null,h):(0,g.localize)(13,null,h)):p<T?(h=Math.floor(p/S),a?h===1?(0,g.localize)(14,null,h):(0,g.localize)(15,null,h):h===1?(0,g.localize)(16,null,h):(0,g.localize)(17,null,h)):p<C?(h=Math.floor(p/T),a?h===1?(0,g.localize)(18,null,h):(0,g.localize)(19,null,h):h===1?(0,g.localize)(20,null,h):(0,g.localize)(21,null,h)):p<E?(h=Math.floor(p/C),a?h===1?(0,g.localize)(22,null,h):(0,g.localize)(23,null,h):h===1?(0,g.localize)(24,null,h):(0,g.localize)(25,null,h)):(h=Math.floor(p/E),a?h===1?(0,g.localize)(26,null,h):(0,g.localize)(27,null,h):h===1?(0,g.localize)(28,null,h):(0,g.localize)(29,null,h))}e.fromNow=k;function i(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(fe[153],me([19,20]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(fe[52],me([0,1,15,13,153]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function S(k,i){return i&&(k.stack||k.stacktrace)?D.localize(0,null,C(k),T(k.stack)||T(k.stacktrace)):C(k)}function T(k){return Array.isArray(k)?k.join(`
`):k}function C(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?D.localize(1,null,k.message):k.message||D.localize(2,null)}function E(k=null,i=!1){if(!k)return D.localize(3,null);if(Array.isArray(k)){const I=g.coalesce(k),a=E(I[0],i);return I.length>1?D.localize(4,null,a,I.length):a}if(L.isString(k))return k;if(k.detail){const I=k.detail;if(I.error)return S(I.error,i);if(I.exception)return S(I.exception,i)}return k.stack?S(k,i):k.message?k.message:D.localize(5,null)}e.toErrorMessage=E}),define(fe[154],me([19,20]),function(Y,e){return Y.create("vs/base/node/processes",e)}),define(fe[113],me([0,1,39,29,10,25,9,12,38,95,13,143,28,154]),function(Y,e,g,L,D,S,T,C,E,k,i,I,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return k.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return k.TerminateResponseCode}});function h(n){switch(n){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function w(n,f){if(C.isWindows)try{const r={stdio:["pipe","pipe","ignore"]};f&&(r.cwd=f);const t=g.execFile("taskkill",["/T","/F","/PID",n.pid.toString()],r);return new Promise(u=>{t.once("error",l=>{u({success:!1,error:l})}),t.once("exit",(l,c)=>{u(l===0?{success:!0}:{success:!1,code:l!==null?l:1})})})}catch(r){return Promise.resolve({success:!1,error:r,code:r.status?h(r.status):1})}else if(C.isLinux||C.isMacintosh)try{const r=D.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Y).fsPath;return new Promise(t=>{g.execFile(r,[n.pid.toString()],{encoding:"utf8",shell:!0},(u,l,c)=>{t(u?{success:!1,error:u}:{success:!0})})})}catch(r){return Promise.resolve({success:!1,error:r})}else n.kill("SIGKILL");return Promise.resolve({success:!0})}function y(n){!n||(delete n.DEBUG,C.isMacintosh&&delete n.DYLD_LIBRARY_PATH,C.isLinux&&delete n.LD_PRELOAD)}e.removeDangerousEnvVariables=y;function P(n=E.env){return n.comspec||"cmd.exe"}e.getWindowsShell=P;class b{constructor(f,r,t,u){if(r!==void 0&&t!==void 0&&u!==void 0)this.cmd=f,this.args=r,this.shell=t,this.options=u;else{const l=f;this.cmd=l.command,this.shell=l.isShellCommand,this.args=l.args.slice(0),this.options=l.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const l=Object.create(null);Object.keys(E.env).forEach(c=>{l[c]=E.env[c]}),Object.keys(this.options.env).forEach(c=>{l[c]=this.options.env[c]}),this.options.env=l}}getSanitizedCommand(){let f=this.cmd.toLowerCase();const r=f.lastIndexOf(T.sep);return r!==-1&&(f=f.substring(r+1)),b.WellKnowCommands[f]?f:"other"}start(f){return C.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(E.cwd()))?Promise.reject(new Error(p.localize(0,null))):this.useExec().then(r=>{let t,u;const l=new Promise((c,m)=>{t=c,u=m});if(r){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=g.exec(c,this.options,(m,d,_)=>{this.childProcess=null;const A=m;A&&A.killed?u({killed:this.terminateRequested,stdout:d.toString(),stderr:_.toString()}):this.handleExec(t,f,m,d,_)})}else{let c=null;const m=d=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(d,t,f,u);const _={terminated:this.terminateRequested};i.isNumber(d)&&(_.cmdCode=d),t(_)};if(this.shell&&C.isWindows){const d=S.deepClone(this.options);d.windowsVerbatimArguments=!0,d.detached=!1;let _=!1,A=!1;const R=[];let B=this.ensureQuotes(this.cmd);R.push(B.value),_=B.quoted,this.args&&this.args.forEach(F=>{B=this.ensureQuotes(F),R.push(B.value),A=A&&B.quoted});const U=["/s","/c"];_?A?U.push('"'+R.join(" ")+'"'):R.length>1?U.push('"'+R[0]+'" '+R.slice(1).join(" ")):U.push('"'+R[0]+'"'):U.push(R.join(" ")),c=g.spawn(P(),U,d)}else this.cmd&&(c=g.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(i.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",d=>{this.childProcess=null,u({terminated:this.terminateRequested,error:d})}),c.pid&&(this.childProcess.on("close",m),this.handleSpawn(c,t,f,u,!0)))}return l})}handleClose(f,r,t,u){}ensureQuotes(f){return b.regexp.test(f)?{value:'"'+f+'"',quoted:!0}:{value:f,quoted:f.length>0&&f[0]==='"'&&f[f.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(f=>f.pid,f=>-1):new Promise(f=>{this.pidResolve=f})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(f=>(this.terminateRequested=!0,w(f,this.options.cwd).then(r=>(r.success&&(this.childProcess=null),r))),f=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(f=>{if(!this.shell||!C.isWindows)return f(!1);const r=g.spawn(P(),["/s","/c"]);r.on("error",t=>f(!0)),r.on("exit",t=>f(!1))})}}e.AbstractProcess=b,b.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},b.regexp=/^[^"].* .*[^"]/;class o extends b{constructor(f,r,t,u){super(f,r,t,u);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(f,r,t,u,l){[u,l].forEach((c,m)=>{const d=new I.LineDecoder;d.write(c).forEach(R=>{r({line:R,source:m===0?0:1})});const A=d.end();A&&r({line:A,source:m===0?0:1})}),f({terminated:this.terminateRequested,error:t})}handleSpawn(f,r,t,u,l){const c=new I.LineDecoder,m=new I.LineDecoder;f.stdout.on("data",d=>{c.write(d).forEach(A=>t({line:A,source:0}))}),f.stderr.on("data",d=>{m.write(d).forEach(A=>t({line:A,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=m}handleClose(f,r,t,u){const l=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;l&&t({line:l,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&t({line:c,source:1})}}e.LineProcess=o;function s(n){let f=[],r=!1;const t=function(u){if(r){f.push(u);return}(!n.send(u,c=>{if(c&&console.error(c),r=!1,f.length>0){const m=f.slice(0);f=[],m.forEach(d=>t(d))}})||C.isWindows)&&(r=!0)};return{send:t}}e.createQueuedSender=s;var v;(function(n){async function f(r,t,u){if(T.isAbsolute(r))return r;if(t===void 0&&(t=E.cwd()),T.dirname(r)!=="."||(u===void 0&&i.isString(E.env.PATH)&&(u=E.env.PATH.split(T.delimiter)),u===void 0||u.length===0))return T.join(t,r);async function c(m){if(await a.Promises.exists(m)){let d;try{d=await a.Promises.stat(m)}catch(_){_.message.startsWith("EACCES")&&(d=await a.Promises.lstat(m))}return d?!d.isDirectory():!1}return!1}for(let m of u){let d;if(T.isAbsolute(m)?d=T.join(m,r):d=T.join(t,m,r),await c(d))return d;let _=d+".com";if(await c(_)||(_=d+".exe",await c(_)))return _}return T.join(t,r)}n.findExecutable=f})(v=e.win32||(e.win32={}))}),define(fe[155],me([19,20]),function(Y,e){return Y.create("vs/editor/common/config/editorOptions",e)}),define(fe[114],me([0,1,155,12,110]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(J){J[J.None=0]="None",J[J.Keep=1]="Keep",J[J.Brackets=2]="Brackets",J[J.Advanced=3]="Advanced",J[J.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class T{constructor(ne){this._values=ne}hasChanged(ne){return this._values[ne]}}e.ConfigurationChangedEvent=T;class C{constructor(){this._values=[]}_read(ne){return this._values[ne]}get(ne){return this._values[ne]}_write(ne,Ee){this._values[ne]=Ee}}e.ValidatedEditorOptions=C;class E{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=E;class k{constructor(ne,Ee,Qe,et){this.id=ne,this.name=Ee,this.defaultValue=Qe,this.schema=et}compute(ne,Ee,Qe){return Qe}}class i{constructor(ne,Ee=null){this.schema=void 0,this.id=ne,this.name="_never_",this.defaultValue=void 0,this.deps=Ee}validate(ne){return this.defaultValue}}class I{constructor(ne,Ee,Qe,et){this.id=ne,this.name=Ee,this.defaultValue=Qe,this.schema=et}validate(ne){return typeof ne=="undefined"?this.defaultValue:ne}compute(ne,Ee,Qe){return Qe}}function a(J,ne){return typeof J=="undefined"?ne:J==="false"?!1:Boolean(J)}e.boolean=a;class p extends I{constructor(ne,Ee,Qe,et=void 0){typeof et!="undefined"&&(et.type="boolean",et.default=Qe),super(ne,Ee,Qe,et)}validate(ne){return a(ne,this.defaultValue)}}function h(J,ne,Ee,Qe){if(typeof J=="undefined")return ne;let et=parseInt(J,10);return isNaN(et)?ne:(et=Math.max(Ee,et),et=Math.min(Qe,et),et|0)}e.clampedInt=h;class w extends I{constructor(ne,Ee,Qe,et,le,Ie=void 0){typeof Ie!="undefined"&&(Ie.type="integer",Ie.default=Qe,Ie.minimum=et,Ie.maximum=le),super(ne,Ee,Qe,Ie),this.minimum=et,this.maximum=le}static clampedInt(ne,Ee,Qe,et){return h(ne,Ee,Qe,et)}validate(ne){return w.clampedInt(ne,this.defaultValue,this.minimum,this.maximum)}}class y extends I{constructor(ne,Ee,Qe,et,le){typeof le!="undefined"&&(le.type="number",le.default=Qe),super(ne,Ee,Qe,le),this.validationFn=et}static clamp(ne,Ee,Qe){return ne<Ee?Ee:ne>Qe?Qe:ne}static float(ne,Ee){if(typeof ne=="number")return ne;if(typeof ne=="undefined")return Ee;const Qe=parseFloat(ne);return isNaN(Qe)?Ee:Qe}validate(ne){return this.validationFn(y.float(ne,this.defaultValue))}}class P extends I{static string(ne,Ee){return typeof ne!="string"?Ee:ne}constructor(ne,Ee,Qe,et=void 0){typeof et!="undefined"&&(et.type="string",et.default=Qe),super(ne,Ee,Qe,et)}validate(ne){return P.string(ne,this.defaultValue)}}function b(J,ne,Ee){return typeof J!="string"||Ee.indexOf(J)===-1?ne:J}e.stringSet=b;class o extends I{constructor(ne,Ee,Qe,et,le=void 0){typeof le!="undefined"&&(le.type="string",le.enum=et,le.default=Qe),super(ne,Ee,Qe,le),this._allowedValues=et}validate(ne){return b(ne,this.defaultValue,this._allowedValues)}}class s extends k{constructor(ne,Ee,Qe,et,le,Ie,Ne=void 0){typeof Ne!="undefined"&&(Ne.type="string",Ne.enum=le,Ne.default=et),super(ne,Ee,Qe,Ne),this._allowedValues=le,this._convert=Ie}validate(ne){return typeof ne!="string"?this.defaultValue:this._allowedValues.indexOf(ne)===-1?this.defaultValue:this._convert(ne)}}function v(J){switch(J){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class n extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[g.localize(0,null),g.localize(1,null),g.localize(2,null)],default:"auto",description:g.localize(3,null)})}validate(ne){switch(ne){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ne,Ee,Qe){return Qe===0?ne.accessibilitySupport:Qe}}class f extends k{constructor(){const ne={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",ne,{"editor.comments.insertSpace":{type:"boolean",default:ne.insertSpace,description:g.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ne.ignoreEmptyLines,description:g.localize(5,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne;return{insertSpace:a(Ee.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:a(Ee.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(J){J[J.Hidden=0]="Hidden",J[J.Blink=1]="Blink",J[J.Smooth=2]="Smooth",J[J.Phase=3]="Phase",J[J.Expand=4]="Expand",J[J.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function t(J){switch(J){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var u;(function(J){J[J.Line=1]="Line",J[J.Block=2]="Block",J[J.Underline=3]="Underline",J[J.LineThin=4]="LineThin",J[J.BlockOutline=5]="BlockOutline",J[J.UnderlineThin=6]="UnderlineThin"})(u=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function l(J){switch(J){case u.Line:return"line";case u.Block:return"block";case u.Underline:return"underline";case u.LineThin:return"line-thin";case u.BlockOutline:return"block-outline";case u.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=l;function c(J){switch(J){case"line":return u.Line;case"block":return u.Block;case"underline":return u.Underline;case"line-thin":return u.LineThin;case"block-outline":return u.BlockOutline;case"underline-thin":return u.UnderlineThin}}class m extends i{constructor(){super(126,[65,33])}compute(ne,Ee,Qe){const et=["monaco-editor"];return Ee.get(33)&&et.push(Ee.get(33)),ne.extraEditorClassName&&et.push(ne.extraEditorClassName),Ee.get(65)==="default"?et.push("mouse-default"):Ee.get(65)==="copy"&&et.push("mouse-copy"),Ee.get(99)&&et.push("showUnused"),Ee.get(124)&&et.push("showDeprecated"),et.join(" ")}}class d extends p{constructor(){super(32,"emptySelectionClipboard",!0,{description:g.localize(6,null)})}compute(ne,Ee,Qe){return Qe&&ne.emptySelectionClipboard}}class _ extends k{constructor(){const ne={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",ne,{"editor.find.cursorMoveOnType":{type:"boolean",default:ne.cursorMoveOnType,description:g.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ne.seedSearchStringFromSelection,enumDescriptions:[g.localize(8,null),g.localize(9,null),g.localize(10,null)],description:g.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ne.autoFindInSelection,enumDescriptions:[g.localize(12,null),g.localize(13,null),g.localize(14,null)],description:g.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ne.globalFindClipboard,description:g.localize(16,null),included:L.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ne.addExtraSpaceOnTop,description:g.localize(17,null)},"editor.find.loop":{type:"boolean",default:ne.loop,description:g.localize(18,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne;return{cursorMoveOnType:a(Ee.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ne.seedSearchStringFromSelection=="boolean"?ne.seedSearchStringFromSelection?"always":"never":b(Ee.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ne.autoFindInSelection=="boolean"?ne.autoFindInSelection?"always":"never":b(Ee.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:a(Ee.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:a(Ee.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:a(Ee.loop,this.defaultValue.loop)}}}class A extends k{constructor(){super(44,"fontLigatures",A.OFF,{anyOf:[{type:"boolean",description:g.localize(19,null)},{type:"string",description:g.localize(20,null)}],description:g.localize(21,null),default:!1})}validate(ne){return typeof ne=="undefined"?this.defaultValue:typeof ne=="string"?ne==="false"?A.OFF:ne==="true"?A.ON:ne:Boolean(ne)?A.ON:A.OFF}}e.EditorFontLigatures=A,A.OFF='"liga" off, "calt" off',A.ON='"liga" on, "calt" on';class R extends i{constructor(){super(43)}compute(ne,Ee,Qe){return ne.fontInfo}}class B extends I{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:g.localize(22,null)})}validate(ne){let Ee=y.float(ne,this.defaultValue);return Ee===0?e.EDITOR_FONT_DEFAULTS.fontSize:y.clamp(Ee,6,100)}compute(ne,Ee,Qe){return ne.fontInfo.fontSize}}class U extends k{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:U.MINIMUM_VALUE,maximum:U.MAXIMUM_VALUE,errorMessage:g.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:U.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:g.localize(24,null)})}validate(ne){return ne==="normal"||ne==="bold"?ne:String(w.clampedInt(ne,e.EDITOR_FONT_DEFAULTS.fontWeight,U.MINIMUM_VALUE,U.MAXIMUM_VALUE))}}U.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],U.MINIMUM_VALUE=1,U.MAXIMUM_VALUE=1e3;class F extends k{constructor(){const ne={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ee={type:"string",enum:["peek","gotoAndPeek","goto"],default:ne.multiple,enumDescriptions:[g.localize(25,null),g.localize(26,null),g.localize(27,null)]},Qe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",ne,{"editor.gotoLocation.multiple":{deprecationMessage:g.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:g.localize(29,null),...Ee},"editor.gotoLocation.multipleTypeDefinitions":{description:g.localize(30,null),...Ee},"editor.gotoLocation.multipleDeclarations":{description:g.localize(31,null),...Ee},"editor.gotoLocation.multipleImplementations":{description:g.localize(32,null),...Ee},"editor.gotoLocation.multipleReferences":{description:g.localize(33,null),...Ee},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ne.alternativeDefinitionCommand,enum:Qe,description:g.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ne.alternativeTypeDefinitionCommand,enum:Qe,description:g.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ne.alternativeDeclarationCommand,enum:Qe,description:g.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ne.alternativeImplementationCommand,enum:Qe,description:g.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ne.alternativeReferenceCommand,enum:Qe,description:g.localize(38,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne;return{multiple:b(Ee.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ee.multipleDefinitions??b(Ee.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ee.multipleTypeDefinitions??b(Ee.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ee.multipleDeclarations??b(Ee.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ee.multipleImplementations??b(Ee.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ee.multipleReferences??b(Ee.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:P.string(Ee.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:P.string(Ee.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:P.string(Ee.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:P.string(Ee.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:P.string(Ee.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class $ extends k{constructor(){const ne={enabled:!0,delay:300,sticky:!0,above:!0};super(52,"hover",ne,{"editor.hover.enabled":{type:"boolean",default:ne.enabled,description:g.localize(39,null)},"editor.hover.delay":{type:"number",default:ne.delay,description:g.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:ne.sticky,description:g.localize(41,null)},"editor.hover.above":{type:"boolean",default:ne.above,description:g.localize(42,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne;return{enabled:a(Ee.enabled,this.defaultValue.enabled),delay:w.clampedInt(Ee.delay,this.defaultValue.delay,0,1e4),sticky:a(Ee.sticky,this.defaultValue.sticky),above:a(Ee.above,this.defaultValue.above)}}}var M;(function(J){J[J.None=0]="None",J[J.Text=1]="Text",J[J.Blocks=2]="Blocks"})(M=e.RenderMinimap||(e.RenderMinimap={}));class z extends i{constructor(){super(129,[49,57,37,64,91,59,60,93,116,119,120,121,2])}compute(ne,Ee,Qe){return z.computeLayout(Ee,{memory:ne.memory,outerWidth:ne.outerWidth,outerHeight:ne.outerHeight,isDominatedByLongLines:ne.isDominatedByLongLines,lineHeight:ne.fontInfo.lineHeight,viewLineCount:ne.viewLineCount,lineNumbersDigitCount:ne.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ne.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ne.fontInfo.maxDigitWidth,pixelRatio:ne.pixelRatio})}static computeContainedMinimapLineCount(ne){const Ee=ne.height/ne.lineHeight,Qe=ne.scrollBeyondLastLine?Ee-1:0,et=(ne.viewLineCount+Qe)/(ne.pixelRatio*ne.height),le=Math.floor(ne.viewLineCount/et);return{typicalViewportLineCount:Ee,extraLinesBeyondLastLine:Qe,desiredRatio:et,minimapLineCount:le}}static _computeMinimapLayout(ne,Ee){const Qe=ne.outerWidth,et=ne.outerHeight,le=ne.pixelRatio;if(!ne.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(le*et),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:et};const Ie=Ee.stableMinimapLayoutInput,Ne=Ie&&ne.outerHeight===Ie.outerHeight&&ne.lineHeight===Ie.lineHeight&&ne.typicalHalfwidthCharacterWidth===Ie.typicalHalfwidthCharacterWidth&&ne.pixelRatio===Ie.pixelRatio&&ne.scrollBeyondLastLine===Ie.scrollBeyondLastLine&&ne.minimap.enabled===Ie.minimap.enabled&&ne.minimap.side===Ie.minimap.side&&ne.minimap.size===Ie.minimap.size&&ne.minimap.showSlider===Ie.minimap.showSlider&&ne.minimap.renderCharacters===Ie.minimap.renderCharacters&&ne.minimap.maxColumn===Ie.minimap.maxColumn&&ne.minimap.scale===Ie.minimap.scale&&ne.verticalScrollbarWidth===Ie.verticalScrollbarWidth&&ne.isViewportWrapping===Ie.isViewportWrapping,Xe=ne.lineHeight,nt=ne.typicalHalfwidthCharacterWidth,ft=ne.scrollBeyondLastLine,tt=ne.minimap.renderCharacters;let ut=le>=2?Math.round(ne.minimap.scale*2):ne.minimap.scale;const Re=ne.minimap.maxColumn,De=ne.minimap.size,Te=ne.minimap.side,se=ne.verticalScrollbarWidth,ue=ne.viewLineCount,we=ne.remainingWidth,ve=ne.isViewportWrapping,Fe=tt?2:3;let qe=Math.floor(le*et);const ze=qe/le;let Ye=!1,lt=!1,xe=Fe*ut,ge=ut/le,be=1;if(De==="fill"||De==="fit"){const{typicalViewportLineCount:mt,extraLinesBeyondLastLine:yt,desiredRatio:Et,minimapLineCount:gt}=z.computeContainedMinimapLineCount({viewLineCount:ue,scrollBeyondLastLine:ft,height:et,lineHeight:Xe,pixelRatio:le});if(ue/gt>1)Ye=!0,lt=!0,ut=1,xe=1,ge=ut/le;else{let vt=!1,Tt=ut+1;if(De==="fit"){const Dt=Math.ceil((ue+yt)*xe);ve&&Ne&&we<=Ee.stableFitRemainingWidth?(vt=!0,Tt=Ee.stableFitMaxMinimapScale):vt=Dt>qe}if(De==="fill"||vt){Ye=!0;const Dt=ut;xe=Math.min(Xe*le,Math.max(1,Math.floor(1/Et))),ve&&Ne&&we<=Ee.stableFitRemainingWidth&&(Tt=Ee.stableFitMaxMinimapScale),ut=Math.min(Tt,Math.max(1,Math.floor(xe/Fe))),ut>Dt&&(be=Math.min(2,ut/Dt)),ge=ut/le/be,qe=Math.ceil(Math.max(mt,ue+yt)*xe),ve?(Ee.stableMinimapLayoutInput=ne,Ee.stableFitRemainingWidth=we,Ee.stableFitMaxMinimapScale=ut):(Ee.stableMinimapLayoutInput=null,Ee.stableFitRemainingWidth=0)}}}const ae=Math.floor(Re*ge),K=Math.min(ae,Math.max(0,Math.floor((we-se-2)*ge/(nt+ge)))+e.MINIMAP_GUTTER_WIDTH);let Se=Math.floor(le*K);const Le=Se/le;Se=Math.floor(Se*be);const it=tt?1:2,Ge=Te==="left"?0:Qe-K-se;return{renderMinimap:it,minimapLeft:Ge,minimapWidth:K,minimapHeightIsEditorHeight:Ye,minimapIsSampling:lt,minimapScale:ut,minimapLineHeight:xe,minimapCanvasInnerWidth:Se,minimapCanvasInnerHeight:qe,minimapCanvasOuterWidth:Le,minimapCanvasOuterHeight:ze}}static computeLayout(ne,Ee){const Qe=Ee.outerWidth|0,et=Ee.outerHeight|0,le=Ee.lineHeight|0,Ie=Ee.lineNumbersDigitCount|0,Ne=Ee.typicalHalfwidthCharacterWidth,Xe=Ee.maxDigitWidth,nt=Ee.pixelRatio,ft=Ee.viewLineCount,tt=ne.get(121),ut=tt==="inherit"?ne.get(120):tt,Re=ut==="inherit"?ne.get(116):ut,De=ne.get(119),Te=ne.get(2),se=Ee.isDominatedByLongLines,ue=ne.get(49),we=ne.get(59).renderType!==0,ve=ne.get(60),Fe=ne.get(93),qe=ne.get(64),ze=ne.get(91),Ye=ze.verticalScrollbarSize,lt=ze.verticalHasArrows,xe=ze.arrowSize,ge=ze.horizontalScrollbarSize,be=ne.get(57),ae=ne.get(37);let K;if(typeof be=="string"&&/^\d+(\.\d+)?ch$/.test(be)){const kt=parseFloat(be.substr(0,be.length-2));K=w.clampedInt(kt*Ne,0,0,1e3)}else K=w.clampedInt(be,0,0,1e3);ae&&(K+=16);let Se=0;if(we){const kt=Math.max(Ie,ve);Se=Math.round(kt*Xe)}let Le=0;ue&&(Le=le);let it=0,Ge=it+Le,mt=Ge+Se,yt=mt+K;const Et=Qe-Le-Se-K;let gt=!1,bt=!1,vt=-1;Te!==2&&(ut==="inherit"&&se?(gt=!0,bt=!0):Re==="on"||Re==="bounded"?bt=!0:Re==="wordWrapColumn"&&(vt=De));const Tt=z._computeMinimapLayout({outerWidth:Qe,outerHeight:et,lineHeight:le,typicalHalfwidthCharacterWidth:Ne,pixelRatio:nt,scrollBeyondLastLine:Fe,minimap:qe,verticalScrollbarWidth:Ye,viewLineCount:ft,remainingWidth:Et,isViewportWrapping:bt},Ee.memory||new E);Tt.renderMinimap!==0&&Tt.minimapLeft===0&&(it+=Tt.minimapWidth,Ge+=Tt.minimapWidth,mt+=Tt.minimapWidth,yt+=Tt.minimapWidth);const Dt=Et-Tt.minimapWidth,$t=Math.max(1,Math.floor((Dt-Ye-2)/Ne)),jt=lt?xe:0;return bt&&(vt=Math.max(1,$t),Re==="bounded"&&(vt=Math.min(vt,De))),{width:Qe,height:et,glyphMarginLeft:it,glyphMarginWidth:Le,lineNumbersLeft:Ge,lineNumbersWidth:Se,decorationsLeft:mt,decorationsWidth:K,contentLeft:yt,contentWidth:Dt,minimap:Tt,viewportColumn:$t,isWordWrapMinified:gt,isViewportWrapping:bt,wrappingColumn:vt,verticalScrollbarWidth:Ye,horizontalScrollbarHeight:ge,overviewRuler:{top:jt,width:Ye,height:et-2*jt,right:0}}}}e.EditorLayoutInfoComputer=z;class N extends k{constructor(){const ne={enabled:!0};super(56,"lightbulb",ne,{"editor.lightbulb.enabled":{type:"boolean",default:ne.enabled,description:g.localize(43,null)}})}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:{enabled:a(ne.enabled,this.defaultValue.enabled)}}}class x extends k{constructor(){const ne={enabled:!0,fontSize:0,fontFamily:""};super(125,"inlayHints",ne,{"editor.inlayHints.enabled":{type:"boolean",default:ne.enabled,description:g.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:ne.fontSize,markdownDescription:g.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:ne.fontFamily,markdownDescription:g.localize(46,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne;return{enabled:a(Ee.enabled,this.defaultValue.enabled),fontSize:w.clampedInt(Ee.fontSize,this.defaultValue.fontSize,0,100),fontFamily:P.string(Ee.fontFamily,this.defaultValue.fontFamily)}}}class j extends y{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ne=>y.clamp(ne,0,150),{markdownDescription:g.localize(47,null)})}compute(ne,Ee,Qe){return ne.fontInfo.lineHeight}}class O extends k{constructor(){const ne={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",ne,{"editor.minimap.enabled":{type:"boolean",default:ne.enabled,description:g.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[g.localize(49,null),g.localize(50,null),g.localize(51,null)],default:ne.size,description:g.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ne.side,description:g.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ne.showSlider,description:g.localize(54,null)},"editor.minimap.scale":{type:"number",default:ne.scale,minimum:1,maximum:3,enum:[1,2,3],description:g.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ne.renderCharacters,description:g.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:ne.maxColumn,description:g.localize(57,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne;return{enabled:a(Ee.enabled,this.defaultValue.enabled),size:b(Ee.size,this.defaultValue.size,["proportional","fill","fit"]),side:b(Ee.side,this.defaultValue.side,["right","left"]),showSlider:b(Ee.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:a(Ee.renderCharacters,this.defaultValue.renderCharacters),scale:w.clampedInt(Ee.scale,1,1,3),maxColumn:w.clampedInt(Ee.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function H(J){return J==="ctrlCmd"?L.isMacintosh?"metaKey":"ctrlKey":"altKey"}class W extends k{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(59,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne;return{top:w.clampedInt(Ee.top,0,0,1e3),bottom:w.clampedInt(Ee.bottom,0,0,1e3)}}}class X extends k{constructor(){const ne={enabled:!0,cycle:!1};super(75,"parameterHints",ne,{"editor.parameterHints.enabled":{type:"boolean",default:ne.enabled,description:g.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:ne.cycle,description:g.localize(61,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne;return{enabled:a(Ee.enabled,this.defaultValue.enabled),cycle:a(Ee.cycle,this.defaultValue.cycle)}}}class Q extends i{constructor(){super(127)}compute(ne,Ee,Qe){return ne.pixelRatio}}class de extends k{constructor(){const ne={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",ne,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ne.strings,description:g.localize(62,null)},comments:{type:"boolean",default:ne.comments,description:g.localize(63,null)},other:{type:"boolean",default:ne.other,description:g.localize(64,null)}}}],default:ne,description:g.localize(65,null)});this.defaultValue=ne}validate(ne){if(typeof ne=="boolean")return ne;if(ne&&typeof ne=="object"){const Ee=ne,Qe={other:a(Ee.other,this.defaultValue.other),comments:a(Ee.comments,this.defaultValue.comments),strings:a(Ee.strings,this.defaultValue.strings)};return Qe.other&&Qe.comments&&Qe.strings?!0:!Qe.other&&!Qe.comments&&!Qe.strings?!1:Qe}return this.defaultValue}}var _e;(function(J){J[J.Off=0]="Off",J[J.On=1]="On",J[J.Relative=2]="Relative",J[J.Interval=3]="Interval",J[J.Custom=4]="Custom"})(_e=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ce extends k{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[g.localize(66,null),g.localize(67,null),g.localize(68,null),g.localize(69,null)],default:"on",description:g.localize(70,null)})}validate(ne){let Ee=this.defaultValue.renderType,Qe=this.defaultValue.renderFn;return typeof ne!="undefined"&&(typeof ne=="function"?(Ee=4,Qe=ne):ne==="interval"?Ee=3:ne==="relative"?Ee=2:ne==="on"?Ee=1:Ee=0),{renderType:Ee,renderFn:Qe}}}function Pe(J){const ne=J.get(86);return ne==="editable"?J.get(80):ne!=="on"}e.filterValidationDecorations=Pe;class Be extends k{constructor(){const ne=[],Ee={type:"number",description:g.localize(71,null)};super(90,"rulers",ne,{type:"array",items:{anyOf:[Ee,{type:["object"],properties:{column:Ee,color:{type:"string",description:g.localize(72,null),format:"color-hex"}}}]},default:ne,description:g.localize(73,null)})}validate(ne){if(Array.isArray(ne)){let Ee=[];for(let Qe of ne)if(typeof Qe=="number")Ee.push({column:w.clampedInt(Qe,0,0,1e4),color:null});else if(Qe&&typeof Qe=="object"){const et=Qe;Ee.push({column:w.clampedInt(et.column,0,0,1e4),color:et.color})}return Ee.sort((Qe,et)=>Qe.column-et.column),Ee}return this.defaultValue}}function We(J,ne){if(typeof J!="string")return ne;switch(J){case"hidden":return 2;case"visible":return 3;default:return 1}}class He extends k{constructor(){const ne={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",ne,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(74,null),g.localize(75,null),g.localize(76,null)],default:"auto",description:g.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(78,null),g.localize(79,null),g.localize(80,null)],default:"auto",description:g.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ne.verticalScrollbarSize,description:g.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ne.horizontalScrollbarSize,description:g.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ne.scrollByPage,description:g.localize(84,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne,Qe=w.clampedInt(Ee.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),et=w.clampedInt(Ee.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:w.clampedInt(Ee.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:We(Ee.vertical,this.defaultValue.vertical),horizontal:We(Ee.horizontal,this.defaultValue.horizontal),useShadows:a(Ee.useShadows,this.defaultValue.useShadows),verticalHasArrows:a(Ee.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:a(Ee.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:a(Ee.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:a(Ee.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Qe,horizontalSliderSize:w.clampedInt(Ee.horizontalSliderSize,Qe,0,1e3),verticalScrollbarSize:et,verticalSliderSize:w.clampedInt(Ee.verticalSliderSize,et,0,1e3),scrollByPage:a(Ee.scrollByPage,this.defaultValue.scrollByPage)}}}class G extends k{constructor(){const ne={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",ne,{"editor.inlineSuggest.enabled":{type:"boolean",default:ne.enabled,description:g.localize(85,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne;return{enabled:a(Ee.enabled,this.defaultValue.enabled),mode:b(Ee.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class ee extends k{constructor(){const ne={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",ne,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ne.enabled,description:g.localize(86,null)}})}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:{enabled:a(ne.enabled,this.defaultValue.enabled)}}}class ie extends k{constructor(){const ne={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",ne,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[g.localize(87,null),g.localize(88,null),g.localize(89,null)],default:ne.bracketPairs,description:g.localize(90,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[g.localize(91,null),g.localize(92,null),g.localize(93,null)],default:ne.bracketPairsHorizontal,description:g.localize(94,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ne.highlightActiveBracketPair,description:g.localize(95,null)},"editor.guides.indentation":{type:"boolean",default:ne.indentation,description:g.localize(96,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:ne.highlightActiveIndentation,description:g.localize(97,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne;return{bracketPairs:ce(Ee.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ce(Ee.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:a(Ee.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:a(Ee.indentation,this.defaultValue.indentation),highlightActiveIndentation:a(Ee.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function ce(J,ne,Ee){const Qe=Ee.indexOf(J);return Qe===-1?ne:Ee[Qe]}class Z extends k{constructor(){const ne={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",ne,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[g.localize(98,null),g.localize(99,null)],default:ne.insertMode,description:g.localize(100,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ne.filterGraceful,description:g.localize(101,null)},"editor.suggest.localityBonus":{type:"boolean",default:ne.localityBonus,description:g.localize(102,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ne.shareSuggestSelections,markdownDescription:g.localize(103,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ne.snippetsPreventQuickSuggestions,description:g.localize(104,null)},"editor.suggest.showIcons":{type:"boolean",default:ne.showIcons,description:g.localize(105,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ne.showStatusBar,description:g.localize(106,null)},"editor.suggest.preview":{type:"boolean",default:ne.preview,description:g.localize(107,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ne.showInlineDetails,description:g.localize(108,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:g.localize(109,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:g.localize(110,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:g.localize(111,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:g.localize(112,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:g.localize(113,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:g.localize(114,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:g.localize(115,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:g.localize(116,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:g.localize(117,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:g.localize(118,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:g.localize(119,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:g.localize(120,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:g.localize(121,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:g.localize(122,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:g.localize(123,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:g.localize(124,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:g.localize(125,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:g.localize(126,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:g.localize(127,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:g.localize(128,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:g.localize(129,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:g.localize(130,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:g.localize(131,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:g.localize(132,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:g.localize(133,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:g.localize(134,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:g.localize(135,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:g.localize(136,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:g.localize(137,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:g.localize(138,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:g.localize(139,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne;return{insertMode:b(Ee.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:a(Ee.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:a(Ee.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:a(Ee.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:a(Ee.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:a(Ee.showIcons,this.defaultValue.showIcons),showStatusBar:a(Ee.showStatusBar,this.defaultValue.showStatusBar),preview:a(Ee.preview,this.defaultValue.preview),previewMode:b(Ee.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:a(Ee.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:a(Ee.showMethods,this.defaultValue.showMethods),showFunctions:a(Ee.showFunctions,this.defaultValue.showFunctions),showConstructors:a(Ee.showConstructors,this.defaultValue.showConstructors),showDeprecated:a(Ee.showDeprecated,this.defaultValue.showDeprecated),showFields:a(Ee.showFields,this.defaultValue.showFields),showVariables:a(Ee.showVariables,this.defaultValue.showVariables),showClasses:a(Ee.showClasses,this.defaultValue.showClasses),showStructs:a(Ee.showStructs,this.defaultValue.showStructs),showInterfaces:a(Ee.showInterfaces,this.defaultValue.showInterfaces),showModules:a(Ee.showModules,this.defaultValue.showModules),showProperties:a(Ee.showProperties,this.defaultValue.showProperties),showEvents:a(Ee.showEvents,this.defaultValue.showEvents),showOperators:a(Ee.showOperators,this.defaultValue.showOperators),showUnits:a(Ee.showUnits,this.defaultValue.showUnits),showValues:a(Ee.showValues,this.defaultValue.showValues),showConstants:a(Ee.showConstants,this.defaultValue.showConstants),showEnums:a(Ee.showEnums,this.defaultValue.showEnums),showEnumMembers:a(Ee.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:a(Ee.showKeywords,this.defaultValue.showKeywords),showWords:a(Ee.showWords,this.defaultValue.showWords),showColors:a(Ee.showColors,this.defaultValue.showColors),showFiles:a(Ee.showFiles,this.defaultValue.showFiles),showReferences:a(Ee.showReferences,this.defaultValue.showReferences),showFolders:a(Ee.showFolders,this.defaultValue.showFolders),showTypeParameters:a(Ee.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:a(Ee.showSnippets,this.defaultValue.showSnippets),showUsers:a(Ee.showUsers,this.defaultValue.showUsers),showIssues:a(Ee.showIssues,this.defaultValue.showIssues)}}}class re extends k{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:g.localize(140,null),default:!0,type:"boolean"}})}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:a(ne.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class pe extends i{constructor(){super(128,[80])}compute(ne,Ee,Qe){return Ee.get(80)?!0:ne.tabFocusMode}}var Me;(function(J){J[J.None=0]="None",J[J.Same=1]="Same",J[J.Indent=2]="Indent",J[J.DeepIndent=3]="DeepIndent"})(Me=e.WrappingIndent||(e.WrappingIndent={}));function je(J){switch(J){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class Ke extends i{constructor(){super(130,[129])}compute(ne,Ee,Qe){const et=Ee.get(129);return{isDominatedByLongLines:ne.isDominatedByLongLines,isWordWrapMinified:et.isWordWrapMinified,isViewportWrapping:et.isViewportWrapping,wrappingColumn:et.wrappingColumn}}}const Ze="Consolas, 'Courier New', monospace",rt="Menlo, Monaco, 'Courier New', monospace",ct="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:L.isMacintosh?rt:L.isLinux?ct:Ze,fontWeight:"normal",fontSize:L.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function ye(J){return e.editorOptionsRegistry[J.id]=J,J}var at;(function(J){J[J.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",J[J.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",J[J.accessibilitySupport=2]="accessibilitySupport",J[J.accessibilityPageSize=3]="accessibilityPageSize",J[J.ariaLabel=4]="ariaLabel",J[J.autoClosingBrackets=5]="autoClosingBrackets",J[J.autoClosingDelete=6]="autoClosingDelete",J[J.autoClosingOvertype=7]="autoClosingOvertype",J[J.autoClosingQuotes=8]="autoClosingQuotes",J[J.autoIndent=9]="autoIndent",J[J.automaticLayout=10]="automaticLayout",J[J.autoSurround=11]="autoSurround",J[J.bracketPairColorization=12]="bracketPairColorization",J[J.guides=13]="guides",J[J.codeLens=14]="codeLens",J[J.codeLensFontFamily=15]="codeLensFontFamily",J[J.codeLensFontSize=16]="codeLensFontSize",J[J.colorDecorators=17]="colorDecorators",J[J.columnSelection=18]="columnSelection",J[J.comments=19]="comments",J[J.contextmenu=20]="contextmenu",J[J.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",J[J.cursorBlinking=22]="cursorBlinking",J[J.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",J[J.cursorStyle=24]="cursorStyle",J[J.cursorSurroundingLines=25]="cursorSurroundingLines",J[J.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",J[J.cursorWidth=27]="cursorWidth",J[J.disableLayerHinting=28]="disableLayerHinting",J[J.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",J[J.domReadOnly=30]="domReadOnly",J[J.dragAndDrop=31]="dragAndDrop",J[J.emptySelectionClipboard=32]="emptySelectionClipboard",J[J.extraEditorClassName=33]="extraEditorClassName",J[J.fastScrollSensitivity=34]="fastScrollSensitivity",J[J.find=35]="find",J[J.fixedOverflowWidgets=36]="fixedOverflowWidgets",J[J.folding=37]="folding",J[J.foldingStrategy=38]="foldingStrategy",J[J.foldingHighlight=39]="foldingHighlight",J[J.foldingImportsByDefault=40]="foldingImportsByDefault",J[J.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",J[J.fontFamily=42]="fontFamily",J[J.fontInfo=43]="fontInfo",J[J.fontLigatures=44]="fontLigatures",J[J.fontSize=45]="fontSize",J[J.fontWeight=46]="fontWeight",J[J.formatOnPaste=47]="formatOnPaste",J[J.formatOnType=48]="formatOnType",J[J.glyphMargin=49]="glyphMargin",J[J.gotoLocation=50]="gotoLocation",J[J.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",J[J.hover=52]="hover",J[J.inDiffEditor=53]="inDiffEditor",J[J.inlineSuggest=54]="inlineSuggest",J[J.letterSpacing=55]="letterSpacing",J[J.lightbulb=56]="lightbulb",J[J.lineDecorationsWidth=57]="lineDecorationsWidth",J[J.lineHeight=58]="lineHeight",J[J.lineNumbers=59]="lineNumbers",J[J.lineNumbersMinChars=60]="lineNumbersMinChars",J[J.linkedEditing=61]="linkedEditing",J[J.links=62]="links",J[J.matchBrackets=63]="matchBrackets",J[J.minimap=64]="minimap",J[J.mouseStyle=65]="mouseStyle",J[J.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",J[J.mouseWheelZoom=67]="mouseWheelZoom",J[J.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",J[J.multiCursorModifier=69]="multiCursorModifier",J[J.multiCursorPaste=70]="multiCursorPaste",J[J.occurrencesHighlight=71]="occurrencesHighlight",J[J.overviewRulerBorder=72]="overviewRulerBorder",J[J.overviewRulerLanes=73]="overviewRulerLanes",J[J.padding=74]="padding",J[J.parameterHints=75]="parameterHints",J[J.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",J[J.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",J[J.quickSuggestions=78]="quickSuggestions",J[J.quickSuggestionsDelay=79]="quickSuggestionsDelay",J[J.readOnly=80]="readOnly",J[J.renameOnType=81]="renameOnType",J[J.renderControlCharacters=82]="renderControlCharacters",J[J.renderFinalNewline=83]="renderFinalNewline",J[J.renderLineHighlight=84]="renderLineHighlight",J[J.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",J[J.renderValidationDecorations=86]="renderValidationDecorations",J[J.renderWhitespace=87]="renderWhitespace",J[J.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",J[J.roundedSelection=89]="roundedSelection",J[J.rulers=90]="rulers",J[J.scrollbar=91]="scrollbar",J[J.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",J[J.scrollBeyondLastLine=93]="scrollBeyondLastLine",J[J.scrollPredominantAxis=94]="scrollPredominantAxis",J[J.selectionClipboard=95]="selectionClipboard",J[J.selectionHighlight=96]="selectionHighlight",J[J.selectOnLineNumbers=97]="selectOnLineNumbers",J[J.showFoldingControls=98]="showFoldingControls",J[J.showUnused=99]="showUnused",J[J.snippetSuggestions=100]="snippetSuggestions",J[J.smartSelect=101]="smartSelect",J[J.smoothScrolling=102]="smoothScrolling",J[J.stickyTabStops=103]="stickyTabStops",J[J.stopRenderingLineAfter=104]="stopRenderingLineAfter",J[J.suggest=105]="suggest",J[J.suggestFontSize=106]="suggestFontSize",J[J.suggestLineHeight=107]="suggestLineHeight",J[J.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",J[J.suggestSelection=109]="suggestSelection",J[J.tabCompletion=110]="tabCompletion",J[J.tabIndex=111]="tabIndex",J[J.unusualLineTerminators=112]="unusualLineTerminators",J[J.useShadowDOM=113]="useShadowDOM",J[J.useTabStops=114]="useTabStops",J[J.wordSeparators=115]="wordSeparators",J[J.wordWrap=116]="wordWrap",J[J.wordWrapBreakAfterCharacters=117]="wordWrapBreakAfterCharacters",J[J.wordWrapBreakBeforeCharacters=118]="wordWrapBreakBeforeCharacters",J[J.wordWrapColumn=119]="wordWrapColumn",J[J.wordWrapOverride1=120]="wordWrapOverride1",J[J.wordWrapOverride2=121]="wordWrapOverride2",J[J.wrappingIndent=122]="wrappingIndent",J[J.wrappingStrategy=123]="wrappingStrategy",J[J.showDeprecated=124]="showDeprecated",J[J.inlayHints=125]="inlayHints",J[J.editorClassName=126]="editorClassName",J[J.pixelRatio=127]="pixelRatio",J[J.tabFocusMode=128]="tabFocusMode",J[J.layoutInfo=129]="layoutInfo",J[J.wrappingInfo=130]="wrappingInfo"})(at=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ye(new p(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:g.localize(141,null)})),acceptSuggestionOnEnter:ye(new o(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",g.localize(142,null),""],markdownDescription:g.localize(143,null)})),accessibilitySupport:ye(new n),accessibilityPageSize:ye(new w(3,"accessibilityPageSize",10,1,1073741824,{description:g.localize(144,null)})),ariaLabel:ye(new P(4,"ariaLabel",g.localize(145,null))),autoClosingBrackets:ye(new o(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(146,null),g.localize(147,null),""],description:g.localize(148,null)})),autoClosingDelete:ye(new o(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",g.localize(149,null),""],description:g.localize(150,null)})),autoClosingOvertype:ye(new o(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",g.localize(151,null),""],description:g.localize(152,null)})),autoClosingQuotes:ye(new o(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(153,null),g.localize(154,null),""],description:g.localize(155,null)})),autoIndent:ye(new s(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],v,{enumDescriptions:[g.localize(156,null),g.localize(157,null),g.localize(158,null),g.localize(159,null),g.localize(160,null)],description:g.localize(161,null)})),automaticLayout:ye(new p(10,"automaticLayout",!1)),autoSurround:ye(new o(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[g.localize(162,null),g.localize(163,null),g.localize(164,null),""],description:g.localize(165,null)})),bracketPairColorization:ye(new ee),bracketPairGuides:ye(new ie),stickyTabStops:ye(new p(103,"stickyTabStops",!1,{description:g.localize(166,null)})),codeLens:ye(new p(14,"codeLens",!0,{description:g.localize(167,null)})),codeLensFontFamily:ye(new P(15,"codeLensFontFamily","",{description:g.localize(168,null)})),codeLensFontSize:ye(new w(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:g.localize(169,null)})),colorDecorators:ye(new p(17,"colorDecorators",!0,{description:g.localize(170,null)})),columnSelection:ye(new p(18,"columnSelection",!1,{description:g.localize(171,null)})),comments:ye(new f),contextmenu:ye(new p(20,"contextmenu",!0)),copyWithSyntaxHighlighting:ye(new p(21,"copyWithSyntaxHighlighting",!0,{description:g.localize(172,null)})),cursorBlinking:ye(new s(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],t,{description:g.localize(173,null)})),cursorSmoothCaretAnimation:ye(new p(23,"cursorSmoothCaretAnimation",!1,{description:g.localize(174,null)})),cursorStyle:ye(new s(24,"cursorStyle",u.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],c,{description:g.localize(175,null)})),cursorSurroundingLines:ye(new w(25,"cursorSurroundingLines",0,0,1073741824,{description:g.localize(176,null)})),cursorSurroundingLinesStyle:ye(new o(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[g.localize(177,null),g.localize(178,null)],description:g.localize(179,null)})),cursorWidth:ye(new w(27,"cursorWidth",0,0,1073741824,{markdownDescription:g.localize(180,null)})),disableLayerHinting:ye(new p(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:ye(new p(29,"disableMonospaceOptimizations",!1)),domReadOnly:ye(new p(30,"domReadOnly",!1)),dragAndDrop:ye(new p(31,"dragAndDrop",!0,{description:g.localize(181,null)})),emptySelectionClipboard:ye(new d),extraEditorClassName:ye(new P(33,"extraEditorClassName","")),fastScrollSensitivity:ye(new y(34,"fastScrollSensitivity",5,J=>J<=0?5:J,{markdownDescription:g.localize(182,null)})),find:ye(new _),fixedOverflowWidgets:ye(new p(36,"fixedOverflowWidgets",!1)),folding:ye(new p(37,"folding",!0,{description:g.localize(183,null)})),foldingStrategy:ye(new o(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[g.localize(184,null),g.localize(185,null)],description:g.localize(186,null)})),foldingHighlight:ye(new p(39,"foldingHighlight",!0,{description:g.localize(187,null)})),foldingImportsByDefault:ye(new p(40,"foldingImportsByDefault",!1,{description:g.localize(188,null)})),unfoldOnClickAfterEndOfLine:ye(new p(41,"unfoldOnClickAfterEndOfLine",!1,{description:g.localize(189,null)})),fontFamily:ye(new P(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:g.localize(190,null)})),fontInfo:ye(new R),fontLigatures2:ye(new A),fontSize:ye(new B),fontWeight:ye(new U),formatOnPaste:ye(new p(47,"formatOnPaste",!1,{description:g.localize(191,null)})),formatOnType:ye(new p(48,"formatOnType",!1,{description:g.localize(192,null)})),glyphMargin:ye(new p(49,"glyphMargin",!0,{description:g.localize(193,null)})),gotoLocation:ye(new F),hideCursorInOverviewRuler:ye(new p(51,"hideCursorInOverviewRuler",!1,{description:g.localize(194,null)})),hover:ye(new $),inDiffEditor:ye(new p(53,"inDiffEditor",!1)),letterSpacing:ye(new y(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,J=>y.clamp(J,-5,20),{description:g.localize(195,null)})),lightbulb:ye(new N),lineDecorationsWidth:ye(new I(57,"lineDecorationsWidth",10)),lineHeight:ye(new j),lineNumbers:ye(new Ce),lineNumbersMinChars:ye(new w(60,"lineNumbersMinChars",5,1,300)),linkedEditing:ye(new p(61,"linkedEditing",!1,{description:g.localize(196,null)})),links:ye(new p(62,"links",!0,{description:g.localize(197,null)})),matchBrackets:ye(new o(63,"matchBrackets","always",["always","near","never"],{description:g.localize(198,null)})),minimap:ye(new O),mouseStyle:ye(new o(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ye(new y(66,"mouseWheelScrollSensitivity",1,J=>J===0?1:J,{markdownDescription:g.localize(199,null)})),mouseWheelZoom:ye(new p(67,"mouseWheelZoom",!1,{markdownDescription:g.localize(200,null)})),multiCursorMergeOverlapping:ye(new p(68,"multiCursorMergeOverlapping",!0,{description:g.localize(201,null)})),multiCursorModifier:ye(new s(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],H,{markdownEnumDescriptions:[g.localize(202,null),g.localize(203,null)],markdownDescription:g.localize(204,null)})),multiCursorPaste:ye(new o(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[g.localize(205,null),g.localize(206,null)],markdownDescription:g.localize(207,null)})),occurrencesHighlight:ye(new p(71,"occurrencesHighlight",!0,{description:g.localize(208,null)})),overviewRulerBorder:ye(new p(72,"overviewRulerBorder",!0,{description:g.localize(209,null)})),overviewRulerLanes:ye(new w(73,"overviewRulerLanes",3,0,3)),padding:ye(new W),parameterHints:ye(new X),peekWidgetDefaultFocus:ye(new o(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[g.localize(210,null),g.localize(211,null)],description:g.localize(212,null)})),definitionLinkOpensInPeek:ye(new p(77,"definitionLinkOpensInPeek",!1,{description:g.localize(213,null)})),quickSuggestions:ye(new de),quickSuggestionsDelay:ye(new w(79,"quickSuggestionsDelay",10,0,1073741824,{description:g.localize(214,null)})),readOnly:ye(new p(80,"readOnly",!1)),renameOnType:ye(new p(81,"renameOnType",!1,{description:g.localize(215,null),markdownDeprecationMessage:g.localize(216,null)})),renderControlCharacters:ye(new p(82,"renderControlCharacters",!0,{description:g.localize(217,null),restricted:!0})),renderFinalNewline:ye(new p(83,"renderFinalNewline",!0,{description:g.localize(218,null)})),renderLineHighlight:ye(new o(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",g.localize(219,null)],description:g.localize(220,null)})),renderLineHighlightOnlyWhenFocus:ye(new p(85,"renderLineHighlightOnlyWhenFocus",!1,{description:g.localize(221,null)})),renderValidationDecorations:ye(new o(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ye(new o(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",g.localize(222,null),g.localize(223,null),g.localize(224,null),""],description:g.localize(225,null)})),revealHorizontalRightPadding:ye(new w(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ye(new p(89,"roundedSelection",!0,{description:g.localize(226,null)})),rulers:ye(new Be),scrollbar:ye(new He),scrollBeyondLastColumn:ye(new w(92,"scrollBeyondLastColumn",5,0,1073741824,{description:g.localize(227,null)})),scrollBeyondLastLine:ye(new p(93,"scrollBeyondLastLine",!0,{description:g.localize(228,null)})),scrollPredominantAxis:ye(new p(94,"scrollPredominantAxis",!0,{description:g.localize(229,null)})),selectionClipboard:ye(new p(95,"selectionClipboard",!0,{description:g.localize(230,null),included:L.isLinux})),selectionHighlight:ye(new p(96,"selectionHighlight",!0,{description:g.localize(231,null)})),selectOnLineNumbers:ye(new p(97,"selectOnLineNumbers",!0)),showFoldingControls:ye(new o(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[g.localize(232,null),g.localize(233,null)],description:g.localize(234,null)})),showUnused:ye(new p(99,"showUnused",!0,{description:g.localize(235,null)})),showDeprecated:ye(new p(124,"showDeprecated",!0,{description:g.localize(236,null)})),inlayHints:ye(new x),snippetSuggestions:ye(new o(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[g.localize(237,null),g.localize(238,null),g.localize(239,null),g.localize(240,null)],description:g.localize(241,null)})),smartSelect:ye(new re),smoothScrolling:ye(new p(102,"smoothScrolling",!1,{description:g.localize(242,null)})),stopRenderingLineAfter:ye(new w(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ye(new Z),inlineSuggest:ye(new G),suggestFontSize:ye(new w(106,"suggestFontSize",0,0,1e3,{markdownDescription:g.localize(243,null)})),suggestLineHeight:ye(new w(107,"suggestLineHeight",0,0,1e3,{markdownDescription:g.localize(244,null)})),suggestOnTriggerCharacters:ye(new p(108,"suggestOnTriggerCharacters",!0,{description:g.localize(245,null)})),suggestSelection:ye(new o(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[g.localize(246,null),g.localize(247,null),g.localize(248,null)],description:g.localize(249,null)})),tabCompletion:ye(new o(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[g.localize(250,null),g.localize(251,null),g.localize(252,null)],description:g.localize(253,null)})),tabIndex:ye(new w(111,"tabIndex",0,-1,1073741824)),unusualLineTerminators:ye(new o(112,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[g.localize(254,null),g.localize(255,null),g.localize(256,null)],description:g.localize(257,null)})),useShadowDOM:ye(new p(113,"useShadowDOM",!0)),useTabStops:ye(new p(114,"useTabStops",!0,{description:g.localize(258,null)})),wordSeparators:ye(new P(115,"wordSeparators",D.USUAL_WORD_SEPARATORS,{description:g.localize(259,null)})),wordWrap:ye(new o(116,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[g.localize(260,null),g.localize(261,null),g.localize(262,null),g.localize(263,null)],description:g.localize(264,null)})),wordWrapBreakAfterCharacters:ye(new P(117,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ye(new P(118,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ye(new w(119,"wordWrapColumn",80,1,1073741824,{markdownDescription:g.localize(265,null)})),wordWrapOverride1:ye(new o(120,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ye(new o(121,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ye(new s(122,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],je,{enumDescriptions:[g.localize(266,null),g.localize(267,null),g.localize(268,null),g.localize(269,null)],description:g.localize(270,null)})),wrappingStrategy:ye(new o(123,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[g.localize(271,null),g.localize(272,null)],description:g.localize(273,null)})),editorClassName:ye(new m),pixelRatio:ye(new Q),tabFocusMode:ye(new pe),layoutInfo:ye(new z),wrappingInfo:ye(new Ke)}}),define(fe[156],me([19,20]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(fe[157],me([19,20]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(fe[158],me([19,20]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(fe[159],me([19,20]),function(Y,e){return Y.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(fe[160],me([19,20]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(fe[161],me([19,20]),function(Y,e){return Y.create("vs/platform/markers/common/markers",e)}),define(fe[162],me([19,20]),function(Y,e){return Y.create("vs/platform/theme/common/iconRegistry",e)}),define(fe[163],me([19,20]),function(Y,e){return Y.create("vs/platform/workspaces/common/workspaces",e)}),define(fe[164],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(fe[165],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostExtensionService",e)}),define(fe[166],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostProgress",e)}),define(fe[167],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostStatusBar",e)}),define(fe[168],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTerminalService",e)}),define(fe[169],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTreeViews",e)}),define(fe[170],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostWorkspace",e)}),define(fe[171],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/node/extHostDebugService",e)}),define(fe[172],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/node/extHostTunnelService",e)}),define(fe[173],me([19,20]),function(Y,e){return Y.create("vs/workbench/common/editor",e)}),define(fe[174],me([19,20]),function(Y,e){return Y.create("vs/workbench/common/views",e)}),define(fe[175],me([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(fe[176],me([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(fe[177],me([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(fe[178],me([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(fe[179],me([19,20]),function(Y,e){return Y.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(fe[180],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var g;(function(T){T[T.ACTIVATE=1]="ACTIVATE",T[T.RESTORE=2]="RESTORE",T[T.PRESERVE=3]="PRESERVE"})(g=e.EditorActivation||(e.EditorActivation={}));var L;(function(T){T[T.PICK=0]="PICK",T[T.DISABLED=1]="DISABLED",T[T.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(L=e.EditorResolution||(e.EditorResolution={}));var D;(function(T){T[T.API=0]="API",T[T.USER=1]="USER"})(D=e.EditorOpenContext||(e.EditorOpenContext={}));var S;(function(T){T[T.Center=0]="Center",T[T.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",T[T.NearTop=2]="NearTop",T[T.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(S=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(fe[181],me([0,1,158]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function S(a){return a=a.trim(),a==="*"||L.test(a)}e.isValidVersionStr=S;function T(a){if(!S(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=a.match(L);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=T;function C(a){if(!a)return null;let p=a.majorBase,h=a.majorMustEqual,w=a.minorBase,y=a.minorMustEqual,P=a.patchBase,b=a.patchMustEqual;a.hasCaret&&(p===0||(y=!1),b=!1);let o=0;if(a.preRelease){const s=D.exec(a.preRelease);if(s){const[,v,n,f]=s;o=Date.UTC(Number(v),Number(n)-1,Number(f))}}return{majorBase:p,majorMustEqual:h,minorBase:w,minorMustEqual:y,patchBase:P,patchMustEqual:b,isMinimum:a.hasGreaterEquals,notBefore:o}}e.normalizeVersion=C;function E(a,p,h){let w;typeof a=="string"?w=C(T(a)):w=a;let y;p instanceof Date?y=p.getTime():typeof p=="string"&&(y=new Date(p).getTime());let P;if(typeof h=="string"?P=C(T(h)):P=h,!w||!P)return!1;let b=w.majorBase,o=w.minorBase,s=w.patchBase,v=P.majorBase,n=P.minorBase,f=P.patchBase,r=P.notBefore,t=P.majorMustEqual,u=P.minorMustEqual,l=P.patchMustEqual;return P.isMinimum?b>v?!0:b<v?!1:o>n?!0:o<n||y&&y<r?!1:s>=f:(b===1&&v===0&&(!t||!u||!l)&&(v=1,n=0,f=0,t=!0,u=!1,l=!1),b<v?!1:b>v?!t:o<n?!1:o>n?!u:s<f?!1:s>f?!l:!(y&&y<r))}e.isValidVersion=E;function k(a,p,h,w){return h.isBuiltin||typeof h.main=="undefined"?!0:I(a,p,h.engines.vscode,w)}e.isValidExtensionVersion=k;function i(a,p,h){return a==="*"||I(p,h,a)}e.isEngineValid=i;function I(a,p,h,w=[]){let y=C(T(h));if(!y)return w.push(g.localize(0,null,h)),!1;if(y.majorBase===0){if(!y.majorMustEqual||!y.minorMustEqual)return w.push(g.localize(1,null,h)),!1}else if(!y.majorMustEqual)return w.push(g.localize(2,null,h)),!1;return E(a,p,y)?!0:(w.push(g.localize(3,null,a,h)),!1)}}),define(fe[115],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class g{constructor(D,S=[],T=!1){this.ctor=D,this.staticArguments=S,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=g}),define(fe[84],me([0,1,115]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function D(T,C,E){C instanceof g.SyncDescriptor||(C=new g.SyncDescriptor(C,[],E)),L.push([T,C])}e.registerSingleton=D;function S(){return L}e.getSingletonServiceDescriptors=S}),define(fe[182],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class g{constructor(S){this.incoming=new Map,this.outgoing=new Map,this.data=S}}e.Node=g;class L{constructor(S){this._hashFn=S,this._nodes=new Map}roots(){const S=[];for(let T of this._nodes.values())T.outgoing.size===0&&S.push(T);return S}insertEdge(S,T){const C=this.lookupOrInsertNode(S),E=this.lookupOrInsertNode(T);C.outgoing.set(this._hashFn(T),E),E.incoming.set(this._hashFn(S),C)}removeNode(S){const T=this._hashFn(S);this._nodes.delete(T);for(let C of this._nodes.values())C.outgoing.delete(T),C.incoming.delete(T)}lookupOrInsertNode(S){const T=this._hashFn(S);let C=this._nodes.get(T);return C||(C=new g(S),this._nodes.set(T,C)),C}lookup(S){return this._nodes.get(this._hashFn(S))}isEmpty(){return this._nodes.size===0}toString(){let S=[];for(let[T,C]of this._nodes)S.push(`${T}, (incoming)[${[...C.incoming.keys()].join(", ")}], (outgoing)[${[...C.outgoing.keys()].join(",")}]`);return S.join(`
`)}findCycleSlow(){for(let[S,T]of this._nodes){const C=new Set([S]),E=this._findCycle(T,C);if(E)return E}}_findCycle(S,T){for(let[C,E]of S.outgoing){if(T.has(C))return[...T,C].join(" -> ");T.add(C);const k=this._findCycle(E,T);if(k)return k;T.delete(C)}}}e.Graph=L}),define(fe[4],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var g;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function C(E){return E[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=C})(g=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function L(T,C,E,k){C[g.DI_TARGET]===C?C[g.DI_DEPENDENCIES].push({id:T,index:E,optional:k}):(C[g.DI_DEPENDENCIES]=[{id:T,index:E,optional:k}],C[g.DI_TARGET]=C)}function D(T){if(g.serviceIds.has(T))return g.serviceIds.get(T);const C=function(E,k,i){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(C,E,i,!1)};return C.toString=()=>T,g.serviceIds.set(T,C),C}e.createDecorator=D;function S(T){return T}e.refineServiceDecorator=S}),define(fe[183],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,g.createDecorator)("modelService");function L(D){return!D.isTooLargeForSyncing()&&!D.isForSimpleWidget}e.shouldSynchronizeModel=L}),define(fe[184],me([0,1,3,49,6,24,79,83,183]),function(Y,e,g,L,D,S,T,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function k(w){return typeof w=="string"?!1:Array.isArray(w)?w.every(k):!!w.exclusive}class i{constructor(){this._clock=0,this._entries=[],this._onDidChange=new g.Emitter}get onDidChange(){return this._onDidChange.event}register(y,P){let b={selector:y,provider:P,_score:-1,_time:this._clock++};return this._entries.push(b),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,D.toDisposable)(()=>{if(b){let o=this._entries.indexOf(b);o>=0&&(this._entries.splice(o,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),b=void 0)}})}has(y){return this.all(y).length>0}all(y){if(!y)return[];this._updateScores(y);const P=[];for(let b of this._entries)b._score>0&&P.push(b.provider);return P}ordered(y){const P=[];return this._orderedForEach(y,b=>P.push(b.provider)),P}orderedGroups(y){const P=[];let b,o;return this._orderedForEach(y,s=>{b&&o===s._score?b.push(s.provider):(o=s._score,b=[s.provider],P.push(b))}),P}_orderedForEach(y,P){if(!!y){this._updateScores(y);for(const b of this._entries)b._score>0&&P(b)}}_updateScores(y){let P={uri:y.uri.toString(),language:y.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===P.language&&this._lastCandidate.uri===P.uri)){this._lastCandidate=P;for(let b of this._entries)if(b._score=(0,C.score)(b.selector,y.uri,y.getLanguageId(),(0,E.shouldSynchronizeModel)(y)),k(b.selector)&&b._score>0){for(let o of this._entries)o._score=0;b._score=1e3;break}this._entries.sort(i._compareByScoreAndTime)}}static _compareByScoreAndTime(y,P){return y._score<P._score?1:y._score>P._score?-1:y._time<P._time?1:y._time>P._time?-1:0}}e.LanguageFeatureRegistry=i;const I=new WeakMap;let a=0;function p(w){let y=I.get(w);return y===void 0&&(y=++a,I.set(w,y)),y}class h{constructor(y,P,b=Number.MAX_SAFE_INTEGER){this._registry=y,this.min=P,this.max=b,this._cache=new S.LRUCache(50,.7)}_key(y){return y.id+this._registry.all(y).reduce((P,b)=>(0,L.doHash)(p(b),P),0)}_clamp(y){return y===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(y*1.3)))}get(y){const P=this._key(y),b=this._cache.get(P);return this._clamp(b?.value)}update(y,P){const b=this._key(y);let o=this._cache.get(b);return o||(o=new T.MovingAverage,this._cache.set(b,o)),o.update(P),this.get(y)}}e.LanguageFeatureRequestDelays=h}),define(fe[85],me([0,1,2,42,184,149,48]),function(Y,e,g,L,D,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var C;(function(d){d[d.Null=0]="Null",d[d.PlainText=1]="PlainText"})(C=e.LanguageId||(e.LanguageId={}));var E;(function(d){d[d.NotSet=-1]="NotSet",d[d.None=0]="None",d[d.Italic=1]="Italic",d[d.Bold=2]="Bold",d[d.Underline=4]="Underline"})(E=e.FontStyle||(e.FontStyle={}));var k;(function(d){d[d.None=0]="None",d[d.DefaultForeground=1]="DefaultForeground",d[d.DefaultBackground=2]="DefaultBackground"})(k=e.ColorId||(e.ColorId={}));var i;(function(d){d[d.Other=0]="Other",d[d.Comment=1]="Comment",d[d.String=2]="String",d[d.RegEx=4]="RegEx"})(i=e.StandardTokenType||(e.StandardTokenType={}));var I;(function(d){d[d.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",d[d.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",d[d.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",d[d.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",d[d.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",d[d.ITALIC_MASK=2048]="ITALIC_MASK",d[d.BOLD_MASK=4096]="BOLD_MASK",d[d.UNDERLINE_MASK=8192]="UNDERLINE_MASK",d[d.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",d[d.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",d[d.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",d[d.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",d[d.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",d[d.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",d[d.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",d[d.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",d[d.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",d[d.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(I=e.MetadataConsts||(e.MetadataConsts={}));class a{static getLanguageId(_){return(_&255)>>>0}static getTokenType(_){return(_&1792)>>>8}static getFontStyle(_){return(_&14336)>>>11}static getForeground(_){return(_&8372224)>>>14}static getBackground(_){return(_&4286578688)>>>23}static getClassNameFromMetadata(_){let A=this.getForeground(_),R="mtk"+A,B=this.getFontStyle(_);return B&1&&(R+=" mtki"),B&2&&(R+=" mtkb"),B&4&&(R+=" mtku"),R}static getInlineStyleFromMetadata(_,A){const R=this.getForeground(_),B=this.getFontStyle(_);let U=`color: ${A[R]};`;return B&1&&(U+="font-style: italic;"),B&2&&(U+="font-weight: bold;"),B&4&&(U+="text-decoration: underline;"),U}}e.TokenMetadata=a;var p;(function(d){d[d.Method=0]="Method",d[d.Function=1]="Function",d[d.Constructor=2]="Constructor",d[d.Field=3]="Field",d[d.Variable=4]="Variable",d[d.Class=5]="Class",d[d.Struct=6]="Struct",d[d.Interface=7]="Interface",d[d.Module=8]="Module",d[d.Property=9]="Property",d[d.Event=10]="Event",d[d.Operator=11]="Operator",d[d.Unit=12]="Unit",d[d.Value=13]="Value",d[d.Constant=14]="Constant",d[d.Enum=15]="Enum",d[d.EnumMember=16]="EnumMember",d[d.Keyword=17]="Keyword",d[d.Text=18]="Text",d[d.Color=19]="Color",d[d.File=20]="File",d[d.Reference=21]="Reference",d[d.Customcolor=22]="Customcolor",d[d.Folder=23]="Folder",d[d.TypeParameter=24]="TypeParameter",d[d.User=25]="User",d[d.Issue=26]="Issue",d[d.Snippet=27]="Snippet"})(p=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let d=Object.create(null);return d[0]="symbol-method",d[1]="symbol-function",d[2]="symbol-constructor",d[3]="symbol-field",d[4]="symbol-variable",d[5]="symbol-class",d[6]="symbol-struct",d[7]="symbol-interface",d[8]="symbol-module",d[9]="symbol-property",d[10]="symbol-event",d[11]="symbol-operator",d[12]="symbol-unit",d[13]="symbol-value",d[14]="symbol-constant",d[15]="symbol-enum",d[16]="symbol-enum-member",d[17]="symbol-keyword",d[27]="symbol-snippet",d[18]="symbol-text",d[19]="symbol-color",d[20]="symbol-file",d[21]="symbol-reference",d[22]="symbol-customcolor",d[23]="symbol-folder",d[24]="symbol-type-parameter",d[25]="account",d[26]="issues",function(_){const A=d[_];let R=A&&T.iconRegistry.get(A);return R||(console.info("No codicon found for CompletionItemKind "+_),R=T.Codicon.symbolProperty),R.classNames}}(),e.completionKindFromString=function(){let d=Object.create(null);return d.method=0,d.function=1,d.constructor=2,d.field=3,d.variable=4,d.class=5,d.struct=6,d.interface=7,d.module=8,d.property=9,d.event=10,d.operator=11,d.unit=12,d.value=13,d.constant=14,d.enum=15,d["enum-member"]=16,d.enumMember=16,d.keyword=17,d.snippet=27,d.text=18,d.color=19,d.file=20,d.reference=21,d.customcolor=22,d.folder=23,d["type-parameter"]=24,d.typeParameter=24,d.account=25,d.issue=26,function(_,A){let R=d[_];return typeof R=="undefined"&&!A&&(R=9),R}}();var h;(function(d){d[d.Deprecated=1]="Deprecated"})(h=e.CompletionItemTag||(e.CompletionItemTag={}));var w;(function(d){d[d.KeepWhitespace=1]="KeepWhitespace",d[d.InsertAsSnippet=4]="InsertAsSnippet"})(w=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var y;(function(d){d[d.Invoke=0]="Invoke",d[d.TriggerCharacter=1]="TriggerCharacter",d[d.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(y=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var P;(function(d){d[d.Automatic=0]="Automatic",d[d.Explicit=1]="Explicit"})(P=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var b;(function(d){d[d.Invoke=1]="Invoke",d[d.Auto=2]="Auto"})(b=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var o;(function(d){d[d.Invoke=1]="Invoke",d[d.TriggerCharacter=2]="TriggerCharacter",d[d.ContentChange=3]="ContentChange"})(o=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var s;(function(d){d[d.Text=0]="Text",d[d.Read=1]="Read",d[d.Write=2]="Write"})(s=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function v(d){return d&&g.URI.isUri(d.uri)&&L.Range.isIRange(d.range)&&(L.Range.isIRange(d.originSelectionRange)||L.Range.isIRange(d.targetSelectionRange))}e.isLocationLink=v;var n;(function(d){d[d.File=0]="File",d[d.Module=1]="Module",d[d.Namespace=2]="Namespace",d[d.Package=3]="Package",d[d.Class=4]="Class",d[d.Method=5]="Method",d[d.Property=6]="Property",d[d.Field=7]="Field",d[d.Constructor=8]="Constructor",d[d.Enum=9]="Enum",d[d.Interface=10]="Interface",d[d.Function=11]="Function",d[d.Variable=12]="Variable",d[d.Constant=13]="Constant",d[d.String=14]="String",d[d.Number=15]="Number",d[d.Boolean=16]="Boolean",d[d.Array=17]="Array",d[d.Object=18]="Object",d[d.Key=19]="Key",d[d.Null=20]="Null",d[d.EnumMember=21]="EnumMember",d[d.Struct=22]="Struct",d[d.Event=23]="Event",d[d.Operator=24]="Operator",d[d.TypeParameter=25]="TypeParameter"})(n=e.SymbolKind||(e.SymbolKind={}));var f;(function(d){d[d.Deprecated=1]="Deprecated"})(f=e.SymbolTag||(e.SymbolTag={}));var r;(function(d){const _=new Map;_.set("file",0),_.set("module",1),_.set("namespace",2),_.set("package",3),_.set("class",4),_.set("method",5),_.set("property",6),_.set("field",7),_.set("constructor",8),_.set("enum",9),_.set("interface",10),_.set("function",11),_.set("variable",12),_.set("constant",13),_.set("string",14),_.set("number",15),_.set("boolean",16),_.set("array",17),_.set("object",18),_.set("key",19),_.set("null",20),_.set("enum-member",21),_.set("struct",22),_.set("event",23),_.set("operator",24),_.set("type-parameter",25);const A=new Map;A.set(0,"file"),A.set(1,"module"),A.set(2,"namespace"),A.set(3,"package"),A.set(4,"class"),A.set(5,"method"),A.set(6,"property"),A.set(7,"field"),A.set(8,"constructor"),A.set(9,"enum"),A.set(10,"interface"),A.set(11,"function"),A.set(12,"variable"),A.set(13,"constant"),A.set(14,"string"),A.set(15,"number"),A.set(16,"boolean"),A.set(17,"array"),A.set(18,"object"),A.set(19,"key"),A.set(20,"null"),A.set(21,"enum-member"),A.set(22,"struct"),A.set(23,"event"),A.set(24,"operator"),A.set(25,"type-parameter");function R(F){return _.get(F)}d.fromString=R;function B(F){return A.get(F)}d.toString=B;function U(F,$){const M=A.get(F);let z=M&&T.iconRegistry.get("symbol-"+M);return z||(console.info("No codicon found for SymbolKind "+F),z=T.Codicon.symbolProperty),`${$?"inline":"block"} ${z.classNames}`}d.toCssClassName=U})(r=e.SymbolKinds||(e.SymbolKinds={}));class t{constructor(_){this.value=_}}e.FoldingRangeKind=t,t.Comment=new t("comment"),t.Imports=new t("imports"),t.Region=new t("region");var u;(function(d){d[d.Collapsed=0]="Collapsed",d[d.Expanded=1]="Expanded"})(u=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var l;(function(d){d[d.Editing=0]="Editing",d[d.Preview=1]="Preview"})(l=e.CommentMode||(e.CommentMode={}));var c;(function(d){d[d.Other=0]="Other",d[d.Type=1]="Type",d[d.Parameter=2]="Parameter"})(c=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new D.LanguageFeatureRegistry,e.RenameProviderRegistry=new D.LanguageFeatureRegistry,e.CompletionProviderRegistry=new D.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new D.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new D.LanguageFeatureRegistry,e.HoverProviderRegistry=new D.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new D.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new D.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new D.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new D.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new D.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new D.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new D.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new D.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new D.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.LinkProviderRegistry=new D.LanguageFeatureRegistry,e.ColorProviderRegistry=new D.LanguageFeatureRegistry,e.SelectionRangeRegistry=new D.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new D.LanguageFeatureRegistry,e.TokenizationRegistry=new S.TokenizationRegistryImpl;var m;(function(d){d[d.None=0]="None",d[d.Option=1]="Option",d[d.Default=2]="Default",d[d.Preferred=3]="Preferred"})(m=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(fe[53],me([0,1,12,8,4]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let S=g.userAgent||"";const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",g.isMacintosh),T.set("isLinux",g.isLinux),T.set("isWindows",g.isWindows),T.set("isWeb",g.isWeb),T.set("isMacNative",g.isMacintosh&&!g.isWeb),T.set("isEdge",S.indexOf("Edg/")>=0),T.set("isFirefox",S.indexOf("Firefox")>=0),T.set("isChrome",S.indexOf("Chrome")>=0),T.set("isSafari",S.indexOf("Safari")>=0);const C=Object.prototype.hasOwnProperty;var E;(function(U){U[U.False=0]="False",U[U.True=1]="True",U[U.Defined=2]="Defined",U[U.Not=3]="Not",U[U.Equals=4]="Equals",U[U.NotEquals=5]="NotEquals",U[U.And=6]="And",U[U.Regex=7]="Regex",U[U.NotRegex=8]="NotRegex",U[U.Or=9]="Or",U[U.In=10]="In",U[U.NotIn=11]="NotIn",U[U.Greater=12]="Greater",U[U.GreaterEquals=13]="GreaterEquals",U[U.Smaller=14]="Smaller",U[U.SmallerEquals=15]="SmallerEquals"})(E=e.ContextKeyExprType||(e.ContextKeyExprType={}));class k{static false(){return a.INSTANCE}static true(){return p.INSTANCE}static has(F){return h.create(F)}static equals(F,$){return w.create(F,$)}static notEquals(F,$){return b.create(F,$)}static regex(F,$){return t.create(F,$)}static in(F,$){return y.create(F,$)}static not(F){return o.create(F)}static and(...F){return c.create(F,null)}static or(...F){return m.create(F,null,!0)}static greater(F,$){return v.create(F,$)}static greaterEquals(F,$){return n.create(F,$)}static smaller(F,$){return f.create(F,$)}static smallerEquals(F,$){return r.create(F,$)}static deserialize(F,$=!1){if(!!F)return this._deserializeOrExpression(F,$)}static _deserializeOrExpression(F,$){let M=F.split("||");return m.create(M.map(z=>this._deserializeAndExpression(z,$)),null,!0)}static _deserializeAndExpression(F,$){let M=F.split("&&");return c.create(M.map(z=>this._deserializeOne(z,$)),null)}static _deserializeOne(F,$){if(F=F.trim(),F.indexOf("!=")>=0){let M=F.split("!=");return b.create(M[0].trim(),this._deserializeValue(M[1],$))}if(F.indexOf("==")>=0){let M=F.split("==");return w.create(M[0].trim(),this._deserializeValue(M[1],$))}if(F.indexOf("=~")>=0){let M=F.split("=~");return t.create(M[0].trim(),this._deserializeRegexValue(M[1],$))}if(F.indexOf(" in ")>=0){let M=F.split(" in ");return y.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(F)){const M=F.split(">=");return n.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(F)){const M=F.split(">");return v.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(F)){const M=F.split("<=");return r.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(F)){const M=F.split("<");return f.create(M[0].trim(),M[1].trim())}return/^\!\s*/.test(F)?o.create(F.substr(1).trim()):h.create(F)}static _deserializeValue(F,$){if(F=F.trim(),F==="true")return!0;if(F==="false")return!1;let M=/^'([^']*)'$/.exec(F);return M?M[1].trim():F}static _deserializeRegexValue(F,$){if((0,L.isFalsyOrWhitespace)(F)){if($)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let M=F.indexOf("/"),z=F.lastIndexOf("/");if(M===z||M<0){if($)throw new Error(`bad regexp-value '${F}', missing /-enclosure`);return console.warn(`bad regexp-value '${F}', missing /-enclosure`),null}let N=F.slice(M+1,z),x=F[z+1]==="i"?"i":"";try{return new RegExp(N,x)}catch(j){if($)throw new Error(`bad regexp-value '${F}', parse error: ${j}`);return console.warn(`bad regexp-value '${F}', parse error: ${j}`),null}}}e.ContextKeyExpr=k;function i(U,F){const $=U?U.substituteConstants():void 0,M=F?F.substituteConstants():void 0;return!$&&!M?!0:!$||!M?!1:$.equals(M)}e.expressionsAreEqualWithConstantSubstitution=i;function I(U,F){return U.cmp(F)}class a{constructor(){this.type=0}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return p.INSTANCE}}e.ContextKeyFalseExpr=a,a.INSTANCE=new a;class p{constructor(){this.type=1}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return a.INSTANCE}}e.ContextKeyTrueExpr=p,p.INSTANCE=new p;class h{constructor(F,$){this.key=F,this.negated=$,this.type=2}static create(F,$=null){const M=T.get(F);return typeof M=="boolean"?M?p.INSTANCE:a.INSTANCE:new h(F,$)}cmp(F){return F.type!==this.type?this.type-F.type:_(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=T.get(this.key);return typeof F=="boolean"?F?p.INSTANCE:a.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.negated||(this.negated=o.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=h;class w{constructor(F,$,M){this.key=F,this.value=$,this.negated=M,this.type=4}static create(F,$,M=null){if(typeof $=="boolean")return $?h.create(F,M):o.create(F,M);const z=T.get(F);return typeof z=="boolean"?$===(z?"true":"false")?p.INSTANCE:a.INSTANCE:new w(F,$,M)}cmp(F){return F.type!==this.type?this.type-F.type:A(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=T.get(this.key);if(typeof F=="boolean"){const $=F?"true":"false";return this.value===$?p.INSTANCE:a.INSTANCE}return this}evaluate(F){return F.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(F){return F.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=w;class y{constructor(F,$){this.key=F,this.valueKey=$,this.type=10,this.negated=null}static create(F,$){return new y(F,$)}cmp(F){return F.type!==this.type?this.type-F.type:A(this.key,this.valueKey,F.key,F.valueKey)}equals(F){return F.type===this.type?this.key===F.key&&this.valueKey===F.valueKey:!1}substituteConstants(){return this}evaluate(F){const $=F.getValue(this.valueKey),M=F.getValue(this.key);return Array.isArray($)?$.indexOf(M)>=0:typeof M=="string"&&typeof $=="object"&&$!==null?C.call($,M):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(F){return F.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=P.create(this)),this.negated}}e.ContextKeyInExpr=y;class P{constructor(F){this._actual=F,this.type=11}static create(F){return new P(F)}cmp(F){return F.type!==this.type?this.type-F.type:this._actual.cmp(F._actual)}equals(F){return F.type===this.type?this._actual.equals(F._actual):!1}substituteConstants(){return this}evaluate(F){return!this._actual.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(F){return new P(this._actual.map(F))}negate(){return this._actual}}e.ContextKeyNotInExpr=P;class b{constructor(F,$,M){this.key=F,this.value=$,this.negated=M,this.type=5}static create(F,$,M=null){if(typeof $=="boolean")return $?o.create(F,M):h.create(F,M);const z=T.get(F);return typeof z=="boolean"?$===(z?"true":"false")?a.INSTANCE:p.INSTANCE:new b(F,$,M)}cmp(F){return F.type!==this.type?this.type-F.type:A(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=T.get(this.key);if(typeof F=="boolean"){const $=F?"true":"false";return this.value===$?a.INSTANCE:p.INSTANCE}return this}evaluate(F){return F.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(F){return F.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=b;class o{constructor(F,$){this.key=F,this.negated=$,this.type=3}static create(F,$=null){const M=T.get(F);return typeof M=="boolean"?M?a.INSTANCE:p.INSTANCE:new o(F,$)}cmp(F){return F.type!==this.type?this.type-F.type:_(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=T.get(this.key);return typeof F=="boolean"?F?a.INSTANCE:p.INSTANCE:this}evaluate(F){return!F.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(F){return F.mapNot(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=o;function s(U,F){if(typeof U=="string"){const $=parseFloat(U);isNaN($)||(U=$)}return typeof U=="string"||typeof U=="number"?F(U):a.INSTANCE}class v{constructor(F,$,M){this.key=F,this.value=$,this.negated=M,this.type=12}static create(F,$,M=null){return s($,z=>new v(F,z,M))}cmp(F){return F.type!==this.type?this.type-F.type:A(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=v;class n{constructor(F,$,M){this.key=F,this.value=$,this.negated=M,this.type=13}static create(F,$,M=null){return s($,z=>new n(F,z,M))}cmp(F){return F.type!==this.type?this.type-F.type:A(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=n;class f{constructor(F,$,M){this.key=F,this.value=$,this.negated=M,this.type=14}static create(F,$,M=null){return s($,z=>new f(F,z,M))}cmp(F){return F.type!==this.type?this.type-F.type:A(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=f;class r{constructor(F,$,M){this.key=F,this.value=$,this.negated=M,this.type=15}static create(F,$,M=null){return s($,z=>new r(F,z,M))}cmp(F){return F.type!==this.type?this.type-F.type:A(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=v.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=r;class t{constructor(F,$){this.key=F,this.regexp=$,this.type=7,this.negated=null}static create(F,$){return new t(F,$)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.key<F.key)return-1;if(this.key>F.key)return 1;const $=this.regexp?this.regexp.source:"",M=F.regexp?F.regexp.source:"";return $<M?-1:$>M?1:0}equals(F){if(F.type===this.type){const $=this.regexp?this.regexp.source:"",M=F.regexp?F.regexp.source:"";return this.key===F.key&&$===M}return!1}substituteConstants(){return this}evaluate(F){let $=F.getValue(this.key);return this.regexp?this.regexp.test($):!1}serialize(){const F=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${F}`}keys(){return[this.key]}map(F){return F.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=u.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class u{constructor(F){this._actual=F,this.type=8}static create(F){return new u(F)}cmp(F){return F.type!==this.type?this.type-F.type:this._actual.cmp(F._actual)}equals(F){return F.type===this.type?this._actual.equals(F._actual):!1}substituteConstants(){return this}evaluate(F){return!this._actual.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(F){return new u(this._actual.map(F))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=u;function l(U){let F=null;for(let $=0,M=U.length;$<M;$++){const z=U[$].substituteConstants();if(U[$]!==z&&F===null){F=[];for(let N=0;N<$;N++)F[N]=U[N]}F!==null&&(F[$]=z)}return F===null?U:F}class c{constructor(F,$){this.expr=F,this.negated=$,this.type=6}static create(F,$){return c._normalizeArr(F,$)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let $=0,M=this.expr.length;$<M;$++){const z=I(this.expr[$],F.expr[$]);if(z!==0)return z}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let $=0,M=this.expr.length;$<M;$++)if(!this.expr[$].equals(F.expr[$]))return!1;return!0}return!1}substituteConstants(){const F=l(this.expr);return F===this.expr?this:c.create(F,this.negated)}evaluate(F){for(let $=0,M=this.expr.length;$<M;$++)if(!this.expr[$].evaluate(F))return!1;return!0}static _normalizeArr(F,$){const M=[];let z=!1;for(const N of F)if(!!N){if(N.type===1){z=!0;continue}if(N.type===0)return a.INSTANCE;if(N.type===6){M.push(...N.expr);continue}M.push(N)}if(M.length===0&&z)return p.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(I);for(let N=1;N<M.length;N++)M[N-1].equals(M[N])&&(M.splice(N,1),N--);if(M.length===1)return M[0];for(;M.length>1;){const N=M[M.length-1];if(N.type!==9)break;M.pop();const x=M.pop(),j=M.length===0,O=m.create(N.expr.map(H=>c.create([H,x],null)),null,j);O&&(M.push(O),M.sort(I))}return M.length===1?M[0]:new c(M,$)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(let $ of this.expr)F.push(...$.keys());return F}map(F){return new c(this.expr.map($=>$.map(F)),null)}negate(){if(!this.negated){const F=[];for(let $ of this.expr)F.push($.negate());this.negated=m.create(F,this,!0)}return this.negated}}class m{constructor(F,$){this.expr=F,this.negated=$,this.type=9}static create(F,$,M){return m._normalizeArr(F,$,M)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let $=0,M=this.expr.length;$<M;$++){const z=I(this.expr[$],F.expr[$]);if(z!==0)return z}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let $=0,M=this.expr.length;$<M;$++)if(!this.expr[$].equals(F.expr[$]))return!1;return!0}return!1}substituteConstants(){const F=l(this.expr);return F===this.expr?this:m.create(F,this.negated,!1)}evaluate(F){for(let $=0,M=this.expr.length;$<M;$++)if(this.expr[$].evaluate(F))return!0;return!1}static _normalizeArr(F,$,M){let z=[],N=!1;if(F){for(let x=0,j=F.length;x<j;x++){const O=F[x];if(!!O){if(O.type===0){N=!0;continue}if(O.type===1)return p.INSTANCE;if(O.type===9){z=z.concat(O.expr);continue}z.push(O)}}if(z.length===0&&N)return a.INSTANCE;z.sort(I)}if(z.length!==0){if(z.length===1)return z[0];for(let x=1;x<z.length;x++)z[x-1].equals(z[x])&&(z.splice(x,1),x--);if(z.length===1)return z[0];if(M){for(let x=0;x<z.length;x++)for(let j=x+1;j<z.length;j++)R(z[x],z[j])&&(z.splice(j,1),j--);if(z.length===1)return z[0]}return new m(z,$)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(let $ of this.expr)F.push(...$.keys());return F}map(F){return new m(this.expr.map($=>$.map(F)),null)}negate(){if(!this.negated){let F=[];for(let $ of this.expr)F.push($.negate());for(;F.length>1;){const $=F.shift(),M=F.shift(),z=[];for(const x of B($))for(const j of B(M))z.push(c.create([x,j],null));const N=F.length===0;F.unshift(m.create(z,null,N))}this.negated=F[0]}return this.negated}}class d extends h{constructor(F,$,M){super(F,null);this._defaultValue=$,typeof M=="object"?d._info.push({...M,key:F}):M!==!0&&d._info.push({key:F,description:M,type:$!=null?typeof $:void 0})}static all(){return d._info.values()}bindTo(F){return F.createKey(this.key,this._defaultValue)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return w.create(this.key,F)}notEqualsTo(F){return b.create(this.key,F)}}e.RawContextKey=d,d._info=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function _(U,F){return U<F?-1:U>F?1:0}function A(U,F,$,M){return U<$?-1:U>$?1:F<M?-1:F>M?1:0}function R(U,F){if(F.type===6&&U.type!==9&&U.type!==6){for(const z of F.expr)if(U.equals(z))return!0}const $=U.negate(),M=B($).concat(B(F));M.sort(I);for(let z=0;z<M.length;z++){const x=M[z].negate();for(let j=z+1;j<M.length;j++){const O=M[j];if(x.equals(O))return!0}}return!1}e.implies=R;function B(U){return U.type===9?U.expr:[U]}}),define(fe[185],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,g.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,g.refineServiceDecorator)(e.IEnvironmentService)}),define(fe[186],me([0,1,10,157,4]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var S;(function(o){o.WIN32_X64="win32-x64",o.WIN32_IA32="win32-ia32",o.WIN32_ARM64="win32-arm64",o.LINUX_X64="linux-x64",o.LINUX_ARM64="linux-arm64",o.LINUX_ARMHF="linux-armhf",o.ALPINE_X64="alpine-x64",o.ALPINE_ARM64="alpine-arm64",o.DARWIN_X64="darwin-x64",o.DARWIN_ARM64="darwin-arm64",o.WEB="web",o.UNIVERSAL="universal",o.UNKNOWN="unknown",o.UNDEFINED="undefined"})(S=e.TargetPlatform||(e.TargetPlatform={}));function T(o){switch(o){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=T;function C(o){switch(o){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=C;function E(o,s){switch(o){case 3:return s==="x64"?"win32-x64":s==="ia32"?"win32-ia32":s==="arm64"?"win32-arm64":"unknown";case 2:return s==="x64"?"linux-x64":s==="arm64"?"linux-arm64":s==="arm"?"linux-armhf":"unknown";case"alpine":return s==="x64"?"alpine-x64":s==="arm64"?"alpine-arm64":"unknown";case 1:return s==="x64"?"darwin-x64":s==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=E;function k(o,s){return s==="web"&&!o.includes("web")}e.isNotWebExtensionInWebTargetPlatform=k;function i(o,s,v){return k(s,v)?!1:o==="undefined"||o==="universal"?!0:o==="unknown"?!1:o===v?!0:I(v).includes(o)}e.isTargetPlatformCompatible=i;function I(o){switch(o){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=I;function a(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}e.isIExtensionIdentifier=a;var p;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=10]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})(p=e.SortBy||(e.SortBy={}));var h;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var w;(function(o){o.Install="install",o.Uninstall="uninstall"})(w=e.StatisticType||(e.StatisticType={}));var y;(function(o){o[o.None=0]="None",o[o.Install=1]="Install",o[o.Update=2]="Update"})(y=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService");var P;(function(o){o.Unsupported="Unsupported",o.Malicious="Malicious",o.Incompatible="Incompatible",o.Invalid="Invalid",o.Download="Download",o.Extract="Extract",o.Delete="Delete",o.Rename="Rename",o.CorruptZip="CorruptZip",o.IncompleteZip="IncompleteZip",o.Internal="Internal"})(P=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class b extends Error{constructor(s,v){super(s);this.code=v,this.name=v}}e.ExtensionManagementError=b,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=g.FileAccess.asBrowserUri("./media/defaultIcon.png",Y).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,D.createDecorator)("IExtensionManagementCLIService")}),define(fe[187],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,g.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,g.createDecorator)("externalTerminal")}),define(fe[188],me([0,1,39,10,9,12,95,28,113,159,187]),function(Y,e,g,L,D,S,T,C,E,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=k.localize(0,null);class a{async getDefaultTerminalForPlatforms(){return{windows:p.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class p extends a{openTerminal(s,v){return this.spawnTerminal(g,s,E.getWindowsShell(),v)}spawnTerminal(s,v,n,f){const r=v.windowsExec||p.getDefaultTerminalWindows();f&&f[1]===":"&&(f=f[0].toUpperCase()+f.substr(1));const t=D.basename(r).toLowerCase();if(t==="cmder"||t==="cmder.exe")return s.spawn(r,f?[f]:void 0),Promise.resolve(void 0);const u=["/c","start","/wait"];return r.indexOf(" ")>=0&&u.push('""'),u.push(r),(t==="wt"||t==="wt.exe")&&u.push("-d ."),new Promise((l,c)=>{const m=y(process),d=s.spawn(n,u,{cwd:f,env:m});d.on("error",c),d.on("exit",()=>l())})}runInTerminal(s,v,n,f,r){const t="windowsExec"in r&&r.windowsExec?r.windowsExec:p.getDefaultTerminalWindows();return new Promise((u,l)=>{const c=`"${v} - ${I}"`,m=`""${n.join('" "')}" & pause"`,d=["/c","start",c,"/wait",t,"/c",m],_=Object.assign({},y(process),f);Object.keys(_).filter(B=>_[B]===null).forEach(B=>delete _[B]);const A={cwd:v,env:_,windowsVerbatimArguments:!0};g.spawn(p.CMD,d,A).on("error",B=>{l(P(B))}),u(void 0)})}static getDefaultTerminalWindows(){if(!p._DEFAULT_TERMINAL_WINDOWS){const s=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");p._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${s?"Sysnative":"System32"}\\cmd.exe`}return p._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=p,p.CMD="cmd.exe";class h extends a{openTerminal(s,v){return this.spawnTerminal(g,s,v)}runInTerminal(s,v,n,f,r){const t=r.osxExec||i.DEFAULT_TERMINAL_OSX;return new Promise((u,l)=>{if(t===i.DEFAULT_TERMINAL_OSX||t==="iTerm.app"){const c=t===i.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",d=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${c}.scpt`,Y).fsPath,"-t",s||I,"-w",v];for(let R of n)d.push("-a"),d.push(R);if(f){const R=Object.assign({},y(process),f);for(let B in R){const U=R[B];U===null?(d.push("-u"),d.push(B)):(d.push("-e"),d.push(`${B}=${U}`))}}let _="";const A=g.spawn(h.OSASCRIPT,d);A.on("error",R=>{l(P(R))}),A.stderr.on("data",R=>{_+=R.toString()}),A.on("exit",R=>{if(R===0)u(void 0);else if(_){const B=_.split(`
`,1);l(new Error(B[0]))}else l(new Error(k.localize(1,null,c,R)))})}else l(new Error(k.localize(2,null,t)))})}spawnTerminal(s,v,n){const f=v.osxExec||i.DEFAULT_TERMINAL_OSX;return new Promise((r,t)=>{const u=["-a",f];n&&u.push(n);const l=y(process),c=s.spawn("/usr/bin/open",u,{cwd:n,env:l});c.on("error",t),c.on("exit",()=>r())})}}e.MacExternalTerminalService=h,h.OSASCRIPT="/usr/bin/osascript";class w extends a{openTerminal(s,v){return this.spawnTerminal(g,s,v)}runInTerminal(s,v,n,f,r){const t=r.linuxExec?Promise.resolve(r.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((u,l)=>{let c=[];t.then(m=>{m.indexOf("gnome-terminal")>=0?c.push("-x"):c.push("-e"),c.push("bash"),c.push("-c");const d=`${b(n)}; echo; read -p "${w.WAIT_MESSAGE}" -n1;`;c.push(`''${d}''`);const _=Object.assign({},y(process),f);Object.keys(_).filter(U=>_[U]===null).forEach(U=>delete _[U]);const A={cwd:v,env:_};let R="";const B=g.spawn(m,c,A);B.on("error",U=>{l(P(U))}),B.stderr.on("data",U=>{R+=U.toString()}),B.on("exit",U=>{if(U===0)u(void 0);else if(R){const F=R.split(`
`,1);l(new Error(F[0]))}else l(new Error(k.localize(4,null,m,U)))})})})}static async getDefaultTerminalLinuxReady(){if(!w._DEFAULT_TERMINAL_LINUX_READY)if(!S.isLinux)w._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const s=await C.Promises.exists("/etc/debian_version");w._DEFAULT_TERMINAL_LINUX_READY=new Promise(v=>{s?v("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?v("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?v("konsole"):process.env.COLORTERM?v(process.env.COLORTERM):process.env.TERM?v(process.env.TERM):v("xterm")})}return w._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(s,v,n){const f=v.linuxExec?Promise.resolve(v.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((r,t)=>{f.then(u=>{const l=y(process),c=s.spawn(u,[],{cwd:n,env:l});c.on("error",t),c.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=w,w.WAIT_MESSAGE=k.localize(3,null);function y(o){const s={...o.env};return(0,T.sanitizeProcessEnvironment)(s),s}function P(o){return"errno"in o&&o.errno==="ENOENT"&&"path"in o&&typeof o.path=="string"?new Error(k.localize(5,null,o.path)):o}function b(o){let s="";for(let v of o)v.indexOf(" ")>=0?s+='"'+v+'"':s+=v,s+=" ";return s}}),define(fe[43],me([0,1,24,9,8,13,2,160,4]),function(Y,e,g,L,D,S,T,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,E.createDecorator)("fileService");function k(M){return M.create===!0}e.isFileOpenForWriteOptions=k;var i;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var I;(function(M){M[M.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var a;(function(M){M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock"})(a=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=p;function h(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=h;function w(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=w;function y(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=y;var P;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(P=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class b extends Error{constructor(z,N){super(z);this.code=N}}e.FileSystemProviderError=b;function o(M,z){const N=new b(M.toString(),z);return v(N,z),N}e.createFileSystemProviderError=o;function s(M){return M||o((0,C.localize)(0,null),P.Unknown)}e.ensureFileSystemProviderError=s;function v(M,z){return M.name=z?`${z} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=v;function n(M){if(!M)return P.Unknown;if(M instanceof b)return M.code;const z=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!z)return P.Unknown;switch(z[1]){case P.FileExists:return P.FileExists;case P.FileIsADirectory:return P.FileIsADirectory;case P.FileNotADirectory:return P.FileNotADirectory;case P.FileNotFound:return P.FileNotFound;case P.FileExceedsMemoryLimit:return P.FileExceedsMemoryLimit;case P.FileTooLarge:return P.FileTooLarge;case P.FileWriteLocked:return P.FileWriteLocked;case P.NoPermissions:return P.NoPermissions;case P.Unavailable:return P.Unavailable}return P.Unknown}e.toFileSystemProviderErrorCode=n;function f(M){if(M instanceof m)return M.fileOperationResult;switch(n(M)){case P.FileNotFound:return 1;case P.FileIsADirectory:return 0;case P.FileNotADirectory:return 10;case P.FileWriteLocked:return 5;case P.NoPermissions:return 6;case P.FileExists:return 4;case P.FileExceedsMemoryLimit:return 9;case P.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=f;var r;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class t{constructor(z,N,x){this.resource=z,this.operation=N,this.target=x}isOperation(z){return this.operation===z}}e.FileOperationEvent=t;var u;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class l{constructor(z,N){this.added=void 0,this.updated=void 0,this.deleted=void 0;const x=new Map;for(const j of z){const O=x.get(j.type);O?O.push([j.resource,j]):x.set(j.type,[[j.resource,j]])}for(const[j,O]of x)switch(j){case 1:this.added=g.TernarySearchTree.forUris(()=>N),this.added.fill(O);break;case 0:this.updated=g.TernarySearchTree.forUris(()=>N),this.updated.fill(O);break;case 2:this.deleted=g.TernarySearchTree.forUris(()=>N),this.deleted.fill(O);break}}contains(z,...N){return this.doContains(z,{includeChildren:!1},...N)}affects(z,...N){return this.doContains(z,{includeChildren:!0},...N)}doContains(z,N,...x){if(!z)return!1;const j=x.length>0;return!!((!j||x.includes(1))&&(this.added?.get(z)||N.includeChildren&&this.added?.findSuperstr(z))||(!j||x.includes(0))&&(this.updated?.get(z)||N.includeChildren&&this.updated?.findSuperstr(z))||(!j||x.includes(2))&&(this.deleted?.findSubstr(z)||N.includeChildren&&this.deleted?.findSuperstr(z)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=l;function c(M,z,N){return!M||!z||M===z||z.length>M.length?!1:(z.charAt(z.length-1)!==L.sep&&(z+=L.sep),N?(0,D.startsWithIgnoreCase)(M,z):M.indexOf(z)===0)}e.isParent=c;class m extends Error{constructor(z,N,x){super(z);this.fileOperationResult=N,this.options=x}}e.FileOperationError=m;class d extends m{constructor(z,N,x){super(z,2,x);this.stat=N}}e.NotModifiedSinceFileOperationError=d;var _;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(_=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var A;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(A=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function R(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=R;async function B(M,z){if(!z.hasProvider(T.URI.from({scheme:M.scheme})))return new Promise(N=>{const x=z.onDidChangeFileSystemProviderRegistrations(j=>{j.scheme===M.scheme&&j.added&&(x.dispose(),N())})})}e.whenProviderRegistered=B,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class U{static formatSize(z){return(0,S.isNumber)(z)||(z=0),z<U.KB?(0,C.localize)(1,null,z.toFixed(0)):z<U.MB?(0,C.localize)(2,null,(z/U.KB).toFixed(2)):z<U.GB?(0,C.localize)(3,null,(z/U.MB).toFixed(2)):z<U.TB?(0,C.localize)(4,null,(z/U.GB).toFixed(2)):(0,C.localize)(5,null,(z/U.TB).toFixed(2))}}e.ByteSize=U,U.KB=1024,U.MB=U.KB*U.KB,U.GB=U.MB*U.KB,U.TB=U.GB*U.KB;var F;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})(F=e.Arch||(e.Arch={}));function $(M){return{maxFileSize:M===0?300*U.MB:16*U.GB,maxHeapSize:M===0?700*U.MB:2*700*U.MB}}e.getPlatformLimits=$}),define(fe[86],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class g{constructor(...D){this._entries=new Map;for(let[S,T]of D)this.set(S,T)}set(D,S){const T=this._entries.get(D);return this._entries.set(D,S),T}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=g}),define(fe[189],me([0,1,16,18,115,182,4,86]),function(Y,e,g,L,D,S,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const E=!1;class k extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class i{constructor(h=new C.ServiceCollection,w=!1,y){this._activeInstantiations=new Set,this._services=h,this._strict=w,this._parent=y,this._services.set(T.IInstantiationService,this)}createChild(h){return new i(h,this._strict,this)}invokeFunction(h,...w){let y=a.traceInvocation(h),P=!1;try{return h({get:o=>{if(P)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(o,y);if(!s)throw new Error(`[invokeFunction] unknown service '${o}'`);return s}},...w)}finally{P=!0,y.stop()}}createInstance(h,...w){let y,P;return h instanceof D.SyncDescriptor?(y=a.traceCreation(h.ctor),P=this._createInstance(h.ctor,h.staticArguments.concat(w),y)):(y=a.traceCreation(h),P=this._createInstance(h,w,y)),y.stop(),P}_createInstance(h,w=[],y){let P=T._util.getServiceDependencies(h).sort((s,v)=>s.index-v.index),b=[];for(const s of P){let v=this._getOrCreateServiceInstance(s.id,y);if(!v&&this._strict&&!s.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${s.id}.`);b.push(v)}let o=P.length>0?P[0].index:w.length;if(w.length!==o){console.warn(`[createInstance] First service dependency of ${h.name} at position ${o+1} conflicts with ${w.length} static arguments`);let s=o-w.length;s>0?w=w.concat(new Array(s)):w=w.slice(0,o)}return new h(...[...w,...b])}_setServiceInstance(h,w){if(this._services.get(h)instanceof D.SyncDescriptor)this._services.set(h,w);else if(this._parent)this._parent._setServiceInstance(h,w);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let w=this._services.get(h);return!w&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):w}_getOrCreateServiceInstance(h,w){let y=this._getServiceInstanceOrDescriptor(h);return y instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,y,w.branch(h,!0)):(w.branch(h,!1),y)}_safeCreateAndCacheServiceInstance(h,w,y){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,w,y)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,w,y){const P=new S.Graph(s=>s.id.toString());let b=0;const o=[{id:h,desc:w,_trace:y}];for(;o.length;){const s=o.pop();if(P.lookupOrInsertNode(s),b++>1e3)throw new k(P);for(let v of T._util.getServiceDependencies(s.desc.ctor)){let n=this._getServiceInstanceOrDescriptor(v.id);if(!n&&!v.optional&&console.warn(`[createInstance] ${h} depends on ${v.id} which is NOT registered.`),n instanceof D.SyncDescriptor){const f={id:v.id,desc:n,_trace:s._trace.branch(v.id,!0)};P.insertEdge(s,f),o.push(f)}}}for(;;){const s=P.roots();if(s.length===0){if(!P.isEmpty())throw new k(P);break}for(const{data:v}of s){if(this._getServiceInstanceOrDescriptor(v.id)instanceof D.SyncDescriptor){const f=this._createServiceInstanceWithOwner(v.id,v.desc.ctor,v.desc.staticArguments,v.desc.supportsDelayedInstantiation,v._trace);this._setServiceInstance(v.id,f)}P.removeNode(v)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,w,y=[],P,b){if(this._services.get(h)instanceof D.SyncDescriptor)return this._createServiceInstance(w,y,P,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,w,y,P,b);throw new Error(`illegalState - creating UNKNOWN service instance ${w.name}`)}_createServiceInstance(h,w=[],y,P){if(y){const b=new g.IdleValue(()=>this._createInstance(h,w,P));return new Proxy(Object.create(null),{get(o,s){if(s in o)return o[s];let v=b.value,n=v[s];return typeof n!="function"||(n=n.bind(v),o[s]=n),n},set(o,s,v){return b.value[s]=v,!0}})}else return this._createInstance(h,w,P)}}e.InstantiationService=i;var I;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(I||(I={}));class a{constructor(h,w){this.type=h,this.name=w,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return E?new a(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):a._None}static traceCreation(h){return E?new a(0,h.name):a._None}branch(h,w){let y=new a(2,h.toString());return this._dep.push([h,w,y]),y}stop(){let h=Date.now()-this._start;a._totals+=h;let w=!1;function y(b,o){let s=[],v=new Array(b+1).join("	");for(const[n,f,r]of o._dep)if(f&&r){w=!0,s.push(`${v}CREATES -> ${n}`);let t=y(b+1,r);t&&s.push(t)}else s.push(`${v}uses -> ${n}`);return s.join(`
`)}let P=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${y(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${a._totals.toFixed(2)}ms)`];(h>2||w)&&console.log(P.join(`
`))}}a._None=new class extends a{constructor(){super(-1,null)}stop(){}branch(){return this}},a._totals=0}),define(fe[11],me([0,1,52,3,6,12,4]),function(Y,e,g,L,D,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,T.createDecorator)("logService"),e.ILoggerService=(0,T.createDecorator)("loggerService");function C(){return new Date().toISOString()}var E;(function(f){f[f.Trace=0]="Trace",f[f.Debug=1]="Debug",f[f.Info=2]="Info",f[f.Warning=3]="Warning",f[f.Error=4]="Error",f[f.Critical=5]="Critical",f[f.Off=6]="Off"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;function k(f,r,t){switch(r){case E.Trace:f.trace(t);break;case E.Debug:f.debug(t);break;case E.Info:f.info(t);break;case E.Warning:f.warn(t);break;case E.Error:f.error(t);break;case E.Critical:f.critical(t);break;default:throw new Error("Invalid log level")}}e.log=k;function i(f){let r="";for(let t=0;t<f.length;t++){let u=f[t];if(typeof u=="object")try{u=JSON.stringify(u)}catch(l){}r+=(t>0?" ":"")+u}return r}e.format=i;class I extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=I;class a extends I{constructor(r){super();this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...t){this.checkLogLevel(E.Trace)&&this.log(E.Trace,i([r,...t]))}debug(r,...t){this.checkLogLevel(E.Debug)&&this.log(E.Debug,i([r,...t]))}info(r,...t){this.checkLogLevel(E.Info)&&this.log(E.Info,i([r,...t]))}warn(r,...t){this.checkLogLevel(E.Warning)&&this.log(E.Warning,i([r,...t]))}error(r,...t){if(this.checkLogLevel(E.Error))if(r instanceof Error){const u=Array.prototype.slice.call(arguments);u[0]=r.stack,this.log(E.Error,i(u))}else this.log(E.Error,i([r,...t]))}critical(r,...t){this.checkLogLevel(E.Critical)&&this.log(E.Critical,i([r,...t]))}flush(){}}e.AbstractMessageLogger=a;class p extends I{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r),this.useColors=!S.isWindows}trace(r,...t){this.getLevel()<=E.Trace&&(this.useColors?console.log(`[90m[main ${C()}][0m`,r,...t):console.log(`[main ${C()}]`,r,...t))}debug(r,...t){this.getLevel()<=E.Debug&&(this.useColors?console.log(`[90m[main ${C()}][0m`,r,...t):console.log(`[main ${C()}]`,r,...t))}info(r,...t){this.getLevel()<=E.Info&&(this.useColors?console.log(`[90m[main ${C()}][0m`,r,...t):console.log(`[main ${C()}]`,r,...t))}warn(r,...t){this.getLevel()<=E.Warning&&(this.useColors?console.warn(`[93m[main ${C()}][0m`,r,...t):console.warn(`[main ${C()}]`,r,...t))}error(r,...t){this.getLevel()<=E.Error&&(this.useColors?console.error(`[91m[main ${C()}][0m`,r,...t):console.error(`[main ${C()}]`,r,...t))}critical(r,...t){this.getLevel()<=E.Critical&&(this.useColors?console.error(`[90m[main ${C()}][0m`,r,...t):console.error(`[main ${C()}]`,r,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=p;class h extends I{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r)}trace(r,...t){this.getLevel()<=E.Trace&&console.log("%cTRACE","color: #888",r,...t)}debug(r,...t){this.getLevel()<=E.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...t)}info(r,...t){this.getLevel()<=E.Info&&console.log("%c INFO","color: #33f",r,...t)}warn(r,...t){this.getLevel()<=E.Warning&&console.log("%c WARN","color: #993",r,...t)}error(r,...t){this.getLevel()<=E.Error&&console.log("%c  ERR","color: #f33",r,...t)}critical(r,...t){this.getLevel()<=E.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...t)}dispose(){}flush(){}}e.ConsoleLogger=h;class w extends I{constructor(r,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=r,this.setLevel(t)}trace(r,...t){this.getLevel()<=E.Trace&&this.adapter.log(E.Trace,[this.extractMessage(r),...t])}debug(r,...t){this.getLevel()<=E.Debug&&this.adapter.log(E.Debug,[this.extractMessage(r),...t])}info(r,...t){this.getLevel()<=E.Info&&this.adapter.log(E.Info,[this.extractMessage(r),...t])}warn(r,...t){this.getLevel()<=E.Warning&&this.adapter.log(E.Warning,[this.extractMessage(r),...t])}error(r,...t){this.getLevel()<=E.Error&&this.adapter.log(E.Error,[this.extractMessage(r),...t])}critical(r,...t){this.getLevel()<=E.Critical&&this.adapter.log(E.Critical,[this.extractMessage(r),...t])}extractMessage(r){return typeof r=="string"?r:(0,g.toErrorMessage)(r,this.getLevel()<=E.Trace)}dispose(){}flush(){}}e.AdapterLogger=w;class y extends I{constructor(r){super();this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const t of this.logServices)t.setLevel(r);super.setLevel(r)}trace(r,...t){for(const u of this.logServices)u.trace(r,...t)}debug(r,...t){for(const u of this.logServices)u.debug(r,...t)}info(r,...t){for(const u of this.logServices)u.info(r,...t)}warn(r,...t){for(const u of this.logServices)u.warn(r,...t)}error(r,...t){for(const u of this.logServices)u.error(r,...t)}critical(r,...t){for(const u of this.logServices)u.critical(r,...t)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=y;class P extends D.Disposable{constructor(r){super();this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...t){this.logger.trace(r,...t)}debug(r,...t){this.logger.debug(r,...t)}info(r,...t){this.logger.info(r,...t)}warn(r,...t){this.logger.warn(r,...t)}error(r,...t){this.logger.error(r,...t)}critical(r,...t){this.logger.critical(r,...t)}flush(){this.logger.flush()}}e.LogService=P;class b extends D.Disposable{constructor(r,t){super();this.logLevel=r,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(u=>{this.logLevel=u,this.logLevelChangeableLoggers.forEach(l=>l.setLevel(u))}))}getLogger(r){return this.loggers.get(r.toString())}createLogger(r,t){let u=this.loggers.get(r.toString());return u||(u=this.doCreateLogger(r,t?.always?E.Trace:this.logLevel,t),this.loggers.set(r.toString(),u),t?.always||this.logLevelChangeableLoggers.push(u)),u}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(r=>r.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=b;class o{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(r){}getLevel(){return E.Info}trace(r,...t){}debug(r,...t){}info(r,...t){}warn(r,...t){}error(r,...t){}critical(r,...t){}dispose(){}flush(){}}e.NullLogService=o;function s(f){if(f.verbose)return E.Trace;if(typeof f.logLevel=="string"){const r=v(f.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=s;function v(f){switch(f){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Critical;case"off":return E.Off}}e.parseLogLevel=v;function n(f){switch(f){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Critical:return"critical";case E.Off:return"off"}}e.LogLevelToString=n}),define(fe[190],me([0,1,43,11]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function D(E,k,i,I){try{const a=await new Promise((p,h)=>{Y(["spdlog"],p,h)});return a.setFlushOn(L.LogLevel.Trace),a.createAsyncRotatingLogger(E,k,i,I)}catch(a){console.error(a)}return null}function S(E,k,i,I){const a=Y.__$__nodeRequire("spdlog");return a.setFlushOn(L.LogLevel.Trace),a.createRotatingLogger(E,k,i,I)}e.createRotatingLogger=S;function T(E,k,i){switch(k){case L.LogLevel.Trace:E.trace(i);break;case L.LogLevel.Debug:E.debug(i);break;case L.LogLevel.Info:E.info(i);break;case L.LogLevel.Warning:E.warn(i);break;case L.LogLevel.Error:E.error(i);break;case L.LogLevel.Critical:E.critical(i);break;default:throw new Error("Invalid log level")}}class C extends L.AbstractMessageLogger{constructor(k,i,I,a){super();this.name=k,this.filepath=i,this.rotating=I,this.buffer=[],this.setLevel(a),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(p=>{this._logger&&this._logger.setLevel(p)}))}_createSpdLogLogger(){const k=this.rotating?6:1,i=30/k*g.ByteSize.MB;return D(this.name,this.filepath,i,k).then(I=>{if(I){this._logger=I,this._logger.setLevel(this.getLevel());for(const{level:a,message:p}of this.buffer)T(this._logger,a,p);this.buffer=[]}})}log(k,i){this._logger?T(this._logger,k,i):this.getLevel()<=k&&this.buffer.push({level:k,message:i})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=C}),define(fe[116],me([0,1,50,161,4]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var S;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(S=e.MarkerTag||(e.MarkerTag={}));var T;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(T=e.MarkerSeverity||(e.MarkerSeverity={})),function(E){function k(h,w){return w-h}E.compare=k;const i=Object.create(null);i[E.Error]=(0,L.localize)(0,null),i[E.Warning]=(0,L.localize)(1,null),i[E.Info]=(0,L.localize)(2,null);function I(h){return i[h]||""}E.toString=I;function a(h){switch(h){case g.default.Error:return E.Error;case g.default.Warning:return E.Warning;case g.default.Info:return E.Info;case g.default.Ignore:return E.Hint}}E.fromSeverity=a;function p(h){switch(h){case E.Error:return g.default.Error;case E.Warning:return g.default.Warning;case E.Info:return g.default.Info;case E.Hint:return g.default.Ignore}}E.toSeverity=p}(T=e.MarkerSeverity||(e.MarkerSeverity={}));var C;(function(E){const k="";function i(a){return I(a,!0)}E.makeKey=i;function I(a,p){let h=[k];return a.source?h.push(a.source.replace("\xA6","\\\xA6")):h.push(k),a.code?typeof a.code=="string"?h.push(a.code.replace("\xA6","\\\xA6")):h.push(a.code.value.replace("\xA6","\\\xA6")):h.push(k),a.severity!==void 0&&a.severity!==null?h.push(T.toString(a.severity)):h.push(k),a.message&&p?h.push(a.message.replace("\xA6","\\\xA6")):h.push(k),a.startLineNumber!==void 0&&a.startLineNumber!==null?h.push(a.startLineNumber.toString()):h.push(k),a.startColumn!==void 0&&a.startColumn!==null?h.push(a.startColumn.toString()):h.push(k),a.endLineNumber!==void 0&&a.endLineNumber!==null?h.push(a.endLineNumber.toString()):h.push(k),a.endColumn!==void 0&&a.endColumn!==null?h.push(a.endColumn.toString()):h.push(k),h.push(k),h.join("\xA6")}E.makeKeyOptionalMessage=I})(C=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,D.createDecorator)("markerService")}),define(fe[191],me([0,1,3,50,4]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=L.default,e.INotificationService=(0,D.createDecorator)("notificationService");var S;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.GLOBAL=1]="GLOBAL"})(S=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var T;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(T=e.NotificationsFilter||(e.NotificationsFilter={}));class C{constructor(){this.progress=new E,this.onDidClose=g.Event.None,this.onDidChangeVisibility=g.Event.None}updateSeverity(i){}updateMessage(i){}updateActions(i){}close(){}}e.NoOpNotification=C;class E{infinite(){}done(){}total(i){}worked(i){}}e.NoOpProgress=E}),define(fe[192],me([0,1,6,8,2,4]),function(Y,e,g,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,S.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return g.Disposable.None},registerValidator(){return g.Disposable.None},registerExternalUriResolver(){return g.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return g.Disposable.None},async open(){return!1},async resolveExternalUri(E){return{resolved:E,dispose(){}}}});function T(E,k){return D.URI.isUri(E)?(0,L.equalsIgnoreCase)(E.scheme,k):(0,L.startsWithIgnoreCase)(E,k+":")}e.matchesScheme=T;function C(E,...k){return k.some(i=>T(E,i))}e.matchesSomeScheme=C}),define(fe[193],me([0,1,10,12,38,23]),function(Y,e,g,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const C=L.globals.vscode.context.configuration();if(C)T=C.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Y?.__$__nodeRequire=="function"){const C=(0,S.dirname)(g.FileAccess.asFileUri("",Y));T=Y.__$__nodeRequire((0,S.joinPath)(C,"product.json").fsPath);const E=Y.__$__nodeRequire((0,S.joinPath)(C,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`}),Object.assign(T,{version:E.version})}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.62.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=T});var $e=this&&this.__param||function(Y,e){return function(g,L){e(g,L,Y)}};define(fe[117],me([0,1,16,21,6,4]),function(Y,e,g,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,S.createDecorator)("progressService");var T;(function(i){i[i.Explorer=1]="Explorer",i[i.Scm=3]="Scm",i[i.Extensions=5]="Extensions",i[i.Window=10]="Window",i[i.Notification=15]="Notification",i[i.Dialog=20]="Dialog"})(T=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class C{constructor(I){this.callback=I}get value(){return this._value}report(I){this._value=I,this.callback(this._value)}}e.Progress=C,C.None=Object.freeze({report(){}});let E=class extends D.Disposable{constructor(I,a){super();this.deferred=new g.DeferredPromise,a.withProgress(I,p=>(this.reporter=p,this.lastStep&&p.report(this.lastStep),this.deferred.p)),this._register((0,D.toDisposable)(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};E=Ve([$e(1,e.IProgressService)],E),e.UnmanagedProgress=E;class k extends D.Disposable{constructor(I){super();this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new D.DisposableStore)}start(I){this.stop();const a=++this.currentOperationId,p=new L.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{a===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add((0,D.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,D.toDisposable)(()=>p.cancel())),this.currentOperationDisposables.add((0,D.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:a,token:p.token,stop:()=>this.doStop(a),isCurrent:()=>this.currentOperationId===a}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,S.createDecorator)("editorProgressService")}),define(fe[34],me([0,1,58,13]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(T,C){g.ok(L.isString(T)),g.ok(L.isObject(C)),g.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,C)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new D}),define(fe[118],me([0,1,3,34]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class S{constructor(){this._onDidChangeSchema=new g.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(E,k){this.schemasById[D(E)]=k,this._onDidChangeSchema.fire(E)}notifySchemaChanged(E){this._onDidChangeSchema.fire(E)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new S;L.Registry.add(e.Extensions.JSONContribution,T)}),define(fe[87],me([0,1,15,3,13,156,118,34]),function(Y,e,g,L,D,S,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var E;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(E=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var k;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(k=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const i=C.Registry.as(T.Extensions.JSONContribution);class I{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:S.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(o,s=!0){this.registerConfigurations([o],s)}registerConfigurations(o,s=!0){const v=this.doRegisterConfigurations(o,s);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}deregisterConfigurations(o){const s=this.doDeregisterConfigurations(o);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}updateConfigurations({add:o,remove:s}){const v=[];v.push(...this.doDeregisterConfigurations(s)),v.push(...this.doRegisterConfigurations(o,!1)),i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,g.distinct)(v))}registerDefaultConfigurations(o){const s=[],v=[];for(const n of o)for(const f in n)if(s.push(f),e.OVERRIDE_PROPERTY_PATTERN.test(f)){this.defaultValues[f]={...this.defaultValues[f]||{},...n[f]};const r={type:"object",default:this.defaultValues[f],description:S.localize(1,null,f),$ref:e.resourceLanguageSettingsSchemaId};v.push(p(f)),this.configurationProperties[f]=r,this.defaultLanguageConfigurationOverridesNode.properties[f]=r}else{this.defaultValues[f]=n[f];const r=this.configurationProperties[f];r&&(this.updatePropertyDefaultValue(f,r),this.updateSchema(f,r))}this.registerOverrideIdentifiers(v),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}deregisterDefaultConfigurations(o){const s=[];for(const v of o)for(const n in v)if(s.push(n),delete this.defaultValues[n],e.OVERRIDE_PROPERTY_PATTERN.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const f=this.configurationProperties[n];f&&(this.updatePropertyDefaultValue(n,f),this.updateSchema(n,f))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}notifyConfigurationSchemaUpdated(...o){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(o){for(const s of o)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(o,s){const v=[];return o.forEach(n=>{v.push(...this.validateAndRegisterProperties(n,s,n.extensionInfo)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),v}doDeregisterConfigurations(o){const s=[],v=n=>{if(n.properties)for(const f in n.properties)s.push(f),delete this.configurationProperties[f],this.removeFromSchema(f,n.properties[f]);n.allOf&&n.allOf.forEach(f=>v(f))};for(const n of o){v(n);const f=this.configurationContributors.indexOf(n);f!==-1&&this.configurationContributors.splice(f,1)}return s}validateAndRegisterProperties(o,s=!0,v,n=3){n=D.isUndefinedOrNull(o.scope)?n:o.scope;let f=[],r=o.properties;if(r)for(let u in r){if(s&&y(u)){delete r[u];continue}const l=r[u];if(this.updatePropertyDefaultValue(u,l),e.OVERRIDE_PROPERTY_PATTERN.test(u)?l.scope=void 0:(l.scope=D.isUndefinedOrNull(l.scope)?n:l.scope,l.restricted=D.isUndefinedOrNull(l.restricted)?!!v?.restrictedConfigurations?.includes(u):l.restricted),r[u].hasOwnProperty("included")&&!r[u].included){this.excludedConfigurationProperties[u]=r[u],delete r[u];continue}else this.configurationProperties[u]=r[u];!r[u].deprecationMessage&&r[u].markdownDeprecationMessage&&(r[u].deprecationMessage=r[u].markdownDeprecationMessage),f.push(u)}let t=o.allOf;if(t)for(let u of t)f.push(...this.validateAndRegisterProperties(u,s,v,n));return f}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(o){const s=v=>{let n=v.properties;if(n)for(const r in n)this.updateSchema(r,n[r]);let f=v.allOf;f&&f.forEach(s)};s(o)}updateSchema(o,s){switch(e.allSettings.properties[o]=s,s.scope){case 1:e.applicationSettings.properties[o]=s;break;case 2:e.machineSettings.properties[o]=s;break;case 6:e.machineOverridableSettings.properties[o]=s;break;case 3:e.windowSettings.properties[o]=s;break;case 4:e.resourceSettings.properties[o]=s;break;case 5:e.resourceSettings.properties[o]=s,this.resourceLanguageSettingsSchema.properties[o]=s;break}}removeFromSchema(o,s){switch(delete e.allSettings.properties[o],s.scope){case 1:delete e.applicationSettings.properties[o];break;case 2:delete e.machineSettings.properties[o];break;case 6:delete e.machineOverridableSettings.properties[o];break;case 3:delete e.windowSettings.properties[o];break;case 4:case 5:delete e.resourceSettings.properties[o];break}}updateOverridePropertyPatternKey(){for(const o of this.overrideIdentifiers.values()){const s=`[${o}]`,v={type:"object",description:S.localize(2,null),errorMessage:S.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,v),e.allSettings.properties[s]=v,e.applicationSettings.properties[s]=v,e.machineSettings.properties[s]=v,e.machineOverridableSettings.properties[s]=v,e.windowSettings.properties[s]=v,e.resourceSettings.properties[s]=v}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(o,s){let v=this.defaultValues[o];D.isUndefined(v)&&(v=s.default),D.isUndefined(v)&&(v=h(s.type)),s.default=v}}const a="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(a);function p(b){return b.substring(1,b.length-1)}e.overrideIdentifierFromKey=p;function h(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const w=new I;C.Registry.add(e.Extensions.Configuration,w);function y(b){return b.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(b)?S.localize(5,null,b):w.getConfigurationProperties()[b]!==void 0?S.localize(6,null,b):null:S.localize(4,null)}e.validateProperty=y;function P(){const b=[],o=w.getConfigurationProperties();for(const s of Object.keys(o))b.push([s,o[s].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=P}),define(fe[119],me([0,1,25,13,2,87,4,34]),function(Y,e,g,L,D,S,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,T.createDecorator)("configurationService");function E(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof D.URI)}e.isConfigurationOverrides=E;var k;(function(f){f[f.USER=1]="USER",f[f.USER_LOCAL=2]="USER_LOCAL",f[f.USER_REMOTE=3]="USER_REMOTE",f[f.WORKSPACE=4]="WORKSPACE",f[f.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",f[f.DEFAULT=6]="DEFAULT",f[f.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(f){switch(f){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function I(f,r){const t=r?f?r.keys.filter(A=>f.keys.indexOf(A)===-1):[...r.keys]:[],u=f?r?f.keys.filter(A=>r.keys.indexOf(A)===-1):[...f.keys]:[],l=[];if(r&&f){for(const A of f.keys)if(r.keys.indexOf(A)!==-1){const R=P(f.contents,A),B=P(r.contents,A);g.equals(R,B)||l.push(A)}}const c=[],m=A=>{const R={};for(const B of A)for(const U of B.identifiers)R[v(U)]=B;return R},d=r?m(r.overrides):{},_=f?m(f.overrides):{};if(Object.keys(d).length)for(const A of t){const R=d[A];R&&c.push([(0,S.overrideIdentifierFromKey)(A),R.keys])}if(Object.keys(_).length)for(const A of u){const R=_[A];R&&c.push([(0,S.overrideIdentifierFromKey)(A),R.keys])}if(Object.keys(d).length&&Object.keys(_).length)for(const A of l){const R=_[A],B=d[A];if(R&&B){const U=I({contents:R.contents,keys:R.keys,overrides:[]},{contents:B.contents,keys:B.keys,overrides:[]});c.push([(0,S.overrideIdentifierFromKey)(A),[...U.added,...U.removed,...U.updated]])}}return{added:t,removed:u,updated:l,overrides:c}}e.compare=I;function a(f,r){const t=[];for(const u of Object.keys(f))if(S.OVERRIDE_PROPERTY_PATTERN.test(u)){const l={};for(const c in f[u])l[c]=f[u][c];t.push({identifiers:[(0,S.overrideIdentifierFromKey)(u).trim()],keys:Object.keys(l),contents:p(l,r)})}return t}e.toOverrides=a;function p(f,r){const t=Object.create(null);for(let u in f)h(t,u,f[u],r);return t}e.toValuesTree=p;function h(f,r,t,u){const l=r.split("."),c=l.pop();let m=f;for(let d=0;d<l.length;d++){let _=l[d],A=m[_];switch(typeof A){case"undefined":A=m[_]=Object.create(null);break;case"object":break;default:u(`Ignoring ${r} as ${l.slice(0,d+1).join(".")} is ${JSON.stringify(A)}`);return}m=A}if(typeof m=="object"&&m!==null)try{m[c]=t}catch(d){u(`Ignoring ${r} as ${l.join(".")} is ${JSON.stringify(m)}`)}else u(`Ignoring ${r} as ${l.join(".")} is ${JSON.stringify(m)}`)}e.addToValueTree=h;function w(f,r){const t=r.split(".");y(f,t)}e.removeFromValueTree=w;function y(f,r){const t=r.shift();if(r.length===0){delete f[t];return}if(Object.keys(f).indexOf(t)!==-1){const u=f[t];typeof u=="object"&&!Array.isArray(u)&&(y(u,r),Object.keys(u).length===0&&delete f[t])}}function P(f,r,t){function u(m,d){let _=m;for(const A of d){if(typeof _!="object"||_===null)return;_=_[A]}return _}const l=r.split("."),c=u(f,l);return typeof c=="undefined"?t:c}e.getConfigurationValue=P;function b(f,r,t){Object.keys(r).forEach(u=>{u!=="__proto__"&&(u in f?L.isObject(f[u])&&L.isObject(r[u])?b(f[u],r[u],t):t&&(f[u]=r[u]):f[u]=r[u])})}e.merge=b;function o(){const f=C.Registry.as(S.Extensions.Configuration).getConfigurationProperties();return Object.keys(f)}e.getConfigurationKeys=o;function s(){const f=Object.create(null),r=C.Registry.as(S.Extensions.Configuration).getConfigurationProperties();for(let t in r){let u=r[t].default;h(f,t,u,l=>console.error(`Conflict in default settings: ${l}`))}return f}e.getDefaultValues=s;function v(f){return`[${f}]`}e.keyFromOverrideIdentifier=v;function n(f,r,t){const u=f.inspect(r),l=f.inspect(t);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:u.defaultValue}e.getMigratedSettingValue=n}),define(fe[194],me([0,1,15,3,61,6,24,25,13,2,119,87,34]),function(Y,e,g,L,D,S,T,C,E,k,i,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(n={},f=[],r=[]){this._contents=n,this._keys=f,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,i.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,f){const r=this.getContentsForOverrideIdentifer(f);return r?n?(0,i.getConfigurationValue)(r,n):r:void 0}getKeysForOverrideIdentifier(n){for(const f of this.overrides)if(f.identifiers.indexOf(n)!==-1)return f.keys;return[]}override(n){let f=this.overrideConfigurations.get(n);return f||(f=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,f)),f}merge(...n){const f=C.deepClone(this.contents),r=C.deepClone(this.overrides),t=[...this.keys];for(const u of n){this.mergeContents(f,u.contents);for(const l of u.overrides){const[c]=r.filter(m=>g.equals(m.identifiers,l.identifiers));c?this.mergeContents(c.contents,l.contents):r.push(C.deepClone(l))}for(const l of u.keys)t.indexOf(l)===-1&&t.push(l)}return new p(f,t,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(n){const f=this.getContentsForOverrideIdentifer(n);if(!f||typeof f!="object"||!Object.keys(f).length)return this;let r={};for(const t of g.distinct([...Object.keys(this.contents),...Object.keys(f)])){let u=this.contents[t],l=f[t];l&&(typeof u=="object"&&typeof l=="object"?(u=C.deepClone(u),this.mergeContents(u,l)):u=l),r[t]=u}return new p(r,this.keys,this.overrides)}mergeContents(n,f){for(const r of Object.keys(f)){if(r in n&&E.isObject(n[r])&&E.isObject(f[r])){this.mergeContents(n[r],f[r]);continue}n[r]=C.deepClone(f[r])}}checkAndFreeze(n){return this.isFrozen&&!Object.isFrozen(n)?C.deepFreeze(n):n}getContentsForOverrideIdentifer(n){for(const f of this.overrides)if(f.identifiers.indexOf(n)!==-1)return f.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,f){this.addKey(n),(0,i.addToValueTree)(this.contents,n,f,r=>{throw new Error(r)})}removeValue(n){this.removeKey(n)&&(0,i.removeFromValueTree)(this.contents,n)}addKey(n){let f=this.keys.length;for(let r=0;r<f;r++)n.indexOf(this.keys[r])===0&&(f=r);this.keys.splice(f,1,n)}removeKey(n){let f=this.keys.indexOf(n);return f!==-1?(this.keys.splice(f,1),!0):!1}}e.ConfigurationModel=p;class h extends p{constructor(){const n=(0,i.getDefaultValues)(),f=(0,i.getConfigurationKeys)(),r=[];for(const t of Object.keys(n))I.OVERRIDE_PROPERTY_PATTERN.test(t)&&r.push({identifiers:[(0,I.overrideIdentifierFromKey)(t).trim()],keys:Object.keys(n[t]),contents:(0,i.toValuesTree)(n[t],u=>console.error(`Conflict in default settings file: ${u}`))});super(n,f,r)}}e.DefaultConfigurationModel=h;class w{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,f){if(!E.isUndefinedOrNull(n)){const r=this.doParseContent(n);this.parseRaw(r,f)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,f){this._raw=n;const{contents:r,keys:t,overrides:u,restricted:l}=this.doParseRaw(n,f);this._configurationModel=new p(r,t,u),this._restrictedConfigurations=l||[]}doParseContent(n){let f={},r=null,t=[],u=[],l=[];function c(d){Array.isArray(t)?t.push(d):r!==null&&(t[r]=d)}let m={onObjectBegin:()=>{let d={};c(d),u.push(t),t=d,r=null},onObjectProperty:d=>{r=d},onObjectEnd:()=>{t=u.pop()},onArrayBegin:()=>{let d=[];c(d),u.push(t),t=d,r=null},onArrayEnd:()=>{t=u.pop()},onLiteralValue:c,onError:(d,_,A)=>{l.push({error:d,offset:_,length:A})}};if(n)try{D.visit(n,m),f=t[0]||{}}catch(d){console.error(`Error while parsing settings file ${this._name}: ${d}`),this._parseErrors=[d]}return f}doParseRaw(n,f){const r=a.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),t=this.filter(n,r,!0,f);n=t.raw;const u=(0,i.toValuesTree)(n,m=>console.error(`Conflict in settings file ${this._name}: ${m}`)),l=Object.keys(n),c=(0,i.toOverrides)(n,m=>console.error(`Conflict in settings file ${this._name}: ${m}`));return{contents:u,keys:l,overrides:c,restricted:t.restricted}}filter(n,f,r,t){if(!t?.scopes&&!t?.skipRestricted)return{raw:n,restricted:[]};const u={},l=[];for(let c in n)if(I.OVERRIDE_PROPERTY_PATTERN.test(c)&&r){const m=this.filter(n[c],f,!1,t);u[c]=m.raw,l.push(...m.restricted)}else{const m=f[c],d=m?typeof m.scope!="undefined"?m.scope:3:void 0;m?.restricted&&l.push(c),(d===void 0||t.scopes===void 0||t.scopes.includes(d))&&(t.skipRestricted&&m?.restricted||(u[c]=n[c]))}return{raw:u,restricted:l}}}e.ConfigurationModelParser=w;class y extends S.Disposable{constructor(n,f,r,t){super();this.userSettingsResource=n,this.scopes=f,this.fileService=t,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(n){return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=y;class P{constructor(n,f,r=new p,t=new p,u=new T.ResourceMap,l=new p,c=new T.ResourceMap,m=!0){this._defaultConfiguration=n,this._localUserConfiguration=f,this._remoteUserConfiguration=r,this._workspaceConfiguration=t,this._folderConfigurations=u,this._memoryConfiguration=l,this._memoryConfigurationByResource=c,this._freeze=m,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(n,f,r){return this.getConsolidateConfigurationModel(f,r).getValue(n)}updateValue(n,f,r={}){let t;r.resource?(t=this._memoryConfigurationByResource.get(r.resource),t||(t=new p,this._memoryConfigurationByResource.set(r.resource,t))):t=this._memoryConfiguration,f===void 0?t.removeValue(n):t.setValue(n,f),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,f,r){const t=this.getConsolidateConfigurationModel(f,r),u=this.getFolderConfigurationModelForResource(f.resource,r),l=f.resource?this._memoryConfigurationByResource.get(f.resource)||this._memoryConfiguration:this._memoryConfiguration,c=f.overrideIdentifier?this._defaultConfiguration.freeze().override(f.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),m=f.overrideIdentifier?this.userConfiguration.freeze().override(f.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),d=f.overrideIdentifier?this.localUserConfiguration.freeze().override(f.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),_=f.overrideIdentifier?this.remoteUserConfiguration.freeze().override(f.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),A=r?f.overrideIdentifier?this._workspaceConfiguration.freeze().override(f.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,R=u?f.overrideIdentifier?u.freeze().override(f.overrideIdentifier).getValue(n):u.freeze().getValue(n):void 0,B=f.overrideIdentifier?l.override(f.overrideIdentifier).getValue(n):l.getValue(n),U=t.getValue(n),F=g.distinct(g.flatten(t.overrides.map($=>$.identifiers))).filter($=>t.getOverrideValue(n,$)!==void 0);return{defaultValue:c,userValue:m,userLocalValue:d,userRemoteValue:_,workspaceValue:A,workspaceFolderValue:R,memoryValue:B,value:U,default:c!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:f.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,f.overrideIdentifier):void 0}:void 0,user:m!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:f.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,f.overrideIdentifier):void 0}:void 0,userLocal:d!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:f.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,f.overrideIdentifier):void 0}:void 0,userRemote:_!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:f.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,f.overrideIdentifier):void 0}:void 0,workspace:A!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:f.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,f.overrideIdentifier):void 0}:void 0,workspaceFolder:R!==void 0?{value:u?.freeze().getValue(n),override:f.overrideIdentifier?u?.freeze().getOverrideValue(n,f.overrideIdentifier):void 0}:void 0,memory:B!==void 0?{value:l.getValue(n),override:f.overrideIdentifier?l.getOverrideValue(n,f.overrideIdentifier):void 0}:void 0,overrideIdentifiers:F.length?F:void 0}}keys(n){const f=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:f?f.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,f){this._folderConfigurations.set(n,f),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,f){const r=f.filter(t=>I.OVERRIDE_PROPERTY_PATTERN.test(t)).map(t=>{const u=(0,I.overrideIdentifierFromKey)(t),l=this._defaultConfiguration.getKeysForOverrideIdentifier(u),c=n.getKeysForOverrideIdentifier(u),m=[...c.filter(d=>l.indexOf(d)===-1),...l.filter(d=>c.indexOf(d)===-1),...l.filter(d=>!C.equals(this._defaultConfiguration.override(u).getValue(d),n.override(u).getValue(d)))];return[u,m]});return this.updateDefaultConfiguration(n),{keys:f,overrides:r}}compareAndUpdateLocalUserConfiguration(n){const{added:f,updated:r,removed:t,overrides:u}=(0,i.compare)(this.localUserConfiguration,n),l=[...f,...r,...t];return l.length&&this.updateLocalUserConfiguration(n),{keys:l,overrides:u}}compareAndUpdateRemoteUserConfiguration(n){const{added:f,updated:r,removed:t,overrides:u}=(0,i.compare)(this.remoteUserConfiguration,n);let l=[...f,...r,...t];return l.length&&this.updateRemoteUserConfiguration(n),{keys:l,overrides:u}}compareAndUpdateWorkspaceConfiguration(n){const{added:f,updated:r,removed:t,overrides:u}=(0,i.compare)(this.workspaceConfiguration,n);let l=[...f,...r,...t];return l.length&&this.updateWorkspaceConfiguration(n),{keys:l,overrides:u}}compareAndUpdateFolderConfiguration(n,f){const r=this.folderConfigurations.get(n),{added:t,updated:u,removed:l,overrides:c}=(0,i.compare)(r,f);let m=[...t,...u,...l];return(m.length||!r)&&this.updateFolderConfiguration(n,f),{keys:m,overrides:c}}compareAndDeleteFolderConfiguration(n){const f=this.folderConfigurations.get(n);if(!f)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:r,updated:t,removed:u,overrides:l}=(0,i.compare)(f,void 0);return{keys:[...r,...t,...u],overrides:l}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(n,f){let r=this.getConsolidatedConfigurationModelForResource(n,f);return n.overrideIdentifier?r.override(n.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:n},f){let r=this.getWorkspaceConsolidatedConfiguration();if(f&&n){const t=f.getFolder(n);t&&(r=this.getFolderConsolidatedConfiguration(t.uri)||r);const u=this._memoryConfigurationByResource.get(n);u&&(r=r.merge(u))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let f=this._foldersConsolidatedConfigurations.get(n);if(!f){const r=this.getWorkspaceConsolidatedConfiguration(),t=this._folderConfigurations.get(n);t?(f=r.merge(t),this._freeze&&(f=f.freeze()),this._foldersConsolidatedConfigurations.set(n,f)):f=r}return f}getFolderConfigurationModelForResource(n,f){if(f&&n){const r=f.getFolder(n);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,f)=>{const{contents:r,overrides:t,keys:u}=this._folderConfigurations.get(f);return n.push([f,{contents:r,overrides:t,keys:u}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(f=>n.add(f)),this.userConfiguration.freeze().keys.forEach(f=>n.add(f)),this._workspaceConfiguration.freeze().keys.forEach(f=>n.add(f)),this._folderConfigurations.forEach(f=>f.freeze().keys.forEach(r=>n.add(r))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const f=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>f.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>f.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>f.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(n).forEach(t=>f.add(t))),[...f.values()]}static parse(n){const f=this.parseConfigurationModel(n.defaults),r=this.parseConfigurationModel(n.user),t=this.parseConfigurationModel(n.workspace),u=n.folders.reduce((l,c)=>(l.set(k.URI.revive(c[0]),this.parseConfigurationModel(c[1])),l),new T.ResourceMap);return new P(f,r,new p,t,u,new p,new T.ResourceMap,!1)}static parseConfigurationModel(n){return new p(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=P;function b(...v){if(v.length===0)return{keys:[],overrides:[]};if(v.length===1)return v[0];const n=new Set,f=new Map;for(const t of v)t.keys.forEach(u=>n.add(u)),t.overrides.forEach(([u,l])=>{const c=(0,T.getOrSet)(f,u,new Set);l.forEach(m=>c.add(m))});const r=[];return f.forEach((t,u)=>r.push([u,[...t.values()]])),{keys:[...n.values()],overrides:r}}e.mergeChanges=b;class o{constructor(n,f,r,t){this.change=n,this.previous=f,this.currentConfiguraiton=r,this.currentWorkspace=t,this._previousConfiguration=void 0;const u=new Set;n.keys.forEach(c=>u.add(c)),n.overrides.forEach(([,c])=>c.forEach(m=>u.add(m))),this.affectedKeys=[...u.values()];const l=new p;this.affectedKeys.forEach(c=>l.setValue(c,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=P.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,f){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(f){const r=this.previousConfiguration?this.previousConfiguration.getValue(n,f,this.previous?.workspace):void 0,t=this.currentConfiguraiton.getValue(n,f,this.currentWorkspace);return!C.equals(r,t)}return!0}return!1}doesAffectedKeysTreeContains(n,f){let r=(0,i.toValuesTree)({[f]:!0},()=>{}),t;for(;typeof r=="object"&&(t=Object.keys(r)[0]);){if(n=n[t],!n)return!1;r=r[t]}return!0}}e.ConfigurationChangeEvent=o;class s extends o{constructor(n,f,r,t){super({keys:n.allKeys(),overrides:[]},void 0,n,f);this.source=r,this.sourceConfig=t}}e.AllKeysConfigurationChangeEvent=s}),define(fe[120],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,g.createDecorator)("remoteAuthorityResolverService");var L;(function(S){S.Unknown="Unknown",S.NotAvailable="NotAvailable",S.TemporarilyNotAvailable="TemporarilyNotAvailable",S.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(T,C=L.Unknown,E){super(T);this._message=T,this._code=C,this._detail=E,this.isHandled=C===L.NotAvailable&&E===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(T){return T instanceof D&&T._code===L.TemporarilyNotAvailable}static isNoResolverFound(T){return T instanceof D&&T._code===L.NoResolverFound}static isHandled(T){return T instanceof D&&T.isHandled}}e.RemoteAuthorityResolverError=D}),define(fe[64],me([0,1,10]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(k){return k.scheme===g.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=L;function D(k){if(!k)return;const i=k.indexOf("+");return i<0?k:k.substr(0,i)}e.getRemoteName=D;function S(k){return k.scheme!==g.Schemas.file&&k.scheme!==g.Schemas.vscodeRemote}e.isVirtualResource=S;function T(k){if(k.folders.length)return k.folders.every(i=>S(i.uri))?k.folders[0].uri:void 0;if(k.configuration&&S(k.configuration))return k.configuration}e.getVirtualWorkspaceLocation=T;function C(k){return T(k)?.scheme}e.getVirtualWorkspaceScheme=C;function E(k){return T(k)!==void 0}e.isVirtualWorkspace=E}),define(fe[27],me([0,1,8,4,64]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function S(a){if(typeof a=="object"&&a!==null&&a.supported!==!0)return a.description}e.getWorkspaceSupportTypeMessage=S;function T(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var C;(function(a){a[a.System=0]="System",a[a.User=1]="User"})(C=e.ExtensionType||(e.ExtensionType={}));class E{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,h){if(typeof p=="undefined"||p===null)return typeof h=="undefined"||h===null;if(typeof h=="undefined"||h===null)return!1;if(typeof p=="string"||typeof h=="string"){let w=typeof p=="string"?p:p.value,y=typeof h=="string"?h:h.value;return g.equalsIgnoreCase(w,y)}return p._lower===h._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.ExtensionIdentifier=E;function k(a){return a.contributes&&a.contributes.localizations?a.contributes.localizations.length>0:!1}e.isLanguagePackExtension=k;function i(a){return a.contributes&&a.contributes.authentication?a.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=i;function I(a,p){if(p&&a.enableProposedApi){const h=`onResolveRemoteAuthority:${(0,D.getRemoteName)(p)}`;return a.activationEvents?.indexOf(h)!==-1}return!1}e.isResolverExtension=I,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(fe[195],me([0,1,8,27]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(h,w){return h.uuid&&w.uuid?h.uuid===w.uuid:h.id===w.id?!0:(0,g.compareIgnoreCase)(h.id,w.id)===0}e.areSameExtensions=D;class S{constructor(w,y){this.version=y,this.id=w.id,this.uuid=w.uuid}key(){return`${this.id}-${this.version}`}equals(w){return w instanceof S?D(this,w)&&this.version===w.version:!1}}e.ExtensionIdentifierWithVersion=S;function T(h,w){return`${h}.${w}`}e.getExtensionId=T;function C(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=C;function E(h,w){return C(T(h,w))}e.getGalleryExtensionId=E;function k(h,w){const y=[],P=b=>{for(const o of y)if(o.some(s=>D(w(s),w(b))))return o;return null};for(const b of h){const o=P(b);o?o.push(b):y.push([b])}return y}e.groupByExtension=k;function i(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function I(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function a(h){const w=new Set;for(const y of h)y.malicious&&w.add(y.id.id);return w}e.getMaliciousExtensionsSet=a;function p(h,w){const y=[],P=w.manifest.extensionDependencies?.slice(0)??[];for(;P.length;){const b=P.shift();if(b&&y.every(o=>!D(o.identifier,{id:b}))){const o=h.filter(s=>D(s.identifier,{id:b}));o.length===1&&(y.push(o[0]),P.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return y}e.getExtensionDependencies=p}),define(fe[121],me([0,1,3,12,4,11]),function(Y,e,g,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var T;(function(h){h.Http="http",h.Https="https"})(T=e.TunnelProtocol||(e.TunnelProtocol={}));var C;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(C=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var E;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(E=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function k(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const w=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!w)return{address:w[1],port:+w[2]}}e.extractLocalHostUriMetaDataForPortMapping=k,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function i(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=i,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function I(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=I;function a(h,w){return w?w!==1&&h<1024:!L.isWindows&&h<1024}e.isPortPrivileged=a;let p=class{constructor(w){this.logService=w,this._onTunnelOpened=new g.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new g.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new g.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(w,y){return this._tunnelProvider=w,w?(this._canElevate=y.elevation,this._privacyOptions=y.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const w=[],y=Array.from(this._tunnels.values());for(let P of y){const b=Array.from(P.values());for(let o of b){const s=await o.value;s&&w.push(s)}}return w}async dispose(){for(const w of this._tunnels.values()){for(const{value:y}of w.values())await y.then(P=>P?.dispose());w.clear()}this._tunnels.clear()}openTunnel(w,y,P,b,o=!1,s=C.Private,v){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${y}:${P} on local port ${b}.`),!w)return;y||(y="localhost");const n=this.retainOrCreateTunnel(w,y,P,b,o,s,v);return n?n.then(f=>{if(!f){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(y,P);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(f);return(f.tunnelRemoteHost!==y||f.tunnelRemotePort!==P)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}makeTunnel(w){return{tunnelRemotePort:w.tunnelRemotePort,tunnelRemoteHost:w.tunnelRemoteHost,tunnelLocalPort:w.tunnelLocalPort,localAddress:w.localAddress,privacy:w.privacy,protocol:w.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${w.tunnelRemoteHost}:${w.tunnelRemotePort} `);const y=this._tunnels.get(w.tunnelRemoteHost);if(y){const P=y.get(w.tunnelRemotePort);P&&(P.refcount--,await this.tryDisposeTunnel(w.tunnelRemoteHost,w.tunnelRemotePort,P))}}}}async tryDisposeTunnel(w,y,P){if(P.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${w}:${y}.`);const b=P.value.then(async o=>{o&&(await o.dispose(!0),this._onTunnelClosed.fire({host:o.tunnelRemoteHost,port:o.tunnelRemotePort}))});return this._tunnels.has(w)&&this._tunnels.get(w).delete(y),b}}async closeTunnel(w,y){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${w}:${y} `);const P=this._tunnels.get(w);if(P&&P.has(y)){const b=P.get(y);b.refcount=0,await this.tryDisposeTunnel(w,y,b)}}addTunnelToMap(w,y,P){this._tunnels.has(w)||this._tunnels.set(w,new Map),this._tunnels.get(w).set(y,{refcount:1,value:P})}async removeEmptyTunnelFromMap(w,y){const P=this._tunnels.get(w);P&&(await P.get(y)||P.delete(y),P.size===0&&this._tunnels.delete(w))}getTunnelFromMap(w,y){let P=[w];i(w)?(P.push(...e.LOCALHOST_ADDRESSES),P.push(...e.ALL_INTERFACES_ADDRESSES)):I(w)&&P.push(...e.ALL_INTERFACES_ADDRESSES);const b=P.map(o=>this._tunnels.get(o));for(const o of b){const s=o?.get(y);if(s)return s}}canTunnel(w){return!!k(w)}createWithProvider(w,y,P,b,o,s,v){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${y}:${P} on local port ${b}.`);const f={elevationRequired:o?a(b===void 0?P:b):!1},r={remoteAddress:{host:y,port:P},localAddressPort:b,privacy:s,public:s!==C.Private,protocol:v},t=w.forwardPort(r,f);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(y,P,t),t}};p=Ve([$e(0,S.ILogService)],p),e.AbstractTunnelService=p}),define(fe[196],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class g{constructor(){this.validators=new Map}vsda(){return new Promise((D,S)=>Y(["vsda"],D,S))}async createNewMessage(D){try{const S=await this.vsda(),T=new S.validator;if(T){const C=String(g._nextId++);return this.validators.set(C,T),{id:C,data:T.createNewMessage(D)}}}catch(S){}return{id:"",data:D}}async validate(D,S){if(!D.id)return!0;const T=this.validators.get(D.id);if(!T)return!1;this.validators.delete(D.id);try{return T.validate(S)==="ok"}catch(C){return!1}}async sign(D){try{const S=await this.vsda(),T=new S.signer;if(T)return T.sign(D)}catch(S){}return D}}e.SignService=g,g._nextId=1}),define(fe[197],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class g{constructor(D){this._callback=D,this._terminalBufferMap=new Map}dispose(){for(const D of this._terminalBufferMap.values())D.dispose()}startBuffering(D,S,T=5){let C;return C=S(E=>{const k=typeof E=="string"?E:E.data;let i=this._terminalBufferMap.get(D);if(i){i.data.push(k);return}const I=setTimeout(()=>this.flushBuffer(D),T);i={data:[k],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(D),C.dispose()}},this._terminalBufferMap.set(D,i)}),C}stopBuffering(D){const S=this._terminalBufferMap.get(D);S&&S.dispose()}flushBuffer(D){const S=this._terminalBufferMap.get(D);S&&(this._terminalBufferMap.delete(D),this._callback(D,S.data.join("")))}}e.TerminalDataBufferer=g}),define(fe[198],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var g;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(g=e.ColorScheme||(e.ColorScheme={}))}),define(fe[65],me([0,1,48,3,6,4,34,198]),function(Y,e,g,L,D,S,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,S.createDecorator)("themeService");var E;(function(y){function P(b){return b&&typeof b=="object"&&typeof b.id=="string"}y.isThemeColor=P})(E=e.ThemeColor||(e.ThemeColor={}));function k(y){return{id:y}}e.themeColorFromId=k;var i;(function(y){function P(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(typeof f.color=="undefined"||E.isThemeColor(f.color))}y.isThemeIcon=P;const b=new RegExp(`^\\$\\((${g.CSSIcon.iconNameExpression}(?:${g.CSSIcon.iconModifierExpression})?)\\)$`);function o(f){const r=b.exec(f);if(!r)return;let[,t]=r;return{id:t}}y.fromString=o;function s(f,r){let t=f.id;const u=t.lastIndexOf("~");return u!==-1&&(t=t.substring(0,u)),r&&(t=`${t}~${r}`),{id:t}}y.modify=s;function v(f,r){return f.id===r.id&&f.color?.id===r.color?.id}y.isEqual=v;function n(f,r){return{id:f.id,color:r?k(r):void 0}}y.asThemeIcon=n,y.asClassNameArray=g.CSSIcon.asClassNameArray,y.asClassName=g.CSSIcon.asClassName,y.asCSSSelector=g.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=g.Codicon.file,e.FolderThemeIcon=g.Codicon.folder;function I(y){switch(y){case C.ColorScheme.DARK:return"vs-dark";case C.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class a{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(P){return this.themingParticipants.push(P),this.onThemingParticipantAddedEmitter.fire(P),(0,D.toDisposable)(()=>{const b=this.themingParticipants.indexOf(P);this.themingParticipants.splice(b,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new a;T.Registry.add(e.Extensions.ThemingContribution,p);function h(y){return p.onColorThemeChange(y)}e.registerThemingParticipant=h;class w extends D.Disposable{constructor(P){super();this.themeService=P,this.theme=P.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(b=>this.onThemeChange(b)))}onThemeChange(P){this.theme=P,this.updateStyles()}updateStyles(){}getColor(P,b){let o=this.theme.getColor(P);return o&&b&&(o=b(o,this.theme)),o?o.toString():null}}e.Themable=w}),define(fe[199],me([0,1,16,48,3,162,118,34,65]),function(Y,e,g,L,D,S,T,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class k{constructor(){this._onDidChange=new D.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,S.localize)(0,null)},fontCharacter:{type:"string",description:(0,S.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${L.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(P,b,o,s){const v=this.iconsById[P];if(v){if(o&&!v.description){v.description=o,this.iconSchema.properties[P].markdownDescription=`${o} $(${P})`;const r=this.iconReferenceSchema.enum.indexOf(P);r!==-1&&(this.iconReferenceSchema.enumDescriptions[r]=o),this._onDidChange.fire()}return v}let n={id:P,description:o,defaults:b,deprecationMessage:s};this.iconsById[P]=n;let f={$ref:"#/definitions/icons"};return s&&(f.deprecationMessage=s),o&&(f.markdownDescription=`${o}: $(${P})`),this.iconSchema.properties[P]=f,this.iconReferenceSchema.enum.push(P),this.iconReferenceSchema.enumDescriptions.push(o||""),this._onDidChange.fire(),{id:P}}deregisterIcon(P){delete this.iconsById[P],delete this.iconSchema.properties[P];const b=this.iconReferenceSchema.enum.indexOf(P);b!==-1&&(this.iconReferenceSchema.enum.splice(b,1),this.iconReferenceSchema.enumDescriptions.splice(b,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(P=>this.iconsById[P])}getIcon(P){return this.iconsById[P]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(P,b){const o=this.iconFontsById[P];if(o)return o;let s={id:P,definition:b};return this.iconFontsById[P]=s,this._onDidChange.fire(),s}deregisterIconFont(P){delete this.iconFontsById[P]}getIconFonts(){return Object.keys(this.iconFontsById).map(P=>this.iconFontsById[P])}getIconFont(P){return this.iconFontsById[P]}toString(){const P=(v,n)=>v.id.localeCompare(n.id),b=v=>{for(;E.ThemeIcon.isThemeIcon(v.defaults);)v=this.iconsById[v.defaults.id];return`codicon codicon-${v?v.id:""}`};let o=[];o.push("| preview     | identifier                        | default codicon ID                | description"),o.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.iconsById).map(v=>this.iconsById[v]);for(const v of s.filter(n=>!!n.description).sort(P))o.push(`|<i class="${b(v)}"></i>|${v.id}|${E.ThemeIcon.isThemeIcon(v.defaults)?v.defaults.id:v.id}|${v.description||""}|`);o.push("| preview     | identifier                        "),o.push("| ----------- | --------------------------------- |");for(const v of s.filter(n=>!E.ThemeIcon.isThemeIcon(n.defaults)).sort(P))o.push(`|<i class="${b(v)}"></i>|${v.id}|`);return o.join(`
`)}}const i=new k;C.Registry.add(e.Extensions.IconContribution,i);function I(y,P,b,o){return i.registerIcon(y,P,b,o)}e.registerIcon=I;function a(){return i}e.getIconRegistry=a;function p(){for(const y of L.iconRegistry.all)i.registerIcon(y.id,y.definition,y.description);L.iconRegistry.onDidRegister(y=>i.registerIcon(y.id,y.definition,y.description))}p(),e.iconsSchemaId="vscode://schemas/icons";let h=C.Registry.as(T.Extensions.JSONContribution);h.registerSchema(e.iconsSchemaId,i.getIconSchema());const w=new g.RunOnceScheduler(()=>h.notifySchemaChanged(e.iconsSchemaId),200);i.onDidChange(()=>{w.isScheduled()||w.schedule()}),e.widgetClose=I("widget-close",L.Codicon.close,(0,S.localize)(2,null)),e.gotoPreviousLocation=I("goto-previous-location",L.Codicon.arrowUp,(0,S.localize)(3,null)),e.gotoNextLocation=I("goto-next-location",L.Codicon.arrowDown,(0,S.localize)(4,null)),e.syncing=E.ThemeIcon.modify(L.Codicon.sync,"spin")}),define(fe[44],me([0,1,24,23,2,4]),function(Y,e,g,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,S.createDecorator)("contextService");var T;(function(a){a[a.EMPTY=1]="EMPTY",a[a.FOLDER=2]="FOLDER",a[a.WORKSPACE=3]="WORKSPACE"})(T=e.WorkbenchState||(e.WorkbenchState={}));function C(a){const p=a;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&Array.isArray(p.folders))}e.isWorkspace=C;function E(a){const p=a;return!!(p&&typeof p=="object"&&D.URI.isUri(p.uri)&&typeof p.name=="string"&&typeof p.toResource=="function")}e.isWorkspaceFolder=E;class k{constructor(p,h,w,y,P){this._id=p,this._transient=w,this._configuration=y,this._ignorePathCasing=P,this._foldersMap=g.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=h}update(p){this._id=p.id,this._configuration=p.configuration,this._transient=p.transient,this._ignorePathCasing=p._ignorePathCasing,this.folders=p.folders}get folders(){return this._folders}set folders(p){this._folders=p,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(p){this._configuration=p}getFolder(p){return p&&this._foldersMap.findSubstr(p.with({scheme:p.scheme,authority:p.authority,path:p.path}))||null}updateFoldersMap(){this._foldersMap=g.TernarySearchTree.forUris(this._ignorePathCasing);for(const p of this.folders)this._foldersMap.set(p.uri,p)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=k;class i{constructor(p,h){this.raw=h,this.uri=p.uri,this.index=p.index,this.name=p.name}toResource(p){return(0,L.joinPath)(this.uri,p)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function I(a){return new i({uri:a,index:0,name:(0,L.basenameOrAuthority)(a)},{uri:a.toString()})}e.toWorkspaceFolder=I}),define(fe[200],me([0,1,29,61,140,81,10,9,12,23,2,163,4,64,44]),function(Y,e,g,L,D,S,T,C,E,k,i,I,a,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const w=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function y(M){return(typeof M=="string"?(0,C.extname)(M):(0,k.extname)(M))===w}e.hasWorkspaceFileExtension=y,e.IWorkspacesService=(0,a.createDecorator)("workspacesService");function P(M){return M.hasOwnProperty("workspace")}e.isRecentWorkspace=P;function b(M){return M.hasOwnProperty("folderUri")}e.isRecentFolder=b;function o(M){return M.hasOwnProperty("fileUri")}e.isRecentFile=o;function s(M){const z=M;return typeof z?.id=="string"&&i.URI.isUri(z.uri)}e.isSingleFolderWorkspaceIdentifier=s;function v(M){if(M.configuration)return{id:M.id,configPath:M.configuration};if(M.folders.length===1)return{id:M.id,uri:M.folders[0].uri}}e.toWorkspaceIdentifier=v;function n(M){const z=M;return typeof z?.id=="string"&&i.URI.isUri(z.configPath)}e.isWorkspaceIdentifier=n;function f(M){const z=M;if(z?.uri)return{id:z.id,uri:i.URI.revive(z.uri)};const N=M;if(N?.configPath)return{id:N.id,configPath:i.URI.revive(N.configPath)};if(M?.id)return{id:M.id}}e.reviveIdentifier=f;function r(M,z){return k.extUriBiasedIgnorePathCase.isEqualOrParent(M,z.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function t(M){return u(M)||l(M)}e.isStoredWorkspaceFolder=t;function u(M){const z=M;return typeof z?.path=="string"&&(!z.name||typeof z.name=="string")}e.isRawFileWorkspaceFolder=u;function l(M){const z=M;return typeof z?.uri=="string"&&(!z.name||typeof z.name=="string")}e.isRawUriWorkspaceFolder=l;function c(M,z,N,x,j=!E.isWindows,O){if(M.scheme!==x.scheme)return{name:N,uri:M.toString(!0)};let H=z?void 0:O.relativePath(x,M);if(H!==void 0)H.length===0?H=".":E.isWindows&&M.scheme===T.Schemas.file&&!j&&(H=H.replace(/\//g,"\\"));else if(M.scheme===T.Schemas.file)H=M.fsPath,E.isWindows&&(H=(0,S.normalizeDriveLetter)(H),j&&(H=(0,g.toSlashes)(H)));else{if(!O.isEqualAuthority(M.authority,x.authority))return{name:N,uri:M.toString(!0)};H=M.path}return{name:N,path:H}}e.getStoredWorkspaceFolder=c;function m(M,z,N){let x=[],j=new Set;const O=N.dirname(z);for(let H of M){let W;if(u(H))H.path&&(W=N.resolvePath(O,H.path));else if(l(H))try{W=i.URI.parse(H.uri),W.path[0]!=="/"&&(W=W.with({path:"/"+W.path}))}catch(X){console.warn(X)}if(W){let X=N.getComparisonKey(W);if(!j.has(X)){j.add(X);const Q=H.name||N.basenameOrAuthority(W);x.push(new h.WorkspaceFolder({uri:W,name:Q,index:x.length},H))}}}return x}e.toWorkspaceFolders=m;function d(M,z,N,x,j){let O=_(z,M);const H=j.dirname(z),W=j.dirname(x),X=[],Q=A(O.folders);for(const Pe of O.folders){const Be=u(Pe)?j.resolvePath(H,Pe.path):i.URI.parse(Pe.uri);let We;N?We=!1:We=!u(Pe)||(0,C.isAbsolute)(Pe.path),X.push(c(Be,We,Pe.name,W,Q,j))}const de={insertSpaces:!1,tabSize:4,eol:E.isLinux||E.isMacintosh?`
`:`\r
`},_e=D.setProperty(M,["folders"],X,de);let Ce=D.applyEdits(M,_e);return(0,k.isEqualAuthority)(O.remoteAuthority,(0,p.getRemoteAuthority)(x))&&(Ce=D.applyEdits(Ce,D.removeProperty(Ce,["remoteAuthority"],de))),Ce}e.rewriteWorkspaceFileForNewLocation=d;function _(M,z){let N=L.parse(z);if(N&&Array.isArray(N.folders))N.folders=N.folders.filter(x=>t(x));else throw new Error(`${M} looks like an invalid workspace file.`);return N}function A(M){return E.isWindows?M.some(z=>u(z)&&z.path.indexOf("/")>=0):!0}e.useSlashForPath=A;function R(M){return M.workspace&&typeof M.workspace=="object"&&typeof M.workspace.id=="string"&&typeof M.workspace.configPath=="string"}function B(M){return typeof M.folderUri=="string"}function U(M){return typeof M.fileUri=="string"}function F(M,z){const N={workspaces:[],files:[]};if(M){const x=function(O,H){for(let W=0;W<O.length;W++)try{H(O[W],W)}catch(X){z.warn(`Error restoring recent entry ${JSON.stringify(O[W])}: ${X.toString()}. Skip entry.`)}},j=M;if(Array.isArray(j.entries))x(j.entries,O=>{const H=O.label,W=O.remoteAuthority;R(O)?N.workspaces.push({label:H,remoteAuthority:W,workspace:{id:O.workspace.id,configPath:i.URI.parse(O.workspace.configPath)}}):B(O)?N.workspaces.push({label:H,remoteAuthority:W,folderUri:i.URI.parse(O.folderUri)}):U(O)&&N.files.push({label:H,remoteAuthority:W,fileUri:i.URI.parse(O.fileUri)})});else{const O=M;Array.isArray(O.workspaces3)&&x(O.workspaces3,(H,W)=>{const X=Array.isArray(O.workspaceLabels)&&O.workspaceLabels[W]||void 0;typeof H=="object"&&typeof H.id=="string"&&typeof H.configURIPath=="string"?N.workspaces.push({label:X,workspace:{id:H.id,configPath:i.URI.parse(H.configURIPath)}}):typeof H=="string"&&N.workspaces.push({label:X,folderUri:i.URI.parse(H)})}),Array.isArray(O.files2)&&x(O.files2,(H,W)=>{const X=Array.isArray(O.fileLabels)&&O.fileLabels[W]||void 0;typeof H=="string"&&N.files.push({label:X,fileUri:i.URI.parse(H)})})}}return N}e.restoreRecentlyOpened=F;function $(M){const z={entries:[]};for(const N of M.workspaces)b(N)?z.entries.push({folderUri:N.folderUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority}):z.entries.push({workspace:{id:N.workspace.id,configPath:N.workspace.configPath.toString()},label:N.label,remoteAuthority:N.remoteAuthority});for(const N of M.files)z.entries.push({fileUri:N.fileUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority});return z}e.toStoreData=$}),define(fe[88],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class g{constructor(D){this.id=D,this._data=new Map,this._idPool=1}add(D){const S=this._idPool++;return this._data.set(S,D),this.logDebugInfo(),S}get(D,S){return this._data.has(D)?this._data.get(D)[S]:void 0}delete(D){this._data.delete(D),this.logDebugInfo()}logDebugInfo(){!g.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=g,g.enableDebugLogging=!1}),define(fe[45],me([0,1,10,23,4]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class S{constructor(){this._systemSchemes=new Set(Object.keys(g.Schemas)),this._providerInfo=new Map,this.extUri=new L.ExtUri(C=>{const E=this._providerInfo.get(C.scheme);return!(E===void 0||E&1024)})}$acceptProviderInfos(C,E){E===null?this._providerInfo.delete(C):this._providerInfo.set(C,E)}isFreeScheme(C){return!this._providerInfo.has(C)&&!this._systemSchemes.has(C)}getCapabilities(C){return this._providerInfo.get(C)}}e.ExtHostFileSystemInfo=S,e.IExtHostFileSystemInfo=(0,D.createDecorator)("IExtHostFileSystemInfo")}),define(fe[26],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,g.createDecorator)("IExtHostInitDataService")}),define(fe[201],me([0,1,11,26]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let D=class extends g.LogService{constructor(T,C){super(T.createLogger(C.logFile))}};D=Ve([$e(0,g.ILoggerService),$e(1,L.IExtHostInitDataService)],D),e.ExtHostLogService=D}),define(fe[202],me([0,1,16]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class L{constructor(T,C,E){this._deferredPromises=new Map,this._id=T,this._shared=C,this._storage=E,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(k=>(this._value=k,this)),this._storageListener=this._storage.onDidChangeStorage(k=>{k.shared===this._shared&&k.key===this._id&&(this._value=k.value)}),this._scheduler=new g.RunOnceScheduler(()=>{const k=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const i of k.values())i.complete()}catch(i){for(const I of k.values())I.error(i)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,T])=>T!==void 0).map(([T])=>T)}get whenReady(){return this._init}get(T,C){let E=this._value[T];return typeof E=="undefined"&&(E=C),E}update(T,C){this._value[T]=C;let E=this._deferredPromises.get(T);if(E!==void 0)return E.p;const k=new g.DeferredPromise;return this._deferredPromises.set(T,k),this._scheduler.isScheduled()||this._scheduler.schedule(),k.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=L;class D extends L{constructor(T,C){super(T.identifier.value,!0,C);this._extension=T}setKeysForSync(T){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},T)}}e.ExtensionGlobalMemento=D}),define(fe[203],me([0,1,3,2,11]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let S=class{constructor(C,E){this._logService=C,this._notebooksAndEditors=E,this._onDidChangeNotebookDocumentMetadata=new g.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new g.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(C,E,k){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(C)).acceptModelChanged(E.value,k)}$acceptDirtyStateChanged(C,E){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(C)).acceptDirty(E)}$acceptModelSaved(C){const E=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(C));this._onDidSaveNotebookDocument.fire(E.apiNotebook)}$acceptDocumentPropertiesChanged(C,E){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",C.path,E);const k=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(C));k.acceptDocumentPropertiesChanged(E),E.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:k.apiNotebook})}};S=Ve([$e(0,D.ILogService)],S),e.ExtHostNotebookDocuments=S}),define(fe[14],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,g.createDecorator)("IExtHostRpcService");class L{constructor(S){this.getProxy=S.getProxy.bind(S),this.set=S.set.bind(S),this.assertRegistered=S.assertRegistered.bind(S),this.drain=S.drain.bind(S)}}e.ExtHostRpcService=L});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,g):D?D.value=g:e.set(Y,g),g},Oe=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[204],me([0,1,27,3]),function(Y,e,g,L){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class S{constructor(C,E){D.set(this,void 0),this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._id=g.ExtensionIdentifier.toKey(C.identifier),st(this,D,E,"f"),Oe(this,D,"f").onDidChangePassword(k=>{k.extensionId===this._id&&this._onDidChange.fire({key:k.key})})}get(C){return Oe(this,D,"f").get(this._id,C)}store(C,E){return Oe(this,D,"f").store(this._id,C,E)}delete(C){return Oe(this,D,"f").delete(this._id,C)}}e.ExtensionSecrets=S,D=new WeakMap}),define(fe[122],me([0,1,4,3]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class D{constructor(){this._onDidChangeTelemetryEnabled=new L.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(T){this._enabled=T}$onDidChangeTelemetryEnabled(T){this._enabled=T,this._onDidChangeTelemetryEnabled.fire(T)}}e.ExtHostTelemetry=D,e.IExtHostTelemetry=(0,g.createDecorator)("IExtHostTelemetry")}),define(fe[66],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var g;(function(b){b[b.Upsert=0]="Upsert",b[b.RemoveChild=1]="RemoveChild",b[b.Invalidated=2]="Invalidated",b[b.SetProp=3]="SetProp",b[b.Bulk=4]="Bulk"})(g=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const L=new WeakMap,D=(b,o)=>{const s={controllerId:o};return L.set(b,s),s};e.createPrivateApiFor=D;const S=b=>L.get(b);e.getPrivateApiFor=S;const T=(b,o,s,v)=>{let n=s;return{enumerable:!0,configurable:!1,get(){return n},set(f){if(!v(n,f)){const r=n;n=f,b.listener?.({op:3,key:o,value:f,previous:r})}}}},C=(b,o)=>b===o,E={range:(b,o)=>b===o?!0:!b||!o?!1:b.isEqual(o),label:C,description:C,busy:C,error:C,canResolveChildren:C,tags:(b,o)=>!(b.length!==o.length||b.some(s=>!o.find(v=>s.id===v.id)))},k=Object.keys(E),i=(b,o)=>({range:T(b,"range",void 0,E.range),label:T(b,"label",o,E.label),description:T(b,"description",void 0,E.description),canResolveChildren:T(b,"canResolveChildren",!1,E.canResolveChildren),busy:T(b,"busy",!1,E.busy),error:T(b,"error",void 0,E.error),tags:T(b,"tags",[],E.tags)}),I=(b,o)=>{const s=new Map;for(const v of k)E[v](b[v],o[v])||s.set(v,o[v]);return s};e.diffTestItems=I;class a extends Error{constructor(o){super(`Attempted to insert a duplicate test item ID ${o}`)}}e.DuplicateTestItemError=a;class p extends Error{constructor(o){super(`TestItem with ID "${o}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=p;class h extends Error{constructor(o,s,v){super(`TestItem with ID "${o}" is from controller "${s}" and cannot be added as a child of an item from controller "${v}".`)}}e.MixedTestItemController=h;const w=b=>{const o=(0,e.getPrivateApiFor)(b);let s=new Map;return{get size(){return s.size},forEach(v,n){for(const f of s.values())v.call(n,f,this)},replace(v){const n=new Map,f=new Set(s.keys()),r={op:4,ops:[]};for(const t of v){if(!(t instanceof y))throw new p(t.id);const u=(0,e.getPrivateApiFor)(t).controllerId;if(u!==o.controllerId)throw new h(t.id,u,o.controllerId);if(n.has(t.id))throw new a(t.id);n.set(t.id,t),f.delete(t.id),r.ops.push({op:0,item:t})}for(const t of f.keys())r.ops.push({op:1,id:t});o.listener?.(r),s=n},add(v){if(!(v instanceof y))throw new p(v.id);s.set(v.id,v),o.listener?.({op:0,item:v})},delete(v){s.delete(v)&&o.listener?.({op:1,id:v})},get(v){return s.get(v)},toJSON(){return Array.from(s.values())},[Symbol.iterator](){return s.values()}}};class y{constructor(o,s,v,n){if(s.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(s)} symbol`);const f=(0,e.createPrivateApiFor)(this,o);Object.defineProperties(this,{id:{value:s,enumerable:!0,writable:!1},uri:{value:n,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return f.parent instanceof P?void 0:f.parent}},children:{value:w(this),enumerable:!0,writable:!1},...i(f,v)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=y;class P extends y{constructor(o,s){super(o,o,s,void 0)}}e.TestItemRootImpl=P}),define(fe[54],me([0,1,4,121,3,14]),function(Y,e,g,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var T;(function(E){function k(I){return{remoteAddress:I.remoteAddress,localAddress:I.localAddress,public:!!I.public,privacy:I.privacy??(I.public?L.TunnelPrivacyId.Public:L.TunnelPrivacyId.Private),protocol:I.protocol}}E.fromApiTunnel=k;function i(I){return{remoteAddress:{host:I.tunnelRemoteHost,port:I.tunnelRemotePort},localAddress:I.localAddress,public:I.privacy!==L.TunnelPrivacyId.ConstantPrivate&&I.privacy!==L.TunnelPrivacyId.ConstantPrivate,privacy:I.privacy,protocol:I.protocol}}E.fromServiceTunnel=i})(T=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,g.createDecorator)("IExtHostTunnelService");let C=class{constructor(k){this.onDidChangeTunnels=new D.Emitter().event}async $applyCandidateFilter(k){return k}async openTunnel(k,i){}async getTunnels(){return[]}async setTunnelExtensionFunctions(k){return{dispose:()=>{}}}registerPortsAttributesProvider(k,i){return{dispose:()=>{}}}async $providePortAttributes(k,i,I,a,p){return[]}async $forwardPort(k,i){}async $closeTunnel(k){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};C=Ve([$e(0,S.IExtHostRpcService)],C),e.ExtHostTunnelService=C});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,g):D?D.value=g:e.set(Y,g),g},Oe=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[7],me([0,1,15,18,98,24,102,8,13,2,31,43,120]),function(Y,e,g,L,D,S,T,C,E,k,i,I,a){"use strict";var p,h,w,y,P,b,o,s,v,n,f,r,t,u,l,c,m,d,_,A;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function R(q){function V(){return Reflect.construct(q,arguments,this.constructor)}return Object.defineProperty(V,"name",Object.getOwnPropertyDescriptor(q,"name")),Object.setPrototypeOf(V,q),Object.setPrototypeOf(V.prototype,q.prototype),V}let B=P=class{constructor(V){p.set(this,void 0),st(this,p,V,"f")}static from(...V){let oe=V;return new P(function(){if(oe){for(const ke of oe)ke&&typeof ke.dispose=="function"&&ke.dispose();oe=void 0}})}dispose(){typeof Oe(this,p,"f")=="function"&&(Oe(this,p,"f").call(this),st(this,p,void 0,"f"))}};p=new WeakMap,B=P=Ve([R],B),e.Disposable=B;let U=b=class{constructor(V,oe){if(V<0)throw(0,L.illegalArgument)("line must be non-negative");if(oe<0)throw(0,L.illegalArgument)("character must be non-negative");this._line=V,this._character=oe}static Min(...V){if(V.length===0)throw new TypeError;let oe=V[0];for(let ke=1;ke<V.length;ke++){const Je=V[ke];Je.isBefore(oe)&&(oe=Je)}return oe}static Max(...V){if(V.length===0)throw new TypeError;let oe=V[0];for(let ke=1;ke<V.length;ke++){const Je=V[ke];Je.isAfter(oe)&&(oe=Je)}return oe}static isPosition(V){if(!V)return!1;if(V instanceof b)return!0;let{line:oe,character:ke}=V;return typeof oe=="number"&&typeof ke=="number"}get line(){return this._line}get character(){return this._character}isBefore(V){return this._line<V._line?!0:V._line<this._line?!1:this._character<V._character}isBeforeOrEqual(V){return this._line<V._line?!0:V._line<this._line?!1:this._character<=V._character}isAfter(V){return!this.isBeforeOrEqual(V)}isAfterOrEqual(V){return!this.isBefore(V)}isEqual(V){return this._line===V._line&&this._character===V._character}compareTo(V){return this._line<V._line?-1:this._line>V.line?1:this._character<V._character?-1:this._character>V._character?1:0}translate(V,oe=0){if(V===null||oe===null)throw(0,L.illegalArgument)();let ke;return typeof V=="undefined"?ke=0:typeof V=="number"?ke=V:(ke=typeof V.lineDelta=="number"?V.lineDelta:0,oe=typeof V.characterDelta=="number"?V.characterDelta:0),ke===0&&oe===0?this:new b(this.line+ke,this.character+oe)}with(V,oe=this.character){if(V===null||oe===null)throw(0,L.illegalArgument)();let ke;return typeof V=="undefined"?ke=this.line:typeof V=="number"?ke=V:(ke=typeof V.line=="number"?V.line:this.line,oe=typeof V.character=="number"?V.character:this.character),ke===this.line&&oe===this.character?this:new b(ke,oe)}toJSON(){return{line:this.line,character:this.character}}};U=b=Ve([R],U),e.Position=U;let F=o=class{constructor(V,oe,ke,Je){let ot,ht;if(typeof V=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Je=="number"?(ot=new U(V,oe),ht=new U(ke,Je)):V instanceof U&&oe instanceof U&&(ot=V,ht=oe),!ot||!ht)throw new Error("Invalid arguments");ot.isBefore(ht)?(this._start=ot,this._end=ht):(this._start=ht,this._end=ot)}static isRange(V){return V instanceof o?!0:V?U.isPosition(V.start)&&U.isPosition(V.end):!1}get start(){return this._start}get end(){return this._end}contains(V){return V instanceof o?this.contains(V._start)&&this.contains(V._end):V instanceof U?!(V.isBefore(this._start)||this._end.isBefore(V)):!1}isEqual(V){return this._start.isEqual(V._start)&&this._end.isEqual(V._end)}intersection(V){const oe=U.Max(V.start,this._start),ke=U.Min(V.end,this._end);if(!oe.isAfter(ke))return new o(oe,ke)}union(V){if(this.contains(V))return this;if(V.contains(this))return V;const oe=U.Min(V.start,this._start),ke=U.Max(V.end,this.end);return new o(oe,ke)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(V,oe=this.end){if(V===null||oe===null)throw(0,L.illegalArgument)();let ke;return V?U.isPosition(V)?ke=V:(ke=V.start||this.start,oe=V.end||this.end):ke=this.start,ke.isEqual(this._start)&&oe.isEqual(this.end)?this:new o(ke,oe)}toJSON(){return[this.start,this.end]}};F=o=Ve([R],F),e.Range=F;let $=s=class extends F{constructor(V,oe,ke,Je){let ot,ht;if(typeof V=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Je=="number"?(ot=new U(V,oe),ht=new U(ke,Je)):V instanceof U&&oe instanceof U&&(ot=V,ht=oe),!ot||!ht)throw new Error("Invalid arguments");super(ot,ht);this._anchor=ot,this._active=ht}static isSelection(V){return V instanceof s?!0:V?F.isRange(V)&&U.isPosition(V.anchor)&&U.isPosition(V.active)&&typeof V.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};$=s=Ve([R],$),e.Selection=$;class M{constructor(V,oe,ke){if(typeof V!="string"||V.length===0)throw(0,L.illegalArgument)("host");if(typeof oe!="number"||oe===0||Math.round(oe)!==oe)throw(0,L.illegalArgument)("port");if(typeof ke!="undefined"&&(typeof ke!="string"||ke.length===0||!/^[0-9A-Za-z\-]+$/.test(ke)))throw(0,L.illegalArgument)("connectionToken");this.host=V,this.port=Math.round(oe),this.connectionToken=ke}}e.ResolvedAuthority=M;class z extends Error{constructor(V,oe=a.RemoteAuthorityResolverErrorCode.Unknown,ke){super(V);this._message=V,this._code=oe,this._detail=ke,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,z.prototype)}static NotAvailable(V,oe){return new z(V,a.RemoteAuthorityResolverErrorCode.NotAvailable,oe)}static TemporarilyNotAvailable(V){return new z(V,a.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=z;var N;(function(q){q[q.LF=1]="LF",q[q.CRLF=2]="CRLF"})(N=e.EndOfLine||(e.EndOfLine={}));var x;(function(q){q[q.Replace=1]="Replace",q[q.Append=2]="Append",q[q.Prepend=3]="Prepend"})(x=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let j=v=class{constructor(V,oe){this._range=V,this._newText=oe}static isTextEdit(V){return V instanceof v?!0:V?F.isRange(V)&&typeof V.newText=="string":!1}static replace(V,oe){return new v(V,oe)}static insert(V,oe){return v.replace(new F(V,V),oe)}static delete(V){return v.replace(V,"")}static setEndOfLine(V){const oe=new v(new F(new U(0,0),new U(0,0)),"");return oe.newEol=V,oe}get range(){return this._range}set range(V){if(V&&!F.isRange(V))throw(0,L.illegalArgument)("range");this._range=V}get newText(){return this._newText||""}set newText(V){if(V&&typeof V!="string")throw(0,L.illegalArgument)("newText");this._newText=V}get newEol(){return this._newEol}set newEol(V){if(V&&typeof V!="number")throw(0,L.illegalArgument)("newEol");this._newEol=V}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};j=v=Ve([R],j),e.TextEdit=j;var O;(function(q){q[q.File=1]="File",q[q.Text=2]="Text",q[q.Cell=3]="Cell",q[q.CellReplace=5]="CellReplace"})(O=e.FileEditType||(e.FileEditType={}));let H=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(V,oe,ke,Je){this._edits.push({_type:1,from:V,to:oe,options:ke,metadata:Je})}createFile(V,oe,ke){this._edits.push({_type:1,from:void 0,to:V,options:oe,metadata:ke})}deleteFile(V,oe,ke){this._edits.push({_type:1,from:V,to:void 0,options:oe,metadata:ke})}replaceNotebookMetadata(V,oe,ke){this._edits.push({_type:3,metadata:ke,uri:V,edit:{editType:5,metadata:oe},notebookMetadata:oe})}replaceNotebookCells(V,oe,ke,Je,ot){let ht,pt,It=[],Rt;if(Vt.isNotebookRange(oe)&&Mt.isNotebookCellDataArray(ke)&&!Mt.isNotebookCellDataArray(Je)?(ht=oe.start,pt=oe.end,It=ke,Rt=Je):typeof oe=="number"&&typeof ke=="number"&&Mt.isNotebookCellDataArray(Je)&&(ht=oe,pt=ke,It=Je,Rt=ot),ht===void 0||pt===void 0)throw new Error("Invalid arguments");(ht!==pt||It.length>0)&&this._edits.push({_type:5,uri:V,index:ht,count:pt-ht,cells:It,metadata:Rt})}replaceNotebookCellMetadata(V,oe,ke,Je){this._edits.push({_type:3,metadata:Je,uri:V,edit:{editType:8,index:oe,metadata:ke}})}replace(V,oe,ke,Je){this._edits.push({_type:2,uri:V,edit:new j(oe,ke),metadata:Je})}insert(V,oe,ke,Je){this.replace(V,new F(oe,oe),ke,Je)}delete(V,oe,ke){this.replace(V,oe,"",ke)}has(V){return this._edits.some(oe=>oe._type===2&&oe.uri.toString()===V.toString())}set(V,oe){if(oe)for(const ke of oe)ke&&this._edits.push({_type:2,uri:V,edit:ke});else{for(let ke=0;ke<this._edits.length;ke++){const Je=this._edits[ke];Je._type===2&&Je.uri.toString()===V.toString()&&(this._edits[ke]=void 0)}(0,g.coalesceInPlace)(this._edits)}}get(V){const oe=[];for(let ke of this._edits)ke._type===2&&ke.uri.toString()===V.toString()&&oe.push(ke.edit);return oe}entries(){const V=new S.ResourceMap;for(let oe of this._edits)if(oe._type===2){let ke=V.get(oe.uri);ke||(ke=[oe.uri,[]],V.set(oe.uri,ke)),ke[1].push(oe.edit)}return[...V.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};H=Ve([R],H),e.WorkspaceEdit=H;let W=n=class{constructor(V){this._tabstop=1,this.value=V||""}static isSnippetString(V){return V instanceof n?!0:V?typeof V.value=="string":!1}static _escape(V){return V.replace(/\$|}|\\/g,"\\$&")}appendText(V){return this.value+=n._escape(V),this}appendTabstop(V=this._tabstop++){return this.value+="$",this.value+=V,this}appendPlaceholder(V,oe=this._tabstop++){if(typeof V=="function"){const ke=new n;ke._tabstop=this._tabstop,V(ke),this._tabstop=ke._tabstop,V=ke.value}else V=n._escape(V);return this.value+="${",this.value+=oe,this.value+=":",this.value+=V,this.value+="}",this}appendChoice(V,oe=this._tabstop++){const ke=V.map(Je=>Je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=oe,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(V,oe){if(typeof oe=="function"){const ke=new n;ke._tabstop=this._tabstop,oe(ke),this._tabstop=ke._tabstop,oe=ke.value}else typeof oe=="string"&&(oe=oe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=V,oe&&(this.value+=":",this.value+=oe),this.value+="}",this}};W=n=Ve([R],W),e.SnippetString=W;var X;(function(q){q[q.Unnecessary=1]="Unnecessary",q[q.Deprecated=2]="Deprecated"})(X=e.DiagnosticTag||(e.DiagnosticTag={}));var Q;(function(q){q[q.Hint=3]="Hint",q[q.Information=2]="Information",q[q.Warning=1]="Warning",q[q.Error=0]="Error"})(Q=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let de=f=class{constructor(V,oe){if(this.uri=V,oe)if(oe instanceof F)this.range=oe;else if(oe instanceof U)this.range=new F(oe,oe);else throw new Error("Illegal argument")}static isLocation(V){return V instanceof f?!0:V?F.isRange(V.range)&&k.URI.isUri(V.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};de=f=Ve([R],de),e.Location=de;let _e=class{constructor(V,oe){this.location=V,this.message=oe}static is(V){return V?typeof V.message=="string"&&V.location&&F.isRange(V.location.range)&&k.URI.isUri(V.location.uri):!1}static isEqual(V,oe){return V===oe?!0:!V||!oe?!1:V.message===oe.message&&V.location.range.isEqual(oe.location.range)&&V.location.uri.toString()===oe.location.uri.toString()}};_e=Ve([R],_e),e.DiagnosticRelatedInformation=_e;let Ce=class{constructor(V,oe,ke=Q.Error){if(!F.isRange(V))throw new TypeError("range must be set");if(!oe)throw new TypeError("message must be set");this.range=V,this.message=oe,this.severity=ke}toJSON(){return{severity:Q[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(V,oe){return V===oe?!0:!V||!oe?!1:V.message===oe.message&&V.severity===oe.severity&&V.code===oe.code&&V.severity===oe.severity&&V.source===oe.source&&V.range.isEqual(oe.range)&&(0,g.equals)(V.tags,oe.tags)&&(0,g.equals)(V.relatedInformation,oe.relatedInformation,_e.isEqual)}};Ce=Ve([R],Ce),e.Diagnostic=Ce;let Pe=class{constructor(V,oe){if(!V)throw new Error("Illegal argument, contents must be defined");Array.isArray(V)?this.contents=V:this.contents=[V],this.range=oe}};Pe=Ve([R],Pe),e.Hover=Pe;var Be;(function(q){q[q.Text=0]="Text",q[q.Read=1]="Read",q[q.Write=2]="Write"})(Be=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let We=class{constructor(V,oe=Be.Text){this.range=V,this.kind=oe}toJSON(){return{range:this.range,kind:Be[this.kind]}}};We=Ve([R],We),e.DocumentHighlight=We;var He;(function(q){q[q.File=0]="File",q[q.Module=1]="Module",q[q.Namespace=2]="Namespace",q[q.Package=3]="Package",q[q.Class=4]="Class",q[q.Method=5]="Method",q[q.Property=6]="Property",q[q.Field=7]="Field",q[q.Constructor=8]="Constructor",q[q.Enum=9]="Enum",q[q.Interface=10]="Interface",q[q.Function=11]="Function",q[q.Variable=12]="Variable",q[q.Constant=13]="Constant",q[q.String=14]="String",q[q.Number=15]="Number",q[q.Boolean=16]="Boolean",q[q.Array=17]="Array",q[q.Object=18]="Object",q[q.Key=19]="Key",q[q.Null=20]="Null",q[q.EnumMember=21]="EnumMember",q[q.Struct=22]="Struct",q[q.Event=23]="Event",q[q.Operator=24]="Operator",q[q.TypeParameter=25]="TypeParameter"})(He=e.SymbolKind||(e.SymbolKind={}));var G;(function(q){q[q.Deprecated=1]="Deprecated"})(G=e.SymbolTag||(e.SymbolTag={}));let ee=r=class{constructor(V,oe,ke,Je,ot){this.name=V,this.kind=oe,this.containerName=ot,typeof ke=="string"&&(this.containerName=ke),Je instanceof de?this.location=Je:ke instanceof F&&(this.location=new de(Je,ke)),r.validate(this)}static validate(V){if(!V.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:He[this.kind],location:this.location,containerName:this.containerName}}};ee=r=Ve([R],ee),e.SymbolInformation=ee;let ie=t=class{constructor(V,oe,ke,Je,ot){this.name=V,this.detail=oe,this.kind=ke,this.range=Je,this.selectionRange=ot,this.children=[],t.validate(this)}static validate(V){if(!V.name)throw new Error("name must not be falsy");if(!V.range.contains(V.selectionRange))throw new Error("selectionRange must be contained in fullRange");V.children&&V.children.forEach(t.validate)}};ie=t=Ve([R],ie),e.DocumentSymbol=ie;var ce;(function(q){q[q.Invoke=1]="Invoke",q[q.Automatic=2]="Automatic"})(ce=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let Z=class{constructor(V,oe){this.title=V,this.kind=oe}};Z=Ve([R],Z),e.CodeAction=Z;let re=u=class{constructor(V){this.value=V}append(V){return new u(this.value?this.value+u.sep+V:V)}intersects(V){return this.contains(V)||V.contains(this)}contains(V){return this.value===V.value||V.value.startsWith(this.value+u.sep)}};re.sep=".",re=u=Ve([R],re),e.CodeActionKind=re,re.Empty=new re(""),re.QuickFix=re.Empty.append("quickfix"),re.Refactor=re.Empty.append("refactor"),re.RefactorExtract=re.Refactor.append("extract"),re.RefactorInline=re.Refactor.append("inline"),re.RefactorRewrite=re.Refactor.append("rewrite"),re.Source=re.Empty.append("source"),re.SourceOrganizeImports=re.Source.append("organizeImports"),re.SourceFixAll=re.Source.append("fixAll");let pe=class{constructor(V,oe){if(this.range=V,this.parent=oe,oe&&!oe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};pe=Ve([R],pe),e.SelectionRange=pe;class Me{constructor(V,oe,ke,Je,ot,ht){this.kind=V,this.name=oe,this.detail=ke,this.uri=Je,this.range=ot,this.selectionRange=ht}}e.CallHierarchyItem=Me;class je{constructor(V,oe){this.fromRanges=oe,this.from=V}}e.CallHierarchyIncomingCall=je;class Ke{constructor(V,oe){this.fromRanges=oe,this.to=V}}e.CallHierarchyOutgoingCall=Ke;var Ze;(function(q){q[q.Information=0]="Information",q[q.Warning=1]="Warning",q[q.Error=2]="Error"})(Ze=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let rt=class{constructor(V,oe){this.range=V,this.command=oe}get isResolved(){return!!this.command}};rt=Ve([R],rt),e.CodeLens=rt;let ct=l=class{constructor(V,oe=!1){h.set(this,void 0),st(this,h,new D.MarkdownString(V,{supportThemeIcons:oe}),"f")}static isMarkdownString(V){return V instanceof l?!0:V&&V.appendCodeblock&&V.appendMarkdown&&V.appendText&&V.value!==void 0}get value(){return Oe(this,h,"f").value}set value(V){Oe(this,h,"f").value=V}get isTrusted(){return Oe(this,h,"f").isTrusted}set isTrusted(V){Oe(this,h,"f").isTrusted=V}get supportThemeIcons(){return Oe(this,h,"f").supportThemeIcons}set supportThemeIcons(V){Oe(this,h,"f").supportThemeIcons=V}get supportHtml(){return Oe(this,h,"f").supportHtml}set supportHtml(V){Oe(this,h,"f").supportHtml=V}appendText(V){return Oe(this,h,"f").appendText(V),this}appendMarkdown(V){return Oe(this,h,"f").appendMarkdown(V),this}appendCodeblock(V,oe){return Oe(this,h,"f").appendCodeblock(oe??"",V),this}};h=new WeakMap,ct=l=Ve([R],ct),e.MarkdownString=ct;let ye=class{constructor(V,oe){this.label=V,this.documentation=oe}};ye=Ve([R],ye),e.ParameterInformation=ye;let at=class{constructor(V,oe){this.label=V,this.documentation=oe,this.parameters=[]}};at=Ve([R],at),e.SignatureInformation=at;let J=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};J=Ve([R],J),e.SignatureHelp=J;var ne;(function(q){q[q.Invoke=1]="Invoke",q[q.TriggerCharacter=2]="TriggerCharacter",q[q.ContentChange=3]="ContentChange"})(ne=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ee;(function(q){q[q.Other=0]="Other",q[q.Type=1]="Type",q[q.Parameter=2]="Parameter"})(Ee=e.InlayHintKind||(e.InlayHintKind={}));let Qe=class{constructor(V,oe,ke){this.text=V,this.position=oe,this.kind=ke}};Qe=Ve([R],Qe),e.InlayHint=Qe;var et;(function(q){q[q.Invoke=0]="Invoke",q[q.TriggerCharacter=1]="TriggerCharacter",q[q.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(et=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var le;(function(q){q[q.Text=0]="Text",q[q.Method=1]="Method",q[q.Function=2]="Function",q[q.Constructor=3]="Constructor",q[q.Field=4]="Field",q[q.Variable=5]="Variable",q[q.Class=6]="Class",q[q.Interface=7]="Interface",q[q.Module=8]="Module",q[q.Property=9]="Property",q[q.Unit=10]="Unit",q[q.Value=11]="Value",q[q.Enum=12]="Enum",q[q.Keyword=13]="Keyword",q[q.Snippet=14]="Snippet",q[q.Color=15]="Color",q[q.File=16]="File",q[q.Reference=17]="Reference",q[q.Folder=18]="Folder",q[q.EnumMember=19]="EnumMember",q[q.Constant=20]="Constant",q[q.Struct=21]="Struct",q[q.Event=22]="Event",q[q.Operator=23]="Operator",q[q.TypeParameter=24]="TypeParameter",q[q.User=25]="User",q[q.Issue=26]="Issue"})(le=e.CompletionItemKind||(e.CompletionItemKind={}));var Ie;(function(q){q[q.Deprecated=1]="Deprecated"})(Ie=e.CompletionItemTag||(e.CompletionItemTag={}));let Ne=class{constructor(V,oe){this.label=V,this.kind=oe}toJSON(){return{label:this.label,kind:this.kind&&le[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ne=Ve([R],Ne),e.CompletionItem=Ne;let Xe=class{constructor(V=[],oe=!1){this.items=V,this.isIncomplete=oe}};Xe=Ve([R],Xe),e.CompletionList=Xe;let nt=class{constructor(V,oe,ke){this.text=V,this.range=oe,this.command=ke}};nt=Ve([R],nt),e.InlineSuggestion=nt;let ft=class{constructor(V){this.items=V}};ft=Ve([R],ft),e.InlineSuggestions=ft;var tt;(function(q){q[q.Active=-1]="Active",q[q.Beside=-2]="Beside",q[q.One=1]="One",q[q.Two=2]="Two",q[q.Three=3]="Three",q[q.Four=4]="Four",q[q.Five=5]="Five",q[q.Six=6]="Six",q[q.Seven=7]="Seven",q[q.Eight=8]="Eight",q[q.Nine=9]="Nine"})(tt=e.ViewColumn||(e.ViewColumn={}));var ut;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(ut=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Re;(function(q){q[q.Off=0]="Off",q[q.On=1]="On",q[q.Relative=2]="Relative"})(Re=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var De;(function(q){q[q.Manual=1]="Manual",q[q.AfterDelay=2]="AfterDelay",q[q.FocusOut=3]="FocusOut"})(De=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Te;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(Te=e.TextEditorRevealType||(e.TextEditorRevealType={}));var se;(function(q){q[q.Keyboard=1]="Keyboard",q[q.Mouse=2]="Mouse",q[q.Command=3]="Command"})(se=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ue;(function(q){q[q.Undo=1]="Undo",q[q.Redo=2]="Redo"})(ue=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var we;(function(q){q[q.OpenOpen=0]="OpenOpen",q[q.ClosedClosed=1]="ClosedClosed",q[q.OpenClosed=2]="OpenClosed",q[q.ClosedOpen=3]="ClosedOpen"})(we=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(q){function V(oe){switch(oe){case"keyboard":return q.Keyboard;case"mouse":return q.Mouse;case"api":return q.Command}}q.fromValue=V}(se=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ve=class{constructor(V,oe){if(oe&&!k.URI.isUri(oe))throw(0,L.illegalArgument)("target");if(!F.isRange(V)||V.isEmpty)throw(0,L.illegalArgument)("range");this.range=V,this.target=oe}};ve=Ve([R],ve),e.DocumentLink=ve;let Fe=class{constructor(V,oe,ke,Je){this.red=V,this.green=oe,this.blue=ke,this.alpha=Je}};Fe=Ve([R],Fe),e.Color=Fe;let qe=class{constructor(V,oe){if(oe&&!(oe instanceof Fe))throw(0,L.illegalArgument)("color");if(!F.isRange(V)||V.isEmpty)throw(0,L.illegalArgument)("range");this.range=V,this.color=oe}};qe=Ve([R],qe),e.ColorInformation=qe;let ze=class{constructor(V){if(!V||typeof V!="string")throw(0,L.illegalArgument)("label");this.label=V}};ze=Ve([R],ze),e.ColorPresentation=ze;var Ye;(function(q){q[q.RGB=0]="RGB",q[q.HEX=1]="HEX",q[q.HSL=2]="HSL"})(Ye=e.ColorFormat||(e.ColorFormat={}));var lt;(function(q){q[q.Error=0]="Error",q[q.Warning=1]="Warning",q[q.Information=2]="Information"})(lt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class xe{constructor(V,oe,ke){if(this.startIndex=V,this.length=oe,this.tooltip=ke,typeof V!="number"||V<0)throw(0,L.illegalArgument)("startIndex");if(typeof oe!="number"||oe<1)throw(0,L.illegalArgument)("length");if(ke!==void 0&&typeof ke!="string")throw(0,L.illegalArgument)("tooltip")}}e.TerminalLink=xe;var ge;(function(q){q[q.Panel=1]="Panel",q[q.Editor=2]="Editor"})(ge=e.TerminalLocation||(e.TerminalLocation={}));class be{constructor(V){this.options=V,typeof V!="object"&&(0,L.illegalArgument)("options")}}e.TerminalProfile=be;var ae;(function(q){q[q.Always=1]="Always",q[q.Silent=2]="Silent",q[q.Never=3]="Never"})(ae=e.TaskRevealKind||(e.TaskRevealKind={}));var K;(function(q){q[q.Shared=1]="Shared",q[q.Dedicated=2]="Dedicated",q[q.New=3]="New"})(K=e.TaskPanelKind||(e.TaskPanelKind={}));let Se=c=class{constructor(V,oe){if(this.label=oe,typeof V!="string"||typeof oe!="string")throw(0,L.illegalArgument)("name");this._id=V}static from(V){switch(V){case"clean":return c.Clean;case"build":return c.Build;case"rebuild":return c.Rebuild;case"test":return c.Test;default:return}}get id(){return this._id}};Se.Clean=new c("clean","Clean"),Se.Build=new c("build","Build"),Se.Rebuild=new c("rebuild","Rebuild"),Se.Test=new c("test","Test"),Se=c=Ve([R],Se),e.TaskGroup=Se;function Le(q){let V="";for(let oe=0;oe<q.length;oe++)V+=q[oe].replace(/,/g,",,")+",";return V}let it=class{constructor(V,oe,ke){if(typeof V!="string")throw(0,L.illegalArgument)("process");this._args=[],this._process=V,oe!==void 0&&(Array.isArray(oe)?(this._args=oe,this._options=ke):this._options=oe)}get process(){return this._process}set process(V){if(typeof V!="string")throw(0,L.illegalArgument)("process");this._process=V}get args(){return this._args}set args(V){Array.isArray(V)||(V=[]),this._args=V}get options(){return this._options}set options(V){this._options=V}computeId(){const V=[];if(V.push("process"),this._process!==void 0&&V.push(this._process),this._args&&this._args.length>0)for(let oe of this._args)V.push(oe);return Le(V)}};it=Ve([R],it),e.ProcessExecution=it;let Ge=class{constructor(V,oe,ke){if(this._args=[],Array.isArray(oe)){if(!V)throw(0,L.illegalArgument)("command can't be undefined or null");if(typeof V!="string"&&typeof V.value!="string")throw(0,L.illegalArgument)("command");this._command=V,this._args=oe,this._options=ke}else{if(typeof V!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=V,this._options=oe}}get commandLine(){return this._commandLine}set commandLine(V){if(typeof V!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=V}get command(){return this._command?this._command:""}set command(V){if(typeof V!="string"&&typeof V.value!="string")throw(0,L.illegalArgument)("command");this._command=V}get args(){return this._args}set args(V){this._args=V||[]}get options(){return this._options}set options(V){this._options=V}computeId(){const V=[];if(V.push("shell"),this._commandLine!==void 0&&V.push(this._commandLine),this._command!==void 0&&V.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let oe of this._args)V.push(typeof oe=="string"?oe:oe.value);return Le(V)}};Ge=Ve([R],Ge),e.ShellExecution=Ge;var mt;(function(q){q[q.Escape=1]="Escape",q[q.Strong=2]="Strong",q[q.Weak=3]="Weak"})(mt=e.ShellQuoting||(e.ShellQuoting={}));var yt;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace"})(yt=e.TaskScope||(e.TaskScope={}));class Et{constructor(V){this._callback=V}computeId(){return"customExecution"+(0,i.generateUuid)()}set callback(V){this._callback=V}get callback(){return this._callback}}e.CustomExecution=Et;let gt=m=class{constructor(V,oe,ke,Je,ot,ht){this.__deprecated=!1,this._definition=this.definition=V;let pt;typeof oe=="string"?(this._name=this.name=oe,this._source=this.source=ke,this.execution=Je,pt=ot,this.__deprecated=!0):oe===yt.Global||oe===yt.Workspace?(this.target=oe,this._name=this.name=ke,this._source=this.source=Je,this.execution=ot,pt=ht):(this.target=oe,this._name=this.name=ke,this._source=this.source=Je,this.execution=ot,pt=ht),typeof pt=="string"?(this._problemMatchers=[pt],this._hasDefinedMatchers=!0):Array.isArray(pt)?(this._problemMatchers=pt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(V){this.__id=V}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof it?this._definition={type:m.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ge?this._definition={type:m.ShellType,id:this._execution.computeId()}:this._execution instanceof Et?this._definition={type:m.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:m.EmptyType,id:(0,i.generateUuid)()}}get definition(){return this._definition}set definition(V){if(V==null)throw(0,L.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=V}get scope(){return this._scope}set target(V){this.clear(),this._scope=V}get name(){return this._name}set name(V){if(typeof V!="string")throw(0,L.illegalArgument)("name");this.clear(),this._name=V}get execution(){return this._execution}set execution(V){V===null&&(V=void 0),this.clear(),this._execution=V;const oe=this._definition.type;(m.EmptyType===oe||m.ProcessType===oe||m.ShellType===oe||m.ExtensionCallbackType===oe)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(V){if(Array.isArray(V))this.clear(),this._problemMatchers=V,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(V){V!==!0&&V!==!1&&(V=!1),this.clear(),this._isBackground=V}get source(){return this._source}set source(V){if(typeof V!="string"||V.length===0)throw(0,L.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=V}get group(){return this._group}set group(V){V===null&&(V=void 0),this.clear(),this._group=V}get detail(){return this._detail}set detail(V){V===null&&(V=void 0),this._detail=V}get presentationOptions(){return this._presentationOptions}set presentationOptions(V){V==null&&(V=Object.create(null)),this.clear(),this._presentationOptions=V}get runOptions(){return this._runOptions}set runOptions(V){V==null&&(V=Object.create(null)),this.clear(),this._runOptions=V}};gt.ExtensionCallbackType="customExecution",gt.ProcessType="process",gt.ShellType="shell",gt.EmptyType="$empty",gt=m=Ve([R],gt),e.Task=gt;var bt;(function(q){q[q.SourceControl=1]="SourceControl",q[q.Window=10]="Window",q[q.Notification=15]="Notification"})(bt=e.ProgressLocation||(e.ProgressLocation={}));let vt=class{constructor(V,oe=Tt.None){this.collapsibleState=oe,k.URI.isUri(V)?this.resourceUri=V:this.label=V}};vt=Ve([R],vt),e.TreeItem=vt;var Tt;(function(q){q[q.None=0]="None",q[q.Collapsed=1]="Collapsed",q[q.Expanded=2]="Expanded"})(Tt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Dt=class{constructor(V,oe){this.id=V,this.color=oe}};Dt=Ve([R],Dt),e.ThemeIcon=Dt,Dt.File=new Dt("file"),Dt.Folder=new Dt("folder");let $t=class{constructor(V){this.id=V}};$t=Ve([R],$t),e.ThemeColor=$t;var jt;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace",q[q.WorkspaceFolder=3]="WorkspaceFolder"})(jt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let kt=class{constructor(V,oe){if(typeof V!="string"&&(!V||!k.URI.isUri(V)&&!k.URI.isUri(V.uri)))throw(0,L.illegalArgument)("base");if(typeof oe!="string")throw(0,L.illegalArgument)("pattern");typeof V=="string"?(this.baseFolder=k.URI.file(V),this.base=V):k.URI.isUri(V)?(this.baseFolder=V,this.base=V.fsPath):(this.baseFolder=V.uri,this.base=V.uri.fsPath),this.pattern=oe}};kt=Ve([R],kt),e.RelativePattern=kt;let Wt=class{constructor(V,oe,ke,Je){this.enabled=typeof V=="boolean"?V:!0,typeof oe=="string"&&(this.condition=oe),typeof ke=="string"&&(this.hitCondition=ke),typeof Je=="string"&&(this.logMessage=Je)}get id(){return this._id||(this._id=(0,i.generateUuid)()),this._id}};Wt=Ve([R],Wt),e.Breakpoint=Wt;let ii=class extends Wt{constructor(V,oe,ke,Je,ot){super(oe,ke,Je,ot);if(V===null)throw(0,L.illegalArgument)("location");this.location=V}};ii=Ve([R],ii),e.SourceBreakpoint=ii;let _t=class extends Wt{constructor(V,oe,ke,Je,ot){super(oe,ke,Je,ot);this.functionName=V}};_t=Ve([R],_t),e.FunctionBreakpoint=_t;let Xt=class extends Wt{constructor(V,oe,ke,Je,ot,ht,pt){super(Je,ot,ht,pt);if(!oe)throw(0,L.illegalArgument)("dataId");this.label=V,this.dataId=oe,this.canPersist=ke}};Xt=Ve([R],Xt),e.DataBreakpoint=Xt;let qt=class{constructor(V,oe,ke){this.command=V,this.args=oe||[],this.options=ke}};qt=Ve([R],qt),e.DebugAdapterExecutable=qt;let ni=class{constructor(V,oe){this.port=V,this.host=oe}};ni=Ve([R],ni),e.DebugAdapterServer=ni;let ri=class{constructor(V){this.path=V}};ri=Ve([R],ri),e.DebugAdapterNamedPipeServer=ri;let At=class{constructor(V){this.implementation=V}};At=Ve([R],At),e.DebugAdapterInlineImplementation=At;let Yt=class{constructor(V,oe){this.range=V,this.expression=oe}};Yt=Ve([R],Yt),e.EvaluatableExpression=Yt;var bi;(function(q){q[q.Automatic=0]="Automatic",q[q.Explicit=1]="Explicit"})(bi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Ht=class{constructor(V,oe){this.range=V,this.text=oe}};Ht=Ve([R],Ht),e.InlineValueText=Ht;let zt=class{constructor(V,oe,ke=!0){this.range=V,this.variableName=oe,this.caseSensitiveLookup=ke}};zt=Ve([R],zt),e.InlineValueVariableLookup=zt;let wt=class{constructor(V,oe){this.range=V,this.expression=oe}};wt=Ve([R],wt),e.InlineValueEvaluatableExpression=wt;let si=class{constructor(V,oe){this.frameId=V,this.stoppedLocation=oe}};si=Ve([R],si),e.InlineValueContext=si;var Nt;(function(q){q[q.Changed=1]="Changed",q[q.Created=2]="Created",q[q.Deleted=3]="Deleted"})(Nt=e.FileChangeType||(e.FileChangeType={}));let Ut=d=class extends Error{constructor(V,oe=I.FileSystemProviderErrorCode.Unknown,ke){super(k.URI.isUri(V)?V.toString(!0):V);this.code=ke?.name??"Unknown",(0,I.markAsFileSystemProviderError)(this,oe),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,d.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}static FileExists(V){return new d(V,I.FileSystemProviderErrorCode.FileExists,d.FileExists)}static FileNotFound(V){return new d(V,I.FileSystemProviderErrorCode.FileNotFound,d.FileNotFound)}static FileNotADirectory(V){return new d(V,I.FileSystemProviderErrorCode.FileNotADirectory,d.FileNotADirectory)}static FileIsADirectory(V){return new d(V,I.FileSystemProviderErrorCode.FileIsADirectory,d.FileIsADirectory)}static NoPermissions(V){return new d(V,I.FileSystemProviderErrorCode.NoPermissions,d.NoPermissions)}static Unavailable(V){return new d(V,I.FileSystemProviderErrorCode.Unavailable,d.Unavailable)}};Ut=d=Ve([R],Ut),e.FileSystemError=Ut;let Jt=class{constructor(V,oe,ke){this.start=V,this.end=oe,this.kind=ke}};Jt=Ve([R],Jt),e.FoldingRange=Jt;var Ei;(function(q){q[q.Comment=1]="Comment",q[q.Imports=2]="Imports",q[q.Region=3]="Region"})(Ei=e.FoldingRangeKind||(e.FoldingRangeKind={}));var fi;(function(q){q[q.Collapsed=0]="Collapsed",q[q.Expanded=1]="Expanded"})(fi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var _i;(function(q){q[q.Editing=0]="Editing",q[q.Preview=1]="Preview"})(_i=e.CommentMode||(e.CommentMode={}));class mi{constructor(V,oe=[]){this.tokenTypes=V,this.tokenModifiers=oe}}e.SemanticTokensLegend=mi;function Zt(q){return typeof q=="undefined"||(0,E.isStringArray)(q)}class oi{constructor(V){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,V){this._hasLegend=!0;for(let oe=0,ke=V.tokenTypes.length;oe<ke;oe++)this._tokenTypeStrToInt.set(V.tokenTypes[oe],oe);for(let oe=0,ke=V.tokenModifiers.length;oe<ke;oe++)this._tokenModifierStrToInt.set(V.tokenModifiers[oe],oe)}}push(V,oe,ke,Je,ot){if(typeof V=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Je=="number"&&(typeof ot=="number"||typeof ot=="undefined"))return typeof ot=="undefined"&&(ot=0),this._pushEncoded(V,oe,ke,Je,ot);if(F.isRange(V)&&typeof oe=="string"&&Zt(ke))return this._push(V,oe,ke);throw(0,L.illegalArgument)()}_push(V,oe,ke){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(V.start.line!==V.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(oe))throw new Error("`tokenType` is not in the provided legend");const Je=V.start.line,ot=V.start.character,ht=V.end.character-V.start.character,pt=this._tokenTypeStrToInt.get(oe);let It=0;if(ke)for(const Rt of ke){if(!this._tokenModifierStrToInt.has(Rt))throw new Error("`tokenModifier` is not in the provided legend");const Ft=this._tokenModifierStrToInt.get(Rt);It|=1<<Ft>>>0}this._pushEncoded(Je,ot,ht,pt,It)}_pushEncoded(V,oe,ke,Je,ot){if(this._dataIsSortedAndDeltaEncoded&&(V<this._prevLine||V===this._prevLine&&oe<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const It=this._data.length/5|0;let Rt=0,Ft=0;for(let Ot=0;Ot<It;Ot++){let xt=this._data[5*Ot],di=this._data[5*Ot+1];xt===0?(xt=Rt,di+=Ft):xt+=Rt,this._data[5*Ot]=xt,this._data[5*Ot+1]=di,Rt=xt,Ft=di}}let ht=V,pt=oe;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ht-=this._prevLine,ht===0&&(pt-=this._prevChar)),this._data[this._dataLen++]=ht,this._data[this._dataLen++]=pt,this._data[this._dataLen++]=ke,this._data[this._dataLen++]=Je,this._data[this._dataLen++]=ot,this._prevLine=V,this._prevChar=oe}static _sortAndDeltaEncode(V){let oe=[];const ke=V.length/5|0;for(let pt=0;pt<ke;pt++)oe[pt]=pt;oe.sort((pt,It)=>{const Rt=V[5*pt],Ft=V[5*It];if(Rt===Ft){const Ot=V[5*pt+1],xt=V[5*It+1];return Ot-xt}return Rt-Ft});const Je=new Uint32Array(V.length);let ot=0,ht=0;for(let pt=0;pt<ke;pt++){const It=5*oe[pt],Rt=V[It+0],Ft=V[It+1],Ot=V[It+2],xt=V[It+3],di=V[It+4],xi=Rt-ot,Gi=xi===0?Ft-ht:Ft,hi=5*pt;Je[hi+0]=xi,Je[hi+1]=Gi,Je[hi+2]=Ot,Je[hi+3]=xt,Je[hi+4]=di,ot=Rt,ht=Ft}return Je}build(V){return this._dataIsSortedAndDeltaEncoded?new Gt(new Uint32Array(this._data),V):new Gt(oi._sortAndDeltaEncode(this._data),V)}}e.SemanticTokensBuilder=oi;class Gt{constructor(V,oe){this.resultId=oe,this.data=V}}e.SemanticTokens=Gt;class ai{constructor(V,oe,ke){this.start=V,this.deleteCount=oe,this.data=ke}}e.SemanticTokensEdit=ai;class Si{constructor(V,oe){this.resultId=oe,this.edits=V}}e.SemanticTokensEdits=Si;var yi;(function(q){q[q.Separate=0]="Separate",q[q.MergeWithParent=1]="MergeWithParent"})(yi=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Kt;(function(q){q[q.Initial=1]="Initial",q[q.Dynamic=2]="Dynamic"})(Kt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let ei=class{constructor(){}};ei.Back={iconPath:new Dt("arrow-left")},ei=Ve([R],ei),e.QuickInputButtons=ei;var Di;(function(q){q[q.UI=1]="UI",q[q.Workspace=2]="Workspace"})(Di=e.ExtensionKind||(e.ExtensionKind={}));class Ci{constructor(V,oe,ke){this.badge=V,this.tooltip=oe,this.color=ke}static validate(V){if(V.badge){let oe=(0,C.nextCharLength)(V.badge,0);if(oe<V.badge.length&&(oe+=(0,C.nextCharLength)(V.badge,oe)),V.badge.length>oe)throw new Error("The 'badge'-property must be undefined or a short character")}if(!V.color&&!V.badge&&!V.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Ci;let li=class{constructor(V){this.kind=V}};li=Ve([R],li),e.ColorTheme=li;var ci;(function(q){q[q.Light=1]="Light",q[q.Dark=2]="Dark",q[q.HighContrast=3]="HighContrast"})(ci=e.ColorThemeKind||(e.ColorThemeKind={}));class Vt{constructor(V,oe){if(V<0)throw(0,L.illegalArgument)("start must be positive");if(oe<0)throw(0,L.illegalArgument)("end must be positive");V<=oe?(this._start=V,this._end=oe):(this._start=oe,this._end=V)}static isNotebookRange(V){return V instanceof Vt?!0:V?typeof V.start=="number"&&typeof V.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(V){let oe=this._start,ke=this._end;return V.start!==void 0&&(oe=V.start),V.end!==void 0&&(ke=V.end),oe===this._start&&ke===this._end?this:new Vt(oe,ke)}}e.NotebookRange=Vt;class Mt{constructor(V,oe,ke,Je,ot,ht,pt){this.kind=V,this.value=oe,this.languageId=ke,this.mime=Je,this.outputs=ot??[],this.metadata=ht,this.executionSummary=pt,Mt.validate(this)}static validate(V){if(typeof V.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof V.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof V.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(V){return Array.isArray(V)&&V.every(oe=>Mt.isNotebookCellData(oe))}static isNotebookCellData(V){return!0}}e.NotebookCellData=Mt;class Ue{constructor(V){this.cells=V}}e.NotebookData=Ue;class Lt{constructor(V,oe){this.data=V,this.mime=oe;const ke=(0,T.normalizeMimeType)(oe,!0);if(!ke)throw new Error(`INVALID mime type: ${oe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ke}static isNotebookCellOutputItem(V){return V instanceof Lt?!0:V?typeof V.mime=="string"&&V.data instanceof Uint8Array:!1}static error(V){const oe={name:V.name,message:V.message,stack:V.stack};return Lt.json(oe,"application/vnd.code.notebook.error")}static stdout(V){return Lt.text(V,"application/vnd.code.notebook.stdout")}static stderr(V){return Lt.text(V,"application/vnd.code.notebook.stderr")}static bytes(V,oe="application/octet-stream"){return new Lt(V,oe)}static text(V,oe=T.Mimes.text){const ke=Oe(Lt,w,"f",y).encode(String(V));return new Lt(ke,oe)}static json(V,oe="application/json"){const ke=JSON.stringify(V,void 0,"	");return Lt.text(ke,oe)}}e.NotebookCellOutputItem=Lt,w=Lt,y={value:new TextEncoder};class Qt{constructor(V,oe,ke){this.items=Qt.ensureUniqueMimeTypes(V,!0),typeof oe=="string"?(this.id=oe,this.metadata=ke):(this.id=(0,i.generateUuid)(),this.metadata=oe??ke)}static isNotebookCellOutput(V){return V instanceof Qt?!0:!V||typeof V!="object"?!1:typeof V.id=="string"&&(0,E.isArray)(V.items)}static ensureUniqueMimeTypes(V,oe=!1){const ke=new Set,Je=new Set;for(let ot=0;ot<V.length;ot++){const ht=V[ot],pt=(0,T.normalizeMimeType)(ht.mime);if(!ke.has(pt)){ke.add(pt);continue}Je.add(ot),oe&&console.warn(`DUPLICATED mime type '${ht.mime}' will be dropped`)}return Je.size===0?V:V.filter((ot,ht)=>!Je.has(ht))}}e.NotebookCellOutput=Qt;var St;(function(q){q[q.Markup=1]="Markup",q[q.Code=2]="Code"})(St=e.NotebookCellKind||(e.NotebookCellKind={}));var ki;(function(q){q[q.Idle=1]="Idle",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(ki=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ii;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(Ii=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var gi;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(gi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class pi{constructor(V,oe){this.text=V,this.alignment=oe}}e.NotebookCellStatusBarItem=pi;var Pi;(function(q){q[q.Default=1]="Default",q[q.Preferred=2]="Preferred"})(Pi=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Ti{constructor(V,oe=[]){this.uri=V,this.provides=(0,g.asArray)(oe)}}e.NotebookRendererScript=Ti;let ui=class{constructor(V,oe){this.label=V,this.timestamp=oe}};ui=Ve([R],ui),e.TimelineItem=ui;var Ai;(function(q){q[q.Production=1]="Production",q[q.Development=2]="Development",q[q.Test=3]="Test"})(Ai=e.ExtensionMode||(e.ExtensionMode={}));var vi;(function(q){q[q.Node=1]="Node",q[q.Webworker=2]="Webworker"})(vi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ri;(function(q){q[q.Other=0]="Other",q[q.Comment=1]="Comment",q[q.String=2]="String",q[q.RegEx=4]="RegEx"})(Ri=e.StandardTokenType||(e.StandardTokenType={}));class Li{constructor(V,oe){this.ranges=V,this.wordPattern=oe}}e.LinkedEditingRanges=Li;class Fi{constructor(V,oe){this._port=V,this._autoForwardAction=oe}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Fi;var Mi;(function(q){q[q.Queued=1]="Queued",q[q.Running=2]="Running",q[q.Passed=3]="Passed",q[q.Failed=4]="Failed",q[q.Skipped=5]="Skipped",q[q.Errored=6]="Errored"})(Mi=e.TestResultState||(e.TestResultState={}));var Oi;(function(q){q[q.Run=1]="Run",q[q.Debug=2]="Debug",q[q.Coverage=3]="Coverage"})(Oi=e.TestRunProfileKind||(e.TestRunProfileKind={}));let te=class{constructor(V=void 0,oe=void 0,ke=void 0){this.include=V,this.exclude=oe,this.profile=ke}};te=Ve([R],te),e.TestRunRequest=te;let he=_=class{constructor(V){this.message=V}static diff(V,oe,ke){const Je=new _(V);return Je.expectedOutput=oe,Je.actualOutput=ke,Je}};he=_=Ve([R],he),e.TestMessage=he;let Ae=class{constructor(V){this.id=V}};Ae=Ve([R],Ae),e.TestTag=Ae;let dt=class{constructor(V,oe){this.covered=V,this.total=oe}};dt=Ve([R],dt),e.CoveredCount=dt;let Ct=A=class{constructor(V,oe,ke,Je){this.uri=V,this.statementCoverage=oe,this.branchCoverage=ke,this.functionCoverage=Je}static fromDetails(V,oe){const ke=new dt(0,0),Je=new dt(0,0),ot=new dt(0,0);for(const pt of oe)if("branches"in pt){ke.total+=1,ke.covered+=pt.executionCount>0?1:0;for(const It of pt.branches)Je.total+=1,Je.covered+=It.executionCount>0?1:0}else ot.total+=1,ot.covered+=pt.executionCount>0?1:0;const ht=new A(V,ke,Je.total>0?Je:void 0,ot.total>0?ot:void 0);return ht.detailedCoverage=oe,ht}};Ct=A=Ve([R],Ct),e.FileCoverage=Ct;let Pt=class{constructor(V,oe,ke=[]){this.executionCount=V,this.location=oe,this.branches=ke}};Pt=Ve([R],Pt),e.StatementCoverage=Pt;let Ni=class{constructor(V,oe){this.executionCount=V,this.location=oe}};Ni=Ve([R],Ni),e.BranchCoverage=Ni;let Ui=class{constructor(V,oe){this.executionCount=V,this.location=oe}};Ui=Ve([R],Ui),e.FunctionCoverage=Ui;var zi;(function(q){q[q.None=0]="None",q[q.Option=1]="Option",q[q.Default=2]="Default",q[q.Preferred=3]="Preferred"})(zi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Vi;(function(q){q[q.Untrusted=0]="Untrusted",q[q.Trusted=1]="Trusted",q[q.Unspecified=2]="Unspecified"})(Vi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var ji;(function(q){q[q.Notify=1]="Notify",q[q.OpenBrowser=2]="OpenBrowser",q[q.OpenPreview=3]="OpenPreview",q[q.Silent=4]="Silent",q[q.Ignore=5]="Ignore",q[q.OpenBrowserOnce=6]="OpenBrowserOnce"})(ji=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class qi{constructor(V,oe,ke,Je,ot,ht){this.kind=V,this.name=oe,this.detail=ke,this.uri=Je,this.range=ot,this.selectionRange=ht}}e.TypeHierarchyItem=qi}),define(fe[123],me([0,1,58,10,8,150,110,7,15]),function(Y,e,g,L,D,S,T,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const k=new Map;function i(h,w){w?k.set(h,w):k.delete(h)}e.setWordDefinitionFor=i;function I(h){return k.get(h)}e.getWordDefinitionFor=I;class a extends S.MirrorTextModel{constructor(w,y,P,b,o,s,v,n){super(y,P,b,o);this._proxy=w,this._languageId=s,this._isDirty=v,this._notebook=n,this._isDisposed=!1}dispose(){(0,g.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(w){return(0,E.equals)(this._lines,w)}get document(){if(!this._document){const w=this;this._document={get uri(){return w._uri},get fileName(){return w._uri.fsPath},get isUntitled(){return w._uri.scheme===L.Schemas.untitled},get languageId(){return w._languageId},get version(){return w._versionId},get isClosed(){return w._isDisposed},get isDirty(){return w._isDirty},get notebook(){return w._notebook},save(){return w._save()},getText(y){return y?w._getTextInRange(y):w.getText()},get eol(){return w._eol===`
`?C.EndOfLine.LF:C.EndOfLine.CRLF},get lineCount(){return w._lines.length},lineAt(y){return w._lineAt(y)},offsetAt(y){return w._offsetAt(y)},positionAt(y){return w._positionAt(y)},validateRange(y){return w._validateRange(y)},validatePosition(y){return w._validatePosition(y)},getWordRangeAtPosition(y,P){return w._getWordRangeAtPosition(y,P)}}}return Object.freeze(this._document)}_acceptLanguageId(w){(0,g.ok)(!this._isDisposed),this._languageId=w}_acceptIsDirty(w){(0,g.ok)(!this._isDisposed),this._isDirty=w}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(w){const y=this._validateRange(w);if(y.isEmpty)return"";if(y.isSingleLine)return this._lines[y.start.line].substring(y.start.character,y.end.character);const P=this._eol,b=y.start.line,o=y.end.line,s=[];s.push(this._lines[b].substring(y.start.character));for(let v=b+1;v<o;v++)s.push(this._lines[v]);return s.push(this._lines[o].substring(0,y.end.character)),s.join(P)}_lineAt(w){let y;if(w instanceof C.Position?y=w.line:typeof w=="number"&&(y=w),typeof y!="number"||y<0||y>=this._lines.length||Math.floor(y)!==y)throw new Error("Illegal value for `line`");return new p(y,this._lines[y],y===this._lines.length-1)}_offsetAt(w){return w=this._validatePosition(w),this._ensureLineStarts(),this._lineStarts.getPrefixSum(w.line-1)+w.character}_positionAt(w){w=Math.floor(w),w=Math.max(0,w),this._ensureLineStarts();const y=this._lineStarts.getIndexOf(w),P=this._lines[y.index].length;return new C.Position(y.index,Math.min(y.remainder,P))}_validateRange(w){if(!(w instanceof C.Range))throw new Error("Invalid argument");const y=this._validatePosition(w.start),P=this._validatePosition(w.end);return y===w.start&&P===w.end?w:new C.Range(y.line,y.character,P.line,P.character)}_validatePosition(w){if(!(w instanceof C.Position))throw new Error("Invalid argument");if(this._lines.length===0)return w.with(0,0);let{line:y,character:P}=w,b=!1;if(y<0)y=0,P=0,b=!0;else if(y>=this._lines.length)y=this._lines.length-1,P=this._lines[y].length,b=!0;else{const o=this._lines[y].length;P<0?(P=0,b=!0):P>o&&(P=o,b=!0)}return b?new C.Position(y,P):w}_getWordRangeAtPosition(w,y){const P=this._validatePosition(w);if(!y)y=I(this._languageId);else if((0,D.regExpLeadsToEndlessLoop)(y))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${y.source}' because it matches the empty string.`);const b=(0,T.getWordAtText)(P.character+1,(0,T.ensureValidWordDefinition)(y),this._lines[P.line],0);if(b)return new C.Range(P.line,b.startColumn-1,P.line,b.endColumn-1)}}e.ExtHostDocumentData=a;class p{constructor(w,y,P){this._line=w,this._text=y,this._isLastLine=P}get lineNumber(){return this._line}get text(){return this._text}get range(){return new C.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new C.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=p}),define(fe[205],me([0,1,7,3,112,6,83,24,2,31]),function(Y,e,g,L,D,S,T,C,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class i{constructor(a,p,h,w){this._notebook=h,this._selector=w,this._disposables=new S.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this.uri=E.URI.from({scheme:"vscode-concat-doc",path:(0,k.generateUuid)()}),this._init(),this._disposables.add(p.onDidChangeDocument(P=>{const b=this._cellUris.get(P.document.uri);b!==void 0&&(this._cellLengths.setValue(b,this._cells[b].document.getText().length+1),this._cellLines.setValue(b,this._cells[b].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const y=P=>{P===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(a.onDidChangeNotebookCells(P=>y(P.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new C.ResourceMap;const a=[],p=[];for(const h of this._notebook.getCells())h.kind===g.NotebookCellKind.Code&&(!this._selector||(0,T.score)(this._selector,h.document.uri,h.document.languageId,!0))&&(this._cellUris.set(h.document.uri,this._cells.length),this._cells.push(h),a.push(h.document.getText().length+1),p.push(h.document.lineCount));this._cellLengths=new D.PrefixSumComputer(new Uint32Array(a)),this._cellLines=new D.PrefixSumComputer(new Uint32Array(p))}get version(){return this._versionId}getText(a){if(!a){let b="";for(const o of this._cells)b+=o.document.getText()+`
`;return b=b.slice(0,-1),b}if(a.isEmpty)return"";const p=this.locationAt(a.start),h=this.locationAt(a.end),w=this._cellUris.get(p.uri),y=this._cellUris.get(h.uri);if(w===void 0||y===void 0)return"";if(w===y)return this._cells[w].document.getText(new g.Range(p.range.start,h.range.end));const P=[this._cells[w].document.getText(new g.Range(p.range.start,new g.Position(this._cells[w].document.lineCount,0)))];for(let b=w+1;b<y;b++)P.push(this._cells[b].document.getText());return P.push(this._cells[y].document.getText(new g.Range(new g.Position(0,0),h.range.end))),P.join(`
`)}offsetAt(a){const p=this._cellLines.getIndexOf(a.line),h=this._cellLengths.getPrefixSum(p.index-1),w=this._cells[p.index].document.offsetAt(a.with(p.remainder));return h+w}positionAt(a){if(typeof a=="number"){const h=this._cellLengths.getIndexOf(a),w=this._cellLines.getPrefixSum(h.index-1);return this._cells[h.index].document.positionAt(h.remainder).translate(w)}const p=this._cellUris.get(a.uri);if(p!==void 0){const h=this._cellLines.getPrefixSum(p-1);return new g.Position(h+a.range.start.line,a.range.start.character)}return new g.Position(0,0)}locationAt(a){g.Range.isRange(a)||(a=new g.Range(a,a));const p=this._cellLines.getIndexOf(a.start.line);let h=p;a.isEmpty||(h=this._cellLines.getIndexOf(a.end.line));const w=new g.Position(p.remainder,a.start.character),y=new g.Position(h.remainder,a.end.character),P=new g.Range(w,y),b=this._cells[p.index];return new g.Location(b.document.uri,b.document.validateRange(P))}contains(a){return this._cellUris.has(a)}validateRange(a){const p=this.validatePosition(a.start),h=this.validatePosition(a.end);return a.with(p,h)}validatePosition(a){const p=this._cellLines.getIndexOf(a.line),h=new g.Position(p.remainder,a.character),w=this._cells[p.index].document.validatePosition(h),y=this._cellLines.getPrefixSum(p.index-1);return new g.Position(y+w.line,w.character)}}e.ExtHostNotebookConcatDocument=i}),define(fe[206],me([0,1,7,14,3]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let S=class{constructor(C){this._actual=new g.ColorTheme(g.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new D.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(C){let E=C==="light"?g.ColorThemeKind.Light:C==="dark"?g.ColorThemeKind.Dark:g.ColorThemeKind.HighContrast;this._actual=new g.ColorTheme(E),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};S=Ve([$e(0,L.IExtHostRpcService)],S),e.ExtHostTheming=S}),define(fe[67],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,g.createDecorator)("IURITransformerService");class L{constructor(S){S?(this.transformIncoming=S.transformIncoming.bind(S),this.transformOutgoing=S.transformOutgoing.bind(S),this.transformOutgoingURI=S.transformOutgoingURI.bind(S),this.transformOutgoingScheme=S.transformOutgoingScheme.bind(S)):(this.transformIncoming=T=>T,this.transformOutgoing=T=>T,this.transformOutgoingURI=T=>T,this.transformOutgoingScheme=T=>T)}}e.URITransformerService=L}),define(fe[207],me([0,1,22]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class L{constructor(){this.buffers=[]}add(E){let k=this.buffers.indexOf(E);return k<0&&(k=this.buffers.length,this.buffers.push(E)),k}}function D(C,E){if(E.serializeBuffersForPostMessage){const k=new L,i=(p,h)=>{if(h instanceof ArrayBuffer){const w=k.add(h);return{$$vscode_array_buffer_reference$$:!0,index:w}}else if(ArrayBuffer.isView(h)){const w=S(h);if(w){const y=k.add(h.buffer);return{$$vscode_array_buffer_reference$$:!0,index:y,view:{type:w,byteLength:h.byteLength,byteOffset:h.byteOffset}}}}return h},I=JSON.stringify(C,i),a=k.buffers.map(p=>{const h=new Uint8Array(p);return g.VSBuffer.wrap(h)});return{message:I,buffers:a}}else return{message:JSON.stringify(C),buffers:[]}}e.serializeWebviewMessage=D;function S(C){switch(C.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function T(C,E){const k=E.map(a=>{const p=new ArrayBuffer(a.byteLength);return new Uint8Array(p).set(a.buffer),p}),i=E.length?(a,p)=>{if(typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const h=p,{index:w}=h,y=k[w];if(h.view)switch(h.view.type){case 1:return new Int8Array(y,h.view.byteOffset,h.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(y,h.view.byteOffset,h.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(y,h.view.byteOffset,h.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(y,h.view.byteOffset,h.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(y,h.view.byteOffset,h.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(y,h.view.byteOffset,h.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(y,h.view.byteOffset,h.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(y,h.view.byteOffset,h.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(y,h.view.byteOffset,h.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(y,h.view.byteOffset,h.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(y,h.view.byteOffset,h.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return y}return p}:void 0;return{message:JSON.parse(C,i),arrayBuffers:k}}e.deserializeWebviewMessage=T}),define(fe[208],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var g;(function(L){function D(T){const C={items:new Map};return T.types.forEach((E,k)=>{C.items.set(E,{asString:async()=>T.items[k].asString})}),C}L.toITreeDataTransfer=D;async function S(T){const C={types:[],items:[]},E=Array.from(T.items.entries());for(const k of E)C.types.push(k[0]),C.items.push({asString:await k[1].asString()});return C}L.toTreeDataTransferDTO=S})(g=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(fe[89],me([0,1,10,2]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function D(C,E){return C.scheme===g.Schemas.http||C.scheme===g.Schemas.https?C:(E&&E.authority&&E.isRemote&&C.scheme===g.Schemas.file&&(C=L.URI.from({scheme:g.Schemas.vscodeRemote,authority:E.authority,path:C.path})),L.URI.from({scheme:g.Schemas.https,authority:`${C.scheme}+${S(C.authority)}.${e.webviewRootResourceAuthority}`,path:C.path,fragment:C.fragment,query:C.query}))}e.asWebviewUri=D;function S(C){return C.replace(/./g,E=>{const k=E.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?E:"-"+k.toString(16).padStart(4,"0")})}function T(C){return C.replace(/-([0-9a-f]{4})/g,(E,k)=>String.fromCharCode(parseInt(k,16)))}e.decodeAuthority=T}),define(fe[209],me([0,1,3,6,89]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class S{constructor(C,E,k){this._proxy=C,this._editors=E,this._initData=k,this._handlePool=0,this._disposables=new L.DisposableStore,this._insets=new Map,this._disposables.add(E.onDidChangeVisibleTextEditors(()=>{const i=E.getVisibleTextEditors();for(const I of this._insets.values())i.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(C=>C.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(C,E,k,i,I){let a;for(const o of this._editors.getVisibleTextEditors(!0))if(o.value===C){a=o;break}if(!a)throw new Error("not a visible editor");const p=this,h=this._handlePool++,w=new g.Emitter,y=new g.Emitter,P=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(o){return(0,D.asWebviewUri)(o,p._initData.remote)}get cspSource(){return D.webviewGenericCspSource}set options(o){this._options=o,p._proxy.$setOptions(h,o)}get options(){return this._options}set html(o){this._html=o,p._proxy.$setHtml(h,o)}get html(){return this._html}get onDidReceiveMessage(){return w.event}postMessage(o){return p._proxy.$postMessage(h,o)}},b=new class{constructor(){this.editor=C,this.line=E,this.height=k,this.webview=P,this.onDidDispose=y.event}dispose(){p._insets.has(h)&&(p._insets.delete(h),p._proxy.$disposeEditorInset(h),y.fire(),y.dispose(),w.dispose())}};return this._proxy.$createEditorInset(h,a.id,a.value.document.uri,E+1,k,i||{},I.identifier,I.extensionLocation),this._insets.set(h,{editor:C,inset:b,onDidReceiveMessage:w}),b}$onDidDispose(C){const E=this._insets.get(C);E&&E.inset.dispose()}$onDidReceiveMessage(C,E){const k=this._insets.get(C);k&&k.onDidReceiveMessage.fire(E)}}e.ExtHostEditorInsets=S}),define(fe[210],me([0,1,173,13,2,6,4,53,34,43,15,10]),function(Y,e,g,L,D,S,T,C,E,k,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,g.localize)(0,null),providerDisplayName:(0,g.localize)(1,null)},e.ActiveEditorDirtyContext=new C.RawContextKey("activeEditorIsDirty",!1,(0,g.localize)(2,null)),e.ActiveEditorPinnedContext=new C.RawContextKey("activeEditorIsNotPreview",!1,(0,g.localize)(3,null)),e.ActiveEditorStickyContext=new C.RawContextKey("activeEditorIsPinned",!1,(0,g.localize)(4,null)),e.ActiveEditorReadonlyContext=new C.RawContextKey("activeEditorIsReadonly",!1,(0,g.localize)(5,null)),e.ActiveEditorCanRevertContext=new C.RawContextKey("activeEditorCanRevert",!1,(0,g.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new C.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new C.RawContextKey("activeEditor",null,{type:"string",description:(0,g.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new C.RawContextKey("activeEditorAvailableEditorIds","",(0,g.localize)(8,null)),e.TextCompareEditorVisibleContext=new C.RawContextKey("textCompareEditorVisible",!1,(0,g.localize)(9,null)),e.TextCompareEditorActiveContext=new C.RawContextKey("textCompareEditorActive",!1,(0,g.localize)(10,null)),e.SideBySideEditorActiveContext=new C.RawContextKey("sideBySideEditorActive",!1,(0,g.localize)(11,null)),e.EditorGroupEditorsCountContext=new C.RawContextKey("groupEditorsCount",0,(0,g.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new C.RawContextKey("activeEditorGroupEmpty",!1,(0,g.localize)(13,null)),e.ActiveEditorGroupIndexContext=new C.RawContextKey("activeEditorGroupIndex",0,(0,g.localize)(14,null)),e.ActiveEditorGroupLastContext=new C.RawContextKey("activeEditorGroupLast",!1,(0,g.localize)(15,null)),e.ActiveEditorGroupLockedContext=new C.RawContextKey("activeEditorGroupLocked",!1,(0,g.localize)(16,null)),e.MultipleEditorGroupsContext=new C.RawContextKey("multipleEditorGroups",!1,(0,g.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new C.RawContextKey("editorIsOpen",!1,(0,g.localize)(18,null)),e.InEditorZenModeContext=new C.RawContextKey("inZenMode",!1,(0,g.localize)(19,null)),e.IsCenteredLayoutContext=new C.RawContextKey("isCenteredLayout",!1,(0,g.localize)(20,null)),e.SplitEditorsVertically=new C.RawContextKey("splitEditorsVertically",!1,(0,g.localize)(21,null)),e.EditorAreaVisibleContext=new C.RawContextKey("editorAreaVisible",!0,(0,g.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function a(U,F,$){for(const M of $.visibleEditorPanes)if(M.group.id===F&&U.matches(M.input))return M.getViewState()}e.findViewStateForEditor=a;function p(U){if(v(U))return!1;const F=U;return D.URI.isUri(F?.resource)}e.isResourceEditorInput=p;function h(U){if(v(U))return!1;const F=U;return F?.original!==void 0&&F.modified!==void 0}e.isResourceDiffEditorInput=h;function w(U){if(v(U)||h(U))return!1;const F=U;return F?.primary!==void 0&&F.secondary!==void 0}e.isResourceSideBySideEditorInput=w;function y(U){if(v(U))return!1;const F=U;return F?F.resource===void 0||F.resource.scheme===I.Schemas.untitled||F.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=y;var P;(function(U){U[U.SHORT=0]="SHORT",U[U.MEDIUM=1]="MEDIUM",U[U.LONG=2]="LONG"})(P=e.Verbosity||(e.Verbosity={}));var b;(function(U){U[U.EXPLICIT=1]="EXPLICIT",U[U.AUTO=2]="AUTO",U[U.FOCUS_CHANGE=3]="FOCUS_CHANGE",U[U.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(b=e.SaveReason||(e.SaveReason={}));var o;(function(U){U[U.None=0]="None",U[U.Readonly=2]="Readonly",U[U.Untitled=4]="Untitled",U[U.Singleton=8]="Singleton",U[U.RequiresTrust=16]="RequiresTrust",U[U.CanSplitInGroup=32]="CanSplitInGroup",U[U.ForceDescription=64]="ForceDescription"})(o=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class s extends S.Disposable{}e.AbstractEditorInput=s;function v(U){return U instanceof s}e.isEditorInput=v;function n(U){const F=U;return D.URI.isUri(F?.preferredResource)}function f(U){const F=U;return v(F?.primary)&&v(F?.secondary)}e.isSideBySideEditorInput=f;function r(U){const F=U;return v(F?.modified)&&v(F?.original)}e.isDiffEditorInput=r;function t(U){return v(U?.editor)}e.isEditorInputWithOptions=t;function u(U){const F=U;return t(U)&&F?.group!==void 0}e.isEditorInputWithOptionsAndGroup=u;function l(U){const F=U;return typeof F?.groupId=="number"&&v(F.editor)}e.isEditorIdentifier=l;var c;(function(U){U[U.UNKNOWN=0]="UNKNOWN",U[U.REPLACE=1]="REPLACE",U[U.MOVE=2]="MOVE",U[U.UNPIN=3]="UNPIN"})(c=e.EditorCloseContext||(e.EditorCloseContext={}));var m;(function(U){U[U.PRIMARY=1]="PRIMARY",U[U.SECONDARY=2]="SECONDARY",U[U.BOTH=3]="BOTH",U[U.ANY=4]="ANY"})(m=e.SideBySideEditor||(e.SideBySideEditor={}));class d{getOriginalUri(F,$){if(!F)return;if($?.supportSideBySide){const{primary:z,secondary:N}=this.getSideEditors(F);if(z&&N){if($?.supportSideBySide===m.BOTH)return{primary:this.getOriginalUri(z,{filterByScheme:$.filterByScheme}),secondary:this.getOriginalUri(N,{filterByScheme:$.filterByScheme})};if($?.supportSideBySide===m.ANY)return this.getOriginalUri(z,{filterByScheme:$.filterByScheme})??this.getOriginalUri(N,{filterByScheme:$.filterByScheme});F=$.supportSideBySide===m.PRIMARY?z:N}}if(h(F)||w(F))return;const M=n(F)?F.preferredResource:F.resource;return!M||!$||!$.filterByScheme?M:this.filterUri(M,$.filterByScheme)}getSideEditors(F){return f(F)||w(F)?{primary:F.primary,secondary:F.secondary}:r(F)||h(F)?{primary:F.modified,secondary:F.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(F,$){if(!F)return;if($?.supportSideBySide){const{primary:z,secondary:N}=this.getSideEditors(F);if(z&&N){if($?.supportSideBySide===m.BOTH)return{primary:this.getCanonicalUri(z,{filterByScheme:$.filterByScheme}),secondary:this.getCanonicalUri(N,{filterByScheme:$.filterByScheme})};if($?.supportSideBySide===m.ANY)return this.getCanonicalUri(z,{filterByScheme:$.filterByScheme})??this.getCanonicalUri(N,{filterByScheme:$.filterByScheme});F=$.supportSideBySide===m.PRIMARY?z:N}}if(h(F)||w(F))return;const M=F.resource;return!M||!$||!$.filterByScheme?M:this.filterUri(M,$.filterByScheme)}filterUri(F,$){if(Array.isArray($)){if($.some(M=>F.scheme===M))return F}else if($===F.scheme)return F}}e.EditorResourceAccessor=new d;var _;(function(U){U[U.LEFT=0]="LEFT",U[U.RIGHT=1]="RIGHT"})(_=e.CloseDirection||(e.CloseDirection={}));class A{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(F){const $=this.instantiationService=F.get(T.IInstantiationService);for(const[M,z]of this.editorSerializerConstructors)this.createEditorSerializer(M,z,$);this.editorSerializerConstructors.clear()}createEditorSerializer(F,$,M){const z=M.createInstance($);this.editorSerializerInstances.set(F,z)}registerFileEditorFactory(F){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=F}getFileEditorFactory(){return(0,L.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(F,$){if(this.editorSerializerConstructors.has(F)||this.editorSerializerInstances.has(F))throw new Error(`A editor serializer with type ID '${F}' was already registered.`);return this.instantiationService?this.createEditorSerializer(F,$,this.instantiationService):this.editorSerializerConstructors.set(F,$),(0,S.toDisposable)(()=>{this.editorSerializerConstructors.delete(F),this.editorSerializerInstances.delete(F)})}getEditorSerializer(F){return this.editorSerializerInstances.get(typeof F=="string"?F:F.typeId)}}E.Registry.add(e.EditorExtensions.EditorFactory,new A);async function R(U,F){if(!U||!U.length)return[];const $=await Promise.all(U.map(async M=>{const z=D.URI.revive(M.fileUri);if(!z||!await F.canHandleResource(z))return;let x=M.exists,j=M.type;if(typeof x!="boolean"||typeof j!="number")try{j=(await F.resolve(z)).isFile?k.FileType.File:k.FileType.Unknown,x=!0}catch{x=!1}if(!x&&M.openOnlyIfExists||j!==k.FileType.File)return;const O={selection:x?M.selection:void 0,pinned:!0,override:M.editorOverrideId};let H;return x?H={resource:z,options:O}:H={resource:z,options:O,forceUntitled:!0},H}));return(0,i.coalesce)($)}e.pathsToEditors=R;var B;(function(U){U[U.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",U[U.SEQUENTIAL=1]="SEQUENTIAL"})(B=e.EditorsOrder||(e.EditorsOrder={}))}),define(fe[211],me([0,1,3,53,174,4,6,24,34,15,59,25,48,199]),function(Y,e,g,L,D,S,T,C,E,k,i,I,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,p.registerIcon)("default-view-icon",a.Codicon.window,(0,D.localize)(0,null));var h;(function(u){u.ViewContainersRegistry="workbench.registry.view.containers",u.ViewsRegistry="workbench.registry.view"})(h=e.Extensions||(e.Extensions={}));var w;(function(u){u[u.Sidebar=0]="Sidebar",u[u.Panel=1]="Panel",u[u.AuxiliaryBar=2]="AuxiliaryBar"})(w=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function y(u){switch(u){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=y;function P(u){return`viewContainer.${u}.enabled`}e.getEnabledViewContainerContextKey=P;class b extends T.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new g.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new g.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,k.flatten)([...this.viewContainers.values()])}registerViewContainer(l,c,m){const d=this.get(l.id);if(d)return d;const _=l;return _.openCommandActionDescriptor=m?.donotRegisterOpenCommand?void 0:_.openCommandActionDescriptor??{id:_.id},(0,C.getOrSet)(this.viewContainers,c,[]).push(_),m?.isDefault&&this.defaultViewContainers.push(_),this._onDidRegister.fire({viewContainer:_,viewContainerLocation:c}),_}deregisterViewContainer(l){for(const c of this.viewContainers.keys()){const m=this.viewContainers.get(c),d=m?.indexOf(l);if(d!==-1){m?.splice(d,1),m.length===0&&this.viewContainers.delete(c),this._onDidDeregister.fire({viewContainer:l,viewContainerLocation:c});return}}}get(l){return this.all.filter(c=>c.id===l)[0]}getViewContainers(l){return[...this.viewContainers.get(l)||[]]}getViewContainerLocation(l){return[...this.viewContainers.keys()].filter(c=>this.getViewContainers(c).filter(m=>m?.id===l.id).length>0)[0]}getDefaultViewContainer(l){return this.defaultViewContainers.find(c=>this.getViewContainerLocation(c)===l)}}E.Registry.add(h.ViewContainersRegistry,new b);var o;(function(u){u.Open="2_open",u.Debug="4_debug",u.SCM="5_scm",u.More="9_more"})(o=e.ViewContentGroups||(e.ViewContentGroups={}));function s(u,l){const c=u.group??o.More,m=l.group??o.More;return c!==m?c.localeCompare(m):(u.order??5)-(l.order??5)}class v extends T.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new g.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new g.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new g.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new g.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new i.SetMap}registerViews(l,c){this.registerViews2([{views:l,viewContainer:c}])}registerViews2(l){l.forEach(({views:c,viewContainer:m})=>this.addViews(c,m)),this._onViewsRegistered.fire(l)}deregisterViews(l,c){const m=this.removeViews(l,c);m.length&&this._onViewsDeregistered.fire({views:m,viewContainer:c})}moveViews(l,c){for(const m of this._views.keys())if(m!==c){const d=this.removeViews(l,m);d.length&&(this.addViews(d,c),this._onDidChangeContainer.fire({views:d,from:m,to:c}))}}getViews(l){return this._views.get(l)||[]}getView(l){for(const c of this._viewContainers){const m=(this._views.get(c)||[]).filter(d=>d.id===l)[0];if(m)return m}return null}getViewContainer(l){for(const c of this._viewContainers)if((this._views.get(c)||[]).filter(d=>d.id===l)[0])return c;return null}registerViewWelcomeContent(l,c){return this._viewWelcomeContents.add(l,c),this._onDidChangeViewWelcomeContent.fire(l),(0,T.toDisposable)(()=>{this._viewWelcomeContents.delete(l,c),this._onDidChangeViewWelcomeContent.fire(l)})}registerViewWelcomeContent2(l,c){const m=new Map;for(const[d,_]of c)this._viewWelcomeContents.add(l,_),m.set(d,(0,T.toDisposable)(()=>{this._viewWelcomeContents.delete(l,_),this._onDidChangeViewWelcomeContent.fire(l)}));return this._onDidChangeViewWelcomeContent.fire(l),m}getViewWelcomeContent(l){const c=[];return this._viewWelcomeContents.forEach(l,m=>c.push(m)),c.sort(s)}addViews(l,c){let m=this._views.get(c);m||(m=[],this._views.set(c,m),this._viewContainers.push(c));for(const d of l){if(this.getView(d.id)!==null)throw new Error((0,D.localize)(1,null,d.id));m.push(d)}}removeViews(l,c){const m=this._views.get(c);if(!m)return[];const d=[],_=[];for(const A of m)l.includes(A)?d.push(A):_.push(A);return d.length&&(_.length?this._views.set(c,_):(this._views.delete(c),this._viewContainers.splice(this._viewContainers.indexOf(c),1))),d}}E.Registry.add(h.ViewsRegistry,new v),e.IViewsService=(0,S.createDecorator)("viewsService"),e.FocusedViewContext=new L.RawContextKey("focusedView","",(0,D.localize)(2,null));function n(u){return`view.${u}.visible`}e.getVisbileViewContextKey=n,e.IViewDescriptorService=(0,S.createDecorator)("viewDescriptorService");var f;(function(u){u[u.Default=0]="Default",u[u.Expand=1]="Expand"})(f=e.ViewVisibilityState||(e.ViewVisibilityState={}));var r;(function(u){u[u.None=0]="None",u[u.Collapsed=1]="Collapsed",u[u.Expanded=2]="Expanded"})(r=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class t{constructor(l,c){this.resolved=!1,this._hasResolve=!1,(0,I.mixin)(this,l),this._hasResolve=!!c,this.resolve=async m=>{if(c&&!this.resolved){const d=await c(m);d&&(this.tooltip=this.tooltip??d.tooltip,this.command=this.command??d.command)}m.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=t,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(fe[124],me([0,1,3,16,175]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class S{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new g.Emitter,this._onExit=new g.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(C){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=C}onEvent(C){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=C}onRequest(C){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=C}sendResponse(C){C.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${C.command}`)):this.internalSend("response",C)}sendRequest(C,E,k,i){const I={command:C};if(E&&Object.keys(E).length>0&&(I.arguments=E),this.internalSend("request",I),typeof i=="number"){const a=setTimeout(()=>{clearTimeout(a);const p=this.pendingRequests.get(I.seq);if(p){this.pendingRequests.delete(I.seq);const h={type:"response",seq:0,request_seq:I.seq,success:!1,command:C,message:(0,D.localize)(0,null,i,C)};p(h)}},i)}return k&&this.pendingRequests.set(I.seq,k),I.seq}acceptMessage(C){this.messageCallback?this.messageCallback(C):(this.queue.push(C),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(C,E){return C.type!=="event"||E.type!=="event"}async processQueue(){let C;for(;this.queue.length;){if((!C||this.needsTaskBoundaryBetween(this.queue[0],C))&&await(0,L.timeout)(0),C=this.queue.shift(),!C)return;switch(C.type){case"event":this.eventCallback&&this.eventCallback(C);break;case"request":this.requestCallback&&this.requestCallback(C);break;case"response":const E=C,k=this.pendingRequests.get(E.request_seq);k&&(this.pendingRequests.delete(E.request_seq),k(E));break}}}internalSend(C,E){E.type=C,E.seq=this.sequence++,this.sendMessage(E)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const C=new Map;this.pendingRequests.forEach((E,k)=>C.set(k,E)),await(0,L.timeout)(500),C.forEach((E,k)=>{E({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(k)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=S}),define(fe[212],me([0,1,8,2,9,25,10]),function(Y,e,g,L,D,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const C=/{([^}]+)}/g;function E(r,t,u){return r.replace(C,function(l,c){return t&&c.length>0&&c[0]!=="_"?l:u&&u.hasOwnProperty(c)?u[c]:l})}e.formatPII=E;function k(r){const t={};for(const u of Object.keys(r))u.startsWith("!")||(t[u]=r[u]);return t}e.filterExceptionsFromTelemetry=k;function i(r){return r.configuration.request==="attach"&&!I(r)&&(!r.parentSession||i(r.parentSession))}e.isSessionAttach=i;function I(r){let t=r.configuration.type;if(!!t)return t==="vslsShare"&&(t=r.configuration.adapterProxy.configuration.type),(0,g.equalsIgnoreCase)(t,"extensionhost")||(0,g.equalsIgnoreCase)(t,"pwa-extensionhost")?r:r.parentSession?I(r.parentSession):void 0}e.getExtensionHostDebugSession=I;function a(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=a;function p(r,t,u){let l,c=0,m=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,d=null;for(;d=m.exec(r);){let _=d.index+1,A=_+d[0].length;if(_<=t&&A>=u){l=d[0],c=_;break}}if(l){let _=/\w+/g,A=null;for(;(A=_.exec(l))&&!(A.index+1+c+A[0].length>=u););A&&(l=l.substring(0,_.lastIndex))}return l?{start:c,end:c+l.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=p;const h=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function w(r){return!!(r&&r.match(h))}e.isUri=w;function y(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(w(r.path))return L.URI.parse(r.path);if((0,D.isAbsolute)(r.path))return L.URI.file(r.path)}return r.path}function P(r){if(typeof r.path=="object"){const t=L.URI.revive(r.path);if(t)return t.scheme===T.Schemas.file?t.fsPath:t.toString()}return r.path}function b(r,t){const u=t?y:P,l=(0,S.deepClone)(r);return s(l,(c,m)=>{c&&m&&(m.path=u(m))}),l}e.convertToDAPaths=b;function o(r,t){const u=t?y:P,l=(0,S.deepClone)(r);return s(l,(c,m)=>{!c&&m&&(m.path=u(m))}),l}e.convertToVSCPaths=o;function s(r,t){switch(r.type){case"event":const u=r;switch(u.event){case"output":t(!1,u.body.source);break;case"loadedSource":t(!1,u.body.source);break;case"breakpoint":t(!1,u.body.breakpoint.source);break;default:break}break;case"request":const l=r;switch(l.command){case"setBreakpoints":t(!0,l.arguments.source);break;case"breakpointLocations":t(!0,l.arguments.source);break;case"source":t(!0,l.arguments.source);break;case"gotoTargets":t(!0,l.arguments.source);break;case"launchVSCode":l.arguments.args.forEach(m=>t(!1,m));break;default:break}break;case"response":const c=r;if(c.success&&c.body)switch(c.command){case"stackTrace":c.body.stackFrames.forEach(m=>t(!1,m.source));break;case"loadedSources":c.body.sources.forEach(m=>t(!1,m));break;case"scopes":c.body.scopes.forEach(m=>t(!1,m.source));break;case"setFunctionBreakpoints":c.body.breakpoints.forEach(m=>t(!1,m.source));break;case"setBreakpoints":c.body.breakpoints.forEach(m=>t(!1,m.source));break;default:break}break}}function v(r){return r.filter(t=>!t.presentation?.hidden).sort((t,u)=>t.presentation?u.presentation?t.presentation.group?u.presentation.group?t.presentation.group!==u.presentation.group?t.presentation.group.localeCompare(u.presentation.group):n(t.presentation.order,u.presentation.order):-1:u.presentation.group?1:n(t.presentation.order,u.presentation.order):-1:u.presentation?1:0)}e.getVisibleAndSorted=v;function n(r,t){return typeof r!="number"?typeof t!="number"?0:1:typeof t!="number"?-1:r-t}async function f(r,t){const u=r.getValue("debug.saveBeforeStart",{overrideIdentifier:t.activeTextEditorMode});if(u!=="none"&&(await t.saveAll(),u==="allEditorsInActiveGroup")){const l=t.activeEditorPane;l&&await t.save({editor:l.input,groupId:l.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=f}),define(fe[213],me([0,1,28,39,176,125,9,8,25,12,186,124]),function(Y,e,g,L,D,S,T,C,E,k,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class a extends I.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(b,o){this.outputStream=o,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,b.on("data",s=>this.handleData(s))}sendMessage(b){if(this.outputStream){const o=JSON.stringify(b);this.outputStream.write(`Content-Length: ${Buffer.byteLength(o,"utf8")}${a.TWO_CRLF}${o}`,"utf8")}}handleData(b){for(this.rawData=Buffer.concat([this.rawData,b]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const o=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,o.length>0)try{this.acceptMessage(JSON.parse(o))}catch(s){this._onError.fire(new Error((s.message||s)+`
`+o))}continue}}else{const o=this.rawData.indexOf(a.TWO_CRLF);if(o!==-1){const v=this.rawData.toString("utf8",0,o).split(a.HEADER_LINESEPARATOR);for(const n of v){const f=n.split(a.HEADER_FIELDSEPARATOR);f[0]==="Content-Length"&&(this.contentLength=Number(f[1]))}this.rawData=this.rawData.slice(o+a.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=a,a.TWO_CRLF=`\r
\r
`,a.HEADER_LINESEPARATOR=/\r?\n/,a.HEADER_FIELDSEPARATOR=/: */;class p extends a{startSession(){return new Promise((b,o)=>{let s=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),b(),s=!0}),this.socket.on("close",()=>{s?this._onError.fire(new Error("connection closed")):o(new Error("connection closed"))}),this.socket.on("error",v=>{s?this._onError.fire(v):o(v)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=p;class h extends p{constructor(b){super();this.adapterServer=b}createConnection(b){return S.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",b)}}e.SocketDebugAdapter=h;class w extends p{constructor(b){super();this.adapterServer=b}createConnection(b){return S.createConnection(this.adapterServer.path,b)}}e.NamedPipeDebugAdapter=w;class y extends a{constructor(b,o,s){super();this.adapterExecutable=b,this.debugType=o,this.outputService=s}async startSession(){const b=this.adapterExecutable.command,o=this.adapterExecutable.args,s=this.adapterExecutable.options||{};try{if(b)if(T.isAbsolute(b)){if(!await g.Promises.exists(b))throw new Error(D.localize(0,null,b))}else b.indexOf("/")<0&&b.indexOf("\\")<0;else throw new Error(D.localize(1,null,this.debugType));let v=process.env;if(s.env&&Object.keys(s.env).length>0&&(v=E.mixin(E.deepClone(process.env),s.env)),b==="node")if(Array.isArray(o)&&o.length>0){const f=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,r={env:v,execArgv:f?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};s.cwd&&(r.cwd=s.cwd);const t=L.fork(o[0],o.slice(1),r);if(!t.pid)throw new Error(D.localize(2,null,o[0]));this.serverProcess=t}else throw new Error(D.localize(3,null));else{const f={env:v};s.cwd&&(f.cwd=s.cwd),this.serverProcess=L.spawn(b,o,f)}this.serverProcess.on("error",f=>{this._onError.fire(f)}),this.serverProcess.on("exit",(f,r)=>{this._onExit.fire(f)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",f=>{this._onError.fire(f)}),this.serverProcess.stdin.on("error",f=>{this._onError.fire(f)});const n=this.outputService;if(n){const f=r=>r.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",r=>{const t=n.getChannel(i.ExtensionsChannelId);t&&t.append(f(r))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(v){this._onError.fire(v)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),k.isWindows?new Promise((b,o)=>{const s=L.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(v,n,f){if(v)return o(v)});s.on("exit",b),s.on("error",o)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(b,o){if(!b)return;const s=Object.create(null);b.runtime&&(b.runtime.indexOf("./")===0?s.runtime=T.join(o,b.runtime):s.runtime=b.runtime),b.runtimeArgs&&(s.runtimeArgs=b.runtimeArgs),b.program&&(T.isAbsolute(b.program)?s.program=b.program:s.program=T.join(o,b.program)),b.args&&(s.args=b.args);const v=b;return v.win&&(s.win=y.extract(v.win,o)),v.winx86&&(s.winx86=y.extract(v.winx86,o)),v.windows&&(s.windows=y.extract(v.windows,o)),v.osx&&(s.osx=y.extract(v.osx,o)),v.linux&&(s.linux=y.extract(v.linux,o)),s}static platformAdapterExecutable(b,o){let s=Object.create(null);o=o.toLowerCase();for(const u of b)if(u.contributes){const l=u.contributes.debuggers;l&&l.length>0&&l.filter(c=>typeof c.type=="string"&&C.equalsIgnoreCase(c.type,o)).forEach(c=>{const m=y.extract(c,u.extensionLocation.fsPath);s=E.mixin(s,m,u.isBuiltin)})}let v;k.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?v=s.winx86||s.win||s.windows:k.isWindows?v=s.win||s.windows:k.isMacintosh?v=s.osx:k.isLinux&&(v=s.linux),v=v||s;let n=v.program||s.program;const f=v.args||s.args;let r=v.runtime||s.runtime;const t=v.runtimeArgs||s.runtimeArgs;if(r)return{type:"executable",command:r,args:(t||[]).concat(typeof n=="string"?[n]:[]).concat(f||[])};if(n)return{type:"executable",command:n,args:f||[]}}}e.ExecutableDebugAdapter=y}),define(fe[214],me([0,1,39,12,29,188]),function(Y,e,g,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function T(a,p){return new Promise((h,w)=>{let y="";const P=g.spawn(a,p);P.pid&&P.stdout.on("data",b=>{y+=b.toString()}),P.on("error",b=>{w(b)}),P.on("close",b=>{h(y)})})}let C;function E(a,p){if(!C)if(L.isWindows)C=new S.WindowsExternalTerminalService;else if(L.isMacintosh)C=new S.MacExternalTerminalService;else if(L.isLinux)C=new S.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const h=p.getConfiguration("terminal");return C.runInTerminal(a.title,a.cwd,a.args,a.env||{},h.external||{})}e.runInExternalTerminal=E;async function k(a){if(a)if(L.isWindows){const p=await new Promise((h,w)=>{Y(["windows-process-tree"],h,w)});return new Promise(h=>{p.getProcessTree(a,w=>{h(w.children.length>0)})})}else return T("/usr/bin/pgrep",["-lP",String(a)]).then(p=>{const h=p.trim();return!(h.length===0||h.indexOf(" tmux")>=0)},p=>!0);return Promise.resolve(!0)}e.hasChildProcesses=k;var i;(function(a){a[a.cmd=0]="cmd",a[a.powershell=1]="powershell",a[a.bash=2]="bash"})(i||(i={}));function I(a,p,h,w){a=a.trim().toLowerCase();let y;a.indexOf("powershell")>=0||a.indexOf("pwsh")>=0?y=1:a.indexOf("cmd.exe")>=0?y=0:a.indexOf("bash")>=0?y=2:L.isWindows?y=0:y=2;let P,b=" ";switch(y){case 1:if(P=s=>(s=s.replace(/\'/g,"''"),s.length>0&&s.charAt(s.length-1)==="\\"?`'${s}\\'`:`'${s}'`),h){const s=(0,D.getDriveLetter)(h);s&&(b+=`${s}:; `),b+=`cd ${P(h)}; `}if(w)for(let s in w){const v=w[s];v===null?b+=`Remove-Item env:${s}; `:b+=`\${env:${s}}='${v}'; `}if(p.length>0){const s=P(p.shift());b+=s[0]==="'"?`& ${s} `:`${s} `;for(let v of p)b+=`${P(v)} `}break;case 0:if(P=s=>(s=s.replace(/\"/g,'""'),s.indexOf(" ")>=0||s.indexOf('"')>=0||s.length===0?`"${s}"`:s),h){const s=(0,D.getDriveLetter)(h);s&&(b+=`${s}: && `),b+=`cd ${P(h)} && `}if(w){b+='cmd /C "';for(let s in w){let v=w[s];v===null?b+=`set "${s}=" && `:(v=v.replace(/[\^\&\|\<\>]/g,n=>`^${n}`),b+=`set "${s}=${v}" && `)}}for(let s of p)b+=`${P(s)} `;w&&(b+='"');break;case 2:P=s=>(s=s.replace(/(["'\\\$])/g,"\\$1"),s.indexOf(" ")>=0||s.indexOf(";")>=0||s.length===0?`"${s}"`:s);const o=s=>/[^\w@%\/+=,.:^-]/.test(s)?`'${s.replace(/'/g,"'\\''")}'`:s;if(h&&(b+=`cd ${P(h)} ; `),w){b+="/usr/bin/env";for(let s in w){const v=w[s];v===null?b+=` -u ${o(s)}`:b+=` ${o(`${s}=${v}`)}`}b+=" "}for(let s of p)b+=`${P(s)} `;break}return b}e.prepareCommand=I}),define(fe[126],me([0,1,30,78,102,10,9,12,53]),function(Y,e,g,L,D,S,T,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var k;(function(_){_[_.Markup=1]="Markup",_[_.Code=2]="Code"})(k=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",D.Mimes.latex,D.Mimes.markdown,"image/png","image/jpeg",D.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[D.Mimes.latex,D.Mimes.markdown,"application/json",D.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["vscode.ipynb"])],["ms-toolsai.jupyter-renderers",new Set(["vscode.ipynb"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var i;(function(_){_[_.Running=1]="Running",_[_.Idle=2]="Idle"})(i=e.NotebookRunState||(e.NotebookRunState={}));var I;(function(_){_[_.Pending=2]="Pending",_[_.Executing=3]="Executing"})(I=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var a;(function(_){_[_.WithHardKernelDependency=0]="WithHardKernelDependency",_[_.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",_[_.Pure=2]="Pure",_[_.Never=3]="Never"})(a=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var p;(function(_){_.Always="always",_.Never="never",_.Optional="optional"})(p=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var h;(function(_){_[_.ModelChange=1]="ModelChange",_[_.Move=2]="Move",_[_.ChangeLanguage=5]="ChangeLanguage",_[_.Initialize=6]="Initialize",_[_.ChangeCellMetadata=7]="ChangeCellMetadata",_[_.Output=8]="Output",_[_.OutputItem=9]="OutputItem",_[_.ChangeCellContent=10]="ChangeCellContent",_[_.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",_[_.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",_[_.ChangeCellMime=13]="ChangeCellMime",_[_.Unknown=100]="Unknown"})(h=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var w;(function(_){_[_.Handle=0]="Handle",_[_.Index=1]="Index"})(w=e.SelectionStateType||(e.SelectionStateType={}));var y;(function(_){_[_.Replace=1]="Replace",_[_.Output=2]="Output",_[_.Metadata=3]="Metadata",_[_.CellLanguage=4]="CellLanguage",_[_.DocumentMetadata=5]="DocumentMetadata",_[_.Move=6]="Move",_[_.OutputItems=7]="OutputItems",_[_.PartialMetadata=8]="PartialMetadata",_[_.PartialInternalMetadata=9]="PartialInternalMetadata"})(y=e.CellEditType||(e.CellEditType={}));var P;(function(_){_.scheme=S.Schemas.vscodeNotebookCell;const A=/^ch(\d{7,})/;function R(M,z){return M.with({scheme:_.scheme,fragment:`ch${z.toString().padStart(7,"0")}${M.scheme!==S.Schemas.file?M.scheme:""}`})}_.generate=R;function B(M){if(M.scheme!==_.scheme)return;const z=A.exec(M.fragment);return z?{handle:Number(z[1]),notebook:M.with({scheme:M.fragment.substr(z[0].length)||S.Schemas.file,fragment:null})}:void 0}_.parse=B;function U(M){if(M.scheme!==S.Schemas.vscodeNotebookCellMetadata)return;const z=A.exec(M.fragment);return z?{handle:Number(z[1]),notebook:M.with({scheme:M.fragment.substr(z[0].length)||S.Schemas.file,fragment:null})}:void 0}_.parseCellMetadataUri=U;function F(M,z,N){return M.with({scheme:N,fragment:`ch${z.toString().padStart(7,"0")}${M.scheme!==S.Schemas.file?M.scheme:""}`})}_.generateCellUri=F;function $(M,z){if(M.scheme!==z)return;const N=A.exec(M.fragment);return N?{handle:Number(N[1]),notebook:M.with({scheme:M.fragment.substr(N[0].length)||S.Schemas.file,fragment:null})}:void 0}_.parseCellUri=$})(P=e.CellUri||(e.CellUri={}));const b=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[D.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[D.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[D.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function o(_){return b.get(_)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=o;function s(_){return b.get(_)?.supportedByCore??!1}e.mimeTypeSupportedByCore=s;function v(_){return b.get(_)?.mergeable??!1}e.mimeTypeIsMergeable=v;const n=_=>C.isWindows?_.replace(/\//g,"\\"):_;class f{constructor(A=[],R=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=R,this.order=[...new Set(A)].map(B=>({pattern:B,matches:g.parse(n(B))}))}sort(A){const R=new Map(L.Iterable.map(A,U=>[U,n(U)]));let B=[];for(const{matches:U}of this.order)for(const[F,$]of R)if(U($)){B.push(F),R.delete(F);break}return R.size&&(B=B.concat([...R.keys()].sort((U,F)=>this.defaultOrder.indexOf(U)-this.defaultOrder.indexOf(F)))),B}prioritize(A,R){const B=this.findIndex(A);if(B===-1){this.order.unshift({pattern:A,matches:g.parse(n(A))});return}const U=new Set(R.map($=>this.findIndex($,B)));U.delete(-1);const F=Array.from(U).sort();this.order.splice(B+1,0,...F.map($=>this.order[$]));for(let $=F.length-1;$>=0;$--)this.order.splice(F[$],1)}toArray(){return this.order.map(A=>A.pattern)}findIndex(A,R=this.order.length){const B=n(A);for(let U=0;U<R;U++)if(this.order[U].matches(B))return U;return-1}}e.MimeTypeDisplayOrder=f;function r(_,A,R,B=(U,F)=>U===F){const U=[];function F(z,N,x){if(N===0&&x.length===0)return;const j=U[U.length-1];j&&j.start+j.deleteCount===z?(j.deleteCount+=N,j.toInsert.push(...x)):U.push({start:z,deleteCount:N,toInsert:x})}let $=0,M=0;for(;;){if($===_.length){F($,0,A.slice(M));break}if(M===A.length){F($,_.length-$,[]);break}const z=_[$],N=A[M];if(B(z,N)){$+=1,M+=1;continue}R(N)?(F($,1,[]),$+=1):(F($,0,[N]),M+=1)}return U}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new E.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(_){_.default="default",_.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function u(_){const A=_;return!!((typeof A.include=="string"||g.isRelativePattern(A.include))&&(typeof A.exclude=="string"||g.isRelativePattern(A.exclude)))}e.isDocumentExcludePattern=u;function l(_,A,R){if(Array.isArray(_.viewType)&&_.viewType.indexOf(A)>=0||_.viewType===A)return!0;if(_.filenamePattern){let B=u(_.filenamePattern)?_.filenamePattern.include:_.filenamePattern,U=u(_.filenamePattern)?_.filenamePattern.exclude:void 0;if(g.match(B,(0,T.basename)(R.fsPath).toLowerCase()))return!(U&&g.match(U,(0,T.basename)(R.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=l;class c{constructor(A){this.textModel=A}getElements(){const A=new Int32Array(this.textModel.cells.length);for(let R=0;R<this.textModel.cells.length;R++)A[R]=this.textModel.cells[R].getHashValue();return A}}e.CellSequence=c,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var m;(function(_){_[_.Left=1]="Left",_[_.Right=2]="Right"})(m=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class d{static create(A){return`${d._prefix}${A}`}static parse(A){if(A.startsWith(d._prefix))return A.substr(d._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=d,d._prefix="notebook/"}),define(fe[215],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var L;(function(D){D[D.Output=1]="Output",D[D.OutputItems=2]="OutputItems",D[D.ExecutionState=3]="ExecutionState",D[D.Complete=4]="Complete"})(L=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,g.createDecorator)("INotebookExecutionService")}),define(fe[216],me([0,1,4,53]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new L.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new L.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new L.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,g.createDecorator)(e.OUTPUT_SERVICE_ID);var D;(function(S){S[S.Append=1]="Append",S[S.Replace=2]="Replace",S[S.Clear=3]="Clear"})(D=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(fe[217],me([0,1,178,4,53]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new D.RawContextKey("customExecutionSupported",!0,g.localize(0,null)),e.ShellExecutionSupportedContext=new D.RawContextKey("shellExecutionSupported",!1,g.localize(1,null)),e.ProcessExecutionSupportedContext=new D.RawContextKey("processExecutionSupported",!1,g.localize(2,null)),e.ITaskService=(0,L.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(fe[218],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function g(D){return[...D.entries()]}e.serializeEnvironmentVariableCollection=g;function L(D){return new Map(D)}e.deserializeEnvironmentVariableCollection=L}),define(fe[127],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var g;(function(I){I[I.Unset=0]="Unset",I[I.Queued=1]="Queued",I[I.Running=2]="Running",I[I.Passed=3]="Passed",I[I.Failed=4]="Failed",I[I.Skipped=5]="Skipped",I[I.Errored=6]="Errored"})(g=e.TestResultState||(e.TestResultState={}));var L;(function(I){I[I.Run=2]="Run",I[I.Debug=4]="Debug",I[I.Coverage=8]="Coverage",I[I.HasNonDefaultProfile=16]="HasNonDefaultProfile",I[I.HasConfigurable=32]="HasConfigurable"})(L=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var D;(function(I){I[I.Error=0]="Error",I[I.Info=1]="Info"})(D=e.TestMessageType||(e.TestMessageType={}));var S;(function(I){I[I.NotExpandable=0]="NotExpandable",I[I.Expandable=1]="Expandable",I[I.BusyExpanding=2]="BusyExpanding",I[I.Expanded=3]="Expanded"})(S=e.TestItemExpandState||(e.TestItemExpandState={}));const T=(I,a)=>{a.expand!==void 0&&(I.expand=a.expand),a.item!==void 0&&(I.item=I.item?Object.assign(I.item,a.item):a.item)};e.applyTestItemUpdate=T;var C;(function(I){I[I.Function=0]="Function",I[I.Statement=1]="Statement"})(C=e.DetailType||(e.DetailType={}));var E;(function(I){I[I.Add=0]="Add",I[I.Update=1]="Update",I[I.Remove=2]="Remove",I[I.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",I[I.Retire=4]="Retire",I[I.AddTag=5]="AddTag",I[I.RemoveTag=6]="RemoveTag"})(E=e.TestDiffOpType||(e.TestDiffOpType={}));class k{add(a){}update(a){}remove(a,p){}complete(){}}e.IncrementalChangeCollector=k;class i{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(a){const p=this.createChangeCollector();for(const h of a)switch(h[0]){case 0:{const w=h[1];if(w.parent){if(this.items.has(w.parent)){const y=this.items.get(w.parent);y.children.add(w.item.extId);const P=this.createItem(w,y);this.items.set(w.item.extId,P),p.add(P)}}else{const y=this.createItem(w);this.roots.add(y),this.items.set(w.item.extId,y),p.add(y)}w.expand===2&&this.busyControllerCount++;break}case 1:{const w=h[1],y=this.items.get(w.extId);if(!y)break;w.expand!==void 0&&(y.expand===2&&this.busyControllerCount--,w.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(y,w),p.update(y);break}case 2:{const w=this.items.get(h[1]);if(!w)break;w.parent?this.items.get(w.parent).children.delete(w.item.extId):this.roots.delete(w);const y=[[h[1]]];for(;y.length;)for(const P of y.pop()){const b=this.items.get(P);b&&(y.push(b.children),this.items.delete(P),p.remove(b,b!==w),b.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(h[1]);break;case 3:this.updatePendingRoots(h[1]);break;case 5:this._tags.set(h[1].id,h[1]);break;case 6:this._tags.delete(h[1]);break}p.complete()}retireTest(a){}updatePendingRoots(a){this.pendingRootCount+=a}createChangeCollector(){return new k}}e.AbstractIncrementalTestCollection=i}),define(fe[90],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var g;(function(S){S.Delimiter="\0"})(g=e.TestIdPathParts||(e.TestIdPathParts={}));var L;(function(S){S[S.IsSame=0]="IsSame",S[S.Disconnected=1]="Disconnected",S[S.IsChild=2]="IsChild",S[S.IsParent=3]="IsParent"})(L=e.TestPosition||(e.TestPosition={}));class D{constructor(T,C=T.length){if(this.path=T,this.viewEnd=C,T.length===0||C<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(T,C,E=T.parent){if(T.id===C)return new D([C]);let k=[T.id];for(let i=E;i&&i.id!==C;i=i.parent)k.push(i.id);return k.push(C),new D(k.reverse())}static isRoot(T){return!T.includes("\0")}static fromString(T){return new D(T.split("\0"))}static join(T,C){return new D([...T.path,C])}static joinToString(T,C){return T.toString()+"\0"+C}static compare(T,C){return T===C?0:C.startsWith(T+"\0")?2:T.startsWith(C+"\0")?3:1}get parentId(){return this.viewEnd>1?new D(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let T=1;T<=this.viewEnd;T++)yield new D(this.path,T)}compare(T){if(typeof T=="string")return D.compare(this.toString(),T);for(let C=0;C<T.viewEnd&&C<this.viewEnd;C++)if(T.path[C]!==this.path[C])return 1;return T.viewEnd>this.viewEnd?2:T.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let T=1;T<this.viewEnd;T++)this.stringifed+="\0",this.stringifed+=this.path[T]}return this.stringifed}}e.TestId=D}),define(fe[219],me([0,1,9,38,13,25,12,81,179]),function(Y,e,g,L,D,S,T,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(I,a,p){this._contributedVariables=new Map,this._context=I,this._labelService=a,p&&(this._envVariablesPromise=p.then(h=>this.prepareEnv(h)))}prepareEnv(I){if(T.isWindows){const a=Object.create(null);return Object.keys(I).forEach(p=>{a[p.toLowerCase()]=I[p]}),a}return I}resolveWithEnvironment(I,a,p){return this.recursiveResolve(this.prepareEnv(I),a?a.uri:void 0,p)}async resolveAsync(I,a){return this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,a)}async resolveAnyBase(I,a,p,h){const w=S.deepClone(a);return T.isWindows&&w.windows?Object.keys(w.windows).forEach(y=>w[y]=w.windows[y]):T.isMacintosh&&w.osx?Object.keys(w.osx).forEach(y=>w[y]=w.osx[y]):T.isLinux&&w.linux&&Object.keys(w.linux).forEach(y=>w[y]=w.linux[y]),delete w.windows,delete w.osx,delete w.linux,this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,w,p,h)}async resolveAnyAsync(I,a,p){return this.resolveAnyBase(I,a,p)}async resolveAnyMap(I,a,p){const h=new Map;return{newConfig:await this.resolveAnyBase(I,a,p,h),resolvedVariables:h}}resolveWithInteractionReplace(I,a,p,h){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,a,p,h){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,a){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,a)}recursiveResolve(I,a,p,h,w){if(D.isString(p))return this.resolveString(I,a,p,h,w);if(D.isArray(p))return p.map(y=>this.recursiveResolve(I,a,y,h,w));if(D.isObject(p)){let y=Object.create(null);return Object.keys(p).forEach(P=>{const b=this.resolveString(I,a,P,h,w);y[b]=this.recursiveResolve(I,a,p[P],h,w)}),y}return p}resolveString(I,a,p,h,w){return p.replace(k.VARIABLE_REGEXP,(P,b)=>{if(b.includes(k.VARIABLE_LHS))return P;let o=this.evaluateSingleVariable(I,P,b,a,h);return w&&w.set(b,o),o!==P&&D.isString(o)&&o.match(k.VARIABLE_REGEXP)&&(o=this.resolveString(I,a,o,h,w)),o})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}evaluateSingleVariable(I,a,p,h,w){let y;const P=p.split(":");P.length>1&&(p=P[0],y=P[1]);const b=()=>{const v=this._context.getFilePath();if(v)return v;throw new Error((0,E.localize)(0,null,a))},o=()=>{const v=b();if(this._context.getWorkspaceFolderPathForFile){const n=this._context.getWorkspaceFolderPathForFile();if(n)return n}throw new Error((0,E.localize)(1,null,a,g.basename(v)))},s=()=>{if(y){const v=this._context.getFolderUri(y);if(v)return v;throw new Error((0,E.localize)(2,null,a,y))}if(h)return h;throw this._context.getWorkspaceFolderCount()>1?new Error((0,E.localize)(3,null,a)):new Error((0,E.localize)(4,null,a))};switch(p){case"env":if(y){if(I){const v=I[T.isWindows?y.toLowerCase():y];if(D.isString(v))return v}return""}throw new Error((0,E.localize)(5,null,a));case"config":if(y){const v=this._context.getConfigurationValue(h,y);if(D.isUndefinedOrNull(v))throw new Error((0,E.localize)(6,null,a,y));if(D.isObject(v))throw new Error((0,E.localize)(7,null,a,y));return v}throw new Error((0,E.localize)(8,null,a));case"command":return this.resolveFromMap(a,y,w,"command");case"input":return this.resolveFromMap(a,y,w,"input");default:switch(p){case"workspaceRoot":case"workspaceFolder":return(0,C.normalizeDriveLetter)(this.fsPath(s()));case"cwd":return h||y?(0,C.normalizeDriveLetter)(this.fsPath(s())):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return g.basename(this.fsPath(s()));case"lineNumber":const v=this._context.getLineNumber();if(v)return v;throw new Error((0,E.localize)(9,null,a));case"selectedText":const n=this._context.getSelectedText();if(n)return n;throw new Error((0,E.localize)(10,null,a));case"file":return b();case"fileWorkspaceFolder":return o();case"relativeFile":return h||y?g.relative(this.fsPath(s()),b()):b();case"relativeFileDirname":const f=g.dirname(b());if(h||y){const l=g.relative(this.fsPath(s()),f);return l.length===0?".":l}return f;case"fileDirname":return g.dirname(b());case"fileExtname":return g.extname(b());case"fileBasename":return g.basename(b());case"fileBasenameNoExtension":const r=g.basename(b());return r.slice(0,r.length-g.extname(r).length);case"fileDirnameBasename":return g.basename(g.dirname(b()));case"execPath":const t=this._context.getExecPath();return t||a;case"execInstallFolder":const u=this._context.getAppRoot();return u||a;case"pathSeparator":return g.sep;default:try{const l=y?`${p}:${y}`:p;return this.resolveFromMap(a,l,w,void 0)}catch(l){return a}}}}resolveFromMap(I,a,p,h){if(a&&p){const w=h===void 0?p[a]:p[h+":"+a];if(typeof w=="string")return w;throw new Error((0,E.localize)(11,null,I))}return I}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(fe[128],me([0,1,4,210]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,g.createDecorator)("editorGroupsService");var D;(function(w){w[w.UP=0]="UP",w[w.DOWN=1]="DOWN",w[w.LEFT=2]="LEFT",w[w.RIGHT=3]="RIGHT"})(D=e.GroupDirection||(e.GroupDirection={}));var S;(function(w){w[w.HORIZONTAL=0]="HORIZONTAL",w[w.VERTICAL=1]="VERTICAL"})(S=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(w){w[w.FIRST=0]="FIRST",w[w.LAST=1]="LAST",w[w.NEXT=2]="NEXT",w[w.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var C;(function(w){w[w.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",w[w.EVEN=1]="EVEN",w[w.TOGGLE=2]="TOGGLE"})(C=e.GroupsArrangement||(e.GroupsArrangement={}));var E;(function(w){w[w.COPY_EDITORS=0]="COPY_EDITORS",w[w.MOVE_EDITORS=1]="MOVE_EDITORS"})(E=e.MergeGroupMode||(e.MergeGroupMode={}));function k(w){const y=w;return(0,L.isEditorInput)(y?.editor)&&(0,L.isEditorInput)(y?.replacement)}e.isEditorReplacement=k;var i;(function(w){w[w.CREATION_TIME=0]="CREATION_TIME",w[w.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",w[w.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(i=e.GroupsOrder||(e.GroupsOrder={}));var I;(function(w){w[w.GROUP_ACTIVE=0]="GROUP_ACTIVE",w[w.GROUP_INDEX=1]="GROUP_INDEX",w[w.GROUP_LOCKED=2]="GROUP_LOCKED",w[w.EDITOR_OPEN=3]="EDITOR_OPEN",w[w.EDITOR_CLOSE=4]="EDITOR_CLOSE",w[w.EDITOR_MOVE=5]="EDITOR_MOVE",w[w.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",w[w.EDITOR_LABEL=7]="EDITOR_LABEL",w[w.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",w[w.EDITOR_PIN=9]="EDITOR_PIN",w[w.EDITOR_STICKY=10]="EDITOR_STICKY",w[w.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(I=e.GroupChangeKind||(e.GroupChangeKind={}));var a;(function(w){w[w.NEW_EDITOR=1]="NEW_EDITOR",w[w.MOVE_EDITOR=2]="MOVE_EDITOR",w[w.COPY_EDITOR=3]="COPY_EDITOR"})(a=e.OpenEditorContext||(e.OpenEditorContext={}));function p(w){const y=w;return!!y&&typeof y.id=="number"&&Array.isArray(y.editors)}e.isEditorGroup=p;function h(w){return w.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=h}),define(fe[220],me([0,1,4,128]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,g.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function D(S){const T=S;return typeof S=="number"||(0,L.isEditorGroup)(T)}e.isPreferredGroup=D}),define(fe[17],me([0,1,15,22,98,294,62,25,13,2,42,85,180,116,66,126,90,220,7]),function(Y,e,g,L,D,S,T,C,E,k,i,I,a,p,h,w,y,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var o;(function(ge){function be(K){const{selectionStartLineNumber:Se,selectionStartColumn:Le,positionLineNumber:it,positionColumn:Ge}=K,mt=new b.Position(Se-1,Le-1),yt=new b.Position(it-1,Ge-1);return new b.Selection(mt,yt)}ge.to=be;function ae(K){const{anchor:Se,active:Le}=K;return{selectionStartLineNumber:Se.line+1,selectionStartColumn:Se.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}ge.from=ae})(o=e.Selection||(e.Selection={}));var s;(function(ge){function be(K){if(!K)return;const{start:Se,end:Le}=K;return{startLineNumber:Se.line+1,startColumn:Se.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}ge.from=be;function ae(K){if(!K)return;const{startLineNumber:Se,startColumn:Le,endLineNumber:it,endColumn:Ge}=K;return new b.Range(Se-1,Le-1,it-1,Ge-1)}ge.to=ae})(s=e.Range||(e.Range={}));var v;(function(ge){function be(ae){switch(ae){case 1:return b.StandardTokenType.Comment;case 0:return b.StandardTokenType.Other;case 4:return b.StandardTokenType.RegEx;case 2:return b.StandardTokenType.String}}ge.to=be})(v=e.TokenType||(e.TokenType={}));var n;(function(ge){function be(K){return new b.Position(K.lineNumber-1,K.column-1)}ge.to=be;function ae(K){return{lineNumber:K.line+1,column:K.character+1}}ge.from=ae})(n=e.Position||(e.Position={}));var f;(function(ge){function be(Se,Le){return(0,g.coalesce)((0,g.asArray)(Se).map(it=>ae(it,Le)))}ge.from=be;function ae(Se,Le){if(typeof Se=="string")return{$serialized:!0,language:Se};if(Se)return{$serialized:!0,language:Se.language,scheme:K(Se.scheme,Le),pattern:typeof Se.pattern=="undefined"?void 0:le.from(Se.pattern),exclusive:Se.exclusive}}function K(Se,Le){return Le&&typeof Se=="string"?Le.transformOutgoingScheme(Se):Se}})(f=e.DocumentSelector||(e.DocumentSelector={}));var r;(function(ge){function be(K){switch(K){case b.DiagnosticTag.Unnecessary:return 1;case b.DiagnosticTag.Deprecated:return 2}}ge.from=be;function ae(K){switch(K){case 1:return b.DiagnosticTag.Unnecessary;case 2:return b.DiagnosticTag.Deprecated;default:return}}ge.to=ae})(r=e.DiagnosticTag||(e.DiagnosticTag={}));var t;(function(ge){function be(K){let Se;return K.code&&((0,E.isString)(K.code)||(0,E.isNumber)(K.code)?Se=String(K.code):Se={value:String(K.code.value),target:K.code.target}),{...s.from(K.range),message:K.message,source:K.source,code:Se,severity:l.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(u.from),tags:Array.isArray(K.tags)?(0,g.coalesce)(K.tags.map(r.from)):void 0}}ge.from=be;function ae(K){const Se=new b.Diagnostic(s.to(K),K.message,l.to(K.severity));return Se.source=K.source,Se.code=(0,E.isString)(K.code)?K.code:K.code?.value,Se.relatedInformation=K.relatedInformation&&K.relatedInformation.map(u.to),Se.tags=K.tags&&(0,g.coalesce)(K.tags.map(r.to)),Se}ge.to=ae})(t=e.Diagnostic||(e.Diagnostic={}));var u;(function(ge){function be(K){return{...s.from(K.location.range),message:K.message,resource:K.location.uri}}ge.from=be;function ae(K){return new b.DiagnosticRelatedInformation(new b.Location(K.resource,s.to(K)),K.message)}ge.to=ae})(u=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var l;(function(ge){function be(K){switch(K){case b.DiagnosticSeverity.Error:return p.MarkerSeverity.Error;case b.DiagnosticSeverity.Warning:return p.MarkerSeverity.Warning;case b.DiagnosticSeverity.Information:return p.MarkerSeverity.Info;case b.DiagnosticSeverity.Hint:return p.MarkerSeverity.Hint}return p.MarkerSeverity.Error}ge.from=be;function ae(K){switch(K){case p.MarkerSeverity.Info:return b.DiagnosticSeverity.Information;case p.MarkerSeverity.Warning:return b.DiagnosticSeverity.Warning;case p.MarkerSeverity.Error:return b.DiagnosticSeverity.Error;case p.MarkerSeverity.Hint:return b.DiagnosticSeverity.Hint;default:return b.DiagnosticSeverity.Error}}ge.to=ae})(l=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var c;(function(ge){function be(K){return typeof K=="number"&&K>=b.ViewColumn.One?K-1:K===b.ViewColumn.Beside?P.SIDE_GROUP:P.ACTIVE_GROUP}ge.from=be;function ae(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}ge.to=ae})(c=e.ViewColumn||(e.ViewColumn={}));function m(ge){return typeof ge.range!="undefined"}function d(ge){return ge.length===0?!0:!!m(ge[0])}e.isDecorationOptionsArr=d;var _;(function(ge){function be(Ge){return Ge.map(ge.from)}ge.fromMany=be;function ae(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function K(Ge){let mt;if(ae(Ge)){const{language:bt,value:vt}=Ge;mt={value:"```"+bt+`
`+vt+"\n```\n"}}else b.MarkdownString.isMarkdownString(Ge)?mt={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml}:typeof Ge=="string"?mt={value:Ge}:mt={value:""};const yt=Object.create(null);mt.uris=yt;const Et=bt=>{try{let vt=k.URI.parse(bt,!0);vt=vt.with({query:Se(vt.query,yt)}),yt[bt]=vt}catch(vt){}return""},gt=new S.Renderer;return gt.link=Et,gt.image=bt=>Et(D.parseHrefAndDimensions(bt).href),S(mt.value,{renderer:gt}),mt}ge.from=K;function Se(Ge,mt){if(!Ge)return Ge;let yt;try{yt=(0,T.parse)(Ge)}catch(gt){}if(!yt)return Ge;let Et=!1;return yt=(0,C.cloneAndChange)(yt,gt=>{if(k.URI.isUri(gt)){const bt=`__uri_${Math.random().toString(16).slice(2,8)}`;return mt[bt]=gt,Et=!0,bt}else return}),Et?JSON.stringify(yt):Ge}function Le(Ge){const mt=new b.MarkdownString(Ge.value,Ge.supportThemeIcons);return mt.isTrusted=Ge.isTrusted,mt.supportHtml=Ge.supportHtml,mt}ge.to=Le;function it(Ge){if(!!Ge)return typeof Ge=="string"?Ge:ge.from(Ge)}ge.fromStrict=it})(_=e.MarkdownString||(e.MarkdownString={}));function A(ge){return d(ge)?ge.map(be=>({range:s.from(be.range),hoverMessage:Array.isArray(be.hoverMessage)?_.fromMany(be.hoverMessage):be.hoverMessage?_.from(be.hoverMessage):void 0,renderOptions:be.renderOptions})):ge.map(be=>({range:s.from(be)}))}e.fromRangeOrRangeWithMessage=A;function R(ge){return typeof ge=="undefined"?ge:typeof ge=="string"?k.URI.file(ge):ge}e.pathOrURIToURI=R;var B;(function(ge){function be(ae){return typeof ae=="undefined"?ae:{contentText:ae.contentText,contentIconPath:ae.contentIconPath?R(ae.contentIconPath):void 0,border:ae.border,borderColor:ae.borderColor,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,color:ae.color,backgroundColor:ae.backgroundColor,margin:ae.margin,width:ae.width,height:ae.height}}ge.from=be})(B=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var U;(function(ge){function be(ae){return typeof ae=="undefined"?ae:{backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?R(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?B.from(ae.before):void 0,after:ae.after?B.from(ae.after):void 0}}ge.from=be})(U=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var F;(function(ge){function be(ae){if(typeof ae=="undefined")return ae;switch(ae){case b.DecorationRangeBehavior.OpenOpen:return 0;case b.DecorationRangeBehavior.ClosedClosed:return 1;case b.DecorationRangeBehavior.OpenClosed:return 2;case b.DecorationRangeBehavior.ClosedOpen:return 3}}ge.from=be})(F=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var $;(function(ge){function be(ae){return{isWholeLine:ae.isWholeLine,rangeBehavior:ae.rangeBehavior?F.from(ae.rangeBehavior):void 0,overviewRulerLane:ae.overviewRulerLane,light:ae.light?U.from(ae.light):void 0,dark:ae.dark?U.from(ae.dark):void 0,backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?R(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?B.from(ae.before):void 0,after:ae.after?B.from(ae.after):void 0}}ge.from=be})($=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var M;(function(ge){function be(K){return{text:K.newText,eol:K.newEol&&J.from(K.newEol),range:s.from(K.range)}}ge.from=be;function ae(K){const Se=new b.TextEdit(s.to(K.range),K.text);return Se.newEol=typeof K.eol=="undefined"?void 0:J.to(K.eol),Se}ge.to=ae})(M=e.TextEdit||(e.TextEdit={}));var z;(function(ge){function be(K,Se,Le){const it={edits:[]};if(K instanceof b.WorkspaceEdit)for(let Ge of K._allEntries())if(Ge._type===1)it.edits.push({_type:1,oldUri:Ge.from,newUri:Ge.to,options:Ge.options,metadata:Ge.metadata});else if(Ge._type===2){const mt=Se?.getDocument(Ge.uri);it.edits.push({_type:2,resource:Ge.uri,edit:M.from(Ge.edit),modelVersionId:mt?.version,metadata:Ge.metadata})}else Ge._type===3?it.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,edit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Le?.getNotebookDocument(Ge.uri,!0)?.apiNotebook.version}):Ge._type===5&&it.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Le?.getNotebookDocument(Ge.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(tt.from)}});return it}ge.from=be;function ae(K){const Se=new b.WorkspaceEdit;for(const Le of K.edits)Le.edit?Se.replace(k.URI.revive(Le.resource),s.to(Le.edit.range),Le.edit.text):Se.renameFile(k.URI.revive(Le.oldUri),k.URI.revive(Le.newUri),Le.options);return Se}ge.to=ae})(z=e.WorkspaceEdit||(e.WorkspaceEdit={}));var N;(function(ge){const be=Object.create(null);be[b.SymbolKind.File]=0,be[b.SymbolKind.Module]=1,be[b.SymbolKind.Namespace]=2,be[b.SymbolKind.Package]=3,be[b.SymbolKind.Class]=4,be[b.SymbolKind.Method]=5,be[b.SymbolKind.Property]=6,be[b.SymbolKind.Field]=7,be[b.SymbolKind.Constructor]=8,be[b.SymbolKind.Enum]=9,be[b.SymbolKind.Interface]=10,be[b.SymbolKind.Function]=11,be[b.SymbolKind.Variable]=12,be[b.SymbolKind.Constant]=13,be[b.SymbolKind.String]=14,be[b.SymbolKind.Number]=15,be[b.SymbolKind.Boolean]=16,be[b.SymbolKind.Array]=17,be[b.SymbolKind.Object]=18,be[b.SymbolKind.Key]=19,be[b.SymbolKind.Null]=20,be[b.SymbolKind.EnumMember]=21,be[b.SymbolKind.Struct]=22,be[b.SymbolKind.Event]=23,be[b.SymbolKind.Operator]=24,be[b.SymbolKind.TypeParameter]=25;function ae(Se){return typeof be[Se]=="number"?be[Se]:6}ge.from=ae;function K(Se){for(const Le in be)if(be[Le]===Se)return Number(Le);return b.SymbolKind.Property}ge.to=K})(N=e.SymbolKind||(e.SymbolKind={}));var x;(function(ge){function be(K){switch(K){case b.SymbolTag.Deprecated:return 1}}ge.from=be;function ae(K){switch(K){case 1:return b.SymbolTag.Deprecated}}ge.to=ae})(x=e.SymbolTag||(e.SymbolTag={}));var j;(function(ge){function be(K){return{name:K.name,kind:N.from(K.kind),tags:K.tags&&K.tags.map(x.from),containerName:K.containerName,location:Q.from(K.location)}}ge.from=be;function ae(K){const Se=new b.SymbolInformation(K.name,N.to(K.kind),K.containerName,Q.to(K.location));return Se.tags=K.tags&&K.tags.map(x.to),Se}ge.to=ae})(j=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var O;(function(ge){function be(K){const Se={name:K.name||"!!MISSING: name!!",detail:K.detail,range:s.from(K.range),selectionRange:s.from(K.selectionRange),kind:N.from(K.kind),tags:K.tags?.map(x.from)??[]};return K.children&&(Se.children=K.children.map(be)),Se}ge.from=be;function ae(K){const Se=new b.DocumentSymbol(K.name,K.detail,N.to(K.kind),s.to(K.range),s.to(K.selectionRange));return(0,g.isNonEmptyArray)(K.tags)&&(Se.tags=K.tags.map(x.to)),K.children&&(Se.children=K.children.map(ae)),Se}ge.to=ae})(O=e.DocumentSymbol||(e.DocumentSymbol={}));var H;(function(ge){function be(K){const Se=new b.CallHierarchyItem(N.to(K.kind),K.name,K.detail||"",k.URI.revive(K.uri),s.to(K.range),s.to(K.selectionRange));return Se._sessionId=K._sessionId,Se._itemId=K._itemId,Se}ge.to=be;function ae(K,Se,Le){if(Se=Se??K._sessionId,Le=Le??K._itemId,Se===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Se,_itemId:Le,name:K.name,detail:K.detail,kind:N.from(K.kind),uri:K.uri,range:s.from(K.range),selectionRange:s.from(K.selectionRange),tags:K.tags?.map(x.from)}}ge.from=ae})(H=e.CallHierarchyItem||(e.CallHierarchyItem={}));var W;(function(ge){function be(ae){return new b.CallHierarchyIncomingCall(H.to(ae.from),ae.fromRanges.map(K=>s.to(K)))}ge.to=be})(W=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var X;(function(ge){function be(ae){return new b.CallHierarchyOutgoingCall(H.to(ae.to),ae.fromRanges.map(K=>s.to(K)))}ge.to=be})(X=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Q;(function(ge){function be(K){return{range:K.range&&s.from(K.range),uri:K.uri}}ge.from=be;function ae(K){return new b.Location(k.URI.revive(K.uri),s.to(K.range))}ge.to=ae})(Q=e.location||(e.location={}));var de;(function(ge){function be(K){const Se=K,Le=K;return{originSelectionRange:Se.originSelectionRange?s.from(Se.originSelectionRange):void 0,uri:Se.targetUri?Se.targetUri:Le.uri,range:s.from(Se.targetRange?Se.targetRange:Le.range),targetSelectionRange:Se.targetSelectionRange?s.from(Se.targetSelectionRange):void 0}}ge.from=be;function ae(K){return{targetUri:k.URI.revive(K.uri),targetRange:s.to(K.range),targetSelectionRange:K.targetSelectionRange?s.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?s.to(K.originSelectionRange):void 0}}ge.to=ae})(de=e.DefinitionLink||(e.DefinitionLink={}));var _e;(function(ge){function be(K){return{range:s.from(K.range),contents:_.fromMany(K.contents)}}ge.from=be;function ae(K){return new b.Hover(K.contents.map(_.to),s.to(K.range))}ge.to=ae})(_e=e.Hover||(e.Hover={}));var Ce;(function(ge){function be(K){return{range:s.from(K.range),expression:K.expression}}ge.from=be;function ae(K){return new b.EvaluatableExpression(s.to(K.range),K.expression)}ge.to=ae})(Ce=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Pe;(function(ge){function be(K){if(K instanceof b.InlineValueText)return{type:"text",range:s.from(K.range),text:K.text};if(K instanceof b.InlineValueVariableLookup)return{type:"variable",range:s.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof b.InlineValueEvaluatableExpression)return{type:"expression",range:s.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}ge.from=be;function ae(K){switch(K.type){case"text":return{range:s.to(K.range),text:K.text};case"variable":return{range:s.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:s.to(K.range),expression:K.expression}}}ge.to=ae})(Pe=e.InlineValue||(e.InlineValue={}));var Be;(function(ge){function be(K){return{frameId:K.frameId,stoppedLocation:s.from(K.stoppedLocation)}}ge.from=be;function ae(K){return new b.InlineValueContext(K.frameId,s.to(K.stoppedLocation))}ge.to=ae})(Be=e.InlineValueContext||(e.InlineValueContext={}));var We;(function(ge){function be(K){return{range:s.from(K.range),kind:K.kind}}ge.from=be;function ae(K){return new b.DocumentHighlight(s.to(K.range),K.kind)}ge.to=ae})(We=e.DocumentHighlight||(e.DocumentHighlight={}));var He;(function(ge){function be(ae){switch(ae){case 1:return b.CompletionTriggerKind.TriggerCharacter;case 2:return b.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return b.CompletionTriggerKind.Invoke}}ge.to=be})(He=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var G;(function(ge){function be(ae){return{triggerKind:He.to(ae.triggerKind),triggerCharacter:ae.triggerCharacter}}ge.to=be})(G=e.CompletionContext||(e.CompletionContext={}));var ee;(function(ge){function be(K){switch(K){case b.CompletionItemTag.Deprecated:return 1}}ge.from=be;function ae(K){switch(K){case 1:return b.CompletionItemTag.Deprecated}}ge.to=ae})(ee=e.CompletionItemTag||(e.CompletionItemTag={}));var ie;(function(ge){const be=new Map([[b.CompletionItemKind.Method,0],[b.CompletionItemKind.Function,1],[b.CompletionItemKind.Constructor,2],[b.CompletionItemKind.Field,3],[b.CompletionItemKind.Variable,4],[b.CompletionItemKind.Class,5],[b.CompletionItemKind.Interface,7],[b.CompletionItemKind.Struct,6],[b.CompletionItemKind.Module,8],[b.CompletionItemKind.Property,9],[b.CompletionItemKind.Unit,12],[b.CompletionItemKind.Value,13],[b.CompletionItemKind.Constant,14],[b.CompletionItemKind.Enum,15],[b.CompletionItemKind.EnumMember,16],[b.CompletionItemKind.Keyword,17],[b.CompletionItemKind.Snippet,27],[b.CompletionItemKind.Text,18],[b.CompletionItemKind.Color,19],[b.CompletionItemKind.File,20],[b.CompletionItemKind.Reference,21],[b.CompletionItemKind.Folder,23],[b.CompletionItemKind.Event,10],[b.CompletionItemKind.Operator,11],[b.CompletionItemKind.TypeParameter,24],[b.CompletionItemKind.Issue,26],[b.CompletionItemKind.User,25]]);function ae(Le){return be.get(Le)??9}ge.from=ae;const K=new Map([[0,b.CompletionItemKind.Method],[1,b.CompletionItemKind.Function],[2,b.CompletionItemKind.Constructor],[3,b.CompletionItemKind.Field],[4,b.CompletionItemKind.Variable],[5,b.CompletionItemKind.Class],[7,b.CompletionItemKind.Interface],[6,b.CompletionItemKind.Struct],[8,b.CompletionItemKind.Module],[9,b.CompletionItemKind.Property],[12,b.CompletionItemKind.Unit],[13,b.CompletionItemKind.Value],[14,b.CompletionItemKind.Constant],[15,b.CompletionItemKind.Enum],[16,b.CompletionItemKind.EnumMember],[17,b.CompletionItemKind.Keyword],[27,b.CompletionItemKind.Snippet],[18,b.CompletionItemKind.Text],[19,b.CompletionItemKind.Color],[20,b.CompletionItemKind.File],[21,b.CompletionItemKind.Reference],[23,b.CompletionItemKind.Folder],[10,b.CompletionItemKind.Event],[11,b.CompletionItemKind.Operator],[24,b.CompletionItemKind.TypeParameter],[25,b.CompletionItemKind.User],[26,b.CompletionItemKind.Issue]]);function Se(Le){return K.get(Le)??b.CompletionItemKind.Property}ge.to=Se})(ie=e.CompletionItemKind||(e.CompletionItemKind={}));var ce;(function(ge){function be(ae,K){const Se=new b.CompletionItem(ae.label);return Se.insertText=ae.insertText,Se.kind=ie.to(ae.kind),Se.tags=ae.tags?.map(ee.to),Se.detail=ae.detail,Se.documentation=D.isMarkdownString(ae.documentation)?_.to(ae.documentation):ae.documentation,Se.sortText=ae.sortText,Se.filterText=ae.filterText,Se.preselect=ae.preselect,Se.commitCharacters=ae.commitCharacters,i.Range.isIRange(ae.range)?Se.range=s.to(ae.range):typeof ae.range=="object"&&(Se.range={inserting:s.to(ae.range.insert),replacing:s.to(ae.range.replace)}),Se.keepWhitespace=typeof ae.insertTextRules=="undefined"?!1:Boolean(ae.insertTextRules&1),typeof ae.insertTextRules!="undefined"&&ae.insertTextRules&4?Se.insertText=new b.SnippetString(ae.insertText):(Se.insertText=ae.insertText,Se.textEdit=Se.range instanceof b.Range?new b.TextEdit(Se.range,Se.insertText):void 0),ae.additionalTextEdits&&ae.additionalTextEdits.length>0&&(Se.additionalTextEdits=ae.additionalTextEdits.map(Le=>M.to(Le))),Se.command=K&&ae.command?K.fromInternal(ae.command):void 0,Se}ge.to=be})(ce=e.CompletionItem||(e.CompletionItem={}));var Z;(function(ge){function be(K){return{label:K.label,documentation:K.documentation?_.fromStrict(K.documentation):void 0}}ge.from=be;function ae(K){return{label:K.label,documentation:D.isMarkdownString(K.documentation)?_.to(K.documentation):K.documentation}}ge.to=ae})(Z=e.ParameterInformation||(e.ParameterInformation={}));var re;(function(ge){function be(K){return{label:K.label,documentation:K.documentation?_.fromStrict(K.documentation):void 0,parameters:Array.isArray(K.parameters)?K.parameters.map(Z.from):[],activeParameter:K.activeParameter}}ge.from=be;function ae(K){return{label:K.label,documentation:D.isMarkdownString(K.documentation)?_.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(Z.to):[],activeParameter:K.activeParameter}}ge.to=ae})(re=e.SignatureInformation||(e.SignatureInformation={}));var pe;(function(ge){function be(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(re.from):[]}}ge.from=be;function ae(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(re.to):[]}}ge.to=ae})(pe=e.SignatureHelp||(e.SignatureHelp={}));var Me;(function(ge){function be(K){return{text:K.text,position:n.from(K.position),kind:je.from(K.kind??b.InlayHintKind.Other),whitespaceBefore:K.whitespaceBefore,whitespaceAfter:K.whitespaceAfter}}ge.from=be;function ae(K){const Se=new b.InlayHint(K.text,n.to(K.position),je.to(K.kind));return Se.whitespaceAfter=K.whitespaceAfter,Se.whitespaceBefore=K.whitespaceBefore,Se}ge.to=ae})(Me=e.InlayHint||(e.InlayHint={}));var je;(function(ge){function be(K){return K}ge.from=be;function ae(K){return K}ge.to=ae})(je=e.InlayHintKind||(e.InlayHintKind={}));var Ke;(function(ge){function be(K){return{range:s.from(K.range),url:K.target,tooltip:K.tooltip}}ge.from=be;function ae(K){let Se;if(K.url)try{Se=typeof K.url=="string"?k.URI.parse(K.url,!0):k.URI.revive(K.url)}catch(Le){}return new b.DocumentLink(s.to(K.range),Se)}ge.to=ae})(Ke=e.DocumentLink||(e.DocumentLink={}));var Ze;(function(ge){function be(K){const Se=new b.ColorPresentation(K.label);return K.textEdit&&(Se.textEdit=M.to(K.textEdit)),K.additionalTextEdits&&(Se.additionalTextEdits=K.additionalTextEdits.map(Le=>M.to(Le))),Se}ge.to=be;function ae(K){return{label:K.label,textEdit:K.textEdit?M.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Se=>M.from(Se)):void 0}}ge.from=ae})(Ze=e.ColorPresentation||(e.ColorPresentation={}));var rt;(function(ge){function be(K){return new b.Color(K[0],K[1],K[2],K[3])}ge.to=be;function ae(K){return[K.red,K.green,K.blue,K.alpha]}ge.from=ae})(rt=e.Color||(e.Color={}));var ct;(function(ge){function be(K){return{range:s.from(K.range)}}ge.from=be;function ae(K){return new b.SelectionRange(s.to(K.range))}ge.to=ae})(ct=e.SelectionRange||(e.SelectionRange={}));var ye;(function(ge){function be(ae){switch(ae){case 2:return b.TextDocumentSaveReason.AfterDelay;case 1:return b.TextDocumentSaveReason.Manual;case 3:case 4:return b.TextDocumentSaveReason.FocusOut}}ge.to=be})(ye=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var at;(function(ge){function be(K){switch(K){case b.TextEditorLineNumbersStyle.Off:return 0;case b.TextEditorLineNumbersStyle.Relative:return 2;case b.TextEditorLineNumbersStyle.On:default:return 1}}ge.from=be;function ae(K){switch(K){case 0:return b.TextEditorLineNumbersStyle.Off;case 2:return b.TextEditorLineNumbersStyle.Relative;case 1:default:return b.TextEditorLineNumbersStyle.On}}ge.to=ae})(at=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var J;(function(ge){function be(K){if(K===b.EndOfLine.CRLF)return 1;if(K===b.EndOfLine.LF)return 0}ge.from=be;function ae(K){if(K===1)return b.EndOfLine.CRLF;if(K===0)return b.EndOfLine.LF}ge.to=ae})(J=e.EndOfLine||(e.EndOfLine={}));var ne;(function(ge){function be(ae){if(typeof ae=="object")return ae.viewId;switch(ae){case b.ProgressLocation.SourceControl:return 3;case b.ProgressLocation.Window:return 10;case b.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ge.from=be})(ne=e.ProgressLocation||(e.ProgressLocation={}));var Ee;(function(ge){function be(ae){const K={start:ae.start+1,end:ae.end+1};return ae.kind&&(K.kind=Qe.from(ae.kind)),K}ge.from=be})(Ee=e.FoldingRange||(e.FoldingRange={}));var Qe;(function(ge){function be(ae){if(ae)switch(ae){case b.FoldingRangeKind.Comment:return I.FoldingRangeKind.Comment;case b.FoldingRangeKind.Imports:return I.FoldingRangeKind.Imports;case b.FoldingRangeKind.Region:return I.FoldingRangeKind.Region}}ge.from=be})(Qe=e.FoldingRangeKind||(e.FoldingRangeKind={}));var et;(function(ge){function be(ae){if(ae)return{pinned:typeof ae.preview=="boolean"?!ae.preview:void 0,inactive:ae.background,preserveFocus:ae.preserveFocus,selection:typeof ae.selection=="object"?s.from(ae.selection):void 0,override:typeof ae.override=="boolean"?a.EditorResolution.DISABLED:void 0}}ge.from=be})(et=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var le;(function(ge){function be(K){return K instanceof b.RelativePattern||typeof K=="string"?K:ae(K)?new b.RelativePattern(K.base,K.pattern):K}ge.from=be;function ae(K){const Se=K;return Se&&typeof Se.base=="string"&&typeof Se.pattern=="string"}})(le=e.GlobPattern||(e.GlobPattern={}));var Ie;(function(ge){function be(ae){if(ae){if(Array.isArray(ae))return ae.map(be);if(typeof ae=="string")return ae;{const K=ae;return{language:K.language,scheme:K.scheme,pattern:typeof K.pattern=="undefined"?void 0:le.from(K.pattern),exclusive:K.exclusive}}}else return}ge.from=be})(Ie=e.LanguageSelector||(e.LanguageSelector={}));var Ne;(function(ge){function be(K){return{start:K.start,end:K.end}}ge.from=be;function ae(K){return new b.NotebookRange(K.start,K.end)}ge.to=ae})(Ne=e.NotebookRange||(e.NotebookRange={}));var Xe;(function(ge){function be(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}ge.to=be;function ae(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}ge.from=ae})(Xe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var nt;(function(ge){function be(K){switch(K){case b.NotebookCellKind.Markup:return w.CellKind.Markup;case b.NotebookCellKind.Code:default:return w.CellKind.Code}}ge.from=be;function ae(K){switch(K){case w.CellKind.Markup:return b.NotebookCellKind.Markup;case w.CellKind.Code:default:return b.NotebookCellKind.Code}}ge.to=ae})(nt=e.NotebookCellKind||(e.NotebookCellKind={}));var ft;(function(ge){function be(K){const Se={metadata:K.metadata??Object.create(null),cells:[]};for(let Le of K.cells)b.NotebookCellData.validate(Le),Se.cells.push(tt.from(Le));return Se}ge.from=be;function ae(K){const Se=new b.NotebookData(K.cells.map(tt.to));return(0,E.isEmptyObject)(K.metadata)||(Se.metadata=K.metadata),Se}ge.to=ae})(ft=e.NotebookData||(e.NotebookData={}));var tt;(function(ge){function be(K){return{cellKind:nt.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:Xe.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(Re.from):[]}}ge.from=be;function ae(K){return new b.NotebookCellData(nt.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(Re.to):void 0,K.metadata,K.internalMetadata?Xe.to(K.internalMetadata):void 0)}ge.to=ae})(tt=e.NotebookCellData||(e.NotebookCellData={}));var ut;(function(ge){function be(K){return{mime:K.mime,valueBytes:L.VSBuffer.wrap(K.data)}}ge.from=be;function ae(K){return new b.NotebookCellOutputItem(K.valueBytes.buffer,K.mime)}ge.to=ae})(ut=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Re;(function(ge){function be(K){return{outputId:K.id,items:K.items.map(ut.from),metadata:K.metadata}}ge.from=be;function ae(K){const Se=K.items.map(ut.to);return new b.NotebookCellOutput(Se,K.outputId,K.metadata)}ge.to=ae})(Re=e.NotebookCellOutput||(e.NotebookCellOutput={}));var De;(function(ge){function be(Le){if(Le!=null){if(Le instanceof b.RelativePattern||typeof Le=="string")return Le;if(Se(Le))return new b.RelativePattern(Le.base,Le.pattern);if(K(Le))return{include:le.from(Le.include)||void 0,exclude:le.from(Le.exclude)||void 0}}}ge.from=be;function ae(Le){return typeof Le=="string"?Le:Se(Le)?{base:Le.base,pattern:Le.pattern}:{include:Le.include,exclude:Le.exclude}}ge.to=ae;function K(Le){const it=Le,Ge=le.from(it.include);if(!(Ge&&Ge instanceof b.RelativePattern||typeof Ge=="string"))return!1;const mt=le.from(it.exclude);return!!(mt&&mt instanceof b.RelativePattern||typeof mt=="string")}function Se(Le){const it=Le;return it&&typeof it.base=="string"&&typeof it.pattern=="string"}})(De=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Te;(function(ge){function be(ae){return{backgroundColor:ae.backgroundColor,borderColor:ae.borderColor,top:ae.top?B.from(ae.top):void 0}}ge.from=be})(Te=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var se;(function(ge){function be(ae,K,Se){const Le=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{alignment:ae.alignment===b.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(Le,Se),text:ae.text,tooltip:ae.tooltip,accessibilityInformation:ae.accessibilityInformation,priority:ae.priority}}ge.from=be})(se=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ue;(function(ge){function be(ae){return{transientOutputs:ae?.transientOutputs??!1,transientCellMetadata:ae?.transientCellMetadata??{},transientDocumentMetadata:ae?.transientDocumentMetadata??{}}}ge.from=be})(ue=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var we;(function(ge){function be(K){return{uri:K.uri,provides:K.provides}}ge.from=be;function ae(K){return new b.NotebookRendererScript(k.URI.revive(K.uri),K.provides)}ge.to=ae})(we=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ve;(function(ge){function be(K){return{message:_.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,location:K.location?Q.from(K.location):void 0}}ge.from=be;function ae(K){const Se=new b.TestMessage(typeof K.message=="string"?K.message:_.to(K.message));return Se.actualOutput=K.actual,Se.expectedOutput=K.expected,Se.location=K.location?Q.to(K.location):void 0,Se}ge.to=ae})(ve=e.TestMessage||(e.TestMessage={}));var Fe;(function(ge){let be;(function(ae){ae.Delimiter="\0"})(be||(be={})),ge.namespace=(ae,K)=>ae+"\0"+K,ge.denamespace=ae=>{const K=ae.indexOf("\0");return{ctrlId:ae.slice(0,K),tagId:ae.slice(K+1)}}})(Fe=e.TestTag||(e.TestTag={}));var qe;(function(ge){function be(Le){const it=(0,h.getPrivateApiFor)(Le).controllerId;return{extId:y.TestId.fromExtHostTestItem(Le,it).toString(),label:Le.label,uri:Le.uri,tags:Le.tags.map(Ge=>Fe.namespace(it,Ge.id)),range:s.from(Le.range)||null,description:Le.description||null,error:Le.error&&_.fromStrict(Le.error)||null}}ge.from=be;function ae(Le){return{parent:void 0,error:void 0,id:y.TestId.fromString(Le.extId).localId,label:Le.label,uri:k.URI.revive(Le.uri),tags:(Le.tags||[]).map(it=>{const{tagId:Ge}=Fe.denamespace(it);return new b.TestTag(Ge)}),range:s.to(Le.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Le.description||void 0}}ge.toPlain=ae;function K(Le){const it=y.TestId.fromString(Le.extId),Ge=new h.TestItemImpl(it.controllerId,it.localId,Le.label,k.URI.revive(Le.uri));return Ge.range=s.to(Le.range||void 0),Ge.description=Le.description||void 0,Ge}function Se(Le){let it;for(const Ge of Le.tests){const mt=K(Ge.item);(0,h.getPrivateApiFor)(mt).parent=it,it=mt}return it}ge.toItemFromContext=Se})(qe=e.TestItem||(e.TestItem={})),function(ge){function be(K){return{id:K.id}}ge.from=be;function ae(K){return new b.TestTag(K.id)}ge.to=ae}(Fe=e.TestTag||(e.TestTag={}));var ze;(function(ge){const be=(K,Se)=>{const Le={...qe.toPlain(K.item),parent:void 0,taskStates:K.tasks.map(it=>({state:it.state,duration:it.duration,messages:it.messages.filter(Ge=>Ge.type===0).map(ve.to)})),children:K.children.map(it=>Se.get(it)).filter(E.isDefined).map(it=>be(it,Se))};for(const it of Le.children)it.parent=Le;return Le};function ae(K){const Se=[],Le=new Map;for(const it of K.items)Le.set(it.item.extId,it),K.request.targets.some(Ge=>Ge.controllerId===it.controllerId&&Ge.testIds.includes(it.item.extId))&&Se.push(it);return{completedAt:K.completedAt,results:Se.map(it=>be(it,Le))}}ge.to=ae})(ze=e.TestResults||(e.TestResults={}));var Ye;(function(ge){function be(Le){return{covered:Le.covered,total:Le.covered}}function ae(Le){return"line"in Le?n.from(Le):s.from(Le)}function K(Le){return"branches"in Le?{count:Le.executionCount,location:ae(Le.location),type:1,branches:Le.branches.length?Le.branches.map(it=>({count:it.executionCount,location:it.location&&ae(it.location)})):void 0}:{type:0,count:Le.executionCount,location:ae(Le.location)}}ge.fromDetailed=K;function Se(Le){return{uri:Le.uri,statement:be(Le.statementCoverage),branch:Le.branchCoverage&&be(Le.branchCoverage),function:Le.functionCoverage&&be(Le.functionCoverage),details:Le.detailedCoverage?.map(K)}}ge.fromFile=Se})(Ye=e.TestCoverage||(e.TestCoverage={}));var lt;(function(ge){function be(ae){switch(ae){case 1:return b.CodeActionTriggerKind.Invoke;case 2:return b.CodeActionTriggerKind.Automatic}}ge.to=be})(lt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var xe;(function(ge){function be(K){const Se=new b.TypeHierarchyItem(N.to(K.kind),K.name,K.detail||"",k.URI.revive(K.uri),s.to(K.range),s.to(K.selectionRange));return Se._sessionId=K._sessionId,Se._itemId=K._itemId,Se}ge.to=be;function ae(K,Se,Le){if(Se=Se??K._sessionId,Le=Le??K._itemId,Se===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Se,_itemId:Le,kind:N.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:s.from(K.range),selectionRange:s.from(K.selectionRange),tags:K.tags?.map(x.from)}}ge.from=ae})(xe=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(fe[221],me([0,1,2,18,7,17,94]),function(Y,e,g,L,D,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class C{constructor(k,i,I,a={timeout:1500,errors:3}){this._logService=k,this._documents=i,this._mainThreadBulkEdits=I,this._thresholds=a,this._callbacks=new T.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(k){return(i,I,a)=>{const h={dispose:this._callbacks.push([i,I,k])};return Array.isArray(a)&&a.push(h),h}}async $participateInSave(k,i){const I=g.URI.revive(k);let a=!1;const p=setTimeout(()=>a=!0,this._thresholds.timeout),h=[];try{for(let w of[...this._callbacks]){if(a)break;const y=this._documents.getDocument(I),P=await this._deliverEventAsyncAndBlameBadListeners(w,{document:y,reason:S.TextDocumentSaveReason.to(i)});h.push(P)}}finally{clearTimeout(p)}return h}_deliverEventAsyncAndBlameBadListeners([k,i,I],a){const p=this._badListeners.get(k);return typeof p=="number"&&p>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,k,i,a).then(()=>!0,h=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(h),!(h instanceof Error)||h.message!=="concurrent_edits"){const w=this._badListeners.get(k);this._badListeners.set(k,w?w+1:1),typeof w=="number"&&w>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(k,i,I,a){const p=[],h=Date.now(),{document:w,reason:y}=a,{version:P}=w,b=Object.freeze({document:w,reason:y,waitUntil(o){if(Object.isFrozen(p))throw(0,L.illegalState)("waitUntil can not be called async");p.push(Promise.resolve(o))}});try{i.apply(I,[b])}catch(o){return Promise.reject(o)}return Object.freeze(p),new Promise((o,s)=>{const v=setTimeout(()=>s(new Error("timeout")),this._thresholds.timeout);return Promise.all(p).then(n=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-h}ms`),clearTimeout(v),o(n)}).catch(n=>{clearTimeout(v),s(n)})}).then(o=>{const s={edits:[]};for(const v of o)if(Array.isArray(v)&&v.every(n=>n instanceof D.TextEdit))for(const{newText:n,newEol:f,range:r}of v)s.edits.push({_type:2,resource:w.uri,edit:{range:r&&S.Range.from(r),text:n,eol:f&&S.EndOfLine.from(f)}});if(s.edits.length!==0)return P===w.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(s):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=C}),define(fe[222],me([0,1,3,30,2,17,7]),function(Y,e,g,L,D,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class C{constructor(i,I,a,p,h){this._onDidCreate=new g.Emitter,this._onDidChange=new g.Emitter,this._onDidDelete=new g.Emitter,this._config=0,a&&(this._config+=1),p&&(this._config+=2),h&&(this._config+=4);const w=(0,L.parse)(I),y=i(P=>{if(!a)for(let b of P.created){const o=D.URI.revive(b);w(o.fsPath)&&this._onDidCreate.fire(o)}if(!p)for(let b of P.changed){const o=D.URI.revive(b);w(o.fsPath)&&this._onDidChange.fire(o)}if(!h)for(let b of P.deleted){const o=D.URI.revive(b);w(o.fsPath)&&this._onDidDelete.fire(o)}});this._disposable=T.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,y)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class E{constructor(i,I,a){this._logService=I,this._extHostDocumentsAndEditors=a,this._onFileSystemEvent=new g.Emitter,this._onDidRenameFile=new g.Emitter,this._onDidCreateFile=new g.Emitter,this._onDidDeleteFile=new g.Emitter,this._onWillRenameFile=new g.AsyncEmitter,this._onWillCreateFile=new g.AsyncEmitter,this._onWillDeleteFile=new g.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(i,I,a,p){return new C(this._onFileSystemEvent.event,i,I,a,p)}$onFileEvent(i){this._onFileSystemEvent.fire(i)}$onDidRunFileOperation(i,I){switch(i){case 2:this._onDidRenameFile.fire(Object.freeze({files:I.map(a=>({oldUri:D.URI.revive(a.source),newUri:D.URI.revive(a.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:I.map(a=>D.URI.revive(a.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:I.map(a=>D.URI.revive(a.target))}));break;default:}}getOnWillRenameFileEvent(i){return this._createWillExecuteEvent(i,this._onWillRenameFile)}getOnWillCreateFileEvent(i){return this._createWillExecuteEvent(i,this._onWillCreateFile)}getOnWillDeleteFileEvent(i){return this._createWillExecuteEvent(i,this._onWillDeleteFile)}_createWillExecuteEvent(i,I){return(a,p,h)=>{const w=function(P){a.call(p,P)};return w.extension=i,I.event(w,void 0,h)}}async $onWillRunFileOperation(i,I,a,p){switch(i){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:I.map(h=>({oldUri:D.URI.revive(h.source),newUri:D.URI.revive(h.target)}))},a,p);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:I.map(h=>D.URI.revive(h.target))},a,p);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:I.map(h=>D.URI.revive(h.target))},a,p)}}async _fireWillEvent(i,I,a,p){const h=new Set,w=[];if(await i.fireAsync(I,p,async(P,b)=>{const o=Date.now(),s=await Promise.resolve(P);s instanceof T.WorkspaceEdit&&(w.push(s),h.add(b.extension.displayName??b.extension.identifier.value)),Date.now()-o>a&&this._logService.warn("SLOW file-participant",b.extension.identifier)}),p.isCancellationRequested||w.length===0)return;const y={edits:[]};for(let P of w){let{edits:b}=S.WorkspaceEdit.from(P,this._extHostDocumentsAndEditors);y.edits=y.edits.concat(b)}return{edit:y,extensionNames:Array.from(h)}}}e.ExtHostFileSystemEventService=E}),define(fe[223],me([0,1,10,25,2,17,7,126]),function(Y,e,g,L,D,S,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class E{constructor(a,p,h,w){this.start=a,this.deletedCount=p,this.deletedItems=h,this.items=w}static asApiEvents(a){return a.map(p=>({start:p.start,deletedCount:p.deletedCount,deletedItems:p.deletedItems,items:p.items.map(h=>h.apiCell)}))}}class k{constructor(a,p,h){this.notebook=a,this._extHostDocument=p,this._cellData=h,this.handle=h.handle,this.uri=D.URI.revive(h.uri),this.cellKind=h.cellKind,this._outputs=h.outputs.map(S.NotebookCellOutput.to),this._internalMetadata=h.internalMetadata??{},this._metadata=Object.freeze(h.metadata??{}),this._previousResult=Object.freeze(S.NotebookCellExecutionSummary.to(h.internalMetadata??{}))}static asModelAddData(a,p){return{EOL:p.eol,lines:p.source,languageId:p.language,uri:p.uri,isDirty:!1,versionId:1,notebook:a}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const a=this,p=this._extHostDocument.getDocument(this.uri);if(!p)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return a.notebook.getCellIndex(a)},notebook:a.notebook.apiNotebook,kind:S.NotebookCellKind.to(this._cellData.cellKind),document:p.document,get mime(){return a._mime},set mime(h){a._mime=h},get outputs(){return a._outputs.slice(0)},get metadata(){return a._metadata},get executionSummary(){return a._previousResult}})}return this._apiCell}setOutputs(a){this._outputs=a.map(S.NotebookCellOutput.to)}setOutputItems(a,p,h){const w=h.map(S.NotebookCellOutputItem.to),y=this._outputs.find(P=>P.id===a);y&&(p||(y.items.length=0),y.items.push(...w))}setMetadata(a){this._metadata=Object.freeze(a)}setInternalMetadata(a){this._internalMetadata=a,this._previousResult=Object.freeze(S.NotebookCellExecutionSummary.to(a))}setMime(a){}}e.ExtHostCell=k;class i{constructor(a,p,h,w,y,P){this._proxy=a,this._textDocumentsAndEditors=p,this._textDocuments=h,this._emitter=w,this.uri=y,this.handle=i._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=P.viewType,this._metadata=Object.freeze(P.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,P.cells]],!0),this._versionId=P.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const a=this;this._notebook={get uri(){return a.uri},get version(){return a._versionId},get notebookType(){return a._notebookType},get isDirty(){return a._isDirty},get isUntitled(){return a.uri.scheme===g.Schemas.untitled},get isClosed(){return a._disposed},get metadata(){return a._metadata},get cellCount(){return a._cells.length},cellAt(p){return p=a._validateIndex(p),a._cells[p].apiCell},getCells(p){return(p?a._getCells(p):a._cells).map(w=>w.apiCell)},save(){return a._save()}}}return this._notebook}updateBackup(a){this._backup?.delete(),this._backup=a}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(a){a.metadata&&(this._metadata=Object.freeze({...this._metadata,...a.metadata}))}acceptDirty(a){this._isDirty=a}acceptModelChanged(a,p){this._versionId=a.versionId,this._isDirty=p;for(const h of a.rawEvents)h.kind===C.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(h.changes,!1):h.kind===C.NotebookCellsChangeType.Move?this._moveCell(h.index,h.newIdx):h.kind===C.NotebookCellsChangeType.Output?this._setCellOutputs(h.index,h.outputs):h.kind===C.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(h.index,h.outputId,h.append,h.outputItems):h.kind===C.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(h.index,h.language):h.kind===C.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(h.index,h.mime):h.kind===C.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(h.index,h.metadata):h.kind===C.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(h.index,h.internalMetadata)}_validateIndex(a){return a=a|0,a<0?0:a>=this._cells.length?this._cells.length-1:a}_validateRange(a){let p=a.start|0,h=a.end|0;return p<0&&(p=0),h>this._cells.length&&(h=this._cells.length),a.with({start:p,end:h})}_getCells(a){a=this._validateRange(a);const p=[];for(let h=a.start;h<a.end;h++)p.push(this._cells[h]);return p}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(a,p){if(this._disposed)return;const h=[],w=[],y=[];a.reverse().forEach(P=>{const o=P[2].map(n=>{const f=new k(this,this._textDocumentsAndEditors,n);return p||w.push(k.asModelAddData(this.apiNotebook,n)),f}),s=new E(P[0],P[1],[],o),v=this._cells.splice(P[0],P[1],...o);for(const n of v)y.push(n.uri),s.deletedItems.push(n.apiCell);h.push(s)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:w,removedDocuments:y}),p||this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:E.asApiEvents(h)}))}_moveCell(a,p){const h=this._cells.splice(a,1);this._cells.splice(p,0,...h);const w=[new E(a,1,h.map(y=>y.apiCell),[]),new E(p,0,[],h)];this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:E.asApiEvents(w)}))}_setCellOutputs(a,p){const h=this._cells[a];h.setOutputs(p),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[h.apiCell]}))}_setCellOutputItems(a,p,h,w){const y=this._cells[a];y.setOutputItems(p,h,w),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[y.apiCell]}))}_changeCellLanguage(a,p){const h=this._cells[a];h.apiCell.document.languageId!==p&&this._textDocuments.$acceptModelModeChanged(h.uri,p)}_changeCellMime(a,p){const h=this._cells[a];h.apiCell.mime=p}_changeCellMetadata(a,p){const h=this._cells[a],w=h.apiCell.metadata;h.setMetadata(p);const y=h.apiCell.metadata;(0,L.equals)(w,y)||this._emitter.emitCellMetadataChange((0,L.deepFreeze)({document:this.apiNotebook,cell:h.apiCell}))}_changeCellInternalMetadata(a,p){const h=this._cells[a],w=h.internalMetadata;if(h.setInternalMetadata(p),w.runState!==p.runState){const y=p.runState??T.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,L.deepFreeze)({document:this.apiNotebook,cell:h.apiCell,state:y}))}}getCellFromApiCell(a){return this._cells.find(p=>p.apiCell===a)}getCellFromIndex(a){return this._cells[a]}getCell(a){return this._cells.find(p=>p.handle===a)}getCellIndex(a){return this._cells.indexOf(a)}}e.ExtHostNotebookDocument=i,i._handlePool=0}),define(fe[129],me([0,1,7,17,18]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class S{constructor(E){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=E}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(E){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:E})}replaceCellMetadata(E,k){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:E,metadata:k})}replaceCells(E,k,i){this._throwIfFinalized(),!(E===k&&i.length===0)&&this._collectedEdits.push({editType:1,index:E,count:k-E,cells:i.map(L.NotebookCellData.from)})}}class T{constructor(E,k,i,I,a,p){this.id=E,this._proxy=k,this.notebookData=i,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=a,this._visibleRanges=I,this._viewColumn=p}get apiEditor(){if(!this._editor){const E=this;this._editor={get document(){return E.notebookData.apiNotebook},get selections(){return E._selections},set selections(k){if(!Array.isArray(k)||!k.every(g.NotebookRange.isNotebookRange))throw(0,D.illegalArgument)("selections");E._selections=k,E._trySetSelections(k)},get visibleRanges(){return E._visibleRanges},revealRange(k,i){E._proxy.$tryRevealRange(E.id,L.NotebookRange.from(k),i??g.NotebookEditorRevealType.Default)},get viewColumn(){return E._viewColumn},edit(k){const i=new S(this.document.version);return k(i),E._applyEdit(i.finalize())},setDecorations(k,i){return E.setDecorations(k,i)}},T.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(E){this._visible=E}_acceptVisibleRanges(E){this._visibleRanges=E}_acceptSelections(E){this._selections=E}_trySetSelections(E){this._proxy.$trySetSelections(this.id,E.map(L.NotebookRange.from))}_acceptViewColumn(E){this._viewColumn=E}_applyEdit(E){if(E.cellEdits.length===0)return Promise.resolve(!0);const k=[];let i=-1;for(let I=0;I<E.cellEdits.length;I++){if(i<0){k.push(E.cellEdits[I]),i++;continue}const p=k[i],h=E.cellEdits[I];if(p.editType===1&&h.editType===1&&p.index===h.index){p.cells.push(...E.cellEdits[I].cells),p.count+=E.cellEdits[I].count;continue}k.push(E.cellEdits[I]),i++}return this._proxy.$tryApplyEdits(this.id,E.documentVersionId,k)}setDecorations(E,k){if(!(k.isEmpty&&!this._hasDecorationsForKey.has(E.key)))return k.isEmpty?this._hasDecorationsForKey.delete(E.key):this._hasDecorationsForKey.add(E.key),this._proxy.$trySetDecorations(this.id,L.NotebookRange.from(k),E.key)}}e.ExtHostNotebookEditor=T,T.apiEditorsToExtHost=new WeakMap}),define(fe[224],me([0,1,17,117,166,21,60,18]),function(Y,e,g,L,D,S,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class E{constructor(a){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=a}async withProgress(a,p,h){const w=this._handles++,{title:y,location:P,cancellable:b}=p,o={label:(0,D.localize)(0,null,a.displayName||a.name),id:a.identifier.value};return this._proxy.$startProgress(w,{location:g.ProgressLocation.from(P),title:y,source:o,cancellable:b},a).catch(C.onUnexpectedExternalError),this._withProgress(w,h,!!b)}_withProgress(a,p,h){let w;h&&(w=new S.CancellationTokenSource,this._mapHandleToCancellationSource.set(a,w));const y=b=>{this._proxy.$progressEnd(b),this._mapHandleToCancellationSource.delete(b),w&&w.dispose()};let P;try{P=p(new i(this._proxy,a),h&&w?w.token:S.CancellationToken.None)}catch(b){throw y(a),b}return P.then(b=>y(a),b=>y(a)),P}$acceptProgressCanceled(a){const p=this._mapHandleToCancellationSource.get(a);p&&(p.cancel(),this._mapHandleToCancellationSource.delete(a))}}e.ExtHostProgress=E;function k(I,a){return I.message=a.message,typeof a.increment=="number"&&(typeof I.increment=="number"?I.increment+=a.increment:I.increment=a.increment),I}class i extends L.Progress{constructor(a,p){super(h=>this.throttledReport(h));this._proxy=a,this._handle=p}throttledReport(a){this._proxy.$progressReport(this._handle,a)}}Ve([(0,T.throttle)(100,(I,a)=>k(I,a),()=>Object.create(null))],i.prototype,"throttledReport",null)}),define(fe[130],me([0,1,58,18,77,17,7]),function(Y,e,g,L,D,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class C{constructor(a,p,h){const w=C._Keys.nextId();a.$registerTextEditorDecorationType(p.identifier,w,S.DecorationRenderOptions.from(h)),this.value=Object.freeze({key:w,dispose(){a.$removeTextEditorDecorationType(w)}})}}e.TextEditorDecorationType=C,C._Keys=new D.IdGenerator("TextEditorDecorationType");class E{constructor(a,p){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=a,this._documentVersionId=a.version,this._undoStopBefore=p.undoStopBefore,this._undoStopAfter=p.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(a,p){this._throwIfFinalized();let h=null;if(a instanceof T.Position)h=new T.Range(a,a);else if(a instanceof T.Range)h=a;else throw new Error("Unrecognized location");this._pushEdit(h,p,!1)}insert(a,p){this._throwIfFinalized(),this._pushEdit(new T.Range(a,a),p,!0)}delete(a){this._throwIfFinalized();let p=null;if(a instanceof T.Range)p=a;else throw new Error("Unrecognized location");this._pushEdit(p,null,!0)}_pushEdit(a,p,h){const w=this._document.validateRange(a);this._collectedEdits.push({range:w,text:p,forceMoveMarkers:h})}setEndOfLine(a){if(this._throwIfFinalized(),a!==T.EndOfLine.LF&&a!==T.EndOfLine.CRLF)throw(0,L.illegalArgument)("endOfLine");this._setEndOfLine=a}}e.TextEditorEdit=E;class k{constructor(a,p,h,w){this._proxy=a,this._id=p,this._accept(h),this._logService=w;const y=this;this.value={get tabSize(){return y._tabSize},set tabSize(P){y._setTabSize(P)},get insertSpaces(){return y._insertSpaces},set insertSpaces(P){y._setInsertSpaces(P)},get cursorStyle(){return y._cursorStyle},set cursorStyle(P){y._setCursorStyle(P)},get lineNumbers(){return y._lineNumbers},set lineNumbers(P){y._setLineNumbers(P)}}}_accept(a){this._tabSize=a.tabSize,this._insertSpaces=a.insertSpaces,this._cursorStyle=a.cursorStyle,this._lineNumbers=S.TextEditorLineNumbersStyle.to(a.lineNumbers)}_validateTabSize(a){if(a==="auto")return"auto";if(typeof a=="number"){const p=Math.floor(a);return p>0?p:null}if(typeof a=="string"){const p=parseInt(a,10);return isNaN(p)?null:p>0?p:null}return null}_setTabSize(a){const p=this._validateTabSize(a);if(p!==null){if(typeof p=="number"){if(this._tabSize===p)return;this._tabSize=p}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:p}))}}_validateInsertSpaces(a){return a==="auto"?"auto":a==="false"?!1:Boolean(a)}_setInsertSpaces(a){const p=this._validateInsertSpaces(a);if(typeof p=="boolean"){if(this._insertSpaces===p)return;this._insertSpaces=p}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:p}))}_setCursorStyle(a){this._cursorStyle!==a&&(this._cursorStyle=a,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:a})))}_setLineNumbers(a){this._lineNumbers!==a&&(this._lineNumbers=a,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:S.TextEditorLineNumbersStyle.from(a)})))}assign(a){const p={};let h=!1;if(typeof a.tabSize!="undefined"){const w=this._validateTabSize(a.tabSize);w==="auto"?(h=!0,p.tabSize=w):typeof w=="number"&&this._tabSize!==w&&(this._tabSize=w,h=!0,p.tabSize=w)}if(typeof a.insertSpaces!="undefined"){const w=this._validateInsertSpaces(a.insertSpaces);w==="auto"?(h=!0,p.insertSpaces=w):this._insertSpaces!==w&&(this._insertSpaces=w,h=!0,p.insertSpaces=w)}typeof a.cursorStyle!="undefined"&&this._cursorStyle!==a.cursorStyle&&(this._cursorStyle=a.cursorStyle,h=!0,p.cursorStyle=a.cursorStyle),typeof a.lineNumbers!="undefined"&&this._lineNumbers!==a.lineNumbers&&(this._lineNumbers=a.lineNumbers,h=!0,p.lineNumbers=S.TextEditorLineNumbersStyle.from(a.lineNumbers)),h&&this._warnOnError(this._proxy.$trySetOptions(this._id,p))}_warnOnError(a){a.catch(p=>this._logService.warn(p))}}e.ExtHostTextEditorOptions=k;class i{constructor(a,p,h,w,y,P,b,o){this.id=a,this._proxy=p,this._logService=h,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=y,this._options=new k(this._proxy,this.id,P,h),this._visibleRanges=b,this._viewColumn=o;const s=this;this.value=Object.freeze({get document(){return w.getValue()},set document(v){throw(0,L.readonly)("document")},get selection(){return s._selections&&s._selections[0]},set selection(v){if(!(v instanceof T.Selection))throw(0,L.illegalArgument)("selection");s._selections=[v],s._trySetSelection()},get selections(){return s._selections},set selections(v){if(!Array.isArray(v)||v.some(n=>!(n instanceof T.Selection)))throw(0,L.illegalArgument)("selections");s._selections=v,s._trySetSelection()},get visibleRanges(){return s._visibleRanges},set visibleRanges(v){throw(0,L.readonly)("visibleRanges")},get options(){return s._options.value},set options(v){s._disposed||s._options.assign(v)},get viewColumn(){return s._viewColumn},set viewColumn(v){throw(0,L.readonly)("viewColumn")},edit(v,n={undoStopBefore:!0,undoStopAfter:!0}){if(s._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const f=new E(w.getValue(),n);return v(f),s._applyEdit(f)},insertSnippet(v,n,f={undoStopBefore:!0,undoStopAfter:!0}){if(s._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!n||Array.isArray(n)&&n.length===0)r=s._selections.map(t=>S.Range.from(t));else if(n instanceof T.Position){const{lineNumber:t,column:u}=S.Position.from(n);r=[{startLineNumber:t,startColumn:u,endLineNumber:t,endColumn:u}]}else if(n instanceof T.Range)r=[S.Range.from(n)];else{r=[];for(const t of n)if(t instanceof T.Range)r.push(S.Range.from(t));else{const{lineNumber:u,column:l}=S.Position.from(t);r.push({startLineNumber:u,startColumn:l,endLineNumber:u,endColumn:l})}}return p.$tryInsertSnippet(a,v.value,r,f)},setDecorations(v,n){const f=n.length===0;f&&!s._hasDecorationsForKey.has(v.key)||(f?s._hasDecorationsForKey.delete(v.key):s._hasDecorationsForKey.add(v.key),s._runOnProxy(()=>{if(S.isDecorationOptionsArr(n))return p.$trySetDecorations(a,v.key,S.fromRangeOrRangeWithMessage(n));{const r=new Array(4*n.length);for(let t=0,u=n.length;t<u;t++){const l=n[t];r[4*t]=l.start.line+1,r[4*t+1]=l.start.character+1,r[4*t+2]=l.end.line+1,r[4*t+3]=l.end.character+1}return p.$trySetDecorationsFast(a,v.key,r)}}))},revealRange(v,n){s._runOnProxy(()=>p.$tryRevealRange(a,S.Range.from(v),n||T.TextEditorRevealType.Default))},show(v){p.$tryShowEditor(a,S.ViewColumn.from(v))},hide(){p.$tryHideEditor(a)}})}dispose(){(0,g.ok)(!this._disposed),this._disposed=!0}_acceptOptions(a){(0,g.ok)(!this._disposed),this._options._accept(a)}_acceptVisibleRanges(a){(0,g.ok)(!this._disposed),this._visibleRanges=a}_acceptViewColumn(a){(0,g.ok)(!this._disposed),this._viewColumn=a}_acceptSelections(a){(0,g.ok)(!this._disposed),this._selections=a}async _trySetSelection(){const a=this._selections.map(S.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,a)),this.value}_applyEdit(a){const p=a.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const h=p.edits.map(y=>y.range);h.sort((y,P)=>y.end.line===P.end.line?y.end.character===P.end.character?y.start.line===P.start.line?y.start.character-P.start.character:y.start.line-P.start.line:y.end.character-P.end.character:y.end.line-P.end.line);for(let y=0,P=h.length-1;y<P;y++){const b=h[y].end;if(h[y+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const w=p.edits.map(y=>({range:S.Range.from(y.range),text:y.text,forceMoveMarkers:y.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,p.documentVersionId,w,{setEndOfLine:typeof p.setEndOfLine=="number"?S.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}_runOnProxy(a){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):a().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this._logService.warn(p),null))}}e.ExtHostTextEditor=i}),define(fe[225],me([0,1,169,23,2,3,6,211,16,7,13,15,17,21,208]),function(Y,e,g,L,D,S,T,C,E,k,i,I,a,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function w(b,o){if((0,i.isString)(b))return{label:b};if(b&&typeof b=="object"&&typeof b.label=="string"){let s;return Array.isArray(b.highlights)&&(s=b.highlights.filter(v=>v.length===2&&typeof v[0]=="number"&&typeof v[1]=="number"),s=s.length?s:void 0),{label:b.label,highlights:s}}}class y{constructor(o,s,v){this._proxy=o,this.commands=s,this.logService=v,this.treeViews=new Map;function n(f){return f&&f.$treeViewId&&f.$treeItemHandle}s.registerArgumentProcessor({processArgument:f=>n(f)?this.convertArgument(f):Array.isArray(f)&&f.length>0?f.map(r=>n(r)?this.convertArgument(r):r):f})}registerTreeDataProvider(o,s,v){const n=this.createTreeView(o,{treeDataProvider:s},v);return{dispose:()=>n.dispose()}}createTreeView(o,s,v){if(!s||!s.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const n=s.dragAndDropController!==void 0,f=this._proxy.$registerTreeViewDataProvider(o,{showCollapseAll:!!s.showCollapseAll,canSelectMany:!!s.canSelectMany,canDragAndDrop:n}),r=this.createExtHostTreeView(o,s,v);return{get onDidCollapseElement(){return r.onDidCollapseElement},get onDidExpandElement(){return r.onDidExpandElement},get selection(){return r.selectedElements},get onDidChangeSelection(){return r.onDidChangeSelection},get visible(){return r.visible},get onDidChangeVisibility(){return r.onDidChangeVisibility},get message(){return r.message},set message(t){r.message=t},get title(){return r.title},set title(t){r.title=t},get description(){return r.description},set description(t){r.description=t},reveal:(t,u)=>r.reveal(t,u),dispose:async()=>{await f,this.treeViews.delete(o),r.dispose()}}}$getChildren(o,s){const v=this.treeViews.get(o);return v?v.getChildren(s):Promise.reject(new Error((0,g.localize)(0,null,o)))}async $onDrop(o,s,v){const n=this.treeViews.get(o);if(!n)return Promise.reject(new Error((0,g.localize)(1,null,o)));const f=h.TreeDataTransferConverter.toITreeDataTransfer(s);if(f.items.has(C.TREE_ITEM_DATA_TRANSFER_TYPE)){const t=JSON.parse(await f.items.get(C.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(u=>n.getExtensionElement(u)).filter(u=>!!u);t.length>0?f.items.set(C.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(t)}):f.items.delete(C.TREE_ITEM_DATA_TRANSFER_TYPE)}return n.onDrop(f,v)}async $hasResolve(o){const s=this.treeViews.get(o);if(!s)throw new Error((0,g.localize)(2,null,o));return s.hasResolve}$resolve(o,s,v){const n=this.treeViews.get(o);if(!n)throw new Error((0,g.localize)(3,null,o));return n.resolveTreeItem(s,v)}$setExpanded(o,s,v){const n=this.treeViews.get(o);if(!n)throw new Error((0,g.localize)(4,null,o));n.setExpanded(s,v)}$setSelection(o,s){const v=this.treeViews.get(o);if(!v)throw new Error((0,g.localize)(5,null,o));v.setSelection(s)}$setVisible(o,s){const v=this.treeViews.get(o);if(!v)throw new Error((0,g.localize)(6,null,o));v.setVisible(s)}createExtHostTreeView(o,s,v){const n=new P(o,s,this._proxy,this.commands.converter,this.logService,v);return this.treeViews.set(o,n),n}convertArgument(o){const s=this.treeViews.get(o.$treeViewId);return s?s.getExtensionElement(o.$treeItemHandle):null}}e.ExtHostTreeViews=y;class P extends T.Disposable{constructor(o,s,v,n,f,r){super();if(this.viewId=o,this.proxy=v,this.commands=n,this.logService=f,this.extension=r,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new S.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new S.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new S.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new S.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new S.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new p.CancellationTokenSource,r.contributes&&r.contributes.views)for(const l in r.contributes.views)for(const c of r.contributes.views[l])c.id===o&&(this._title=c.name);this.dataProvider=s.treeDataProvider,this.dndController=s.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(l=>this._onDidChangeData.fire({message:!1,element:l}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(l=>this._onDidChangeData.fire({message:!1,element:l})));let t,u;this._register(S.Event.debounce(this._onDidChangeData.event,(l,c)=>(l||(l={message:!1,elements:[]}),c.element!==!1&&(t||(t=new Promise(m=>u=m),this.refreshPromise=this.refreshPromise.then(()=>t)),Array.isArray(c.element)?l.elements.push(...c.element):l.elements.push(c.element)),c.message&&(l.message=!0),l),200,!0)(({message:l,elements:c})=>{c.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const m=u;return t=null,this.refresh(c).then(()=>m())})),l&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(o=>this.getExtensionElement(o)).filter(o=>!(0,i.isUndefinedOrNull)(o))}async getChildren(o){const s=o?this.getExtensionElement(o):void 0;if(o&&!s)return this.logService.error(`No tree item with id '${o}' found.`),Promise.resolve([]);let v=this.getChildrenNodes(o);return v||(v=await this.fetchChildrenNodes(s)),v?v.map(n=>n.item):void 0}getExtensionElement(o){return this.elements.get(o)}reveal(o,s){s=s||{select:!0,focus:!1};const v=(0,i.isUndefinedOrNull)(s.select)?!0:s.select,n=(0,i.isUndefinedOrNull)(s.focus)?!1:s.focus,f=(0,i.isUndefinedOrNull)(s.expand)?!1:s.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):o?this.refreshPromise.then(()=>this.resolveUnknownParentChain(o)).then(r=>this.resolveTreeNode(o,r[r.length-1]).then(t=>this.proxy.$reveal(this.viewId,{item:t.item,parentChain:r.map(u=>u.item)},{select:v,focus:n,expand:f})),r=>this.logService.error(r)):this.proxy.$reveal(this.viewId,void 0,{select:v,focus:n,expand:f})}get message(){return this._message}set message(o){this._message=o,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(o){this._title=o,this.proxy.$setTitle(this.viewId,o,this._description)}get description(){return this._description}set description(o){this._description=o,this.proxy.$setTitle(this.viewId,this._title,o)}setExpanded(o,s){const v=this.getExtensionElement(o);v&&(s?this._onDidExpandElement.fire(Object.freeze({element:v})):this._onDidCollapseElement.fire(Object.freeze({element:v})))}setSelection(o){(0,I.equals)(this._selectedHandles,o)||(this._selectedHandles=o,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(o){o!==this._visible&&(this._visible=o,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(o,s){const v=this.getExtensionElement(s);if(!!v)return(0,E.asPromise)(()=>this.dndController?.onDrop(o,v))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(o,s){if(!this.dataProvider.resolveTreeItem)return;const v=this.elements.get(o);if(v){const n=this.nodes.get(v);if(n){const f=await this.dataProvider.resolveTreeItem(n.extensionItem,v,s)??n.extensionItem;return n.item.tooltip=this.getTooltip(f.tooltip),n.item.command=this.getCommand(n.disposableStore,f.command),n.item}}}resolveUnknownParentChain(o){return this.resolveParent(o).then(s=>s?this.resolveUnknownParentChain(s).then(v=>this.resolveTreeNode(s,v[v.length-1]).then(n=>(v.push(n),v))):Promise.resolve([]))}resolveParent(o){const s=this.nodes.get(o);return s?Promise.resolve(s.parent?this.elements.get(s.parent.item.handle):void 0):(0,E.asPromise)(()=>this.dataProvider.getParent(o))}resolveTreeNode(o,s){const v=this.nodes.get(o);return v?Promise.resolve(v):(0,E.asPromise)(()=>this.dataProvider.getTreeItem(o)).then(n=>this.createHandle(o,n,s,!0)).then(n=>this.getChildren(s?s.item.handle:void 0).then(()=>{const f=this.getExtensionElement(n);if(f){const r=this.nodes.get(f);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${n}`)}))}getChildrenNodes(o){if(o){let s;if(typeof o=="string"){const v=this.getExtensionElement(o);s=v?this.nodes.get(v):void 0}else s=o;return s&&s.children||void 0}return this.roots}async fetchChildrenNodes(o){this.clearChildren(o);const s=new p.CancellationTokenSource(this._refreshCancellationSource.token);try{const v=o?this.nodes.get(o):void 0,n=await this.dataProvider.getChildren(o);if(s.token.isCancellationRequested)return;const f=await Promise.all((0,I.coalesce)(n||[]).map(async r=>{const t=await this.dataProvider.getTreeItem(r);return t&&!s.token.isCancellationRequested?this.createAndRegisterTreeNode(r,t,v):null}));return s.token.isCancellationRequested?void 0:(0,I.coalesce)(f)}finally{s.dispose()}}refresh(o){if(o.some(v=>!v))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new p.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const v=this.getHandlesToRefresh(o);if(v.length)return this.refreshHandles(v)}return Promise.resolve(void 0)}getHandlesToRefresh(o){const s=new Set,v=o.map(f=>this.nodes.get(f));for(const f of v)if(f&&!s.has(f.item.handle)){let r=f;for(;r&&r.parent&&v.findIndex(t=>r&&r.parent&&t&&t.item.handle===r.parent.item.handle)===-1;){const t=this.elements.get(r.parent.item.handle);r=t?this.nodes.get(t):void 0}r&&!r.parent&&s.add(f.item.handle)}const n=[];return s.forEach(f=>{const r=this.elements.get(f);if(r){const t=this.nodes.get(r);t&&(!t.parent||!s.has(t.parent.item.handle))&&n.push(f)}}),n}refreshHandles(o){const s={};return Promise.all(o.map(v=>this.refreshNode(v).then(n=>{n&&(s[v]=n.item)}))).then(()=>Object.keys(s).length?this.proxy.$refresh(this.viewId,s):void 0)}refreshNode(o){const s=this.getExtensionElement(o);if(s){const v=this.nodes.get(s);if(v)return this.clearChildren(s),(0,E.asPromise)(()=>this.dataProvider.getTreeItem(s)).then(n=>{if(n){const f=this.createTreeNode(s,n,v.parent);return this.updateNodeCache(s,f,v,v.parent),v.dispose(),f}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(o,s,v){const n=this.createTreeNode(o,s,v);if(s.id&&this.elements.has(n.item.handle))throw new Error((0,g.localize)(7,null,s.id));return this.addNodeToCache(o,n),this.addNodeToParentCache(n,v),n}getTooltip(o){return k.MarkdownString.isMarkdownString(o)?a.MarkdownString.from(o):o}getCommand(o,s){return s?this.commands.toInternal(s,o):void 0}createTreeNode(o,s,v){const n=new T.DisposableStore,f=this.createHandle(o,s,v),r=this.getLightIconPath(s);return{item:{handle:f,parentHandle:v?v.item.handle:void 0,label:w(s.label,this.extension),description:s.description,resourceUri:s.resourceUri,tooltip:this.getTooltip(s.tooltip),command:this.getCommand(n,s.command),contextValue:s.contextValue,icon:r,iconDark:this.getDarkIconPath(s)||r,themeIcon:this.getThemeIcon(s),collapsibleState:(0,i.isUndefinedOrNull)(s.collapsibleState)?k.TreeItemCollapsibleState.None:s.collapsibleState,accessibilityInformation:s.accessibilityInformation},extensionItem:s,parent:v,children:void 0,disposableStore:n,dispose(){n.dispose()}}}getThemeIcon(o){return o.iconPath instanceof k.ThemeIcon?o.iconPath:void 0}createHandle(o,{id:s,label:v,resourceUri:n},f,r){if(s)return`${P.ID_HANDLE_PREFIX}/${s}`;const t=w(v,this.extension),u=f?f.item.handle:P.LABEL_HANDLE_PREFIX;let l=t?t.label:n?(0,L.basename)(n):"";l=l.indexOf("/")!==-1?l.replace("/","//"):l;const c=this.nodes.has(o)?this.nodes.get(o).item.handle:void 0,m=this.getChildrenNodes(f)||[];let d,_=0;do{if(d=`${u}/${_}:${l}`,r||!this.elements.has(d)||c===d)break;_++}while(_<=m.length);return d}getLightIconPath(o){if(o.iconPath&&!(o.iconPath instanceof k.ThemeIcon))return typeof o.iconPath=="string"||D.URI.isUri(o.iconPath)?this.getIconPath(o.iconPath):this.getIconPath(o.iconPath.light)}getDarkIconPath(o){if(o.iconPath&&!(o.iconPath instanceof k.ThemeIcon)&&o.iconPath.dark)return this.getIconPath(o.iconPath.dark)}getIconPath(o){return D.URI.isUri(o)?o:D.URI.file(o)}addNodeToCache(o,s){this.elements.set(s.item.handle,o),this.nodes.set(o,s)}updateNodeCache(o,s,v,n){this.elements.delete(s.item.handle),this.nodes.delete(o),s.item.handle!==v.item.handle&&this.elements.delete(v.item.handle),this.addNodeToCache(o,s);const f=this.getChildrenNodes(n)||[],r=f.filter(t=>t.item.handle===v.item.handle)[0];r&&f.splice(f.indexOf(r),1,s)}addNodeToParentCache(o,s){s?(s.children||(s.children=[]),s.children.push(o)):(this.roots||(this.roots=[]),this.roots.push(o))}clearChildren(o){if(o){const s=this.nodes.get(o);if(s){if(s.children)for(const v of s.children){const n=this.elements.get(v.item.handle);n&&this.clear(n)}s.children=void 0}}else this.clearAll()}clear(o){const s=this.nodes.get(o);if(s){if(s.children)for(const v of s.children){const n=this.elements.get(v.item.handle);n&&this.clear(n)}this.nodes.delete(o),this.elements.delete(s.item.handle),s.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(o=>o.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}P.LABEL_HANDLE_PREFIX="0",P.ID_HANDLE_PREFIX="1"}),define(fe[226],me([0,1,16,3,6,13,66,17,127,90]),function(Y,e,g,L,D,S,T,C,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class i extends D.Disposable{constructor(a){super();this.controllerId=a,this.debounceSendDiff=this._register(new g.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new L.Emitter),this.root=new T.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(a){this._resolveHandler=a;for(const p of this.tree.values())this.updateExpandability(p)}collectDiff(){const a=this.diff;return this.diff=[],a}pushDiff(a){const p=this.diff[this.diff.length-1];if(p&&a[0]===1){if(p[0]===1&&p[1].extId===a[1].extId){(0,E.applyTestItemUpdate)(p[1],a[1]);return}if(p[0]===0&&p[1].item.extId===a[1].extId){(0,E.applyTestItemUpdate)(p[1],a[1]);return}}this.diff.push(a),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(a,p){const h=this.tree.get(a);if(!!h){if((h.expandLevels===void 0||p>h.expandLevels)&&(h.expandLevels=p),h.expand===1){const w=this.resolveChildren(h);return w.isOpen()?this.expandChildren(h,p-1):w.wait().then(()=>this.expandChildren(h,p-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.expandChildren(h,p-1)):this.expandChildren(h,p-1)}}dispose(){for(const a of this.tree.values())(0,T.getPrivateApiFor)(a.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(a,p){switch(p.op){case 2:this.pushDiff([4,a.fullId.toString()]);break;case 1:this.removeItem(k.TestId.joinToString(a.fullId,p.id));break;case 0:this.upsertItem(p.item,a);break;case 4:for(const b of p.ops)this.onTestItemEvent(a,b);break;case 3:const{key:h,value:w,previous:y}=p,P=a.fullId.toString();switch(h){case"canResolveChildren":this.updateExpandability(a);break;case"tags":this.diffTagRefs(w,y,P);break;case"range":this.pushDiff([1,{extId:P,item:{range:C.Range.from(w)}}]);break;case"error":this.pushDiff([1,{extId:P,item:{error:C.MarkdownString.fromStrict(w)||null}}]);break;default:this.pushDiff([1,{extId:P,item:{[h]:w??null}}]);break}break;default:(0,S.assertNever)(p)}}upsertItem(a,p){if(!(a instanceof T.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${a.id} did not`);const h=k.TestId.fromExtHostTestItem(a,this.root.id,p?.actual),w=(0,T.getPrivateApiFor)(a);w.parent&&w.parent!==p?.actual&&w.parent.children.delete(a.id);let y=this.tree.get(h.toString());if(!y){y={fullId:h,actual:a,parent:p?h.parentId:null,expandLevels:p?.expandLevels?p.expandLevels-1:void 0,expand:0},a.tags.forEach(this.incrementTagRefs,this),this.tree.set(y.fullId.toString(),y),this.setItemParent(a,p),this.pushDiff([0,{parent:y.parent&&y.parent.toString(),controllerId:this.controllerId,expand:y.expand,item:C.TestItem.from(a)}]),this.connectItemAndChildren(a,y,p);return}if(y.actual===a){this.connectItem(a,y,p);return}const P=y.actual.children,b=y.actual,o=(0,T.diffTestItems)(b,a);(0,T.getPrivateApiFor)(b).listener=void 0,y.actual=a,y.expand=0;for(const[s,v]of o)this.onTestItemEvent(y,{op:3,key:s,value:v,previous:b[s]});this.connectItemAndChildren(a,y,p);for(const s of P)a.children.get(s.id)||this.removeItem(k.TestId.joinToString(h,s.id))}diffTagRefs(a,p,h){const w=new Set(p.map(y=>y.id));for(const y of a)w.delete(y.id)||this.incrementTagRefs(y);this.pushDiff([1,{extId:h,item:{tags:a.map(y=>C.TestTag.namespace(this.controllerId,y.id))}}]),w.forEach(this.decrementTagRefs,this)}incrementTagRefs(a){const p=this.tags.get(a.id);p?p.refCount++:(this.tags.set(a.id,{refCount:1}),this.pushDiff([5,{id:C.TestTag.namespace(this.controllerId,a.id),ctrlLabel:this.root.label}]))}decrementTagRefs(a){const p=this.tags.get(a);p&&!--p.refCount&&(this.tags.delete(a),this.pushDiff([6,C.TestTag.namespace(this.controllerId,a)]))}setItemParent(a,p){(0,T.getPrivateApiFor)(a).parent=p&&p.actual!==this.root?p.actual:void 0}connectItem(a,p,h){this.setItemParent(a,h);const w=(0,T.getPrivateApiFor)(a);w.parent=h?.actual,w.listener=y=>this.onTestItemEvent(p,y),this.updateExpandability(p)}connectItemAndChildren(a,p,h){this.connectItem(a,p,h);for(const w of a.children)this.upsertItem(w,p)}updateExpandability(a){let p;this._resolveHandler?a.resolveBarrier?p=a.resolveBarrier.isOpen()?3:2:p=a.actual.canResolveChildren?1:0:p=0,p!==a.expand&&(a.expand=p,this.pushDiff([1,{extId:a.fullId.toString(),expand:p}]),p===1&&a.expandLevels!==void 0&&this.resolveChildren(a))}expandChildren(a,p){if(p<0)return;const h=[];for(const w of a.actual.children){const y=this.expand(k.TestId.joinToString(a.fullId,w.id),p);(0,g.isThenable)(y)&&h.push(y)}if(h.length)return Promise.all(h).then(()=>{})}resolveChildren(a){if(a.resolveBarrier)return a.resolveBarrier;if(!this._resolveHandler){const y=new g.Barrier;return y.open(),y}a.expand=2,this.pushExpandStateUpdate(a);const p=a.resolveBarrier=new g.Barrier,h=y=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),a.actual!==this.root&&(a.actual.error=y.stack||y.message||String(y))};let w;try{w=this._resolveHandler(a.actual===this.root?void 0:a.actual)}catch(y){h(y)}return(0,g.isThenable)(w)?w.catch(h).then(()=>{p.open(),this.updateExpandability(a)}):(p.open(),this.updateExpandability(a)),a.resolveBarrier}pushExpandStateUpdate(a){this.pushDiff([1,{extId:a.fullId.toString(),expand:a.expand}])}removeItem(a){const p=this.tree.get(a);if(!p)throw new Error("attempting to remove non-existent child");this.pushDiff([2,a]);const h=[p];for(;h.length;){const w=h.pop();if(!!w){(0,T.getPrivateApiFor)(w.actual).listener=void 0;for(const y of w.actual.tags)this.decrementTagRefs(y.id);this.tree.delete(w.fullId.toString());for(const y of w.actual.children)h.push(this.tree.get(k.TestId.joinToString(w.fullId,y.id)))}}}flushDiff(){const a=this.collectDiff();a.length&&this.diffOpEmitter.fire(a)}}e.SingleUseTestCollection=i}),define(fe[227],me([0,1,4,185]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,g.refineServiceDecorator)(L.IEnvironmentService)}),define(fe[228],me([0,1,27,3,9]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class S{constructor(i){this.removedDueToLooping=i}}e.DeltaExtensionsResult=S;class T{constructor(i){this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(E),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const i of this._extensionDescriptions){if(this._extensionsMap.has(g.ExtensionIdentifier.toKey(i.identifier))){console.error("Extension `"+i.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(g.ExtensionIdentifier.toKey(i.identifier),i),this._extensionsArr.push(i),Array.isArray(i.activationEvents))for(let I of i.activationEvents)I==="onUri"&&(I=`onUri:${g.ExtensionIdentifier.toKey(i.identifier)}`),this._activationMap.has(I)||this._activationMap.set(I,[]),this._activationMap.get(I).push(i)}}keepOnly(i){const I=new Set;i.forEach(a=>I.add(g.ExtensionIdentifier.toKey(a))),this._extensionDescriptions=this._extensionDescriptions.filter(a=>I.has(g.ExtensionIdentifier.toKey(a.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(i,I){i.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(i));const a=T._findLoopingExtensions(this._extensionDescriptions);if(I=I.concat(a.map(p=>p.identifier)),I.length>0){const p=new Set;I.forEach(h=>p.add(g.ExtensionIdentifier.toKey(h))),this._extensionDescriptions=this._extensionDescriptions.filter(h=>!p.has(g.ExtensionIdentifier.toKey(h.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new S(a)}static _findLoopingExtensions(i){const I=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(y){this._nodesSet.has(y)||(this._nodesSet.add(y),this._nodesArr.push(y))}addArc(y,P){this.addNode(y),this.addNode(P),this._arcs.has(y)?this._arcs.get(y).push(P):this._arcs.set(y,[P])}getArcs(y){return this._arcs.has(y)?this._arcs.get(y):[]}hasOnlyGoodArcs(y,P){const b=I.getArcs(y);for(let o=0;o<b.length;o++)if(!P.has(b[o]))return!1;return!0}getNodes(){return this._nodesArr}};let a=new Map;for(let y of i){const P=g.ExtensionIdentifier.toKey(y.identifier);if(a.set(P,y),y.extensionDependencies)for(let b of y.extensionDependencies){const o=g.ExtensionIdentifier.toKey(b);I.addArc(P,o)}}let p=new Set;I.getNodes().filter(y=>I.getArcs(y).length===0).forEach(y=>p.add(y));let h=I.getNodes().filter(y=>!p.has(y)),w;do{w=!1;for(let y=0;y<h.length;y++){const P=h[y];I.hasOnlyGoodArcs(P,p)&&(h.splice(y,1),y--,p.add(P),w=!0)}}while(w);return h.map(y=>a.get(y))}containsActivationEvent(i){return this._activationMap.has(i)}containsExtension(i){return this._extensionsMap.has(g.ExtensionIdentifier.toKey(i))}getExtensionDescriptionsForActivationEvent(i){const I=this._activationMap.get(i);return I?I.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(i){const I=this._extensionsMap.get(g.ExtensionIdentifier.toKey(i));return I||void 0}}e.ExtensionDescriptionRegistry=T;var C;(function(k){k[k.Builtin=0]="Builtin",k[k.User=1]="User",k[k.Dev=2]="Dev"})(C||(C={}));function E(k,i){const I=k.isBuiltin?0:k.isUnderDevelopment?2:1,a=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(I!==a)return I-a;const p=D.posix.basename(k.extensionLocation.path),h=D.posix.basename(i.extensionLocation.path);return p<h?-1:p>h?1:0}}),define(fe[229],me([0,1,22]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var L;(function(C){C[C.VersionMismatch=55]="VersionMismatch",C[C.UnexpectedError=81]="UnexpectedError"})(L=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var D;(function(C){C[C.Initialized=0]="Initialized",C[C.Ready=1]="Ready",C[C.Terminate=2]="Terminate"})(D=e.MessageType||(e.MessageType={}));function S(C){const E=g.VSBuffer.alloc(1);switch(C){case 0:E.writeUInt8(1,0);break;case 1:E.writeUInt8(2,0);break;case 2:E.writeUInt8(3,0);break}return E}e.createMessageOfType=S;function T(C,E){if(C.byteLength!==1)return!1;switch(C.readUInt8(0)){case 1:return E===0;case 2:return E===1;case 3:return E===2;default:return!1}}e.isMessageOfType=T}),define(fe[35],me([0,1,3,2,4,27,195]),function(Y,e,g,L,D,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new S.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,D.createDecorator)("extensionService");var C;(function(s){s[s.None=0]="None",s[s.LocalProcess=1]="LocalProcess",s[s.LocalWebWorker=2]="LocalWebWorker",s[s.Remote=3]="Remote"})(C=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function E(s){switch(s){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=E;class k{constructor(v){this.dependency=v}}e.MissingExtensionDependency=k;var i;(function(s){s[s.LocalProcess=0]="LocalProcess",s[s.LocalWebWorker=1]="LocalWebWorker",s[s.Remote=2]="Remote"})(i=e.ExtensionHostKind||(e.ExtensionHostKind={}));function I(s){switch(s){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=I;class a{constructor(v,n,f,r){this.codeLoadingTime=v,this.activateCallTime=n,this.activateResolvedTime=f,this.activationReason=r}}e.ActivationTimes=a;class p{constructor(v,n){this.description=v,this.value=n}}e.ExtensionPointContribution=p,e.ExtensionHostLogFileName="exthost";var h;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(h=e.ActivationKind||(e.ActivationKind={}));function w(s){s.enableProposedApi||y(s)}e.checkProposedApiEnabled=w;function y(s){throw new Error(`[${s.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${s.identifier.value}`)}e.throwProposedApiError=y;function P(s){return{type:s.isBuiltin?0:1,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,T.getGalleryExtensionId)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation}}e.toExtension=P;function b(s,v){return{identifier:new S.ExtensionIdentifier(s.identifier.id),isBuiltin:s.type===0,isUserBuiltin:s.type===1&&s.isBuiltin,isUnderDevelopment:!!v,extensionLocation:s.location,...s.manifest,uuid:s.identifier.uuid}}e.toExtensionDescription=b;class o{constructor(){this.onDidRegisterExtensions=g.Event.None,this.onDidChangeExtensionsStatus=g.Event.None,this.onDidChangeExtensions=g.Event.None,this.onWillActivateByEvent=g.Event.None,this.onDidChangeResponsiveChange=g.Event.None}activateByEvent(v){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(v){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(v){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(v){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(v,n){return Promise.resolve()}_onWillActivateExtension(v){}_onDidActivateExtension(v,n,f,r,t){}_onDidActivateExtensionError(v,n){}_onExtensionRuntimeError(v,n){}_onExtensionHostExit(v){}}e.NullExtensionService=o}),define(fe[230],me([0,1,27,35,11]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const S=Promise.resolve(void 0);class T{constructor(h,w,y,P){this.startup=h,this.codeLoadingTime=w,this.activateCallTime=y,this.activateResolvedTime=P}}e.ExtensionActivationTimes=T,T.NONE=new T(!1,-1,-1,-1);class C{constructor(h){this._startup=h,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(h,w){return h===-1||w===-1?-1:w-h}build(){return new T(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=C;class E{constructor(h,w,y,P,b,o){this.activationFailed=h,this.activationFailedError=w,this.activationTimes=y,this.module=P,this.exports=b,this.subscriptions=o}}e.ActivatedExtension=E;class k extends E{constructor(h){super(!1,null,h,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=k;class i extends E{constructor(){super(!1,null,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=i;class I extends E{constructor(h){super(!0,h,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=I;let a=class{constructor(h,w,y,P,b){this._logService=b,this._registry=h,this._resolvedExtensionsSet=new Set,w.forEach(o=>this._resolvedExtensionsSet.add(g.ExtensionIdentifier.toKey(o))),this._hostExtensionsMap=new Map,y.forEach(o=>this._hostExtensionsMap.set(g.ExtensionIdentifier.toKey(o),o)),this._host=P,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(h){const w=g.ExtensionIdentifier.toKey(h);return this._activatedExtensions.has(w)}getActivatedExtension(h){const w=g.ExtensionIdentifier.toKey(h),y=this._activatedExtensions.get(w);if(!y)throw new Error("Extension `"+h.value+"` is not known or not activated");return y}activateByEvent(h,w){if(this._alreadyActivatedEvents[h])return S;const y=this._registry.getExtensionDescriptionsForActivationEvent(h);return this._activateExtensions(y.map(P=>({id:P.identifier,reason:{startup:w,extensionId:P.identifier,activationEvent:h}}))).then(()=>{this._alreadyActivatedEvents[h]=!0})}activateById(h,w){const y=this._registry.getExtensionDescription(h);if(!y)throw new Error("Extension `"+h+"` is not known");return this._activateExtensions([{id:y.identifier,reason:w}])}_handleActivateRequest(h,w,y){if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(h.id))){w[g.ExtensionIdentifier.toKey(h.id)]=h;return}const P=this._registry.getExtensionDescription(h.id);if(!P){const s=new Error(`Cannot activate unknown extension '${h.id.value}'`);this._host.onExtensionActivationError(h.id,s,new L.MissingExtensionDependency(h.id.value)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(h.id),new I(s));return}const b=typeof P.extensionDependencies=="undefined"?[]:P.extensionDependencies;let o=!0;for(let s=0,v=b.length;s<v;s++){const n=b[s];if(this._resolvedExtensionsSet.has(g.ExtensionIdentifier.toKey(n)))continue;const f=this._activatedExtensions.get(g.ExtensionIdentifier.toKey(n));if(f&&!f.activationFailed)continue;if(f&&f.activationFailed){const l=P.displayName||P.identifier.value,c=this._registry.getExtensionDescription(n),m=c&&c.displayName||n,d=new Error(`Cannot activate the '${l}' extension because its dependency '${m}' failed to activate`);d.detail=f.activationFailedError,this._host.onExtensionActivationError(P.identifier,d,null),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(P.identifier),new I(d));return}if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(n))){o=!1,w[g.ExtensionIdentifier.toKey(n)]={id:this._hostExtensionsMap.get(g.ExtensionIdentifier.toKey(n)),reason:h.reason};continue}const r=this._registry.getExtensionDescription(n);if(r){if(!r.main&&!r.browser)continue;o=!1,w[g.ExtensionIdentifier.toKey(n)]={id:r.identifier,reason:h.reason};continue}const t=P.displayName||P.identifier.value,u=new Error(`Cannot activate the '${t}' extension because it depends on unknown extension '${n}'`);this._host.onExtensionActivationError(P.identifier,u,new L.MissingExtensionDependency(n)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(P.identifier),new I(u));return}o?w[g.ExtensionIdentifier.toKey(P.identifier)]=h:y.push(h)}_activateExtensions(h){if(h.length===0||(h=h.filter(b=>!this._activatedExtensions.has(g.ExtensionIdentifier.toKey(b.id))),h.length===0))return Promise.resolve(void 0);const w=Object.create(null),y=[];for(let b=0,o=h.length;b<o;b++)this._handleActivateRequest(h[b],w,y);for(let b=0,o=y.length;b<o;b++){const s=g.ExtensionIdentifier.toKey(y[b].id);w[s]&&delete w[s]}const P=Object.keys(w).map(b=>w[b]);return y.length===0?Promise.all(P.map(b=>this._activateExtension(b.id,b.reason))).then(b=>{}):this._activateExtensions(P).then(b=>this._activateExtensions(y))}_activateExtension(h,w){const y=g.ExtensionIdentifier.toKey(h);if(this._activatedExtensions.has(y))return Promise.resolve(void 0);const P=this._activatingExtensions.get(y);if(P)return P;const b=this._host.actualActivateExtension(h,w).then(void 0,o=>{const s=new Error;return o&&o.name&&(s.name=o.name),o&&o.message?s.message=`Activating extension '${h.value}' failed: ${o.message}.`:s.message=`Activating extension '${h.value}' failed: ${o}.`,o&&o.stack&&(s.stack=o.stack),this._host.onExtensionActivationError(h,s,null),this._logService.error(`Activating extension ${h.value} failed due to an error:`),this._logService.error(o),new I(o)}).then(o=>{this._activatedExtensions.set(y,o),this._activatingExtensions.delete(y)});return this._activatingExtensions.set(y,b),b}};a=Ve([$e(4,D.ILogService)],a),e.ExtensionsActivator=a}),define(fe[231],me([0,1,18]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class L{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((S,T)=>{this._actualOk=S,this._actualErr=T,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(S){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=S,this._actual&&this._actualOk(S))}resolveErr(S){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=S,this._actual?this._actualErr(S):(0,g.onUnexpectedError)(S))}then(S,T){return this._ensureActual().then(S,T)}catch(S){return this._ensureActual().then(void 0,S)}finally(S){return this._ensureActual().finally(S)}}e.LazyPromise=L}),define(fe[55],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class g{constructor(k,i){this._proxyIdentifierBrand=void 0,this.isMain=k,this.sid=i,this.nid=++g.count}}e.ProxyIdentifier=g,g.count=0;const L=[];function D(E){const k=new g(!0,E);return L[k.nid]=k,k}e.createMainContextProxyIdentifier=D;function S(E){const k=new g(!1,E);return L[k.nid]=k,k}e.createExtHostContextProxyIdentifier=S;function T(E){return L[E].sid}e.getStringIdentifierForProxy=T;class C{constructor(k){this.value=k}}e.SerializableObjectWithBuffers=C}),define(fe[5],me([0,1,62,2,55]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var S;(function(o){o[o.Desktop=1]="Desktop",o[o.Web=2]="Web"})(S=e.UIKind||(e.UIKind={}));var T;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(T=e.TextEditorRevealType||(e.TextEditorRevealType={}));var C;(function(o){o[o.Editable=0]="Editable",o[o.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var E;(function(o){o[o.Int8Array=1]="Int8Array",o[o.Uint8Array=2]="Uint8Array",o[o.Uint8ClampedArray=3]="Uint8ClampedArray",o[o.Int16Array=4]="Int16Array",o[o.Uint16Array=5]="Uint16Array",o[o.Int32Array=6]="Int32Array",o[o.Uint32Array=7]="Uint32Array",o[o.Float32Array=8]="Float32Array",o[o.Float64Array=9]="Float64Array",o[o.BigInt64Array=10]="BigInt64Array",o[o.BigUint64Array=11]="BigUint64Array"})(E=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var k;(function(o){o[o.Text=1]="Text",o[o.Error=2]="Error",o[o.Rich=3]="Rich"})(k=e.CellOutputKind||(e.CellOutputKind={}));var i;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(i=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var I;(function(o){o[o.None=0]="None",o[o.Process=1]="Process",o[o.Output=2]="Output"})(I=e.CandidatePortSource||(e.CandidatePortSource={}));var a;(function(o){o.name="$ident";function s(n,f){return Object.defineProperty(n,o.name,{value:f,enumerable:!0}),n}o.mixin=s;function v(n){return n[o.name]}o.of=v})(a=e.ObjectIdentifier||(e.ObjectIdentifier={}));class p{static mixin(s){return s._id=p._n++,s}}e.IdObject=p,p._n=0;var h;(function(o){o.label="a",o.kind="b",o.detail="c",o.documentation="d",o.sortText="e",o.filterText="f",o.preselect="g",o.insertText="h",o.insertTextRules="i",o.range="j",o.commitCharacters="k",o.additionalTextEdits="l",o.command="m",o.kindModifier="n"})(h=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var w;(function(o){o.defaultRanges="a",o.completions="b",o.isIncomplete="c",o.duration="d"})(w=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var y;(function(o){o[o.File=1]="File",o[o.Text=2]="Text",o[o.Cell=3]="Cell"})(y=e.WorkspaceEditType||(e.WorkspaceEditType={}));function P(o){if(o&&o.edits)for(const s of o.edits)typeof s.resource=="object"?s.resource=L.URI.revive(s.resource):(s.newUri=L.URI.revive(s.newUri),s.oldUri=L.URI.revive(s.oldUri)),s.metadata&&s.metadata.iconPath&&(s.metadata=(0,g.revive)(s.metadata));return o}e.reviveWorkspaceEditDto=P;var b;(function(o){o[o.Workspace=0]="Workspace",o[o.TextDocument=1]="TextDocument"})(b=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,D.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,D.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,D.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,D.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,D.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,D.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,D.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,D.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,D.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,D.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,D.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,D.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,D.createMainContextProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,D.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,D.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,D.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,D.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,D.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,D.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,D.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,D.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,D.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,D.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,D.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,D.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,D.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,D.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,D.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,D.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,D.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,D.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,D.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,D.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,D.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,D.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,D.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,D.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,D.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,D.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,D.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,D.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,D.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,D.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,D.createExtHostContextProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,D.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,D.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,D.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,D.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,D.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,D.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,D.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,D.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,D.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,D.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,D.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,D.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,D.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,D.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,D.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,D.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,D.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,D.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,D.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,D.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,D.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,D.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(fe[91],me([0,1,5,3,4]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class S{constructor(C){this._onDidChangePassword=new L.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=C.getProxy(g.MainContext.MainThreadSecretState)}async $onDidChangePassword(C){this._onDidChangePassword.fire(C)}get(C,E){return this._proxy.$getPassword(C,E)}store(C,E,k){return this._proxy.$setPassword(C,E,k)}delete(C,E){return this._proxy.$deletePassword(C,E)}}e.ExtHostSecretState=S,e.IExtHostSecretState=(0,D.createDecorator)("IExtHostSecretState")}),define(fe[68],me([0,1,4,11,5,14]),function(Y,e,g,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,g.createDecorator)("IExtHostApiDeprecationService");let T=class{constructor(E,k){this._extHostLogService=k,this._reportedUsages=new Set,this._telemetryShape=E.getProxy(D.MainContext.MainThreadTelemetry)}report(E,k,i){const I=this.getUsageKey(E,k);this._reportedUsages.has(I)||(this._reportedUsages.add(I),k.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${E}' is deprecated. ${i}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:E}))}getUsageKey(E,k){return`${E}-${k.identifier.value}`}};T=Ve([$e(0,S.IExtHostRpcService),$e(1,L.ILogService)],T),e.ExtHostApiDeprecationService=T,e.NullApiDeprecationService=Object.freeze(new class{report(C,E,k){}})}),define(fe[232],me([0,1,3,5,7,27]),function(Y,e,g,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class T{constructor(E){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new g.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=E.getProxy(L.MainContext.MainThreadAuthentication)}$setProviders(E){return this._providers=E,Promise.resolve()}async getSession(E,k,i,I={}){const a=S.ExtensionIdentifier.toKey(E.identifier),p=this._inFlightRequests.get(a)||[],h=[...i].sort().join(" ");let w=p.find(y=>y.scopes===h);if(w)return w.result;{const y=this._getSession(E,a,k,i,I);w={scopes:h,result:y},p.push(w),this._inFlightRequests.set(a,p);try{await y}finally{const P=p.findIndex(b=>b.scopes===h);P>-1&&(p.splice(P),this._inFlightRequests.set(a,p))}return y}}async _getSession(E,k,i,I,a={}){await this._proxy.$ensureProvider(i);const p=E.displayName||E.name;return this._proxy.$getSession(i,I,k,p,a)}async removeSession(E,k){const i=this._authenticationProviders.get(E);return i?i.provider.removeSession(k):this._proxy.$removeSession(E,k)}registerAuthenticationProvider(E,k,i,I){if(this._authenticationProviders.get(E))throw new Error(`An authentication provider with id '${E}' is already registered.`);this._authenticationProviders.set(E,{label:k,provider:i,options:I??{supportsMultipleAccounts:!1}}),this._providers.find(p=>p.id===E)||this._providers.push({id:E,label:k});const a=i.onDidChangeSessions(p=>{this._proxy.$sendDidChangeSessions(E,{added:p.added??[],changed:p.changed??[],removed:p.removed??[]})});return this._proxy.$registerAuthenticationProvider(E,k,I?.supportsMultipleAccounts??!1),new D.Disposable(()=>{a.dispose(),this._authenticationProviders.delete(E);const p=this._providers.findIndex(h=>h.id===E);p>-1&&this._providers.splice(p),this._proxy.$unregisterAuthenticationProvider(E)})}$createSession(E,k){const i=this._authenticationProviders.get(E);if(i)return Promise.resolve(i.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$removeSession(E,k){const i=this._authenticationProviders.get(E);if(i)return Promise.resolve(i.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$getSessions(E,k){const i=this._authenticationProviders.get(E);if(i)return Promise.resolve(i.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$onDidChangeAuthenticationSessions(E,k){return this._onDidChangeSessions.fire({provider:{id:E,label:k}}),Promise.resolve()}}e.ExtHostAuthentication=T}),define(fe[233],me([0,1,5,14,17]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let S=class{constructor(C,E){this._extHostDocumentsAndEditors=E,this._proxy=C.getProxy(g.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(C){const E=D.WorkspaceEdit.from(C,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(E)}};S=Ve([$e(0,L.IExtHostRpcService)],S),e.ExtHostBulkEdits=S}),define(fe[234],me([0,1,5]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class L{constructor(S){const T=S.getProxy(g.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return T.$readText()},writeText(C){return T.$writeText(C)}})}}e.ExtHostClipboard=L}),define(fe[40],me([0,1,13,7,17,25,5,15,11,62,42,51,2,6,4,14,66,22,55,52]),function(Y,e,g,L,D,S,T,C,E,k,i,I,a,p,h,w,y,P,b,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let s=class{constructor(u,l){this._commands=new Map,this._apiCommands=new Map,this._proxy=u.getProxy(T.MainContext.MainThreadCommands),this._logService=l,this.converter=new v(this,c=>{const m=this._apiCommands.get(c);return m?.result===f.Void?m:void 0},l),this._argumentProcessors=[{processArgument(c){return(0,k.revive)(c)}},{processArgument(c){return(0,S.cloneAndChange)(c,function(m){if(i.Range.isIRange(m))return D.Range.to(m);if(I.Position.isIPosition(m))return D.Position.to(m);if(i.Range.isIRange(m.range)&&a.URI.isUri(m.uri))return D.location.to(m);if(m instanceof P.VSBuffer)return m.buffer.buffer;if(!Array.isArray(m))return m})}}]}registerArgumentProcessor(u){this._argumentProcessors.push(u)}registerApiCommand(u){const l=this.registerCommand(!1,u.id,async(...c)=>{const m=u.args.map((_,A)=>{if(!_.validate(c[A]))throw new Error(`Invalid argument '${_.name}' when running '${u.id}', received: ${c[A]}`);return _.convert(c[A])}),d=await this.executeCommand(u.internalId,...m);return u.result.convert(d,c,this.converter)},void 0,{description:u.description,args:u.args,returns:u.result.description});return this._apiCommands.set(u.id,u),new L.Disposable(()=>{l.dispose(),this._apiCommands.delete(u.id)})}registerCommand(u,l,c,m,d,_){if(this._logService.trace("ExtHostCommands#registerCommand",l),!l.trim().length)throw new Error("invalid id");if(this._commands.has(l))throw new Error(`command '${l}' already exists`);return this._commands.set(l,{callback:c,thisArg:m,description:d,extension:_}),u&&this._proxy.$registerCommand(l),new L.Disposable(()=>{this._commands.delete(l)&&u&&this._proxy.$unregisterCommand(l)})}executeCommand(u,...l){return this._logService.trace("ExtHostCommands#executeCommand",u),this._doExecuteCommand(u,l,!0)}async _doExecuteCommand(u,l,c){if(this._commands.has(u))return this._executeContributedCommand(u,l,!1);{let m=!1;const d=(0,S.cloneAndChange)(l,function(_){if(_ instanceof L.Position)return D.Position.from(_);if(_ instanceof L.Range)return D.Range.from(_);if(_ instanceof L.Location)return D.location.from(_);if(L.NotebookRange.isNotebookRange(_))return D.NotebookRange.from(_);if(_ instanceof ArrayBuffer)return m=!0,P.VSBuffer.wrap(new Uint8Array(_));if(_ instanceof Uint8Array)return m=!0,P.VSBuffer.wrap(_);if(!Array.isArray(_))return _});try{const _=await this._proxy.$executeCommand(u,m?new b.SerializableObjectWithBuffers(d):d,c);return(0,k.revive)(_)}catch(_){if(_ instanceof Error&&_.message==="$executeCommand:retry")return this._doExecuteCommand(u,l,!1);throw _}}}async _executeContributedCommand(u,l,c){const m=this._commands.get(u);if(!m)throw new Error("Unknown command");let{callback:d,thisArg:_,description:A}=m;if(A)for(let R=0;R<A.args.length;R++)try{(0,g.validateConstraint)(l[R],A.args[R].constraint)}catch(B){throw new Error(`Running the contributed command: '${u}' failed. Illegal argument '${A.args[R].name}' - ${A.args[R].description}`)}try{return await d.apply(_,l)}catch(R){if(u===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...l);B&&(u=B.command)}throw this._logService.error(R,u,m.extension?.identifier),c?new class extends Error{constructor(){super((0,o.toErrorMessage)(R));this.id=u,this.source=m.extension?.displayName??m.extension?.name}}:R}}$executeContributedCommand(u,...l){return this._logService.trace("ExtHostCommands#$executeContributedCommand",u),this._commands.has(u)?(l=l.map(c=>this._argumentProcessors.reduce((m,d)=>d.processArgument(m),c)),this._executeContributedCommand(u,l,!0)):Promise.reject(new Error(`Contributed command '${u}' does not exist.`))}getCommands(u=!1){return this._logService.trace("ExtHostCommands#getCommands",u),this._proxy.$getCommands().then(l=>(u&&(l=l.filter(c=>c[0]!=="_")),l))}$getContributedCommandHandlerDescriptions(){const u=Object.create(null);for(let[l,c]of this._commands){let{description:m}=c;m&&(u[l]=m)}return Promise.resolve(u)}};s=Ve([$e(0,w.IExtHostRpcService),$e(1,E.ILogService)],s),e.ExtHostCommands=s,e.IExtHostCommands=(0,h.createDecorator)("IExtHostCommands");class v{constructor(u,l,c){this._commands=u,this._lookupApiCommand=l,this._logService=c,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(u,l){if(!u)return;const c={$ident:void 0,id:u.command,title:u.title,tooltip:u.tooltip};if(!u.command)return c;const m=this._lookupApiCommand(u.command);if(m)c.id=m.internalId,c.arguments=m.args.map((d,_)=>d.convert(u.arguments&&u.arguments[_]));else if((0,C.isNonEmptyArray)(u.arguments)){const d=++this._cachIdPool;this._cache.set(d,u),l.add((0,p.toDisposable)(()=>{this._cache.delete(d),this._logService.trace("CommandsConverter#DISPOSE",d)})),c.$ident=d,c.id=this.delegatingCommandId,c.arguments=[d],this._logService.trace("CommandsConverter#CREATE",u.command,d)}return c}fromInternal(u){const l=T.ObjectIdentifier.of(u);return typeof l=="number"?this._cache.get(l):{command:u.id,title:u.title,arguments:u.arguments}}getActualCommand(...u){return this._cache.get(u[0])}_executeConvertedCommand(...u){const l=this.getActualCommand(...u);return this._logService.trace("CommandsConverter#EXECUTE",u[0],l?l.command:"MISSING"),l?this._commands.executeCommand(l.command,...l.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=v;class n{constructor(u,l,c,m){this.name=u,this.description=l,this.validate=c,this.convert=m}optional(){return new n(this.name,`(optional) ${this.description}`,u=>u==null||this.validate(u),u=>u===void 0?void 0:u===null?null:this.convert(u))}with(u,l){return new n(u??this.name,l??this.description,this.validate,this.convert)}}e.ApiCommandArgument=n,n.Uri=new n("uri","Uri of a text document",t=>a.URI.isUri(t),t=>t),n.Position=new n("position","A position in a text document",t=>L.Position.isPosition(t),D.Position.from),n.Range=new n("range","A range in a text document",t=>L.Range.isRange(t),D.Range.from),n.Selection=new n("selection","A selection in a text document",t=>L.Selection.isSelection(t),D.Selection.from),n.Number=new n("number","",t=>typeof t=="number",t=>t),n.String=new n("string","",t=>typeof t=="string",t=>t),n.CallHierarchyItem=new n("item","A call hierarchy item",t=>t instanceof L.CallHierarchyItem,D.CallHierarchyItem.from),n.TypeHierarchyItem=new n("item","A type hierarchy item",t=>t instanceof L.TypeHierarchyItem,D.TypeHierarchyItem.from),n.TestItem=new n("testItem","A VS Code TestItem",t=>t instanceof y.TestItemImpl,D.TestItem.from);class f{constructor(u,l){this.description=u,this.convert=l}}e.ApiCommandResult=f,f.Void=new f("no result",t=>t);class r{constructor(u,l,c,m,d){this.id=u,this.internalId=l,this.description=c,this.args=m,this.result=d}}e.ApiCommand=r}),define(fe[235],me([0,1,17,7,85,40,15,111]),function(Y,e,g,L,D,S,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const E=[new S.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",i(g.DocumentHighlight.to))),new S.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,p)=>{if((0,T.isFalsyOrEmpty)(a))return;class h extends L.SymbolInformation{static to(y){const P=new h(y.name,g.SymbolKind.to(y.kind),y.containerName||"",new L.Location(p[0],g.Range.to(y.range)));return P.detail=y.detail,P.range=P.location.range,P.selectionRange=g.Range.to(y.selectionRange),P.children=y.children?y.children.map(h.to):[],P}}return a.map(h.to)})),new S.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(g.TextEdit.to))),new S.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range,new S.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(g.TextEdit.to))),new S.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,new S.ApiCommandArgument("ch","Trigger character",a=>typeof a=="string",a=>a),new S.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(g.TextEdit.to))),new S.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new S.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new S.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new S.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new S.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location-instances.",i(g.location.to))),new S.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Hover-instances.",i(g.Hover.to))),new S.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("position","A position in a text document",a=>Array.isArray(a)&&a.every(p=>L.Position.isPosition(p)),a=>a.map(g.Position.from))],new S.ApiCommandResult("A promise that resolves to an array of ranges.",a=>a.map(p=>{let h;for(const w of p.reverse())h=new L.SelectionRange(g.Range.to(w),h);return h}))),new S.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[S.ApiCommandArgument.String.with("query","Search string")],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",a=>{const p=[];if(Array.isArray(a))for(let h of a)p.push(...h[1].map(g.WorkspaceSymbol.to));return p})),new S.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(g.CallHierarchyItem.to))),new S.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(g.CallHierarchyIncomingCall.to))),new S.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(g.CallHierarchyOutgoingCall.to))),new S.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to a range and placeholder text.",a=>{if(!!a)return{range:g.Range.to(a.range),placeholder:a.text}})),new S.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("newName","The new symbol name")],new S.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",a=>{if(!!a){if(a.rejectReason)throw new Error(a.rejectReason);return g.WorkspaceEdit.to(a)}})),new S.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new S.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(g.DocumentLink.to))),new S.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new L.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const p=(0,C.decodeSemanticTokensDto)(a);if(p.type==="full")return new L.SemanticTokens(p.data,void 0)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range.optional()],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new L.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const p=(0,C.decodeSemanticTokensDto)(a);if(p.type==="full")return new L.SemanticTokens(p.data,void 0)})),new S.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new S.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(a,p,h)=>{if(!a)return new L.CompletionList([]);const w=a.suggestions.map(y=>g.CompletionItem.to(y,h));return new L.CompletionList(w,a.incomplete)})),new S.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new S.ApiCommandResult("A promise that resolves to SignatureHelp.",a=>{if(a)return g.SignatureHelp.to(a)})),new S.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new S.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(a,p,h)=>i(w=>new L.CodeLens(g.Range.to(w.range),w.command&&h.fromInternal(w.command)))(a))),new S.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>L.Range.isRange(a),a=>L.Selection.isSelection(a)?g.Selection.from(a):g.Range.from(a)),S.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new S.ApiCommandResult("A promise that resolves to an array of Command-instances.",(a,p,h)=>i(w=>{if(w._isSynthetic){if(!w.command)throw new Error("Synthetic code actions must have a command");return h.fromInternal(w.command)}else{const y=new L.CodeAction(w.title,w.kind?new L.CodeActionKind(w.kind):void 0);return w.edit&&(y.edit=g.WorkspaceEdit.to(w.edit)),w.command&&(y.command=h.fromInternal(w.command)),y.isPreferred=w.isPreferred,y}})(a))),new S.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(p=>new L.ColorInformation(g.Range.to(p.range),g.Color.to(p.color))):[])),new S.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new S.ApiCommandArgument("color","The color to show and insert",a=>a instanceof L.Color,g.Color.from),new S.ApiCommandArgument("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:g.Range.from(a.range)}))],new S.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(g.ColorPresentation.to):[])),new S.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of Inlay objects",a=>a.map(g.InlayHint.to))),new S.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new S.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",i(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(p=>g.NotebookExclusiveDocumentPattern.to(p))})))),new S.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of InlineValue objects",a=>a.map(g.InlineValue.to))),new S.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[g.ViewColumn.from(a.viewColumn),g.TextEditorOpenOptions.from(a)])).optional(),S.ApiCommandArgument.String.with("label","").optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[S.ApiCommandArgument.Uri.with("resource","Resource to open"),S.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[g.ViewColumn.from(a.viewColumn),g.TextEditorOpenOptions.from(a)])).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[S.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),S.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),S.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[g.ViewColumn.from(a.viewColumn),g.TextEditorOpenOptions.from(a)]).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A TypeHierarchyItem or undefined",a=>a.map(g.TypeHierarchyItem.to))),new S.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[S.ApiCommandArgument.TypeHierarchyItem],new S.ApiCommandResult("A TypeHierarchyItem or undefined",a=>a.map(g.TypeHierarchyItem.to))),new S.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[S.ApiCommandArgument.TypeHierarchyItem],new S.ApiCommandResult("A TypeHierarchyItem or undefined",a=>a.map(g.TypeHierarchyItem.to))),new S.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[S.ApiCommandArgument.TestItem],S.ApiCommandResult.Void)];class k{static register(p){E.forEach(p.registerApiCommand,p)}}e.ExtHostApiCommands=k;function i(a){return p=>{if(Array.isArray(p))return p.map(a)}}function I(a){if(!Array.isArray(a))return;const p=[];for(const h of a)D.isLocationLink(h)?p.push(g.DefinitionLink.to(h)):p.push(g.location.to(h));return p}}),define(fe[236],me([0,1,16,60,3,6,2,85,27,17,7,5]),function(Y,e,g,L,D,S,T,C,E,k,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function a(p,h,w){const y=p.getProxy(I.MainContext.MainThreadComments);class P{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,h.registerArgumentProcessor({processArgument:t=>{if(t&&t.$mid===6){const u=this._commentControllers.get(t.handle);return u||t}else if(t&&t.$mid===7){const u=this._commentControllers.get(t.commentControlHandle);if(!u)return t;const l=u.getCommentThread(t.commentThreadHandle);return l||t}else if(t&&t.$mid===8){const u=this._commentControllers.get(t.thread.commentControlHandle);if(!u)return t;const l=u.getCommentThread(t.thread.commentThreadHandle);return l?{thread:l,text:t.text}:t}else if(t&&t.$mid===9){const u=this._commentControllers.get(t.thread.commentControlHandle);if(!u)return t;const l=u.getCommentThread(t.thread.commentThreadHandle);if(!l)return t;let c=t.commentUniqueId,m=l.getCommentByUniqueId(c);return m||t}else if(t&&t.$mid===10){const u=this._commentControllers.get(t.thread.commentControlHandle);if(!u)return t;const l=u.getCommentThread(t.thread.commentThreadHandle);if(!l)return t;let c=t.text,m=t.commentUniqueId,d=l.getCommentByUniqueId(m);return d?(d.body=c,d):t}return t}})}createCommentController(t,u,l){const c=P.handlePool++,m=new o(t,c,u,l);this._commentControllers.set(m.handle,m);const d=this._commentControllersByExtension.get(E.ExtensionIdentifier.toKey(t.identifier))||[];return d.push(m),this._commentControllersByExtension.set(E.ExtensionIdentifier.toKey(t.identifier),d),m.value}$createCommentThreadTemplate(t,u,l){const c=this._commentControllers.get(t);!c||c.$createCommentThreadTemplate(u,l)}async $updateCommentThreadTemplate(t,u,l){const c=this._commentControllers.get(t);!c||c.$updateCommentThreadTemplate(u,l)}$deleteCommentThread(t,u){const l=this._commentControllers.get(t);l&&l.$deleteCommentThread(u)}$provideCommentingRanges(t,u,l){const c=this._commentControllers.get(t);if(!c||!c.commentingRangeProvider)return Promise.resolve(void 0);const m=w.getDocument(T.URI.revive(u));return(0,g.asPromise)(()=>c.commentingRangeProvider.provideCommentingRanges(m,l)).then(d=>d?d.map(_=>k.Range.from(_)):void 0)}$toggleReaction(t,u,l,c,m){const d=this._commentControllers.get(t);return!d||!d.reactionHandler?Promise.resolve(void 0):(0,g.asPromise)(()=>{const _=d.getCommentThread(u);if(_){const A=_.getCommentByUniqueId(c.uniqueIdInThread);if(d!==void 0&&A&&d.reactionHandler)return d.reactionHandler(A,n(m))}return Promise.resolve(void 0)})}dispose(){}}P.handlePool=0;class b{constructor(t,u,l,c,m,d,_){this._commentControllerHandle=u,this._id=l,this._uri=c,this._range=m,this._comments=d,this.handle=b._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new D.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new S.MutableDisposable,this._acceptInputDisposables.value=new S.DisposableStore,this._id===void 0&&(this._id=`${t}.${this.handle}`),y.$createCommentThread(u,this.handle,this._id,this._uri,k.Range.from(this._range),_),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=d,this._localDisposables.push({dispose:()=>{y.$deleteCommentThread(u,this.handle)}});const A=this;this.value={get uri(){return A.uri},get range(){return A.range},set range(R){A.range=R},get comments(){return A.comments},set comments(R){A.comments=R},get collapsibleState(){return A.collapsibleState},set collapsibleState(R){A.collapsibleState=R},get canReply(){return A.canReply},set canReply(R){A.canReply=R},get contextValue(){return A.contextValue},set contextValue(R){A.contextValue=R},get label(){return A.label},set label(R){A.label=R},dispose:()=>{A.dispose()}}}set threadId(t){this._id=t}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(t){t.isEqual(this._range)||(this._range=t,this.modifications.range=t,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(t){this._canReply!==t&&(this._canReply=t,this.modifications.canReply=t,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(t){this._label=t,this.modifications.label=t,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(t){this._contextValue=t,this.modifications.contextValue=t,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(t){this._comments=t,this.modifications.comments=t,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(t){this._collapseState=t,this.modifications.collapsibleState=t,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new S.DisposableStore);const t=l=>Object.prototype.hasOwnProperty.call(this.modifications,l),u={};t("range")&&(u.range=k.Range.from(this._range)),t("label")&&(u.label=this.label),t("contextValue")&&(u.contextValue=this.contextValue??null),t("comments")&&(u.comments=this._comments.map(l=>s(this,l,this._commentsMap))),t("collapsibleState")&&(u.collapseState=f(this._collapseState)),t("canReply")&&(u.canReply=this.canReply),this.modifications={},y.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,u)}getCommentByUniqueId(t){for(let u of this._commentsMap){let l=u[0],c=u[1];if(t===c)return l}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(t=>t.dispose())}}b._handlePool=0,Ve([(0,L.debounce)(100)],b.prototype,"eventuallyUpdateCommentThread",null);class o{constructor(t,u,l,c){this._extension=t,this._handle=u,this._id=l,this._label=c,this._threads=new Map,y.$registerCommentController(this.handle,l,c);const m=this;this.value=Object.freeze({id:m.id,label:m.label,get options(){return m.options},set options(d){m.options=d},get commentingRangeProvider(){return m.commentingRangeProvider},set commentingRangeProvider(d){m.commentingRangeProvider=d},get reactionHandler(){return m.reactionHandler},set reactionHandler(d){m.reactionHandler=d},createCommentThread(d,_,A){return m.createCommentThread(d,_,A).value},dispose:()=>{m.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{y.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(t){this._commentingRangeProvider=t,y.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(t){this._reactionHandler=t,y.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!t})}get options(){return this._options}set options(t){this._options=t,y.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(t,u,l,c){if(typeof t=="string"){const m=new b(this.id,this.handle,t,u,l,c,this._extension.identifier);return this._threads.set(m.handle,m),m}else{const m=new b(this.id,this.handle,void 0,t,u,l,this._extension.identifier);return this._threads.set(m.handle,m),m}}$createCommentThreadTemplate(t,u){const l=new b(this.id,this.handle,void 0,T.URI.revive(t),k.Range.to(u),[],this._extension.identifier);return l.collapsibleState=C.CommentThreadCollapsibleState.Expanded,this._threads.set(l.handle,l),l}$updateCommentThreadTemplate(t,u){let l=this._threads.get(t);l&&(l.range=k.Range.to(u))}$deleteCommentThread(t){let u=this._threads.get(t);u&&u.dispose(),this._threads.delete(t)}getCommentThread(t){return this._threads.get(t)}dispose(){this._threads.forEach(t=>{t.dispose()}),this._localDisposables.forEach(t=>t.dispose())}}function s(r,t,u){let l=u.get(t);l||(l=++r.commentHandle,u.set(t,l));const c=t.author&&t.author.iconPath?t.author.iconPath.toString():void 0;return{mode:t.mode,contextValue:t.contextValue,uniqueIdInThread:l,body:k.MarkdownString.from(t.body),userName:t.author.name,userIconPath:c,label:t.label,commentReactions:t.reactions?t.reactions.map(m=>v(m)):void 0}}function v(r){return{label:r.label,iconPath:r.iconPath?k.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function n(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?T.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function f(r){if(r!==void 0)switch(r){case i.CommentThreadCollapsibleState.Expanded:return C.CommentThreadCollapsibleState.Expanded;case i.CommentThreadCollapsibleState.Collapsed:return C.CommentThreadCollapsibleState.Collapsed}return C.CommentThreadCollapsibleState.Collapsed}return new P}e.createExtHostComments=a}),define(fe[131],me([0,1,2,5,7,4,14,11,15,8,9]),function(Y,e,g,L,D,S,T,C,E,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class wi{constructor(p,h){this._logService=h,this._provider=new Map,this._proxy=p.getProxy(L.MainContext.MainThreadDecorations)}registerFileDecorationProvider(p,h){const w=wi._handlePool++;this._provider.set(w,{provider:p,extensionId:h}),this._proxy.$registerDecorationProvider(w,h.value);const y=p.onDidChangeFileDecorations&&p.onDidChangeFileDecorations(P=>{if(!P){this._proxy.$onDidChange(w,null);return}let b=(0,E.asArray)(P);if(b.length<=wi._maxEventSize){this._proxy.$onDidChange(w,b);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",h.value,b.length);const o=b.map(n=>({uri:n,rank:(0,k.count)(n.path,"/")})),s=(0,E.groupBy)(o,(n,f)=>n.rank-f.rank||(0,k.compare)(n.uri.path,f.uri.path));let v=[];e:for(let n of s){let f;for(let r of n){let t=(0,i.dirname)(r.uri.path);if(f!==t&&(f=t,v.push(r.uri)>=wi._maxEventSize))break e}}this._proxy.$onDidChange(w,v)});return new D.Disposable(()=>{y?.dispose(),this._proxy.$unregisterDecorationProvider(w),this._provider.delete(w)})}async $provideDecorations(p,h,w){if(!this._provider.has(p))return Object.create(null);const y=Object.create(null),{provider:P,extensionId:b}=this._provider.get(p);return await Promise.all(h.map(async o=>{try{const{uri:s,id:v}=o,n=await Promise.resolve(P.provideFileDecoration(g.URI.revive(s),w));if(!n)return;try{D.FileDecoration.validate(n),y[v]=[n.propagate,n.tooltip,n.badge,n.color]}catch(f){this._logService.warn(`INVALID decoration from extension '${b.value}': ${f}`)}}catch(s){this._logService.error(s)}})),y}};I._handlePool=0,I._maxEventSize=250,I=Ve([$e(0,T.IExtHostRpcService),$e(1,C.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=(0,S.createDecorator)("IExtHostDecorations")});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,g):D?D.value=g:e.set(Y,g),g},Oe=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[237],me([0,1,164,116,2,5,7,17,3,11,24,45]),function(Y,e,g,L,D,S,T,C,E,k,i,I){"use strict";var a,p,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class w{constructor(b,o,s,v,n,f){this._name=b,this._owner=o,this._maxDiagnosticsPerFile=s,a.set(this,void 0),p.set(this,void 0),h.set(this,void 0),this._isDisposed=!1,st(this,h,new i.ResourceMap(r=>v.getComparisonKey(r)),"f"),st(this,a,n,"f"),st(this,p,f,"f")}dispose(){this._isDisposed||(Oe(this,p,"f").fire([...Oe(this,h,"f").keys()]),Oe(this,a,"f")&&Oe(this,a,"f").$clear(this._owner),Oe(this,h,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(b,o){if(!b){this.clear();return}this._checkDisposed();let s=[];if(D.URI.isUri(b)){if(!o){this.delete(b);return}Oe(this,h,"f").set(b,o.slice()),s=[b]}else if(Array.isArray(b)){s=[];let n;b=[...b].sort(w._compareIndexedTuplesByUri);for(const f of b){const[r,t]=f;if((!n||r.toString()!==n.toString())&&(n&&Oe(this,h,"f").get(n).length===0&&Oe(this,h,"f").delete(n),n=r,s.push(r),Oe(this,h,"f").set(r,[])),t){const u=Oe(this,h,"f").get(r);u&&u.push(...t)}else{const u=Oe(this,h,"f").get(r);u&&(u.length=0)}}}if(Oe(this,p,"f").fire(s),!Oe(this,a,"f"))return;const v=[];for(let n of s){let f=[];const r=Oe(this,h,"f").get(n);if(r)if(r.length>this._maxDiagnosticsPerFile){f=[];const t=[T.DiagnosticSeverity.Error,T.DiagnosticSeverity.Warning,T.DiagnosticSeverity.Information,T.DiagnosticSeverity.Hint];e:for(let u=0;u<4;u++)for(let l of r)if(l.severity===t[u]&&f.push(C.Diagnostic.from(l))===this._maxDiagnosticsPerFile)break e;f.push({severity:L.MarkerSeverity.Info,message:(0,g.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:f[f.length-1].startLineNumber,startColumn:f[f.length-1].startColumn,endLineNumber:f[f.length-1].endLineNumber,endColumn:f[f.length-1].endColumn})}else f=r.map(t=>C.Diagnostic.from(t));v.push([n,f])}Oe(this,a,"f").$changeMany(this._owner,v)}delete(b){this._checkDisposed(),Oe(this,p,"f").fire([b]),Oe(this,h,"f").delete(b),Oe(this,a,"f")&&Oe(this,a,"f").$changeMany(this._owner,[[b,void 0]])}clear(){this._checkDisposed(),Oe(this,p,"f").fire([...Oe(this,h,"f").keys()]),Oe(this,h,"f").clear(),Oe(this,a,"f")&&Oe(this,a,"f").$clear(this._owner)}forEach(b,o){this._checkDisposed();for(let s of Oe(this,h,"f").keys())b.apply(o,[s,this.get(s),this])}get(b){this._checkDisposed();const o=Oe(this,h,"f").get(b);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(b){return this._checkDisposed(),Array.isArray(Oe(this,h,"f").get(b))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(b,o){return b[0].toString()<o[0].toString()?-1:b[0].toString()>o[0].toString()?1:0}}e.DiagnosticCollection=w,a=new WeakMap,p=new WeakMap,h=new WeakMap;let y=class ti{constructor(b,o,s){this._logService=o,this._fileSystemInfoService=s,this._collections=new Map,this._onDidChangeDiagnostics=new E.DebounceEmitter({merge:v=>v.flat(),delay:50}),this.onDidChangeDiagnostics=E.Event.map(this._onDidChangeDiagnostics.event,ti._mapper),this._proxy=b.getProxy(S.MainContext.MainThreadDiagnostics)}static _mapper(b){const o=new i.ResourceMap;for(const s of b)o.set(s,s);return{uris:Object.freeze(Array.from(o.values()))}}createDiagnosticCollection(b,o){const{_collections:s,_proxy:v,_onDidChangeDiagnostics:n,_logService:f,_fileSystemInfoService:r}=this,t=new class{$changeMany(c,m){v.$changeMany(c,m),f.trace("[DiagnosticCollection] change many (extension, owner, uris)",b.value,c,m.length===0?"CLEARING":m)}$clear(c){v.$clear(c),f.trace("[DiagnosticCollection] remove all (extension, owner)",b.value,c)}dispose(){v.dispose()}};let u;if(!o)o="_generated_diagnostic_collection_name_#"+ti._idPool++,u=o;else if(!s.has(o))u=o;else{this._logService.warn(`DiagnosticCollection with name '${o}' does already exist.`);do u=o+ti._idPool++;while(s.has(u))}return new class extends w{constructor(){super(o,u,ti._maxDiagnosticsPerFile,r.extUri,t,n);s.set(u,this)}dispose(){super.dispose(),s.delete(u)}}}getDiagnostics(b){if(b)return this._getDiagnostics(b);{const o=new Map,s=[];for(const v of this._collections.values())v.forEach((n,f)=>{let r=o.get(n.toString());typeof r=="undefined"&&(r=s.length,o.set(n.toString(),r),s.push([n,[]])),s[r][1]=s[r][1].concat(...f)});return s}}_getDiagnostics(b){let o=[];for(let s of this._collections.values())s.has(b)&&(o=o.concat(s.get(b)));return o}$acceptMarkersChange(b){if(!this._mirrorCollection){const o="_generated_mirror",s=new w(o,o,ti._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(o,s),this._mirrorCollection=s}for(const[o,s]of b)this._mirrorCollection.set(D.URI.revive(o),s.map(C.Diagnostic.to))}};y._idPool=0,y._maxDiagnosticsPerFile=1e3,y=Ve([$e(1,k.ILogService),$e(2,I.IExtHostFileSystemInfo)],y),e.ExtHostDiagnostics=y}),define(fe[238],me([0,1,2,5]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class D{constructor(T){this._proxy=T.getProxy(L.MainContext.MainThreadDialogs)}showOpenDialog(T){return this._proxy.$showOpenDialog(T).then(C=>C?C.map(E=>g.URI.revive(E)):void 0)}showSaveDialog(T){return this._proxy.$showSaveDialog(T).then(C=>C?g.URI.revive(C):void 0)}}e.ExtHostDialogs=D}),define(fe[239],me([0,1,18,2,7,5,10,21,8]),function(Y,e,g,L,D,S,T,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(I,a,p){this._documentsAndEditors=a,this._logService=p,this._documentContentProviders=new Map,this._proxy=I.getProxy(S.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,a){if(Object.keys(T.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const p=k._handlePool++;this._documentContentProviders.set(p,a),this._proxy.$registerTextContentProvider(p,I);let h;return typeof a.onDidChange=="function"&&(h=a.onDidChange(w=>{if(w.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${w.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(w)&&this.$provideTextDocumentContent(p,w).then(y=>{if(!y&&typeof y!="string")return;const P=this._documentsAndEditors.getDocument(w);if(!P)return;const b=(0,E.splitLines)(y);if(!P.equalLines(b))return this._proxy.$onVirtualDocumentChange(w,y)},g.onUnexpectedError)})),new D.Disposable(()=>{this._documentContentProviders.delete(p)&&this._proxy.$unregisterTextContentProvider(p),h&&(h.dispose(),h=void 0)})}$provideTextDocumentContent(I,a){const p=this._documentContentProviders.get(I);return p?Promise.resolve(p.provideTextDocumentContent(L.URI.revive(a),C.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${a.scheme}`))}}e.ExtHostDocumentContentProvider=k,k._handlePool=0}),define(fe[240],me([0,1,3,6,2,5,123,17,13,25,7]),function(Y,e,g,L,D,S,T,C,E,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class I{constructor(p,h){this._onDidAddDocument=new g.Emitter,this._onDidRemoveDocument=new g.Emitter,this._onDidChangeDocument=new g.Emitter,this._onDidSaveDocument=new g.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new L.DisposableStore,this._documentLoader=new Map,this._proxy=p.getProxy(S.MainContext.MainThreadDocuments),this._documentsAndEditors=h,this._documentsAndEditors.onDidRemoveDocuments(w=>{for(const y of w)this._onDidRemoveDocument.fire(y.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(w=>{for(const y of w)this._onDidAddDocument.fire(y.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(p){if(!p)return;const h=this._documentsAndEditors.getDocument(p);if(h)return h}getDocument(p){const h=this.getDocumentData(p);if(!h?.document)throw new Error(`Unable to retrieve document from URI '${p}'`);return h.document}ensureDocumentData(p){const h=this._documentsAndEditors.getDocument(p);if(h)return Promise.resolve(h);let w=this._documentLoader.get(p.toString());return w||(w=this._proxy.$tryOpenDocument(p).then(y=>{this._documentLoader.delete(p.toString());const P=D.URI.revive(y);return(0,E.assertIsDefined)(this._documentsAndEditors.getDocument(P))},y=>(this._documentLoader.delete(p.toString()),Promise.reject(y))),this._documentLoader.set(p.toString(),w)),w}createDocumentData(p){return this._proxy.$tryCreateDocument(p).then(h=>D.URI.revive(h))}$acceptModelModeChanged(p,h){const w=D.URI.revive(p),y=this._documentsAndEditors.getDocument(w);if(!y)throw new Error("unknown document");this._onDidRemoveDocument.fire(y.document),y._acceptLanguageId(h),this._onDidAddDocument.fire(y.document)}$acceptModelSaved(p){const h=D.URI.revive(p),w=this._documentsAndEditors.getDocument(h);if(!w)throw new Error("unknown document");this.$acceptDirtyStateChanged(p,!1),this._onDidSaveDocument.fire(w.document)}$acceptDirtyStateChanged(p,h){const w=D.URI.revive(p),y=this._documentsAndEditors.getDocument(w);if(!y)throw new Error("unknown document");y._acceptIsDirty(h),this._onDidChangeDocument.fire({document:y.document,contentChanges:[],reason:void 0})}$acceptModelChanged(p,h,w){const y=D.URI.revive(p),P=this._documentsAndEditors.getDocument(y);if(!P)throw new Error("unknown document");P._acceptIsDirty(w),P.onEvents(h);let b;h.isUndoing?b=i.TextDocumentChangeReason.Undo:h.isRedoing&&(b=i.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,k.deepFreeze)({document:P.document,contentChanges:h.changes.map(o=>({range:C.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:b}))}setWordDefinitionFor(p,h){(0,T.setWordDefinitionFor)(p,h)}}e.ExtHostDocuments=I}),define(fe[46],me([0,1,58,3,6,2,4,5,123,14,130,17,11,24,10,78,141]),function(Y,e,g,L,D,S,T,C,E,k,i,I,a,p,h,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class P{constructor(s){this.value=s,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let b=class{constructor(s,v){this._extHostRpc=s,this._logService=v,this._activeEditorId=null,this._editors=new Map,this._documents=new p.ResourceMap,this._onDidAddDocuments=new L.Emitter,this._onDidRemoveDocuments=new L.Emitter,this._onDidChangeVisibleTextEditors=new L.Emitter,this._onDidChangeActiveTextEditor=new L.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(s){this.acceptDocumentsAndEditorsDelta(s)}acceptDocumentsAndEditorsDelta(s){const v=[],n=[],f=[];if(s.removedDocuments)for(const r of s.removedDocuments){const t=S.URI.revive(r),u=this._documents.get(t);u?.unref()&&(this._documents.delete(t),v.push(u.value))}if(s.addedDocuments)for(const r of s.addedDocuments){const t=S.URI.revive(r.uri);let u=this._documents.get(t);if(u&&t.scheme!==h.Schemas.vscodeNotebookCell&&t.scheme!==h.Schemas.vscodeInteractiveInput)throw new Error(`document '${t} already exists!'`);u||(u=new P(new E.ExtHostDocumentData(this._extHostRpc.getProxy(C.MainContext.MainThreadDocuments),t,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this._documents.set(t,u),n.push(u.value)),u.ref()}if(s.removedEditors)for(const r of s.removedEditors){const t=this._editors.get(r);this._editors.delete(r),t&&f.push(t)}if(s.addedEditors)for(const r of s.addedEditors){const t=S.URI.revive(r.documentUri);g.ok(this._documents.has(t),`document '${t}' does not exist`),g.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const u=this._documents.get(t).value,l=new i.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(C.MainContext.MainThreadTextEditors),this._logService,new y.Lazy(()=>u.document),r.selections.map(I.Selection.to),r.options,r.visibleRanges.map(c=>I.Range.to(c)),typeof r.editorPosition=="number"?I.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,l)}s.newActiveEditor!==void 0&&(g.ok(s.newActiveEditor===null||this._editors.has(s.newActiveEditor),`active editor '${s.newActiveEditor}' does not exist`),this._activeEditorId=s.newActiveEditor),(0,D.dispose)(v),(0,D.dispose)(f),s.removedDocuments&&this._onDidRemoveDocuments.fire(v),s.addedDocuments&&this._onDidAddDocuments.fire(n),(s.removedEditors||s.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),s.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(s){return this._documents.get(s)?.value}allDocuments(){return w.Iterable.map(this._documents.values(),s=>s.value)}getEditor(s){return this._editors.get(s)}activeEditor(s){if(!this._activeEditorId)return;const v=this._editors.get(this._activeEditorId);return s?v:v?.value}allEditors(){return[...this._editors.values()]}};b=Ve([$e(0,k.IExtHostRpcService),$e(1,a.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=(0,T.createDecorator)("IExtHostDocumentsAndEditors")}),define(fe[56],me([0,1,17,5,2,3,4,14,16]),function(Y,e,g,L,D,S,T,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,T.createDecorator)("IExtHostEditorTabs");let k=class{constructor(I){this._onDidChangeTabs=new S.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new S.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=I.getProxy(L.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(I){let a=-1;this._tabs=I.map((h,w)=>(h.isActive&&(a=w),Object.freeze({label:h.label,viewColumn:g.ViewColumn.to(h.viewColumn),index:w,resource:D.URI.revive(h.resource),additionalResourcesAndViewIds:h.additionalResourcesAndViewIds.map(({resource:y,viewId:P})=>({resource:D.URI.revive(y),viewId:P})),viewId:h.editorId,isActive:h.isActive,move:async(y,P)=>{this._proxy.$moveTab(h,y,g.ViewColumn.from(P)),await(0,E.raceTimeout)(S.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(h),await(0,E.raceTimeout)(S.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((h,w)=>h.viewColumn===w.viewColumn?h.index-w.index:h.viewColumn-w.viewColumn);const p=this._activeTab;this._activeTab=a===-1?void 0:this._tabs[a],this._activeTab!==p&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};k=Ve([$e(0,C.IExtHostRpcService)],k),e.ExtHostEditorTabs=k}),define(fe[241],me([0,1,2,5,6,7,17,148,8,22]),function(Y,e,g,L,D,S,T,C,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class i{constructor(){this._schemes=[]}add(p){this._stateMachine=void 0,this._schemes.push(p)}delete(p){const h=this._schemes.indexOf(p);h>=0&&(this._schemes.splice(h,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const p=this._schemes.sort(),h=[];let w,y,P=14,b=14;for(const o of p){let s=w?(0,E.commonPrefixLength)(w,o):0;for(s===0?y=1:y=b;s<o.length;s++)s+1===o.length?(P=b,b=9):b+=1,h.push([y,o.toUpperCase().charCodeAt(s),b]),h.push([y,o.toLowerCase().charCodeAt(s),b]),y=b;w=o,b=P}h.push([9,58,10]),h.push([10,47,12]),this._stateMachine=new C.StateMachine(h)}}provideDocumentLinks(p){this._initStateMachine();const h=[],w=C.LinkComputer.computeLinks({getLineContent(y){return p.lineAt(y-1).text},getLineCount(){return p.lineCount}},this._stateMachine);for(const y of w){const P=T.DocumentLink.to(y);P.target&&h.push(P)}return h}}class I{constructor(p,h){this._extHostLanguageFeatures=h,this._linkProvider=new i,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=p.getProxy(L.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(p,h,w,y={}){if(this._registeredSchemes.has(h))throw new Error(`a provider for the scheme '${h}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const P=this._handlePool++;this._linkProvider.add(h),this._registeredSchemes.add(h),this._fsProvider.set(P,w);let b=2;y.isCaseSensitive&&(b+=1024),y.isReadonly&&(b+=2048),typeof w.copy=="function"&&(b+=8),typeof w.open=="function"&&typeof w.close=="function"&&typeof w.read=="function"&&typeof w.write=="function"&&(b+=4),this._proxy.$registerFileSystemProvider(P,h,b).catch(s=>{console.error(`FAILED to register filesystem provider of ${p.value}-extension for the scheme ${h}`),console.error(s)});const o=w.onDidChangeFile(s=>{const v=[];for(const n of s){let{uri:f,type:r}=n;if(f.scheme!==h)continue;let t;switch(r){case S.FileChangeType.Changed:t=0;break;case S.FileChangeType.Created:t=1;break;case S.FileChangeType.Deleted:t=2;break;default:throw new Error("Unknown FileChangeType")}v.push({resource:f,type:t})}this._proxy.$onFileSystemChange(P,v)});return(0,D.toDisposable)(()=>{o.dispose(),this._linkProvider.delete(h),this._registeredSchemes.delete(h),this._fsProvider.delete(P),this._proxy.$unregisterProvider(P)})}static _asIStat(p){const{type:h,ctime:w,mtime:y,size:P,permissions:b}=p;return{type:h,ctime:w,mtime:y,size:P,permissions:b}}$stat(p,h){return Promise.resolve(this._getFsProvider(p).stat(g.URI.revive(h))).then(w=>I._asIStat(w))}$readdir(p,h){return Promise.resolve(this._getFsProvider(p).readDirectory(g.URI.revive(h)))}$readFile(p,h){return Promise.resolve(this._getFsProvider(p).readFile(g.URI.revive(h))).then(w=>k.VSBuffer.wrap(w))}$writeFile(p,h,w,y){return Promise.resolve(this._getFsProvider(p).writeFile(g.URI.revive(h),w.buffer,y))}$delete(p,h,w){return Promise.resolve(this._getFsProvider(p).delete(g.URI.revive(h),w))}$rename(p,h,w,y){return Promise.resolve(this._getFsProvider(p).rename(g.URI.revive(h),g.URI.revive(w),y))}$copy(p,h,w,y){const P=this._getFsProvider(p);if(!P.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(P.copy(g.URI.revive(h),g.URI.revive(w),y))}$mkdir(p,h){return Promise.resolve(this._getFsProvider(p).createDirectory(g.URI.revive(h)))}$watch(p,h,w,y){const P=this._getFsProvider(p).watch(g.URI.revive(w),y);this._watches.set(h,P)}$unwatch(p,h){const w=this._watches.get(h);w&&(w.dispose(),this._watches.delete(h))}$open(p,h,w){const y=this._getFsProvider(p);if(!y.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(y.open(g.URI.revive(h),w))}$close(p,h){const w=this._getFsProvider(p);if(!w.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(w.close(h))}$read(p,h,w,y){const P=this._getFsProvider(p);if(!P.read)throw new Error('FileSystemProvider does not implement "read"');const b=k.VSBuffer.alloc(y);return Promise.resolve(P.read(h,w,b.buffer,0,y)).then(o=>b.slice(0,o))}$write(p,h,w,y){const P=this._getFsProvider(p);if(!P.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(P.write(h,w,y.buffer,0,y.byteLength))}_getFsProvider(p){const h=this._fsProvider.get(p);if(!h){const w=new Error;throw w.name="ENOPRO",w.message="no provider",w}return h}}e.ExtHostFileSystem=I}),define(fe[69],me([0,1,5,43,7,22,4,14,45]),function(Y,e,g,L,D,S,T,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let k=class Bt{constructor(I,a){const p=I.getProxy(g.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(h){return p.$stat(h).catch(Bt._handleError)},readDirectory(h){return p.$readdir(h).catch(Bt._handleError)},createDirectory(h){return p.$mkdir(h).catch(Bt._handleError)},async readFile(h){return p.$readFile(h).then(w=>w.buffer).catch(Bt._handleError)},writeFile(h,w){return p.$writeFile(h,S.VSBuffer.wrap(w)).catch(Bt._handleError)},delete(h,w){return p.$delete(h,{recursive:!1,useTrash:!1,...w}).catch(Bt._handleError)},rename(h,w,y){return p.$rename(h,w,{overwrite:!1,...y}).catch(Bt._handleError)},copy(h,w,y){return p.$copy(h,w,{overwrite:!1,...y}).catch(Bt._handleError)},isWritableFileSystem(h){const w=a.getCapabilities(h);if(typeof w=="number")return!(w&2048)}})}static _handleError(I){if(!(I instanceof Error))throw new D.FileSystemError(String(I));if(I.name==="ENOPRO")throw D.FileSystemError.Unavailable(I.message);switch(I.name){case L.FileSystemProviderErrorCode.FileExists:throw D.FileSystemError.FileExists(I.message);case L.FileSystemProviderErrorCode.FileNotFound:throw D.FileSystemError.FileNotFound(I.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw D.FileSystemError.FileNotADirectory(I.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw D.FileSystemError.FileIsADirectory(I.message);case L.FileSystemProviderErrorCode.NoPermissions:throw D.FileSystemError.NoPermissions(I.message);case L.FileSystemProviderErrorCode.Unavailable:throw D.FileSystemError.Unavailable(I.message);default:throw new D.FileSystemError(I.message,I.name)}}};k=Ve([$e(0,C.IExtHostRpcService),$e(1,E.IExtHostFileSystemInfo)],k),e.ExtHostConsumerFileSystem=k,e.IExtHostConsumerFileSystem=(0,T.createDecorator)("IExtHostConsumerFileSystem")}),define(fe[242],me([0,1,2,40]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class D{constructor(T,C,E,k){this._extHostNotebooks=C,this._textDocumentsAndEditors=E,this._commands=k;const i=new L.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.ApiCommandArgument("showOptions","Show Options",I=>!0,I=>I),new L.ApiCommandArgument("resource","Interactive resource Uri",I=>!0,I=>I),new L.ApiCommandArgument("controllerId","Notebook controller Id",I=>!0,I=>I),new L.ApiCommandArgument("title","Interactive editor title",I=>!0,I=>I)],new L.ApiCommandResult("Notebook and input URI",I=>{if(I.notebookEditorId!==void 0){const a=this._extHostNotebooks.getEditorById(I.notebookEditorId);return{notebookUri:g.URI.revive(I.notebookUri),inputUri:g.URI.revive(I.inputUri),notebookEditor:a.apiEditor}}return{notebookUri:g.URI.revive(I.notebookUri),inputUri:g.URI.revive(I.inputUri)}}));this._commands.registerApiCommand(i)}$willAddInteractiveDocument(T,C,E,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:C,lines:[""],languageId:E,uri:T,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(g.URI.revive(k))?.apiNotebook}]})}$willRemoveInteractiveDocument(T,C){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[T]})}}e.ExtHostInteractive=D}),define(fe[243],me([0,1,6,5]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class D{constructor(T){this._handlePool=0,this._proxy=T.getProxy(L.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(T){const C=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(C,T),(0,g.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(C)})}}e.ExtHostLabelService=D}),define(fe[244],me([0,1,2,25,17,7,5,8,42,15,13,145,6,111,77,88,47,18,3]),function(Y,e,g,L,D,S,T,C,E,k,i,I,a,p,h,w,y,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class o{constructor(G,ee){this._documents=G,this._provider=ee}async provideDocumentSymbols(G,ee){const ie=this._documents.getDocument(G),ce=await this._provider.provideDocumentSymbols(ie,ee);if(!(0,k.isFalsyOrEmpty)(ce))return ce[0]instanceof S.DocumentSymbol?ce.map(D.DocumentSymbol.from):o._asDocumentSymbolTree(ce)}static _asDocumentSymbolTree(G){G=G.slice(0).sort((ce,Z)=>{let re=ce.location.range.start.compareTo(Z.location.range.start);return re===0&&(re=Z.location.range.end.compareTo(ce.location.range.end)),re});const ee=[],ie=[];for(const ce of G){const Z={name:ce.name||"!!MISSING: name!!",kind:D.SymbolKind.from(ce.kind),tags:ce.tags?.map(D.SymbolTag.from)||[],detail:"",containerName:ce.containerName,range:D.Range.from(ce.location.range),selectionRange:D.Range.from(ce.location.range),children:[]};for(;;){if(ie.length===0){ie.push(Z),ee.push(Z);break}const re=ie[ie.length-1];if(E.Range.containsRange(re.range,Z.range)&&!E.Range.equalsRange(re.range,Z.range)){re.children&&re.children.push(Z),ie.push(Z);break}ie.pop()}}return ee}}class s{constructor(G,ee,ie){this._documents=G,this._commands=ee,this._provider=ie,this._cache=new w.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(G,ee){const ie=this._documents.getDocument(G),ce=await this._provider.provideCodeLenses(ie,ee);if(!ce||ee.isCancellationRequested)return;const Z=this._cache.add(ce),re=new a.DisposableStore;this._disposables.set(Z,re);const pe={cacheId:Z,lenses:[]};for(let Me=0;Me<ce.length;Me++)pe.lenses.push({cacheId:[Z,Me],range:D.Range.from(ce[Me].range),command:this._commands.toInternal(ce[Me].command,re)});return pe}async resolveCodeLens(G,ee){const ie=G.cacheId&&this._cache.get(...G.cacheId);if(!ie)return;let ce;if(typeof this._provider.resolveCodeLens!="function"||ie.isResolved?ce=ie:ce=await this._provider.resolveCodeLens(ie,ee),ce||(ce=ie),ee.isCancellationRequested)return;const Z=G.cacheId&&this._disposables.get(G.cacheId[0]);if(!!Z)return G.command=this._commands.toInternal(ce.command??s._badCmd,Z),G}releaseCodeLenses(G){this._disposables.get(G)?.dispose(),this._disposables.delete(G),this._cache.delete(G)}}s._badCmd={command:"missing",title:"!!MISSING: command!!"};function v(He){return Array.isArray(He)?He.map(D.DefinitionLink.from):He?[D.DefinitionLink.from(He)]:[]}class n{constructor(G,ee){this._documents=G,this._provider=ee}async provideDefinition(G,ee,ie){const ce=this._documents.getDocument(G),Z=D.Position.to(ee),re=await this._provider.provideDefinition(ce,Z,ie);return v(re)}}class f{constructor(G,ee){this._documents=G,this._provider=ee}async provideDeclaration(G,ee,ie){const ce=this._documents.getDocument(G),Z=D.Position.to(ee),re=await this._provider.provideDeclaration(ce,Z,ie);return v(re)}}class r{constructor(G,ee){this._documents=G,this._provider=ee}async provideImplementation(G,ee,ie){const ce=this._documents.getDocument(G),Z=D.Position.to(ee),re=await this._provider.provideImplementation(ce,Z,ie);return v(re)}}class t{constructor(G,ee){this._documents=G,this._provider=ee}async provideTypeDefinition(G,ee,ie){const ce=this._documents.getDocument(G),Z=D.Position.to(ee),re=await this._provider.provideTypeDefinition(ce,Z,ie);return v(re)}}class u{constructor(G,ee){this._documents=G,this._provider=ee}async provideHover(G,ee,ie){const ce=this._documents.getDocument(G),Z=D.Position.to(ee),re=await this._provider.provideHover(ce,Z,ie);if(!(!re||(0,k.isFalsyOrEmpty)(re.contents)))return re.range||(re.range=ce.getWordRangeAtPosition(Z)),re.range||(re.range=new S.Range(Z,Z)),D.Hover.from(re)}}class l{constructor(G,ee){this._documents=G,this._provider=ee}async provideEvaluatableExpression(G,ee,ie){const ce=this._documents.getDocument(G),Z=D.Position.to(ee),re=await this._provider.provideEvaluatableExpression(ce,Z,ie);if(re)return D.EvaluatableExpression.from(re)}}class c{constructor(G,ee){this._documents=G,this._provider=ee}async provideInlineValues(G,ee,ie,ce){const Z=this._documents.getDocument(G),re=await this._provider.provideInlineValues(Z,D.Range.to(ee),D.InlineValueContext.to(ie),ce);if(Array.isArray(re))return re.map(pe=>D.InlineValue.from(pe))}}class m{constructor(G,ee){this._documents=G,this._provider=ee}async provideDocumentHighlights(G,ee,ie){const ce=this._documents.getDocument(G),Z=D.Position.to(ee),re=await this._provider.provideDocumentHighlights(ce,Z,ie);if(Array.isArray(re))return re.map(D.DocumentHighlight.from)}}class d{constructor(G,ee){this._documents=G,this._provider=ee}async provideLinkedEditingRanges(G,ee,ie){const ce=this._documents.getDocument(G),Z=D.Position.to(ee),re=await this._provider.provideLinkedEditingRanges(ce,Z,ie);if(re&&Array.isArray(re.ranges))return{ranges:(0,k.coalesce)(re.ranges.map(D.Range.from)),wordPattern:re.wordPattern}}}class _{constructor(G,ee){this._documents=G,this._provider=ee}async provideReferences(G,ee,ie,ce){const Z=this._documents.getDocument(G),re=D.Position.to(ee),pe=await this._provider.provideReferences(Z,re,ie,ce);if(Array.isArray(pe))return pe.map(D.location.from)}}class A{constructor(G,ee,ie,ce,Z,re,pe){this._documents=G,this._commands=ee,this._diagnostics=ie,this._provider=ce,this._logService=Z,this._extension=re,this._apiDeprecation=pe,this._cache=new w.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(G,ee,ie,ce){const Z=this._documents.getDocument(G),re=I.Selection.isISelection(ee)?D.Selection.to(ee):D.Range.to(ee),pe=[];for(const ct of this._diagnostics.getDiagnostics(G))if(re.intersection(ct.range)&&pe.push(ct)>A._maxCodeActionsPerFile)break;const Me={diagnostics:pe,only:ie.only?new S.CodeActionKind(ie.only):void 0,triggerKind:D.CodeActionTriggerKind.to(ie.trigger)},je=await this._provider.provideCodeActions(Z,re,Me,ce);if(!(0,k.isNonEmptyArray)(je)||ce.isCancellationRequested)return;const Ke=this._cache.add(je),Ze=new a.DisposableStore;this._disposables.set(Ke,Ze);const rt=[];for(let ct=0;ct<je.length;ct++){const ye=je[ct];!ye||(A._isCommand(ye)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),rt.push({_isSynthetic:!0,title:ye.title,command:this._commands.toInternal(ye,Ze)})):(Me.only&&(ye.kind?Me.only.contains(ye.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action is of kind '${ye.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),rt.push({cacheId:[Ke,ct],title:ye.title,command:ye.command&&this._commands.toInternal(ye.command,Ze),diagnostics:ye.diagnostics&&ye.diagnostics.map(D.Diagnostic.from),edit:ye.edit&&D.WorkspaceEdit.from(ye.edit),kind:ye.kind&&ye.kind.value,isPreferred:ye.isPreferred,disabled:ye.disabled?.reason})))}return{cacheId:Ke,actions:rt}}async resolveCodeAction(G,ee){const[ie,ce]=G,Z=this._cache.get(ie,ce);if(!Z||A._isCommand(Z)||!this._provider.resolveCodeAction)return;const re=await this._provider.resolveCodeAction(Z,ee)??Z;return re?.edit?D.WorkspaceEdit.from(re.edit):void 0}releaseCodeActions(G){this._disposables.get(G)?.dispose(),this._disposables.delete(G),this._cache.delete(G)}static _isCommand(G){return typeof G.command=="string"&&typeof G.title=="string"}}A._maxCodeActionsPerFile=1e3;class R{constructor(G,ee){this._documents=G,this._provider=ee}async provideDocumentFormattingEdits(G,ee,ie){const ce=this._documents.getDocument(G),Z=await this._provider.provideDocumentFormattingEdits(ce,ee,ie);if(Array.isArray(Z))return Z.map(D.TextEdit.from)}}class B{constructor(G,ee){this._documents=G,this._provider=ee}async provideDocumentRangeFormattingEdits(G,ee,ie,ce){const Z=this._documents.getDocument(G),re=D.Range.to(ee),pe=await this._provider.provideDocumentRangeFormattingEdits(Z,re,ie,ce);if(Array.isArray(pe))return pe.map(D.TextEdit.from)}}class U{constructor(G,ee){this._documents=G,this._provider=ee,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(G,ee,ie,ce,Z){const re=this._documents.getDocument(G),pe=D.Position.to(ee),Me=await this._provider.provideOnTypeFormattingEdits(re,pe,ie,ce,Z);if(Array.isArray(Me))return Me.map(D.TextEdit.from)}}class F{constructor(G,ee){this._provider=G,this._logService=ee,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(G,ee){const ie=T.IdObject.mixin({symbols:[]}),ce=await this._provider.provideWorkspaceSymbols(G,ee);if((0,k.isNonEmptyArray)(ce))for(const Z of ce){if(!Z)continue;if(!Z.name){this._logService.warn("INVALID SymbolInformation, lacks name",Z);continue}const re=T.IdObject.mixin(D.WorkspaceSymbol.from(Z));this._symbolCache.set(re._id,Z),ie.symbols.push(re)}return ie.symbols.length>0&&this._resultCache.set(ie._id,[ie.symbols[0]._id,ie.symbols[ie.symbols.length-1]._id]),ie}async resolveWorkspaceSymbol(G,ee){if(typeof this._provider.resolveWorkspaceSymbol!="function")return G;const ie=this._symbolCache.get(G._id);if(ie){const ce=await this._provider.resolveWorkspaceSymbol(ie,ee);return ce&&(0,L.mixin)(G,D.WorkspaceSymbol.from(ce),!0)}}releaseWorkspaceSymbols(G){const ee=this._resultCache.get(G);if(ee){for(let[ie,ce]=ee;ie<=ce;ie++)this._symbolCache.delete(ie);this._resultCache.delete(G)}}}class ${constructor(G,ee,ie){this._documents=G,this._provider=ee,this._logService=ie}static supportsResolving(G){return typeof G.prepareRename=="function"}async provideRenameEdits(G,ee,ie,ce){const Z=this._documents.getDocument(G),re=D.Position.to(ee);try{const pe=await this._provider.provideRenameEdits(Z,re,ie,ce);return pe?D.WorkspaceEdit.from(pe):void 0}catch(pe){const Me=$._asMessage(pe);return Me?{rejectReason:Me,edits:void 0}:Promise.reject(pe)}}async resolveRenameLocation(G,ee,ie){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ce=this._documents.getDocument(G),Z=D.Position.to(ee);try{const re=await this._provider.prepareRename(ce,Z,ie);let pe,Me;if(S.Range.isRange(re)?(pe=re,Me=ce.getText(re)):(0,i.isObject)(re)&&(pe=re.range,Me=re.placeholder),!pe||!Me)return;if(pe.start.line>Z.line||pe.end.line<Z.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:D.Range.from(pe),text:Me}}catch(re){const pe=$._asMessage(re);return pe?{rejectReason:pe,range:void 0,text:void 0}:Promise.reject(re)}}static _asMessage(G){return typeof G=="string"?G:G instanceof Error&&typeof G.message=="string"?G.message:void 0}}class M{constructor(G,ee){this.resultId=G,this.tokens=ee}}class z{constructor(G,ee){this._documents=G,this._provider=ee,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(G,ee,ie){const ce=this._documents.getDocument(G),Z=ee!==0?this._previousResults.get(ee):null;let re=typeof Z?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(ce,Z.resultId,ie):await this._provider.provideDocumentSemanticTokens(ce,ie);return Z&&this._previousResults.delete(ee),re?(re=z._fixProvidedSemanticTokens(re),this._send(z._convertToEdits(Z,re),re)):null}async releaseDocumentSemanticColoring(G){this._previousResults.delete(G)}static _fixProvidedSemanticTokens(G){return z._isSemanticTokens(G)?z._isCorrectSemanticTokens(G)?G:new S.SemanticTokens(new Uint32Array(G.data),G.resultId):z._isSemanticTokensEdits(G)?z._isCorrectSemanticTokensEdits(G)?G:new S.SemanticTokensEdits(G.edits.map(ee=>new S.SemanticTokensEdit(ee.start,ee.deleteCount,ee.data?new Uint32Array(ee.data):ee.data)),G.resultId):G}static _isSemanticTokens(G){return G&&!!G.data}static _isCorrectSemanticTokens(G){return G.data instanceof Uint32Array}static _isSemanticTokensEdits(G){return G&&Array.isArray(G.edits)}static _isCorrectSemanticTokensEdits(G){for(const ee of G.edits)if(!(ee.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(G,ee){if(!z._isSemanticTokens(ee)||!G||!G.tokens)return ee;const ie=G.tokens,ce=ie.length,Z=ee.data,re=Z.length;let pe=0;const Me=Math.min(ce,re);for(;pe<Me&&ie[pe]===Z[pe];)pe++;if(pe===ce&&pe===re)return new S.SemanticTokensEdits([],ee.resultId);let je=0;const Ke=Me-pe;for(;je<Ke&&ie[ce-je-1]===Z[re-je-1];)je++;return new S.SemanticTokensEdits([{start:pe,deleteCount:ce-pe-je,data:Z.subarray(pe,re-je)}],ee.resultId)}_send(G,ee){if(z._isSemanticTokens(G)){const ie=this._nextResultId++;return this._previousResults.set(ie,new M(G.resultId,G.data)),(0,p.encodeSemanticTokensDto)({id:ie,type:"full",data:G.data})}if(z._isSemanticTokensEdits(G)){const ie=this._nextResultId++;return z._isSemanticTokens(ee)?this._previousResults.set(ie,new M(ee.resultId,ee.data)):this._previousResults.set(ie,new M(G.resultId)),(0,p.encodeSemanticTokensDto)({id:ie,type:"delta",deltas:(G.edits||[]).map(ce=>({start:ce.start,deleteCount:ce.deleteCount,data:ce.data}))})}return null}}e.DocumentSemanticTokensAdapter=z;class N{constructor(G,ee){this._documents=G,this._provider=ee}async provideDocumentRangeSemanticTokens(G,ee,ie){const ce=this._documents.getDocument(G),Z=await this._provider.provideDocumentRangeSemanticTokens(ce,D.Range.to(ee),ie);return Z?this._send(Z):null}_send(G){return(0,p.encodeSemanticTokensDto)({id:0,type:"full",data:G.data})}}e.DocumentRangeSemanticTokensAdapter=N;class x{constructor(G,ee,ie,ce,Z){this._documents=G,this._commands=ee,this._provider=ie,this._apiDeprecation=ce,this._extension=Z,this._cache=new w.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(G){return typeof G.resolveCompletionItem=="function"}async provideCompletionItems(G,ee,ie,ce){const Z=this._documents.getDocument(G),re=D.Position.to(ee),pe=Z.getWordRangeAtPosition(re)||new S.Range(re,re),Me=pe.with({end:re}),je=new y.StopWatch(!0),Ke=await this._provider.provideCompletionItems(Z,re,ce,D.CompletionContext.to(ie));if(!Ke||ce.isCancellationRequested)return;const Ze=Array.isArray(Ke)?new S.CompletionList(Ke):Ke,rt=x.supportsResolving(this._provider)?this._cache.add(Ze.items):this._cache.add([]),ct=new a.DisposableStore;this._disposables.set(rt,ct);const ye=[],at={x:rt,b:ye,a:{replace:D.Range.from(pe),insert:D.Range.from(Me)},c:Ze.isIncomplete||void 0,d:je.elapsed()};for(let J=0;J<Ze.items.length;J++){const ne=Ze.items[J],Ee=this._convertCompletionItem(ne,[rt,J],Me,pe);ye.push(Ee)}return at}async resolveCompletionItem(G,ee){if(typeof this._provider.resolveCompletionItem!="function")return;const ie=this._cache.get(...G);if(!ie)return;const ce=await this._provider.resolveCompletionItem(ie,ee);if(!!ce)return this._convertCompletionItem(ce,G)}releaseCompletionItems(G){this._disposables.get(G)?.dispose(),this._disposables.delete(G),this._cache.delete(G)}_convertCompletionItem(G,ee,ie,ce){const Z=this._disposables.get(ee[0]);if(!Z)throw Error("DisposableStore is missing...");const re={x:ee,a:G.label,b:G.kind!==void 0?D.CompletionItemKind.from(G.kind):void 0,n:G.tags&&G.tags.map(D.CompletionItemTag.from),c:G.detail,d:typeof G.documentation=="undefined"?void 0:D.MarkdownString.fromStrict(G.documentation),e:G.sortText!==G.label?G.sortText:void 0,f:G.filterText!==G.label?G.filterText:void 0,g:G.preselect||void 0,i:G.keepWhitespace?1:0,k:G.commitCharacters,l:G.additionalTextEdits&&G.additionalTextEdits.map(D.TextEdit.from),m:this._commands.toInternal(G.command,Z)};G.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),re.h=G.textEdit.newText):typeof G.insertText=="string"?re.h=G.insertText:G.insertText instanceof S.SnippetString&&(re.h=G.insertText.value,re.i|=4);let pe;return G.textEdit?pe=G.textEdit.range:G.range&&(pe=G.range),S.Range.isRange(pe)?re.j=D.Range.from(pe):pe&&(!ie?.isEqual(pe.inserting)||!ce?.isEqual(pe.replacing))&&(re.j={insert:D.Range.from(pe.inserting),replace:D.Range.from(pe.replacing)}),re}}class j{constructor(G,ee,ie){this._documents=G,this._provider=ee,this._commands=ie,this._cache=new w.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(G,ee,ie,ce){const Z=this._documents.getDocument(G),re=D.Position.to(ee),pe=await this._provider.provideInlineCompletionItems(Z,re,{selectedCompletionInfo:ie.selectedSuggestionInfo?{range:D.Range.to(ie.selectedSuggestionInfo.range),text:ie.selectedSuggestionInfo.text}:void 0,triggerKind:ie.triggerKind},ce);if(!pe||ce.isCancellationRequested)return;const Me=(0,i.isArray)(pe)?{items:pe}:pe,je=this._cache.add(Me.items);let Ke;return{pid:je,items:Me.items.map((Ze,rt)=>{let ct;return Ze.command&&(Ke||(Ke=new a.DisposableStore,this._disposables.set(je,Ke)),ct=this._commands.toInternal(Ze.command,Ke)),{text:Ze.text,range:Ze.range?D.Range.from(Ze.range):void 0,command:ct,idx:rt}})}}disposeCompletions(G){this._cache.delete(G);const ee=this._disposables.get(G);ee&&ee.clear(),this._disposables.delete(G)}handleDidShowCompletionItem(G,ee){const ie=this._cache.get(G,ee);ie&&O.get(this._provider).fireOnDidShowCompletionItem({completionItem:ie})}}class O{constructor(){this._onDidShowCompletionItemEmitter=new b.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(G){let ee=O.map.get(G);return ee||(ee=new O,O.map.set(G,ee)),ee}fireOnDidShowCompletionItem(G){this._onDidShowCompletionItemEmitter.fire(G)}}e.InlineCompletionController=O,O.map=new WeakMap;class H{constructor(G,ee){this._documents=G,this._provider=ee,this._cache=new w.Cache("SignatureHelp")}async provideSignatureHelp(G,ee,ie,ce){const Z=this._documents.getDocument(G),re=D.Position.to(ee),pe=this.reviveContext(ie),Me=await this._provider.provideSignatureHelp(Z,re,ce,pe);if(Me){const je=this._cache.add([Me]);return{...D.SignatureHelp.from(Me),id:je}}}reviveContext(G){let ee;if(G.activeSignatureHelp){const ie=D.SignatureHelp.to(G.activeSignatureHelp),ce=this._cache.get(G.activeSignatureHelp.id,0);ce?(ee=ce,ee.activeSignature=ie.activeSignature,ee.activeParameter=ie.activeParameter):ee=ie}return{...G,activeSignatureHelp:ee}}releaseSignatureHelp(G){this._cache.delete(G)}}class W{constructor(G,ee){this._documents=G,this._provider=ee}async provideInlayHints(G,ee,ie){const ce=this._documents.getDocument(G),Z=await this._provider.provideInlayHints(ce,D.Range.to(ee),ie);return Z?{hints:Z.map(D.InlayHint.from)}:void 0}}class X{constructor(G,ee){this._documents=G,this._provider=ee,this._cache=new w.Cache("DocumentLink")}async provideLinks(G,ee){const ie=this._documents.getDocument(G),ce=await this._provider.provideDocumentLinks(ie,ee);if(!(!Array.isArray(ce)||ce.length===0)&&!ee.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ce.filter(X._validateLink).map(D.DocumentLink.from)};{const Z=this._cache.add(ce),re={links:[],id:Z};for(let pe=0;pe<ce.length;pe++){if(!X._validateLink(ce[pe]))continue;const Me=D.DocumentLink.from(ce[pe]);Me.cacheId=[Z,pe],re.links.push(Me)}return re}}}static _validateLink(G){return G.target&&G.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(G,ee){if(typeof this._provider.resolveDocumentLink!="function")return;const ie=this._cache.get(...G);if(!ie)return;const ce=await this._provider.resolveDocumentLink(ie,ee);if(!(!ce||!X._validateLink(ce)))return D.DocumentLink.from(ce)}releaseLinks(G){this._cache.delete(G)}}class Q{constructor(G,ee){this._documents=G,this._provider=ee}async provideColors(G,ee){const ie=this._documents.getDocument(G),ce=await this._provider.provideDocumentColors(ie,ee);return Array.isArray(ce)?ce.map(re=>({color:D.Color.from(re.color),range:D.Range.from(re.range)})):[]}async provideColorPresentations(G,ee,ie){const ce=this._documents.getDocument(G),Z=D.Range.to(ee.range),re=D.Color.to(ee.color),pe=await this._provider.provideColorPresentations(re,{document:ce,range:Z},ie);if(!!Array.isArray(pe))return pe.map(D.ColorPresentation.from)}}class de{constructor(G,ee){this._documents=G,this._provider=ee}async provideFoldingRanges(G,ee,ie){const ce=this._documents.getDocument(G),Z=await this._provider.provideFoldingRanges(ce,ee,ie);if(!!Array.isArray(Z))return Z.map(D.FoldingRange.from)}}class _e{constructor(G,ee,ie){this._documents=G,this._provider=ee,this._logService=ie}async provideSelectionRanges(G,ee,ie){const ce=this._documents.getDocument(G),Z=ee.map(D.Position.to),re=await this._provider.provideSelectionRanges(ce,Z,ie);if(!(0,k.isNonEmptyArray)(re))return[];if(re.length!==Z.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const pe=[];for(let Me=0;Me<Z.length;Me++){const je=[];pe.push(je);let Ke=Z[Me],Ze=re[Me];for(;;){if(!Ze.range.contains(Ke))throw new Error("INVALID selection range, must contain the previous range");if(je.push(D.SelectionRange.from(Ze)),!Ze.parent)break;Ke=Ze.range,Ze=Ze.parent}}return pe}}class Ce{constructor(G,ee){this._documents=G,this._provider=ee,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(G,ee,ie){const ce=this._documents.getDocument(G),Z=D.Position.to(ee),re=await this._provider.prepareCallHierarchy(ce,Z,ie);if(!re)return;const pe=this._idPool.nextId();return this._cache.set(pe,new Map),Array.isArray(re)?re.map(Me=>this._cacheAndConvertItem(pe,Me)):[this._cacheAndConvertItem(pe,re)]}async provideCallsTo(G,ee,ie){const ce=this._itemFromCache(G,ee);if(!ce)throw new Error("missing call hierarchy item");const Z=await this._provider.provideCallHierarchyIncomingCalls(ce,ie);if(!!Z)return Z.map(re=>({from:this._cacheAndConvertItem(G,re.from),fromRanges:re.fromRanges.map(pe=>D.Range.from(pe))}))}async provideCallsFrom(G,ee,ie){const ce=this._itemFromCache(G,ee);if(!ce)throw new Error("missing call hierarchy item");const Z=await this._provider.provideCallHierarchyOutgoingCalls(ce,ie);if(!!Z)return Z.map(re=>({to:this._cacheAndConvertItem(G,re.to),fromRanges:re.fromRanges.map(pe=>D.Range.from(pe))}))}releaseSession(G){this._cache.delete(G)}_cacheAndConvertItem(G,ee){const ie=this._cache.get(G),ce=D.CallHierarchyItem.from(ee,G,ie.size.toString(36));return ie.set(ce._itemId,ee),ce}_itemFromCache(G,ee){return this._cache.get(G)?.get(ee)}}class Pe{constructor(G,ee){this._documents=G,this._provider=ee,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(G,ee,ie){const ce=this._documents.getDocument(G),Z=D.Position.to(ee),re=await this._provider.prepareTypeHierarchy(ce,Z,ie);if(!re)return;const pe=this._idPool.nextId();return this._cache.set(pe,new Map),Array.isArray(re)?re.map(Me=>this._cacheAndConvertItem(pe,Me)):[this._cacheAndConvertItem(pe,re)]}async provideSupertypes(G,ee,ie){const ce=this._itemFromCache(G,ee);if(!ce)throw new Error("missing type hierarchy item");const Z=await this._provider.provideTypeHierarchySupertypes(ce,ie);if(!!Z)return Z.map(re=>this._cacheAndConvertItem(G,re))}async provideSubtypes(G,ee,ie){const ce=this._itemFromCache(G,ee);if(!ce)throw new Error("missing type hierarchy item");const Z=await this._provider.provideTypeHierarchySubtypes(ce,ie);if(!!Z)return Z.map(re=>this._cacheAndConvertItem(G,re))}releaseSession(G){this._cache.delete(G)}_cacheAndConvertItem(G,ee){const ie=this._cache.get(G),ce=D.TypeHierarchyItem.from(ee,G,ie.size.toString(36));return ie.set(ce._itemId,ee),ce}_itemFromCache(G,ee){return this._cache.get(G)?.get(ee)}}class Be{constructor(G,ee){this.adapter=G,this.extension=ee}}class We{constructor(G,ee,ie,ce,Z,re,pe){this._adapter=new Map,this._uriTransformer=ee,this._proxy=G.getProxy(T.MainContext.MainThreadLanguageFeatures),this._documents=ie,this._commands=ce,this._diagnostics=Z,this._logService=re,this._apiDeprecation=pe}_transformDocumentSelector(G){return D.DocumentSelector.from(G,this._uriTransformer)}_createDisposable(G){return new S.Disposable(()=>{this._adapter.delete(G),this._proxy.$unregister(G)})}_nextHandle(){return We._handlePool++}_withAdapter(G,ee,ie,ce,Z=!1){const re=this._adapter.get(G);if(!re)return Promise.resolve(ce);if(re.adapter instanceof ee){let pe;re.extension&&(pe=Date.now(),this._logService.trace(`[${re.extension.identifier.value}] INVOKE provider '${ee.name}'`));const Me=ie(re.adapter,re.extension),je=re.extension;return je&&Promise.resolve(Me).then(()=>this._logService.trace(`[${je.identifier.value}] provider DONE after ${Date.now()-pe}ms`),Ke=>{Z&&Ke instanceof P.CancellationError||(this._logService.error(`[${je.identifier.value}] provider FAILED`),this._logService.error(Ke))}),Me}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(G,ee){const ie=this._nextHandle();return this._adapter.set(ie,new Be(G,ee)),ie}static _extLabel(G){return G.displayName||G.name}registerDocumentSymbolProvider(G,ee,ie,ce){const Z=this._addNewAdapter(new o(this._documents,ie),G),re=ce&&ce.label||We._extLabel(G);return this._proxy.$registerDocumentSymbolProvider(Z,this._transformDocumentSelector(ee),re),this._createDisposable(Z)}$provideDocumentSymbols(G,ee,ie){return this._withAdapter(G,o,ce=>ce.provideDocumentSymbols(g.URI.revive(ee),ie),void 0)}registerCodeLensProvider(G,ee,ie){const ce=this._nextHandle(),Z=typeof ie.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ce,new Be(new s(this._documents,this._commands.converter,ie),G)),this._proxy.$registerCodeLensSupport(ce,this._transformDocumentSelector(ee),Z);let re=this._createDisposable(ce);if(Z!==void 0){const pe=ie.onDidChangeCodeLenses(Me=>this._proxy.$emitCodeLensEvent(Z));re=S.Disposable.from(re,pe)}return re}$provideCodeLenses(G,ee,ie){return this._withAdapter(G,s,ce=>ce.provideCodeLenses(g.URI.revive(ee),ie),void 0)}$resolveCodeLens(G,ee,ie){return this._withAdapter(G,s,ce=>ce.resolveCodeLens(ee,ie),void 0)}$releaseCodeLenses(G,ee){this._withAdapter(G,s,ie=>Promise.resolve(ie.releaseCodeLenses(ee)),void 0)}registerDefinitionProvider(G,ee,ie){const ce=this._addNewAdapter(new n(this._documents,ie),G);return this._proxy.$registerDefinitionSupport(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideDefinition(G,ee,ie,ce){return this._withAdapter(G,n,Z=>Z.provideDefinition(g.URI.revive(ee),ie,ce),[])}registerDeclarationProvider(G,ee,ie){const ce=this._addNewAdapter(new f(this._documents,ie),G);return this._proxy.$registerDeclarationSupport(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideDeclaration(G,ee,ie,ce){return this._withAdapter(G,f,Z=>Z.provideDeclaration(g.URI.revive(ee),ie,ce),[])}registerImplementationProvider(G,ee,ie){const ce=this._addNewAdapter(new r(this._documents,ie),G);return this._proxy.$registerImplementationSupport(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideImplementation(G,ee,ie,ce){return this._withAdapter(G,r,Z=>Z.provideImplementation(g.URI.revive(ee),ie,ce),[])}registerTypeDefinitionProvider(G,ee,ie){const ce=this._addNewAdapter(new t(this._documents,ie),G);return this._proxy.$registerTypeDefinitionSupport(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideTypeDefinition(G,ee,ie,ce){return this._withAdapter(G,t,Z=>Z.provideTypeDefinition(g.URI.revive(ee),ie,ce),[])}registerHoverProvider(G,ee,ie,ce){const Z=this._addNewAdapter(new u(this._documents,ie),G);return this._proxy.$registerHoverProvider(Z,this._transformDocumentSelector(ee)),this._createDisposable(Z)}$provideHover(G,ee,ie,ce){return this._withAdapter(G,u,Z=>Z.provideHover(g.URI.revive(ee),ie,ce),void 0)}registerEvaluatableExpressionProvider(G,ee,ie,ce){const Z=this._addNewAdapter(new l(this._documents,ie),G);return this._proxy.$registerEvaluatableExpressionProvider(Z,this._transformDocumentSelector(ee)),this._createDisposable(Z)}$provideEvaluatableExpression(G,ee,ie,ce){return this._withAdapter(G,l,Z=>Z.provideEvaluatableExpression(g.URI.revive(ee),ie,ce),void 0)}registerInlineValuesProvider(G,ee,ie,ce){const Z=typeof ie.onDidChangeInlineValues=="function"?this._nextHandle():void 0,re=this._addNewAdapter(new c(this._documents,ie),G);this._proxy.$registerInlineValuesProvider(re,this._transformDocumentSelector(ee),Z);let pe=this._createDisposable(re);if(Z!==void 0){const Me=ie.onDidChangeInlineValues(je=>this._proxy.$emitInlineValuesEvent(Z));pe=S.Disposable.from(pe,Me)}return pe}$provideInlineValues(G,ee,ie,ce,Z){return this._withAdapter(G,c,re=>re.provideInlineValues(g.URI.revive(ee),ie,ce,Z),void 0)}registerDocumentHighlightProvider(G,ee,ie){const ce=this._addNewAdapter(new m(this._documents,ie),G);return this._proxy.$registerDocumentHighlightProvider(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideDocumentHighlights(G,ee,ie,ce){return this._withAdapter(G,m,Z=>Z.provideDocumentHighlights(g.URI.revive(ee),ie,ce),void 0)}registerLinkedEditingRangeProvider(G,ee,ie){const ce=this._addNewAdapter(new d(this._documents,ie),G);return this._proxy.$registerLinkedEditingRangeProvider(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideLinkedEditingRanges(G,ee,ie,ce){return this._withAdapter(G,d,async Z=>{const re=await Z.provideLinkedEditingRanges(g.URI.revive(ee),ie,ce);if(re)return{ranges:re.ranges,wordPattern:re.wordPattern?We._serializeRegExp(re.wordPattern):void 0}},void 0)}registerReferenceProvider(G,ee,ie){const ce=this._addNewAdapter(new _(this._documents,ie),G);return this._proxy.$registerReferenceSupport(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideReferences(G,ee,ie,ce,Z){return this._withAdapter(G,_,re=>re.provideReferences(g.URI.revive(ee),ie,ce,Z),void 0)}registerCodeActionProvider(G,ee,ie,ce){const Z=new a.DisposableStore,re=this._addNewAdapter(new A(this._documents,this._commands.converter,this._diagnostics,ie,this._logService,G,this._apiDeprecation),G);return this._proxy.$registerQuickFixSupport(re,this._transformDocumentSelector(ee),{providedKinds:ce?.providedCodeActionKinds?.map(pe=>pe.value),documentation:ce?.documentation?.map(pe=>({kind:pe.kind.value,command:this._commands.converter.toInternal(pe.command,Z)}))},We._extLabel(G),Boolean(ie.resolveCodeAction)),Z.add(this._createDisposable(re)),Z}$provideCodeActions(G,ee,ie,ce,Z){return this._withAdapter(G,A,re=>re.provideCodeActions(g.URI.revive(ee),ie,ce,Z),void 0)}$resolveCodeAction(G,ee,ie){return this._withAdapter(G,A,ce=>ce.resolveCodeAction(ee,ie),void 0)}$releaseCodeActions(G,ee){this._withAdapter(G,A,ie=>Promise.resolve(ie.releaseCodeActions(ee)),void 0)}registerDocumentFormattingEditProvider(G,ee,ie){const ce=this._addNewAdapter(new R(this._documents,ie),G);return this._proxy.$registerDocumentFormattingSupport(ce,this._transformDocumentSelector(ee),G.identifier,G.displayName||G.name),this._createDisposable(ce)}$provideDocumentFormattingEdits(G,ee,ie,ce){return this._withAdapter(G,R,Z=>Z.provideDocumentFormattingEdits(g.URI.revive(ee),ie,ce),void 0)}registerDocumentRangeFormattingEditProvider(G,ee,ie){const ce=this._addNewAdapter(new B(this._documents,ie),G);return this._proxy.$registerRangeFormattingSupport(ce,this._transformDocumentSelector(ee),G.identifier,G.displayName||G.name),this._createDisposable(ce)}$provideDocumentRangeFormattingEdits(G,ee,ie,ce,Z){return this._withAdapter(G,B,re=>re.provideDocumentRangeFormattingEdits(g.URI.revive(ee),ie,ce,Z),void 0)}registerOnTypeFormattingEditProvider(G,ee,ie,ce){const Z=this._addNewAdapter(new U(this._documents,ie),G);return this._proxy.$registerOnTypeFormattingSupport(Z,this._transformDocumentSelector(ee),ce,G.identifier),this._createDisposable(Z)}$provideOnTypeFormattingEdits(G,ee,ie,ce,Z,re){return this._withAdapter(G,U,pe=>pe.provideOnTypeFormattingEdits(g.URI.revive(ee),ie,ce,Z,re),void 0)}registerWorkspaceSymbolProvider(G,ee){const ie=this._addNewAdapter(new F(ee,this._logService),G);return this._proxy.$registerNavigateTypeSupport(ie),this._createDisposable(ie)}$provideWorkspaceSymbols(G,ee,ie){return this._withAdapter(G,F,ce=>ce.provideWorkspaceSymbols(ee,ie),{symbols:[]})}$resolveWorkspaceSymbol(G,ee,ie){return this._withAdapter(G,F,ce=>ce.resolveWorkspaceSymbol(ee,ie),void 0)}$releaseWorkspaceSymbols(G,ee){this._withAdapter(G,F,ie=>ie.releaseWorkspaceSymbols(ee),void 0)}registerRenameProvider(G,ee,ie){const ce=this._addNewAdapter(new $(this._documents,ie,this._logService),G);return this._proxy.$registerRenameSupport(ce,this._transformDocumentSelector(ee),$.supportsResolving(ie)),this._createDisposable(ce)}$provideRenameEdits(G,ee,ie,ce,Z){return this._withAdapter(G,$,re=>re.provideRenameEdits(g.URI.revive(ee),ie,ce,Z),void 0)}$resolveRenameLocation(G,ee,ie,ce){return this._withAdapter(G,$,Z=>Z.resolveRenameLocation(g.URI.revive(ee),ie,ce),void 0)}registerDocumentSemanticTokensProvider(G,ee,ie,ce){const Z=this._nextHandle(),re=typeof ie.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(Z,new Be(new z(this._documents,ie),G)),this._proxy.$registerDocumentSemanticTokensProvider(Z,this._transformDocumentSelector(ee),ce,re);let pe=this._createDisposable(Z);if(re){const Me=ie.onDidChangeSemanticTokens(je=>this._proxy.$emitDocumentSemanticTokensEvent(re));pe=S.Disposable.from(pe,Me)}return pe}$provideDocumentSemanticTokens(G,ee,ie,ce){return this._withAdapter(G,z,Z=>Z.provideDocumentSemanticTokens(g.URI.revive(ee),ie,ce),null,!0)}$releaseDocumentSemanticTokens(G,ee){this._withAdapter(G,z,ie=>ie.releaseDocumentSemanticColoring(ee),void 0)}registerDocumentRangeSemanticTokensProvider(G,ee,ie,ce){const Z=this._addNewAdapter(new N(this._documents,ie),G);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Z,this._transformDocumentSelector(ee),ce),this._createDisposable(Z)}$provideDocumentRangeSemanticTokens(G,ee,ie,ce){return this._withAdapter(G,N,Z=>Z.provideDocumentRangeSemanticTokens(g.URI.revive(ee),ie,ce),null,!0)}registerCompletionItemProvider(G,ee,ie,ce){const Z=this._addNewAdapter(new x(this._documents,this._commands.converter,ie,this._apiDeprecation,G),G);return this._proxy.$registerSuggestSupport(Z,this._transformDocumentSelector(ee),ce,x.supportsResolving(ie),`${G.identifier.value}(${ce.join("")})`),this._createDisposable(Z)}$provideCompletionItems(G,ee,ie,ce,Z){return this._withAdapter(G,x,re=>re.provideCompletionItems(g.URI.revive(ee),ie,ce,Z),void 0)}$resolveCompletionItem(G,ee,ie){return this._withAdapter(G,x,ce=>ce.resolveCompletionItem(ee,ie),void 0)}$releaseCompletionItems(G,ee){this._withAdapter(G,x,ie=>ie.releaseCompletionItems(ee),void 0)}registerInlineCompletionsProvider(G,ee,ie){const ce=this._addNewAdapter(new j(this._documents,ie,this._commands.converter),G);return this._proxy.$registerInlineCompletionsSupport(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideInlineCompletions(G,ee,ie,ce,Z){return this._withAdapter(G,j,re=>re.provideInlineCompletions(g.URI.revive(ee),ie,ce,Z),void 0)}$handleInlineCompletionDidShow(G,ee,ie){this._withAdapter(G,j,async ce=>{ce.handleDidShowCompletionItem(ee,ie)},void 0)}$freeInlineCompletionsList(G,ee){this._withAdapter(G,j,async ie=>{ie.disposeCompletions(ee)},void 0)}registerSignatureHelpProvider(G,ee,ie,ce){const Z=Array.isArray(ce)?{triggerCharacters:ce,retriggerCharacters:[]}:ce,re=this._addNewAdapter(new H(this._documents,ie),G);return this._proxy.$registerSignatureHelpProvider(re,this._transformDocumentSelector(ee),Z),this._createDisposable(re)}$provideSignatureHelp(G,ee,ie,ce,Z){return this._withAdapter(G,H,re=>re.provideSignatureHelp(g.URI.revive(ee),ie,ce,Z),void 0)}$releaseSignatureHelp(G,ee){this._withAdapter(G,H,ie=>ie.releaseSignatureHelp(ee),void 0)}registerInlayHintsProvider(G,ee,ie){const ce=typeof ie.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Z=this._addNewAdapter(new W(this._documents,ie),G);this._proxy.$registerInlayHintsProvider(Z,this._transformDocumentSelector(ee),ce);let re=this._createDisposable(Z);if(ce!==void 0){const pe=ie.onDidChangeInlayHints(Me=>this._proxy.$emitInlayHintsEvent(ce));re=S.Disposable.from(re,pe)}return re}$provideInlayHints(G,ee,ie,ce){return this._withAdapter(G,W,Z=>Z.provideInlayHints(g.URI.revive(ee),ie,ce),void 0)}registerDocumentLinkProvider(G,ee,ie){const ce=this._addNewAdapter(new X(this._documents,ie),G);return this._proxy.$registerDocumentLinkProvider(ce,this._transformDocumentSelector(ee),typeof ie.resolveDocumentLink=="function"),this._createDisposable(ce)}$provideDocumentLinks(G,ee,ie){return this._withAdapter(G,X,ce=>ce.provideLinks(g.URI.revive(ee),ie),void 0)}$resolveDocumentLink(G,ee,ie){return this._withAdapter(G,X,ce=>ce.resolveLink(ee,ie),void 0)}$releaseDocumentLinks(G,ee){this._withAdapter(G,X,ie=>ie.releaseLinks(ee),void 0)}registerColorProvider(G,ee,ie){const ce=this._addNewAdapter(new Q(this._documents,ie),G);return this._proxy.$registerDocumentColorProvider(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideDocumentColors(G,ee,ie){return this._withAdapter(G,Q,ce=>ce.provideColors(g.URI.revive(ee),ie),[])}$provideColorPresentations(G,ee,ie,ce){return this._withAdapter(G,Q,Z=>Z.provideColorPresentations(g.URI.revive(ee),ie,ce),void 0)}registerFoldingRangeProvider(G,ee,ie){const ce=this._nextHandle(),Z=typeof ie.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ce,new Be(new de(this._documents,ie),G)),this._proxy.$registerFoldingRangeProvider(ce,this._transformDocumentSelector(ee),Z);let re=this._createDisposable(ce);if(Z!==void 0){const pe=ie.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Z));re=S.Disposable.from(re,pe)}return re}$provideFoldingRanges(G,ee,ie,ce){return this._withAdapter(G,de,Z=>Z.provideFoldingRanges(g.URI.revive(ee),ie,ce),void 0)}registerSelectionRangeProvider(G,ee,ie){const ce=this._addNewAdapter(new _e(this._documents,ie,this._logService),G);return this._proxy.$registerSelectionRangeProvider(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideSelectionRanges(G,ee,ie,ce){return this._withAdapter(G,_e,Z=>Z.provideSelectionRanges(g.URI.revive(ee),ie,ce),[])}registerCallHierarchyProvider(G,ee,ie){const ce=this._addNewAdapter(new Ce(this._documents,ie),G);return this._proxy.$registerCallHierarchyProvider(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$prepareCallHierarchy(G,ee,ie,ce){return this._withAdapter(G,Ce,Z=>Promise.resolve(Z.prepareSession(g.URI.revive(ee),ie,ce)),void 0)}$provideCallHierarchyIncomingCalls(G,ee,ie,ce){return this._withAdapter(G,Ce,Z=>Z.provideCallsTo(ee,ie,ce),void 0)}$provideCallHierarchyOutgoingCalls(G,ee,ie,ce){return this._withAdapter(G,Ce,Z=>Z.provideCallsFrom(ee,ie,ce),void 0)}$releaseCallHierarchy(G,ee){this._withAdapter(G,Ce,ie=>Promise.resolve(ie.releaseSession(ee)),void 0)}registerTypeHierarchyProvider(G,ee,ie){const ce=this._addNewAdapter(new Pe(this._documents,ie),G);return this._proxy.$registerTypeHierarchyProvider(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$prepareTypeHierarchy(G,ee,ie,ce){return this._withAdapter(G,Pe,Z=>Promise.resolve(Z.prepareSession(g.URI.revive(ee),ie,ce)),void 0)}$provideTypeHierarchySupertypes(G,ee,ie,ce){return this._withAdapter(G,Pe,Z=>Z.provideSupertypes(ee,ie,ce),void 0)}$provideTypeHierarchySubtypes(G,ee,ie,ce){return this._withAdapter(G,Pe,Z=>Z.provideSubtypes(ee,ie,ce),void 0)}$releaseTypeHierarchy(G,ee){this._withAdapter(G,Pe,ie=>Promise.resolve(ie.releaseSession(ee)),void 0)}static _serializeRegExp(G){return{pattern:G.source,flags:(0,C.regExpFlags)(G)}}static _serializeIndentationRule(G){return{decreaseIndentPattern:We._serializeRegExp(G.decreaseIndentPattern),increaseIndentPattern:We._serializeRegExp(G.increaseIndentPattern),indentNextLinePattern:G.indentNextLinePattern?We._serializeRegExp(G.indentNextLinePattern):void 0,unIndentedLinePattern:G.unIndentedLinePattern?We._serializeRegExp(G.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(G){return{beforeText:We._serializeRegExp(G.beforeText),afterText:G.afterText?We._serializeRegExp(G.afterText):void 0,previousLineText:G.previousLineText?We._serializeRegExp(G.previousLineText):void 0,action:G.action}}static _serializeOnEnterRules(G){return G.map(We._serializeOnEnterRule)}setLanguageConfiguration(G,ee,ie){let{wordPattern:ce}=ie;if(ce&&(0,C.regExpLeadsToEndlessLoop)(ce))throw new Error(`Invalid language configuration: wordPattern '${ce}' is not allowed to match the empty string.`);ce?this._documents.setWordDefinitionFor(ee,ce):this._documents.setWordDefinitionFor(ee,void 0),ie.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",G,"Do not use."),ie.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",G,"Do not use.");const Z=this._nextHandle(),re={comments:ie.comments,brackets:ie.brackets,wordPattern:ie.wordPattern?We._serializeRegExp(ie.wordPattern):void 0,indentationRules:ie.indentationRules?We._serializeIndentationRule(ie.indentationRules):void 0,onEnterRules:ie.onEnterRules?We._serializeOnEnterRules(ie.onEnterRules):void 0,__electricCharacterSupport:ie.__electricCharacterSupport,__characterPairSupport:ie.__characterPairSupport};return this._proxy.$setLanguageConfiguration(Z,ee,re),this._createDisposable(Z)}$setWordDefinitions(G){for(const ee of G)this._documents.setWordDefinitionFor(ee.languageId,new RegExp(ee.regexSource,ee.regexFlags))}}e.ExtHostLanguageFeatures=We,We._handlePool=0}),define(fe[245],me([0,1,5,17,7,50,16,6]),function(Y,e,g,L,D,S,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class E{constructor(i,I,a,p){this._documents=I,this._commands=a,this._uriTransformer=p,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=i.getProxy(g.MainContext.MainThreadLanguages)}$acceptLanguageIds(i){this._languageIds=i}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(i,I){await this._proxy.$changeLanguage(i,I);const a=this._documents.getDocumentData(i);if(!a)throw new Error(`document '${i.toString}' NOT found`);return a.document}async tokenAtPosition(i,I){const a=i.version,p=L.Position.from(I),h=await this._proxy.$tokensAtPosition(i.uri,p),w={type:D.StandardTokenType.Other,range:i.getWordRangeAtPosition(I)??new D.Range(I.line,I.character,I.line,I.character)};if(!h)return w;const y={range:L.Range.to(h.range),type:L.TokenType.to(h.type)};return!y.range.contains(I)||a!==i.version?w:y}createLanguageStatusItem(i,I,a){const p=this._handlePool++,h=this._proxy,w=this._ids,y=`${i.identifier.value}/${I}`;if(w.has(y))throw new Error(`LanguageStatusItem with id '${I}' ALREADY exists`);w.add(y);const P={selector:a,id:I,name:i.displayName??i.name,severity:D.LanguageStatusSeverity.Information,command:void 0,text:"",detail:""};let b,o=new C.DisposableStore;const s=()=>{b?.dispose(),b=(0,T.disposableTimeout)(()=>{o.clear(),this._proxy.$setLanguageStatus(p,{id:y,name:P.name??i.displayName??i.name,source:i.displayName??i.name,selector:L.DocumentSelector.from(P.selector,this._uriTransformer),label:P.text,detail:P.detail??"",severity:P.severity===D.LanguageStatusSeverity.Error?S.default.Error:P.severity===D.LanguageStatusSeverity.Warning?S.default.Warning:S.default.Info,command:P.command&&this._commands.toInternal(P.command,o),accessibilityInfo:P.accessibilityInformation})},0)},v={dispose(){o.dispose(),b?.dispose(),h.$removeLanguageStatus(p),w.delete(y)},get id(){return P.id},get name(){return P.name},set name(n){P.name=n,s()},get selector(){return P.selector},set selector(n){P.selector=n,s()},get text(){return P.text},set text(n){P.text=n,s()},get detail(){return P.detail},set detail(n){P.detail=n,s()},get severity(){return P.severity},set severity(n){P.severity=n,s()},get accessibilityInformation(){return P.accessibilityInformation},set accessibilityInformation(n){P.accessibilityInformation=n,s()},get command(){return P.command},set command(n){P.command=n,s()}};return s(),v}}e.ExtHostLanguages=E}),define(fe[132],me([0,1,11,5,26,14,3]),function(Y,e,g,L,D,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let C=class extends g.AbstractLoggerService{constructor(i,I){const a=new T.Emitter;super(I.logLevel,a.event);this._proxy=i.getProxy(L.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(a)}$setLevel(i){this._onDidChangeLogLevel.fire(i)}doCreateLogger(i,I,a){return new E(this._proxy,i,I,a)}};C=Ve([$e(0,S.IExtHostRpcService),$e(1,D.IExtHostInitDataService)],C),e.ExtHostLoggerService=C;class E extends g.AbstractMessageLogger{constructor(i,I,a,p){super(p?.always);this.proxy=i,this.file=I,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(a),this.proxy.$createLogger(I,p).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(i,I){const a=[[i,I]];this.isLoggerCreated?this.doLog(a):this.buffer.push(...a)}doLog(i){this.proxy.$log(this.file,i)}}}),define(fe[246],me([0,1,5,11,35]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function S(C){return C&&C.title}let T=class{constructor(E,k){this._logService=k,this._proxy=E.getProxy(g.MainContext.MainThreadMessageService)}showMessage(E,k,i,I,a){const p={extension:E};let h;typeof I=="string"||S(I)?h=[I,...a]:(p.modal=I?.modal,p.useCustom=I?.useCustom,p.detail=I?.detail,h=a),p.useCustom&&(0,D.checkProposedApiEnabled)(E);const w=[];for(let y=0;y<h.length;y++){const P=h[y];if(typeof P=="string")w.push({title:P,handle:y,isCloseAffordance:!1});else if(typeof P=="object"){let{title:b,isCloseAffordance:o}=P;w.push({title:b,isCloseAffordance:!!o,handle:y})}else this._logService.warn("Invalid message item:",P)}return this._proxy.$showMessage(k,i,p,w).then(y=>{if(typeof y=="number")return h[y]})}};T=Ve([$e(1,L.ILogService)],T),e.ExtHostMessageService=T}),define(fe[247],me([0,1,22,3,49,6,24,8,13,2,88,5,17,7,55,223,129]),function(Y,e,g,L,D,S,T,C,E,k,i,I,a,p,h,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class P{constructor(o,s,v,n,f){this._textDocumentsAndEditors=v,this._textDocuments=n,this._extensionStoragePaths=f,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new T.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new L.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new L.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new L.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new L.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new L.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new L.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new L.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new i.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=o.getProxy(I.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=o.getProxy(I.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=o.getProxy(I.MainContext.MainThreadNotebookEditors),this._commandsConverter=s.converter,s.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const t=r.notebookEditor?.notebookUri,u=r.cell.handle,c=this._documents.get(t)?.getCell(u);if(c)return c.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(o=>o.apiEditor)}getEditorById(o){const s=this._editors.get(o);if(!s)throw new Error(`unknown text editor: ${o}. known editors: ${[...this._editors.keys()]} `);return s}getIdByEditor(o){for(const[s,v]of this._editors)if(v.apiEditor===o)return s}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(o,s){const v=this._documents.get(o);if(!v&&!s)throw new Error(`NO notebook document for '${o}'`);return v}_getProviderData(o){const s=this._notebookContentProviders.get(o);if(!s)throw new Error(`NO provider for '${o}'`);return s}registerNotebookContentProvider(o,s,v,n,f){if((0,C.isFalsyOrWhitespace)(s))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(s))throw new Error(`Notebook provider for '${s}' already registered`);this._notebookContentProviders.set(s,{extension:o,provider:v});let r;return v.onDidChangeNotebookContentOptions&&(r=v.onDidChangeNotebookContentOptions(()=>{const t=a.NotebookDocumentContentOptions.from(v.options);this._notebookProxy.$updateNotebookProviderOptions(s,t)})),this._notebookProxy.$registerNotebookProvider({id:o.identifier,location:o.extensionLocation},s,a.NotebookDocumentContentOptions.from(n),P._convertNotebookRegistrationData(o,f)),new p.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(s),this._notebookProxy.$unregisterNotebookProvider(s)})}static _convertNotebookRegistrationData(o,s){if(!s)return;const v=s.filenamePattern.map(n=>a.NotebookExclusiveDocumentPattern.from(n)).filter(n=>n!==void 0);if(s.filenamePattern&&!v){console.warn(`Notebook content provider view options file name pattern is invalid ${s.filenamePattern}`);return}return{extension:o.identifier,providerDisplayName:o.displayName||o.name,displayName:s.displayName,filenamePattern:v,exclusive:s.exclusive||!1}}registerNotebookCellStatusBarItemProvider(o,s,v){const n=P._notebookStatusBarItemProviderHandlePool++,f=typeof v.onDidChangeCellStatusBarItems=="function"?P._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(n,v),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(n,f,s);let r;return f!==void 0&&(r=v.onDidChangeCellStatusBarItems(t=>this._notebookProxy.$emitCellStatusBarEvent(f))),new p.Disposable(()=>{this._notebookStatusBarItemProviders.delete(n),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(n,f),r&&r.dispose()})}async createNotebookDocument(o){const s=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:o.viewType,content:o.content&&a.NotebookData.from(o.content)});return k.URI.revive(s)}async openNotebookDocument(o){const s=this._documents.get(o);if(s)return s.apiNotebook;const v=await this._notebookDocumentsProxy.$tryOpenNotebook(o),n=this._documents.get(k.URI.revive(v));return(0,E.assertIsDefined)(n?.apiNotebook)}async showNotebookDocument(o,s){k.URI.isUri(o)&&(o=await this.openNotebookDocument(o));let v;typeof s=="object"?v={position:a.ViewColumn.from(s.viewColumn),preserveFocus:s.preserveFocus,selections:s.selections&&s.selections.map(a.NotebookRange.from),pinned:typeof s.preview=="boolean"?!s.preview:void 0}:v={preserveFocus:!1};const n=await this._notebookEditorsProxy.$tryShowNotebookDocument(o.uri,o.notebookType,v),f=n&&this._editors.get(n)?.apiEditor;if(f)return f;throw n?new Error(`Could NOT open editor for "${o.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${o.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(o,s,v,n){const f=this._notebookStatusBarItemProviders.get(o),r=k.URI.revive(s),t=this._documents.get(r);if(!t||!f)return;const u=t.getCellFromIndex(v);if(!u)return;const l=await f.provideCellStatusBarItems(u.apiCell,n);if(!l)return;const c=new S.DisposableStore,m=this._statusBarCache.add([c]),_=(Array.isArray(l)?l:[l]).map(A=>a.NotebookStatusBarItem.from(A,this._commandsConverter,c));return{cacheId:m,items:_}}$releaseNotebookCellStatusBarItems(o){this._statusBarCache.delete(o)}registerNotebookSerializer(o,s,v,n,f){if((0,C.isFalsyOrWhitespace)(s))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,v),this._notebookProxy.$registerNotebookSerializer(r,{id:o.identifier,location:o.extensionLocation},s,a.NotebookDocumentContentOptions.from(n),P._convertNotebookRegistrationData(o,f)),(0,S.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(o,s,v){const n=this._notebookSerializer.get(o);if(!n)throw new Error("NO serializer found");const f=await n.deserializeNotebook(s.buffer,v);return new h.SerializableObjectWithBuffers(a.NotebookData.from(f))}async $notebookToData(o,s,v){const n=this._notebookSerializer.get(o);if(!n)throw new Error("NO serializer found");const f=await n.serializeNotebook(a.NotebookData.to(s.value),v);return g.VSBuffer.wrap(f)}async $openNotebook(o,s,v,n,f){const{provider:r}=this._getProviderData(o),t=await r.openNotebook(k.URI.revive(s),{backupId:v,untitledDocumentData:n?.buffer},f);return new h.SerializableObjectWithBuffers({metadata:t.metadata??Object.create(null),cells:t.cells.map(a.NotebookCellData.from)})}async $saveNotebook(o,s,v){const n=this.getNotebookDocument(k.URI.revive(s)),{provider:f}=this._getProviderData(o);return await f.saveNotebook(n.apiNotebook,v),!0}async $saveNotebookAs(o,s,v,n){const f=this.getNotebookDocument(k.URI.revive(s)),{provider:r}=this._getProviderData(o);return await r.saveNotebookAs(k.URI.revive(v),f.apiNotebook,n),!0}async $backupNotebook(o,s,v){const n=this.getNotebookDocument(k.URI.revive(s)),f=this._getProviderData(o),r=this._extensionStoragePaths.workspaceValue(f.extension)??this._extensionStoragePaths.globalValue(f.extension),t=String((0,D.hash)([n.uri.toString(),this._backupIdPool++])),u=k.URI.joinPath(r,t),l=await f.provider.backupNotebook(n.apiNotebook,{destination:u},v);return n.updateBackup(l),l.id}_createExtHostEditor(o,s,v){if(this._editors.has(s))throw new Error(`editor with id ALREADY EXSIST: ${s}`);const n=new y.ExtHostNotebookEditor(s,this._notebookEditorsProxy,o,v.visibleRanges.map(a.NotebookRange.to),v.selections.map(a.NotebookRange.to),typeof v.viewColumn=="number"?a.ViewColumn.to(v.viewColumn):void 0);this._editors.set(s,n)}$acceptDocumentAndEditorsDelta(o){if(o.value.removedDocuments)for(const v of o.value.removedDocuments){const n=k.URI.revive(v),f=this._documents.get(n);f&&(f.dispose(),this._documents.delete(n),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:f.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(f.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===n.toString()&&this._editors.delete(r.id)}if(o.value.addedDocuments){const v=[];for(const n of o.value.addedDocuments){const f=k.URI.revive(n.uri);if(this._documents.has(f))throw new Error(`adding EXISTING notebook ${f} `);const r=this,t=new w.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(u){r._onDidChangeNotebookCells.fire(u)},emitCellOutputsChange(u){r._onDidChangeCellOutputs.fire(u)},emitCellMetadataChange(u){r._onDidChangeCellMetadata.fire(u)},emitCellExecutionStateChange(u){r._onDidChangeCellExecutionState.fire(u)}},f,n);v.push(...n.cells.map(u=>w.ExtHostCell.asModelAddData(t.apiNotebook,u))),this._documents.get(f)?.dispose(),this._documents.set(f,t),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:v}),this._onDidOpenNotebookDocument.fire(t.apiNotebook)}}if(o.value.addedEditors)for(const v of o.value.addedEditors){if(this._editors.has(v.id))return;const n=k.URI.revive(v.documentUri),f=this._documents.get(n);f&&this._createExtHostEditor(f,v.id,v)}const s=[];if(o.value.removedEditors)for(const v of o.value.removedEditors){const n=this._editors.get(v);n&&(this._editors.delete(v),this._activeNotebookEditor?.id===n.id&&(this._activeNotebookEditor=void 0),s.push(n))}if(o.value.visibleEditors){this._visibleNotebookEditors=o.value.visibleEditors.map(n=>this._editors.get(n)).filter(n=>!!n);const v=new Set;this._visibleNotebookEditors.forEach(n=>v.add(n.id));for(const n of this._editors.values()){const f=v.has(n.id);n._acceptVisibility(f)}this._visibleNotebookEditors=[...this._editors.values()].map(n=>n).filter(n=>n.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}o.value.newActiveEditor===null?this._activeNotebookEditor=void 0:o.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(o.value.newActiveEditor)),o.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=P,P._notebookStatusBarItemProviderHandlePool=0}),define(fe[248],me([0,1,3,77,11,5,14,17]),function(Y,e,g,L,D,S,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class E{constructor(I,a){const p=E._Keys.nextId();I.$registerNotebookEditorDecorationType(p,C.NotebookDecorationRenderOptions.from(a)),this.value={key:p,dispose(){I.$removeNotebookEditorDecorationType(p)}}}}E._Keys=new L.IdGenerator("NotebookEditorDecorationType");let k=class{constructor(I,a,p){this._logService=I,this._extHostRpc=a,this._notebooksAndEditors=p,this._onDidChangeNotebookEditorSelection=new g.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new g.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(I){return new E(this._extHostRpc.getProxy(S.MainContext.MainThreadNotebookEditors),I).value}$acceptEditorPropertiesChanged(I,a){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",I,a);const p=this._notebooksAndEditors.getEditorById(I);a.visibleRanges&&p._acceptVisibleRanges(a.visibleRanges.ranges.map(C.NotebookRange.to)),a.selections&&p._acceptSelections(a.selections.selections.map(C.NotebookRange.to)),a.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:p.apiEditor,visibleRanges:p.apiEditor.visibleRanges}),a.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:p.apiEditor,selections:p.apiEditor.selections}))}$acceptEditorViewColumns(I){for(const a in I)this._notebooksAndEditors.getEditorById(a)._acceptViewColumn(C.ViewColumn.to(I[a]))}};k=Ve([$e(0,D.ILogService),$e(1,T.IExtHostRpcService)],k),e.ExtHostNotebookEditors=k}),define(fe[249],me([0,1,15,16,21,3,6,24,2,27,11,5,40,17,7,89,215,35,55]),function(Y,e,g,L,D,S,T,C,E,k,i,I,a,p,h,w,y,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let o=class{constructor(r,t,u,l,c){this._initData=t,this._extHostNotebook=u,this._commands=l,this._logService=c,this._activeExecutions=new C.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=r.getProxy(I.MainContext.MainThreadNotebookKernels);const m=new a.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new a.ApiCommandArgument("options","Select kernel options",d=>!0,d=>{if(d&&"notebookEditor"in d&&"id"in d){const _=this._extHostNotebook.getIdByEditor(d.notebookEditor);return{id:d.id,extension:d.extension,notebookEditorId:_}}else if(d&&"notebookEditor"in d){const _=this._extHostNotebook.getIdByEditor(d.notebookEditor);if(_===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${d.notebookEditor.document.uri.toString()}`);return{notebookEditorId:_}}return d})],a.ApiCommandResult.Void);this._commands.registerApiCommand(m)}createNotebookController(r,t,u,l,c,m){for(let H of this._kernelData.values())if(H.controller.id===t&&k.ExtensionIdentifier.equals(r.identifier,H.extensionId))throw new Error(`notebook controller with id '${t}' ALREADY exist`);const d=this._handlePool++,_=this;this._logService.trace(`NotebookController[${d}], CREATED by ${r.identifier.value}, ${t}`);const A=()=>console.warn(`NO execute handler from notebook controller '${$.id}' of extension: '${r.identifier}'`);let R=!1;const B=new T.DisposableStore,U=new S.Emitter,F=new S.Emitter,$={id:`${r.identifier.value}/${t}`,notebookType:u,extensionId:r.identifier,extensionLocation:r.extensionLocation,label:l||r.identifier.value,preloads:m?m.map(p.NotebookRendererScript.from):[]};let M=c??A,z;this._proxy.$addKernel(d,$).catch(H=>{console.log(H),R=!0});let N=0;const x=()=>{if(R)return;const H=++N;Promise.resolve().then(()=>{H===N&&this._proxy.$updateKernel(d,$)})},j=new C.ResourceMap,O={get id(){return t},get notebookType(){return $.notebookType},onDidChangeSelectedNotebooks:U.event,get label(){return $.label},set label(H){$.label=H??r.displayName??r.name,x()},get detail(){return $.detail??""},set detail(H){$.detail=H,x()},get description(){return $.description??""},set description(H){$.description=H,x()},get kind(){return(0,P.checkProposedApiEnabled)(r),$.kind??""},set kind(H){(0,P.checkProposedApiEnabled)(r),$.kind=H,x()},get supportedLanguages(){return $.supportedLanguages},set supportedLanguages(H){$.supportedLanguages=H,x()},get supportsExecutionOrder(){return $.supportsExecutionOrder??!1},set supportsExecutionOrder(H){$.supportsExecutionOrder=H,x()},get rendererScripts(){return $.preloads?$.preloads.map(p.NotebookRendererScript.to):[]},get executeHandler(){return M},set executeHandler(H){M=H??A},get interruptHandler(){return z},set interruptHandler(H){z=H,$.supportsInterrupt=Boolean(H),x()},createNotebookCellExecution(H){if(R)throw new Error("notebook controller is DISPOSED");if(!j.has(H.notebook.uri))throw _._logService.trace(`NotebookController[${d}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(j.keys()).map(W=>W.toString())),new Error(`notebook controller is NOT associated to notebook: ${H.notebook.uri.toString()}`);return _._createNotebookCellExecution(H)},dispose:()=>{R||(this._logService.trace(`NotebookController[${d}], DISPOSED`),R=!0,this._kernelData.delete(d),B.dispose(),U.dispose(),F.dispose(),this._proxy.$removeKernel(d))},updateNotebookAffinity(H,W){_._proxy.$updateNotebookPriority(d,H.uri,W)},onDidReceiveMessage:F.event,postMessage(H,W){return(0,P.checkProposedApiEnabled)(r),_._proxy.$postMessage(d,W&&_._extHostNotebook.getIdByEditor(W),H)},asWebviewUri(H){return(0,P.checkProposedApiEnabled)(r),(0,w.asWebviewUri)(H,_._initData.remote)}};return this._kernelData.set(d,{extensionId:r.identifier,controller:O,onDidReceiveMessage:F,onDidChangeSelection:U,associatedNotebooks:j}),O}$acceptNotebookAssociation(r,t,u){const l=this._kernelData.get(r);if(l){const c=this._extHostNotebook.getNotebookDocument(E.URI.revive(t));u?l.associatedNotebooks.set(c.uri,!0):l.associatedNotebooks.delete(c.uri),this._logService.trace(`NotebookController[${r}] ASSOCIATE notebook`,c.uri.toString(),u),l.onDidChangeSelection.fire({selected:u,notebook:c.apiNotebook})}}async $executeCells(r,t,u){const l=this._kernelData.get(r);if(!l)return;const c=this._extHostNotebook.getNotebookDocument(E.URI.revive(t)),m=[];for(let d of u){const _=c.getCell(d);_&&m.push(_.apiCell)}try{this._logService.trace(`NotebookController[${r}] EXECUTE cells`,c.uri.toString(),m.length),await l.controller.executeHandler.call(l.controller,m,c.apiNotebook,l.controller)}catch(d){this._logService.error(`NotebookController[${r}] execute cells FAILED`,d),console.error(d)}}async $cancelCells(r,t,u){const l=this._kernelData.get(r);if(!l)return;const c=this._extHostNotebook.getNotebookDocument(E.URI.revive(t));if(l.controller.interruptHandler)await l.controller.interruptHandler.call(l.controller,c.apiNotebook);else for(let m of u){const d=c.getCell(m);d&&this._activeExecutions.get(d.uri)?.cancel()}}$acceptKernelMessageFromRenderer(r,t,u){const l=this._kernelData.get(r);if(!l)return;const c=this._extHostNotebook.getEditorById(t);l.onDidReceiveMessage.fire(Object.freeze({editor:c.apiEditor,message:u}))}_createNotebookCellExecution(r){if(r.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const u=this._extHostNotebook.getNotebookDocument(r.notebook.uri).getCellFromApiCell(r);if(!u)throw new Error("invalid cell");if(this._activeExecutions.has(u.uri))throw new Error(`duplicate execution for ${u.uri}`);const l=new v(u.notebook,u,this._proxy);this._activeExecutions.set(u.uri,l);const c=l.onDidChangeState(()=>{l.state===s.Resolved&&(l.dispose(),c.dispose(),this._activeExecutions.delete(u.uri))});return l.asApiObject()}};o=Ve([$e(4,i.ILogService)],o),e.ExtHostNotebookKernels=o;var s;(function(f){f[f.Init=0]="Init",f[f.Started=1]="Started",f[f.Resolved=2]="Resolved"})(s||(s={}));class v extends T.Disposable{constructor(r,t,u){super();this._document=r,this._cell=t,this._proxy=u,this._handle=v.HANDLE++,this._onDidChangeState=new S.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=s.Init,this._tokenSource=this._register(new D.CancellationTokenSource),this._collector=new n(10,l=>this.update(l)),this._executionOrder=t.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(r){await this._collector.addItem(r)}async update(r){const t=Array.isArray(r)?r:[r];return this._proxy.$updateExecutions(new b.SerializableObjectWithBuffers(t))}verifyStateForOutput(){if(this._state===s.Init)throw new Error("Must call start before modifying cell output");if(this._state===s.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(r){let t=this._cell;if(r&&(t=this._document.getCellFromApiCell(r)),!t)throw new Error("INVALID cell");return t.handle}validateAndConvertOutputs(r){return r.map(t=>{const u=h.NotebookCellOutput.ensureUniqueMimeTypes(t.items,!0);return u===t.items?p.NotebookCellOutput.from(t):p.NotebookCellOutput.from({items:u,id:t.id,metadata:t.metadata})})}async updateOutputs(r,t,u){const l=this.cellIndexToHandle(t),c=this.validateAndConvertOutputs((0,g.asArray)(r));return this.updateSoon({editType:y.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:l,append:u,outputs:c})}async updateOutputItems(r,t,u){return r=h.NotebookCellOutput.ensureUniqueMimeTypes((0,g.asArray)(r),!0),this.updateSoon({editType:y.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:r.map(p.NotebookCellOutputItem.from),outputId:t.id,append:u})}asApiObject(){const r=this;return Object.freeze({get token(){return r._tokenSource.token},get cell(){return r._cell.apiCell},get executionOrder(){return r._executionOrder},set executionOrder(u){r._executionOrder=u,r.update([{editType:y.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,executionOrder:r._executionOrder}])},start(u){if(r._state===s.Resolved||r._state===s.Started)throw new Error("Cannot call start again");r._state=s.Started,r._onDidChangeState.fire(),r.update({editType:y.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,runStartTime:u})},end(u,l){if(r._state===s.Resolved)throw new Error("Cannot call resolve twice");r._state=s.Resolved,r._onDidChangeState.fire(),r.updateSoon({editType:y.CellExecutionUpdateType.Complete,executionHandle:r._handle,runEndTime:l,lastRunSuccess:u}),r._collector.flush(),r._proxy.$removeExecution(r._handle)},clearOutput(u){return r.verifyStateForOutput(),r.updateOutputs([],u,!1)},appendOutput(u,l){return r.verifyStateForOutput(),r.updateOutputs(u,l,!0)},replaceOutput(u,l){return r.verifyStateForOutput(),r.updateOutputs(u,l,!1)},appendOutputItems(u,l){return r.verifyStateForOutput(),r.updateOutputItems(u,l,!0)},replaceOutputItems(u,l){return r.verifyStateForOutput(),r.updateOutputItems(u,l,!1)}})}}v.HANDLE=0;class n{constructor(r,t){this.delay=r,this.callback=t,this.batch=[],this.startedTimer=Date.now()}addItem(r){return this.batch.push(r),this.currentDeferred||(this.currentDeferred=new L.DeferredPromise,this.startedTimer=Date.now(),(0,L.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const r=this.currentDeferred;this.currentDeferred=void 0;const t=this.batch;return this.batch=[],this.callback(t).finally(()=>r.complete())}}}),define(fe[250],me([0,1,3,5,129]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class S{constructor(C,E){this._extHostNotebook=E,this._rendererMessageEmitters=new Map,this.proxy=C.getProxy(L.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(C,E,k){const i=this._extHostNotebook.getEditorById(C);this._rendererMessageEmitters.get(E)?.fire({editor:i.apiEditor,message:k})}createRendererMessaging(C,E){if(!C.contributes?.notebookRenderer?.some(a=>a.id===E))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${E})`);const k=!!C.enableProposedApi,i=new WeakMap;return{onDidReceiveMessage:(a,p,h)=>{const w=k?a:y=>{const P={};i.set(P,y.editor),a({editor:P,message:y.message})};return this.getOrCreateEmitterFor(E).event(w,p,h)},postMessage:(a,p)=>{D.ExtHostNotebookEditor.apiEditorsToExtHost.has(a)&&([a,p]=[p,a]);const h=k?p:i.get(p),w=h&&D.ExtHostNotebookEditor.apiEditorsToExtHost.get(h);return this.proxy.$postMessage(w?.id,E,a)}}}getOrCreateEmitterFor(C){let E=this._rendererMessageEmitters.get(C);return E||(E=new g.Emitter({onLastListenerRemove:()=>{E?.dispose(),this._rendererMessageEmitters.delete(C)}}),this._rendererMessageEmitters.set(C,E),E)}}e.ExtHostNotebookRenderers=S}),define(fe[133],me([0,1,5,6,4,14,35,11,216,69,26,45,152,22]),function(Y,e,g,L,D,S,T,C,E,k,i,I,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class h extends L.Disposable{constructor(P,b,o,s){super();this.id=P,this.name=b,this.logger=o,this.proxy=s,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(P){this.append(P+`
`)}append(P){this.write(P),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,E.OutputChannelUpdateMode.Append))}clear(){const P=this.offset;this.logger.flush(),this.proxy.$update(this.id,E.OutputChannelUpdateMode.Clear,P)}replace(P){const b=this.offset;this.write(P),this.proxy.$update(this.id,E.OutputChannelUpdateMode.Replace,b),this.visible&&this.logger.flush()}show(P,b){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof P=="boolean"?P:b))}hide(){this.proxy.$close(this.id)}write(P){this.offset+=p.VSBuffer.fromString(P).byteLength,this.logger.info(P)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=h;let w=class{constructor(P,b,o,s,v){this.extHostFileSystem=o,this.extHostFileSystemInfo=s,this.loggerService=v,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=P.getProxy(g.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(b.logsLocation,`output_logging_${(0,a.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(P){this.visibleChannelId=P;for(const[b,o]of this.channels)o.visible=b===this.visibleChannelId}createOutputChannel(P,b){if(P=P.trim(),!P)throw new Error("illegal argument `name`. must not be falsy");const o=this.doCreateOutputChannel(P,b);return o.then(s=>{this.channels.set(s.id,s),s.visible=s.id===this.visibleChannelId}),this.createExtHostOutputChannel(P,o,b)}async doCreateOutputChannel(P,b){const o=await this.createOutputDirectory(),s=this.extHostFileSystemInfo.extUri.joinPath(o,`${this.namePool++}-${P.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),v=this.loggerService.createLogger(s,{always:!0,donotRotate:!0,donotUseFormatters:!0}),n=await this.proxy.$register(P,!1,s,b.identifier.value);return new h(n,P,v,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(P,b,o){const s=(v,n)=>{if(n&&(0,T.checkProposedApiEnabled)(o),v.disposed)throw new Error("Channel has been closed")};return{get name(){return P},append(v){b.then(n=>{s(n),n.append(v)})},appendLine(v){b.then(n=>{s(n),n.appendLine(v)})},clear(){b.then(v=>{s(v),v.clear()})},replace(v){b.then(n=>{s(n,!0),n.replace(v)})},show(v,n){b.then(f=>{s(f),f.show(v,n)})},hide(){b.then(v=>{s(v),v.hide()})},dispose(){b.then(v=>{s(v),v.dispose()})}}}};w=Ve([$e(0,S.IExtHostRpcService),$e(1,i.IExtHostInitDataService),$e(2,k.IExtHostConsumerFileSystem),$e(3,I.IExtHostFileSystemInfo),$e(4,C.ILoggerService)],w),e.ExtHostOutputService=w,e.IExtHostOutputService=(0,D.createDecorator)("IExtHostOutputService")}),define(fe[251],me([0,1,16,21,3,6,5,2,7,18,15,50,65]),function(Y,e,g,L,D,S,T,C,E,k,i,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function p(h,w,y){const P=h.getProxy(T.MainContext.MainThreadQuickOpen);class b{constructor(l,c){this._sessions=new Map,this._instances=0,this._workspace=l,this._commands=c}showQuickPick(l,c,m,d=L.CancellationToken.None){this._onDidSelectItem=void 0;const _=Promise.resolve(l),A=++this._instances,R=P.$show(A,{title:m?.title,placeHolder:m?.placeHolder,matchOnDescription:m?.matchOnDescription,matchOnDetail:m?.matchOnDetail,ignoreFocusLost:m?.ignoreFocusOut,canPickMany:m?.canPickMany},d),B={},U=R.then(()=>B);return Promise.race([U,_]).then(F=>{if(F!==B)return _.then($=>{const M=[];for(let z=0;z<$.length;z++){const N=$[z];let x,j,O,H,W;typeof N=="string"?x=N:(x=N.label,j=N.description,O=N.detail,H=N.picked,W=N.alwaysShow),M.push({label:x,description:j,handle:z,detail:O,picked:H,alwaysShow:W})}return m&&typeof m.onDidSelectItem=="function"&&(this._onDidSelectItem=z=>{m.onDidSelectItem($[z])}),P.$setItems(A,M),R.then(z=>{if(typeof z=="number")return $[z];if(Array.isArray(z))return z.map(N=>$[N])})})}).then(void 0,F=>{if(!(0,k.isPromiseCanceledError)(F))return P.$setError(A,F),Promise.reject(F)})}$onItemSelected(l){this._onDidSelectItem&&this._onDidSelectItem(l)}showInput(l,c=L.CancellationToken.None){return this._validateInput=l?l.validateInput:void 0,P.$input(l,typeof this._validateInput=="function",c).then(void 0,m=>{if(!(0,k.isPromiseCanceledError)(m))return Promise.reject(m)})}$validateInput(l){return this._validateInput?(0,g.asPromise)(()=>this._validateInput(l)):Promise.resolve(void 0)}async showWorkspaceFolderPick(l,c=L.CancellationToken.None){const m=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[l]);if(!m)return;const d=await this._workspace.getWorkspaceFolders2();if(!!d)return d.find(_=>_.uri.toString()===m.uri.toString())}createQuickPick(l,c){const m=new r(l,c,()=>this._sessions.delete(m._id));return this._sessions.set(m._id,m),m}createInputBox(l){const c=new t(l,()=>this._sessions.delete(c._id));return this._sessions.set(c._id,c),c}$onDidChangeValue(l,c){const m=this._sessions.get(l);m&&m._fireDidChangeValue(c)}$onDidAccept(l){const c=this._sessions.get(l);c&&c._fireDidAccept()}$onDidChangeActive(l,c){const m=this._sessions.get(l);m instanceof r&&m._fireDidChangeActive(c)}$onDidChangeSelection(l,c){const m=this._sessions.get(l);m instanceof r&&m._fireDidChangeSelection(c)}$onDidTriggerButton(l,c){const m=this._sessions.get(l);m&&m._fireDidTriggerButton(c)}$onDidTriggerItemButton(l,c,m){const d=this._sessions.get(l);d instanceof r&&d._fireDidTriggerItemButton(c,m)}$onDidHide(l){const c=this._sessions.get(l);c&&c._fireDidHide()}}class o{constructor(l,c){this._extensionId=l,this._onDidDispose=c,this._id=r._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new D.Emitter,this._onDidChangeValueEmitter=new D.Emitter,this._onDidTriggerButtonEmitter=new D.Emitter,this._onDidHideEmitter=new D.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(l){this._title=l,this.update({title:l})}get step(){return this._steps}set step(l){this._steps=l,this.update({step:l})}get totalSteps(){return this._totalSteps}set totalSteps(l){this._totalSteps=l,this.update({totalSteps:l})}get enabled(){return this._enabled}set enabled(l){this._enabled=l,this.update({enabled:l})}get busy(){return this._busy}set busy(l){this._busy=l,this.update({busy:l})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(l){this._ignoreFocusOut=l,this.update({ignoreFocusOut:l})}get value(){return this._value}set value(l){this._value=l,this.update({value:l})}get placeholder(){return this._placeholder}set placeholder(l){this._placeholder=l,this.update({placeholder:l})}get buttons(){return this._buttons}set buttons(l){this._buttons=l.slice(),this._handlesToButtons.clear(),l.forEach((c,m)=>{const d=c===E.QuickInputButtons.Back?-1:m;this._handlesToButtons.set(d,c)}),this.update({buttons:l.map((c,m)=>({...f(c),tooltip:c.tooltip,handle:c===E.QuickInputButtons.Back?-1:m}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(l){this._value=l,this._onDidChangeValueEmitter.fire(l)}_fireDidTriggerButton(l){const c=this._handlesToButtons.get(l);c&&this._onDidTriggerButtonEmitter.fire(c)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,S.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),P.$dispose(this._id))}update(l){if(!this._disposed){for(const c of Object.keys(l)){const m=l[c];this._pendingUpdate[c]=m===void 0?null:m}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){P.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}o._nextId=1;function s(u){if(u instanceof E.ThemeIcon)return{id:u.id};const l=n(u),c=v(u);return{dark:typeof l=="string"?C.URI.file(l):l,light:typeof c=="string"?C.URI.file(c):c}}function v(u){return typeof u=="object"&&"light"in u?u.light:u}function n(u){return typeof u=="object"&&"dark"in u?u.dark:u}function f(u){const l=s(u.iconPath);let c,m;return"id"in l?m=a.ThemeIcon.asClassName(l):c=l,{iconPath:c,iconClass:m}}class r extends o{constructor(l,c,m){super(l,m);this.enableProposedApi=c,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new D.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new D.Emitter,this._onDidTriggerItemButtonEmitter=new D.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(l){this._items=l.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),l.forEach((c,m)=>{this._handlesToItems.set(m,c),this._itemsToHandles.set(c,m)}),this.update({items:l.map((c,m)=>({label:c.label,description:c.description,handle:m,detail:c.detail,picked:c.picked,alwaysShow:c.alwaysShow,buttons:c.buttons&&this.enableProposedApi?c.buttons.map((d,_)=>({...f(d),tooltip:d.tooltip,handle:_})):void 0}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(l){this._canSelectMany=l,this.update({canSelectMany:l})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(l){this._matchOnDescription=l,this.update({matchOnDescription:l})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(l){this._matchOnDetail=l,this.update({matchOnDetail:l})}get sortByLabel(){return this._sortByLabel}set sortByLabel(l){this._sortByLabel=l,this.update({sortByLabel:l})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(l){this._keepScrollPosition=l,this.update({keepScrollPosition:l})}get activeItems(){return this._activeItems}set activeItems(l){this._activeItems=l.filter(c=>this._itemsToHandles.has(c)),this.update({activeItems:this._activeItems.map(c=>this._itemsToHandles.get(c))})}get selectedItems(){return this._selectedItems}set selectedItems(l){this._selectedItems=l.filter(c=>this._itemsToHandles.has(c)),this.update({selectedItems:this._selectedItems.map(c=>this._itemsToHandles.get(c))})}_fireDidChangeActive(l){const c=(0,i.coalesce)(l.map(m=>this._handlesToItems.get(m)));this._activeItems=c,this._onDidChangeActiveEmitter.fire(c)}_fireDidChangeSelection(l){const c=(0,i.coalesce)(l.map(m=>this._handlesToItems.get(m)));this._selectedItems=c,this._onDidChangeSelectionEmitter.fire(c)}_fireDidTriggerItemButton(l,c){const m=this._handlesToItems.get(l);if(!m||!m.buttons||!m.buttons.length)return;const d=m.buttons[c];d&&this._onDidTriggerItemButtonEmitter.fire({button:d,item:m})}}class t extends o{constructor(l,c){super(l,c);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(l){this._password=l,this.update({password:l})}get prompt(){return this._prompt}set prompt(l){this._prompt=l,this.update({prompt:l})}get validationMessage(){return this._validationMessage}set validationMessage(l){this._validationMessage=l,this.update({validationMessage:l,severity:l?I.default.Error:I.default.Ignore})}}return new b(w,y)}e.createExtHostQuickOpen=p}),define(fe[252],me([0,1,2,3,60,6,16,5,15,100,11,27,35,65,17]),function(Y,e,g,L,D,S,T,C,E,k,i,I,a,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function w(l){if(l)return typeof l.iconPath=="string"?g.URI.file(l.iconPath):g.URI.isUri(l.iconPath)||p.ThemeIcon.isThemeIcon(l.iconPath)?l.iconPath:void 0}function y(l,c){if(!l.iconPath&&!c.iconPath)return 0;if(l.iconPath){if(!c.iconPath)return 1}else return-1;const m=typeof l.iconPath=="string"?l.iconPath:g.URI.isUri(l.iconPath)?l.iconPath.fsPath:l.iconPath.id,d=typeof c.iconPath=="string"?c.iconPath:g.URI.isUri(c.iconPath)?c.iconPath.fsPath:c.iconPath.id;return(0,k.comparePaths)(m,d)}function P(l,c){let m=0;if(l.strikeThrough!==c.strikeThrough)return l.strikeThrough?1:-1;if(l.faded!==c.faded)return l.faded?1:-1;if(l.tooltip!==c.tooltip)return(l.tooltip||"").localeCompare(c.tooltip||"");if(m=y(l,c),m!==0)return m;if(l.light&&c.light)m=y(l.light,c.light);else{if(l.light)return 1;if(c.light)return-1}if(m!==0)return m;if(l.dark&&c.dark)m=y(l.dark,c.dark);else{if(l.dark)return 1;if(c.dark)return-1}return m}function b(l,c){if(l.command!==c.command)return l.command<c.command?-1:1;if(l.title!==c.title)return l.title<c.title?-1:1;if(l.tooltip!==c.tooltip){if(l.tooltip!==void 0&&c.tooltip!==void 0)return l.tooltip<c.tooltip?-1:1;if(l.tooltip!==void 0)return 1;if(c.tooltip!==void 0)return-1}if(l.arguments===c.arguments)return 0;if(l.arguments)if(c.arguments){if(l.arguments.length!==c.arguments.length)return l.arguments.length-c.arguments.length}else return 1;else return-1;for(let m=0;m<l.arguments.length;m++){const d=l.arguments[m],_=c.arguments[m];if(d!==_)return d<_?-1:1}return 0}function o(l,c){let m=(0,k.comparePaths)(l.resourceUri.fsPath,c.resourceUri.fsPath,!0);if(m!==0)return m;if(l.command&&c.command)m=b(l.command,c.command);else{if(l.command)return 1;if(c.command)return-1}if(m!==0)return m;if(l.decorations&&c.decorations)m=P(l.decorations,c.decorations);else{if(l.decorations)return 1;if(c.decorations)return-1}return m}function s(l,c){for(let m=0;m<l.length;m++)if(l[m]!==c[m])return!1;return!0}function v(l,c){return l.command===c.command&&l.title===c.title&&l.tooltip===c.tooltip&&(l.arguments&&c.arguments?s(l.arguments,c.arguments):l.arguments===c.arguments)}function n(l,c){return(0,E.equals)(l,c,v)}class f{constructor(c,m,d){this._extension=c,this._proxy=m,this._sourceControlHandle=d,this._value="",this._onDidChange=new L.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(c){this._proxy.$setInputBoxValue(this._sourceControlHandle,c),this.updateValue(c)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(c){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,c),this._placeholder=c}get validateInput(){return(0,a.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(c){if((0,a.checkProposedApiEnabled)(this._extension),c&&typeof c!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=c,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!c)}get visible(){return this._visible}set visible(c){c=!!c,this._visible!==c&&(this._visible=c,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,c))}focus(){(0,a.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(c,m){(0,a.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,c,m)}$onInputBoxValueChange(c){this.updateValue(c)}updateValue(c){this._value=c,this._onDidChange.fire(c)}}e.ExtHostSCMInputBox=f;class r{constructor(c,m,d,_,A){this._proxy=c,this._commands=m,this._sourceControlHandle=d,this._id=_,this._label=A,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new L.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(c){this._label=c,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,c)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(c){this._hideWhenEmpty=c,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(c){this._resourceStates=[...c],this._onDidUpdateResourceStates.fire()}getResourceState(c){return this._resourceStatesMap.get(c)}$executeResourceCommand(c,m){const d=this._resourceStatesCommandsMap.get(c);return d?(0,T.asPromise)(()=>this._commands.executeCommand(d.command,...d.arguments||[],m)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const c=[...this._resourceStates].sort(o),d=(0,E.sortedDiff)(this._resourceSnapshot,c,o).map(R=>{const B=R.toInsert.map(U=>{const F=this._resourceHandlePool++;this._resourceStatesMap.set(F,U);const $=U.resourceUri;let M;if(U.command)if(U.command.command==="vscode.open"||U.command.command==="vscode.diff"){const de=new S.DisposableStore;M=this._commands.converter.toInternal(U.command,de),this._resourceStatesDisposablesMap.set(F,de)}else this._resourceStatesCommandsMap.set(F,U.command);const z=w(U.decorations),N=U.decorations&&w(U.decorations.light)||z,x=U.decorations&&w(U.decorations.dark)||z,j=[N,x],O=U.decorations&&U.decorations.tooltip||"",H=U.decorations&&!!U.decorations.strikeThrough,W=U.decorations&&!!U.decorations.faded,X=U.contextValue||"";return{rawResource:[F,$,j,O,H,W,X,M],handle:F}});return{start:R.start,deleteCount:R.deleteCount,toInsert:B}}),_=d.map(({start:R,deleteCount:B,toInsert:U})=>[R,B,U.map(F=>F.rawResource)]),A=d.reverse();for(const{start:R,deleteCount:B,toInsert:U}of A){const F=U.map(M=>M.handle),$=this._handlesSnapshot.splice(R,B,...F);for(const M of $)this._resourceStatesMap.delete(M),this._resourceStatesCommandsMap.delete(M),this._resourceStatesDisposablesMap.get(M)?.dispose(),this._resourceStatesDisposablesMap.delete(M)}return this._resourceSnapshot=c,_}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class t{constructor(c,m,d,_,A,R){this._extension=c,this._proxy=m,this._commands=d,this._id=_,this._label=A,this._rootUri=R,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new S.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new S.MutableDisposable,this._statusBarDisposables=new S.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new L.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=t._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new f(c,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,_,A,R)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(c){this._count!==c&&(this._count=c,this._proxy.$updateSourceControl(this.handle,{count:c}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(c){this._quickDiffProvider=c,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!c})}get commitTemplate(){return this._commitTemplate}set commitTemplate(c){c!==this._commitTemplate&&(this._commitTemplate=c,this._proxy.$updateSourceControl(this.handle,{commitTemplate:c}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(c){this._acceptInputDisposables.value=new S.DisposableStore,this._acceptInputCommand=c;const m=this._commands.converter.toInternal(c,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:m})}get actionButton(){return(0,a.checkProposedApiEnabled)(this._extension),this._actionButton}set actionButton(c){(0,a.checkProposedApiEnabled)(this._extension),this._actionButtonDisposables.value=new S.DisposableStore,this._actionButton=c;const m=c!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;this._proxy.$updateSourceControl(this.handle,{actionButton:m??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(c){if(this._statusBarCommands&&c&&n(this._statusBarCommands,c))return;this._statusBarDisposables.value=new S.DisposableStore,this._statusBarCommands=c;const m=(c||[]).map(d=>this._commands.converter.toInternal(d,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:m})}get selected(){return this._selected}createResourceGroup(c,m){const d=new r(this._proxy,this._commands,this.handle,c,m),_=L.Event.once(d.onDidDispose)(()=>this.createdResourceGroups.delete(d));return this.createdResourceGroups.set(d,_),this.eventuallyAddResourceGroups(),d}eventuallyAddResourceGroups(){const c=[],m=[];for(const[d,_]of this.createdResourceGroups){_.dispose();const A=d.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(d),this.eventuallyUpdateResourceStates()});L.Event.once(d.onDidDispose)(()=>{this.updatedResourceGroups.delete(d),A.dispose(),this._groups.delete(d.handle),this._proxy.$unregisterGroup(this.handle,d.handle)}),c.push([d.handle,d.id,d.label,d.features]);const R=d._takeResourceStateSnapshot();R.length>0&&m.push([d.handle,R]),this._groups.set(d.handle,d)}this._proxy.$registerGroups(this.handle,c,m),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const c=[];this.updatedResourceGroups.forEach(m=>{const d=m._takeResourceStateSnapshot();d.length!==0&&c.push([m.handle,d])}),c.length>0&&this._proxy.$spliceResourceStates(this.handle,c),this.updatedResourceGroups.clear()}getResourceGroup(c){return this._groups.get(c)}setSelectionState(c){this._selected=c,this._onDidChangeSelection.fire(c)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(c=>c.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}t._handlePool=0,Ve([(0,D.debounce)(100)],t.prototype,"eventuallyAddResourceGroups",null),Ve([(0,D.debounce)(100)],t.prototype,"eventuallyUpdateResourceStates",null);let u=class Bi{constructor(c,m,d){this._commands=m,this.logService=d,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new L.Emitter,this._proxy=c.getProxy(C.MainContext.MainThreadSCM),this._telemetry=c.getProxy(C.MainContext.MainThreadTelemetry),m.registerArgumentProcessor({processArgument:_=>{if(_&&_.$mid===3){const A=this._sourceControls.get(_.sourceControlHandle);if(!A)return _;const R=A.getResourceGroup(_.groupHandle);return R?R.getResourceState(_.handle):_}else if(_&&_.$mid===4){const A=this._sourceControls.get(_.sourceControlHandle);return A?A.getResourceGroup(_.groupHandle):_}else if(_&&_.$mid===5){const A=this._sourceControls.get(_.handle);return A||_}return _}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(c,m,d,_){this.logService.trace("ExtHostSCM#createSourceControl",c.identifier.value,m,d,_),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:c.identifier.value});const A=Bi._handlePool++,R=new t(c,this._proxy,this._commands,m,d,_);this._sourceControls.set(A,R);const B=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(c.identifier))||[];return B.push(R),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(c.identifier),B),R}getLastInputBox(c){this.logService.trace("ExtHostSCM#getLastInputBox",c.identifier.value);const m=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(c.identifier)),d=m&&m[m.length-1];return d&&d.inputBox}$provideOriginalResource(c,m,d){const _=g.URI.revive(m);this.logService.trace("ExtHostSCM#$provideOriginalResource",c,_.toString());const A=this._sourceControls.get(c);return!A||!A.quickDiffProvider||!A.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,T.asPromise)(()=>A.quickDiffProvider.provideOriginalResource(_,d)).then(R=>R||null)}$onInputBoxValueChange(c,m){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",c);const d=this._sourceControls.get(c);return d&&d.inputBox.$onInputBoxValueChange(m),Promise.resolve(void 0)}$executeResourceCommand(c,m,d,_){this.logService.trace("ExtHostSCM#$executeResourceCommand",c,m,d);const A=this._sourceControls.get(c);if(!A)return Promise.resolve(void 0);const R=A.getResourceGroup(m);return R?R.$executeResourceCommand(d,_):Promise.resolve(void 0)}$validateInput(c,m,d){this.logService.trace("ExtHostSCM#$validateInput",c);const _=this._sourceControls.get(c);return!_||!_.inputBox.validateInput?Promise.resolve(void 0):(0,T.asPromise)(()=>_.inputBox.validateInput(m,d)).then(A=>{if(!A)return Promise.resolve(void 0);const R=h.MarkdownString.fromStrict(A.message);return R?Promise.resolve([R,A.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(c){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",c),c!==void 0&&this._sourceControls.get(c)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=c,Promise.resolve(void 0)}};u._handlePool=0,u=Ve([$e(2,i.ILogService)],u),e.ExtHostSCM=u});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,g):D?D.value=g:e.set(Y,g),g},Oe=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[253],me([0,1,7,5,167,6,17,13]),function(Y,e,g,L,D,S,T,C){"use strict";var E,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class i{constructor(h,w,y,P,b=g.StatusBarAlignment.Left,o){E.set(this,void 0),k.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new S.DisposableStore,st(this,E,h,"f"),st(this,k,w,"f"),this._entryId=i.ID_GEN++,this._extension=y,this._id=P,this._alignment=b,this._priority=this.validatePriority(o)}validatePriority(h){if(!!(0,C.isNumber)(h))return h===Number.POSITIVE_INFINITY?Number.MAX_VALUE:h===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:h}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(h){this._text=h,this.update()}set name(h){this._name=h,this.update()}set tooltip(h){this._tooltip=h,this.update()}set color(h){this._color=h,this.update()}set backgroundColor(h){h&&!i.ALLOWED_BACKGROUND_COLORS.has(h.id)&&(h=void 0),this._backgroundColor=h,this.update()}set command(h){this._command?.fromApi!==h&&(this._internalCommandRegistration.clear(),typeof h=="string"?this._command={fromApi:h,internal:Oe(this,k,"f").toInternal({title:"",command:h},this._internalCommandRegistration)}:h?this._command={fromApi:h,internal:Oe(this,k,"f").toInternal(h,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(h){this._accessibilityInformation=h,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Oe(this,E,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let h;this._extension?this._id?h=`${this._extension.identifier.value}.${this._id}`:h=this._extension.identifier.value:h=this._id;let w;this._name?w=this._name:w=(0,D.localize)(0,null,this._extension.displayName||this._extension.name);let y=this._color;this._backgroundColor&&(y=i.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const P=this._tooltip?T.MarkdownString.fromStrict(this._tooltip):void 0;Oe(this,E,"f").$setEntry(this._entryId,h,w,this._text,P,this._command?.internal,y,this._backgroundColor,this._alignment===g.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=i,E=new WeakMap,k=new WeakMap,i.ID_GEN=0,i.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new g.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new g.ThemeColor("statusBarItem.warningForeground")]]);class I{constructor(h){this._messages=[],this._item=h.createStatusBarEntry(void 0,"status.extensionMessage",g.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,D.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(h){const w={message:h};return this._messages.unshift(w),this._update(),new g.Disposable(()=>{const y=this._messages.indexOf(w);y>=0&&(this._messages.splice(y,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class a{constructor(h,w){this._proxy=h.getProxy(L.MainContext.MainThreadStatusBar),this._commands=w,this._statusMessage=new I(this)}createStatusBarEntry(h,w,y,P){return new i(this._proxy,this._commands,h,w,y,P)}setStatusBarMessage(h,w){const y=this._statusMessage.setMessage(h);let P;return typeof w=="number"?P=setTimeout(()=>y.dispose(),w):typeof w!="undefined"&&w.then(()=>y.dispose(),()=>y.dispose()),new g.Disposable(()=>{y.dispose(),clearTimeout(P)})}}e.ExtHostStatusBar=a}),define(fe[92],me([0,1,5,3,4]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class S{constructor(C){this._onDidChangeStorage=new L.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=C.getProxy(g.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(C,E){this._proxy.$registerExtensionStorageKeysToSync(C,E)}getValue(C,E,k){return this._proxy.$getValue(C,E).then(i=>i||k)}setValue(C,E,k){return this._proxy.$setValue(C,E,k)}$acceptValue(C,E,k){this._onDidChangeStorage.fire({shared:C,key:E,value:k})}}e.ExtHostStorage=S,e.IExtHostStorage=(0,D.createDecorator)("IExtHostStorage")}),define(fe[70],me([0,1,4,26,11,69,2]),function(Y,e,g,L,D,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,g.createDecorator)("IExtensionStoragePaths");let C=class{constructor(k,i,I){this._logService=i,this._extHostFileSystem=I,this._workspace=k.workspace??void 0,this._environment=k.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(a=>this._value=a)}async _getWorkspaceStorageURI(k){return T.URI.joinPath(this._environment.workspaceStorageHome,k)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const k=this._workspace.id,i=await this._getWorkspaceStorageURI(k);try{return await this._extHostFileSystem.value.stat(i),this._logService.trace("[ExtHostStorage] storage dir already exists",i),i}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",i),await this._extHostFileSystem.value.createDirectory(i),await this._extHostFileSystem.value.writeFile(T.URI.joinPath(i,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:T.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),i}catch(I){this._logService.error("[ExtHostStorage]",I);return}}workspaceValue(k){if(this._value)return T.URI.joinPath(this._value,k.identifier.value)}globalValue(k){return T.URI.joinPath(this._environment.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};C=Ve([$e(0,L.IExtHostInitDataService),$e(1,D.ILogService),$e(2,S.IExtHostConsumerFileSystem)],C),e.ExtensionStoragePaths=C}),define(fe[33],me([0,1,3,5,4,2,14,6,7,168,18,218,21,31,197,65,13,16]),function(Y,e,g,L,D,S,T,C,E,k,i,I,a,p,h,w,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,D.createDecorator)("IExtHostTerminalService");class b{constructor(l,c,m,d){this._proxy=l,this._id=c,this._creationOptions=m,this._name=d,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(A=>this._pidPromiseComplete=A);const _=this;this.value={get name(){return _._name||""},get processId(){return _._pidPromise},get creationOptions(){return _._creationOptions},get exitStatus(){return _._exitStatus},get state(){return _._state},sendText(A,R=!0){_._checkDisposed(),_._proxy.$sendText(_._id,A,R)},show(A){_._checkDisposed(),_._proxy.$show(_._id,A)},hide(){_._checkDisposed(),_._proxy.$hide(_._id)},dispose(){_._disposed||(_._disposed=!0,_._proxy.$dispose(_._id))},get dimensions(){if(!(_._cols===void 0||_._rows===void 0))return{columns:_._cols,rows:_._rows}}}}async create(l,c){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:l.name,shellPath:(0,y.withNullAsUndefined)(l.shellPath),shellArgs:(0,y.withNullAsUndefined)(l.shellArgs),cwd:(0,y.withNullAsUndefined)(l.cwd),env:(0,y.withNullAsUndefined)(l.env),icon:(0,y.withNullAsUndefined)(r(l.iconPath)),color:w.ThemeColor.isThemeColor(l.color)?l.color.id:void 0,initialText:(0,y.withNullAsUndefined)(l.message),strictEnv:(0,y.withNullAsUndefined)(l.strictEnv),hideFromUser:(0,y.withNullAsUndefined)(l.hideFromUser),isFeatureTerminal:(0,y.withNullAsUndefined)(c?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,y.withNullAsUndefined)(c?.useShellEnvironment),location:c?.location||this._serializeParentTerminal(l.location,c?.resolvedExtHostIdentifier)})}async createExtensionTerminal(l,c,m,d){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:m,color:w.ThemeColor.isThemeColor(d)?d.id:void 0,location:this._serializeParentTerminal(l,c)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(l,c){return typeof l=="object"?"parentTerminal"in l&&l.parentTerminal&&c?{parentTerminal:c}:"viewColumn"in l?{viewColumn:l.viewColumn,preserveFocus:l.preserveFocus}:void 0:l}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(l){this._name=l}setExitCode(l){this._exitStatus=Object.freeze({code:l})}setDimensions(l,c){return l===this._cols&&c===this._rows||l===0||c===0?!1:(this._cols=l,this._rows=c,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(l){this._pidPromiseComplete?(this._pidPromiseComplete(l),this._pidPromiseComplete=void 0):this._pidPromise.then(c=>{c!==l&&(this._pidPromise=Promise.resolve(l))})}}e.ExtHostTerminal=b;class o{constructor(l){this._pty=l,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new g.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new g.Emitter,this._onDidChangeProperty=new g.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new g.Emitter,this.onProcessExit=this._onProcessExit.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}refreshProperty(l){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${l}`)}updateProperty(l,c){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${l}, value: ${c}`)}async start(){}shutdown(){this._pty.close()}input(l){this._pty.handleInput&&this._pty.handleInput(l)}resize(l,c){this._pty.setDimensions&&this._pty.setDimensions({columns:l,rows:c})}async processBinary(l){}acknowledgeDataEvent(l){}async setUnicodeVersion(l){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(l){this._pty.onDidWrite(c=>this._onProcessData.fire(c)),this._pty.onDidClose&&this._pty.onDidClose((c=void 0)=>{this._onProcessExit.fire(c===void 0?void 0:c)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(c=>{c&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:c.columns,rows:c.rows}})}),this._pty.onDidChangeName&&this._pty.onDidChangeName(c=>{this._onDidChangeProperty.fire({type:"title",value:c})}),this._pty.open(l||void 0),this._pty.setDimensions&&l&&this._pty.setDimensions(l),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=o;let s=1,v=class extends C.Disposable{constructor(l,c){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new g.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new g.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new g.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new g.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new g.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=c.getProxy(L.MainContext.MainThreadTerminalService),this._bufferer=new h.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new g.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(l),this._register({dispose:()=>{for(const[m,d]of this._terminalProcesses)d.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(l=>l.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(l){return(l?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(l){return(l?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(l,c){const m=new b(this._proxy,(0,p.generateUuid)(),l,l.name),d=new o(l.pty);return m.createExtensionTerminal(l.location,this._serializeParentTerminal(l,c).resolvedExtHostIdentifier,r(l.iconPath),t(l.color)).then(_=>{const A=this._setupExtHostProcessListeners(_,d);this._terminalProcessDisposables[_]=A}),this._terminals.push(m),m.value}_serializeParentTerminal(l,c){if(c=c||{},l.location&&typeof l.location=="object"&&"parentTerminal"in l.location){const m=l.location.parentTerminal;if(m){const d=this._terminals.find(_=>_.value===m);d&&(c.resolvedExtHostIdentifier=d._id)}}else l.location&&typeof l.location!="object"?c.location=l.location:c.location&&typeof c.location=="object"&&"splitActiveTerminal"in c.location&&(c.location={splitActiveTerminal:!0});return c}attachPtyToTerminal(l,c){if(!this._getTerminalById(l))throw new Error(`Cannot resolve terminal with id ${l} for virtual process`);const d=new o(c),_=this._setupExtHostProcessListeners(l,d);this._terminalProcessDisposables[l]=_}async $acceptActiveTerminalChanged(l){const c=this._activeTerminal;if(l===null){this._activeTerminal=void 0,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const m=this._getTerminalById(l);m&&(this._activeTerminal=m,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(l,c){const m=this._getTerminalById(l);m&&this._onDidWriteTerminalData.fire({terminal:m.value,data:c})}async $acceptTerminalDimensions(l,c,m){const d=this._getTerminalById(l);d&&d.setDimensions(c,m)&&this._onDidChangeTerminalDimensions.fire({terminal:d.value,dimensions:d.value.dimensions})}async $acceptTerminalMaximumDimensions(l,c,m){this._terminalProcesses.get(l)?.resize(c,m)}async $acceptTerminalTitleChange(l,c){const m=this._getTerminalById(l);m&&(m.name=c)}async $acceptTerminalClosed(l,c){const m=this._getTerminalObjectIndexById(this._terminals,l);if(m!==null){const d=this._terminals.splice(m,1)[0];d.setExitCode(c),this._onDidCloseTerminal.fire(d.value)}}$acceptTerminalOpened(l,c,m,d){if(c){const R=this._getTerminalObjectIndexById(this._terminals,c);if(R!==null){this._terminals[R]._id=l,this._onDidOpenTerminal.fire(this.terminals[R]),this._terminals[R].isOpen=!0;return}}const _={name:d.name,shellPath:d.executable,shellArgs:d.args,cwd:typeof d.cwd=="string"?d.cwd:S.URI.revive(d.cwd),env:d.env,hideFromUser:d.hideFromUser},A=new b(this._proxy,l,_,m);this._terminals.push(A),this._onDidOpenTerminal.fire(A.value),A.isOpen=!0}async $acceptTerminalProcessId(l,c){const m=this._getTerminalById(l);m&&m._setProcessId(c)}async $startExtensionTerminal(l,c){const m=this._getTerminalById(l);if(!m)return{message:(0,k.localize)(0,null,l)};m.isOpen||await new Promise(_=>{const A=this.onDidOpenTerminal(async R=>{R===m.value&&(A.dispose(),_())})});const d=this._terminalProcesses.get(l);d?d.startSendingEvents(c):this._extensionTerminalAwaitingStart[l]={initialDimensions:c}}_setupExtHostProcessListeners(l,c){const m=new C.DisposableStore;m.add(c.onProcessReady(_=>this._proxy.$sendProcessReady(l,_.pid,_.cwd))),m.add(c.onDidChangeProperty(_=>this._proxy.$sendProcessProperty(l,_))),this._bufferer.startBuffering(l,c.onProcessData),m.add(c.onProcessExit(_=>this._onProcessExit(l,_))),this._terminalProcesses.set(l,c);const d=this._extensionTerminalAwaitingStart[l];return d&&c instanceof o&&(c.startSendingEvents(d.initialDimensions),delete this._extensionTerminalAwaitingStart[l]),m}$acceptProcessAckDataEvent(l,c){this._terminalProcesses.get(l)?.acknowledgeDataEvent(c)}$acceptProcessInput(l,c){this._terminalProcesses.get(l)?.input(c)}$acceptTerminalInteraction(l){const c=this._getTerminalById(l);c?.setInteractedWith()&&this._onDidChangeTerminalState.fire(c.value)}$acceptProcessResize(l,c,m){try{this._terminalProcesses.get(l)?.resize(c,m)}catch(d){if(d.code!=="EPIPE"&&d.code!=="ERR_IPC_CHANNEL_CLOSED")throw d}}$acceptProcessShutdown(l,c){this._terminalProcesses.get(l)?.shutdown(c)}$acceptProcessRequestInitialCwd(l){this._terminalProcesses.get(l)?.getInitialCwd().then(c=>this._proxy.$sendProcessProperty(l,{type:"initialCwd",value:c}))}$acceptProcessRequestCwd(l){this._terminalProcesses.get(l)?.getCwd().then(c=>this._proxy.$sendProcessProperty(l,{type:"cwd",value:c}))}$acceptProcessRequestLatency(l){return l}registerLinkProvider(l){return this._linkProviders.add(l),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new E.Disposable(()=>{this._linkProviders.delete(l),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(l,c,m){if(this._profileProviders.has(c))throw new Error(`Terminal profile provider "${c}" already registered`);return this._profileProviders.set(c,m),this._proxy.$registerProfileProvider(c,l.identifier.value),new E.Disposable(()=>{this._profileProviders.delete(c),this._proxy.$unregisterProfileProvider(c)})}async $createContributedProfileTerminal(l,c){const m=new a.CancellationTokenSource().token;let d=await this._profileProviders.get(l)?.provideTerminalProfile(m);if(!m.isCancellationRequested){if(d&&!("options"in d)&&(d={options:d}),!d||!("options"in d))throw new Error(`No terminal profile options provided for id "${l}"`);if("pty"in d.options){this.createExtensionTerminal(d.options,c);return}this.createTerminalFromOptions(d.options,c)}}async $provideLinks(l,c){const m=this._getTerminalById(l);if(!m)return[];this._terminalLinkCache.delete(l);const d=this._terminalLinkCancellationSource.get(l);d&&d.dispose(!0);const _=new a.CancellationTokenSource;this._terminalLinkCancellationSource.set(l,_);const A=[],R={terminal:m.value,line:c},B=[];for(const $ of this._linkProviders)B.push(P.Promises.withAsyncBody(async M=>{_.token.onCancellationRequested(()=>M({provider:$,links:[]}));const z=await $.provideTerminalLinks(R,_.token)||[];_.token.isCancellationRequested||M({provider:$,links:z})}));const U=await Promise.all(B);if(_.token.isCancellationRequested)return[];const F=new Map;for(const $ of U)$&&$.links.length>0&&A.push(...$.links.map(M=>{const z={id:s++,startIndex:M.startIndex,length:M.length,label:M.tooltip};return F.set(z.id,{provider:$.provider,link:M}),z}));return this._terminalLinkCache.set(l,F),A}$activateLink(l,c){const m=this._terminalLinkCache.get(l)?.get(c);!m||m.provider.handleTerminalLink(m.link)}_onProcessExit(l,c){this._bufferer.stopBuffering(l),this._terminalProcesses.delete(l),delete this._extensionTerminalAwaitingStart[l];const m=this._terminalProcessDisposables[l];m&&(m.dispose(),delete this._terminalProcessDisposables[l]),this._proxy.$sendProcessExit(l,c)}_getTerminalById(l){return this._getTerminalObjectById(this._terminals,l)}_getTerminalObjectById(l,c){const m=this._getTerminalObjectIndexById(l,c);return m!==null?l[m]:null}_getTerminalObjectIndexById(l,c){let m=null;return l.some((d,_)=>d._id===c?(m=_,!0):!1),m}getEnvironmentVariableCollection(l){let c=this._environmentVariableCollections.get(l.identifier.value);return c||(c=new n,this._setEnvironmentVariableCollection(l.identifier.value,c)),c}_syncEnvironmentVariableCollection(l,c){const m=(0,I.serializeEnvironmentVariableCollection)(c.map);this._proxy.$setEnvironmentVariableCollection(l,c.persistent,m.length===0?void 0:m)}$initEnvironmentVariableCollections(l){l.forEach(c=>{const m=c[0],d=new n(c[1]);this._setEnvironmentVariableCollection(m,d)})}$acceptDefaultProfile(l,c){this._defaultProfile=l,this._defaultAutomationProfile=c}_setEnvironmentVariableCollection(l,c){this._environmentVariableCollections.set(l,c),c.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(l,c)})}};v=Ve([$e(1,T.IExtHostRpcService)],v),e.BaseExtHostTerminalService=v;class n{constructor(l){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new g.Emitter,this.map=new Map(l)}get persistent(){return this._persistent}set persistent(l){this._persistent=l,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(l,c){this._setIfDiffers(l,{value:c,type:E.EnvironmentVariableMutatorType.Replace})}append(l,c){this._setIfDiffers(l,{value:c,type:E.EnvironmentVariableMutatorType.Append})}prepend(l,c){this._setIfDiffers(l,{value:c,type:E.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(l,c){const m=this.map.get(l);(!m||m.value!==c.value||m.type!==c.type)&&(this.map.set(l,c),this._onDidChangeCollection.fire())}get(l){return this.map.get(l)}forEach(l,c){this.map.forEach((m,d)=>l.call(c,d,m,this))}delete(l){this.map.delete(l),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=n;let f=class extends v{constructor(l){super(!1,l)}createTerminal(l,c,m){throw new i.NotSupportedError}createTerminalFromOptions(l,c){throw new i.NotSupportedError}};f=Ve([$e(0,T.IExtHostRpcService)],f),e.WorkerExtHostTerminalService=f;function r(u){if(!(!u||typeof u=="string"))return"id"in u?{id:u.id,color:u.color}:u}function t(u){return w.ThemeColor.isThemeColor(u)?u:void 0}});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,g):D?D.value=g:e.set(Y,g),g},Oe=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[254],me([0,1,15,22,21,3,76,49,6,25,13,31,5,14,66,17,7,226,127,90]),function(Y,e,g,L,D,S,T,C,E,k,i,I,a,p,h,w,y,P,b,o){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let v=class{constructor(R,B){this.resultsChangedEmitter=new S.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=R.getProxy(a.MainContext.MainThreadTesting),this.observer=new m(this.proxy),this.runTracker=new f(this.proxy),B.registerArgumentProcessor({processArgument:U=>U?.$mid===13?w.TestItem.toItemFromContext(U):U})}createTestController(R,B){if(this.controllers.has(R))throw new Error(`Attempt to insert a duplicate controller with ID "${R}"`);const U=new E.DisposableStore,F=U.add(new P.SingleUseTestCollection(R));F.root.label=B;const $=new Map,M=this.proxy,z={items:F.root.children,get label(){return B},set label(x){B=x,F.root.label=x,M.$updateControllerLabel(R,B)},get id(){return R},createRunProfile:(x,j,O,H,W)=>{let X=(0,C.hash)(x);for(;$.has(X);)X++;const Q=new d(this.proxy,R,X,x,j,O,H,W);return $.set(X,Q),Q},createTestItem(x,j,O){return new h.TestItemImpl(R,x,j,O)},createTestRun:(x,j,O=!0)=>this.runTracker.createTestRun(R,F,x,j,O),set resolveHandler(x){F.resolveHandler=x},get resolveHandler(){return F.resolveHandler},dispose:()=>{U.dispose()}};z.createRunConfiguration=z.createRunProfile,M.$registerTestController(R,B),U.add((0,E.toDisposable)(()=>M.$unregisterTestController(R)));const N={controller:z,collection:F,profiles:$};return this.controllers.set(R,N),U.add((0,E.toDisposable)(()=>this.controllers.delete(R))),U.add(F.onDidGenerateDiff(x=>M.$publishDiff(R,x))),z}createTestObserver(){return this.observer.checkout()}async runTests(R,B=D.CancellationToken.None){const U=r(R);if(!U)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const F=this.controllers.get(U.controllerId);if(!F)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:R.include?.map($=>$.id)??[F.collection.root.id],profileGroup:_[U.kind],profileId:U.profileId,controllerId:U.controllerId}],exclude:R.exclude?.map($=>$.id)},B)}$provideFileCoverage(R,B,U){return(0,g.mapFind)(this.runTracker.trackers,$=>$.id===R?$.getCoverage(B):void 0)?.provideFileCoverage(U)??Promise.resolve([])}$resolveFileCoverage(R,B,U,F){return(0,g.mapFind)(this.runTracker.trackers,M=>M.id===R?M.getCoverage(B):void 0)?.resolveFileCoverage(U,F)??Promise.resolve([])}$configureRunProfile(R,B){this.controllers.get(R)?.profiles.get(B)?.configureHandler?.()}$publishTestResults(R){this.results=Object.freeze(R.map(B=>(0,k.deepFreeze)(w.TestResults.to(B))).concat(this.results).sort((B,U)=>U.completedAt-B.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(R,B){const U=this.controllers.get(o.TestId.fromString(R).controllerId)?.collection;U&&(await U.expand(R,B<0?Infinity:B),U.flushDiff())}$acceptDiff(R){this.observer.applyDiff(R)}async $runControllerTests(R,B){const U=this.controllers.get(R.controllerId);if(!U)return;const{collection:F,profiles:$}=U,M=$.get(R.profileId);if(!M)return;const z=R.testIds.map(O=>F.tree.get(O)).filter(i.isDefined),N=R.excludeExtIds.map(O=>U.collection.tree.get(O)).filter(i.isDefined).filter(O=>z.some(H=>H.fullId.compare(O.fullId)===2));if(!z.length)return;const x=new y.TestRunRequest(z.some(O=>O.actual instanceof h.TestItemRootImpl)?void 0:z.map(O=>O.actual),N.map(O=>O.actual),M),j=this.runTracker.prepareForMainThreadTestRun(x,t.fromInternal(R,U.collection),B);try{await M.runHandler(x,B)}finally{j.isRunning&&!B.isCancellationRequested&&await S.Event.toPromise(j.onEnd),j.dispose()}}$cancelExtensionTestRun(R){R===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(R)}};v=Ve([$e(0,p.IExtHostRpcService)],v),e.ExtHostTesting=v;class n extends E.Disposable{constructor(R,B,U){super();this.dto=R,this.proxy=B,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new S.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new D.CancellationTokenSource(U)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:F}of this.tasks.values())F.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(R){return this.tasks.get(R)?.coverage}createRun(R){const B=this.dto.id,U=this.dto.controllerId,F=(0,I.generateUuid)(),$=new u(this.proxy,B,F),M=j=>(O,...H)=>{if(N){console.warn(`Setting the state of test "${O.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(O)||(this.ensureTestIsKnown(O),j(O,...H))},z=(j,O)=>{const H=O instanceof Array?O.map(w.TestMessage.from):[w.TestMessage.from(O)];if(j.uri&&j.range){const W={range:w.Range.from(j.range),uri:j.uri};for(const X of H)X.location=X.location||W}this.proxy.$appendTestMessagesInRun(B,F,o.TestId.fromExtHostTestItem(j,U).toString(),H)};let N=!1;const x={isPersisted:this.dto.isPersisted,token:this.cts.token,name:R,get coverageProvider(){return $.coverageProvider},set coverageProvider(j){$.coverageProvider=j},enqueued:M(j=>{this.proxy.$updateTestStateInRun(B,F,o.TestId.fromExtHostTestItem(j,U).toString(),1)}),skipped:M(j=>{this.proxy.$updateTestStateInRun(B,F,o.TestId.fromExtHostTestItem(j,U).toString(),5)}),started:M(j=>{this.proxy.$updateTestStateInRun(B,F,o.TestId.fromExtHostTestItem(j,U).toString(),2)}),errored:M((j,O,H)=>{z(j,O),this.proxy.$updateTestStateInRun(B,F,o.TestId.fromExtHostTestItem(j,U).toString(),6,H)}),failed:M((j,O,H)=>{z(j,O),this.proxy.$updateTestStateInRun(B,F,o.TestId.fromExtHostTestItem(j,U).toString(),4,H)}),passed:M((j,O)=>{this.proxy.$updateTestStateInRun(B,F,o.TestId.fromExtHostTestItem(j,this.dto.controllerId).toString(),3,O)}),appendOutput:(j,O,H)=>{N||(H&&(this.dto.isIncluded(H)?this.ensureTestIsKnown(H):H=void 0),this.proxy.$appendOutputToRun(B,F,L.VSBuffer.fromString(j),O&&w.location.from(O),H&&o.TestId.fromExtHostTestItem(H,U).toString()))},end:()=>{N||(N=!0,this.proxy.$finishedTestRunTask(B,F),this.tasks.delete(F),this.isRunning||this.dispose())}};return this.tasks.set(F,{run:x,coverage:$}),this.proxy.$startedTestRunTask(B,{id:F,name:R,running:!0}),x}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(R){if(!(R instanceof h.TestItemImpl))throw new h.InvalidTestItemError(R.id);if(this.sharedTestIds.has(o.TestId.fromExtHostTestItem(R,this.dto.controllerId).toString()))return;const B=[],U=this.dto.colllection.root;for(;;){const F=w.TestItem.from(R);if(B.unshift(F),this.sharedTestIds.has(F.extId)||(this.sharedTestIds.add(F.extId),R===U))break;R=R.parent||U}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,B)}}class f{constructor(R){this.proxy=R,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(R,B,U){return this.getTracker(R,B,U)}cancelRunById(R){for(const B of this.tracked.values())if(B.id===R){B.dispose();return}}cancelAllRuns(){for(const R of this.tracked.values())R.dispose()}createTestRun(R,B,U,F,$){const M=this.tracked.get(U);if(M)return M.createRun(F);const z=t.fromPublic(R,B,U,$),N=r(U);this.proxy.$startedExtensionTestRun({controllerId:R,profile:N&&{group:_[N.kind],id:N.profileId},exclude:U.exclude?.map(j=>j.id)??[],id:z.id,include:U.include?.map(j=>j.id)??[B.root.id],persist:$});const x=this.getTracker(U,z);return x.onEnd(()=>this.proxy.$finishedExtensionTestRun(z.id)),x.createRun(F)}getTracker(R,B,U){const F=new n(B,this.proxy,U);return this.tracked.set(R,F),F.onEnd(()=>this.tracked.delete(R)),F}}e.TestRunCoordinator=f;const r=A=>{if(!!A.profile){if(!(A.profile instanceof d))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return A.profile}};class t{constructor(R,B,U,F,$,M){this.controllerId=R,this.id=B,this.isPersisted=$,this.colllection=M,this.includePrefix=U.map(z=>z+"\0"),this.excludePrefix=F.map(z=>z+"\0")}static fromPublic(R,B,U,F){return new t(R,(0,I.generateUuid)(),U.include?.map($=>o.TestId.fromExtHostTestItem($,R).toString())??[R],U.exclude?.map($=>o.TestId.fromExtHostTestItem($,R).toString())??[],F,B)}static fromInternal(R,B){return new t(R.controllerId,R.runId,R.testIds,R.excludeExtIds,!0,B)}isIncluded(R){const B=o.TestId.fromExtHostTestItem(R,this.controllerId).toString()+"\0";for(const U of this.excludePrefix)if(B===U||B.startsWith(U))return!1;for(const U of this.includePrefix)if(B===U||B.startsWith(U))return!0;return!1}}e.TestRunDto=t;class u{constructor(R,B,U){this.proxy=R,this.runId=B,this.taskId=U}set coverageProvider(R){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!R||(this._coverageProvider=R,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(R){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(R))());try{return(await this.fileCoverage)?.map(w.TestCoverage.fromFile)??[]}catch(B){throw this.fileCoverage=void 0,B}}async resolveFileCoverage(R,B){const U=await this.fileCoverage;let F=U?.[R];return!this._coverageProvider||!U||!F?[]:(F.detailedCoverage||(F=U[R]=await this._coverageProvider.resolveFileCoverage?.(F,B)??F),F.detailedCoverage?.map(w.TestCoverage.fromDetailed)??[])}}class l extends b.IncrementalChangeCollector{constructor(R){super();this.emitter=R,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(R){this.added.add(R)}update(R){Object.assign(R.revived,w.TestItem.toPlain(R.item)),this.added.has(R)||this.updated.add(R)}remove(R){if(this.added.has(R)){this.added.delete(R);return}if(this.updated.delete(R),R.parent&&this.alreadyRemoved.has(R.parent)){this.alreadyRemoved.add(R.item.extId);return}this.removed.add(R)}getChangeEvent(){const{added:R,updated:B,removed:U}=this;return{get added(){return[...R].map(F=>F.revived)},get updated(){return[...B].map(F=>F.revived)},get removed(){return[...U].map(F=>F.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class c extends b.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new S.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(R){return this.items.get(R)}getMirroredTestDataByReference(R){return this.items.get(R.id)}createItem(R,B){return{...R,revived:w.TestItem.toPlain(R.item),depth:B?B.depth+1:0,children:new Set}}createChangeCollector(){return new l(this.changeEmitter)}}e.MirroredTestCollection=c;class m{constructor(R){this.proxy=R}checkout(){this.current||(this.current=this.createObserverData());const R=this.current;return R.observers++,{onDidChangeTest:R.tests.onDidChangeTests,get tests(){return[...R.tests.rootTests].map(B=>B.revived)},dispose:(0,T.once)(()=>{--R.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(R){return this.current?.tests.getMirroredTestDataByReference(R)}applyDiff(R){this.current?.tests.apply(R)}createObserverData(){const R=new c;return this.proxy.$subscribeToDiffs(),{observers:0,tests:R}}}class d{constructor(R,B,U,F,$,M,z=!1,N=void 0){this.controllerId=B,this.profileId=U,this._label=F,this.kind=$,this.runHandler=M,this._isDefault=z,this._tag=N,s.set(this,void 0),st(this,s,R,"f");const x=_[$];if(typeof x!="number")throw new Error(`Unknown TestRunProfile.group ${$}`);Oe(this,s,"f").$publishTestRunProfile({profileId:U,controllerId:B,tag:N?w.TestTag.namespace(this.controllerId,N.id):null,label:F,group:x,isDefault:z,hasConfigurationHandler:!1})}get label(){return this._label}set label(R){R!==this._label&&(this._label=R,Oe(this,s,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:R}))}get isDefault(){return this._isDefault}set isDefault(R){R!==this._isDefault&&(this._isDefault=R,Oe(this,s,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:R}))}get tag(){return this._tag}set tag(R){R?.id!==this._tag?.id&&(this._tag=R,Oe(this,s,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:R?w.TestTag.namespace(this.controllerId,R.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(R){R!==this._configureHandler&&(this._configureHandler=R,Oe(this,s,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!R}))}dispose(){Oe(this,s,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=d,s=new WeakMap;const _={[y.TestRunProfileKind.Coverage]:8,[y.TestRunProfileKind.Debug]:4,[y.TestRunProfileKind.Run]:2}}),define(fe[255],me([0,1,3,15,5,130,17,7]),function(Y,e,g,L,D,S,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class E{constructor(i,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new g.Emitter,this._onDidChangeTextEditorOptions=new g.Emitter,this._onDidChangeTextEditorVisibleRanges=new g.Emitter,this._onDidChangeTextEditorViewColumn=new g.Emitter,this._onDidChangeActiveTextEditor=new g.Emitter,this._onDidChangeVisibleTextEditors=new g.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=i.getProxy(D.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(a=>this._onDidChangeVisibleTextEditors.fire(a)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(a=>this._onDidChangeActiveTextEditor.fire(a))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(i){const I=this._extHostDocumentsAndEditors.allEditors();return i?I:I.map(a=>a.value)}async showTextDocument(i,I,a){let p;typeof I=="number"?p={position:T.ViewColumn.from(I),preserveFocus:a}:typeof I=="object"?p={position:T.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?T.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:p={preserveFocus:!1};const h=await this._proxy.$tryShowTextDocument(i.uri,p),w=h&&this._extHostDocumentsAndEditors.getEditor(h);if(w)return w.value;throw h?new Error(`Could NOT open editor for "${i.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.uri.toString()}".`)}createTextEditorDecorationType(i,I){return new S.TextEditorDecorationType(this._proxy,i,I).value}$acceptEditorPropertiesChanged(i,I){const a=this._extHostDocumentsAndEditors.getEditor(i);if(!a)throw new Error("unknown text editor");if(I.options&&a._acceptOptions(I.options),I.selections){const p=I.selections.selections.map(T.Selection.to);a._acceptSelections(p)}if(I.visibleRanges){const p=L.coalesce(I.visibleRanges.map(T.Range.to));a._acceptVisibleRanges(p)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:a.value,options:{...I.options,lineNumbers:T.TextEditorLineNumbersStyle.to(I.options.lineNumbers)}}),I.selections){const p=C.TextEditorSelectionChangeKind.fromValue(I.selections.source),h=I.selections.selections.map(T.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:a.value,selections:h,kind:p})}if(I.visibleRanges){const p=L.coalesce(I.visibleRanges.map(T.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:a.value,visibleRanges:p})}}$acceptEditorPositionData(i){for(const I in i){const a=this._extHostDocumentsAndEditors.getEditor(I);if(!a)throw new Error("Unknown text editor");const p=T.ViewColumn.to(i[I]);a.value.viewColumn!==p&&(a._acceptViewColumn(p),this._onDidChangeTextEditorViewColumn.fire({textEditor:a.value,viewColumn:p}))}}getDiffInformation(i){return Promise.resolve(this._proxy.$getDiffInformation(i))}}e.ExtHostEditors=E}),define(fe[256],me([0,1,2,4,5,6,7]),function(Y,e,g,L,D,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,L.createDecorator)("IExtHostTimeline");class C{constructor(i,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=i.getProxy(D.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:a=>{if(a&&a.$mid===11){const p=a.uri===void 0?void 0:g.URI.revive(a.uri);return this._itemsBySourceAndUriMap.get(a.source)?.get(E(p))?.get(a.handle)}return a}})}async $getTimeline(i,I,a,p,h){return this._providers.get(i)?.provideTimeline(g.URI.revive(I),a,p,h)}registerTimelineProvider(i,I,a,p){const h=new S.DisposableStore,w=this.convertTimelineItem(I.id,p,h).bind(this);let y;I.onDidChange&&(y=I.onDidChange(b=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...b,id:I.id}),this));const P=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...I,scheme:i,onDidChange:void 0,async provideTimeline(b,o,s,v){v?.resetCache&&(h.clear(),P.get(I.id)?.clear());const n=await I.provideTimeline(b,o,s);if(n==null)return;const f=w(b,v);return{...n,source:I.id,items:n.items.map(f)}},dispose(){for(const b of P.values())b.get(I.id)?.clear();y?.dispose(),h.dispose()}})}convertTimelineItem(i,I,a){return(p,h)=>{let w;if(h?.cacheResults){let y=this._itemsBySourceAndUriMap.get(i);y===void 0&&(y=new Map,this._itemsBySourceAndUriMap.set(i,y));const P=E(p);w=y.get(P),w===void 0&&(w=new Map,y.set(P,w))}return y=>{const{iconPath:P,...b}=y,o=`${i}|${y.id??y.timestamp}`;w?.set(o,y);let s,v,n;return y.iconPath&&(P instanceof T.ThemeIcon?n={id:P.id,color:P.color}:g.URI.isUri(P)?(s=P,v=P):{light:s,dark:v}=P),{...b,id:b.id??void 0,handle:o,source:i,command:y.command?I.toInternal(y.command,a):void 0,icon:s,iconDark:v,themeIcon:n,accessibilityInformation:y.accessibilityInformation}}}}registerTimelineProviderCore(i){if(this._providers.get(i.id))throw new Error(`Timeline Provider ${i.id} already exists.`);return this._proxy.$registerTimelineProvider({id:i.id,label:i.label,scheme:i.scheme}),this._providers.set(i.id,i),(0,S.toDisposable)(()=>{for(const a of this._itemsBySourceAndUriMap.values())a.get(i.id)?.clear();this._providers.delete(i.id),this._proxy.$unregisterTimelineProvider(i.id),i.dispose()})}}e.ExtHostTimeline=C;function E(k){return k?.toString()}}),define(fe[257],me([0,1,6,10,2,5]),function(Y,e,g,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class T{constructor(E){this._openers=new Map,this._proxy=E.getProxy(S.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(E,k,i,I){if(this._openers.has(k))throw new Error(`Opener with id '${k}' already registered`);const a=I.schemes.find(p=>!T.supportedSchemes.has(p));if(a)throw new Error(`Scheme '${a}' is not supported. Only http and https are currently supported.`);return this._openers.set(k,i),this._proxy.$registerUriOpener(k,I.schemes,E,I.label),(0,g.toDisposable)(()=>{this._openers.delete(k),this._proxy.$unregisterUriOpener(k)})}async $canOpenUri(E,k,i){const I=this._openers.get(E);if(!I)throw new Error(`Unknown opener with id: ${E}`);const a=D.URI.revive(k);return I.canOpenExternalUri(a,i)}async $openUri(E,k,i){const I=this._openers.get(E);if(!I)throw new Error(`Unknown opener id: '${E}'`);return I.openExternalUri(D.URI.revive(k.resolvedUri),{sourceUri:D.URI.revive(k.sourceUri)},i)}}e.ExtHostUriOpeners=T,T.supportedSchemes=new Set([L.Schemas.http,L.Schemas.https])}),define(fe[258],me([0,1,5,2,6,18,27]),function(Y,e,g,L,D,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class C{constructor(k){this.handles=new Set,this.handlers=new Map,this._proxy=k.getProxy(g.MainContext.MainThreadUrls)}registerUriHandler(k,i){if(this.handles.has(T.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const I=C.HandlePool++;return this.handles.add(T.ExtensionIdentifier.toKey(k)),this.handlers.set(I,i),this._proxy.$registerUriHandler(I,k),(0,D.toDisposable)(()=>{this.handles.delete(T.ExtensionIdentifier.toKey(k)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(k,i){const I=this.handlers.get(k);if(!I)return Promise.resolve(void 0);try{I.handleUri(L.URI.revive(i))}catch(a){(0,S.onUnexpectedError)(a)}return Promise.resolve(void 0)}async createAppUri(k){return L.URI.revive(await this._proxy.$createAppUri(k))}}e.ExtHostUrls=C,C.HandlePool=0});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,g):D?D.value=g:e.set(Y,g),g},Oe=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[71],me([0,1,3,10,2,181,207,89,5]),function(Y,e,g,L,D,S,T,C,E){"use strict";var k,i,I,a,p,h,w,y,P,b,o,s;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class v{constructor(m,d,_,A,R,B,U){k.set(this,void 0),i.set(this,void 0),I.set(this,void 0),a.set(this,void 0),p.set(this,void 0),h.set(this,void 0),w.set(this,""),y.set(this,void 0),P.set(this,!1),b.set(this,!1),o.set(this,!1),this._onMessageEmitter=new g.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,s.set(this,new g.Emitter),this._onDidDispose=Oe(this,s,"f").event,st(this,k,m,"f"),st(this,i,d,"f"),st(this,y,_,"f"),st(this,a,A,"f"),st(this,p,R,"f"),st(this,h,B,"f"),st(this,o,n(B),"f"),st(this,I,U,"f")}dispose(){st(this,P,!0,"f"),Oe(this,s,"f").fire(),Oe(this,s,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(m){return st(this,b,!0,"f"),(0,C.asWebviewUri)(m,Oe(this,a,"f").remote)}get cspSource(){const m=Oe(this,h,"f").extensionLocation;if(m.scheme===L.Schemas.https||m.scheme===L.Schemas.http){let d=m.toString();return d.endsWith("/")||(d+="/"),d+" "+C.webviewGenericCspSource}return C.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Oe(this,w,"f")}set html(m){this.assertNotDisposed(),Oe(this,w,"f")!==m&&(st(this,w,m,"f"),!Oe(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(m)&&(st(this,b,!0,"f"),Oe(this,I,"f").report("Webview vscode-resource: uris",Oe(this,h,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Oe(this,i,"f").$setHtml(Oe(this,k,"f"),m))}get options(){return this.assertNotDisposed(),Oe(this,y,"f")}set options(m){this.assertNotDisposed(),Oe(this,i,"f").$setOptions(Oe(this,k,"f"),t(Oe(this,h,"f"),Oe(this,p,"f"),m)),st(this,y,m,"f")}async postMessage(m){if(Oe(this,P,"f"))return!1;const d=(0,T.serializeWebviewMessage)(m,{serializeBuffersForPostMessage:Oe(this,o,"f")});return Oe(this,i,"f").$postMessage(Oe(this,k,"f"),d.message,...d.buffers)}assertNotDisposed(){if(Oe(this,P,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=v,k=new WeakMap,i=new WeakMap,I=new WeakMap,a=new WeakMap,p=new WeakMap,h=new WeakMap,w=new WeakMap,y=new WeakMap,P=new WeakMap,b=new WeakMap,o=new WeakMap,s=new WeakMap;function n(c){try{const m=(0,S.normalizeVersion)((0,S.parseVersion)(c.engines.vscode));return!!m&&m.majorBase>=1&&m.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=n;class f{constructor(m,d,_,A,R){this.initData=d,this.workspace=_,this._logService=A,this._deprecationService=R,this._webviews=new Map,this._webviewProxy=m.getProxy(E.MainContext.MainThreadWebviews)}$onMessage(m,d,..._){const A=this.getWebview(m);if(A){const{message:R}=(0,T.deserializeWebviewMessage)(d,_);A._onMessageEmitter.fire(R)}}$onMissingCsp(m,d){this._logService.warn(`${d} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(m,d,_){const A=new v(m,this._webviewProxy,u(d),this.initData,this.workspace,_,this._deprecationService);return this._webviews.set(m,A),A._onDidDispose(()=>{this._webviews.delete(m)}),A}deleteWebview(m){this._webviews.delete(m)}getWebview(m){return this._webviews.get(m)}}e.ExtHostWebviews=f;function r(c){return{id:c.identifier,location:c.extensionLocation}}e.toExtensionData=r;function t(c,m,d){return{enableCommandUris:d.enableCommandUris,enableScripts:d.enableScripts,enableForms:d.enableForms,portMapping:d.portMapping,localResourceRoots:d.localResourceRoots||l(c,m)}}e.serializeWebviewOptions=t;function u(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(m=>D.URI.from(m))}}e.reviveOptions=u;function l(c,m){return[...(m?.getWorkspaceFolders()||[]).map(d=>d.uri),c.extensionLocation]}}),define(fe[259],me([0,1,21,49,6,10,23,2,17,71,88,5,7]),function(Y,e,g,L,D,S,T,C,E,k,i,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class p{constructor(n,f){this.document=n,this._storagePath=f,this._backupCounter=1,this._edits=new i.Cache("custom documents")}addEdit(n){return this._edits.add([n])}async undo(n,f){await this.getEdit(n).undo(),f||this.disposeBackup()}async redo(n,f){await this.getEdit(n).redo(),f||this.disposeBackup()}disposeEdits(n){for(const f of n)this._edits.delete(f)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const n=s(this.document.uri)+this._backupCounter++;return(0,T.joinPath)(this._storagePath,n)}updateBackup(n){this._backup?.delete(),this._backup=n}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(n){const f=this._edits.get(n,0);if(!f)throw new Error("No edit found");return f}}class h{constructor(){this._documents=new Map}get(n,f){return this._documents.get(this.key(n,f))}add(n,f,r){const t=this.key(n,f.uri);if(this._documents.has(t))throw new Error(`Document already exists for viewType:${n} resource:${f.uri}`);const u=new p(f,r);return this._documents.set(t,u),u}delete(n,f){const r=this.key(n,f.uri);this._documents.delete(r)}key(n,f){return`${n}@@@${f}`}}var w;(function(v){v[v.Text=0]="Text",v[v.Custom=1]="Custom"})(w||(w={}));class y{constructor(){this._providers=new Map}addTextProvider(n,f,r){return this.add(0,n,f,r)}addCustomProvider(n,f,r){return this.add(1,n,f,r)}get(n){return this._providers.get(n)}add(n,f,r,t){if(this._providers.has(f))throw new Error(`Provider for viewType:${f} already registered`);return this._providers.set(f,{type:n,extension:r,provider:t}),new a.Disposable(()=>this._providers.delete(f))}}class P{constructor(n,f,r,t,u){this._extHostDocuments=f,this._extensionStoragePaths=r,this._extHostWebview=t,this._extHostWebviewPanels=u,this._editorProviders=new y,this._documents=new h,this._proxy=n.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(n,f,r,t){const u=new D.DisposableStore;return b(r)?(u.add(this._editorProviders.addTextProvider(f,n,r)),this._proxy.$registerTextEditorProvider((0,k.toExtensionData)(n),f,t.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(n))):(u.add(this._editorProviders.addCustomProvider(f,n,r)),this.supportEditing(r)&&u.add(r.onDidChangeCustomDocument(l=>{const c=this.getCustomDocumentEntry(f,l.document.uri);if(o(l)){const m=c.addEdit(l);this._proxy.$onDidEdit(l.document.uri,f,m,l.label)}else this._proxy.$onContentChange(l.document.uri,f)})),this._proxy.$registerCustomEditorProvider((0,k.toExtensionData)(n),f,t.webviewOptions||{},!!t.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(n))),a.Disposable.from(u,new a.Disposable(()=>{this._proxy.$unregisterEditorProvider(f)}))}async $createCustomDocument(n,f,r,t,u){const l=this._editorProviders.get(f);if(!l)throw new Error(`No provider found for '${f}'`);if(l.type!==1)throw new Error(`Invalid provide type for '${f}'`);const c=C.URI.revive(n),m=await l.provider.openCustomDocument(c,{backupId:r,untitledDocumentData:t?.buffer},u);let d;return this.supportEditing(l.provider)&&this._extensionStoragePaths&&(d=this._extensionStoragePaths.workspaceValue(l.extension)??this._extensionStoragePaths.globalValue(l.extension)),this._documents.add(f,m,d),{editable:this.supportEditing(l.provider)}}async $disposeCustomDocument(n,f){const r=this._editorProviders.get(f);if(!r)throw new Error(`No provider found for '${f}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${f}'`);const t=C.URI.revive(n),{document:u}=this.getCustomDocumentEntry(f,t);this._documents.delete(f,u),u.dispose()}async $resolveWebviewEditor(n,f,r,t,u,l){const c=this._editorProviders.get(r);if(!c)throw new Error(`No provider found for '${r}'`);const m=E.ViewColumn.to(u),d=this._extHostWebview.createNewWebview(f,t.webviewOptions,c.extension),_=this._extHostWebviewPanels.createNewWebviewPanel(f,r,t.title,m,t.panelOptions,d),A=C.URI.revive(n);switch(c.type){case 1:{const{document:R}=this.getCustomDocumentEntry(r,A);return c.provider.resolveCustomEditor(R,_,l)}case 0:{const R=this._extHostDocuments.getDocument(A);return c.provider.resolveCustomTextEditor(R,_,l)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(n,f,r){this.getCustomDocumentEntry(f,n).disposeEdits(r)}async $onMoveCustomEditor(n,f,r){const t=this._editorProviders.get(r);if(!t)throw new Error(`No provider found for '${r}'`);if(!t.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const u=this._extHostWebviewPanels.getWebviewPanel(n);if(!u)throw new Error("No webview found");const l=C.URI.revive(f),c=this._extHostDocuments.getDocument(l);await t.provider.moveCustomTextEditor(c,u,g.CancellationToken.None)}async $undo(n,f,r,t){return this.getCustomDocumentEntry(f,n).undo(r,t)}async $redo(n,f,r,t){return this.getCustomDocumentEntry(f,n).redo(r,t)}async $revert(n,f,r){const t=this.getCustomDocumentEntry(f,n);await this.getCustomEditorProvider(f).revertCustomDocument(t.document,r),t.disposeBackup()}async $onSave(n,f,r){const t=this.getCustomDocumentEntry(f,n);await this.getCustomEditorProvider(f).saveCustomDocument(t.document,r),t.disposeBackup()}async $onSaveAs(n,f,r,t){const u=this.getCustomDocumentEntry(f,n);return this.getCustomEditorProvider(f).saveCustomDocumentAs(u.document,C.URI.revive(r),t)}async $backup(n,f,r){const t=this.getCustomDocumentEntry(f,n),l=await this.getCustomEditorProvider(f).backupCustomDocument(t.document,{destination:t.getNewBackupUri()},r);return t.updateBackup(l),l.id}getCustomDocumentEntry(n,f){const r=this._documents.get(n,C.URI.revive(f));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(n){const r=this._editorProviders.get(n)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(n){return!!n.onDidChangeCustomDocument}}e.ExtHostCustomEditors=P;function b(v){return typeof v.resolveCustomTextEditor=="function"}function o(v){return typeof v.undo=="function"&&typeof v.redo=="function"}function s(v){const n=v.scheme===S.Schemas.file||v.scheme===S.Schemas.untitled?v.fsPath:v.toString();return(0,L.hash)(n)+""}});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,g):D?D.value=g:e.set(Y,g),g},Oe=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[260],me([0,1,3,6,2,31,17,71,5,7]),function(Y,e,g,L,D,S,T,C,E,k){"use strict";var i,I,a,p,h,w,y,P,b,o,s,v,n;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class f extends L.Disposable{constructor(l,c,m,d,_,A,R){super();i.set(this,void 0),I.set(this,void 0),a.set(this,void 0),p.set(this,void 0),h.set(this,void 0),w.set(this,void 0),y.set(this,void 0),P.set(this,void 0),b.set(this,!0),o.set(this,!0),s.set(this,!1),v.set(this,this._register(new g.Emitter)),this.onDidDispose=Oe(this,v,"f").event,n.set(this,this._register(new g.Emitter)),this.onDidChangeViewState=Oe(this,n,"f").event,st(this,i,l,"f"),st(this,I,c,"f"),st(this,a,m,"f"),st(this,h,A,"f"),st(this,P,_,"f"),st(this,w,d,"f"),st(this,p,R,"f")}dispose(){Oe(this,s,"f")||(st(this,s,!0,"f"),Oe(this,v,"f").fire(),Oe(this,I,"f").$disposeWebview(Oe(this,i,"f")),Oe(this,p,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Oe(this,p,"f")}get viewType(){return this.assertNotDisposed(),Oe(this,a,"f")}get title(){return this.assertNotDisposed(),Oe(this,w,"f")}set title(l){this.assertNotDisposed(),Oe(this,w,"f")!==l&&(st(this,w,l,"f"),Oe(this,I,"f").$setTitle(Oe(this,i,"f"),l))}get iconPath(){return this.assertNotDisposed(),Oe(this,y,"f")}set iconPath(l){this.assertNotDisposed(),Oe(this,y,"f")!==l&&(st(this,y,l,"f"),Oe(this,I,"f").$setIconPath(Oe(this,i,"f"),D.URI.isUri(l)?{light:l,dark:l}:l))}get options(){return Oe(this,h,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Oe(this,P,"f")=="number"&&Oe(this,P,"f")<0))return Oe(this,P,"f")}get active(){return this.assertNotDisposed(),Oe(this,o,"f")}get visible(){return this.assertNotDisposed(),Oe(this,b,"f")}_updateViewState(l){Oe(this,s,"f")||(this.active!==l.active||this.visible!==l.visible||this.viewColumn!==l.viewColumn)&&(st(this,o,l.active,"f"),st(this,b,l.visible,"f"),st(this,P,l.viewColumn,"f"),Oe(this,n,"f").fire({webviewPanel:this}))}reveal(l,c){this.assertNotDisposed(),Oe(this,I,"f").$reveal(Oe(this,i,"f"),{viewColumn:l?T.ViewColumn.from(l):void 0,preserveFocus:!!c})}assertNotDisposed(){if(Oe(this,s,"f"))throw new Error("Webview is disposed")}}i=new WeakMap,I=new WeakMap,a=new WeakMap,p=new WeakMap,h=new WeakMap,w=new WeakMap,y=new WeakMap,P=new WeakMap,b=new WeakMap,o=new WeakMap,s=new WeakMap,v=new WeakMap,n=new WeakMap;class r{constructor(l,c,m){this.webviews=c,this.workspace=m,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=l.getProxy(E.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,S.generateUuid)()}createWebviewPanel(l,c,m,d,_={}){const A=typeof d=="object"?d.viewColumn:d,R={viewColumn:T.ViewColumn.from(A),preserveFocus:typeof d=="object"&&!!d.preserveFocus},B=(0,C.shouldSerializeBuffersForPostMessage)(l),U=r.newHandle();this._proxy.$createWebviewPanel((0,C.toExtensionData)(l),U,c,{title:m,panelOptions:t(_),webviewOptions:(0,C.serializeWebviewOptions)(l,this.workspace,_),serializeBuffersForPostMessage:B},R);const F=this.webviews.createNewWebview(U,_,l);return this.createNewWebviewPanel(U,c,m,A,_,F)}$onDidChangeWebviewPanelViewStates(l){const c=Object.keys(l);c.sort((m,d)=>{const _=l[m],A=l[d];return _.active?1:A.active?-1:+_.visible-+A.visible});for(const m of c){const d=this.getWebviewPanel(m);if(!d)continue;const _=l[m];d._updateViewState({active:_.active,visible:_.visible,viewColumn:T.ViewColumn.to(_.position)})}}async $onDidDisposeWebviewPanel(l){this.getWebviewPanel(l)?.dispose(),this._webviewPanels.delete(l),this.webviews.deleteWebview(l)}registerWebviewPanelSerializer(l,c,m){if(this._serializers.has(c))throw new Error(`Serializer for '${c}' already registered`);return this._serializers.set(c,{serializer:m,extension:l}),this._proxy.$registerSerializer(c,{serializeBuffersForPostMessage:(0,C.shouldSerializeBuffersForPostMessage)(l)}),new k.Disposable(()=>{this._serializers.delete(c),this._proxy.$unregisterSerializer(c)})}async $deserializeWebviewPanel(l,c,m,d){const _=this._serializers.get(c);if(!_)throw new Error(`No serializer found for '${c}'`);const{serializer:A,extension:R}=_,B=this.webviews.createNewWebview(l,m.webviewOptions,R),U=this.createNewWebviewPanel(l,c,m.title,d,m.panelOptions,B);await A.deserializeWebviewPanel(U,m.state)}createNewWebviewPanel(l,c,m,d,_,A){const R=new f(l,this._proxy,c,m,d,_,A);return this._webviewPanels.set(l,R),R}getWebviewPanel(l){return this._webviewPanels.get(l)}}e.ExtHostWebviewPanels=r;function t(u){return{enableFindWidget:u.enableFindWidget,retainContextWhenHidden:u.retainContextWhenHidden}}});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,g):D?D.value=g:e.set(Y,g),g},Oe=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[261],me([0,1,3,6,71,5,7]),function(Y,e,g,L,D,S,T){"use strict";var C,E,k,i,I,a,p,h,w,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class P extends L.Disposable{constructor(s,v,n,f,r,t){super();C.set(this,void 0),E.set(this,void 0),k.set(this,void 0),i.set(this,void 0),I.set(this,!1),a.set(this,void 0),p.set(this,void 0),h.set(this,void 0),w.set(this,this._register(new g.Emitter)),this.onDidChangeVisibility=Oe(this,w,"f").event,y.set(this,this._register(new g.Emitter)),this.onDidDispose=Oe(this,y,"f").event,st(this,k,n,"f"),st(this,p,f,"f"),st(this,C,s,"f"),st(this,E,v,"f"),st(this,i,r,"f"),st(this,a,t,"f")}dispose(){Oe(this,I,"f")||(st(this,I,!0,"f"),Oe(this,y,"f").fire(),Oe(this,i,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Oe(this,p,"f")}set title(s){this.assertNotDisposed(),Oe(this,p,"f")!==s&&(st(this,p,s,"f"),Oe(this,E,"f").$setWebviewViewTitle(Oe(this,C,"f"),s))}get description(){return this.assertNotDisposed(),Oe(this,h,"f")}set description(s){this.assertNotDisposed(),Oe(this,h,"f")!==s&&(st(this,h,s,"f"),Oe(this,E,"f").$setWebviewViewDescription(Oe(this,C,"f"),s))}get visible(){return Oe(this,a,"f")}get webview(){return Oe(this,i,"f")}get viewType(){return Oe(this,k,"f")}_setVisible(s){s===Oe(this,a,"f")||Oe(this,I,"f")||(st(this,a,s,"f"),Oe(this,w,"f").fire())}show(s){this.assertNotDisposed(),Oe(this,E,"f").$show(Oe(this,C,"f"),!!s)}assertNotDisposed(){if(Oe(this,I,"f"))throw new Error("Webview is disposed")}}C=new WeakMap,E=new WeakMap,k=new WeakMap,i=new WeakMap,I=new WeakMap,a=new WeakMap,p=new WeakMap,h=new WeakMap,w=new WeakMap,y=new WeakMap;class b{constructor(s,v){this._extHostWebview=v,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=s.getProxy(S.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(s,v,n,f){if(this._viewProviders.has(v))throw new Error(`View provider for '${v}' already registered`);return this._viewProviders.set(v,{provider:n,extension:s}),this._proxy.$registerWebviewViewProvider((0,D.toExtensionData)(s),v,{retainContextWhenHidden:f?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new T.Disposable(()=>{this._viewProviders.delete(v),this._proxy.$unregisterWebviewViewProvider(v)})}async $resolveWebviewView(s,v,n,f,r){const t=this._viewProviders.get(v);if(!t)throw new Error(`No view provider found for '${v}'`);const{provider:u,extension:l}=t,c=this._extHostWebview.createNewWebview(s,{},l),m=new P(s,this._proxy,v,n,c,!0);this._webviewViews.set(s,m),await u.resolveWebviewView(m,{state:f},r)}async $onDidChangeWebviewViewVisibility(s,v){this.getWebviewView(s)._setVisible(v)}async $disposeWebviewView(s){const v=this.getWebviewView(s);this._webviewViews.delete(s),v.dispose(),this._extHostWebview.deleteWebview(s)}getWebviewView(s){const v=this._webviewViews.get(s);if(!v)throw new Error("No webview found");return v}}e.ExtHostWebviewViews=b}),define(fe[134],me([0,1,3,5,2,10,8,4,14]),function(Y,e,g,L,D,S,T,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class $i{constructor(I){this._onDidChangeWindowState=new g.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=$i.InitialState,this._proxy=I.getProxy(L.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(a=>this.$onDidChangeWindowFocus(a))}get state(){return this._state}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state={...this._state,focused:I},this._onDidChangeWindowState.fire(this._state))}openUri(I,a){let p;if(typeof I=="string"){p=I;try{I=D.URI.parse(I)}catch(h){return Promise.reject(`Invalid uri - '${I}'`)}}return(0,T.isFalsyOrWhitespace)(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===S.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,p,a)}async asExternalUri(I,a){if((0,T.isFalsyOrWhitespace)(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");const p=await this._proxy.$asExternalUri(I,a);return D.URI.from(p)}};k.InitialState={focused:!0},k=Ve([$e(0,E.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,C.createDecorator)("IExtHostWindow")}),define(fe[262],me([0,1,9,82,31,40,6,5,2,14]),function(Y,e,g,L,D,S,T,C,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let i=class extends T.Disposable{constructor(a,p){super();const h=a.getProxy(C.MainContext.MainThreadDownloadService);p.registerCommand(!1,"_workbench.downloadResource",async w=>{const y=E.URI.file((0,g.join)((0,L.tmpdir)(),(0,D.generateUuid)()));return await h.$download(w,y),y})}};i=Ve([$e(0,k.IExtHostRpcService),$e(1,S.IExtHostCommands)],i),e.ExtHostDownloadService=i}),define(fe[263],me([0,1,132,10,190,31]),function(Y,e,g,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class T extends g.ExtHostLoggerService{doCreateLogger(E,k,i){if(E.scheme===L.Schemas.file){const I=new D.SpdLogLogger(i?.name||(0,S.generateUuid)(),E.fsPath,!i?.donotRotate,k);return i?.donotUseFormatters&&I.clearFormatters(),I}return super.doCreateLogger(E,k,i)}}e.ExtHostLoggerService=T}),define(fe[264],me([0,1,63,9,2,70,6,10,16,28]),function(Y,e,g,L,D,S,T,C,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class i extends S.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(n){const f=await super._getWorkspaceStorageURI(n);if(f.scheme!==C.Schemas.file)return f;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${f.fsPath}.`),f;const r=f.fsPath;let t=0;do{let u;t===0?u=r:u=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${t}`:`${r}-${t}`,await I(u);const l=L.join(u,"vscode.lock"),c=await w(this._logService,l,!1);if(c)return this._workspaceStorageLock=c,process.on("exit",()=>{c.dispose()}),D.URI.file(u);t++}while(t<10);return f}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=i;async function I(v){try{await k.Promises.stat(v);return}catch{}try{await k.Promises.mkdir(v,{recursive:!0})}catch{}}const a=1e3,p=10*60*1e3;class h extends T.Disposable{constructor(n,f){super();this.logService=n,this.filename=f,this._timer=this._register(new E.IntervalTimer),this._timer.cancelAndSet(async()=>{const r=await y(n,f);(!r||r.pid!==process.pid)&&(n.info(`Lock '${f}': The lock was lost unexpectedly.`),this._timer.cancel());try{await k.Promises.utimes(f,new Date,new Date)}catch(t){n.error(t),n.info(`Lock '${f}': Could not update mtime.`)}},a)}dispose(){super.dispose();try{g.unlinkSync(this.filename)}catch(n){}}async setWillRelease(n){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${n} ms.`);try{const f={pid:process.pid,willReleaseAt:Date.now()+n};await k.Promises.writeFile(this.filename,JSON.stringify(f),{flag:"w"})}catch(f){this.logService.error(f)}}}async function w(v,n,f){try{const t={pid:process.pid,willReleaseAt:0};await k.Promises.writeFile(n,JSON.stringify(t),{flag:"wx"})}catch(t){v.error(t)}const r=await y(v,n);return!r||r.pid!==process.pid?f?(v.info(`Lock '${n}': Could not acquire lock, giving up.`),null):(v.info(`Lock '${n}': Could not acquire lock, checking if the file is stale.`),o(v,n)):(v.info(`Lock '${n}': Lock acquired.`),new h(v,n))}async function y(v,n){let f;try{f=await k.Promises.readFile(n)}catch(r){return v.error(r),null}try{return JSON.parse(String(f))}catch(r){return v.error(r),null}}async function P(v,n){let f;try{f=await k.Promises.stat(n)}catch(r){return v.error(r),0}return f.mtime.getTime()}function b(v){try{return process.kill(v,0),!0}catch(n){return!1}}async function o(v,n){const f=await y(v,n);if(!f)return v.info(`Lock '${n}': Could not read pid of lock holder.`),s(v,n);if(f.willReleaseAt){let c=f.willReleaseAt-Date.now();if(c<5e3){for(c>0?v.info(`Lock '${n}': The lockfile is scheduled to be released in ${c} ms.`):v.info(`Lock '${n}': The lockfile is scheduled to have been released.`);c>0;){if(await(0,E.timeout)(Math.min(100,c)),await P(v,n)===0)return s(v,n);c=f.willReleaseAt-Date.now()}return s(v,n)}}if(!b(f.pid))return v.info(`Lock '${n}': The pid ${f.pid} appears to be gone.`),s(v,n);const r=await P(v,n),t=Date.now()-r;if(t<=p)return v.info(`Lock '${n}': The lock does not look stale, elapsed: ${t} ms, giving up.`),null;v.info(`Lock '${n}': The lock looks stale, waiting for 2s.`),await(0,E.timeout)(2e3);const u=await P(v,n),l=Date.now()-u;return l<=p?(v.info(`Lock '${n}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null):(v.info(`Lock '${n}': The lock looks stale even after waiting for 2s.`),s(v,n))}async function s(v,n){v.info(`Lock '${n}': Deleting a stale lock.`);try{await k.Promises.unlink(n)}catch(f){}return w(v,n,!0)}}),define(fe[265],me([0,1,31,14,33]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let S=class extends D.BaseExtHostTerminalService{constructor(C){super(!0,C)}createTerminal(C,E,k){return this.createTerminalFromOptions({name:C,shellPath:E,shellArgs:k})}createTerminalFromOptions(C,E){const k=new D.ExtHostTerminal(this._proxy,(0,g.generateUuid)(),C,C.name);return this._terminals.push(k),k.create(C,this._serializeParentTerminal(C,E)),k.value}};S=Ve([$e(0,L.IExtHostRpcService)],S),e.ExtHostTerminalService=S}),define(fe[266],me([0,1,5,14,172,6,26,2,39,23,28,7,12,54,3,121,79,11]),function(Y,e,g,L,D,S,T,C,E,k,i,I,a,p,h,w,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class b{constructor(m,d,_){this.remoteAddress=m,this.localAddress=d,this._dispose=_,this._onDispose=new h.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function o(c){const m=c.trim().split(`
`),d=[];return m.forEach(A=>{const R=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(A);R&&R.length>=3&&d.push({pid:parseInt(R[1],10),socket:parseInt(R[2],10)})}),d.reduce((A,R)=>(A[R.socket]=R,A),{})}e.getSockets=o;function s(...c){const m=[].concat(...c.map(n));return[...new Map(m.filter(d=>d.st==="0A").map(d=>{const _=d.local_address.split(":");return{socket:parseInt(d.inode,10),ip:v(_[0]),port:parseInt(_[1],16)}}).map(d=>[d.ip+":"+d.port,d])).values()]}e.loadListeningPorts=s;function v(c){let m="";if(c.length===8)for(let d=c.length-2;d>=0;d-=2)m+=parseInt(c.substr(d,2),16),d!==0&&(m+=".");else for(let d=c.length-4;d>=0;d-=4)m+=parseInt(c.substr(d,4),16).toString(16),d!==0&&(m+=":");return m}e.parseIpAddress=v;function n(c){const m=c.trim().split(`
`),d=m.shift().trim().split(/\s+/).filter(A=>A!=="rx_queue"&&A!=="tm->when");return m.map(A=>A.trim().split(/\s+/).reduce((R,B,U)=>(R[d[U]||U]=B,R),{}))}e.loadConnectionTable=n;function f(c){return!!c.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||c.indexOf("out/vs/server/main.js")!==-1||c.indexOf("_productName=VSCode")!==-1}function r(c){const m=c.trim().split(`
`),d=[];return m.forEach(_=>{const A=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(_);A&&A.length>=4&&d.push({pid:parseInt(A[1],10),ppid:parseInt(A[2]),cmd:A[3]})}),d}e.getRootProcesses=r;async function t(c,m,d){const _=d.reduce((R,B)=>(R[B.pid]=B,R),{}),A=[];return c.forEach(({socket:R,ip:B,port:U})=>{const F=m[R]?m[R].pid:void 0,$=F?_[F]?.cmd:void 0;F&&$&&!f($)&&A.push({host:B,port:U,detail:$,pid:F})}),A}e.findPorts=t;function u(c,m,d){const _=new Map,A=r(m);for(const R of c){const B=d.get(R.port);if(B){_.set(R.port,B);continue}const U=A.find(F=>F.cmd.includes(`${R.port}`));if(U){let F=U,$;do $=A.find(M=>M.ppid===F.pid),$&&(F=$);while($);_.set(R.port,{host:R.ip,port:R.port,pid:F.pid,detail:F.cmd,ppid:F.ppid})}else _.set(R.port,{host:R.ip,port:R.port,ppid:Number.MAX_VALUE})}return _}e.tryFindRootPorts=u;let l=class extends S.Disposable{constructor(m,d,_){super();this.logService=_,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new h.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=m.getProxy(g.MainContext.MainThreadTunnelService),a.isLinux&&d.remote.isRemote&&d.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(m,d){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${m.identifier.value} called openTunnel API for ${d.remoteAddress.host}:${d.remoteAddress.port}.`);const _=await this._proxy.$openTunnel(d,m.displayName);if(_){const A=new b(_.remoteAddress,_.localAddress,()=>this._proxy.$closeTunnel(_.remoteAddress));return this._register(A),A}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(m){return Math.max(m*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(m,d){const _=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(_,{selector:m,provider:d}),this._proxy.$registerPortsAttributesProvider(m,_),new I.Disposable(()=>{this._portAttributesProviders.delete(_),this._proxy.$unregisterPortsAttributesProvider(_)})}async $providePortAttributes(m,d,_,A,R){const B=[];for(const F of m){const $=this._portAttributesProviders.get(F);if(!$)return[];B.push(...await Promise.all(d.map(async M=>$.provider.providePortAttributes(M,_,A,R))))}const U=B.filter(F=>!!F);return U.length>0?U.map(F=>({autoForwardAction:F.autoForwardAction,port:F.port})):[]}async $registerCandidateFinder(m){if(m&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=m;let d=new y.MovingAverage,_;for(;this._candidateFindingEnabled;){const A=new Date().getTime(),R=(await this.findCandidatePorts()).filter(U=>(0,w.isLocalhost)(U.host)||(0,w.isAllInterfaces)(U.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${R.map(U=>U.port).join(", ")}`);const B=new Date().getTime()-A;d.update(B),(!_||JSON.stringify(_)!==JSON.stringify(R))&&(_=R,await this._proxy.$onFoundNewCandidates(_)),await new Promise(U=>setTimeout(()=>U(),this.calculateDelay(d.value)))}}async setTunnelExtensionFunctions(m){if(m){if(m.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(m.candidatePortSource),m.showCandidatePort&&(this._showCandidatePort=m.showCandidatePort,this._proxy.$setCandidateFilter()),m.tunnelFactory){this._forwardPortProvider=m.tunnelFactory;let d=m.tunnelFeatures?.privacyOptions??[];m.tunnelFeatures?.public&&d.length===0&&(d=[{id:"private",label:D.localize(0,null),themeIcon:"lock"},{id:"public",label:D.localize(1,null),themeIcon:"eye"}]),this._proxy.$setTunnelProvider({elevation:!!m.tunnelFeatures?.elevation,public:!!m.tunnelFeatures?.public,privacyOptions:d})}}else this._forwardPortProvider=void 0;return(0,S.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(m,d){if(this._extensionTunnels.has(m.host)){const _=this._extensionTunnels.get(m.host);_.has(m.port)&&(d&&_.get(m.port).disposeListener.dispose(),await _.get(m.port).tunnel.dispose(),_.delete(m.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(m,d){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const _=this._forwardPortProvider(m,d);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),_!==void 0){const A=await _;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(m.remoteAddress.host)||this._extensionTunnels.set(m.remoteAddress.host,new Map);const R=this._register(A.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(A.remoteAddress))));return this._extensionTunnels.get(m.remoteAddress.host).set(m.remoteAddress.port,{tunnel:A,disposeListener:R}),p.TunnelDto.fromApiTunnel(A)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(_){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(m){const d=await Promise.all(m.map(A=>this._showCandidatePort(A.host,A.port,A.detail??""))),_=m.filter((A,R)=>d[R]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${m.map(A=>A.port).join(", ")} to ${_.map(A=>A.port).join(", ")}`),_}async findCandidatePorts(){let m="",d="";try{m=await i.Promises.readFile("/proc/net/tcp","utf8"),d=await i.Promises.readFile("/proc/net/tcp6","utf8")}catch(N){}const _=s(m,d),A=await new Promise(N=>{(0,E.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(x,j,O)=>{N(j)})}),R=o(A),B=await i.Promises.readdir("/proc"),U=[];for(let N of B)try{const x=Number(N),j=k.joinPath(C.URI.file("/proc"),N);if((await i.Promises.stat(j.fsPath)).isDirectory()&&!isNaN(x)){const H=await i.Promises.readlink(k.joinPath(j,"cwd").fsPath),W=await i.Promises.readFile(k.joinPath(j,"cmdline").fsPath,"utf8");U.push({pid:x,cwd:H,cmd:W})}}catch(x){}const F=[],$=_.filter(N=>{const x=R[N.socket];return x||F.push(N),x}),M=t($,R,U);let z;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${F.length}`),F.length>0){const N=await new Promise(x=>{(0,E.exec)("ps -F -A -l | grep root",(j,O,H)=>{x(O)})});this._foundRootPorts=u(F,N,this._foundRootPorts),z=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${z.join(", ")}`)}return M.then(N=>z?N.concat(z):N)}};l=Ve([$e(0,L.IExtHostRpcService),$e(1,T.IExtHostInitDataService),$e(2,P.ILogService)],l),e.ExtHostTunnelService=l}),define(fe[267],me([0,1,16,22,21,18,3,6,103,231,55]),function(Y,e,g,L,D,S,T,C,E,k,i){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function a(_,A){try{return JSON.stringify(_,A)}catch(R){return"null"}}const p="$$ref$$",h={[p]:-1};class w{constructor(A,R){this.jsonString=A,this.referencedBuffers=R}}function y(_,A=null,R=!1){const B=[];return{jsonString:(R?a:JSON.stringify)(_,(F,$)=>{if(typeof $=="undefined")return h;if(typeof $=="object"){if($ instanceof L.VSBuffer){const M=B.push($)-1;return{[p]:M}}if(A)return A(F,$)}return $}),referencedBuffers:B}}e.stringifyJsonWithBufferRefs=y;function P(_,A,R){return JSON.parse(_,(B,U)=>{if(U){const F=U[p];if(typeof F=="number")return A[F];if(R&&U.$mid===1)return R.transformIncoming(U)}return U})}e.parseJsonAndRestoreBufferRefs=P;function b(_,A){return JSON.stringify(_,A)}function o(_){return _?(A,R)=>R&&R.$mid===1?_.transformOutgoing(R):R:null}var s;(function(_){_[_.LocalSide=0]="LocalSide",_[_.OtherSide=1]="OtherSide"})(s=e.RequestInitiator||(e.RequestInitiator={}));var v;(function(_){_[_.Responsive=0]="Responsive",_[_.Unresponsive=1]="Unresponsive"})(v=e.ResponsiveState||(e.ResponsiveState={}));const n=()=>{},f=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class t extends C.Disposable{constructor(A,R=null,B=null){super();this[I]=!0,this._onDidChangeResponsiveState=this._register(new T.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=A,this._logger=R,this._uriTransformer=B,this._uriReplacer=o(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let U=0,F=i.ProxyIdentifier.count;U<F;U++)this._locals[U]=null,this._proxies[U]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new g.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(U=>this._receiveOneMessage(U))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(A=>{this._pendingRPCReplies[A].resolveErr(S.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(A){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(A){this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(A){this._responsiveState!==A&&(this._responsiveState=A,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(A){return this._uriTransformer?(0,E.transformIncomingURIs)(A,this._uriTransformer):A}getProxy(A){const{nid:R,sid:B}=A;return this._proxies[R]||(this._proxies[R]=this._createProxy(R,B)),this._proxies[R]}_createProxy(A,R){let B={get:(U,F)=>(typeof F=="string"&&!U[F]&&F.charCodeAt(0)===36&&(U[F]=(...$)=>this._remoteCall(A,F,$)),F===r?R:U[F])};return new Proxy(Object.create(null),B)}set(A,R){return this._locals[A.nid]=R,R}assertRegistered(A){for(let R=0,B=A.length;R<B;R++){const U=A[R];if(!this._locals[U.nid])throw new Error(`Missing actor ${U.sid} (isMain: ${U.isMain})`)}}_receiveOneMessage(A){if(this._isDisposed)return;const R=A.byteLength,B=u.read(A,0),U=B.readUInt8(),F=B.readUInt32();switch(U){case 1:case 2:{let{rpcId:$,method:M,args:z}=c.deserializeRequestJSONArgs(B);this._uriTransformer&&(z=(0,E.transformIncomingURIs)(z,this._uriTransformer)),this._receiveRequest(R,F,$,M,z,U===2);break}case 3:case 4:{let{rpcId:$,method:M,args:z}=c.deserializeRequestMixedArgs(B);this._uriTransformer&&(z=(0,E.transformIncomingURIs)(z,this._uriTransformer)),this._receiveRequest(R,F,$,M,z,U===4);break}case 5:{this._logger&&this._logger.logIncoming(R,F,0,"ack"),this._onDidReceiveAcknowledge(F);break}case 6:{this._receiveCancel(R,F);break}case 7:{this._receiveReply(R,F,void 0);break}case 9:{let $=c.deserializeReplyOKJSON(B);this._uriTransformer&&($=(0,E.transformIncomingURIs)($,this._uriTransformer)),this._receiveReply(R,F,$);break}case 10:{const $=c.deserializeReplyOKJSONWithBuffers(B,this._uriTransformer);this._receiveReply(R,F,$);break}case 8:{let $=c.deserializeReplyOKVSBuffer(B);this._receiveReply(R,F,$);break}case 11:{let $=c.deserializeReplyErrError(B);this._uriTransformer&&($=(0,E.transformIncomingURIs)($,this._uriTransformer)),this._receiveReplyErr(R,F,$);break}case 12:{this._receiveReplyErr(R,F,void 0);break}default:console.error("received unexpected message"),console.error(A)}}_receiveRequest(A,R,B,U,F,$){this._logger&&this._logger.logIncoming(A,R,1,`receiveRequest ${(0,i.getStringIdentifierForProxy)(B)}.${U}(`,F);const M=String(R);let z,N;if($){const j=new D.CancellationTokenSource;F.push(j.token),z=this._invokeHandler(B,U,F),N=()=>j.cancel()}else z=this._invokeHandler(B,U,F),N=n;this._cancelInvokedHandlers[M]=N;const x=c.serializeAcknowledged(R);this._logger&&this._logger.logOutgoing(x.byteLength,R,1,"ack"),this._protocol.send(x),z.then(j=>{delete this._cancelInvokedHandlers[M];const O=c.serializeReplyOK(R,j,this._uriReplacer);this._logger&&this._logger.logOutgoing(O.byteLength,R,1,"reply:",j),this._protocol.send(O)},j=>{delete this._cancelInvokedHandlers[M];const O=c.serializeReplyErr(R,j);this._logger&&this._logger.logOutgoing(O.byteLength,R,1,"replyErr:",j),this._protocol.send(O)})}_receiveCancel(A,R){this._logger&&this._logger.logIncoming(A,R,1,"receiveCancel");const B=String(R);this._cancelInvokedHandlers[B]&&this._cancelInvokedHandlers[B]()}_receiveReply(A,R,B){this._logger&&this._logger.logIncoming(A,R,0,"receiveReply:",B);const U=String(R);if(!this._pendingRPCReplies.hasOwnProperty(U))return;const F=this._pendingRPCReplies[U];delete this._pendingRPCReplies[U],F.resolveOk(B)}_receiveReplyErr(A,R,B){this._logger&&this._logger.logIncoming(A,R,0,"receiveReplyErr:",B);const U=String(R);if(!this._pendingRPCReplies.hasOwnProperty(U))return;const F=this._pendingRPCReplies[U];delete this._pendingRPCReplies[U];let $;B&&(B.$isError?($=new Error,$.name=B.name,$.message=B.message,$.stack=B.stack):$=B),F.resolveErr($)}_invokeHandler(A,R,B){try{return Promise.resolve(this._doInvokeHandler(A,R,B))}catch(U){return Promise.reject(U)}}_doInvokeHandler(A,R,B){const U=this._locals[A];if(!U)throw new Error("Unknown actor "+(0,i.getStringIdentifierForProxy)(A));let F=U[R];if(typeof F!="function")throw new Error("Unknown method "+R+" on actor "+(0,i.getStringIdentifierForProxy)(A));return F.apply(U,B)}_remoteCall(A,R,B){if(this._isDisposed)return Promise.reject(S.canceled());let U=null;if(B.length>0&&D.CancellationToken.isCancellationToken(B[B.length-1])&&(U=B.pop()),U&&U.isCancellationRequested)return Promise.reject(S.canceled());const F=c.serializeRequestArguments(B,this._uriReplacer),$=++this._lastMessageId,M=String($),z=new k.LazyPromise;U&&U.onCancellationRequested(()=>{const x=c.serializeCancel($);this._logger&&this._logger.logOutgoing(x.byteLength,$,0,"cancel"),this._protocol.send(c.serializeCancel($))}),this._pendingRPCReplies[M]=z,this._onWillSendRequest($);const N=c.serializeRequest($,A,R,F,!!U);return this._logger&&this._logger.logOutgoing(N.byteLength,$,0,`request: ${(0,i.getStringIdentifierForProxy)(A)}.${R}(`,B),this._protocol.send(N),z}}e.RPCProtocol=t,I=f,t.UNRESPONSIVE_TIME=3*1e3;class u{constructor(A,R){this._buff=A,this._offset=R}static alloc(A,R,B){let U=new u(L.VSBuffer.alloc(B+1+4),0);return U.writeUInt8(A),U.writeUInt32(R),U}static read(A,R){return new u(A,R)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(A){this._buff.writeUInt8(A,this._offset),this._offset+=1}readUInt8(){const A=this._buff.readUInt8(this._offset);return this._offset+=1,A}writeUInt32(A){this._buff.writeUInt32BE(A,this._offset),this._offset+=4}readUInt32(){const A=this._buff.readUInt32BE(this._offset);return this._offset+=4,A}static sizeShortString(A){return 1+A.byteLength}writeShortString(A){this._buff.writeUInt8(A.byteLength,this._offset),this._offset+=1,this._buff.set(A,this._offset),this._offset+=A.byteLength}readShortString(){const A=this._buff.readUInt8(this._offset);this._offset+=1;const B=this._buff.slice(this._offset,this._offset+A).toString();return this._offset+=A,B}static sizeLongString(A){return 4+A.byteLength}writeLongString(A){this._buff.writeUInt32BE(A.byteLength,this._offset),this._offset+=4,this._buff.set(A,this._offset),this._offset+=A.byteLength}readLongString(){const A=this._buff.readUInt32BE(this._offset);this._offset+=4;const B=this._buff.slice(this._offset,this._offset+A).toString();return this._offset+=A,B}writeBuffer(A){this._buff.writeUInt32BE(A.byteLength,this._offset),this._offset+=4,this._buff.set(A,this._offset),this._offset+=A.byteLength}static sizeVSBuffer(A){return 4+A.byteLength}writeVSBuffer(A){this._buff.writeUInt32BE(A.byteLength,this._offset),this._offset+=4,this._buff.set(A,this._offset),this._offset+=A.byteLength}readVSBuffer(){const A=this._buff.readUInt32BE(this._offset);this._offset+=4;const R=this._buff.slice(this._offset,this._offset+A);return this._offset+=A,R}static sizeMixedArray(A){let R=0;R+=1;for(let B=0,U=A.length;B<U;B++){const F=A[B];switch(R+=1,F.type){case 1:R+=this.sizeLongString(F.value);break;case 2:R+=this.sizeVSBuffer(F.value);break;case 3:R+=this.sizeUInt32,R+=this.sizeLongString(F.value);for(let $=0;$<F.buffers.length;++$)R+=this.sizeVSBuffer(F.buffers[$]);break;case 4:break}}return R}writeMixedArray(A){this._buff.writeUInt8(A.length,this._offset),this._offset+=1;for(let R=0,B=A.length;R<B;R++){const U=A[R];switch(U.type){case 1:this.writeUInt8(1),this.writeLongString(U.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(U.value);break;case 3:this.writeUInt8(3),this.writeUInt32(U.buffers.length),this.writeLongString(U.value);for(let F=0;F<U.buffers.length;++F)this.writeBuffer(U.buffers[F]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const A=this._buff.readUInt8(this._offset);this._offset+=1;let R=new Array(A);for(let B=0;B<A;B++)switch(this.readUInt8()){case 1:R[B]=this.readLongString();break;case 2:R[B]=this.readVSBuffer();break;case 3:const F=this.readUInt32(),$=this.readLongString(),M=[];for(let z=0;z<F;++z)M.push(this.readVSBuffer());R[B]=new i.SerializableObjectWithBuffers(P($,M,null));break;case 4:R[B]=void 0;break}return R}}u.sizeUInt32=4;var l;(function(_){_[_.Simple=0]="Simple",_[_.Mixed=1]="Mixed"})(l||(l={}));class c{static _useMixedArgSerialization(A){for(let R=0,B=A.length;R<B;R++)if(A[R]instanceof L.VSBuffer||A[R]instanceof i.SerializableObjectWithBuffers||typeof A[R]=="undefined")return!0;return!1}static serializeRequestArguments(A,R){if(this._useMixedArgSerialization(A)){const B=[];for(let U=0,F=A.length;U<F;U++){const $=A[U];if($ instanceof L.VSBuffer)B[U]={type:2,value:$};else if(typeof $=="undefined")B[U]={type:4};else if($ instanceof i.SerializableObjectWithBuffers){const{jsonString:M,referencedBuffers:z}=y($.value,R);B[U]={type:3,value:L.VSBuffer.fromString(M),buffers:z}}else B[U]={type:1,value:L.VSBuffer.fromString(b($,R))}}return{type:1,args:B}}return{type:0,args:b(A,R)}}static serializeRequest(A,R,B,U,F){switch(U.type){case 0:return this._requestJSONArgs(A,R,B,U.args,F);case 1:return this._requestMixedArgs(A,R,B,U.args,F)}}static _requestJSONArgs(A,R,B,U,F){const $=L.VSBuffer.fromString(B),M=L.VSBuffer.fromString(U);let z=0;z+=u.sizeUInt8(),z+=u.sizeShortString($),z+=u.sizeLongString(M);let N=u.alloc(F?2:1,A,z);return N.writeUInt8(R),N.writeShortString($),N.writeLongString(M),N.buffer}static deserializeRequestJSONArgs(A){const R=A.readUInt8(),B=A.readShortString(),U=A.readLongString();return{rpcId:R,method:B,args:JSON.parse(U)}}static _requestMixedArgs(A,R,B,U,F){const $=L.VSBuffer.fromString(B);let M=0;M+=u.sizeUInt8(),M+=u.sizeShortString($),M+=u.sizeMixedArray(U);let z=u.alloc(F?4:3,A,M);return z.writeUInt8(R),z.writeShortString($),z.writeMixedArray(U),z.buffer}static deserializeRequestMixedArgs(A){const R=A.readUInt8(),B=A.readShortString(),U=A.readMixedArray(),F=new Array(U.length);for(let $=0,M=U.length;$<M;$++){const z=U[$];typeof z=="string"?F[$]=JSON.parse(z):F[$]=z}return{rpcId:R,method:B,args:F}}static serializeAcknowledged(A){return u.alloc(5,A,0).buffer}static serializeCancel(A){return u.alloc(6,A,0).buffer}static serializeReplyOK(A,R,B){if(typeof R=="undefined")return this._serializeReplyOKEmpty(A);if(R instanceof L.VSBuffer)return this._serializeReplyOKVSBuffer(A,R);if(R instanceof i.SerializableObjectWithBuffers){const{jsonString:U,referencedBuffers:F}=y(R.value,B,!0);return this._serializeReplyOKJSONWithBuffers(A,U,F)}else return this._serializeReplyOKJSON(A,a(R,B))}static _serializeReplyOKEmpty(A){return u.alloc(7,A,0).buffer}static _serializeReplyOKVSBuffer(A,R){let B=0;B+=u.sizeVSBuffer(R);let U=u.alloc(8,A,B);return U.writeVSBuffer(R),U.buffer}static deserializeReplyOKVSBuffer(A){return A.readVSBuffer()}static _serializeReplyOKJSON(A,R){const B=L.VSBuffer.fromString(R);let U=0;U+=u.sizeLongString(B);let F=u.alloc(9,A,U);return F.writeLongString(B),F.buffer}static _serializeReplyOKJSONWithBuffers(A,R,B){const U=L.VSBuffer.fromString(R);let F=0;F+=u.sizeUInt32,F+=u.sizeLongString(U);for(const M of B)F+=u.sizeVSBuffer(M);let $=u.alloc(10,A,F);$.writeUInt32(B.length),$.writeLongString(U);for(const M of B)$.writeBuffer(M);return $.buffer}static deserializeReplyOKJSON(A){const R=A.readLongString();return JSON.parse(R)}static deserializeReplyOKJSONWithBuffers(A,R){const B=A.readUInt32(),U=A.readLongString(),F=[];for(let $=0;$<B;++$)F.push(A.readVSBuffer());return new i.SerializableObjectWithBuffers(P(U,F,R))}static serializeReplyErr(A,R){return R?this._serializeReplyErrEror(A,R):this._serializeReplyErrEmpty(A)}static _serializeReplyErrEror(A,R){const B=L.VSBuffer.fromString(a(S.transformErrorForSerialization(R),null));let U=0;U+=u.sizeLongString(B);let F=u.alloc(11,A,U);return F.writeLongString(B),F.buffer}static deserializeReplyErrError(A){const R=A.readLongString();return JSON.parse(R)}static _serializeReplyErrEmpty(A){return u.alloc(12,A,0).buffer}}var m;(function(_){_[_.RequestJSONArgs=1]="RequestJSONArgs",_[_.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",_[_.RequestMixedArgs=3]="RequestMixedArgs",_[_.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",_[_.Acknowledged=5]="Acknowledged",_[_.Cancel=6]="Cancel",_[_.ReplyOKEmpty=7]="ReplyOKEmpty",_[_.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",_[_.ReplyOKJSON=9]="ReplyOKJSON",_[_.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",_[_.ReplyErrError=11]="ReplyErrError",_[_.ReplyErrEmpty=12]="ReplyErrEmpty"})(m||(m={}));var d;(function(_){_[_.String=1]="String",_[_.VSBuffer=2]="VSBuffer",_[_.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",_[_.Undefined=4]="Undefined"})(d||(d={}))}),define(fe[268],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,g.createDecorator)("remoteAgentService")}),define(fe[269],me([0,1,10,9,12,2,4,64,44,227,268]),function(Y,e,g,L,D,S,T,C,E,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,T.createDecorator)("pathService");let I=class Wi{constructor(p,h,w,y){this.localUserHome=p,this.remoteAgentService=h,this.environmentService=w,this.contextService=y,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||D.OS)(),this.resolveUserHome=(async()=>{const P=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=P?.userHome||p})()}get defaultUriScheme(){return Wi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(p,h){if(p.remoteAuthority)return g.Schemas.vscodeRemote;const w=(0,C.getVirtualWorkspaceScheme)(h.getWorkspace());if(w)return w;const y=h.getWorkspace().folders[0];if(y)return y.uri.scheme;const P=h.getWorkspace().configuration;return P?P.scheme:g.Schemas.file}async userHome(p){return p?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(p=>p===1?L.win32:L.posix)}async fileURI(p){let h="";if(await this.resolveOS===1&&(p=p.replace(/\\/g,"/")),p[0]==="/"&&p[1]==="/"){const y=p.indexOf("/",2);y===-1?(h=p.substring(2),p="/"):(h=p.substring(2,y),p=p.substring(y)||"/")}return S.URI.from({scheme:g.Schemas.file,authority:h,path:p,query:"",fragment:""})}};I=Ve([$e(1,i.IRemoteAgentService),$e(2,k.IWorkbenchEnvironmentService),$e(3,E.IWorkspaceContextService)],I),e.AbstractPathService=I}),define(fe[72],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class g{constructor(T,C){this.line=T,this.character=C}isBefore(T){return!1}isBeforeOrEqual(T){return!1}isAfter(T){return!1}isAfterOrEqual(T){return!1}isEqual(T){return!1}compareTo(T){return 0}translate(T,C){return new g(0,0)}with(T){return new g(0,0)}}e.Position=g;class L{constructor(T,C,E,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new g(T,C),this.end=new g(E,k)}contains(T){return!1}isEqual(T){return!1}intersection(T){}union(T){return new L(0,0,0,0)}with(T){return new L(0,0,0,0)}}e.Range=L;var D;(function(S){S[S.Information=1]="Information",S[S.Warning=2]="Warning"})(D=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(fe[32],me([0,1,15,30,25,29,8,4,9,18,72,13]),function(Y,e,g,L,D,S,T,C,E,k,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return i.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const a="\u27EA ",p=" characters skipped \u27EB",h=(a.length+p.length+5)*2;e.ISearchService=(0,C.createDecorator)("searchService");var w;(function(x){x[x.file=0]="file",x[x.text=1]="text"})(w=e.SearchProviderType||(e.SearchProviderType={}));var y;(function(x){x[x.File=1]="File",x[x.Text=2]="Text"})(y=e.QueryType||(e.QueryType={}));function P(x){return!!x.preview}e.resultIsMatch=P;function b(x){return!!x.resource}e.isFileMatch=b;function o(x){return!!x.message}e.isProgressMessage=o;var s;(function(x){x[x.Normal=0]="Normal",x[x.NewSearchStarted=1]="NewSearchStarted"})(s=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class v{constructor(j){this.resource=j,this.results=[]}}e.FileMatch=v;class n{constructor(j,O,H){this.ranges=O;const W=Array.isArray(O)?O:[O];if(H&&H.matchLines===1&&f(W)){j=(0,T.getNLines)(j,H.matchLines);let X="",Q=0,de=0;const _e=Math.floor(H.charsPerLine/5),Ce=[];for(const Pe of W){const Be=Math.max(Pe.startColumn-_e,0),We=Pe.startColumn+H.charsPerLine;if(Be>de+_e+h){const He=a+(Be-de)+p;X+=He+j.slice(Be,We),Q+=Be-(de+He.length)}else X+=j.slice(de,We);Ce.push(new t(0,Pe.startColumn-Q,Pe.endColumn-Q)),de=We}this.preview={text:X,matches:Array.isArray(this.ranges)?Ce:Ce[0]}}else{const X=Array.isArray(O)?O[0].startLineNumber:O.startLineNumber;this.preview={text:j,matches:(0,g.mapArrayOrNot)(O,Q=>new r(Q.startLineNumber-X,Q.startColumn,Q.endLineNumber-X,Q.endColumn))}}}}e.TextSearchMatch=n;function f(x){const j=x[0].startLineNumber;for(const O of x)if(O.startLineNumber!==j||O.endLineNumber!==j)return!1;return!0}class r{constructor(j,O,H,W){this.startLineNumber=j,this.startColumn=O,this.endLineNumber=H,this.endColumn=W}}e.SearchRange=r;class t extends r{constructor(j,O,H){super(j,O,j,H)}}e.OneLineRange=t;var u;(function(x){x.Default="default",x.FileNames="fileNames",x.Type="type",x.Modified="modified",x.CountDescending="countDescending",x.CountAscending="countAscending"})(u=e.SearchSortOrder||(e.SearchSortOrder={}));function l(x,j=!0){const O=x&&x.files&&x.files.exclude,H=j&&x&&x.search&&x.search.exclude;if(!O&&!H)return;if(!O||!H)return O||H;let W=Object.create(null);return W=D.mixin(W,D.deepClone(O)),W=D.mixin(W,D.deepClone(H),!0),W}e.getExcludes=l;function c(x,j){return x.excludePattern&&L.match(x.excludePattern,j)?!1:x.includePattern||x.usingSearchPaths?x.includePattern&&L.match(x.includePattern,j)?!0:x.usingSearchPaths?!!x.folderQueries&&x.folderQueries.some(O=>{const H=O.folder.fsPath;if(S.isEqualOrParent(j,H)){const W=E.relative(H,j);return!O.includePattern||!!L.match(O.includePattern,W)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var m;(function(x){x[x.unknownEncoding=1]="unknownEncoding",x[x.regexParseError=2]="regexParseError",x[x.globParseError=3]="globParseError",x[x.invalidLiteral=4]="invalidLiteral",x[x.rgProcessError=5]="rgProcessError",x[x.other=6]="other",x[x.canceled=7]="canceled"})(m=e.SearchErrorCode||(e.SearchErrorCode={}));class d extends Error{constructor(j,O){super(j);this.code=O}}e.SearchError=d;function _(x){const j=x.message;if((0,k.isPromiseCanceledError)(x))return new d(j,m.canceled);try{const O=JSON.parse(j);return new d(O.message,O.code)}catch(O){return new d(j,m.other)}}e.deserializeSearchError=_;function A(x){const j={message:x.message,code:x.code};return new Error(JSON.stringify(j))}e.serializeSearchError=A;function R(x){return x.type==="error"?!0:x.type==="success"}e.isSerializedSearchComplete=R;function B(x){return x.type==="success"}e.isSerializedSearchSuccess=B;function U(x){return!!x.path}e.isSerializedFileMatch=U;function F(x,j){const O=x.searchPath?x.searchPath:x.relativePath;return(0,T.fuzzyContains)(O,j)}e.isFilePatternMatch=F;class ${constructor(j){this.path=j,this.results=[]}addMatch(j){this.results.push(j)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=$;function M(x,j){const O={...x||{},...j||{}};return Object.keys(O).filter(H=>{const W=O[H];return typeof W=="boolean"&&W})}e.resolvePatternsForProvider=M;class z{constructor(j,O){this._parsedIncludeExpression=null,this._excludeExpression={...j.excludePattern||{},...O.excludePattern||{}},this._parsedExcludeExpression=L.parse(this._excludeExpression);let H=j.includePattern;O.includePattern&&(H?H={...H,...O.includePattern}:H=O.includePattern),H&&(this._parsedIncludeExpression=L.parse(H))}matchesExcludesSync(j,O,H){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(j,O,H))}includedInQuerySync(j,O,H){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(j,O,H)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(j,O,H))}includedInQuery(j,O,H){const W=this._parsedExcludeExpression(j,O,H),X=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(j,O,H):!0;return(0,I.isPromise)(W)?W.then(Q=>Q?!1:X()):X()}hasSiblingExcludeClauses(){return N(this._excludeExpression)}}e.QueryGlobTester=z;function N(x){for(const j in x)if(typeof x[j]!="boolean")return!0;return!1}}),define(fe[36],me([0,1,15,16,21,3,24,10,79,23,8,13,2,170,4,11,191,44,45,26,14,7,32,5]),function(Y,e,g,L,D,S,T,C,E,k,i,I,a,p,h,w,y,P,b,o,s,v,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(A,R,B){return new k.ExtUri(U=>c(U,B)).isEqual(A,R)}function t(A,R,B){return r(A.uri,R.uri,B)?0:(0,i.compare)(A.uri.toString(),R.uri.toString())}function u(A,R,B){return A.index!==R.index?A.index<R.index?-1:1:r(A.uri,R.uri,B)?(0,i.compare)(A.name,R.name):(0,i.compare)(A.uri.toString(),R.uri.toString())}function l(A,R,B,U){const F=A.slice(0).sort((M,z)=>B(M,z,U)),$=R.slice(0).sort((M,z)=>B(M,z,U));return(0,g.delta)(F,$,(M,z)=>B(M,z,U))}function c(A,R){const B=R.getCapabilities(A.scheme);return!(B&&B&1024)}class m extends P.Workspace{constructor(R,B,U,F,$,M,z){super(R,U.map(N=>new P.WorkspaceFolder(N)),F,$,z);this._name=B,this._isUntitled=M,this._workspaceFolders=[],this._structure=T.TernarySearchTree.forUris(z),U.forEach(N=>{this._workspaceFolders.push(N),this._structure.set(N.uri,N)})}static toExtHostWorkspace(R,B,U,F){if(!R)return{workspace:null,added:[],removed:[]};const{id:$,name:M,folders:z,configuration:N,transient:x,isUntitled:j}=R,O=[],H=B;B?z.forEach((de,_e)=>{const Ce=a.URI.revive(de.uri),Pe=m._findFolder(U||B,Ce,F);Pe?(Pe.name=de.name,Pe.index=de.index,O.push(Pe)):O.push({uri:Ce,name:de.name,index:_e})}):O.push(...z.map(({uri:de,name:_e,index:Ce})=>({uri:a.URI.revive(de),name:_e,index:Ce}))),O.sort((de,_e)=>de.index<_e.index?-1:1);const W=new m($,M,O,!!x,N?a.URI.revive(N):null,!!j,de=>c(de,F)),{added:X,removed:Q}=l(H?H.workspaceFolders:[],W.workspaceFolders,t,F);return{workspace:W,added:X,removed:Q}}static _findFolder(R,B,U){for(let F=0;F<R.folders.length;F++){const $=R.workspaceFolders[F];if(r($.uri,B,U))return $}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(R,B){return B&&this._structure.get(R)&&(R=(0,k.dirname)(R)),this._structure.findSubstr(R)}resolveWorkspaceFolder(R){return this._structure.get(R)}}let d=class{constructor(R,B,U,F){this._onDidChangeWorkspace=new S.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new S.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=F,this._extHostFileSystemInfo=U,this._requestIdProvider=new E.Counter,this._barrier=new L.Barrier,this._proxy=R.getProxy(f.MainContext.MainThreadWorkspace),this._messageService=R.getProxy(f.MainContext.MainThreadMessageService);const $=B.workspace;this._confirmedWorkspace=$?new m($.id,$.name,[],!!$.transient,$.configuration?a.URI.revive($.configuration):null,!!$.isUntitled,M=>c(M,U)):void 0}$initializeWorkspace(R,B){this._trusted=B,this.$acceptWorkspaceData(R),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?a.URI.from({scheme:C.Schemas.untitled,path:(0,k.basename)((0,k.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(R,B,U,...F){const $=[];if(Array.isArray(F)&&F.forEach(j=>{a.URI.isUri(j.uri)&&!$.some(O=>r(O.uri,j.uri,this._extHostFileSystemInfo))&&$.push({uri:j.uri,name:j.name||(0,k.basenameOrAuthority)(j.uri)})}),this._unconfirmedWorkspace||[B,U].some(j=>typeof j!="number"||j<0)||U===0&&$.length===0)return!1;const M=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(B+U>M.length)return!1;const z=M.slice(0);z.splice(B,U,...$.map(j=>({uri:j.uri,name:j.name||(0,k.basenameOrAuthority)(j.uri),index:void 0})));for(let j=0;j<z.length;j++){const O=z[j];if(z.some((H,W)=>W!==j&&r(O.uri,H.uri,this._extHostFileSystemInfo)))return!1}z.forEach((j,O)=>j.index=O);const{added:N,removed:x}=l(M,z,u,this._extHostFileSystemInfo);if(N.length===0&&x.length===0)return!1;if(this._proxy){const j=R.displayName||R.name;this._proxy.$updateWorkspaceFolders(j,B,U,$).then(void 0,O=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(y.Severity.Error,(0,p.localize)(0,null,j,O.toString()),{extension:R},[])})}return this.trySetWorkspaceFolders(z),!0}getWorkspaceFolder(R,B){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,B)}async getWorkspaceFolder2(R,B){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,B)}async resolveWorkspaceFolder(R){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(R)}getPath(){if(!this._actualWorkspace)return;const{folders:R}=this._actualWorkspace;if(R.length!==0)return R[0].uri.fsPath}getRelativePath(R,B){let U,F="";if(typeof R=="string"?(U=a.URI.file(R),F=R):typeof R!="undefined"&&(U=R,F=R.fsPath),!U)return F;const $=this.getWorkspaceFolder(U,!0);if(!$)return F;typeof B=="undefined"&&this._actualWorkspace&&(B=this._actualWorkspace.folders.length>1);let M=(0,k.relativePath)($.uri,U);return B&&$.name&&(M=`${$.name}/${M}`),M}trySetWorkspaceFolders(R){this._actualWorkspace&&(this._unconfirmedWorkspace=m.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:R,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(R){const{workspace:B,added:U,removed:F}=m.toExtHostWorkspace(R,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=B||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:U,removed:F}))}findFiles(R,B,U,F,$=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let M;if(B===null?M=!1:B&&(typeof B=="string"?M=B:M=B.pattern),$&&$.isCancellationRequested)return Promise.resolve([]);const{includePattern:z,folder:N}=_(R);return this._proxy.$startFileSearch((0,I.withUndefinedAsNull)(z),(0,I.withUndefinedAsNull)(N),(0,I.withUndefinedAsNull)(M),(0,I.withUndefinedAsNull)(U),$).then(x=>Array.isArray(x)?x.map(j=>a.URI.revive(j)):[])}async findTextInFiles(R,B,U,F,$=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const M=this._requestIdProvider.getNext(),z=typeof B.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:N,folder:x}=_(B.include),j=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,O={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:z,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:N,excludePattern:j},H=!1;if(this._activeSearchCallbacks[M]=W=>{if(H)return;const X=a.URI.revive(W.resource);W.results.forEach(Q=>{(0,n.resultIsMatch)(Q)?U({uri:X,preview:{text:Q.preview.text,matches:(0,g.mapArrayOrNot)(Q.preview.matches,de=>new v.Range(de.startLineNumber,de.startColumn,de.endLineNumber,de.endColumn))},ranges:(0,g.mapArrayOrNot)(Q.ranges,de=>new v.Range(de.startLineNumber,de.startColumn,de.endLineNumber,de.endColumn))}):U({uri:X,text:Q.text,lineNumber:Q.lineNumber})})},$.isCancellationRequested)return{};try{const W=await this._proxy.$startTextSearch(R,(0,I.withUndefinedAsNull)(x),O,M,$);return delete this._activeSearchCallbacks[M],W||{}}catch(W){throw delete this._activeSearchCallbacks[M],W}}$handleTextSearchResult(R,B){this._activeSearchCallbacks[B]&&this._activeSearchCallbacks[B](R)}saveAll(R){return this._proxy.$saveAll(R)}resolveProxy(R){return this._proxy.$resolveProxy(R)}get trusted(){return this._trusted}requestWorkspaceTrust(R){return this._proxy.$requestWorkspaceTrust(R)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};d=Ve([$e(0,s.IExtHostRpcService),$e(1,o.IExtHostInitDataService),$e(2,b.IExtHostFileSystemInfo),$e(3,w.ILogService)],d),e.ExtHostWorkspace=d,e.IExtHostWorkspace=(0,h.createDecorator)("IExtHostWorkspace");function _(A){let R,B;return A&&(typeof A=="string"?R=A:(R=A.pattern,B=A.baseFolder||a.URI.file(A.base))),{includePattern:R,folder:B}}}),define(fe[37],me([0,1,25,3,36,5,7,194,87,13,16,4,14,11,2]),function(Y,e,g,L,D,S,T,C,E,k,i,I,a,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function w(f,r){if(r){const t=r.split(".");let u=f;for(let l=0;u&&l<t.length;l++)u=u[t[l]];return u}}function y(f){return f instanceof h.URI}function P(f){return f&&f.uri instanceof h.URI&&f.languageId&&typeof f.languageId=="string"}function b(f){return f&&!f.uri&&f.languageId&&typeof f.languageId=="string"}function o(f){return f&&f.uri instanceof h.URI&&(!f.name||typeof f.name=="string")&&(!f.index||typeof f.index=="number")}function s(f){if(y(f))return{resource:f};if(P(f))return{resource:f.uri,overrideIdentifier:f.languageId};if(b(f))return{overrideIdentifier:f.languageId};if(o(f))return{resource:f.uri};if(f===null)return{resource:null}}let v=class{constructor(r,t,u){this._proxy=r.getProxy(S.MainContext.MainThreadConfiguration),this._extHostWorkspace=t,this._logService=u,this._barrier=new i.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new n(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,t){this.getConfigProvider().then(u=>u.$acceptConfigurationChanged(r,t))}};v=Ve([$e(0,a.IExtHostRpcService),$e(1,D.IExtHostWorkspace),$e(2,p.ILogService)],v),e.ExtHostConfiguration=v;class n{constructor(r,t,u,l){this._onDidChangeConfiguration=new L.Emitter,this._proxy=r,this._logService=l,this._extHostWorkspace=t,this._configuration=C.Configuration.parse(u),this._configurationScopes=this._toMap(u.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,t){const u={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=C.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(t,u))}getConfiguration(r,t,u){const l=s(t)||{},c=this._toReadonlyValue(r?w(this._configuration.getValue(void 0,l,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,l,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,l,u?.identifier);function m(_){if(_==null)return null;if(typeof _=="boolean")return _?1:4;switch(_){case T.ConfigurationTarget.Global:return 1;case T.ConfigurationTarget.Workspace:return 4;case T.ConfigurationTarget.WorkspaceFolder:return 5}}const d={has(_){return typeof w(c,_)!="undefined"},get:(_,A)=>{this._validateConfigurationAccess(r?`${r}.${_}`:_,l,u?.identifier);let R=w(c,_);if(typeof R=="undefined")R=A;else{let B;const U=(F,$)=>{let M;const z=()=>{B=B||(0,g.deepClone)(c),M=M||w(B,$)};return(0,k.isObject)(F)?new Proxy(F,{get:(N,x)=>{if(typeof x=="string"&&x.toLowerCase()==="tojson")return z(),()=>M;if(B)return M=M||w(B,$),M[x];const j=N[x];return typeof x=="string"?U(j,`${$}.${x}`):j},set:(N,x,j)=>(z(),M&&(M[x]=j),!0),deleteProperty:(N,x)=>(z(),M&&delete M[x],!0),defineProperty:(N,x,j)=>(z(),M&&Object.defineProperty(M,x,j),!0)}):F};R=U(R,_)}return R},update:(_,A,R,B)=>{_=r?`${r}.${_}`:_;const U=m(R);return A!==void 0?this._proxy.$updateConfigurationOption(U,_,A,l,B):this._proxy.$removeConfigurationOption(U,_,l,B)},inspect:_=>{_=r?`${r}.${_}`:_;const A=(0,g.deepClone)(this._configuration.inspect(_,l,this._extHostWorkspace.workspace));if(A)return{key:_,defaultValue:A.default?.value,globalValue:A.user?.value,workspaceValue:A.workspace?.value,workspaceFolderValue:A.workspaceFolder?.value,defaultLanguageValue:A.default?.override,globalLanguageValue:A.user?.override,workspaceLanguageValue:A.workspace?.override,workspaceFolderLanguageValue:A.workspaceFolder?.override,languageIds:A.overrideIdentifiers}}};return typeof c=="object"&&(0,g.mixin)(d,c,!1),Object.freeze(d)}_toReadonlyValue(r){const t=u=>(0,k.isObject)(u)?new Proxy(u,{get:(l,c)=>t(l[c]),set:(l,c,m)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(c)}' of object`)},deleteProperty:(l,c)=>{throw new Error(`TypeError: Cannot delete read only property '${String(c)}' of object`)},defineProperty:(l,c)=>{throw new Error(`TypeError: Cannot define property '${String(c)}' for a readonly object`)},setPrototypeOf:l=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):u;return t(r)}_validateConfigurationAccess(r,t,u){const l=E.OVERRIDE_PROPERTY_PATTERN.test(r)?4:this._configurationScopes.get(r),c=u?`[${u.value}] `:"";if(l===4){typeof t?.resource=="undefined"&&this._logService.warn(`${c}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(l===3){t?.resource&&this._logService.warn(`${c}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,t){const u=new C.ConfigurationChangeEvent(r,t,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(l,c)=>u.affectsConfiguration(l,s(c))})}_toMap(r){return r.reduce((t,u)=>(t.set(u[0],u[1]),t),new Map)}}e.ExtHostConfigProvider=n,e.IExtHostConfiguration=(0,I.createDecorator)("IExtHostConfiguration")});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,g):D?D.value=g:e.set(Y,g),g},Oe=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[73],me([0,1,2,16,3,5,7,36,46,37,21,33,14,26,4,10,12,11,68,217,18]),function(Y,e,g,L,D,S,T,C,E,k,i,I,a,p,h,w,y,P,b,o,s){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var n;(function($){function M(N){if(N!=null)return N}$.from=M;function z(N){if(N!=null)return N}$.to=z})(n=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var f;(function($){function M(N){if(N!=null)return N}$.from=M;function z(N){if(N!=null)return N}$.to=z})(f=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function($){function M(N){if(N!=null)return N}$.from=M;function z(N){if(N!=null)return N}$.to=z})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var t;(function($){function M(x){if(x){const j=x;return j&&!!j.process}else return!1}$.is=M;function z(x){if(x==null)return;const j={process:x.process,args:x.args};return x.options&&(j.options=r.from(x.options)),j}$.from=z;function N(x){if(x!=null)return new T.ProcessExecution(x.process,x.args,x.options)}$.to=N})(t=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var u;(function($){function M(N){if(N!=null)return N}$.from=M;function z(N){if(N!=null)return N}$.to=z})(u=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var l;(function($){function M(x){if(x){const j=x;return j&&(!!j.commandLine||!!j.command)}else return!1}$.is=M;function z(x){if(x==null)return;const j={};return x.commandLine!==void 0?j.commandLine=x.commandLine:(j.command=x.command,j.args=x.args),x.options&&(j.options=u.from(x.options)),j}$.from=z;function N(x){if(!(x==null||x.command===void 0&&x.commandLine===void 0))return x.commandLine?new T.ShellExecution(x.commandLine,x.options):new T.ShellExecution(x.command,x.args?x.args:[],x.options)}$.to=N})(l=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var c;(function($){function M(x){if(x){let j=x;return j&&j.customExecution==="customExecution"}else return!1}$.is=M;function z(x){return{customExecution:"customExecution"}}$.from=z;function N(x,j){return j.get(x)}$.to=N})(c=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var m;(function($){function M(z,N){let x;return z.scope!==void 0&&typeof z.scope!="number"?x=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===T.TaskScope.Workspace&&N&&N.workspaceFile?x=N.workspaceFile:x=o.USER_TASKS_GROUP_KEY),{id:z._id,workspaceFolder:x}}$.from=M})(m=e.TaskHandleDTO||(e.TaskHandleDTO={}));var d;(function($){function M(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}$.from=M})(d=e.TaskGroupDTO||(e.TaskGroupDTO={}));var _;(function($){function M(x,j){if(x==null)return[];const O=[];for(let H of x){const W=z(H,j);W&&O.push(W)}return O}$.fromMany=M;function z(x,j){if(x==null)return;let O;x.execution instanceof T.ProcessExecution?O=t.from(x.execution):x.execution instanceof T.ShellExecution?O=l.from(x.execution):x.execution&&x.execution instanceof T.CustomExecution&&(O=c.from(x.execution));const H=n.from(x.definition);let W;return x.scope?typeof x.scope=="number"?W=x.scope:W=x.scope.uri:W=T.TaskScope.Workspace,!H||!W?void 0:{_id:x._id,definition:H,name:x.name,source:{extensionId:j.identifier.value,label:x.source,scope:W},execution:O,isBackground:x.isBackground,group:d.from(x.group),presentationOptions:f.from(x.presentationOptions),problemMatchers:x.problemMatchers,hasDefinedMatchers:x.hasDefinedMatchers,runOptions:x.runOptions?x.runOptions:{reevaluateOnRerun:!0},detail:x.detail}}$.from=z;async function N(x,j,O){if(x==null)return;let H;t.is(x.execution)?H=t.to(x.execution):l.is(x.execution)?H=l.to(x.execution):c.is(x.execution)&&(H=c.to(x._id,O));const W=n.to(x.definition);let X;if(x.source&&(x.source.scope!==void 0?typeof x.source.scope=="number"?X=x.source.scope:X=await j.resolveWorkspaceFolder(g.URI.revive(x.source.scope)):X=T.TaskScope.Workspace),!W||!X)return;const Q=new T.Task(W,X,x.name,x.source.label,H,x.problemMatchers);return x.isBackground!==void 0&&(Q.isBackground=x.isBackground),x.group!==void 0&&(Q.group=T.TaskGroup.from(x.group._id),Q.group&&x.group.isDefault&&(Q.group=new T.TaskGroup(Q.group.id,Q.group.label),x.group.isDefault&&(Q.group.isDefault=x.group.isDefault))),x.presentationOptions&&(Q.presentationOptions=f.to(x.presentationOptions)),x._id&&(Q._id=x._id),x.detail&&(Q.detail=x.detail),Q}$.to=N})(_=e.TaskDTO||(e.TaskDTO={}));var A;(function($){function M(N){return N}$.from=M;function z(N){if(!!N)return Object.assign(Object.create(null),N)}$.to=z})(A=e.TaskFilterDTO||(e.TaskFilterDTO={}));class R{constructor(M,z,N){this._id=z,this._task=N,v.set(this,void 0),st(this,v,M,"f")}get task(){return this._task}terminate(){Oe(this,v,"f").terminateTask(this)}fireDidStartProcess(M){}fireDidEndProcess(M){}}v=new WeakMap;var B;(function($){function M(z){return{id:z._id,task:void 0}}$.from=M})(B=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let U=class{constructor(M,z,N,x,j,O,H,W){this._onDidExecuteTask=new D.Emitter,this._onDidTerminateTask=new D.Emitter,this._onDidTaskProcessStarted=new D.Emitter,this._onDidTaskProcessEnded=new D.Emitter,this._proxy=M.getProxy(S.MainContext.MainThreadTask),this._workspaceProvider=N,this._editorService=x,this._configurationService=j,this._terminalService=O,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=H,this._deprecationService=W,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(M,z,N){if(!N)return new T.Disposable(()=>{});const x=this.nextHandle();return this._handlers.set(x,{type:z,provider:N,extension:M}),this._proxy.$registerTaskProvider(x,z),new T.Disposable(()=>{this._handlers.delete(x),this._proxy.$unregisterTaskProvider(x)})}registerTaskSystem(M,z){this._proxy.$registerTaskSystem(M,z)}fetchTasks(M){return this._proxy.$fetchTasks(A.from(M)).then(async z=>{const N=[];for(let x of z){const j=await _.to(x,this._workspaceProvider,this._providedCustomExecutions2);j&&N.push(j)}return N})}get taskExecutions(){const M=[];return this._taskExecutions.forEach(z=>M.push(z)),M}terminateTask(M){if(!(M instanceof R))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(M._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(M,z,N){const x=this._providedCustomExecutions2.get(M.id);x&&(this._activeCustomExecutions2.set(M.id,x),this._terminalService.attachPtyToTerminal(z,await x.callback(N))),this._lastStartedTask=M.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(M)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(M){const z=await this.getTaskExecution(M);this._taskExecutionPromises.delete(M.id),this._taskExecutions.delete(M.id),this.customExecutionComplete(M),this._onDidTerminateTask.fire({execution:z})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(M){const z=await this.getTaskExecution(M.id);this._onDidTaskProcessStarted.fire({execution:z,processId:M.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(M){const z=await this.getTaskExecution(M.id);this._onDidTaskProcessEnded.fire({execution:z,exitCode:M.exitCode})}$provideTasks(M,z){const N=this._handlers.get(M);if(!N)return Promise.reject(new Error("no handler found"));const x=[],j=(0,L.asPromise)(()=>N.provider.provideTasks(i.CancellationToken.None)).then(O=>this.provideTasksInternal(z,x,N,O));return new Promise(O=>{j.then(H=>{Promise.all(x).then(()=>{O(H)})})})}async $resolveTask(M,z){const N=this._handlers.get(M);if(!N)return Promise.reject(new Error("no handler found"));if(z.definition.type!==N.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${N.type}].`);const x=await _.to(z,this._workspaceProvider,this._providedCustomExecutions2);if(!x)throw new Error("Unexpected: Task cannot be resolved.");const j=await N.provider.resolveTask(x,i.CancellationToken.None);if(!j)return;this.checkDeprecation(j,N);const O=_.from(j,N.extension);if(!O)throw new Error("Unexpected: Task cannot be resolved.");if(j.definition!==x.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return c.is(O.execution)&&await this.addCustomExecution(O,j,!0),await this.resolveTaskInternal(O)}nextHandle(){return this._handleCounter++}async addCustomExecution(M,z,N){const x=await this._proxy.$createTaskId(M);!N&&!this._providedCustomExecutions2.has(x)&&(this._notProvidedCustomExecutions.add(x),this._activeCustomExecutions2.set(x,z.execution)),this._providedCustomExecutions2.set(x,z.execution)}async getTaskExecution(M,z){if(typeof M=="string"){const j=this._taskExecutionPromises.get(M);if(!j)throw new Error("Unexpected: The specified task is missing an execution");return j}let N=this._taskExecutionPromises.get(M.id);if(N)return N;const x=new Promise((j,O)=>{function H(W,X,Q){Q?j(new R(W,X.id,Q)):O("Unexpected: Task does not exist.")}z?H(this,M,z):_.to(M.task,this._workspaceProvider,this._providedCustomExecutions2).then(W=>H(this,M,W))});return this._taskExecutionPromises.set(M.id,x),x.then(j=>(this._taskExecutions.set(M.id,j),j),j=>Promise.reject(j))}checkDeprecation(M,z){M._deprecated&&this._deprecationService.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(M){this._activeCustomExecutions2.get(M.id)&&this._activeCustomExecutions2.delete(M.id),this._notProvidedCustomExecutions.has(M.id)&&this._lastStartedTask!==M.id&&(this._providedCustomExecutions2.delete(M.id),this._notProvidedCustomExecutions.delete(M.id));let N=this._notProvidedCustomExecutions.values(),x=N.next();for(;!x.done;)!this._activeCustomExecutions2.has(x.value)&&this._lastStartedTask!==x.value&&(this._providedCustomExecutions2.delete(x.value),this._notProvidedCustomExecutions.delete(x.value)),x=N.next()}};U=Ve([$e(0,a.IExtHostRpcService),$e(1,p.IExtHostInitDataService),$e(2,C.IExtHostWorkspace),$e(3,E.IExtHostDocumentsAndEditors),$e(4,k.IExtHostConfiguration),$e(5,I.IExtHostTerminalService),$e(6,P.ILogService),$e(7,b.IExtHostApiDeprecationService)],U),e.ExtHostTaskBase=U;let F=class extends U{constructor(M,z,N,x,j,O,H,W){super(M,z,N,x,j,O,H,W);this.registerTaskSystem(w.Schemas.vscodeRemote,{scheme:w.Schemas.vscodeRemote,authority:"",platform:y.PlatformToString(0)})}async executeTask(M,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const N=_.from(z,M);if(N===void 0)throw new Error("Task is not valid");if(c.is(N.execution))await this.addCustomExecution(N,z,!1);else throw new s.NotSupportedError;const x=await this.getTaskExecution(await this._proxy.$getTaskExecution(N),z);return this._proxy.$executeTask(N).catch(j=>{throw new Error(j)}),x}provideTasksInternal(M,z,N,x){const j=[];if(x)for(let O of x){this.checkDeprecation(O,N),(!O.definition||!M[O.definition.type])&&this._logService.warn(`The task [${O.source}, ${O.name}] uses an undefined task type. The task will be ignored in the future.`);const H=_.from(O,N.extension);H&&c.is(H.execution)?(j.push(H),z.push(this.addCustomExecution(H,O,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:j,extension:N.extension}}async resolveTaskInternal(M){if(c.is(M.execution))return M;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(M,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(M,z,N){}};F=Ve([$e(0,a.IExtHostRpcService),$e(1,p.IExtHostInitDataService),$e(2,C.IExtHostWorkspace),$e(3,E.IExtHostDocumentsAndEditors),$e(4,k.IExtHostConfiguration),$e(5,I.IExtHostTerminalService),$e(6,P.ILogService),$e(7,b.IExtHostApiDeprecationService)],F),e.WorkerExtHostTask=F,e.IExtHostTask=(0,h.createDecorator)("IExtHostTask")}),define(fe[270],me([0,1,15,59,30,81,24,10,9,23,8,13,2,146,177,119,44,128,269,32]),function(Y,e,g,L,D,S,T,C,E,k,i,I,a,p,h,w,y,P,b,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let s=class{constructor(m,d,_,A){this.configurationService=m,this.workspaceContextService=d,this.editorGroupsService=_,this.pathService=A}text(m,d,_={}){m=this.getContentPattern(m,_);const A=this.configurationService.getValue(),R=d&&d.some(U=>!this.configurationService.getValue({resource:U}).search.useRipgrep);return{...this.commonQuery(d?.map(y.toWorkspaceFolder),_),type:2,contentPattern:m,previewOptions:_.previewOptions,maxFileSize:_.maxFileSize,usePCRE2:A.search.usePCRE2||R||!1,beforeContext:_.beforeContext,afterContext:_.afterContext,userDisabledExcludesAndIgnoreFiles:_.disregardExcludeSettings&&_.disregardIgnoreFiles}}getContentPattern(m,d){const _=this.configurationService.getValue();m.isRegExp&&(m.pattern=m.pattern.replace(/\r?\n/g,"\\n"));const A={...m,wordSeparators:_.editor.wordSeparators};return this.isCaseSensitive(m,d)&&(A.isCaseSensitive=!0),this.isMultiline(m)&&(A.isMultiline=!0),A}file(m,d={}){return{...this.commonQuery(m,d),type:1,filePattern:d.filePattern?d.filePattern.trim():d.filePattern,exists:d.exists,sortByScore:d.sortByScore,cacheKey:d.cacheKey}}handleIncludeExclude(m,d){return m?(m=Array.isArray(m)?m.map(t):t(m),d?this.parseSearchPaths(m):{pattern:n(...Array.isArray(m)?m:[m])}):{}}commonQuery(m=[],d={}){const _=this.handleIncludeExclude(d.includePattern,d.expandPatterns),A=this.handleIncludeExclude(d.excludePattern,d.expandPatterns),R=m.length>1,B=(_.searchPaths&&_.searchPaths.length?_.searchPaths.map($=>this.getFolderQueryForSearchPath($,d,A)):m.map($=>this.getFolderQueryForRoot($,d,A,R))).filter($=>!!$),U={_reason:d._reason,folderQueries:B,usingSearchPaths:!!(_.searchPaths&&_.searchPaths.length),extraFileResources:d.extraFileResources,excludePattern:A.pattern,includePattern:_.pattern,onlyOpenEditors:d.onlyOpenEditors,maxResults:d.maxResults};if(d.onlyOpenEditors){const M=g.coalesce(g.flatten(this.editorGroupsService.groups.map(N=>N.editors.map(x=>x.resource)))).filter(N=>(0,o.pathIncludedInQuery)(U,N.fsPath)),z=this.commonQueryFromFileList(M);return{...U,...z}}const F=d.extraFileResources&&d.extraFileResources.filter($=>(0,o.pathIncludedInQuery)(U,$.fsPath));return U.extraFileResources=F&&F.length?F:void 0,U}commonQueryFromFileList(m){const d=[],_=new T.ResourceMap,A={};let R=!1;return m.forEach(B=>{if(B.scheme===C.Schemas.walkThrough)return;if((0,k.isAbsolutePath)(B)){const F=this.workspaceContextService.getWorkspaceFolder(B)?.uri??B.with({path:E.dirname(B.fsPath)});let $=_.get(F);$||(R=!0,$={folder:F,includePattern:{}},d.push($),_.set(F,$));const M=E.relative(F.fsPath,B.fsPath);(0,I.assertIsDefined)($.includePattern)[M.replace(/\\/g,"/")]=!0}else B.fsPath&&(R=!0,A[B.fsPath]=!0)}),{folderQueries:d,includePattern:A,usingSearchPaths:!0,excludePattern:R?void 0:{"**/*":!0}}}isCaseSensitive(m,d){if(d.isSmartCase){if(m.isRegExp){if(i.containsUppercaseCharacter(m.pattern,!0))return!0}else if(i.containsUppercaseCharacter(m.pattern))return!0}return!!m.isCaseSensitive}isMultiline(m){return m.isMultiline||m.isRegExp&&(0,p.isMultilineRegexSource)(m.pattern)||m.pattern.indexOf(`
`)>=0?!0:!!m.isMultiline}parseSearchPaths(m){const d=z=>E.isAbsolute(z)||/^\.\.?([\/\\]|$)/.test(z),A=(Array.isArray(m)?m:f(m)).map(z=>{const N=this.pathService.resolvedUserHome;return N?(0,S.untildify)(z,N.scheme===C.Schemas.file?N.fsPath:N.path):z}),R=L.groupBy(A,z=>d(z)?"searchPaths":"exprSegments"),B=(R.exprSegments||[]).map(z=>i.rtrim(z,"/")).map(z=>i.rtrim(z,"\\")).map(z=>(z[0]==="."&&(z="*"+z),r(z))),U={},F=this.expandSearchPathPatterns(R.searchPaths||[]);F&&F.length&&(U.searchPaths=F);const $=g.flatten(B),M=n(...$);return M&&(U.pattern=M),U}getExcludesForFolder(m,d){return d.disregardExcludeSettings?void 0:(0,o.getExcludes)(m,!d.disregardSearchExcludeSettings)}expandSearchPathPatterns(m){if(!m||!m.length)return[];const d=g.flatten(m.map(A=>{let{pathPortion:R,globPortion:B}=v(A);B&&(B=u(B));const U=this.expandOneSearchPath(R);return g.flatten(U.map(F=>this.resolveOneSearchPathPattern(F,B)))})),_=new Map;return d.forEach(A=>{const R=A.searchPath.toString(),B=_.get(R);B?A.pattern&&(B.pattern=B.pattern||{},B.pattern[A.pattern]=!0):_.set(R,{searchPath:A.searchPath,pattern:A.pattern?n(A.pattern):void 0})}),Array.from(_.values())}expandOneSearchPath(m){if(E.isAbsolute(m)){const d=this.workspaceContextService.getWorkspace().folders;return d[0]&&d[0].uri.scheme!==C.Schemas.file?[{searchPath:d[0].uri.with({path:m})}]:[{searchPath:a.URI.file(E.normalize(m))}]}if(this.workspaceContextService.getWorkbenchState()===2){const d=this.workspaceContextService.getWorkspace().folders[0].uri;if(m=t(m),m.startsWith("../")||m===".."){const A=E.posix.resolve(d.path,m);return[{searchPath:d.with({path:A})}]}const _=u(m);return[{searchPath:d,pattern:_}]}else{if(m==="./"||m===".\\")return[];{const d=m.replace(/^\.[\/\\]/,""),A=this.workspaceContextService.getWorkspace().folders.map(R=>{const B=d.match(new RegExp(`^${i.escapeRegExpCharacters(R.name)}(?:/(.*)|$)`));return B?{match:B,folder:R}:null}).filter(I.isDefined);if(A.length)return A.map(R=>{const B=R.match[1];return{searchPath:R.folder.uri,pattern:B&&u(B)}});{const R=m.match(/\.[\/\\](.+)[\/\\]?/),B=R?R[1]:m,U=h.localize(0,null,B);throw new Error(U)}}}}resolveOneSearchPathPattern(m,d){const _=m.pattern&&d?`${m.pattern}/${d}`:m.pattern||d,A=[{searchPath:m.searchPath,pattern:_}];return _&&!_.endsWith("**")&&A.push({searchPath:m.searchPath,pattern:_+"/**"}),A}getFolderQueryForSearchPath(m,d,_){const A=this.getFolderQueryForRoot((0,y.toWorkspaceFolder)(m.searchPath),d,_,!1);return A?{...A,includePattern:m.pattern}:null}getFolderQueryForRoot(m,d,_,A){let R;const B=a.URI.isUri(m)?m:m.uri;if(_.searchPaths){const z=_.searchPaths.filter(N=>(0,k.isEqual)(N.searchPath,B))[0];if(z&&!z.pattern)return null;z&&(R=z.pattern)}const U=this.configurationService.getValue({resource:B}),$={...this.getExcludesForFolder(U,d)||{},...R||{}},M=a.URI.isUri(m)?(0,k.basename)(m):m.name;return{folder:B,folderName:A?M:void 0,excludePattern:Object.keys($).length>0?$:void 0,fileEncoding:U.files&&U.files.encoding,disregardIgnoreFiles:typeof d.disregardIgnoreFiles=="boolean"?d.disregardIgnoreFiles:!U.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof d.disregardGlobalIgnoreFiles=="boolean"?d.disregardGlobalIgnoreFiles:!U.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof d.ignoreSymlinks=="boolean"?d.ignoreSymlinks:!U.search.followSymlinks}}};s=Ve([$e(0,w.IConfigurationService),$e(1,y.IWorkspaceContextService),$e(2,P.IEditorGroupsService),$e(3,b.IPathService)],s),e.QueryBuilder=s;function v(c){const m=c.match(/[\*\{\}\(\)\[\]\?]/);if(m){const d=m.index,_=c.substr(0,d).match(/[/|\\][^/\\]*$/);if(_){let A=c.substr(0,_.index);return A.match(/[/\\]/)||(A+="/"),{pathPortion:A,globPortion:c.substr((_.index||0)+1)}}}return{pathPortion:c}}function n(...c){return c.length?c.reduce((m,d)=>(m[d]=!0,m),Object.create(null)):void 0}function f(c){return D.splitGlobAware(c,",").map(m=>m.trim()).filter(m=>!!m.length)}function r(c){return[`**/${c}/**`,`**/${c}`].map(d=>d.replace(/\*\*\/\*\*/g,"**"))}function t(c){return c.replace(/\\/g,"/")}function u(c){return t(c).replace(/^\.\//,"").replace(/\/+$/g,"")}function l(c,m){c=g.distinct(c,A=>A.toString());const d=[],_=m.getWorkspace();return c&&c.forEach(A=>{let R;if(m.getWorkbenchState()===2)R=(0,k.relativePath)(_.folders[0].uri,A),R&&R!=="."&&(R="./"+R);else{const B=m.getWorkspaceFolder(A);if(B){const U=B.name;if(_.folders.filter($=>$.name===U).length===1){const $=(0,k.relativePath)(B.uri,A);$===""?R=`./${B.name}`:R=`./${B.name}/${$}`}else R=A.fsPath}}R&&d.push(R)}),d}e.resolveResourcesForSearchIncludes=l}),define(fe[271],me([0,1,23,2,21,18,4,270,32,44]),function(Y,e,g,L,D,S,T,C,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const i=7e3;function I(w,y){const P=y.activationEvents;if(!P)return Promise.resolve(void 0);const b=[],o=[];for(const t of P)if(/^workspaceContains:/.test(t)){const u=t.substr("workspaceContains:".length);u.indexOf("*")>=0||u.indexOf("?")>=0||w.forceUsingSearch?o.push(u):b.push(u)}if(b.length===0&&o.length===0)return Promise.resolve(void 0);let s;const v=new Promise((t,u)=>{s=t}),n=t=>s({activationEvent:t}),f=Promise.all(b.map(t=>a(w,t,n))).then(()=>{}),r=p(w,y.identifier,o,n);return Promise.all([f,r]).then(()=>{s(void 0)}),v}e.checkActivateWorkspaceContainsExtension=I;async function a(w,y,P){for(const b of w.folders)if(await w.exists(g.joinPath(L.URI.revive(b),y))){P(`workspaceContains:${y}`);return}}async function p(w,y,P,b){if(P.length===0)return Promise.resolve(void 0);const o=new D.CancellationTokenSource,s=w.checkExists(w.folders,P,o.token),v=setTimeout(async()=>{o.cancel(),b(`workspaceContainsTimeout:${P.join(",")}`)},i);let n=!1;try{n=await s}catch(f){S.isPromiseCanceledError(f)||S.onUnexpectedError(f)}o.dispose(),clearTimeout(v),n&&b(`workspaceContains:${P.join(",")}`)}function h(w,y,P,b){const o=w.get(T.IInstantiationService),s=w.get(E.ISearchService),n=o.createInstance(C.QueryBuilder).file(y.map(f=>(0,k.toWorkspaceFolder)(L.URI.revive(f))),{_reason:"checkExists",includePattern:P,exists:!0});return s.fileSearch(n,b).then(f=>!!f.limitHit,f=>S.isPromiseCanceledError(f)?!1:Promise.reject(f))}e.checkGlobFileExists=h});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,g):D?D.value=g:e.set(Y,g),g},Oe=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[41],me([0,1,165,9,74,23,16,6,24,2,11,5,37,230,92,36,35,228,18,27,22,202,7,120,4,26,70,14,86,54,33,3,271,91,204,10]),function(Y,e,g,L,D,S,T,C,E,k,i,I,a,p,h,w,y,P,b,o,s,v,n,f,r,t,u,l,c,m,d,_,A,R,B,U){"use strict";var F,$,M;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let z=class Hi extends C.Disposable{constructor(O,H,W,X,Q,de,_e,Ce,Pe,Be){super();this._onDidChangeRemoteConnectionData=this._register(new _.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=H,this._extHostContext=W,this._initData=_e,this._extHostWorkspace=X,this._extHostConfiguration=Q,this._logService=de,this._extHostTunnelService=Pe,this._extHostTerminalService=Be,this._disposables=new C.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new T.Barrier,this._readyToStartExtensionHost=new T.Barrier,this._readyToRunExtensions=new T.Barrier,this._eagerExtensionsActivated=new T.Barrier,this._registry=new P.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new h.ExtHostStorage(this._extHostContext),this._secretState=new R.ExtHostSecretState(this._extHostContext),this._storagePath=Ce,this._instaService=O.createChild(new c.ServiceCollection([h.IExtHostStorage,this._storage],[R.IExtHostSecretState,this._secretState]));const We=new Set;this._initData.hostExtensions.forEach(He=>We.add(o.ExtensionIdentifier.toKey(He))),this._activator=new p.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(He,G,ee)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(He,b.transformErrorForSerialization(G),ee)},actualActivateExtension:async(He,G)=>{if(We.has(o.ExtensionIdentifier.toKey(He)))return await this._mainThreadExtensionsProxy.$activateExtension(He,G),new p.HostExtension;const ee=this._registry.getExtensionDescription(He);return this._activateExtension(ee,G)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),D.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(O){b.onUnexpectedError(O)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let O=[];try{O=this._registry.getAllExtensionDescriptions().map(Q=>Q.identifier).filter(Q=>this.isActivated(Q)).map(Q=>this._deactivate(Q))}catch(H){}await Promise.all(O)}isActivated(O){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(O):!1}_activateByEvent(O,H){return this._activator.activateByEvent(O,H)}_activateById(O,H){return this._activator.activateById(O,H)}activateByIdWithErrors(O,H){return this._activateById(O,H).then(()=>{const W=this._activator.getActivatedExtension(O);if(W.activationFailed)return Promise.reject(W.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(O=>this._registry)}getExtensionExports(O){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(O).exports:null}async _realPathExtensionUri(O){if(O.scheme!==U.Schemas.file)return O;const H=await this._hostUtils.realpath(O.fsPath);return k.URI.file(H)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const O=E.TernarySearchTree.forUris(H=>S.extUriBiasedIgnorePathCase.ignorePathCasing(H));for(const H of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(H)){const W=await this._realPathExtensionUri(H.extensionLocation);O.set(W,H)}return O})()),this._extensionPathIndex}_deactivate(O){let H=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(O))return H;const W=this._activator.getActivatedExtension(O);if(!W)return H;try{typeof W.module.deactivate=="function"&&(H=Promise.resolve(W.module.deactivate()).then(void 0,X=>(this._logService.error(X),Promise.resolve(void 0))))}catch(X){this._logService.error(X)}try{(0,C.dispose)(W.subscriptions)}catch(X){this._logService.error(X)}return H}async _activateExtension(O,H){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier),this._doActivateExtension(O,H).then(W=>{const X=W.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(O.identifier,X.codeLoadingTime,X.activateCallTime,X.activateResolvedTime,H),this._logExtensionActivationTimes(O,H,"success",X),W},W=>{throw this._logExtensionActivationTimes(O,H,"failure"),W})}_logExtensionActivationTimes(O,H,W,X){const Q=N(O,H);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Q,...X||{},outcome:W})}_doActivateExtension(O,H){const W=N(O,H);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",W);const X=this._getEntryPoint(O);if(!X)return Promise.resolve(new p.EmptyExtension(p.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${O.identifier.value}, startup: ${H.startup}, activationEvent: '${H.activationEvent}'${O.identifier.value!==H.extensionId.value?`, root cause: ${H.extensionId.value}`:""}`),this._logService.flush();const Q=new p.ExtensionActivationTimesBuilder(H.startup);return Promise.all([this._loadCommonJSModule(O.identifier,(0,S.joinPath)(O.extensionLocation,X),Q),this._loadExtensionContext(O)]).then(de=>(D.mark(`code/extHost/willActivateExtension/${O.identifier.value}`),Hi._callActivate(this._logService,O.identifier,de[0],de[1],Q))).then(de=>(D.mark(`code/extHost/didActivateExtension/${O.identifier.value}`),de))}_loadExtensionContext(O){const H=new v.ExtensionGlobalMemento(O,this._storage),W=new v.ExtensionMemento(O.identifier.value,!1,this._storage),X=new B.ExtensionSecrets(O,this._secretState),Q=O.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,de=this._initData.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${O.identifier.value}`),Promise.all([H.whenReady,W.whenReady,this._storagePath.whenReady]).then(()=>{const _e=this;let Ce;return Object.freeze({globalState:H,workspaceState:W,secrets:X,subscriptions:[],get extensionUri(){return O.extensionLocation},get extensionPath(){return O.extensionLocation.fsPath},asAbsolutePath(Pe){return L.join(O.extensionLocation.fsPath,Pe)},get storagePath(){return _e._storagePath.workspaceValue(O)?.fsPath},get globalStoragePath(){return _e._storagePath.globalValue(O).fsPath},get logPath(){return L.join(_e._initData.logsLocation.fsPath,O.identifier.value)},get logUri(){return k.URI.joinPath(_e._initData.logsLocation,O.identifier.value)},get storageUri(){return _e._storagePath.workspaceValue(O)},get globalStorageUri(){return _e._storagePath.globalValue(O)},get extensionMode(){return Q},get extension(){return Ce===void 0&&(Ce=new x(_e,O.identifier,O,de)),Ce},get extensionRuntime(){return(0,y.checkProposedApiEnabled)(O),_e.extensionRuntime},get environmentVariableCollection(){return _e._extHostTerminalService.getEnvironmentVariableCollection(O)}})})}static _callActivate(O,H,W,X,Q){return W=W||{activate:void 0,deactivate:void 0},this._callActivateOptional(O,H,W,X,Q).then(de=>new p.ActivatedExtension(!1,null,Q.build(),W,de,X.subscriptions))}static _callActivateOptional(O,H,W,X,Q){if(typeof W.activate=="function")try{Q.activateCallStart(),O.trace(`ExtensionService#_callActivateOptional ${H.value}`);const de=typeof global=="object"?global:self,_e=W.activate.apply(de,[X]);return Q.activateCallStop(),Q.activateResolveStart(),Promise.resolve(_e).then(Ce=>(Q.activateResolveStop(),Ce))}catch(de){return Promise.reject(de)}else return Promise.resolve(W)}_activateOneStartupFinished(O,H){this._activateById(O.identifier,{startup:!1,extensionId:O.identifier,activationEvent:H}).then(void 0,W=>{this._logService.error(W)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(D.getMarks());for(const O of this._registry.getAllExtensionDescriptions())if(O.activationEvents)for(const H of O.activationEvents)H==="onStartupFinished"&&this._activateOneStartupFinished(O,H)}_handleEagerExtensions(){const O=this._activateByEvent("*",!0).then(void 0,Q=>{this._logService.error(Q)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(Q=>this._handleWorkspaceContainsEagerExtensions(Q.added)));const H=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],W=this._handleWorkspaceContainsEagerExtensions(H),X=Promise.all([O,W]).then(()=>{});return Promise.race([X,(0,T.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),X}_handleWorkspaceContainsEagerExtensions(O){return O.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(H=>this._handleWorkspaceContainsEagerExtension(O,H))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(O,H){if(this.isActivated(H.identifier))return;const W=!this._initData.remote.isRemote&&!!this._initData.remote.authority,X={folders:O.map(de=>de.uri),forceUsingSearch:W,exists:de=>this._hostUtils.exists(de.fsPath),checkExists:(de,_e,Ce)=>this._mainThreadWorkspaceProxy.$checkExists(de,_e,Ce)},Q=await(0,A.checkActivateWorkspaceContainsExtension)(X,H);if(!!Q)return this._activateById(H.identifier,{startup:!0,extensionId:H.identifier,activationEvent:Q.activationEvent}).then(void 0,de=>this._logService.error(de))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(O){throw console.error(O),O}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:O,extensionTestsLocationURI:H}=this._initData.environment;if(!O||!H)throw new Error(g.localize(0,null));const W=await this._loadCommonJSModule(null,H,new p.ExtensionActivationTimesBuilder(!1));if(!W||typeof W.run!="function")throw new Error(g.localize(1,null,H.toString()));return new Promise((X,Q)=>{const de=(Pe,Be)=>{Pe?Q(Pe):X(typeof Be=="number"&&Be>0?1:0)},_e=(0,S.originalFSPath)(H),Ce=W.run(_e,de);Ce&&Ce.then&&Ce.then(()=>{X(0)}).catch(Pe=>{Q(Pe.toString())})})}async $extensionTestsExit(O){this._logService.info(`Extension host terminating: test runner requested exit with code ${O}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${O}`),this._logService.flush(),this._hostUtils.exit(O)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(O,H){return this._resolvers[O]=H,(0,C.toDisposable)(()=>{delete this._resolvers[O]})}async _activateAndGetResolver(O){const H=O.indexOf("+");if(H===-1)throw new Error("Not an authority that can be resolved!");const W=O.substr(0,H);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${W}`,!1),{authorityPrefix:W,resolver:this._resolvers[W]}}async $resolveAuthority(O,H){const{authorityPrefix:W,resolver:X}=await this._activateAndGetResolver(O);if(!X)return{type:"error",error:{code:f.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${W}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(X)),D.mark(`code/extHost/willResolveAuthority/${W}`);const Q=await X.resolve(O,{resolveAttempt:H});D.mark(`code/extHost/didResolveAuthorityOK/${W}`);const de={authority:O,host:Q.host,port:Q.port,connectionToken:Q.connectionToken},_e={extensionHostEnv:Q.extensionHostEnv,isTrusted:Q.isTrusted};return{type:"ok",value:{authority:de,options:_e,tunnelInformation:{environmentTunnels:Q.environmentTunnels}}}}catch(Q){if(D.mark(`code/extHost/didResolveAuthorityError/${W}`),Q instanceof n.RemoteAuthorityResolverError)return{type:"error",error:{code:Q._code,message:Q._message,detail:Q._detail}};throw Q}}async $getCanonicalURI(O,H){const{authorityPrefix:W,resolver:X}=await this._activateAndGetResolver(O);if(!X)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${W}`);const Q=k.URI.revive(H);if(typeof X.getCanonicalURI=="undefined")return Q;const de=await(0,T.asPromise)(()=>X.getCanonicalURI(Q));return de||Q}$startExtensionHost(O){return this._registry.keepOnly(O),this._startExtensionHost()}$activateByEvent(O,H){return H===1?this._activateByEvent(O,!1):this._readyToRunExtensions.wait().then(W=>this._activateByEvent(O,!1))}async $activate(O,H){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(O)?(await this._activateById(O,H),!0):!1}async $deltaExtensions(O,H){O.forEach(X=>X.extensionLocation=k.URI.revive(X.extensionLocation));const W=await this.getExtensionPathIndex();return await Promise.all(H.map(async X=>{const Q=this._registry.getExtensionDescription(X);Q&&W.delete(await this._realPathExtensionUri(Q.extensionLocation))})),await Promise.all(O.map(async X=>{const Q=await this._realPathExtensionUri(X.extensionLocation);W.set(Q,X)})),this._registry.deltaExtensions(O,H),Promise.resolve(void 0)}async $test_latency(O){return O}async $test_up(O){return O.byteLength}async $test_down(O){let H=s.VSBuffer.alloc(O),W=Math.random()%256;for(let X=0;X<O;X++)H.writeUInt8(W,X);return H}async $updateRemoteConnectionData(O){this._remoteConnectionData=O,this._onDidChangeRemoteConnectionData.fire()}};z=Ve([$e(0,r.IInstantiationService),$e(1,e.IHostUtils),$e(2,l.IExtHostRpcService),$e(3,w.IExtHostWorkspace),$e(4,a.IExtHostConfiguration),$e(5,i.ILogService),$e(6,t.IExtHostInitDataService),$e(7,u.IExtensionStoragePaths),$e(8,m.IExtHostTunnelService),$e(9,d.IExtHostTerminalService)],z),e.AbstractExtHostExtensionService=z;function N(j,O){return{id:j.identifier.value,name:j.name,extensionVersion:j.version,publisherDisplayName:j.publisher,activationEvents:j.activationEvents?j.activationEvents.join(","):null,isBuiltin:j.isBuiltin,reason:O.activationEvent,reasonId:O.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class x{constructor(O,H,W,X){F.set(this,void 0),$.set(this,void 0),M.set(this,void 0),st(this,F,O,"f"),st(this,$,H,"f"),st(this,M,W.identifier,"f"),this.id=W.identifier.value,this.extensionUri=W.extensionLocation,this.extensionPath=L.normalize((0,S.originalFSPath)(W.extensionLocation)),this.packageJSON=W,this.extensionKind=X}get isActive(){return Oe(this,F,"f").isActivated(Oe(this,M,"f"))}get exports(){if(this.packageJSON.api!=="none")return Oe(this,F,"f").getExtensionExports(Oe(this,M,"f"))}activate(){return Oe(this,F,"f").activateByIdWithErrors(Oe(this,M,"f"),{startup:!1,extensionId:Oe(this,$,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=x,F=new WeakMap,$=new WeakMap,M=new WeakMap}),define(fe[57],me([0,1,9,2,3,16,5,7,124,36,41,46,219,37,212,14,4,13,38,56]),function(Y,e,g,L,D,S,T,C,E,k,i,I,a,p,h,w,y,P,b,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,y.createDecorator)("IExtHostDebugService");let s=class{constructor(c,m,d,_,A,R){this._workspaceService=m,this._extensionService=d,this._editorsService=_,this._configurationService=A,this._editorTabs=R,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new D.Emitter,this._onDidTerminateDebugSession=new D.Emitter,this._onDidChangeActiveDebugSession=new D.Emitter,this._onDidReceiveDebugSessionCustomEvent=new D.Emitter,this._debugServiceProxy=c.getProxy(T.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new D.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new n(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(B=>{B.onDidChange(U=>{this.registerAllDebugTypes(B)}),this.registerAllDebugTypes(B)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(c,m){const d=c;if(typeof d.sourceReference=="number"&&d.sourceReference>0){let _=`debug:${encodeURIComponent(d.path||"")}`,A="?";return m&&(_+=`${A}session=${encodeURIComponent(m.id)}`,A="&"),_+=`${A}ref=${d.sourceReference}`,L.URI.parse(_)}else{if(d.path)return L.URI.file(d.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(c){const m=[];for(const d of c.getAllExtensionDescriptions())if(d.contributes){const _=d.contributes.debuggers;if(_&&_.length>0)for(const A of _)(0,h.isDebuggerMainContribution)(A)&&m.push(A.type)}this._debugServiceProxy.$registerDebugTypes(m)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const c=[];return this._breakpoints.forEach(m=>c.push(m)),c}addBreakpoints(c){this.startBreakpoints();const m=c.filter(A=>{const R=A.id;return this._breakpoints.has(R)?!1:(this._breakpoints.set(R,A),!0)});this.fireBreakpointChanges(m,[],[]);const d=[],_=new Map;for(const A of m)if(A instanceof C.SourceBreakpoint){let R=_.get(A.location.uri.toString());R||(R={type:"sourceMulti",uri:A.location.uri,lines:[]},_.set(A.location.uri.toString(),R),d.push(R)),R.lines.push({id:A.id,enabled:A.enabled,condition:A.condition,hitCondition:A.hitCondition,logMessage:A.logMessage,line:A.location.range.start.line,character:A.location.range.start.character})}else A instanceof C.FunctionBreakpoint&&d.push({type:"function",id:A.id,enabled:A.enabled,hitCondition:A.hitCondition,logMessage:A.logMessage,condition:A.condition,functionName:A.functionName});return this._debugServiceProxy.$registerBreakpoints(d)}removeBreakpoints(c){this.startBreakpoints();const m=c.filter(R=>this._breakpoints.delete(R.id));this.fireBreakpointChanges([],m,[]);const d=m.filter(R=>R instanceof C.SourceBreakpoint).map(R=>R.id),_=m.filter(R=>R instanceof C.FunctionBreakpoint).map(R=>R.id),A=m.filter(R=>R instanceof C.DataBreakpoint).map(R=>R.id);return this._debugServiceProxy.$unregisterBreakpoints(d,_,A)}startDebugging(c,m,d){return this._debugServiceProxy.$startDebugging(c?c.uri:void 0,m,{parentSessionID:d.parentSession?d.parentSession.id:void 0,lifecycleManagedByParent:d.lifecycleManagedByParent,repl:d.consoleMode===C.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:d.noDebug,compact:d.compact,debugUI:d.debugUI,suppressSaveBeforeStart:d.suppressSaveBeforeStart})}stopDebugging(c){return this._debugServiceProxy.$stopDebugging(c?c.id:void 0)}registerDebugConfigurationProvider(c,m,d){if(!m)return new C.Disposable(()=>{});const _=this._configProviderHandleCounter++;return this._configProviders.push({type:c,handle:_,provider:m}),this._debugServiceProxy.$registerDebugConfigurationProvider(c,d,!!m.provideDebugConfigurations,!!m.resolveDebugConfiguration,!!m.resolveDebugConfigurationWithSubstitutedVariables,_),new C.Disposable(()=>{this._configProviders=this._configProviders.filter(A=>A.provider!==m),this._debugServiceProxy.$unregisterDebugConfigurationProvider(_)})}registerDebugAdapterDescriptorFactory(c,m,d){if(!d)return new C.Disposable(()=>{});if(!this.definesDebugType(c,m))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${m}' debugger.`);if(this.getAdapterDescriptorFactoryByType(m))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const _=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:m,handle:_,factory:d}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(m,_),new C.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(A=>A.factory!==d),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(_)})}registerDebugAdapterTrackerFactory(c,m){if(!m)return new C.Disposable(()=>{});const d=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:c,handle:d,factory:m}),new C.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(_=>_.factory!==m)})}async $runInTerminal(c,m){return Promise.resolve(void 0)}async $substituteVariables(c,m){if(!this._variableResolver){const[A,R]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(A||[],this._editorsService,R)}let d;const _=await this.getFolder(c);return _&&(d={uri:_.uri,name:_.name,index:_.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(d,m)}createDebugAdapter(c,m){if(c.type==="implementation")return new t(c.implementation)}createSignService(){}async $startDASession(c,m){const d=this,_=await this.getSession(m);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(_.type),_).then(A=>{if(!A)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${_.type}' (extension might have failed to activate)`);const R=this.convertToDto(A),B=this.createDebugAdapter(R,_);if(!B)throw new Error(`Couldn't create a debug adapter for type '${_.type}'.`);const U=B;return this._debugAdapters.set(c,U),this.getDebugAdapterTrackers(_).then(F=>(F&&this._debugAdaptersTrackers.set(c,F),U.onMessage(async $=>{if($.type==="request"&&$.command==="handshake"){const M=$,z={type:"response",seq:0,command:M.command,request_seq:M.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const N=await this._signService.sign(M.arguments.value);z.body={signature:N},U.sendResponse(z)}else throw new Error("no signer")}catch(N){z.success=!1,z.message=N.message,U.sendResponse(z)}}else F&&F.onDidSendMessage&&F.onDidSendMessage($),$=(0,h.convertToVSCPaths)($,!0),d._debugServiceProxy.$acceptDAMessage(c,$)}),U.onError($=>{F&&F.onError&&F.onError($),this._debugServiceProxy.$acceptDAError(c,$.name,$.message,$.stack)}),U.onExit($=>{F&&F.onExit&&F.onExit((0,P.withNullAsUndefined)($),void 0),this._debugServiceProxy.$acceptDAExit(c,(0,P.withNullAsUndefined)($),void 0)}),F&&F.onWillStartSession&&F.onWillStartSession(),U.startSession()))})}$sendDAMessage(c,m){m=(0,h.convertToDAPaths)(m,!1);const d=this._debugAdaptersTrackers.get(c);d&&d.onWillReceiveMessage&&d.onWillReceiveMessage(m);const _=this._debugAdapters.get(c);_&&_.sendMessage(m)}$stopDASession(c){const m=this._debugAdaptersTrackers.get(c);this._debugAdaptersTrackers.delete(c),m&&m.onWillStopSession&&m.onWillStopSession();const d=this._debugAdapters.get(c);return this._debugAdapters.delete(c),d?d.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(c){const m=[],d=[],_=[];if(c.added)for(const A of c.added){const R=A.id;if(R&&!this._breakpoints.has(R)){let B;if(A.type==="function")B=new C.FunctionBreakpoint(A.functionName,A.enabled,A.condition,A.hitCondition,A.logMessage);else if(A.type==="data")B=new C.DataBreakpoint(A.label,A.dataId,A.canPersist,A.enabled,A.hitCondition,A.condition,A.logMessage);else{const U=L.URI.revive(A.uri);B=new C.SourceBreakpoint(new C.Location(U,new C.Position(A.line,A.character)),A.enabled,A.condition,A.hitCondition,A.logMessage)}B._id=R,this._breakpoints.set(R,B),m.push(B)}}if(c.removed)for(const A of c.removed){const R=this._breakpoints.get(A);R&&(this._breakpoints.delete(A),d.push(R))}if(c.changed){for(const A of c.changed)if(A.id){const R=this._breakpoints.get(A.id);if(R){if(R instanceof C.FunctionBreakpoint&&A.type==="function"){const B=R;B.enabled=A.enabled,B.condition=A.condition,B.hitCondition=A.hitCondition,B.logMessage=A.logMessage,B.functionName=A.functionName}else if(R instanceof C.SourceBreakpoint&&A.type==="source"){const B=R;B.enabled=A.enabled,B.condition=A.condition,B.hitCondition=A.hitCondition,B.logMessage=A.logMessage,B.location=new C.Location(L.URI.revive(A.uri),new C.Position(A.line,A.character))}_.push(R)}}}this.fireBreakpointChanges(m,d,_)}$provideDebugConfigurations(c,m,d){return(0,S.asPromise)(async()=>{const _=this.getConfigProviderByHandle(c);if(!_)throw new Error("no DebugConfigurationProvider found");if(!_.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const A=await this.getFolder(m);return _.provideDebugConfigurations(A,d)}).then(_=>{if(!_)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return _})}$resolveDebugConfiguration(c,m,d,_){return(0,S.asPromise)(async()=>{const A=this.getConfigProviderByHandle(c);if(!A)throw new Error("no DebugConfigurationProvider found");if(!A.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const R=await this.getFolder(m);return A.resolveDebugConfiguration(R,d,_)})}$resolveDebugConfigurationWithSubstitutedVariables(c,m,d,_){return(0,S.asPromise)(async()=>{const A=this.getConfigProviderByHandle(c);if(!A)throw new Error("no DebugConfigurationProvider found");if(!A.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const R=await this.getFolder(m);return A.resolveDebugConfigurationWithSubstitutedVariables(R,d,_)})}async $provideDebugAdapter(c,m){const d=this.getAdapterDescriptorFactoryByHandle(c);if(!d)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const _=await this.getSession(m);return this.getAdapterDescriptor(d,_).then(A=>{if(!A)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${_.type}'`);return this.convertToDto(A)})}async $acceptDebugSessionStarted(c){const m=await this.getSession(c);this._onDidStartDebugSession.fire(m)}async $acceptDebugSessionTerminated(c){const m=await this.getSession(c);m&&(this._onDidTerminateDebugSession.fire(m),this._debugSessions.delete(m.id))}async $acceptDebugSessionActiveChanged(c){this._activeDebugSession=c?await this.getSession(c):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(c,m){const d=await this.getSession(c);d&&d._acceptNameChanged(m)}async $acceptDebugSessionCustomEvent(c,m){const _={session:await this.getSession(c),event:m.event,body:m.body};this._onDidReceiveDebugSessionCustomEvent.fire(_)}convertToDto(c){if(c instanceof C.DebugAdapterExecutable)return{type:"executable",command:c.command,args:c.args,options:c.options};if(c instanceof C.DebugAdapterServer)return{type:"server",port:c.port,host:c.host};if(c instanceof C.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:c.path};if(c instanceof C.DebugAdapterInlineImplementation)return{type:"implementation",implementation:c.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(c){const m=this._adapterFactories.filter(d=>d.type===c);if(m.length>0)return m[0].factory}getAdapterDescriptorFactoryByHandle(c){const m=this._adapterFactories.filter(d=>d.handle===c);if(m.length>0)return m[0].factory}getConfigProviderByHandle(c){const m=this._configProviders.filter(d=>d.handle===c);if(m.length>0)return m[0].provider}definesDebugType(c,m){if(c.contributes){const d=c.contributes.debuggers;if(d&&d.length>0){for(const _ of d)if(_.label&&_.type&&_.type===m)return!0}}return!1}getDebugAdapterTrackers(c){const d=c.configuration.type,_=this._trackerFactories.filter(A=>A.type===d||A.type==="*").map(A=>(0,S.asPromise)(()=>A.factory.createDebugAdapterTracker(c)).then(R=>R,R=>null));return Promise.race([Promise.all(_).then(A=>{const R=A.filter(B=>!!B);if(R.length>0)return new r(R)}),new Promise((A,R)=>{const B=setTimeout(()=>{clearTimeout(B),R(new Error("timeout"))},1e3)})]).catch(A=>{})}async getAdapterDescriptor(c,m){const d=m.configuration.debugServer;if(typeof d=="number")return Promise.resolve(new C.DebugAdapterServer(d));if(c){const A=await this._extensionService.getExtensionRegistry();return(0,S.asPromise)(()=>c.createDebugAdapterDescriptor(m,this.daExecutableFromPackage(m,A))).then(R=>{if(R)return R})}const _=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(m,_))}daExecutableFromPackage(c,m){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(c,m,d){(c.length>0||m.length>0||d.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:c,removed:m,changed:d}))}async getSession(c){if(c)if(typeof c=="string"){const m=this._debugSessions.get(c);if(m)return m}else{let m=this._debugSessions.get(c.id);if(!m){const d=await this.getFolder(c.folderUri),_=c.parent?this._debugSessions.get(c.parent):void 0;m=new v(this._debugServiceProxy,c.id,c.type,c.name,d,c.configuration,_),this._debugSessions.set(m.id,m),this._debugServiceProxy.$sessionCached(m.id)}return m}throw new Error("cannot find session")}getFolder(c){if(c){const m=L.URI.revive(c);return this._workspaceService.resolveWorkspaceFolder(m)}return Promise.resolve(void 0)}};s=Ve([$e(0,w.IExtHostRpcService),$e(1,k.IExtHostWorkspace),$e(2,i.IExtHostExtensionService),$e(3,I.IExtHostDocumentsAndEditors),$e(4,p.IExtHostConfiguration),$e(5,o.IExtHostEditorTabs)],s),e.ExtHostDebugServiceBase=s;class v{constructor(c,m,d,_,A,R,B){this._debugServiceProxy=c,this._id=m,this._type=d,this._name=_,this._workspaceFolder=A,this._configuration=R,this._parentSession=B}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(c){this._name=c,this._debugServiceProxy.$setDebugSessionName(this._id,c)}get parentSession(){return this._parentSession}_acceptNameChanged(c){this._name=c}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(c,m){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,c,m)}getDebugProtocolBreakpoint(c){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,c.id)}}e.ExtHostDebugSession=v;class n{constructor(c){this.value=Object.freeze({append(m){c.$appendDebugConsole(m)},appendLine(m){this.append(m+`
`)}})}}e.ExtHostDebugConsole=n;class f extends a.AbstractVariableResolverService{constructor(c,m,d,_,A){function R(){if(m){const B=m.activeEditor();if(B)return B.document.uri;const U=_.tabs.filter(F=>F.isActive);if(U.length>0){const F=U[0].resource;return F&&(F.primary||F.secondary)?F.primary??F.secondary:U[0].resource}}}super({getFolderUri:B=>{const U=c.filter(F=>F.name===B);if(U&&U.length>0)return U[0].uri},getWorkspaceFolderCount:()=>c.length,getConfigurationValue:(B,U)=>d.getConfiguration(void 0,B).get(U),getAppRoot:()=>b.cwd(),getExecPath:()=>b.env.VSCODE_EXEC_PATH,getFilePath:()=>{const B=R();if(B)return g.normalize(B.fsPath)},getWorkspaceFolderPathForFile:()=>{if(A){const B=R();if(B){const U=A.getWorkspaceFolder(B);if(U)return g.normalize(U.uri.fsPath)}}},getSelectedText:()=>{if(m){const B=m.activeEditor();if(B&&!B.selection.isEmpty)return B.document.getText(B.selection)}},getLineNumber:()=>{if(m){const B=m.activeEditor();if(B)return String(B.selection.end.line+1)}}},void 0,Promise.resolve(b.env))}}e.ExtHostVariableResolverService=f;class r{constructor(c){this.trackers=c}onWillStartSession(){this.trackers.forEach(c=>c.onWillStartSession?c.onWillStartSession():void 0)}onWillReceiveMessage(c){this.trackers.forEach(m=>m.onWillReceiveMessage?m.onWillReceiveMessage(c):void 0)}onDidSendMessage(c){this.trackers.forEach(m=>m.onDidSendMessage?m.onDidSendMessage(c):void 0)}onWillStopSession(){this.trackers.forEach(c=>c.onWillStopSession?c.onWillStopSession():void 0)}onError(c){this.trackers.forEach(m=>m.onError?m.onError(c):void 0)}onExit(c,m){this.trackers.forEach(d=>d.onExit?d.onExit(c,m):void 0)}}class t extends E.AbstractDebugAdapter{constructor(c){super();this.implementation=c,c.onDidSendMessage(m=>{this.acceptMessage(m)})}startSession(){return Promise.resolve(void 0)}sendMessage(c){this.implementation.handleMessage(c)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let u=class extends s{constructor(c,m,d,_,A,R){super(c,m,d,_,A,R)}createVariableResolver(c,m,d){return new f(c,m,d,this._editorTabs)}};u=Ve([$e(0,w.IExtHostRpcService),$e(1,k.IExtHostWorkspace),$e(2,i.IExtHostExtensionService),$e(3,I.IExtHostDocumentsAndEditors),$e(4,p.IExtHostConfiguration),$e(5,o.IExtHostEditorTabs)],u),e.WorkerExtHostDebugService=u}),define(fe[272],me([0,1,74,2,5,37,35,27,14,26,4,41,38,11]),function(Y,e,g,L,D,S,T,C,E,k,i,I,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let h=class{constructor(o,s,v,n,f,r,t){this._apiFactory=o,this._extensionRegistry=s,this._instaService=v,this._extHostConfiguration=n,this._extHostExtensionService=f,this._initData=r,this._logService=t,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),g.mark("code/extHost/willWaitForConfig");const o=await this._extHostConfiguration.getConfigProvider();g.mark("code/extHost/didWaitForConfig");const s=await this._extHostExtensionService.getExtensionPathIndex();this.register(new w(this._apiFactory,s,this._extensionRegistry,o,this._logService)),this.register(this._instaService.createInstance(y,s)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(P,s,this._initData.environment.appUriScheme))}register(o){if(Array.isArray(o.nodeModuleName))for(let s of o.nodeModuleName)this._factories.set(s,o);else this._factories.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this._alternatives.push(s=>o.alternativeModuleName(s))}};h=Ve([$e(2,i.IInstantiationService),$e(3,S.IExtHostConfiguration),$e(4,I.IExtHostExtensionService),$e(5,k.IExtHostInitDataService),$e(6,p.ILogService)],h),e.RequireInterceptor=h;class w{constructor(o,s,v,n,f){this._apiFactory=o,this._extensionPaths=s,this._extensionRegistry=v,this._configProvider=n,this._logService=f,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(o,s){const v=this._extensionPaths.findSubstr(s);if(v){let n=this._extApiImpl.get(C.ExtensionIdentifier.toKey(v.identifier));return n||(n=this._apiFactory(v,this._extensionRegistry,this._configProvider),this._extApiImpl.set(C.ExtensionIdentifier.toKey(v.identifier),n)),n}if(!this._defaultApiImpl){let n="";this._extensionPaths.forEach((f,r)=>n+=`	${r} -> ${f.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${s}. These are the extension path mappings: 
${n}`),this._defaultApiImpl=this._apiFactory(T.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let y=class{constructor(o,s,v){this._extensionPaths=o,this.nodeModuleName="keytar",this._mainThreadTelemetry=s.getProxy(D.MainContext.MainThreadTelemetry);const{environment:n}=v,f=s.getProxy(D.MainContext.MainThreadKeytar);if(n.appRoot){let r=n.appRoot.fsPath;a.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,t)=>f.$getPassword(r,t),setPassword:(r,t,u)=>f.$setPassword(r,t,u),deletePassword:(r,t)=>f.$deletePassword(r,t),findPassword:r=>f.$findPassword(r),findCredentials(r){return f.$findCredentials(r)}}}load(o,s){const v=this._extensionPaths.findSubstr(s);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:v?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(o){const s=o.length;if(s<=7||!this.alternativeNames)return;const v=s-7;if((o.charAt(v)==="/"||o.charAt(v)==="\\")&&o.endsWith("keytar")&&(o=o.replace(/\\/g,"/"),this.alternativeNames.has(o)))return"keytar"}};y=Ve([$e(1,E.IExtHostRpcService),$e(2,k.IExtHostInitDataService)],y);let P=class{constructor(o,s,v){this._extensionPaths=o,this._appUriScheme=s,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=v.getProxy(D.MainContext.MainThreadTelemetry);const n=v.getProxy(D.MainContext.MainThreadWindow);this._impl=(f,r)=>{const t=L.URI.parse(f);return r?this.callOriginal(f,r):t.scheme==="http"||t.scheme==="https"?n.$openUri(t,f,{allowTunneling:!0}):t.scheme==="mailto"||t.scheme===this._appUriScheme?n.$openUri(t,f,{}):this.callOriginal(f,r)}}load(o,s,v){const n=this._extensionPaths.findSubstr(s);return n&&(this._extensionId=n.identifier.value,this.sendShimmingTelemetry()),this._original=v(o),this._impl}callOriginal(o,s){return this.sendNoForwardTelemetry(),this._original(o,s)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};P=Ve([$e(2,E.IExtHostRpcService)],P)}),define(fe[273],me([0,1,171,12,7,213,36,41,46,37,33,14,57,196,16,214,56]),function(Y,e,g,L,D,S,T,C,E,k,i,I,a,p,h,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let P=class extends a.ExtHostDebugServiceBase{constructor(s,v,n,f,r,t,u){super(s,v,n,f,r,u);this._terminalService=t,this._integratedTerminalInstances=new b}createDebugAdapter(s,v){switch(s.type){case"server":return new S.SocketDebugAdapter(s);case"pipeServer":return new S.NamedPipeDebugAdapter(s);case"executable":return new S.ExecutableDebugAdapter(s,v.type)}return super.createDebugAdapter(s,v)}daExecutableFromPackage(s,v){const n=S.ExecutableDebugAdapter.platformAdapterExecutable(v.getAllExtensionDescriptions(),s.type);if(n)return new D.DebugAdapterExecutable(n.command,n.args,n.options)}createSignService(){return new p.SignService}async $runInTerminal(s,v){if(s.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(R=>{this._integratedTerminalInstances.onTerminalClosed(R)}));const n=await this._configurationService.getConfigProvider(),f=this._terminalService.getDefaultShell(!0),r=this._terminalService.getDefaultShellArgs(!0),t=s.title||g.localize(0,null),u=JSON.stringify({shell:f,shellArgs:r});let l=await this._integratedTerminalInstances.checkout(u,t),c,m=!1;if(l)c=s.cwd;else{const R={shellPath:f,shellArgs:r,cwd:s.cwd,name:t,iconPath:new D.ThemeIcon("debug")};m=!0,l=this._terminalService.createTerminalFromOptions(R,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(l,u)}l.show(!0);const d=await l.processId;m?await new Promise(R=>setTimeout(R,1e3)):n.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(f.indexOf("powershell")>=0||f.indexOf("pwsh")>=0||f.indexOf("cmd.exe")>=0?l.sendText("cls"):f.indexOf("bash")>=0?l.sendText("clear"):L.isWindows?l.sendText("cls"):l.sendText("clear"));const _=(0,w.prepareCommand)(f,s.args,c,s.env);l.sendText(_);const A=this.onDidTerminateDebugSession(R=>{R.id===v&&(this._integratedTerminalInstances.free(l),A.dispose())});return d}else if(s.kind==="external")return(0,w.runInExternalTerminal)(s,await this._configurationService.getConfigProvider());return super.$runInTerminal(s,v)}createVariableResolver(s,v,n){return new a.ExtHostVariableResolverService(s,v,n,this._editorTabs,this._workspaceService)}};P=Ve([$e(0,I.IExtHostRpcService),$e(1,T.IExtHostWorkspace),$e(2,C.IExtHostExtensionService),$e(3,E.IExtHostDocumentsAndEditors),$e(4,k.IExtHostConfiguration),$e(5,i.IExtHostTerminalService),$e(6,y.IExtHostEditorTabs)],P),e.ExtHostDebugService=P;class b{constructor(){this._terminalInstances=new Map}async checkout(s,v){const f=[...this._terminalInstances.entries()].map(([r,t])=>(0,h.createCancelablePromise)(async u=>{if(r.name!==v||t.lastUsedAt!==-1&&await(0,w.hasChildProcesses)(await r.processId))return null;const l=Date.now();return t.lastUsedAt+b.minUseDelay>l||u.isCancellationRequested||t.config!==s?null:(t.lastUsedAt=l,r)}));return await(0,h.firstParallel)(f,r=>!!r)}insert(s,v){this._terminalInstances.set(s,{lastUsedAt:Date.now(),config:v})}free(s){const v=this._terminalInstances.get(s);v&&(v.lastUsedAt=-1)}onTerminalClosed(s){this._terminalInstances.delete(s)}}b.minUseDelay=1e3}),define(fe[274],me([0,1,9,2,113,36,57,46,37,44,33,14,26,73,10,11,68,56,23,82]),function(Y,e,g,L,D,S,T,C,E,k,i,I,a,p,h,w,y,P,b,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let s=class extends p.ExtHostTaskBase{constructor(n,f,r,t,u,l,c,m,d){super(n,f,r,t,u,l,c,m);this.workspaceService=r,this.editorTabs=d,f.remote.isRemote&&f.remote.authority?this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:f.remote.authority,platform:process.platform}):this.registerTaskSystem(h.Schemas.file,{scheme:h.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(n,f){const r=f;if(!f.execution&&r._id===void 0)throw new Error("Tasks to execute must include an execution");if(r._id!==void 0){const t=p.TaskHandleDTO.from(r,this.workspaceService),u=await this._proxy.$getTaskExecution(t);if(u.task===void 0)throw new Error("Task from execution DTO is undefined");const l=await this.getTaskExecution(u,f);return this._proxy.$executeTask(t).catch(()=>{}),l}else{const t=p.TaskDTO.from(f,n);if(t===void 0)return Promise.reject(new Error("Task is not valid"));p.CustomExecutionDTO.is(t.execution)&&await this.addCustomExecution(t,f,!1);const u=await this.getTaskExecution(await this._proxy.$getTaskExecution(t),f);return this._proxy.$executeTask(t).catch(()=>{}),u}}provideTasksInternal(n,f,r,t){const u=[];if(t)for(let l of t){this.checkDeprecation(l,r),(!l.definition||!n[l.definition.type])&&this._logService.warn(`The task [${l.source}, ${l.name}] uses an undefined task type. The task will be ignored in the future.`);const c=p.TaskDTO.from(l,r.extension);c&&(u.push(c),p.CustomExecutionDTO.is(c.execution)&&f.push(this.addCustomExecution(c,l,!0)))}return{tasks:u,extension:r.extension}}async resolveTaskInternal(n){return n}async getVariableResolver(n){if(this._variableResolver===void 0){const f=await this._configurationService.getConfigProvider();this._variableResolver=new T.ExtHostVariableResolverService(n,this._editorService,f,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(n){let f=n&&n.length>0?n[0]:void 0;if(!f){const r=L.URI.file((0,o.homedir)());f=new k.WorkspaceFolder({uri:r,name:b.basename(r),index:0})}return{uri:f.uri,name:f.name,index:f.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(n,f){const r=L.URI.revive(n),t={process:void 0,variables:Object.create(null)},u=await this._workspaceProvider.resolveWorkspaceFolder(r),l=await this._workspaceProvider.getWorkspaceFolders2()??[],c=await this.getVariableResolver(l),m=u?{uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(l);for(let d of f.variables)t.variables[d]=await c.resolveAsync(m,d);if(f.process!==void 0){let d;if(f.process.path!==void 0){d=f.process.path.split(g.delimiter);for(let _=0;_<d.length;_++)d[_]=await c.resolveAsync(m,d[_])}t.process=await D.win32.findExecutable(await c.resolveAsync(m,f.process.name),f.process.cwd!==void 0?await c.resolveAsync(m,f.process.cwd):void 0,d)}return t}async $jsonTasksSupported(){return!0}async $findExecutable(n,f,r){return D.win32.findExecutable(n,f,r)}};s=Ve([$e(0,I.IExtHostRpcService),$e(1,a.IExtHostInitDataService),$e(2,S.IExtHostWorkspace),$e(3,C.IExtHostDocumentsAndEditors),$e(4,E.IExtHostConfiguration),$e(5,i.IExtHostTerminalService),$e(6,w.ILogService),$e(7,y.IExtHostApiDeprecationService),$e(8,P.IExtHostEditorTabs)],s),e.ExtHostTask=s}),define(fe[275],me([0,1,16,18,74,6,2,5,267,11,84,86,26,189,14,67,41,33]),function(Y,e,g,L,D,S,T,C,E,k,i,I,a,p,h,w,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class b{constructor(s,v,n,f){this._disposables=new S.DisposableStore,this._isTerminating=!1,this._hostUtils=n,this._rpcProtocol=new E.RPCProtocol(s,null,f),v=b._transform(v,this._rpcProtocol);const r=new I.ServiceCollection(...(0,i.getSingletonServiceDescriptors)());r.set(a.IExtHostInitDataService,{_serviceBrand:void 0,...v}),r.set(h.IExtHostRpcService,new h.ExtHostRpcService(this._rpcProtocol)),r.set(w.IURITransformerService,new w.URITransformerService(f)),r.set(y.IHostUtils,n);const t=new p.InstantiationService(r,!0),u=t.invokeFunction(d=>d.get(P.IExtHostTerminalService));this._disposables.add(u),this._logService=t.invokeFunction(d=>d.get(k.ILogService)),D.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",v),this._extensionService=t.invokeFunction(d=>d.get(y.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const l=new WeakMap;this._extensionService.getExtensionPathIndex().then(d=>{Error.prepareStackTrace=(_,A)=>{let R="",B,U;for(const F of A)R+=`
	at ${F.toString()}`,U=F.getFileName(),!B&&U&&(B=d.findSubstr(T.URI.file(U)));return l.set(_,B),`${_.name||"Error"}: ${_.message||""}${R}`}});const c=this._rpcProtocol.getProxy(C.MainContext.MainThreadExtensionService),m=this._rpcProtocol.getProxy(C.MainContext.MainThreadErrors);L.setUnexpectedErrorHandler(d=>{const _=L.transformErrorForSerialization(d),A=l.get(d);A?c.$onExtensionRuntimeError(A.identifier,_):m.$onUnexpectedError(_)})}terminate(s){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${s}`),this._logService.flush(),this._disposables.dispose(),L.setUnexpectedErrorHandler(n=>{this._logService.error(n)}),this._rpcProtocol.dispose();const v=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,g.timeout)(4e3),v]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(s,v){s.extensions.forEach(f=>f.extensionLocation=T.URI.revive(v.transformIncomingURIs(f.extensionLocation))),s.environment.appRoot=T.URI.revive(v.transformIncomingURIs(s.environment.appRoot));const n=s.environment.extensionDevelopmentLocationURI;return n&&(s.environment.extensionDevelopmentLocationURI=n.map(f=>T.URI.revive(v.transformIncomingURIs(f)))),s.environment.extensionTestsLocationURI=T.URI.revive(v.transformIncomingURIs(s.environment.extensionTestsLocationURI)),s.environment.globalStorageHome=T.URI.revive(v.transformIncomingURIs(s.environment.globalStorageHome)),s.environment.workspaceStorageHome=T.URI.revive(v.transformIncomingURIs(s.environment.workspaceStorageHome)),s.logsLocation=T.URI.revive(v.transformIncomingURIs(s.logsLocation)),s.logFile=T.URI.revive(v.transformIncomingURIs(s.logFile)),s.workspace=v.transformIncomingURIs(s.workspace),s}}e.ExtensionHostMain=b}),define(fe[276],me([0,1,9,21,52,30,23,47,32]),function(Y,e,g,L,D,S,T,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(a,p,h){this.config=a,this.provider=p,this.sessionToken=h,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=a.filePattern,this.includePattern=a.includePattern&&S.parse(a.includePattern),this.maxResults=a.maxResults||void 0,this.exists=a.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=a.excludePattern&&S.parse(a.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(a=>a.cancel()),this.activeCancellationTokens=new Set}search(a){const p=this.config.folderQueries||[];return new Promise((h,w)=>{const y=P=>{this.resultCount++,a(P)};if(this.isCanceled)return h({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(P=>{const b=P.toString(),o=g.basename(b);this.globalExcludePattern&&this.globalExcludePattern(b,o)||this.matchFile(y,{base:P,basename:o})}),Promise.all(p.map(P=>this.searchInFolder(P,y))).then(P=>{h({limitHit:this.isLimitHit,stats:P[0]||void 0})},P=>{w(new Error((0,D.toErrorMessage)(P)))})})}async searchInFolder(a,p){const h=new L.CancellationTokenSource,w=this.getSearchOptionsForFolder(a),y=this.initDirectoryTree(),P=new E.QueryGlobTester(this.config,a),b=!P.hasSiblingExcludeClauses();let o;try{this.activeCancellationTokens.add(h),o=C.StopWatch.create();const s=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},w,h.token),v=o.elapsed(),n=C.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(s&&s.forEach(f=>{const r=g.posix.relative(a.folder.path,f.path);if(b){const t=g.basename(f.path);this.matchFile(p,{base:a.folder,relativePath:r,basename:t});return}this.addDirectoryEntries(y,a.folder,r,p)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(y,P,p),{providerTime:v,postProcessTime:n.elapsed()})}finally{h.dispose(),this.activeCancellationTokens.delete(h)}}getSearchOptionsForFolder(a){const p=(0,E.resolvePatternsForProvider)(this.config.includePattern,a.includePattern),h=(0,E.resolvePatternsForProvider)(this.config.excludePattern,a.excludePattern);return{folder:a.folder,excludes:h,includes:p,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,followSymlinks:!a.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}addDirectoryEntries({pathToEntries:a},p,h,w){if(h===this.filePattern){const P=g.basename(this.filePattern);this.matchFile(w,{base:p,relativePath:this.filePattern,basename:P})}function y(P){const b=g.basename(P),o=g.dirname(P);let s=a[o];s||(s=a[o]=[],y(o)),s.push({base:p,relativePath:P,basename:b})}y(h)}matchDirectoryTree({rootEntries:a,pathToEntries:p},h,w){const y=this,P=this.filePattern;function b(o){const s=S.hasSiblingFn(()=>o.map(v=>v.basename));for(let v=0,n=o.length;v<n;v++){const f=o[v],{relativePath:r,basename:t}=f;if(h.matchesExcludesSync(r,t,P!==t?s:void 0))continue;const u=p[r];if(u)b(u);else{if(r===P)continue;y.matchFile(w,f)}if(y.isLimitHit)break}}b(a)}matchFile(a,p){(!this.includePattern||p.relativePath&&this.includePattern(p.relativePath,p.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||a(p))}}class i{constructor(){this.sessions=new Map}fileSearch(a,p,h,w){const y=this.getSessionTokenSource(a.cacheKey),P=new k(a,p,y&&y.token);let b=0;const o=s=>{b+=s.length,h(s.map(v=>this.rawMatchToSearchItem(v)))};return this.doSearch(P,i.BATCH_SIZE,o,w).then(s=>({limitHit:s.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:b,detailStats:s.stats}}))}clearCache(a){const p=this.getSessionTokenSource(a);p&&p.cancel()}getSessionTokenSource(a){if(!!a)return this.sessions.has(a)||this.sessions.set(a,new L.CancellationTokenSource),this.sessions.get(a)}rawMatchToSearchItem(a){return a.relativePath?{resource:T.joinPath(a.base,a.relativePath)}:{resource:a.base}}doSearch(a,p,h,w){w.onCancellationRequested(()=>{a.cancel()});const y=b=>{b&&(P.push(b),p>0&&P.length>=p&&(h(P),P=[]))};let P=[];return a.search(y).then(b=>(P.length&&h(P),b),b=>(P.length&&h(P),Promise.reject(b)))}}e.FileSearchManager=i,i.BATCH_SIZE=512}),define(fe[135],me([0,1,15,21,52,30,10,9,23,13,2,32]),function(Y,e,g,L,D,S,T,C,E,k,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class a{constructor(o,s,v,n){this.query=o,this.provider=s,this.fileUtils=v,this.processType=n,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(o,s){const v=this.query.folderQueries||[],n=new L.CancellationTokenSource;return s.onCancellationRequested(()=>n.cancel()),new Promise((f,r)=>{this.collector=new h(o);let t=!1;const u=(l,c)=>{if(!t&&!this.isLimitHit){const m=this.resultSize(l);y(l)&&typeof this.query.maxResults=="number"&&this.resultCount+m>this.query.maxResults&&(this.isLimitHit=!0,t=!0,n.cancel(),l=this.trimResultToSize(l,this.query.maxResults-this.resultCount));const d=this.resultSize(l);this.resultCount+=d,(d>0||!y(l))&&this.collector.add(l,c)}};Promise.all(v.map((l,c)=>this.searchInFolder(l,m=>u(m,c),n.token))).then(l=>{n.dispose(),this.collector.flush();const c=l.some(m=>!!m&&!!m.limitHit);f({limitHit:this.isLimitHit||c,messages:(0,g.flatten)(l.map(m=>m?.message?(0,k.isArray)(m.message)?m.message:[m.message]:[])),stats:{type:this.processType}})},l=>{n.dispose();const c=(0,D.toErrorMessage)(l);r(new Error(c))})})}resultSize(o){return y(o)?Array.isArray(o.ranges)?o.ranges.length:1:0}trimResultToSize(o,s){const v=Array.isArray(o.ranges)?o.ranges:[o.ranges],n=Array.isArray(o.preview.matches)?o.preview.matches:[o.preview.matches];return{ranges:v.slice(0,s),preview:{matches:n.slice(0,s),text:o.preview.text},uri:o.uri}}async searchInFolder(o,s,v){const n=new I.QueryGlobTester(this.query,o),f=[],r={report:l=>{if(!this.validateProviderResult(l))return;const c=o.folder.scheme===T.Schemas.file?S.hasSiblingPromiseFn(()=>this.fileUtils.readdir(E.dirname(l.uri))):void 0,m=E.relativePath(o.folder,l.uri);if(m){const d=n.includedInQuery(m,C.basename(m),c);(0,k.isPromise)(d)?f.push(d.then(_=>{_&&s(l)})):d&&s(l)}}},t=this.getSearchOptionsForFolder(o),u=await this.provider.provideTextSearchResults(p(this.query.contentPattern),t,r,v);return f.length&&await Promise.all(f),u}validateProviderResult(o){if(y(o)){if(Array.isArray(o.ranges)){if(!Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(o.preview.matches.length!==o.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(o){const s=(0,I.resolvePatternsForProvider)(this.query.includePattern,o.includePattern),v=(0,I.resolvePatternsForProvider)(this.query.excludePattern,o.excludePattern),n={folder:i.URI.from(o.folder),excludes:v,includes:s,useIgnoreFiles:!o.disregardIgnoreFiles,useGlobalIgnoreFiles:!o.disregardGlobalIgnoreFiles,followSymlinks:!o.ignoreSymlinks,encoding:o.fileEncoding&&this.fileUtils.toCanonicalName(o.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return n.usePCRE2=this.query.usePCRE2,n}}e.TextSearchManager=a;function p(b){return{isCaseSensitive:b.isCaseSensitive||!1,isRegExp:b.isRegExp||!1,isWordMatch:b.isWordMatch||!1,isMultiline:b.isMultiline||!1,pattern:b.pattern}}class h{constructor(o){this._onResult=o,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new P(512,s=>this.sendItems(s))}add(o,s){this._currentFileMatch&&(this._currentFolderIdx!==s||!E.isEqual(this._currentUri,o.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=s,this._currentFileMatch={resource:o.uri,results:[]}),this._currentFileMatch.results.push(w(o))}pushToCollector(){const o=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,o)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(o){this._onResult(o)}}e.TextSearchResultsCollector=h;function w(b){return y(b)?{preview:{matches:(0,g.mapArrayOrNot)(b.preview.matches,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character})),text:b.preview.text},ranges:(0,g.mapArrayOrNot)(b.ranges,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character}))}:{text:b.text,lineNumber:b.lineNumber}}function y(b){return!!b.preview}e.extensionResultIsMatch=y;class P{constructor(o,s){this.maxBatchSize=o,this.cb=s,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(o,s){!o||this.addItemToBatch(o,s)}addItems(o,s){!o||this.addItemsToBatch(o,s)}addItemToBatch(o,s){this.batch.push(o),this.batchSize+=s,this.onUpdate()}addItemsToBatch(o,s){this.batch=this.batch.concat(o),this.batchSize+=s,this.onUpdate()}onUpdate(){this.totalNumberCompleted<P.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},P.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=P,P.TIMEOUT=4e3,P.START_BATCH_AFTER_COUNT=50}),define(fe[75],me([0,1,6,5,4,276,14,67,11,2,135]),function(Y,e,g,L,D,S,T,C,E,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,D.createDecorator)("IExtHostSearch");let I=class{constructor(w,y,P){this.extHostRpc=w,this._uriTransformer=y,this._logService=P,this._proxy=this.extHostRpc.getProxy(L.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new S.FileSearchManager}_transformScheme(w){return this._uriTransformer.transformOutgoingScheme(w)}registerTextSearchProvider(w,y){if(this._textSearchUsedSchemes.has(w))throw new Error(`a text search provider for the scheme '${w}' is already registered`);this._textSearchUsedSchemes.add(w);const P=this._handlePool++;return this._textSearchProvider.set(P,y),this._proxy.$registerTextSearchProvider(P,this._transformScheme(w)),(0,g.toDisposable)(()=>{this._textSearchUsedSchemes.delete(w),this._textSearchProvider.delete(P),this._proxy.$unregisterProvider(P)})}registerFileSearchProvider(w,y){if(this._fileSearchUsedSchemes.has(w))throw new Error(`a file search provider for the scheme '${w}' is already registered`);this._fileSearchUsedSchemes.add(w);const P=this._handlePool++;return this._fileSearchProvider.set(P,y),this._proxy.$registerFileSearchProvider(P,this._transformScheme(w)),(0,g.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(w),this._fileSearchProvider.delete(P),this._proxy.$unregisterProvider(P)})}$provideFileSearchResults(w,y,P,b){const o=a(P),s=this._fileSearchProvider.get(w);if(s)return this._fileSearchManager.fileSearch(o,s,v=>{this._proxy.$handleFileMatch(w,y,v.map(n=>n.resource))},b);throw new Error("unknown provider: "+w)}$clearCache(w){return this._fileSearchManager.clearCache(w),Promise.resolve(void 0)}$provideTextSearchResults(w,y,P,b){const o=this._textSearchProvider.get(w);if(!o||!o.provideTextSearchResults)throw new Error(`Unknown provider ${w}`);const s=a(P);return this.createTextSearchManager(s,o).search(n=>this._proxy.$handleTextMatch(w,y,n),b)}$enableExtensionHostSearch(){}createTextSearchManager(w,y){return new i.TextSearchManager(w,y,{readdir:P=>Promise.resolve([]),toCanonicalName:P=>P},"textSearchProvider")}};I=Ve([$e(0,T.IExtHostRpcService),$e(1,C.IURITransformerService),$e(2,E.ILogService)],I),e.ExtHostSearch=I;function a(h){return{...h,folderQueries:h.folderQueries&&h.folderQueries.map(p),extraFileResources:h.extraFileResources&&h.extraFileResources.map(w=>k.URI.revive(w))}}e.reviveQuery=a;function p(h){return{...h,folder:k.URI.revive(h.folder)}}}),define(fe[277],me([0,1,21,18,3,50,2,114,109,147,83,43,5,235,234,40,236,37,237,238,239,221,240,46,41,241,222,244,245,246,133,224,251,252,253,92,33,255,225,17,7,258,71,134,36,35,59,209,243,64,131,73,57,75,11,67,14,26,247,206,54,68,232,256,205,70,69,261,259,260,233,45,254,257,91,56,122,249,72,250,10,192,248,203,242]),function(Y,e,g,L,D,S,T,C,E,k,i,I,a,p,h,w,y,P,b,o,s,v,n,f,r,t,u,l,c,m,d,_,A,R,B,U,F,$,M,z,N,x,j,O,H,W,X,Q,de,_e,Ce,Pe,Be,We,He,G,ee,ie,ce,Z,re,pe,Me,je,Ke,Ze,rt,ct,ye,at,J,ne,Ee,Qe,et,le,Ie,Ne,Xe,nt,ft,tt,ut,Re,De){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Te(se){const ue=se.get(ie.IExtHostInitDataService),we=se.get(ne.IExtHostFileSystemInfo),ve=se.get(rt.IExtHostConsumerFileSystem),Fe=se.get(r.IExtHostExtensionService),qe=se.get(H.IExtHostWorkspace),ze=se.get(Ie.IExtHostTelemetry),Ye=se.get(P.IExtHostConfiguration),lt=se.get(G.IURITransformerService),xe=se.get(ee.IExtHostRpcService),ge=se.get(U.IExtHostStorage),be=se.get(Ze.IExtensionStoragePaths),ae=se.get(He.ILoggerService),K=se.get(He.ILogService),Se=se.get(re.IExtHostTunnelService),Le=se.get(pe.IExtHostApiDeprecationService),it=se.get(O.IExtHostWindow),Ge=se.get(et.IExtHostSecretState),mt=se.get(le.IExtHostEditorTabs);xe.set(a.ExtHostContext.ExtHostFileSystemInfo,we),xe.set(a.ExtHostContext.ExtHostLogLevelServiceShape,ae),xe.set(a.ExtHostContext.ExtHostWorkspace,qe),xe.set(a.ExtHostContext.ExtHostConfiguration,Ye),xe.set(a.ExtHostContext.ExtHostExtensionService,Fe),xe.set(a.ExtHostContext.ExtHostStorage,ge),xe.set(a.ExtHostContext.ExtHostTunnelService,Se),xe.set(a.ExtHostContext.ExtHostWindow,it),xe.set(a.ExtHostContext.ExtHostSecretState,Ge),xe.set(a.ExtHostContext.ExtHostTelemetry,ze),xe.set(a.ExtHostContext.ExtHostEditorTabs,mt);const yt=xe.set(a.ExtHostContext.ExtHostDecorations,se.get(Ce.IExtHostDecorations)),Et=xe.set(a.ExtHostContext.ExtHostDocumentsAndEditors,se.get(f.IExtHostDocumentsAndEditors)),gt=xe.set(a.ExtHostContext.ExtHostCommands,se.get(w.IExtHostCommands)),bt=xe.set(a.ExtHostContext.ExtHostTerminalService,se.get(F.IExtHostTerminalService)),vt=xe.set(a.ExtHostContext.ExtHostDebugService,se.get(Be.IExtHostDebugService)),Tt=xe.set(a.ExtHostContext.ExtHostSearch,se.get(We.IExtHostSearch)),Dt=xe.set(a.ExtHostContext.ExtHostTask,se.get(Pe.IExtHostTask)),$t=xe.set(a.ExtHostContext.ExtHostOutputService,se.get(d.IExtHostOutputService)),jt=xe.set(a.ExtHostContext.ExtHostUrls,new x.ExtHostUrls(xe)),kt=xe.set(a.ExtHostContext.ExtHostDocuments,new n.ExtHostDocuments(xe,Et)),Wt=xe.set(a.ExtHostContext.ExtHostDocumentContentProviders,new s.ExtHostDocumentContentProvider(xe,Et,K)),ii=xe.set(a.ExtHostContext.ExtHostDocumentSaveParticipant,new v.ExtHostDocumentSaveParticipant(K,kt,xe.getProxy(a.MainContext.MainThreadBulkEdits))),_t=xe.set(a.ExtHostContext.ExtHostNotebook,new ce.ExtHostNotebookController(xe,gt,Et,kt,be)),Xt=xe.set(a.ExtHostContext.ExtHostNotebookDocuments,new Re.ExtHostNotebookDocuments(K,_t)),qt=xe.set(a.ExtHostContext.ExtHostNotebookEditors,new ut.ExtHostNotebookEditors(K,xe,_t)),ni=xe.set(a.ExtHostContext.ExtHostNotebookKernels,new Ne.ExtHostNotebookKernels(xe,ue,_t,gt,K)),ri=xe.set(a.ExtHostContext.ExtHostNotebookRenderers,new nt.ExtHostNotebookRenderers(xe,_t)),At=xe.set(a.ExtHostContext.ExtHostEditors,new $.ExtHostEditors(xe,Et)),Yt=xe.set(a.ExtHostContext.ExtHostTreeViews,new M.ExtHostTreeViews(xe.getProxy(a.MainContext.MainThreadTreeViews),gt,K)),bi=xe.set(a.ExtHostContext.ExtHostEditorInsets,new Q.ExtHostEditorInsets(xe.getProxy(a.MainContext.MainThreadEditorInsets),At,ue)),Ht=xe.set(a.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(xe,K,we)),zt=xe.set(a.ExtHostContext.ExtHostLanguages,new c.ExtHostLanguages(xe,kt,gt.converter,lt)),wt=xe.set(a.ExtHostContext.ExtHostLanguageFeatures,new l.ExtHostLanguageFeatures(xe,lt,kt,gt,Ht,K,Le)),si=xe.set(a.ExtHostContext.ExtHostFileSystem,new t.ExtHostFileSystem(xe,wt)),Nt=xe.set(a.ExtHostContext.ExtHostFileSystemEventService,new u.ExtHostFileSystemEventService(xe,K,Et)),Ut=xe.set(a.ExtHostContext.ExtHostQuickOpen,(0,A.createExtHostQuickOpen)(xe,qe,gt)),Jt=xe.set(a.ExtHostContext.ExtHostSCM,new R.ExtHostSCM(xe,gt,K)),Ei=xe.set(a.ExtHostContext.ExtHostComments,(0,y.createExtHostComments)(xe,gt,kt)),fi=xe.set(a.ExtHostContext.ExtHostProgress,new _.ExtHostProgress(xe.getProxy(a.MainContext.MainThreadProgress))),_i=xe.set(a.ExtHostContext.ExtHosLabelService,new de.ExtHostLabelService(xe)),mi=xe.set(a.ExtHostContext.ExtHostTheming,new Z.ExtHostTheming(xe)),Zt=xe.set(a.ExtHostContext.ExtHostAuthentication,new Me.ExtHostAuthentication(xe)),oi=xe.set(a.ExtHostContext.ExtHostTimeline,new je.ExtHostTimeline(xe,gt)),Gt=xe.set(a.ExtHostContext.ExtHostWebviews,new j.ExtHostWebviews(xe,{remote:ue.remote},qe,K,Le)),ai=xe.set(a.ExtHostContext.ExtHostWebviewPanels,new at.ExtHostWebviewPanels(xe,Gt,qe)),Si=xe.set(a.ExtHostContext.ExtHostCustomEditors,new ye.ExtHostCustomEditors(xe,kt,be,Gt,ai)),yi=xe.set(a.ExtHostContext.ExtHostWebviewViews,new ct.ExtHostWebviewViews(xe,Gt)),Kt=xe.set(a.ExtHostContext.ExtHostTesting,new Ee.ExtHostTesting(xe,gt)),ei=xe.set(a.ExtHostContext.ExtHostUriOpeners,new Qe.ExtHostUriOpeners(xe));xe.set(a.ExtHostContext.ExtHostInteractive,new De.ExtHostInteractive(xe,_t,Et,gt));const Di=(0,X.values)(a.ExtHostContext);xe.assertRegistered(Di);const Ci=new J.ExtHostBulkEdits(xe,Et),li=new h.ExtHostClipboard(xe),ci=new m.ExtHostMessageService(xe,K),Vt=new o.ExtHostDialogs(xe),Mt=new B.ExtHostStatusBar(xe,gt.converter);return p.ExtHostApiCommands.register(gt),function(Ue,Lt,Qt){const St=function(){let te=!Ue.isUnderDevelopment;function he(Ae){te||(K.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Ae(dt){if(Array.isArray(dt))dt.forEach(Ae);else if(typeof dt=="string")he(dt);else{const Ct=dt;typeof Ct.scheme=="undefined"&&he(dt),!Ue.enableProposedApi&&typeof Ct.exclusive=="boolean"&&(0,W.throwProposedApiError)(Ue)}return dt}}(),ki={getSession(te,he,Ae){return(Ae?.forceNewSession||Ae?.silent)&&(0,W.checkProposedApiEnabled)(Ue),Zt.getSession(Ue,te,he,Ae)},async hasSession(te,he){return(0,W.checkProposedApiEnabled)(Ue),!!await Zt.getSession(Ue,te,he,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(te,he,Ae,dt){return Zt.registerAuthenticationProvider(te,he,Ae,dt)}},Ii={registerCommand(te,he,Ae){return gt.registerCommand(!0,te,he,Ae,void 0,Ue)},registerTextEditorCommand(te,he,Ae){return gt.registerCommand(!0,te,(...dt)=>{const Ct=At.getActiveTextEditor();if(!Ct){K.warn("Cannot execute "+te+" because there is no active text editor.");return}return Ct.edit(Pt=>{he.apply(Ae,[Ct,Pt,...dt])}).then(Pt=>{Pt||K.warn("Edits from command "+te+" were not applied.")},Pt=>{K.warn("An error occurred while running command "+te,Pt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(te,he,Ae)=>((0,W.checkProposedApiEnabled)(Ue),gt.registerCommand(!0,te,async(...dt)=>{const Ct=Et.activeEditor(!0);if(!Ct){K.warn("Cannot execute "+te+" because there is no active text editor.");return}const Pt=await At.getDiffInformation(Ct.id);he.apply(Ae,[Pt,...dt])},void 0,void 0,Ue)),executeCommand(te,...he){return gt.executeCommand(te,...he)},getCommands(te=!1){return gt.getCommands(te)}},gi={get machineId(){return ue.telemetryInfo.machineId},get sessionId(){return ue.telemetryInfo.sessionId},get language(){return ue.environment.appLanguage},get appName(){return ue.environment.appName},get appRoot(){return ue.environment.appRoot?.fsPath??""},get appHost(){return ue.environment.appHost},get uriScheme(){return ue.environment.appUriScheme},get clipboard(){return li.value},get shell(){return bt.getDefaultShell(!1)},get isTelemetryEnabled(){return ze.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return ze.onDidChangeTelemetryEnabled},get isNewAppInstall(){const te=Date.now()-new Date(ue.telemetryInfo.firstSessionDate).getTime();return isNaN(te)?!1:te<1e3*60*60*24},openExternal(te,he){return it.openUri(te,{allowTunneling:!!ue.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===ue.environment.appUriScheme)return jt.createAppUri(te);try{return await it.asExternalUri(te,{allowTunneling:!!ue.remote.authority})}catch(he){if((0,tt.matchesScheme)(te,ft.Schemas.http)||(0,tt.matchesScheme)(te,ft.Schemas.https))return te;throw he}},get remoteName(){return(0,_e.getRemoteName)(ue.remote.authority)},get remoteAuthority(){return(0,W.checkProposedApiEnabled)(Ue),ue.remote.authority},get uiKind(){return ue.uiKind}};ue.environment.extensionTestsLocationURI||Object.freeze(gi);const pi=ue.remote.isRemote?N.ExtensionKind.Workspace:N.ExtensionKind.UI,Pi={createTestController(te,he){return Kt.createTestController(te,he)},createTestObserver(){return(0,W.checkProposedApiEnabled)(Ue),Kt.createTestObserver()},runTests(te){return(0,W.checkProposedApiEnabled)(Ue),Kt.runTests(te)},get onDidChangeTestResults(){return(0,W.checkProposedApiEnabled)(Ue),Kt.onResultsChanged},get testResults(){return(0,W.checkProposedApiEnabled)(Ue),Kt.results}},Ti={getExtension(te){const he=Lt.getExtensionDescription(te);if(he)return new r.Extension(Fe,Ue.identifier,he,pi)},get all(){return Lt.getAllExtensionDescriptions().map(te=>new r.Extension(Fe,Ue.identifier,te,pi))},get onDidChange(){return Lt.onDidChange}},ui={createDiagnosticCollection(te){return Ht.createDiagnosticCollection(Ue.identifier,te)},get onDidChangeDiagnostics(){return Ht.onDidChangeDiagnostics},getDiagnostics:te=>Ht.getDiagnostics(te),getLanguages(){return zt.getLanguages()},setTextDocumentLanguage(te,he){return zt.changeLanguage(te.uri,he)},match(te,he){return(0,i.score)(z.LanguageSelector.from(te),he.uri,he.languageId,!0)},registerCodeActionsProvider(te,he,Ae){return wt.registerCodeActionProvider(Ue,St(te),he,Ae)},registerCodeLensProvider(te,he){return wt.registerCodeLensProvider(Ue,St(te),he)},registerDefinitionProvider(te,he){return wt.registerDefinitionProvider(Ue,St(te),he)},registerDeclarationProvider(te,he){return wt.registerDeclarationProvider(Ue,St(te),he)},registerImplementationProvider(te,he){return wt.registerImplementationProvider(Ue,St(te),he)},registerTypeDefinitionProvider(te,he){return wt.registerTypeDefinitionProvider(Ue,St(te),he)},registerHoverProvider(te,he){return wt.registerHoverProvider(Ue,St(te),he,Ue.identifier)},registerEvaluatableExpressionProvider(te,he){return wt.registerEvaluatableExpressionProvider(Ue,St(te),he,Ue.identifier)},registerInlineValuesProvider(te,he){return wt.registerInlineValuesProvider(Ue,St(te),he,Ue.identifier)},registerDocumentHighlightProvider(te,he){return wt.registerDocumentHighlightProvider(Ue,St(te),he)},registerLinkedEditingRangeProvider(te,he){return wt.registerLinkedEditingRangeProvider(Ue,St(te),he)},registerReferenceProvider(te,he){return wt.registerReferenceProvider(Ue,St(te),he)},registerRenameProvider(te,he){return wt.registerRenameProvider(Ue,St(te),he)},registerDocumentSymbolProvider(te,he,Ae){return wt.registerDocumentSymbolProvider(Ue,St(te),he,Ae)},registerWorkspaceSymbolProvider(te){return wt.registerWorkspaceSymbolProvider(Ue,te)},registerDocumentFormattingEditProvider(te,he){return wt.registerDocumentFormattingEditProvider(Ue,St(te),he)},registerDocumentRangeFormattingEditProvider(te,he){return wt.registerDocumentRangeFormattingEditProvider(Ue,St(te),he)},registerOnTypeFormattingEditProvider(te,he,Ae,...dt){return wt.registerOnTypeFormattingEditProvider(Ue,St(te),he,[Ae].concat(dt))},registerDocumentSemanticTokensProvider(te,he,Ae){return wt.registerDocumentSemanticTokensProvider(Ue,St(te),he,Ae)},registerDocumentRangeSemanticTokensProvider(te,he,Ae){return wt.registerDocumentRangeSemanticTokensProvider(Ue,St(te),he,Ae)},registerSignatureHelpProvider(te,he,Ae,...dt){return typeof Ae=="object"?wt.registerSignatureHelpProvider(Ue,St(te),he,Ae):wt.registerSignatureHelpProvider(Ue,St(te),he,typeof Ae=="undefined"?[]:[Ae,...dt])},registerCompletionItemProvider(te,he,...Ae){return wt.registerCompletionItemProvider(Ue,St(te),he,Ae)},registerInlineCompletionItemProvider(te,he){return(0,W.checkProposedApiEnabled)(Ue),wt.registerInlineCompletionsProvider(Ue,St(te),he)},registerDocumentLinkProvider(te,he){return wt.registerDocumentLinkProvider(Ue,St(te),he)},registerColorProvider(te,he){return wt.registerColorProvider(Ue,St(te),he)},registerFoldingRangeProvider(te,he){return wt.registerFoldingRangeProvider(Ue,St(te),he)},registerSelectionRangeProvider(te,he){return wt.registerSelectionRangeProvider(Ue,te,he)},registerCallHierarchyProvider(te,he){return wt.registerCallHierarchyProvider(Ue,te,he)},registerTypeHierarchyProvider(te,he){return wt.registerTypeHierarchyProvider(Ue,te,he)},setLanguageConfiguration:(te,he)=>wt.setLanguageConfiguration(Ue,te,he),getTokenInformationAtPosition(te,he){return(0,W.checkProposedApiEnabled)(Ue),zt.tokenAtPosition(te,he)},registerInlayHintsProvider(te,he){return(0,W.checkProposedApiEnabled)(Ue),wt.registerInlayHintsProvider(Ue,te,he)},createLanguageStatusItem(te,he){return(0,W.checkProposedApiEnabled)(Ue),zt.createLanguageStatusItem(Ue,te,he)}},Ai={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return bt.activeTerminal},get terminals(){return bt.terminals},async showTextDocument(te,he,Ae){const dt=await(T.URI.isUri(te)?Promise.resolve(vi.openTextDocument(te)):Promise.resolve(te));return At.showTextDocument(dt,he,Ae)},createTextEditorDecorationType(te){return At.createTextEditorDecorationType(Ue,te)},onDidChangeActiveTextEditor(te,he,Ae){return At.onDidChangeActiveTextEditor(te,he,Ae)},onDidChangeVisibleTextEditors(te,he,Ae){return At.onDidChangeVisibleTextEditors(te,he,Ae)},onDidChangeTextEditorSelection(te,he,Ae){return At.onDidChangeTextEditorSelection(te,he,Ae)},onDidChangeTextEditorOptions(te,he,Ae){return At.onDidChangeTextEditorOptions(te,he,Ae)},onDidChangeTextEditorVisibleRanges(te,he,Ae){return At.onDidChangeTextEditorVisibleRanges(te,he,Ae)},onDidChangeTextEditorViewColumn(te,he,Ae){return At.onDidChangeTextEditorViewColumn(te,he,Ae)},onDidCloseTerminal(te,he,Ae){return bt.onDidCloseTerminal(te,he,Ae)},onDidOpenTerminal(te,he,Ae){return bt.onDidOpenTerminal(te,he,Ae)},onDidChangeActiveTerminal(te,he,Ae){return bt.onDidChangeActiveTerminal(te,he,Ae)},onDidChangeTerminalDimensions(te,he,Ae){return(0,W.checkProposedApiEnabled)(Ue),bt.onDidChangeTerminalDimensions(te,he,Ae)},onDidChangeTerminalState(te,he,Ae){return bt.onDidChangeTerminalState(te,he,Ae)},onDidWriteTerminalData(te,he,Ae){return(0,W.checkProposedApiEnabled)(Ue),bt.onDidWriteTerminalData(te,he,Ae)},get state(){return it.state},onDidChangeWindowState(te,he,Ae){return it.onDidChangeWindowState(te,he,Ae)},showInformationMessage(te,...he){return ci.showMessage(Ue,S.default.Info,te,he[0],he.slice(1))},showWarningMessage(te,...he){return ci.showMessage(Ue,S.default.Warning,te,he[0],he.slice(1))},showErrorMessage(te,...he){return ci.showMessage(Ue,S.default.Error,te,he[0],he.slice(1))},showQuickPick(te,he,Ae){return Ut.showQuickPick(te,!!Ue.enableProposedApi,he,Ae)},showWorkspaceFolderPick(te){return Ut.showWorkspaceFolderPick(te)},showInputBox(te,he){return Ut.showInput(te,he)},showOpenDialog(te){return Vt.showOpenDialog(te)},showSaveDialog(te){return Vt.showSaveDialog(te)},createStatusBarItem(te,he,Ae){let dt,Ct,Pt;return typeof te=="string"?(dt=te,Ct=he,Pt=Ae):(Ct=te,Pt=he),Mt.createStatusBarEntry(Ue,dt,Ct,Pt)},setStatusBarMessage(te,he){return Mt.setStatusBarMessage(te,he)},withScmProgress(te){return Le.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),fi.withProgress(Ue,{location:N.ProgressLocation.SourceControl},(he,Ae)=>te({report(dt){}}))},withProgress(te,he){return fi.withProgress(Ue,te,he)},createOutputChannel(te){return $t.createOutputChannel(te,Ue)},createWebviewPanel(te,he,Ae,dt){return ai.createWebviewPanel(Ue,te,he,Ae,dt)},createWebviewTextEditorInset(te,he,Ae,dt){return(0,W.checkProposedApiEnabled)(Ue),bi.createWebviewEditorInset(te,he,Ae,dt,Ue)},createTerminal(te,he,Ae){return typeof te=="object"?("location"in te&&(0,W.checkProposedApiEnabled)(Ue),"pty"in te?bt.createExtensionTerminal(te):bt.createTerminalFromOptions(te)):bt.createTerminal(te,he,Ae)},registerTerminalLinkProvider(te){return bt.registerLinkProvider(te)},registerTerminalProfileProvider(te,he){return bt.registerProfileProvider(Ue,te,he)},registerTreeDataProvider(te,he){return Yt.registerTreeDataProvider(te,he,Ue)},createTreeView(te,he){return Yt.createTreeView(te,he,Ue)},registerWebviewPanelSerializer:(te,he)=>ai.registerWebviewPanelSerializer(Ue,te,he),registerCustomEditorProvider:(te,he,Ae={})=>Si.registerCustomEditorProvider(Ue,te,he,Ae),registerFileDecorationProvider(te){return yt.registerFileDecorationProvider(te,Ue.identifier)},registerUriHandler(te){return jt.registerUriHandler(Ue.identifier,te)},createQuickPick(){return Ut.createQuickPick(Ue.identifier,!!Ue.enableProposedApi)},createInputBox(){return Ut.createInputBox(Ue.identifier)},get activeColorTheme(){return mi.activeColorTheme},onDidChangeActiveColorTheme(te,he,Ae){return mi.onDidChangeActiveColorTheme(te,he,Ae)},registerWebviewViewProvider(te,he,Ae){return yi.registerWebviewViewProvider(Ue,te,he,Ae?.webviewOptions)},get activeNotebookEditor(){return(0,W.checkProposedApiEnabled)(Ue),_t.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,he,Ae){return(0,W.checkProposedApiEnabled)(Ue),_t.onDidChangeActiveNotebookEditor(te,he,Ae)},get visibleNotebookEditors(){return(0,W.checkProposedApiEnabled)(Ue),_t.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,W.checkProposedApiEnabled)(Ue),_t.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,he,Ae){return(0,W.checkProposedApiEnabled)(Ue),qt.onDidChangeNotebookEditorSelection(te,he,Ae)},onDidChangeNotebookEditorVisibleRanges(te,he,Ae){return(0,W.checkProposedApiEnabled)(Ue),qt.onDidChangeNotebookEditorVisibleRanges(te,he,Ae)},showNotebookDocument(te,he){return(0,W.checkProposedApiEnabled)(Ue),_t.showNotebookDocument(te,he)},registerExternalUriOpener(te,he,Ae){return(0,W.checkProposedApiEnabled)(Ue),ei.registerExternalUriOpener(Ue.identifier,te,he,Ae)},get tabs(){return(0,W.checkProposedApiEnabled)(Ue),mt.tabs},get activeTab(){return(0,W.checkProposedApiEnabled)(Ue),mt.activeTab},get onDidChangeTabs(){return(0,W.checkProposedApiEnabled)(Ue),mt.onDidChangeTabs},get onDidChangeActiveTab(){return(0,W.checkProposedApiEnabled)(Ue),mt.onDidChangeActiveTab},getInlineCompletionItemController(te){return(0,W.checkProposedApiEnabled)(Ue),l.InlineCompletionController.get(te)}},vi={get rootPath(){return Le.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),qe.getPath()},set rootPath(te){throw L.readonly()},getWorkspaceFolder(te){return qe.getWorkspaceFolder(te)},get workspaceFolders(){return qe.getWorkspaceFolders()},get name(){return qe.name},set name(te){throw L.readonly()},get workspaceFile(){return qe.workspaceFile},set workspaceFile(te){throw L.readonly()},updateWorkspaceFolders:(te,he,...Ae)=>qe.updateWorkspaceFolders(Ue,te,he||0,...Ae),onDidChangeWorkspaceFolders:function(te,he,Ae){return qe.onDidChangeWorkspace(te,he,Ae)},asRelativePath:(te,he)=>qe.getRelativePath(te,he),findFiles:(te,he,Ae,dt)=>qe.findFiles(z.GlobPattern.from(te),z.GlobPattern.from(he),Ae,Ue.identifier,dt),findTextInFiles:(te,he,Ae,dt)=>{let Ct,Pt;return typeof he=="object"?(Ct=he,Pt=Ae):(Ct={},Pt=he,dt=Ae),qe.findTextInFiles(te,Ct||{},Pt,Ue.identifier,dt)},saveAll:te=>qe.saveAll(te),applyEdit(te){return Ci.applyWorkspaceEdit(te)},createFileSystemWatcher:(te,he,Ae,dt)=>Nt.createFileSystemWatcher(z.GlobPattern.from(te),he,Ae,dt),get textDocuments(){return kt.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw L.readonly()},openTextDocument(te){let he;const Ae=te;if(typeof te=="string")he=Promise.resolve(T.URI.file(te));else if(T.URI.isUri(te))he=Promise.resolve(te);else if(!Ae||typeof Ae=="object")he=kt.createDocumentData(Ae);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(dt=>kt.ensureDocumentData(dt).then(Ct=>Ct.document))},onDidOpenTextDocument:(te,he,Ae)=>kt.onDidAddDocument(te,he,Ae),onDidCloseTextDocument:(te,he,Ae)=>kt.onDidRemoveDocument(te,he,Ae),onDidChangeTextDocument:(te,he,Ae)=>kt.onDidChangeDocument(te,he,Ae),onDidSaveTextDocument:(te,he,Ae)=>kt.onDidSaveDocument(te,he,Ae),onWillSaveTextDocument:(te,he,Ae)=>ii.getOnWillSaveTextDocumentEvent(Ue)(te,he,Ae),get notebookDocuments(){return _t.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,he){let Ae;if(T.URI.isUri(te))Ae=te,await _t.openNotebookDocument(te);else if(typeof te=="string")Ae=T.URI.revive(await _t.createNotebookDocument({viewType:te,content:he}));else throw new Error("Invalid arguments");return _t.getNotebookDocument(Ae).apiNotebook},get onDidOpenNotebookDocument(){return _t.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return _t.onDidCloseNotebookDocument},registerNotebookSerializer(te,he,Ae,dt){return _t.registerNotebookSerializer(Ue,te,he,Ae,Ue.enableProposedApi?dt:void 0)},registerNotebookContentProvider:(te,he,Ae,dt)=>((0,W.checkProposedApiEnabled)(Ue),_t.registerNotebookContentProvider(Ue,te,he,Ae,Ue.enableProposedApi?dt:void 0)),onDidChangeConfiguration:(te,he,Ae)=>Qt.onDidChangeConfiguration(te,he,Ae),getConfiguration(te,he){return he=arguments.length===1?void 0:he,Qt.getConfiguration(te,he,Ue)},registerTextDocumentContentProvider(te,he){return Wt.registerTextDocumentContentProvider(te,he)},registerTaskProvider:(te,he)=>(Le.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),Dt.registerTaskProvider(Ue,te,he)),registerFileSystemProvider(te,he,Ae){return si.registerFileSystemProvider(Ue.identifier,te,he,Ae)},get fs(){return ve.value},registerFileSearchProvider:(te,he)=>((0,W.checkProposedApiEnabled)(Ue),Tt.registerFileSearchProvider(te,he)),registerTextSearchProvider:(te,he)=>((0,W.checkProposedApiEnabled)(Ue),Tt.registerTextSearchProvider(te,he)),registerRemoteAuthorityResolver:(te,he)=>((0,W.checkProposedApiEnabled)(Ue),Fe.registerRemoteAuthorityResolver(te,he)),registerResourceLabelFormatter:te=>((0,W.checkProposedApiEnabled)(Ue),_i.$registerResourceLabelFormatter(te)),onDidCreateFiles:(te,he,Ae)=>Nt.onDidCreateFile(te,he,Ae),onDidDeleteFiles:(te,he,Ae)=>Nt.onDidDeleteFile(te,he,Ae),onDidRenameFiles:(te,he,Ae)=>Nt.onDidRenameFile(te,he,Ae),onWillCreateFiles:(te,he,Ae)=>Nt.getOnWillCreateFileEvent(Ue)(te,he,Ae),onWillDeleteFiles:(te,he,Ae)=>Nt.getOnWillDeleteFileEvent(Ue)(te,he,Ae),onWillRenameFiles:(te,he,Ae)=>Nt.getOnWillRenameFileEvent(Ue)(te,he,Ae),openTunnel:te=>((0,W.checkProposedApiEnabled)(Ue),Se.openTunnel(Ue,te).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,W.checkProposedApiEnabled)(Ue),Se.getTunnels()},onDidChangeTunnels:(te,he,Ae)=>((0,W.checkProposedApiEnabled)(Ue),Se.onDidChangeTunnels(te,he,Ae)),registerPortAttributesProvider:(te,he)=>((0,W.checkProposedApiEnabled)(Ue),Se.registerPortsAttributesProvider(te,he)),registerTimelineProvider:(te,he)=>((0,W.checkProposedApiEnabled)(Ue),oi.registerTimelineProvider(te,he,Ue.identifier,gt.converter)),get isTrusted(){return qe.trusted},requestWorkspaceTrust:te=>((0,W.checkProposedApiEnabled)(Ue),qe.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,he,Ae)=>qe.onDidGrantWorkspaceTrust(te,he,Ae)},Ri={get inputBox(){return Le.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),Jt.getLastInputBox(Ue)},createSourceControl(te,he,Ae){return Jt.createSourceControl(Ue,te,he,Ae)}},Li={createCommentController(te,he){return Ei.createCommentController(Ue,te,he)}},Fi={get activeDebugSession(){return vt.activeDebugSession},get activeDebugConsole(){return vt.activeDebugConsole},get breakpoints(){return vt.breakpoints},onDidStartDebugSession(te,he,Ae){return vt.onDidStartDebugSession(te,he,Ae)},onDidTerminateDebugSession(te,he,Ae){return vt.onDidTerminateDebugSession(te,he,Ae)},onDidChangeActiveDebugSession(te,he,Ae){return vt.onDidChangeActiveDebugSession(te,he,Ae)},onDidReceiveDebugSessionCustomEvent(te,he,Ae){return vt.onDidReceiveDebugSessionCustomEvent(te,he,Ae)},onDidChangeBreakpoints(te,he,Ae){return vt.onDidChangeBreakpoints(te,he,Ae)},registerDebugConfigurationProvider(te,he,Ae){return vt.registerDebugConfigurationProvider(te,he,Ae||N.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,he){return vt.registerDebugAdapterDescriptorFactory(Ue,te,he)},registerDebugAdapterTrackerFactory(te,he){return vt.registerDebugAdapterTrackerFactory(te,he)},startDebugging(te,he,Ae){return!Ae||typeof Ae=="object"&&"configuration"in Ae?vt.startDebugging(te,he,{parentSession:Ae}):vt.startDebugging(te,he,Ae||{})},stopDebugging(te){return vt.stopDebugging(te)},addBreakpoints(te){return vt.addBreakpoints(te)},removeBreakpoints(te){return vt.removeBreakpoints(te)},asDebugSourceUri(te,he){return vt.asDebugSourceUri(te,he)}},Mi={registerTaskProvider:(te,he)=>Dt.registerTaskProvider(Ue,te,he),fetchTasks:te=>Dt.fetchTasks(te),executeTask:te=>Dt.executeTask(Ue,te),get taskExecutions(){return Dt.taskExecutions},onDidStartTask:(te,he,Ae)=>Dt.onDidStartTask(te,he,Ae),onDidEndTask:(te,he,Ae)=>Dt.onDidEndTask(te,he,Ae),onDidStartTaskProcess:(te,he,Ae)=>Dt.onDidStartTaskProcess(te,he,Ae),onDidEndTaskProcess:(te,he,Ae)=>Dt.onDidEndTaskProcess(te,he,Ae)},Oi={createNotebookController(te,he,Ae,dt,Ct){return ni.createNotebookController(Ue,te,he,Ae,dt,Ue.enableProposedApi?Ct:void 0)},registerNotebookCellStatusBarItemProvider:(te,he)=>_t.registerNotebookCellStatusBarItemProvider(Ue,te,he),get onDidSaveNotebookDocument(){return(0,W.checkProposedApiEnabled)(Ue),Xt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(te){return(0,W.checkProposedApiEnabled)(Ue),qt.createNotebookEditorDecorationType(te)},createRendererMessaging(te){return ri.createRendererMessaging(Ue,te)},onDidChangeNotebookDocumentMetadata(te,he,Ae){return(0,W.checkProposedApiEnabled)(Ue),Xt.onDidChangeNotebookDocumentMetadata(te,he,Ae)},onDidChangeNotebookCells(te,he,Ae){return(0,W.checkProposedApiEnabled)(Ue),_t.onDidChangeNotebookCells(te,he,Ae)},onDidChangeNotebookCellExecutionState(te,he,Ae){return(0,W.checkProposedApiEnabled)(Ue),_t.onDidChangeNotebookCellExecutionState(te,he,Ae)},onDidChangeCellOutputs(te,he,Ae){return(0,W.checkProposedApiEnabled)(Ue),_t.onDidChangeCellOutputs(te,he,Ae)},onDidChangeCellMetadata(te,he,Ae){return(0,W.checkProposedApiEnabled)(Ue),_t.onDidChangeCellMetadata(te,he,Ae)},createConcatTextDocument(te,he){return(0,W.checkProposedApiEnabled)(Ue),new Ke.ExtHostNotebookConcatDocument(_t,kt,te,he)}};return{version:ue.version,authentication:ki,commands:Ii,comments:Li,debug:Fi,env:gi,extensions:Ti,languages:ui,notebooks:Oi,scm:Ri,tasks:Mi,tests:Pi,window:Ai,workspace:vi,Breakpoint:N.Breakpoint,CallHierarchyIncomingCall:N.CallHierarchyIncomingCall,CallHierarchyItem:N.CallHierarchyItem,CallHierarchyOutgoingCall:N.CallHierarchyOutgoingCall,CancellationError:L.CancellationError,CancellationTokenSource:g.CancellationTokenSource,CandidatePortSource:a.CandidatePortSource,CodeAction:N.CodeAction,CodeActionKind:N.CodeActionKind,CodeActionTriggerKind:N.CodeActionTriggerKind,CodeLens:N.CodeLens,Color:N.Color,ColorInformation:N.ColorInformation,ColorPresentation:N.ColorPresentation,ColorThemeKind:N.ColorThemeKind,CommentMode:N.CommentMode,CommentThreadCollapsibleState:N.CommentThreadCollapsibleState,CompletionItem:N.CompletionItem,CompletionItemKind:N.CompletionItemKind,CompletionItemTag:N.CompletionItemTag,CompletionList:N.CompletionList,CompletionTriggerKind:N.CompletionTriggerKind,ConfigurationTarget:N.ConfigurationTarget,CustomExecution:N.CustomExecution,DebugAdapterExecutable:N.DebugAdapterExecutable,DebugAdapterInlineImplementation:N.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:N.DebugAdapterNamedPipeServer,DebugAdapterServer:N.DebugAdapterServer,DebugConfigurationProviderTriggerKind:N.DebugConfigurationProviderTriggerKind,DebugConsoleMode:N.DebugConsoleMode,DecorationRangeBehavior:N.DecorationRangeBehavior,Diagnostic:N.Diagnostic,DiagnosticRelatedInformation:N.DiagnosticRelatedInformation,DiagnosticSeverity:N.DiagnosticSeverity,DiagnosticTag:N.DiagnosticTag,Disposable:N.Disposable,DocumentHighlight:N.DocumentHighlight,DocumentHighlightKind:N.DocumentHighlightKind,DocumentLink:N.DocumentLink,DocumentSymbol:N.DocumentSymbol,EndOfLine:N.EndOfLine,EnvironmentVariableMutatorType:N.EnvironmentVariableMutatorType,EvaluatableExpression:N.EvaluatableExpression,InlineValueText:N.InlineValueText,InlineValueVariableLookup:N.InlineValueVariableLookup,InlineValueEvaluatableExpression:N.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:N.InlineCompletionTriggerKind,EventEmitter:D.Emitter,ExtensionKind:N.ExtensionKind,ExtensionMode:N.ExtensionMode,ExternalUriOpenerPriority:N.ExternalUriOpenerPriority,FileChangeType:N.FileChangeType,FileDecoration:N.FileDecoration,FileSystemError:N.FileSystemError,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:N.FoldingRange,FoldingRangeKind:N.FoldingRangeKind,FunctionBreakpoint:N.FunctionBreakpoint,InlineCompletionItem:N.InlineSuggestion,InlineCompletionList:N.InlineSuggestions,Hover:N.Hover,IndentAction:k.IndentAction,Location:N.Location,MarkdownString:N.MarkdownString,OverviewRulerLane:E.OverviewRulerLane,ParameterInformation:N.ParameterInformation,PortAutoForwardAction:N.PortAutoForwardAction,Position:N.Position,ProcessExecution:N.ProcessExecution,ProgressLocation:N.ProgressLocation,QuickInputButtons:N.QuickInputButtons,Range:N.Range,RelativePattern:N.RelativePattern,Selection:N.Selection,SelectionRange:N.SelectionRange,SemanticTokens:N.SemanticTokens,SemanticTokensBuilder:N.SemanticTokensBuilder,SemanticTokensEdit:N.SemanticTokensEdit,SemanticTokensEdits:N.SemanticTokensEdits,SemanticTokensLegend:N.SemanticTokensLegend,ShellExecution:N.ShellExecution,ShellQuoting:N.ShellQuoting,SignatureHelp:N.SignatureHelp,SignatureHelpTriggerKind:N.SignatureHelpTriggerKind,SignatureInformation:N.SignatureInformation,SnippetString:N.SnippetString,SourceBreakpoint:N.SourceBreakpoint,StandardTokenType:N.StandardTokenType,StatusBarAlignment:N.StatusBarAlignment,SymbolInformation:N.SymbolInformation,SymbolKind:N.SymbolKind,SymbolTag:N.SymbolTag,Task:N.Task,TaskGroup:N.TaskGroup,TaskPanelKind:N.TaskPanelKind,TaskRevealKind:N.TaskRevealKind,TaskScope:N.TaskScope,TerminalLink:N.TerminalLink,TerminalLocation:N.TerminalLocation,TerminalProfile:N.TerminalProfile,TextDocumentSaveReason:N.TextDocumentSaveReason,TextEdit:N.TextEdit,TextEditorCursorStyle:C.TextEditorCursorStyle,TextEditorLineNumbersStyle:N.TextEditorLineNumbersStyle,TextEditorRevealType:N.TextEditorRevealType,TextEditorSelectionChangeKind:N.TextEditorSelectionChangeKind,TextDocumentChangeReason:N.TextDocumentChangeReason,ThemeColor:N.ThemeColor,ThemeIcon:N.ThemeIcon,TreeItem:N.TreeItem,TreeItemCollapsibleState:N.TreeItemCollapsibleState,TypeHierarchyItem:N.TypeHierarchyItem,UIKind:a.UIKind,Uri:T.URI,ViewColumn:N.ViewColumn,WorkspaceEdit:N.WorkspaceEdit,InlayHint:N.InlayHint,InlayHintKind:N.InlayHintKind,RemoteAuthorityResolverError:N.RemoteAuthorityResolverError,ResolvedAuthority:N.ResolvedAuthority,SourceControlInputBoxValidationType:N.SourceControlInputBoxValidationType,ExtensionRuntime:N.ExtensionRuntime,TimelineItem:N.TimelineItem,NotebookRange:N.NotebookRange,NotebookCellKind:N.NotebookCellKind,NotebookCellExecutionState:N.NotebookCellExecutionState,NotebookCellData:N.NotebookCellData,NotebookData:N.NotebookData,NotebookRendererScript:N.NotebookRendererScript,NotebookCellStatusBarAlignment:N.NotebookCellStatusBarAlignment,NotebookEditorRevealType:N.NotebookEditorRevealType,NotebookCellOutput:N.NotebookCellOutput,NotebookCellOutputItem:N.NotebookCellOutputItem,NotebookCellStatusBarItem:N.NotebookCellStatusBarItem,NotebookControllerAffinity:N.NotebookControllerAffinity,PortAttributes:N.PortAttributes,LinkedEditingRanges:N.LinkedEditingRanges,TestResultState:N.TestResultState,TestRunRequest:N.TestRunRequest,TestMessage:N.TestMessage,TestTag:N.TestTag,TestRunProfileKind:N.TestRunProfileKind,TextSearchCompleteMessageType:Xe.TextSearchCompleteMessageType,CoveredCount:N.CoveredCount,FileCoverage:N.FileCoverage,StatementCoverage:N.StatementCoverage,BranchCoverage:N.BranchCoverage,FunctionCoverage:N.FunctionCoverage,WorkspaceTrustState:N.WorkspaceTrustState,LanguageStatusSeverity:N.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=Te}),define(fe[278],me([0,1,84,133,36,131,37,40,46,33,73,57,75,92,54,68,134,69,45,91,122,56,132,11,201]),function(Y,e,g,L,D,S,T,C,E,k,i,I,a,p,h,w,y,P,b,o,s,v,n,f,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.registerSingleton)(f.ILoggerService,n.ExtHostLoggerService),(0,g.registerSingleton)(f.ILogService,r.ExtHostLogService),(0,g.registerSingleton)(w.IExtHostApiDeprecationService,w.ExtHostApiDeprecationService),(0,g.registerSingleton)(C.IExtHostCommands,C.ExtHostCommands),(0,g.registerSingleton)(T.IExtHostConfiguration,T.ExtHostConfiguration),(0,g.registerSingleton)(P.IExtHostConsumerFileSystem,P.ExtHostConsumerFileSystem),(0,g.registerSingleton)(I.IExtHostDebugService,I.WorkerExtHostDebugService),(0,g.registerSingleton)(S.IExtHostDecorations,S.ExtHostDecorations),(0,g.registerSingleton)(E.IExtHostDocumentsAndEditors,E.ExtHostDocumentsAndEditors),(0,g.registerSingleton)(b.IExtHostFileSystemInfo,b.ExtHostFileSystemInfo),(0,g.registerSingleton)(L.IExtHostOutputService,L.ExtHostOutputService),(0,g.registerSingleton)(a.IExtHostSearch,a.ExtHostSearch),(0,g.registerSingleton)(p.IExtHostStorage,p.ExtHostStorage),(0,g.registerSingleton)(i.IExtHostTask,i.WorkerExtHostTask),(0,g.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService),(0,g.registerSingleton)(h.IExtHostTunnelService,h.ExtHostTunnelService),(0,g.registerSingleton)(y.IExtHostWindow,y.ExtHostWindow),(0,g.registerSingleton)(D.IExtHostWorkspace,D.ExtHostWorkspace),(0,g.registerSingleton)(o.IExtHostSecretState,o.ExtHostSecretState),(0,g.registerSingleton)(s.IExtHostTelemetry,s.ExtHostTelemetry),(0,g.registerSingleton)(v.IExtHostEditorTabs,v.ExtHostEditorTabs)}),define(fe[93],me([0,1,15,11,32,72]),function(Y,e,g,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function T(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.anchorGlob=T;function C(I,a,p,h){const w=(0,g.mapArrayOrNot)(p,E),y=new D.TextSearchMatch(a,w,h),P=y.preview.matches;return{ranges:(0,g.mapArrayOrNot)(w,k),uri:I,preview:{text:y.preview.text,matches:(0,g.mapArrayOrNot)(P,k)}}}e.createTextSearchResult=C;function E(I){return new D.SearchRange(I.start.line,I.start.character,I.end.line,I.end.character)}function k(I){return new S.Range(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let i=class{constructor(a,p){this.prefix=a,this.logService=p}appendLine(a){this.logService.debug(`${this.prefix}#search`,a)}};i=Ve([$e(1,L.ILogService)],i),e.OutputChannel=i}),define(fe[279],me([0,1,96,22]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function D(n){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(f=>f===n)}e.isUTFEncoding=D,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const S=512,T=512,C=512*8,E=512*128;class k{constructor(f){this.iconvLiteDecoder=f}static async create(f){let r;if(f!==e.UTF8)r=(await new Promise((u,l)=>{Y(["iconv-lite-umd"],u,l)})).getDecoder(p(f));else{const t=new TextDecoder;r={write(u){return t.decode(u,{stream:!0})},end(){return t.decode()}}}return new k(r)}write(f){return this.iconvLiteDecoder.write(f)}end(){return this.iconvLiteDecoder.end()}}function i(n,f){const r=f.minBytesRequiredForDetection??f.guessEncoding?C:T;return new Promise((t,u)=>{const l=(0,g.newWriteableStream)(A=>A.join("")),c=[];let m=0,d;const _=async()=>{try{const A=await v({buffer:L.VSBuffer.concat(c),bytesRead:m},f.guessEncoding);A.encoding=await f.overwriteEncoding(A.encoding),d=await k.create(A.encoding);const R=d.write(L.VSBuffer.concat(c).buffer);l.write(R),c.length=0,m=0,t({stream:l,detected:A})}catch(A){u(A)}};(0,g.listenStream)(n,{onData:async A=>{d?l.write(d.write(A.buffer)):(c.push(A),m+=A.byteLength,m>=r&&(n.pause(),await _(),setTimeout(()=>n.resume())))},onError:A=>l.error(A),onEnd:async()=>{d||await _(),l.end(d?.end())}})})}e.toDecodeStream=i;async function I(n,f,r){const u=(await new Promise((m,d)=>{Y(["iconv-lite-umd"],m,d)})).getEncoder(p(f),r);let l=!1,c=!1;return{read(){if(c)return null;const m=n.read();if(typeof m!="string"){if(c=!0,!l&&r?.addBOM)switch(f){case e.UTF8:case e.UTF8_with_bom:return L.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const d=u.end();return d&&d.length>0?(l=!0,L.VSBuffer.wrap(d)):null}return l=!0,L.VSBuffer.wrap(u.write(m))}}}e.toEncodeReadable=I;async function a(n){return(await new Promise((r,t)=>{Y(["iconv-lite-umd"],r,t)})).encodingExists(p(n))}e.encodingExists=a;function p(n){return n===e.UTF8_with_bom||n===null?e.UTF8:n}e.toNodeEncoding=p;function h(n,f){if(!n||f<e.UTF16be_BOM.length)return null;const r=n.readUInt8(0),t=n.readUInt8(1);if(r===e.UTF16be_BOM[0]&&t===e.UTF16be_BOM[1])return e.UTF16be;if(r===e.UTF16le_BOM[0]&&t===e.UTF16le_BOM[1])return e.UTF16le;if(f<e.UTF8_BOM.length)return null;const u=n.readUInt8(2);return r===e.UTF8_BOM[0]&&t===e.UTF8_BOM[1]&&u===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=h;const w=["ascii","utf-16","utf-32"];async function y(n){const f=await new Promise((c,m)=>{Y(["jschardet"],c,m)}),r=n.slice(0,E),t=o(r.buffer),u=f.detect(t);if(!u||!u.encoding)return null;const l=u.encoding.toLowerCase();return 0<=w.indexOf(l)?null:b(u.encoding)}const P={ibm866:"cp866",big5:"cp950"};function b(n){const f=n.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return P[f]||f}function o(n){let f="";for(let r=0;r<n.length;r++)f+=String.fromCharCode(n[r]);return f}function s(n){switch(n){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const f=n.match(/windows(\d+)/);return f?"windows-"+f[1]:n}}e.toCanonicalName=s;function v({buffer:n,bytesRead:f},r){let t=h(n,f),u=!1;if(t!==e.UTF16be&&t!==e.UTF16le&&n){let l=!0,c=!0,m=!1;for(let d=0;d<f&&d<S;d++){const _=d%2==1,A=n.readUInt8(d)===0;if(A&&(m=!0),l&&(_&&!A||!_&&A)&&(l=!1),c&&(_&&A||!_&&!A)&&(c=!1),A&&!l&&!c)break}m&&(l?t=e.UTF16le:c?t=e.UTF16be:u=!0)}return r&&!u&&!t&&n?y(n.slice(0,f)).then(l=>({seemsBinary:!1,encoding:l})):{seemsBinary:u,encoding:t}}e.detectEncodingFromBuffer=v,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(fe[136],me([0,1,279,28,135]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class S extends D.TextSearchManager{constructor(C,E,k=L,i="searchProcess"){super(C,E,{readdir:I=>k.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,g.toCanonicalName)(I)},i)}}e.NativeTextSearchManager=S}),define(fe[280],me([0,1,281,295,296,2,297]),function(Y,e,g,L,D,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function C(I,a,p,h,w,y){const P=y.environment.useHostProxy,b=typeof P=="boolean"?P:!y.remote.isRemote,o=(0,T.createProxyResolver)({resolveProxy:v=>I.resolveProxy(v),getHttpProxySetting:()=>a.getConfiguration("http").get("proxy"),log:(v,n,...f)=>{switch(v){case T.LogLevel.Trace:h.trace(n,...f);break;case T.LogLevel.Debug:h.debug(n,...f);break;case T.LogLevel.Info:h.info(n,...f);break;case T.LogLevel.Warning:h.warn(n,...f);break;case T.LogLevel.Error:h.error(n,...f);break;case T.LogLevel.Critical:h.critical(n,...f);break;case T.LogLevel.Off:break;default:r(v,n,f);break}function r(t,u,...l){h.error("Unknown log level",t),h.error(u,...l)}},getLogLevel:()=>h.getLevel(),proxyResolveTelemetry:v=>{w.$publicLog2("resolveProxy",v)},useHostProxy:b,env:process.env}),s=E(a,o);return i(p,s)}e.connectProxyResolver=C;function E(I,a){const p={config:I.getConfiguration("http").get("proxySupport")||"off"};I.onDidChangeConfiguration(w=>{p.config=I.getConfiguration("http").get("proxySupport")||"off"});const h={config:!!I.getConfiguration("http").get("systemCertificates")};return I.onDidChangeConfiguration(w=>{h.config=!!I.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},g,(0,T.createHttpPatch)(g,a,{config:"off"},h,!0)),on:Object.assign({},g,(0,T.createHttpPatch)(g,a,{config:"on"},h,!0)),override:Object.assign({},g,(0,T.createHttpPatch)(g,a,{config:"override"},h,!0)),onRequest:Object.assign({},g,(0,T.createHttpPatch)(g,a,p,h,!0)),default:Object.assign(g,(0,T.createHttpPatch)(g,a,p,h,!1))},https:{off:Object.assign({},L,(0,T.createHttpPatch)(L,a,{config:"off"},h,!0)),on:Object.assign({},L,(0,T.createHttpPatch)(L,a,{config:"on"},h,!0)),override:Object.assign({},L,(0,T.createHttpPatch)(L,a,{config:"override"},h,!0)),onRequest:Object.assign({},L,(0,T.createHttpPatch)(L,a,p,h,!0)),default:Object.assign(L,(0,T.createHttpPatch)(L,a,p,h,!1))},tls:Object.assign(D,(0,T.createTlsPatch)(D))}}const k=new Map;function i(I,a){return I.getExtensionPathIndex().then(p=>{const h=Y.__$__nodeRequire("module"),w=h._load;h._load=function(P,b,o){if(P==="tls")return a.tls;if(P!=="http"&&P!=="https")return w.apply(this,arguments);const s=a[P],v=p.findSubstr(S.URI.file(b.filename));let n=k.get(v);if(n||k.set(v,n={}),!n[P]){let f=s.default;v&&v.enableProposedApi&&(f=s[v.proxySupport]||s.onRequest),n[P]={...f}}return n[P]}})}}),define(fe[282],me([0,1,39,9,80,29,12,8,93,283]),function(Y,e,g,L,D,S,T,C,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const i=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(o,s,v,n){const f=a(o,s,v,n),r=s.folder.fsPath;return{cmd:g.spawn(i,f.args,{cwd:r}),rgDiskPath:i,siblingClauses:f.siblingClauses,rgArgs:f,cwd:r}}e.spawnRipgrepCmd=I;function a(o,s,v,n){const f=["--files","--hidden","--case-sensitive"];h([s],v,!1).forEach(t=>{const u=(0,E.anchorGlob)(t);if(f.push("-g",u),T.isMacintosh){const l=(0,D.normalizeNFD)(u);l!==u&&f.push("-g",l)}});const r=p([s],n,void 0,!1);return r.globArgs.forEach(t=>{const u=`!${(0,E.anchorGlob)(t)}`;if(f.push("-g",u),T.isMacintosh){const l=(0,D.normalizeNFD)(u);l!==u&&f.push("-g",l)}}),s.disregardIgnoreFiles!==!1?f.push("--no-ignore"):f.push("--no-ignore-parent"),s.ignoreSymlinks||f.push("--follow"),o.exists&&f.push("--quiet"),f.push("--no-config"),s.disregardGlobalIgnoreFiles&&f.push("--no-ignore-global"),{args:f,siblingClauses:r.siblingClauses}}function p(o,s,v,n=!0){const f=[];let r={};return o.forEach(t=>{const u=Object.assign({},t.excludePattern||{},s||{}),l=w(u,n?t.folder.fsPath:void 0,v);f.push(...l.globArgs),l.siblingClauses&&(r=Object.assign(r,l.siblingClauses))}),{globArgs:f,siblingClauses:r}}e.foldersToRgExcludeGlobs=p;function h(o,s,v=!0){const n=[];return o.forEach(f=>{const r=Object.assign({},s||{},f.includePattern||{}),t=w(r,v?f.folder.fsPath:void 0);n.push(...t.globArgs)}),n}e.foldersToIncludeGlobs=h;function w(o,s,v){const n=[],f={};return Object.keys(o).forEach(r=>{if(v&&v.has(r)||!r)return;const t=o[r];r=P(s?y(s,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof t=="boolean"&&t?(r.startsWith("\\\\")&&(r+="**"),n.push(b(r))):t&&t.when&&(f[r]=t)}),{globArgs:n,siblingClauses:f}}function y(o,s){return L.isAbsolute(s)?s:L.join(o,s)}e.getAbsoluteGlob=y;function P(o){return o=C.rtrim(o,"\\"),C.rtrim(o,"/")}function b(o){return S.getRoot(o).toLowerCase()==="c:/"?o.replace(/^c:[/\\]/i,"/"):o}e.fixDriveC=b}),define(fe[284],me([0,1,39,63,9,104,15,52,30,80,29,12,47,8,13,28,32,282,101]),function(Y,e,g,L,D,S,T,C,E,k,i,I,a,p,h,w,y,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const o=new Set;process.on("exit",()=>{o.forEach(r=>r())});class s{constructor(t){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=t,this.filePattern=t.filePattern||"",this.includePattern=t.includePattern&&E.parse(t.includePattern),this.maxResults=t.maxResults||null,this.exists=!!t.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,b.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=t.excludePattern&&E.parse(t.excludePattern),this.folderExcludePatterns=new Map,t.folderQueries.forEach(u=>{const l=Object.assign({},u.excludePattern||{},this.config.excludePattern||{}),c=u.folder.fsPath;t.folderQueries.map(m=>m.folder.fsPath).filter(m=>m!==c).forEach(m=>{(0,i.isEqualOrParent)(m,c)&&(l[D.relative(c,m)]=!0)}),this.folderExcludePatterns.set(c,new n(l,c))})}cancel(){this.isCanceled=!0,o.forEach(t=>t())}walk(t,u,l,c,m){if(this.fileWalkSW=a.StopWatch.create(!1),this.isCanceled)return m(null,this.isLimitHit);u.forEach(d=>{const _=D.basename(d.fsPath);this.globalExcludePattern&&this.globalExcludePattern(d.fsPath,_)||this.matchFile(l,{relativePath:d.fsPath,searchPath:void 0})}),this.cmdSW=a.StopWatch.create(!1),this.parallel(t,(d,_)=>{this.call(this.cmdTraversal,this,d,l,c,A=>{if(A){const R=(0,C.toErrorMessage)(A);console.error(R),this.errors.push(R),_(A,void 0)}else _(null,void 0)})},(d,_)=>{this.fileWalkSW.stop();const A=d?T.coalesce(d)[0]:null;m(A,this.isLimitHit)})}parallel(t,u,l){const c=new Array(t.length),m=new Array(t.length);let d=!1,_=0;if(t.length===0)return l(null,[]);t.forEach((A,R)=>{u(A,(B,U)=>{if(B?(d=!0,c[R]=null,m[R]=B):(c[R]=U,m[R]=null),++_===t.length)return l(d?m:null,c)})})}call(t,u,...l){try{t.apply(u,l)}catch(c){l[l.length-1](c)}}cmdTraversal(t,u,l,c){const m=t.folder.fsPath,d=I.isMacintosh;let _;const A=()=>_&&_.kill();o.add(A);let R=N=>{o.delete(A),R=()=>{},c(N)},B="";const U=this.initDirectoryTree();let F;const $=(0,P.spawnRipgrepCmd)(this.config,t,this.config.includePattern,this.folderExcludePatterns.get(t.folder.fsPath).expression);_=$.cmd,F=!Object.keys($.siblingClauses).length;const M=$.rgArgs.args.map(N=>N.match(/^-/)?N:`'${N}'`).join(" ");let z=`${$.rgDiskPath} ${M}
 - cwd: ${$.cwd}`;$.rgArgs.siblingClauses&&(z+=`
 - Sibling clauses: ${JSON.stringify($.rgArgs.siblingClauses)}`),l({message:z}),this.cmdResultCount=0,this.collectStdout(_,"utf8",l,(N,x,j)=>{if(N){R(N);return}if(this.isLimitHit){R();return}const H=(B+(d?k.normalizeNFC(x||""):x)).split(`
`);if(j){const W=H.length;H[W-1]=H[W-1].trim(),H[W-1]||H.pop()}else B=H.pop()||"";if(H.length&&H[0].indexOf(`
`)!==-1){R(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=H.length,F){for(const W of H)if(this.matchFile(u,{base:m,relativePath:W,searchPath:this.getSearchPath(t,W)}),this.isLimitHit){A();break}(j||this.isLimitHit)&&R();return}this.addDirectoryEntries(t,U,m,H,u),j&&(this.matchDirectoryTree(U,m,u),R())})}spawnFindCmd(t){const u=this.folderExcludePatterns.get(t.folder.fsPath),l=u.getBasenameTerms(),c=u.getPathTerms(),m=["-L","."];if(l.length||c.length){m.push("-not","(","(");for(const d of l)m.push("-name",d),m.push("-o");for(const d of c)m.push("-path",d),m.push("-o");m.pop(),m.push(")","-prune",")")}return m.push("-type","f"),g.spawn("find",m,{cwd:t.folder.fsPath})}readStdout(t,u,l){let c="";this.collectStdout(t,u,()=>{},(m,d,_)=>{if(m){l(m);return}c+=d,_&&l(null,c)})}collectStdout(t,u,l,c){let m=(A,R,B)=>{(A||B)&&(m=()=>{},this.cmdSW&&this.cmdSW.stop()),c(A,R,B)},d=!1;t.stdout?(this.forwardData(t.stdout,u,m),t.stdout.once("data",()=>d=!0)):l({message:"stdout is null"});let _;t.stderr?_=this.collectData(t.stderr):l({message:"stderr is null"}),t.on("error",A=>{m(A)}),t.on("close",A=>{let R;!d&&(R=this.decodeData(_,u))&&f(R)?m(new Error(`command failed with error code ${A}: ${this.decodeData(_,u)}`)):(this.exists&&A===0&&(this.isLimitHit=!0),m(null,"",!0))})}forwardData(t,u,l){const c=new S.StringDecoder(u);return t.on("data",m=>{l(null,c.write(m))}),c}collectData(t){const u=[];return t.on("data",l=>{u.push(l)}),u}decodeData(t,u){const l=new S.StringDecoder(u);return t.map(c=>l.write(c)).join("")}initDirectoryTree(){const t={rootEntries:[],pathToEntries:Object.create(null)};return t.pathToEntries["."]=t.rootEntries,t}addDirectoryEntries(t,{pathToEntries:u},l,c,m){c.indexOf(this.filePattern)!==-1&&this.matchFile(m,{base:l,relativePath:this.filePattern,searchPath:this.getSearchPath(t,this.filePattern)});const d=_=>{const A=D.basename(_),R=D.dirname(_);let B=u[R];B||(B=u[R]=[],d(R)),B.push({base:l,relativePath:_,basename:A,searchPath:this.getSearchPath(t,_)})};c.forEach(d)}matchDirectoryTree({rootEntries:t,pathToEntries:u},l,c){const m=this,d=this.folderExcludePatterns.get(l),_=this.filePattern;function A(R){m.directoriesWalked++;const B=E.hasSiblingFn(()=>R.map(U=>U.basename));for(let U=0,F=R.length;U<F;U++){const $=R[U],{relativePath:M,basename:z}=$;if(d.test(M,z,_!==z?B:void 0))continue;const N=u[M];if(N)A(N);else{if(m.filesWalked++,M===_)continue;m.matchFile(c,$)}if(m.isLimitHit)break}}A(t)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(t,u,l,c,m){const d=t.folder,_=E.hasSiblingFn(()=>l);this.parallel(l,(A,R)=>{if(this.isCanceled||this.isLimitHit)return R(null);const B=u?[u,A].join(D.sep):A;if(this.folderExcludePatterns.get(t.folder.fsPath).test(B,A,this.config.filePattern!==A?_:void 0))return R(null);const U=[d.fsPath,B].join(D.sep);L.lstat(U,(F,$)=>{if(F||this.isCanceled||this.isLimitHit)return R(null);this.statLinkIfNeeded(U,$,(M,z)=>M||this.isCanceled||this.isLimitHit?R(null):z.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(U,$,(N,x)=>N||this.isCanceled||this.isLimitHit||(x=x||"",this.walkedPaths[x])?R(null):(this.walkedPaths[x]=!0,w.Promises.readdir(U).then(j=>{if(this.isCanceled||this.isLimitHit)return R(null);this.doWalk(t,B,j,c,O=>R(O||null))},j=>{R(null)})))):(this.filesWalked++,B===this.filePattern||this.maxFilesize&&h.isNumber(z.size)&&z.size>this.maxFilesize||this.matchFile(c,{base:d.fsPath,relativePath:B,searchPath:this.getSearchPath(t,B)}),R(null,void 0)))})},A=>{const R=A&&T.coalesce(A);return m(R&&R.length>0?R[0]:void 0)})}matchFile(t,u){this.isFileMatch(u)&&(!this.includePattern||this.includePattern(u.relativePath,D.basename(u.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||t(u))}isFileMatch(t){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,y.isFilePatternMatch)(t,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(t,u,l){return u.isSymbolicLink()?L.stat(t,l):l(null,u)}realPathIfNeeded(t,u,l){return u.isSymbolicLink()?L.realpath(t,(c,m)=>c?l(c):l(null,m)):l(null,t)}getSearchPath(t,u){return t.folderName?D.join(t.folderName,u):u}}e.FileWalker=s;class v{constructor(t){this.folderQueries=t.folderQueries,this.extraFiles=t.extraFileResources||[],this.walker=new s(t)}search(t,u,l){this.walker.walk(this.folderQueries,this.extraFiles,t,u,(c,m)=>{l(c,{limitHit:m,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=v;class n{constructor(t,u){this.expression=t,this.root=u,this.init(t)}init(t){let u,l;Object.keys(t).filter(c=>t[c]).forEach(c=>{D.isAbsolute(c)?(u=u||E.getEmptyExpression(),u[c]=t[c]):(l=l||E.getEmptyExpression(),l[c]=t[c])}),this.absoluteParsedExpr=u&&E.parse(u,{trimForExclusions:!0}),this.relativeParsedExpr=l&&E.parse(l,{trimForExclusions:!0})}test(t,u,l){return this.relativeParsedExpr&&this.relativeParsedExpr(t,u,l)||this.absoluteParsedExpr&&this.absoluteParsedExpr(D.join(this.root,t),u,l)}getBasenameTerms(){const t=[];return this.absoluteParsedExpr&&t.push(...E.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&t.push(...E.getBasenameTerms(this.relativeParsedExpr)),t}getPathTerms(){const t=[];return this.absoluteParsedExpr&&t.push(...E.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&t.push(...E.getPathTerms(this.relativeParsedExpr)),t}}function f(r){const t=r.trim().split(`
`),u=t[0].trim();if(u.startsWith("Error parsing regex"))return u;if(u.startsWith("regex parse error"))return p.uppercaseFirstLetter(t[t.length-1].trim());if(u.startsWith("error parsing glob")||u.startsWith("unsupported encoding"))return u.charAt(0).toUpperCase()+u.substr(1);if(u==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(u.startsWith("Literal "))return u}e.rgErrorMsgForDisplay=f}),define(fe[137],me([0,1,39,298,104,15,59,30,9,8,2,32,72,299,283,93]),function(Y,e,g,L,D,S,T,C,E,k,i,I,a,p,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const y=h.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class P{constructor(d){this.outputChannel=d}provideTextSearchResults(d,_,A,R){return this.outputChannel.appendLine(`provideTextSearchResults ${d.pattern}, ${JSON.stringify({..._,folder:_.folder.toString()})}`),new Promise((B,U)=>{R.onCancellationRequested(()=>O());const F=f(d,_),$=_.folder.fsPath,M=F.map(de=>de.match(/^-/)?de:`'${de}'`).join(" ");this.outputChannel.appendLine(`${y} ${M}
 - cwd: ${$}`);let z=g.spawn(y,F,{cwd:$});z.on("error",de=>{console.error(de),this.outputChannel.appendLine("Error: "+(de&&de.message)),U((0,I.serializeSearchError)(new I.SearchError(de&&de.message,I.SearchErrorCode.rgProcessError)))});let N=!1;const x=new s(_.maxResults,$,_.previewOptions);x.on("result",de=>{N=!0,W="",A.report(de)});let j=!1;const O=()=>{j=!0,z&&z.kill(),x&&x.cancel()};let H=!1;x.on("hitLimit",()=>{H=!0,O()});let W="";z.stdout.on("data",de=>{x.handleData(de),N||(W+=de)});let X=!1;z.stdout.once("data",()=>X=!0);let Q="";z.stderr.on("data",de=>{const _e=de.toString();this.outputChannel.appendLine(_e),Q+=_e}),z.on("close",()=>{if(this.outputChannel.appendLine(X?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(N?"Got result from parser":"No result from parser"),W&&this.outputChannel.appendLine(`Got data without result: ${W}`),this.outputChannel.appendLine(""),j)B({limitHit:H});else{x.flush(),z=null;let de;Q&&!X&&(de=b(Q))?U((0,I.serializeSearchError)(new I.SearchError(de.message,de.code))):B({limitHit:H})}})})}}e.RipgrepTextSearchEngine=P;function b(m){const d=m.split(`
`),_=d[0].trim();if(d.some(R=>R.startsWith("regex parse error")))return new I.SearchError(o(d),I.SearchErrorCode.regexParseError);const A=_.match(/grep config error: unknown encoding: (.*)/);if(A)return new I.SearchError(`Unknown encoding: ${A[1]}`,I.SearchErrorCode.unknownEncoding);if(_.startsWith("error parsing glob"))return new I.SearchError(_.charAt(0).toUpperCase()+_.substr(1),I.SearchErrorCode.globParseError);if(_.startsWith("the literal"))return new I.SearchError(_.charAt(0).toUpperCase()+_.substr(1),I.SearchErrorCode.invalidLiteral);if(_.startsWith("PCRE2: error compiling pattern"))return new I.SearchError(_,I.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=b;function o(m){const d=["Regex parse error"],_=m.filter(A=>A.startsWith("PCRE2:"));if(_.length>=1){const A=_[0].replace("PCRE2:","");if(A.indexOf(":")!==-1&&A.split(":").length>=2){const R=A.split(":")[1];d.push(":"+R)}}return d.join("")}e.buildRegexParseError=o;class s extends L.EventEmitter{constructor(d,_,A){super();this.maxResults=d,this.rootFolder=_,this.previewOptions=A,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new D.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(d,_){return super.on(d,_),this}handleData(d){if(this.isDone)return;const _=typeof d=="string"?d:this.stringDecoder.write(d);this.handleDecodedData(_)}handleDecodedData(d){let _=d.indexOf(`
`);const A=this.remainder+d;if(_>=0)_+=this.remainder.length;else{this.remainder=A;return}let R=0;for(;_>=0;)this.handleLine(A.substring(R,_).trim()),R=_+1,_=A.indexOf(`
`,R);this.remainder=A.substring(R)}handleLine(d){if(this.isDone||!d)return;let _;try{_=JSON.parse(d)}catch(A){throw new Error(`malformed line from rg: ${d}`)}if(_.type==="match"){const A=v(_.data.path),R=i.URI.file(E.join(this.rootFolder,A)),B=this.createTextSearchMatch(_.data,R);this.onResult(B),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(_.type==="context"){const A=v(_.data.path),R=i.URI.file(E.join(this.rootFolder,A));this.createTextSearchContext(_.data,R).forEach(U=>this.onResult(U))}}createTextSearchMatch(d,_){const A=d.line_number-1,R=v(d.lines),B=Buffer.from(R);let U=0,F=0,$=A;d.submatches.length===0&&d.submatches.push(R.length?{start:0,end:1,match:{text:R[0]}}:{start:0,end:0,match:{text:""}});const M=(0,S.coalesce)(d.submatches.map((z,N)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const x=v(z.match),j=B.slice(U,z.start).toString().length,O=F+j,H=n(x),W=$,X=H.numLines+W,Q=H.numLines>0?H.lastLineLength:H.lastLineLength+O;return U=z.end,F=Q,$=X,new a.Range(W,O,X,Q)}));return(0,w.createTextSearchResult)(_,R,M,this.previewOptions)}createTextSearchContext(d,_){const A=v(d.lines),R=d.line_number;return A.replace(/\r?\n$/,"").split(`
`).map((B,U)=>({text:B,uri:_,lineNumber:R+U}))}onResult(d){this.emit("result",d)}}e.RipgrepParser=s;function v(m){return m.bytes?Buffer.from(m.bytes,"base64").toString():m.text}function n(m){const d=/\n/g;let _=0,A=-1,R;for(;R=d.exec(m);)_++,A=R.index;const B=A>=0?m.length-A-1:m.length;return{numLines:_,lastLineLength:B}}function f(m,d){const _=["--hidden"];_.push(m.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:A,otherIncludes:R}=(0,T.groupBy)(d.includes,U=>U.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(R&&R.length){const U=new Set;R.forEach(F=>{U.add(F)}),_.push("-g","!*"),U.forEach(F=>{r(F).map(w.anchorGlob).forEach($=>{_.push("-g",$)})})}A&&A.length&&A.forEach(U=>{_.push("-g",U)}),d.excludes.map(w.anchorGlob).forEach(U=>_.push("-g",`!${U}`)),d.maxFileSize&&_.push("--max-filesize",d.maxFileSize+""),d.useIgnoreFiles?_.push("--no-ignore-parent"):_.push("--no-ignore"),d.followSymlinks&&_.push("--follow"),d.encoding&&d.encoding!=="utf8"&&_.push("--encoding",d.encoding),m.pattern==="--"&&(m.isRegExp=!0,m.pattern="\\-\\-"),m.isMultiline&&!m.isRegExp&&(m.pattern=(0,k.escapeRegExpCharacters)(m.pattern),m.isRegExp=!0),d.usePCRE2&&_.push("--pcre2"),_.push("--crlf"),m.isRegExp&&(m.pattern=t(m.pattern),_.push("--auto-hybrid-regex"));let B;if(m.isWordMatch){const F=(0,k.createRegExp)(m.pattern,!!m.isRegExp,{wholeWord:m.isWordMatch}).source.replace(/\\\//g,"/");_.push("--regexp",F)}else if(m.isRegExp){let U=l(m.pattern);U=c(U),_.push("--regexp",U)}else B=m.pattern,_.push("--fixed-strings");return _.push("--no-config"),d.useGlobalIgnoreFiles||_.push("--no-ignore-global"),_.push("--json"),m.isMultiline&&_.push("--multiline"),d.beforeContext&&_.push("--before-context",d.beforeContext+""),d.afterContext&&_.push("--after-context",d.afterContext+""),_.push("--"),B&&_.push(B),_.push("."),_}function r(m){const d=(0,C.splitGlobAware)(m,"/");return d.map((_,A)=>d.slice(0,A+1).join("/"))}e.spreadGlobComponents=r;function t(m){const d=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;m.match(d);)m=m.replace(d,"$1\\x{$2}");const _=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;m.match(_);)m=m.replace(_,"$1\\x{$2}");return m}e.unicodeEscapesToPCRE2=t;const u=m=>m.type==="Assertion"&&m.kind==="lookbehind";function l(m){let d;try{d=new p.RegExpParser().parsePattern(m)}catch{return m}let _="",A=0;const R=(F,$,M)=>{_+=m.slice(A,F)+M,A=$},B=[];return new p.RegExpVisitor({onCharacterEnter(F){if(F.raw!=="\\n")return;const $=B[0];if(!$)R(F.start,F.end,"\\r?\\n");else if(!B.some(u))if($.type==="CharacterClass")if($.negate){const M=m.slice($.start+2,F.start)+m.slice(F.end,$.end-1);if($.parent?.type==="Quantifier"){const z=$.parent;R(z.start,z.end,(M?`[^${M}]`:".")+(z.greedy?"+":"*"))}else R($.start,$.end,"(?!\\r?\\n"+(M?`|[${M}]`:"")+")")}else{const M=m.slice($.start+1,F.start)+m.slice(F.end,$.end-1);R($.start,$.end,M===""?"\\r?\\n":`(?:[${M}]|\\r?\\n)`)}else $.type==="Quantifier"&&R(F.start,F.end,"(?:\\r?\\n)")},onQuantifierEnter(F){B.unshift(F)},onQuantifierLeave(){B.shift()},onCharacterClassRangeEnter(F){B.unshift(F)},onCharacterClassRangeLeave(){B.shift()},onCharacterClassEnter(F){B.unshift(F)},onCharacterClassLeave(){B.shift()},onAssertionEnter(F){u(F)&&B.push(F)},onAssertionLeave(F){B[0]===F&&B.shift()}}).visit(d),_+=m.slice(A),_}e.fixRegexNewline=l;function c(m){return m.replace(/\n/g,"\\r?\\n")}e.fixNewline=c}),define(fe[285],me([0,1,21,137,117,10]),function(Y,e,g,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class T{constructor(k){this.outputChannel=k,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(k,i,I,a){const p=new L.RipgrepTextSearchEngine(this.outputChannel);if(i.folder.scheme===S.Schemas.userData){const h={...i,folder:i.folder.with({scheme:S.Schemas.file})},w=new D.Progress(y=>I.report({...y,uri:y.uri.with({scheme:i.folder.scheme})}));return this.withToken(a,y=>p.provideTextSearchResults(k,h,w,y))}else return this.withToken(a,h=>p.provideTextSearchResults(k,i,I,h))}async withToken(k,i){const I=C(k);this.inProgress.add(I);const a=await i(I.token);return this.inProgress.delete(I),a}dispose(){this.inProgress.forEach(k=>k.cancel())}}e.RipgrepSearchProvider=T;function C(E){const k=new g.CancellationTokenSource;return E.onCancellationRequested(()=>k.cancel()),k}}),define(fe[286],me([0,1,28,137,136]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class S{constructor(E){this.query=E}search(E,k,i){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(p){i({message:p})}},a=new D.NativeTextSearchManager(this.query,new L.RipgrepTextSearchEngine(I),g);return new Promise((p,h)=>a.search(w=>{k(w.map(T))},E).then(w=>p({limitHit:w.limitHit,type:"success",stats:w.stats}),h))}}e.TextSearchEngineAdapter=S;function T(C){return{path:C.resource&&C.resource.fsPath,results:C.results,numMatches:(C.results||[]).reduce((E,k)=>{if(k.ranges){const i=k;return E+(Array.isArray(i.ranges)?i.ranges.length:1)}else return E+1},0)}}}),define(fe[287],me([0,1,15,16,18,3,101,9,47,2,43,32,284,286]),function(Y,e,g,L,D,S,T,C,E,k,i,I,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class h{constructor(s="searchProcess"){this.processType=s,this.caches=Object.create(null)}fileSearch(s){let v;const n=P(s),f=new S.Emitter({onFirstListenerDidAdd:()=>{v=(0,L.createCancelablePromise)(r=>this.doFileSearchWithEngine(a.Engine,n,t=>f.fire(t),r)),v.then(r=>f.fire(r),r=>f.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onLastListenerRemove:()=>{v.cancel()}});return f.event}textSearch(s){let v;const n=P(s),f=new S.Emitter({onFirstListenerDidAdd:()=>{v=(0,L.createCancelablePromise)(r=>this.ripgrepTextSearch(n,t=>f.fire(t),r)),v.then(r=>f.fire(r),r=>f.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onLastListenerRemove:()=>{v.cancel()}});return f.event}ripgrepTextSearch(s,v,n){return s.maxFileSize=(0,i.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new p.TextSearchEngineAdapter(s).search(n,v,v)}doFileSearch(s,v,n){return this.doFileSearchWithEngine(a.Engine,s,v,n)}doFileSearchWithEngine(s,v,n,f,r=h.BATCH_SIZE){let t=0;const u=c=>{Array.isArray(c)?(t+=c.length,n(c.map(m=>this.rawMatchToSearchItem(m)))):c.relativePath?(t++,n(this.rawMatchToSearchItem(c))):n(c)};if(v.sortByScore){let c=this.trySortedSearchFromCache(v,u,f);if(!c){const m=v.maxResults?Object.assign({},v,{maxResults:null}):v,d=new s(m);c=this.doSortedSearch(d,v,n,u,f)}return new Promise((m,d)=>{c.then(([_,A])=>{const R=A.map(B=>this.rawMatchToSearchItem(B));this.sendProgress(R,n,r),m(_)},d)})}const l=new s(v);return this.doSearch(l,u,r,f).then(c=>({limitHit:c.limitHit,type:"success",stats:{detailStats:c.stats,type:this.processType,fromCache:!1,resultCount:t,sortingTime:void 0}}))}rawMatchToSearchItem(s){return{path:s.base?(0,C.join)(s.base,s.relativePath):s.relativePath}}doSortedSearch(s,v,n,f,r){const t=new S.Emitter;let u=(0,L.createCancelablePromise)(c=>{let m=[];const d=_=>{Array.isArray(_)?m=_:(f(_),t.fire(_))};return this.doSearch(s,d,-1,c).then(_=>[_,m])}),l;if(v.cacheKey){l=this.getOrCreateCache(v.cacheKey);const c={promise:u,event:t.event,resolved:!1};l.resultsToSearchCache[v.filePattern||""]=c,u.then(()=>{c.resolved=!0},m=>{delete l.resultsToSearchCache[v.filePattern||""]}),u=this.preventCancellation(u)}return u.then(([c,m])=>{const d=l?l.scorerCache:Object.create(null),_=(typeof v.maxResults!="number"||v.maxResults>0)&&E.StopWatch.create(!1);return this.sortResults(v,m,d,r).then(A=>{const R=_?_.elapsed():-1;return[{type:"success",stats:{detailStats:c.stats,sortingTime:R,fromCache:!1,type:this.processType,workspaceFolderCount:v.folderQueries.length,resultCount:A.length},messages:c.messages,limitHit:c.limitHit||typeof v.maxResults=="number"&&m.length>v.maxResults},A]})})}getOrCreateCache(s){const v=this.caches[s];return v||(this.caches[s]=new w)}trySortedSearchFromCache(s,v,n){const f=s.cacheKey&&this.caches[s.cacheKey];if(!f)return;const r=this.getResultsFromCache(f,s.filePattern||"",v,n);if(r)return r.then(([t,u,l])=>{const c=E.StopWatch.create(!1);return this.sortResults(s,u,f.scorerCache,n).then(m=>{const d=c.elapsed(),_={fromCache:!0,detailStats:l,type:this.processType,resultCount:u.length,sortingTime:d};return[{type:"success",limitHit:t.limitHit||typeof s.maxResults=="number"&&u.length>s.maxResults,stats:_},m]})})}sortResults(s,v,n,f){const r=(0,T.prepareQuery)(s.filePattern||""),t=(l,c)=>(0,T.compareItemsByFuzzyScore)(l,c,r,!0,y,n),u=typeof s.maxResults=="number"?s.maxResults:Number.MAX_VALUE;return g.topAsync(v,t,u,1e4,f)}sendProgress(s,v,n){if(n&&n>0)for(let f=0;f<s.length;f+=n)v(s.slice(f,f+n));else v(s)}getResultsFromCache(s,v,n,f){const r=E.StopWatch.create(!1),t=v.indexOf(C.sep)>=0;let u;for(const d in s.resultsToSearchCache)if(v.startsWith(d)){if(t&&d.indexOf(C.sep)<0&&d!=="")continue;const _=s.resultsToSearchCache[d];u={promise:this.preventCancellation(_.promise),event:_.event,resolved:_.resolved};break}if(!u)return null;const l=r.elapsed(),c=E.StopWatch.create(!1),m=u.event(n);return f&&f.onCancellationRequested(()=>{m.dispose()}),u.promise.then(([d,_])=>{if(f&&f.isCancellationRequested)throw(0,D.canceled)();const A=[],R=(0,T.prepareQuery)(v).normalizedLowercase;for(const B of _)!(0,I.isFilePatternMatch)(B,R)||A.push(B);return[d,A,{cacheWasResolved:u.resolved,cacheLookupTime:l,cacheFilterTime:c.elapsed(),cacheEntryCount:_.length}]})}doSearch(s,v,n,f){return new Promise((r,t)=>{let u=[];f&&f.onCancellationRequested(()=>s.cancel()),s.search(l=>{l&&(n?(u.push(l),n>0&&u.length>=n&&(v(u),u=[])):v(l))},l=>{v(l)},(l,c)=>{u.length&&v(u),l?t(l):r(c)})})}clearCache(s){return delete this.caches[s],Promise.resolve(void 0)}preventCancellation(s){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(v,n){return s.then(v,n)}catch(v){return this.then(void 0,v)}finally(v){return s.finally(v)}}}}e.SearchService=h,h.BATCH_SIZE=512;class w{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const y=new class{getItemLabel(o){return(0,C.basename)(o.relativePath)}getItemDescription(o){return(0,C.dirname)(o.relativePath)}getItemPath(o){return o.relativePath}};function P(o){return{...o,folderQueries:o.folderQueries&&o.folderQueries.map(b),extraFileResources:o.extraFileResources&&o.extraFileResources.map(s=>k.URI.revive(s))}}function b(o){return{...o,folder:k.URI.revive(o.folder)}}}),define(fe[288],me([0,1,6,10,2,28,11,26,14,75,67,32,287,285,93,136]),function(Y,e,g,L,D,S,T,C,E,k,i,I,a,p,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let y=class extends k.ExtHostSearch{constructor(b,o,s,v){super(b,s,v);this._pfs=S,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const n=new h.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(L.Schemas.userData,new p.RipgrepSearchProvider(n)),o.remote.isRemote&&o.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const b=new h.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(L.Schemas.file,new p.RipgrepSearchProvider(b)),this.registerInternalFileSearchProvider(L.Schemas.file,new a.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(b,o){const s=this._handlePool++;return this._internalFileSearchProvider=o,this._internalFileSearchHandle=s,this._proxy.$registerFileSearchProvider(s,this._transformScheme(b)),(0,g.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(s)})}$provideFileSearchResults(b,o,s,v){const n=(0,k.reviveQuery)(s);return b===this._internalFileSearchHandle?this.doInternalFileSearch(b,o,n,v):super.$provideFileSearchResults(b,o,s,v)}doInternalFileSearch(b,o,s,v){const n=f=>{if((0,I.isSerializedFileMatch)(f)&&(f=[f]),Array.isArray(f)){this._proxy.$handleFileMatch(b,o,f.map(r=>D.URI.file(r.path)));return}f.message&&this._logService.debug("ExtHostSearch",f.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(s,n,v)}$clearCache(b){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(b),super.$clearCache(b)}createTextSearchManager(b,o){return new w.NativeTextSearchManager(b,o,void 0,"textSearchProvider")}};y=Ve([$e(0,E.IExtHostRpcService),$e(1,C.IExtHostInitDataService),$e(2,i.IURITransformerService),$e(3,T.ILogService)],y),e.NativeExtHostSearch=y}),define(fe[138],me([0,1,300,125,82,22,18,3,6,9,12,31,106,107,301]),function(Y,e,g,L,D,S,T,C,E,k,i,I,a,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class w{constructor(c){this.socket=c,this._errorListener=m=>{if(m){if(m.code==="EPIPE")return;(0,T.onUnexpectedError)(m)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(c){const m=d=>c(S.VSBuffer.wrap(d));return this.socket.on("data",m),{dispose:()=>this.socket.off("data",m)}}onClose(c){const m=d=>{c({type:0,hadError:d,error:void 0})};return this.socket.on("close",m),{dispose:()=>this.socket.off("close",m)}}onEnd(c){return this.socket.on("end",c),{dispose:()=>this.socket.off("end",c)}}write(c){if(!this.socket.destroyed)try{this.socket.write(c.buffer,m=>{if(m){if(m.code==="EPIPE")return;(0,T.onUnexpectedError)(m)}})}catch(m){if(m.code==="EPIPE")return;(0,T.onUnexpectedError)(m)}}end(){this.socket.end()}drain(){return new Promise((c,m)=>{if(this.socket.bufferSize===0){c();return}const d=()=>{this.socket.off("close",d),this.socket.off("end",d),this.socket.off("error",d),this.socket.off("timeout",d),this.socket.off("drain",d),c()};this.socket.on("close",d),this.socket.on("end",d),this.socket.on("error",d),this.socket.on("timeout",d),this.socket.on("drain",d)})}}e.NodeSocket=w;var y;(function(l){l[l.MinHeaderByteSize=2]="MinHeaderByteSize"})(y||(y={}));var P;(function(l){l[l.PeekHeader=1]="PeekHeader",l[l.ReadHeader=2]="ReadHeader",l[l.ReadBody=3]="ReadBody",l[l.Fin=4]="Fin"})(P||(P={}));class b extends E.Disposable{constructor(c,m,d,_){super();this._onDidZlibFlush=this._register(new C.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new C.Emitter),this._onClose=this._register(new C.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=c,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=m,this._recordInflateBytes=_,m?(this._zlibInflate=h.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",A=>{console.error(A),(0,T.onUnexpectedError)(A),this._onClose.fire({type:0,hadError:!0,error:A})}),this._zlibInflate.on("data",A=>{this._pendingInflateData.push(A)}),d&&(this._zlibInflate.write(d.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=h.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",A=>{console.error(A),(0,T.onUnexpectedError)(A),this._onClose.fire({type:0,hadError:!0,error:A})}),this._zlibDeflate.on("data",A=>{this._pendingDeflateData.push(A)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new p.ChunkStream,this._register(this.socket.onData(A=>this._acceptChunk(A))),this._register(this.socket.onClose(A=>this._onClose.fire(A)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?S.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):S.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(c){return this._onData.event(c)}onClose(c){return this._onClose.event(c)}onEnd(c){return this.socket.onEnd(c)}write(c){this._totalOutgoingDataBytes+=c.byteLength,this._zlibDeflate?(this._zlibDeflate.write(c.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let m=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,m=m.slice(0,m.length-4),this._isEnded||this._write(S.VSBuffer.wrap(m),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(c,!1)}_write(c,m){let d=2;c.byteLength<126?d+=0:c.byteLength<2**16?d+=2:d+=8;const _=S.VSBuffer.alloc(d);if(m?_.writeUInt8(194,0):_.writeUInt8(130,0),c.byteLength<126)_.writeUInt8(c.byteLength,1);else if(c.byteLength<2**16){_.writeUInt8(126,1);let A=1;_.writeUInt8(c.byteLength>>>8&255,++A),_.writeUInt8(c.byteLength>>>0&255,++A)}else{_.writeUInt8(127,1);let A=1;_.writeUInt8(0,++A),_.writeUInt8(0,++A),_.writeUInt8(0,++A),_.writeUInt8(0,++A),_.writeUInt8(c.byteLength>>>24&255,++A),_.writeUInt8(c.byteLength>>>16&255,++A),_.writeUInt8(c.byteLength>>>8&255,++A),_.writeUInt8(c.byteLength>>>0&255,++A)}this._totalOutgoingWireBytes+=_.byteLength+c.byteLength,this.socket.write(S.VSBuffer.concat([_,c]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(c){if(c.byteLength!==0){for(this._totalIncomingWireBytes+=c.byteLength,this._incomingData.acceptChunk(c);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const m=this._incomingData.peek(this._state.readLen),d=m.readUInt8(0),_=(d&128)>>>7,A=(d&64)>>>6,R=m.readUInt8(1),B=(R&128)>>>7,U=R&127;this._state.state=2,this._state.readLen=2+(B?4:0)+(U===126?2:0)+(U===127?8:0),this._state.fin=_,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(A)),this._state.firstFrameOfMessage=Boolean(_),this._state.mask=0}else if(this._state.state===2){const m=this._incomingData.read(this._state.readLen),d=m.readUInt8(1),_=(d&128)>>>7;let A=d&127,R=1;A===126?A=m.readUInt8(++R)*2**8+m.readUInt8(++R):A===127&&(A=m.readUInt8(++R)*0+m.readUInt8(++R)*0+m.readUInt8(++R)*0+m.readUInt8(++R)*0+m.readUInt8(++R)*2**24+m.readUInt8(++R)*2**16+m.readUInt8(++R)*2**8+m.readUInt8(++R));let B=0;_&&(B=m.readUInt8(++R)*2**24+m.readUInt8(++R)*2**16+m.readUInt8(++R)*2**8+m.readUInt8(++R)),this._state.state=3,this._state.readLen=A,this._state.mask=B}else if(this._state.state===3){const m=this._incomingData.read(this._state.readLen);o(m,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate&&this._state.compressed?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(m.buffer)),this._zlibInflate.write(m.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const d=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=d.length,this._onData.fire(S.VSBuffer.wrap(d))})):(this._totalIncomingDataBytes+=m.byteLength,this._onData.fire(m))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await C.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=b;function o(l,c){if(c===0)return;let m=l.byteLength>>>2;for(let U=0;U<m;U++){const F=l.readUInt32BE(U*4);l.writeUInt32BE(F^c,U*4)}let d=m*4,_=l.byteLength-d;const A=c>>>24&255,R=c>>>16&255,B=c>>>8&255;_>=1&&l.writeUInt8(l.readUInt8(d)^A,d),_>=2&&l.writeUInt8(l.readUInt8(d+1)^R,d+1),_>=3&&l.writeUInt8(l.readUInt8(d+2)^B,d+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const s={[2]:107,[1]:103};function v(){const l=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${l}-sock`;let c;return e.XDG_RUNTIME_DIR?c=(0,k.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${l}.sock`):c=(0,k.join)((0,D.tmpdir)(),`vscode-ipc-${l}.sock`),f(c),c}e.createRandomIPCHandle=v;function n(l,c,m){const d=(0,g.createHash)("md5").update(l).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${d}-${m}-${c}-sock`;let _;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?_=(0,k.join)(e.XDG_RUNTIME_DIR,`vscode-${d.substr(0,8)}-${m}-${c}.sock`):_=(0,k.join)(l,`${m}-${c}.sock`),f(_),_}e.createStaticIPCHandle=n;function f(l){const c=s[i.platform];typeof c=="number"&&l.length>=c&&console.warn(`WARNING: IPC handle "${l}" is longer than ${c} chars, try a shorter --user-data-dir`)}class r extends a.IPCServer{constructor(c){super(r.toClientConnectionEvent(c));this.server=c}static toClientConnectionEvent(c){const m=C.Event.fromNodeEventEmitter(c,"connection");return C.Event.map(m,d=>({protocol:new p.Protocol(new w(d)),onDidClientDisconnect:C.Event.once(C.Event.fromNodeEventEmitter(d,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function t(l){return new Promise((c,m)=>{const d=(0,L.createServer)();d.on("error",m),d.listen(l,()=>{d.removeListener("error",m),c(new r(d))})})}e.serve=t;function u(l,c){return new Promise((m,d)=>{const _=(0,L.createConnection)(l,()=>{_.removeListener("error",d),m(p.Client.fromSocket(new w(_),c))});_.once("error",d)})}e.connect=u}),define(fe[289],me([0,1,138,281,63,40,2,200,11]),function(Y,e,g,L,D,S,T,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class k{constructor(a,p,h){this._commands=a,this.logService=p,this._ipcHandlePath=h,this._server=L.createServer((w,y)=>this.onRequest(w,y)),this.setup().catch(w=>(p.error(w),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",a=>this.logService.error(a))}catch(a){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(a,p){const h=[];a.setEncoding("utf8"),a.on("data",w=>h.push(w)),a.on("end",()=>{const w=JSON.parse(h.join(""));switch(w.type){case"open":this.open(w,p);break;case"openExternal":this.openExternal(w,p);break;case"status":this.getStatus(w,p);break;case"extensionManagement":this.manageExtensions(w,p).catch(this.logService.error);break;default:p.writeHead(404),p.write(`Unknown message type: ${w.type}`,y=>{y&&this.logService.error(y)}),p.end();break}})}open(a,p){let{fileURIs:h,folderURIs:w,forceNewWindow:y,diffMode:P,addMode:b,forceReuseWindow:o,gotoLineMode:s,waitMarkerFilePath:v}=a;const n=[];if(Array.isArray(w))for(const f of w)try{n.push({folderUri:T.URI.parse(f)})}catch(r){}if(Array.isArray(h))for(const f of h)try{(0,C.hasWorkspaceFileExtension)(f)?n.push({workspaceUri:T.URI.parse(f)}):n.push({fileUri:T.URI.parse(f)})}catch(r){}if(n.length){const f=v?T.URI.file(v):void 0,t={forceNewWindow:y,diffMode:P,addMode:b,gotoLineMode:s,forceReuseWindow:o,preferNewWindow:!o&&!f&&!b,waitMarkerFileURI:f};this._commands.executeCommand("_remoteCLI.windowOpen",n,t)}p.writeHead(200),p.end()}async openExternal(a,p){for(const h of a.uris){const w=T.URI.parse(h),y=w.scheme==="file"?w:h;await this._commands.executeCommand("_remoteCLI.openExternal",y)}p.writeHead(200),p.end()}async manageExtensions(a,p){try{const h=P=>P?.map(b=>/\.vsix$/i.test(b)?T.URI.parse(b):b),w={list:a.list,install:h(a.install),uninstall:h(a.uninstall),force:a.force},y=await this._commands.executeCommand("_remoteCLI.manageExtensions",w);p.writeHead(200),p.write(y)}catch(h){p.writeHead(500),p.write(String(h),w=>{w&&this.logService.error(w)})}p.end()}async getStatus(a,p){try{const h=await this._commands.executeCommand("_remoteCLI.getSystemStatus");p.writeHead(200),p.write(h),p.end()}catch(h){p.writeHead(500),p.write(String(h),w=>{w&&this.logService.error(w)}),p.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&D.existsSync(this._ipcHandlePath)&&D.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=k;let i=class extends k{constructor(a,p){super(a,p,(0,g.createRandomIPCHandle)())}};i=Ve([$e(0,S.IExtHostCommands),$e(1,E.ILogService)],i),e.CLIServer=i}),define(fe[290],me([0,1,74,277,272,5,280,41,262,2,10,7,289,105]),function(Y,e,g,L,D,S,T,C,E,k,i,I,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class h extends D.RequireInterceptor{_installInterceptor(){const P=this,b=Y.__$__nodeRequire("module"),o=b._load;b._load=function(v,n,f){for(let r of P._alternatives){let t=r(v);if(t){v=t;break}}return P._factories.has(v)?P._factories.get(v).load(v,k.URI.file((0,p.realpathSync)(n.filename)),r=>o.apply(this,[r,n,f])):o.apply(this,arguments)}}}class w extends C.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=I.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const P=this._instaService.invokeFunction(L.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(E.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const n=this._instaService.createInstance(a.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=n.ipcHandlePath}await this._instaService.createInstance(h,P,this._registry).install(),g.mark("code/extHost/didInitAPI");const o=await this._extHostConfiguration.getConfigProvider();await(0,T.connectProxyResolver)(this._extHostWorkspace,o,this,this._logService,this._mainThreadTelemetryProxy,this._initData),g.mark("code/extHost/didInitProxyResolver");const s=process.send,v=this._extHostContext.getProxy(S.MainContext.MainThreadConsole);process.send=(...n)=>n.length===0||!n[0]||n[0].type!=="__$console"?s.apply(process,n):(v.$logExtensionHostMessage(n[0]),!1)}_getEntryPoint(P){return P.main}_loadCommonJSModule(P,b,o){if(b.scheme!==i.Schemas.file)throw new Error(`Cannot load URI: '${b}', must be of file-scheme`);let s=null;o.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${b.toString(!0)}`),this._logService.flush();try{P&&g.mark(`code/extHost/willLoadExtensionCode/${P.value}`),s=Y.__$__nodeRequire(b.fsPath)}catch(v){return Promise.reject(v)}finally{P&&g.mark(`code/extHost/didLoadExtensionCode/${P.value}`),o.codeLoadingStop()}return Promise.resolve(s)}async $setRemoteEnvironment(P){if(!!this._initData.remote.isRemote)for(const b in P){const o=P[b];o===null?delete process.env[b]:process.env[b]=o}}}e.ExtHostExtensionService=w}),define(fe[291],me([0,1,84,265,274,273,288,290,266,57,41,75,73,33,54,70,264,263,11]),function(Y,e,g,L,D,S,T,C,E,k,i,I,a,p,h,w,y,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.registerSingleton)(i.IExtHostExtensionService,C.ExtHostExtensionService),(0,g.registerSingleton)(b.ILoggerService,P.ExtHostLoggerService),(0,g.registerSingleton)(w.IExtensionStoragePaths,y.ExtensionStoragePaths),(0,g.registerSingleton)(k.IExtHostDebugService,S.ExtHostDebugService),(0,g.registerSingleton)(I.IExtHostSearch,T.NativeExtHostSearch),(0,g.registerSingleton)(a.IExtHostTask,D.ExtHostTask),(0,g.registerSingleton)(p.IExtHostTerminalService,L.ExtHostTerminalService),(0,g.registerSingleton)(h.IExtHostTunnelService,E.ExtHostTunnelService)}),define(fe[292],me([0,1,125,302,74,18,107,138,193,229,275,22,103,28,105,16,114,278,291]),function(Y,e,g,L,D,S,T,C,E,k,i,I,a,p,h,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let u=0;u<process.execArgv.length;u++)process.execArgv[u]==="--inspect-port=0"&&(process.execArgv.splice(u,1),u--)}();const P=L(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"],boolean:["skipWorkspaceStorageLock"]});(function(){const t=Y.__$__nodeRequire("module"),u=t._load;t._load=function(l){if(l==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return u.apply(this,arguments)}})();const b=process.exit.bind(process);function o(t){process.exit=function(u){if(t)b(u);else{const l=new Error("An extension called process.exit() and this was prevented.");console.warn(l.stack)}},process.crash=function(){const u=new Error("An extension called process.crash() and this was prevented.");console.warn(u.stack)}}let s=function(t){b()};function v(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((t,u)=>{let l=null,c=setTimeout(()=>{s("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const m=108e5,d=3e5,_=new w.ProcessTimeRunOnceScheduler(()=>s("renderer disconnected for too long (1)"),m),A=new w.ProcessTimeRunOnceScheduler(()=>s("renderer disconnected for too long (2)"),d);process.on("message",(B,U)=>{if(B&&B.type==="VSCODE_EXTHOST_IPC_SOCKET"){const F=I.VSBuffer.wrap(Buffer.from(B.initialDataChunk,"base64"));let $;if(B.skipWebSocketFrames)$=new C.NodeSocket(U);else{const M=I.VSBuffer.wrap(Buffer.from(B.inflateBytes,"base64"));$=new C.WebSocketNodeSocket(new C.NodeSocket(U),B.permessageDeflate,M,!1)}l?(_.cancel(),A.cancel(),l.beginAcceptReconnection($,F),l.endAcceptReconnection()):(clearTimeout(c),l=new T.PersistentProtocol($,F),l.onDidDispose(()=>s("renderer disconnected")),t(l),l.onSocketClose(()=>{_.schedule()}))}if(B&&B.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(A.isScheduled())return;_.isScheduled()&&A.schedule()}});const R={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(R)});{const t=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((u,l)=>{const c=g.createConnection(t,()=>{c.removeListener("error",l),u(new T.PersistentProtocol(new C.NodeSocket(c)))});c.once("error",l),c.on("close",()=>{s("renderer closed the socket")})})}}async function n(){const t=await v();return new class{constructor(){this._onMessage=new T.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,t.onMessage(u=>{(0,k.isMessageOfType)(u,2)?(this._terminating=!0,s("received terminate message from renderer")):this._onMessage.fire(u)})}send(u){this._terminating||t.send(u)}drain(){return t.drain()}}}function f(t){return new Promise(u=>{const l=t.onMessage(c=>{l.dispose();const m=JSON.parse(c.toString()),d=m.commit,_=E.default.commit;d&&_&&d!==_&&b(55);const A=[];process.on("unhandledRejection",(U,F)=>{A.push(F),setTimeout(()=>{const $=A.indexOf(F);$>=0&&F.catch(M=>{A.splice($,1),(0,S.isPromiseCanceledError)(M)||(console.warn(`rejected promise not handled within 1 second: ${M}`),M&&M.stack&&console.warn(`stack trace: ${M.stack}`),U&&(0,S.onUnexpectedError)(U))})},1e3)}),process.on("rejectionHandled",U=>{const F=A.indexOf(U);F>=0&&A.splice(F,1)}),process.on("uncaughtException",function(U){(0,S.onUnexpectedError)(U)});let R=0;setInterval(function(){try{process.kill(m.parentPid,0),R=0}catch(U){U&&U.code==="EPERM"?(R++,R>=3&&s(`parent process ${m.parentPid} does not exist anymore (3 x EPERM): ${U.message} (code: ${U.code}) (errno: ${U.errno})`)):s(`parent process ${m.parentPid} does not exist anymore: ${U.message} (code: ${U.code}) (errno: ${U.errno})`)}},1e3);let B;try{B=Y.__$__nodeRequire("native-watchdog"),B.start(m.parentPid)}catch(U){(0,S.onUnexpectedError)(U)}t.send((0,k.createMessageOfType)(0)),u({protocol:t,initData:m})});t.send((0,k.createMessageOfType)(1))})}async function r(){D.mark("code/extHost/willConnectToRenderer");const t=await n();D.mark("code/extHost/didConnectToRenderer");const u=await f(t);D.mark("code/extHost/didWaitForInitData");const{initData:l}=u;o(!!l.environment.extensionTestsLocationURI),l.environment.useHostProxy=P.useHostProxy!==void 0?P.useHostProxy!=="false":void 0,l.environment.skipWorkspaceStorageLock=(0,y.boolean)(P.skipWorkspaceStorageLock,!1);const c=new class{constructor(){this.pid=process.pid}exit(A){b(A)}exists(A){return p.Promises.exists(A)}realpath(A){return(0,h.realpath)(A)}};let m=null;if(l.remote.authority&&P.uriTransformerPath)try{const A=Y.__$__nodeRequire(P.uriTransformerPath)(l.remote.authority);m=new a.URITransformer(A)}catch(_){console.error(_)}const d=new i.ExtensionHostMain(u.protocol,l,c,m);s=_=>d.terminate(_)}e.startExtensionHostProcess=r}),define(fe[303],me([0,1,292]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.startExtensionHostProcess)().catch(L=>console.log(L))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b614fb5db84b3ac07fc3e8b12c69c1dd581924ce/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
