/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var we=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/base/common/network","vs/platform/log/common/log","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/errors","vs/base/common/path","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/map","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/base/common/platform","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/severity","vs/base/common/uuid","vs/platform/contextkey/common/contextkey","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/extpath","vs/editor/common/core/range","vs/base/common/errorMessage","vs/platform/files/common/files","vs/platform/theme/common/themeService","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/base/common/hash","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/model","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/model/textModelSearch","vs/editor/common/core/position","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/tokenizationRegistry","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/model/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/remote/common/tunnel","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/core/characterClassifier","vs/editor/common/model/mirrorTextModel","vs/editor/common/viewModel/prefixSumComputer","vs/base/common/marked/marked","vs/base/common/linkedList","vs/editor/common/modes/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/workbench/services/extensions/worker/extensionHostWorker"],be=function(re){for(var e=[],u=0,M=re.length;u<M;u++)e[u]=we[re[u]];return e};define(we[43],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function u(M,E){if(!M)throw new Error(E?`Assertion failed (${E})`:"Assertion Failed")}e.ok=u}),define(we[54],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const u=Object.prototype.hasOwnProperty;function M(t){const _=[];for(let i in t)u.call(t,i)&&_.push(t[i]);return _}e.values=M;function E(t,_){for(let i in t)if(u.call(t,i)&&_({key:i,value:t[i]},function(){delete t[i]})===!1)return}e.forEach=E;function P(t,_){const i=Object.create(null);for(const m of t){const a=_(m);let f=i[a];f||(f=i[a]=[]),f.push(m)}return i}e.groupBy=P;function F(t){const _=Object.create(null);return t&&t.forEach((i,m)=>{_[m]=i}),_}e.fromMap=F;function T(t,_){const i=[],m=[];for(let a of t)_.has(a)||i.push(a);for(let a of _)t.has(a)||m.push(a);return{removed:i,added:m}}e.diffSets=T;function C(t,_){const i=[],m=[];for(let[a,f]of t)_.has(a)||i.push(f);for(let[a,f]of _)t.has(a)||m.push(f);return{removed:i,added:m}}e.diffMaps=C;class A{constructor(){this.map=new Map}add(_,i){let m=this.map.get(_);m||(m=new Set,this.map.set(_,m)),m.add(i)}delete(_,i){const m=this.map.get(_);!m||(m.delete(i),m.size===0&&this.map.delete(_))}forEach(_,i){const m=this.map.get(_);!m||m.forEach(i)}}e.SetMap=A}),define(we[55],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function u(F){return(T,C,A)=>{let t=null,_=null;if(typeof A.value=="function"?(t="value",_=A.value):typeof A.get=="function"&&(t="get",_=A.get),!_)throw new Error("not supported");A[t]=F(_,C)}}e.createDecorator=u;function M(F,T,C){let A=null,t=null;if(typeof C.value=="function"?(A="value",t=C.value,t.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof C.get=="function"&&(A="get",t=C.get),!t)throw new Error("not supported");const _=`$memoize$${T}`;C[A]=function(...i){return this.hasOwnProperty(_)||Object.defineProperty(this,_,{configurable:!1,enumerable:!1,writable:!1,value:t.apply(this,i)}),this[_]}}e.memoize=M;function E(F,T,C){return u((A,t)=>{const _=`$debounce$${t}`,i=`$debounce$result$${t}`;return function(...m){this[i]||(this[i]=C?C():void 0),clearTimeout(this[_]),T&&(this[i]=T(this[i],...m),m=[this[i]]),this[_]=setTimeout(()=>{A.apply(this,m),this[i]=C?C():void 0},F)}})}e.debounce=E;function P(F,T,C){return u((A,t)=>{const _=`$throttle$timer$${t}`,i=`$throttle$result$${t}`,m=`$throttle$lastRun$${t}`,a=`$throttle$pending$${t}`;return function(...f){if(this[i]||(this[i]=C?C():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),T&&(this[i]=T(this[i],...f)),this[a])return;const p=this[m]+F;p<=Date.now()?(this[m]=Date.now(),A.apply(this,[this[i]]),this[i]=C?C():void 0):(this[a]=!0,this[_]=setTimeout(()=>{this[a]=!1,this[m]=Date.now(),A.apply(this,[this[i]]),this[i]=C?C():void 0},p-Date.now()))}})}e.throttle=P}),define(we[56],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class u{constructor(E){this._prefix=E,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=u,e.defaultGenerator=new u("id#")}),define(we[102],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var u;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(u=e.ScanError||(e.ScanError={}));var M;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(M=e.SyntaxKind||(e.SyntaxKind={}));var E;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(E=e.ParseErrorCode||(e.ParseErrorCode={}));var P;(function(r){r.DEFAULT={allowTrailingComma:!0}})(P=e.ParseOptions||(e.ParseOptions={}));function F(r,w=!1){let s=0,n=r.length,g="",l=0,c=16,b=0;function h(x){let N=0,V=0;for(;N<x;){const W=r.charCodeAt(s);if(W>=48&&W<=57)V=V*16+W-48;else if(W>=65&&W<=70)V=V*16+W-65+10;else if(W>=97&&W<=102)V=V*16+W-97+10;else break;s++,N++}return N<x&&(V=-1),V}function y(x){s=x,g="",l=0,c=16,b=0}function R(){const x=s;if(r.charCodeAt(s)===48)s++;else for(s++;s<r.length&&A(r.charCodeAt(s));)s++;if(s<r.length&&r.charCodeAt(s)===46)if(s++,s<r.length&&A(r.charCodeAt(s)))for(s++;s<r.length&&A(r.charCodeAt(s));)s++;else return b=3,r.substring(x,s);let N=s;if(s<r.length&&(r.charCodeAt(s)===69||r.charCodeAt(s)===101))if(s++,(s<r.length&&r.charCodeAt(s)===43||r.charCodeAt(s)===45)&&s++,s<r.length&&A(r.charCodeAt(s))){for(s++;s<r.length&&A(r.charCodeAt(s));)s++;N=s}else b=3;return r.substring(x,N)}function I(){let x="",N=s;for(;;){if(s>=n){x+=r.substring(N,s),b=2;break}const V=r.charCodeAt(s);if(V===34){x+=r.substring(N,s),s++;break}if(V===92){if(x+=r.substring(N,s),s++,s>=n){b=2;break}switch(r.charCodeAt(s++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:const $=h(4);$>=0?x+=String.fromCharCode($):b=4;break;default:b=5}N=s;continue}if(V>=0&&V<=31)if(C(V)){x+=r.substring(N,s),b=2;break}else b=6;s++}return x}function B(){if(g="",b=0,l=s,s>=n)return l=n,c=17;let x=r.charCodeAt(s);if(T(x)){do s++,g+=String.fromCharCode(x),x=r.charCodeAt(s);while(T(x));return c=15}if(C(x))return s++,g+=String.fromCharCode(x),x===13&&r.charCodeAt(s)===10&&(s++,g+=`
`),c=14;switch(x){case 123:return s++,c=1;case 125:return s++,c=2;case 91:return s++,c=3;case 93:return s++,c=4;case 58:return s++,c=6;case 44:return s++,c=5;case 34:return s++,g=I(),c=10;case 47:const N=s-1;if(r.charCodeAt(s+1)===47){for(s+=2;s<n&&!C(r.charCodeAt(s));)s++;return g=r.substring(N,s),c=12}if(r.charCodeAt(s+1)===42){s+=2;const V=n-1;let W=!1;for(;s<V;){if(r.charCodeAt(s)===42&&r.charCodeAt(s+1)===47){s+=2,W=!0;break}s++}return W||(s++,b=1),g=r.substring(N,s),c=13}return g+=String.fromCharCode(x),s++,c=16;case 45:if(g+=String.fromCharCode(x),s++,s===n||!A(r.charCodeAt(s)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return g+=R(),c=11;default:for(;s<n&&L(x);)s++,x=r.charCodeAt(s);if(l!==s){switch(g=r.substring(l,s),g){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return g+=String.fromCharCode(x),s++,c=16}}function L(x){if(T(x)||C(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function k(){let x;do x=B();while(x>=12&&x<=15);return x}return{setPosition:y,getPosition:()=>s,scan:w?k:B,getToken:()=>c,getTokenValue:()=>g,getTokenOffset:()=>l,getTokenLength:()=>s-l,getTokenError:()=>b}}e.createScanner=F;function T(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function C(r){return r===10||r===13||r===8232||r===8233}function A(r){return r>=48&&r<=57}var t;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(t||(t={}));function _(r,w){const s=[],n=new Object;let g;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function b(h,y,R,I){l.value=h,l.offset=y,l.length=R,l.type=I,l.colonOffset=void 0,g=l}try{o(r,{onObjectBegin:(h,y)=>{if(w<=h)throw n;g=void 0,c=w>h,s.push("")},onObjectProperty:(h,y,R)=>{if(w<y||(b(h,y,R,"property"),s[s.length-1]=h,w<=y+R))throw n},onObjectEnd:(h,y)=>{if(w<=h)throw n;g=void 0,s.pop()},onArrayBegin:(h,y)=>{if(w<=h)throw n;g=void 0,s.push(0)},onArrayEnd:(h,y)=>{if(w<=h)throw n;g=void 0,s.pop()},onLiteralValue:(h,y,R)=>{if(w<y||(b(h,y,R,D(h)),w<=y+R))throw n},onSeparator:(h,y,R)=>{if(w<=y)throw n;if(h===":"&&g&&g.type==="property")g.colonOffset=y,c=!1,g=void 0;else if(h===","){const I=s[s.length-1];typeof I=="number"?s[s.length-1]=I+1:(c=!0,s[s.length-1]=""),g=void 0}}})}catch(h){if(h!==n)throw h}return{path:s,previousNode:g,isAtPropertyKey:c,matches:h=>{let y=0;for(let R=0;y<h.length&&R<s.length;R++)if(h[y]===s[R]||h[y]==="*")y++;else if(h[y]!=="**")return!1;return y===h.length}}}e.getLocation=_;function i(r,w=[],s=P.DEFAULT){let n=null,g=[];const l=[];function c(h){Array.isArray(g)?g.push(h):n!==null&&(g[n]=h)}return o(r,{onObjectBegin:()=>{const h={};c(h),l.push(g),g=h,n=null},onObjectProperty:h=>{n=h},onObjectEnd:()=>{g=l.pop()},onArrayBegin:()=>{const h=[];c(h),l.push(g),g=h,n=null},onArrayEnd:()=>{g=l.pop()},onLiteralValue:c,onError:(h,y,R)=>{w.push({error:h,offset:y,length:R})}},s),g[0]}e.parse=i;function m(r,w=[],s=P.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function g(h){n.type==="property"&&(n.length=h-n.offset,n=n.parent)}function l(h){return n.children.push(h),h}o(r,{onObjectBegin:h=>{n=l({type:"object",offset:h,length:-1,parent:n,children:[]})},onObjectProperty:(h,y,R)=>{n=l({type:"property",offset:y,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:h,offset:y,length:R,parent:n})},onObjectEnd:(h,y)=>{n.length=h+y-n.offset,n=n.parent,g(h+y)},onArrayBegin:(h,y)=>{n=l({type:"array",offset:h,length:-1,parent:n,children:[]})},onArrayEnd:(h,y)=>{n.length=h+y-n.offset,n=n.parent,g(h+y)},onLiteralValue:(h,y,R)=>{l({type:D(h),offset:y,length:R,parent:n,value:h}),g(y+R)},onSeparator:(h,y,R)=>{n.type==="property"&&(h===":"?n.colonOffset=y:h===","&&g(y))},onError:(h,y,R)=>{w.push({error:h,offset:y,length:R})}},s);const b=n.children[0];return b&&delete b.parent,b}e.parseTree=m;function a(r,w){if(!r)return;let s=r;for(let n of w)if(typeof n=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let g=!1;for(const l of s.children)if(Array.isArray(l.children)&&l.children[0].value===n){s=l.children[1],g=!0;break}if(!g)return}else{const g=n;if(s.type!=="array"||g<0||!Array.isArray(s.children)||g>=s.children.length)return;s=s.children[g]}return s}e.findNodeAtLocation=a;function f(r){if(!r.parent||!r.parent.children)return[];const w=f(r.parent);if(r.parent.type==="property"){const s=r.parent.children[0].value;w.push(s)}else if(r.parent.type==="array"){const s=r.parent.children.indexOf(r);s!==-1&&w.push(s)}return w}e.getNodePath=f;function p(r){switch(r.type){case"array":return r.children.map(p);case"object":const w=Object.create(null);for(let s of r.children){const n=s.children[1];n&&(w[s.children[0].value]=p(n))}return w;case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=p;function S(r,w,s=!1){return w>=r.offset&&w<r.offset+r.length||s&&w===r.offset+r.length}e.contains=S;function v(r,w,s=!1){if(S(r,w,s)){const n=r.children;if(Array.isArray(n))for(let g=0;g<n.length&&n[g].offset<=w;g++){const l=v(n[g],w,s);if(l)return l}return r}}e.findNodeAtOffset=v;function o(r,w,s=P.DEFAULT){const n=F(r,!1);function g(ce){return ce?()=>ce(n.getTokenOffset(),n.getTokenLength()):()=>!0}function l(ce){return ce?Fe=>ce(Fe,n.getTokenOffset(),n.getTokenLength()):()=>!0}const c=g(w.onObjectBegin),b=l(w.onObjectProperty),h=g(w.onObjectEnd),y=g(w.onArrayBegin),R=g(w.onArrayEnd),I=l(w.onLiteralValue),B=l(w.onSeparator),L=g(w.onComment),k=l(w.onError),x=s&&s.disallowComments,N=s&&s.allowTrailingComma;function V(){for(;;){const ce=n.scan();switch(n.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:x||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(ce){case 12:case 13:x?W(10):L();break;case 16:W(1);break;case 15:case 14:break;default:return ce}}}function W(ce,Fe=[],Qe=[]){if(k(ce),Fe.length+Qe.length>0){let Oe=n.getToken();for(;Oe!==17;){if(Fe.indexOf(Oe)!==-1){V();break}else if(Qe.indexOf(Oe)!==-1)break;Oe=V()}}}function $(ce){const Fe=n.getTokenValue();return ce?I(Fe):b(Fe),V(),!0}function X(){switch(n.getToken()){case 11:let ce=0;try{ce=JSON.parse(n.getTokenValue()),typeof ce!="number"&&(W(2),ce=0)}catch(Fe){W(2)}I(ce);break;case 7:I(null);break;case 8:I(!0);break;case 9:I(!1);break;default:return!1}return V(),!0}function j(){return n.getToken()!==10?(W(3,[],[2,5]),!1):($(!1),n.getToken()===6?(B(":"),V(),pe()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function Q(){c(),V();let ce=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(ce||W(4,[],[]),B(","),V(),n.getToken()===2&&N)break}else ce&&W(6,[],[]);j()||W(4,[],[2,5]),ce=!0}return h(),n.getToken()!==2?W(7,[2],[]):V(),!0}function ae(){y(),V();let ce=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(ce||W(4,[],[]),B(","),V(),n.getToken()===4&&N)break}else ce&&W(6,[],[]);pe()||W(4,[],[4,5]),ce=!0}return R(),n.getToken()!==4?W(8,[4],[]):V(),!0}function pe(){switch(n.getToken()){case 3:return ae();case 1:return Q();case 10:return $(!0);default:return X()}}return V(),n.getToken()===17?s.allowEmptyContent?!0:(W(4,[],[]),!1):pe()?(n.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.visit=o;function d(r,w){let s=F(r),n=[],g,l=0,c;do switch(c=s.getPosition(),g=s.scan(),g){case 12:case 13:case 17:l!==c&&n.push(r.substring(l,c)),w!==void 0&&n.push(s.getTokenValue().replace(/[^\r\n]/g,w)),l=s.getPosition();break}while(g!==17);return n.join("")}e.stripComments=d;function D(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=D}),define(we[103],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class u{constructor(E){this.executor=E,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(E){this._error=E}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(E){return new u(()=>E(this.getValue()))}}e.Lazy=u}),function(re,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(re=typeof globalThis!="undefined"?globalThis:re||self,re.marked=e())}(this,function(){"use strict";function re(Ie,ye){for(var De=0;De<ye.length;De++){var ee=ye[De];ee.enumerable=ee.enumerable||!1,ee.configurable=!0,"value"in ee&&(ee.writable=!0),Object.defineProperty(Ie,ee.key,ee)}}function e(Ie,ye,De){return ye&&re(Ie.prototype,ye),De&&re(Ie,De),Ie}function u(Ie,ye){if(!!Ie){if(typeof Ie=="string")return M(Ie,ye);var De=Object.prototype.toString.call(Ie).slice(8,-1);if(De==="Object"&&Ie.constructor&&(De=Ie.constructor.name),De==="Map"||De==="Set")return Array.from(Ie);if(De==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(De))return M(Ie,ye)}}function M(Ie,ye){(ye==null||ye>Ie.length)&&(ye=Ie.length);for(var De=0,ee=new Array(ye);De<ye;De++)ee[De]=Ie[De];return ee}function E(Ie,ye){var De=typeof Symbol!="undefined"&&Ie[Symbol.iterator]||Ie["@@iterator"];if(De)return(De=De.call(Ie)).next.bind(De);if(Array.isArray(Ie)||(De=u(Ie))||ye&&Ie&&typeof Ie.length=="number"){De&&(Ie=De);var ee=0;return function(){return ee>=Ie.length?{done:!0}:{done:!1,value:Ie[ee++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var P={exports:{}};function F(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function T(Ie){P.exports.defaults=Ie}P.exports={defaults:F(),getDefaults:F,changeDefaults:T};var C=/[&<>"']/,A=/[&<>"']/g,t=/[<>"']|&(?!#?\w+;)/,_=/[<>"']|&(?!#?\w+;)/g,i={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},m=function(ye){return i[ye]};function a(Ie,ye){if(ye){if(C.test(Ie))return Ie.replace(A,m)}else if(t.test(Ie))return Ie.replace(_,m);return Ie}var f=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function p(Ie){return Ie.replace(f,function(ye,De){return De=De.toLowerCase(),De==="colon"?":":De.charAt(0)==="#"?De.charAt(1)==="x"?String.fromCharCode(parseInt(De.substring(2),16)):String.fromCharCode(+De.substring(1)):""})}var S=/(^|[^\[])\^/g;function v(Ie,ye){Ie=Ie.source||Ie,ye=ye||"";var De={replace:function(oe,fe){return fe=fe.source||fe,fe=fe.replace(S,"$1"),Ie=Ie.replace(oe,fe),De},getRegex:function(){return new RegExp(Ie,ye)}};return De}var o=/[^\w:]/g,d=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function D(Ie,ye,De){if(Ie){var ee;try{ee=decodeURIComponent(p(De)).replace(o,"").toLowerCase()}catch(oe){return null}if(ee.indexOf("javascript:")===0||ee.indexOf("vbscript:")===0||ee.indexOf("data:")===0)return null}ye&&!d.test(De)&&(De=g(ye,De));try{De=encodeURI(De).replace(/%25/g,"%")}catch(oe){return null}return De}var r={},w=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,n=/^([^:]+:\/*[^/]*)[\s\S]*$/;function g(Ie,ye){r[" "+Ie]||(w.test(Ie)?r[" "+Ie]=Ie+"/":r[" "+Ie]=h(Ie,"/",!0)),Ie=r[" "+Ie];var De=Ie.indexOf(":")===-1;return ye.substring(0,2)==="//"?De?ye:Ie.replace(s,"$1")+ye:ye.charAt(0)==="/"?De?ye:Ie.replace(n,"$1")+ye:Ie+ye}var l={exec:function(){}};function c(Ie){for(var ye=1,De,ee;ye<arguments.length;ye++){De=arguments[ye];for(ee in De)Object.prototype.hasOwnProperty.call(De,ee)&&(Ie[ee]=De[ee])}return Ie}function b(Ie,ye){var De=Ie.replace(/\|/g,function(fe,he,ke){for(var Le=!1,Me=he;--Me>=0&&ke[Me]==="\\";)Le=!Le;return Le?"|":" |"}),ee=De.split(/ \|/),oe=0;if(ee[0].trim()||ee.shift(),ee[ee.length-1].trim()||ee.pop(),ee.length>ye)ee.splice(ye);else for(;ee.length<ye;)ee.push("");for(;oe<ee.length;oe++)ee[oe]=ee[oe].trim().replace(/\\\|/g,"|");return ee}function h(Ie,ye,De){var ee=Ie.length;if(ee===0)return"";for(var oe=0;oe<ee;){var fe=Ie.charAt(ee-oe-1);if(fe===ye&&!De)oe++;else if(fe!==ye&&De)oe++;else break}return Ie.substr(0,ee-oe)}function y(Ie,ye){if(Ie.indexOf(ye[1])===-1)return-1;for(var De=Ie.length,ee=0,oe=0;oe<De;oe++)if(Ie[oe]==="\\")oe++;else if(Ie[oe]===ye[0])ee++;else if(Ie[oe]===ye[1]&&(ee--,ee<0))return oe;return-1}function R(Ie){Ie&&Ie.sanitize&&!Ie.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function I(Ie,ye){if(ye<1)return"";for(var De="";ye>1;)ye&1&&(De+=Ie),ye>>=1,Ie+=Ie;return De+Ie}var B={escape:a,unescape:p,edit:v,cleanUrl:D,resolveUrl:g,noopTest:l,merge:c,splitCells:b,rtrim:h,findClosingBracket:y,checkSanitizeDeprecation:R,repeatString:I},L=P.exports.defaults,k=B.rtrim,x=B.splitCells,N=B.escape,V=B.findClosingBracket;function W(Ie,ye,De,ee){var oe=ye.href,fe=ye.title?N(ye.title):null,he=Ie[1].replace(/\\([\[\]])/g,"$1");if(Ie[0].charAt(0)!=="!"){ee.state.inLink=!0;var ke={type:"link",raw:De,href:oe,title:fe,text:he,tokens:ee.inlineTokens(he,[])};return ee.state.inLink=!1,ke}else return{type:"image",raw:De,href:oe,title:fe,text:N(he)}}function $(Ie,ye){var De=Ie.match(/^(\s+)(?:```)/);if(De===null)return ye;var ee=De[1];return ye.split(`
`).map(function(oe){var fe=oe.match(/^\s+/);if(fe===null)return oe;var he=fe[0];return he.length>=ee.length?oe.slice(ee.length):oe}).join(`
`)}var X=function(){function Ie(De){this.options=De||L}var ye=Ie.prototype;return ye.space=function(ee){var oe=this.rules.block.newline.exec(ee);if(oe)return oe[0].length>1?{type:"space",raw:oe[0]}:{raw:`
`}},ye.code=function(ee){var oe=this.rules.block.code.exec(ee);if(oe){var fe=oe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:oe[0],codeBlockStyle:"indented",text:this.options.pedantic?fe:k(fe,`
`)}}},ye.fences=function(ee){var oe=this.rules.block.fences.exec(ee);if(oe){var fe=oe[0],he=$(fe,oe[3]||"");return{type:"code",raw:fe,lang:oe[2]?oe[2].trim():oe[2],text:he}}},ye.heading=function(ee){var oe=this.rules.block.heading.exec(ee);if(oe){var fe=oe[2].trim();if(/#$/.test(fe)){var he=k(fe,"#");(this.options.pedantic||!he||/ $/.test(he))&&(fe=he.trim())}var ke={type:"heading",raw:oe[0],depth:oe[1].length,text:fe,tokens:[]};return this.lexer.inline(ke.text,ke.tokens),ke}},ye.hr=function(ee){var oe=this.rules.block.hr.exec(ee);if(oe)return{type:"hr",raw:oe[0]}},ye.blockquote=function(ee){var oe=this.rules.block.blockquote.exec(ee);if(oe){var fe=oe[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:oe[0],tokens:this.lexer.blockTokens(fe,[]),text:fe}}},ye.list=function(ee){var oe=this.rules.block.list.exec(ee);if(oe){var fe,he,ke,Le,Me,ze,it,Re,ue,me,ne=oe[1].trim(),H=ne.length>1,ve={type:"list",raw:"",ordered:H,start:H?+ne.slice(0,-1):"",loose:!1,items:[]};ne=H?"\\d{1,9}\\"+ne.slice(-1):"\\"+ne,this.options.pedantic&&(ne=H?ne:"[*+-]");for(var Ce=new RegExp("^( {0,3}"+ne+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");ee&&!(this.rules.block.hr.test(ee)||!(oe=Ce.exec(ee)));){ue=oe[2].split(`
`),this.options.pedantic?(Le=2,me=ue[0].trimLeft()):(Le=oe[2].search(/[^ ]/),Le=oe[1].length+(Le>4?1:Le),me=ue[0].slice(Le-oe[1].length)),ze=!1,fe=oe[0],!ue[0]&&/^ *$/.test(ue[1])&&(fe=oe[1]+ue.slice(0,2).join(`
`)+`
`,ve.loose=!0,ue=[]);var Ke=new RegExp("^ {0,"+Math.min(3,Le-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Me=1;Me<ue.length;Me++){if(Re=ue[Me],this.options.pedantic&&(Re=Re.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Ke.test(Re)){fe=oe[1]+ue.slice(0,Me).join(`
`)+`
`;break}if(!ze){Re.trim()||(ze=!0),Re.search(/[^ ]/)>=Le?me+=`
`+Re.slice(Le):me+=`
`+Re;continue}if(Re.search(/[^ ]/)>=Le||!Re.trim()){me+=`
`+Re.slice(Le);continue}else{fe=oe[1]+ue.slice(0,Me).join(`
`)+`
`;break}}ve.loose||(it?ve.loose=!0:/\n *\n *$/.test(fe)&&(it=!0)),this.options.gfm&&(he=/^\[[ xX]\] /.exec(me),he&&(ke=he[0]!=="[ ] ",me=me.replace(/^\[[ xX]\] +/,""))),ve.items.push({type:"list_item",raw:fe,task:!!he,checked:ke,loose:!1,text:me}),ve.raw+=fe,ee=ee.slice(fe.length)}ve.items[ve.items.length-1].raw=fe.trimRight(),ve.items[ve.items.length-1].text=me.trimRight(),ve.raw=ve.raw.trimRight();var xe=ve.items.length;for(Me=0;Me<xe;Me++)this.lexer.state.top=!1,ve.items[Me].tokens=this.lexer.blockTokens(ve.items[Me].text,[]),ve.items[Me].tokens.some(function(lt){return lt.type==="space"})&&(ve.loose=!0,ve.items[Me].loose=!0);return ve}},ye.html=function(ee){var oe=this.rules.block.html.exec(ee);if(oe){var fe={type:"html",raw:oe[0],pre:!this.options.sanitizer&&(oe[1]==="pre"||oe[1]==="script"||oe[1]==="style"),text:oe[0]};return this.options.sanitize&&(fe.type="paragraph",fe.text=this.options.sanitizer?this.options.sanitizer(oe[0]):N(oe[0]),fe.tokens=[],this.lexer.inline(fe.text,fe.tokens)),fe}},ye.def=function(ee){var oe=this.rules.block.def.exec(ee);if(oe){oe[3]&&(oe[3]=oe[3].substring(1,oe[3].length-1));var fe=oe[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:fe,raw:oe[0],href:oe[2],title:oe[3]}}},ye.table=function(ee){var oe=this.rules.block.table.exec(ee);if(oe){var fe={type:"table",header:x(oe[1]).map(function(it){return{text:it}}),align:oe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:oe[3]?oe[3].replace(/\n$/,"").split(`
`):[]};if(fe.header.length===fe.align.length){fe.raw=oe[0];var he=fe.align.length,ke,Le,Me,ze;for(ke=0;ke<he;ke++)/^ *-+: *$/.test(fe.align[ke])?fe.align[ke]="right":/^ *:-+: *$/.test(fe.align[ke])?fe.align[ke]="center":/^ *:-+ *$/.test(fe.align[ke])?fe.align[ke]="left":fe.align[ke]=null;for(he=fe.rows.length,ke=0;ke<he;ke++)fe.rows[ke]=x(fe.rows[ke],fe.header.length).map(function(it){return{text:it}});for(he=fe.header.length,Le=0;Le<he;Le++)fe.header[Le].tokens=[],this.lexer.inlineTokens(fe.header[Le].text,fe.header[Le].tokens);for(he=fe.rows.length,Le=0;Le<he;Le++)for(ze=fe.rows[Le],Me=0;Me<ze.length;Me++)ze[Me].tokens=[],this.lexer.inlineTokens(ze[Me].text,ze[Me].tokens);return fe}}},ye.lheading=function(ee){var oe=this.rules.block.lheading.exec(ee);if(oe){var fe={type:"heading",raw:oe[0],depth:oe[2].charAt(0)==="="?1:2,text:oe[1],tokens:[]};return this.lexer.inline(fe.text,fe.tokens),fe}},ye.paragraph=function(ee){var oe=this.rules.block.paragraph.exec(ee);if(oe){var fe={type:"paragraph",raw:oe[0],text:oe[1].charAt(oe[1].length-1)===`
`?oe[1].slice(0,-1):oe[1],tokens:[]};return this.lexer.inline(fe.text,fe.tokens),fe}},ye.text=function(ee){var oe=this.rules.block.text.exec(ee);if(oe){var fe={type:"text",raw:oe[0],text:oe[0],tokens:[]};return this.lexer.inline(fe.text,fe.tokens),fe}},ye.escape=function(ee){var oe=this.rules.inline.escape.exec(ee);if(oe)return{type:"escape",raw:oe[0],text:N(oe[1])}},ye.tag=function(ee){var oe=this.rules.inline.tag.exec(ee);if(oe)return!this.lexer.state.inLink&&/^<a /i.test(oe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(oe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(oe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(oe[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:oe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(oe[0]):N(oe[0]):oe[0]}},ye.link=function(ee){var oe=this.rules.inline.link.exec(ee);if(oe){var fe=oe[2].trim();if(!this.options.pedantic&&/^</.test(fe)){if(!/>$/.test(fe))return;var he=k(fe.slice(0,-1),"\\");if((fe.length-he.length)%2==0)return}else{var ke=V(oe[2],"()");if(ke>-1){var Le=oe[0].indexOf("!")===0?5:4,Me=Le+oe[1].length+ke;oe[2]=oe[2].substring(0,ke),oe[0]=oe[0].substring(0,Me).trim(),oe[3]=""}}var ze=oe[2],it="";if(this.options.pedantic){var Re=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ze);Re&&(ze=Re[1],it=Re[3])}else it=oe[3]?oe[3].slice(1,-1):"";return ze=ze.trim(),/^</.test(ze)&&(this.options.pedantic&&!/>$/.test(fe)?ze=ze.slice(1):ze=ze.slice(1,-1)),W(oe,{href:ze&&ze.replace(this.rules.inline._escapes,"$1"),title:it&&it.replace(this.rules.inline._escapes,"$1")},oe[0],this.lexer)}},ye.reflink=function(ee,oe){var fe;if((fe=this.rules.inline.reflink.exec(ee))||(fe=this.rules.inline.nolink.exec(ee))){var he=(fe[2]||fe[1]).replace(/\s+/g," ");if(he=oe[he.toLowerCase()],!he||!he.href){var ke=fe[0].charAt(0);return{type:"text",raw:ke,text:ke}}return W(fe,he,fe[0],this.lexer)}},ye.emStrong=function(ee,oe,fe){fe===void 0&&(fe="");var he=this.rules.inline.emStrong.lDelim.exec(ee);if(!!he&&!(he[3]&&fe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ke=he[1]||he[2]||"";if(!ke||ke&&(fe===""||this.rules.inline.punctuation.exec(fe))){var Le=he[0].length-1,Me,ze,it=Le,Re=0,ue=he[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ue.lastIndex=0,oe=oe.slice(-1*ee.length+Le);(he=ue.exec(oe))!=null;)if(Me=he[1]||he[2]||he[3]||he[4]||he[5]||he[6],!!Me){if(ze=Me.length,he[3]||he[4]){it+=ze;continue}else if((he[5]||he[6])&&Le%3&&!((Le+ze)%3)){Re+=ze;continue}if(it-=ze,!(it>0)){if(ze=Math.min(ze,ze+it+Re),Math.min(Le,ze)%2){var me=ee.slice(1,Le+he.index+ze);return{type:"em",raw:ee.slice(0,Le+he.index+ze+1),text:me,tokens:this.lexer.inlineTokens(me,[])}}var ne=ee.slice(2,Le+he.index+ze-1);return{type:"strong",raw:ee.slice(0,Le+he.index+ze+1),text:ne,tokens:this.lexer.inlineTokens(ne,[])}}}}}},ye.codespan=function(ee){var oe=this.rules.inline.code.exec(ee);if(oe){var fe=oe[2].replace(/\n/g," "),he=/[^ ]/.test(fe),ke=/^ /.test(fe)&&/ $/.test(fe);return he&&ke&&(fe=fe.substring(1,fe.length-1)),fe=N(fe,!0),{type:"codespan",raw:oe[0],text:fe}}},ye.br=function(ee){var oe=this.rules.inline.br.exec(ee);if(oe)return{type:"br",raw:oe[0]}},ye.del=function(ee){var oe=this.rules.inline.del.exec(ee);if(oe)return{type:"del",raw:oe[0],text:oe[2],tokens:this.lexer.inlineTokens(oe[2],[])}},ye.autolink=function(ee,oe){var fe=this.rules.inline.autolink.exec(ee);if(fe){var he,ke;return fe[2]==="@"?(he=N(this.options.mangle?oe(fe[1]):fe[1]),ke="mailto:"+he):(he=N(fe[1]),ke=he),{type:"link",raw:fe[0],text:he,href:ke,tokens:[{type:"text",raw:he,text:he}]}}},ye.url=function(ee,oe){var fe;if(fe=this.rules.inline.url.exec(ee)){var he,ke;if(fe[2]==="@")he=N(this.options.mangle?oe(fe[0]):fe[0]),ke="mailto:"+he;else{var Le;do Le=fe[0],fe[0]=this.rules.inline._backpedal.exec(fe[0])[0];while(Le!==fe[0]);he=N(fe[0]),fe[1]==="www."?ke="http://"+he:ke=he}return{type:"link",raw:fe[0],text:he,href:ke,tokens:[{type:"text",raw:he,text:he}]}}},ye.inlineText=function(ee,oe){var fe=this.rules.inline.text.exec(ee);if(fe){var he;return this.lexer.state.inRawBlock?he=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):N(fe[0]):fe[0]:he=N(this.options.smartypants?oe(fe[0]):fe[0]),{type:"text",raw:fe[0],text:he}}},Ie}(),j=B.noopTest,Q=B.edit,ae=B.merge,pe={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:j,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};pe._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,pe._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,pe.def=Q(pe.def).replace("label",pe._label).replace("title",pe._title).getRegex(),pe.bullet=/(?:[*+-]|\d{1,9}[.)])/,pe.listItemStart=Q(/^( *)(bull) */).replace("bull",pe.bullet).getRegex(),pe.list=Q(pe.list).replace(/bull/g,pe.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+pe.def.source+")").getRegex(),pe._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",pe._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,pe.html=Q(pe.html,"i").replace("comment",pe._comment).replace("tag",pe._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),pe.paragraph=Q(pe._paragraph).replace("hr",pe.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",pe._tag).getRegex(),pe.blockquote=Q(pe.blockquote).replace("paragraph",pe.paragraph).getRegex(),pe.normal=ae({},pe),pe.gfm=ae({},pe.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),pe.gfm.table=Q(pe.gfm.table).replace("hr",pe.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",pe._tag).getRegex(),pe.pedantic=ae({},pe.normal,{html:Q(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",pe._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:j,paragraph:Q(pe.normal._paragraph).replace("hr",pe.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",pe.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ce={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:j,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:j,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ce._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ce.punctuation=Q(ce.punctuation).replace(/punctuation/g,ce._punctuation).getRegex(),ce.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ce.escapedEmSt=/\\\*|\\_/g,ce._comment=Q(pe._comment).replace("(?:-->|$)","-->").getRegex(),ce.emStrong.lDelim=Q(ce.emStrong.lDelim).replace(/punct/g,ce._punctuation).getRegex(),ce.emStrong.rDelimAst=Q(ce.emStrong.rDelimAst,"g").replace(/punct/g,ce._punctuation).getRegex(),ce.emStrong.rDelimUnd=Q(ce.emStrong.rDelimUnd,"g").replace(/punct/g,ce._punctuation).getRegex(),ce._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ce._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ce._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ce.autolink=Q(ce.autolink).replace("scheme",ce._scheme).replace("email",ce._email).getRegex(),ce._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ce.tag=Q(ce.tag).replace("comment",ce._comment).replace("attribute",ce._attribute).getRegex(),ce._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ce._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ce._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ce.link=Q(ce.link).replace("label",ce._label).replace("href",ce._href).replace("title",ce._title).getRegex(),ce.reflink=Q(ce.reflink).replace("label",ce._label).getRegex(),ce.reflinkSearch=Q(ce.reflinkSearch,"g").replace("reflink",ce.reflink).replace("nolink",ce.nolink).getRegex(),ce.normal=ae({},ce),ce.pedantic=ae({},ce.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:Q(/^!?\[(label)\]\((.*?)\)/).replace("label",ce._label).getRegex(),reflink:Q(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ce._label).getRegex()}),ce.gfm=ae({},ce.normal,{escape:Q(ce.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ce.gfm.url=Q(ce.gfm.url,"i").replace("email",ce.gfm._extended_email).getRegex(),ce.breaks=ae({},ce.gfm,{br:Q(ce.br).replace("{2,}","*").getRegex(),text:Q(ce.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var Fe={block:pe,inline:ce},Qe=X,Oe=P.exports.defaults,He=Fe.block,Je=Fe.inline,Ye=B.repeatString;function qe(Ie){return Ie.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function z(Ie){var ye="",De,ee,oe=Ie.length;for(De=0;De<oe;De++)ee=Ie.charCodeAt(De),Math.random()>.5&&(ee="x"+ee.toString(16)),ye+="&#"+ee+";";return ye}var K=function(){function Ie(De){this.tokens=[],this.tokens.links=Object.create(null),this.options=De||Oe,this.options.tokenizer=this.options.tokenizer||new Qe,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ee={block:He.normal,inline:Je.normal};this.options.pedantic?(ee.block=He.pedantic,ee.inline=Je.pedantic):this.options.gfm&&(ee.block=He.gfm,this.options.breaks?ee.inline=Je.breaks:ee.inline=Je.gfm),this.tokenizer.rules=ee}Ie.lex=function(ee,oe){var fe=new Ie(oe);return fe.lex(ee)},Ie.lexInline=function(ee,oe){var fe=new Ie(oe);return fe.inlineTokens(ee)};var ye=Ie.prototype;return ye.lex=function(ee){ee=ee.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ee,this.tokens);for(var oe;oe=this.inlineQueue.shift();)this.inlineTokens(oe.src,oe.tokens);return this.tokens},ye.blockTokens=function(ee,oe){var fe=this;oe===void 0&&(oe=[]),this.options.pedantic&&(ee=ee.replace(/^ +$/gm,""));for(var he,ke,Le,Me;ee;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(it){return(he=it.call({lexer:fe},ee,oe))?(ee=ee.substring(he.raw.length),oe.push(he),!0):!1}))){if(he=this.tokenizer.space(ee)){ee=ee.substring(he.raw.length),he.type&&oe.push(he);continue}if(he=this.tokenizer.code(ee)){ee=ee.substring(he.raw.length),ke=oe[oe.length-1],ke&&(ke.type==="paragraph"||ke.type==="text")?(ke.raw+=`
`+he.raw,ke.text+=`
`+he.text,this.inlineQueue[this.inlineQueue.length-1].src=ke.text):oe.push(he);continue}if(he=this.tokenizer.fences(ee)){ee=ee.substring(he.raw.length),oe.push(he);continue}if(he=this.tokenizer.heading(ee)){ee=ee.substring(he.raw.length),oe.push(he);continue}if(he=this.tokenizer.hr(ee)){ee=ee.substring(he.raw.length),oe.push(he);continue}if(he=this.tokenizer.blockquote(ee)){ee=ee.substring(he.raw.length),oe.push(he);continue}if(he=this.tokenizer.list(ee)){ee=ee.substring(he.raw.length),oe.push(he);continue}if(he=this.tokenizer.html(ee)){ee=ee.substring(he.raw.length),oe.push(he);continue}if(he=this.tokenizer.def(ee)){ee=ee.substring(he.raw.length),ke=oe[oe.length-1],ke&&(ke.type==="paragraph"||ke.type==="text")?(ke.raw+=`
`+he.raw,ke.text+=`
`+he.raw,this.inlineQueue[this.inlineQueue.length-1].src=ke.text):this.tokens.links[he.tag]||(this.tokens.links[he.tag]={href:he.href,title:he.title});continue}if(he=this.tokenizer.table(ee)){ee=ee.substring(he.raw.length),oe.push(he);continue}if(he=this.tokenizer.lheading(ee)){ee=ee.substring(he.raw.length),oe.push(he);continue}if(Le=ee,this.options.extensions&&this.options.extensions.startBlock&&function(){var it=Infinity,Re=ee.slice(1),ue=void 0;fe.options.extensions.startBlock.forEach(function(me){ue=me.call({lexer:this},Re),typeof ue=="number"&&ue>=0&&(it=Math.min(it,ue))}),it<Infinity&&it>=0&&(Le=ee.substring(0,it+1))}(),this.state.top&&(he=this.tokenizer.paragraph(Le))){ke=oe[oe.length-1],Me&&ke.type==="paragraph"?(ke.raw+=`
`+he.raw,ke.text+=`
`+he.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ke.text):oe.push(he),Me=Le.length!==ee.length,ee=ee.substring(he.raw.length);continue}if(he=this.tokenizer.text(ee)){ee=ee.substring(he.raw.length),ke=oe[oe.length-1],ke&&ke.type==="text"?(ke.raw+=`
`+he.raw,ke.text+=`
`+he.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ke.text):oe.push(he);continue}if(ee){var ze="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(ze);break}else throw new Error(ze)}}return this.state.top=!0,oe},ye.inline=function(ee,oe){this.inlineQueue.push({src:ee,tokens:oe})},ye.inlineTokens=function(ee,oe){var fe=this;oe===void 0&&(oe=[]);var he,ke,Le,Me=ee,ze,it,Re;if(this.tokens.links){var ue=Object.keys(this.tokens.links);if(ue.length>0)for(;(ze=this.tokenizer.rules.inline.reflinkSearch.exec(Me))!=null;)ue.includes(ze[0].slice(ze[0].lastIndexOf("[")+1,-1))&&(Me=Me.slice(0,ze.index)+"["+Ye("a",ze[0].length-2)+"]"+Me.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ze=this.tokenizer.rules.inline.blockSkip.exec(Me))!=null;)Me=Me.slice(0,ze.index)+"["+Ye("a",ze[0].length-2)+"]"+Me.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ze=this.tokenizer.rules.inline.escapedEmSt.exec(Me))!=null;)Me=Me.slice(0,ze.index)+"++"+Me.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ee;)if(it||(Re=""),it=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ne){return(he=ne.call({lexer:fe},ee,oe))?(ee=ee.substring(he.raw.length),oe.push(he),!0):!1}))){if(he=this.tokenizer.escape(ee)){ee=ee.substring(he.raw.length),oe.push(he);continue}if(he=this.tokenizer.tag(ee)){ee=ee.substring(he.raw.length),ke=oe[oe.length-1],ke&&he.type==="text"&&ke.type==="text"?(ke.raw+=he.raw,ke.text+=he.text):oe.push(he);continue}if(he=this.tokenizer.link(ee)){ee=ee.substring(he.raw.length),oe.push(he);continue}if(he=this.tokenizer.reflink(ee,this.tokens.links)){ee=ee.substring(he.raw.length),ke=oe[oe.length-1],ke&&he.type==="text"&&ke.type==="text"?(ke.raw+=he.raw,ke.text+=he.text):oe.push(he);continue}if(he=this.tokenizer.emStrong(ee,Me,Re)){ee=ee.substring(he.raw.length),oe.push(he);continue}if(he=this.tokenizer.codespan(ee)){ee=ee.substring(he.raw.length),oe.push(he);continue}if(he=this.tokenizer.br(ee)){ee=ee.substring(he.raw.length),oe.push(he);continue}if(he=this.tokenizer.del(ee)){ee=ee.substring(he.raw.length),oe.push(he);continue}if(he=this.tokenizer.autolink(ee,z)){ee=ee.substring(he.raw.length),oe.push(he);continue}if(!this.state.inLink&&(he=this.tokenizer.url(ee,z))){ee=ee.substring(he.raw.length),oe.push(he);continue}if(Le=ee,this.options.extensions&&this.options.extensions.startInline&&function(){var ne=Infinity,H=ee.slice(1),ve=void 0;fe.options.extensions.startInline.forEach(function(Ce){ve=Ce.call({lexer:this},H),typeof ve=="number"&&ve>=0&&(ne=Math.min(ne,ve))}),ne<Infinity&&ne>=0&&(Le=ee.substring(0,ne+1))}(),he=this.tokenizer.inlineText(Le,qe)){ee=ee.substring(he.raw.length),he.raw.slice(-1)!=="_"&&(Re=he.raw.slice(-1)),it=!0,ke=oe[oe.length-1],ke&&ke.type==="text"?(ke.raw+=he.raw,ke.text+=he.text):oe.push(he);continue}if(ee){var me="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(me);break}else throw new Error(me)}}return oe},e(Ie,null,[{key:"rules",get:function(){return{block:He,inline:Je}}}]),Ie}(),Z=P.exports.defaults,se=B.cleanUrl,G=B.escape,ie=function(){function Ie(De){this.options=De||Z}var ye=Ie.prototype;return ye.code=function(ee,oe,fe){var he=(oe||"").match(/\S*/)[0];if(this.options.highlight){var ke=this.options.highlight(ee,he);ke!=null&&ke!==ee&&(fe=!0,ee=ke)}return ee=ee.replace(/\n$/,"")+`
`,he?'<pre><code class="'+this.options.langPrefix+G(he,!0)+'">'+(fe?ee:G(ee,!0))+`</code></pre>
`:"<pre><code>"+(fe?ee:G(ee,!0))+`</code></pre>
`},ye.blockquote=function(ee){return`<blockquote>
`+ee+`</blockquote>
`},ye.html=function(ee){return ee},ye.heading=function(ee,oe,fe,he){return this.options.headerIds?"<h"+oe+' id="'+this.options.headerPrefix+he.slug(fe)+'">'+ee+"</h"+oe+`>
`:"<h"+oe+">"+ee+"</h"+oe+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(ee,oe,fe){var he=oe?"ol":"ul",ke=oe&&fe!==1?' start="'+fe+'"':"";return"<"+he+ke+`>
`+ee+"</"+he+`>
`},ye.listitem=function(ee){return"<li>"+ee+`</li>
`},ye.checkbox=function(ee){return"<input "+(ee?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(ee){return"<p>"+ee+`</p>
`},ye.table=function(ee,oe){return oe&&(oe="<tbody>"+oe+"</tbody>"),`<table>
<thead>
`+ee+`</thead>
`+oe+`</table>
`},ye.tablerow=function(ee){return`<tr>
`+ee+`</tr>
`},ye.tablecell=function(ee,oe){var fe=oe.header?"th":"td",he=oe.align?"<"+fe+' align="'+oe.align+'">':"<"+fe+">";return he+ee+"</"+fe+`>
`},ye.strong=function(ee){return"<strong>"+ee+"</strong>"},ye.em=function(ee){return"<em>"+ee+"</em>"},ye.codespan=function(ee){return"<code>"+ee+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(ee){return"<del>"+ee+"</del>"},ye.link=function(ee,oe,fe){if(ee=se(this.options.sanitize,this.options.baseUrl,ee),ee===null)return fe;var he='<a href="'+G(ee)+'"';return oe&&(he+=' title="'+oe+'"'),he+=">"+fe+"</a>",he},ye.image=function(ee,oe,fe){if(ee=se(this.options.sanitize,this.options.baseUrl,ee),ee===null)return fe;var he='<img src="'+ee+'" alt="'+fe+'"';return oe&&(he+=' title="'+oe+'"'),he+=this.options.xhtml?"/>":">",he},ye.text=function(ee){return ee},Ie}(),de=function(){function Ie(){}var ye=Ie.prototype;return ye.strong=function(ee){return ee},ye.em=function(ee){return ee},ye.codespan=function(ee){return ee},ye.del=function(ee){return ee},ye.html=function(ee){return ee},ye.text=function(ee){return ee},ye.link=function(ee,oe,fe){return""+fe},ye.image=function(ee,oe,fe){return""+fe},ye.br=function(){return""},Ie}(),Pe=function(){function Ie(){this.seen={}}var ye=Ie.prototype;return ye.serialize=function(ee){return ee.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(ee,oe){var fe=ee,he=0;if(this.seen.hasOwnProperty(fe)){he=this.seen[ee];do he++,fe=ee+"-"+he;while(this.seen.hasOwnProperty(fe))}return oe||(this.seen[ee]=he,this.seen[fe]=0),fe},ye.slug=function(ee,oe){oe===void 0&&(oe={});var fe=this.serialize(ee);return this.getNextSafeSlug(fe,oe.dryrun)},Ie}(),Ne=ie,We=de,je=Pe,et=P.exports.defaults,ot=B.unescape,_e=function(){function Ie(De){this.options=De||et,this.options.renderer=this.options.renderer||new Ne,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new We,this.slugger=new je}Ie.parse=function(ee,oe){var fe=new Ie(oe);return fe.parse(ee)},Ie.parseInline=function(ee,oe){var fe=new Ie(oe);return fe.parseInline(ee)};var ye=Ie.prototype;return ye.parse=function(ee,oe){oe===void 0&&(oe=!0);var fe="",he,ke,Le,Me,ze,it,Re,ue,me,ne,H,ve,Ce,Ke,xe,lt,Et,vt,ut,gt=ee.length;for(he=0;he<gt;he++){if(ne=ee[he],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ne.type]&&(ut=this.options.extensions.renderers[ne.type].call({parser:this},ne),ut!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ne.type))){fe+=ut||"";continue}switch(ne.type){case"space":continue;case"hr":{fe+=this.renderer.hr();continue}case"heading":{fe+=this.renderer.heading(this.parseInline(ne.tokens),ne.depth,ot(this.parseInline(ne.tokens,this.textRenderer)),this.slugger);continue}case"code":{fe+=this.renderer.code(ne.text,ne.lang,ne.escaped);continue}case"table":{for(ue="",Re="",Me=ne.header.length,ke=0;ke<Me;ke++)Re+=this.renderer.tablecell(this.parseInline(ne.header[ke].tokens),{header:!0,align:ne.align[ke]});for(ue+=this.renderer.tablerow(Re),me="",Me=ne.rows.length,ke=0;ke<Me;ke++){for(it=ne.rows[ke],Re="",ze=it.length,Le=0;Le<ze;Le++)Re+=this.renderer.tablecell(this.parseInline(it[Le].tokens),{header:!1,align:ne.align[Le]});me+=this.renderer.tablerow(Re)}fe+=this.renderer.table(ue,me);continue}case"blockquote":{me=this.parse(ne.tokens),fe+=this.renderer.blockquote(me);continue}case"list":{for(H=ne.ordered,ve=ne.start,Ce=ne.loose,Me=ne.items.length,me="",ke=0;ke<Me;ke++)xe=ne.items[ke],lt=xe.checked,Et=xe.task,Ke="",xe.task&&(vt=this.renderer.checkbox(lt),Ce?xe.tokens.length>0&&xe.tokens[0].type==="paragraph"?(xe.tokens[0].text=vt+" "+xe.tokens[0].text,xe.tokens[0].tokens&&xe.tokens[0].tokens.length>0&&xe.tokens[0].tokens[0].type==="text"&&(xe.tokens[0].tokens[0].text=vt+" "+xe.tokens[0].tokens[0].text)):xe.tokens.unshift({type:"text",text:vt}):Ke+=vt),Ke+=this.parse(xe.tokens,Ce),me+=this.renderer.listitem(Ke,Et,lt);fe+=this.renderer.list(me,H,ve);continue}case"html":{fe+=this.renderer.html(ne.text);continue}case"paragraph":{fe+=this.renderer.paragraph(this.parseInline(ne.tokens));continue}case"text":{for(me=ne.tokens?this.parseInline(ne.tokens):ne.text;he+1<gt&&ee[he+1].type==="text";)ne=ee[++he],me+=`
`+(ne.tokens?this.parseInline(ne.tokens):ne.text);fe+=oe?this.renderer.paragraph(me):me;continue}default:{var dt='Token with "'+ne.type+'" type was not found.';if(this.options.silent){console.error(dt);return}else throw new Error(dt)}}}return fe},ye.parseInline=function(ee,oe){oe=oe||this.renderer;var fe="",he,ke,Le,Me=ee.length;for(he=0;he<Me;he++){if(ke=ee[he],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ke.type]&&(Le=this.options.extensions.renderers[ke.type].call({parser:this},ke),Le!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(ke.type))){fe+=Le||"";continue}switch(ke.type){case"escape":{fe+=oe.text(ke.text);break}case"html":{fe+=oe.html(ke.text);break}case"link":{fe+=oe.link(ke.href,ke.title,this.parseInline(ke.tokens,oe));break}case"image":{fe+=oe.image(ke.href,ke.title,ke.text);break}case"strong":{fe+=oe.strong(this.parseInline(ke.tokens,oe));break}case"em":{fe+=oe.em(this.parseInline(ke.tokens,oe));break}case"codespan":{fe+=oe.codespan(ke.text);break}case"br":{fe+=oe.br();break}case"del":{fe+=oe.del(this.parseInline(ke.tokens,oe));break}case"text":{fe+=oe.text(ke.text);break}default:{var ze='Token with "'+ke.type+'" type was not found.';if(this.options.silent){console.error(ze);return}else throw new Error(ze)}}}return fe},Ie}(),nt=K,q=_e,J=X,ge=ie,$e=de,Ge=Pe,rt=B.merge,ft=B.checkSanitizeDeprecation,ht=B.escape,Dt=P.exports.getDefaults,Tt=P.exports.changeDefaults,It=P.exports.defaults;function Xe(Ie,ye,De){if(typeof Ie=="undefined"||Ie===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ie!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ie)+", string expected");if(typeof ye=="function"&&(De=ye,ye=null),ye=rt({},Xe.defaults,ye||{}),ft(ye),De){var ee=ye.highlight,oe;try{oe=nt.lex(Ie,ye)}catch(Le){return De(Le)}var fe=function(Me){var ze;if(!Me)try{ye.walkTokens&&Xe.walkTokens(oe,ye.walkTokens),ze=q.parse(oe,ye)}catch(it){Me=it}return ye.highlight=ee,Me?De(Me):De(null,ze)};if(!ee||ee.length<3||(delete ye.highlight,!oe.length))return fe();var he=0;Xe.walkTokens(oe,function(Le){Le.type==="code"&&(he++,setTimeout(function(){ee(Le.text,Le.lang,function(Me,ze){if(Me)return fe(Me);ze!=null&&ze!==Le.text&&(Le.text=ze,Le.escaped=!0),he--,he===0&&fe()})},0))}),he===0&&fe();return}try{var ke=nt.lex(Ie,ye);return ye.walkTokens&&Xe.walkTokens(ke,ye.walkTokens),q.parse(ke,ye)}catch(Le){if(Le.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+ht(Le.message+"",!0)+"</pre>";throw Le}}Xe.options=Xe.setOptions=function(Ie){return rt(Xe.defaults,Ie),Tt(Xe.defaults),Xe},Xe.getDefaults=Dt,Xe.defaults=It,Xe.use=function(){for(var Ie=this,ye=arguments.length,De=new Array(ye),ee=0;ee<ye;ee++)De[ee]=arguments[ee];var oe=rt.apply(void 0,[{}].concat(De)),fe=Xe.defaults.extensions||{renderers:{},childTokens:{}},he;De.forEach(function(ke){if(ke.extensions&&(he=!0,ke.extensions.forEach(function(Me){if(!Me.name)throw new Error("extension name required");if(Me.renderer){var ze=fe.renderers?fe.renderers[Me.name]:null;ze?fe.renderers[Me.name]=function(){for(var it=arguments.length,Re=new Array(it),ue=0;ue<it;ue++)Re[ue]=arguments[ue];var me=Me.renderer.apply(this,Re);return me===!1&&(me=ze.apply(this,Re)),me}:fe.renderers[Me.name]=Me.renderer}if(Me.tokenizer){if(!Me.level||Me.level!=="block"&&Me.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");fe[Me.level]?fe[Me.level].unshift(Me.tokenizer):fe[Me.level]=[Me.tokenizer],Me.start&&(Me.level==="block"?fe.startBlock?fe.startBlock.push(Me.start):fe.startBlock=[Me.start]:Me.level==="inline"&&(fe.startInline?fe.startInline.push(Me.start):fe.startInline=[Me.start]))}Me.childTokens&&(fe.childTokens[Me.name]=Me.childTokens)})),ke.renderer&&function(){var Me=Xe.defaults.renderer||new ge,ze=function(ue){var me=Me[ue];Me[ue]=function(){for(var ne=arguments.length,H=new Array(ne),ve=0;ve<ne;ve++)H[ve]=arguments[ve];var Ce=ke.renderer[ue].apply(Me,H);return Ce===!1&&(Ce=me.apply(Me,H)),Ce}};for(var it in ke.renderer)ze(it);oe.renderer=Me}(),ke.tokenizer&&function(){var Me=Xe.defaults.tokenizer||new J,ze=function(ue){var me=Me[ue];Me[ue]=function(){for(var ne=arguments.length,H=new Array(ne),ve=0;ve<ne;ve++)H[ve]=arguments[ve];var Ce=ke.tokenizer[ue].apply(Me,H);return Ce===!1&&(Ce=me.apply(Me,H)),Ce}};for(var it in ke.tokenizer)ze(it);oe.tokenizer=Me}(),ke.walkTokens){var Le=Xe.defaults.walkTokens;oe.walkTokens=function(Me){ke.walkTokens.call(Ie,Me),Le&&Le(Me)}}he&&(oe.extensions=fe),Xe.setOptions(oe)})},Xe.walkTokens=function(Ie,ye){for(var De=function(){var he=oe.value;switch(ye(he),he.type){case"table":{for(var ke=E(he.header),Le;!(Le=ke()).done;){var Me=Le.value;Xe.walkTokens(Me.tokens,ye)}for(var ze=E(he.rows),it;!(it=ze()).done;)for(var Re=it.value,ue=E(Re),me;!(me=ue()).done;){var ne=me.value;Xe.walkTokens(ne.tokens,ye)}break}case"list":{Xe.walkTokens(he.items,ye);break}default:Xe.defaults.extensions&&Xe.defaults.extensions.childTokens&&Xe.defaults.extensions.childTokens[he.type]?Xe.defaults.extensions.childTokens[he.type].forEach(function(H){Xe.walkTokens(he[H],ye)}):he.tokens&&Xe.walkTokens(he.tokens,ye)}},ee=E(Ie),oe;!(oe=ee()).done;)De()},Xe.parseInline=function(Ie,ye){if(typeof Ie=="undefined"||Ie===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ie!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ie)+", string expected");ye=rt({},Xe.defaults,ye||{}),ft(ye);try{var De=nt.lexInline(Ie,ye);return ye.walkTokens&&Xe.walkTokens(De,ye.walkTokens),q.parseInline(De,ye)}catch(ee){if(ee.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+ht(ee.message+"",!0)+"</pre>";throw ee}},Xe.Parser=q,Xe.parser=q.parse,Xe.Renderer=ge,Xe.TextRenderer=$e,Xe.Lexer=nt,Xe.lexer=nt.lex,Xe.Tokenizer=J,Xe.Slugger=Ge,Xe.parse=Xe;var pt=Xe;return pt}),define(we[76],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function u(F,T,C){return Math.min(Math.max(F,T),C)}e.clamp=u;function M(F,T){return(T+F%T)%T}e.rot=M;class E{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=E;class P{constructor(){this._n=1,this._val=0}update(T){return this._val=this._val+(T-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=P}),function(){function re(E){const P=[];typeof E=="number"&&P.push("code/timeOrigin",E);function F(C){P.push(C,Date.now())}function T(){const C=[];for(let A=0;A<P.length;A+=2)C.push({name:P[A],startTime:P[A+1]});return C}return{mark:F,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?re():{mark(E){performance.mark(E)},getMarks(){let E=performance.timeOrigin;typeof E!="number"&&(E=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(E)}];for(const F of performance.getEntriesByType("mark"))P.push({name:F.name,startTime:Math.round(E+F.startTime)});return P}};if(typeof process=="object"){const E=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return re(E)}else return console.trace("perf-util loaded in UNKNOWN environment"),re()}function u(E){return E.MonacoPerformanceMarks||(E.MonacoPerformanceMarks=e()),E.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return u(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=u(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=u(M))}(),define(we[35],be([0,1,3]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class M{constructor(){this._icons=new Map,this._onDidRegister=new u.Emitter}add(_){const i=this._icons.get(_.id);i?_.description?i.description=_.description:console.error(`Duplicate registration of codicon ${_.id}`):(this._icons.set(_.id,_),this._onDidRegister.fire(_))}get(_){return this._icons.get(_)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const E=new M;e.iconRegistry=E;function P(t,_){return new T(t,_)}e.registerCodicon=P;function F(t){return t?t.replace(/\$\((.*?)\)/g,(_,i)=>` ${i} `).trim():""}e.getCodiconAriaLabel=F;class T{constructor(_,i,m){this.id=_,this.definition=i,this.description=m,E.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=T;function C(t,_){const i=["codicon","codicon-"+t];return _&&i.push("codicon-modifier-"+_),i}e.getClassNamesArray=C;var A;(function(t){t.iconNameSegment="[A-Za-z0-9]+",t.iconNameExpression="[A-Za-z0-9\\-]+",t.iconModifierExpression="~[A-Za-z]+",t.iconNameCharacter="[A-Za-z0-9\\-~]";const _=new RegExp(`^(${t.iconNameExpression})(${t.iconModifierExpression})?$`);function i(f){if(f instanceof T)return["codicon","codicon-"+f.id];const p=_.exec(f.id);if(!p)return i(T.error);let[,S,v]=p;const o=["codicon","codicon-"+S];return v&&o.push("codicon-modifier-"+v.substr(1)),o}t.asClassNameArray=i;function m(f){return i(f).join(" ")}t.asClassName=m;function a(f){return"."+i(f).join(".")}t.asCSSSelector=a})(A=e.CSSIcon||(e.CSSIcon={})),function(t){t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"})}(T=e.Codicon||(e.Codicon={}))}),define(we[104],be([0,1,16,6]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function E(o){const d=o;return d?[d.on,d.pause,d.resume,d.destroy].every(D=>typeof D=="function"):!1}e.isReadableStream=E;function P(o){const d=o;return d?E(d.stream)&&Array.isArray(d.buffer)&&typeof d.ended=="boolean":!1}e.isReadableBufferedStream=P;function F(o,d){return new T(o,d)}e.newWriteableStream=F;class T{constructor(d,D){this.reducer=d,this.options=D,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(d){if(!this.state.destroyed){if(this.state.flowing)this.emitData(d);else if(this.buffer.data.push(d),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(D=>this.pendingWritePromises.push(D))}}error(d){this.state.destroyed||(this.state.flowing?this.emitError(d):this.buffer.error.push(d))}end(d){this.state.destroyed||(typeof d!="undefined"&&this.write(d),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(d){this.listeners.data.slice(0).forEach(D=>D(d))}emitError(d){this.listeners.error.length===0?(0,u.onUnexpectedError)(d):this.listeners.error.slice(0).forEach(D=>D(d))}emitEnd(){this.listeners.end.slice(0).forEach(d=>d())}on(d,D){if(!this.state.destroyed)switch(d){case"data":this.listeners.data.push(D),this.resume();break;case"end":this.listeners.end.push(D),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(D),this.state.flowing&&this.flowErrors();break}}removeListener(d,D){if(this.state.destroyed)return;let r;switch(d){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const w=r.indexOf(D);w>=0&&r.splice(w,1)}}flowData(){if(this.buffer.data.length>0){const d=this.reducer(this.buffer.data);this.emitData(d),this.buffer.data.length=0;const D=[...this.pendingWritePromises];this.pendingWritePromises.length=0,D.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const d of this.buffer.error)this.emitError(d);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function C(o,d){const D=[];let r;for(;(r=o.read())!==null;)D.push(r);return d(D)}e.consumeReadable=C;function A(o,d,D){const r=[];let w;for(;(w=o.read())!==null&&r.length<D;)r.push(w);return w===null&&r.length>0?d(r):{read:()=>{if(r.length>0)return r.shift();if(typeof w!="undefined"){const s=w;return w=void 0,s}return o.read()}}}e.peekReadable=A;function t(o,d){return new Promise((D,r)=>{const w=[];_(o,{onData:s=>{d&&w.push(s)},onError:s=>{d?r(s):D(void 0)},onEnd:()=>{D(d?d(w):void 0)}})})}e.consumeStream=t;function _(o,d){o.on("error",D=>d.onError(D)),o.on("end",()=>d.onEnd()),o.on("data",D=>d.onData(D))}e.listenStream=_;function i(o,d){return new Promise((D,r)=>{const w=new M.DisposableStore,s=[],n=c=>{if(s.push(c),s.length>d)return w.dispose(),o.pause(),D({stream:o,buffer:s,ended:!1})},g=c=>r(c),l=()=>D({stream:o,buffer:s,ended:!0});w.add((0,M.toDisposable)(()=>o.removeListener("error",g))),o.on("error",g),w.add((0,M.toDisposable)(()=>o.removeListener("end",l))),o.on("end",l),w.add((0,M.toDisposable)(()=>o.removeListener("data",n))),o.on("data",n)})}e.peekStream=i;function m(o,d){const D=F(d);return D.end(o),D}e.toStream=m;function a(){const o=F(()=>{throw new Error("not supported")});return o.end(),o}e.emptyStream=a;function f(o){let d=!1;return{read:()=>d?null:(d=!0,o)}}e.toReadable=f;function p(o,d,D){const r=F(D);return _(o,{onData:w=>r.write(d.data(w)),onError:w=>r.error(d.error?d.error(w):w),onEnd:()=>r.end()}),r}e.transform=p;function S(o,d,D){let r=!1;return{read:()=>{const w=d.read();return r?w:(r=!0,w!==null?D([o,w]):o)}}}e.prefixedReadable=S;function v(o,d,D){let r=!1;const w=F(D);return _(d,{onData:s=>r?w.write(s):(r=!0,w.write(D([o,s]))),onError:s=>w.error(s),onEnd:()=>{r||(r=!0,w.write(o)),w.end()}}),w}e.prefixedStream=v}),define(we[22],be([0,1,104]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const M=typeof Buffer!="undefined";let E,P;class F{constructor(n){this.buffer=n,this.byteLength=this.buffer.byteLength}static alloc(n){return M?new F(Buffer.allocUnsafe(n)):new F(new Uint8Array(n))}static wrap(n){return M&&!Buffer.isBuffer(n)&&(n=Buffer.from(n.buffer,n.byteOffset,n.byteLength)),new F(n)}static fromString(n,g){return!(g?.dontUseNodeBuffer||!1)&&M?new F(Buffer.from(n)):(E||(E=new TextEncoder),new F(E.encode(n)))}static concat(n,g){if(typeof g=="undefined"){g=0;for(let b=0,h=n.length;b<h;b++)g+=n[b].byteLength}const l=F.alloc(g);let c=0;for(let b=0,h=n.length;b<h;b++){const y=n[b];l.set(y,c),c+=y.byteLength}return l}toString(){return M?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(n,g){return new F(this.buffer.subarray(n,g))}set(n,g){n instanceof F?this.buffer.set(n.buffer,g):this.buffer.set(n,g)}readUInt32BE(n){return A(this.buffer,n)}writeUInt32BE(n,g){t(this.buffer,n,g)}readUInt32LE(n){return _(this.buffer,n)}writeUInt32LE(n,g){i(this.buffer,n,g)}readUInt8(n){return m(this.buffer,n)}writeUInt8(n,g){a(this.buffer,n,g)}}e.VSBuffer=F;function T(s,n){return s[n+0]<<0>>>0|s[n+1]<<8>>>0}e.readUInt16LE=T;function C(s,n,g){s[g+0]=n&255,n=n>>>8,s[g+1]=n&255}e.writeUInt16LE=C;function A(s,n){return s[n]*2**24+s[n+1]*2**16+s[n+2]*2**8+s[n+3]}e.readUInt32BE=A;function t(s,n,g){s[g+3]=n,n=n>>>8,s[g+2]=n,n=n>>>8,s[g+1]=n,n=n>>>8,s[g]=n}e.writeUInt32BE=t;function _(s,n){return s[n+0]<<0>>>0|s[n+1]<<8>>>0|s[n+2]<<16>>>0|s[n+3]<<24>>>0}e.readUInt32LE=_;function i(s,n,g){s[g+0]=n&255,n=n>>>8,s[g+1]=n&255,n=n>>>8,s[g+2]=n&255,n=n>>>8,s[g+3]=n&255}e.writeUInt32LE=i;function m(s,n){return s[n]}e.readUInt8=m;function a(s,n,g){s[g]=n}e.writeUInt8=a;function f(s){return u.consumeReadable(s,n=>F.concat(n))}e.readableToBuffer=f;function p(s){return u.toReadable(s)}e.bufferToReadable=p;function S(s){return u.consumeStream(s,n=>F.concat(n))}e.streamToBuffer=S;async function v(s){return s.ended?F.concat(s.buffer):F.concat([...s.buffer,await S(s.stream)])}e.bufferedStreamToBuffer=v;function o(s){return u.toStream(s,n=>F.concat(n))}e.bufferToStream=o;function d(s){return u.transform(s,{data:n=>typeof n=="string"?F.fromString(n):F.wrap(n)},n=>F.concat(n))}e.streamToBufferReadableStream=d;function D(s){return u.newWriteableStream(n=>F.concat(n),s)}e.newWriteableBufferStream=D;function r(s,n){return u.prefixedReadable(s,n,g=>F.concat(g))}e.prefixedBufferReadable=r;function w(s,n){return u.prefixedStream(s,n,g=>F.concat(g))}e.prefixedBufferStream=w});var Ze=this&&this.__classPrivateFieldSet||function(re,e,u,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,u):E?E.value=u:e.set(re,u),u},Te=this&&this.__classPrivateFieldGet||function(re,e,u,M){if(u==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?M:u==="a"?M.call(re):M?M.value:e.get(re)};define(we[20],be([0,1,15,9]),function(re,e,u,M){"use strict";var E,P,F;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function T(s,n,g){let l=s.get(n);return l===void 0&&(l=g,s.set(n,l)),l}e.getOrSet=T;function C(s){const n=[];return s.forEach((g,l)=>{n.push(`${l} => ${g}`)}),`Map(${s.size}) {${n.join(", ")}}`}e.mapToString=C;function A(s){const n=[];return s.forEach(g=>{n.push(g)}),`Set(${s.size}) {${n.join(", ")}}`}e.setToString=A;class t{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const g=n.charCodeAt(0),l=this._value.charCodeAt(this._pos);return g-l}value(){return this._value[this._pos]}}e.StringIterator=t;class _{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,M.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=_;class i{constructor(n=!0,g=!0){this._splitOnBackslash=n,this._caseSensitive=g}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const g=this._value.charCodeAt(this._to);if(g===47||this._splitOnBackslash&&g===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,M.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=i;var m;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(m||(m={}));class a{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new i(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,M.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,M.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,M.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,M.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=a;class f{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(s){s[s.Left=-1]="Left",s[s.Mid=0]="Mid",s[s.Right=1]="Right"})(p||(p={}));class S{constructor(n){this._iter=n}static forUris(n=()=>!1){return new S(new a(n))}static forPaths(){return new S(new i)}static forStrings(){return new S(new t)}static forConfigKeys(){return new S(new _)}clear(){this._root=void 0}fill(n,g){if(g){const l=g.slice(0);(0,u.shuffle)(l);for(let c of l)this.set(c,n)}else{const l=n.slice(0);(0,u.shuffle)(l);for(let c of l)this.set(c[0],c[1])}}set(n,g){const l=this._iter.reset(n);let c;this._root||(this._root=new f,this._root.segment=l.value());const b=[];for(c=this._root;;){const y=l.cmp(c.segment);if(y>0)c.left||(c.left=new f,c.left.segment=l.value()),b.push([-1,c]),c=c.left;else if(y<0)c.right||(c.right=new f,c.right.segment=l.value()),b.push([1,c]),c=c.right;else if(l.hasNext())l.next(),c.mid||(c.mid=new f,c.mid.segment=l.value()),b.push([0,c]),c=c.mid;else break}const h=c.value;c.value=g,c.key=n;for(let y=b.length-1;y>=0;y--){const R=b[y][1];R.updateHeight();const I=R.balanceFactor();if(I<-1||I>1){const B=b[y][0],L=b[y+1][0];if(B===1&&L===1)b[y][1]=R.rotateLeft();else if(B===-1&&L===-1)b[y][1]=R.rotateRight();else if(B===1&&L===-1)R.right=b[y+1][1]=b[y+1][1].rotateRight(),b[y][1]=R.rotateLeft();else if(B===-1&&L===1)R.left=b[y+1][1]=b[y+1][1].rotateLeft(),b[y][1]=R.rotateRight();else throw new Error;if(y>0)switch(b[y-1][0]){case-1:b[y-1][1].left=b[y][1];break;case 1:b[y-1][1].right=b[y][1];break;case 0:b[y-1][1].mid=b[y][1];break}else this._root=b[0][1]}}return h}get(n){return this._getNode(n)?.value}_getNode(n){const g=this._iter.reset(n);let l=this._root;for(;l;){const c=g.cmp(l.segment);if(c>0)l=l.left;else if(c<0)l=l.right;else if(g.hasNext())g.next(),l=l.mid;else break}return l}has(n){const g=this._getNode(n);return!(g?.value===void 0&&g?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,g){const l=this._iter.reset(n),c=[];let b=this._root;for(;b;){const h=l.cmp(b.segment);if(h>0)c.push([-1,b]),b=b.left;else if(h<0)c.push([1,b]),b=b.right;else if(l.hasNext())l.next(),c.push([0,b]),b=b.mid;else break}if(!!b){if(g?(b.left=void 0,b.mid=void 0,b.right=void 0,b.height=1):(b.key=void 0,b.value=void 0),!b.mid&&!b.value)if(b.left&&b.right){const h=this._min(b.right),{key:y,value:R,segment:I}=h;this._delete(h.key,!1),b.key=y,b.value=R,b.segment=I}else{const h=b.left??b.right;if(c.length>0){const[y,R]=c[c.length-1];switch(y){case-1:R.left=h;break;case 0:R.mid=h;break;case 1:R.right=h;break}}else this._root=h}for(let h=c.length-1;h>=0;h--){const y=c[h][1];y.updateHeight();const R=y.balanceFactor();if(R>1?(y.right.balanceFactor()>=0||(y.right=c[h+1][1]=c[h+1][1].rotateRight()),c[h][1]=y.rotateLeft()):R<-1&&(y.left.balanceFactor()<=0||(y.left=c[h+1][1]=c[h+1][1].rotateLeft()),c[h][1]=y.rotateRight()),h>0)switch(c[h-1][0]){case-1:c[h-1][1].left=c[h][1];break;case 1:c[h-1][1].right=c[h][1];break;case 0:c[h-1][1].mid=c[h][1];break}else this._root=c[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const g=this._iter.reset(n);let l=this._root,c;for(;l;){const b=g.cmp(l.segment);if(b>0)l=l.left;else if(b<0)l=l.right;else if(g.hasNext())g.next(),c=l.value||c,l=l.mid;else break}return l&&l.value||c}findSuperstr(n){const g=this._iter.reset(n);let l=this._root;for(;l;){const c=g.cmp(l.segment);if(c>0)l=l.left;else if(c<0)l=l.right;else if(g.hasNext())g.next(),l=l.mid;else return l.mid?this._entries(l.mid):void 0}}forEach(n){for(const[g,l]of this)n(l,g)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){!n||(n.left&&(yield*this._entries(n.left)),n.value&&(yield[n.key,n.value]),n.mid&&(yield*this._entries(n.mid)),n.right&&(yield*this._entries(n.right)))}_isBalanced(){const n=g=>{if(!g)return!0;const l=g.balanceFactor();return l<-1||l>1?!1:n(g.left)&&n(g.right)};return n(this._root)}}e.TernarySearchTree=S;class v{constructor(n,g){this.uri=n,this.value=g}}class o{constructor(n,g){this[E]="ResourceMap",n instanceof o?(this.map=new Map(n.map),this.toKey=g??o.defaultToKey):(this.map=new Map,this.toKey=n??o.defaultToKey)}set(n,g){return this.map.set(this.toKey(n),new v(n,g)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,g){typeof g!="undefined"&&(n=n.bind(g));for(let[l,c]of this.map)n(c.value,c.uri,this)}*values(){for(let n of this.map.values())yield n.value}*keys(){for(let n of this.map.values())yield n.uri}*entries(){for(let n of this.map.values())yield[n.uri,n.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(let[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=o,o.defaultToKey=s=>s.toString();var d;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(d=e.Touch||(e.Touch={}));class D{constructor(){this[P]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,g=0){const l=this._map.get(n);if(!!l)return g!==0&&this.touch(l,g),l.value}set(n,g,l=0){let c=this._map.get(n);if(c)c.value=g,l!==0&&this.touch(c,l);else{switch(c={key:n,value:g,next:void 0,previous:void 0},l){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(n,c),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const g=this._map.get(n);if(!!g)return this._map.delete(n),this.removeItem(g),this._size--,g.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,g){const l=this._state;let c=this._head;for(;c;){if(g?n.bind(g)(c.value,c.key,this):n(c.value,c.key,this),this._state!==l)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const n=this,g=this._state;let l=this._head;const c={[Symbol.iterator](){return c},next(){if(n._state!==g)throw new Error("LinkedMap got modified during iteration.");if(l){const b={value:l.key,done:!1};return l=l.next,b}else return{value:void 0,done:!0}}};return c}values(){const n=this,g=this._state;let l=this._head;const c={[Symbol.iterator](){return c},next(){if(n._state!==g)throw new Error("LinkedMap got modified during iteration.");if(l){const b={value:l.value,done:!1};return l=l.next,b}else return{value:void 0,done:!0}}};return c}entries(){const n=this,g=this._state;let l=this._head;const c={[Symbol.iterator](){return c},next(){if(n._state!==g)throw new Error("LinkedMap got modified during iteration.");if(l){const b={value:[l.key,l.value],done:!1};return l=l.next,b}else return{value:void 0,done:!0}}};return c}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let g=this._head,l=this.size;for(;g&&l>n;)this._map.delete(g.key),g=g.next,l--;this._head=g,this._size=l,g&&(g.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const g=n.next,l=n.previous;if(!g||!l)throw new Error("Invalid list");g.previous=l,l.next=g}n.next=void 0,n.previous=void 0,this._state++}touch(n,g){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(g!==1&&g!==2)){if(g===1){if(n===this._head)return;const l=n.next,c=n.previous;n===this._tail?(c.next=void 0,this._tail=c):(l.previous=c,c.next=l),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(g===2){if(n===this._tail)return;const l=n.next,c=n.previous;n===this._head?(l.previous=void 0,this._head=l):(l.previous=c,c.next=l),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((g,l)=>{n.push([l,g])}),n}fromJSON(n){this.clear();for(const[g,l]of n)this.set(g,l)}}e.LinkedMap=D;class r extends D{constructor(n,g=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,g),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,g=2){return super.get(n,g)}peek(n){return super.get(n,0)}set(n,g){return super.set(n,g,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=r;class w{constructor(n){F.set(this,void 0),Ze(this,F,n,"f")}get size(){return Te(this,F,"f").size}forEach(n,g){Te(this,F,"f").forEach(n,g)}get(n){return Te(this,F,"f").get(n)}has(n){return Te(this,F,"f").has(n)}entries(){return Te(this,F,"f").entries()}keys(){return Te(this,F,"f").keys()}values(){return Te(this,F,"f").values()}[(F=new WeakMap,Symbol.iterator)](){return Te(this,F,"f").entries()}}e.ReadonlyMapView=w}),define(we[105],be([0,1,20,9]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function E(...G){return function(ie,de){for(let Pe=0,Ne=G.length;Pe<Ne;Pe++){const We=G[Pe](ie,de);if(We)return We}return null}}e.or=E,e.matchesStrictPrefix=P.bind(void 0,!1),e.matchesPrefix=P.bind(void 0,!0);function P(G,ie,de){if(!de||de.length<ie.length)return null;let Pe;return G?Pe=M.startsWithIgnoreCase(de,ie):Pe=de.indexOf(ie)===0,Pe?ie.length>0?[{start:0,end:ie.length}]:[]:null}function F(G,ie){const de=ie.toLowerCase().indexOf(G.toLowerCase());return de===-1?null:[{start:de,end:de+G.length}]}e.matchesContiguousSubString=F;function T(G,ie){return C(G.toLowerCase(),ie.toLowerCase(),0,0)}e.matchesSubString=T;function C(G,ie,de,Pe){if(de===G.length)return[];if(Pe===ie.length)return null;if(G[de]===ie[Pe]){let Ne=null;return(Ne=C(G,ie,de+1,Pe+1))?S({start:Pe,end:Pe+1},Ne):null}return C(G,ie,de,Pe+1)}function A(G){return 97<=G&&G<=122}function t(G){return 65<=G&&G<=90}e.isUpper=t;function _(G){return 48<=G&&G<=57}function i(G){return G===32||G===9||G===10||G===13}const m=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(G=>m.add(G.charCodeAt(0)));function a(G){return i(G)||m.has(G)}function f(G,ie){return G===ie||a(G)&&a(ie)}function p(G){return A(G)||t(G)||_(G)}function S(G,ie){return ie.length===0?ie=[G]:G.end===ie[0].start?ie[0].start=G.start:ie.unshift(G),ie}function v(G,ie){for(let de=ie;de<G.length;de++){const Pe=G.charCodeAt(de);if(t(Pe)||_(Pe)||de>0&&!p(G.charCodeAt(de-1)))return de}return G.length}function o(G,ie,de,Pe){if(de===G.length)return[];if(Pe===ie.length)return null;if(G[de]!==ie[Pe].toLowerCase())return null;{let Ne=null,We=Pe+1;for(Ne=o(G,ie,de+1,Pe+1);!Ne&&(We=v(ie,We))<ie.length;)Ne=o(G,ie,de+1,We),We++;return Ne===null?null:S({start:Pe,end:Pe+1},Ne)}}function d(G){let ie=0,de=0,Pe=0,Ne=0,We=0;for(let nt=0;nt<G.length;nt++)We=G.charCodeAt(nt),t(We)&&ie++,A(We)&&de++,p(We)&&Pe++,_(We)&&Ne++;const je=ie/G.length,et=de/G.length,ot=Pe/G.length,_e=Ne/G.length;return{upperPercent:je,lowerPercent:et,alphaPercent:ot,numericPercent:_e}}function D(G){const{upperPercent:ie,lowerPercent:de}=G;return de===0&&ie>.6}function r(G){const{upperPercent:ie,lowerPercent:de,alphaPercent:Pe,numericPercent:Ne}=G;return de>.2&&ie<.8&&Pe>.6&&Ne<.2}function w(G){let ie=0,de=0,Pe=0,Ne=0;for(let We=0;We<G.length;We++)Pe=G.charCodeAt(We),t(Pe)&&ie++,A(Pe)&&de++,i(Pe)&&Ne++;return(ie===0||de===0)&&Ne===0?G.length<=30:ie<=5}function s(G,ie){if(!ie||(ie=ie.trim(),ie.length===0)||!w(G)||ie.length>60)return null;const de=d(ie);if(!r(de)){if(!D(de))return null;ie=ie.toLowerCase()}let Pe=null,Ne=0;for(G=G.toLowerCase();Ne<ie.length&&(Pe=o(G,ie,0,Ne))===null;)Ne=v(ie,Ne+1);return Pe}e.matchesCamelCase=s;function n(G,ie,de=!1){if(!ie||ie.length===0)return null;let Pe=null,Ne=0;for(G=G.toLowerCase(),ie=ie.toLowerCase();Ne<ie.length&&(Pe=g(G,ie,0,Ne,de))===null;)Ne=l(ie,Ne+1);return Pe}e.matchesWords=n;function g(G,ie,de,Pe,Ne){if(de===G.length)return[];if(Pe===ie.length)return null;if(f(G.charCodeAt(de),ie.charCodeAt(Pe))){let We=null,je=Pe+1;if(We=g(G,ie,de+1,Pe+1,Ne),!Ne)for(;!We&&(je=l(ie,je))<ie.length;)We=g(G,ie,de+1,je,Ne),je++;return We===null?null:S({start:Pe,end:Pe+1},We)}else return null}function l(G,ie){for(let de=ie;de<G.length;de++)if(a(G.charCodeAt(de))||de>0&&a(G.charCodeAt(de-1)))return de;return G.length}const c=E(e.matchesPrefix,s,F),b=E(e.matchesPrefix,s,T),h=new u.LRUCache(1e4);function y(G,ie,de=!1){if(typeof G!="string"||typeof ie!="string")return null;let Pe=h.get(G);Pe||(Pe=new RegExp(M.convertSimple2RegExpPattern(G),"i"),h.set(G,Pe));const Ne=Pe.exec(ie);return Ne?[{start:Ne.index,end:Ne.index+Ne[0].length}]:de?b(G,ie):c(G,ie)}e.matchesFuzzy=y;function R(G,ie){const de=Je(G,G.toLowerCase(),0,ie,ie.toLowerCase(),0,!0);return de?B(de):null}e.matchesFuzzy2=R;function I(G,ie,de,Pe,Ne,We){const je=Math.min(13,G.length);for(;de<je;de++){const et=Je(G,ie,de,Pe,Ne,We,!1);if(et)return et}return[0,We]}e.anyScore=I;function B(G){if(typeof G=="undefined")return[];const ie=[],de=G[1];for(let Pe=G.length-1;Pe>1;Pe--){const Ne=G[Pe]+de,We=ie[ie.length-1];We&&We.end===Ne?We.end=Ne+1:ie.push({start:Ne,end:Ne+1})}return ie}e.createMatches=B;const L=128;function k(){const G=[],ie=[];for(let de=0;de<=L;de++)ie[de]=0;for(let de=0;de<=L;de++)G.push(ie.slice(0));return G}function x(G){const ie=[];for(let de=0;de<=G;de++)ie[de]=0;return ie}const N=x(2*L),V=x(2*L),W=k(),$=k(),X=k(),j=!1;function Q(G,ie,de,Pe,Ne){function We(et,ot,_e=" "){for(;et.length<ot;)et=_e+et;return et}let je=` |   |${Pe.split("").map(et=>We(et,3)).join("|")}
`;for(let et=0;et<=de;et++)et===0?je+=" |":je+=`${ie[et-1]}|`,je+=G[et].slice(0,Ne+1).map(ot=>We(ot.toString(),3)).join("|")+`
`;return je}function ae(G,ie,de,Pe){G=G.substr(ie),de=de.substr(Pe),console.log(Q($,G,G.length,de,de.length)),console.log(Q(X,G,G.length,de,de.length)),console.log(Q(W,G,G.length,de,de.length))}function pe(G,ie){if(ie<0||ie>=G.length)return!1;const de=G.codePointAt(ie);switch(de){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!M.isEmojiImprecise(de)}}function ce(G,ie){if(ie<0||ie>=G.length)return!1;switch(G.charCodeAt(ie)){case 32:case 9:return!0;default:return!1}}function Fe(G,ie,de){return ie[G]!==de[G]}function Qe(G,ie,de,Pe,Ne,We,je=!1){for(;ie<de&&Ne<We;)G[ie]===Pe[Ne]&&(je&&(N[ie]=Ne),ie+=1),Ne+=1;return ie===de}e.isPatternInWord=Qe;var Oe;(function(G){G[G.Diag=1]="Diag",G[G.Left=2]="Left",G[G.LeftLeft=3]="LeftLeft"})(Oe||(Oe={}));var He;(function(G){G.Default=[-100,0];function ie(de){return!de||de.length===2&&de[0]===-100&&de[1]===0}G.isDefault=ie})(He=e.FuzzyScore||(e.FuzzyScore={}));function Je(G,ie,de,Pe,Ne,We,je){const et=G.length>L?L:G.length,ot=Pe.length>L?L:Pe.length;if(de>=et||We>=ot||et-de>ot-We||!Qe(ie,de,et,Ne,We,ot,!0))return;Ye(et,ot,de,We,ie,Ne);let _e=1,nt=1,q=de,J=We;const ge=[!1];for(_e=1,q=de;q<et;_e++,q++){const ht=N[q],Dt=V[q],Tt=q+1<et?V[q+1]:ot;for(nt=ht-We+1,J=ht;J<Tt;nt++,J++){let It=Number.MIN_SAFE_INTEGER,Xe=!1;J<=Dt&&(It=qe(G,ie,q,de,Pe,Ne,J,ot,We,W[_e-1][nt-1]===0,ge));let pt=0;It!==Number.MAX_SAFE_INTEGER&&(Xe=!0,pt=It+$[_e-1][nt-1]);const Ie=J>ht,ye=Ie?$[_e][nt-1]+(W[_e][nt-1]>0?-5:0):0,De=J>ht+1&&W[_e][nt-1]>0,ee=De?$[_e][nt-2]+(W[_e][nt-2]>0?-5:0):0;if(De&&(!Ie||ee>=ye)&&(!Xe||ee>=pt))$[_e][nt]=ee,X[_e][nt]=3,W[_e][nt]=0;else if(Ie&&(!Xe||ye>=pt))$[_e][nt]=ye,X[_e][nt]=2,W[_e][nt]=0;else if(Xe)$[_e][nt]=pt,X[_e][nt]=1,W[_e][nt]=W[_e-1][nt-1]+1;else throw new Error("not possible")}}if(j&&ae(G,de,Pe,We),!ge[0]&&!je)return;_e--,nt--;const $e=[$[_e][nt],We];let Ge=0,rt=0;for(;_e>=1;){let ht=nt;do{const Dt=X[_e][ht];if(Dt===3)ht=ht-2;else if(Dt===2)ht=ht-1;else break}while(ht>=1);Ge>1&&ie[de+_e-1]===Ne[We+nt-1]&&!Fe(ht+We-1,Pe,Ne)&&Ge+1>W[_e][ht]&&(ht=nt),ht===nt?Ge++:Ge=1,rt||(rt=ht),_e--,nt=ht-1,$e.push(nt)}ot===et&&($e[0]+=2);const ft=rt-et;return $e[0]-=ft,$e}e.fuzzyScore=Je;function Ye(G,ie,de,Pe,Ne,We){let je=G-1,et=ie-1;for(;je>=de&&et>=Pe;)Ne[je]===We[et]&&(V[je]=et,je--),et--}function qe(G,ie,de,Pe,Ne,We,je,et,ot,_e,nt){if(ie[de]!==We[je])return Number.MIN_SAFE_INTEGER;let q=1,J=!1;return je===de-Pe?q=G[de]===Ne[je]?7:5:Fe(je,Ne,We)&&(je===0||!Fe(je-1,Ne,We))?(q=G[de]===Ne[je]?7:5,J=!0):pe(We,je)&&(je===0||!pe(We,je-1))?q=5:(pe(We,je-1)||ce(We,je-1))&&(q=5,J=!0),q>1&&de===Pe&&(nt[0]=!0),J||(J=Fe(je,Ne,We)||pe(We,je-1)||ce(We,je-1)),de===Pe?je>ot&&(q-=J?3:5):_e?q+=J?2:0:q+=J?0:1,je+1===et&&(q-=J?3:5),q}function z(G,ie,de,Pe,Ne,We,je){return Z(G,ie,de,Pe,Ne,We,!0,je)}e.fuzzyScoreGracefulAggressive=z;function K(G,ie,de,Pe,Ne,We,je){return Z(G,ie,de,Pe,Ne,We,!1,je)}e.fuzzyScoreGraceful=K;function Z(G,ie,de,Pe,Ne,We,je,et){let ot=Je(G,ie,de,Pe,Ne,We,et);if(ot&&!je)return ot;if(G.length>=3){const _e=Math.min(7,G.length-1);for(let nt=de+1;nt<_e;nt++){const q=se(G,nt);if(q){const J=Je(q,q.toLowerCase(),de,Pe,Ne,We,et);J&&(J[0]-=3,(!ot||J[0]>ot[0])&&(ot=J))}}}return ot}function se(G,ie){if(ie+1>=G.length)return;const de=G[ie],Pe=G[ie+1];if(de!==Pe)return G.slice(0,ie)+Pe+de+G.slice(ie+2)}}),define(we[106],be([0,1,35,105,9]),function(re,e,u,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const P=new RegExp(`\\$\\(${u.CSSIcon.iconNameExpression}(?:${u.CSSIcon.iconModifierExpression})?\\)`,"g"),F=new RegExp(u.CSSIcon.iconNameCharacter),T=new RegExp(`(\\\\)?${P.source}`,"g");function C(p){return p.replace(T,(S,v)=>v?S:`\\${S}`)}e.escapeIcons=C;const A=new RegExp(`\\\\${P.source}`,"g");function t(p){return p.replace(A,S=>`\\${S}`)}e.markdownEscapeEscapedIcons=t;const _=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function i(p){return p.indexOf(e.iconStartMarker)===-1?p:p.replace(_,(S,v,o,d)=>o?S:v||d||"")}e.stripIcons=i;function m(p){const S=p.indexOf(e.iconStartMarker);return S===-1?{text:p}:a(p,S)}e.parseLabelWithIcons=m;function a(p,S){const v=[];let o="";function d(c){if(c){o+=c;for(const b of c)v.push(w)}}let D=-1,r="",w=0,s,n,g=S;const l=p.length;for(d(p.substr(0,S));g<l;)s=p[g],n=p[g+1],s===e.iconStartMarker[0]&&n===e.iconStartMarker[1]?(D=g,d(r),r=e.iconStartMarker,g++):s===")"&&D!==-1?(w+=g-D+1,D=-1,r=""):D!==-1?F.test(s)?r+=s:(d(r),D=-1,r=""):d(s),g++;return d(r),{text:o,iconOffsets:v}}function f(p,S,v=!1){const{text:o,iconOffsets:d}=S;if(!d||d.length===0)return(0,M.matchesFuzzy)(p,o,v);const D=(0,E.ltrim)(o," "),r=o.length-D.length,w=(0,M.matchesFuzzy)(p,D,v);if(w)for(const s of w){const n=d[s.start+r]+r;s.start+=n,s.end+=n}return w}e.matchesFuzzyIconAware=f}),define(we[77],be([0,1,16,106]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var E;(function(i){i[i.Paragraph=0]="Paragraph",i[i.Break=1]="Break"})(E=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class P{constructor(m="",a=!1){if(this.value=m,typeof this.value!="string")throw(0,u.illegalArgument)("value");typeof a=="boolean"?(this.isTrusted=a,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=a.isTrusted??void 0,this.supportThemeIcons=a.supportThemeIcons??!1,this.supportHtml=a.supportHtml??!1)}appendText(m,a=0){return this.value+=A(this.supportThemeIcons?(0,M.escapeIcons)(m):m).replace(/([ \t]+)/g,(f,p)=>"&nbsp;".repeat(p.length)).replace(/\>/gm,"\\>").replace(/\n/g,a===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,a){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=a,this.value+="\n```\n",this}}e.MarkdownString=P;function F(i){return T(i)?!i.value:Array.isArray(i)?i.every(F):!0}e.isEmptyMarkdownString=F;function T(i){return i instanceof P?!0:i&&typeof i=="object"?typeof i.value=="string"&&(typeof i.isTrusted=="boolean"||i.isTrusted===void 0)&&(typeof i.supportThemeIcons=="boolean"||i.supportThemeIcons===void 0):!1}e.isMarkdownString=T;function C(i,m){return i===m?!0:!i||!m?!1:i.value===m.value&&i.isTrusted===m.isTrusted&&i.supportThemeIcons===m.supportThemeIcons}e.markdownStringEqual=C;function A(i){return i.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=A;function t(i){return i&&i.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=t;function _(i){const m=[],a=i.split("|").map(p=>p.trim());i=a[0];const f=a[1];if(f){const p=/height=(\d+)/.exec(f),S=/width=(\d+)/.exec(f),v=p?p[1]:"",o=S?S[1]:"",d=isFinite(parseInt(o)),D=isFinite(parseInt(v));d&&m.push(`width="${o}"`),D&&m.push(`height="${v}"`)}return{href:i,dimensions:m}}e.parseHrefAndDimensions=_}),define(we[36],be([0,1,9]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(E){E[E.Ignore=0]="Ignore",E[E.Info=1]="Info",E[E.Warning=2]="Warning",E[E.Error=3]="Error"})(M||(M={})),function(E){const P="error",F="warning",T="warn",C="info",A="ignore";function t(i){return i?u.equalsIgnoreCase(P,i)?E.Error:u.equalsIgnoreCase(F,i)||u.equalsIgnoreCase(T,i)?E.Warning:u.equalsIgnoreCase(C,i)?E.Info:E.Ignore:E.Ignore}E.fromValue=t;function _(i){switch(i){case E.Error:return P;case E.Warning:return F;case E.Info:return C;default:return A}}E.toString=_}(M||(M={})),e.default=M}),define(we[44],be([0,1,17,25,9,10]),function(re,e,u,M,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function F(s){return s===47||s===92}e.isPathSeparator=F;function T(s){return s.replace(/[\\/]/g,u.posix.sep)}e.toSlashes=T;function C(s){return s.indexOf("/")===-1&&(s=T(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=C;function A(s,n=u.posix.sep){if(!s)return"";const g=s.length,l=s.charCodeAt(0);if(F(l)){if(F(s.charCodeAt(1))&&!F(s.charCodeAt(2))){let b=3;const h=b;for(;b<g&&!F(s.charCodeAt(b));b++);if(h!==b&&!F(s.charCodeAt(b+1))){for(b+=1;b<g;b++)if(F(s.charCodeAt(b)))return s.slice(0,b+1).replace(/[\\/]/g,n)}}return n}else if(S(l)&&s.charCodeAt(1)===58)return F(s.charCodeAt(2))?s.slice(0,2)+n:s.slice(0,2);let c=s.indexOf("://");if(c!==-1){for(c+=3;c<g;c++)if(F(s.charCodeAt(c)))return s.slice(0,c+1)}return""}e.getRoot=A;function t(s){if(!M.isWindows||!s||s.length<5)return!1;let n=s.charCodeAt(0);if(n!==92||(n=s.charCodeAt(1),n!==92))return!1;let g=2;const l=g;for(;g<s.length&&(n=s.charCodeAt(g),n!==92);g++);return!(l===g||(n=s.charCodeAt(g+1),isNaN(n)||n===92))}e.isUNC=t;const _=/[\\/:\*\?"<>\|]/g,i=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function a(s,n=M.isWindows){const g=n?_:i;return!(!s||s.length===0||/^\s+$/.test(s)||(g.lastIndex=0,g.test(s))||n&&m.test(s)||s==="."||s===".."||n&&s[s.length-1]==="."||n&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=a;function f(s,n,g){const l=s===n;return!g||l?l:!s||!n?!1:(0,E.equalsIgnoreCase)(s,n)}e.isEqual=f;function p(s,n,g,l=u.sep){if(s===n)return!0;if(!s||!n||n.length>s.length)return!1;if(g){if(!(0,E.startsWithIgnoreCase)(s,n))return!1;if(n.length===s.length)return!0;let b=n.length;return n.charAt(n.length-1)===l&&b--,s.charAt(b)===l}return n.charAt(n.length-1)!==l&&(n+=l),s.indexOf(n)===0}e.isEqualOrParent=p;function S(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=S;function v(s,n){return M.isWindows&&s.endsWith(":")&&(s+=u.sep),(0,u.isAbsolute)(s)||(s=(0,u.join)(n,s)),s=(0,u.normalize)(s),M.isWindows?(s=(0,E.rtrim)(s,u.sep),s.endsWith(":")&&(s+=u.sep)):(s=(0,E.rtrim)(s,u.sep),s||(s=u.sep)),s}e.sanitizeFilePath=v;function o(s){const n=(0,u.normalize)(s);return M.isWindows?s.length>3?!1:d(n)&&(s.length===2||n.charCodeAt(2)===92):n===u.posix.sep}e.isRootOrDriveLetter=o;function d(s,n){return(n!==void 0?n:M.isWindows)?S(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=d;function D(s){return d(s)?s[0]:void 0}e.getDriveLetter=D;function r(s,n,g){return n.length>s.length?-1:s===n?0:(g&&(s=s.toLowerCase(),n=n.toLowerCase()),s.indexOf(n))}e.indexOfPath=r;function w(s){const n=s.split(":");let g,l,c;if(n.forEach(b=>{const h=Number(b);(0,P.isNumber)(h)?l===void 0?l=h:c===void 0&&(c=h):g=g?[g,b].join(":"):b}),!g)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:g,line:l!==void 0?l:void 0,column:c!==void 0?c:l!==void 0?1:void 0}}e.parseLineAndColumnAware=w}),define(we[23],be([0,1,10]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function M(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const p=Array.isArray(f)?[]:{};return Object.keys(f).forEach(S=>{f[S]&&typeof f[S]=="object"?p[S]=M(f[S]):p[S]=f[S]}),p}e.deepClone=M;function E(f){if(!f||typeof f!="object")return f;const p=[f];for(;p.length>0;){const S=p.shift();Object.freeze(S);for(const v in S)if(P.call(S,v)){const o=S[v];typeof o=="object"&&!Object.isFrozen(o)&&p.push(o)}}return f}e.deepFreeze=E;const P=Object.prototype.hasOwnProperty;function F(f,p){return T(f,p,new Set)}e.cloneAndChange=F;function T(f,p,S){if((0,u.isUndefinedOrNull)(f))return f;const v=p(f);if(typeof v!="undefined")return v;if((0,u.isArray)(f)){const o=[];for(const d of f)o.push(T(d,p,S));return o}if((0,u.isObject)(f)){if(S.has(f))throw new Error("Cannot clone recursive data-structure");S.add(f);const o={};for(let d in f)P.call(f,d)&&(o[d]=T(f[d],p,S));return S.delete(f),o}return f}function C(f,p,S=!0){return(0,u.isObject)(f)?((0,u.isObject)(p)&&Object.keys(p).forEach(v=>{v in f?S&&((0,u.isObject)(f[v])&&(0,u.isObject)(p[v])?C(f[v],p[v],S):f[v]=p[v]):f[v]=p[v]}),f):p}e.mixin=C;function A(f,p){if(f===p)return!0;if(f==null||p===null||p===void 0||typeof f!=typeof p||typeof f!="object"||Array.isArray(f)!==Array.isArray(p))return!1;let S,v;if(Array.isArray(f)){if(f.length!==p.length)return!1;for(S=0;S<f.length;S++)if(!A(f[S],p[S]))return!1}else{const o=[];for(v in f)o.push(v);o.sort();const d=[];for(v in p)d.push(v);if(d.sort(),!A(o,d))return!1;for(S=0;S<o.length;S++)if(!A(f[o[S]],p[o[S]]))return!1}return!0}e.equals=A;function t(f){const p=new Set;return JSON.stringify(f,(S,v)=>{if((0,u.isObject)(v)||Array.isArray(v)){if(p.has(v))return"[Circular]";p.add(v)}return v})}e.safeStringify=t;function _(f,p,S){const v=p(f);return typeof v=="undefined"?S:v}e.getOrDefault=_;function i(f,p){const S=Object.create(null);return!f||!p||Object.keys(p).forEach(o=>{const d=f[o],D=p[o];A(d,D)||(S[o]=D)}),S}e.distinct=i;function m(f,p){const S=p.toLowerCase(),v=Object.keys(f).find(o=>o.toLowerCase()===S);return v?f[v]:f[p]}e.getCaseInsensitive=m;function a(f,p){const S=Object.create(null);for(const v of Object.keys(f))p(v,f[v])&&(S[v]=f[v]);return S}e.filter=a}),define(we[57],be([0,1,22,9,2]),function(re,e,u,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function P(t){return JSON.stringify(t,C)}e.stringify=P;function F(t){let _=JSON.parse(t);return _=A(_),_}e.parse=F;var T;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadReply=8]="CommentThreadReply",t[t.CommentNode=9]="CommentNode",t[t.CommentThreadNode=10]="CommentThreadNode",t[t.TimelineActionContext=11]="TimelineActionContext",t[t.NotebookCellActionContext=12]="NotebookCellActionContext",t[t.TestItemContext=13]="TestItemContext"})(T=e.MarshalledId||(e.MarshalledId={}));function C(t,_){return _ instanceof RegExp?{$mid:2,source:_.source,flags:(0,M.regExpFlags)(_)}:_}function A(t,_=0){if(!t||_>200)return t;if(typeof t=="object"){switch(t.$mid){case 1:return E.URI.revive(t);case 2:return new RegExp(t.source,t.flags)}if(t instanceof u.VSBuffer||t instanceof Uint8Array)return t;if(Array.isArray(t))for(let i=0;i<t.length;++i)t[i]=A(t[i],_+1);else for(const i in t)Object.hasOwnProperty.call(t,i)&&(t[i]=A(t[i],_+1))}return t}e.revive=A}),define(we[11],be([0,1,25,2]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var E;(function(T){T.inMemory="inmemory",T.vscode="vscode",T.internal="private",T.walkThrough="walkThrough",T.walkThroughSnippet="walkThroughSnippet",T.http="http",T.https="https",T.file="file",T.mailto="mailto",T.untitled="untitled",T.data="data",T.command="command",T.vscodeRemote="vscode-remote",T.vscodeRemoteResource="vscode-remote-resource",T.userData="vscode-userdata",T.vscodeCustomEditor="vscode-custom-editor",T.vscodeNotebook="vscode-notebook",T.vscodeNotebookCell="vscode-notebook-cell",T.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",T.vscodeNotebookCellOutput="vscode-notebook-cell-output",T.vscodeInteractive="vscode-interactive",T.vscodeInteractiveInput="vscode-interactive-input",T.vscodeSettings="vscode-settings",T.vscodeWorkspaceTrust="vscode-workspace-trust",T.vscodeTerminal="vscode-terminal",T.webviewPanel="webview-panel",T.vscodeWebview="vscode-webview",T.extension="extension",T.vscodeFileResource="vscode-file",T.tmp="tmp",T.vsls="vsls"})(E=e.Schemas||(e.Schemas={}));class P{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(C){this._preferredWebSchema=C}setDelegate(C){this._delegate=C}set(C,A,t){this._hosts[C]=A,this._ports[C]=t}setConnectionToken(C,A){this._connectionTokens[C]=A}rewrite(C){if(this._delegate)return this._delegate(C);const A=C.authority;let t=this._hosts[A];t&&t.indexOf(":")!==-1&&(t=`[${t}]`);const _=this._ports[A],i=this._connectionTokens[A];let m=`path=${encodeURIComponent(C.path)}`;return typeof i=="string"&&(m+=`&tkn=${encodeURIComponent(i)}`),M.URI.from({scheme:u.isWeb?this._preferredWebSchema:E.vscodeRemoteResource,authority:`${t}:${_}`,path:"/vscode-remote-resource",query:m})}}e.RemoteAuthorities=new P;class F{asBrowserUri(C,A){const t=this.toUri(C,A);return t.scheme===E.vscodeRemote?e.RemoteAuthorities.rewrite(t):t.scheme===E.file&&(u.isNative||typeof u.globals.importScripts=="function"&&u.globals.origin===`${E.vscodeFileResource}://${F.FALLBACK_AUTHORITY}`)?t.with({scheme:E.vscodeFileResource,authority:t.authority||F.FALLBACK_AUTHORITY,query:null,fragment:null}):t}asFileUri(C,A){const t=this.toUri(C,A);return t.scheme===E.vscodeFileResource?t.with({scheme:E.file,authority:t.authority!==F.FALLBACK_AUTHORITY?t.authority:null,query:null,fragment:null}):t}toUri(C,A){return M.URI.isUri(C)?C:M.URI.parse(A.toUrl(C))}}F.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new F}),define(we[24],be([0,1,44,11,17,25,9,2]),function(re,e,u,M,E,P,F,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function C(m){return(0,T.uriToFsPath)(m,!0)}e.originalFSPath=C;class A{constructor(a){this._ignorePathCasing=a}compare(a,f,p=!1){return a===f?0:(0,F.compare)(this.getComparisonKey(a,p),this.getComparisonKey(f,p))}isEqual(a,f,p=!1){return a===f?!0:!a||!f?!1:this.getComparisonKey(a,p)===this.getComparisonKey(f,p)}getComparisonKey(a,f=!1){return a.with({path:this._ignorePathCasing(a)?a.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(a){return this._ignorePathCasing(a)}isEqualOrParent(a,f,p=!1){if(a.scheme===f.scheme){if(a.scheme===M.Schemas.file)return u.isEqualOrParent(C(a),C(f),this._ignorePathCasing(a))&&a.query===f.query&&(p||a.fragment===f.fragment);if((0,e.isEqualAuthority)(a.authority,f.authority))return u.isEqualOrParent(a.path,f.path,this._ignorePathCasing(a),"/")&&a.query===f.query&&(p||a.fragment===f.fragment)}return!1}joinPath(a,...f){return T.URI.joinPath(a,...f)}basenameOrAuthority(a){return(0,e.basename)(a)||a.authority}basename(a){return E.posix.basename(a.path)}extname(a){return E.posix.extname(a.path)}dirname(a){if(a.path.length===0)return a;let f;return a.scheme===M.Schemas.file?f=T.URI.file(E.dirname(C(a))).path:(f=E.posix.dirname(a.path),a.authority&&f.length&&f.charCodeAt(0)!==47&&(console.error(`dirname("${a.toString})) resulted in a relative path`),f="/")),a.with({path:f})}normalizePath(a){if(!a.path.length)return a;let f;return a.scheme===M.Schemas.file?f=T.URI.file(E.normalize(C(a))).path:f=E.posix.normalize(a.path),a.with({path:f})}relativePath(a,f){if(a.scheme!==f.scheme||!(0,e.isEqualAuthority)(a.authority,f.authority))return;if(a.scheme===M.Schemas.file){const v=E.relative(C(a),C(f));return P.isWindows?u.toSlashes(v):v}let p=a.path||"/",S=f.path||"/";if(this._ignorePathCasing(a)){let v=0;for(const o=Math.min(p.length,S.length);v<o&&!(p.charCodeAt(v)!==S.charCodeAt(v)&&p.charAt(v).toLowerCase()!==S.charAt(v).toLowerCase());v++);p=S.substr(0,v)+p.substr(v)}return E.posix.relative(p,S)}resolvePath(a,f){if(a.scheme===M.Schemas.file){const p=T.URI.file(E.resolve(C(a),f));return a.with({authority:p.authority,path:p.path})}return f=u.toPosixPath(f),a.with({path:E.posix.resolve(a.path,f)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,f){return a===f||a!==void 0&&f!==void 0&&(0,F.equalsIgnoreCase)(a,f)}hasTrailingPathSeparator(a,f=E.sep){if(a.scheme===M.Schemas.file){const p=C(a);return p.length>u.getRoot(p).length&&p[p.length-1]===f}else{const p=a.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,f=E.sep){return(0,e.hasTrailingPathSeparator)(a,f)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,f=E.sep){let p=!1;if(a.scheme===M.Schemas.file){const S=C(a);p=S!==void 0&&S.length===u.getRoot(S).length&&S[S.length-1]===f}else{f="/";const S=a.path;p=S.length===1&&S.charCodeAt(S.length-1)===47}return!p&&!(0,e.hasTrailingPathSeparator)(a,f)?a.with({path:a.path+"/"}):a}}e.ExtUri=A,e.extUri=new A(()=>!1),e.extUriBiasedIgnorePathCase=new A(m=>m.scheme===M.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new A(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function t(m,a){const f=[];for(let p=0;p<m.length;p++){const S=a(m[p]);m.some((v,o)=>o===p?!1:(0,e.isEqualOrParent)(S,a(v)))||f.push(m[p])}return f}e.distinctParents=t;var _;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function a(f){const p=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(o=>{const[d,D]=o.split(":");d&&D&&p.set(d,D)});const v=f.path.substring(0,f.path.indexOf(";"));return v&&p.set(m.META_DATA_MIME,v),p}m.parseMetaData=a})(_=e.DataUri||(e.DataUri={}));function i(m,a,f){if(a){let p=m.path;return p&&p[0]!==E.posix.sep&&(p=E.posix.sep+p),m.with({scheme:f,authority:a,path:p})}return m.with({scheme:f})}e.toLocalResource=i}),define(we[13],be([0,1,21,16,3,6,24]),function(re,e,u,M,E,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function T(W){return!!W&&typeof W.then=="function"}e.isThenable=T;function C(W){const $=new u.CancellationTokenSource,X=W($.token),j=new Promise((Q,ae)=>{const pe=$.token.onCancellationRequested(()=>{pe.dispose(),$.dispose(),ae((0,M.canceled)())});Promise.resolve(X).then(ce=>{pe.dispose(),$.dispose(),Q(ce)},ce=>{pe.dispose(),$.dispose(),ae(ce)})});return new class{cancel(){$.cancel()}then(Q,ae){return j.then(Q,ae)}catch(Q){return this.then(void 0,Q)}finally(Q){return j.finally(Q)}}}e.createCancelablePromise=C;function A(W,$,X){return Promise.race([W,new Promise(j=>$.onCancellationRequested(()=>j(X)))])}e.raceCancellation=A;async function t(W){let $=-1;const X=W.map((Q,ae)=>Q.then(pe=>($=ae,pe))),j=await Promise.race(X);return W.forEach((Q,ae)=>{ae!==$&&Q.cancel()}),j}e.raceCancellablePromises=t;function _(W,$,X){let j;const Q=setTimeout(()=>{j?.(void 0),X?.()},$);return Promise.race([W.finally(()=>clearTimeout(Q)),new Promise(ae=>j=ae)])}e.raceTimeout=_;function i(W){return new Promise(($,X)=>{const j=W();T(j)?j.then($,X):$(j)})}e.asPromise=i;class m{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue($){if(this.activePromise){if(this.queuedPromiseFactory=$,!this.queuedPromise){const X=()=>{this.queuedPromise=null;const j=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,j};this.queuedPromise=new Promise(j=>{this.activePromise.then(X,X).then(j)})}return new Promise((X,j)=>{this.queuedPromise.then(X,j)})}return this.activePromise=$(),new Promise((X,j)=>{this.activePromise.then(Q=>{this.activePromise=null,X(Q)},Q=>{this.activePromise=null,j(Q)})})}}e.Throttler=m;class a{constructor(){this.current=Promise.resolve(null)}queue($){return this.current=this.current.then(()=>$(),()=>$())}}e.Sequencer=a;class f{constructor(){this.promiseMap=new Map}queue($,X){const Q=(this.promiseMap.get($)??Promise.resolve()).catch(()=>{}).then(X).finally(()=>{this.promiseMap.get($)===Q&&this.promiseMap.delete($)});return this.promiseMap.set($,Q),Q}}e.SequencerByKey=f;class p{constructor($){this.defaultDelay=$,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger($,X=this.defaultDelay){return this.task=$,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((j,Q)=>{this.doResolve=j,this.doReject=Q}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const j=this.task;return this.task=null,j()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},X),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,M.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=p;class S{constructor($){this.delayer=new p($),this.throttler=new m}trigger($,X){return this.delayer.trigger(()=>this.throttler.queue($),X)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=S;class v{constructor(){this._isOpen=!1,this._promise=new Promise(($,X)=>{this._completePromise=$})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=v;class o extends v{constructor($){super();this._timeout=setTimeout(()=>this.open(),$)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function d(W,$){return $?new Promise((X,j)=>{const Q=setTimeout(()=>{ae.dispose(),X()},W),ae=$.onCancellationRequested(()=>{clearTimeout(Q),ae.dispose(),j((0,M.canceled)())})}):C(X=>d(W,X))}e.timeout=d;function D(W,$=0){const X=setTimeout(W,$);return(0,P.toDisposable)(()=>clearTimeout(X))}e.disposableTimeout=D;function r(W){const $=[];let X=0;const j=W.length;function Q(){return X<j?W[X++]():null}function ae(pe){pe!=null&&$.push(pe);const ce=Q();return ce?ce.then(ae):Promise.resolve($)}return Promise.resolve(null).then(ae)}e.sequence=r;function w(W,$=j=>!!j,X=null){let j=0;const Q=W.length,ae=()=>{if(j>=Q)return Promise.resolve(X);const pe=W[j++];return Promise.resolve(pe()).then(Fe=>$(Fe)?Promise.resolve(Fe):ae())};return ae()}e.first=w;function s(W,$=j=>!!j,X=null){if(W.length===0)return Promise.resolve(X);let j=W.length;const Q=()=>{j=-1;for(const ae of W)ae.cancel?.()};return new Promise((ae,pe)=>{for(const ce of W)ce.then(Fe=>{--j>=0&&$(Fe)?(Q(),ae(Fe)):j===0&&ae(X)}).catch(Fe=>{--j>=0&&(Q(),pe(Fe))})})}e.firstParallel=s;class n{constructor($){this._size=0,this.maxDegreeOfParalellism=$,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new E.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue($){return this._size++,new Promise((X,j)=>{this.outstandingPromises.push({factory:$,c:X,e:j}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const $=this.outstandingPromises.shift();this.runningPromises++;const X=$.factory();X.then($.c,$.e),X.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=n;class g extends n{constructor(){super(1)}}e.Queue=g;class l{constructor(){this.queues=new Map}queueFor($,X=F.extUri){const j=X.getComparisonKey($);let Q=this.queues.get(j);return Q||(Q=new g,E.Event.once(Q.onFinished)(()=>{Q?.dispose(),this.queues.delete(j)}),this.queues.set(j,Q)),Q}dispose(){this.queues.forEach($=>$.dispose()),this.queues.clear()}}e.ResourceQueue=l;class c{constructor($,X){this._token=-1,typeof $=="function"&&typeof X=="number"&&this.setIfNotSet($,X)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet($,X){this.cancel(),this._token=setTimeout(()=>{this._token=-1,$()},X)}setIfNotSet($,X){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,$()},X))}}e.TimeoutTimer=c;class b{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet($,X){this.cancel(),this._token=setInterval(()=>{$()},X)}}e.IntervalTimer=b;class h{constructor($,X){this.timeoutToken=-1,this.runner=$,this.timeout=X,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule($=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,$)}get delay(){return this.timeout}set delay($){this.timeout=$}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=h;class y{constructor($,X){X%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${X}ms is not a multiple of 1000ms.`),this.runner=$,this.timeout=X,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule($=this.timeout){$%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${$}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil($/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=y;class R extends h{constructor($,X){super($,X);this.units=[]}work($){this.units.push($),this.isScheduled()||this.schedule()}doRun(){const $=this.units;this.units=[],this.runner&&this.runner($)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=R;class I extends P.Disposable{constructor($,X,j,Q){super();this.maxWorkChunkSize=$,this.maxPendingWork=X,this.throttleDelay=j,this.handler=Q,this.pendingWork=[],this.throttler=this._register(new P.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work($){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+$.length>this.maxPendingWork)return!1}else if(this.pending+$.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...$),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new h(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=I,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=W=>{const $=setTimeout(()=>{const j=Date.now()+15;W(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,j-Date.now())}}))});let X=!1;return{dispose(){X||(X=!0,clearTimeout($))}}}:e.runWhenIdle=(W,$)=>{const X=requestIdleCallback(W,typeof $=="number"?{timeout:$}:void 0);let j=!1;return{dispose(){j||(j=!0,cancelIdleCallback(X))}}}}();class B{constructor($){this._didRun=!1,this._executor=()=>{try{this._value=$()}catch(X){this._error=X}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=B;async function L(W,$,X){let j;for(let Q=0;Q<X;Q++)try{return await W()}catch(ae){j=ae,await d($)}throw j}e.retry=L;class k{hasPending($){return this._pending?typeof $=="number"?this._pending.taskId===$:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending($,X,j){return this._pending={taskId:$,cancel:()=>j?.(),promise:X},X.then(()=>this.donePending($),()=>this.donePending($)),X}donePending($){this._pending&&$===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const $=this._next;this._next=void 0,$.run().then($.promiseResolve,$.promiseReject)}}setNext($){if(this._next)this._next.run=$;else{let X,j;const Q=new Promise((ae,pe)=>{X=ae,j=pe});this._next={run:$,promise:Q,promiseResolve:X,promiseReject:j}}return this._next.promise}}e.TaskSequentializer=k;class x{constructor($){this.interval=$,this.lastIncrementTime=0,this.value=0}increment(){const $=Date.now();return $-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=$,this.value=0),this.value++,this.value}}e.IntervalCounter=x;class N{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise(($,X)=>{this.completeCallback=$,this.errorCallback=X})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete($){return new Promise(X=>{this.completeCallback($),this.resolved=!0,X()})}error($){return new Promise(X=>{this.errorCallback($),this.rejected=!0,X()})}cancel(){new Promise($=>{this.errorCallback((0,M.canceled)()),this.rejected=!0,$()})}}e.DeferredPromise=N;var V;(function(W){async function $(j){let Q;const ae=await Promise.all(j.map(pe=>pe.then(ce=>ce,ce=>{Q||(Q=ce)})));if(typeof Q!="undefined")throw Q;return ae}W.settled=$;function X(j){return new Promise(async(Q,ae)=>{try{await j(Q,ae)}catch(pe){ae(pe)}})}W.withAsyncBody=X})(V=e.Promises||(e.Promises={}))}),define(we[107],be([0,1,13,17]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const E=new u.IdleValue(()=>{const h=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:h,collatorIsNumeric:h.resolvedOptions().numeric}}),P=new u.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),F=new u.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function T(h,y,R=!1){const I=h||"",B=y||"",L=E.value.collator.compare(I,B);return E.value.collatorIsNumeric&&L===0&&I!==B?I<B?-1:1:L}e.compareFileNames=T;function C(h,y){const R=P.value.collator;return h=h||"",y=y||"",D(R,h,y)}e.compareFileNamesDefault=C;function A(h,y){const R=P.value.collator;return h=h||"",y=y||"",n(h,y)||D(R,h,y)}e.compareFileNamesUpper=A;function t(h,y){const R=P.value.collator;return h=h||"",y=y||"",s(h,y)||D(R,h,y)}e.compareFileNamesLower=t;function _(h,y){return h=h||"",y=y||"",h===y?0:h<y?-1:1}e.compareFileNamesUnicode=_;function i(h,y,R=!1){R||(h=h&&h.toLowerCase(),y=y&&y.toLowerCase());const[I,B]=o(h),[L,k]=o(y);return I!==L?I<L?-1:1:B===k?0:B<k?-1:1}e.noIntlCompareFileNames=i;function m(h,y){const[R,I]=o(h),[B,L]=o(y);let k=E.value.collator.compare(I,L);if(k===0){if(E.value.collatorIsNumeric&&I!==L)return I<L?-1:1;if(k=E.value.collator.compare(R,B),E.value.collatorIsNumeric&&k===0&&R!==B)return R<B?-1:1}return k}e.compareFileExtensions=m;function a(h,y){h=h||"",y=y||"";const R=d(h),I=d(y),B=P.value.collator,L=F.value.collator;return D(L,R,I)||D(B,h,y)}e.compareFileExtensionsDefault=a;function f(h,y){h=h||"",y=y||"";const R=d(h),I=d(y),B=P.value.collator,L=F.value.collator;return D(L,R,I)||n(h,y)||D(B,h,y)}e.compareFileExtensionsUpper=f;function p(h,y){h=h||"",y=y||"";const R=d(h),I=d(y),B=P.value.collator,L=F.value.collator;return D(L,R,I)||s(h,y)||D(B,h,y)}e.compareFileExtensionsLower=p;function S(h,y){h=h||"",y=y||"";const R=d(h).toLowerCase(),I=d(y).toLowerCase();return R!==I?R<I?-1:1:h!==y?h<y?-1:1:0}e.compareFileExtensionsUnicode=S;const v=/^(.*?)(\.([^.]*))?$/;function o(h,y=!1){const R=h?v.exec(h):[];let I=[R&&R[1]||"",R&&R[3]||""];return y&&(!I[0]&&I[1]||I[0]&&I[0].charAt(0)===".")&&(I=[I[0]+"."+I[1],""]),I}function d(h){const y=h?v.exec(h):[];return y&&y[1]&&y[1].charAt(0)!=="."&&y[3]||""}function D(h,y,R){let I=h.compare(y,R);return I!==0?I:y.length!==R.length?y.length<R.length?-1:1:0}function r(h){const y=h.charAt(0);return y.toLocaleUpperCase()!==y}function w(h){const y=h.charAt(0);return y.toLocaleLowerCase()!==y}function s(h,y){return r(h)&&w(y)?-1:w(h)&&r(y)?1:0}function n(h,y){return w(h)&&r(y)?-1:r(h)&&w(y)?1:0}function g(h,y,R=!1){return R||(h=h&&h.toLowerCase(),y=y&&y.toLowerCase()),h===y?0:h<y?-1:1}function l(h,y,R=!1){const I=h.split(M.sep),B=y.split(M.sep),L=I.length-1,k=B.length-1;let x,N;for(let V=0;;V++){if(x=L===V,N=k===V,x&&N)return T(I[V],B[V],R);if(x)return-1;if(N)return 1;const W=g(I[V],B[V],R);if(W!==0)return W}}e.comparePaths=l;function c(h,y,R){const I=h.toLowerCase(),B=y.toLowerCase(),L=b(h,y,R);if(L)return L;const k=I.endsWith(R),x=B.endsWith(R);if(k!==x)return k?-1:1;const N=T(I,B);return N!==0?N:I.localeCompare(B)}e.compareAnything=c;function b(h,y,R){const I=h.toLowerCase(),B=y.toLowerCase(),L=I.startsWith(R),k=B.startsWith(R);if(L!==k)return L?-1:1;if(L&&k){if(I.length<B.length)return-1;if(I.length>B.length)return 1}return 0}e.compareByPrefix=b}),define(we[28],be([0,1,13,44,20,17,9]),function(re,e,u,M,E,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function T(){return Object.create(null)}e.getEmptyExpression=T;const C="**",A="/",t="[/\\\\]",_="[^/\\\\]",i=/\//g;function m(j){switch(j){case 0:return"";case 1:return`${_}*?`;default:return`(?:${t}|${_}+${t}|${t}${_}+)*?`}}function a(j,Q){if(!j)return[];const ae=[];let pe=!1,ce=!1,Fe="";for(const Qe of j){switch(Qe){case Q:if(!pe&&!ce){ae.push(Fe),Fe="";continue}break;case"{":pe=!0;break;case"}":pe=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}Fe+=Qe}return Fe&&ae.push(Fe),ae}e.splitGlobAware=a;function f(j){if(!j)return"";let Q="";const ae=a(j,A);if(ae.every(pe=>pe===C))Q=".*";else{let pe=!1;ae.forEach((ce,Fe)=>{if(ce===C){pe||(Q+=m(2),pe=!0);return}let Qe=!1,Oe="",He=!1,Je="";for(const Ye of ce){if(Ye!=="}"&&Qe){Oe+=Ye;continue}if(He&&(Ye!=="]"||!Je)){let qe;Ye==="-"?qe=Ye:(Ye==="^"||Ye==="!")&&!Je?qe="^":Ye===A?qe="":qe=F.escapeRegExpCharacters(Ye),Je+=qe;continue}switch(Ye){case"{":Qe=!0;continue;case"[":He=!0;continue;case"}":Q+=`(?:${a(Oe,",").map(K=>f(K)).join("|")})`,Qe=!1,Oe="";break;case"]":Q+="["+Je+"]",He=!1,Je="";break;case"?":Q+=_;continue;case"*":Q+=m(1);continue;default:Q+=F.escapeRegExpCharacters(Ye)}}Fe<ae.length-1&&(ae[Fe+1]!==C||Fe+2<ae.length)&&(Q+=t),pe=!1})}return Q}const p=/^\*\*\/\*\.[\w\.-]+$/,S=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,o=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,D=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new E.LRUCache(1e4),w=function(){return!1},s=function(){return null};function n(j,Q){if(!j)return s;let ae;typeof j!="string"?ae=j.pattern:ae=j,ae=ae.trim();const pe=`${ae}_${!!Q.trimForExclusions}`;let ce=r.get(pe);if(ce)return g(ce,j);let Fe;if(p.test(ae)){const Qe=ae.substr(4);ce=function(Oe,He){return typeof Oe=="string"&&Oe.endsWith(Qe)?ae:null}}else(Fe=S.exec(l(ae,Q)))?ce=c(Fe[1],ae):(Q.trimForExclusions?o:v).test(ae)?ce=b(ae,Q):(Fe=d.exec(l(ae,Q)))?ce=h(Fe[1].substr(1),ae,!0):(Fe=D.exec(l(ae,Q)))?ce=h(Fe[1],ae,!1):ce=y(ae);return r.set(pe,ce),g(ce,j)}function g(j,Q){return typeof Q=="string"?j:function(ae,pe){return M.isEqualOrParent(ae,Q.base)?j(P.relative(Q.base,ae),pe):null}}function l(j,Q){return Q.trimForExclusions&&j.endsWith("/**")?j.substr(0,j.length-2):j}function c(j,Q){const ae=`/${j}`,pe=`\\${j}`,ce=function(Qe,Oe){return typeof Qe!="string"?null:Oe?Oe===j?Q:null:Qe===j||Qe.endsWith(ae)||Qe.endsWith(pe)?Q:null},Fe=[j];return ce.basenames=Fe,ce.patterns=[Q],ce.allBasenames=Fe,ce}function b(j,Q){const ae=X(j.slice(1,-1).split(",").map(Oe=>n(Oe,Q)).filter(Oe=>Oe!==s),j),pe=ae.length;if(!pe)return s;if(pe===1)return ae[0];const ce=function(Oe,He){for(let Je=0,Ye=ae.length;Je<Ye;Je++)if(ae[Je](Oe,He))return j;return null},Fe=ae.find(Oe=>!!Oe.allBasenames);Fe&&(ce.allBasenames=Fe.allBasenames);const Qe=ae.reduce((Oe,He)=>He.allPaths?Oe.concat(He.allPaths):Oe,[]);return Qe.length&&(ce.allPaths=Qe),ce}function h(j,Q,ae){const pe=P.sep===P.posix.sep,ce=pe?j:j.replace(i,P.sep),Fe=P.sep+ce,Qe=P.posix.sep+j,Oe=ae?function(He,Je){return typeof He=="string"&&(He===ce||He.endsWith(Fe)||!pe&&(He===j||He.endsWith(Qe)))?Q:null}:function(He,Je){return typeof He=="string"&&(He===ce||!pe&&He===j)?Q:null};return Oe.allPaths=[(ae?"*/":"./")+j],Oe}function y(j){try{const Q=new RegExp(`^${f(j)}$`);return function(ae){return Q.lastIndex=0,typeof ae=="string"&&Q.test(ae)?j:null}}catch(Q){return s}}function R(j,Q,ae){return!j||typeof Q!="string"?!1:I(j)(Q,void 0,ae)}e.match=R;function I(j,Q={}){if(!j)return w;if(typeof j=="string"||x(j)){const ae=n(j,Q);if(ae===s)return w;const pe=function(ce,Fe){return!!ae(ce,Fe)};return ae.allBasenames&&(pe.allBasenames=ae.allBasenames),ae.allPaths&&(pe.allPaths=ae.allPaths),pe}return W(j,Q)}e.parse=I;function B(j){if(!j)return;let Q;return ae=>(Q||(Q=(j()||Promise.resolve([])).then(pe=>pe?k(pe):{})),Q.then(pe=>!!pe[ae]))}e.hasSiblingPromiseFn=B;function L(j){if(!j)return;let Q;return ae=>{if(!Q){const pe=j();Q=pe?k(pe):{}}return!!Q[ae]}}e.hasSiblingFn=L;function k(j){const Q={};for(const ae of j)Q[ae]=!0;return Q}function x(j){const Q=j;return Q&&typeof Q.base=="string"&&typeof Q.pattern=="string"}e.isRelativePattern=x;function N(j){return j.allBasenames||[]}e.getBasenameTerms=N;function V(j){return j.allPaths||[]}e.getPathTerms=V;function W(j,Q){const ae=X(Object.getOwnPropertyNames(j).map(Oe=>$(Oe,j[Oe],Q)).filter(Oe=>Oe!==s)),pe=ae.length;if(!pe)return s;if(!ae.some(Oe=>!!Oe.requiresSiblings)){if(pe===1)return ae[0];const Oe=function(Ye,qe){for(let z=0,K=ae.length;z<K;z++){const Z=ae[z](Ye,qe);if(Z)return Z}return null},He=ae.find(Ye=>!!Ye.allBasenames);He&&(Oe.allBasenames=He.allBasenames);const Je=ae.reduce((Ye,qe)=>qe.allPaths?Ye.concat(qe.allPaths):Ye,[]);return Je.length&&(Oe.allPaths=Je),Oe}const ce=function(Oe,He,Je){let Ye;for(let qe=0,z=ae.length;qe<z;qe++){const K=ae[qe];K.requiresSiblings&&Je&&(He||(He=P.basename(Oe)),Ye||(Ye=He.substr(0,He.length-P.extname(Oe).length)));const Z=K(Oe,He,Ye,Je);if(Z)return Z}return null},Fe=ae.find(Oe=>!!Oe.allBasenames);Fe&&(ce.allBasenames=Fe.allBasenames);const Qe=ae.reduce((Oe,He)=>He.allPaths?Oe.concat(He.allPaths):Oe,[]);return Qe.length&&(ce.allPaths=Qe),ce}function $(j,Q,ae){if(Q===!1)return s;const pe=n(j,ae);if(pe===s)return s;if(typeof Q=="boolean")return pe;if(Q){const ce=Q.when;if(typeof ce=="string"){const Fe=(Qe,Oe,He,Je)=>{if(!Je||!pe(Qe,Oe))return null;const Ye=ce.replace("$(basename)",He),qe=Je(Ye);return(0,u.isThenable)(qe)?qe.then(z=>z?j:null):qe?j:null};return Fe.requiresSiblings=!0,Fe}}return pe}function X(j,Q){const ae=j.filter(Oe=>!!Oe.basenames);if(ae.length<2)return j;const pe=ae.reduce((Oe,He)=>{const Je=He.basenames;return Je?Oe.concat(Je):Oe},[]);let ce;if(Q){ce=[];for(let Oe=0,He=pe.length;Oe<He;Oe++)ce.push(Q)}else ce=ae.reduce((Oe,He)=>{const Je=He.patterns;return Je?Oe.concat(Je):Oe},[]);const Fe=function(Oe,He){if(typeof Oe!="string")return null;if(!He){let Ye;for(Ye=Oe.length;Ye>0;Ye--){const qe=Oe.charCodeAt(Ye-1);if(qe===47||qe===92)break}He=Oe.substr(Ye)}const Je=pe.indexOf(He);return Je!==-1?ce[Je]:null};Fe.basenames=pe,Fe.patterns=ce,Fe.allBasenames=pe;const Qe=j.filter(Oe=>!Oe.basenames);return Qe.push(Fe),Qe}}),define(we[78],be([0,1,44,11,17,25,24,9,2]),function(re,e,u,M,E,P,F,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function A(n,g,l){if(typeof n=="string"&&(n=C.URI.file(n)),l){const b=l.getWorkspaceFolder(n);if(b){const h=l.getWorkspace().folders.length>1;let y;if((0,F.isEqual)(b.uri,n)?y="":y=(0,F.relativePath)(b.uri,n),h){const R=b.name?b.name:(0,F.basename)(b.uri);y=y?R+" \u2022 "+y:R}return y}}if(n.scheme!==M.Schemas.file&&n.scheme!==M.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if((0,u.hasDriveLetter)(n.fsPath))return(0,E.normalize)(_(n.fsPath));let c=(0,E.normalize)(n.fsPath);return!P.isWindows&&g?.userHome&&(c=m(c,g.userHome.fsPath)),c}e.getPathLabel=A;function t(n){if(!n)return;typeof n=="string"&&(n=C.URI.file(n));const g=(0,F.basename)(n)||(n.scheme===M.Schemas.file?n.fsPath:n.path);return P.isWindows&&(0,u.isRootOrDriveLetter)(g)?_(g):g}e.getBaseLabel=t;function _(n,g){return(0,u.hasDriveLetter)(n,g)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=_;let i=Object.create(null);function m(n,g){if(P.isWindows||!n||!g)return n;let l=i.original===g?i.normalized:void 0;return l||(l=`${(0,T.rtrim)(g,E.posix.sep)}${E.posix.sep}`,i={original:g,normalized:l}),(P.isLinux?n.startsWith(l):(0,T.startsWithIgnoreCase)(n,l))&&(n=`~/${n.substr(l.length)}`),n}e.tildify=m;function a(n,g){return n.replace(/^~($|\/|\\)/,`${g}$1`)}e.untildify=a;const f="\u2026",p="\\\\",S="~";function v(n,g=E.sep){const l=new Array(n.length);let c=!1;for(let b=0;b<n.length;b++){let h=n[b];if(h===""){l[b]=`.${g}`;continue}if(!h){l[b]=h;continue}c=!0;let y="";h.indexOf(p)===0?(y=h.substr(0,h.indexOf(p)+p.length),h=h.substr(h.indexOf(p)+p.length)):h.indexOf(g)===0?(y=h.substr(0,h.indexOf(g)+g.length),h=h.substr(h.indexOf(g)+g.length)):h.indexOf(S)===0&&(y=h.substr(0,h.indexOf(S)+S.length),h=h.substr(h.indexOf(S)+S.length));const R=h.split(g);for(let I=1;c&&I<=R.length;I++)for(let B=R.length-I;c&&B>=0;B--){c=!1;let L=R.slice(B,B+I).join(g);for(let k=0;!c&&k<n.length;k++)if(k!==b&&n[k]&&n[k].indexOf(L)>-1){const x=B+I===R.length,N=B>0&&n[k].indexOf(g)>-1?g+L:L,V=n[k].endsWith(N);c=!x||V}if(!c){let k="";(R[0].endsWith(":")||y!=="")&&(B===1&&(B=0,I++,L=R[0]+g+L),B>0&&(k=R[0]+g),k=y+k),B>0&&(k=k+f+g),k=k+L,B+I<R.length&&(k=k+g+f),l[b]=k}}c&&(l[b]=h)}return l}e.shorten=v;var o;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(o||(o={}));function d(n,g=Object.create(null)){const l=[];let c=!1,b="";for(const h of n)if(h==="$"||c&&h==="{")b&&l.push({value:b,type:o.TEXT}),b="",c=!0;else if(h==="}"&&c){const y=g[b];if(typeof y=="string")y.length&&l.push({value:y,type:o.VARIABLE});else if(y){const R=l[l.length-1];(!R||R.type!==o.SEPARATOR)&&l.push({value:y.label,type:o.SEPARATOR})}b="",c=!1}else b+=h;return b&&!c&&l.push({value:b,type:o.TEXT}),l.filter((h,y)=>{if(h.type===o.SEPARATOR){const R=l[y-1],I=l[y+1];return[R,I].every(B=>B&&(B.type===o.VARIABLE||B.type===o.TEXT)&&B.value.length>0)}return!0}).map(h=>h.value).join("")}e.template=d;function D(n,g){return P.isMacintosh||g?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.isMacintosh?"&":"&&"):n.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.mnemonicMenuLabel=D;function r(n,g){return P.isMacintosh||g?n.replace(/\(&&\w\)|&&/g,""):P.isWindows?n.replace(/&&|&/g,l=>l==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=r;function w(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=w;function s(n){const g=n.indexOf("/")!==-1?E.posix:E.win32,l=g.basename(n),c=g.dirname(n);return l.length?{name:l,parentPath:c}:{name:c,parentPath:""}}e.splitName=s}),define(we[79],be([0,1,28,11,17,24,9]),function(re,e,u,M,E,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var T;(function(n){n.text="text/plain",n.binary="application/octet-stream",n.unknown="application/unknown",n.markdown="text/markdown",n.latex="text/latex"})(T=e.Mimes||(e.Mimes={}));let C=[],A=[],t=[];function _(n,g=!1){const l=i(n);C.push(l),l.userConfigured?t.push(l):A.push(l),g&&!l.userConfigured&&C.forEach(c=>{c.mime===l.mime||c.userConfigured||(l.extension&&c.extension===l.extension&&console.warn(`Overwriting extension <<${l.extension}>> to now point to mime <<${l.mime}>>`),l.filename&&c.filename===l.filename&&console.warn(`Overwriting filename <<${l.filename}>> to now point to mime <<${l.mime}>>`),l.filepattern&&c.filepattern===l.filepattern&&console.warn(`Overwriting filepattern <<${l.filepattern}>> to now point to mime <<${l.mime}>>`),l.firstline&&c.firstline===l.firstline&&console.warn(`Overwriting firstline <<${l.firstline}>> to now point to mime <<${l.mime}>>`))})}e.registerTextMime=_;function i(n){return{id:n.id,mime:n.mime,filename:n.filename,extension:n.extension,filepattern:n.filepattern,firstline:n.firstline,userConfigured:n.userConfigured,filenameLowercase:n.filename?n.filename.toLowerCase():void 0,extensionLowercase:n.extension?n.extension.toLowerCase():void 0,filepatternLowercase:n.filepattern?(0,u.parse)(n.filepattern.toLowerCase()):void 0,filepatternOnPath:n.filepattern?n.filepattern.indexOf(E.posix.sep)>=0:!1}}function m(n){n?(C=C.filter(g=>!g.userConfigured),t=[]):(C=[],A=[],t=[])}e.clearTextMimes=m;function a(n,g){let l;if(n)switch(n.scheme){case M.Schemas.file:l=n.fsPath;break;case M.Schemas.data:l=P.DataUri.parseMetaData(n).get(P.DataUri.META_DATA_LABEL);break;default:l=n.path}if(!l)return[T.unknown];l=l.toLowerCase();const c=(0,E.basename)(l),b=f(l,c,t);if(b)return[b,T.text];const h=f(l,c,A);if(h)return[h,T.text];if(g){const y=p(g);if(y)return[y,T.text]}return[T.unknown]}e.guessMimeTypes=a;function f(n,g,l){let c=null,b=null,h=null;for(let y=l.length-1;y>=0;y--){const R=l[y];if(g===R.filenameLowercase){c=R;break}if(R.filepattern&&(!b||R.filepattern.length>b.filepattern.length)){const I=R.filepatternOnPath?n:g;R.filepatternLowercase?.(I)&&(b=R)}R.extension&&(!h||R.extension.length>h.extension.length)&&g.endsWith(R.extensionLowercase)&&(h=R)}return c?c.mime:b?b.mime:h?h.mime:null}function p(n){if((0,F.startsWithUTF8BOM)(n)&&(n=n.substr(1)),n.length>0)for(let g=C.length-1;g>=0;g--){const l=C[g];if(!l.firstline)continue;const c=n.match(l.firstline);if(c&&c.length>0)return l.mime}return null}function S(n){return n?typeof n=="string"?n===T.binary||n===T.text||n===T.unknown:n.length===1&&S(n[0]):!0}e.isUnspecific=S;const v={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},o={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function d(n){const g=(0,E.extname)(n),l=v[g.toLowerCase()];return l!==void 0?l:D(n)}e.getMediaOrTextMime=d;function D(n){const g=(0,E.extname)(n);return o[g.toLowerCase()]}e.getMediaMime=D;function r(n){for(const g in o)if(o[g]===n)return g}e.getExtensionForMimeType=r;const w=/^(.+)\/(.+?)(;.+)?$/;function s(n,g){const l=w.exec(n);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:g?void 0:n}e.normalizeMimeType=s}),define(we[108],be([0,1,2]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function M(t){return t.toJSON()}class E{constructor(_){this._uriTransformer=_}transformIncoming(_){const i=this._uriTransformer.transformIncoming(_);return i===_?_:M(u.URI.from(i))}transformOutgoing(_){const i=this._uriTransformer.transformOutgoing(_);return i===_?_:M(u.URI.from(i))}transformOutgoingURI(_){const i=this._uriTransformer.transformOutgoing(_);return i===_?_:u.URI.from(i)}transformOutgoingScheme(_){return this._uriTransformer.transformOutgoingScheme(_)}}e.URITransformer=E,e.DefaultURITransformer=new class{transformIncoming(t){return t}transformOutgoing(t){return t}transformOutgoingURI(t){return t}transformOutgoingScheme(t){return t}};function P(t,_,i){if(!t||i>200)return null;if(typeof t=="object"){if(t instanceof u.URI)return _.transformOutgoing(t);for(let m in t)if(Object.hasOwnProperty.call(t,m)){const a=P(t[m],_,i+1);a!==null&&(t[m]=a)}}return null}function F(t,_){const i=P(t,_,0);return i===null?t:i}e.transformOutgoingURIs=F;function T(t,_,i,m){if(!t||m>200)return null;if(typeof t=="object"){if(t.$mid===1)return i?u.URI.revive(_.transformIncoming(t)):_.transformIncoming(t);for(let a in t)if(Object.hasOwnProperty.call(t,a)){const f=T(t[a],_,i,m+1);f!==null&&(t[a]=f)}}return null}function C(t,_){const i=T(t,_,!1,0);return i===null?t:i}e.transformIncomingURIs=C;function A(t,_){const i=T(t,_,!0,0);return i===null?t:i}e.transformAndReviveIncomingURIs=A}),define(we[37],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const u=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(C){return u.test(C)}e.isUUID=M;const E=new Uint8Array(16),P=[];for(let C=0;C<256;C++)P.push(C.toString(16).padStart(2,"0"));let F;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?F=crypto.getRandomValues.bind(crypto):F=function(C){for(let A=0;A<C.length;A++)C[A]=Math.floor(Math.random()*256);return C};function T(){F(E),E[6]=E[6]&15|64,E[8]=E[8]&63|128;let C=0,A="";return A+=P[E[C++]],A+=P[E[C++]],A+=P[E[C++]],A+=P[E[C++]],A+="-",A+=P[E[C++]],A+=P[E[C++]],A+="-",A+=P[E[C++]],A+=P[E[C++]],A+="-",A+=P[E[C++]],A+=P[E[C++]],A+="-",A+=P[E[C++]],A+=P[E[C++]],A+=P[E[C++]],A+=P[E[C++]],A+=P[E[C++]],A+=P[E[C++]],A}e.generateUuid=T}),define(we[109],be([0,1,231]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var M;(function(F){F[F.Regular=0]="Regular",F[F.Whitespace=1]="Whitespace",F[F.WordSeparator=2]="WordSeparator"})(M=e.WordCharacterClass||(e.WordCharacterClass={}));class E extends u.CharacterClassifier{constructor(T){super(0);for(let C=0,A=T.length;C<A;C++)this.set(T.charCodeAt(C),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=E;function P(F){let T={};return C=>(T.hasOwnProperty(C)||(T[C]=F(C)),T[C])}e.getMapForWordSeparators=P(F=>new E(F))}),define(we[80],be([0,1,23]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.IndentGuideHorizontalLine=e.IndentGuide=e.HorizontalGuidesState=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var M;(function(v){v[v.Left=1]="Left",v[v.Center=2]="Center",v[v.Right=4]="Right",v[v.Full=7]="Full"})(M=e.OverviewRulerLane||(e.OverviewRulerLane={}));var E;(function(v){v[v.Inline=1]="Inline",v[v.Gutter=2]="Gutter"})(E=e.MinimapPosition||(e.MinimapPosition={}));var P;(function(v){v[v.TextDefined=0]="TextDefined",v[v.LF=1]="LF",v[v.CRLF=2]="CRLF"})(P=e.EndOfLinePreference||(e.EndOfLinePreference={}));var F;(function(v){v[v.LF=1]="LF",v[v.CRLF=2]="CRLF"})(F=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var T;(function(v){v[v.LF=0]="LF",v[v.CRLF=1]="CRLF"})(T=e.EndOfLineSequence||(e.EndOfLineSequence={}));class C{constructor(o){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,o.tabSize|0),this.indentSize=o.tabSize|0,this.insertSpaces=Boolean(o.insertSpaces),this.defaultEOL=o.defaultEOL|0,this.trimAutoWhitespace=Boolean(o.trimAutoWhitespace),this.bracketPairColorizationOptions=o.bracketPairColorizationOptions}equals(o){return this.tabSize===o.tabSize&&this.indentSize===o.indentSize&&this.insertSpaces===o.insertSpaces&&this.defaultEOL===o.defaultEOL&&this.trimAutoWhitespace===o.trimAutoWhitespace&&(0,u.equals)(this.bracketPairColorizationOptions,o.bracketPairColorizationOptions)}createChangeEvent(o){return{tabSize:this.tabSize!==o.tabSize,indentSize:this.indentSize!==o.indentSize,insertSpaces:this.insertSpaces!==o.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==o.trimAutoWhitespace}}}e.TextModelResolvedOptions=C;class A{constructor(o,d){this._findMatchBrand=void 0,this.range=o,this.matches=d}}e.FindMatch=A;var t;(function(v){v[v.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",v[v.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",v[v.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",v[v.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(t=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var _;(function(v){v[v.Disabled=0]="Disabled",v[v.EnabledForActive=1]="EnabledForActive",v[v.Enabled=2]="Enabled"})(_=e.HorizontalGuidesState||(e.HorizontalGuidesState={}));class i{constructor(o,d,D){this.visibleColumn=o,this.className=d,this.horizontalLine=D}}e.IndentGuide=i;class m{constructor(o,d){this.top=o,this.endColumn=d}}e.IndentGuideHorizontalLine=m;var a;(function(v){v[v.Left=0]="Left",v[v.Right=1]="Right",v[v.None=2]="None"})(a=e.PositionAffinity||(e.PositionAffinity={}));var f;(function(v){v[v.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(f=e.ModelConstants||(e.ModelConstants={}));class p{constructor(o,d,D,r,w,s){this.identifier=o,this.range=d,this.text=D,this.forceMoveMarkers=r,this.isAutoWhitespaceEdit=w,this._isTracked=s}}e.ValidAnnotatedEditOperation=p;class S{constructor(o,d,D){this.reverseEdits=o,this.changes=d,this.trimAutoWhitespaceLineNumbers=D}}e.ApplyEditsResult=S}),define(we[110],be([0,1,9,109,111,45,80]),function(re,e,u,M,E,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const T=999;class C{constructor(o,d,D,r){this.searchString=o,this.isRegex=d,this.matchCase=D,this.wordSeparators=r}parseSearchRequest(){if(this.searchString==="")return null;let o;this.isRegex?o=A(this.searchString):o=this.searchString.indexOf(`
`)>=0;let d=null;try{d=u.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:o,global:!0,unicode:!0})}catch(r){return null}if(!d)return null;let D=!this.isRegex&&!o;return D&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(D=this.matchCase),new t(d,this.wordSeparators?(0,M.getMapForWordSeparators)(this.wordSeparators):null,D?this.searchString:null)}}e.SearchParams=C;function A(v){if(!v||v.length===0)return!1;for(let o=0,d=v.length;o<d;o++)if(v.charCodeAt(o)===92){if(o++,o>=d)break;const r=v.charCodeAt(o);if(r===110||r===114||r===87)return!0}return!1}e.isMultilineRegexSource=A;class t{constructor(o,d,D){this.regex=o,this.wordSeparators=d,this.simpleSearch=D}}e.SearchData=t;function _(v,o,d){if(!d)return new F.FindMatch(v,null);let D=[];for(let r=0,w=o.length;r<w;r++)D[r]=o[r];return new F.FindMatch(v,D)}e.createFindMatch=_;class i{constructor(o){let d=[],D=0;for(let r=0,w=o.length;r<w;r++)o.charCodeAt(r)===10&&(d[D++]=r);this._lineFeedsOffsets=d}findLineFeedCountBeforeOffset(o){const d=this._lineFeedsOffsets;let D=0,r=d.length-1;if(r===-1||o<=d[0])return 0;for(;D<r;){const w=D+((r-D)/2>>0);d[w]>=o?r=w-1:d[w+1]>=o?(D=w,r=w):D=w+1}return D+1}}class m{static findMatches(o,d,D,r,w){const s=d.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(o,D,new S(s.wordSeparators,s.regex),r,w):this._doFindMatchesLineByLine(o,D,s,r,w):[]}static _getMultilineMatchRange(o,d,D,r,w,s){let n,g=0;r?(g=r.findLineFeedCountBeforeOffset(w),n=d+w+g):n=d+w;let l;if(r){let y=r.findLineFeedCountBeforeOffset(w+s.length)-g;l=n+s.length+y}else l=n+s.length;const c=o.getPositionAt(n),b=o.getPositionAt(l);return new P.Range(c.lineNumber,c.column,b.lineNumber,b.column)}static _doFindMatchesMultiline(o,d,D,r,w){const s=o.getOffsetAt(d.getStartPosition()),n=o.getValueInRange(d,1),g=o.getEOL()===`\r
`?new i(n):null,l=[];let c=0,b;for(D.reset(0);b=D.next(n);)if(l[c++]=_(this._getMultilineMatchRange(o,s,n,g,b.index,b[0]),b,r),c>=w)return l;return l}static _doFindMatchesLineByLine(o,d,D,r,w){const s=[];let n=0;if(d.startLineNumber===d.endLineNumber){const l=o.getLineContent(d.startLineNumber).substring(d.startColumn-1,d.endColumn-1);return n=this._findMatchesInLine(D,l,d.startLineNumber,d.startColumn-1,n,s,r,w),s}const g=o.getLineContent(d.startLineNumber).substring(d.startColumn-1);n=this._findMatchesInLine(D,g,d.startLineNumber,d.startColumn-1,n,s,r,w);for(let l=d.startLineNumber+1;l<d.endLineNumber&&n<w;l++)n=this._findMatchesInLine(D,o.getLineContent(l),l,0,n,s,r,w);if(n<w){const l=o.getLineContent(d.endLineNumber).substring(0,d.endColumn-1);n=this._findMatchesInLine(D,l,d.endLineNumber,0,n,s,r,w)}return s}static _findMatchesInLine(o,d,D,r,w,s,n,g){const l=o.wordSeparators;if(!n&&o.simpleSearch){const h=o.simpleSearch,y=h.length,R=d.length;let I=-y;for(;(I=d.indexOf(h,I+y))!==-1;)if((!l||p(l,d,R,I,y))&&(s[w++]=new F.FindMatch(new P.Range(D,I+1+r,D,I+1+y+r),null),w>=g))return w;return w}const c=new S(o.wordSeparators,o.regex);let b;c.reset(0);do if(b=c.next(d),b&&(s[w++]=_(new P.Range(D,b.index+1+r,D,b.index+1+b[0].length+r),b,n),w>=g))return w;while(b);return w}static findNextMatch(o,d,D,r){const w=d.parseSearchRequest();if(!w)return null;const s=new S(w.wordSeparators,w.regex);return w.regex.multiline?this._doFindNextMatchMultiline(o,D,s,r):this._doFindNextMatchLineByLine(o,D,s,r)}static _doFindNextMatchMultiline(o,d,D,r){const w=new E.Position(d.lineNumber,1),s=o.getOffsetAt(w),n=o.getLineCount(),g=o.getValueInRange(new P.Range(w.lineNumber,w.column,n,o.getLineMaxColumn(n)),1),l=o.getEOL()===`\r
`?new i(g):null;D.reset(d.column-1);let c=D.next(g);return c?_(this._getMultilineMatchRange(o,s,g,l,c.index,c[0]),c,r):d.lineNumber!==1||d.column!==1?this._doFindNextMatchMultiline(o,new E.Position(1,1),D,r):null}static _doFindNextMatchLineByLine(o,d,D,r){const w=o.getLineCount(),s=d.lineNumber,n=o.getLineContent(s),g=this._findFirstMatchInLine(D,n,s,d.column,r);if(g)return g;for(let l=1;l<=w;l++){const c=(s+l-1)%w,b=o.getLineContent(c+1),h=this._findFirstMatchInLine(D,b,c+1,1,r);if(h)return h}return null}static _findFirstMatchInLine(o,d,D,r,w){o.reset(r-1);const s=o.next(d);return s?_(new P.Range(D,s.index+1,D,s.index+1+s[0].length),s,w):null}static findPreviousMatch(o,d,D,r){const w=d.parseSearchRequest();if(!w)return null;const s=new S(w.wordSeparators,w.regex);return w.regex.multiline?this._doFindPreviousMatchMultiline(o,D,s,r):this._doFindPreviousMatchLineByLine(o,D,s,r)}static _doFindPreviousMatchMultiline(o,d,D,r){const w=this._doFindMatchesMultiline(o,new P.Range(1,1,d.lineNumber,d.column),D,r,10*T);if(w.length>0)return w[w.length-1];const s=o.getLineCount();return d.lineNumber!==s||d.column!==o.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(o,new E.Position(s,o.getLineMaxColumn(s)),D,r):null}static _doFindPreviousMatchLineByLine(o,d,D,r){const w=o.getLineCount(),s=d.lineNumber,n=o.getLineContent(s).substring(0,d.column-1),g=this._findLastMatchInLine(D,n,s,r);if(g)return g;for(let l=1;l<=w;l++){const c=(w+s-l-1)%w,b=o.getLineContent(c+1),h=this._findLastMatchInLine(D,b,c+1,r);if(h)return h}return null}static _findLastMatchInLine(o,d,D,r){let w=null,s;for(o.reset(0);s=o.next(d);)w=_(new P.Range(D,s.index+1,D,s.index+1+s[0].length),s,r);return w}}e.TextModelSearch=m;function a(v,o,d,D,r){if(D===0)return!0;const w=o.charCodeAt(D-1);if(v.get(w)!==0||w===13||w===10)return!0;if(r>0){const s=o.charCodeAt(D);if(v.get(s)!==0)return!0}return!1}function f(v,o,d,D,r){if(D+r===d)return!0;const w=o.charCodeAt(D+r);if(v.get(w)!==0||w===13||w===10)return!0;if(r>0){const s=o.charCodeAt(D+r-1);if(v.get(s)!==0)return!0}return!1}function p(v,o,d,D,r){return a(v,o,d,D,r)&&f(v,o,d,D,r)}e.isValidMatch=p;class S{constructor(o,d){this._wordSeparators=o,this._searchRegex=d,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(o){this._searchRegex.lastIndex=o,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(o){const d=o.length;let D;do{if(this._prevMatchStartIndex+this._prevMatchLength===d||(D=this._searchRegex.exec(o),!D))return null;const r=D.index,w=D[0].length;if(r===this._prevMatchStartIndex&&w===this._prevMatchLength){if(w===0){u.getNextCodePoint(o,d,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=r,this._prevMatchLength=w,!this._wordSeparators||p(this._wordSeparators,o,d,r,w))return D}while(D);return null}}e.Searcher=S}),define(we[112],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var u;(function(F){F[F.None=0]="None",F[F.Indent=1]="Indent",F[F.IndentOutdent=2]="IndentOutdent",F[F.Outdent=3]="Outdent"})(u=e.IndentAction||(e.IndentAction={}));class M{constructor(T){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=T.open,this.close=T.close,this._standardTokenMask=0,Array.isArray(T.notIn))for(let C=0,A=T.notIn.length;C<A;C++)switch(T.notIn[C]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(T){return(this._standardTokenMask&T)==0}}e.StandardAutoClosingPairConditional=M;class E{constructor(T){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const C of T)P(this.autoClosingPairsOpenByStart,C.open.charAt(0),C),P(this.autoClosingPairsOpenByEnd,C.open.charAt(C.open.length-1),C),P(this.autoClosingPairsCloseByStart,C.close.charAt(0),C),P(this.autoClosingPairsCloseByEnd,C.close.charAt(C.close.length-1),C),C.close.length===1&&C.open.length===1&&P(this.autoClosingPairsCloseSingleChar,C.close,C)}}e.AutoClosingPairs=E;function P(F,T,C){F.has(T)?F.get(T).push(C):F.set(T,[C])}}),define(we[58],be([0,1,28,17]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function E(P,F,T,C){if(Array.isArray(P)){let A=0;for(const t of P){const _=E(t,F,T,C);if(_===10)return _;_>A&&(A=_)}return A}else{if(typeof P=="string")return C?P==="*"?5:P===T?10:0:0;if(P){const{language:A,pattern:t,scheme:_,hasAccessToAllModels:i}=P;if(!C&&!i)return 0;let m=0;if(_)if(_===F.scheme)m=10;else if(_==="*")m=5;else return 0;if(A)if(A===T)m=10;else if(A==="*")m=Math.max(m,5);else return 0;if(t){let a;if(typeof t=="string"?a=t:a={...t,base:(0,M.normalize)(t.base)},a===F.fsPath||(0,u.match)(a,F.fsPath))m=10;else return 0}return m}else return 0}}e.score=E}),define(we[113],be([0,1,3,6]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class E{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new u.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(F){this._onDidChange.fire({changedLanguages:F,changedColorMap:!1})}register(F,T){return this._map.set(F,T),this.fire([F]),(0,M.toDisposable)(()=>{this._map.get(F)===T&&(this._map.delete(F),this.fire([F]))})}registerPromise(F,T){let C=null,A=!1;return this._promises.set(F,T.then(t=>{this._promises.delete(F),!(A||!t)&&(C=this.register(F,t))})),(0,M.toDisposable)(()=>{A=!0,C&&C.dispose()})}getPromise(F){const T=this.get(F);if(T)return Promise.resolve(T);const C=this._promises.get(F);return C?C.then(A=>this.get(F)):null}get(F){return this._map.get(F)||null}setColorMap(F){this._colorMap=F,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=E}),define(we[81],be([0,1,22,25]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var E;(function(_){_[_.Full=1]="Full",_[_.Delta=2]="Delta"})(E||(E={}));function P(_){for(let i=0,m=_.length;i<m;i+=4){const a=_[i+0],f=_[i+1],p=_[i+2],S=_[i+3];_[i+0]=S,_[i+1]=p,_[i+2]=f,_[i+3]=a}}function F(_){const i=new Uint8Array(_.buffer,_.byteOffset,_.length*4);return M.isLittleEndian()||P(i),u.VSBuffer.wrap(i)}function T(_){const i=_.buffer;if(M.isLittleEndian()||P(i),i.byteOffset%4==0)return new Uint32Array(i.buffer,i.byteOffset,i.length/4);{const m=new Uint8Array(i.byteLength);return m.set(i),new Uint32Array(m.buffer,m.byteOffset,m.length/4)}}function C(_){const i=new Uint32Array(A(_));let m=0;if(i[m++]=_.id,_.type==="full")i[m++]=1,i[m++]=_.data.length,i.set(_.data,m),m+=_.data.length;else{i[m++]=2,i[m++]=_.deltas.length;for(const a of _.deltas)i[m++]=a.start,i[m++]=a.deleteCount,a.data?(i[m++]=a.data.length,i.set(a.data,m),m+=a.data.length):i[m++]=0}return F(i)}e.encodeSemanticTokensDto=C;function A(_){let i=0;if(i+=1+1,_.type==="full")i+=1+_.data.length;else{i+=1,i+=(1+1+1)*_.deltas.length;for(const m of _.deltas)m.data&&(i+=m.data.length)}return i}function t(_){const i=T(_);let m=0;const a=i[m++];if(i[m++]===1){const v=i[m++],o=i.subarray(m,m+v);return m+=v,{id:a,type:"full",data:o}}const p=i[m++];let S=[];for(let v=0;v<p;v++){const o=i[m++],d=i[m++],D=i[m++];let r;D>0&&(r=i.subarray(m,m+D),m+=D),S[v]={start:o,deleteCount:d,data:r}}return{id:a,type:"delta",deltas:S}}e.decodeSemanticTokensDto=t}),define(we[114],be([18,19]),function(re,e){return re.create("vs/base/common/date",e)}),define(we[115],be([0,1,114]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const M=60,E=M*60,P=E*24,F=P*7,T=P*30,C=P*365;function A(_,i){typeof _!="number"&&(_=_.getTime());const m=Math.round((new Date().getTime()-_)/1e3);if(m<-30)return(0,u.localize)(0,null,A(new Date().getTime()+m*1e3,!1));if(m<30)return(0,u.localize)(1,null);let a;return m<M?(a=m,i?a===1?(0,u.localize)(2,null,a):(0,u.localize)(3,null,a):a===1?(0,u.localize)(4,null,a):(0,u.localize)(5,null,a)):m<E?(a=Math.floor(m/M),i?a===1?(0,u.localize)(6,null,a):(0,u.localize)(7,null,a):a===1?(0,u.localize)(8,null,a):(0,u.localize)(9,null,a)):m<P?(a=Math.floor(m/E),i?a===1?(0,u.localize)(10,null,a):(0,u.localize)(11,null,a):a===1?(0,u.localize)(12,null,a):(0,u.localize)(13,null,a)):m<F?(a=Math.floor(m/P),i?a===1?(0,u.localize)(14,null,a):(0,u.localize)(15,null,a):a===1?(0,u.localize)(16,null,a):(0,u.localize)(17,null,a)):m<T?(a=Math.floor(m/F),i?a===1?(0,u.localize)(18,null,a):(0,u.localize)(19,null,a):a===1?(0,u.localize)(20,null,a):(0,u.localize)(21,null,a)):m<C?(a=Math.floor(m/T),i?a===1?(0,u.localize)(22,null,a):(0,u.localize)(23,null,a):a===1?(0,u.localize)(24,null,a):(0,u.localize)(25,null,a)):(a=Math.floor(m/C),i?a===1?(0,u.localize)(26,null,a):(0,u.localize)(27,null,a):a===1?(0,u.localize)(28,null,a):(0,u.localize)(29,null,a))}e.fromNow=A;function t(_){return _.getFullYear()+"-"+String(_.getMonth()+1).padStart(2,"0")+"-"+String(_.getDate()).padStart(2,"0")+"T"+String(_.getHours()).padStart(2,"0")+":"+String(_.getMinutes()).padStart(2,"0")+":"+String(_.getSeconds()).padStart(2,"0")+"."+(_.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=t}),define(we[116],be([18,19]),function(re,e){return re.create("vs/base/common/errorMessage",e)}),define(we[46],be([0,1,15,10,116]),function(re,e,u,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function P(A,t){return t&&(A.stack||A.stacktrace)?E.localize(0,null,T(A),F(A.stack)||F(A.stacktrace)):T(A)}function F(A){return Array.isArray(A)?A.join(`
`):A}function T(A){return typeof A.code=="string"&&typeof A.errno=="number"&&typeof A.syscall=="string"?E.localize(1,null,A.message):A.message||E.localize(2,null)}function C(A=null,t=!1){if(!A)return E.localize(3,null);if(Array.isArray(A)){const _=u.coalesce(A),i=C(_[0],t);return _.length>1?E.localize(4,null,i,_.length):i}if(M.isString(A))return A;if(A.detail){const _=A.detail;if(_.error)return P(_.error,t);if(_.exception)return P(_.exception,t)}return A.stack?P(A,t):A.message?A.message:E.localize(5,null)}e.toErrorMessage=C}),define(we[117],be([18,19]),function(re,e){return re.create("vs/editor/common/config/editorOptions",e)}),define(we[118],be([0,1,117,25,119]),function(re,e,u,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var P;(function(q){q[q.None=0]="None",q[q.Keep=1]="Keep",q[q.Brackets=2]="Brackets",q[q.Advanced=3]="Advanced",q[q.Full=4]="Full"})(P=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class F{constructor(J){this._values=J}hasChanged(J){return this._values[J]}}e.ConfigurationChangedEvent=F;class T{constructor(){this._values=[]}_read(J){return this._values[J]}get(J){return this._values[J]}_write(J,ge){this._values[J]=ge}}e.ValidatedEditorOptions=T;class C{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=C;class A{constructor(J,ge,$e,Ge){this.id=J,this.name=ge,this.defaultValue=$e,this.schema=Ge}compute(J,ge,$e){return $e}}class t{constructor(J,ge=null){this.schema=void 0,this.id=J,this.name="_never_",this.defaultValue=void 0,this.deps=ge}validate(J){return this.defaultValue}}class _{constructor(J,ge,$e,Ge){this.id=J,this.name=ge,this.defaultValue=$e,this.schema=Ge}validate(J){return typeof J=="undefined"?this.defaultValue:J}compute(J,ge,$e){return $e}}function i(q,J){return typeof q=="undefined"?J:q==="false"?!1:Boolean(q)}e.boolean=i;class m extends _{constructor(J,ge,$e,Ge=void 0){typeof Ge!="undefined"&&(Ge.type="boolean",Ge.default=$e),super(J,ge,$e,Ge)}validate(J){return i(J,this.defaultValue)}}function a(q,J,ge,$e){if(typeof q=="undefined")return J;let Ge=parseInt(q,10);return isNaN(Ge)?J:(Ge=Math.max(ge,Ge),Ge=Math.min($e,Ge),Ge|0)}e.clampedInt=a;class f extends _{constructor(J,ge,$e,Ge,rt,ft=void 0){typeof ft!="undefined"&&(ft.type="integer",ft.default=$e,ft.minimum=Ge,ft.maximum=rt),super(J,ge,$e,ft),this.minimum=Ge,this.maximum=rt}static clampedInt(J,ge,$e,Ge){return a(J,ge,$e,Ge)}validate(J){return f.clampedInt(J,this.defaultValue,this.minimum,this.maximum)}}class p extends _{constructor(J,ge,$e,Ge,rt){typeof rt!="undefined"&&(rt.type="number",rt.default=$e),super(J,ge,$e,rt),this.validationFn=Ge}static clamp(J,ge,$e){return J<ge?ge:J>$e?$e:J}static float(J,ge){if(typeof J=="number")return J;if(typeof J=="undefined")return ge;const $e=parseFloat(J);return isNaN($e)?ge:$e}validate(J){return this.validationFn(p.float(J,this.defaultValue))}}class S extends _{static string(J,ge){return typeof J!="string"?ge:J}constructor(J,ge,$e,Ge=void 0){typeof Ge!="undefined"&&(Ge.type="string",Ge.default=$e),super(J,ge,$e,Ge)}validate(J){return S.string(J,this.defaultValue)}}function v(q,J,ge){return typeof q!="string"||ge.indexOf(q)===-1?J:q}e.stringSet=v;class o extends _{constructor(J,ge,$e,Ge,rt=void 0){typeof rt!="undefined"&&(rt.type="string",rt.enum=Ge,rt.default=$e),super(J,ge,$e,rt),this._allowedValues=Ge}validate(J){return v(J,this.defaultValue,this._allowedValues)}}class d extends A{constructor(J,ge,$e,Ge,rt,ft,ht=void 0){typeof ht!="undefined"&&(ht.type="string",ht.enum=rt,ht.default=Ge),super(J,ge,$e,ht),this._allowedValues=rt,this._convert=ft}validate(J){return typeof J!="string"?this.defaultValue:this._allowedValues.indexOf(J)===-1?this.defaultValue:this._convert(J)}}function D(q){switch(q){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class r extends A{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[u.localize(0,null),u.localize(1,null),u.localize(2,null)],default:"auto",description:u.localize(3,null)})}validate(J){switch(J){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(J,ge,$e){return $e===0?J.accessibilitySupport:$e}}class w extends A{constructor(){const J={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",J,{"editor.comments.insertSpace":{type:"boolean",default:J.insertSpace,description:u.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:J.ignoreEmptyLines,description:u.localize(5,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const ge=J;return{insertSpace:i(ge.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:i(ge.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var s;(function(q){q[q.Hidden=0]="Hidden",q[q.Blink=1]="Blink",q[q.Smooth=2]="Smooth",q[q.Phase=3]="Phase",q[q.Expand=4]="Expand",q[q.Solid=5]="Solid"})(s=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function n(q){switch(q){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var g;(function(q){q[q.Line=1]="Line",q[q.Block=2]="Block",q[q.Underline=3]="Underline",q[q.LineThin=4]="LineThin",q[q.BlockOutline=5]="BlockOutline",q[q.UnderlineThin=6]="UnderlineThin"})(g=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function l(q){switch(q){case g.Line:return"line";case g.Block:return"block";case g.Underline:return"underline";case g.LineThin:return"line-thin";case g.BlockOutline:return"block-outline";case g.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=l;function c(q){switch(q){case"line":return g.Line;case"block":return g.Block;case"underline":return g.Underline;case"line-thin":return g.LineThin;case"block-outline":return g.BlockOutline;case"underline-thin":return g.UnderlineThin}}class b extends t{constructor(){super(126,[65,33])}compute(J,ge,$e){const Ge=["monaco-editor"];return ge.get(33)&&Ge.push(ge.get(33)),J.extraEditorClassName&&Ge.push(J.extraEditorClassName),ge.get(65)==="default"?Ge.push("mouse-default"):ge.get(65)==="copy"&&Ge.push("mouse-copy"),ge.get(99)&&Ge.push("showUnused"),ge.get(124)&&Ge.push("showDeprecated"),Ge.join(" ")}}class h extends m{constructor(){super(32,"emptySelectionClipboard",!0,{description:u.localize(6,null)})}compute(J,ge,$e){return $e&&J.emptySelectionClipboard}}class y extends A{constructor(){const J={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",J,{"editor.find.cursorMoveOnType":{type:"boolean",default:J.cursorMoveOnType,description:u.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:J.seedSearchStringFromSelection,enumDescriptions:[u.localize(8,null),u.localize(9,null),u.localize(10,null)],description:u.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:J.autoFindInSelection,enumDescriptions:[u.localize(12,null),u.localize(13,null),u.localize(14,null)],description:u.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:J.globalFindClipboard,description:u.localize(16,null),included:M.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:J.addExtraSpaceOnTop,description:u.localize(17,null)},"editor.find.loop":{type:"boolean",default:J.loop,description:u.localize(18,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const ge=J;return{cursorMoveOnType:i(ge.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof J.seedSearchStringFromSelection=="boolean"?J.seedSearchStringFromSelection?"always":"never":v(ge.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof J.autoFindInSelection=="boolean"?J.autoFindInSelection?"always":"never":v(ge.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:i(ge.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:i(ge.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:i(ge.loop,this.defaultValue.loop)}}}class R extends A{constructor(){super(44,"fontLigatures",R.OFF,{anyOf:[{type:"boolean",description:u.localize(19,null)},{type:"string",description:u.localize(20,null)}],description:u.localize(21,null),default:!1})}validate(J){return typeof J=="undefined"?this.defaultValue:typeof J=="string"?J==="false"?R.OFF:J==="true"?R.ON:J:Boolean(J)?R.ON:R.OFF}}e.EditorFontLigatures=R,R.OFF='"liga" off, "calt" off',R.ON='"liga" on, "calt" on';class I extends t{constructor(){super(43)}compute(J,ge,$e){return J.fontInfo}}class B extends _{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:u.localize(22,null)})}validate(J){let ge=p.float(J,this.defaultValue);return ge===0?e.EDITOR_FONT_DEFAULTS.fontSize:p.clamp(ge,6,100)}compute(J,ge,$e){return J.fontInfo.fontSize}}class L extends A{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:L.MINIMUM_VALUE,maximum:L.MAXIMUM_VALUE,errorMessage:u.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:L.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:u.localize(24,null)})}validate(J){return J==="normal"||J==="bold"?J:String(f.clampedInt(J,e.EDITOR_FONT_DEFAULTS.fontWeight,L.MINIMUM_VALUE,L.MAXIMUM_VALUE))}}L.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],L.MINIMUM_VALUE=1,L.MAXIMUM_VALUE=1e3;class k extends A{constructor(){const J={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ge={type:"string",enum:["peek","gotoAndPeek","goto"],default:J.multiple,enumDescriptions:[u.localize(25,null),u.localize(26,null),u.localize(27,null)]},$e=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",J,{"editor.gotoLocation.multiple":{deprecationMessage:u.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:u.localize(29,null),...ge},"editor.gotoLocation.multipleTypeDefinitions":{description:u.localize(30,null),...ge},"editor.gotoLocation.multipleDeclarations":{description:u.localize(31,null),...ge},"editor.gotoLocation.multipleImplementations":{description:u.localize(32,null),...ge},"editor.gotoLocation.multipleReferences":{description:u.localize(33,null),...ge},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:J.alternativeDefinitionCommand,enum:$e,description:u.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:J.alternativeTypeDefinitionCommand,enum:$e,description:u.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:J.alternativeDeclarationCommand,enum:$e,description:u.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:J.alternativeImplementationCommand,enum:$e,description:u.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:J.alternativeReferenceCommand,enum:$e,description:u.localize(38,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const ge=J;return{multiple:v(ge.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ge.multipleDefinitions??v(ge.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ge.multipleTypeDefinitions??v(ge.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ge.multipleDeclarations??v(ge.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ge.multipleImplementations??v(ge.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ge.multipleReferences??v(ge.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:S.string(ge.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:S.string(ge.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:S.string(ge.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:S.string(ge.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:S.string(ge.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class x extends A{constructor(){const J={enabled:!0,delay:300,sticky:!0,above:!0};super(52,"hover",J,{"editor.hover.enabled":{type:"boolean",default:J.enabled,description:u.localize(39,null)},"editor.hover.delay":{type:"number",default:J.delay,description:u.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:J.sticky,description:u.localize(41,null)},"editor.hover.above":{type:"boolean",default:J.above,description:u.localize(42,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const ge=J;return{enabled:i(ge.enabled,this.defaultValue.enabled),delay:f.clampedInt(ge.delay,this.defaultValue.delay,0,1e4),sticky:i(ge.sticky,this.defaultValue.sticky),above:i(ge.above,this.defaultValue.above)}}}var N;(function(q){q[q.None=0]="None",q[q.Text=1]="Text",q[q.Blocks=2]="Blocks"})(N=e.RenderMinimap||(e.RenderMinimap={}));class V extends t{constructor(){super(129,[49,57,37,64,91,59,60,93,116,119,120,121,2])}compute(J,ge,$e){return V.computeLayout(ge,{memory:J.memory,outerWidth:J.outerWidth,outerHeight:J.outerHeight,isDominatedByLongLines:J.isDominatedByLongLines,lineHeight:J.fontInfo.lineHeight,viewLineCount:J.viewLineCount,lineNumbersDigitCount:J.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:J.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:J.fontInfo.maxDigitWidth,pixelRatio:J.pixelRatio})}static computeContainedMinimapLineCount(J){const ge=J.height/J.lineHeight,$e=J.scrollBeyondLastLine?ge-1:0,Ge=(J.viewLineCount+$e)/(J.pixelRatio*J.height),rt=Math.floor(J.viewLineCount/Ge);return{typicalViewportLineCount:ge,extraLinesBeyondLastLine:$e,desiredRatio:Ge,minimapLineCount:rt}}static _computeMinimapLayout(J,ge){const $e=J.outerWidth,Ge=J.outerHeight,rt=J.pixelRatio;if(!J.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(rt*Ge),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ge};const ft=ge.stableMinimapLayoutInput,ht=ft&&J.outerHeight===ft.outerHeight&&J.lineHeight===ft.lineHeight&&J.typicalHalfwidthCharacterWidth===ft.typicalHalfwidthCharacterWidth&&J.pixelRatio===ft.pixelRatio&&J.scrollBeyondLastLine===ft.scrollBeyondLastLine&&J.minimap.enabled===ft.minimap.enabled&&J.minimap.side===ft.minimap.side&&J.minimap.size===ft.minimap.size&&J.minimap.showSlider===ft.minimap.showSlider&&J.minimap.renderCharacters===ft.minimap.renderCharacters&&J.minimap.maxColumn===ft.minimap.maxColumn&&J.minimap.scale===ft.minimap.scale&&J.verticalScrollbarWidth===ft.verticalScrollbarWidth&&J.isViewportWrapping===ft.isViewportWrapping,Dt=J.lineHeight,Tt=J.typicalHalfwidthCharacterWidth,It=J.scrollBeyondLastLine,Xe=J.minimap.renderCharacters;let pt=rt>=2?Math.round(J.minimap.scale*2):J.minimap.scale;const Ie=J.minimap.maxColumn,ye=J.minimap.size,De=J.minimap.side,ee=J.verticalScrollbarWidth,oe=J.viewLineCount,fe=J.remainingWidth,he=J.isViewportWrapping,ke=Xe?2:3;let Le=Math.floor(rt*Ge);const Me=Le/rt;let ze=!1,it=!1,Re=ke*pt,ue=pt/rt,me=1;if(ye==="fill"||ye==="fit"){const{typicalViewportLineCount:lt,extraLinesBeyondLastLine:Et,desiredRatio:vt,minimapLineCount:ut}=V.computeContainedMinimapLineCount({viewLineCount:oe,scrollBeyondLastLine:It,height:Ge,lineHeight:Dt,pixelRatio:rt});if(oe/ut>1)ze=!0,it=!0,pt=1,Re=1,ue=pt/rt;else{let dt=!1,Pt=pt+1;if(ye==="fit"){const _t=Math.ceil((oe+Et)*Re);he&&ht&&fe<=ge.stableFitRemainingWidth?(dt=!0,Pt=ge.stableFitMaxMinimapScale):dt=_t>Le}if(ye==="fill"||dt){ze=!0;const _t=pt;Re=Math.min(Dt*rt,Math.max(1,Math.floor(1/vt))),he&&ht&&fe<=ge.stableFitRemainingWidth&&(Pt=ge.stableFitMaxMinimapScale),pt=Math.min(Pt,Math.max(1,Math.floor(Re/ke))),pt>_t&&(me=Math.min(2,pt/_t)),ue=pt/rt/me,Le=Math.ceil(Math.max(lt,oe+Et)*Re),he?(ge.stableMinimapLayoutInput=J,ge.stableFitRemainingWidth=fe,ge.stableFitMaxMinimapScale=pt):(ge.stableMinimapLayoutInput=null,ge.stableFitRemainingWidth=0)}}}const ne=Math.floor(Ie*ue),H=Math.min(ne,Math.max(0,Math.floor((fe-ee-2)*ue/(Tt+ue)))+e.MINIMAP_GUTTER_WIDTH);let ve=Math.floor(rt*H);const Ce=ve/rt;ve=Math.floor(ve*me);const Ke=Xe?1:2,xe=De==="left"?0:$e-H-ee;return{renderMinimap:Ke,minimapLeft:xe,minimapWidth:H,minimapHeightIsEditorHeight:ze,minimapIsSampling:it,minimapScale:pt,minimapLineHeight:Re,minimapCanvasInnerWidth:ve,minimapCanvasInnerHeight:Le,minimapCanvasOuterWidth:Ce,minimapCanvasOuterHeight:Me}}static computeLayout(J,ge){const $e=ge.outerWidth|0,Ge=ge.outerHeight|0,rt=ge.lineHeight|0,ft=ge.lineNumbersDigitCount|0,ht=ge.typicalHalfwidthCharacterWidth,Dt=ge.maxDigitWidth,Tt=ge.pixelRatio,It=ge.viewLineCount,Xe=J.get(121),pt=Xe==="inherit"?J.get(120):Xe,Ie=pt==="inherit"?J.get(116):pt,ye=J.get(119),De=J.get(2),ee=ge.isDominatedByLongLines,oe=J.get(49),fe=J.get(59).renderType!==0,he=J.get(60),ke=J.get(93),Le=J.get(64),Me=J.get(91),ze=Me.verticalScrollbarSize,it=Me.verticalHasArrows,Re=Me.arrowSize,ue=Me.horizontalScrollbarSize,me=J.get(57),ne=J.get(37);let H;if(typeof me=="string"&&/^\d+(\.\d+)?ch$/.test(me)){const St=parseFloat(me.substr(0,me.length-2));H=f.clampedInt(St*ht,0,0,1e3)}else H=f.clampedInt(me,0,0,1e3);ne&&(H+=16);let ve=0;if(fe){const St=Math.max(ft,he);ve=Math.round(St*Dt)}let Ce=0;oe&&(Ce=rt);let Ke=0,xe=Ke+Ce,lt=xe+ve,Et=lt+H;const vt=$e-Ce-ve-H;let ut=!1,gt=!1,dt=-1;De!==2&&(pt==="inherit"&&ee?(ut=!0,gt=!0):Ie==="on"||Ie==="bounded"?gt=!0:Ie==="wordWrapColumn"&&(dt=ye));const Pt=V._computeMinimapLayout({outerWidth:$e,outerHeight:Ge,lineHeight:rt,typicalHalfwidthCharacterWidth:ht,pixelRatio:Tt,scrollBeyondLastLine:ke,minimap:Le,verticalScrollbarWidth:ze,viewLineCount:It,remainingWidth:vt,isViewportWrapping:gt},ge.memory||new C);Pt.renderMinimap!==0&&Pt.minimapLeft===0&&(Ke+=Pt.minimapWidth,xe+=Pt.minimapWidth,lt+=Pt.minimapWidth,Et+=Pt.minimapWidth);const _t=vt-Pt.minimapWidth,$t=Math.max(1,Math.floor((_t-ze-2)/ht)),jt=it?Re:0;return gt&&(dt=Math.max(1,$t),Ie==="bounded"&&(dt=Math.min(dt,ye))),{width:$e,height:Ge,glyphMarginLeft:Ke,glyphMarginWidth:Ce,lineNumbersLeft:xe,lineNumbersWidth:ve,decorationsLeft:lt,decorationsWidth:H,contentLeft:Et,contentWidth:_t,minimap:Pt,viewportColumn:$t,isWordWrapMinified:ut,isViewportWrapping:gt,wrappingColumn:dt,verticalScrollbarWidth:ze,horizontalScrollbarHeight:ue,overviewRuler:{top:jt,width:ze,height:Ge-2*jt,right:0}}}}e.EditorLayoutInfoComputer=V;class W extends A{constructor(){const J={enabled:!0};super(56,"lightbulb",J,{"editor.lightbulb.enabled":{type:"boolean",default:J.enabled,description:u.localize(43,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:i(J.enabled,this.defaultValue.enabled)}}}class $ extends A{constructor(){const J={enabled:!0,fontSize:0,fontFamily:""};super(125,"inlayHints",J,{"editor.inlayHints.enabled":{type:"boolean",default:J.enabled,description:u.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:J.fontSize,markdownDescription:u.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:J.fontFamily,markdownDescription:u.localize(46,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const ge=J;return{enabled:i(ge.enabled,this.defaultValue.enabled),fontSize:f.clampedInt(ge.fontSize,this.defaultValue.fontSize,0,100),fontFamily:S.string(ge.fontFamily,this.defaultValue.fontFamily)}}}class X extends p{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,J=>p.clamp(J,0,150),{markdownDescription:u.localize(47,null)})}compute(J,ge,$e){return J.fontInfo.lineHeight}}class j extends A{constructor(){const J={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",J,{"editor.minimap.enabled":{type:"boolean",default:J.enabled,description:u.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[u.localize(49,null),u.localize(50,null),u.localize(51,null)],default:J.size,description:u.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:J.side,description:u.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:J.showSlider,description:u.localize(54,null)},"editor.minimap.scale":{type:"number",default:J.scale,minimum:1,maximum:3,enum:[1,2,3],description:u.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:J.renderCharacters,description:u.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:J.maxColumn,description:u.localize(57,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const ge=J;return{enabled:i(ge.enabled,this.defaultValue.enabled),size:v(ge.size,this.defaultValue.size,["proportional","fill","fit"]),side:v(ge.side,this.defaultValue.side,["right","left"]),showSlider:v(ge.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:i(ge.renderCharacters,this.defaultValue.renderCharacters),scale:f.clampedInt(ge.scale,1,1,3),maxColumn:f.clampedInt(ge.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Q(q){return q==="ctrlCmd"?M.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ae extends A{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:u.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:u.localize(59,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const ge=J;return{top:f.clampedInt(ge.top,0,0,1e3),bottom:f.clampedInt(ge.bottom,0,0,1e3)}}}class pe extends A{constructor(){const J={enabled:!0,cycle:!1};super(75,"parameterHints",J,{"editor.parameterHints.enabled":{type:"boolean",default:J.enabled,description:u.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:J.cycle,description:u.localize(61,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const ge=J;return{enabled:i(ge.enabled,this.defaultValue.enabled),cycle:i(ge.cycle,this.defaultValue.cycle)}}}class ce extends t{constructor(){super(127)}compute(J,ge,$e){return J.pixelRatio}}class Fe extends A{constructor(){const J={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",J,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:J.strings,description:u.localize(62,null)},comments:{type:"boolean",default:J.comments,description:u.localize(63,null)},other:{type:"boolean",default:J.other,description:u.localize(64,null)}}}],default:J,description:u.localize(65,null)});this.defaultValue=J}validate(J){if(typeof J=="boolean")return J;if(J&&typeof J=="object"){const ge=J,$e={other:i(ge.other,this.defaultValue.other),comments:i(ge.comments,this.defaultValue.comments),strings:i(ge.strings,this.defaultValue.strings)};return $e.other&&$e.comments&&$e.strings?!0:!$e.other&&!$e.comments&&!$e.strings?!1:$e}return this.defaultValue}}var Qe;(function(q){q[q.Off=0]="Off",q[q.On=1]="On",q[q.Relative=2]="Relative",q[q.Interval=3]="Interval",q[q.Custom=4]="Custom"})(Qe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Oe extends A{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[u.localize(66,null),u.localize(67,null),u.localize(68,null),u.localize(69,null)],default:"on",description:u.localize(70,null)})}validate(J){let ge=this.defaultValue.renderType,$e=this.defaultValue.renderFn;return typeof J!="undefined"&&(typeof J=="function"?(ge=4,$e=J):J==="interval"?ge=3:J==="relative"?ge=2:J==="on"?ge=1:ge=0),{renderType:ge,renderFn:$e}}}function He(q){const J=q.get(86);return J==="editable"?q.get(80):J!=="on"}e.filterValidationDecorations=He;class Je extends A{constructor(){const J=[],ge={type:"number",description:u.localize(71,null)};super(90,"rulers",J,{type:"array",items:{anyOf:[ge,{type:["object"],properties:{column:ge,color:{type:"string",description:u.localize(72,null),format:"color-hex"}}}]},default:J,description:u.localize(73,null)})}validate(J){if(Array.isArray(J)){let ge=[];for(let $e of J)if(typeof $e=="number")ge.push({column:f.clampedInt($e,0,0,1e4),color:null});else if($e&&typeof $e=="object"){const Ge=$e;ge.push({column:f.clampedInt(Ge.column,0,0,1e4),color:Ge.color})}return ge.sort(($e,Ge)=>$e.column-Ge.column),ge}return this.defaultValue}}function Ye(q,J){if(typeof q!="string")return J;switch(q){case"hidden":return 2;case"visible":return 3;default:return 1}}class qe extends A{constructor(){const J={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",J,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[u.localize(74,null),u.localize(75,null),u.localize(76,null)],default:"auto",description:u.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[u.localize(78,null),u.localize(79,null),u.localize(80,null)],default:"auto",description:u.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:J.verticalScrollbarSize,description:u.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:J.horizontalScrollbarSize,description:u.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:J.scrollByPage,description:u.localize(84,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const ge=J,$e=f.clampedInt(ge.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ge=f.clampedInt(ge.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:f.clampedInt(ge.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ye(ge.vertical,this.defaultValue.vertical),horizontal:Ye(ge.horizontal,this.defaultValue.horizontal),useShadows:i(ge.useShadows,this.defaultValue.useShadows),verticalHasArrows:i(ge.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:i(ge.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:i(ge.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:i(ge.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:$e,horizontalSliderSize:f.clampedInt(ge.horizontalSliderSize,$e,0,1e3),verticalScrollbarSize:Ge,verticalSliderSize:f.clampedInt(ge.verticalSliderSize,Ge,0,1e3),scrollByPage:i(ge.scrollByPage,this.defaultValue.scrollByPage)}}}class z extends A{constructor(){const J={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",J,{"editor.inlineSuggest.enabled":{type:"boolean",default:J.enabled,description:u.localize(85,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const ge=J;return{enabled:i(ge.enabled,this.defaultValue.enabled),mode:v(ge.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class K extends A{constructor(){const J={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",J,{"editor.bracketPairColorization.enabled":{type:"boolean",default:J.enabled,description:u.localize(86,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:i(J.enabled,this.defaultValue.enabled)}}}class Z extends A{constructor(){const J={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",J,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[u.localize(87,null),u.localize(88,null),u.localize(89,null)],default:J.bracketPairs,description:u.localize(90,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[u.localize(91,null),u.localize(92,null),u.localize(93,null)],default:J.bracketPairsHorizontal,description:u.localize(94,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:J.highlightActiveBracketPair,description:u.localize(95,null)},"editor.guides.indentation":{type:"boolean",default:J.indentation,description:u.localize(96,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:J.highlightActiveIndentation,description:u.localize(97,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const ge=J;return{bracketPairs:se(ge.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:se(ge.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:i(ge.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:i(ge.indentation,this.defaultValue.indentation),highlightActiveIndentation:i(ge.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function se(q,J,ge){const $e=ge.indexOf(q);return $e===-1?J:ge[$e]}class G extends A{constructor(){const J={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",J,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[u.localize(98,null),u.localize(99,null)],default:J.insertMode,description:u.localize(100,null)},"editor.suggest.filterGraceful":{type:"boolean",default:J.filterGraceful,description:u.localize(101,null)},"editor.suggest.localityBonus":{type:"boolean",default:J.localityBonus,description:u.localize(102,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:J.shareSuggestSelections,markdownDescription:u.localize(103,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:J.snippetsPreventQuickSuggestions,description:u.localize(104,null)},"editor.suggest.showIcons":{type:"boolean",default:J.showIcons,description:u.localize(105,null)},"editor.suggest.showStatusBar":{type:"boolean",default:J.showStatusBar,description:u.localize(106,null)},"editor.suggest.preview":{type:"boolean",default:J.preview,description:u.localize(107,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:J.showInlineDetails,description:u.localize(108,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:u.localize(109,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:u.localize(110,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:u.localize(111,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:u.localize(112,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:u.localize(113,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:u.localize(114,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:u.localize(115,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:u.localize(116,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:u.localize(117,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:u.localize(118,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:u.localize(119,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:u.localize(120,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:u.localize(121,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:u.localize(122,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:u.localize(123,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:u.localize(124,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:u.localize(125,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:u.localize(126,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:u.localize(127,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:u.localize(128,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:u.localize(129,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:u.localize(130,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:u.localize(131,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:u.localize(132,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:u.localize(133,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:u.localize(134,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:u.localize(135,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:u.localize(136,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:u.localize(137,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:u.localize(138,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:u.localize(139,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const ge=J;return{insertMode:v(ge.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:i(ge.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:i(ge.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:i(ge.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:i(ge.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:i(ge.showIcons,this.defaultValue.showIcons),showStatusBar:i(ge.showStatusBar,this.defaultValue.showStatusBar),preview:i(ge.preview,this.defaultValue.preview),previewMode:v(ge.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:i(ge.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:i(ge.showMethods,this.defaultValue.showMethods),showFunctions:i(ge.showFunctions,this.defaultValue.showFunctions),showConstructors:i(ge.showConstructors,this.defaultValue.showConstructors),showDeprecated:i(ge.showDeprecated,this.defaultValue.showDeprecated),showFields:i(ge.showFields,this.defaultValue.showFields),showVariables:i(ge.showVariables,this.defaultValue.showVariables),showClasses:i(ge.showClasses,this.defaultValue.showClasses),showStructs:i(ge.showStructs,this.defaultValue.showStructs),showInterfaces:i(ge.showInterfaces,this.defaultValue.showInterfaces),showModules:i(ge.showModules,this.defaultValue.showModules),showProperties:i(ge.showProperties,this.defaultValue.showProperties),showEvents:i(ge.showEvents,this.defaultValue.showEvents),showOperators:i(ge.showOperators,this.defaultValue.showOperators),showUnits:i(ge.showUnits,this.defaultValue.showUnits),showValues:i(ge.showValues,this.defaultValue.showValues),showConstants:i(ge.showConstants,this.defaultValue.showConstants),showEnums:i(ge.showEnums,this.defaultValue.showEnums),showEnumMembers:i(ge.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:i(ge.showKeywords,this.defaultValue.showKeywords),showWords:i(ge.showWords,this.defaultValue.showWords),showColors:i(ge.showColors,this.defaultValue.showColors),showFiles:i(ge.showFiles,this.defaultValue.showFiles),showReferences:i(ge.showReferences,this.defaultValue.showReferences),showFolders:i(ge.showFolders,this.defaultValue.showFolders),showTypeParameters:i(ge.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:i(ge.showSnippets,this.defaultValue.showSnippets),showUsers:i(ge.showUsers,this.defaultValue.showUsers),showIssues:i(ge.showIssues,this.defaultValue.showIssues)}}}class ie extends A{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:u.localize(140,null),default:!0,type:"boolean"}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:i(J.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class de extends t{constructor(){super(128,[80])}compute(J,ge,$e){return ge.get(80)?!0:J.tabFocusMode}}var Pe;(function(q){q[q.None=0]="None",q[q.Same=1]="Same",q[q.Indent=2]="Indent",q[q.DeepIndent=3]="DeepIndent"})(Pe=e.WrappingIndent||(e.WrappingIndent={}));function Ne(q){switch(q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class We extends t{constructor(){super(130,[129])}compute(J,ge,$e){const Ge=ge.get(129);return{isDominatedByLongLines:J.isDominatedByLongLines,isWordWrapMinified:Ge.isWordWrapMinified,isViewportWrapping:Ge.isViewportWrapping,wrappingColumn:Ge.wrappingColumn}}}const je="Consolas, 'Courier New', monospace",et="Menlo, Monaco, 'Courier New', monospace",ot="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:M.isMacintosh?et:M.isLinux?ot:je,fontWeight:"normal",fontSize:M.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function _e(q){return e.editorOptionsRegistry[q.id]=q,q}var nt;(function(q){q[q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",q[q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",q[q.accessibilitySupport=2]="accessibilitySupport",q[q.accessibilityPageSize=3]="accessibilityPageSize",q[q.ariaLabel=4]="ariaLabel",q[q.autoClosingBrackets=5]="autoClosingBrackets",q[q.autoClosingDelete=6]="autoClosingDelete",q[q.autoClosingOvertype=7]="autoClosingOvertype",q[q.autoClosingQuotes=8]="autoClosingQuotes",q[q.autoIndent=9]="autoIndent",q[q.automaticLayout=10]="automaticLayout",q[q.autoSurround=11]="autoSurround",q[q.bracketPairColorization=12]="bracketPairColorization",q[q.guides=13]="guides",q[q.codeLens=14]="codeLens",q[q.codeLensFontFamily=15]="codeLensFontFamily",q[q.codeLensFontSize=16]="codeLensFontSize",q[q.colorDecorators=17]="colorDecorators",q[q.columnSelection=18]="columnSelection",q[q.comments=19]="comments",q[q.contextmenu=20]="contextmenu",q[q.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",q[q.cursorBlinking=22]="cursorBlinking",q[q.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",q[q.cursorStyle=24]="cursorStyle",q[q.cursorSurroundingLines=25]="cursorSurroundingLines",q[q.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",q[q.cursorWidth=27]="cursorWidth",q[q.disableLayerHinting=28]="disableLayerHinting",q[q.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",q[q.domReadOnly=30]="domReadOnly",q[q.dragAndDrop=31]="dragAndDrop",q[q.emptySelectionClipboard=32]="emptySelectionClipboard",q[q.extraEditorClassName=33]="extraEditorClassName",q[q.fastScrollSensitivity=34]="fastScrollSensitivity",q[q.find=35]="find",q[q.fixedOverflowWidgets=36]="fixedOverflowWidgets",q[q.folding=37]="folding",q[q.foldingStrategy=38]="foldingStrategy",q[q.foldingHighlight=39]="foldingHighlight",q[q.foldingImportsByDefault=40]="foldingImportsByDefault",q[q.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",q[q.fontFamily=42]="fontFamily",q[q.fontInfo=43]="fontInfo",q[q.fontLigatures=44]="fontLigatures",q[q.fontSize=45]="fontSize",q[q.fontWeight=46]="fontWeight",q[q.formatOnPaste=47]="formatOnPaste",q[q.formatOnType=48]="formatOnType",q[q.glyphMargin=49]="glyphMargin",q[q.gotoLocation=50]="gotoLocation",q[q.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",q[q.hover=52]="hover",q[q.inDiffEditor=53]="inDiffEditor",q[q.inlineSuggest=54]="inlineSuggest",q[q.letterSpacing=55]="letterSpacing",q[q.lightbulb=56]="lightbulb",q[q.lineDecorationsWidth=57]="lineDecorationsWidth",q[q.lineHeight=58]="lineHeight",q[q.lineNumbers=59]="lineNumbers",q[q.lineNumbersMinChars=60]="lineNumbersMinChars",q[q.linkedEditing=61]="linkedEditing",q[q.links=62]="links",q[q.matchBrackets=63]="matchBrackets",q[q.minimap=64]="minimap",q[q.mouseStyle=65]="mouseStyle",q[q.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",q[q.mouseWheelZoom=67]="mouseWheelZoom",q[q.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",q[q.multiCursorModifier=69]="multiCursorModifier",q[q.multiCursorPaste=70]="multiCursorPaste",q[q.occurrencesHighlight=71]="occurrencesHighlight",q[q.overviewRulerBorder=72]="overviewRulerBorder",q[q.overviewRulerLanes=73]="overviewRulerLanes",q[q.padding=74]="padding",q[q.parameterHints=75]="parameterHints",q[q.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",q[q.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",q[q.quickSuggestions=78]="quickSuggestions",q[q.quickSuggestionsDelay=79]="quickSuggestionsDelay",q[q.readOnly=80]="readOnly",q[q.renameOnType=81]="renameOnType",q[q.renderControlCharacters=82]="renderControlCharacters",q[q.renderFinalNewline=83]="renderFinalNewline",q[q.renderLineHighlight=84]="renderLineHighlight",q[q.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",q[q.renderValidationDecorations=86]="renderValidationDecorations",q[q.renderWhitespace=87]="renderWhitespace",q[q.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",q[q.roundedSelection=89]="roundedSelection",q[q.rulers=90]="rulers",q[q.scrollbar=91]="scrollbar",q[q.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",q[q.scrollBeyondLastLine=93]="scrollBeyondLastLine",q[q.scrollPredominantAxis=94]="scrollPredominantAxis",q[q.selectionClipboard=95]="selectionClipboard",q[q.selectionHighlight=96]="selectionHighlight",q[q.selectOnLineNumbers=97]="selectOnLineNumbers",q[q.showFoldingControls=98]="showFoldingControls",q[q.showUnused=99]="showUnused",q[q.snippetSuggestions=100]="snippetSuggestions",q[q.smartSelect=101]="smartSelect",q[q.smoothScrolling=102]="smoothScrolling",q[q.stickyTabStops=103]="stickyTabStops",q[q.stopRenderingLineAfter=104]="stopRenderingLineAfter",q[q.suggest=105]="suggest",q[q.suggestFontSize=106]="suggestFontSize",q[q.suggestLineHeight=107]="suggestLineHeight",q[q.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",q[q.suggestSelection=109]="suggestSelection",q[q.tabCompletion=110]="tabCompletion",q[q.tabIndex=111]="tabIndex",q[q.unusualLineTerminators=112]="unusualLineTerminators",q[q.useShadowDOM=113]="useShadowDOM",q[q.useTabStops=114]="useTabStops",q[q.wordSeparators=115]="wordSeparators",q[q.wordWrap=116]="wordWrap",q[q.wordWrapBreakAfterCharacters=117]="wordWrapBreakAfterCharacters",q[q.wordWrapBreakBeforeCharacters=118]="wordWrapBreakBeforeCharacters",q[q.wordWrapColumn=119]="wordWrapColumn",q[q.wordWrapOverride1=120]="wordWrapOverride1",q[q.wordWrapOverride2=121]="wordWrapOverride2",q[q.wrappingIndent=122]="wrappingIndent",q[q.wrappingStrategy=123]="wrappingStrategy",q[q.showDeprecated=124]="showDeprecated",q[q.inlayHints=125]="inlayHints",q[q.editorClassName=126]="editorClassName",q[q.pixelRatio=127]="pixelRatio",q[q.tabFocusMode=128]="tabFocusMode",q[q.layoutInfo=129]="layoutInfo",q[q.wrappingInfo=130]="wrappingInfo"})(nt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:_e(new m(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:u.localize(141,null)})),acceptSuggestionOnEnter:_e(new o(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",u.localize(142,null),""],markdownDescription:u.localize(143,null)})),accessibilitySupport:_e(new r),accessibilityPageSize:_e(new f(3,"accessibilityPageSize",10,1,1073741824,{description:u.localize(144,null)})),ariaLabel:_e(new S(4,"ariaLabel",u.localize(145,null))),autoClosingBrackets:_e(new o(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",u.localize(146,null),u.localize(147,null),""],description:u.localize(148,null)})),autoClosingDelete:_e(new o(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",u.localize(149,null),""],description:u.localize(150,null)})),autoClosingOvertype:_e(new o(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",u.localize(151,null),""],description:u.localize(152,null)})),autoClosingQuotes:_e(new o(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",u.localize(153,null),u.localize(154,null),""],description:u.localize(155,null)})),autoIndent:_e(new d(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],D,{enumDescriptions:[u.localize(156,null),u.localize(157,null),u.localize(158,null),u.localize(159,null),u.localize(160,null)],description:u.localize(161,null)})),automaticLayout:_e(new m(10,"automaticLayout",!1)),autoSurround:_e(new o(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[u.localize(162,null),u.localize(163,null),u.localize(164,null),""],description:u.localize(165,null)})),bracketPairColorization:_e(new K),bracketPairGuides:_e(new Z),stickyTabStops:_e(new m(103,"stickyTabStops",!1,{description:u.localize(166,null)})),codeLens:_e(new m(14,"codeLens",!0,{description:u.localize(167,null)})),codeLensFontFamily:_e(new S(15,"codeLensFontFamily","",{description:u.localize(168,null)})),codeLensFontSize:_e(new f(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:u.localize(169,null)})),colorDecorators:_e(new m(17,"colorDecorators",!0,{description:u.localize(170,null)})),columnSelection:_e(new m(18,"columnSelection",!1,{description:u.localize(171,null)})),comments:_e(new w),contextmenu:_e(new m(20,"contextmenu",!0)),copyWithSyntaxHighlighting:_e(new m(21,"copyWithSyntaxHighlighting",!0,{description:u.localize(172,null)})),cursorBlinking:_e(new d(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],n,{description:u.localize(173,null)})),cursorSmoothCaretAnimation:_e(new m(23,"cursorSmoothCaretAnimation",!1,{description:u.localize(174,null)})),cursorStyle:_e(new d(24,"cursorStyle",g.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],c,{description:u.localize(175,null)})),cursorSurroundingLines:_e(new f(25,"cursorSurroundingLines",0,0,1073741824,{description:u.localize(176,null)})),cursorSurroundingLinesStyle:_e(new o(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[u.localize(177,null),u.localize(178,null)],description:u.localize(179,null)})),cursorWidth:_e(new f(27,"cursorWidth",0,0,1073741824,{markdownDescription:u.localize(180,null)})),disableLayerHinting:_e(new m(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:_e(new m(29,"disableMonospaceOptimizations",!1)),domReadOnly:_e(new m(30,"domReadOnly",!1)),dragAndDrop:_e(new m(31,"dragAndDrop",!0,{description:u.localize(181,null)})),emptySelectionClipboard:_e(new h),extraEditorClassName:_e(new S(33,"extraEditorClassName","")),fastScrollSensitivity:_e(new p(34,"fastScrollSensitivity",5,q=>q<=0?5:q,{markdownDescription:u.localize(182,null)})),find:_e(new y),fixedOverflowWidgets:_e(new m(36,"fixedOverflowWidgets",!1)),folding:_e(new m(37,"folding",!0,{description:u.localize(183,null)})),foldingStrategy:_e(new o(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[u.localize(184,null),u.localize(185,null)],description:u.localize(186,null)})),foldingHighlight:_e(new m(39,"foldingHighlight",!0,{description:u.localize(187,null)})),foldingImportsByDefault:_e(new m(40,"foldingImportsByDefault",!1,{description:u.localize(188,null)})),unfoldOnClickAfterEndOfLine:_e(new m(41,"unfoldOnClickAfterEndOfLine",!1,{description:u.localize(189,null)})),fontFamily:_e(new S(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:u.localize(190,null)})),fontInfo:_e(new I),fontLigatures2:_e(new R),fontSize:_e(new B),fontWeight:_e(new L),formatOnPaste:_e(new m(47,"formatOnPaste",!1,{description:u.localize(191,null)})),formatOnType:_e(new m(48,"formatOnType",!1,{description:u.localize(192,null)})),glyphMargin:_e(new m(49,"glyphMargin",!0,{description:u.localize(193,null)})),gotoLocation:_e(new k),hideCursorInOverviewRuler:_e(new m(51,"hideCursorInOverviewRuler",!1,{description:u.localize(194,null)})),hover:_e(new x),inDiffEditor:_e(new m(53,"inDiffEditor",!1)),letterSpacing:_e(new p(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,q=>p.clamp(q,-5,20),{description:u.localize(195,null)})),lightbulb:_e(new W),lineDecorationsWidth:_e(new _(57,"lineDecorationsWidth",10)),lineHeight:_e(new X),lineNumbers:_e(new Oe),lineNumbersMinChars:_e(new f(60,"lineNumbersMinChars",5,1,300)),linkedEditing:_e(new m(61,"linkedEditing",!1,{description:u.localize(196,null)})),links:_e(new m(62,"links",!0,{description:u.localize(197,null)})),matchBrackets:_e(new o(63,"matchBrackets","always",["always","near","never"],{description:u.localize(198,null)})),minimap:_e(new j),mouseStyle:_e(new o(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:_e(new p(66,"mouseWheelScrollSensitivity",1,q=>q===0?1:q,{markdownDescription:u.localize(199,null)})),mouseWheelZoom:_e(new m(67,"mouseWheelZoom",!1,{markdownDescription:u.localize(200,null)})),multiCursorMergeOverlapping:_e(new m(68,"multiCursorMergeOverlapping",!0,{description:u.localize(201,null)})),multiCursorModifier:_e(new d(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Q,{markdownEnumDescriptions:[u.localize(202,null),u.localize(203,null)],markdownDescription:u.localize(204,null)})),multiCursorPaste:_e(new o(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[u.localize(205,null),u.localize(206,null)],markdownDescription:u.localize(207,null)})),occurrencesHighlight:_e(new m(71,"occurrencesHighlight",!0,{description:u.localize(208,null)})),overviewRulerBorder:_e(new m(72,"overviewRulerBorder",!0,{description:u.localize(209,null)})),overviewRulerLanes:_e(new f(73,"overviewRulerLanes",3,0,3)),padding:_e(new ae),parameterHints:_e(new pe),peekWidgetDefaultFocus:_e(new o(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[u.localize(210,null),u.localize(211,null)],description:u.localize(212,null)})),definitionLinkOpensInPeek:_e(new m(77,"definitionLinkOpensInPeek",!1,{description:u.localize(213,null)})),quickSuggestions:_e(new Fe),quickSuggestionsDelay:_e(new f(79,"quickSuggestionsDelay",10,0,1073741824,{description:u.localize(214,null)})),readOnly:_e(new m(80,"readOnly",!1)),renameOnType:_e(new m(81,"renameOnType",!1,{description:u.localize(215,null),markdownDeprecationMessage:u.localize(216,null)})),renderControlCharacters:_e(new m(82,"renderControlCharacters",!0,{description:u.localize(217,null),restricted:!0})),renderFinalNewline:_e(new m(83,"renderFinalNewline",!0,{description:u.localize(218,null)})),renderLineHighlight:_e(new o(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",u.localize(219,null)],description:u.localize(220,null)})),renderLineHighlightOnlyWhenFocus:_e(new m(85,"renderLineHighlightOnlyWhenFocus",!1,{description:u.localize(221,null)})),renderValidationDecorations:_e(new o(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:_e(new o(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",u.localize(222,null),u.localize(223,null),u.localize(224,null),""],description:u.localize(225,null)})),revealHorizontalRightPadding:_e(new f(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:_e(new m(89,"roundedSelection",!0,{description:u.localize(226,null)})),rulers:_e(new Je),scrollbar:_e(new qe),scrollBeyondLastColumn:_e(new f(92,"scrollBeyondLastColumn",5,0,1073741824,{description:u.localize(227,null)})),scrollBeyondLastLine:_e(new m(93,"scrollBeyondLastLine",!0,{description:u.localize(228,null)})),scrollPredominantAxis:_e(new m(94,"scrollPredominantAxis",!0,{description:u.localize(229,null)})),selectionClipboard:_e(new m(95,"selectionClipboard",!0,{description:u.localize(230,null),included:M.isLinux})),selectionHighlight:_e(new m(96,"selectionHighlight",!0,{description:u.localize(231,null)})),selectOnLineNumbers:_e(new m(97,"selectOnLineNumbers",!0)),showFoldingControls:_e(new o(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[u.localize(232,null),u.localize(233,null)],description:u.localize(234,null)})),showUnused:_e(new m(99,"showUnused",!0,{description:u.localize(235,null)})),showDeprecated:_e(new m(124,"showDeprecated",!0,{description:u.localize(236,null)})),inlayHints:_e(new $),snippetSuggestions:_e(new o(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[u.localize(237,null),u.localize(238,null),u.localize(239,null),u.localize(240,null)],description:u.localize(241,null)})),smartSelect:_e(new ie),smoothScrolling:_e(new m(102,"smoothScrolling",!1,{description:u.localize(242,null)})),stopRenderingLineAfter:_e(new f(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:_e(new G),inlineSuggest:_e(new z),suggestFontSize:_e(new f(106,"suggestFontSize",0,0,1e3,{markdownDescription:u.localize(243,null)})),suggestLineHeight:_e(new f(107,"suggestLineHeight",0,0,1e3,{markdownDescription:u.localize(244,null)})),suggestOnTriggerCharacters:_e(new m(108,"suggestOnTriggerCharacters",!0,{description:u.localize(245,null)})),suggestSelection:_e(new o(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[u.localize(246,null),u.localize(247,null),u.localize(248,null)],description:u.localize(249,null)})),tabCompletion:_e(new o(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[u.localize(250,null),u.localize(251,null),u.localize(252,null)],description:u.localize(253,null)})),tabIndex:_e(new f(111,"tabIndex",0,-1,1073741824)),unusualLineTerminators:_e(new o(112,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[u.localize(254,null),u.localize(255,null),u.localize(256,null)],description:u.localize(257,null)})),useShadowDOM:_e(new m(113,"useShadowDOM",!0)),useTabStops:_e(new m(114,"useTabStops",!0,{description:u.localize(258,null)})),wordSeparators:_e(new S(115,"wordSeparators",E.USUAL_WORD_SEPARATORS,{description:u.localize(259,null)})),wordWrap:_e(new o(116,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[u.localize(260,null),u.localize(261,null),u.localize(262,null),u.localize(263,null)],description:u.localize(264,null)})),wordWrapBreakAfterCharacters:_e(new S(117,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:_e(new S(118,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:_e(new f(119,"wordWrapColumn",80,1,1073741824,{markdownDescription:u.localize(265,null)})),wordWrapOverride1:_e(new o(120,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:_e(new o(121,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:_e(new d(122,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Ne,{enumDescriptions:[u.localize(266,null),u.localize(267,null),u.localize(268,null),u.localize(269,null)],description:u.localize(270,null)})),wrappingStrategy:_e(new o(123,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[u.localize(271,null),u.localize(272,null)],description:u.localize(273,null)})),editorClassName:_e(new b),pixelRatio:_e(new ce),tabFocusMode:_e(new de),layoutInfo:_e(new V),wrappingInfo:_e(new We)}}),define(we[120],be([18,19]),function(re,e){return re.create("vs/platform/configuration/common/configurationRegistry",e)}),define(we[121],be([18,19]),function(re,e){return re.create("vs/platform/extensions/common/extensionValidator",e)}),define(we[122],be([18,19]),function(re,e){return re.create("vs/platform/files/common/files",e)}),define(we[123],be([18,19]),function(re,e){return re.create("vs/platform/markers/common/markers",e)}),define(we[124],be([18,19]),function(re,e){return re.create("vs/platform/theme/common/iconRegistry",e)}),define(we[125],be([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(we[126],be([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostExtensionService",e)}),define(we[127],be([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostProgress",e)}),define(we[128],be([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostStatusBar",e)}),define(we[129],be([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostTerminalService",e)}),define(we[130],be([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostTreeViews",e)}),define(we[131],be([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostWorkspace",e)}),define(we[132],be([18,19]),function(re,e){return re.create("vs/workbench/common/editor",e)}),define(we[133],be([18,19]),function(re,e){return re.create("vs/workbench/common/views",e)}),define(we[134],be([18,19]),function(re,e){return re.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(we[135],be([18,19]),function(re,e){return re.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(we[136],be([18,19]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(we[137],be([18,19]),function(re,e){return re.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(we[138],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var u;(function(F){F[F.ACTIVATE=1]="ACTIVATE",F[F.RESTORE=2]="RESTORE",F[F.PRESERVE=3]="PRESERVE"})(u=e.EditorActivation||(e.EditorActivation={}));var M;(function(F){F[F.PICK=0]="PICK",F[F.DISABLED=1]="DISABLED",F[F.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(M=e.EditorResolution||(e.EditorResolution={}));var E;(function(F){F[F.API=0]="API",F[F.USER=1]="USER"})(E=e.EditorOpenContext||(e.EditorOpenContext={}));var P;(function(F){F[F.Center=0]="Center",F[F.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",F[F.NearTop=2]="NearTop",F[F.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(P=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(we[139],be([0,1,121]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function P(i){return i=i.trim(),i==="*"||M.test(i)}e.isValidVersionStr=P;function F(i){if(!P(i))return null;if(i=i.trim(),i==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let m=i.match(M);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=F;function T(i){if(!i)return null;let m=i.majorBase,a=i.majorMustEqual,f=i.minorBase,p=i.minorMustEqual,S=i.patchBase,v=i.patchMustEqual;i.hasCaret&&(m===0||(p=!1),v=!1);let o=0;if(i.preRelease){const d=E.exec(i.preRelease);if(d){const[,D,r,w]=d;o=Date.UTC(Number(D),Number(r)-1,Number(w))}}return{majorBase:m,majorMustEqual:a,minorBase:f,minorMustEqual:p,patchBase:S,patchMustEqual:v,isMinimum:i.hasGreaterEquals,notBefore:o}}e.normalizeVersion=T;function C(i,m,a){let f;typeof i=="string"?f=T(F(i)):f=i;let p;m instanceof Date?p=m.getTime():typeof m=="string"&&(p=new Date(m).getTime());let S;if(typeof a=="string"?S=T(F(a)):S=a,!f||!S)return!1;let v=f.majorBase,o=f.minorBase,d=f.patchBase,D=S.majorBase,r=S.minorBase,w=S.patchBase,s=S.notBefore,n=S.majorMustEqual,g=S.minorMustEqual,l=S.patchMustEqual;return S.isMinimum?v>D?!0:v<D?!1:o>r?!0:o<r||p&&p<s?!1:d>=w:(v===1&&D===0&&(!n||!g||!l)&&(D=1,r=0,w=0,n=!0,g=!1,l=!1),v<D?!1:v>D?!n:o<r?!1:o>r?!g:d<w?!1:d>w?!l:!(p&&p<s))}e.isValidVersion=C;function A(i,m,a,f){return a.isBuiltin||typeof a.main=="undefined"?!0:_(i,m,a.engines.vscode,f)}e.isValidExtensionVersion=A;function t(i,m,a){return i==="*"||_(m,a,i)}e.isEngineValid=t;function _(i,m,a,f=[]){let p=T(F(a));if(!p)return f.push(u.localize(0,null,a)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return f.push(u.localize(1,null,a)),!1}else if(!p.majorMustEqual)return f.push(u.localize(2,null,a)),!1;return C(i,m,p)?!0:(f.push(u.localize(3,null,i,a)),!1)}}),define(we[82],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class u{constructor(E,P=[],F=!1){this.ctor=E,this.staticArguments=P,this.supportsDelayedInstantiation=F}}e.SyncDescriptor=u}),define(we[59],be([0,1,82]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const M=[];function E(F,T,C){T instanceof u.SyncDescriptor||(T=new u.SyncDescriptor(T,[],C)),M.push([F,T])}e.registerSingleton=E;function P(){return M}e.getSingletonServiceDescriptors=P}),define(we[140],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class u{constructor(P){this.incoming=new Map,this.outgoing=new Map,this.data=P}}e.Node=u;class M{constructor(P){this._hashFn=P,this._nodes=new Map}roots(){const P=[];for(let F of this._nodes.values())F.outgoing.size===0&&P.push(F);return P}insertEdge(P,F){const T=this.lookupOrInsertNode(P),C=this.lookupOrInsertNode(F);T.outgoing.set(this._hashFn(F),C),C.incoming.set(this._hashFn(P),T)}removeNode(P){const F=this._hashFn(P);this._nodes.delete(F);for(let T of this._nodes.values())T.outgoing.delete(F),T.incoming.delete(F)}lookupOrInsertNode(P){const F=this._hashFn(P);let T=this._nodes.get(F);return T||(T=new u(P),this._nodes.set(F,T)),T}lookup(P){return this._nodes.get(this._hashFn(P))}isEmpty(){return this._nodes.size===0}toString(){let P=[];for(let[F,T]of this._nodes)P.push(`${F}, (incoming)[${[...T.incoming.keys()].join(", ")}], (outgoing)[${[...T.outgoing.keys()].join(",")}]`);return P.join(`
`)}findCycleSlow(){for(let[P,F]of this._nodes){const T=new Set([P]),C=this._findCycle(F,T);if(C)return C}}_findCycle(P,F){for(let[T,C]of P.outgoing){if(F.has(T))return[...F,T].join(" -> ");F.add(T);const A=this._findCycle(C,F);if(A)return A;F.delete(T)}}}e.Graph=M}),define(we[4],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var u;(function(F){F.serviceIds=new Map,F.DI_TARGET="$di$target",F.DI_DEPENDENCIES="$di$dependencies";function T(C){return C[F.DI_DEPENDENCIES]||[]}F.getServiceDependencies=T})(u=e._util||(e._util={})),e.IInstantiationService=E("instantiationService");function M(F,T,C,A){T[u.DI_TARGET]===T?T[u.DI_DEPENDENCIES].push({id:F,index:C,optional:A}):(T[u.DI_DEPENDENCIES]=[{id:F,index:C,optional:A}],T[u.DI_TARGET]=T)}function E(F){if(u.serviceIds.has(F))return u.serviceIds.get(F);const T=function(C,A,t){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(T,C,t,!1)};return T.toString=()=>F,u.serviceIds.set(F,T),T}e.createDecorator=E;function P(F){return F}e.refineServiceDecorator=P}),define(we[141],be([0,1,4]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,u.createDecorator)("modelService");function M(E){return!E.isTooLargeForSyncing()&&!E.isForSimpleWidget}e.shouldSynchronizeModel=M}),define(we[142],be([0,1,3,60,6,20,76,58,141]),function(re,e,u,M,E,P,F,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function A(f){return typeof f=="string"?!1:Array.isArray(f)?f.every(A):!!f.exclusive}class t{constructor(){this._clock=0,this._entries=[],this._onDidChange=new u.Emitter}get onDidChange(){return this._onDidChange.event}register(p,S){let v={selector:p,provider:S,_score:-1,_time:this._clock++};return this._entries.push(v),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,E.toDisposable)(()=>{if(v){let o=this._entries.indexOf(v);o>=0&&(this._entries.splice(o,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),v=void 0)}})}has(p){return this.all(p).length>0}all(p){if(!p)return[];this._updateScores(p);const S=[];for(let v of this._entries)v._score>0&&S.push(v.provider);return S}ordered(p){const S=[];return this._orderedForEach(p,v=>S.push(v.provider)),S}orderedGroups(p){const S=[];let v,o;return this._orderedForEach(p,d=>{v&&o===d._score?v.push(d.provider):(o=d._score,v=[d.provider],S.push(v))}),S}_orderedForEach(p,S){if(!!p){this._updateScores(p);for(const v of this._entries)v._score>0&&S(v)}}_updateScores(p){let S={uri:p.uri.toString(),language:p.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===S.language&&this._lastCandidate.uri===S.uri)){this._lastCandidate=S;for(let v of this._entries)if(v._score=(0,T.score)(v.selector,p.uri,p.getLanguageId(),(0,C.shouldSynchronizeModel)(p)),A(v.selector)&&v._score>0){for(let o of this._entries)o._score=0;v._score=1e3;break}this._entries.sort(t._compareByScoreAndTime)}}static _compareByScoreAndTime(p,S){return p._score<S._score?1:p._score>S._score?-1:p._time<S._time?1:p._time>S._time?-1:0}}e.LanguageFeatureRegistry=t;const _=new WeakMap;let i=0;function m(f){let p=_.get(f);return p===void 0&&(p=++i,_.set(f,p)),p}class a{constructor(p,S,v=Number.MAX_SAFE_INTEGER){this._registry=p,this.min=S,this.max=v,this._cache=new P.LRUCache(50,.7)}_key(p){return p.id+this._registry.all(p).reduce((S,v)=>(0,M.doHash)(m(v),S),0)}_clamp(p){return p===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(p*1.3)))}get(p){const S=this._key(p),v=this._cache.get(S);return this._clamp(v?.value)}update(p,S){const v=this._key(p);let o=this._cache.get(v);return o||(o=new F.MovingAverage,this._cache.set(v,o)),o.update(S),this.get(p)}}e.LanguageFeatureRequestDelays=a}),define(we[61],be([0,1,2,45,142,113,35]),function(re,e,u,M,E,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var T;(function(h){h[h.Null=0]="Null",h[h.PlainText=1]="PlainText"})(T=e.LanguageId||(e.LanguageId={}));var C;(function(h){h[h.NotSet=-1]="NotSet",h[h.None=0]="None",h[h.Italic=1]="Italic",h[h.Bold=2]="Bold",h[h.Underline=4]="Underline"})(C=e.FontStyle||(e.FontStyle={}));var A;(function(h){h[h.None=0]="None",h[h.DefaultForeground=1]="DefaultForeground",h[h.DefaultBackground=2]="DefaultBackground"})(A=e.ColorId||(e.ColorId={}));var t;(function(h){h[h.Other=0]="Other",h[h.Comment=1]="Comment",h[h.String=2]="String",h[h.RegEx=4]="RegEx"})(t=e.StandardTokenType||(e.StandardTokenType={}));var _;(function(h){h[h.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",h[h.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",h[h.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",h[h.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",h[h.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",h[h.ITALIC_MASK=2048]="ITALIC_MASK",h[h.BOLD_MASK=4096]="BOLD_MASK",h[h.UNDERLINE_MASK=8192]="UNDERLINE_MASK",h[h.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",h[h.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",h[h.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",h[h.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",h[h.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",h[h.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",h[h.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",h[h.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",h[h.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",h[h.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(_=e.MetadataConsts||(e.MetadataConsts={}));class i{static getLanguageId(y){return(y&255)>>>0}static getTokenType(y){return(y&1792)>>>8}static getFontStyle(y){return(y&14336)>>>11}static getForeground(y){return(y&8372224)>>>14}static getBackground(y){return(y&4286578688)>>>23}static getClassNameFromMetadata(y){let R=this.getForeground(y),I="mtk"+R,B=this.getFontStyle(y);return B&1&&(I+=" mtki"),B&2&&(I+=" mtkb"),B&4&&(I+=" mtku"),I}static getInlineStyleFromMetadata(y,R){const I=this.getForeground(y),B=this.getFontStyle(y);let L=`color: ${R[I]};`;return B&1&&(L+="font-style: italic;"),B&2&&(L+="font-weight: bold;"),B&4&&(L+="text-decoration: underline;"),L}}e.TokenMetadata=i;var m;(function(h){h[h.Method=0]="Method",h[h.Function=1]="Function",h[h.Constructor=2]="Constructor",h[h.Field=3]="Field",h[h.Variable=4]="Variable",h[h.Class=5]="Class",h[h.Struct=6]="Struct",h[h.Interface=7]="Interface",h[h.Module=8]="Module",h[h.Property=9]="Property",h[h.Event=10]="Event",h[h.Operator=11]="Operator",h[h.Unit=12]="Unit",h[h.Value=13]="Value",h[h.Constant=14]="Constant",h[h.Enum=15]="Enum",h[h.EnumMember=16]="EnumMember",h[h.Keyword=17]="Keyword",h[h.Text=18]="Text",h[h.Color=19]="Color",h[h.File=20]="File",h[h.Reference=21]="Reference",h[h.Customcolor=22]="Customcolor",h[h.Folder=23]="Folder",h[h.TypeParameter=24]="TypeParameter",h[h.User=25]="User",h[h.Issue=26]="Issue",h[h.Snippet=27]="Snippet"})(m=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let h=Object.create(null);return h[0]="symbol-method",h[1]="symbol-function",h[2]="symbol-constructor",h[3]="symbol-field",h[4]="symbol-variable",h[5]="symbol-class",h[6]="symbol-struct",h[7]="symbol-interface",h[8]="symbol-module",h[9]="symbol-property",h[10]="symbol-event",h[11]="symbol-operator",h[12]="symbol-unit",h[13]="symbol-value",h[14]="symbol-constant",h[15]="symbol-enum",h[16]="symbol-enum-member",h[17]="symbol-keyword",h[27]="symbol-snippet",h[18]="symbol-text",h[19]="symbol-color",h[20]="symbol-file",h[21]="symbol-reference",h[22]="symbol-customcolor",h[23]="symbol-folder",h[24]="symbol-type-parameter",h[25]="account",h[26]="issues",function(y){const R=h[y];let I=R&&F.iconRegistry.get(R);return I||(console.info("No codicon found for CompletionItemKind "+y),I=F.Codicon.symbolProperty),I.classNames}}(),e.completionKindFromString=function(){let h=Object.create(null);return h.method=0,h.function=1,h.constructor=2,h.field=3,h.variable=4,h.class=5,h.struct=6,h.interface=7,h.module=8,h.property=9,h.event=10,h.operator=11,h.unit=12,h.value=13,h.constant=14,h.enum=15,h["enum-member"]=16,h.enumMember=16,h.keyword=17,h.snippet=27,h.text=18,h.color=19,h.file=20,h.reference=21,h.customcolor=22,h.folder=23,h["type-parameter"]=24,h.typeParameter=24,h.account=25,h.issue=26,function(y,R){let I=h[y];return typeof I=="undefined"&&!R&&(I=9),I}}();var a;(function(h){h[h.Deprecated=1]="Deprecated"})(a=e.CompletionItemTag||(e.CompletionItemTag={}));var f;(function(h){h[h.KeepWhitespace=1]="KeepWhitespace",h[h.InsertAsSnippet=4]="InsertAsSnippet"})(f=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var p;(function(h){h[h.Invoke=0]="Invoke",h[h.TriggerCharacter=1]="TriggerCharacter",h[h.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(p=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var S;(function(h){h[h.Automatic=0]="Automatic",h[h.Explicit=1]="Explicit"})(S=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var v;(function(h){h[h.Invoke=1]="Invoke",h[h.Auto=2]="Auto"})(v=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var o;(function(h){h[h.Invoke=1]="Invoke",h[h.TriggerCharacter=2]="TriggerCharacter",h[h.ContentChange=3]="ContentChange"})(o=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var d;(function(h){h[h.Text=0]="Text",h[h.Read=1]="Read",h[h.Write=2]="Write"})(d=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function D(h){return h&&u.URI.isUri(h.uri)&&M.Range.isIRange(h.range)&&(M.Range.isIRange(h.originSelectionRange)||M.Range.isIRange(h.targetSelectionRange))}e.isLocationLink=D;var r;(function(h){h[h.File=0]="File",h[h.Module=1]="Module",h[h.Namespace=2]="Namespace",h[h.Package=3]="Package",h[h.Class=4]="Class",h[h.Method=5]="Method",h[h.Property=6]="Property",h[h.Field=7]="Field",h[h.Constructor=8]="Constructor",h[h.Enum=9]="Enum",h[h.Interface=10]="Interface",h[h.Function=11]="Function",h[h.Variable=12]="Variable",h[h.Constant=13]="Constant",h[h.String=14]="String",h[h.Number=15]="Number",h[h.Boolean=16]="Boolean",h[h.Array=17]="Array",h[h.Object=18]="Object",h[h.Key=19]="Key",h[h.Null=20]="Null",h[h.EnumMember=21]="EnumMember",h[h.Struct=22]="Struct",h[h.Event=23]="Event",h[h.Operator=24]="Operator",h[h.TypeParameter=25]="TypeParameter"})(r=e.SymbolKind||(e.SymbolKind={}));var w;(function(h){h[h.Deprecated=1]="Deprecated"})(w=e.SymbolTag||(e.SymbolTag={}));var s;(function(h){const y=new Map;y.set("file",0),y.set("module",1),y.set("namespace",2),y.set("package",3),y.set("class",4),y.set("method",5),y.set("property",6),y.set("field",7),y.set("constructor",8),y.set("enum",9),y.set("interface",10),y.set("function",11),y.set("variable",12),y.set("constant",13),y.set("string",14),y.set("number",15),y.set("boolean",16),y.set("array",17),y.set("object",18),y.set("key",19),y.set("null",20),y.set("enum-member",21),y.set("struct",22),y.set("event",23),y.set("operator",24),y.set("type-parameter",25);const R=new Map;R.set(0,"file"),R.set(1,"module"),R.set(2,"namespace"),R.set(3,"package"),R.set(4,"class"),R.set(5,"method"),R.set(6,"property"),R.set(7,"field"),R.set(8,"constructor"),R.set(9,"enum"),R.set(10,"interface"),R.set(11,"function"),R.set(12,"variable"),R.set(13,"constant"),R.set(14,"string"),R.set(15,"number"),R.set(16,"boolean"),R.set(17,"array"),R.set(18,"object"),R.set(19,"key"),R.set(20,"null"),R.set(21,"enum-member"),R.set(22,"struct"),R.set(23,"event"),R.set(24,"operator"),R.set(25,"type-parameter");function I(k){return y.get(k)}h.fromString=I;function B(k){return R.get(k)}h.toString=B;function L(k,x){const N=R.get(k);let V=N&&F.iconRegistry.get("symbol-"+N);return V||(console.info("No codicon found for SymbolKind "+k),V=F.Codicon.symbolProperty),`${x?"inline":"block"} ${V.classNames}`}h.toCssClassName=L})(s=e.SymbolKinds||(e.SymbolKinds={}));class n{constructor(y){this.value=y}}e.FoldingRangeKind=n,n.Comment=new n("comment"),n.Imports=new n("imports"),n.Region=new n("region");var g;(function(h){h[h.Collapsed=0]="Collapsed",h[h.Expanded=1]="Expanded"})(g=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var l;(function(h){h[h.Editing=0]="Editing",h[h.Preview=1]="Preview"})(l=e.CommentMode||(e.CommentMode={}));var c;(function(h){h[h.Other=0]="Other",h[h.Type=1]="Type",h[h.Parameter=2]="Parameter"})(c=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new E.LanguageFeatureRegistry,e.RenameProviderRegistry=new E.LanguageFeatureRegistry,e.CompletionProviderRegistry=new E.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new E.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new E.LanguageFeatureRegistry,e.HoverProviderRegistry=new E.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new E.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new E.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new E.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new E.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new E.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new E.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new E.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new E.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new E.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.LinkProviderRegistry=new E.LanguageFeatureRegistry,e.ColorProviderRegistry=new E.LanguageFeatureRegistry,e.SelectionRangeRegistry=new E.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new E.LanguageFeatureRegistry,e.TokenizationRegistry=new P.TokenizationRegistryImpl;var b;(function(h){h[h.None=0]="None",h[h.Option=1]="Option",h[h.Default=2]="Default",h[h.Preferred=3]="Preferred"})(b=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(we[38],be([0,1,25,9,4]),function(re,e,u,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let P=u.userAgent||"";const F=new Map;F.set("false",!1),F.set("true",!0),F.set("isMac",u.isMacintosh),F.set("isLinux",u.isLinux),F.set("isWindows",u.isWindows),F.set("isWeb",u.isWeb),F.set("isMacNative",u.isMacintosh&&!u.isWeb),F.set("isEdge",P.indexOf("Edg/")>=0),F.set("isFirefox",P.indexOf("Firefox")>=0),F.set("isChrome",P.indexOf("Chrome")>=0),F.set("isSafari",P.indexOf("Safari")>=0);const T=Object.prototype.hasOwnProperty;var C;(function(L){L[L.False=0]="False",L[L.True=1]="True",L[L.Defined=2]="Defined",L[L.Not=3]="Not",L[L.Equals=4]="Equals",L[L.NotEquals=5]="NotEquals",L[L.And=6]="And",L[L.Regex=7]="Regex",L[L.NotRegex=8]="NotRegex",L[L.Or=9]="Or",L[L.In=10]="In",L[L.NotIn=11]="NotIn",L[L.Greater=12]="Greater",L[L.GreaterEquals=13]="GreaterEquals",L[L.Smaller=14]="Smaller",L[L.SmallerEquals=15]="SmallerEquals"})(C=e.ContextKeyExprType||(e.ContextKeyExprType={}));class A{static false(){return i.INSTANCE}static true(){return m.INSTANCE}static has(k){return a.create(k)}static equals(k,x){return f.create(k,x)}static notEquals(k,x){return v.create(k,x)}static regex(k,x){return n.create(k,x)}static in(k,x){return p.create(k,x)}static not(k){return o.create(k)}static and(...k){return c.create(k,null)}static or(...k){return b.create(k,null,!0)}static greater(k,x){return D.create(k,x)}static greaterEquals(k,x){return r.create(k,x)}static smaller(k,x){return w.create(k,x)}static smallerEquals(k,x){return s.create(k,x)}static deserialize(k,x=!1){if(!!k)return this._deserializeOrExpression(k,x)}static _deserializeOrExpression(k,x){let N=k.split("||");return b.create(N.map(V=>this._deserializeAndExpression(V,x)),null,!0)}static _deserializeAndExpression(k,x){let N=k.split("&&");return c.create(N.map(V=>this._deserializeOne(V,x)),null)}static _deserializeOne(k,x){if(k=k.trim(),k.indexOf("!=")>=0){let N=k.split("!=");return v.create(N[0].trim(),this._deserializeValue(N[1],x))}if(k.indexOf("==")>=0){let N=k.split("==");return f.create(N[0].trim(),this._deserializeValue(N[1],x))}if(k.indexOf("=~")>=0){let N=k.split("=~");return n.create(N[0].trim(),this._deserializeRegexValue(N[1],x))}if(k.indexOf(" in ")>=0){let N=k.split(" in ");return p.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(k)){const N=k.split(">=");return r.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(k)){const N=k.split(">");return D.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(k)){const N=k.split("<=");return s.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(k)){const N=k.split("<");return w.create(N[0].trim(),N[1].trim())}return/^\!\s*/.test(k)?o.create(k.substr(1).trim()):a.create(k)}static _deserializeValue(k,x){if(k=k.trim(),k==="true")return!0;if(k==="false")return!1;let N=/^'([^']*)'$/.exec(k);return N?N[1].trim():k}static _deserializeRegexValue(k,x){if((0,M.isFalsyOrWhitespace)(k)){if(x)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let N=k.indexOf("/"),V=k.lastIndexOf("/");if(N===V||N<0){if(x)throw new Error(`bad regexp-value '${k}', missing /-enclosure`);return console.warn(`bad regexp-value '${k}', missing /-enclosure`),null}let W=k.slice(N+1,V),$=k[V+1]==="i"?"i":"";try{return new RegExp(W,$)}catch(X){if(x)throw new Error(`bad regexp-value '${k}', parse error: ${X}`);return console.warn(`bad regexp-value '${k}', parse error: ${X}`),null}}}e.ContextKeyExpr=A;function t(L,k){const x=L?L.substituteConstants():void 0,N=k?k.substituteConstants():void 0;return!x&&!N?!0:!x||!N?!1:x.equals(N)}e.expressionsAreEqualWithConstantSubstitution=t;function _(L,k){return L.cmp(k)}class i{constructor(){this.type=0}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!1}serialize(){return"false"}keys(){return[]}map(k){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=i,i.INSTANCE=new i;class m{constructor(){this.type=1}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!0}serialize(){return"true"}keys(){return[]}map(k){return this}negate(){return i.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class a{constructor(k,x){this.key=k,this.negated=x,this.type=2}static create(k,x=null){const N=F.get(k);return typeof N=="boolean"?N?m.INSTANCE:i.INSTANCE:new a(k,x)}cmp(k){return k.type!==this.type?this.type-k.type:y(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=F.get(this.key);return typeof k=="boolean"?k?m.INSTANCE:i.INSTANCE:this}evaluate(k){return!!k.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(k){return k.mapDefined(this.key)}negate(){return this.negated||(this.negated=o.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=a;class f{constructor(k,x,N){this.key=k,this.value=x,this.negated=N,this.type=4}static create(k,x,N=null){if(typeof x=="boolean")return x?a.create(k,N):o.create(k,N);const V=F.get(k);return typeof V=="boolean"?x===(V?"true":"false")?m.INSTANCE:i.INSTANCE:new f(k,x,N)}cmp(k){return k.type!==this.type?this.type-k.type:R(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=F.get(this.key);if(typeof k=="boolean"){const x=k?"true":"false";return this.value===x?m.INSTANCE:i.INSTANCE}return this}evaluate(k){return k.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(k){return k.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=v.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=f;class p{constructor(k,x){this.key=k,this.valueKey=x,this.type=10,this.negated=null}static create(k,x){return new p(k,x)}cmp(k){return k.type!==this.type?this.type-k.type:R(this.key,this.valueKey,k.key,k.valueKey)}equals(k){return k.type===this.type?this.key===k.key&&this.valueKey===k.valueKey:!1}substituteConstants(){return this}evaluate(k){const x=k.getValue(this.valueKey),N=k.getValue(this.key);return Array.isArray(x)?x.indexOf(N)>=0:typeof N=="string"&&typeof x=="object"&&x!==null?T.call(x,N):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(k){return k.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=S.create(this)),this.negated}}e.ContextKeyInExpr=p;class S{constructor(k){this._actual=k,this.type=11}static create(k){return new S(k)}cmp(k){return k.type!==this.type?this.type-k.type:this._actual.cmp(k._actual)}equals(k){return k.type===this.type?this._actual.equals(k._actual):!1}substituteConstants(){return this}evaluate(k){return!this._actual.evaluate(k)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(k){return new S(this._actual.map(k))}negate(){return this._actual}}e.ContextKeyNotInExpr=S;class v{constructor(k,x,N){this.key=k,this.value=x,this.negated=N,this.type=5}static create(k,x,N=null){if(typeof x=="boolean")return x?o.create(k,N):a.create(k,N);const V=F.get(k);return typeof V=="boolean"?x===(V?"true":"false")?i.INSTANCE:m.INSTANCE:new v(k,x,N)}cmp(k){return k.type!==this.type?this.type-k.type:R(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=F.get(this.key);if(typeof k=="boolean"){const x=k?"true":"false";return this.value===x?i.INSTANCE:m.INSTANCE}return this}evaluate(k){return k.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(k){return k.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=v;class o{constructor(k,x){this.key=k,this.negated=x,this.type=3}static create(k,x=null){const N=F.get(k);return typeof N=="boolean"?N?i.INSTANCE:m.INSTANCE:new o(k,x)}cmp(k){return k.type!==this.type?this.type-k.type:y(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=F.get(this.key);return typeof k=="boolean"?k?i.INSTANCE:m.INSTANCE:this}evaluate(k){return!k.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(k){return k.mapNot(this.key)}negate(){return this.negated||(this.negated=a.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=o;function d(L,k){if(typeof L=="string"){const x=parseFloat(L);isNaN(x)||(L=x)}return typeof L=="string"||typeof L=="number"?k(L):i.INSTANCE}class D{constructor(k,x,N){this.key=k,this.value=x,this.negated=N,this.type=12}static create(k,x,N=null){return d(x,V=>new D(k,V,N))}cmp(k){return k.type!==this.type?this.type-k.type:R(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=D;class r{constructor(k,x,N){this.key=k,this.value=x,this.negated=N,this.type=13}static create(k,x,N=null){return d(x,V=>new r(k,V,N))}cmp(k){return k.type!==this.type?this.type-k.type:R(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=r;class w{constructor(k,x,N){this.key=k,this.value=x,this.negated=N,this.type=14}static create(k,x,N=null){return d(x,V=>new w(k,V,N))}cmp(k){return k.type!==this.type?this.type-k.type:R(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=w;class s{constructor(k,x,N){this.key=k,this.value=x,this.negated=N,this.type=15}static create(k,x,N=null){return d(x,V=>new s(k,V,N))}cmp(k){return k.type!==this.type?this.type-k.type:R(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=D.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=s;class n{constructor(k,x){this.key=k,this.regexp=x,this.type=7,this.negated=null}static create(k,x){return new n(k,x)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.key<k.key)return-1;if(this.key>k.key)return 1;const x=this.regexp?this.regexp.source:"",N=k.regexp?k.regexp.source:"";return x<N?-1:x>N?1:0}equals(k){if(k.type===this.type){const x=this.regexp?this.regexp.source:"",N=k.regexp?k.regexp.source:"";return this.key===k.key&&x===N}return!1}substituteConstants(){return this}evaluate(k){let x=k.getValue(this.key);return this.regexp?this.regexp.test(x):!1}serialize(){const k=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${k}`}keys(){return[this.key]}map(k){return k.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=g.create(this)),this.negated}}e.ContextKeyRegexExpr=n;class g{constructor(k){this._actual=k,this.type=8}static create(k){return new g(k)}cmp(k){return k.type!==this.type?this.type-k.type:this._actual.cmp(k._actual)}equals(k){return k.type===this.type?this._actual.equals(k._actual):!1}substituteConstants(){return this}evaluate(k){return!this._actual.evaluate(k)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(k){return new g(this._actual.map(k))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=g;function l(L){let k=null;for(let x=0,N=L.length;x<N;x++){const V=L[x].substituteConstants();if(L[x]!==V&&k===null){k=[];for(let W=0;W<x;W++)k[W]=L[W]}k!==null&&(k[x]=V)}return k===null?L:k}class c{constructor(k,x){this.expr=k,this.negated=x,this.type=6}static create(k,x){return c._normalizeArr(k,x)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let x=0,N=this.expr.length;x<N;x++){const V=_(this.expr[x],k.expr[x]);if(V!==0)return V}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let x=0,N=this.expr.length;x<N;x++)if(!this.expr[x].equals(k.expr[x]))return!1;return!0}return!1}substituteConstants(){const k=l(this.expr);return k===this.expr?this:c.create(k,this.negated)}evaluate(k){for(let x=0,N=this.expr.length;x<N;x++)if(!this.expr[x].evaluate(k))return!1;return!0}static _normalizeArr(k,x){const N=[];let V=!1;for(const W of k)if(!!W){if(W.type===1){V=!0;continue}if(W.type===0)return i.INSTANCE;if(W.type===6){N.push(...W.expr);continue}N.push(W)}if(N.length===0&&V)return m.INSTANCE;if(N.length!==0){if(N.length===1)return N[0];N.sort(_);for(let W=1;W<N.length;W++)N[W-1].equals(N[W])&&(N.splice(W,1),W--);if(N.length===1)return N[0];for(;N.length>1;){const W=N[N.length-1];if(W.type!==9)break;N.pop();const $=N.pop(),X=N.length===0,j=b.create(W.expr.map(Q=>c.create([Q,$],null)),null,X);j&&(N.push(j),N.sort(_))}return N.length===1?N[0]:new c(N,x)}}serialize(){return this.expr.map(k=>k.serialize()).join(" && ")}keys(){const k=[];for(let x of this.expr)k.push(...x.keys());return k}map(k){return new c(this.expr.map(x=>x.map(k)),null)}negate(){if(!this.negated){const k=[];for(let x of this.expr)k.push(x.negate());this.negated=b.create(k,this,!0)}return this.negated}}class b{constructor(k,x){this.expr=k,this.negated=x,this.type=9}static create(k,x,N){return b._normalizeArr(k,x,N)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let x=0,N=this.expr.length;x<N;x++){const V=_(this.expr[x],k.expr[x]);if(V!==0)return V}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let x=0,N=this.expr.length;x<N;x++)if(!this.expr[x].equals(k.expr[x]))return!1;return!0}return!1}substituteConstants(){const k=l(this.expr);return k===this.expr?this:b.create(k,this.negated,!1)}evaluate(k){for(let x=0,N=this.expr.length;x<N;x++)if(this.expr[x].evaluate(k))return!0;return!1}static _normalizeArr(k,x,N){let V=[],W=!1;if(k){for(let $=0,X=k.length;$<X;$++){const j=k[$];if(!!j){if(j.type===0){W=!0;continue}if(j.type===1)return m.INSTANCE;if(j.type===9){V=V.concat(j.expr);continue}V.push(j)}}if(V.length===0&&W)return i.INSTANCE;V.sort(_)}if(V.length!==0){if(V.length===1)return V[0];for(let $=1;$<V.length;$++)V[$-1].equals(V[$])&&(V.splice($,1),$--);if(V.length===1)return V[0];if(N){for(let $=0;$<V.length;$++)for(let X=$+1;X<V.length;X++)I(V[$],V[X])&&(V.splice(X,1),X--);if(V.length===1)return V[0]}return new b(V,x)}}serialize(){return this.expr.map(k=>k.serialize()).join(" || ")}keys(){const k=[];for(let x of this.expr)k.push(...x.keys());return k}map(k){return new b(this.expr.map(x=>x.map(k)),null)}negate(){if(!this.negated){let k=[];for(let x of this.expr)k.push(x.negate());for(;k.length>1;){const x=k.shift(),N=k.shift(),V=[];for(const $ of B(x))for(const X of B(N))V.push(c.create([$,X],null));const W=k.length===0;k.unshift(b.create(V,null,W))}this.negated=k[0]}return this.negated}}class h extends a{constructor(k,x,N){super(k,null);this._defaultValue=x,typeof N=="object"?h._info.push({...N,key:k}):N!==!0&&h._info.push({key:k,description:N,type:x!=null?typeof x:void 0})}static all(){return h._info.values()}bindTo(k){return k.createKey(this.key,this._defaultValue)}getValue(k){return k.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(k){return f.create(this.key,k)}notEqualsTo(k){return v.create(this.key,k)}}e.RawContextKey=h,h._info=[],e.IContextKeyService=(0,E.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function y(L,k){return L<k?-1:L>k?1:0}function R(L,k,x,N){return L<x?-1:L>x?1:k<N?-1:k>N?1:0}function I(L,k){if(k.type===6&&L.type!==9&&L.type!==6){for(const V of k.expr)if(L.equals(V))return!0}const x=L.negate(),N=B(x).concat(B(k));N.sort(_);for(let V=0;V<N.length;V++){const $=N[V].negate();for(let X=V+1;X<N.length;X++){const j=N[X];if($.equals(j))return!0}}return!1}e.implies=I;function B(L){return L.type===9?L.expr:[L]}}),define(we[143],be([0,1,4]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,u.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,u.refineServiceDecorator)(e.IEnvironmentService)}),define(we[47],be([0,1,20,17,9,10,2,122,4]),function(re,e,u,M,E,P,F,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,C.createDecorator)("fileService");function A(N){return N.create===!0}e.isFileOpenForWriteOptions=A;var t;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(t=e.FileType||(e.FileType={}));var _;(function(N){N[N.Readonly=1]="Readonly"})(_=e.FilePermission||(e.FilePermission={}));var i;(function(N){N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock"})(i=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(N){return!!(N.capabilities&2)}e.hasReadWriteCapability=m;function a(N){return!!(N.capabilities&8)}e.hasFileFolderCopyCapability=a;function f(N){return!!(N.capabilities&4)}e.hasOpenReadWriteCloseCapability=f;function p(N){return!!(N.capabilities&16)}e.hasFileReadStreamCapability=p;var S;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(S=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class v extends Error{constructor(V,W){super(V);this.code=W}}e.FileSystemProviderError=v;function o(N,V){const W=new v(N.toString(),V);return D(W,V),W}e.createFileSystemProviderError=o;function d(N){return N||o((0,T.localize)(0,null),S.Unknown)}e.ensureFileSystemProviderError=d;function D(N,V){return N.name=V?`${V} (FileSystemError)`:"FileSystemError",N}e.markAsFileSystemProviderError=D;function r(N){if(!N)return S.Unknown;if(N instanceof v)return N.code;const V=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!V)return S.Unknown;switch(V[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileExceedsMemoryLimit:return S.FileExceedsMemoryLimit;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}e.toFileSystemProviderErrorCode=r;function w(N){if(N instanceof b)return N.fileOperationResult;switch(r(N)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 10;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileExceedsMemoryLimit:return 9;case S.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=w;var s;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class n{constructor(V,W,$){this.resource=V,this.operation=W,this.target=$}isOperation(V){return this.operation===V}}e.FileOperationEvent=n;var g;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(g=e.FileChangeType||(e.FileChangeType={}));class l{constructor(V,W){this.added=void 0,this.updated=void 0,this.deleted=void 0;const $=new Map;for(const X of V){const j=$.get(X.type);j?j.push([X.resource,X]):$.set(X.type,[[X.resource,X]])}for(const[X,j]of $)switch(X){case 1:this.added=u.TernarySearchTree.forUris(()=>W),this.added.fill(j);break;case 0:this.updated=u.TernarySearchTree.forUris(()=>W),this.updated.fill(j);break;case 2:this.deleted=u.TernarySearchTree.forUris(()=>W),this.deleted.fill(j);break}}contains(V,...W){return this.doContains(V,{includeChildren:!1},...W)}affects(V,...W){return this.doContains(V,{includeChildren:!0},...W)}doContains(V,W,...$){if(!V)return!1;const X=$.length>0;return!!((!X||$.includes(1))&&(this.added?.get(V)||W.includeChildren&&this.added?.findSuperstr(V))||(!X||$.includes(0))&&(this.updated?.get(V)||W.includeChildren&&this.updated?.findSuperstr(V))||(!X||$.includes(2))&&(this.deleted?.findSubstr(V)||W.includeChildren&&this.deleted?.findSuperstr(V)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=l;function c(N,V,W){return!N||!V||N===V||V.length>N.length?!1:(V.charAt(V.length-1)!==M.sep&&(V+=M.sep),W?(0,E.startsWithIgnoreCase)(N,V):N.indexOf(V)===0)}e.isParent=c;class b extends Error{constructor(V,W,$){super(V);this.fileOperationResult=W,this.options=$}}e.FileOperationError=b;class h extends b{constructor(V,W,$){super(V,2,$);this.stat=W}}e.NotModifiedSinceFileOperationError=h;var y;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",N[N.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(y=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var R;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(R=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function I(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.etag=I;async function B(N,V){if(!V.hasProvider(F.URI.from({scheme:N.scheme})))return new Promise(W=>{const $=V.onDidChangeFileSystemProviderRegistrations(X=>{X.scheme===N.scheme&&X.added&&($.dispose(),W())})})}e.whenProviderRegistered=B,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class L{static formatSize(V){return(0,P.isNumber)(V)||(V=0),V<L.KB?(0,T.localize)(1,null,V.toFixed(0)):V<L.MB?(0,T.localize)(2,null,(V/L.KB).toFixed(2)):V<L.GB?(0,T.localize)(3,null,(V/L.MB).toFixed(2)):V<L.TB?(0,T.localize)(4,null,(V/L.GB).toFixed(2)):(0,T.localize)(5,null,(V/L.TB).toFixed(2))}}e.ByteSize=L,L.KB=1024,L.MB=L.KB*L.KB,L.GB=L.MB*L.KB,L.TB=L.GB*L.KB;var k;(function(N){N[N.IA32=0]="IA32",N[N.OTHER=1]="OTHER"})(k=e.Arch||(e.Arch={}));function x(N){return{maxFileSize:N===0?300*L.MB:16*L.GB,maxHeapSize:N===0?700*L.MB:2*700*L.MB}}e.getPlatformLimits=x}),define(we[62],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class u{constructor(...E){this._entries=new Map;for(let[P,F]of E)this.set(P,F)}set(E,P){const F=this._entries.get(E);return this._entries.set(E,P),F}has(E){return this._entries.has(E)}get(E){return this._entries.get(E)}}e.ServiceCollection=u}),define(we[144],be([0,1,13,16,82,140,4,62]),function(re,e,u,M,E,P,F,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const C=!1;class A extends Error{constructor(a){super("cyclic dependency between services");this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class t{constructor(a=new T.ServiceCollection,f=!1,p){this._activeInstantiations=new Set,this._services=a,this._strict=f,this._parent=p,this._services.set(F.IInstantiationService,this)}createChild(a){return new t(a,this._strict,this)}invokeFunction(a,...f){let p=i.traceInvocation(a),S=!1;try{return a({get:o=>{if(S)throw(0,M.illegalState)("service accessor is only valid during the invocation of its target method");const d=this._getOrCreateServiceInstance(o,p);if(!d)throw new Error(`[invokeFunction] unknown service '${o}'`);return d}},...f)}finally{S=!0,p.stop()}}createInstance(a,...f){let p,S;return a instanceof E.SyncDescriptor?(p=i.traceCreation(a.ctor),S=this._createInstance(a.ctor,a.staticArguments.concat(f),p)):(p=i.traceCreation(a),S=this._createInstance(a,f,p)),p.stop(),S}_createInstance(a,f=[],p){let S=F._util.getServiceDependencies(a).sort((d,D)=>d.index-D.index),v=[];for(const d of S){let D=this._getOrCreateServiceInstance(d.id,p);if(!D&&this._strict&&!d.optional)throw new Error(`[createInstance] ${a.name} depends on UNKNOWN service ${d.id}.`);v.push(D)}let o=S.length>0?S[0].index:f.length;if(f.length!==o){console.warn(`[createInstance] First service dependency of ${a.name} at position ${o+1} conflicts with ${f.length} static arguments`);let d=o-f.length;d>0?f=f.concat(new Array(d)):f=f.slice(0,o)}return new a(...[...f,...v])}_setServiceInstance(a,f){if(this._services.get(a)instanceof E.SyncDescriptor)this._services.set(a,f);else if(this._parent)this._parent._setServiceInstance(a,f);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){let f=this._services.get(a);return!f&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):f}_getOrCreateServiceInstance(a,f){let p=this._getServiceInstanceOrDescriptor(a);return p instanceof E.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,p,f.branch(a,!0)):(f.branch(a,!1),p)}_safeCreateAndCacheServiceInstance(a,f,p){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,f,p)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,f,p){const S=new P.Graph(d=>d.id.toString());let v=0;const o=[{id:a,desc:f,_trace:p}];for(;o.length;){const d=o.pop();if(S.lookupOrInsertNode(d),v++>1e3)throw new A(S);for(let D of F._util.getServiceDependencies(d.desc.ctor)){let r=this._getServiceInstanceOrDescriptor(D.id);if(!r&&!D.optional&&console.warn(`[createInstance] ${a} depends on ${D.id} which is NOT registered.`),r instanceof E.SyncDescriptor){const w={id:D.id,desc:r,_trace:d._trace.branch(D.id,!0)};S.insertEdge(d,w),o.push(w)}}}for(;;){const d=S.roots();if(d.length===0){if(!S.isEmpty())throw new A(S);break}for(const{data:D}of d){if(this._getServiceInstanceOrDescriptor(D.id)instanceof E.SyncDescriptor){const w=this._createServiceInstanceWithOwner(D.id,D.desc.ctor,D.desc.staticArguments,D.desc.supportsDelayedInstantiation,D._trace);this._setServiceInstance(D.id,w)}S.removeNode(D)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,f,p=[],S,v){if(this._services.get(a)instanceof E.SyncDescriptor)return this._createServiceInstance(f,p,S,v);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,f,p,S,v);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}_createServiceInstance(a,f=[],p,S){if(p){const v=new u.IdleValue(()=>this._createInstance(a,f,S));return new Proxy(Object.create(null),{get(o,d){if(d in o)return o[d];let D=v.value,r=D[d];return typeof r!="function"||(r=r.bind(D),o[d]=r),r},set(o,d,D){return v.value[d]=D,!0}})}else return this._createInstance(a,f,S)}}e.InstantiationService=t;var _;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(_||(_={}));class i{constructor(a,f){this.type=a,this.name=f,this._start=Date.now(),this._dep=[]}static traceInvocation(a){return C?new i(1,a.name||a.toString().substring(0,42).replace(/\n/g,"")):i._None}static traceCreation(a){return C?new i(0,a.name):i._None}branch(a,f){let p=new i(2,a.toString());return this._dep.push([a,f,p]),p}stop(){let a=Date.now()-this._start;i._totals+=a;let f=!1;function p(v,o){let d=[],D=new Array(v+1).join("	");for(const[r,w,s]of o._dep)if(w&&s){f=!0,d.push(`${D}CREATES -> ${r}`);let n=p(v+1,s);n&&d.push(n)}else d.push(`${D}uses -> ${r}`);return d.join(`
`)}let S=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${i._totals.toFixed(2)}ms)`];(a>2||f)&&console.log(S.join(`
`))}}i._None=new class extends i{constructor(){super(-1,null)}stop(){}branch(){return this}},i._totals=0}),define(we[12],be([0,1,46,3,6,25,4]),function(re,e,u,M,E,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,F.createDecorator)("logService"),e.ILoggerService=(0,F.createDecorator)("loggerService");function T(){return new Date().toISOString()}var C;(function(w){w[w.Trace=0]="Trace",w[w.Debug=1]="Debug",w[w.Info=2]="Info",w[w.Warning=3]="Warning",w[w.Error=4]="Error",w[w.Critical=5]="Critical",w[w.Off=6]="Off"})(C=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=C.Info;function A(w,s,n){switch(s){case C.Trace:w.trace(n);break;case C.Debug:w.debug(n);break;case C.Info:w.info(n);break;case C.Warning:w.warn(n);break;case C.Error:w.error(n);break;case C.Critical:w.critical(n);break;default:throw new Error("Invalid log level")}}e.log=A;function t(w){let s="";for(let n=0;n<w.length;n++){let g=w[n];if(typeof g=="object")try{g=JSON.stringify(g)}catch(l){}s+=(n>0?" ":"")+g}return s}e.format=t;class _ extends E.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new M.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(s){this.level!==s&&(this.level=s,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=_;class i extends _{constructor(s){super();this.logAlways=s}checkLogLevel(s){return this.logAlways||this.getLevel()<=s}trace(s,...n){this.checkLogLevel(C.Trace)&&this.log(C.Trace,t([s,...n]))}debug(s,...n){this.checkLogLevel(C.Debug)&&this.log(C.Debug,t([s,...n]))}info(s,...n){this.checkLogLevel(C.Info)&&this.log(C.Info,t([s,...n]))}warn(s,...n){this.checkLogLevel(C.Warning)&&this.log(C.Warning,t([s,...n]))}error(s,...n){if(this.checkLogLevel(C.Error))if(s instanceof Error){const g=Array.prototype.slice.call(arguments);g[0]=s.stack,this.log(C.Error,t(g))}else this.log(C.Error,t([s,...n]))}critical(s,...n){this.checkLogLevel(C.Critical)&&this.log(C.Critical,t([s,...n]))}flush(){}}e.AbstractMessageLogger=i;class m extends _{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s),this.useColors=!P.isWindows}trace(s,...n){this.getLevel()<=C.Trace&&(this.useColors?console.log(`[90m[main ${T()}][0m`,s,...n):console.log(`[main ${T()}]`,s,...n))}debug(s,...n){this.getLevel()<=C.Debug&&(this.useColors?console.log(`[90m[main ${T()}][0m`,s,...n):console.log(`[main ${T()}]`,s,...n))}info(s,...n){this.getLevel()<=C.Info&&(this.useColors?console.log(`[90m[main ${T()}][0m`,s,...n):console.log(`[main ${T()}]`,s,...n))}warn(s,...n){this.getLevel()<=C.Warning&&(this.useColors?console.warn(`[93m[main ${T()}][0m`,s,...n):console.warn(`[main ${T()}]`,s,...n))}error(s,...n){this.getLevel()<=C.Error&&(this.useColors?console.error(`[91m[main ${T()}][0m`,s,...n):console.error(`[main ${T()}]`,s,...n))}critical(s,...n){this.getLevel()<=C.Critical&&(this.useColors?console.error(`[90m[main ${T()}][0m`,s,...n):console.error(`[main ${T()}]`,s,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=m;class a extends _{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s)}trace(s,...n){this.getLevel()<=C.Trace&&console.log("%cTRACE","color: #888",s,...n)}debug(s,...n){this.getLevel()<=C.Debug&&console.log("%cDEBUG","background: #eee; color: #888",s,...n)}info(s,...n){this.getLevel()<=C.Info&&console.log("%c INFO","color: #33f",s,...n)}warn(s,...n){this.getLevel()<=C.Warning&&console.log("%c WARN","color: #993",s,...n)}error(s,...n){this.getLevel()<=C.Error&&console.log("%c  ERR","color: #f33",s,...n)}critical(s,...n){this.getLevel()<=C.Critical&&console.log("%cCRITI","background: #f33; color: white",s,...n)}dispose(){}flush(){}}e.ConsoleLogger=a;class f extends _{constructor(s,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=s,this.setLevel(n)}trace(s,...n){this.getLevel()<=C.Trace&&this.adapter.log(C.Trace,[this.extractMessage(s),...n])}debug(s,...n){this.getLevel()<=C.Debug&&this.adapter.log(C.Debug,[this.extractMessage(s),...n])}info(s,...n){this.getLevel()<=C.Info&&this.adapter.log(C.Info,[this.extractMessage(s),...n])}warn(s,...n){this.getLevel()<=C.Warning&&this.adapter.log(C.Warning,[this.extractMessage(s),...n])}error(s,...n){this.getLevel()<=C.Error&&this.adapter.log(C.Error,[this.extractMessage(s),...n])}critical(s,...n){this.getLevel()<=C.Critical&&this.adapter.log(C.Critical,[this.extractMessage(s),...n])}extractMessage(s){return typeof s=="string"?s:(0,u.toErrorMessage)(s,this.getLevel()<=C.Trace)}dispose(){}flush(){}}e.AdapterLogger=f;class p extends _{constructor(s){super();this.logServices=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const n of this.logServices)n.setLevel(s);super.setLevel(s)}trace(s,...n){for(const g of this.logServices)g.trace(s,...n)}debug(s,...n){for(const g of this.logServices)g.debug(s,...n)}info(s,...n){for(const g of this.logServices)g.info(s,...n)}warn(s,...n){for(const g of this.logServices)g.warn(s,...n)}error(s,...n){for(const g of this.logServices)g.error(s,...n)}critical(s,...n){for(const g of this.logServices)g.critical(s,...n)}flush(){for(const s of this.logServices)s.flush()}dispose(){for(const s of this.logServices)s.dispose()}}e.MultiplexLogService=p;class S extends E.Disposable{constructor(s){super();this.logger=s,this._register(s)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(s){this.logger.setLevel(s)}getLevel(){return this.logger.getLevel()}trace(s,...n){this.logger.trace(s,...n)}debug(s,...n){this.logger.debug(s,...n)}info(s,...n){this.logger.info(s,...n)}warn(s,...n){this.logger.warn(s,...n)}error(s,...n){this.logger.error(s,...n)}critical(s,...n){this.logger.critical(s,...n)}flush(){this.logger.flush()}}e.LogService=S;class v extends E.Disposable{constructor(s,n){super();this.logLevel=s,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(g=>{this.logLevel=g,this.logLevelChangeableLoggers.forEach(l=>l.setLevel(g))}))}getLogger(s){return this.loggers.get(s.toString())}createLogger(s,n){let g=this.loggers.get(s.toString());return g||(g=this.doCreateLogger(s,n?.always?C.Trace:this.logLevel,n),this.loggers.set(s.toString(),g),n?.always||this.logLevelChangeableLoggers.push(g)),g}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(s=>s.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=v;class o{constructor(){this.onDidChangeLogLevel=new M.Emitter().event}setLevel(s){}getLevel(){return C.Info}trace(s,...n){}debug(s,...n){}info(s,...n){}warn(s,...n){}error(s,...n){}critical(s,...n){}dispose(){}flush(){}}e.NullLogService=o;function d(w){if(w.verbose)return C.Trace;if(typeof w.logLevel=="string"){const s=D(w.logLevel.toLowerCase());if(s!==void 0)return s}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=d;function D(w){switch(w){case"trace":return C.Trace;case"debug":return C.Debug;case"info":return C.Info;case"warn":return C.Warning;case"error":return C.Error;case"critical":return C.Critical;case"off":return C.Off}}e.parseLogLevel=D;function r(w){switch(w){case C.Trace:return"trace";case C.Debug:return"debug";case C.Info:return"info";case C.Warning:return"warn";case C.Error:return"error";case C.Critical:return"critical";case C.Off:return"off"}}e.LogLevelToString=r}),define(we[83],be([0,1,36,123,4]),function(re,e,u,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function(C){C[C.Unnecessary=1]="Unnecessary",C[C.Deprecated=2]="Deprecated"})(P=e.MarkerTag||(e.MarkerTag={}));var F;(function(C){C[C.Hint=1]="Hint",C[C.Info=2]="Info",C[C.Warning=4]="Warning",C[C.Error=8]="Error"})(F=e.MarkerSeverity||(e.MarkerSeverity={})),function(C){function A(a,f){return f-a}C.compare=A;const t=Object.create(null);t[C.Error]=(0,M.localize)(0,null),t[C.Warning]=(0,M.localize)(1,null),t[C.Info]=(0,M.localize)(2,null);function _(a){return t[a]||""}C.toString=_;function i(a){switch(a){case u.default.Error:return C.Error;case u.default.Warning:return C.Warning;case u.default.Info:return C.Info;case u.default.Ignore:return C.Hint}}C.fromSeverity=i;function m(a){switch(a){case C.Error:return u.default.Error;case C.Warning:return u.default.Warning;case C.Info:return u.default.Info;case C.Hint:return u.default.Ignore}}C.toSeverity=m}(F=e.MarkerSeverity||(e.MarkerSeverity={}));var T;(function(C){const A="";function t(i){return _(i,!0)}C.makeKey=t;function _(i,m){let a=[A];return i.source?a.push(i.source.replace("\xA6","\\\xA6")):a.push(A),i.code?typeof i.code=="string"?a.push(i.code.replace("\xA6","\\\xA6")):a.push(i.code.value.replace("\xA6","\\\xA6")):a.push(A),i.severity!==void 0&&i.severity!==null?a.push(F.toString(i.severity)):a.push(A),i.message&&m?a.push(i.message.replace("\xA6","\\\xA6")):a.push(A),i.startLineNumber!==void 0&&i.startLineNumber!==null?a.push(i.startLineNumber.toString()):a.push(A),i.startColumn!==void 0&&i.startColumn!==null?a.push(i.startColumn.toString()):a.push(A),i.endLineNumber!==void 0&&i.endLineNumber!==null?a.push(i.endLineNumber.toString()):a.push(A),i.endColumn!==void 0&&i.endColumn!==null?a.push(i.endColumn.toString()):a.push(A),a.push(A),a.join("\xA6")}C.makeKeyOptionalMessage=_})(T=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,E.createDecorator)("markerService")}),define(we[145],be([0,1,3,36,4]),function(re,e,u,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=M.default,e.INotificationService=(0,E.createDecorator)("notificationService");var P;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.GLOBAL=1]="GLOBAL"})(P=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var F;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})(F=e.NotificationsFilter||(e.NotificationsFilter={}));class T{constructor(){this.progress=new C,this.onDidClose=u.Event.None,this.onDidChangeVisibility=u.Event.None}updateSeverity(t){}updateMessage(t){}updateActions(t){}close(){}}e.NoOpNotification=T;class C{infinite(){}done(){}total(t){}worked(t){}}e.NoOpProgress=C}),define(we[146],be([0,1,6,9,2,4]),function(re,e,u,M,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,P.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return u.Disposable.None},registerValidator(){return u.Disposable.None},registerExternalUriResolver(){return u.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return u.Disposable.None},async open(){return!1},async resolveExternalUri(C){return{resolved:C,dispose(){}}}});function F(C,A){return E.URI.isUri(C)?(0,M.equalsIgnoreCase)(C.scheme,A):(0,M.startsWithIgnoreCase)(C,A+":")}e.matchesScheme=F;function T(C,...A){return A.some(t=>F(C,t))}e.matchesSomeScheme=T});var Ue=this&&this.__decorate||function(re,e,u,M){var E=arguments.length,P=E<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,u):M,F;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(re,e,u,M);else for(var T=re.length-1;T>=0;T--)(F=re[T])&&(P=(E<3?F(P):E>3?F(e,u,P):F(e,u))||P);return E>3&&P&&Object.defineProperty(e,u,P),P},Be=this&&this.__param||function(re,e){return function(u,M){e(u,M,re)}};define(we[147],be([0,1,13,21,6,4]),function(re,e,u,M,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,P.createDecorator)("progressService");var F;(function(t){t[t.Explorer=1]="Explorer",t[t.Scm=3]="Scm",t[t.Extensions=5]="Extensions",t[t.Window=10]="Window",t[t.Notification=15]="Notification",t[t.Dialog=20]="Dialog"})(F=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class T{constructor(_){this.callback=_}get value(){return this._value}report(_){this._value=_,this.callback(this._value)}}e.Progress=T,T.None=Object.freeze({report(){}});let C=class extends E.Disposable{constructor(_,i){super();this.deferred=new u.DeferredPromise,i.withProgress(_,m=>(this.reporter=m,this.lastStep&&m.report(this.lastStep),this.deferred.p)),this._register((0,E.toDisposable)(()=>this.deferred.complete()))}report(_){this.reporter?this.reporter.report(_):this.lastStep=_}};C=Ue([Be(1,e.IProgressService)],C),e.UnmanagedProgress=C;class A extends E.Disposable{constructor(_){super();this.progressIndicator=_,this.currentOperationId=0,this.currentOperationDisposables=this._register(new E.DisposableStore)}start(_){this.stop();const i=++this.currentOperationId,m=new M.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{i===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},_),this.currentOperationDisposables.add((0,E.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,E.toDisposable)(()=>m.cancel())),this.currentOperationDisposables.add((0,E.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:i,token:m.token,stop:()=>this.doStop(i),isCurrent:()=>this.currentOperationId===i}}stop(){this.doStop(this.currentOperationId)}doStop(_){this.currentOperationId===_&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=A,e.IEditorProgressService=(0,P.createDecorator)("editorProgressService")}),define(we[29],be([0,1,43,10]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class E{constructor(){this.data=new Map}add(F,T){u.ok(M.isString(F)),u.ok(M.isObject(T)),u.ok(!this.data.has(F),"There is already an extension with this id"),this.data.set(F,T)}knows(F){return this.data.has(F)}as(F){return this.data.get(F)||null}}e.Registry=new E}),define(we[84],be([0,1,3,29]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function E(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class P{constructor(){this._onDidChangeSchema=new u.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(C,A){this.schemasById[E(C)]=A,this._onDidChangeSchema.fire(C)}notifySchemaChanged(C){this._onDidChangeSchema.fire(C)}getSchemaContributions(){return{schemas:this.schemasById}}}const F=new P;M.Registry.add(e.Extensions.JSONContribution,F)}),define(we[63],be([0,1,15,3,10,120,84,29]),function(re,e,u,M,E,P,F,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var A;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const t=T.Registry.as(F.Extensions.JSONContribution);class _{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new M.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new M.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:P.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(o,d=!0){this.registerConfigurations([o],d)}registerConfigurations(o,d=!0){const D=this.doRegisterConfigurations(o,d);t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(D)}deregisterConfigurations(o){const d=this.doDeregisterConfigurations(o);t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}updateConfigurations({add:o,remove:d}){const D=[];D.push(...this.doDeregisterConfigurations(d)),D.push(...this.doRegisterConfigurations(o,!1)),t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,u.distinct)(D))}registerDefaultConfigurations(o){const d=[],D=[];for(const r of o)for(const w in r)if(d.push(w),e.OVERRIDE_PROPERTY_PATTERN.test(w)){this.defaultValues[w]={...this.defaultValues[w]||{},...r[w]};const s={type:"object",default:this.defaultValues[w],description:P.localize(1,null,w),$ref:e.resourceLanguageSettingsSchemaId};D.push(m(w)),this.configurationProperties[w]=s,this.defaultLanguageConfigurationOverridesNode.properties[w]=s}else{this.defaultValues[w]=r[w];const s=this.configurationProperties[w];s&&(this.updatePropertyDefaultValue(w,s),this.updateSchema(w,s))}this.registerOverrideIdentifiers(D),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}deregisterDefaultConfigurations(o){const d=[];for(const D of o)for(const r in D)if(d.push(r),delete this.defaultValues[r],e.OVERRIDE_PROPERTY_PATTERN.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const w=this.configurationProperties[r];w&&(this.updatePropertyDefaultValue(r,w),this.updateSchema(r,w))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}notifyConfigurationSchemaUpdated(...o){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(o){for(const d of o)this.overrideIdentifiers.add(d);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(o,d){const D=[];return o.forEach(r=>{D.push(...this.validateAndRegisterProperties(r,d,r.extensionInfo)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),D}doDeregisterConfigurations(o){const d=[],D=r=>{if(r.properties)for(const w in r.properties)d.push(w),delete this.configurationProperties[w],this.removeFromSchema(w,r.properties[w]);r.allOf&&r.allOf.forEach(w=>D(w))};for(const r of o){D(r);const w=this.configurationContributors.indexOf(r);w!==-1&&this.configurationContributors.splice(w,1)}return d}validateAndRegisterProperties(o,d=!0,D,r=3){r=E.isUndefinedOrNull(o.scope)?r:o.scope;let w=[],s=o.properties;if(s)for(let g in s){if(d&&p(g)){delete s[g];continue}const l=s[g];if(this.updatePropertyDefaultValue(g,l),e.OVERRIDE_PROPERTY_PATTERN.test(g)?l.scope=void 0:(l.scope=E.isUndefinedOrNull(l.scope)?r:l.scope,l.restricted=E.isUndefinedOrNull(l.restricted)?!!D?.restrictedConfigurations?.includes(g):l.restricted),s[g].hasOwnProperty("included")&&!s[g].included){this.excludedConfigurationProperties[g]=s[g],delete s[g];continue}else this.configurationProperties[g]=s[g];!s[g].deprecationMessage&&s[g].markdownDeprecationMessage&&(s[g].deprecationMessage=s[g].markdownDeprecationMessage),w.push(g)}let n=o.allOf;if(n)for(let g of n)w.push(...this.validateAndRegisterProperties(g,d,D,r));return w}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(o){const d=D=>{let r=D.properties;if(r)for(const s in r)this.updateSchema(s,r[s]);let w=D.allOf;w&&w.forEach(d)};d(o)}updateSchema(o,d){switch(e.allSettings.properties[o]=d,d.scope){case 1:e.applicationSettings.properties[o]=d;break;case 2:e.machineSettings.properties[o]=d;break;case 6:e.machineOverridableSettings.properties[o]=d;break;case 3:e.windowSettings.properties[o]=d;break;case 4:e.resourceSettings.properties[o]=d;break;case 5:e.resourceSettings.properties[o]=d,this.resourceLanguageSettingsSchema.properties[o]=d;break}}removeFromSchema(o,d){switch(delete e.allSettings.properties[o],d.scope){case 1:delete e.applicationSettings.properties[o];break;case 2:delete e.machineSettings.properties[o];break;case 6:delete e.machineOverridableSettings.properties[o];break;case 3:delete e.windowSettings.properties[o];break;case 4:case 5:delete e.resourceSettings.properties[o];break}}updateOverridePropertyPatternKey(){for(const o of this.overrideIdentifiers.values()){const d=`[${o}]`,D={type:"object",description:P.localize(2,null),errorMessage:P.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(d,D),e.allSettings.properties[d]=D,e.applicationSettings.properties[d]=D,e.machineSettings.properties[d]=D,e.machineOverridableSettings.properties[d]=D,e.windowSettings.properties[d]=D,e.resourceSettings.properties[d]=D}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(o,d){let D=this.defaultValues[o];E.isUndefined(D)&&(D=d.default),E.isUndefined(D)&&(D=a(d.type)),d.default=D}}const i="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(i);function m(v){return v.substring(1,v.length-1)}e.overrideIdentifierFromKey=m;function a(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=a;const f=new _;T.Registry.add(e.Extensions.Configuration,f);function p(v){return v.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(v)?P.localize(5,null,v):f.getConfigurationProperties()[v]!==void 0?P.localize(6,null,v):null:P.localize(4,null)}e.validateProperty=p;function S(){const v=[],o=f.getConfigurationProperties();for(const d of Object.keys(o))v.push([d,o[d].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.getScopes=S}),define(we[85],be([0,1,23,10,2,63,4,29]),function(re,e,u,M,E,P,F,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,F.createDecorator)("configurationService");function C(w){return w&&typeof w=="object"&&(!w.overrideIdentifier||typeof w.overrideIdentifier=="string")&&(!w.resource||w.resource instanceof E.URI)}e.isConfigurationOverrides=C;var A;(function(w){w[w.USER=1]="USER",w[w.USER_LOCAL=2]="USER_LOCAL",w[w.USER_REMOTE=3]="USER_REMOTE",w[w.WORKSPACE=4]="WORKSPACE",w[w.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",w[w.DEFAULT=6]="DEFAULT",w[w.MEMORY=7]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function t(w){switch(w){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=t;function _(w,s){const n=s?w?s.keys.filter(R=>w.keys.indexOf(R)===-1):[...s.keys]:[],g=w?s?w.keys.filter(R=>s.keys.indexOf(R)===-1):[...w.keys]:[],l=[];if(s&&w){for(const R of w.keys)if(s.keys.indexOf(R)!==-1){const I=S(w.contents,R),B=S(s.contents,R);u.equals(I,B)||l.push(R)}}const c=[],b=R=>{const I={};for(const B of R)for(const L of B.identifiers)I[D(L)]=B;return I},h=s?b(s.overrides):{},y=w?b(w.overrides):{};if(Object.keys(h).length)for(const R of n){const I=h[R];I&&c.push([(0,P.overrideIdentifierFromKey)(R),I.keys])}if(Object.keys(y).length)for(const R of g){const I=y[R];I&&c.push([(0,P.overrideIdentifierFromKey)(R),I.keys])}if(Object.keys(h).length&&Object.keys(y).length)for(const R of l){const I=y[R],B=h[R];if(I&&B){const L=_({contents:I.contents,keys:I.keys,overrides:[]},{contents:B.contents,keys:B.keys,overrides:[]});c.push([(0,P.overrideIdentifierFromKey)(R),[...L.added,...L.removed,...L.updated]])}}return{added:n,removed:g,updated:l,overrides:c}}e.compare=_;function i(w,s){const n=[];for(const g of Object.keys(w))if(P.OVERRIDE_PROPERTY_PATTERN.test(g)){const l={};for(const c in w[g])l[c]=w[g][c];n.push({identifiers:[(0,P.overrideIdentifierFromKey)(g).trim()],keys:Object.keys(l),contents:m(l,s)})}return n}e.toOverrides=i;function m(w,s){const n=Object.create(null);for(let g in w)a(n,g,w[g],s);return n}e.toValuesTree=m;function a(w,s,n,g){const l=s.split("."),c=l.pop();let b=w;for(let h=0;h<l.length;h++){let y=l[h],R=b[y];switch(typeof R){case"undefined":R=b[y]=Object.create(null);break;case"object":break;default:g(`Ignoring ${s} as ${l.slice(0,h+1).join(".")} is ${JSON.stringify(R)}`);return}b=R}if(typeof b=="object"&&b!==null)try{b[c]=n}catch(h){g(`Ignoring ${s} as ${l.join(".")} is ${JSON.stringify(b)}`)}else g(`Ignoring ${s} as ${l.join(".")} is ${JSON.stringify(b)}`)}e.addToValueTree=a;function f(w,s){const n=s.split(".");p(w,n)}e.removeFromValueTree=f;function p(w,s){const n=s.shift();if(s.length===0){delete w[n];return}if(Object.keys(w).indexOf(n)!==-1){const g=w[n];typeof g=="object"&&!Array.isArray(g)&&(p(g,s),Object.keys(g).length===0&&delete w[n])}}function S(w,s,n){function g(b,h){let y=b;for(const R of h){if(typeof y!="object"||y===null)return;y=y[R]}return y}const l=s.split("."),c=g(w,l);return typeof c=="undefined"?n:c}e.getConfigurationValue=S;function v(w,s,n){Object.keys(s).forEach(g=>{g!=="__proto__"&&(g in w?M.isObject(w[g])&&M.isObject(s[g])?v(w[g],s[g],n):n&&(w[g]=s[g]):w[g]=s[g])})}e.merge=v;function o(){const w=T.Registry.as(P.Extensions.Configuration).getConfigurationProperties();return Object.keys(w)}e.getConfigurationKeys=o;function d(){const w=Object.create(null),s=T.Registry.as(P.Extensions.Configuration).getConfigurationProperties();for(let n in s){let g=s[n].default;a(w,n,g,l=>console.error(`Conflict in default settings: ${l}`))}return w}e.getDefaultValues=d;function D(w){return`[${w}]`}e.keyFromOverrideIdentifier=D;function r(w,s,n){const g=w.inspect(s),l=w.inspect(n);return typeof g.userValue!="undefined"||typeof g.workspaceValue!="undefined"||typeof g.workspaceFolderValue!="undefined"?g.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:g.defaultValue}e.getMigratedSettingValue=r}),define(we[148],be([0,1,15,3,102,6,20,23,10,2,85,63,29]),function(re,e,u,M,E,P,F,T,C,A,t,_,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class m{constructor(r={},w=[],s=[]){this._contents=r,this._keys=w,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,t.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,w){const s=this.getContentsForOverrideIdentifer(w);return s?r?(0,t.getConfigurationValue)(s,r):s:void 0}getKeysForOverrideIdentifier(r){for(const w of this.overrides)if(w.identifiers.indexOf(r)!==-1)return w.keys;return[]}override(r){let w=this.overrideConfigurations.get(r);return w||(w=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,w)),w}merge(...r){const w=T.deepClone(this.contents),s=T.deepClone(this.overrides),n=[...this.keys];for(const g of r){this.mergeContents(w,g.contents);for(const l of g.overrides){const[c]=s.filter(b=>u.equals(b.identifiers,l.identifiers));c?this.mergeContents(c.contents,l.contents):s.push(T.deepClone(l))}for(const l of g.keys)n.indexOf(l)===-1&&n.push(l)}return new m(w,n,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(r){const w=this.getContentsForOverrideIdentifer(r);if(!w||typeof w!="object"||!Object.keys(w).length)return this;let s={};for(const n of u.distinct([...Object.keys(this.contents),...Object.keys(w)])){let g=this.contents[n],l=w[n];l&&(typeof g=="object"&&typeof l=="object"?(g=T.deepClone(g),this.mergeContents(g,l)):g=l),s[n]=g}return new m(s,this.keys,this.overrides)}mergeContents(r,w){for(const s of Object.keys(w)){if(s in r&&C.isObject(r[s])&&C.isObject(w[s])){this.mergeContents(r[s],w[s]);continue}r[s]=T.deepClone(w[s])}}checkAndFreeze(r){return this.isFrozen&&!Object.isFrozen(r)?T.deepFreeze(r):r}getContentsForOverrideIdentifer(r){for(const w of this.overrides)if(w.identifiers.indexOf(r)!==-1)return w.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,w){this.addKey(r),(0,t.addToValueTree)(this.contents,r,w,s=>{throw new Error(s)})}removeValue(r){this.removeKey(r)&&(0,t.removeFromValueTree)(this.contents,r)}addKey(r){let w=this.keys.length;for(let s=0;s<w;s++)r.indexOf(this.keys[s])===0&&(w=s);this.keys.splice(w,1,r)}removeKey(r){let w=this.keys.indexOf(r);return w!==-1?(this.keys.splice(w,1),!0):!1}}e.ConfigurationModel=m;class a extends m{constructor(){const r=(0,t.getDefaultValues)(),w=(0,t.getConfigurationKeys)(),s=[];for(const n of Object.keys(r))_.OVERRIDE_PROPERTY_PATTERN.test(n)&&s.push({identifiers:[(0,_.overrideIdentifierFromKey)(n).trim()],keys:Object.keys(r[n]),contents:(0,t.toValuesTree)(r[n],g=>console.error(`Conflict in default settings file: ${g}`))});super(r,w,s)}}e.DefaultConfigurationModel=a;class f{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,w){if(!C.isUndefinedOrNull(r)){const s=this.doParseContent(r);this.parseRaw(s,w)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,w){this._raw=r;const{contents:s,keys:n,overrides:g,restricted:l}=this.doParseRaw(r,w);this._configurationModel=new m(s,n,g),this._restrictedConfigurations=l||[]}doParseContent(r){let w={},s=null,n=[],g=[],l=[];function c(h){Array.isArray(n)?n.push(h):s!==null&&(n[s]=h)}let b={onObjectBegin:()=>{let h={};c(h),g.push(n),n=h,s=null},onObjectProperty:h=>{s=h},onObjectEnd:()=>{n=g.pop()},onArrayBegin:()=>{let h=[];c(h),g.push(n),n=h,s=null},onArrayEnd:()=>{n=g.pop()},onLiteralValue:c,onError:(h,y,R)=>{l.push({error:h,offset:y,length:R})}};if(r)try{E.visit(r,b),w=n[0]||{}}catch(h){console.error(`Error while parsing settings file ${this._name}: ${h}`),this._parseErrors=[h]}return w}doParseRaw(r,w){const s=i.Registry.as(_.Extensions.Configuration).getConfigurationProperties(),n=this.filter(r,s,!0,w);r=n.raw;const g=(0,t.toValuesTree)(r,b=>console.error(`Conflict in settings file ${this._name}: ${b}`)),l=Object.keys(r),c=(0,t.toOverrides)(r,b=>console.error(`Conflict in settings file ${this._name}: ${b}`));return{contents:g,keys:l,overrides:c,restricted:n.restricted}}filter(r,w,s,n){if(!n?.scopes&&!n?.skipRestricted)return{raw:r,restricted:[]};const g={},l=[];for(let c in r)if(_.OVERRIDE_PROPERTY_PATTERN.test(c)&&s){const b=this.filter(r[c],w,!1,n);g[c]=b.raw,l.push(...b.restricted)}else{const b=w[c],h=b?typeof b.scope!="undefined"?b.scope:3:void 0;b?.restricted&&l.push(c),(h===void 0||n.scopes===void 0||n.scopes.includes(h))&&(n.skipRestricted&&b?.restricted||(g[c]=r[c]))}return{raw:g,restricted:l}}}e.ConfigurationModelParser=f;class p extends P.Disposable{constructor(r,w,s,n){super();this.userSettingsResource=r,this.scopes=w,this.fileService=n,this._onDidChange=this._register(new M.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(M.Event.filter(this.fileService.onDidFilesChange,g=>g.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(r){return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=p;class S{constructor(r,w,s=new m,n=new m,g=new F.ResourceMap,l=new m,c=new F.ResourceMap,b=!0){this._defaultConfiguration=r,this._localUserConfiguration=w,this._remoteUserConfiguration=s,this._workspaceConfiguration=n,this._folderConfigurations=g,this._memoryConfiguration=l,this._memoryConfigurationByResource=c,this._freeze=b,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new F.ResourceMap,this._userConfiguration=null}getValue(r,w,s){return this.getConsolidateConfigurationModel(w,s).getValue(r)}updateValue(r,w,s={}){let n;s.resource?(n=this._memoryConfigurationByResource.get(s.resource),n||(n=new m,this._memoryConfigurationByResource.set(s.resource,n))):n=this._memoryConfiguration,w===void 0?n.removeValue(r):n.setValue(r,w),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,w,s){const n=this.getConsolidateConfigurationModel(w,s),g=this.getFolderConfigurationModelForResource(w.resource,s),l=w.resource?this._memoryConfigurationByResource.get(w.resource)||this._memoryConfiguration:this._memoryConfiguration,c=w.overrideIdentifier?this._defaultConfiguration.freeze().override(w.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),b=w.overrideIdentifier?this.userConfiguration.freeze().override(w.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),h=w.overrideIdentifier?this.localUserConfiguration.freeze().override(w.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),y=w.overrideIdentifier?this.remoteUserConfiguration.freeze().override(w.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),R=s?w.overrideIdentifier?this._workspaceConfiguration.freeze().override(w.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,I=g?w.overrideIdentifier?g.freeze().override(w.overrideIdentifier).getValue(r):g.freeze().getValue(r):void 0,B=w.overrideIdentifier?l.override(w.overrideIdentifier).getValue(r):l.getValue(r),L=n.getValue(r),k=u.distinct(u.flatten(n.overrides.map(x=>x.identifiers))).filter(x=>n.getOverrideValue(r,x)!==void 0);return{defaultValue:c,userValue:b,userLocalValue:h,userRemoteValue:y,workspaceValue:R,workspaceFolderValue:I,memoryValue:B,value:L,default:c!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:w.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,w.overrideIdentifier):void 0}:void 0,user:b!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:w.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,w.overrideIdentifier):void 0}:void 0,userLocal:h!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:w.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,w.overrideIdentifier):void 0}:void 0,userRemote:y!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:w.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,w.overrideIdentifier):void 0}:void 0,workspace:R!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:w.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,w.overrideIdentifier):void 0}:void 0,workspaceFolder:I!==void 0?{value:g?.freeze().getValue(r),override:w.overrideIdentifier?g?.freeze().getOverrideValue(r,w.overrideIdentifier):void 0}:void 0,memory:B!==void 0?{value:l.getValue(r),override:w.overrideIdentifier?l.getOverrideValue(r,w.overrideIdentifier):void 0}:void 0,overrideIdentifiers:k.length?k:void 0}}keys(r){const w=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:w?w.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,w){this._folderConfigurations.set(r,w),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,w){const s=w.filter(n=>_.OVERRIDE_PROPERTY_PATTERN.test(n)).map(n=>{const g=(0,_.overrideIdentifierFromKey)(n),l=this._defaultConfiguration.getKeysForOverrideIdentifier(g),c=r.getKeysForOverrideIdentifier(g),b=[...c.filter(h=>l.indexOf(h)===-1),...l.filter(h=>c.indexOf(h)===-1),...l.filter(h=>!T.equals(this._defaultConfiguration.override(g).getValue(h),r.override(g).getValue(h)))];return[g,b]});return this.updateDefaultConfiguration(r),{keys:w,overrides:s}}compareAndUpdateLocalUserConfiguration(r){const{added:w,updated:s,removed:n,overrides:g}=(0,t.compare)(this.localUserConfiguration,r),l=[...w,...s,...n];return l.length&&this.updateLocalUserConfiguration(r),{keys:l,overrides:g}}compareAndUpdateRemoteUserConfiguration(r){const{added:w,updated:s,removed:n,overrides:g}=(0,t.compare)(this.remoteUserConfiguration,r);let l=[...w,...s,...n];return l.length&&this.updateRemoteUserConfiguration(r),{keys:l,overrides:g}}compareAndUpdateWorkspaceConfiguration(r){const{added:w,updated:s,removed:n,overrides:g}=(0,t.compare)(this.workspaceConfiguration,r);let l=[...w,...s,...n];return l.length&&this.updateWorkspaceConfiguration(r),{keys:l,overrides:g}}compareAndUpdateFolderConfiguration(r,w){const s=this.folderConfigurations.get(r),{added:n,updated:g,removed:l,overrides:c}=(0,t.compare)(s,w);let b=[...n,...g,...l];return(b.length||!s)&&this.updateFolderConfiguration(r,w),{keys:b,overrides:c}}compareAndDeleteFolderConfiguration(r){const w=this.folderConfigurations.get(r);if(!w)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:s,updated:n,removed:g,overrides:l}=(0,t.compare)(w,void 0);return{keys:[...s,...n,...g],overrides:l}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(r,w){let s=this.getConsolidatedConfigurationModelForResource(r,w);return r.overrideIdentifier?s.override(r.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:r},w){let s=this.getWorkspaceConsolidatedConfiguration();if(w&&r){const n=w.getFolder(r);n&&(s=this.getFolderConsolidatedConfiguration(n.uri)||s);const g=this._memoryConfigurationByResource.get(r);g&&(s=s.merge(g))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let w=this._foldersConsolidatedConfigurations.get(r);if(!w){const s=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(r);n?(w=s.merge(n),this._freeze&&(w=w.freeze()),this._foldersConsolidatedConfigurations.set(r,w)):w=s}return w}getFolderConfigurationModelForResource(r,w){if(w&&r){const s=w.getFolder(r);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,w)=>{const{contents:s,overrides:n,keys:g}=this._folderConfigurations.get(w);return r.push([w,{contents:s,overrides:n,keys:g}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(w=>r.add(w)),this.userConfiguration.freeze().keys.forEach(w=>r.add(w)),this._workspaceConfiguration.freeze().keys.forEach(w=>r.add(w)),this._folderConfigurations.forEach(w=>w.freeze().keys.forEach(s=>r.add(s))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const w=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>w.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>w.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>w.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(r).forEach(n=>w.add(n))),[...w.values()]}static parse(r){const w=this.parseConfigurationModel(r.defaults),s=this.parseConfigurationModel(r.user),n=this.parseConfigurationModel(r.workspace),g=r.folders.reduce((l,c)=>(l.set(A.URI.revive(c[0]),this.parseConfigurationModel(c[1])),l),new F.ResourceMap);return new S(w,s,new m,n,g,new m,new F.ResourceMap,!1)}static parseConfigurationModel(r){return new m(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=S;function v(...D){if(D.length===0)return{keys:[],overrides:[]};if(D.length===1)return D[0];const r=new Set,w=new Map;for(const n of D)n.keys.forEach(g=>r.add(g)),n.overrides.forEach(([g,l])=>{const c=(0,F.getOrSet)(w,g,new Set);l.forEach(b=>c.add(b))});const s=[];return w.forEach((n,g)=>s.push([g,[...n.values()]])),{keys:[...r.values()],overrides:s}}e.mergeChanges=v;class o{constructor(r,w,s,n){this.change=r,this.previous=w,this.currentConfiguraiton=s,this.currentWorkspace=n,this._previousConfiguration=void 0;const g=new Set;r.keys.forEach(c=>g.add(c)),r.overrides.forEach(([,c])=>c.forEach(b=>g.add(b))),this.affectedKeys=[...g.values()];const l=new m;this.affectedKeys.forEach(c=>l.setValue(c,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=S.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,w){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(w){const s=this.previousConfiguration?this.previousConfiguration.getValue(r,w,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(r,w,this.currentWorkspace);return!T.equals(s,n)}return!0}return!1}doesAffectedKeysTreeContains(r,w){let s=(0,t.toValuesTree)({[w]:!0},()=>{}),n;for(;typeof s=="object"&&(n=Object.keys(s)[0]);){if(r=r[n],!r)return!1;s=s[n]}return!0}}e.ConfigurationChangeEvent=o;class d extends o{constructor(r,w,s,n){super({keys:r.allKeys(),overrides:[]},void 0,r,w);this.source=s,this.sourceConfig=n}}e.AllKeysConfigurationChangeEvent=d}),define(we[86],be([0,1,4]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,u.createDecorator)("remoteAuthorityResolverService");var M;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(M=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class E extends Error{constructor(F,T=M.Unknown,C){super(F);this._message=F,this._code=T,this._detail=C,this.isHandled=T===M.NotAvailable&&C===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,E.prototype)}static isTemporarilyNotAvailable(F){return F instanceof E&&F._code===M.TemporarilyNotAvailable}static isNoResolverFound(F){return F instanceof E&&F._code===M.NoResolverFound}static isHandled(F){return F instanceof E&&F.isHandled}}e.RemoteAuthorityResolverError=E}),define(we[64],be([0,1,11]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function M(A){return A.scheme===u.Schemas.vscodeRemote?A.authority:void 0}e.getRemoteAuthority=M;function E(A){if(!A)return;const t=A.indexOf("+");return t<0?A:A.substr(0,t)}e.getRemoteName=E;function P(A){return A.scheme!==u.Schemas.file&&A.scheme!==u.Schemas.vscodeRemote}e.isVirtualResource=P;function F(A){if(A.folders.length)return A.folders.every(t=>P(t.uri))?A.folders[0].uri:void 0;if(A.configuration&&P(A.configuration))return A.configuration}e.getVirtualWorkspaceLocation=F;function T(A){return F(A)?.scheme}e.getVirtualWorkspaceScheme=T;function C(A){return F(A)!==void 0}e.isVirtualWorkspace=C}),define(we[26],be([0,1,9,4,64]),function(re,e,u,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function P(i){if(typeof i=="object"&&i!==null&&i.supported!==!0)return i.description}e.getWorkspaceSupportTypeMessage=P;function F(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=F,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));class C{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,a){if(typeof m=="undefined"||m===null)return typeof a=="undefined"||a===null;if(typeof a=="undefined"||a===null)return!1;if(typeof m=="string"||typeof a=="string"){let f=typeof m=="string"?m:m.value,p=typeof a=="string"?a:a.value;return u.equalsIgnoreCase(f,p)}return m._lower===a._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.ExtensionIdentifier=C;function A(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=A;function t(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=t;function _(i,m){if(m&&i.enableProposedApi){const a=`onResolveRemoteAuthority:${(0,E.getRemoteName)(m)}`;return i.activationEvents?.indexOf(a)!==-1}return!1}e.isResolverExtension=_,e.IBuiltinExtensionsScannerService=(0,M.createDecorator)("IBuiltinExtensionsScannerService")}),define(we[149],be([0,1,9,26]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function E(a,f){return a.uuid&&f.uuid?a.uuid===f.uuid:a.id===f.id?!0:(0,u.compareIgnoreCase)(a.id,f.id)===0}e.areSameExtensions=E;class P{constructor(f,p){this.version=p,this.id=f.id,this.uuid=f.uuid}key(){return`${this.id}-${this.version}`}equals(f){return f instanceof P?E(this,f)&&this.version===f.version:!1}}e.ExtensionIdentifierWithVersion=P;function F(a,f){return`${a}.${f}`}e.getExtensionId=F;function T(a){return a.toLocaleLowerCase()}e.adoptToGalleryExtensionId=T;function C(a,f){return T(F(a,f))}e.getGalleryExtensionId=C;function A(a,f){const p=[],S=v=>{for(const o of p)if(o.some(d=>E(f(d),f(v))))return o;return null};for(const v of a){const o=S(v);o?o.push(v):p.push([v])}return p}e.groupByExtension=A;function t(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=t;function _(a){return{id:a.identifier.id,name:a.name,galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),...a.telemetryData}}e.getGalleryExtensionTelemetryData=_,e.BetterMergeId=new M.ExtensionIdentifier("pprice.better-merge");function i(a){const f=new Set;for(const p of a)p.malicious&&f.add(p.id.id);return f}e.getMaliciousExtensionsSet=i;function m(a,f){const p=[],S=f.manifest.extensionDependencies?.slice(0)??[];for(;S.length;){const v=S.shift();if(v&&p.every(o=>!E(o.identifier,{id:v}))){const o=a.filter(d=>E(d.identifier,{id:v}));o.length===1&&(p.push(o[0]),S.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return p}e.getExtensionDependencies=m}),define(we[150],be([0,1,3,25,4,12]),function(re,e,u,M,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,E.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,E.createDecorator)("sharedTunnelsService");var F;(function(a){a.Http="http",a.Https="https"})(F=e.TunnelProtocol||(e.TunnelProtocol={}));var T;(function(a){a.ConstantPrivate="constantPrivate",a.Private="private",a.Public="public"})(T=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var C;(function(a){a[a.Notify=1]="Notify",a[a.OpenBrowser=2]="OpenBrowser",a[a.OpenPreview=3]="OpenPreview",a[a.Silent=4]="Silent",a[a.Ignore=5]="Ignore",a[a.OpenBrowserOnce=6]="OpenBrowserOnce"})(C=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function A(a){if(a.scheme!=="http"&&a.scheme!=="https")return;const f=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(a.authority);if(!!f)return{address:f[1],port:+f[2]}}e.extractLocalHostUriMetaDataForPortMapping=A,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function t(a){return e.LOCALHOST_ADDRESSES.indexOf(a)>=0}e.isLocalhost=t,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function _(a){return e.ALL_INTERFACES_ADDRESSES.indexOf(a)>=0}e.isAllInterfaces=_;function i(a,f){return f?f!==1&&a<1024:!M.isWindows&&a<1024}e.isPortPrivileged=i;let m=class{constructor(f){this.logService=f,this._onTunnelOpened=new u.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new u.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new u.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(f,p){return this._tunnelProvider=f,f?(this._canElevate=p.elevation,this._privacyOptions=p.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const f=[],p=Array.from(this._tunnels.values());for(let S of p){const v=Array.from(S.values());for(let o of v){const d=await o.value;d&&f.push(d)}}return f}async dispose(){for(const f of this._tunnels.values()){for(const{value:p}of f.values())await p.then(S=>S?.dispose());f.clear()}this._tunnels.clear()}openTunnel(f,p,S,v,o=!1,d=T.Private,D){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${p}:${S} on local port ${v}.`),!f)return;p||(p="localhost");const r=this.retainOrCreateTunnel(f,p,S,v,o,d,D);return r?r.then(w=>{if(!w){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(p,S);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(w);return(w.tunnelRemoteHost!==p||w.tunnelRemotePort!==S)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(f){return{tunnelRemotePort:f.tunnelRemotePort,tunnelRemoteHost:f.tunnelRemoteHost,tunnelLocalPort:f.tunnelLocalPort,localAddress:f.localAddress,privacy:f.privacy,protocol:f.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${f.tunnelRemoteHost}:${f.tunnelRemotePort} `);const p=this._tunnels.get(f.tunnelRemoteHost);if(p){const S=p.get(f.tunnelRemotePort);S&&(S.refcount--,await this.tryDisposeTunnel(f.tunnelRemoteHost,f.tunnelRemotePort,S))}}}}async tryDisposeTunnel(f,p,S){if(S.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${f}:${p}.`);const v=S.value.then(async o=>{o&&(await o.dispose(!0),this._onTunnelClosed.fire({host:o.tunnelRemoteHost,port:o.tunnelRemotePort}))});return this._tunnels.has(f)&&this._tunnels.get(f).delete(p),v}}async closeTunnel(f,p){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${f}:${p} `);const S=this._tunnels.get(f);if(S&&S.has(p)){const v=S.get(p);v.refcount=0,await this.tryDisposeTunnel(f,p,v)}}addTunnelToMap(f,p,S){this._tunnels.has(f)||this._tunnels.set(f,new Map),this._tunnels.get(f).set(p,{refcount:1,value:S})}async removeEmptyTunnelFromMap(f,p){const S=this._tunnels.get(f);S&&(await S.get(p)||S.delete(p),S.size===0&&this._tunnels.delete(f))}getTunnelFromMap(f,p){let S=[f];t(f)?(S.push(...e.LOCALHOST_ADDRESSES),S.push(...e.ALL_INTERFACES_ADDRESSES)):_(f)&&S.push(...e.ALL_INTERFACES_ADDRESSES);const v=S.map(o=>this._tunnels.get(o));for(const o of v){const d=o?.get(p);if(d)return d}}canTunnel(f){return!!A(f)}createWithProvider(f,p,S,v,o,d,D){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${p}:${S} on local port ${v}.`);const w={elevationRequired:o?i(v===void 0?S:v):!1},s={remoteAddress:{host:p,port:S},localAddressPort:v,privacy:d,public:d!==T.Private,protocol:D},n=f.forwardPort(s,w);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),n&&this.addTunnelToMap(p,S,n),n}};m=Ue([Be(0,P.ILogService)],m),e.AbstractTunnelService=m}),define(we[151],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class u{constructor(E){this._callback=E,this._terminalBufferMap=new Map}dispose(){for(const E of this._terminalBufferMap.values())E.dispose()}startBuffering(E,P,F=5){let T;return T=P(C=>{const A=typeof C=="string"?C:C.data;let t=this._terminalBufferMap.get(E);if(t){t.data.push(A);return}const _=setTimeout(()=>this.flushBuffer(E),F);t={data:[A],timeoutId:_,dispose:()=>{clearTimeout(_),this.flushBuffer(E),T.dispose()}},this._terminalBufferMap.set(E,t)}),T}stopBuffering(E){const P=this._terminalBufferMap.get(E);P&&P.dispose()}flushBuffer(E){const P=this._terminalBufferMap.get(E);P&&(this._terminalBufferMap.delete(E),this._callback(E,P.data.join("")))}}e.TerminalDataBufferer=u}),define(we[152],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var u;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST="hc"})(u=e.ColorScheme||(e.ColorScheme={}))}),define(we[48],be([0,1,35,3,6,4,29,152]),function(re,e,u,M,E,P,F,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,P.createDecorator)("themeService");var C;(function(p){function S(v){return v&&typeof v=="object"&&typeof v.id=="string"}p.isThemeColor=S})(C=e.ThemeColor||(e.ThemeColor={}));function A(p){return{id:p}}e.themeColorFromId=A;var t;(function(p){function S(w){return w&&typeof w=="object"&&typeof w.id=="string"&&(typeof w.color=="undefined"||C.isThemeColor(w.color))}p.isThemeIcon=S;const v=new RegExp(`^\\$\\((${u.CSSIcon.iconNameExpression}(?:${u.CSSIcon.iconModifierExpression})?)\\)$`);function o(w){const s=v.exec(w);if(!s)return;let[,n]=s;return{id:n}}p.fromString=o;function d(w,s){let n=w.id;const g=n.lastIndexOf("~");return g!==-1&&(n=n.substring(0,g)),s&&(n=`${n}~${s}`),{id:n}}p.modify=d;function D(w,s){return w.id===s.id&&w.color?.id===s.color?.id}p.isEqual=D;function r(w,s){return{id:w.id,color:s?A(s):void 0}}p.asThemeIcon=r,p.asClassNameArray=u.CSSIcon.asClassNameArray,p.asClassName=u.CSSIcon.asClassName,p.asCSSSelector=u.CSSIcon.asCSSSelector})(t=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=u.Codicon.file,e.FolderThemeIcon=u.Codicon.folder;function _(p){switch(p){case T.ColorScheme.DARK:return"vs-dark";case T.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=_,e.Extensions={ThemingContribution:"base.contributions.theming"};class i{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new M.Emitter}onColorThemeChange(S){return this.themingParticipants.push(S),this.onThemingParticipantAddedEmitter.fire(S),(0,E.toDisposable)(()=>{const v=this.themingParticipants.indexOf(S);this.themingParticipants.splice(v,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let m=new i;F.Registry.add(e.Extensions.ThemingContribution,m);function a(p){return m.onColorThemeChange(p)}e.registerThemingParticipant=a;class f extends E.Disposable{constructor(S){super();this.themeService=S,this.theme=S.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(v=>this.onThemeChange(v)))}onThemeChange(S){this.theme=S,this.updateStyles()}updateStyles(){}getColor(S,v){let o=this.theme.getColor(S);return o&&v&&(o=v(o,this.theme)),o?o.toString():null}}e.Themable=f}),define(we[153],be([0,1,13,35,3,124,84,29,48]),function(re,e,u,M,E,P,F,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class A{constructor(){this._onDidChange=new E.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,P.localize)(0,null)},fontCharacter:{type:"string",description:(0,P.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${M.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(S,v,o,d){const D=this.iconsById[S];if(D){if(o&&!D.description){D.description=o,this.iconSchema.properties[S].markdownDescription=`${o} $(${S})`;const s=this.iconReferenceSchema.enum.indexOf(S);s!==-1&&(this.iconReferenceSchema.enumDescriptions[s]=o),this._onDidChange.fire()}return D}let r={id:S,description:o,defaults:v,deprecationMessage:d};this.iconsById[S]=r;let w={$ref:"#/definitions/icons"};return d&&(w.deprecationMessage=d),o&&(w.markdownDescription=`${o}: $(${S})`),this.iconSchema.properties[S]=w,this.iconReferenceSchema.enum.push(S),this.iconReferenceSchema.enumDescriptions.push(o||""),this._onDidChange.fire(),{id:S}}deregisterIcon(S){delete this.iconsById[S],delete this.iconSchema.properties[S];const v=this.iconReferenceSchema.enum.indexOf(S);v!==-1&&(this.iconReferenceSchema.enum.splice(v,1),this.iconReferenceSchema.enumDescriptions.splice(v,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(S=>this.iconsById[S])}getIcon(S){return this.iconsById[S]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(S,v){const o=this.iconFontsById[S];if(o)return o;let d={id:S,definition:v};return this.iconFontsById[S]=d,this._onDidChange.fire(),d}deregisterIconFont(S){delete this.iconFontsById[S]}getIconFonts(){return Object.keys(this.iconFontsById).map(S=>this.iconFontsById[S])}getIconFont(S){return this.iconFontsById[S]}toString(){const S=(D,r)=>D.id.localeCompare(r.id),v=D=>{for(;C.ThemeIcon.isThemeIcon(D.defaults);)D=this.iconsById[D.defaults.id];return`codicon codicon-${D?D.id:""}`};let o=[];o.push("| preview     | identifier                        | default codicon ID                | description"),o.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const d=Object.keys(this.iconsById).map(D=>this.iconsById[D]);for(const D of d.filter(r=>!!r.description).sort(S))o.push(`|<i class="${v(D)}"></i>|${D.id}|${C.ThemeIcon.isThemeIcon(D.defaults)?D.defaults.id:D.id}|${D.description||""}|`);o.push("| preview     | identifier                        "),o.push("| ----------- | --------------------------------- |");for(const D of d.filter(r=>!C.ThemeIcon.isThemeIcon(r.defaults)).sort(S))o.push(`|<i class="${v(D)}"></i>|${D.id}|`);return o.join(`
`)}}const t=new A;T.Registry.add(e.Extensions.IconContribution,t);function _(p,S,v,o){return t.registerIcon(p,S,v,o)}e.registerIcon=_;function i(){return t}e.getIconRegistry=i;function m(){for(const p of M.iconRegistry.all)t.registerIcon(p.id,p.definition,p.description);M.iconRegistry.onDidRegister(p=>t.registerIcon(p.id,p.definition,p.description))}m(),e.iconsSchemaId="vscode://schemas/icons";let a=T.Registry.as(F.Extensions.JSONContribution);a.registerSchema(e.iconsSchemaId,t.getIconSchema());const f=new u.RunOnceScheduler(()=>a.notifySchemaChanged(e.iconsSchemaId),200);t.onDidChange(()=>{f.isScheduled()||f.schedule()}),e.widgetClose=_("widget-close",M.Codicon.close,(0,P.localize)(2,null)),e.gotoPreviousLocation=_("goto-previous-location",M.Codicon.arrowUp,(0,P.localize)(3,null)),e.gotoNextLocation=_("goto-next-location",M.Codicon.arrowDown,(0,P.localize)(4,null)),e.syncing=C.ThemeIcon.modify(M.Codicon.sync,"spin")}),define(we[49],be([0,1,20,24,2,4]),function(re,e,u,M,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");var F;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(F=e.WorkbenchState||(e.WorkbenchState={}));function T(i){const m=i;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.isWorkspace=T;function C(i){const m=i;return!!(m&&typeof m=="object"&&E.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.isWorkspaceFolder=C;class A{constructor(m,a,f,p,S){this._id=m,this._transient=f,this._configuration=p,this._ignorePathCasing=S,this._foldersMap=u.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=a}update(m){this._id=m.id,this._configuration=m.configuration,this._transient=m.transient,this._ignorePathCasing=m._ignorePathCasing,this.folders=m.folders}get folders(){return this._folders}set folders(m){this._folders=m,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(m){this._configuration=m}getFolder(m){return m&&this._foldersMap.findSubstr(m.with({scheme:m.scheme,authority:m.authority,path:m.path}))||null}updateFoldersMap(){this._foldersMap=u.TernarySearchTree.forUris(this._ignorePathCasing);for(const m of this.folders)this._foldersMap.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=A;class t{constructor(m,a){this.raw=a,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,M.joinPath)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=t;function _(i){return new t({uri:i,index:0,name:(0,M.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=_}),define(we[65],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class u{constructor(E){this.id=E,this._data=new Map,this._idPool=1}add(E){const P=this._idPool++;return this._data.set(P,E),this.logDebugInfo(),P}get(E,P){return this._data.has(E)?this._data.get(E)[P]:void 0}delete(E){this._data.delete(E),this.logDebugInfo()}logDebugInfo(){!u.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=u,u.enableDebugLogging=!1}),define(we[31],be([0,1,11,24,4]),function(re,e,u,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class P{constructor(){this._systemSchemes=new Set(Object.keys(u.Schemas)),this._providerInfo=new Map,this.extUri=new M.ExtUri(T=>{const C=this._providerInfo.get(T.scheme);return!(C===void 0||C&1024)})}$acceptProviderInfos(T,C){C===null?this._providerInfo.delete(T):this._providerInfo.set(T,C)}isFreeScheme(T){return!this._providerInfo.has(T)&&!this._systemSchemes.has(T)}getCapabilities(T){return this._providerInfo.get(T)}}e.ExtHostFileSystemInfo=P,e.IExtHostFileSystemInfo=(0,E.createDecorator)("IExtHostFileSystemInfo")}),define(we[27],be([0,1,4]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,u.createDecorator)("IExtHostInitDataService")}),define(we[154],be([0,1,12,27]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let E=class extends u.LogService{constructor(F,T){super(F.createLogger(T.logFile))}};E=Ue([Be(0,u.ILoggerService),Be(1,M.IExtHostInitDataService)],E),e.ExtHostLogService=E}),define(we[155],be([0,1,13]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class M{constructor(F,T,C){this._deferredPromises=new Map,this._id=F,this._shared=T,this._storage=C,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(A=>(this._value=A,this)),this._storageListener=this._storage.onDidChangeStorage(A=>{A.shared===this._shared&&A.key===this._id&&(this._value=A.value)}),this._scheduler=new u.RunOnceScheduler(()=>{const A=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const t of A.values())t.complete()}catch(t){for(const _ of A.values())_.error(t)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,F])=>F!==void 0).map(([F])=>F)}get whenReady(){return this._init}get(F,T){let C=this._value[F];return typeof C=="undefined"&&(C=T),C}update(F,T){this._value[F]=T;let C=this._deferredPromises.get(F);if(C!==void 0)return C.p;const A=new u.DeferredPromise;return this._deferredPromises.set(F,A),this._scheduler.isScheduled()||this._scheduler.schedule(),A.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=M;class E extends M{constructor(F,T){super(F.identifier.value,!0,T);this._extension=F}setKeysForSync(F){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},F)}}e.ExtensionGlobalMemento=E}),define(we[156],be([0,1,3,2,12]),function(re,e,u,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let P=class{constructor(T,C){this._logService=T,this._notebooksAndEditors=C,this._onDidChangeNotebookDocumentMetadata=new u.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new u.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(T,C,A){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(T)).acceptModelChanged(C.value,A)}$acceptDirtyStateChanged(T,C){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(T)).acceptDirty(C)}$acceptModelSaved(T){const C=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(T));this._onDidSaveNotebookDocument.fire(C.apiNotebook)}$acceptDocumentPropertiesChanged(T,C){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",T.path,C);const A=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(T));A.acceptDocumentPropertiesChanged(C),C.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:A.apiNotebook})}};P=Ue([Be(0,E.ILogService)],P),e.ExtHostNotebookDocuments=P}),define(we[14],be([0,1,4]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,u.createDecorator)("IExtHostRpcService");class M{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.ExtHostRpcService=M});var Ze=this&&this.__classPrivateFieldSet||function(re,e,u,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,u):E?E.value=u:e.set(re,u),u},Te=this&&this.__classPrivateFieldGet||function(re,e,u,M){if(u==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?M:u==="a"?M.call(re):M?M.value:e.get(re)};define(we[157],be([0,1,26,3]),function(re,e,u,M){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class P{constructor(T,C){E.set(this,void 0),this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._id=u.ExtensionIdentifier.toKey(T.identifier),Ze(this,E,C,"f"),Te(this,E,"f").onDidChangePassword(A=>{A.extensionId===this._id&&this._onDidChange.fire({key:A.key})})}get(T){return Te(this,E,"f").get(this._id,T)}store(T,C){return Te(this,E,"f").store(this._id,T,C)}delete(T){return Te(this,E,"f").delete(this._id,T)}}e.ExtensionSecrets=P,E=new WeakMap}),define(we[87],be([0,1,4,3]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class E{constructor(){this._onDidChangeTelemetryEnabled=new M.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(F){this._enabled=F}$onDidChangeTelemetryEnabled(F){this._enabled=F,this._onDidChangeTelemetryEnabled.fire(F)}}e.ExtHostTelemetry=E,e.IExtHostTelemetry=(0,u.createDecorator)("IExtHostTelemetry")}),define(we[50],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var u;(function(v){v[v.Upsert=0]="Upsert",v[v.RemoveChild=1]="RemoveChild",v[v.Invalidated=2]="Invalidated",v[v.SetProp=3]="SetProp",v[v.Bulk=4]="Bulk"})(u=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const M=new WeakMap,E=(v,o)=>{const d={controllerId:o};return M.set(v,d),d};e.createPrivateApiFor=E;const P=v=>M.get(v);e.getPrivateApiFor=P;const F=(v,o,d,D)=>{let r=d;return{enumerable:!0,configurable:!1,get(){return r},set(w){if(!D(r,w)){const s=r;r=w,v.listener?.({op:3,key:o,value:w,previous:s})}}}},T=(v,o)=>v===o,C={range:(v,o)=>v===o?!0:!v||!o?!1:v.isEqual(o),label:T,description:T,busy:T,error:T,canResolveChildren:T,tags:(v,o)=>!(v.length!==o.length||v.some(d=>!o.find(D=>d.id===D.id)))},A=Object.keys(C),t=(v,o)=>({range:F(v,"range",void 0,C.range),label:F(v,"label",o,C.label),description:F(v,"description",void 0,C.description),canResolveChildren:F(v,"canResolveChildren",!1,C.canResolveChildren),busy:F(v,"busy",!1,C.busy),error:F(v,"error",void 0,C.error),tags:F(v,"tags",[],C.tags)}),_=(v,o)=>{const d=new Map;for(const D of A)C[D](v[D],o[D])||d.set(D,o[D]);return d};e.diffTestItems=_;class i extends Error{constructor(o){super(`Attempted to insert a duplicate test item ID ${o}`)}}e.DuplicateTestItemError=i;class m extends Error{constructor(o){super(`TestItem with ID "${o}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=m;class a extends Error{constructor(o,d,D){super(`TestItem with ID "${o}" is from controller "${d}" and cannot be added as a child of an item from controller "${D}".`)}}e.MixedTestItemController=a;const f=v=>{const o=(0,e.getPrivateApiFor)(v);let d=new Map;return{get size(){return d.size},forEach(D,r){for(const w of d.values())D.call(r,w,this)},replace(D){const r=new Map,w=new Set(d.keys()),s={op:4,ops:[]};for(const n of D){if(!(n instanceof p))throw new m(n.id);const g=(0,e.getPrivateApiFor)(n).controllerId;if(g!==o.controllerId)throw new a(n.id,g,o.controllerId);if(r.has(n.id))throw new i(n.id);r.set(n.id,n),w.delete(n.id),s.ops.push({op:0,item:n})}for(const n of w.keys())s.ops.push({op:1,id:n});o.listener?.(s),d=r},add(D){if(!(D instanceof p))throw new m(D.id);d.set(D.id,D),o.listener?.({op:0,item:D})},delete(D){d.delete(D)&&o.listener?.({op:1,id:D})},get(D){return d.get(D)},toJSON(){return Array.from(d.values())},[Symbol.iterator](){return d.values()}}};class p{constructor(o,d,D,r){if(d.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(d)} symbol`);const w=(0,e.createPrivateApiFor)(this,o);Object.defineProperties(this,{id:{value:d,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return w.parent instanceof S?void 0:w.parent}},children:{value:f(this),enumerable:!0,writable:!1},...t(w,D)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=p;class S extends p{constructor(o,d){super(o,o,d,void 0)}}e.TestItemRootImpl=S}),define(we[66],be([0,1,4,150,3,14]),function(re,e,u,M,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var F;(function(C){function A(_){return{remoteAddress:_.remoteAddress,localAddress:_.localAddress,public:!!_.public,privacy:_.privacy??(_.public?M.TunnelPrivacyId.Public:M.TunnelPrivacyId.Private),protocol:_.protocol}}C.fromApiTunnel=A;function t(_){return{remoteAddress:{host:_.tunnelRemoteHost,port:_.tunnelRemotePort},localAddress:_.localAddress,public:_.privacy!==M.TunnelPrivacyId.ConstantPrivate&&_.privacy!==M.TunnelPrivacyId.ConstantPrivate,privacy:_.privacy,protocol:_.protocol}}C.fromServiceTunnel=t})(F=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,u.createDecorator)("IExtHostTunnelService");let T=class{constructor(A){this.onDidChangeTunnels=new E.Emitter().event}async $applyCandidateFilter(A){return A}async openTunnel(A,t){}async getTunnels(){return[]}async setTunnelExtensionFunctions(A){return{dispose:()=>{}}}registerPortsAttributesProvider(A,t){return{dispose:()=>{}}}async $providePortAttributes(A,t,_,i,m){return[]}async $forwardPort(A,t){}async $closeTunnel(A){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};T=Ue([Be(0,P.IExtHostRpcService)],T),e.ExtHostTunnelService=T});var Ze=this&&this.__classPrivateFieldSet||function(re,e,u,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,u):E?E.value=u:e.set(re,u),u},Te=this&&this.__classPrivateFieldGet||function(re,e,u,M){if(u==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?M:u==="a"?M.call(re):M?M.value:e.get(re)};define(we[7],be([0,1,15,16,77,20,79,9,10,2,37,47,86]),function(re,e,u,M,E,P,F,T,C,A,t,_,i){"use strict";var m,a,f,p,S,v,o,d,D,r,w,s,n,g,l,c,b,h,y,R;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function I(U){function O(){return Reflect.construct(U,arguments,this.constructor)}return Object.defineProperty(O,"name",Object.getOwnPropertyDescriptor(U,"name")),Object.setPrototypeOf(O,U),Object.setPrototypeOf(O.prototype,U.prototype),O}let B=S=class{constructor(O){m.set(this,void 0),Ze(this,m,O,"f")}static from(...O){let te=O;return new S(function(){if(te){for(const Ee of te)Ee&&typeof Ee.dispose=="function"&&Ee.dispose();te=void 0}})}dispose(){typeof Te(this,m,"f")=="function"&&(Te(this,m,"f").call(this),Ze(this,m,void 0,"f"))}};m=new WeakMap,B=S=Ue([I],B),e.Disposable=B;let L=v=class{constructor(O,te){if(O<0)throw(0,M.illegalArgument)("line must be non-negative");if(te<0)throw(0,M.illegalArgument)("character must be non-negative");this._line=O,this._character=te}static Min(...O){if(O.length===0)throw new TypeError;let te=O[0];for(let Ee=1;Ee<O.length;Ee++){const Ve=O[Ee];Ve.isBefore(te)&&(te=Ve)}return te}static Max(...O){if(O.length===0)throw new TypeError;let te=O[0];for(let Ee=1;Ee<O.length;Ee++){const Ve=O[Ee];Ve.isAfter(te)&&(te=Ve)}return te}static isPosition(O){if(!O)return!1;if(O instanceof v)return!0;let{line:te,character:Ee}=O;return typeof te=="number"&&typeof Ee=="number"}get line(){return this._line}get character(){return this._character}isBefore(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<O._character}isBeforeOrEqual(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<=O._character}isAfter(O){return!this.isBeforeOrEqual(O)}isAfterOrEqual(O){return!this.isBefore(O)}isEqual(O){return this._line===O._line&&this._character===O._character}compareTo(O){return this._line<O._line?-1:this._line>O.line?1:this._character<O._character?-1:this._character>O._character?1:0}translate(O,te=0){if(O===null||te===null)throw(0,M.illegalArgument)();let Ee;return typeof O=="undefined"?Ee=0:typeof O=="number"?Ee=O:(Ee=typeof O.lineDelta=="number"?O.lineDelta:0,te=typeof O.characterDelta=="number"?O.characterDelta:0),Ee===0&&te===0?this:new v(this.line+Ee,this.character+te)}with(O,te=this.character){if(O===null||te===null)throw(0,M.illegalArgument)();let Ee;return typeof O=="undefined"?Ee=this.line:typeof O=="number"?Ee=O:(Ee=typeof O.line=="number"?O.line:this.line,te=typeof O.character=="number"?O.character:this.character),Ee===this.line&&te===this.character?this:new v(Ee,te)}toJSON(){return{line:this.line,character:this.character}}};L=v=Ue([I],L),e.Position=L;let k=o=class{constructor(O,te,Ee,Ve){let tt,at;if(typeof O=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ve=="number"?(tt=new L(O,te),at=new L(Ee,Ve)):O instanceof L&&te instanceof L&&(tt=O,at=te),!tt||!at)throw new Error("Invalid arguments");tt.isBefore(at)?(this._start=tt,this._end=at):(this._start=at,this._end=tt)}static isRange(O){return O instanceof o?!0:O?L.isPosition(O.start)&&L.isPosition(O.end):!1}get start(){return this._start}get end(){return this._end}contains(O){return O instanceof o?this.contains(O._start)&&this.contains(O._end):O instanceof L?!(O.isBefore(this._start)||this._end.isBefore(O)):!1}isEqual(O){return this._start.isEqual(O._start)&&this._end.isEqual(O._end)}intersection(O){const te=L.Max(O.start,this._start),Ee=L.Min(O.end,this._end);if(!te.isAfter(Ee))return new o(te,Ee)}union(O){if(this.contains(O))return this;if(O.contains(this))return O;const te=L.Min(O.start,this._start),Ee=L.Max(O.end,this.end);return new o(te,Ee)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(O,te=this.end){if(O===null||te===null)throw(0,M.illegalArgument)();let Ee;return O?L.isPosition(O)?Ee=O:(Ee=O.start||this.start,te=O.end||this.end):Ee=this.start,Ee.isEqual(this._start)&&te.isEqual(this.end)?this:new o(Ee,te)}toJSON(){return[this.start,this.end]}};k=o=Ue([I],k),e.Range=k;let x=d=class extends k{constructor(O,te,Ee,Ve){let tt,at;if(typeof O=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ve=="number"?(tt=new L(O,te),at=new L(Ee,Ve)):O instanceof L&&te instanceof L&&(tt=O,at=te),!tt||!at)throw new Error("Invalid arguments");super(tt,at);this._anchor=tt,this._active=at}static isSelection(O){return O instanceof d?!0:O?k.isRange(O)&&L.isPosition(O.anchor)&&L.isPosition(O.active)&&typeof O.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};x=d=Ue([I],x),e.Selection=x;class N{constructor(O,te,Ee){if(typeof O!="string"||O.length===0)throw(0,M.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,M.illegalArgument)("port");if(typeof Ee!="undefined"&&(typeof Ee!="string"||Ee.length===0||!/^[0-9A-Za-z\-]+$/.test(Ee)))throw(0,M.illegalArgument)("connectionToken");this.host=O,this.port=Math.round(te),this.connectionToken=Ee}}e.ResolvedAuthority=N;class V extends Error{constructor(O,te=i.RemoteAuthorityResolverErrorCode.Unknown,Ee){super(O);this._message=O,this._code=te,this._detail=Ee,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,V.prototype)}static NotAvailable(O,te){return new V(O,i.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(O){return new V(O,i.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=V;var W;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})(W=e.EndOfLine||(e.EndOfLine={}));var $;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})($=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let X=D=class{constructor(O,te){this._range=O,this._newText=te}static isTextEdit(O){return O instanceof D?!0:O?k.isRange(O)&&typeof O.newText=="string":!1}static replace(O,te){return new D(O,te)}static insert(O,te){return D.replace(new k(O,O),te)}static delete(O){return D.replace(O,"")}static setEndOfLine(O){const te=new D(new k(new L(0,0),new L(0,0)),"");return te.newEol=O,te}get range(){return this._range}set range(O){if(O&&!k.isRange(O))throw(0,M.illegalArgument)("range");this._range=O}get newText(){return this._newText||""}set newText(O){if(O&&typeof O!="string")throw(0,M.illegalArgument)("newText");this._newText=O}get newEol(){return this._newEol}set newEol(O){if(O&&typeof O!="number")throw(0,M.illegalArgument)("newEol");this._newEol=O}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};X=D=Ue([I],X),e.TextEdit=X;var j;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellReplace=5]="CellReplace"})(j=e.FileEditType||(e.FileEditType={}));let Q=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(O,te,Ee,Ve){this._edits.push({_type:1,from:O,to:te,options:Ee,metadata:Ve})}createFile(O,te,Ee){this._edits.push({_type:1,from:void 0,to:O,options:te,metadata:Ee})}deleteFile(O,te,Ee){this._edits.push({_type:1,from:O,to:void 0,options:te,metadata:Ee})}replaceNotebookMetadata(O,te,Ee){this._edits.push({_type:3,metadata:Ee,uri:O,edit:{editType:5,metadata:te},notebookMetadata:te})}replaceNotebookCells(O,te,Ee,Ve,tt){let at,ct,Ct=[],Rt;if(Vt.isNotebookRange(te)&&Lt.isNotebookCellDataArray(Ee)&&!Lt.isNotebookCellDataArray(Ve)?(at=te.start,ct=te.end,Ct=Ee,Rt=Ve):typeof te=="number"&&typeof Ee=="number"&&Lt.isNotebookCellDataArray(Ve)&&(at=te,ct=Ee,Ct=Ve,Rt=tt),at===void 0||ct===void 0)throw new Error("Invalid arguments");(at!==ct||Ct.length>0)&&this._edits.push({_type:5,uri:O,index:at,count:ct-at,cells:Ct,metadata:Rt})}replaceNotebookCellMetadata(O,te,Ee,Ve){this._edits.push({_type:3,metadata:Ve,uri:O,edit:{editType:8,index:te,metadata:Ee}})}replace(O,te,Ee,Ve){this._edits.push({_type:2,uri:O,edit:new X(te,Ee),metadata:Ve})}insert(O,te,Ee,Ve){this.replace(O,new k(te,te),Ee,Ve)}delete(O,te,Ee){this.replace(O,te,"",Ee)}has(O){return this._edits.some(te=>te._type===2&&te.uri.toString()===O.toString())}set(O,te){if(te)for(const Ee of te)Ee&&this._edits.push({_type:2,uri:O,edit:Ee});else{for(let Ee=0;Ee<this._edits.length;Ee++){const Ve=this._edits[Ee];Ve._type===2&&Ve.uri.toString()===O.toString()&&(this._edits[Ee]=void 0)}(0,u.coalesceInPlace)(this._edits)}}get(O){const te=[];for(let Ee of this._edits)Ee._type===2&&Ee.uri.toString()===O.toString()&&te.push(Ee.edit);return te}entries(){const O=new P.ResourceMap;for(let te of this._edits)if(te._type===2){let Ee=O.get(te.uri);Ee||(Ee=[te.uri,[]],O.set(te.uri,Ee)),Ee[1].push(te.edit)}return[...O.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Q=Ue([I],Q),e.WorkspaceEdit=Q;let ae=r=class{constructor(O){this._tabstop=1,this.value=O||""}static isSnippetString(O){return O instanceof r?!0:O?typeof O.value=="string":!1}static _escape(O){return O.replace(/\$|}|\\/g,"\\$&")}appendText(O){return this.value+=r._escape(O),this}appendTabstop(O=this._tabstop++){return this.value+="$",this.value+=O,this}appendPlaceholder(O,te=this._tabstop++){if(typeof O=="function"){const Ee=new r;Ee._tabstop=this._tabstop,O(Ee),this._tabstop=Ee._tabstop,O=Ee.value}else O=r._escape(O);return this.value+="${",this.value+=te,this.value+=":",this.value+=O,this.value+="}",this}appendChoice(O,te=this._tabstop++){const Ee=O.map(Ve=>Ve.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=Ee,this.value+="|}",this}appendVariable(O,te){if(typeof te=="function"){const Ee=new r;Ee._tabstop=this._tabstop,te(Ee),this._tabstop=Ee._tabstop,te=Ee.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=O,te&&(this.value+=":",this.value+=te),this.value+="}",this}};ae=r=Ue([I],ae),e.SnippetString=ae;var pe;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(pe=e.DiagnosticTag||(e.DiagnosticTag={}));var ce;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(ce=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Fe=w=class{constructor(O,te){if(this.uri=O,te)if(te instanceof k)this.range=te;else if(te instanceof L)this.range=new k(te,te);else throw new Error("Illegal argument")}static isLocation(O){return O instanceof w?!0:O?k.isRange(O.range)&&A.URI.isUri(O.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Fe=w=Ue([I],Fe),e.Location=Fe;let Qe=class{constructor(O,te){this.location=O,this.message=te}static is(O){return O?typeof O.message=="string"&&O.location&&k.isRange(O.location.range)&&A.URI.isUri(O.location.uri):!1}static isEqual(O,te){return O===te?!0:!O||!te?!1:O.message===te.message&&O.location.range.isEqual(te.location.range)&&O.location.uri.toString()===te.location.uri.toString()}};Qe=Ue([I],Qe),e.DiagnosticRelatedInformation=Qe;let Oe=class{constructor(O,te,Ee=ce.Error){if(!k.isRange(O))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=O,this.message=te,this.severity=Ee}toJSON(){return{severity:ce[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(O,te){return O===te?!0:!O||!te?!1:O.message===te.message&&O.severity===te.severity&&O.code===te.code&&O.severity===te.severity&&O.source===te.source&&O.range.isEqual(te.range)&&(0,u.equals)(O.tags,te.tags)&&(0,u.equals)(O.relatedInformation,te.relatedInformation,Qe.isEqual)}};Oe=Ue([I],Oe),e.Diagnostic=Oe;let He=class{constructor(O,te){if(!O)throw new Error("Illegal argument, contents must be defined");Array.isArray(O)?this.contents=O:this.contents=[O],this.range=te}};He=Ue([I],He),e.Hover=He;var Je;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(Je=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ye=class{constructor(O,te=Je.Text){this.range=O,this.kind=te}toJSON(){return{range:this.range,kind:Je[this.kind]}}};Ye=Ue([I],Ye),e.DocumentHighlight=Ye;var qe;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(qe=e.SymbolKind||(e.SymbolKind={}));var z;(function(U){U[U.Deprecated=1]="Deprecated"})(z=e.SymbolTag||(e.SymbolTag={}));let K=s=class{constructor(O,te,Ee,Ve,tt){this.name=O,this.kind=te,this.containerName=tt,typeof Ee=="string"&&(this.containerName=Ee),Ve instanceof Fe?this.location=Ve:Ee instanceof k&&(this.location=new Fe(Ve,Ee)),s.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:qe[this.kind],location:this.location,containerName:this.containerName}}};K=s=Ue([I],K),e.SymbolInformation=K;let Z=n=class{constructor(O,te,Ee,Ve,tt){this.name=O,this.detail=te,this.kind=Ee,this.range=Ve,this.selectionRange=tt,this.children=[],n.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy");if(!O.range.contains(O.selectionRange))throw new Error("selectionRange must be contained in fullRange");O.children&&O.children.forEach(n.validate)}};Z=n=Ue([I],Z),e.DocumentSymbol=Z;var se;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(se=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let G=class{constructor(O,te){this.title=O,this.kind=te}};G=Ue([I],G),e.CodeAction=G;let ie=g=class{constructor(O){this.value=O}append(O){return new g(this.value?this.value+g.sep+O:O)}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+g.sep)}};ie.sep=".",ie=g=Ue([I],ie),e.CodeActionKind=ie,ie.Empty=new ie(""),ie.QuickFix=ie.Empty.append("quickfix"),ie.Refactor=ie.Empty.append("refactor"),ie.RefactorExtract=ie.Refactor.append("extract"),ie.RefactorInline=ie.Refactor.append("inline"),ie.RefactorRewrite=ie.Refactor.append("rewrite"),ie.Source=ie.Empty.append("source"),ie.SourceOrganizeImports=ie.Source.append("organizeImports"),ie.SourceFixAll=ie.Source.append("fixAll");let de=class{constructor(O,te){if(this.range=O,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};de=Ue([I],de),e.SelectionRange=de;class Pe{constructor(O,te,Ee,Ve,tt,at){this.kind=O,this.name=te,this.detail=Ee,this.uri=Ve,this.range=tt,this.selectionRange=at}}e.CallHierarchyItem=Pe;class Ne{constructor(O,te){this.fromRanges=te,this.from=O}}e.CallHierarchyIncomingCall=Ne;class We{constructor(O,te){this.fromRanges=te,this.to=O}}e.CallHierarchyOutgoingCall=We;var je;(function(U){U[U.Information=0]="Information",U[U.Warning=1]="Warning",U[U.Error=2]="Error"})(je=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(O,te){this.range=O,this.command=te}get isResolved(){return!!this.command}};et=Ue([I],et),e.CodeLens=et;let ot=l=class{constructor(O,te=!1){a.set(this,void 0),Ze(this,a,new E.MarkdownString(O,{supportThemeIcons:te}),"f")}static isMarkdownString(O){return O instanceof l?!0:O&&O.appendCodeblock&&O.appendMarkdown&&O.appendText&&O.value!==void 0}get value(){return Te(this,a,"f").value}set value(O){Te(this,a,"f").value=O}get isTrusted(){return Te(this,a,"f").isTrusted}set isTrusted(O){Te(this,a,"f").isTrusted=O}get supportThemeIcons(){return Te(this,a,"f").supportThemeIcons}set supportThemeIcons(O){Te(this,a,"f").supportThemeIcons=O}get supportHtml(){return Te(this,a,"f").supportHtml}set supportHtml(O){Te(this,a,"f").supportHtml=O}appendText(O){return Te(this,a,"f").appendText(O),this}appendMarkdown(O){return Te(this,a,"f").appendMarkdown(O),this}appendCodeblock(O,te){return Te(this,a,"f").appendCodeblock(te??"",O),this}};a=new WeakMap,ot=l=Ue([I],ot),e.MarkdownString=ot;let _e=class{constructor(O,te){this.label=O,this.documentation=te}};_e=Ue([I],_e),e.ParameterInformation=_e;let nt=class{constructor(O,te){this.label=O,this.documentation=te,this.parameters=[]}};nt=Ue([I],nt),e.SignatureInformation=nt;let q=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};q=Ue([I],q),e.SignatureHelp=q;var J;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(J=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var ge;(function(U){U[U.Other=0]="Other",U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(ge=e.InlayHintKind||(e.InlayHintKind={}));let $e=class{constructor(O,te,Ee){this.text=O,this.position=te,this.kind=Ee}};$e=Ue([I],$e),e.InlayHint=$e;var Ge;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ge=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var rt;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(rt=e.CompletionItemKind||(e.CompletionItemKind={}));var ft;(function(U){U[U.Deprecated=1]="Deprecated"})(ft=e.CompletionItemTag||(e.CompletionItemTag={}));let ht=class{constructor(O,te){this.label=O,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&rt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ht=Ue([I],ht),e.CompletionItem=ht;let Dt=class{constructor(O=[],te=!1){this.items=O,this.isIncomplete=te}};Dt=Ue([I],Dt),e.CompletionList=Dt;let Tt=class{constructor(O,te,Ee){this.text=O,this.range=te,this.command=Ee}};Tt=Ue([I],Tt),e.InlineSuggestion=Tt;let It=class{constructor(O){this.items=O}};It=Ue([I],It),e.InlineSuggestions=It;var Xe;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(Xe=e.ViewColumn||(e.ViewColumn={}));var pt;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(pt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ie;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative"})(Ie=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ye;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(ye=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var De;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(De=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ee;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(ee=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var oe;(function(U){U[U.Undo=1]="Undo",U[U.Redo=2]="Redo"})(oe=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var fe;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(fe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(U){function O(te){switch(te){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=O}(ee=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let he=class{constructor(O,te){if(te&&!A.URI.isUri(te))throw(0,M.illegalArgument)("target");if(!k.isRange(O)||O.isEmpty)throw(0,M.illegalArgument)("range");this.range=O,this.target=te}};he=Ue([I],he),e.DocumentLink=he;let ke=class{constructor(O,te,Ee,Ve){this.red=O,this.green=te,this.blue=Ee,this.alpha=Ve}};ke=Ue([I],ke),e.Color=ke;let Le=class{constructor(O,te){if(te&&!(te instanceof ke))throw(0,M.illegalArgument)("color");if(!k.isRange(O)||O.isEmpty)throw(0,M.illegalArgument)("range");this.range=O,this.color=te}};Le=Ue([I],Le),e.ColorInformation=Le;let Me=class{constructor(O){if(!O||typeof O!="string")throw(0,M.illegalArgument)("label");this.label=O}};Me=Ue([I],Me),e.ColorPresentation=Me;var ze;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(ze=e.ColorFormat||(e.ColorFormat={}));var it;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(it=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Re{constructor(O,te,Ee){if(this.startIndex=O,this.length=te,this.tooltip=Ee,typeof O!="number"||O<0)throw(0,M.illegalArgument)("startIndex");if(typeof te!="number"||te<1)throw(0,M.illegalArgument)("length");if(Ee!==void 0&&typeof Ee!="string")throw(0,M.illegalArgument)("tooltip")}}e.TerminalLink=Re;var ue;(function(U){U[U.Panel=1]="Panel",U[U.Editor=2]="Editor"})(ue=e.TerminalLocation||(e.TerminalLocation={}));class me{constructor(O){this.options=O,typeof O!="object"&&(0,M.illegalArgument)("options")}}e.TerminalProfile=me;var ne;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(ne=e.TaskRevealKind||(e.TaskRevealKind={}));var H;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(H=e.TaskPanelKind||(e.TaskPanelKind={}));let ve=c=class{constructor(O,te){if(this.label=te,typeof O!="string"||typeof te!="string")throw(0,M.illegalArgument)("name");this._id=O}static from(O){switch(O){case"clean":return c.Clean;case"build":return c.Build;case"rebuild":return c.Rebuild;case"test":return c.Test;default:return}}get id(){return this._id}};ve.Clean=new c("clean","Clean"),ve.Build=new c("build","Build"),ve.Rebuild=new c("rebuild","Rebuild"),ve.Test=new c("test","Test"),ve=c=Ue([I],ve),e.TaskGroup=ve;function Ce(U){let O="";for(let te=0;te<U.length;te++)O+=U[te].replace(/,/g,",,")+",";return O}let Ke=class{constructor(O,te,Ee){if(typeof O!="string")throw(0,M.illegalArgument)("process");this._args=[],this._process=O,te!==void 0&&(Array.isArray(te)?(this._args=te,this._options=Ee):this._options=te)}get process(){return this._process}set process(O){if(typeof O!="string")throw(0,M.illegalArgument)("process");this._process=O}get args(){return this._args}set args(O){Array.isArray(O)||(O=[]),this._args=O}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("process"),this._process!==void 0&&O.push(this._process),this._args&&this._args.length>0)for(let te of this._args)O.push(te);return Ce(O)}};Ke=Ue([I],Ke),e.ProcessExecution=Ke;let xe=class{constructor(O,te,Ee){if(this._args=[],Array.isArray(te)){if(!O)throw(0,M.illegalArgument)("command can't be undefined or null");if(typeof O!="string"&&typeof O.value!="string")throw(0,M.illegalArgument)("command");this._command=O,this._args=te,this._options=Ee}else{if(typeof O!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=O,this._options=te}}get commandLine(){return this._commandLine}set commandLine(O){if(typeof O!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=O}get command(){return this._command?this._command:""}set command(O){if(typeof O!="string"&&typeof O.value!="string")throw(0,M.illegalArgument)("command");this._command=O}get args(){return this._args}set args(O){this._args=O||[]}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("shell"),this._commandLine!==void 0&&O.push(this._commandLine),this._command!==void 0&&O.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let te of this._args)O.push(typeof te=="string"?te:te.value);return Ce(O)}};xe=Ue([I],xe),e.ShellExecution=xe;var lt;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(lt=e.ShellQuoting||(e.ShellQuoting={}));var Et;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(Et=e.TaskScope||(e.TaskScope={}));class vt{constructor(O){this._callback=O}computeId(){return"customExecution"+(0,t.generateUuid)()}set callback(O){this._callback=O}get callback(){return this._callback}}e.CustomExecution=vt;let ut=b=class{constructor(O,te,Ee,Ve,tt,at){this.__deprecated=!1,this._definition=this.definition=O;let ct;typeof te=="string"?(this._name=this.name=te,this._source=this.source=Ee,this.execution=Ve,ct=tt,this.__deprecated=!0):te===Et.Global||te===Et.Workspace?(this.target=te,this._name=this.name=Ee,this._source=this.source=Ve,this.execution=tt,ct=at):(this.target=te,this._name=this.name=Ee,this._source=this.source=Ve,this.execution=tt,ct=at),typeof ct=="string"?(this._problemMatchers=[ct],this._hasDefinedMatchers=!0):Array.isArray(ct)?(this._problemMatchers=ct,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(O){this.__id=O}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ke?this._definition={type:b.ProcessType,id:this._execution.computeId()}:this._execution instanceof xe?this._definition={type:b.ShellType,id:this._execution.computeId()}:this._execution instanceof vt?this._definition={type:b.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:b.EmptyType,id:(0,t.generateUuid)()}}get definition(){return this._definition}set definition(O){if(O==null)throw(0,M.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=O}get scope(){return this._scope}set target(O){this.clear(),this._scope=O}get name(){return this._name}set name(O){if(typeof O!="string")throw(0,M.illegalArgument)("name");this.clear(),this._name=O}get execution(){return this._execution}set execution(O){O===null&&(O=void 0),this.clear(),this._execution=O;const te=this._definition.type;(b.EmptyType===te||b.ProcessType===te||b.ShellType===te||b.ExtensionCallbackType===te)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(O){if(Array.isArray(O))this.clear(),this._problemMatchers=O,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(O){O!==!0&&O!==!1&&(O=!1),this.clear(),this._isBackground=O}get source(){return this._source}set source(O){if(typeof O!="string"||O.length===0)throw(0,M.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=O}get group(){return this._group}set group(O){O===null&&(O=void 0),this.clear(),this._group=O}get detail(){return this._detail}set detail(O){O===null&&(O=void 0),this._detail=O}get presentationOptions(){return this._presentationOptions}set presentationOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._presentationOptions=O}get runOptions(){return this._runOptions}set runOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._runOptions=O}};ut.ExtensionCallbackType="customExecution",ut.ProcessType="process",ut.ShellType="shell",ut.EmptyType="$empty",ut=b=Ue([I],ut),e.Task=ut;var gt;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(gt=e.ProgressLocation||(e.ProgressLocation={}));let dt=class{constructor(O,te=Pt.None){this.collapsibleState=te,A.URI.isUri(O)?this.resourceUri=O:this.label=O}};dt=Ue([I],dt),e.TreeItem=dt;var Pt;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(Pt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let _t=class{constructor(O,te){this.id=O,this.color=te}};_t=Ue([I],_t),e.ThemeIcon=_t,_t.File=new _t("file"),_t.Folder=new _t("folder");let $t=class{constructor(O){this.id=O}};$t=Ue([I],$t),e.ThemeColor=$t;var jt;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(jt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let St=class{constructor(O,te){if(typeof O!="string"&&(!O||!A.URI.isUri(O)&&!A.URI.isUri(O.uri)))throw(0,M.illegalArgument)("base");if(typeof te!="string")throw(0,M.illegalArgument)("pattern");typeof O=="string"?(this.baseFolder=A.URI.file(O),this.base=O):A.URI.isUri(O)?(this.baseFolder=O,this.base=O.fsPath):(this.baseFolder=O.uri,this.base=O.uri.fsPath),this.pattern=te}};St=Ue([I],St),e.RelativePattern=St;let Wt=class{constructor(O,te,Ee,Ve){this.enabled=typeof O=="boolean"?O:!0,typeof te=="string"&&(this.condition=te),typeof Ee=="string"&&(this.hitCondition=Ee),typeof Ve=="string"&&(this.logMessage=Ve)}get id(){return this._id||(this._id=(0,t.generateUuid)()),this._id}};Wt=Ue([I],Wt),e.Breakpoint=Wt;let ii=class extends Wt{constructor(O,te,Ee,Ve,tt){super(te,Ee,Ve,tt);if(O===null)throw(0,M.illegalArgument)("location");this.location=O}};ii=Ue([I],ii),e.SourceBreakpoint=ii;let wt=class extends Wt{constructor(O,te,Ee,Ve,tt){super(te,Ee,Ve,tt);this.functionName=O}};wt=Ue([I],wt),e.FunctionBreakpoint=wt;let Yt=class extends Wt{constructor(O,te,Ee,Ve,tt,at,ct){super(Ve,tt,at,ct);if(!te)throw(0,M.illegalArgument)("dataId");this.label=O,this.dataId=te,this.canPersist=Ee}};Yt=Ue([I],Yt),e.DataBreakpoint=Yt;let qt=class{constructor(O,te,Ee){this.command=O,this.args=te||[],this.options=Ee}};qt=Ue([I],qt),e.DebugAdapterExecutable=qt;let ni=class{constructor(O,te){this.port=O,this.host=te}};ni=Ue([I],ni),e.DebugAdapterServer=ni;let ri=class{constructor(O){this.path=O}};ri=Ue([I],ri),e.DebugAdapterNamedPipeServer=ri;let At=class{constructor(O){this.implementation=O}};At=Ue([I],At),e.DebugAdapterInlineImplementation=At;let Jt=class{constructor(O,te){this.range=O,this.expression=te}};Jt=Ue([I],Jt),e.EvaluatableExpression=Jt;var bi;(function(U){U[U.Automatic=0]="Automatic",U[U.Explicit=1]="Explicit"})(bi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let zt=class{constructor(O,te){this.range=O,this.text=te}};zt=Ue([I],zt),e.InlineValueText=zt;let Ht=class{constructor(O,te,Ee=!0){this.range=O,this.variableName=te,this.caseSensitiveLookup=Ee}};Ht=Ue([I],Ht),e.InlineValueVariableLookup=Ht;let mt=class{constructor(O,te){this.range=O,this.expression=te}};mt=Ue([I],mt),e.InlineValueEvaluatableExpression=mt;let si=class{constructor(O,te){this.frameId=O,this.stoppedLocation=te}};si=Ue([I],si),e.InlineValueContext=si;var Nt;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(Nt=e.FileChangeType||(e.FileChangeType={}));let xt=h=class extends Error{constructor(O,te=_.FileSystemProviderErrorCode.Unknown,Ee){super(A.URI.isUri(O)?O.toString(!0):O);this.code=Ee?.name??"Unknown",(0,_.markAsFileSystemProviderError)(this,te),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,h.prototype),typeof Error.captureStackTrace=="function"&&typeof Ee=="function"&&Error.captureStackTrace(this,Ee)}static FileExists(O){return new h(O,_.FileSystemProviderErrorCode.FileExists,h.FileExists)}static FileNotFound(O){return new h(O,_.FileSystemProviderErrorCode.FileNotFound,h.FileNotFound)}static FileNotADirectory(O){return new h(O,_.FileSystemProviderErrorCode.FileNotADirectory,h.FileNotADirectory)}static FileIsADirectory(O){return new h(O,_.FileSystemProviderErrorCode.FileIsADirectory,h.FileIsADirectory)}static NoPermissions(O){return new h(O,_.FileSystemProviderErrorCode.NoPermissions,h.NoPermissions)}static Unavailable(O){return new h(O,_.FileSystemProviderErrorCode.Unavailable,h.Unavailable)}};xt=h=Ue([I],xt),e.FileSystemError=xt;let Xt=class{constructor(O,te,Ee){this.start=O,this.end=te,this.kind=Ee}};Xt=Ue([I],Xt),e.FoldingRange=Xt;var Ei;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(Ei=e.FoldingRangeKind||(e.FoldingRangeKind={}));var fi;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(fi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var _i;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(_i=e.CommentMode||(e.CommentMode={}));class mi{constructor(O,te=[]){this.tokenTypes=O,this.tokenModifiers=te}}e.SemanticTokensLegend=mi;function Zt(U){return typeof U=="undefined"||(0,C.isStringArray)(U)}class oi{constructor(O){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,O){this._hasLegend=!0;for(let te=0,Ee=O.tokenTypes.length;te<Ee;te++)this._tokenTypeStrToInt.set(O.tokenTypes[te],te);for(let te=0,Ee=O.tokenModifiers.length;te<Ee;te++)this._tokenModifierStrToInt.set(O.tokenModifiers[te],te)}}push(O,te,Ee,Ve,tt){if(typeof O=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ve=="number"&&(typeof tt=="number"||typeof tt=="undefined"))return typeof tt=="undefined"&&(tt=0),this._pushEncoded(O,te,Ee,Ve,tt);if(k.isRange(O)&&typeof te=="string"&&Zt(Ee))return this._push(O,te,Ee);throw(0,M.illegalArgument)()}_push(O,te,Ee){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(O.start.line!==O.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(te))throw new Error("`tokenType` is not in the provided legend");const Ve=O.start.line,tt=O.start.character,at=O.end.character-O.start.character,ct=this._tokenTypeStrToInt.get(te);let Ct=0;if(Ee)for(const Rt of Ee){if(!this._tokenModifierStrToInt.has(Rt))throw new Error("`tokenModifier` is not in the provided legend");const Mt=this._tokenModifierStrToInt.get(Rt);Ct|=1<<Mt>>>0}this._pushEncoded(Ve,tt,at,ct,Ct)}_pushEncoded(O,te,Ee,Ve,tt){if(this._dataIsSortedAndDeltaEncoded&&(O<this._prevLine||O===this._prevLine&&te<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Ct=this._data.length/5|0;let Rt=0,Mt=0;for(let Ot=0;Ot<Ct;Ot++){let Ut=this._data[5*Ot],di=this._data[5*Ot+1];Ut===0?(Ut=Rt,di+=Mt):Ut+=Rt,this._data[5*Ot]=Ut,this._data[5*Ot+1]=di,Rt=Ut,Mt=di}}let at=O,ct=te;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(ct-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=ct,this._data[this._dataLen++]=Ee,this._data[this._dataLen++]=Ve,this._data[this._dataLen++]=tt,this._prevLine=O,this._prevChar=te}static _sortAndDeltaEncode(O){let te=[];const Ee=O.length/5|0;for(let ct=0;ct<Ee;ct++)te[ct]=ct;te.sort((ct,Ct)=>{const Rt=O[5*ct],Mt=O[5*Ct];if(Rt===Mt){const Ot=O[5*ct+1],Ut=O[5*Ct+1];return Ot-Ut}return Rt-Mt});const Ve=new Uint32Array(O.length);let tt=0,at=0;for(let ct=0;ct<Ee;ct++){const Ct=5*te[ct],Rt=O[Ct+0],Mt=O[Ct+1],Ot=O[Ct+2],Ut=O[Ct+3],di=O[Ct+4],Ui=Rt-tt,Gi=Ui===0?Mt-at:Mt,hi=5*ct;Ve[hi+0]=Ui,Ve[hi+1]=Gi,Ve[hi+2]=Ot,Ve[hi+3]=Ut,Ve[hi+4]=di,tt=Rt,at=Mt}return Ve}build(O){return this._dataIsSortedAndDeltaEncoded?new Gt(new Uint32Array(this._data),O):new Gt(oi._sortAndDeltaEncode(this._data),O)}}e.SemanticTokensBuilder=oi;class Gt{constructor(O,te){this.resultId=te,this.data=O}}e.SemanticTokens=Gt;class ai{constructor(O,te,Ee){this.start=O,this.deleteCount=te,this.data=Ee}}e.SemanticTokensEdit=ai;class yi{constructor(O,te){this.resultId=te,this.edits=O}}e.SemanticTokensEdits=yi;var Si;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(Si=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Kt;(function(U){U[U.Initial=1]="Initial",U[U.Dynamic=2]="Dynamic"})(Kt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let ei=class{constructor(){}};ei.Back={iconPath:new _t("arrow-left")},ei=Ue([I],ei),e.QuickInputButtons=ei;var Di;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(Di=e.ExtensionKind||(e.ExtensionKind={}));class Ci{constructor(O,te,Ee){this.badge=O,this.tooltip=te,this.color=Ee}static validate(O){if(O.badge){let te=(0,T.nextCharLength)(O.badge,0);if(te<O.badge.length&&(te+=(0,T.nextCharLength)(O.badge,te)),O.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}if(!O.color&&!O.badge&&!O.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Ci;let li=class{constructor(O){this.kind=O}};li=Ue([I],li),e.ColorTheme=li;var ui;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast"})(ui=e.ColorThemeKind||(e.ColorThemeKind={}));class Vt{constructor(O,te){if(O<0)throw(0,M.illegalArgument)("start must be positive");if(te<0)throw(0,M.illegalArgument)("end must be positive");O<=te?(this._start=O,this._end=te):(this._start=te,this._end=O)}static isNotebookRange(O){return O instanceof Vt?!0:O?typeof O.start=="number"&&typeof O.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(O){let te=this._start,Ee=this._end;return O.start!==void 0&&(te=O.start),O.end!==void 0&&(Ee=O.end),te===this._start&&Ee===this._end?this:new Vt(te,Ee)}}e.NotebookRange=Vt;class Lt{constructor(O,te,Ee,Ve,tt,at,ct){this.kind=O,this.value=te,this.languageId=Ee,this.mime=Ve,this.outputs=tt??[],this.metadata=at,this.executionSummary=ct,Lt.validate(this)}static validate(O){if(typeof O.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof O.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof O.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(O){return Array.isArray(O)&&O.every(te=>Lt.isNotebookCellData(te))}static isNotebookCellData(O){return!0}}e.NotebookCellData=Lt;class Ae{constructor(O){this.cells=O}}e.NotebookData=Ae;class Ft{constructor(O,te){this.data=O,this.mime=te;const Ee=(0,F.normalizeMimeType)(te,!0);if(!Ee)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ee}static isNotebookCellOutputItem(O){return O instanceof Ft?!0:O?typeof O.mime=="string"&&O.data instanceof Uint8Array:!1}static error(O){const te={name:O.name,message:O.message,stack:O.stack};return Ft.json(te,"application/vnd.code.notebook.error")}static stdout(O){return Ft.text(O,"application/vnd.code.notebook.stdout")}static stderr(O){return Ft.text(O,"application/vnd.code.notebook.stderr")}static bytes(O,te="application/octet-stream"){return new Ft(O,te)}static text(O,te=F.Mimes.text){const Ee=Te(Ft,f,"f",p).encode(String(O));return new Ft(Ee,te)}static json(O,te="application/json"){const Ee=JSON.stringify(O,void 0,"	");return Ft.text(Ee,te)}}e.NotebookCellOutputItem=Ft,f=Ft,p={value:new TextEncoder};class Qt{constructor(O,te,Ee){this.items=Qt.ensureUniqueMimeTypes(O,!0),typeof te=="string"?(this.id=te,this.metadata=Ee):(this.id=(0,t.generateUuid)(),this.metadata=te??Ee)}static isNotebookCellOutput(O){return O instanceof Qt?!0:!O||typeof O!="object"?!1:typeof O.id=="string"&&(0,C.isArray)(O.items)}static ensureUniqueMimeTypes(O,te=!1){const Ee=new Set,Ve=new Set;for(let tt=0;tt<O.length;tt++){const at=O[tt],ct=(0,F.normalizeMimeType)(at.mime);if(!Ee.has(ct)){Ee.add(ct);continue}Ve.add(tt),te&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ve.size===0?O:O.filter((tt,at)=>!Ve.has(at))}}e.NotebookCellOutput=Qt;var bt;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(bt=e.NotebookCellKind||(e.NotebookCellKind={}));var ki;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(ki=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ii;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(Ii=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var gi;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(gi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class pi{constructor(O,te){this.text=O,this.alignment=te}}e.NotebookCellStatusBarItem=pi;var Pi;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(Pi=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Ti{constructor(O,te=[]){this.uri=O,this.provides=(0,u.asArray)(te)}}e.NotebookRendererScript=Ti;let ci=class{constructor(O,te){this.label=O,this.timestamp=te}};ci=Ue([I],ci),e.TimelineItem=ci;var Ai;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(Ai=e.ExtensionMode||(e.ExtensionMode={}));var vi;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(vi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ri;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=4]="RegEx"})(Ri=e.StandardTokenType||(e.StandardTokenType={}));class Fi{constructor(O,te){this.ranges=O,this.wordPattern=te}}e.LinkedEditingRanges=Fi;class Mi{constructor(O,te){this._port=O,this._autoForwardAction=te}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Mi;var Li;(function(U){U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(Li=e.TestResultState||(e.TestResultState={}));var Oi;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(Oi=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Y=class{constructor(O=void 0,te=void 0,Ee=void 0){this.include=O,this.exclude=te,this.profile=Ee}};Y=Ue([I],Y),e.TestRunRequest=Y;let le=y=class{constructor(O){this.message=O}static diff(O,te,Ee){const Ve=new y(O);return Ve.expectedOutput=te,Ve.actualOutput=Ee,Ve}};le=y=Ue([I],le),e.TestMessage=le;let Se=class{constructor(O){this.id=O}};Se=Ue([I],Se),e.TestTag=Se;let st=class{constructor(O,te){this.covered=O,this.total=te}};st=Ue([I],st),e.CoveredCount=st;let yt=R=class{constructor(O,te,Ee,Ve){this.uri=O,this.statementCoverage=te,this.branchCoverage=Ee,this.functionCoverage=Ve}static fromDetails(O,te){const Ee=new st(0,0),Ve=new st(0,0),tt=new st(0,0);for(const ct of te)if("branches"in ct){Ee.total+=1,Ee.covered+=ct.executionCount>0?1:0;for(const Ct of ct.branches)Ve.total+=1,Ve.covered+=Ct.executionCount>0?1:0}else tt.total+=1,tt.covered+=ct.executionCount>0?1:0;const at=new R(O,Ee,Ve.total>0?Ve:void 0,tt.total>0?tt:void 0);return at.detailedCoverage=te,at}};yt=R=Ue([I],yt),e.FileCoverage=yt;let kt=class{constructor(O,te,Ee=[]){this.executionCount=O,this.location=te,this.branches=Ee}};kt=Ue([I],kt),e.StatementCoverage=kt;let Ni=class{constructor(O,te){this.executionCount=O,this.location=te}};Ni=Ue([I],Ni),e.BranchCoverage=Ni;let xi=class{constructor(O,te){this.executionCount=O,this.location=te}};xi=Ue([I],xi),e.FunctionCoverage=xi;var Hi;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(Hi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Vi;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(Vi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var ji;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore",U[U.OpenBrowserOnce=6]="OpenBrowserOnce"})(ji=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class qi{constructor(O,te,Ee,Ve,tt,at){this.kind=O,this.name=te,this.detail=Ee,this.uri=Ve,this.range=tt,this.selectionRange=at}}e.TypeHierarchyItem=qi}),define(we[88],be([0,1,43,11,9,232,119,7,15]),function(re,e,u,M,E,P,F,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const A=new Map;function t(a,f){f?A.set(a,f):A.delete(a)}e.setWordDefinitionFor=t;function _(a){return A.get(a)}e.getWordDefinitionFor=_;class i extends P.MirrorTextModel{constructor(f,p,S,v,o,d,D,r){super(p,S,v,o);this._proxy=f,this._languageId=d,this._isDirty=D,this._notebook=r,this._isDisposed=!1}dispose(){(0,u.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(f){return(0,C.equals)(this._lines,f)}get document(){if(!this._document){const f=this;this._document={get uri(){return f._uri},get fileName(){return f._uri.fsPath},get isUntitled(){return f._uri.scheme===M.Schemas.untitled},get languageId(){return f._languageId},get version(){return f._versionId},get isClosed(){return f._isDisposed},get isDirty(){return f._isDirty},get notebook(){return f._notebook},save(){return f._save()},getText(p){return p?f._getTextInRange(p):f.getText()},get eol(){return f._eol===`
`?T.EndOfLine.LF:T.EndOfLine.CRLF},get lineCount(){return f._lines.length},lineAt(p){return f._lineAt(p)},offsetAt(p){return f._offsetAt(p)},positionAt(p){return f._positionAt(p)},validateRange(p){return f._validateRange(p)},validatePosition(p){return f._validatePosition(p)},getWordRangeAtPosition(p,S){return f._getWordRangeAtPosition(p,S)}}}return Object.freeze(this._document)}_acceptLanguageId(f){(0,u.ok)(!this._isDisposed),this._languageId=f}_acceptIsDirty(f){(0,u.ok)(!this._isDisposed),this._isDirty=f}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(f){const p=this._validateRange(f);if(p.isEmpty)return"";if(p.isSingleLine)return this._lines[p.start.line].substring(p.start.character,p.end.character);const S=this._eol,v=p.start.line,o=p.end.line,d=[];d.push(this._lines[v].substring(p.start.character));for(let D=v+1;D<o;D++)d.push(this._lines[D]);return d.push(this._lines[o].substring(0,p.end.character)),d.join(S)}_lineAt(f){let p;if(f instanceof T.Position?p=f.line:typeof f=="number"&&(p=f),typeof p!="number"||p<0||p>=this._lines.length||Math.floor(p)!==p)throw new Error("Illegal value for `line`");return new m(p,this._lines[p],p===this._lines.length-1)}_offsetAt(f){return f=this._validatePosition(f),this._ensureLineStarts(),this._lineStarts.getPrefixSum(f.line-1)+f.character}_positionAt(f){f=Math.floor(f),f=Math.max(0,f),this._ensureLineStarts();const p=this._lineStarts.getIndexOf(f),S=this._lines[p.index].length;return new T.Position(p.index,Math.min(p.remainder,S))}_validateRange(f){if(!(f instanceof T.Range))throw new Error("Invalid argument");const p=this._validatePosition(f.start),S=this._validatePosition(f.end);return p===f.start&&S===f.end?f:new T.Range(p.line,p.character,S.line,S.character)}_validatePosition(f){if(!(f instanceof T.Position))throw new Error("Invalid argument");if(this._lines.length===0)return f.with(0,0);let{line:p,character:S}=f,v=!1;if(p<0)p=0,S=0,v=!0;else if(p>=this._lines.length)p=this._lines.length-1,S=this._lines[p].length,v=!0;else{const o=this._lines[p].length;S<0?(S=0,v=!0):S>o&&(S=o,v=!0)}return v?new T.Position(p,S):f}_getWordRangeAtPosition(f,p){const S=this._validatePosition(f);if(!p)p=_(this._languageId);else if((0,E.regExpLeadsToEndlessLoop)(p))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${p.source}' because it matches the empty string.`);const v=(0,F.getWordAtText)(S.character+1,(0,F.ensureValidWordDefinition)(p),this._lines[S.line],0);if(v)return new T.Range(S.line,v.startColumn-1,S.line,v.endColumn-1)}}e.ExtHostDocumentData=i;class m{constructor(f,p,S){this._line=f,this._text=p,this._isLastLine=S}get lineNumber(){return this._line}get text(){return this._text}get range(){return new T.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new T.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=m}),define(we[158],be([0,1,7,3,233,6,58,20,2,37]),function(re,e,u,M,E,P,F,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class t{constructor(i,m,a,f){this._notebook=a,this._selector=f,this._disposables=new P.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this.uri=C.URI.from({scheme:"vscode-concat-doc",path:(0,A.generateUuid)()}),this._init(),this._disposables.add(m.onDidChangeDocument(S=>{const v=this._cellUris.get(S.document.uri);v!==void 0&&(this._cellLengths.setValue(v,this._cells[v].document.getText().length+1),this._cellLines.setValue(v,this._cells[v].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const p=S=>{S===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(i.onDidChangeNotebookCells(S=>p(S.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new T.ResourceMap;const i=[],m=[];for(const a of this._notebook.getCells())a.kind===u.NotebookCellKind.Code&&(!this._selector||(0,F.score)(this._selector,a.document.uri,a.document.languageId,!0))&&(this._cellUris.set(a.document.uri,this._cells.length),this._cells.push(a),i.push(a.document.getText().length+1),m.push(a.document.lineCount));this._cellLengths=new E.PrefixSumComputer(new Uint32Array(i)),this._cellLines=new E.PrefixSumComputer(new Uint32Array(m))}get version(){return this._versionId}getText(i){if(!i){let v="";for(const o of this._cells)v+=o.document.getText()+`
`;return v=v.slice(0,-1),v}if(i.isEmpty)return"";const m=this.locationAt(i.start),a=this.locationAt(i.end),f=this._cellUris.get(m.uri),p=this._cellUris.get(a.uri);if(f===void 0||p===void 0)return"";if(f===p)return this._cells[f].document.getText(new u.Range(m.range.start,a.range.end));const S=[this._cells[f].document.getText(new u.Range(m.range.start,new u.Position(this._cells[f].document.lineCount,0)))];for(let v=f+1;v<p;v++)S.push(this._cells[v].document.getText());return S.push(this._cells[p].document.getText(new u.Range(new u.Position(0,0),a.range.end))),S.join(`
`)}offsetAt(i){const m=this._cellLines.getIndexOf(i.line),a=this._cellLengths.getPrefixSum(m.index-1),f=this._cells[m.index].document.offsetAt(i.with(m.remainder));return a+f}positionAt(i){if(typeof i=="number"){const a=this._cellLengths.getIndexOf(i),f=this._cellLines.getPrefixSum(a.index-1);return this._cells[a.index].document.positionAt(a.remainder).translate(f)}const m=this._cellUris.get(i.uri);if(m!==void 0){const a=this._cellLines.getPrefixSum(m-1);return new u.Position(a+i.range.start.line,i.range.start.character)}return new u.Position(0,0)}locationAt(i){u.Range.isRange(i)||(i=new u.Range(i,i));const m=this._cellLines.getIndexOf(i.start.line);let a=m;i.isEmpty||(a=this._cellLines.getIndexOf(i.end.line));const f=new u.Position(m.remainder,i.start.character),p=new u.Position(a.remainder,i.end.character),S=new u.Range(f,p),v=this._cells[m.index];return new u.Location(v.document.uri,v.document.validateRange(S))}contains(i){return this._cellUris.has(i)}validateRange(i){const m=this.validatePosition(i.start),a=this.validatePosition(i.end);return i.with(m,a)}validatePosition(i){const m=this._cellLines.getIndexOf(i.line),a=new u.Position(m.remainder,i.character),f=this._cells[m.index].document.validatePosition(a),p=this._cellLines.getPrefixSum(m.index-1);return new u.Position(p+f.line,f.character)}}e.ExtHostNotebookConcatDocument=t}),define(we[159],be([0,1,7,14,3]),function(re,e,u,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let P=class{constructor(T){this._actual=new u.ColorTheme(u.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new E.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(T){let C=T==="light"?u.ColorThemeKind.Light:T==="dark"?u.ColorThemeKind.Dark:u.ColorThemeKind.HighContrast;this._actual=new u.ColorTheme(C),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};P=Ue([Be(0,M.IExtHostRpcService)],P),e.ExtHostTheming=P}),define(we[67],be([0,1,4]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,u.createDecorator)("IURITransformerService");class M{constructor(P){P?(this.transformIncoming=P.transformIncoming.bind(P),this.transformOutgoing=P.transformOutgoing.bind(P),this.transformOutgoingURI=P.transformOutgoingURI.bind(P),this.transformOutgoingScheme=P.transformOutgoingScheme.bind(P)):(this.transformIncoming=F=>F,this.transformOutgoing=F=>F,this.transformOutgoingURI=F=>F,this.transformOutgoingScheme=F=>F)}}e.URITransformerService=M}),define(we[160],be([0,1,22]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class M{constructor(){this.buffers=[]}add(C){let A=this.buffers.indexOf(C);return A<0&&(A=this.buffers.length,this.buffers.push(C)),A}}function E(T,C){if(C.serializeBuffersForPostMessage){const A=new M,t=(m,a)=>{if(a instanceof ArrayBuffer){const f=A.add(a);return{$$vscode_array_buffer_reference$$:!0,index:f}}else if(ArrayBuffer.isView(a)){const f=P(a);if(f){const p=A.add(a.buffer);return{$$vscode_array_buffer_reference$$:!0,index:p,view:{type:f,byteLength:a.byteLength,byteOffset:a.byteOffset}}}}return a},_=JSON.stringify(T,t),i=A.buffers.map(m=>{const a=new Uint8Array(m);return u.VSBuffer.wrap(a)});return{message:_,buffers:i}}else return{message:JSON.stringify(T),buffers:[]}}e.serializeWebviewMessage=E;function P(T){switch(T.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function F(T,C){const A=C.map(i=>{const m=new ArrayBuffer(i.byteLength);return new Uint8Array(m).set(i.buffer),m}),t=C.length?(i,m)=>{if(typeof m=="object"&&m.$$vscode_array_buffer_reference$$){const a=m,{index:f}=a,p=A[f];if(a.view)switch(a.view.type){case 1:return new Int8Array(p,a.view.byteOffset,a.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(p,a.view.byteOffset,a.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(p,a.view.byteOffset,a.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(p,a.view.byteOffset,a.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(p,a.view.byteOffset,a.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(p,a.view.byteOffset,a.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(p,a.view.byteOffset,a.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(p,a.view.byteOffset,a.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(p,a.view.byteOffset,a.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(p,a.view.byteOffset,a.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(p,a.view.byteOffset,a.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return p}return m}:void 0;return{message:JSON.parse(T,t),arrayBuffers:A}}e.deserializeWebviewMessage=F}),define(we[161],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var u;(function(M){function E(F){const T={items:new Map};return F.types.forEach((C,A)=>{T.items.set(C,{asString:async()=>F.items[A].asString})}),T}M.toITreeDataTransfer=E;async function P(F){const T={types:[],items:[]},C=Array.from(F.items.entries());for(const A of C)T.types.push(A[0]),T.items.push({asString:await A[1].asString()});return T}M.toTreeDataTransferDTO=P})(u=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(we[68],be([0,1,11,2]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function E(T,C){return T.scheme===u.Schemas.http||T.scheme===u.Schemas.https?T:(C&&C.authority&&C.isRemote&&T.scheme===u.Schemas.file&&(T=M.URI.from({scheme:u.Schemas.vscodeRemote,authority:C.authority,path:T.path})),M.URI.from({scheme:u.Schemas.https,authority:`${T.scheme}+${P(T.authority)}.${e.webviewRootResourceAuthority}`,path:T.path,fragment:T.fragment,query:T.query}))}e.asWebviewUri=E;function P(T){return T.replace(/./g,C=>{const A=C.charCodeAt(0);return A>=97&&A<=122||A>=65&&A<=90||A>=48&&A<=57?C:"-"+A.toString(16).padStart(4,"0")})}function F(T){return T.replace(/-([0-9a-f]{4})/g,(C,A)=>String.fromCharCode(parseInt(A,16)))}e.decodeAuthority=F}),define(we[162],be([0,1,3,6,68]),function(re,e,u,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class P{constructor(T,C,A){this._proxy=T,this._editors=C,this._initData=A,this._handlePool=0,this._disposables=new M.DisposableStore,this._insets=new Map,this._disposables.add(C.onDidChangeVisibleTextEditors(()=>{const t=C.getVisibleTextEditors();for(const _ of this._insets.values())t.indexOf(_.editor)<0&&_.inset.dispose()}))}dispose(){this._insets.forEach(T=>T.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(T,C,A,t,_){let i;for(const o of this._editors.getVisibleTextEditors(!0))if(o.value===T){i=o;break}if(!i)throw new Error("not a visible editor");const m=this,a=this._handlePool++,f=new u.Emitter,p=new u.Emitter,S=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(o){return(0,E.asWebviewUri)(o,m._initData.remote)}get cspSource(){return E.webviewGenericCspSource}set options(o){this._options=o,m._proxy.$setOptions(a,o)}get options(){return this._options}set html(o){this._html=o,m._proxy.$setHtml(a,o)}get html(){return this._html}get onDidReceiveMessage(){return f.event}postMessage(o){return m._proxy.$postMessage(a,o)}},v=new class{constructor(){this.editor=T,this.line=C,this.height=A,this.webview=S,this.onDidDispose=p.event}dispose(){m._insets.has(a)&&(m._insets.delete(a),m._proxy.$disposeEditorInset(a),p.fire(),p.dispose(),f.dispose())}};return this._proxy.$createEditorInset(a,i.id,i.value.document.uri,C+1,A,t||{},_.identifier,_.extensionLocation),this._insets.set(a,{editor:T,inset:v,onDidReceiveMessage:f}),v}$onDidDispose(T){const C=this._insets.get(T);C&&C.inset.dispose()}$onDidReceiveMessage(T,C){const A=this._insets.get(T);A&&A.onDidReceiveMessage.fire(C)}}e.ExtHostEditorInsets=P}),define(we[163],be([0,1,132,10,2,6,4,38,29,47,15,11]),function(re,e,u,M,E,P,F,T,C,A,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,u.localize)(0,null),providerDisplayName:(0,u.localize)(1,null)},e.ActiveEditorDirtyContext=new T.RawContextKey("activeEditorIsDirty",!1,(0,u.localize)(2,null)),e.ActiveEditorPinnedContext=new T.RawContextKey("activeEditorIsNotPreview",!1,(0,u.localize)(3,null)),e.ActiveEditorStickyContext=new T.RawContextKey("activeEditorIsPinned",!1,(0,u.localize)(4,null)),e.ActiveEditorReadonlyContext=new T.RawContextKey("activeEditorIsReadonly",!1,(0,u.localize)(5,null)),e.ActiveEditorCanRevertContext=new T.RawContextKey("activeEditorCanRevert",!1,(0,u.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new T.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new T.RawContextKey("activeEditor",null,{type:"string",description:(0,u.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new T.RawContextKey("activeEditorAvailableEditorIds","",(0,u.localize)(8,null)),e.TextCompareEditorVisibleContext=new T.RawContextKey("textCompareEditorVisible",!1,(0,u.localize)(9,null)),e.TextCompareEditorActiveContext=new T.RawContextKey("textCompareEditorActive",!1,(0,u.localize)(10,null)),e.SideBySideEditorActiveContext=new T.RawContextKey("sideBySideEditorActive",!1,(0,u.localize)(11,null)),e.EditorGroupEditorsCountContext=new T.RawContextKey("groupEditorsCount",0,(0,u.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new T.RawContextKey("activeEditorGroupEmpty",!1,(0,u.localize)(13,null)),e.ActiveEditorGroupIndexContext=new T.RawContextKey("activeEditorGroupIndex",0,(0,u.localize)(14,null)),e.ActiveEditorGroupLastContext=new T.RawContextKey("activeEditorGroupLast",!1,(0,u.localize)(15,null)),e.ActiveEditorGroupLockedContext=new T.RawContextKey("activeEditorGroupLocked",!1,(0,u.localize)(16,null)),e.MultipleEditorGroupsContext=new T.RawContextKey("multipleEditorGroups",!1,(0,u.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new T.RawContextKey("editorIsOpen",!1,(0,u.localize)(18,null)),e.InEditorZenModeContext=new T.RawContextKey("inZenMode",!1,(0,u.localize)(19,null)),e.IsCenteredLayoutContext=new T.RawContextKey("isCenteredLayout",!1,(0,u.localize)(20,null)),e.SplitEditorsVertically=new T.RawContextKey("splitEditorsVertically",!1,(0,u.localize)(21,null)),e.EditorAreaVisibleContext=new T.RawContextKey("editorAreaVisible",!0,(0,u.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function i(L,k,x){for(const N of x.visibleEditorPanes)if(N.group.id===k&&L.matches(N.input))return N.getViewState()}e.findViewStateForEditor=i;function m(L){if(D(L))return!1;const k=L;return E.URI.isUri(k?.resource)}e.isResourceEditorInput=m;function a(L){if(D(L))return!1;const k=L;return k?.original!==void 0&&k.modified!==void 0}e.isResourceDiffEditorInput=a;function f(L){if(D(L)||a(L))return!1;const k=L;return k?.primary!==void 0&&k.secondary!==void 0}e.isResourceSideBySideEditorInput=f;function p(L){if(D(L))return!1;const k=L;return k?k.resource===void 0||k.resource.scheme===_.Schemas.untitled||k.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=p;var S;(function(L){L[L.SHORT=0]="SHORT",L[L.MEDIUM=1]="MEDIUM",L[L.LONG=2]="LONG"})(S=e.Verbosity||(e.Verbosity={}));var v;(function(L){L[L.EXPLICIT=1]="EXPLICIT",L[L.AUTO=2]="AUTO",L[L.FOCUS_CHANGE=3]="FOCUS_CHANGE",L[L.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(v=e.SaveReason||(e.SaveReason={}));var o;(function(L){L[L.None=0]="None",L[L.Readonly=2]="Readonly",L[L.Untitled=4]="Untitled",L[L.Singleton=8]="Singleton",L[L.RequiresTrust=16]="RequiresTrust",L[L.CanSplitInGroup=32]="CanSplitInGroup",L[L.ForceDescription=64]="ForceDescription"})(o=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class d extends P.Disposable{}e.AbstractEditorInput=d;function D(L){return L instanceof d}e.isEditorInput=D;function r(L){const k=L;return E.URI.isUri(k?.preferredResource)}function w(L){const k=L;return D(k?.primary)&&D(k?.secondary)}e.isSideBySideEditorInput=w;function s(L){const k=L;return D(k?.modified)&&D(k?.original)}e.isDiffEditorInput=s;function n(L){return D(L?.editor)}e.isEditorInputWithOptions=n;function g(L){const k=L;return n(L)&&k?.group!==void 0}e.isEditorInputWithOptionsAndGroup=g;function l(L){const k=L;return typeof k?.groupId=="number"&&D(k.editor)}e.isEditorIdentifier=l;var c;(function(L){L[L.UNKNOWN=0]="UNKNOWN",L[L.REPLACE=1]="REPLACE",L[L.MOVE=2]="MOVE",L[L.UNPIN=3]="UNPIN"})(c=e.EditorCloseContext||(e.EditorCloseContext={}));var b;(function(L){L[L.PRIMARY=1]="PRIMARY",L[L.SECONDARY=2]="SECONDARY",L[L.BOTH=3]="BOTH",L[L.ANY=4]="ANY"})(b=e.SideBySideEditor||(e.SideBySideEditor={}));class h{getOriginalUri(k,x){if(!k)return;if(x?.supportSideBySide){const{primary:V,secondary:W}=this.getSideEditors(k);if(V&&W){if(x?.supportSideBySide===b.BOTH)return{primary:this.getOriginalUri(V,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri(W,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===b.ANY)return this.getOriginalUri(V,{filterByScheme:x.filterByScheme})??this.getOriginalUri(W,{filterByScheme:x.filterByScheme});k=x.supportSideBySide===b.PRIMARY?V:W}}if(a(k)||f(k))return;const N=r(k)?k.preferredResource:k.resource;return!N||!x||!x.filterByScheme?N:this.filterUri(N,x.filterByScheme)}getSideEditors(k){return w(k)||f(k)?{primary:k.primary,secondary:k.secondary}:s(k)||a(k)?{primary:k.modified,secondary:k.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(k,x){if(!k)return;if(x?.supportSideBySide){const{primary:V,secondary:W}=this.getSideEditors(k);if(V&&W){if(x?.supportSideBySide===b.BOTH)return{primary:this.getCanonicalUri(V,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri(W,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===b.ANY)return this.getCanonicalUri(V,{filterByScheme:x.filterByScheme})??this.getCanonicalUri(W,{filterByScheme:x.filterByScheme});k=x.supportSideBySide===b.PRIMARY?V:W}}if(a(k)||f(k))return;const N=k.resource;return!N||!x||!x.filterByScheme?N:this.filterUri(N,x.filterByScheme)}filterUri(k,x){if(Array.isArray(x)){if(x.some(N=>k.scheme===N))return k}else if(x===k.scheme)return k}}e.EditorResourceAccessor=new h;var y;(function(L){L[L.LEFT=0]="LEFT",L[L.RIGHT=1]="RIGHT"})(y=e.CloseDirection||(e.CloseDirection={}));class R{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(k){const x=this.instantiationService=k.get(F.IInstantiationService);for(const[N,V]of this.editorSerializerConstructors)this.createEditorSerializer(N,V,x);this.editorSerializerConstructors.clear()}createEditorSerializer(k,x,N){const V=N.createInstance(x);this.editorSerializerInstances.set(k,V)}registerFileEditorFactory(k){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=k}getFileEditorFactory(){return(0,M.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(k,x){if(this.editorSerializerConstructors.has(k)||this.editorSerializerInstances.has(k))throw new Error(`A editor serializer with type ID '${k}' was already registered.`);return this.instantiationService?this.createEditorSerializer(k,x,this.instantiationService):this.editorSerializerConstructors.set(k,x),(0,P.toDisposable)(()=>{this.editorSerializerConstructors.delete(k),this.editorSerializerInstances.delete(k)})}getEditorSerializer(k){return this.editorSerializerInstances.get(typeof k=="string"?k:k.typeId)}}C.Registry.add(e.EditorExtensions.EditorFactory,new R);async function I(L,k){if(!L||!L.length)return[];const x=await Promise.all(L.map(async N=>{const V=E.URI.revive(N.fileUri);if(!V||!await k.canHandleResource(V))return;let $=N.exists,X=N.type;if(typeof $!="boolean"||typeof X!="number")try{X=(await k.resolve(V)).isFile?A.FileType.File:A.FileType.Unknown,$=!0}catch{$=!1}if(!$&&N.openOnlyIfExists||X!==A.FileType.File)return;const j={selection:$?N.selection:void 0,pinned:!0,override:N.editorOverrideId};let Q;return $?Q={resource:V,options:j}:Q={resource:V,options:j,forceUntitled:!0},Q}));return(0,t.coalesce)(x)}e.pathsToEditors=I;var B;(function(L){L[L.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",L[L.SEQUENTIAL=1]="SEQUENTIAL"})(B=e.EditorsOrder||(e.EditorsOrder={}))}),define(we[164],be([0,1,3,38,133,4,6,20,29,15,54,23,35,153]),function(re,e,u,M,E,P,F,T,C,A,t,_,i,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,m.registerIcon)("default-view-icon",i.Codicon.window,(0,E.localize)(0,null));var a;(function(g){g.ViewContainersRegistry="workbench.registry.view.containers",g.ViewsRegistry="workbench.registry.view"})(a=e.Extensions||(e.Extensions={}));var f;(function(g){g[g.Sidebar=0]="Sidebar",g[g.Panel=1]="Panel",g[g.AuxiliaryBar=2]="AuxiliaryBar"})(f=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function p(g){switch(g){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=p;function S(g){return`viewContainer.${g}.enabled`}e.getEnabledViewContainerContextKey=S;class v extends F.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new u.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new u.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,A.flatten)([...this.viewContainers.values()])}registerViewContainer(l,c,b){const h=this.get(l.id);if(h)return h;const y=l;return y.openCommandActionDescriptor=b?.donotRegisterOpenCommand?void 0:y.openCommandActionDescriptor??{id:y.id},(0,T.getOrSet)(this.viewContainers,c,[]).push(y),b?.isDefault&&this.defaultViewContainers.push(y),this._onDidRegister.fire({viewContainer:y,viewContainerLocation:c}),y}deregisterViewContainer(l){for(const c of this.viewContainers.keys()){const b=this.viewContainers.get(c),h=b?.indexOf(l);if(h!==-1){b?.splice(h,1),b.length===0&&this.viewContainers.delete(c),this._onDidDeregister.fire({viewContainer:l,viewContainerLocation:c});return}}}get(l){return this.all.filter(c=>c.id===l)[0]}getViewContainers(l){return[...this.viewContainers.get(l)||[]]}getViewContainerLocation(l){return[...this.viewContainers.keys()].filter(c=>this.getViewContainers(c).filter(b=>b?.id===l.id).length>0)[0]}getDefaultViewContainer(l){return this.defaultViewContainers.find(c=>this.getViewContainerLocation(c)===l)}}C.Registry.add(a.ViewContainersRegistry,new v);var o;(function(g){g.Open="2_open",g.Debug="4_debug",g.SCM="5_scm",g.More="9_more"})(o=e.ViewContentGroups||(e.ViewContentGroups={}));function d(g,l){const c=g.group??o.More,b=l.group??o.More;return c!==b?c.localeCompare(b):(g.order??5)-(l.order??5)}class D extends F.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new u.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new u.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new u.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new u.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new t.SetMap}registerViews(l,c){this.registerViews2([{views:l,viewContainer:c}])}registerViews2(l){l.forEach(({views:c,viewContainer:b})=>this.addViews(c,b)),this._onViewsRegistered.fire(l)}deregisterViews(l,c){const b=this.removeViews(l,c);b.length&&this._onViewsDeregistered.fire({views:b,viewContainer:c})}moveViews(l,c){for(const b of this._views.keys())if(b!==c){const h=this.removeViews(l,b);h.length&&(this.addViews(h,c),this._onDidChangeContainer.fire({views:h,from:b,to:c}))}}getViews(l){return this._views.get(l)||[]}getView(l){for(const c of this._viewContainers){const b=(this._views.get(c)||[]).filter(h=>h.id===l)[0];if(b)return b}return null}getViewContainer(l){for(const c of this._viewContainers)if((this._views.get(c)||[]).filter(h=>h.id===l)[0])return c;return null}registerViewWelcomeContent(l,c){return this._viewWelcomeContents.add(l,c),this._onDidChangeViewWelcomeContent.fire(l),(0,F.toDisposable)(()=>{this._viewWelcomeContents.delete(l,c),this._onDidChangeViewWelcomeContent.fire(l)})}registerViewWelcomeContent2(l,c){const b=new Map;for(const[h,y]of c)this._viewWelcomeContents.add(l,y),b.set(h,(0,F.toDisposable)(()=>{this._viewWelcomeContents.delete(l,y),this._onDidChangeViewWelcomeContent.fire(l)}));return this._onDidChangeViewWelcomeContent.fire(l),b}getViewWelcomeContent(l){const c=[];return this._viewWelcomeContents.forEach(l,b=>c.push(b)),c.sort(d)}addViews(l,c){let b=this._views.get(c);b||(b=[],this._views.set(c,b),this._viewContainers.push(c));for(const h of l){if(this.getView(h.id)!==null)throw new Error((0,E.localize)(1,null,h.id));b.push(h)}}removeViews(l,c){const b=this._views.get(c);if(!b)return[];const h=[],y=[];for(const R of b)l.includes(R)?h.push(R):y.push(R);return h.length&&(y.length?this._views.set(c,y):(this._views.delete(c),this._viewContainers.splice(this._viewContainers.indexOf(c),1))),h}}C.Registry.add(a.ViewsRegistry,new D),e.IViewsService=(0,P.createDecorator)("viewsService"),e.FocusedViewContext=new M.RawContextKey("focusedView","",(0,E.localize)(2,null));function r(g){return`view.${g}.visible`}e.getVisbileViewContextKey=r,e.IViewDescriptorService=(0,P.createDecorator)("viewDescriptorService");var w;(function(g){g[g.Default=0]="Default",g[g.Expand=1]="Expand"})(w=e.ViewVisibilityState||(e.ViewVisibilityState={}));var s;(function(g){g[g.None=0]="None",g[g.Collapsed=1]="Collapsed",g[g.Expanded=2]="Expanded"})(s=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class n{constructor(l,c){this.resolved=!1,this._hasResolve=!1,(0,_.mixin)(this,l),this._hasResolve=!!c,this.resolve=async b=>{if(c&&!this.resolved){const h=await c(b);h&&(this.tooltip=this.tooltip??h.tooltip,this.command=this.command??h.command)}b.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=n,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(we[165],be([0,1,3,13,134]),function(re,e,u,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class P{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new u.Emitter,this._onExit=new u.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(T){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=T}onEvent(T){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=T}onRequest(T){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=T}sendResponse(T){T.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${T.command}`)):this.internalSend("response",T)}sendRequest(T,C,A,t){const _={command:T};if(C&&Object.keys(C).length>0&&(_.arguments=C),this.internalSend("request",_),typeof t=="number"){const i=setTimeout(()=>{clearTimeout(i);const m=this.pendingRequests.get(_.seq);if(m){this.pendingRequests.delete(_.seq);const a={type:"response",seq:0,request_seq:_.seq,success:!1,command:T,message:(0,E.localize)(0,null,t,T)};m(a)}},t)}return A&&this.pendingRequests.set(_.seq,A),_.seq}acceptMessage(T){this.messageCallback?this.messageCallback(T):(this.queue.push(T),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(T,C){return T.type!=="event"||C.type!=="event"}async processQueue(){let T;for(;this.queue.length;){if((!T||this.needsTaskBoundaryBetween(this.queue[0],T))&&await(0,M.timeout)(0),T=this.queue.shift(),!T)return;switch(T.type){case"event":this.eventCallback&&this.eventCallback(T);break;case"request":this.requestCallback&&this.requestCallback(T);break;case"response":const C=T,A=this.pendingRequests.get(C.request_seq);A&&(this.pendingRequests.delete(C.request_seq),A(C));break}}}internalSend(T,C){C.type=T,C.seq=this.sequence++,this.sendMessage(C)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const T=new Map;this.pendingRequests.forEach((C,A)=>T.set(A,C)),await(0,M.timeout)(500),T.forEach((C,A)=>{C({type:"response",seq:0,request_seq:A,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(A)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=P}),define(we[166],be([0,1,9,2,17,23,11]),function(re,e,u,M,E,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const T=/{([^}]+)}/g;function C(s,n,g){return s.replace(T,function(l,c){return n&&c.length>0&&c[0]!=="_"?l:g&&g.hasOwnProperty(c)?g[c]:l})}e.formatPII=C;function A(s){const n={};for(const g of Object.keys(s))g.startsWith("!")||(n[g]=s[g]);return n}e.filterExceptionsFromTelemetry=A;function t(s){return s.configuration.request==="attach"&&!_(s)&&(!s.parentSession||t(s.parentSession))}e.isSessionAttach=t;function _(s){let n=s.configuration.type;if(!!n)return n==="vslsShare"&&(n=s.configuration.adapterProxy.configuration.type),(0,u.equalsIgnoreCase)(n,"extensionhost")||(0,u.equalsIgnoreCase)(n,"pwa-extensionhost")?s:s.parentSession?_(s.parentSession):void 0}e.getExtensionHostDebugSession=_;function i(s){return s.type&&(s.label||s.program||s.runtime)}e.isDebuggerMainContribution=i;function m(s,n,g){let l,c=0,b=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,h=null;for(;h=b.exec(s);){let y=h.index+1,R=y+h[0].length;if(y<=n&&R>=g){l=h[0],c=y;break}}if(l){let y=/\w+/g,R=null;for(;(R=y.exec(l))&&!(R.index+1+c+R[0].length>=g););R&&(l=l.substring(0,y.lastIndex))}return l?{start:c,end:c+l.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=m;const a=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function f(s){return!!(s&&s.match(a))}e.isUri=f;function p(s){if(typeof s.path=="string"&&!(typeof s.sourceReference=="number"&&s.sourceReference>0)){if(f(s.path))return M.URI.parse(s.path);if((0,E.isAbsolute)(s.path))return M.URI.file(s.path)}return s.path}function S(s){if(typeof s.path=="object"){const n=M.URI.revive(s.path);if(n)return n.scheme===F.Schemas.file?n.fsPath:n.toString()}return s.path}function v(s,n){const g=n?p:S,l=(0,P.deepClone)(s);return d(l,(c,b)=>{c&&b&&(b.path=g(b))}),l}e.convertToDAPaths=v;function o(s,n){const g=n?p:S,l=(0,P.deepClone)(s);return d(l,(c,b)=>{!c&&b&&(b.path=g(b))}),l}e.convertToVSCPaths=o;function d(s,n){switch(s.type){case"event":const g=s;switch(g.event){case"output":n(!1,g.body.source);break;case"loadedSource":n(!1,g.body.source);break;case"breakpoint":n(!1,g.body.breakpoint.source);break;default:break}break;case"request":const l=s;switch(l.command){case"setBreakpoints":n(!0,l.arguments.source);break;case"breakpointLocations":n(!0,l.arguments.source);break;case"source":n(!0,l.arguments.source);break;case"gotoTargets":n(!0,l.arguments.source);break;case"launchVSCode":l.arguments.args.forEach(b=>n(!1,b));break;default:break}break;case"response":const c=s;if(c.success&&c.body)switch(c.command){case"stackTrace":c.body.stackFrames.forEach(b=>n(!1,b.source));break;case"loadedSources":c.body.sources.forEach(b=>n(!1,b));break;case"scopes":c.body.scopes.forEach(b=>n(!1,b.source));break;case"setFunctionBreakpoints":c.body.breakpoints.forEach(b=>n(!1,b.source));break;case"setBreakpoints":c.body.breakpoints.forEach(b=>n(!1,b.source));break;default:break}break}}function D(s){return s.filter(n=>!n.presentation?.hidden).sort((n,g)=>n.presentation?g.presentation?n.presentation.group?g.presentation.group?n.presentation.group!==g.presentation.group?n.presentation.group.localeCompare(g.presentation.group):r(n.presentation.order,g.presentation.order):-1:g.presentation.group?1:r(n.presentation.order,g.presentation.order):-1:g.presentation?1:0)}e.getVisibleAndSorted=D;function r(s,n){return typeof s!="number"?typeof n!="number"?0:1:typeof n!="number"?-1:s-n}async function w(s,n){const g=s.getValue("debug.saveBeforeStart",{overrideIdentifier:n.activeTextEditorMode});if(g!=="none"&&(await n.saveAll(),g==="allEditorsInActiveGroup")){const l=n.activeEditorPane;l&&await n.save({editor:l.input,groupId:l.group.id})}await s.reloadConfiguration()}e.saveAllBeforeDebugStart=w}),define(we[89],be([0,1,28,167,79,11,17,25,38]),function(re,e,u,M,E,P,F,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var A;(function(y){y[y.Markup=1]="Markup",y[y.Code=2]="Code"})(A=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",E.Mimes.latex,E.Mimes.markdown,"image/png","image/jpeg",E.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[E.Mimes.latex,E.Mimes.markdown,"application/json",E.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["vscode.ipynb"])],["ms-toolsai.jupyter-renderers",new Set(["vscode.ipynb"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var t;(function(y){y[y.Running=1]="Running",y[y.Idle=2]="Idle"})(t=e.NotebookRunState||(e.NotebookRunState={}));var _;(function(y){y[y.Pending=2]="Pending",y[y.Executing=3]="Executing"})(_=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var i;(function(y){y[y.WithHardKernelDependency=0]="WithHardKernelDependency",y[y.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",y[y.Pure=2]="Pure",y[y.Never=3]="Never"})(i=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var m;(function(y){y.Always="always",y.Never="never",y.Optional="optional"})(m=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var a;(function(y){y[y.ModelChange=1]="ModelChange",y[y.Move=2]="Move",y[y.ChangeLanguage=5]="ChangeLanguage",y[y.Initialize=6]="Initialize",y[y.ChangeCellMetadata=7]="ChangeCellMetadata",y[y.Output=8]="Output",y[y.OutputItem=9]="OutputItem",y[y.ChangeCellContent=10]="ChangeCellContent",y[y.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",y[y.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",y[y.ChangeCellMime=13]="ChangeCellMime",y[y.Unknown=100]="Unknown"})(a=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var f;(function(y){y[y.Handle=0]="Handle",y[y.Index=1]="Index"})(f=e.SelectionStateType||(e.SelectionStateType={}));var p;(function(y){y[y.Replace=1]="Replace",y[y.Output=2]="Output",y[y.Metadata=3]="Metadata",y[y.CellLanguage=4]="CellLanguage",y[y.DocumentMetadata=5]="DocumentMetadata",y[y.Move=6]="Move",y[y.OutputItems=7]="OutputItems",y[y.PartialMetadata=8]="PartialMetadata",y[y.PartialInternalMetadata=9]="PartialInternalMetadata"})(p=e.CellEditType||(e.CellEditType={}));var S;(function(y){y.scheme=P.Schemas.vscodeNotebookCell;const R=/^ch(\d{7,})/;function I(N,V){return N.with({scheme:y.scheme,fragment:`ch${V.toString().padStart(7,"0")}${N.scheme!==P.Schemas.file?N.scheme:""}`})}y.generate=I;function B(N){if(N.scheme!==y.scheme)return;const V=R.exec(N.fragment);return V?{handle:Number(V[1]),notebook:N.with({scheme:N.fragment.substr(V[0].length)||P.Schemas.file,fragment:null})}:void 0}y.parse=B;function L(N){if(N.scheme!==P.Schemas.vscodeNotebookCellMetadata)return;const V=R.exec(N.fragment);return V?{handle:Number(V[1]),notebook:N.with({scheme:N.fragment.substr(V[0].length)||P.Schemas.file,fragment:null})}:void 0}y.parseCellMetadataUri=L;function k(N,V,W){return N.with({scheme:W,fragment:`ch${V.toString().padStart(7,"0")}${N.scheme!==P.Schemas.file?N.scheme:""}`})}y.generateCellUri=k;function x(N,V){if(N.scheme!==V)return;const W=R.exec(N.fragment);return W?{handle:Number(W[1]),notebook:N.with({scheme:N.fragment.substr(W[0].length)||P.Schemas.file,fragment:null})}:void 0}y.parseCellUri=x})(S=e.CellUri||(e.CellUri={}));const v=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[E.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[E.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[E.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function o(y){return v.get(y)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=o;function d(y){return v.get(y)?.supportedByCore??!1}e.mimeTypeSupportedByCore=d;function D(y){return v.get(y)?.mergeable??!1}e.mimeTypeIsMergeable=D;const r=y=>T.isWindows?y.replace(/\//g,"\\"):y;class w{constructor(R=[],I=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=I,this.order=[...new Set(R)].map(B=>({pattern:B,matches:u.parse(r(B))}))}sort(R){const I=new Map(M.Iterable.map(R,L=>[L,r(L)]));let B=[];for(const{matches:L}of this.order)for(const[k,x]of I)if(L(x)){B.push(k),I.delete(k);break}return I.size&&(B=B.concat([...I.keys()].sort((L,k)=>this.defaultOrder.indexOf(L)-this.defaultOrder.indexOf(k)))),B}prioritize(R,I){const B=this.findIndex(R);if(B===-1){this.order.unshift({pattern:R,matches:u.parse(r(R))});return}const L=new Set(I.map(x=>this.findIndex(x,B)));L.delete(-1);const k=Array.from(L).sort();this.order.splice(B+1,0,...k.map(x=>this.order[x]));for(let x=k.length-1;x>=0;x--)this.order.splice(k[x],1)}toArray(){return this.order.map(R=>R.pattern)}findIndex(R,I=this.order.length){const B=r(R);for(let L=0;L<I;L++)if(this.order[L].matches(B))return L;return-1}}e.MimeTypeDisplayOrder=w;function s(y,R,I,B=(L,k)=>L===k){const L=[];function k(V,W,$){if(W===0&&$.length===0)return;const X=L[L.length-1];X&&X.start+X.deleteCount===V?(X.deleteCount+=W,X.toInsert.push(...$)):L.push({start:V,deleteCount:W,toInsert:$})}let x=0,N=0;for(;;){if(x===y.length){k(x,0,R.slice(N));break}if(N===R.length){k(x,y.length-x,[]);break}const V=y[x],W=R[N];if(B(V,W)){x+=1,N+=1;continue}I(W)?(k(x,1,[]),x+=1):(k(x,0,[W]),N+=1)}return L}e.diff=s,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var n;(function(y){y.default="default",y.option="option"})(n=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function g(y){const R=y;return!!((typeof R.include=="string"||u.isRelativePattern(R.include))&&(typeof R.exclude=="string"||u.isRelativePattern(R.exclude)))}e.isDocumentExcludePattern=g;function l(y,R,I){if(Array.isArray(y.viewType)&&y.viewType.indexOf(R)>=0||y.viewType===R)return!0;if(y.filenamePattern){let B=g(y.filenamePattern)?y.filenamePattern.include:y.filenamePattern,L=g(y.filenamePattern)?y.filenamePattern.exclude:void 0;if(u.match(B,(0,F.basename)(I.fsPath).toLowerCase()))return!(L&&u.match(L,(0,F.basename)(I.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=l;class c{constructor(R){this.textModel=R}getElements(){const R=new Int32Array(this.textModel.cells.length);for(let I=0;I<this.textModel.cells.length;I++)R[I]=this.textModel.cells[I].getHashValue();return R}}e.CellSequence=c,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var b;(function(y){y[y.Left=1]="Left",y[y.Right=2]="Right"})(b=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class h{static create(R){return`${h._prefix}${R}`}static parse(R){if(R.startsWith(h._prefix))return R.substr(h._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=h,h._prefix="notebook/"}),define(we[168],be([0,1,4]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var M;(function(E){E[E.Output=1]="Output",E[E.OutputItems=2]="OutputItems",E[E.ExecutionState=3]="ExecutionState",E[E.Complete=4]="Complete"})(M=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,u.createDecorator)("INotebookExecutionService")}),define(we[169],be([0,1,4,38]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new M.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new M.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new M.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,u.createDecorator)(e.OUTPUT_SERVICE_ID);var E;(function(P){P[P.Append=1]="Append",P[P.Replace=2]="Replace",P[P.Clear=3]="Clear"})(E=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(we[170],be([0,1,136,4,38]),function(re,e,u,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new E.RawContextKey("customExecutionSupported",!0,u.localize(0,null)),e.ShellExecutionSupportedContext=new E.RawContextKey("shellExecutionSupported",!1,u.localize(1,null)),e.ProcessExecutionSupportedContext=new E.RawContextKey("processExecutionSupported",!1,u.localize(2,null)),e.ITaskService=(0,M.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(we[171],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function u(E){return[...E.entries()]}e.serializeEnvironmentVariableCollection=u;function M(E){return new Map(E)}e.deserializeEnvironmentVariableCollection=M}),define(we[90],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var u;(function(_){_[_.Unset=0]="Unset",_[_.Queued=1]="Queued",_[_.Running=2]="Running",_[_.Passed=3]="Passed",_[_.Failed=4]="Failed",_[_.Skipped=5]="Skipped",_[_.Errored=6]="Errored"})(u=e.TestResultState||(e.TestResultState={}));var M;(function(_){_[_.Run=2]="Run",_[_.Debug=4]="Debug",_[_.Coverage=8]="Coverage",_[_.HasNonDefaultProfile=16]="HasNonDefaultProfile",_[_.HasConfigurable=32]="HasConfigurable"})(M=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var E;(function(_){_[_.Error=0]="Error",_[_.Info=1]="Info"})(E=e.TestMessageType||(e.TestMessageType={}));var P;(function(_){_[_.NotExpandable=0]="NotExpandable",_[_.Expandable=1]="Expandable",_[_.BusyExpanding=2]="BusyExpanding",_[_.Expanded=3]="Expanded"})(P=e.TestItemExpandState||(e.TestItemExpandState={}));const F=(_,i)=>{i.expand!==void 0&&(_.expand=i.expand),i.item!==void 0&&(_.item=_.item?Object.assign(_.item,i.item):i.item)};e.applyTestItemUpdate=F;var T;(function(_){_[_.Function=0]="Function",_[_.Statement=1]="Statement"})(T=e.DetailType||(e.DetailType={}));var C;(function(_){_[_.Add=0]="Add",_[_.Update=1]="Update",_[_.Remove=2]="Remove",_[_.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",_[_.Retire=4]="Retire",_[_.AddTag=5]="AddTag",_[_.RemoveTag=6]="RemoveTag"})(C=e.TestDiffOpType||(e.TestDiffOpType={}));class A{add(i){}update(i){}remove(i,m){}complete(){}}e.IncrementalChangeCollector=A;class t{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(i){const m=this.createChangeCollector();for(const a of i)switch(a[0]){case 0:{const f=a[1];if(f.parent){if(this.items.has(f.parent)){const p=this.items.get(f.parent);p.children.add(f.item.extId);const S=this.createItem(f,p);this.items.set(f.item.extId,S),m.add(S)}}else{const p=this.createItem(f);this.roots.add(p),this.items.set(f.item.extId,p),m.add(p)}f.expand===2&&this.busyControllerCount++;break}case 1:{const f=a[1],p=this.items.get(f.extId);if(!p)break;f.expand!==void 0&&(p.expand===2&&this.busyControllerCount--,f.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(p,f),m.update(p);break}case 2:{const f=this.items.get(a[1]);if(!f)break;f.parent?this.items.get(f.parent).children.delete(f.item.extId):this.roots.delete(f);const p=[[a[1]]];for(;p.length;)for(const S of p.pop()){const v=this.items.get(S);v&&(p.push(v.children),this.items.delete(S),m.remove(v,v!==f),v.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(a[1]);break;case 3:this.updatePendingRoots(a[1]);break;case 5:this._tags.set(a[1].id,a[1]);break;case 6:this._tags.delete(a[1]);break}m.complete()}retireTest(i){}updatePendingRoots(i){this.pendingRootCount+=i}createChangeCollector(){return new A}}e.AbstractIncrementalTestCollection=t}),define(we[69],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var u;(function(P){P.Delimiter="\0"})(u=e.TestIdPathParts||(e.TestIdPathParts={}));var M;(function(P){P[P.IsSame=0]="IsSame",P[P.Disconnected=1]="Disconnected",P[P.IsChild=2]="IsChild",P[P.IsParent=3]="IsParent"})(M=e.TestPosition||(e.TestPosition={}));class E{constructor(F,T=F.length){if(this.path=F,this.viewEnd=T,F.length===0||T<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(F,T,C=F.parent){if(F.id===T)return new E([T]);let A=[F.id];for(let t=C;t&&t.id!==T;t=t.parent)A.push(t.id);return A.push(T),new E(A.reverse())}static isRoot(F){return!F.includes("\0")}static fromString(F){return new E(F.split("\0"))}static join(F,T){return new E([...F.path,T])}static joinToString(F,T){return F.toString()+"\0"+T}static compare(F,T){return F===T?0:T.startsWith(F+"\0")?2:F.startsWith(T+"\0")?3:1}get parentId(){return this.viewEnd>1?new E(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let F=1;F<=this.viewEnd;F++)yield new E(this.path,F)}compare(F){if(typeof F=="string")return E.compare(this.toString(),F);for(let T=0;T<F.viewEnd&&T<this.viewEnd;T++)if(F.path[T]!==this.path[T])return 1;return F.viewEnd>this.viewEnd?2:F.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let F=1;F<this.viewEnd;F++)this.stringifed+="\0",this.stringifed+=this.path[F]}return this.stringifed}}e.TestId=E}),define(we[172],be([0,1,17,91,10,23,25,78,137]),function(re,e,u,M,E,P,F,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class A{constructor(_,i,m){this._contributedVariables=new Map,this._context=_,this._labelService=i,m&&(this._envVariablesPromise=m.then(a=>this.prepareEnv(a)))}prepareEnv(_){if(F.isWindows){const i=Object.create(null);return Object.keys(_).forEach(m=>{i[m.toLowerCase()]=_[m]}),i}return _}resolveWithEnvironment(_,i,m){return this.recursiveResolve(this.prepareEnv(_),i?i.uri:void 0,m)}async resolveAsync(_,i){return this.recursiveResolve(await this._envVariablesPromise,_?_.uri:void 0,i)}async resolveAnyBase(_,i,m,a){const f=P.deepClone(i);return F.isWindows&&f.windows?Object.keys(f.windows).forEach(p=>f[p]=f.windows[p]):F.isMacintosh&&f.osx?Object.keys(f.osx).forEach(p=>f[p]=f.osx[p]):F.isLinux&&f.linux&&Object.keys(f.linux).forEach(p=>f[p]=f.linux[p]),delete f.windows,delete f.osx,delete f.linux,this.recursiveResolve(await this._envVariablesPromise,_?_.uri:void 0,f,m,a)}async resolveAnyAsync(_,i,m){return this.resolveAnyBase(_,i,m)}async resolveAnyMap(_,i,m){const a=new Map;return{newConfig:await this.resolveAnyBase(_,i,m,a),resolvedVariables:a}}resolveWithInteractionReplace(_,i,m,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(_,i,m,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(_,i){if(this._contributedVariables.has(_))throw new Error("Variable "+_+" is contributed twice.");this._contributedVariables.set(_,i)}recursiveResolve(_,i,m,a,f){if(E.isString(m))return this.resolveString(_,i,m,a,f);if(E.isArray(m))return m.map(p=>this.recursiveResolve(_,i,p,a,f));if(E.isObject(m)){let p=Object.create(null);return Object.keys(m).forEach(S=>{const v=this.resolveString(_,i,S,a,f);p[v]=this.recursiveResolve(_,i,m[S],a,f)}),p}return m}resolveString(_,i,m,a,f){return m.replace(A.VARIABLE_REGEXP,(S,v)=>{if(v.includes(A.VARIABLE_LHS))return S;let o=this.evaluateSingleVariable(_,S,v,i,a);return f&&f.set(v,o),o!==S&&E.isString(o)&&o.match(A.VARIABLE_REGEXP)&&(o=this.resolveString(_,i,o,a,f)),o})}fsPath(_){return this._labelService?this._labelService.getUriLabel(_,{noPrefix:!0}):_.fsPath}evaluateSingleVariable(_,i,m,a,f){let p;const S=m.split(":");S.length>1&&(m=S[0],p=S[1]);const v=()=>{const D=this._context.getFilePath();if(D)return D;throw new Error((0,C.localize)(0,null,i))},o=()=>{const D=v();if(this._context.getWorkspaceFolderPathForFile){const r=this._context.getWorkspaceFolderPathForFile();if(r)return r}throw new Error((0,C.localize)(1,null,i,u.basename(D)))},d=()=>{if(p){const D=this._context.getFolderUri(p);if(D)return D;throw new Error((0,C.localize)(2,null,i,p))}if(a)return a;throw this._context.getWorkspaceFolderCount()>1?new Error((0,C.localize)(3,null,i)):new Error((0,C.localize)(4,null,i))};switch(m){case"env":if(p){if(_){const D=_[F.isWindows?p.toLowerCase():p];if(E.isString(D))return D}return""}throw new Error((0,C.localize)(5,null,i));case"config":if(p){const D=this._context.getConfigurationValue(a,p);if(E.isUndefinedOrNull(D))throw new Error((0,C.localize)(6,null,i,p));if(E.isObject(D))throw new Error((0,C.localize)(7,null,i,p));return D}throw new Error((0,C.localize)(8,null,i));case"command":return this.resolveFromMap(i,p,f,"command");case"input":return this.resolveFromMap(i,p,f,"input");default:switch(m){case"workspaceRoot":case"workspaceFolder":return(0,T.normalizeDriveLetter)(this.fsPath(d()));case"cwd":return a||p?(0,T.normalizeDriveLetter)(this.fsPath(d())):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return u.basename(this.fsPath(d()));case"lineNumber":const D=this._context.getLineNumber();if(D)return D;throw new Error((0,C.localize)(9,null,i));case"selectedText":const r=this._context.getSelectedText();if(r)return r;throw new Error((0,C.localize)(10,null,i));case"file":return v();case"fileWorkspaceFolder":return o();case"relativeFile":return a||p?u.relative(this.fsPath(d()),v()):v();case"relativeFileDirname":const w=u.dirname(v());if(a||p){const l=u.relative(this.fsPath(d()),w);return l.length===0?".":l}return w;case"fileDirname":return u.dirname(v());case"fileExtname":return u.extname(v());case"fileBasename":return u.basename(v());case"fileBasenameNoExtension":const s=u.basename(v());return s.slice(0,s.length-u.extname(s).length);case"fileDirnameBasename":return u.basename(u.dirname(v()));case"execPath":const n=this._context.getExecPath();return n||i;case"execInstallFolder":const g=this._context.getAppRoot();return g||i;case"pathSeparator":return u.sep;default:try{const l=p?`${m}:${p}`:m;return this.resolveFromMap(i,l,f,void 0)}catch(l){return i}}}}resolveFromMap(_,i,m,a){if(i&&m){const f=a===void 0?m[i]:m[a+":"+i];if(typeof f=="string")return f;throw new Error((0,C.localize)(11,null,_))}return _}}e.AbstractVariableResolverService=A,A.VARIABLE_LHS="${",A.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(we[92],be([0,1,4,163]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,u.createDecorator)("editorGroupsService");var E;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(E=e.GroupDirection||(e.GroupDirection={}));var P;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(P=e.GroupOrientation||(e.GroupOrientation={}));var F;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(F=e.GroupLocation||(e.GroupLocation={}));var T;(function(f){f[f.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",f[f.EVEN=1]="EVEN",f[f.TOGGLE=2]="TOGGLE"})(T=e.GroupsArrangement||(e.GroupsArrangement={}));var C;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(C=e.MergeGroupMode||(e.MergeGroupMode={}));function A(f){const p=f;return(0,M.isEditorInput)(p?.editor)&&(0,M.isEditorInput)(p?.replacement)}e.isEditorReplacement=A;var t;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(t=e.GroupsOrder||(e.GroupsOrder={}));var _;(function(f){f[f.GROUP_ACTIVE=0]="GROUP_ACTIVE",f[f.GROUP_INDEX=1]="GROUP_INDEX",f[f.GROUP_LOCKED=2]="GROUP_LOCKED",f[f.EDITOR_OPEN=3]="EDITOR_OPEN",f[f.EDITOR_CLOSE=4]="EDITOR_CLOSE",f[f.EDITOR_MOVE=5]="EDITOR_MOVE",f[f.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",f[f.EDITOR_LABEL=7]="EDITOR_LABEL",f[f.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",f[f.EDITOR_PIN=9]="EDITOR_PIN",f[f.EDITOR_STICKY=10]="EDITOR_STICKY",f[f.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(_=e.GroupChangeKind||(e.GroupChangeKind={}));var i;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(i=e.OpenEditorContext||(e.OpenEditorContext={}));function m(f){const p=f;return!!p&&typeof p.id=="number"&&Array.isArray(p.editors)}e.isEditorGroup=m;function a(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=a}),define(we[173],be([0,1,4,92]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,u.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function E(P){const F=P;return typeof P=="number"||(0,M.isEditorGroup)(F)}e.isPreferredGroup=E}),define(we[8],be([0,1,15,22,77,234,57,23,10,2,45,61,138,83,50,89,69,173,7]),function(re,e,u,M,E,P,F,T,C,A,t,_,i,m,a,f,p,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var o;(function(ue){function me(H){const{selectionStartLineNumber:ve,selectionStartColumn:Ce,positionLineNumber:Ke,positionColumn:xe}=H,lt=new v.Position(ve-1,Ce-1),Et=new v.Position(Ke-1,xe-1);return new v.Selection(lt,Et)}ue.to=me;function ne(H){const{anchor:ve,active:Ce}=H;return{selectionStartLineNumber:ve.line+1,selectionStartColumn:ve.character+1,positionLineNumber:Ce.line+1,positionColumn:Ce.character+1}}ue.from=ne})(o=e.Selection||(e.Selection={}));var d;(function(ue){function me(H){if(!H)return;const{start:ve,end:Ce}=H;return{startLineNumber:ve.line+1,startColumn:ve.character+1,endLineNumber:Ce.line+1,endColumn:Ce.character+1}}ue.from=me;function ne(H){if(!H)return;const{startLineNumber:ve,startColumn:Ce,endLineNumber:Ke,endColumn:xe}=H;return new v.Range(ve-1,Ce-1,Ke-1,xe-1)}ue.to=ne})(d=e.Range||(e.Range={}));var D;(function(ue){function me(ne){switch(ne){case 1:return v.StandardTokenType.Comment;case 0:return v.StandardTokenType.Other;case 4:return v.StandardTokenType.RegEx;case 2:return v.StandardTokenType.String}}ue.to=me})(D=e.TokenType||(e.TokenType={}));var r;(function(ue){function me(H){return new v.Position(H.lineNumber-1,H.column-1)}ue.to=me;function ne(H){return{lineNumber:H.line+1,column:H.character+1}}ue.from=ne})(r=e.Position||(e.Position={}));var w;(function(ue){function me(ve,Ce){return(0,u.coalesce)((0,u.asArray)(ve).map(Ke=>ne(Ke,Ce)))}ue.from=me;function ne(ve,Ce){if(typeof ve=="string")return{$serialized:!0,language:ve};if(ve)return{$serialized:!0,language:ve.language,scheme:H(ve.scheme,Ce),pattern:typeof ve.pattern=="undefined"?void 0:rt.from(ve.pattern),exclusive:ve.exclusive}}function H(ve,Ce){return Ce&&typeof ve=="string"?Ce.transformOutgoingScheme(ve):ve}})(w=e.DocumentSelector||(e.DocumentSelector={}));var s;(function(ue){function me(H){switch(H){case v.DiagnosticTag.Unnecessary:return 1;case v.DiagnosticTag.Deprecated:return 2}}ue.from=me;function ne(H){switch(H){case 1:return v.DiagnosticTag.Unnecessary;case 2:return v.DiagnosticTag.Deprecated;default:return}}ue.to=ne})(s=e.DiagnosticTag||(e.DiagnosticTag={}));var n;(function(ue){function me(H){let ve;return H.code&&((0,C.isString)(H.code)||(0,C.isNumber)(H.code)?ve=String(H.code):ve={value:String(H.code.value),target:H.code.target}),{...d.from(H.range),message:H.message,source:H.source,code:ve,severity:l.from(H.severity),relatedInformation:H.relatedInformation&&H.relatedInformation.map(g.from),tags:Array.isArray(H.tags)?(0,u.coalesce)(H.tags.map(s.from)):void 0}}ue.from=me;function ne(H){const ve=new v.Diagnostic(d.to(H),H.message,l.to(H.severity));return ve.source=H.source,ve.code=(0,C.isString)(H.code)?H.code:H.code?.value,ve.relatedInformation=H.relatedInformation&&H.relatedInformation.map(g.to),ve.tags=H.tags&&(0,u.coalesce)(H.tags.map(s.to)),ve}ue.to=ne})(n=e.Diagnostic||(e.Diagnostic={}));var g;(function(ue){function me(H){return{...d.from(H.location.range),message:H.message,resource:H.location.uri}}ue.from=me;function ne(H){return new v.DiagnosticRelatedInformation(new v.Location(H.resource,d.to(H)),H.message)}ue.to=ne})(g=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var l;(function(ue){function me(H){switch(H){case v.DiagnosticSeverity.Error:return m.MarkerSeverity.Error;case v.DiagnosticSeverity.Warning:return m.MarkerSeverity.Warning;case v.DiagnosticSeverity.Information:return m.MarkerSeverity.Info;case v.DiagnosticSeverity.Hint:return m.MarkerSeverity.Hint}return m.MarkerSeverity.Error}ue.from=me;function ne(H){switch(H){case m.MarkerSeverity.Info:return v.DiagnosticSeverity.Information;case m.MarkerSeverity.Warning:return v.DiagnosticSeverity.Warning;case m.MarkerSeverity.Error:return v.DiagnosticSeverity.Error;case m.MarkerSeverity.Hint:return v.DiagnosticSeverity.Hint;default:return v.DiagnosticSeverity.Error}}ue.to=ne})(l=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var c;(function(ue){function me(H){return typeof H=="number"&&H>=v.ViewColumn.One?H-1:H===v.ViewColumn.Beside?S.SIDE_GROUP:S.ACTIVE_GROUP}ue.from=me;function ne(H){if(typeof H=="number"&&H>=0)return H+1;throw new Error("invalid 'EditorGroupColumn'")}ue.to=ne})(c=e.ViewColumn||(e.ViewColumn={}));function b(ue){return typeof ue.range!="undefined"}function h(ue){return ue.length===0?!0:!!b(ue[0])}e.isDecorationOptionsArr=h;var y;(function(ue){function me(xe){return xe.map(ue.from)}ue.fromMany=me;function ne(xe){return xe&&typeof xe=="object"&&typeof xe.language=="string"&&typeof xe.value=="string"}function H(xe){let lt;if(ne(xe)){const{language:gt,value:dt}=xe;lt={value:"```"+gt+`
`+dt+"\n```\n"}}else v.MarkdownString.isMarkdownString(xe)?lt={value:xe.value,isTrusted:xe.isTrusted,supportThemeIcons:xe.supportThemeIcons,supportHtml:xe.supportHtml}:typeof xe=="string"?lt={value:xe}:lt={value:""};const Et=Object.create(null);lt.uris=Et;const vt=gt=>{try{let dt=A.URI.parse(gt,!0);dt=dt.with({query:ve(dt.query,Et)}),Et[gt]=dt}catch(dt){}return""},ut=new P.Renderer;return ut.link=vt,ut.image=gt=>vt(E.parseHrefAndDimensions(gt).href),P(lt.value,{renderer:ut}),lt}ue.from=H;function ve(xe,lt){if(!xe)return xe;let Et;try{Et=(0,F.parse)(xe)}catch(ut){}if(!Et)return xe;let vt=!1;return Et=(0,T.cloneAndChange)(Et,ut=>{if(A.URI.isUri(ut)){const gt=`__uri_${Math.random().toString(16).slice(2,8)}`;return lt[gt]=ut,vt=!0,gt}else return}),vt?JSON.stringify(Et):xe}function Ce(xe){const lt=new v.MarkdownString(xe.value,xe.supportThemeIcons);return lt.isTrusted=xe.isTrusted,lt.supportHtml=xe.supportHtml,lt}ue.to=Ce;function Ke(xe){if(!!xe)return typeof xe=="string"?xe:ue.from(xe)}ue.fromStrict=Ke})(y=e.MarkdownString||(e.MarkdownString={}));function R(ue){return h(ue)?ue.map(me=>({range:d.from(me.range),hoverMessage:Array.isArray(me.hoverMessage)?y.fromMany(me.hoverMessage):me.hoverMessage?y.from(me.hoverMessage):void 0,renderOptions:me.renderOptions})):ue.map(me=>({range:d.from(me)}))}e.fromRangeOrRangeWithMessage=R;function I(ue){return typeof ue=="undefined"?ue:typeof ue=="string"?A.URI.file(ue):ue}e.pathOrURIToURI=I;var B;(function(ue){function me(ne){return typeof ne=="undefined"?ne:{contentText:ne.contentText,contentIconPath:ne.contentIconPath?I(ne.contentIconPath):void 0,border:ne.border,borderColor:ne.borderColor,fontStyle:ne.fontStyle,fontWeight:ne.fontWeight,textDecoration:ne.textDecoration,color:ne.color,backgroundColor:ne.backgroundColor,margin:ne.margin,width:ne.width,height:ne.height}}ue.from=me})(B=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var L;(function(ue){function me(ne){return typeof ne=="undefined"?ne:{backgroundColor:ne.backgroundColor,outline:ne.outline,outlineColor:ne.outlineColor,outlineStyle:ne.outlineStyle,outlineWidth:ne.outlineWidth,border:ne.border,borderColor:ne.borderColor,borderRadius:ne.borderRadius,borderSpacing:ne.borderSpacing,borderStyle:ne.borderStyle,borderWidth:ne.borderWidth,fontStyle:ne.fontStyle,fontWeight:ne.fontWeight,textDecoration:ne.textDecoration,cursor:ne.cursor,color:ne.color,opacity:ne.opacity,letterSpacing:ne.letterSpacing,gutterIconPath:ne.gutterIconPath?I(ne.gutterIconPath):void 0,gutterIconSize:ne.gutterIconSize,overviewRulerColor:ne.overviewRulerColor,before:ne.before?B.from(ne.before):void 0,after:ne.after?B.from(ne.after):void 0}}ue.from=me})(L=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var k;(function(ue){function me(ne){if(typeof ne=="undefined")return ne;switch(ne){case v.DecorationRangeBehavior.OpenOpen:return 0;case v.DecorationRangeBehavior.ClosedClosed:return 1;case v.DecorationRangeBehavior.OpenClosed:return 2;case v.DecorationRangeBehavior.ClosedOpen:return 3}}ue.from=me})(k=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var x;(function(ue){function me(ne){return{isWholeLine:ne.isWholeLine,rangeBehavior:ne.rangeBehavior?k.from(ne.rangeBehavior):void 0,overviewRulerLane:ne.overviewRulerLane,light:ne.light?L.from(ne.light):void 0,dark:ne.dark?L.from(ne.dark):void 0,backgroundColor:ne.backgroundColor,outline:ne.outline,outlineColor:ne.outlineColor,outlineStyle:ne.outlineStyle,outlineWidth:ne.outlineWidth,border:ne.border,borderColor:ne.borderColor,borderRadius:ne.borderRadius,borderSpacing:ne.borderSpacing,borderStyle:ne.borderStyle,borderWidth:ne.borderWidth,fontStyle:ne.fontStyle,fontWeight:ne.fontWeight,textDecoration:ne.textDecoration,cursor:ne.cursor,color:ne.color,opacity:ne.opacity,letterSpacing:ne.letterSpacing,gutterIconPath:ne.gutterIconPath?I(ne.gutterIconPath):void 0,gutterIconSize:ne.gutterIconSize,overviewRulerColor:ne.overviewRulerColor,before:ne.before?B.from(ne.before):void 0,after:ne.after?B.from(ne.after):void 0}}ue.from=me})(x=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var N;(function(ue){function me(H){return{text:H.newText,eol:H.newEol&&q.from(H.newEol),range:d.from(H.range)}}ue.from=me;function ne(H){const ve=new v.TextEdit(d.to(H.range),H.text);return ve.newEol=typeof H.eol=="undefined"?void 0:q.to(H.eol),ve}ue.to=ne})(N=e.TextEdit||(e.TextEdit={}));var V;(function(ue){function me(H,ve,Ce){const Ke={edits:[]};if(H instanceof v.WorkspaceEdit)for(let xe of H._allEntries())if(xe._type===1)Ke.edits.push({_type:1,oldUri:xe.from,newUri:xe.to,options:xe.options,metadata:xe.metadata});else if(xe._type===2){const lt=ve?.getDocument(xe.uri);Ke.edits.push({_type:2,resource:xe.uri,edit:N.from(xe.edit),modelVersionId:lt?.version,metadata:xe.metadata})}else xe._type===3?Ke.edits.push({_type:3,metadata:xe.metadata,resource:xe.uri,edit:xe.edit,notebookMetadata:xe.notebookMetadata,notebookVersionId:Ce?.getNotebookDocument(xe.uri,!0)?.apiNotebook.version}):xe._type===5&&Ke.edits.push({_type:3,metadata:xe.metadata,resource:xe.uri,notebookVersionId:Ce?.getNotebookDocument(xe.uri,!0)?.apiNotebook.version,edit:{editType:1,index:xe.index,count:xe.count,cells:xe.cells.map(Xe.from)}});return Ke}ue.from=me;function ne(H){const ve=new v.WorkspaceEdit;for(const Ce of H.edits)Ce.edit?ve.replace(A.URI.revive(Ce.resource),d.to(Ce.edit.range),Ce.edit.text):ve.renameFile(A.URI.revive(Ce.oldUri),A.URI.revive(Ce.newUri),Ce.options);return ve}ue.to=ne})(V=e.WorkspaceEdit||(e.WorkspaceEdit={}));var W;(function(ue){const me=Object.create(null);me[v.SymbolKind.File]=0,me[v.SymbolKind.Module]=1,me[v.SymbolKind.Namespace]=2,me[v.SymbolKind.Package]=3,me[v.SymbolKind.Class]=4,me[v.SymbolKind.Method]=5,me[v.SymbolKind.Property]=6,me[v.SymbolKind.Field]=7,me[v.SymbolKind.Constructor]=8,me[v.SymbolKind.Enum]=9,me[v.SymbolKind.Interface]=10,me[v.SymbolKind.Function]=11,me[v.SymbolKind.Variable]=12,me[v.SymbolKind.Constant]=13,me[v.SymbolKind.String]=14,me[v.SymbolKind.Number]=15,me[v.SymbolKind.Boolean]=16,me[v.SymbolKind.Array]=17,me[v.SymbolKind.Object]=18,me[v.SymbolKind.Key]=19,me[v.SymbolKind.Null]=20,me[v.SymbolKind.EnumMember]=21,me[v.SymbolKind.Struct]=22,me[v.SymbolKind.Event]=23,me[v.SymbolKind.Operator]=24,me[v.SymbolKind.TypeParameter]=25;function ne(ve){return typeof me[ve]=="number"?me[ve]:6}ue.from=ne;function H(ve){for(const Ce in me)if(me[Ce]===ve)return Number(Ce);return v.SymbolKind.Property}ue.to=H})(W=e.SymbolKind||(e.SymbolKind={}));var $;(function(ue){function me(H){switch(H){case v.SymbolTag.Deprecated:return 1}}ue.from=me;function ne(H){switch(H){case 1:return v.SymbolTag.Deprecated}}ue.to=ne})($=e.SymbolTag||(e.SymbolTag={}));var X;(function(ue){function me(H){return{name:H.name,kind:W.from(H.kind),tags:H.tags&&H.tags.map($.from),containerName:H.containerName,location:ce.from(H.location)}}ue.from=me;function ne(H){const ve=new v.SymbolInformation(H.name,W.to(H.kind),H.containerName,ce.to(H.location));return ve.tags=H.tags&&H.tags.map($.to),ve}ue.to=ne})(X=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var j;(function(ue){function me(H){const ve={name:H.name||"!!MISSING: name!!",detail:H.detail,range:d.from(H.range),selectionRange:d.from(H.selectionRange),kind:W.from(H.kind),tags:H.tags?.map($.from)??[]};return H.children&&(ve.children=H.children.map(me)),ve}ue.from=me;function ne(H){const ve=new v.DocumentSymbol(H.name,H.detail,W.to(H.kind),d.to(H.range),d.to(H.selectionRange));return(0,u.isNonEmptyArray)(H.tags)&&(ve.tags=H.tags.map($.to)),H.children&&(ve.children=H.children.map(ne)),ve}ue.to=ne})(j=e.DocumentSymbol||(e.DocumentSymbol={}));var Q;(function(ue){function me(H){const ve=new v.CallHierarchyItem(W.to(H.kind),H.name,H.detail||"",A.URI.revive(H.uri),d.to(H.range),d.to(H.selectionRange));return ve._sessionId=H._sessionId,ve._itemId=H._itemId,ve}ue.to=me;function ne(H,ve,Ce){if(ve=ve??H._sessionId,Ce=Ce??H._itemId,ve===void 0||Ce===void 0)throw new Error("invalid item");return{_sessionId:ve,_itemId:Ce,name:H.name,detail:H.detail,kind:W.from(H.kind),uri:H.uri,range:d.from(H.range),selectionRange:d.from(H.selectionRange),tags:H.tags?.map($.from)}}ue.from=ne})(Q=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ae;(function(ue){function me(ne){return new v.CallHierarchyIncomingCall(Q.to(ne.from),ne.fromRanges.map(H=>d.to(H)))}ue.to=me})(ae=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var pe;(function(ue){function me(ne){return new v.CallHierarchyOutgoingCall(Q.to(ne.to),ne.fromRanges.map(H=>d.to(H)))}ue.to=me})(pe=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ce;(function(ue){function me(H){return{range:H.range&&d.from(H.range),uri:H.uri}}ue.from=me;function ne(H){return new v.Location(A.URI.revive(H.uri),d.to(H.range))}ue.to=ne})(ce=e.location||(e.location={}));var Fe;(function(ue){function me(H){const ve=H,Ce=H;return{originSelectionRange:ve.originSelectionRange?d.from(ve.originSelectionRange):void 0,uri:ve.targetUri?ve.targetUri:Ce.uri,range:d.from(ve.targetRange?ve.targetRange:Ce.range),targetSelectionRange:ve.targetSelectionRange?d.from(ve.targetSelectionRange):void 0}}ue.from=me;function ne(H){return{targetUri:A.URI.revive(H.uri),targetRange:d.to(H.range),targetSelectionRange:H.targetSelectionRange?d.to(H.targetSelectionRange):void 0,originSelectionRange:H.originSelectionRange?d.to(H.originSelectionRange):void 0}}ue.to=ne})(Fe=e.DefinitionLink||(e.DefinitionLink={}));var Qe;(function(ue){function me(H){return{range:d.from(H.range),contents:y.fromMany(H.contents)}}ue.from=me;function ne(H){return new v.Hover(H.contents.map(y.to),d.to(H.range))}ue.to=ne})(Qe=e.Hover||(e.Hover={}));var Oe;(function(ue){function me(H){return{range:d.from(H.range),expression:H.expression}}ue.from=me;function ne(H){return new v.EvaluatableExpression(d.to(H.range),H.expression)}ue.to=ne})(Oe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var He;(function(ue){function me(H){if(H instanceof v.InlineValueText)return{type:"text",range:d.from(H.range),text:H.text};if(H instanceof v.InlineValueVariableLookup)return{type:"variable",range:d.from(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};if(H instanceof v.InlineValueEvaluatableExpression)return{type:"expression",range:d.from(H.range),expression:H.expression};throw new Error("Unknown 'InlineValue' type")}ue.from=me;function ne(H){switch(H.type){case"text":return{range:d.to(H.range),text:H.text};case"variable":return{range:d.to(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};case"expression":return{range:d.to(H.range),expression:H.expression}}}ue.to=ne})(He=e.InlineValue||(e.InlineValue={}));var Je;(function(ue){function me(H){return{frameId:H.frameId,stoppedLocation:d.from(H.stoppedLocation)}}ue.from=me;function ne(H){return new v.InlineValueContext(H.frameId,d.to(H.stoppedLocation))}ue.to=ne})(Je=e.InlineValueContext||(e.InlineValueContext={}));var Ye;(function(ue){function me(H){return{range:d.from(H.range),kind:H.kind}}ue.from=me;function ne(H){return new v.DocumentHighlight(d.to(H.range),H.kind)}ue.to=ne})(Ye=e.DocumentHighlight||(e.DocumentHighlight={}));var qe;(function(ue){function me(ne){switch(ne){case 1:return v.CompletionTriggerKind.TriggerCharacter;case 2:return v.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return v.CompletionTriggerKind.Invoke}}ue.to=me})(qe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var z;(function(ue){function me(ne){return{triggerKind:qe.to(ne.triggerKind),triggerCharacter:ne.triggerCharacter}}ue.to=me})(z=e.CompletionContext||(e.CompletionContext={}));var K;(function(ue){function me(H){switch(H){case v.CompletionItemTag.Deprecated:return 1}}ue.from=me;function ne(H){switch(H){case 1:return v.CompletionItemTag.Deprecated}}ue.to=ne})(K=e.CompletionItemTag||(e.CompletionItemTag={}));var Z;(function(ue){const me=new Map([[v.CompletionItemKind.Method,0],[v.CompletionItemKind.Function,1],[v.CompletionItemKind.Constructor,2],[v.CompletionItemKind.Field,3],[v.CompletionItemKind.Variable,4],[v.CompletionItemKind.Class,5],[v.CompletionItemKind.Interface,7],[v.CompletionItemKind.Struct,6],[v.CompletionItemKind.Module,8],[v.CompletionItemKind.Property,9],[v.CompletionItemKind.Unit,12],[v.CompletionItemKind.Value,13],[v.CompletionItemKind.Constant,14],[v.CompletionItemKind.Enum,15],[v.CompletionItemKind.EnumMember,16],[v.CompletionItemKind.Keyword,17],[v.CompletionItemKind.Snippet,27],[v.CompletionItemKind.Text,18],[v.CompletionItemKind.Color,19],[v.CompletionItemKind.File,20],[v.CompletionItemKind.Reference,21],[v.CompletionItemKind.Folder,23],[v.CompletionItemKind.Event,10],[v.CompletionItemKind.Operator,11],[v.CompletionItemKind.TypeParameter,24],[v.CompletionItemKind.Issue,26],[v.CompletionItemKind.User,25]]);function ne(Ce){return me.get(Ce)??9}ue.from=ne;const H=new Map([[0,v.CompletionItemKind.Method],[1,v.CompletionItemKind.Function],[2,v.CompletionItemKind.Constructor],[3,v.CompletionItemKind.Field],[4,v.CompletionItemKind.Variable],[5,v.CompletionItemKind.Class],[7,v.CompletionItemKind.Interface],[6,v.CompletionItemKind.Struct],[8,v.CompletionItemKind.Module],[9,v.CompletionItemKind.Property],[12,v.CompletionItemKind.Unit],[13,v.CompletionItemKind.Value],[14,v.CompletionItemKind.Constant],[15,v.CompletionItemKind.Enum],[16,v.CompletionItemKind.EnumMember],[17,v.CompletionItemKind.Keyword],[27,v.CompletionItemKind.Snippet],[18,v.CompletionItemKind.Text],[19,v.CompletionItemKind.Color],[20,v.CompletionItemKind.File],[21,v.CompletionItemKind.Reference],[23,v.CompletionItemKind.Folder],[10,v.CompletionItemKind.Event],[11,v.CompletionItemKind.Operator],[24,v.CompletionItemKind.TypeParameter],[25,v.CompletionItemKind.User],[26,v.CompletionItemKind.Issue]]);function ve(Ce){return H.get(Ce)??v.CompletionItemKind.Property}ue.to=ve})(Z=e.CompletionItemKind||(e.CompletionItemKind={}));var se;(function(ue){function me(ne,H){const ve=new v.CompletionItem(ne.label);return ve.insertText=ne.insertText,ve.kind=Z.to(ne.kind),ve.tags=ne.tags?.map(K.to),ve.detail=ne.detail,ve.documentation=E.isMarkdownString(ne.documentation)?y.to(ne.documentation):ne.documentation,ve.sortText=ne.sortText,ve.filterText=ne.filterText,ve.preselect=ne.preselect,ve.commitCharacters=ne.commitCharacters,t.Range.isIRange(ne.range)?ve.range=d.to(ne.range):typeof ne.range=="object"&&(ve.range={inserting:d.to(ne.range.insert),replacing:d.to(ne.range.replace)}),ve.keepWhitespace=typeof ne.insertTextRules=="undefined"?!1:Boolean(ne.insertTextRules&1),typeof ne.insertTextRules!="undefined"&&ne.insertTextRules&4?ve.insertText=new v.SnippetString(ne.insertText):(ve.insertText=ne.insertText,ve.textEdit=ve.range instanceof v.Range?new v.TextEdit(ve.range,ve.insertText):void 0),ne.additionalTextEdits&&ne.additionalTextEdits.length>0&&(ve.additionalTextEdits=ne.additionalTextEdits.map(Ce=>N.to(Ce))),ve.command=H&&ne.command?H.fromInternal(ne.command):void 0,ve}ue.to=me})(se=e.CompletionItem||(e.CompletionItem={}));var G;(function(ue){function me(H){return{label:H.label,documentation:H.documentation?y.fromStrict(H.documentation):void 0}}ue.from=me;function ne(H){return{label:H.label,documentation:E.isMarkdownString(H.documentation)?y.to(H.documentation):H.documentation}}ue.to=ne})(G=e.ParameterInformation||(e.ParameterInformation={}));var ie;(function(ue){function me(H){return{label:H.label,documentation:H.documentation?y.fromStrict(H.documentation):void 0,parameters:Array.isArray(H.parameters)?H.parameters.map(G.from):[],activeParameter:H.activeParameter}}ue.from=me;function ne(H){return{label:H.label,documentation:E.isMarkdownString(H.documentation)?y.to(H.documentation):H.documentation,parameters:Array.isArray(H.parameters)?H.parameters.map(G.to):[],activeParameter:H.activeParameter}}ue.to=ne})(ie=e.SignatureInformation||(e.SignatureInformation={}));var de;(function(ue){function me(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(ie.from):[]}}ue.from=me;function ne(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(ie.to):[]}}ue.to=ne})(de=e.SignatureHelp||(e.SignatureHelp={}));var Pe;(function(ue){function me(H){return{text:H.text,position:r.from(H.position),kind:Ne.from(H.kind??v.InlayHintKind.Other),whitespaceBefore:H.whitespaceBefore,whitespaceAfter:H.whitespaceAfter}}ue.from=me;function ne(H){const ve=new v.InlayHint(H.text,r.to(H.position),Ne.to(H.kind));return ve.whitespaceAfter=H.whitespaceAfter,ve.whitespaceBefore=H.whitespaceBefore,ve}ue.to=ne})(Pe=e.InlayHint||(e.InlayHint={}));var Ne;(function(ue){function me(H){return H}ue.from=me;function ne(H){return H}ue.to=ne})(Ne=e.InlayHintKind||(e.InlayHintKind={}));var We;(function(ue){function me(H){return{range:d.from(H.range),url:H.target,tooltip:H.tooltip}}ue.from=me;function ne(H){let ve;if(H.url)try{ve=typeof H.url=="string"?A.URI.parse(H.url,!0):A.URI.revive(H.url)}catch(Ce){}return new v.DocumentLink(d.to(H.range),ve)}ue.to=ne})(We=e.DocumentLink||(e.DocumentLink={}));var je;(function(ue){function me(H){const ve=new v.ColorPresentation(H.label);return H.textEdit&&(ve.textEdit=N.to(H.textEdit)),H.additionalTextEdits&&(ve.additionalTextEdits=H.additionalTextEdits.map(Ce=>N.to(Ce))),ve}ue.to=me;function ne(H){return{label:H.label,textEdit:H.textEdit?N.from(H.textEdit):void 0,additionalTextEdits:H.additionalTextEdits?H.additionalTextEdits.map(ve=>N.from(ve)):void 0}}ue.from=ne})(je=e.ColorPresentation||(e.ColorPresentation={}));var et;(function(ue){function me(H){return new v.Color(H[0],H[1],H[2],H[3])}ue.to=me;function ne(H){return[H.red,H.green,H.blue,H.alpha]}ue.from=ne})(et=e.Color||(e.Color={}));var ot;(function(ue){function me(H){return{range:d.from(H.range)}}ue.from=me;function ne(H){return new v.SelectionRange(d.to(H.range))}ue.to=ne})(ot=e.SelectionRange||(e.SelectionRange={}));var _e;(function(ue){function me(ne){switch(ne){case 2:return v.TextDocumentSaveReason.AfterDelay;case 1:return v.TextDocumentSaveReason.Manual;case 3:case 4:return v.TextDocumentSaveReason.FocusOut}}ue.to=me})(_e=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var nt;(function(ue){function me(H){switch(H){case v.TextEditorLineNumbersStyle.Off:return 0;case v.TextEditorLineNumbersStyle.Relative:return 2;case v.TextEditorLineNumbersStyle.On:default:return 1}}ue.from=me;function ne(H){switch(H){case 0:return v.TextEditorLineNumbersStyle.Off;case 2:return v.TextEditorLineNumbersStyle.Relative;case 1:default:return v.TextEditorLineNumbersStyle.On}}ue.to=ne})(nt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var q;(function(ue){function me(H){if(H===v.EndOfLine.CRLF)return 1;if(H===v.EndOfLine.LF)return 0}ue.from=me;function ne(H){if(H===1)return v.EndOfLine.CRLF;if(H===0)return v.EndOfLine.LF}ue.to=ne})(q=e.EndOfLine||(e.EndOfLine={}));var J;(function(ue){function me(ne){if(typeof ne=="object")return ne.viewId;switch(ne){case v.ProgressLocation.SourceControl:return 3;case v.ProgressLocation.Window:return 10;case v.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ue.from=me})(J=e.ProgressLocation||(e.ProgressLocation={}));var ge;(function(ue){function me(ne){const H={start:ne.start+1,end:ne.end+1};return ne.kind&&(H.kind=$e.from(ne.kind)),H}ue.from=me})(ge=e.FoldingRange||(e.FoldingRange={}));var $e;(function(ue){function me(ne){if(ne)switch(ne){case v.FoldingRangeKind.Comment:return _.FoldingRangeKind.Comment;case v.FoldingRangeKind.Imports:return _.FoldingRangeKind.Imports;case v.FoldingRangeKind.Region:return _.FoldingRangeKind.Region}}ue.from=me})($e=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ge;(function(ue){function me(ne){if(ne)return{pinned:typeof ne.preview=="boolean"?!ne.preview:void 0,inactive:ne.background,preserveFocus:ne.preserveFocus,selection:typeof ne.selection=="object"?d.from(ne.selection):void 0,override:typeof ne.override=="boolean"?i.EditorResolution.DISABLED:void 0}}ue.from=me})(Ge=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var rt;(function(ue){function me(H){return H instanceof v.RelativePattern||typeof H=="string"?H:ne(H)?new v.RelativePattern(H.base,H.pattern):H}ue.from=me;function ne(H){const ve=H;return ve&&typeof ve.base=="string"&&typeof ve.pattern=="string"}})(rt=e.GlobPattern||(e.GlobPattern={}));var ft;(function(ue){function me(ne){if(ne){if(Array.isArray(ne))return ne.map(me);if(typeof ne=="string")return ne;{const H=ne;return{language:H.language,scheme:H.scheme,pattern:typeof H.pattern=="undefined"?void 0:rt.from(H.pattern),exclusive:H.exclusive}}}else return}ue.from=me})(ft=e.LanguageSelector||(e.LanguageSelector={}));var ht;(function(ue){function me(H){return{start:H.start,end:H.end}}ue.from=me;function ne(H){return new v.NotebookRange(H.start,H.end)}ue.to=ne})(ht=e.NotebookRange||(e.NotebookRange={}));var Dt;(function(ue){function me(H){return{timing:typeof H.runStartTime=="number"&&typeof H.runEndTime=="number"?{startTime:H.runStartTime,endTime:H.runEndTime}:void 0,executionOrder:H.executionOrder,success:H.lastRunSuccess}}ue.to=me;function ne(H){return{lastRunSuccess:H.success,runStartTime:H.timing?.startTime,runEndTime:H.timing?.endTime,executionOrder:H.executionOrder}}ue.from=ne})(Dt=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Tt;(function(ue){function me(H){switch(H){case v.NotebookCellKind.Markup:return f.CellKind.Markup;case v.NotebookCellKind.Code:default:return f.CellKind.Code}}ue.from=me;function ne(H){switch(H){case f.CellKind.Markup:return v.NotebookCellKind.Markup;case f.CellKind.Code:default:return v.NotebookCellKind.Code}}ue.to=ne})(Tt=e.NotebookCellKind||(e.NotebookCellKind={}));var It;(function(ue){function me(H){const ve={metadata:H.metadata??Object.create(null),cells:[]};for(let Ce of H.cells)v.NotebookCellData.validate(Ce),ve.cells.push(Xe.from(Ce));return ve}ue.from=me;function ne(H){const ve=new v.NotebookData(H.cells.map(Xe.to));return(0,C.isEmptyObject)(H.metadata)||(ve.metadata=H.metadata),ve}ue.to=ne})(It=e.NotebookData||(e.NotebookData={}));var Xe;(function(ue){function me(H){return{cellKind:Tt.from(H.kind),language:H.languageId,mime:H.mime,source:H.value,metadata:H.metadata,internalMetadata:Dt.from(H.executionSummary??{}),outputs:H.outputs?H.outputs.map(Ie.from):[]}}ue.from=me;function ne(H){return new v.NotebookCellData(Tt.to(H.cellKind),H.source,H.language,H.mime,H.outputs?H.outputs.map(Ie.to):void 0,H.metadata,H.internalMetadata?Dt.to(H.internalMetadata):void 0)}ue.to=ne})(Xe=e.NotebookCellData||(e.NotebookCellData={}));var pt;(function(ue){function me(H){return{mime:H.mime,valueBytes:M.VSBuffer.wrap(H.data)}}ue.from=me;function ne(H){return new v.NotebookCellOutputItem(H.valueBytes.buffer,H.mime)}ue.to=ne})(pt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ie;(function(ue){function me(H){return{outputId:H.id,items:H.items.map(pt.from),metadata:H.metadata}}ue.from=me;function ne(H){const ve=H.items.map(pt.to);return new v.NotebookCellOutput(ve,H.outputId,H.metadata)}ue.to=ne})(Ie=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ye;(function(ue){function me(Ce){if(Ce!=null){if(Ce instanceof v.RelativePattern||typeof Ce=="string")return Ce;if(ve(Ce))return new v.RelativePattern(Ce.base,Ce.pattern);if(H(Ce))return{include:rt.from(Ce.include)||void 0,exclude:rt.from(Ce.exclude)||void 0}}}ue.from=me;function ne(Ce){return typeof Ce=="string"?Ce:ve(Ce)?{base:Ce.base,pattern:Ce.pattern}:{include:Ce.include,exclude:Ce.exclude}}ue.to=ne;function H(Ce){const Ke=Ce,xe=rt.from(Ke.include);if(!(xe&&xe instanceof v.RelativePattern||typeof xe=="string"))return!1;const lt=rt.from(Ke.exclude);return!!(lt&&lt instanceof v.RelativePattern||typeof lt=="string")}function ve(Ce){const Ke=Ce;return Ke&&typeof Ke.base=="string"&&typeof Ke.pattern=="string"}})(ye=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var De;(function(ue){function me(ne){return{backgroundColor:ne.backgroundColor,borderColor:ne.borderColor,top:ne.top?B.from(ne.top):void 0}}ue.from=me})(De=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var ee;(function(ue){function me(ne,H,ve){const Ce=typeof ne.command=="string"?{title:"",command:ne.command}:ne.command;return{alignment:ne.alignment===v.NotebookCellStatusBarAlignment.Left?1:2,command:H.toInternal(Ce,ve),text:ne.text,tooltip:ne.tooltip,accessibilityInformation:ne.accessibilityInformation,priority:ne.priority}}ue.from=me})(ee=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var oe;(function(ue){function me(ne){return{transientOutputs:ne?.transientOutputs??!1,transientCellMetadata:ne?.transientCellMetadata??{},transientDocumentMetadata:ne?.transientDocumentMetadata??{}}}ue.from=me})(oe=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var fe;(function(ue){function me(H){return{uri:H.uri,provides:H.provides}}ue.from=me;function ne(H){return new v.NotebookRendererScript(A.URI.revive(H.uri),H.provides)}ue.to=ne})(fe=e.NotebookRendererScript||(e.NotebookRendererScript={}));var he;(function(ue){function me(H){return{message:y.fromStrict(H.message)||"",type:0,expected:H.expectedOutput,actual:H.actualOutput,location:H.location?ce.from(H.location):void 0}}ue.from=me;function ne(H){const ve=new v.TestMessage(typeof H.message=="string"?H.message:y.to(H.message));return ve.actualOutput=H.actual,ve.expectedOutput=H.expected,ve.location=H.location?ce.to(H.location):void 0,ve}ue.to=ne})(he=e.TestMessage||(e.TestMessage={}));var ke;(function(ue){let me;(function(ne){ne.Delimiter="\0"})(me||(me={})),ue.namespace=(ne,H)=>ne+"\0"+H,ue.denamespace=ne=>{const H=ne.indexOf("\0");return{ctrlId:ne.slice(0,H),tagId:ne.slice(H+1)}}})(ke=e.TestTag||(e.TestTag={}));var Le;(function(ue){function me(Ce){const Ke=(0,a.getPrivateApiFor)(Ce).controllerId;return{extId:p.TestId.fromExtHostTestItem(Ce,Ke).toString(),label:Ce.label,uri:Ce.uri,tags:Ce.tags.map(xe=>ke.namespace(Ke,xe.id)),range:d.from(Ce.range)||null,description:Ce.description||null,error:Ce.error&&y.fromStrict(Ce.error)||null}}ue.from=me;function ne(Ce){return{parent:void 0,error:void 0,id:p.TestId.fromString(Ce.extId).localId,label:Ce.label,uri:A.URI.revive(Ce.uri),tags:(Ce.tags||[]).map(Ke=>{const{tagId:xe}=ke.denamespace(Ke);return new v.TestTag(xe)}),range:d.to(Ce.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Ce.description||void 0}}ue.toPlain=ne;function H(Ce){const Ke=p.TestId.fromString(Ce.extId),xe=new a.TestItemImpl(Ke.controllerId,Ke.localId,Ce.label,A.URI.revive(Ce.uri));return xe.range=d.to(Ce.range||void 0),xe.description=Ce.description||void 0,xe}function ve(Ce){let Ke;for(const xe of Ce.tests){const lt=H(xe.item);(0,a.getPrivateApiFor)(lt).parent=Ke,Ke=lt}return Ke}ue.toItemFromContext=ve})(Le=e.TestItem||(e.TestItem={})),function(ue){function me(H){return{id:H.id}}ue.from=me;function ne(H){return new v.TestTag(H.id)}ue.to=ne}(ke=e.TestTag||(e.TestTag={}));var Me;(function(ue){const me=(H,ve)=>{const Ce={...Le.toPlain(H.item),parent:void 0,taskStates:H.tasks.map(Ke=>({state:Ke.state,duration:Ke.duration,messages:Ke.messages.filter(xe=>xe.type===0).map(he.to)})),children:H.children.map(Ke=>ve.get(Ke)).filter(C.isDefined).map(Ke=>me(Ke,ve))};for(const Ke of Ce.children)Ke.parent=Ce;return Ce};function ne(H){const ve=[],Ce=new Map;for(const Ke of H.items)Ce.set(Ke.item.extId,Ke),H.request.targets.some(xe=>xe.controllerId===Ke.controllerId&&xe.testIds.includes(Ke.item.extId))&&ve.push(Ke);return{completedAt:H.completedAt,results:ve.map(Ke=>me(Ke,Ce))}}ue.to=ne})(Me=e.TestResults||(e.TestResults={}));var ze;(function(ue){function me(Ce){return{covered:Ce.covered,total:Ce.covered}}function ne(Ce){return"line"in Ce?r.from(Ce):d.from(Ce)}function H(Ce){return"branches"in Ce?{count:Ce.executionCount,location:ne(Ce.location),type:1,branches:Ce.branches.length?Ce.branches.map(Ke=>({count:Ke.executionCount,location:Ke.location&&ne(Ke.location)})):void 0}:{type:0,count:Ce.executionCount,location:ne(Ce.location)}}ue.fromDetailed=H;function ve(Ce){return{uri:Ce.uri,statement:me(Ce.statementCoverage),branch:Ce.branchCoverage&&me(Ce.branchCoverage),function:Ce.functionCoverage&&me(Ce.functionCoverage),details:Ce.detailedCoverage?.map(H)}}ue.fromFile=ve})(ze=e.TestCoverage||(e.TestCoverage={}));var it;(function(ue){function me(ne){switch(ne){case 1:return v.CodeActionTriggerKind.Invoke;case 2:return v.CodeActionTriggerKind.Automatic}}ue.to=me})(it=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Re;(function(ue){function me(H){const ve=new v.TypeHierarchyItem(W.to(H.kind),H.name,H.detail||"",A.URI.revive(H.uri),d.to(H.range),d.to(H.selectionRange));return ve._sessionId=H._sessionId,ve._itemId=H._itemId,ve}ue.to=me;function ne(H,ve,Ce){if(ve=ve??H._sessionId,Ce=Ce??H._itemId,ve===void 0||Ce===void 0)throw new Error("invalid item");return{_sessionId:ve,_itemId:Ce,kind:W.from(H.kind),name:H.name,detail:H.detail??"",uri:H.uri,range:d.from(H.range),selectionRange:d.from(H.selectionRange),tags:H.tags?.map($.from)}}ue.from=ne})(Re=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(we[174],be([0,1,2,16,7,8,235]),function(re,e,u,M,E,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class T{constructor(A,t,_,i={timeout:1500,errors:3}){this._logService=A,this._documents=t,this._mainThreadBulkEdits=_,this._thresholds=i,this._callbacks=new F.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(A){return(t,_,i)=>{const a={dispose:this._callbacks.push([t,_,A])};return Array.isArray(i)&&i.push(a),a}}async $participateInSave(A,t){const _=u.URI.revive(A);let i=!1;const m=setTimeout(()=>i=!0,this._thresholds.timeout),a=[];try{for(let f of[...this._callbacks]){if(i)break;const p=this._documents.getDocument(_),S=await this._deliverEventAsyncAndBlameBadListeners(f,{document:p,reason:P.TextDocumentSaveReason.to(t)});a.push(S)}}finally{clearTimeout(m)}return a}_deliverEventAsyncAndBlameBadListeners([A,t,_],i){const m=this._badListeners.get(A);return typeof m=="number"&&m>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(_,A,t,i).then(()=>!0,a=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${_.identifier.value}' threw ERROR`),this._logService.error(a),!(a instanceof Error)||a.message!=="concurrent_edits"){const f=this._badListeners.get(A);this._badListeners.set(A,f?f+1:1),typeof f=="number"&&f>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${_.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(A,t,_,i){const m=[],a=Date.now(),{document:f,reason:p}=i,{version:S}=f,v=Object.freeze({document:f,reason:p,waitUntil(o){if(Object.isFrozen(m))throw(0,M.illegalState)("waitUntil can not be called async");m.push(Promise.resolve(o))}});try{t.apply(_,[v])}catch(o){return Promise.reject(o)}return Object.freeze(m),new Promise((o,d)=>{const D=setTimeout(()=>d(new Error("timeout")),this._thresholds.timeout);return Promise.all(m).then(r=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' finished after ${Date.now()-a}ms`),clearTimeout(D),o(r)}).catch(r=>{clearTimeout(D),d(r)})}).then(o=>{const d={edits:[]};for(const D of o)if(Array.isArray(D)&&D.every(r=>r instanceof E.TextEdit))for(const{newText:r,newEol:w,range:s}of D)d.edits.push({_type:2,resource:f.uri,edit:{range:s&&P.Range.from(s),text:r,eol:w&&P.EndOfLine.from(w)}});if(d.edits.length!==0)return S===f.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(d):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=T}),define(we[175],be([0,1,3,28,2,8,7]),function(re,e,u,M,E,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class T{constructor(t,_,i,m,a){this._onDidCreate=new u.Emitter,this._onDidChange=new u.Emitter,this._onDidDelete=new u.Emitter,this._config=0,i&&(this._config+=1),m&&(this._config+=2),a&&(this._config+=4);const f=(0,M.parse)(_),p=t(S=>{if(!i)for(let v of S.created){const o=E.URI.revive(v);f(o.fsPath)&&this._onDidCreate.fire(o)}if(!m)for(let v of S.changed){const o=E.URI.revive(v);f(o.fsPath)&&this._onDidChange.fire(o)}if(!a)for(let v of S.deleted){const o=E.URI.revive(v);f(o.fsPath)&&this._onDidDelete.fire(o)}});this._disposable=F.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,p)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class C{constructor(t,_,i){this._logService=_,this._extHostDocumentsAndEditors=i,this._onFileSystemEvent=new u.Emitter,this._onDidRenameFile=new u.Emitter,this._onDidCreateFile=new u.Emitter,this._onDidDeleteFile=new u.Emitter,this._onWillRenameFile=new u.AsyncEmitter,this._onWillCreateFile=new u.AsyncEmitter,this._onWillDeleteFile=new u.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(t,_,i,m){return new T(this._onFileSystemEvent.event,t,_,i,m)}$onFileEvent(t){this._onFileSystemEvent.fire(t)}$onDidRunFileOperation(t,_){switch(t){case 2:this._onDidRenameFile.fire(Object.freeze({files:_.map(i=>({oldUri:E.URI.revive(i.source),newUri:E.URI.revive(i.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:_.map(i=>E.URI.revive(i.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:_.map(i=>E.URI.revive(i.target))}));break;default:}}getOnWillRenameFileEvent(t){return this._createWillExecuteEvent(t,this._onWillRenameFile)}getOnWillCreateFileEvent(t){return this._createWillExecuteEvent(t,this._onWillCreateFile)}getOnWillDeleteFileEvent(t){return this._createWillExecuteEvent(t,this._onWillDeleteFile)}_createWillExecuteEvent(t,_){return(i,m,a)=>{const f=function(S){i.call(m,S)};return f.extension=t,_.event(f,void 0,a)}}async $onWillRunFileOperation(t,_,i,m){switch(t){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:_.map(a=>({oldUri:E.URI.revive(a.source),newUri:E.URI.revive(a.target)}))},i,m);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:_.map(a=>E.URI.revive(a.target))},i,m);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:_.map(a=>E.URI.revive(a.target))},i,m)}}async _fireWillEvent(t,_,i,m){const a=new Set,f=[];if(await t.fireAsync(_,m,async(S,v)=>{const o=Date.now(),d=await Promise.resolve(S);d instanceof F.WorkspaceEdit&&(f.push(d),a.add(v.extension.displayName??v.extension.identifier.value)),Date.now()-o>i&&this._logService.warn("SLOW file-participant",v.extension.identifier)}),m.isCancellationRequested||f.length===0)return;const p={edits:[]};for(let S of f){let{edits:v}=P.WorkspaceEdit.from(S,this._extHostDocumentsAndEditors);p.edits=p.edits.concat(v)}return{edit:p,extensionNames:Array.from(a)}}}e.ExtHostFileSystemEventService=C}),define(we[176],be([0,1,11,23,2,8,7,89]),function(re,e,u,M,E,P,F,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class C{constructor(i,m,a,f){this.start=i,this.deletedCount=m,this.deletedItems=a,this.items=f}static asApiEvents(i){return i.map(m=>({start:m.start,deletedCount:m.deletedCount,deletedItems:m.deletedItems,items:m.items.map(a=>a.apiCell)}))}}class A{constructor(i,m,a){this.notebook=i,this._extHostDocument=m,this._cellData=a,this.handle=a.handle,this.uri=E.URI.revive(a.uri),this.cellKind=a.cellKind,this._outputs=a.outputs.map(P.NotebookCellOutput.to),this._internalMetadata=a.internalMetadata??{},this._metadata=Object.freeze(a.metadata??{}),this._previousResult=Object.freeze(P.NotebookCellExecutionSummary.to(a.internalMetadata??{}))}static asModelAddData(i,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:i}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const i=this,m=this._extHostDocument.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return i.notebook.getCellIndex(i)},notebook:i.notebook.apiNotebook,kind:P.NotebookCellKind.to(this._cellData.cellKind),document:m.document,get mime(){return i._mime},set mime(a){i._mime=a},get outputs(){return i._outputs.slice(0)},get metadata(){return i._metadata},get executionSummary(){return i._previousResult}})}return this._apiCell}setOutputs(i){this._outputs=i.map(P.NotebookCellOutput.to)}setOutputItems(i,m,a){const f=a.map(P.NotebookCellOutputItem.to),p=this._outputs.find(S=>S.id===i);p&&(m||(p.items.length=0),p.items.push(...f))}setMetadata(i){this._metadata=Object.freeze(i)}setInternalMetadata(i){this._internalMetadata=i,this._previousResult=Object.freeze(P.NotebookCellExecutionSummary.to(i))}setMime(i){}}e.ExtHostCell=A;class t{constructor(i,m,a,f,p,S){this._proxy=i,this._textDocumentsAndEditors=m,this._textDocuments=a,this._emitter=f,this.uri=p,this.handle=t._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=S.viewType,this._metadata=Object.freeze(S.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,S.cells]],!0),this._versionId=S.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const i=this;this._notebook={get uri(){return i.uri},get version(){return i._versionId},get notebookType(){return i._notebookType},get isDirty(){return i._isDirty},get isUntitled(){return i.uri.scheme===u.Schemas.untitled},get isClosed(){return i._disposed},get metadata(){return i._metadata},get cellCount(){return i._cells.length},cellAt(m){return m=i._validateIndex(m),i._cells[m].apiCell},getCells(m){return(m?i._getCells(m):i._cells).map(f=>f.apiCell)},save(){return i._save()}}}return this._notebook}updateBackup(i){this._backup?.delete(),this._backup=i}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(i){i.metadata&&(this._metadata=Object.freeze({...this._metadata,...i.metadata}))}acceptDirty(i){this._isDirty=i}acceptModelChanged(i,m){this._versionId=i.versionId,this._isDirty=m;for(const a of i.rawEvents)a.kind===T.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(a.changes,!1):a.kind===T.NotebookCellsChangeType.Move?this._moveCell(a.index,a.newIdx):a.kind===T.NotebookCellsChangeType.Output?this._setCellOutputs(a.index,a.outputs):a.kind===T.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(a.index,a.outputId,a.append,a.outputItems):a.kind===T.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(a.index,a.language):a.kind===T.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(a.index,a.mime):a.kind===T.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(a.index,a.metadata):a.kind===T.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(a.index,a.internalMetadata)}_validateIndex(i){return i=i|0,i<0?0:i>=this._cells.length?this._cells.length-1:i}_validateRange(i){let m=i.start|0,a=i.end|0;return m<0&&(m=0),a>this._cells.length&&(a=this._cells.length),i.with({start:m,end:a})}_getCells(i){i=this._validateRange(i);const m=[];for(let a=i.start;a<i.end;a++)m.push(this._cells[a]);return m}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(i,m){if(this._disposed)return;const a=[],f=[],p=[];i.reverse().forEach(S=>{const o=S[2].map(r=>{const w=new A(this,this._textDocumentsAndEditors,r);return m||f.push(A.asModelAddData(this.apiNotebook,r)),w}),d=new C(S[0],S[1],[],o),D=this._cells.splice(S[0],S[1],...o);for(const r of D)p.push(r.uri),d.deletedItems.push(r.apiCell);a.push(d)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:f,removedDocuments:p}),m||this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:C.asApiEvents(a)}))}_moveCell(i,m){const a=this._cells.splice(i,1);this._cells.splice(m,0,...a);const f=[new C(i,1,a.map(p=>p.apiCell),[]),new C(m,0,[],a)];this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:C.asApiEvents(f)}))}_setCellOutputs(i,m){const a=this._cells[i];a.setOutputs(m),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[a.apiCell]}))}_setCellOutputItems(i,m,a,f){const p=this._cells[i];p.setOutputItems(m,a,f),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[p.apiCell]}))}_changeCellLanguage(i,m){const a=this._cells[i];a.apiCell.document.languageId!==m&&this._textDocuments.$acceptModelModeChanged(a.uri,m)}_changeCellMime(i,m){const a=this._cells[i];a.apiCell.mime=m}_changeCellMetadata(i,m){const a=this._cells[i],f=a.apiCell.metadata;a.setMetadata(m);const p=a.apiCell.metadata;(0,M.equals)(f,p)||this._emitter.emitCellMetadataChange((0,M.deepFreeze)({document:this.apiNotebook,cell:a.apiCell}))}_changeCellInternalMetadata(i,m){const a=this._cells[i],f=a.internalMetadata;if(a.setInternalMetadata(m),f.runState!==m.runState){const p=m.runState??F.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,M.deepFreeze)({document:this.apiNotebook,cell:a.apiCell,state:p}))}}getCellFromApiCell(i){return this._cells.find(m=>m.apiCell===i)}getCellFromIndex(i){return this._cells[i]}getCell(i){return this._cells.find(m=>m.handle===i)}getCellIndex(i){return this._cells.indexOf(i)}}e.ExtHostNotebookDocument=t,t._handlePool=0}),define(we[93],be([0,1,7,8,16]),function(re,e,u,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class P{constructor(C){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=C}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(C){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:C})}replaceCellMetadata(C,A){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:C,metadata:A})}replaceCells(C,A,t){this._throwIfFinalized(),!(C===A&&t.length===0)&&this._collectedEdits.push({editType:1,index:C,count:A-C,cells:t.map(M.NotebookCellData.from)})}}class F{constructor(C,A,t,_,i,m){this.id=C,this._proxy=A,this.notebookData=t,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=i,this._visibleRanges=_,this._viewColumn=m}get apiEditor(){if(!this._editor){const C=this;this._editor={get document(){return C.notebookData.apiNotebook},get selections(){return C._selections},set selections(A){if(!Array.isArray(A)||!A.every(u.NotebookRange.isNotebookRange))throw(0,E.illegalArgument)("selections");C._selections=A,C._trySetSelections(A)},get visibleRanges(){return C._visibleRanges},revealRange(A,t){C._proxy.$tryRevealRange(C.id,M.NotebookRange.from(A),t??u.NotebookEditorRevealType.Default)},get viewColumn(){return C._viewColumn},edit(A){const t=new P(this.document.version);return A(t),C._applyEdit(t.finalize())},setDecorations(A,t){return C.setDecorations(A,t)}},F.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(C){this._visible=C}_acceptVisibleRanges(C){this._visibleRanges=C}_acceptSelections(C){this._selections=C}_trySetSelections(C){this._proxy.$trySetSelections(this.id,C.map(M.NotebookRange.from))}_acceptViewColumn(C){this._viewColumn=C}_applyEdit(C){if(C.cellEdits.length===0)return Promise.resolve(!0);const A=[];let t=-1;for(let _=0;_<C.cellEdits.length;_++){if(t<0){A.push(C.cellEdits[_]),t++;continue}const m=A[t],a=C.cellEdits[_];if(m.editType===1&&a.editType===1&&m.index===a.index){m.cells.push(...C.cellEdits[_].cells),m.count+=C.cellEdits[_].count;continue}A.push(C.cellEdits[_]),t++}return this._proxy.$tryApplyEdits(this.id,C.documentVersionId,A)}setDecorations(C,A){if(!(A.isEmpty&&!this._hasDecorationsForKey.has(C.key)))return A.isEmpty?this._hasDecorationsForKey.delete(C.key):this._hasDecorationsForKey.add(C.key),this._proxy.$trySetDecorations(this.id,M.NotebookRange.from(A),C.key)}}e.ExtHostNotebookEditor=F,F.apiEditorsToExtHost=new WeakMap}),define(we[177],be([0,1,8,147,127,21,55,16]),function(re,e,u,M,E,P,F,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(i){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=i}async withProgress(i,m,a){const f=this._handles++,{title:p,location:S,cancellable:v}=m,o={label:(0,E.localize)(0,null,i.displayName||i.name),id:i.identifier.value};return this._proxy.$startProgress(f,{location:u.ProgressLocation.from(S),title:p,source:o,cancellable:v},i).catch(T.onUnexpectedExternalError),this._withProgress(f,a,!!v)}_withProgress(i,m,a){let f;a&&(f=new P.CancellationTokenSource,this._mapHandleToCancellationSource.set(i,f));const p=v=>{this._proxy.$progressEnd(v),this._mapHandleToCancellationSource.delete(v),f&&f.dispose()};let S;try{S=m(new t(this._proxy,i),a&&f?f.token:P.CancellationToken.None)}catch(v){throw p(i),v}return S.then(v=>p(i),v=>p(i)),S}$acceptProgressCanceled(i){const m=this._mapHandleToCancellationSource.get(i);m&&(m.cancel(),this._mapHandleToCancellationSource.delete(i))}}e.ExtHostProgress=C;function A(_,i){return _.message=i.message,typeof i.increment=="number"&&(typeof _.increment=="number"?_.increment+=i.increment:_.increment=i.increment),_}class t extends M.Progress{constructor(i,m){super(a=>this.throttledReport(a));this._proxy=i,this._handle=m}throttledReport(i){this._proxy.$progressReport(this._handle,i)}}Ue([(0,F.throttle)(100,(_,i)=>A(_,i),()=>Object.create(null))],t.prototype,"throttledReport",null)}),define(we[94],be([0,1,43,16,56,8,7]),function(re,e,u,M,E,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class T{constructor(i,m,a){const f=T._Keys.nextId();i.$registerTextEditorDecorationType(m.identifier,f,P.DecorationRenderOptions.from(a)),this.value=Object.freeze({key:f,dispose(){i.$removeTextEditorDecorationType(f)}})}}e.TextEditorDecorationType=T,T._Keys=new E.IdGenerator("TextEditorDecorationType");class C{constructor(i,m){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=i,this._documentVersionId=i.version,this._undoStopBefore=m.undoStopBefore,this._undoStopAfter=m.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(i,m){this._throwIfFinalized();let a=null;if(i instanceof F.Position)a=new F.Range(i,i);else if(i instanceof F.Range)a=i;else throw new Error("Unrecognized location");this._pushEdit(a,m,!1)}insert(i,m){this._throwIfFinalized(),this._pushEdit(new F.Range(i,i),m,!0)}delete(i){this._throwIfFinalized();let m=null;if(i instanceof F.Range)m=i;else throw new Error("Unrecognized location");this._pushEdit(m,null,!0)}_pushEdit(i,m,a){const f=this._document.validateRange(i);this._collectedEdits.push({range:f,text:m,forceMoveMarkers:a})}setEndOfLine(i){if(this._throwIfFinalized(),i!==F.EndOfLine.LF&&i!==F.EndOfLine.CRLF)throw(0,M.illegalArgument)("endOfLine");this._setEndOfLine=i}}e.TextEditorEdit=C;class A{constructor(i,m,a,f){this._proxy=i,this._id=m,this._accept(a),this._logService=f;const p=this;this.value={get tabSize(){return p._tabSize},set tabSize(S){p._setTabSize(S)},get insertSpaces(){return p._insertSpaces},set insertSpaces(S){p._setInsertSpaces(S)},get cursorStyle(){return p._cursorStyle},set cursorStyle(S){p._setCursorStyle(S)},get lineNumbers(){return p._lineNumbers},set lineNumbers(S){p._setLineNumbers(S)}}}_accept(i){this._tabSize=i.tabSize,this._insertSpaces=i.insertSpaces,this._cursorStyle=i.cursorStyle,this._lineNumbers=P.TextEditorLineNumbersStyle.to(i.lineNumbers)}_validateTabSize(i){if(i==="auto")return"auto";if(typeof i=="number"){const m=Math.floor(i);return m>0?m:null}if(typeof i=="string"){const m=parseInt(i,10);return isNaN(m)?null:m>0?m:null}return null}_setTabSize(i){const m=this._validateTabSize(i);if(m!==null){if(typeof m=="number"){if(this._tabSize===m)return;this._tabSize=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:m}))}}_validateInsertSpaces(i){return i==="auto"?"auto":i==="false"?!1:Boolean(i)}_setInsertSpaces(i){const m=this._validateInsertSpaces(i);if(typeof m=="boolean"){if(this._insertSpaces===m)return;this._insertSpaces=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:m}))}_setCursorStyle(i){this._cursorStyle!==i&&(this._cursorStyle=i,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:i})))}_setLineNumbers(i){this._lineNumbers!==i&&(this._lineNumbers=i,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:P.TextEditorLineNumbersStyle.from(i)})))}assign(i){const m={};let a=!1;if(typeof i.tabSize!="undefined"){const f=this._validateTabSize(i.tabSize);f==="auto"?(a=!0,m.tabSize=f):typeof f=="number"&&this._tabSize!==f&&(this._tabSize=f,a=!0,m.tabSize=f)}if(typeof i.insertSpaces!="undefined"){const f=this._validateInsertSpaces(i.insertSpaces);f==="auto"?(a=!0,m.insertSpaces=f):this._insertSpaces!==f&&(this._insertSpaces=f,a=!0,m.insertSpaces=f)}typeof i.cursorStyle!="undefined"&&this._cursorStyle!==i.cursorStyle&&(this._cursorStyle=i.cursorStyle,a=!0,m.cursorStyle=i.cursorStyle),typeof i.lineNumbers!="undefined"&&this._lineNumbers!==i.lineNumbers&&(this._lineNumbers=i.lineNumbers,a=!0,m.lineNumbers=P.TextEditorLineNumbersStyle.from(i.lineNumbers)),a&&this._warnOnError(this._proxy.$trySetOptions(this._id,m))}_warnOnError(i){i.catch(m=>this._logService.warn(m))}}e.ExtHostTextEditorOptions=A;class t{constructor(i,m,a,f,p,S,v,o){this.id=i,this._proxy=m,this._logService=a,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=p,this._options=new A(this._proxy,this.id,S,a),this._visibleRanges=v,this._viewColumn=o;const d=this;this.value=Object.freeze({get document(){return f.getValue()},set document(D){throw(0,M.readonly)("document")},get selection(){return d._selections&&d._selections[0]},set selection(D){if(!(D instanceof F.Selection))throw(0,M.illegalArgument)("selection");d._selections=[D],d._trySetSelection()},get selections(){return d._selections},set selections(D){if(!Array.isArray(D)||D.some(r=>!(r instanceof F.Selection)))throw(0,M.illegalArgument)("selections");d._selections=D,d._trySetSelection()},get visibleRanges(){return d._visibleRanges},set visibleRanges(D){throw(0,M.readonly)("visibleRanges")},get options(){return d._options.value},set options(D){d._disposed||d._options.assign(D)},get viewColumn(){return d._viewColumn},set viewColumn(D){throw(0,M.readonly)("viewColumn")},edit(D,r={undoStopBefore:!0,undoStopAfter:!0}){if(d._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const w=new C(f.getValue(),r);return D(w),d._applyEdit(w)},insertSnippet(D,r,w={undoStopBefore:!0,undoStopAfter:!0}){if(d._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!r||Array.isArray(r)&&r.length===0)s=d._selections.map(n=>P.Range.from(n));else if(r instanceof F.Position){const{lineNumber:n,column:g}=P.Position.from(r);s=[{startLineNumber:n,startColumn:g,endLineNumber:n,endColumn:g}]}else if(r instanceof F.Range)s=[P.Range.from(r)];else{s=[];for(const n of r)if(n instanceof F.Range)s.push(P.Range.from(n));else{const{lineNumber:g,column:l}=P.Position.from(n);s.push({startLineNumber:g,startColumn:l,endLineNumber:g,endColumn:l})}}return m.$tryInsertSnippet(i,D.value,s,w)},setDecorations(D,r){const w=r.length===0;w&&!d._hasDecorationsForKey.has(D.key)||(w?d._hasDecorationsForKey.delete(D.key):d._hasDecorationsForKey.add(D.key),d._runOnProxy(()=>{if(P.isDecorationOptionsArr(r))return m.$trySetDecorations(i,D.key,P.fromRangeOrRangeWithMessage(r));{const s=new Array(4*r.length);for(let n=0,g=r.length;n<g;n++){const l=r[n];s[4*n]=l.start.line+1,s[4*n+1]=l.start.character+1,s[4*n+2]=l.end.line+1,s[4*n+3]=l.end.character+1}return m.$trySetDecorationsFast(i,D.key,s)}}))},revealRange(D,r){d._runOnProxy(()=>m.$tryRevealRange(i,P.Range.from(D),r||F.TextEditorRevealType.Default))},show(D){m.$tryShowEditor(i,P.ViewColumn.from(D))},hide(){m.$tryHideEditor(i)}})}dispose(){(0,u.ok)(!this._disposed),this._disposed=!0}_acceptOptions(i){(0,u.ok)(!this._disposed),this._options._accept(i)}_acceptVisibleRanges(i){(0,u.ok)(!this._disposed),this._visibleRanges=i}_acceptViewColumn(i){(0,u.ok)(!this._disposed),this._viewColumn=i}_acceptSelections(i){(0,u.ok)(!this._disposed),this._selections=i}async _trySetSelection(){const i=this._selections.map(P.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,i)),this.value}_applyEdit(i){const m=i.finalize();if(m.edits.length===0&&!m.setEndOfLine)return Promise.resolve(!0);const a=m.edits.map(p=>p.range);a.sort((p,S)=>p.end.line===S.end.line?p.end.character===S.end.character?p.start.line===S.start.line?p.start.character-S.start.character:p.start.line-S.start.line:p.end.character-S.end.character:p.end.line-S.end.line);for(let p=0,S=a.length-1;p<S;p++){const v=a[p].end;if(a[p+1].start.isBefore(v))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const f=m.edits.map(p=>({range:P.Range.from(p.range),text:p.text,forceMoveMarkers:p.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,m.documentVersionId,f,{setEndOfLine:typeof m.setEndOfLine=="number"?P.EndOfLine.from(m.setEndOfLine):void 0,undoStopBefore:m.undoStopBefore,undoStopAfter:m.undoStopAfter})}_runOnProxy(i){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):i().then(()=>this,m=>(m instanceof Error&&m.name==="DISPOSED"||this._logService.warn(m),null))}}e.ExtHostTextEditor=t}),define(we[178],be([0,1,130,24,2,3,6,164,13,7,10,15,8,21,161]),function(re,e,u,M,E,P,F,T,C,A,t,_,i,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function f(v,o){if((0,t.isString)(v))return{label:v};if(v&&typeof v=="object"&&typeof v.label=="string"){let d;return Array.isArray(v.highlights)&&(d=v.highlights.filter(D=>D.length===2&&typeof D[0]=="number"&&typeof D[1]=="number"),d=d.length?d:void 0),{label:v.label,highlights:d}}}class p{constructor(o,d,D){this._proxy=o,this.commands=d,this.logService=D,this.treeViews=new Map;function r(w){return w&&w.$treeViewId&&w.$treeItemHandle}d.registerArgumentProcessor({processArgument:w=>r(w)?this.convertArgument(w):Array.isArray(w)&&w.length>0?w.map(s=>r(s)?this.convertArgument(s):s):w})}registerTreeDataProvider(o,d,D){const r=this.createTreeView(o,{treeDataProvider:d},D);return{dispose:()=>r.dispose()}}createTreeView(o,d,D){if(!d||!d.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=d.dragAndDropController!==void 0,w=this._proxy.$registerTreeViewDataProvider(o,{showCollapseAll:!!d.showCollapseAll,canSelectMany:!!d.canSelectMany,canDragAndDrop:r}),s=this.createExtHostTreeView(o,d,D);return{get onDidCollapseElement(){return s.onDidCollapseElement},get onDidExpandElement(){return s.onDidExpandElement},get selection(){return s.selectedElements},get onDidChangeSelection(){return s.onDidChangeSelection},get visible(){return s.visible},get onDidChangeVisibility(){return s.onDidChangeVisibility},get message(){return s.message},set message(n){s.message=n},get title(){return s.title},set title(n){s.title=n},get description(){return s.description},set description(n){s.description=n},reveal:(n,g)=>s.reveal(n,g),dispose:async()=>{await w,this.treeViews.delete(o),s.dispose()}}}$getChildren(o,d){const D=this.treeViews.get(o);return D?D.getChildren(d):Promise.reject(new Error((0,u.localize)(0,null,o)))}async $onDrop(o,d,D){const r=this.treeViews.get(o);if(!r)return Promise.reject(new Error((0,u.localize)(1,null,o)));const w=a.TreeDataTransferConverter.toITreeDataTransfer(d);if(w.items.has(T.TREE_ITEM_DATA_TRANSFER_TYPE)){const n=JSON.parse(await w.items.get(T.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(g=>r.getExtensionElement(g)).filter(g=>!!g);n.length>0?w.items.set(T.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(n)}):w.items.delete(T.TREE_ITEM_DATA_TRANSFER_TYPE)}return r.onDrop(w,D)}async $hasResolve(o){const d=this.treeViews.get(o);if(!d)throw new Error((0,u.localize)(2,null,o));return d.hasResolve}$resolve(o,d,D){const r=this.treeViews.get(o);if(!r)throw new Error((0,u.localize)(3,null,o));return r.resolveTreeItem(d,D)}$setExpanded(o,d,D){const r=this.treeViews.get(o);if(!r)throw new Error((0,u.localize)(4,null,o));r.setExpanded(d,D)}$setSelection(o,d){const D=this.treeViews.get(o);if(!D)throw new Error((0,u.localize)(5,null,o));D.setSelection(d)}$setVisible(o,d){const D=this.treeViews.get(o);if(!D)throw new Error((0,u.localize)(6,null,o));D.setVisible(d)}createExtHostTreeView(o,d,D){const r=new S(o,d,this._proxy,this.commands.converter,this.logService,D);return this.treeViews.set(o,r),r}convertArgument(o){const d=this.treeViews.get(o.$treeViewId);return d?d.getExtensionElement(o.$treeItemHandle):null}}e.ExtHostTreeViews=p;class S extends F.Disposable{constructor(o,d,D,r,w,s){super();if(this.viewId=o,this.proxy=D,this.commands=r,this.logService=w,this.extension=s,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new P.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new P.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new P.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new P.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new P.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new m.CancellationTokenSource,s.contributes&&s.contributes.views)for(const l in s.contributes.views)for(const c of s.contributes.views[l])c.id===o&&(this._title=c.name);this.dataProvider=d.treeDataProvider,this.dndController=d.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(l=>this._onDidChangeData.fire({message:!1,element:l}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(l=>this._onDidChangeData.fire({message:!1,element:l})));let n,g;this._register(P.Event.debounce(this._onDidChangeData.event,(l,c)=>(l||(l={message:!1,elements:[]}),c.element!==!1&&(n||(n=new Promise(b=>g=b),this.refreshPromise=this.refreshPromise.then(()=>n)),Array.isArray(c.element)?l.elements.push(...c.element):l.elements.push(c.element)),c.message&&(l.message=!0),l),200,!0)(({message:l,elements:c})=>{c.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const b=g;return n=null,this.refresh(c).then(()=>b())})),l&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(o=>this.getExtensionElement(o)).filter(o=>!(0,t.isUndefinedOrNull)(o))}async getChildren(o){const d=o?this.getExtensionElement(o):void 0;if(o&&!d)return this.logService.error(`No tree item with id '${o}' found.`),Promise.resolve([]);let D=this.getChildrenNodes(o);return D||(D=await this.fetchChildrenNodes(d)),D?D.map(r=>r.item):void 0}getExtensionElement(o){return this.elements.get(o)}reveal(o,d){d=d||{select:!0,focus:!1};const D=(0,t.isUndefinedOrNull)(d.select)?!0:d.select,r=(0,t.isUndefinedOrNull)(d.focus)?!1:d.focus,w=(0,t.isUndefinedOrNull)(d.expand)?!1:d.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):o?this.refreshPromise.then(()=>this.resolveUnknownParentChain(o)).then(s=>this.resolveTreeNode(o,s[s.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:s.map(g=>g.item)},{select:D,focus:r,expand:w})),s=>this.logService.error(s)):this.proxy.$reveal(this.viewId,void 0,{select:D,focus:r,expand:w})}get message(){return this._message}set message(o){this._message=o,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(o){this._title=o,this.proxy.$setTitle(this.viewId,o,this._description)}get description(){return this._description}set description(o){this._description=o,this.proxy.$setTitle(this.viewId,this._title,o)}setExpanded(o,d){const D=this.getExtensionElement(o);D&&(d?this._onDidExpandElement.fire(Object.freeze({element:D})):this._onDidCollapseElement.fire(Object.freeze({element:D})))}setSelection(o){(0,_.equals)(this._selectedHandles,o)||(this._selectedHandles=o,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(o){o!==this._visible&&(this._visible=o,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(o,d){const D=this.getExtensionElement(d);if(!!D)return(0,C.asPromise)(()=>this.dndController?.onDrop(o,D))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(o,d){if(!this.dataProvider.resolveTreeItem)return;const D=this.elements.get(o);if(D){const r=this.nodes.get(D);if(r){const w=await this.dataProvider.resolveTreeItem(r.extensionItem,D,d)??r.extensionItem;return r.item.tooltip=this.getTooltip(w.tooltip),r.item.command=this.getCommand(r.disposableStore,w.command),r.item}}}resolveUnknownParentChain(o){return this.resolveParent(o).then(d=>d?this.resolveUnknownParentChain(d).then(D=>this.resolveTreeNode(d,D[D.length-1]).then(r=>(D.push(r),D))):Promise.resolve([]))}resolveParent(o){const d=this.nodes.get(o);return d?Promise.resolve(d.parent?this.elements.get(d.parent.item.handle):void 0):(0,C.asPromise)(()=>this.dataProvider.getParent(o))}resolveTreeNode(o,d){const D=this.nodes.get(o);return D?Promise.resolve(D):(0,C.asPromise)(()=>this.dataProvider.getTreeItem(o)).then(r=>this.createHandle(o,r,d,!0)).then(r=>this.getChildren(d?d.item.handle:void 0).then(()=>{const w=this.getExtensionElement(r);if(w){const s=this.nodes.get(w);if(s)return Promise.resolve(s)}throw new Error(`Cannot resolve tree item for element ${r}`)}))}getChildrenNodes(o){if(o){let d;if(typeof o=="string"){const D=this.getExtensionElement(o);d=D?this.nodes.get(D):void 0}else d=o;return d&&d.children||void 0}return this.roots}async fetchChildrenNodes(o){this.clearChildren(o);const d=new m.CancellationTokenSource(this._refreshCancellationSource.token);try{const D=o?this.nodes.get(o):void 0,r=await this.dataProvider.getChildren(o);if(d.token.isCancellationRequested)return;const w=await Promise.all((0,_.coalesce)(r||[]).map(async s=>{const n=await this.dataProvider.getTreeItem(s);return n&&!d.token.isCancellationRequested?this.createAndRegisterTreeNode(s,n,D):null}));return d.token.isCancellationRequested?void 0:(0,_.coalesce)(w)}finally{d.dispose()}}refresh(o){if(o.some(D=>!D))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new m.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const D=this.getHandlesToRefresh(o);if(D.length)return this.refreshHandles(D)}return Promise.resolve(void 0)}getHandlesToRefresh(o){const d=new Set,D=o.map(w=>this.nodes.get(w));for(const w of D)if(w&&!d.has(w.item.handle)){let s=w;for(;s&&s.parent&&D.findIndex(n=>s&&s.parent&&n&&n.item.handle===s.parent.item.handle)===-1;){const n=this.elements.get(s.parent.item.handle);s=n?this.nodes.get(n):void 0}s&&!s.parent&&d.add(w.item.handle)}const r=[];return d.forEach(w=>{const s=this.elements.get(w);if(s){const n=this.nodes.get(s);n&&(!n.parent||!d.has(n.parent.item.handle))&&r.push(w)}}),r}refreshHandles(o){const d={};return Promise.all(o.map(D=>this.refreshNode(D).then(r=>{r&&(d[D]=r.item)}))).then(()=>Object.keys(d).length?this.proxy.$refresh(this.viewId,d):void 0)}refreshNode(o){const d=this.getExtensionElement(o);if(d){const D=this.nodes.get(d);if(D)return this.clearChildren(d),(0,C.asPromise)(()=>this.dataProvider.getTreeItem(d)).then(r=>{if(r){const w=this.createTreeNode(d,r,D.parent);return this.updateNodeCache(d,w,D,D.parent),D.dispose(),w}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(o,d,D){const r=this.createTreeNode(o,d,D);if(d.id&&this.elements.has(r.item.handle))throw new Error((0,u.localize)(7,null,d.id));return this.addNodeToCache(o,r),this.addNodeToParentCache(r,D),r}getTooltip(o){return A.MarkdownString.isMarkdownString(o)?i.MarkdownString.from(o):o}getCommand(o,d){return d?this.commands.toInternal(d,o):void 0}createTreeNode(o,d,D){const r=new F.DisposableStore,w=this.createHandle(o,d,D),s=this.getLightIconPath(d);return{item:{handle:w,parentHandle:D?D.item.handle:void 0,label:f(d.label,this.extension),description:d.description,resourceUri:d.resourceUri,tooltip:this.getTooltip(d.tooltip),command:this.getCommand(r,d.command),contextValue:d.contextValue,icon:s,iconDark:this.getDarkIconPath(d)||s,themeIcon:this.getThemeIcon(d),collapsibleState:(0,t.isUndefinedOrNull)(d.collapsibleState)?A.TreeItemCollapsibleState.None:d.collapsibleState,accessibilityInformation:d.accessibilityInformation},extensionItem:d,parent:D,children:void 0,disposableStore:r,dispose(){r.dispose()}}}getThemeIcon(o){return o.iconPath instanceof A.ThemeIcon?o.iconPath:void 0}createHandle(o,{id:d,label:D,resourceUri:r},w,s){if(d)return`${S.ID_HANDLE_PREFIX}/${d}`;const n=f(D,this.extension),g=w?w.item.handle:S.LABEL_HANDLE_PREFIX;let l=n?n.label:r?(0,M.basename)(r):"";l=l.indexOf("/")!==-1?l.replace("/","//"):l;const c=this.nodes.has(o)?this.nodes.get(o).item.handle:void 0,b=this.getChildrenNodes(w)||[];let h,y=0;do{if(h=`${g}/${y}:${l}`,s||!this.elements.has(h)||c===h)break;y++}while(y<=b.length);return h}getLightIconPath(o){if(o.iconPath&&!(o.iconPath instanceof A.ThemeIcon))return typeof o.iconPath=="string"||E.URI.isUri(o.iconPath)?this.getIconPath(o.iconPath):this.getIconPath(o.iconPath.light)}getDarkIconPath(o){if(o.iconPath&&!(o.iconPath instanceof A.ThemeIcon)&&o.iconPath.dark)return this.getIconPath(o.iconPath.dark)}getIconPath(o){return E.URI.isUri(o)?o:E.URI.file(o)}addNodeToCache(o,d){this.elements.set(d.item.handle,o),this.nodes.set(o,d)}updateNodeCache(o,d,D,r){this.elements.delete(d.item.handle),this.nodes.delete(o),d.item.handle!==D.item.handle&&this.elements.delete(D.item.handle),this.addNodeToCache(o,d);const w=this.getChildrenNodes(r)||[],s=w.filter(n=>n.item.handle===D.item.handle)[0];s&&w.splice(w.indexOf(s),1,d)}addNodeToParentCache(o,d){d?(d.children||(d.children=[]),d.children.push(o)):(this.roots||(this.roots=[]),this.roots.push(o))}clearChildren(o){if(o){const d=this.nodes.get(o);if(d){if(d.children)for(const D of d.children){const r=this.elements.get(D.item.handle);r&&this.clear(r)}d.children=void 0}}else this.clearAll()}clear(o){const d=this.nodes.get(o);if(d){if(d.children)for(const D of d.children){const r=this.elements.get(D.item.handle);r&&this.clear(r)}this.nodes.delete(o),this.elements.delete(d.item.handle),d.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(o=>o.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}S.LABEL_HANDLE_PREFIX="0",S.ID_HANDLE_PREFIX="1"}),define(we[179],be([0,1,13,3,6,10,50,8,90,69]),function(re,e,u,M,E,P,F,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class t extends E.Disposable{constructor(i){super();this.controllerId=i,this.debounceSendDiff=this._register(new u.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new M.Emitter),this.root=new F.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(i){this._resolveHandler=i;for(const m of this.tree.values())this.updateExpandability(m)}collectDiff(){const i=this.diff;return this.diff=[],i}pushDiff(i){const m=this.diff[this.diff.length-1];if(m&&i[0]===1){if(m[0]===1&&m[1].extId===i[1].extId){(0,C.applyTestItemUpdate)(m[1],i[1]);return}if(m[0]===0&&m[1].item.extId===i[1].extId){(0,C.applyTestItemUpdate)(m[1],i[1]);return}}this.diff.push(i),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(i,m){const a=this.tree.get(i);if(!!a){if((a.expandLevels===void 0||m>a.expandLevels)&&(a.expandLevels=m),a.expand===1){const f=this.resolveChildren(a);return f.isOpen()?this.expandChildren(a,m-1):f.wait().then(()=>this.expandChildren(a,m-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.expandChildren(a,m-1)):this.expandChildren(a,m-1)}}dispose(){for(const i of this.tree.values())(0,F.getPrivateApiFor)(i.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(i,m){switch(m.op){case 2:this.pushDiff([4,i.fullId.toString()]);break;case 1:this.removeItem(A.TestId.joinToString(i.fullId,m.id));break;case 0:this.upsertItem(m.item,i);break;case 4:for(const v of m.ops)this.onTestItemEvent(i,v);break;case 3:const{key:a,value:f,previous:p}=m,S=i.fullId.toString();switch(a){case"canResolveChildren":this.updateExpandability(i);break;case"tags":this.diffTagRefs(f,p,S);break;case"range":this.pushDiff([1,{extId:S,item:{range:T.Range.from(f)}}]);break;case"error":this.pushDiff([1,{extId:S,item:{error:T.MarkdownString.fromStrict(f)||null}}]);break;default:this.pushDiff([1,{extId:S,item:{[a]:f??null}}]);break}break;default:(0,P.assertNever)(m)}}upsertItem(i,m){if(!(i instanceof F.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${i.id} did not`);const a=A.TestId.fromExtHostTestItem(i,this.root.id,m?.actual),f=(0,F.getPrivateApiFor)(i);f.parent&&f.parent!==m?.actual&&f.parent.children.delete(i.id);let p=this.tree.get(a.toString());if(!p){p={fullId:a,actual:i,parent:m?a.parentId:null,expandLevels:m?.expandLevels?m.expandLevels-1:void 0,expand:0},i.tags.forEach(this.incrementTagRefs,this),this.tree.set(p.fullId.toString(),p),this.setItemParent(i,m),this.pushDiff([0,{parent:p.parent&&p.parent.toString(),controllerId:this.controllerId,expand:p.expand,item:T.TestItem.from(i)}]),this.connectItemAndChildren(i,p,m);return}if(p.actual===i){this.connectItem(i,p,m);return}const S=p.actual.children,v=p.actual,o=(0,F.diffTestItems)(v,i);(0,F.getPrivateApiFor)(v).listener=void 0,p.actual=i,p.expand=0;for(const[d,D]of o)this.onTestItemEvent(p,{op:3,key:d,value:D,previous:v[d]});this.connectItemAndChildren(i,p,m);for(const d of S)i.children.get(d.id)||this.removeItem(A.TestId.joinToString(a,d.id))}diffTagRefs(i,m,a){const f=new Set(m.map(p=>p.id));for(const p of i)f.delete(p.id)||this.incrementTagRefs(p);this.pushDiff([1,{extId:a,item:{tags:i.map(p=>T.TestTag.namespace(this.controllerId,p.id))}}]),f.forEach(this.decrementTagRefs,this)}incrementTagRefs(i){const m=this.tags.get(i.id);m?m.refCount++:(this.tags.set(i.id,{refCount:1}),this.pushDiff([5,{id:T.TestTag.namespace(this.controllerId,i.id),ctrlLabel:this.root.label}]))}decrementTagRefs(i){const m=this.tags.get(i);m&&!--m.refCount&&(this.tags.delete(i),this.pushDiff([6,T.TestTag.namespace(this.controllerId,i)]))}setItemParent(i,m){(0,F.getPrivateApiFor)(i).parent=m&&m.actual!==this.root?m.actual:void 0}connectItem(i,m,a){this.setItemParent(i,a);const f=(0,F.getPrivateApiFor)(i);f.parent=a?.actual,f.listener=p=>this.onTestItemEvent(m,p),this.updateExpandability(m)}connectItemAndChildren(i,m,a){this.connectItem(i,m,a);for(const f of i.children)this.upsertItem(f,m)}updateExpandability(i){let m;this._resolveHandler?i.resolveBarrier?m=i.resolveBarrier.isOpen()?3:2:m=i.actual.canResolveChildren?1:0:m=0,m!==i.expand&&(i.expand=m,this.pushDiff([1,{extId:i.fullId.toString(),expand:m}]),m===1&&i.expandLevels!==void 0&&this.resolveChildren(i))}expandChildren(i,m){if(m<0)return;const a=[];for(const f of i.actual.children){const p=this.expand(A.TestId.joinToString(i.fullId,f.id),m);(0,u.isThenable)(p)&&a.push(p)}if(a.length)return Promise.all(a).then(()=>{})}resolveChildren(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this._resolveHandler){const p=new u.Barrier;return p.open(),p}i.expand=2,this.pushExpandStateUpdate(i);const m=i.resolveBarrier=new u.Barrier,a=p=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),i.actual!==this.root&&(i.actual.error=p.stack||p.message||String(p))};let f;try{f=this._resolveHandler(i.actual===this.root?void 0:i.actual)}catch(p){a(p)}return(0,u.isThenable)(f)?f.catch(a).then(()=>{m.open(),this.updateExpandability(i)}):(m.open(),this.updateExpandability(i)),i.resolveBarrier}pushExpandStateUpdate(i){this.pushDiff([1,{extId:i.fullId.toString(),expand:i.expand}])}removeItem(i){const m=this.tree.get(i);if(!m)throw new Error("attempting to remove non-existent child");this.pushDiff([2,i]);const a=[m];for(;a.length;){const f=a.pop();if(!!f){(0,F.getPrivateApiFor)(f.actual).listener=void 0;for(const p of f.actual.tags)this.decrementTagRefs(p.id);this.tree.delete(f.fullId.toString());for(const p of f.actual.children)a.push(this.tree.get(A.TestId.joinToString(f.fullId,p.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.diffOpEmitter.fire(i)}}e.SingleUseTestCollection=t}),define(we[180],be([0,1,4,143]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,u.refineServiceDecorator)(M.IEnvironmentService)}),define(we[181],be([0,1,26,3,17]),function(re,e,u,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class P{constructor(t){this.removedDueToLooping=t}}e.DeltaExtensionsResult=P;class F{constructor(t){this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=t,this._initialize()}_initialize(){this._extensionDescriptions.sort(C),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const t of this._extensionDescriptions){if(this._extensionsMap.has(u.ExtensionIdentifier.toKey(t.identifier))){console.error("Extension `"+t.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(u.ExtensionIdentifier.toKey(t.identifier),t),this._extensionsArr.push(t),Array.isArray(t.activationEvents))for(let _ of t.activationEvents)_==="onUri"&&(_=`onUri:${u.ExtensionIdentifier.toKey(t.identifier)}`),this._activationMap.has(_)||this._activationMap.set(_,[]),this._activationMap.get(_).push(t)}}keepOnly(t){const _=new Set;t.forEach(i=>_.add(u.ExtensionIdentifier.toKey(i))),this._extensionDescriptions=this._extensionDescriptions.filter(i=>_.has(u.ExtensionIdentifier.toKey(i.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(t,_){t.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(t));const i=F._findLoopingExtensions(this._extensionDescriptions);if(_=_.concat(i.map(m=>m.identifier)),_.length>0){const m=new Set;_.forEach(a=>m.add(u.ExtensionIdentifier.toKey(a))),this._extensionDescriptions=this._extensionDescriptions.filter(a=>!m.has(u.ExtensionIdentifier.toKey(a.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new P(i)}static _findLoopingExtensions(t){const _=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(p){this._nodesSet.has(p)||(this._nodesSet.add(p),this._nodesArr.push(p))}addArc(p,S){this.addNode(p),this.addNode(S),this._arcs.has(p)?this._arcs.get(p).push(S):this._arcs.set(p,[S])}getArcs(p){return this._arcs.has(p)?this._arcs.get(p):[]}hasOnlyGoodArcs(p,S){const v=_.getArcs(p);for(let o=0;o<v.length;o++)if(!S.has(v[o]))return!1;return!0}getNodes(){return this._nodesArr}};let i=new Map;for(let p of t){const S=u.ExtensionIdentifier.toKey(p.identifier);if(i.set(S,p),p.extensionDependencies)for(let v of p.extensionDependencies){const o=u.ExtensionIdentifier.toKey(v);_.addArc(S,o)}}let m=new Set;_.getNodes().filter(p=>_.getArcs(p).length===0).forEach(p=>m.add(p));let a=_.getNodes().filter(p=>!m.has(p)),f;do{f=!1;for(let p=0;p<a.length;p++){const S=a[p];_.hasOnlyGoodArcs(S,m)&&(a.splice(p,1),p--,m.add(S),f=!0)}}while(f);return a.map(p=>i.get(p))}containsActivationEvent(t){return this._activationMap.has(t)}containsExtension(t){return this._extensionsMap.has(u.ExtensionIdentifier.toKey(t))}getExtensionDescriptionsForActivationEvent(t){const _=this._activationMap.get(t);return _?_.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(t){const _=this._extensionsMap.get(u.ExtensionIdentifier.toKey(t));return _||void 0}}e.ExtensionDescriptionRegistry=F;var T;(function(A){A[A.Builtin=0]="Builtin",A[A.User=1]="User",A[A.Dev=2]="Dev"})(T||(T={}));function C(A,t){const _=A.isBuiltin?0:A.isUnderDevelopment?2:1,i=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(_!==i)return _-i;const m=E.posix.basename(A.extensionLocation.path),a=E.posix.basename(t.extensionLocation.path);return m<a?-1:m>a?1:0}}),define(we[182],be([0,1,22]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var M;(function(T){T[T.VersionMismatch=55]="VersionMismatch",T[T.UnexpectedError=81]="UnexpectedError"})(M=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var E;(function(T){T[T.Initialized=0]="Initialized",T[T.Ready=1]="Ready",T[T.Terminate=2]="Terminate"})(E=e.MessageType||(e.MessageType={}));function P(T){const C=u.VSBuffer.alloc(1);switch(T){case 0:C.writeUInt8(1,0);break;case 1:C.writeUInt8(2,0);break;case 2:C.writeUInt8(3,0);break}return C}e.createMessageOfType=P;function F(T,C){if(T.byteLength!==1)return!1;switch(T.readUInt8(0)){case 1:return C===0;case 2:return C===1;case 3:return C===2;default:return!1}}e.isMessageOfType=F}),define(we[30],be([0,1,3,2,4,26,149]),function(re,e,u,M,E,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new P.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,E.createDecorator)("extensionService");var T;(function(d){d[d.None=0]="None",d[d.LocalProcess=1]="LocalProcess",d[d.LocalWebWorker=2]="LocalWebWorker",d[d.Remote=3]="Remote"})(T=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function C(d){switch(d){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=C;class A{constructor(D){this.dependency=D}}e.MissingExtensionDependency=A;var t;(function(d){d[d.LocalProcess=0]="LocalProcess",d[d.LocalWebWorker=1]="LocalWebWorker",d[d.Remote=2]="Remote"})(t=e.ExtensionHostKind||(e.ExtensionHostKind={}));function _(d){switch(d){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=_;class i{constructor(D,r,w,s){this.codeLoadingTime=D,this.activateCallTime=r,this.activateResolvedTime=w,this.activationReason=s}}e.ActivationTimes=i;class m{constructor(D,r){this.description=D,this.value=r}}e.ExtensionPointContribution=m,e.ExtensionHostLogFileName="exthost";var a;(function(d){d[d.Normal=0]="Normal",d[d.Immediate=1]="Immediate"})(a=e.ActivationKind||(e.ActivationKind={}));function f(d){d.enableProposedApi||p(d)}e.checkProposedApiEnabled=f;function p(d){throw new Error(`[${d.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${d.identifier.value}`)}e.throwProposedApiError=p;function S(d){return{type:d.isBuiltin?0:1,isBuiltin:d.isBuiltin||d.isUserBuiltin,identifier:{id:(0,F.getGalleryExtensionId)(d.publisher,d.name),uuid:d.uuid},manifest:d,location:d.extensionLocation}}e.toExtension=S;function v(d,D){return{identifier:new P.ExtensionIdentifier(d.identifier.id),isBuiltin:d.type===0,isUserBuiltin:d.type===1&&d.isBuiltin,isUnderDevelopment:!!D,extensionLocation:d.location,...d.manifest,uuid:d.identifier.uuid}}e.toExtensionDescription=v;class o{constructor(){this.onDidRegisterExtensions=u.Event.None,this.onDidChangeExtensionsStatus=u.Event.None,this.onDidChangeExtensions=u.Event.None,this.onWillActivateByEvent=u.Event.None,this.onDidChangeResponsiveChange=u.Event.None}activateByEvent(D){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(D){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(D){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(D){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(D,r){return Promise.resolve()}_onWillActivateExtension(D){}_onDidActivateExtension(D,r,w,s,n){}_onDidActivateExtensionError(D,r){}_onExtensionRuntimeError(D,r){}_onExtensionHostExit(D){}}e.NullExtensionService=o}),define(we[183],be([0,1,26,30,12]),function(re,e,u,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const P=Promise.resolve(void 0);class F{constructor(a,f,p,S){this.startup=a,this.codeLoadingTime=f,this.activateCallTime=p,this.activateResolvedTime=S}}e.ExtensionActivationTimes=F,F.NONE=new F(!1,-1,-1,-1);class T{constructor(a){this._startup=a,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(a,f){return a===-1||f===-1?-1:f-a}build(){return new F(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=T;class C{constructor(a,f,p,S,v,o){this.activationFailed=a,this.activationFailedError=f,this.activationTimes=p,this.module=S,this.exports=v,this.subscriptions=o}}e.ActivatedExtension=C;class A extends C{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=A;class t extends C{constructor(){super(!1,null,F.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=t;class _ extends C{constructor(a){super(!0,a,F.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=_;let i=class{constructor(a,f,p,S,v){this._logService=v,this._registry=a,this._resolvedExtensionsSet=new Set,f.forEach(o=>this._resolvedExtensionsSet.add(u.ExtensionIdentifier.toKey(o))),this._hostExtensionsMap=new Map,p.forEach(o=>this._hostExtensionsMap.set(u.ExtensionIdentifier.toKey(o),o)),this._host=S,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(a){const f=u.ExtensionIdentifier.toKey(a);return this._activatedExtensions.has(f)}getActivatedExtension(a){const f=u.ExtensionIdentifier.toKey(a),p=this._activatedExtensions.get(f);if(!p)throw new Error("Extension `"+a.value+"` is not known or not activated");return p}activateByEvent(a,f){if(this._alreadyActivatedEvents[a])return P;const p=this._registry.getExtensionDescriptionsForActivationEvent(a);return this._activateExtensions(p.map(S=>({id:S.identifier,reason:{startup:f,extensionId:S.identifier,activationEvent:a}}))).then(()=>{this._alreadyActivatedEvents[a]=!0})}activateById(a,f){const p=this._registry.getExtensionDescription(a);if(!p)throw new Error("Extension `"+a+"` is not known");return this._activateExtensions([{id:p.identifier,reason:f}])}_handleActivateRequest(a,f,p){if(this._hostExtensionsMap.has(u.ExtensionIdentifier.toKey(a.id))){f[u.ExtensionIdentifier.toKey(a.id)]=a;return}const S=this._registry.getExtensionDescription(a.id);if(!S){const d=new Error(`Cannot activate unknown extension '${a.id.value}'`);this._host.onExtensionActivationError(a.id,d,new M.MissingExtensionDependency(a.id.value)),this._activatedExtensions.set(u.ExtensionIdentifier.toKey(a.id),new _(d));return}const v=typeof S.extensionDependencies=="undefined"?[]:S.extensionDependencies;let o=!0;for(let d=0,D=v.length;d<D;d++){const r=v[d];if(this._resolvedExtensionsSet.has(u.ExtensionIdentifier.toKey(r)))continue;const w=this._activatedExtensions.get(u.ExtensionIdentifier.toKey(r));if(w&&!w.activationFailed)continue;if(w&&w.activationFailed){const l=S.displayName||S.identifier.value,c=this._registry.getExtensionDescription(r),b=c&&c.displayName||r,h=new Error(`Cannot activate the '${l}' extension because its dependency '${b}' failed to activate`);h.detail=w.activationFailedError,this._host.onExtensionActivationError(S.identifier,h,null),this._activatedExtensions.set(u.ExtensionIdentifier.toKey(S.identifier),new _(h));return}if(this._hostExtensionsMap.has(u.ExtensionIdentifier.toKey(r))){o=!1,f[u.ExtensionIdentifier.toKey(r)]={id:this._hostExtensionsMap.get(u.ExtensionIdentifier.toKey(r)),reason:a.reason};continue}const s=this._registry.getExtensionDescription(r);if(s){if(!s.main&&!s.browser)continue;o=!1,f[u.ExtensionIdentifier.toKey(r)]={id:s.identifier,reason:a.reason};continue}const n=S.displayName||S.identifier.value,g=new Error(`Cannot activate the '${n}' extension because it depends on unknown extension '${r}'`);this._host.onExtensionActivationError(S.identifier,g,new M.MissingExtensionDependency(r)),this._activatedExtensions.set(u.ExtensionIdentifier.toKey(S.identifier),new _(g));return}o?f[u.ExtensionIdentifier.toKey(S.identifier)]=a:p.push(a)}_activateExtensions(a){if(a.length===0||(a=a.filter(v=>!this._activatedExtensions.has(u.ExtensionIdentifier.toKey(v.id))),a.length===0))return Promise.resolve(void 0);const f=Object.create(null),p=[];for(let v=0,o=a.length;v<o;v++)this._handleActivateRequest(a[v],f,p);for(let v=0,o=p.length;v<o;v++){const d=u.ExtensionIdentifier.toKey(p[v].id);f[d]&&delete f[d]}const S=Object.keys(f).map(v=>f[v]);return p.length===0?Promise.all(S.map(v=>this._activateExtension(v.id,v.reason))).then(v=>{}):this._activateExtensions(S).then(v=>this._activateExtensions(p))}_activateExtension(a,f){const p=u.ExtensionIdentifier.toKey(a);if(this._activatedExtensions.has(p))return Promise.resolve(void 0);const S=this._activatingExtensions.get(p);if(S)return S;const v=this._host.actualActivateExtension(a,f).then(void 0,o=>{const d=new Error;return o&&o.name&&(d.name=o.name),o&&o.message?d.message=`Activating extension '${a.value}' failed: ${o.message}.`:d.message=`Activating extension '${a.value}' failed: ${o}.`,o&&o.stack&&(d.stack=o.stack),this._host.onExtensionActivationError(a,d,null),this._logService.error(`Activating extension ${a.value} failed due to an error:`),this._logService.error(o),new _(o)}).then(o=>{this._activatedExtensions.set(p,o),this._activatingExtensions.delete(p)});return this._activatingExtensions.set(p,v),v}};i=Ue([Be(4,E.ILogService)],i),e.ExtensionsActivator=i}),define(we[184],be([0,1,16]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class M{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((P,F)=>{this._actualOk=P,this._actualErr=F,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(P){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=P,this._actual&&this._actualOk(P))}resolveErr(P){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=P,this._actual?this._actualErr(P):(0,u.onUnexpectedError)(P))}then(P,F){return this._ensureActual().then(P,F)}catch(P){return this._ensureActual().then(void 0,P)}finally(P){return this._ensureActual().finally(P)}}e.LazyPromise=M}),define(we[39],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class u{constructor(A,t){this._proxyIdentifierBrand=void 0,this.isMain=A,this.sid=t,this.nid=++u.count}}e.ProxyIdentifier=u,u.count=0;const M=[];function E(C){const A=new u(!0,C);return M[A.nid]=A,A}e.createMainContextProxyIdentifier=E;function P(C){const A=new u(!1,C);return M[A.nid]=A,A}e.createExtHostContextProxyIdentifier=P;function F(C){return M[C].sid}e.getStringIdentifierForProxy=F;class T{constructor(A){this.value=A}}e.SerializableObjectWithBuffers=T}),define(we[5],be([0,1,57,2,39]),function(re,e,u,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var P;(function(o){o[o.Desktop=1]="Desktop",o[o.Web=2]="Web"})(P=e.UIKind||(e.UIKind={}));var F;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(F=e.TextEditorRevealType||(e.TextEditorRevealType={}));var T;(function(o){o[o.Editable=0]="Editable",o[o.SupportsHotExit=1]="SupportsHotExit"})(T=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var C;(function(o){o[o.Int8Array=1]="Int8Array",o[o.Uint8Array=2]="Uint8Array",o[o.Uint8ClampedArray=3]="Uint8ClampedArray",o[o.Int16Array=4]="Int16Array",o[o.Uint16Array=5]="Uint16Array",o[o.Int32Array=6]="Int32Array",o[o.Uint32Array=7]="Uint32Array",o[o.Float32Array=8]="Float32Array",o[o.Float64Array=9]="Float64Array",o[o.BigInt64Array=10]="BigInt64Array",o[o.BigUint64Array=11]="BigUint64Array"})(C=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var A;(function(o){o[o.Text=1]="Text",o[o.Error=2]="Error",o[o.Rich=3]="Rich"})(A=e.CellOutputKind||(e.CellOutputKind={}));var t;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(t=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var _;(function(o){o[o.None=0]="None",o[o.Process=1]="Process",o[o.Output=2]="Output"})(_=e.CandidatePortSource||(e.CandidatePortSource={}));var i;(function(o){o.name="$ident";function d(r,w){return Object.defineProperty(r,o.name,{value:w,enumerable:!0}),r}o.mixin=d;function D(r){return r[o.name]}o.of=D})(i=e.ObjectIdentifier||(e.ObjectIdentifier={}));class m{static mixin(d){return d._id=m._n++,d}}e.IdObject=m,m._n=0;var a;(function(o){o.label="a",o.kind="b",o.detail="c",o.documentation="d",o.sortText="e",o.filterText="f",o.preselect="g",o.insertText="h",o.insertTextRules="i",o.range="j",o.commitCharacters="k",o.additionalTextEdits="l",o.command="m",o.kindModifier="n"})(a=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var f;(function(o){o.defaultRanges="a",o.completions="b",o.isIncomplete="c",o.duration="d"})(f=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var p;(function(o){o[o.File=1]="File",o[o.Text=2]="Text",o[o.Cell=3]="Cell"})(p=e.WorkspaceEditType||(e.WorkspaceEditType={}));function S(o){if(o&&o.edits)for(const d of o.edits)typeof d.resource=="object"?d.resource=M.URI.revive(d.resource):(d.newUri=M.URI.revive(d.newUri),d.oldUri=M.URI.revive(d.oldUri)),d.metadata&&d.metadata.iconPath&&(d.metadata=(0,u.revive)(d.metadata));return o}e.reviveWorkspaceEditDto=S;var v;(function(o){o[o.Workspace=0]="Workspace",o[o.TextDocument=1]="TextDocument"})(v=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,E.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,E.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,E.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,E.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,E.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,E.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,E.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,E.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,E.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,E.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,E.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,E.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,E.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,E.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,E.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,E.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,E.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,E.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,E.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,E.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,E.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,E.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,E.createMainContextProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,E.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,E.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,E.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,E.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,E.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,E.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,E.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,E.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,E.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,E.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,E.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,E.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,E.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,E.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,E.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,E.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,E.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,E.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,E.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,E.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,E.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,E.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,E.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,E.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,E.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,E.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,E.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,E.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,E.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,E.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,E.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,E.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,E.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,E.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,E.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,E.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,E.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,E.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,E.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,E.createExtHostContextProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,E.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,E.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,E.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,E.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,E.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,E.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,E.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,E.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,E.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,E.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,E.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,E.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,E.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,E.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,E.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,E.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,E.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,E.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,E.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,E.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,E.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,E.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(we[70],be([0,1,5,3,4]),function(re,e,u,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class P{constructor(T){this._onDidChangePassword=new M.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=T.getProxy(u.MainContext.MainThreadSecretState)}async $onDidChangePassword(T){this._onDidChangePassword.fire(T)}get(T,C){return this._proxy.$getPassword(T,C)}store(T,C,A){return this._proxy.$setPassword(T,C,A)}delete(T,C){return this._proxy.$deletePassword(T,C)}}e.ExtHostSecretState=P,e.IExtHostSecretState=(0,E.createDecorator)("IExtHostSecretState")}),define(we[71],be([0,1,4,12,5,14]),function(re,e,u,M,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,u.createDecorator)("IExtHostApiDeprecationService");let F=class{constructor(C,A){this._extHostLogService=A,this._reportedUsages=new Set,this._telemetryShape=C.getProxy(E.MainContext.MainThreadTelemetry)}report(C,A,t){const _=this.getUsageKey(C,A);this._reportedUsages.has(_)||(this._reportedUsages.add(_),A.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${C}' is deprecated. ${t}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:A.identifier.value,apiId:C}))}getUsageKey(C,A){return`${C}-${A.identifier.value}`}};F=Ue([Be(0,P.IExtHostRpcService),Be(1,M.ILogService)],F),e.ExtHostApiDeprecationService=F,e.NullApiDeprecationService=Object.freeze(new class{report(T,C,A){}})}),define(we[185],be([0,1,3,5,7,26]),function(re,e,u,M,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class F{constructor(C){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new u.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=C.getProxy(M.MainContext.MainThreadAuthentication)}$setProviders(C){return this._providers=C,Promise.resolve()}async getSession(C,A,t,_={}){const i=P.ExtensionIdentifier.toKey(C.identifier),m=this._inFlightRequests.get(i)||[],a=[...t].sort().join(" ");let f=m.find(p=>p.scopes===a);if(f)return f.result;{const p=this._getSession(C,i,A,t,_);f={scopes:a,result:p},m.push(f),this._inFlightRequests.set(i,m);try{await p}finally{const S=m.findIndex(v=>v.scopes===a);S>-1&&(m.splice(S),this._inFlightRequests.set(i,m))}return p}}async _getSession(C,A,t,_,i={}){await this._proxy.$ensureProvider(t);const m=C.displayName||C.name;return this._proxy.$getSession(t,_,A,m,i)}async removeSession(C,A){const t=this._authenticationProviders.get(C);return t?t.provider.removeSession(A):this._proxy.$removeSession(C,A)}registerAuthenticationProvider(C,A,t,_){if(this._authenticationProviders.get(C))throw new Error(`An authentication provider with id '${C}' is already registered.`);this._authenticationProviders.set(C,{label:A,provider:t,options:_??{supportsMultipleAccounts:!1}}),this._providers.find(m=>m.id===C)||this._providers.push({id:C,label:A});const i=t.onDidChangeSessions(m=>{this._proxy.$sendDidChangeSessions(C,{added:m.added??[],changed:m.changed??[],removed:m.removed??[]})});return this._proxy.$registerAuthenticationProvider(C,A,_?.supportsMultipleAccounts??!1),new E.Disposable(()=>{i.dispose(),this._authenticationProviders.delete(C);const m=this._providers.findIndex(a=>a.id===C);m>-1&&this._providers.splice(m),this._proxy.$unregisterAuthenticationProvider(C)})}$createSession(C,A){const t=this._authenticationProviders.get(C);if(t)return Promise.resolve(t.provider.createSession(A));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$removeSession(C,A){const t=this._authenticationProviders.get(C);if(t)return Promise.resolve(t.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$getSessions(C,A){const t=this._authenticationProviders.get(C);if(t)return Promise.resolve(t.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$onDidChangeAuthenticationSessions(C,A){return this._onDidChangeSessions.fire({provider:{id:C,label:A}}),Promise.resolve()}}e.ExtHostAuthentication=F}),define(we[186],be([0,1,5,14,8]),function(re,e,u,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let P=class{constructor(T,C){this._extHostDocumentsAndEditors=C,this._proxy=T.getProxy(u.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(T){const C=E.WorkspaceEdit.from(T,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(C)}};P=Ue([Be(0,M.IExtHostRpcService)],P),e.ExtHostBulkEdits=P}),define(we[187],be([0,1,5]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class M{constructor(P){const F=P.getProxy(u.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return F.$readText()},writeText(T){return F.$writeText(T)}})}}e.ExtHostClipboard=M}),define(we[40],be([0,1,10,7,8,23,5,15,12,57,45,111,2,6,4,14,50,22,39,46]),function(re,e,u,M,E,P,F,T,C,A,t,_,i,m,a,f,p,S,v,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let d=class{constructor(g,l){this._commands=new Map,this._apiCommands=new Map,this._proxy=g.getProxy(F.MainContext.MainThreadCommands),this._logService=l,this.converter=new D(this,c=>{const b=this._apiCommands.get(c);return b?.result===w.Void?b:void 0},l),this._argumentProcessors=[{processArgument(c){return(0,A.revive)(c)}},{processArgument(c){return(0,P.cloneAndChange)(c,function(b){if(t.Range.isIRange(b))return E.Range.to(b);if(_.Position.isIPosition(b))return E.Position.to(b);if(t.Range.isIRange(b.range)&&i.URI.isUri(b.uri))return E.location.to(b);if(b instanceof S.VSBuffer)return b.buffer.buffer;if(!Array.isArray(b))return b})}}]}registerArgumentProcessor(g){this._argumentProcessors.push(g)}registerApiCommand(g){const l=this.registerCommand(!1,g.id,async(...c)=>{const b=g.args.map((y,R)=>{if(!y.validate(c[R]))throw new Error(`Invalid argument '${y.name}' when running '${g.id}', received: ${c[R]}`);return y.convert(c[R])}),h=await this.executeCommand(g.internalId,...b);return g.result.convert(h,c,this.converter)},void 0,{description:g.description,args:g.args,returns:g.result.description});return this._apiCommands.set(g.id,g),new M.Disposable(()=>{l.dispose(),this._apiCommands.delete(g.id)})}registerCommand(g,l,c,b,h,y){if(this._logService.trace("ExtHostCommands#registerCommand",l),!l.trim().length)throw new Error("invalid id");if(this._commands.has(l))throw new Error(`command '${l}' already exists`);return this._commands.set(l,{callback:c,thisArg:b,description:h,extension:y}),g&&this._proxy.$registerCommand(l),new M.Disposable(()=>{this._commands.delete(l)&&g&&this._proxy.$unregisterCommand(l)})}executeCommand(g,...l){return this._logService.trace("ExtHostCommands#executeCommand",g),this._doExecuteCommand(g,l,!0)}async _doExecuteCommand(g,l,c){if(this._commands.has(g))return this._executeContributedCommand(g,l,!1);{let b=!1;const h=(0,P.cloneAndChange)(l,function(y){if(y instanceof M.Position)return E.Position.from(y);if(y instanceof M.Range)return E.Range.from(y);if(y instanceof M.Location)return E.location.from(y);if(M.NotebookRange.isNotebookRange(y))return E.NotebookRange.from(y);if(y instanceof ArrayBuffer)return b=!0,S.VSBuffer.wrap(new Uint8Array(y));if(y instanceof Uint8Array)return b=!0,S.VSBuffer.wrap(y);if(!Array.isArray(y))return y});try{const y=await this._proxy.$executeCommand(g,b?new v.SerializableObjectWithBuffers(h):h,c);return(0,A.revive)(y)}catch(y){if(y instanceof Error&&y.message==="$executeCommand:retry")return this._doExecuteCommand(g,l,!1);throw y}}}async _executeContributedCommand(g,l,c){const b=this._commands.get(g);if(!b)throw new Error("Unknown command");let{callback:h,thisArg:y,description:R}=b;if(R)for(let I=0;I<R.args.length;I++)try{(0,u.validateConstraint)(l[I],R.args[I].constraint)}catch(B){throw new Error(`Running the contributed command: '${g}' failed. Illegal argument '${R.args[I].name}' - ${R.args[I].description}`)}try{return await h.apply(y,l)}catch(I){if(g===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...l);B&&(g=B.command)}throw this._logService.error(I,g,b.extension?.identifier),c?new class extends Error{constructor(){super((0,o.toErrorMessage)(I));this.id=g,this.source=b.extension?.displayName??b.extension?.name}}:I}}$executeContributedCommand(g,...l){return this._logService.trace("ExtHostCommands#$executeContributedCommand",g),this._commands.has(g)?(l=l.map(c=>this._argumentProcessors.reduce((b,h)=>h.processArgument(b),c)),this._executeContributedCommand(g,l,!0)):Promise.reject(new Error(`Contributed command '${g}' does not exist.`))}getCommands(g=!1){return this._logService.trace("ExtHostCommands#getCommands",g),this._proxy.$getCommands().then(l=>(g&&(l=l.filter(c=>c[0]!=="_")),l))}$getContributedCommandHandlerDescriptions(){const g=Object.create(null);for(let[l,c]of this._commands){let{description:b}=c;b&&(g[l]=b)}return Promise.resolve(g)}};d=Ue([Be(0,f.IExtHostRpcService),Be(1,C.ILogService)],d),e.ExtHostCommands=d,e.IExtHostCommands=(0,a.createDecorator)("IExtHostCommands");class D{constructor(g,l,c){this._commands=g,this._lookupApiCommand=l,this._logService=c,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(g,l){if(!g)return;const c={$ident:void 0,id:g.command,title:g.title,tooltip:g.tooltip};if(!g.command)return c;const b=this._lookupApiCommand(g.command);if(b)c.id=b.internalId,c.arguments=b.args.map((h,y)=>h.convert(g.arguments&&g.arguments[y]));else if((0,T.isNonEmptyArray)(g.arguments)){const h=++this._cachIdPool;this._cache.set(h,g),l.add((0,m.toDisposable)(()=>{this._cache.delete(h),this._logService.trace("CommandsConverter#DISPOSE",h)})),c.$ident=h,c.id=this.delegatingCommandId,c.arguments=[h],this._logService.trace("CommandsConverter#CREATE",g.command,h)}return c}fromInternal(g){const l=F.ObjectIdentifier.of(g);return typeof l=="number"?this._cache.get(l):{command:g.id,title:g.title,arguments:g.arguments}}getActualCommand(...g){return this._cache.get(g[0])}_executeConvertedCommand(...g){const l=this.getActualCommand(...g);return this._logService.trace("CommandsConverter#EXECUTE",g[0],l?l.command:"MISSING"),l?this._commands.executeCommand(l.command,...l.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=D;class r{constructor(g,l,c,b){this.name=g,this.description=l,this.validate=c,this.convert=b}optional(){return new r(this.name,`(optional) ${this.description}`,g=>g==null||this.validate(g),g=>g===void 0?void 0:g===null?null:this.convert(g))}with(g,l){return new r(g??this.name,l??this.description,this.validate,this.convert)}}e.ApiCommandArgument=r,r.Uri=new r("uri","Uri of a text document",n=>i.URI.isUri(n),n=>n),r.Position=new r("position","A position in a text document",n=>M.Position.isPosition(n),E.Position.from),r.Range=new r("range","A range in a text document",n=>M.Range.isRange(n),E.Range.from),r.Selection=new r("selection","A selection in a text document",n=>M.Selection.isSelection(n),E.Selection.from),r.Number=new r("number","",n=>typeof n=="number",n=>n),r.String=new r("string","",n=>typeof n=="string",n=>n),r.CallHierarchyItem=new r("item","A call hierarchy item",n=>n instanceof M.CallHierarchyItem,E.CallHierarchyItem.from),r.TypeHierarchyItem=new r("item","A type hierarchy item",n=>n instanceof M.TypeHierarchyItem,E.TypeHierarchyItem.from),r.TestItem=new r("testItem","A VS Code TestItem",n=>n instanceof p.TestItemImpl,E.TestItem.from);class w{constructor(g,l){this.description=g,this.convert=l}}e.ApiCommandResult=w,w.Void=new w("no result",n=>n);class s{constructor(g,l,c,b,h){this.id=g,this.internalId=l,this.description=c,this.args=b,this.result=h}}e.ApiCommand=s}),define(we[188],be([0,1,8,7,61,40,15,81]),function(re,e,u,M,E,P,F,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const C=[new P.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",t(u.DocumentHighlight.to))),new P.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[P.ApiCommandArgument.Uri],new P.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(i,m)=>{if((0,F.isFalsyOrEmpty)(i))return;class a extends M.SymbolInformation{static to(p){const S=new a(p.name,u.SymbolKind.to(p.kind),p.containerName||"",new M.Location(m[0],u.Range.to(p.range)));return S.detail=p.detail,S.range=S.location.range,S.selectionRange=u.Range.to(p.selectionRange),S.children=p.children?p.children.map(a.to):[],S}}return i.map(a.to)})),new P.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[P.ApiCommandArgument.Uri,new P.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new P.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(u.TextEdit.to))),new P.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Range,new P.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new P.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(u.TextEdit.to))),new P.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position,new P.ApiCommandArgument("ch","Trigger character",i=>typeof i=="string",i=>i),new P.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new P.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(u.TextEdit.to))),new P.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new P.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new P.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new P.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new P.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of Location-instances.",t(u.location.to))),new P.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of Hover-instances.",t(u.Hover.to))),new P.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[P.ApiCommandArgument.Uri,new P.ApiCommandArgument("position","A position in a text document",i=>Array.isArray(i)&&i.every(m=>M.Position.isPosition(m)),i=>i.map(u.Position.from))],new P.ApiCommandResult("A promise that resolves to an array of ranges.",i=>i.map(m=>{let a;for(const f of m.reverse())a=new M.SelectionRange(u.Range.to(f),a);return a}))),new P.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[P.ApiCommandArgument.String.with("query","Search string")],new P.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",i=>{const m=[];if(Array.isArray(i))for(let a of i)m.push(...a[1].map(u.WorkspaceSymbol.to));return m})),new P.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A CallHierarchyItem or undefined",i=>i.map(u.CallHierarchyItem.to))),new P.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[P.ApiCommandArgument.CallHierarchyItem],new P.ApiCommandResult("A CallHierarchyItem or undefined",i=>i.map(u.CallHierarchyIncomingCall.to))),new P.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[P.ApiCommandArgument.CallHierarchyItem],new P.ApiCommandResult("A CallHierarchyItem or undefined",i=>i.map(u.CallHierarchyOutgoingCall.to))),new P.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to a range and placeholder text.",i=>{if(!!i)return{range:u.Range.to(i.range),placeholder:i.text}})),new P.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position,P.ApiCommandArgument.String.with("newName","The new symbol name")],new P.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",i=>{if(!!i){if(i.rejectReason)throw new Error(i.rejectReason);return u.WorkspaceEdit.to(i)}})),new P.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new P.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",i=>i.map(u.DocumentLink.to))),new P.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[P.ApiCommandArgument.Uri],new P.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",i=>{if(!!i)return new M.SemanticTokensLegend(i.tokenTypes,i.tokenModifiers)})),new P.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[P.ApiCommandArgument.Uri],new P.ApiCommandResult("A promise that resolves to SemanticTokens.",i=>{if(!i)return;const m=(0,T.decodeSemanticTokensDto)(i);if(m.type==="full")return new M.SemanticTokens(m.data,void 0)})),new P.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Range.optional()],new P.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",i=>{if(!!i)return new M.SemanticTokensLegend(i.tokenTypes,i.tokenModifiers)})),new P.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Range],new P.ApiCommandResult("A promise that resolves to SemanticTokens.",i=>{if(!i)return;const m=(0,T.decodeSemanticTokensDto)(i);if(m.type==="full")return new M.SemanticTokens(m.data,void 0)})),new P.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position,P.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),P.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new P.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(i,m,a)=>{if(!i)return new M.CompletionList([]);const f=i.suggestions.map(p=>u.CompletionItem.to(p,a));return new M.CompletionList(f,i.incomplete)})),new P.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position,P.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new P.ApiCommandResult("A promise that resolves to SignatureHelp.",i=>{if(i)return u.SignatureHelp.to(i)})),new P.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new P.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(i,m,a)=>t(f=>new M.CodeLens(u.Range.to(f.range),f.command&&a.fromInternal(f.command)))(i))),new P.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[P.ApiCommandArgument.Uri,new P.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",i=>M.Range.isRange(i),i=>M.Selection.isSelection(i)?u.Selection.from(i):u.Range.from(i)),P.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),P.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new P.ApiCommandResult("A promise that resolves to an array of Command-instances.",(i,m,a)=>t(f=>{if(f._isSynthetic){if(!f.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(f.command)}else{const p=new M.CodeAction(f.title,f.kind?new M.CodeActionKind(f.kind):void 0);return f.edit&&(p.edit=u.WorkspaceEdit.to(f.edit)),f.command&&(p.command=a.fromInternal(f.command)),p.isPreferred=f.isPreferred,p}})(i))),new P.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[P.ApiCommandArgument.Uri],new P.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",i=>i?i.map(m=>new M.ColorInformation(u.Range.to(m.range),u.Color.to(m.color))):[])),new P.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new P.ApiCommandArgument("color","The color to show and insert",i=>i instanceof M.Color,u.Color.from),new P.ApiCommandArgument("context","Context object with uri and range",i=>!0,i=>({uri:i.uri,range:u.Range.from(i.range)}))],new P.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",i=>i?i.map(u.ColorPresentation.to):[])),new P.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Range],new P.ApiCommandResult("A promise that resolves to an array of Inlay objects",i=>i.map(u.InlayHint.to))),new P.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new P.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",t(i=>({viewType:i.viewType,displayName:i.displayName,options:{transientOutputs:i.options.transientOutputs,transientCellMetadata:i.options.transientCellMetadata,transientDocumentMetadata:i.options.transientDocumentMetadata},filenamePattern:i.filenamePattern.map(m=>u.NotebookExclusiveDocumentPattern.to(m))})))),new P.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Range],new P.ApiCommandResult("A promise that resolves to an array of InlineValue objects",i=>i.map(u.InlineValue.to))),new P.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[P.ApiCommandArgument.Uri,new P.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="number"||typeof i=="object",i=>i&&(typeof i=="number"?[i,void 0]:[u.ViewColumn.from(i.viewColumn),u.TextEditorOpenOptions.from(i)])).optional(),P.ApiCommandArgument.String.with("label","").optional()],P.ApiCommandResult.Void),new P.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[P.ApiCommandArgument.Uri.with("resource","Resource to open"),P.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new P.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="number"||typeof i=="object",i=>i&&(typeof i=="number"?[i,void 0]:[u.ViewColumn.from(i.viewColumn),u.TextEditorOpenOptions.from(i)])).optional()],P.ApiCommandResult.Void),new P.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[P.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),P.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),P.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new P.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="object",i=>i&&[u.ViewColumn.from(i.viewColumn),u.TextEditorOpenOptions.from(i)]).optional()],P.ApiCommandResult.Void),new P.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A TypeHierarchyItem or undefined",i=>i.map(u.TypeHierarchyItem.to))),new P.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[P.ApiCommandArgument.TypeHierarchyItem],new P.ApiCommandResult("A TypeHierarchyItem or undefined",i=>i.map(u.TypeHierarchyItem.to))),new P.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[P.ApiCommandArgument.TypeHierarchyItem],new P.ApiCommandResult("A TypeHierarchyItem or undefined",i=>i.map(u.TypeHierarchyItem.to))),new P.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[P.ApiCommandArgument.TestItem],P.ApiCommandResult.Void)];class A{static register(m){C.forEach(m.registerApiCommand,m)}}e.ExtHostApiCommands=A;function t(i){return m=>{if(Array.isArray(m))return m.map(i)}}function _(i){if(!Array.isArray(i))return;const m=[];for(const a of i)E.isLocationLink(a)?m.push(u.DefinitionLink.to(a)):m.push(u.location.to(a));return m}}),define(we[189],be([0,1,13,55,3,6,2,61,26,8,7,5]),function(re,e,u,M,E,P,F,T,C,A,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function i(m,a,f){const p=m.getProxy(_.MainContext.MainThreadComments);class S{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,a.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const g=this._commentControllers.get(n.handle);return g||n}else if(n&&n.$mid===7){const g=this._commentControllers.get(n.commentControlHandle);if(!g)return n;const l=g.getCommentThread(n.commentThreadHandle);return l||n}else if(n&&n.$mid===8){const g=this._commentControllers.get(n.thread.commentControlHandle);if(!g)return n;const l=g.getCommentThread(n.thread.commentThreadHandle);return l?{thread:l,text:n.text}:n}else if(n&&n.$mid===9){const g=this._commentControllers.get(n.thread.commentControlHandle);if(!g)return n;const l=g.getCommentThread(n.thread.commentThreadHandle);if(!l)return n;let c=n.commentUniqueId,b=l.getCommentByUniqueId(c);return b||n}else if(n&&n.$mid===10){const g=this._commentControllers.get(n.thread.commentControlHandle);if(!g)return n;const l=g.getCommentThread(n.thread.commentThreadHandle);if(!l)return n;let c=n.text,b=n.commentUniqueId,h=l.getCommentByUniqueId(b);return h?(h.body=c,h):n}return n}})}createCommentController(n,g,l){const c=S.handlePool++,b=new o(n,c,g,l);this._commentControllers.set(b.handle,b);const h=this._commentControllersByExtension.get(C.ExtensionIdentifier.toKey(n.identifier))||[];return h.push(b),this._commentControllersByExtension.set(C.ExtensionIdentifier.toKey(n.identifier),h),b.value}$createCommentThreadTemplate(n,g,l){const c=this._commentControllers.get(n);!c||c.$createCommentThreadTemplate(g,l)}async $updateCommentThreadTemplate(n,g,l){const c=this._commentControllers.get(n);!c||c.$updateCommentThreadTemplate(g,l)}$deleteCommentThread(n,g){const l=this._commentControllers.get(n);l&&l.$deleteCommentThread(g)}$provideCommentingRanges(n,g,l){const c=this._commentControllers.get(n);if(!c||!c.commentingRangeProvider)return Promise.resolve(void 0);const b=f.getDocument(F.URI.revive(g));return(0,u.asPromise)(()=>c.commentingRangeProvider.provideCommentingRanges(b,l)).then(h=>h?h.map(y=>A.Range.from(y)):void 0)}$toggleReaction(n,g,l,c,b){const h=this._commentControllers.get(n);return!h||!h.reactionHandler?Promise.resolve(void 0):(0,u.asPromise)(()=>{const y=h.getCommentThread(g);if(y){const R=y.getCommentByUniqueId(c.uniqueIdInThread);if(h!==void 0&&R&&h.reactionHandler)return h.reactionHandler(R,r(b))}return Promise.resolve(void 0)})}dispose(){}}S.handlePool=0;class v{constructor(n,g,l,c,b,h,y){this._commentControllerHandle=g,this._id=l,this._uri=c,this._range=b,this._comments=h,this.handle=v._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new E.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputDisposables.value=new P.DisposableStore,this._id===void 0&&(this._id=`${n}.${this.handle}`),p.$createCommentThread(g,this.handle,this._id,this._uri,A.Range.from(this._range),y),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=h,this._localDisposables.push({dispose:()=>{p.$deleteCommentThread(g,this.handle)}});const R=this;this.value={get uri(){return R.uri},get range(){return R.range},set range(I){R.range=I},get comments(){return R.comments},set comments(I){R.comments=I},get collapsibleState(){return R.collapsibleState},set collapsibleState(I){R.collapsibleState=I},get canReply(){return R.canReply},set canReply(I){R.canReply=I},get contextValue(){return R.contextValue},set contextValue(I){R.contextValue=I},get label(){return R.label},set label(I){R.label=I},dispose:()=>{R.dispose()}}}set threadId(n){this._id=n}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(n){n.isEqual(this._range)||(this._range=n,this.modifications.range=n,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(n){this._canReply!==n&&(this._canReply=n,this.modifications.canReply=n,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(n){this._label=n,this.modifications.label=n,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(n){this._contextValue=n,this.modifications.contextValue=n,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(n){this._comments=n,this.modifications.comments=n,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(n){this._collapseState=n,this.modifications.collapsibleState=n,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new P.DisposableStore);const n=l=>Object.prototype.hasOwnProperty.call(this.modifications,l),g={};n("range")&&(g.range=A.Range.from(this._range)),n("label")&&(g.label=this.label),n("contextValue")&&(g.contextValue=this.contextValue??null),n("comments")&&(g.comments=this._comments.map(l=>d(this,l,this._commentsMap))),n("collapsibleState")&&(g.collapseState=w(this._collapseState)),n("canReply")&&(g.canReply=this.canReply),this.modifications={},p.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,g)}getCommentByUniqueId(n){for(let g of this._commentsMap){let l=g[0],c=g[1];if(n===c)return l}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(n=>n.dispose())}}v._handlePool=0,Ue([(0,M.debounce)(100)],v.prototype,"eventuallyUpdateCommentThread",null);class o{constructor(n,g,l,c){this._extension=n,this._handle=g,this._id=l,this._label=c,this._threads=new Map,p.$registerCommentController(this.handle,l,c);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(h){b.options=h},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(h){b.commentingRangeProvider=h},get reactionHandler(){return b.reactionHandler},set reactionHandler(h){b.reactionHandler=h},createCommentThread(h,y,R){return b.createCommentThread(h,y,R).value},dispose:()=>{b.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{p.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(n){this._commentingRangeProvider=n,p.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(n){this._reactionHandler=n,p.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!n})}get options(){return this._options}set options(n){this._options=n,p.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(n,g,l,c){if(typeof n=="string"){const b=new v(this.id,this.handle,n,g,l,c,this._extension.identifier);return this._threads.set(b.handle,b),b}else{const b=new v(this.id,this.handle,void 0,n,g,l,this._extension.identifier);return this._threads.set(b.handle,b),b}}$createCommentThreadTemplate(n,g){const l=new v(this.id,this.handle,void 0,F.URI.revive(n),A.Range.to(g),[],this._extension.identifier);return l.collapsibleState=T.CommentThreadCollapsibleState.Expanded,this._threads.set(l.handle,l),l}$updateCommentThreadTemplate(n,g){let l=this._threads.get(n);l&&(l.range=A.Range.to(g))}$deleteCommentThread(n){let g=this._threads.get(n);g&&g.dispose(),this._threads.delete(n)}getCommentThread(n){return this._threads.get(n)}dispose(){this._threads.forEach(n=>{n.dispose()}),this._localDisposables.forEach(n=>n.dispose())}}function d(s,n,g){let l=g.get(n);l||(l=++s.commentHandle,g.set(n,l));const c=n.author&&n.author.iconPath?n.author.iconPath.toString():void 0;return{mode:n.mode,contextValue:n.contextValue,uniqueIdInThread:l,body:A.MarkdownString.from(n.body),userName:n.author.name,userIconPath:c,label:n.label,commentReactions:n.reactions?n.reactions.map(b=>D(b)):void 0}}function D(s){return{label:s.label,iconPath:s.iconPath?A.pathOrURIToURI(s.iconPath):void 0,count:s.count,hasReacted:s.authorHasReacted}}function r(s){return{label:s.label||"",count:s.count||0,iconPath:s.iconPath?F.URI.revive(s.iconPath):"",authorHasReacted:s.hasReacted||!1}}function w(s){if(s!==void 0)switch(s){case t.CommentThreadCollapsibleState.Expanded:return T.CommentThreadCollapsibleState.Expanded;case t.CommentThreadCollapsibleState.Collapsed:return T.CommentThreadCollapsibleState.Collapsed}return T.CommentThreadCollapsibleState.Collapsed}return new S}e.createExtHostComments=i}),define(we[95],be([0,1,2,5,7,4,14,12,15,9,17]),function(re,e,u,M,E,P,F,T,C,A,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let _=class wi{constructor(m,a){this._logService=a,this._provider=new Map,this._proxy=m.getProxy(M.MainContext.MainThreadDecorations)}registerFileDecorationProvider(m,a){const f=wi._handlePool++;this._provider.set(f,{provider:m,extensionId:a}),this._proxy.$registerDecorationProvider(f,a.value);const p=m.onDidChangeFileDecorations&&m.onDidChangeFileDecorations(S=>{if(!S){this._proxy.$onDidChange(f,null);return}let v=(0,C.asArray)(S);if(v.length<=wi._maxEventSize){this._proxy.$onDidChange(f,v);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",a.value,v.length);const o=v.map(r=>({uri:r,rank:(0,A.count)(r.path,"/")})),d=(0,C.groupBy)(o,(r,w)=>r.rank-w.rank||(0,A.compare)(r.uri.path,w.uri.path));let D=[];e:for(let r of d){let w;for(let s of r){let n=(0,t.dirname)(s.uri.path);if(w!==n&&(w=n,D.push(s.uri)>=wi._maxEventSize))break e}}this._proxy.$onDidChange(f,D)});return new E.Disposable(()=>{p?.dispose(),this._proxy.$unregisterDecorationProvider(f),this._provider.delete(f)})}async $provideDecorations(m,a,f){if(!this._provider.has(m))return Object.create(null);const p=Object.create(null),{provider:S,extensionId:v}=this._provider.get(m);return await Promise.all(a.map(async o=>{try{const{uri:d,id:D}=o,r=await Promise.resolve(S.provideFileDecoration(u.URI.revive(d),f));if(!r)return;try{E.FileDecoration.validate(r),p[D]=[r.propagate,r.tooltip,r.badge,r.color]}catch(w){this._logService.warn(`INVALID decoration from extension '${v.value}': ${w}`)}}catch(d){this._logService.error(d)}})),p}};_._handlePool=0,_._maxEventSize=250,_=Ue([Be(0,F.IExtHostRpcService),Be(1,T.ILogService)],_),e.ExtHostDecorations=_,e.IExtHostDecorations=(0,P.createDecorator)("IExtHostDecorations")});var Ze=this&&this.__classPrivateFieldSet||function(re,e,u,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,u):E?E.value=u:e.set(re,u),u},Te=this&&this.__classPrivateFieldGet||function(re,e,u,M){if(u==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?M:u==="a"?M.call(re):M?M.value:e.get(re)};define(we[190],be([0,1,125,83,2,5,7,8,3,12,20,31]),function(re,e,u,M,E,P,F,T,C,A,t,_){"use strict";var i,m,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class f{constructor(v,o,d,D,r,w){this._name=v,this._owner=o,this._maxDiagnosticsPerFile=d,i.set(this,void 0),m.set(this,void 0),a.set(this,void 0),this._isDisposed=!1,Ze(this,a,new t.ResourceMap(s=>D.getComparisonKey(s)),"f"),Ze(this,i,r,"f"),Ze(this,m,w,"f")}dispose(){this._isDisposed||(Te(this,m,"f").fire([...Te(this,a,"f").keys()]),Te(this,i,"f")&&Te(this,i,"f").$clear(this._owner),Te(this,a,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(v,o){if(!v){this.clear();return}this._checkDisposed();let d=[];if(E.URI.isUri(v)){if(!o){this.delete(v);return}Te(this,a,"f").set(v,o.slice()),d=[v]}else if(Array.isArray(v)){d=[];let r;v=[...v].sort(f._compareIndexedTuplesByUri);for(const w of v){const[s,n]=w;if((!r||s.toString()!==r.toString())&&(r&&Te(this,a,"f").get(r).length===0&&Te(this,a,"f").delete(r),r=s,d.push(s),Te(this,a,"f").set(s,[])),n){const g=Te(this,a,"f").get(s);g&&g.push(...n)}else{const g=Te(this,a,"f").get(s);g&&(g.length=0)}}}if(Te(this,m,"f").fire(d),!Te(this,i,"f"))return;const D=[];for(let r of d){let w=[];const s=Te(this,a,"f").get(r);if(s)if(s.length>this._maxDiagnosticsPerFile){w=[];const n=[F.DiagnosticSeverity.Error,F.DiagnosticSeverity.Warning,F.DiagnosticSeverity.Information,F.DiagnosticSeverity.Hint];e:for(let g=0;g<4;g++)for(let l of s)if(l.severity===n[g]&&w.push(T.Diagnostic.from(l))===this._maxDiagnosticsPerFile)break e;w.push({severity:M.MarkerSeverity.Info,message:(0,u.localize)(0,null,s.length-this._maxDiagnosticsPerFile),startLineNumber:w[w.length-1].startLineNumber,startColumn:w[w.length-1].startColumn,endLineNumber:w[w.length-1].endLineNumber,endColumn:w[w.length-1].endColumn})}else w=s.map(n=>T.Diagnostic.from(n));D.push([r,w])}Te(this,i,"f").$changeMany(this._owner,D)}delete(v){this._checkDisposed(),Te(this,m,"f").fire([v]),Te(this,a,"f").delete(v),Te(this,i,"f")&&Te(this,i,"f").$changeMany(this._owner,[[v,void 0]])}clear(){this._checkDisposed(),Te(this,m,"f").fire([...Te(this,a,"f").keys()]),Te(this,a,"f").clear(),Te(this,i,"f")&&Te(this,i,"f").$clear(this._owner)}forEach(v,o){this._checkDisposed();for(let d of Te(this,a,"f").keys())v.apply(o,[d,this.get(d),this])}get(v){this._checkDisposed();const o=Te(this,a,"f").get(v);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(v){return this._checkDisposed(),Array.isArray(Te(this,a,"f").get(v))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(v,o){return v[0].toString()<o[0].toString()?-1:v[0].toString()>o[0].toString()?1:0}}e.DiagnosticCollection=f,i=new WeakMap,m=new WeakMap,a=new WeakMap;let p=class ti{constructor(v,o,d){this._logService=o,this._fileSystemInfoService=d,this._collections=new Map,this._onDidChangeDiagnostics=new C.DebounceEmitter({merge:D=>D.flat(),delay:50}),this.onDidChangeDiagnostics=C.Event.map(this._onDidChangeDiagnostics.event,ti._mapper),this._proxy=v.getProxy(P.MainContext.MainThreadDiagnostics)}static _mapper(v){const o=new t.ResourceMap;for(const d of v)o.set(d,d);return{uris:Object.freeze(Array.from(o.values()))}}createDiagnosticCollection(v,o){const{_collections:d,_proxy:D,_onDidChangeDiagnostics:r,_logService:w,_fileSystemInfoService:s}=this,n=new class{$changeMany(c,b){D.$changeMany(c,b),w.trace("[DiagnosticCollection] change many (extension, owner, uris)",v.value,c,b.length===0?"CLEARING":b)}$clear(c){D.$clear(c),w.trace("[DiagnosticCollection] remove all (extension, owner)",v.value,c)}dispose(){D.dispose()}};let g;if(!o)o="_generated_diagnostic_collection_name_#"+ti._idPool++,g=o;else if(!d.has(o))g=o;else{this._logService.warn(`DiagnosticCollection with name '${o}' does already exist.`);do g=o+ti._idPool++;while(d.has(g))}return new class extends f{constructor(){super(o,g,ti._maxDiagnosticsPerFile,s.extUri,n,r);d.set(g,this)}dispose(){super.dispose(),d.delete(g)}}}getDiagnostics(v){if(v)return this._getDiagnostics(v);{const o=new Map,d=[];for(const D of this._collections.values())D.forEach((r,w)=>{let s=o.get(r.toString());typeof s=="undefined"&&(s=d.length,o.set(r.toString(),s),d.push([r,[]])),d[s][1]=d[s][1].concat(...w)});return d}}_getDiagnostics(v){let o=[];for(let d of this._collections.values())d.has(v)&&(o=o.concat(d.get(v)));return o}$acceptMarkersChange(v){if(!this._mirrorCollection){const o="_generated_mirror",d=new f(o,o,ti._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(o,d),this._mirrorCollection=d}for(const[o,d]of v)this._mirrorCollection.set(E.URI.revive(o),d.map(T.Diagnostic.to))}};p._idPool=0,p._maxDiagnosticsPerFile=1e3,p=Ue([Be(1,A.ILogService),Be(2,_.IExtHostFileSystemInfo)],p),e.ExtHostDiagnostics=p}),define(we[191],be([0,1,2,5]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class E{constructor(F){this._proxy=F.getProxy(M.MainContext.MainThreadDialogs)}showOpenDialog(F){return this._proxy.$showOpenDialog(F).then(T=>T?T.map(C=>u.URI.revive(C)):void 0)}showSaveDialog(F){return this._proxy.$showSaveDialog(F).then(T=>T?u.URI.revive(T):void 0)}}e.ExtHostDialogs=E}),define(we[192],be([0,1,16,2,7,5,11,21,9]),function(re,e,u,M,E,P,F,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class A{constructor(_,i,m){this._documentsAndEditors=i,this._logService=m,this._documentContentProviders=new Map,this._proxy=_.getProxy(P.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(_,i){if(Object.keys(F.Schemas).indexOf(_)>=0)throw new Error(`scheme '${_}' already registered`);const m=A._handlePool++;this._documentContentProviders.set(m,i),this._proxy.$registerTextContentProvider(m,_);let a;return typeof i.onDidChange=="function"&&(a=i.onDidChange(f=>{if(f.scheme!==_){this._logService.warn(`Provider for scheme '${_}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(f)&&this.$provideTextDocumentContent(m,f).then(p=>{if(!p&&typeof p!="string")return;const S=this._documentsAndEditors.getDocument(f);if(!S)return;const v=(0,C.splitLines)(p);if(!S.equalLines(v))return this._proxy.$onVirtualDocumentChange(f,p)},u.onUnexpectedError)})),new E.Disposable(()=>{this._documentContentProviders.delete(m)&&this._proxy.$unregisterTextContentProvider(m),a&&(a.dispose(),a=void 0)})}$provideTextDocumentContent(_,i){const m=this._documentContentProviders.get(_);return m?Promise.resolve(m.provideTextDocumentContent(M.URI.revive(i),T.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${i.scheme}`))}}e.ExtHostDocumentContentProvider=A,A._handlePool=0}),define(we[193],be([0,1,3,6,2,5,88,8,10,23,7]),function(re,e,u,M,E,P,F,T,C,A,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class _{constructor(m,a){this._onDidAddDocument=new u.Emitter,this._onDidRemoveDocument=new u.Emitter,this._onDidChangeDocument=new u.Emitter,this._onDidSaveDocument=new u.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new M.DisposableStore,this._documentLoader=new Map,this._proxy=m.getProxy(P.MainContext.MainThreadDocuments),this._documentsAndEditors=a,this._documentsAndEditors.onDidRemoveDocuments(f=>{for(const p of f)this._onDidRemoveDocument.fire(p.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(f=>{for(const p of f)this._onDidAddDocument.fire(p.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(m){if(!m)return;const a=this._documentsAndEditors.getDocument(m);if(a)return a}getDocument(m){const a=this.getDocumentData(m);if(!a?.document)throw new Error(`Unable to retrieve document from URI '${m}'`);return a.document}ensureDocumentData(m){const a=this._documentsAndEditors.getDocument(m);if(a)return Promise.resolve(a);let f=this._documentLoader.get(m.toString());return f||(f=this._proxy.$tryOpenDocument(m).then(p=>{this._documentLoader.delete(m.toString());const S=E.URI.revive(p);return(0,C.assertIsDefined)(this._documentsAndEditors.getDocument(S))},p=>(this._documentLoader.delete(m.toString()),Promise.reject(p))),this._documentLoader.set(m.toString(),f)),f}createDocumentData(m){return this._proxy.$tryCreateDocument(m).then(a=>E.URI.revive(a))}$acceptModelModeChanged(m,a){const f=E.URI.revive(m),p=this._documentsAndEditors.getDocument(f);if(!p)throw new Error("unknown document");this._onDidRemoveDocument.fire(p.document),p._acceptLanguageId(a),this._onDidAddDocument.fire(p.document)}$acceptModelSaved(m){const a=E.URI.revive(m),f=this._documentsAndEditors.getDocument(a);if(!f)throw new Error("unknown document");this.$acceptDirtyStateChanged(m,!1),this._onDidSaveDocument.fire(f.document)}$acceptDirtyStateChanged(m,a){const f=E.URI.revive(m),p=this._documentsAndEditors.getDocument(f);if(!p)throw new Error("unknown document");p._acceptIsDirty(a),this._onDidChangeDocument.fire({document:p.document,contentChanges:[],reason:void 0})}$acceptModelChanged(m,a,f){const p=E.URI.revive(m),S=this._documentsAndEditors.getDocument(p);if(!S)throw new Error("unknown document");S._acceptIsDirty(f),S.onEvents(a);let v;a.isUndoing?v=t.TextDocumentChangeReason.Undo:a.isRedoing&&(v=t.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,A.deepFreeze)({document:S.document,contentChanges:a.changes.map(o=>({range:T.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:v}))}setWordDefinitionFor(m,a){(0,F.setWordDefinitionFor)(m,a)}}e.ExtHostDocuments=_}),define(we[51],be([0,1,43,3,6,2,4,5,88,14,94,8,12,20,11,167,103]),function(re,e,u,M,E,P,F,T,C,A,t,_,i,m,a,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class S{constructor(d){this.value=d,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let v=class{constructor(d,D){this._extHostRpc=d,this._logService=D,this._activeEditorId=null,this._editors=new Map,this._documents=new m.ResourceMap,this._onDidAddDocuments=new M.Emitter,this._onDidRemoveDocuments=new M.Emitter,this._onDidChangeVisibleTextEditors=new M.Emitter,this._onDidChangeActiveTextEditor=new M.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(d){this.acceptDocumentsAndEditorsDelta(d)}acceptDocumentsAndEditorsDelta(d){const D=[],r=[],w=[];if(d.removedDocuments)for(const s of d.removedDocuments){const n=P.URI.revive(s),g=this._documents.get(n);g?.unref()&&(this._documents.delete(n),D.push(g.value))}if(d.addedDocuments)for(const s of d.addedDocuments){const n=P.URI.revive(s.uri);let g=this._documents.get(n);if(g&&n.scheme!==a.Schemas.vscodeNotebookCell&&n.scheme!==a.Schemas.vscodeInteractiveInput)throw new Error(`document '${n} already exists!'`);g||(g=new S(new C.ExtHostDocumentData(this._extHostRpc.getProxy(T.MainContext.MainThreadDocuments),n,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this._documents.set(n,g),r.push(g.value)),g.ref()}if(d.removedEditors)for(const s of d.removedEditors){const n=this._editors.get(s);this._editors.delete(s),n&&w.push(n)}if(d.addedEditors)for(const s of d.addedEditors){const n=P.URI.revive(s.documentUri);u.ok(this._documents.has(n),`document '${n}' does not exist`),u.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const g=this._documents.get(n).value,l=new t.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(T.MainContext.MainThreadTextEditors),this._logService,new p.Lazy(()=>g.document),s.selections.map(_.Selection.to),s.options,s.visibleRanges.map(c=>_.Range.to(c)),typeof s.editorPosition=="number"?_.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,l)}d.newActiveEditor!==void 0&&(u.ok(d.newActiveEditor===null||this._editors.has(d.newActiveEditor),`active editor '${d.newActiveEditor}' does not exist`),this._activeEditorId=d.newActiveEditor),(0,E.dispose)(D),(0,E.dispose)(w),d.removedDocuments&&this._onDidRemoveDocuments.fire(D),d.addedDocuments&&this._onDidAddDocuments.fire(r),(d.removedEditors||d.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),d.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(d){return this._documents.get(d)?.value}allDocuments(){return f.Iterable.map(this._documents.values(),d=>d.value)}getEditor(d){return this._editors.get(d)}activeEditor(d){if(!this._activeEditorId)return;const D=this._editors.get(this._activeEditorId);return d?D:D?.value}allEditors(){return[...this._editors.values()]}};v=Ue([Be(0,A.IExtHostRpcService),Be(1,i.ILogService)],v),e.ExtHostDocumentsAndEditors=v,e.IExtHostDocumentsAndEditors=(0,F.createDecorator)("IExtHostDocumentsAndEditors")}),define(we[72],be([0,1,8,5,2,3,4,14,13]),function(re,e,u,M,E,P,F,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,F.createDecorator)("IExtHostEditorTabs");let A=class{constructor(_){this._onDidChangeTabs=new P.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new P.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=_.getProxy(M.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(_){let i=-1;this._tabs=_.map((a,f)=>(a.isActive&&(i=f),Object.freeze({label:a.label,viewColumn:u.ViewColumn.to(a.viewColumn),index:f,resource:E.URI.revive(a.resource),additionalResourcesAndViewIds:a.additionalResourcesAndViewIds.map(({resource:p,viewId:S})=>({resource:E.URI.revive(p),viewId:S})),viewId:a.editorId,isActive:a.isActive,move:async(p,S)=>{this._proxy.$moveTab(a,p,u.ViewColumn.from(S)),await(0,C.raceTimeout)(P.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(a),await(0,C.raceTimeout)(P.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((a,f)=>a.viewColumn===f.viewColumn?a.index-f.index:a.viewColumn-f.viewColumn);const m=this._activeTab;this._activeTab=i===-1?void 0:this._tabs[i],this._activeTab!==m&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};A=Ue([Be(0,T.IExtHostRpcService)],A),e.ExtHostEditorTabs=A}),define(we[194],be([0,1,2,5,6,7,8,236,9,22]),function(re,e,u,M,E,P,F,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class t{constructor(){this._schemes=[]}add(m){this._stateMachine=void 0,this._schemes.push(m)}delete(m){const a=this._schemes.indexOf(m);a>=0&&(this._schemes.splice(a,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const m=this._schemes.sort(),a=[];let f,p,S=14,v=14;for(const o of m){let d=f?(0,C.commonPrefixLength)(f,o):0;for(d===0?p=1:p=v;d<o.length;d++)d+1===o.length?(S=v,v=9):v+=1,a.push([p,o.toUpperCase().charCodeAt(d),v]),a.push([p,o.toLowerCase().charCodeAt(d),v]),p=v;f=o,v=S}a.push([9,58,10]),a.push([10,47,12]),this._stateMachine=new T.StateMachine(a)}}provideDocumentLinks(m){this._initStateMachine();const a=[],f=T.LinkComputer.computeLinks({getLineContent(p){return m.lineAt(p-1).text},getLineCount(){return m.lineCount}},this._stateMachine);for(const p of f){const S=F.DocumentLink.to(p);S.target&&a.push(S)}return a}}class _{constructor(m,a){this._extHostLanguageFeatures=a,this._linkProvider=new t,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=m.getProxy(M.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(m,a,f,p={}){if(this._registeredSchemes.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const S=this._handlePool++;this._linkProvider.add(a),this._registeredSchemes.add(a),this._fsProvider.set(S,f);let v=2;p.isCaseSensitive&&(v+=1024),p.isReadonly&&(v+=2048),typeof f.copy=="function"&&(v+=8),typeof f.open=="function"&&typeof f.close=="function"&&typeof f.read=="function"&&typeof f.write=="function"&&(v+=4),this._proxy.$registerFileSystemProvider(S,a,v).catch(d=>{console.error(`FAILED to register filesystem provider of ${m.value}-extension for the scheme ${a}`),console.error(d)});const o=f.onDidChangeFile(d=>{const D=[];for(const r of d){let{uri:w,type:s}=r;if(w.scheme!==a)continue;let n;switch(s){case P.FileChangeType.Changed:n=0;break;case P.FileChangeType.Created:n=1;break;case P.FileChangeType.Deleted:n=2;break;default:throw new Error("Unknown FileChangeType")}D.push({resource:w,type:n})}this._proxy.$onFileSystemChange(S,D)});return(0,E.toDisposable)(()=>{o.dispose(),this._linkProvider.delete(a),this._registeredSchemes.delete(a),this._fsProvider.delete(S),this._proxy.$unregisterProvider(S)})}static _asIStat(m){const{type:a,ctime:f,mtime:p,size:S,permissions:v}=m;return{type:a,ctime:f,mtime:p,size:S,permissions:v}}$stat(m,a){return Promise.resolve(this._getFsProvider(m).stat(u.URI.revive(a))).then(f=>_._asIStat(f))}$readdir(m,a){return Promise.resolve(this._getFsProvider(m).readDirectory(u.URI.revive(a)))}$readFile(m,a){return Promise.resolve(this._getFsProvider(m).readFile(u.URI.revive(a))).then(f=>A.VSBuffer.wrap(f))}$writeFile(m,a,f,p){return Promise.resolve(this._getFsProvider(m).writeFile(u.URI.revive(a),f.buffer,p))}$delete(m,a,f){return Promise.resolve(this._getFsProvider(m).delete(u.URI.revive(a),f))}$rename(m,a,f,p){return Promise.resolve(this._getFsProvider(m).rename(u.URI.revive(a),u.URI.revive(f),p))}$copy(m,a,f,p){const S=this._getFsProvider(m);if(!S.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(S.copy(u.URI.revive(a),u.URI.revive(f),p))}$mkdir(m,a){return Promise.resolve(this._getFsProvider(m).createDirectory(u.URI.revive(a)))}$watch(m,a,f,p){const S=this._getFsProvider(m).watch(u.URI.revive(f),p);this._watches.set(a,S)}$unwatch(m,a){const f=this._watches.get(a);f&&(f.dispose(),this._watches.delete(a))}$open(m,a,f){const p=this._getFsProvider(m);if(!p.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(p.open(u.URI.revive(a),f))}$close(m,a){const f=this._getFsProvider(m);if(!f.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(f.close(a))}$read(m,a,f,p){const S=this._getFsProvider(m);if(!S.read)throw new Error('FileSystemProvider does not implement "read"');const v=A.VSBuffer.alloc(p);return Promise.resolve(S.read(a,f,v.buffer,0,p)).then(o=>v.slice(0,o))}$write(m,a,f,p){const S=this._getFsProvider(m);if(!S.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(S.write(a,f,p.buffer,0,p.byteLength))}_getFsProvider(m){const a=this._fsProvider.get(m);if(!a){const f=new Error;throw f.name="ENOPRO",f.message="no provider",f}return a}}e.ExtHostFileSystem=_}),define(we[52],be([0,1,5,47,7,22,4,14,31]),function(re,e,u,M,E,P,F,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let A=class Bt{constructor(_,i){const m=_.getProxy(u.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(a){return m.$stat(a).catch(Bt._handleError)},readDirectory(a){return m.$readdir(a).catch(Bt._handleError)},createDirectory(a){return m.$mkdir(a).catch(Bt._handleError)},async readFile(a){return m.$readFile(a).then(f=>f.buffer).catch(Bt._handleError)},writeFile(a,f){return m.$writeFile(a,P.VSBuffer.wrap(f)).catch(Bt._handleError)},delete(a,f){return m.$delete(a,{recursive:!1,useTrash:!1,...f}).catch(Bt._handleError)},rename(a,f,p){return m.$rename(a,f,{overwrite:!1,...p}).catch(Bt._handleError)},copy(a,f,p){return m.$copy(a,f,{overwrite:!1,...p}).catch(Bt._handleError)},isWritableFileSystem(a){const f=i.getCapabilities(a);if(typeof f=="number")return!(f&2048)}})}static _handleError(_){if(!(_ instanceof Error))throw new E.FileSystemError(String(_));if(_.name==="ENOPRO")throw E.FileSystemError.Unavailable(_.message);switch(_.name){case M.FileSystemProviderErrorCode.FileExists:throw E.FileSystemError.FileExists(_.message);case M.FileSystemProviderErrorCode.FileNotFound:throw E.FileSystemError.FileNotFound(_.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw E.FileSystemError.FileNotADirectory(_.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw E.FileSystemError.FileIsADirectory(_.message);case M.FileSystemProviderErrorCode.NoPermissions:throw E.FileSystemError.NoPermissions(_.message);case M.FileSystemProviderErrorCode.Unavailable:throw E.FileSystemError.Unavailable(_.message);default:throw new E.FileSystemError(_.message,_.name)}}};A=Ue([Be(0,T.IExtHostRpcService),Be(1,C.IExtHostFileSystemInfo)],A),e.ExtHostConsumerFileSystem=A,e.IExtHostConsumerFileSystem=(0,F.createDecorator)("IExtHostConsumerFileSystem")}),define(we[195],be([0,1,2,40]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class E{constructor(F,T,C,A){this._extHostNotebooks=T,this._textDocumentsAndEditors=C,this._commands=A;const t=new M.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.ApiCommandArgument("showOptions","Show Options",_=>!0,_=>_),new M.ApiCommandArgument("resource","Interactive resource Uri",_=>!0,_=>_),new M.ApiCommandArgument("controllerId","Notebook controller Id",_=>!0,_=>_),new M.ApiCommandArgument("title","Interactive editor title",_=>!0,_=>_)],new M.ApiCommandResult("Notebook and input URI",_=>{if(_.notebookEditorId!==void 0){const i=this._extHostNotebooks.getEditorById(_.notebookEditorId);return{notebookUri:u.URI.revive(_.notebookUri),inputUri:u.URI.revive(_.inputUri),notebookEditor:i.apiEditor}}return{notebookUri:u.URI.revive(_.notebookUri),inputUri:u.URI.revive(_.inputUri)}}));this._commands.registerApiCommand(t)}$willAddInteractiveDocument(F,T,C,A){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],languageId:C,uri:F,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(u.URI.revive(A))?.apiNotebook}]})}$willRemoveInteractiveDocument(F,T){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[F]})}}e.ExtHostInteractive=E}),define(we[196],be([0,1,6,5]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class E{constructor(F){this._handlePool=0,this._proxy=F.getProxy(M.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(F){const T=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(T,F),(0,u.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(T)})}}e.ExtHostLabelService=E}),define(we[197],be([0,1,2,23,8,7,5,9,45,15,10,237,6,81,56,65,198,16,3]),function(re,e,u,M,E,P,F,T,C,A,t,_,i,m,a,f,p,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class o{constructor(z,K){this._documents=z,this._provider=K}async provideDocumentSymbols(z,K){const Z=this._documents.getDocument(z),se=await this._provider.provideDocumentSymbols(Z,K);if(!(0,A.isFalsyOrEmpty)(se))return se[0]instanceof P.DocumentSymbol?se.map(E.DocumentSymbol.from):o._asDocumentSymbolTree(se)}static _asDocumentSymbolTree(z){z=z.slice(0).sort((se,G)=>{let ie=se.location.range.start.compareTo(G.location.range.start);return ie===0&&(ie=G.location.range.end.compareTo(se.location.range.end)),ie});const K=[],Z=[];for(const se of z){const G={name:se.name||"!!MISSING: name!!",kind:E.SymbolKind.from(se.kind),tags:se.tags?.map(E.SymbolTag.from)||[],detail:"",containerName:se.containerName,range:E.Range.from(se.location.range),selectionRange:E.Range.from(se.location.range),children:[]};for(;;){if(Z.length===0){Z.push(G),K.push(G);break}const ie=Z[Z.length-1];if(C.Range.containsRange(ie.range,G.range)&&!C.Range.equalsRange(ie.range,G.range)){ie.children&&ie.children.push(G),Z.push(G);break}Z.pop()}}return K}}class d{constructor(z,K,Z){this._documents=z,this._commands=K,this._provider=Z,this._cache=new f.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(z,K){const Z=this._documents.getDocument(z),se=await this._provider.provideCodeLenses(Z,K);if(!se||K.isCancellationRequested)return;const G=this._cache.add(se),ie=new i.DisposableStore;this._disposables.set(G,ie);const de={cacheId:G,lenses:[]};for(let Pe=0;Pe<se.length;Pe++)de.lenses.push({cacheId:[G,Pe],range:E.Range.from(se[Pe].range),command:this._commands.toInternal(se[Pe].command,ie)});return de}async resolveCodeLens(z,K){const Z=z.cacheId&&this._cache.get(...z.cacheId);if(!Z)return;let se;if(typeof this._provider.resolveCodeLens!="function"||Z.isResolved?se=Z:se=await this._provider.resolveCodeLens(Z,K),se||(se=Z),K.isCancellationRequested)return;const G=z.cacheId&&this._disposables.get(z.cacheId[0]);if(!!G)return z.command=this._commands.toInternal(se.command??d._badCmd,G),z}releaseCodeLenses(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}}d._badCmd={command:"missing",title:"!!MISSING: command!!"};function D(qe){return Array.isArray(qe)?qe.map(E.DefinitionLink.from):qe?[E.DefinitionLink.from(qe)]:[]}class r{constructor(z,K){this._documents=z,this._provider=K}async provideDefinition(z,K,Z){const se=this._documents.getDocument(z),G=E.Position.to(K),ie=await this._provider.provideDefinition(se,G,Z);return D(ie)}}class w{constructor(z,K){this._documents=z,this._provider=K}async provideDeclaration(z,K,Z){const se=this._documents.getDocument(z),G=E.Position.to(K),ie=await this._provider.provideDeclaration(se,G,Z);return D(ie)}}class s{constructor(z,K){this._documents=z,this._provider=K}async provideImplementation(z,K,Z){const se=this._documents.getDocument(z),G=E.Position.to(K),ie=await this._provider.provideImplementation(se,G,Z);return D(ie)}}class n{constructor(z,K){this._documents=z,this._provider=K}async provideTypeDefinition(z,K,Z){const se=this._documents.getDocument(z),G=E.Position.to(K),ie=await this._provider.provideTypeDefinition(se,G,Z);return D(ie)}}class g{constructor(z,K){this._documents=z,this._provider=K}async provideHover(z,K,Z){const se=this._documents.getDocument(z),G=E.Position.to(K),ie=await this._provider.provideHover(se,G,Z);if(!(!ie||(0,A.isFalsyOrEmpty)(ie.contents)))return ie.range||(ie.range=se.getWordRangeAtPosition(G)),ie.range||(ie.range=new P.Range(G,G)),E.Hover.from(ie)}}class l{constructor(z,K){this._documents=z,this._provider=K}async provideEvaluatableExpression(z,K,Z){const se=this._documents.getDocument(z),G=E.Position.to(K),ie=await this._provider.provideEvaluatableExpression(se,G,Z);if(ie)return E.EvaluatableExpression.from(ie)}}class c{constructor(z,K){this._documents=z,this._provider=K}async provideInlineValues(z,K,Z,se){const G=this._documents.getDocument(z),ie=await this._provider.provideInlineValues(G,E.Range.to(K),E.InlineValueContext.to(Z),se);if(Array.isArray(ie))return ie.map(de=>E.InlineValue.from(de))}}class b{constructor(z,K){this._documents=z,this._provider=K}async provideDocumentHighlights(z,K,Z){const se=this._documents.getDocument(z),G=E.Position.to(K),ie=await this._provider.provideDocumentHighlights(se,G,Z);if(Array.isArray(ie))return ie.map(E.DocumentHighlight.from)}}class h{constructor(z,K){this._documents=z,this._provider=K}async provideLinkedEditingRanges(z,K,Z){const se=this._documents.getDocument(z),G=E.Position.to(K),ie=await this._provider.provideLinkedEditingRanges(se,G,Z);if(ie&&Array.isArray(ie.ranges))return{ranges:(0,A.coalesce)(ie.ranges.map(E.Range.from)),wordPattern:ie.wordPattern}}}class y{constructor(z,K){this._documents=z,this._provider=K}async provideReferences(z,K,Z,se){const G=this._documents.getDocument(z),ie=E.Position.to(K),de=await this._provider.provideReferences(G,ie,Z,se);if(Array.isArray(de))return de.map(E.location.from)}}class R{constructor(z,K,Z,se,G,ie,de){this._documents=z,this._commands=K,this._diagnostics=Z,this._provider=se,this._logService=G,this._extension=ie,this._apiDeprecation=de,this._cache=new f.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(z,K,Z,se){const G=this._documents.getDocument(z),ie=_.Selection.isISelection(K)?E.Selection.to(K):E.Range.to(K),de=[];for(const ot of this._diagnostics.getDiagnostics(z))if(ie.intersection(ot.range)&&de.push(ot)>R._maxCodeActionsPerFile)break;const Pe={diagnostics:de,only:Z.only?new P.CodeActionKind(Z.only):void 0,triggerKind:E.CodeActionTriggerKind.to(Z.trigger)},Ne=await this._provider.provideCodeActions(G,ie,Pe,se);if(!(0,A.isNonEmptyArray)(Ne)||se.isCancellationRequested)return;const We=this._cache.add(Ne),je=new i.DisposableStore;this._disposables.set(We,je);const et=[];for(let ot=0;ot<Ne.length;ot++){const _e=Ne[ot];!_e||(R._isCommand(_e)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:_e.title,command:this._commands.toInternal(_e,je)})):(Pe.only&&(_e.kind?Pe.only.contains(_e.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Pe.only.value} 'requested but returned code action is of kind '${_e.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Pe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),et.push({cacheId:[We,ot],title:_e.title,command:_e.command&&this._commands.toInternal(_e.command,je),diagnostics:_e.diagnostics&&_e.diagnostics.map(E.Diagnostic.from),edit:_e.edit&&E.WorkspaceEdit.from(_e.edit),kind:_e.kind&&_e.kind.value,isPreferred:_e.isPreferred,disabled:_e.disabled?.reason})))}return{cacheId:We,actions:et}}async resolveCodeAction(z,K){const[Z,se]=z,G=this._cache.get(Z,se);if(!G||R._isCommand(G)||!this._provider.resolveCodeAction)return;const ie=await this._provider.resolveCodeAction(G,K)??G;return ie?.edit?E.WorkspaceEdit.from(ie.edit):void 0}releaseCodeActions(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}static _isCommand(z){return typeof z.command=="string"&&typeof z.title=="string"}}R._maxCodeActionsPerFile=1e3;class I{constructor(z,K){this._documents=z,this._provider=K}async provideDocumentFormattingEdits(z,K,Z){const se=this._documents.getDocument(z),G=await this._provider.provideDocumentFormattingEdits(se,K,Z);if(Array.isArray(G))return G.map(E.TextEdit.from)}}class B{constructor(z,K){this._documents=z,this._provider=K}async provideDocumentRangeFormattingEdits(z,K,Z,se){const G=this._documents.getDocument(z),ie=E.Range.to(K),de=await this._provider.provideDocumentRangeFormattingEdits(G,ie,Z,se);if(Array.isArray(de))return de.map(E.TextEdit.from)}}class L{constructor(z,K){this._documents=z,this._provider=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(z,K,Z,se,G){const ie=this._documents.getDocument(z),de=E.Position.to(K),Pe=await this._provider.provideOnTypeFormattingEdits(ie,de,Z,se,G);if(Array.isArray(Pe))return Pe.map(E.TextEdit.from)}}class k{constructor(z,K){this._provider=z,this._logService=K,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(z,K){const Z=F.IdObject.mixin({symbols:[]}),se=await this._provider.provideWorkspaceSymbols(z,K);if((0,A.isNonEmptyArray)(se))for(const G of se){if(!G)continue;if(!G.name){this._logService.warn("INVALID SymbolInformation, lacks name",G);continue}const ie=F.IdObject.mixin(E.WorkspaceSymbol.from(G));this._symbolCache.set(ie._id,G),Z.symbols.push(ie)}return Z.symbols.length>0&&this._resultCache.set(Z._id,[Z.symbols[0]._id,Z.symbols[Z.symbols.length-1]._id]),Z}async resolveWorkspaceSymbol(z,K){if(typeof this._provider.resolveWorkspaceSymbol!="function")return z;const Z=this._symbolCache.get(z._id);if(Z){const se=await this._provider.resolveWorkspaceSymbol(Z,K);return se&&(0,M.mixin)(z,E.WorkspaceSymbol.from(se),!0)}}releaseWorkspaceSymbols(z){const K=this._resultCache.get(z);if(K){for(let[Z,se]=K;Z<=se;Z++)this._symbolCache.delete(Z);this._resultCache.delete(z)}}}class x{constructor(z,K,Z){this._documents=z,this._provider=K,this._logService=Z}static supportsResolving(z){return typeof z.prepareRename=="function"}async provideRenameEdits(z,K,Z,se){const G=this._documents.getDocument(z),ie=E.Position.to(K);try{const de=await this._provider.provideRenameEdits(G,ie,Z,se);return de?E.WorkspaceEdit.from(de):void 0}catch(de){const Pe=x._asMessage(de);return Pe?{rejectReason:Pe,edits:void 0}:Promise.reject(de)}}async resolveRenameLocation(z,K,Z){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const se=this._documents.getDocument(z),G=E.Position.to(K);try{const ie=await this._provider.prepareRename(se,G,Z);let de,Pe;if(P.Range.isRange(ie)?(de=ie,Pe=se.getText(ie)):(0,t.isObject)(ie)&&(de=ie.range,Pe=ie.placeholder),!de||!Pe)return;if(de.start.line>G.line||de.end.line<G.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:E.Range.from(de),text:Pe}}catch(ie){const de=x._asMessage(ie);return de?{rejectReason:de,range:void 0,text:void 0}:Promise.reject(ie)}}static _asMessage(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class N{constructor(z,K){this.resultId=z,this.tokens=K}}class V{constructor(z,K){this._documents=z,this._provider=K,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(z,K,Z){const se=this._documents.getDocument(z),G=K!==0?this._previousResults.get(K):null;let ie=typeof G?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(se,G.resultId,Z):await this._provider.provideDocumentSemanticTokens(se,Z);return G&&this._previousResults.delete(K),ie?(ie=V._fixProvidedSemanticTokens(ie),this._send(V._convertToEdits(G,ie),ie)):null}async releaseDocumentSemanticColoring(z){this._previousResults.delete(z)}static _fixProvidedSemanticTokens(z){return V._isSemanticTokens(z)?V._isCorrectSemanticTokens(z)?z:new P.SemanticTokens(new Uint32Array(z.data),z.resultId):V._isSemanticTokensEdits(z)?V._isCorrectSemanticTokensEdits(z)?z:new P.SemanticTokensEdits(z.edits.map(K=>new P.SemanticTokensEdit(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),z.resultId):z}static _isSemanticTokens(z){return z&&!!z.data}static _isCorrectSemanticTokens(z){return z.data instanceof Uint32Array}static _isSemanticTokensEdits(z){return z&&Array.isArray(z.edits)}static _isCorrectSemanticTokensEdits(z){for(const K of z.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(z,K){if(!V._isSemanticTokens(K)||!z||!z.tokens)return K;const Z=z.tokens,se=Z.length,G=K.data,ie=G.length;let de=0;const Pe=Math.min(se,ie);for(;de<Pe&&Z[de]===G[de];)de++;if(de===se&&de===ie)return new P.SemanticTokensEdits([],K.resultId);let Ne=0;const We=Pe-de;for(;Ne<We&&Z[se-Ne-1]===G[ie-Ne-1];)Ne++;return new P.SemanticTokensEdits([{start:de,deleteCount:se-de-Ne,data:G.subarray(de,ie-Ne)}],K.resultId)}_send(z,K){if(V._isSemanticTokens(z)){const Z=this._nextResultId++;return this._previousResults.set(Z,new N(z.resultId,z.data)),(0,m.encodeSemanticTokensDto)({id:Z,type:"full",data:z.data})}if(V._isSemanticTokensEdits(z)){const Z=this._nextResultId++;return V._isSemanticTokens(K)?this._previousResults.set(Z,new N(K.resultId,K.data)):this._previousResults.set(Z,new N(z.resultId)),(0,m.encodeSemanticTokensDto)({id:Z,type:"delta",deltas:(z.edits||[]).map(se=>({start:se.start,deleteCount:se.deleteCount,data:se.data}))})}return null}}e.DocumentSemanticTokensAdapter=V;class W{constructor(z,K){this._documents=z,this._provider=K}async provideDocumentRangeSemanticTokens(z,K,Z){const se=this._documents.getDocument(z),G=await this._provider.provideDocumentRangeSemanticTokens(se,E.Range.to(K),Z);return G?this._send(G):null}_send(z){return(0,m.encodeSemanticTokensDto)({id:0,type:"full",data:z.data})}}e.DocumentRangeSemanticTokensAdapter=W;class ${constructor(z,K,Z,se,G){this._documents=z,this._commands=K,this._provider=Z,this._apiDeprecation=se,this._extension=G,this._cache=new f.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}async provideCompletionItems(z,K,Z,se){const G=this._documents.getDocument(z),ie=E.Position.to(K),de=G.getWordRangeAtPosition(ie)||new P.Range(ie,ie),Pe=de.with({end:ie}),Ne=new p.StopWatch(!0),We=await this._provider.provideCompletionItems(G,ie,se,E.CompletionContext.to(Z));if(!We||se.isCancellationRequested)return;const je=Array.isArray(We)?new P.CompletionList(We):We,et=$.supportsResolving(this._provider)?this._cache.add(je.items):this._cache.add([]),ot=new i.DisposableStore;this._disposables.set(et,ot);const _e=[],nt={x:et,b:_e,a:{replace:E.Range.from(de),insert:E.Range.from(Pe)},c:je.isIncomplete||void 0,d:Ne.elapsed()};for(let q=0;q<je.items.length;q++){const J=je.items[q],ge=this._convertCompletionItem(J,[et,q],Pe,de);_e.push(ge)}return nt}async resolveCompletionItem(z,K){if(typeof this._provider.resolveCompletionItem!="function")return;const Z=this._cache.get(...z);if(!Z)return;const se=await this._provider.resolveCompletionItem(Z,K);if(!!se)return this._convertCompletionItem(se,z)}releaseCompletionItems(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}_convertCompletionItem(z,K,Z,se){const G=this._disposables.get(K[0]);if(!G)throw Error("DisposableStore is missing...");const ie={x:K,a:z.label,b:z.kind!==void 0?E.CompletionItemKind.from(z.kind):void 0,n:z.tags&&z.tags.map(E.CompletionItemTag.from),c:z.detail,d:typeof z.documentation=="undefined"?void 0:E.MarkdownString.fromStrict(z.documentation),e:z.sortText!==z.label?z.sortText:void 0,f:z.filterText!==z.label?z.filterText:void 0,g:z.preselect||void 0,i:z.keepWhitespace?1:0,k:z.commitCharacters,l:z.additionalTextEdits&&z.additionalTextEdits.map(E.TextEdit.from),m:this._commands.toInternal(z.command,G)};z.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ie.h=z.textEdit.newText):typeof z.insertText=="string"?ie.h=z.insertText:z.insertText instanceof P.SnippetString&&(ie.h=z.insertText.value,ie.i|=4);let de;return z.textEdit?de=z.textEdit.range:z.range&&(de=z.range),P.Range.isRange(de)?ie.j=E.Range.from(de):de&&(!Z?.isEqual(de.inserting)||!se?.isEqual(de.replacing))&&(ie.j={insert:E.Range.from(de.inserting),replace:E.Range.from(de.replacing)}),ie}}class X{constructor(z,K,Z){this._documents=z,this._provider=K,this._commands=Z,this._cache=new f.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(z,K,Z,se){const G=this._documents.getDocument(z),ie=E.Position.to(K),de=await this._provider.provideInlineCompletionItems(G,ie,{selectedCompletionInfo:Z.selectedSuggestionInfo?{range:E.Range.to(Z.selectedSuggestionInfo.range),text:Z.selectedSuggestionInfo.text}:void 0,triggerKind:Z.triggerKind},se);if(!de||se.isCancellationRequested)return;const Pe=(0,t.isArray)(de)?{items:de}:de,Ne=this._cache.add(Pe.items);let We;return{pid:Ne,items:Pe.items.map((je,et)=>{let ot;return je.command&&(We||(We=new i.DisposableStore,this._disposables.set(Ne,We)),ot=this._commands.toInternal(je.command,We)),{text:je.text,range:je.range?E.Range.from(je.range):void 0,command:ot,idx:et}})}}disposeCompletions(z){this._cache.delete(z);const K=this._disposables.get(z);K&&K.clear(),this._disposables.delete(z)}handleDidShowCompletionItem(z,K){const Z=this._cache.get(z,K);Z&&j.get(this._provider).fireOnDidShowCompletionItem({completionItem:Z})}}class j{constructor(){this._onDidShowCompletionItemEmitter=new v.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(z){let K=j.map.get(z);return K||(K=new j,j.map.set(z,K)),K}fireOnDidShowCompletionItem(z){this._onDidShowCompletionItemEmitter.fire(z)}}e.InlineCompletionController=j,j.map=new WeakMap;class Q{constructor(z,K){this._documents=z,this._provider=K,this._cache=new f.Cache("SignatureHelp")}async provideSignatureHelp(z,K,Z,se){const G=this._documents.getDocument(z),ie=E.Position.to(K),de=this.reviveContext(Z),Pe=await this._provider.provideSignatureHelp(G,ie,se,de);if(Pe){const Ne=this._cache.add([Pe]);return{...E.SignatureHelp.from(Pe),id:Ne}}}reviveContext(z){let K;if(z.activeSignatureHelp){const Z=E.SignatureHelp.to(z.activeSignatureHelp),se=this._cache.get(z.activeSignatureHelp.id,0);se?(K=se,K.activeSignature=Z.activeSignature,K.activeParameter=Z.activeParameter):K=Z}return{...z,activeSignatureHelp:K}}releaseSignatureHelp(z){this._cache.delete(z)}}class ae{constructor(z,K){this._documents=z,this._provider=K}async provideInlayHints(z,K,Z){const se=this._documents.getDocument(z),G=await this._provider.provideInlayHints(se,E.Range.to(K),Z);return G?{hints:G.map(E.InlayHint.from)}:void 0}}class pe{constructor(z,K){this._documents=z,this._provider=K,this._cache=new f.Cache("DocumentLink")}async provideLinks(z,K){const Z=this._documents.getDocument(z),se=await this._provider.provideDocumentLinks(Z,K);if(!(!Array.isArray(se)||se.length===0)&&!K.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:se.filter(pe._validateLink).map(E.DocumentLink.from)};{const G=this._cache.add(se),ie={links:[],id:G};for(let de=0;de<se.length;de++){if(!pe._validateLink(se[de]))continue;const Pe=E.DocumentLink.from(se[de]);Pe.cacheId=[G,de],ie.links.push(Pe)}return ie}}}static _validateLink(z){return z.target&&z.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(z,K){if(typeof this._provider.resolveDocumentLink!="function")return;const Z=this._cache.get(...z);if(!Z)return;const se=await this._provider.resolveDocumentLink(Z,K);if(!(!se||!pe._validateLink(se)))return E.DocumentLink.from(se)}releaseLinks(z){this._cache.delete(z)}}class ce{constructor(z,K){this._documents=z,this._provider=K}async provideColors(z,K){const Z=this._documents.getDocument(z),se=await this._provider.provideDocumentColors(Z,K);return Array.isArray(se)?se.map(ie=>({color:E.Color.from(ie.color),range:E.Range.from(ie.range)})):[]}async provideColorPresentations(z,K,Z){const se=this._documents.getDocument(z),G=E.Range.to(K.range),ie=E.Color.to(K.color),de=await this._provider.provideColorPresentations(ie,{document:se,range:G},Z);if(!!Array.isArray(de))return de.map(E.ColorPresentation.from)}}class Fe{constructor(z,K){this._documents=z,this._provider=K}async provideFoldingRanges(z,K,Z){const se=this._documents.getDocument(z),G=await this._provider.provideFoldingRanges(se,K,Z);if(!!Array.isArray(G))return G.map(E.FoldingRange.from)}}class Qe{constructor(z,K,Z){this._documents=z,this._provider=K,this._logService=Z}async provideSelectionRanges(z,K,Z){const se=this._documents.getDocument(z),G=K.map(E.Position.to),ie=await this._provider.provideSelectionRanges(se,G,Z);if(!(0,A.isNonEmptyArray)(ie))return[];if(ie.length!==G.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const de=[];for(let Pe=0;Pe<G.length;Pe++){const Ne=[];de.push(Ne);let We=G[Pe],je=ie[Pe];for(;;){if(!je.range.contains(We))throw new Error("INVALID selection range, must contain the previous range");if(Ne.push(E.SelectionRange.from(je)),!je.parent)break;We=je.range,je=je.parent}}return de}}class Oe{constructor(z,K){this._documents=z,this._provider=K,this._idPool=new a.IdGenerator(""),this._cache=new Map}async prepareSession(z,K,Z){const se=this._documents.getDocument(z),G=E.Position.to(K),ie=await this._provider.prepareCallHierarchy(se,G,Z);if(!ie)return;const de=this._idPool.nextId();return this._cache.set(de,new Map),Array.isArray(ie)?ie.map(Pe=>this._cacheAndConvertItem(de,Pe)):[this._cacheAndConvertItem(de,ie)]}async provideCallsTo(z,K,Z){const se=this._itemFromCache(z,K);if(!se)throw new Error("missing call hierarchy item");const G=await this._provider.provideCallHierarchyIncomingCalls(se,Z);if(!!G)return G.map(ie=>({from:this._cacheAndConvertItem(z,ie.from),fromRanges:ie.fromRanges.map(de=>E.Range.from(de))}))}async provideCallsFrom(z,K,Z){const se=this._itemFromCache(z,K);if(!se)throw new Error("missing call hierarchy item");const G=await this._provider.provideCallHierarchyOutgoingCalls(se,Z);if(!!G)return G.map(ie=>({to:this._cacheAndConvertItem(z,ie.to),fromRanges:ie.fromRanges.map(de=>E.Range.from(de))}))}releaseSession(z){this._cache.delete(z)}_cacheAndConvertItem(z,K){const Z=this._cache.get(z),se=E.CallHierarchyItem.from(K,z,Z.size.toString(36));return Z.set(se._itemId,K),se}_itemFromCache(z,K){return this._cache.get(z)?.get(K)}}class He{constructor(z,K){this._documents=z,this._provider=K,this._idPool=new a.IdGenerator(""),this._cache=new Map}async prepareSession(z,K,Z){const se=this._documents.getDocument(z),G=E.Position.to(K),ie=await this._provider.prepareTypeHierarchy(se,G,Z);if(!ie)return;const de=this._idPool.nextId();return this._cache.set(de,new Map),Array.isArray(ie)?ie.map(Pe=>this._cacheAndConvertItem(de,Pe)):[this._cacheAndConvertItem(de,ie)]}async provideSupertypes(z,K,Z){const se=this._itemFromCache(z,K);if(!se)throw new Error("missing type hierarchy item");const G=await this._provider.provideTypeHierarchySupertypes(se,Z);if(!!G)return G.map(ie=>this._cacheAndConvertItem(z,ie))}async provideSubtypes(z,K,Z){const se=this._itemFromCache(z,K);if(!se)throw new Error("missing type hierarchy item");const G=await this._provider.provideTypeHierarchySubtypes(se,Z);if(!!G)return G.map(ie=>this._cacheAndConvertItem(z,ie))}releaseSession(z){this._cache.delete(z)}_cacheAndConvertItem(z,K){const Z=this._cache.get(z),se=E.TypeHierarchyItem.from(K,z,Z.size.toString(36));return Z.set(se._itemId,K),se}_itemFromCache(z,K){return this._cache.get(z)?.get(K)}}class Je{constructor(z,K){this.adapter=z,this.extension=K}}class Ye{constructor(z,K,Z,se,G,ie,de){this._adapter=new Map,this._uriTransformer=K,this._proxy=z.getProxy(F.MainContext.MainThreadLanguageFeatures),this._documents=Z,this._commands=se,this._diagnostics=G,this._logService=ie,this._apiDeprecation=de}_transformDocumentSelector(z){return E.DocumentSelector.from(z,this._uriTransformer)}_createDisposable(z){return new P.Disposable(()=>{this._adapter.delete(z),this._proxy.$unregister(z)})}_nextHandle(){return Ye._handlePool++}_withAdapter(z,K,Z,se,G=!1){const ie=this._adapter.get(z);if(!ie)return Promise.resolve(se);if(ie.adapter instanceof K){let de;ie.extension&&(de=Date.now(),this._logService.trace(`[${ie.extension.identifier.value}] INVOKE provider '${K.name}'`));const Pe=Z(ie.adapter,ie.extension),Ne=ie.extension;return Ne&&Promise.resolve(Pe).then(()=>this._logService.trace(`[${Ne.identifier.value}] provider DONE after ${Date.now()-de}ms`),We=>{G&&We instanceof S.CancellationError||(this._logService.error(`[${Ne.identifier.value}] provider FAILED`),this._logService.error(We))}),Pe}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(z,K){const Z=this._nextHandle();return this._adapter.set(Z,new Je(z,K)),Z}static _extLabel(z){return z.displayName||z.name}registerDocumentSymbolProvider(z,K,Z,se){const G=this._addNewAdapter(new o(this._documents,Z),z),ie=se&&se.label||Ye._extLabel(z);return this._proxy.$registerDocumentSymbolProvider(G,this._transformDocumentSelector(K),ie),this._createDisposable(G)}$provideDocumentSymbols(z,K,Z){return this._withAdapter(z,o,se=>se.provideDocumentSymbols(u.URI.revive(K),Z),void 0)}registerCodeLensProvider(z,K,Z){const se=this._nextHandle(),G=typeof Z.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(se,new Je(new d(this._documents,this._commands.converter,Z),z)),this._proxy.$registerCodeLensSupport(se,this._transformDocumentSelector(K),G);let ie=this._createDisposable(se);if(G!==void 0){const de=Z.onDidChangeCodeLenses(Pe=>this._proxy.$emitCodeLensEvent(G));ie=P.Disposable.from(ie,de)}return ie}$provideCodeLenses(z,K,Z){return this._withAdapter(z,d,se=>se.provideCodeLenses(u.URI.revive(K),Z),void 0)}$resolveCodeLens(z,K,Z){return this._withAdapter(z,d,se=>se.resolveCodeLens(K,Z),void 0)}$releaseCodeLenses(z,K){this._withAdapter(z,d,Z=>Promise.resolve(Z.releaseCodeLenses(K)),void 0)}registerDefinitionProvider(z,K,Z){const se=this._addNewAdapter(new r(this._documents,Z),z);return this._proxy.$registerDefinitionSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideDefinition(z,K,Z,se){return this._withAdapter(z,r,G=>G.provideDefinition(u.URI.revive(K),Z,se),[])}registerDeclarationProvider(z,K,Z){const se=this._addNewAdapter(new w(this._documents,Z),z);return this._proxy.$registerDeclarationSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideDeclaration(z,K,Z,se){return this._withAdapter(z,w,G=>G.provideDeclaration(u.URI.revive(K),Z,se),[])}registerImplementationProvider(z,K,Z){const se=this._addNewAdapter(new s(this._documents,Z),z);return this._proxy.$registerImplementationSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideImplementation(z,K,Z,se){return this._withAdapter(z,s,G=>G.provideImplementation(u.URI.revive(K),Z,se),[])}registerTypeDefinitionProvider(z,K,Z){const se=this._addNewAdapter(new n(this._documents,Z),z);return this._proxy.$registerTypeDefinitionSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideTypeDefinition(z,K,Z,se){return this._withAdapter(z,n,G=>G.provideTypeDefinition(u.URI.revive(K),Z,se),[])}registerHoverProvider(z,K,Z,se){const G=this._addNewAdapter(new g(this._documents,Z),z);return this._proxy.$registerHoverProvider(G,this._transformDocumentSelector(K)),this._createDisposable(G)}$provideHover(z,K,Z,se){return this._withAdapter(z,g,G=>G.provideHover(u.URI.revive(K),Z,se),void 0)}registerEvaluatableExpressionProvider(z,K,Z,se){const G=this._addNewAdapter(new l(this._documents,Z),z);return this._proxy.$registerEvaluatableExpressionProvider(G,this._transformDocumentSelector(K)),this._createDisposable(G)}$provideEvaluatableExpression(z,K,Z,se){return this._withAdapter(z,l,G=>G.provideEvaluatableExpression(u.URI.revive(K),Z,se),void 0)}registerInlineValuesProvider(z,K,Z,se){const G=typeof Z.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ie=this._addNewAdapter(new c(this._documents,Z),z);this._proxy.$registerInlineValuesProvider(ie,this._transformDocumentSelector(K),G);let de=this._createDisposable(ie);if(G!==void 0){const Pe=Z.onDidChangeInlineValues(Ne=>this._proxy.$emitInlineValuesEvent(G));de=P.Disposable.from(de,Pe)}return de}$provideInlineValues(z,K,Z,se,G){return this._withAdapter(z,c,ie=>ie.provideInlineValues(u.URI.revive(K),Z,se,G),void 0)}registerDocumentHighlightProvider(z,K,Z){const se=this._addNewAdapter(new b(this._documents,Z),z);return this._proxy.$registerDocumentHighlightProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideDocumentHighlights(z,K,Z,se){return this._withAdapter(z,b,G=>G.provideDocumentHighlights(u.URI.revive(K),Z,se),void 0)}registerLinkedEditingRangeProvider(z,K,Z){const se=this._addNewAdapter(new h(this._documents,Z),z);return this._proxy.$registerLinkedEditingRangeProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideLinkedEditingRanges(z,K,Z,se){return this._withAdapter(z,h,async G=>{const ie=await G.provideLinkedEditingRanges(u.URI.revive(K),Z,se);if(ie)return{ranges:ie.ranges,wordPattern:ie.wordPattern?Ye._serializeRegExp(ie.wordPattern):void 0}},void 0)}registerReferenceProvider(z,K,Z){const se=this._addNewAdapter(new y(this._documents,Z),z);return this._proxy.$registerReferenceSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideReferences(z,K,Z,se,G){return this._withAdapter(z,y,ie=>ie.provideReferences(u.URI.revive(K),Z,se,G),void 0)}registerCodeActionProvider(z,K,Z,se){const G=new i.DisposableStore,ie=this._addNewAdapter(new R(this._documents,this._commands.converter,this._diagnostics,Z,this._logService,z,this._apiDeprecation),z);return this._proxy.$registerQuickFixSupport(ie,this._transformDocumentSelector(K),{providedKinds:se?.providedCodeActionKinds?.map(de=>de.value),documentation:se?.documentation?.map(de=>({kind:de.kind.value,command:this._commands.converter.toInternal(de.command,G)}))},Ye._extLabel(z),Boolean(Z.resolveCodeAction)),G.add(this._createDisposable(ie)),G}$provideCodeActions(z,K,Z,se,G){return this._withAdapter(z,R,ie=>ie.provideCodeActions(u.URI.revive(K),Z,se,G),void 0)}$resolveCodeAction(z,K,Z){return this._withAdapter(z,R,se=>se.resolveCodeAction(K,Z),void 0)}$releaseCodeActions(z,K){this._withAdapter(z,R,Z=>Promise.resolve(Z.releaseCodeActions(K)),void 0)}registerDocumentFormattingEditProvider(z,K,Z){const se=this._addNewAdapter(new I(this._documents,Z),z);return this._proxy.$registerDocumentFormattingSupport(se,this._transformDocumentSelector(K),z.identifier,z.displayName||z.name),this._createDisposable(se)}$provideDocumentFormattingEdits(z,K,Z,se){return this._withAdapter(z,I,G=>G.provideDocumentFormattingEdits(u.URI.revive(K),Z,se),void 0)}registerDocumentRangeFormattingEditProvider(z,K,Z){const se=this._addNewAdapter(new B(this._documents,Z),z);return this._proxy.$registerRangeFormattingSupport(se,this._transformDocumentSelector(K),z.identifier,z.displayName||z.name),this._createDisposable(se)}$provideDocumentRangeFormattingEdits(z,K,Z,se,G){return this._withAdapter(z,B,ie=>ie.provideDocumentRangeFormattingEdits(u.URI.revive(K),Z,se,G),void 0)}registerOnTypeFormattingEditProvider(z,K,Z,se){const G=this._addNewAdapter(new L(this._documents,Z),z);return this._proxy.$registerOnTypeFormattingSupport(G,this._transformDocumentSelector(K),se,z.identifier),this._createDisposable(G)}$provideOnTypeFormattingEdits(z,K,Z,se,G,ie){return this._withAdapter(z,L,de=>de.provideOnTypeFormattingEdits(u.URI.revive(K),Z,se,G,ie),void 0)}registerWorkspaceSymbolProvider(z,K){const Z=this._addNewAdapter(new k(K,this._logService),z);return this._proxy.$registerNavigateTypeSupport(Z),this._createDisposable(Z)}$provideWorkspaceSymbols(z,K,Z){return this._withAdapter(z,k,se=>se.provideWorkspaceSymbols(K,Z),{symbols:[]})}$resolveWorkspaceSymbol(z,K,Z){return this._withAdapter(z,k,se=>se.resolveWorkspaceSymbol(K,Z),void 0)}$releaseWorkspaceSymbols(z,K){this._withAdapter(z,k,Z=>Z.releaseWorkspaceSymbols(K),void 0)}registerRenameProvider(z,K,Z){const se=this._addNewAdapter(new x(this._documents,Z,this._logService),z);return this._proxy.$registerRenameSupport(se,this._transformDocumentSelector(K),x.supportsResolving(Z)),this._createDisposable(se)}$provideRenameEdits(z,K,Z,se,G){return this._withAdapter(z,x,ie=>ie.provideRenameEdits(u.URI.revive(K),Z,se,G),void 0)}$resolveRenameLocation(z,K,Z,se){return this._withAdapter(z,x,G=>G.resolveRenameLocation(u.URI.revive(K),Z,se),void 0)}registerDocumentSemanticTokensProvider(z,K,Z,se){const G=this._nextHandle(),ie=typeof Z.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(G,new Je(new V(this._documents,Z),z)),this._proxy.$registerDocumentSemanticTokensProvider(G,this._transformDocumentSelector(K),se,ie);let de=this._createDisposable(G);if(ie){const Pe=Z.onDidChangeSemanticTokens(Ne=>this._proxy.$emitDocumentSemanticTokensEvent(ie));de=P.Disposable.from(de,Pe)}return de}$provideDocumentSemanticTokens(z,K,Z,se){return this._withAdapter(z,V,G=>G.provideDocumentSemanticTokens(u.URI.revive(K),Z,se),null,!0)}$releaseDocumentSemanticTokens(z,K){this._withAdapter(z,V,Z=>Z.releaseDocumentSemanticColoring(K),void 0)}registerDocumentRangeSemanticTokensProvider(z,K,Z,se){const G=this._addNewAdapter(new W(this._documents,Z),z);return this._proxy.$registerDocumentRangeSemanticTokensProvider(G,this._transformDocumentSelector(K),se),this._createDisposable(G)}$provideDocumentRangeSemanticTokens(z,K,Z,se){return this._withAdapter(z,W,G=>G.provideDocumentRangeSemanticTokens(u.URI.revive(K),Z,se),null,!0)}registerCompletionItemProvider(z,K,Z,se){const G=this._addNewAdapter(new $(this._documents,this._commands.converter,Z,this._apiDeprecation,z),z);return this._proxy.$registerSuggestSupport(G,this._transformDocumentSelector(K),se,$.supportsResolving(Z),`${z.identifier.value}(${se.join("")})`),this._createDisposable(G)}$provideCompletionItems(z,K,Z,se,G){return this._withAdapter(z,$,ie=>ie.provideCompletionItems(u.URI.revive(K),Z,se,G),void 0)}$resolveCompletionItem(z,K,Z){return this._withAdapter(z,$,se=>se.resolveCompletionItem(K,Z),void 0)}$releaseCompletionItems(z,K){this._withAdapter(z,$,Z=>Z.releaseCompletionItems(K),void 0)}registerInlineCompletionsProvider(z,K,Z){const se=this._addNewAdapter(new X(this._documents,Z,this._commands.converter),z);return this._proxy.$registerInlineCompletionsSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideInlineCompletions(z,K,Z,se,G){return this._withAdapter(z,X,ie=>ie.provideInlineCompletions(u.URI.revive(K),Z,se,G),void 0)}$handleInlineCompletionDidShow(z,K,Z){this._withAdapter(z,X,async se=>{se.handleDidShowCompletionItem(K,Z)},void 0)}$freeInlineCompletionsList(z,K){this._withAdapter(z,X,async Z=>{Z.disposeCompletions(K)},void 0)}registerSignatureHelpProvider(z,K,Z,se){const G=Array.isArray(se)?{triggerCharacters:se,retriggerCharacters:[]}:se,ie=this._addNewAdapter(new Q(this._documents,Z),z);return this._proxy.$registerSignatureHelpProvider(ie,this._transformDocumentSelector(K),G),this._createDisposable(ie)}$provideSignatureHelp(z,K,Z,se,G){return this._withAdapter(z,Q,ie=>ie.provideSignatureHelp(u.URI.revive(K),Z,se,G),void 0)}$releaseSignatureHelp(z,K){this._withAdapter(z,Q,Z=>Z.releaseSignatureHelp(K),void 0)}registerInlayHintsProvider(z,K,Z){const se=typeof Z.onDidChangeInlayHints=="function"?this._nextHandle():void 0,G=this._addNewAdapter(new ae(this._documents,Z),z);this._proxy.$registerInlayHintsProvider(G,this._transformDocumentSelector(K),se);let ie=this._createDisposable(G);if(se!==void 0){const de=Z.onDidChangeInlayHints(Pe=>this._proxy.$emitInlayHintsEvent(se));ie=P.Disposable.from(ie,de)}return ie}$provideInlayHints(z,K,Z,se){return this._withAdapter(z,ae,G=>G.provideInlayHints(u.URI.revive(K),Z,se),void 0)}registerDocumentLinkProvider(z,K,Z){const se=this._addNewAdapter(new pe(this._documents,Z),z);return this._proxy.$registerDocumentLinkProvider(se,this._transformDocumentSelector(K),typeof Z.resolveDocumentLink=="function"),this._createDisposable(se)}$provideDocumentLinks(z,K,Z){return this._withAdapter(z,pe,se=>se.provideLinks(u.URI.revive(K),Z),void 0)}$resolveDocumentLink(z,K,Z){return this._withAdapter(z,pe,se=>se.resolveLink(K,Z),void 0)}$releaseDocumentLinks(z,K){this._withAdapter(z,pe,Z=>Z.releaseLinks(K),void 0)}registerColorProvider(z,K,Z){const se=this._addNewAdapter(new ce(this._documents,Z),z);return this._proxy.$registerDocumentColorProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideDocumentColors(z,K,Z){return this._withAdapter(z,ce,se=>se.provideColors(u.URI.revive(K),Z),[])}$provideColorPresentations(z,K,Z,se){return this._withAdapter(z,ce,G=>G.provideColorPresentations(u.URI.revive(K),Z,se),void 0)}registerFoldingRangeProvider(z,K,Z){const se=this._nextHandle(),G=typeof Z.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(se,new Je(new Fe(this._documents,Z),z)),this._proxy.$registerFoldingRangeProvider(se,this._transformDocumentSelector(K),G);let ie=this._createDisposable(se);if(G!==void 0){const de=Z.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(G));ie=P.Disposable.from(ie,de)}return ie}$provideFoldingRanges(z,K,Z,se){return this._withAdapter(z,Fe,G=>G.provideFoldingRanges(u.URI.revive(K),Z,se),void 0)}registerSelectionRangeProvider(z,K,Z){const se=this._addNewAdapter(new Qe(this._documents,Z,this._logService),z);return this._proxy.$registerSelectionRangeProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideSelectionRanges(z,K,Z,se){return this._withAdapter(z,Qe,G=>G.provideSelectionRanges(u.URI.revive(K),Z,se),[])}registerCallHierarchyProvider(z,K,Z){const se=this._addNewAdapter(new Oe(this._documents,Z),z);return this._proxy.$registerCallHierarchyProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$prepareCallHierarchy(z,K,Z,se){return this._withAdapter(z,Oe,G=>Promise.resolve(G.prepareSession(u.URI.revive(K),Z,se)),void 0)}$provideCallHierarchyIncomingCalls(z,K,Z,se){return this._withAdapter(z,Oe,G=>G.provideCallsTo(K,Z,se),void 0)}$provideCallHierarchyOutgoingCalls(z,K,Z,se){return this._withAdapter(z,Oe,G=>G.provideCallsFrom(K,Z,se),void 0)}$releaseCallHierarchy(z,K){this._withAdapter(z,Oe,Z=>Promise.resolve(Z.releaseSession(K)),void 0)}registerTypeHierarchyProvider(z,K,Z){const se=this._addNewAdapter(new He(this._documents,Z),z);return this._proxy.$registerTypeHierarchyProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$prepareTypeHierarchy(z,K,Z,se){return this._withAdapter(z,He,G=>Promise.resolve(G.prepareSession(u.URI.revive(K),Z,se)),void 0)}$provideTypeHierarchySupertypes(z,K,Z,se){return this._withAdapter(z,He,G=>G.provideSupertypes(K,Z,se),void 0)}$provideTypeHierarchySubtypes(z,K,Z,se){return this._withAdapter(z,He,G=>G.provideSubtypes(K,Z,se),void 0)}$releaseTypeHierarchy(z,K){this._withAdapter(z,He,Z=>Promise.resolve(Z.releaseSession(K)),void 0)}static _serializeRegExp(z){return{pattern:z.source,flags:(0,T.regExpFlags)(z)}}static _serializeIndentationRule(z){return{decreaseIndentPattern:Ye._serializeRegExp(z.decreaseIndentPattern),increaseIndentPattern:Ye._serializeRegExp(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?Ye._serializeRegExp(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?Ye._serializeRegExp(z.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(z){return{beforeText:Ye._serializeRegExp(z.beforeText),afterText:z.afterText?Ye._serializeRegExp(z.afterText):void 0,previousLineText:z.previousLineText?Ye._serializeRegExp(z.previousLineText):void 0,action:z.action}}static _serializeOnEnterRules(z){return z.map(Ye._serializeOnEnterRule)}setLanguageConfiguration(z,K,Z){let{wordPattern:se}=Z;if(se&&(0,T.regExpLeadsToEndlessLoop)(se))throw new Error(`Invalid language configuration: wordPattern '${se}' is not allowed to match the empty string.`);se?this._documents.setWordDefinitionFor(K,se):this._documents.setWordDefinitionFor(K,void 0),Z.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),Z.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const G=this._nextHandle(),ie={comments:Z.comments,brackets:Z.brackets,wordPattern:Z.wordPattern?Ye._serializeRegExp(Z.wordPattern):void 0,indentationRules:Z.indentationRules?Ye._serializeIndentationRule(Z.indentationRules):void 0,onEnterRules:Z.onEnterRules?Ye._serializeOnEnterRules(Z.onEnterRules):void 0,__electricCharacterSupport:Z.__electricCharacterSupport,__characterPairSupport:Z.__characterPairSupport};return this._proxy.$setLanguageConfiguration(G,K,ie),this._createDisposable(G)}$setWordDefinitions(z){for(const K of z)this._documents.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.ExtHostLanguageFeatures=Ye,Ye._handlePool=0}),define(we[199],be([0,1,5,8,7,36,13,6]),function(re,e,u,M,E,P,F,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class C{constructor(t,_,i,m){this._documents=_,this._commands=i,this._uriTransformer=m,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=t.getProxy(u.MainContext.MainThreadLanguages)}$acceptLanguageIds(t){this._languageIds=t}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(t,_){await this._proxy.$changeLanguage(t,_);const i=this._documents.getDocumentData(t);if(!i)throw new Error(`document '${t.toString}' NOT found`);return i.document}async tokenAtPosition(t,_){const i=t.version,m=M.Position.from(_),a=await this._proxy.$tokensAtPosition(t.uri,m),f={type:E.StandardTokenType.Other,range:t.getWordRangeAtPosition(_)??new E.Range(_.line,_.character,_.line,_.character)};if(!a)return f;const p={range:M.Range.to(a.range),type:M.TokenType.to(a.type)};return!p.range.contains(_)||i!==t.version?f:p}createLanguageStatusItem(t,_,i){const m=this._handlePool++,a=this._proxy,f=this._ids,p=`${t.identifier.value}/${_}`;if(f.has(p))throw new Error(`LanguageStatusItem with id '${_}' ALREADY exists`);f.add(p);const S={selector:i,id:_,name:t.displayName??t.name,severity:E.LanguageStatusSeverity.Information,command:void 0,text:"",detail:""};let v,o=new T.DisposableStore;const d=()=>{v?.dispose(),v=(0,F.disposableTimeout)(()=>{o.clear(),this._proxy.$setLanguageStatus(m,{id:p,name:S.name??t.displayName??t.name,source:t.displayName??t.name,selector:M.DocumentSelector.from(S.selector,this._uriTransformer),label:S.text,detail:S.detail??"",severity:S.severity===E.LanguageStatusSeverity.Error?P.default.Error:S.severity===E.LanguageStatusSeverity.Warning?P.default.Warning:P.default.Info,command:S.command&&this._commands.toInternal(S.command,o),accessibilityInfo:S.accessibilityInformation})},0)},D={dispose(){o.dispose(),v?.dispose(),a.$removeLanguageStatus(m),f.delete(p)},get id(){return S.id},get name(){return S.name},set name(r){S.name=r,d()},get selector(){return S.selector},set selector(r){S.selector=r,d()},get text(){return S.text},set text(r){S.text=r,d()},get detail(){return S.detail},set detail(r){S.detail=r,d()},get severity(){return S.severity},set severity(r){S.severity=r,d()},get accessibilityInformation(){return S.accessibilityInformation},set accessibilityInformation(r){S.accessibilityInformation=r,d()},get command(){return S.command},set command(r){S.command=r,d()}};return d(),D}}e.ExtHostLanguages=C}),define(we[200],be([0,1,12,5,27,14,3]),function(re,e,u,M,E,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let T=class extends u.AbstractLoggerService{constructor(t,_){const i=new F.Emitter;super(_.logLevel,i.event);this._proxy=t.getProxy(M.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(i)}$setLevel(t){this._onDidChangeLogLevel.fire(t)}doCreateLogger(t,_,i){return new C(this._proxy,t,_,i)}};T=Ue([Be(0,P.IExtHostRpcService),Be(1,E.IExtHostInitDataService)],T),e.ExtHostLoggerService=T;class C extends u.AbstractMessageLogger{constructor(t,_,i,m){super(m?.always);this.proxy=t,this.file=_,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(i),this.proxy.$createLogger(_,m).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(t,_){const i=[[t,_]];this.isLoggerCreated?this.doLog(i):this.buffer.push(...i)}doLog(t){this.proxy.$log(this.file,t)}}}),define(we[201],be([0,1,5,12,30]),function(re,e,u,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function P(T){return T&&T.title}let F=class{constructor(C,A){this._logService=A,this._proxy=C.getProxy(u.MainContext.MainThreadMessageService)}showMessage(C,A,t,_,i){const m={extension:C};let a;typeof _=="string"||P(_)?a=[_,...i]:(m.modal=_?.modal,m.useCustom=_?.useCustom,m.detail=_?.detail,a=i),m.useCustom&&(0,E.checkProposedApiEnabled)(C);const f=[];for(let p=0;p<a.length;p++){const S=a[p];if(typeof S=="string")f.push({title:S,handle:p,isCloseAffordance:!1});else if(typeof S=="object"){let{title:v,isCloseAffordance:o}=S;f.push({title:v,isCloseAffordance:!!o,handle:p})}else this._logService.warn("Invalid message item:",S)}return this._proxy.$showMessage(A,t,m,f).then(p=>{if(typeof p=="number")return a[p]})}};F=Ue([Be(1,M.ILogService)],F),e.ExtHostMessageService=F}),define(we[202],be([0,1,22,3,60,6,20,9,10,2,65,5,8,7,39,176,93]),function(re,e,u,M,E,P,F,T,C,A,t,_,i,m,a,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class S{constructor(o,d,D,r,w){this._textDocumentsAndEditors=D,this._textDocuments=r,this._extensionStoragePaths=w,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new F.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new M.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new M.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new M.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new M.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new M.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new M.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new M.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new t.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=o.getProxy(_.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=o.getProxy(_.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=o.getProxy(_.MainContext.MainThreadNotebookEditors),this._commandsConverter=d.converter,d.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===12){const n=s.notebookEditor?.notebookUri,g=s.cell.handle,c=this._documents.get(n)?.getCell(g);if(c)return c.apiCell}return s}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(o=>o.apiEditor)}getEditorById(o){const d=this._editors.get(o);if(!d)throw new Error(`unknown text editor: ${o}. known editors: ${[...this._editors.keys()]} `);return d}getIdByEditor(o){for(const[d,D]of this._editors)if(D.apiEditor===o)return d}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(o,d){const D=this._documents.get(o);if(!D&&!d)throw new Error(`NO notebook document for '${o}'`);return D}_getProviderData(o){const d=this._notebookContentProviders.get(o);if(!d)throw new Error(`NO provider for '${o}'`);return d}registerNotebookContentProvider(o,d,D,r,w){if((0,T.isFalsyOrWhitespace)(d))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(d))throw new Error(`Notebook provider for '${d}' already registered`);this._notebookContentProviders.set(d,{extension:o,provider:D});let s;return D.onDidChangeNotebookContentOptions&&(s=D.onDidChangeNotebookContentOptions(()=>{const n=i.NotebookDocumentContentOptions.from(D.options);this._notebookProxy.$updateNotebookProviderOptions(d,n)})),this._notebookProxy.$registerNotebookProvider({id:o.identifier,location:o.extensionLocation},d,i.NotebookDocumentContentOptions.from(r),S._convertNotebookRegistrationData(o,w)),new m.Disposable(()=>{s?.dispose(),this._notebookContentProviders.delete(d),this._notebookProxy.$unregisterNotebookProvider(d)})}static _convertNotebookRegistrationData(o,d){if(!d)return;const D=d.filenamePattern.map(r=>i.NotebookExclusiveDocumentPattern.from(r)).filter(r=>r!==void 0);if(d.filenamePattern&&!D){console.warn(`Notebook content provider view options file name pattern is invalid ${d.filenamePattern}`);return}return{extension:o.identifier,providerDisplayName:o.displayName||o.name,displayName:d.displayName,filenamePattern:D,exclusive:d.exclusive||!1}}registerNotebookCellStatusBarItemProvider(o,d,D){const r=S._notebookStatusBarItemProviderHandlePool++,w=typeof D.onDidChangeCellStatusBarItems=="function"?S._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(r,D),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(r,w,d);let s;return w!==void 0&&(s=D.onDidChangeCellStatusBarItems(n=>this._notebookProxy.$emitCellStatusBarEvent(w))),new m.Disposable(()=>{this._notebookStatusBarItemProviders.delete(r),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(r,w),s&&s.dispose()})}async createNotebookDocument(o){const d=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:o.viewType,content:o.content&&i.NotebookData.from(o.content)});return A.URI.revive(d)}async openNotebookDocument(o){const d=this._documents.get(o);if(d)return d.apiNotebook;const D=await this._notebookDocumentsProxy.$tryOpenNotebook(o),r=this._documents.get(A.URI.revive(D));return(0,C.assertIsDefined)(r?.apiNotebook)}async showNotebookDocument(o,d){A.URI.isUri(o)&&(o=await this.openNotebookDocument(o));let D;typeof d=="object"?D={position:i.ViewColumn.from(d.viewColumn),preserveFocus:d.preserveFocus,selections:d.selections&&d.selections.map(i.NotebookRange.from),pinned:typeof d.preview=="boolean"?!d.preview:void 0}:D={preserveFocus:!1};const r=await this._notebookEditorsProxy.$tryShowNotebookDocument(o.uri,o.notebookType,D),w=r&&this._editors.get(r)?.apiEditor;if(w)return w;throw r?new Error(`Could NOT open editor for "${o.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${o.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(o,d,D,r){const w=this._notebookStatusBarItemProviders.get(o),s=A.URI.revive(d),n=this._documents.get(s);if(!n||!w)return;const g=n.getCellFromIndex(D);if(!g)return;const l=await w.provideCellStatusBarItems(g.apiCell,r);if(!l)return;const c=new P.DisposableStore,b=this._statusBarCache.add([c]),y=(Array.isArray(l)?l:[l]).map(R=>i.NotebookStatusBarItem.from(R,this._commandsConverter,c));return{cacheId:b,items:y}}$releaseNotebookCellStatusBarItems(o){this._statusBarCache.delete(o)}registerNotebookSerializer(o,d,D,r,w){if((0,T.isFalsyOrWhitespace)(d))throw new Error("viewType cannot be empty or just whitespace");const s=this._handlePool++;return this._notebookSerializer.set(s,D),this._notebookProxy.$registerNotebookSerializer(s,{id:o.identifier,location:o.extensionLocation},d,i.NotebookDocumentContentOptions.from(r),S._convertNotebookRegistrationData(o,w)),(0,P.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(s)})}async $dataToNotebook(o,d,D){const r=this._notebookSerializer.get(o);if(!r)throw new Error("NO serializer found");const w=await r.deserializeNotebook(d.buffer,D);return new a.SerializableObjectWithBuffers(i.NotebookData.from(w))}async $notebookToData(o,d,D){const r=this._notebookSerializer.get(o);if(!r)throw new Error("NO serializer found");const w=await r.serializeNotebook(i.NotebookData.to(d.value),D);return u.VSBuffer.wrap(w)}async $openNotebook(o,d,D,r,w){const{provider:s}=this._getProviderData(o),n=await s.openNotebook(A.URI.revive(d),{backupId:D,untitledDocumentData:r?.buffer},w);return new a.SerializableObjectWithBuffers({metadata:n.metadata??Object.create(null),cells:n.cells.map(i.NotebookCellData.from)})}async $saveNotebook(o,d,D){const r=this.getNotebookDocument(A.URI.revive(d)),{provider:w}=this._getProviderData(o);return await w.saveNotebook(r.apiNotebook,D),!0}async $saveNotebookAs(o,d,D,r){const w=this.getNotebookDocument(A.URI.revive(d)),{provider:s}=this._getProviderData(o);return await s.saveNotebookAs(A.URI.revive(D),w.apiNotebook,r),!0}async $backupNotebook(o,d,D){const r=this.getNotebookDocument(A.URI.revive(d)),w=this._getProviderData(o),s=this._extensionStoragePaths.workspaceValue(w.extension)??this._extensionStoragePaths.globalValue(w.extension),n=String((0,E.hash)([r.uri.toString(),this._backupIdPool++])),g=A.URI.joinPath(s,n),l=await w.provider.backupNotebook(r.apiNotebook,{destination:g},D);return r.updateBackup(l),l.id}_createExtHostEditor(o,d,D){if(this._editors.has(d))throw new Error(`editor with id ALREADY EXSIST: ${d}`);const r=new p.ExtHostNotebookEditor(d,this._notebookEditorsProxy,o,D.visibleRanges.map(i.NotebookRange.to),D.selections.map(i.NotebookRange.to),typeof D.viewColumn=="number"?i.ViewColumn.to(D.viewColumn):void 0);this._editors.set(d,r)}$acceptDocumentAndEditorsDelta(o){if(o.value.removedDocuments)for(const D of o.value.removedDocuments){const r=A.URI.revive(D),w=this._documents.get(r);w&&(w.dispose(),this._documents.delete(r),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:w.apiNotebook.getCells().map(s=>s.document.uri)}),this._onDidCloseNotebookDocument.fire(w.apiNotebook));for(const s of this._editors.values())s.notebookData.uri.toString()===r.toString()&&this._editors.delete(s.id)}if(o.value.addedDocuments){const D=[];for(const r of o.value.addedDocuments){const w=A.URI.revive(r.uri);if(this._documents.has(w))throw new Error(`adding EXISTING notebook ${w} `);const s=this,n=new f.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(g){s._onDidChangeNotebookCells.fire(g)},emitCellOutputsChange(g){s._onDidChangeCellOutputs.fire(g)},emitCellMetadataChange(g){s._onDidChangeCellMetadata.fire(g)},emitCellExecutionStateChange(g){s._onDidChangeCellExecutionState.fire(g)}},w,r);D.push(...r.cells.map(g=>f.ExtHostCell.asModelAddData(n.apiNotebook,g))),this._documents.get(w)?.dispose(),this._documents.set(w,n),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:D}),this._onDidOpenNotebookDocument.fire(n.apiNotebook)}}if(o.value.addedEditors)for(const D of o.value.addedEditors){if(this._editors.has(D.id))return;const r=A.URI.revive(D.documentUri),w=this._documents.get(r);w&&this._createExtHostEditor(w,D.id,D)}const d=[];if(o.value.removedEditors)for(const D of o.value.removedEditors){const r=this._editors.get(D);r&&(this._editors.delete(D),this._activeNotebookEditor?.id===r.id&&(this._activeNotebookEditor=void 0),d.push(r))}if(o.value.visibleEditors){this._visibleNotebookEditors=o.value.visibleEditors.map(r=>this._editors.get(r)).filter(r=>!!r);const D=new Set;this._visibleNotebookEditors.forEach(r=>D.add(r.id));for(const r of this._editors.values()){const w=D.has(r.id);r._acceptVisibility(w)}this._visibleNotebookEditors=[...this._editors.values()].map(r=>r).filter(r=>r.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}o.value.newActiveEditor===null?this._activeNotebookEditor=void 0:o.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(o.value.newActiveEditor)),o.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=S,S._notebookStatusBarItemProviderHandlePool=0}),define(we[203],be([0,1,3,56,12,5,14,8]),function(re,e,u,M,E,P,F,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class C{constructor(_,i){const m=C._Keys.nextId();_.$registerNotebookEditorDecorationType(m,T.NotebookDecorationRenderOptions.from(i)),this.value={key:m,dispose(){_.$removeNotebookEditorDecorationType(m)}}}}C._Keys=new M.IdGenerator("NotebookEditorDecorationType");let A=class{constructor(_,i,m){this._logService=_,this._extHostRpc=i,this._notebooksAndEditors=m,this._onDidChangeNotebookEditorSelection=new u.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new u.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(_){return new C(this._extHostRpc.getProxy(P.MainContext.MainThreadNotebookEditors),_).value}$acceptEditorPropertiesChanged(_,i){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",_,i);const m=this._notebooksAndEditors.getEditorById(_);i.visibleRanges&&m._acceptVisibleRanges(i.visibleRanges.ranges.map(T.NotebookRange.to)),i.selections&&m._acceptSelections(i.selections.selections.map(T.NotebookRange.to)),i.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:m.apiEditor,visibleRanges:m.apiEditor.visibleRanges}),i.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:m.apiEditor,selections:m.apiEditor.selections}))}$acceptEditorViewColumns(_){for(const i in _)this._notebooksAndEditors.getEditorById(i)._acceptViewColumn(T.ViewColumn.to(_[i]))}};A=Ue([Be(0,E.ILogService),Be(1,F.IExtHostRpcService)],A),e.ExtHostNotebookEditors=A}),define(we[204],be([0,1,15,13,21,3,6,20,2,26,12,5,40,8,7,68,168,30,39]),function(re,e,u,M,E,P,F,T,C,A,t,_,i,m,a,f,p,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let o=class{constructor(s,n,g,l,c){this._initData=n,this._extHostNotebook=g,this._commands=l,this._logService=c,this._activeExecutions=new T.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=s.getProxy(_.MainContext.MainThreadNotebookKernels);const b=new i.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new i.ApiCommandArgument("options","Select kernel options",h=>!0,h=>{if(h&&"notebookEditor"in h&&"id"in h){const y=this._extHostNotebook.getIdByEditor(h.notebookEditor);return{id:h.id,extension:h.extension,notebookEditorId:y}}else if(h&&"notebookEditor"in h){const y=this._extHostNotebook.getIdByEditor(h.notebookEditor);if(y===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${h.notebookEditor.document.uri.toString()}`);return{notebookEditorId:y}}return h})],i.ApiCommandResult.Void);this._commands.registerApiCommand(b)}createNotebookController(s,n,g,l,c,b){for(let Q of this._kernelData.values())if(Q.controller.id===n&&A.ExtensionIdentifier.equals(s.identifier,Q.extensionId))throw new Error(`notebook controller with id '${n}' ALREADY exist`);const h=this._handlePool++,y=this;this._logService.trace(`NotebookController[${h}], CREATED by ${s.identifier.value}, ${n}`);const R=()=>console.warn(`NO execute handler from notebook controller '${x.id}' of extension: '${s.identifier}'`);let I=!1;const B=new F.DisposableStore,L=new P.Emitter,k=new P.Emitter,x={id:`${s.identifier.value}/${n}`,notebookType:g,extensionId:s.identifier,extensionLocation:s.extensionLocation,label:l||s.identifier.value,preloads:b?b.map(m.NotebookRendererScript.from):[]};let N=c??R,V;this._proxy.$addKernel(h,x).catch(Q=>{console.log(Q),I=!0});let W=0;const $=()=>{if(I)return;const Q=++W;Promise.resolve().then(()=>{Q===W&&this._proxy.$updateKernel(h,x)})},X=new T.ResourceMap,j={get id(){return n},get notebookType(){return x.notebookType},onDidChangeSelectedNotebooks:L.event,get label(){return x.label},set label(Q){x.label=Q??s.displayName??s.name,$()},get detail(){return x.detail??""},set detail(Q){x.detail=Q,$()},get description(){return x.description??""},set description(Q){x.description=Q,$()},get kind(){return(0,S.checkProposedApiEnabled)(s),x.kind??""},set kind(Q){(0,S.checkProposedApiEnabled)(s),x.kind=Q,$()},get supportedLanguages(){return x.supportedLanguages},set supportedLanguages(Q){x.supportedLanguages=Q,$()},get supportsExecutionOrder(){return x.supportsExecutionOrder??!1},set supportsExecutionOrder(Q){x.supportsExecutionOrder=Q,$()},get rendererScripts(){return x.preloads?x.preloads.map(m.NotebookRendererScript.to):[]},get executeHandler(){return N},set executeHandler(Q){N=Q??R},get interruptHandler(){return V},set interruptHandler(Q){V=Q,x.supportsInterrupt=Boolean(Q),$()},createNotebookCellExecution(Q){if(I)throw new Error("notebook controller is DISPOSED");if(!X.has(Q.notebook.uri))throw y._logService.trace(`NotebookController[${h}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(X.keys()).map(ae=>ae.toString())),new Error(`notebook controller is NOT associated to notebook: ${Q.notebook.uri.toString()}`);return y._createNotebookCellExecution(Q)},dispose:()=>{I||(this._logService.trace(`NotebookController[${h}], DISPOSED`),I=!0,this._kernelData.delete(h),B.dispose(),L.dispose(),k.dispose(),this._proxy.$removeKernel(h))},updateNotebookAffinity(Q,ae){y._proxy.$updateNotebookPriority(h,Q.uri,ae)},onDidReceiveMessage:k.event,postMessage(Q,ae){return(0,S.checkProposedApiEnabled)(s),y._proxy.$postMessage(h,ae&&y._extHostNotebook.getIdByEditor(ae),Q)},asWebviewUri(Q){return(0,S.checkProposedApiEnabled)(s),(0,f.asWebviewUri)(Q,y._initData.remote)}};return this._kernelData.set(h,{extensionId:s.identifier,controller:j,onDidReceiveMessage:k,onDidChangeSelection:L,associatedNotebooks:X}),j}$acceptNotebookAssociation(s,n,g){const l=this._kernelData.get(s);if(l){const c=this._extHostNotebook.getNotebookDocument(C.URI.revive(n));g?l.associatedNotebooks.set(c.uri,!0):l.associatedNotebooks.delete(c.uri),this._logService.trace(`NotebookController[${s}] ASSOCIATE notebook`,c.uri.toString(),g),l.onDidChangeSelection.fire({selected:g,notebook:c.apiNotebook})}}async $executeCells(s,n,g){const l=this._kernelData.get(s);if(!l)return;const c=this._extHostNotebook.getNotebookDocument(C.URI.revive(n)),b=[];for(let h of g){const y=c.getCell(h);y&&b.push(y.apiCell)}try{this._logService.trace(`NotebookController[${s}] EXECUTE cells`,c.uri.toString(),b.length),await l.controller.executeHandler.call(l.controller,b,c.apiNotebook,l.controller)}catch(h){this._logService.error(`NotebookController[${s}] execute cells FAILED`,h),console.error(h)}}async $cancelCells(s,n,g){const l=this._kernelData.get(s);if(!l)return;const c=this._extHostNotebook.getNotebookDocument(C.URI.revive(n));if(l.controller.interruptHandler)await l.controller.interruptHandler.call(l.controller,c.apiNotebook);else for(let b of g){const h=c.getCell(b);h&&this._activeExecutions.get(h.uri)?.cancel()}}$acceptKernelMessageFromRenderer(s,n,g){const l=this._kernelData.get(s);if(!l)return;const c=this._extHostNotebook.getEditorById(n);l.onDidReceiveMessage.fire(Object.freeze({editor:c.apiEditor,message:g}))}_createNotebookCellExecution(s){if(s.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const g=this._extHostNotebook.getNotebookDocument(s.notebook.uri).getCellFromApiCell(s);if(!g)throw new Error("invalid cell");if(this._activeExecutions.has(g.uri))throw new Error(`duplicate execution for ${g.uri}`);const l=new D(g.notebook,g,this._proxy);this._activeExecutions.set(g.uri,l);const c=l.onDidChangeState(()=>{l.state===d.Resolved&&(l.dispose(),c.dispose(),this._activeExecutions.delete(g.uri))});return l.asApiObject()}};o=Ue([Be(4,t.ILogService)],o),e.ExtHostNotebookKernels=o;var d;(function(w){w[w.Init=0]="Init",w[w.Started=1]="Started",w[w.Resolved=2]="Resolved"})(d||(d={}));class D extends F.Disposable{constructor(s,n,g){super();this._document=s,this._cell=n,this._proxy=g,this._handle=D.HANDLE++,this._onDidChangeState=new P.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=d.Init,this._tokenSource=this._register(new E.CancellationTokenSource),this._collector=new r(10,l=>this.update(l)),this._executionOrder=n.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(s){await this._collector.addItem(s)}async update(s){const n=Array.isArray(s)?s:[s];return this._proxy.$updateExecutions(new v.SerializableObjectWithBuffers(n))}verifyStateForOutput(){if(this._state===d.Init)throw new Error("Must call start before modifying cell output");if(this._state===d.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(s){let n=this._cell;if(s&&(n=this._document.getCellFromApiCell(s)),!n)throw new Error("INVALID cell");return n.handle}validateAndConvertOutputs(s){return s.map(n=>{const g=a.NotebookCellOutput.ensureUniqueMimeTypes(n.items,!0);return g===n.items?m.NotebookCellOutput.from(n):m.NotebookCellOutput.from({items:g,id:n.id,metadata:n.metadata})})}async updateOutputs(s,n,g){const l=this.cellIndexToHandle(n),c=this.validateAndConvertOutputs((0,u.asArray)(s));return this.updateSoon({editType:p.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:l,append:g,outputs:c})}async updateOutputItems(s,n,g){return s=a.NotebookCellOutput.ensureUniqueMimeTypes((0,u.asArray)(s),!0),this.updateSoon({editType:p.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:s.map(m.NotebookCellOutputItem.from),outputId:n.id,append:g})}asApiObject(){const s=this;return Object.freeze({get token(){return s._tokenSource.token},get cell(){return s._cell.apiCell},get executionOrder(){return s._executionOrder},set executionOrder(g){s._executionOrder=g,s.update([{editType:p.CellExecutionUpdateType.ExecutionState,executionHandle:s._handle,executionOrder:s._executionOrder}])},start(g){if(s._state===d.Resolved||s._state===d.Started)throw new Error("Cannot call start again");s._state=d.Started,s._onDidChangeState.fire(),s.update({editType:p.CellExecutionUpdateType.ExecutionState,executionHandle:s._handle,runStartTime:g})},end(g,l){if(s._state===d.Resolved)throw new Error("Cannot call resolve twice");s._state=d.Resolved,s._onDidChangeState.fire(),s.updateSoon({editType:p.CellExecutionUpdateType.Complete,executionHandle:s._handle,runEndTime:l,lastRunSuccess:g}),s._collector.flush(),s._proxy.$removeExecution(s._handle)},clearOutput(g){return s.verifyStateForOutput(),s.updateOutputs([],g,!1)},appendOutput(g,l){return s.verifyStateForOutput(),s.updateOutputs(g,l,!0)},replaceOutput(g,l){return s.verifyStateForOutput(),s.updateOutputs(g,l,!1)},appendOutputItems(g,l){return s.verifyStateForOutput(),s.updateOutputItems(g,l,!0)},replaceOutputItems(g,l){return s.verifyStateForOutput(),s.updateOutputItems(g,l,!1)}})}}D.HANDLE=0;class r{constructor(s,n){this.delay=s,this.callback=n,this.batch=[],this.startedTimer=Date.now()}addItem(s){return this.batch.push(s),this.currentDeferred||(this.currentDeferred=new M.DeferredPromise,this.startedTimer=Date.now(),(0,M.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const s=this.currentDeferred;this.currentDeferred=void 0;const n=this.batch;return this.batch=[],this.callback(n).finally(()=>s.complete())}}}),define(we[205],be([0,1,3,5,93]),function(re,e,u,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class P{constructor(T,C){this._extHostNotebook=C,this._rendererMessageEmitters=new Map,this.proxy=T.getProxy(M.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(T,C,A){const t=this._extHostNotebook.getEditorById(T);this._rendererMessageEmitters.get(C)?.fire({editor:t.apiEditor,message:A})}createRendererMessaging(T,C){if(!T.contributes?.notebookRenderer?.some(i=>i.id===C))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${C})`);const A=!!T.enableProposedApi,t=new WeakMap;return{onDidReceiveMessage:(i,m,a)=>{const f=A?i:p=>{const S={};t.set(S,p.editor),i({editor:S,message:p.message})};return this.getOrCreateEmitterFor(C).event(f,m,a)},postMessage:(i,m)=>{E.ExtHostNotebookEditor.apiEditorsToExtHost.has(i)&&([i,m]=[m,i]);const a=A?m:t.get(m),f=a&&E.ExtHostNotebookEditor.apiEditorsToExtHost.get(a);return this.proxy.$postMessage(f?.id,C,i)}}}getOrCreateEmitterFor(T){let C=this._rendererMessageEmitters.get(T);return C||(C=new u.Emitter({onLastListenerRemove:()=>{C?.dispose(),this._rendererMessageEmitters.delete(T)}}),this._rendererMessageEmitters.set(T,C),C)}}e.ExtHostNotebookRenderers=P}),define(we[96],be([0,1,5,6,4,14,30,12,169,52,27,31,115,22]),function(re,e,u,M,E,P,F,T,C,A,t,_,i,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class a extends M.Disposable{constructor(S,v,o,d){super();this.id=S,this.name=v,this.logger=o,this.proxy=d,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(S){this.append(S+`
`)}append(S){this.write(S),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,C.OutputChannelUpdateMode.Append))}clear(){const S=this.offset;this.logger.flush(),this.proxy.$update(this.id,C.OutputChannelUpdateMode.Clear,S)}replace(S){const v=this.offset;this.write(S),this.proxy.$update(this.id,C.OutputChannelUpdateMode.Replace,v),this.visible&&this.logger.flush()}show(S,v){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof S=="boolean"?S:v))}hide(){this.proxy.$close(this.id)}write(S){this.offset+=m.VSBuffer.fromString(S).byteLength,this.logger.info(S)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=a;let f=class{constructor(S,v,o,d,D){this.extHostFileSystem=o,this.extHostFileSystemInfo=d,this.loggerService=D,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=S.getProxy(u.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(v.logsLocation,`output_logging_${(0,i.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(S){this.visibleChannelId=S;for(const[v,o]of this.channels)o.visible=v===this.visibleChannelId}createOutputChannel(S,v){if(S=S.trim(),!S)throw new Error("illegal argument `name`. must not be falsy");const o=this.doCreateOutputChannel(S,v);return o.then(d=>{this.channels.set(d.id,d),d.visible=d.id===this.visibleChannelId}),this.createExtHostOutputChannel(S,o,v)}async doCreateOutputChannel(S,v){const o=await this.createOutputDirectory(),d=this.extHostFileSystemInfo.extUri.joinPath(o,`${this.namePool++}-${S.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),D=this.loggerService.createLogger(d,{always:!0,donotRotate:!0,donotUseFormatters:!0}),r=await this.proxy.$register(S,!1,d,v.identifier.value);return new a(r,S,D,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(S,v,o){const d=(D,r)=>{if(r&&(0,F.checkProposedApiEnabled)(o),D.disposed)throw new Error("Channel has been closed")};return{get name(){return S},append(D){v.then(r=>{d(r),r.append(D)})},appendLine(D){v.then(r=>{d(r),r.appendLine(D)})},clear(){v.then(D=>{d(D),D.clear()})},replace(D){v.then(r=>{d(r,!0),r.replace(D)})},show(D,r){v.then(w=>{d(w),w.show(D,r)})},hide(){v.then(D=>{d(D),D.hide()})},dispose(){v.then(D=>{d(D),D.dispose()})}}}};f=Ue([Be(0,P.IExtHostRpcService),Be(1,t.IExtHostInitDataService),Be(2,A.IExtHostConsumerFileSystem),Be(3,_.IExtHostFileSystemInfo),Be(4,T.ILoggerService)],f),e.ExtHostOutputService=f,e.IExtHostOutputService=(0,E.createDecorator)("IExtHostOutputService")}),define(we[206],be([0,1,13,21,3,6,5,2,7,16,15,36,48]),function(re,e,u,M,E,P,F,T,C,A,t,_,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function m(a,f,p){const S=a.getProxy(F.MainContext.MainThreadQuickOpen);class v{constructor(l,c){this._sessions=new Map,this._instances=0,this._workspace=l,this._commands=c}showQuickPick(l,c,b,h=M.CancellationToken.None){this._onDidSelectItem=void 0;const y=Promise.resolve(l),R=++this._instances,I=S.$show(R,{title:b?.title,placeHolder:b?.placeHolder,matchOnDescription:b?.matchOnDescription,matchOnDetail:b?.matchOnDetail,ignoreFocusLost:b?.ignoreFocusOut,canPickMany:b?.canPickMany},h),B={},L=I.then(()=>B);return Promise.race([L,y]).then(k=>{if(k!==B)return y.then(x=>{const N=[];for(let V=0;V<x.length;V++){const W=x[V];let $,X,j,Q,ae;typeof W=="string"?$=W:($=W.label,X=W.description,j=W.detail,Q=W.picked,ae=W.alwaysShow),N.push({label:$,description:X,handle:V,detail:j,picked:Q,alwaysShow:ae})}return b&&typeof b.onDidSelectItem=="function"&&(this._onDidSelectItem=V=>{b.onDidSelectItem(x[V])}),S.$setItems(R,N),I.then(V=>{if(typeof V=="number")return x[V];if(Array.isArray(V))return V.map(W=>x[W])})})}).then(void 0,k=>{if(!(0,A.isPromiseCanceledError)(k))return S.$setError(R,k),Promise.reject(k)})}$onItemSelected(l){this._onDidSelectItem&&this._onDidSelectItem(l)}showInput(l,c=M.CancellationToken.None){return this._validateInput=l?l.validateInput:void 0,S.$input(l,typeof this._validateInput=="function",c).then(void 0,b=>{if(!(0,A.isPromiseCanceledError)(b))return Promise.reject(b)})}$validateInput(l){return this._validateInput?(0,u.asPromise)(()=>this._validateInput(l)):Promise.resolve(void 0)}async showWorkspaceFolderPick(l,c=M.CancellationToken.None){const b=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[l]);if(!b)return;const h=await this._workspace.getWorkspaceFolders2();if(!!h)return h.find(y=>y.uri.toString()===b.uri.toString())}createQuickPick(l,c){const b=new s(l,c,()=>this._sessions.delete(b._id));return this._sessions.set(b._id,b),b}createInputBox(l){const c=new n(l,()=>this._sessions.delete(c._id));return this._sessions.set(c._id,c),c}$onDidChangeValue(l,c){const b=this._sessions.get(l);b&&b._fireDidChangeValue(c)}$onDidAccept(l){const c=this._sessions.get(l);c&&c._fireDidAccept()}$onDidChangeActive(l,c){const b=this._sessions.get(l);b instanceof s&&b._fireDidChangeActive(c)}$onDidChangeSelection(l,c){const b=this._sessions.get(l);b instanceof s&&b._fireDidChangeSelection(c)}$onDidTriggerButton(l,c){const b=this._sessions.get(l);b&&b._fireDidTriggerButton(c)}$onDidTriggerItemButton(l,c,b){const h=this._sessions.get(l);h instanceof s&&h._fireDidTriggerItemButton(c,b)}$onDidHide(l){const c=this._sessions.get(l);c&&c._fireDidHide()}}class o{constructor(l,c){this._extensionId=l,this._onDidDispose=c,this._id=s._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new E.Emitter,this._onDidChangeValueEmitter=new E.Emitter,this._onDidTriggerButtonEmitter=new E.Emitter,this._onDidHideEmitter=new E.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(l){this._title=l,this.update({title:l})}get step(){return this._steps}set step(l){this._steps=l,this.update({step:l})}get totalSteps(){return this._totalSteps}set totalSteps(l){this._totalSteps=l,this.update({totalSteps:l})}get enabled(){return this._enabled}set enabled(l){this._enabled=l,this.update({enabled:l})}get busy(){return this._busy}set busy(l){this._busy=l,this.update({busy:l})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(l){this._ignoreFocusOut=l,this.update({ignoreFocusOut:l})}get value(){return this._value}set value(l){this._value=l,this.update({value:l})}get placeholder(){return this._placeholder}set placeholder(l){this._placeholder=l,this.update({placeholder:l})}get buttons(){return this._buttons}set buttons(l){this._buttons=l.slice(),this._handlesToButtons.clear(),l.forEach((c,b)=>{const h=c===C.QuickInputButtons.Back?-1:b;this._handlesToButtons.set(h,c)}),this.update({buttons:l.map((c,b)=>({...w(c),tooltip:c.tooltip,handle:c===C.QuickInputButtons.Back?-1:b}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(l){this._value=l,this._onDidChangeValueEmitter.fire(l)}_fireDidTriggerButton(l){const c=this._handlesToButtons.get(l);c&&this._onDidTriggerButtonEmitter.fire(c)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,P.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),S.$dispose(this._id))}update(l){if(!this._disposed){for(const c of Object.keys(l)){const b=l[c];this._pendingUpdate[c]=b===void 0?null:b}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){S.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}o._nextId=1;function d(g){if(g instanceof C.ThemeIcon)return{id:g.id};const l=r(g),c=D(g);return{dark:typeof l=="string"?T.URI.file(l):l,light:typeof c=="string"?T.URI.file(c):c}}function D(g){return typeof g=="object"&&"light"in g?g.light:g}function r(g){return typeof g=="object"&&"dark"in g?g.dark:g}function w(g){const l=d(g.iconPath);let c,b;return"id"in l?b=i.ThemeIcon.asClassName(l):c=l,{iconPath:c,iconClass:b}}class s extends o{constructor(l,c,b){super(l,b);this.enableProposedApi=c,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new E.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new E.Emitter,this._onDidTriggerItemButtonEmitter=new E.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(l){this._items=l.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),l.forEach((c,b)=>{this._handlesToItems.set(b,c),this._itemsToHandles.set(c,b)}),this.update({items:l.map((c,b)=>({label:c.label,description:c.description,handle:b,detail:c.detail,picked:c.picked,alwaysShow:c.alwaysShow,buttons:c.buttons&&this.enableProposedApi?c.buttons.map((h,y)=>({...w(h),tooltip:h.tooltip,handle:y})):void 0}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(l){this._canSelectMany=l,this.update({canSelectMany:l})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(l){this._matchOnDescription=l,this.update({matchOnDescription:l})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(l){this._matchOnDetail=l,this.update({matchOnDetail:l})}get sortByLabel(){return this._sortByLabel}set sortByLabel(l){this._sortByLabel=l,this.update({sortByLabel:l})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(l){this._keepScrollPosition=l,this.update({keepScrollPosition:l})}get activeItems(){return this._activeItems}set activeItems(l){this._activeItems=l.filter(c=>this._itemsToHandles.has(c)),this.update({activeItems:this._activeItems.map(c=>this._itemsToHandles.get(c))})}get selectedItems(){return this._selectedItems}set selectedItems(l){this._selectedItems=l.filter(c=>this._itemsToHandles.has(c)),this.update({selectedItems:this._selectedItems.map(c=>this._itemsToHandles.get(c))})}_fireDidChangeActive(l){const c=(0,t.coalesce)(l.map(b=>this._handlesToItems.get(b)));this._activeItems=c,this._onDidChangeActiveEmitter.fire(c)}_fireDidChangeSelection(l){const c=(0,t.coalesce)(l.map(b=>this._handlesToItems.get(b)));this._selectedItems=c,this._onDidChangeSelectionEmitter.fire(c)}_fireDidTriggerItemButton(l,c){const b=this._handlesToItems.get(l);if(!b||!b.buttons||!b.buttons.length)return;const h=b.buttons[c];h&&this._onDidTriggerItemButtonEmitter.fire({button:h,item:b})}}class n extends o{constructor(l,c){super(l,c);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(l){this._password=l,this.update({password:l})}get prompt(){return this._prompt}set prompt(l){this._prompt=l,this.update({prompt:l})}get validationMessage(){return this._validationMessage}set validationMessage(l){this._validationMessage=l,this.update({validationMessage:l,severity:l?_.default.Error:_.default.Ignore})}}return new v(f,p)}e.createExtHostQuickOpen=m}),define(we[207],be([0,1,2,3,55,6,13,5,15,107,12,26,30,48,8]),function(re,e,u,M,E,P,F,T,C,A,t,_,i,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function f(l){if(l)return typeof l.iconPath=="string"?u.URI.file(l.iconPath):u.URI.isUri(l.iconPath)||m.ThemeIcon.isThemeIcon(l.iconPath)?l.iconPath:void 0}function p(l,c){if(!l.iconPath&&!c.iconPath)return 0;if(l.iconPath){if(!c.iconPath)return 1}else return-1;const b=typeof l.iconPath=="string"?l.iconPath:u.URI.isUri(l.iconPath)?l.iconPath.fsPath:l.iconPath.id,h=typeof c.iconPath=="string"?c.iconPath:u.URI.isUri(c.iconPath)?c.iconPath.fsPath:c.iconPath.id;return(0,A.comparePaths)(b,h)}function S(l,c){let b=0;if(l.strikeThrough!==c.strikeThrough)return l.strikeThrough?1:-1;if(l.faded!==c.faded)return l.faded?1:-1;if(l.tooltip!==c.tooltip)return(l.tooltip||"").localeCompare(c.tooltip||"");if(b=p(l,c),b!==0)return b;if(l.light&&c.light)b=p(l.light,c.light);else{if(l.light)return 1;if(c.light)return-1}if(b!==0)return b;if(l.dark&&c.dark)b=p(l.dark,c.dark);else{if(l.dark)return 1;if(c.dark)return-1}return b}function v(l,c){if(l.command!==c.command)return l.command<c.command?-1:1;if(l.title!==c.title)return l.title<c.title?-1:1;if(l.tooltip!==c.tooltip){if(l.tooltip!==void 0&&c.tooltip!==void 0)return l.tooltip<c.tooltip?-1:1;if(l.tooltip!==void 0)return 1;if(c.tooltip!==void 0)return-1}if(l.arguments===c.arguments)return 0;if(l.arguments)if(c.arguments){if(l.arguments.length!==c.arguments.length)return l.arguments.length-c.arguments.length}else return 1;else return-1;for(let b=0;b<l.arguments.length;b++){const h=l.arguments[b],y=c.arguments[b];if(h!==y)return h<y?-1:1}return 0}function o(l,c){let b=(0,A.comparePaths)(l.resourceUri.fsPath,c.resourceUri.fsPath,!0);if(b!==0)return b;if(l.command&&c.command)b=v(l.command,c.command);else{if(l.command)return 1;if(c.command)return-1}if(b!==0)return b;if(l.decorations&&c.decorations)b=S(l.decorations,c.decorations);else{if(l.decorations)return 1;if(c.decorations)return-1}return b}function d(l,c){for(let b=0;b<l.length;b++)if(l[b]!==c[b])return!1;return!0}function D(l,c){return l.command===c.command&&l.title===c.title&&l.tooltip===c.tooltip&&(l.arguments&&c.arguments?d(l.arguments,c.arguments):l.arguments===c.arguments)}function r(l,c){return(0,C.equals)(l,c,D)}class w{constructor(c,b,h){this._extension=c,this._proxy=b,this._sourceControlHandle=h,this._value="",this._onDidChange=new M.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(c){this._proxy.$setInputBoxValue(this._sourceControlHandle,c),this.updateValue(c)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(c){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,c),this._placeholder=c}get validateInput(){return(0,i.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(c){if((0,i.checkProposedApiEnabled)(this._extension),c&&typeof c!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=c,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!c)}get visible(){return this._visible}set visible(c){c=!!c,this._visible!==c&&(this._visible=c,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,c))}focus(){(0,i.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(c,b){(0,i.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,c,b)}$onInputBoxValueChange(c){this.updateValue(c)}updateValue(c){this._value=c,this._onDidChange.fire(c)}}e.ExtHostSCMInputBox=w;class s{constructor(c,b,h,y,R){this._proxy=c,this._commands=b,this._sourceControlHandle=h,this._id=y,this._label=R,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new M.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new M.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=s._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(c){this._label=c,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,c)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(c){this._hideWhenEmpty=c,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(c){this._resourceStates=[...c],this._onDidUpdateResourceStates.fire()}getResourceState(c){return this._resourceStatesMap.get(c)}$executeResourceCommand(c,b){const h=this._resourceStatesCommandsMap.get(c);return h?(0,F.asPromise)(()=>this._commands.executeCommand(h.command,...h.arguments||[],b)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const c=[...this._resourceStates].sort(o),h=(0,C.sortedDiff)(this._resourceSnapshot,c,o).map(I=>{const B=I.toInsert.map(L=>{const k=this._resourceHandlePool++;this._resourceStatesMap.set(k,L);const x=L.resourceUri;let N;if(L.command)if(L.command.command==="vscode.open"||L.command.command==="vscode.diff"){const Fe=new P.DisposableStore;N=this._commands.converter.toInternal(L.command,Fe),this._resourceStatesDisposablesMap.set(k,Fe)}else this._resourceStatesCommandsMap.set(k,L.command);const V=f(L.decorations),W=L.decorations&&f(L.decorations.light)||V,$=L.decorations&&f(L.decorations.dark)||V,X=[W,$],j=L.decorations&&L.decorations.tooltip||"",Q=L.decorations&&!!L.decorations.strikeThrough,ae=L.decorations&&!!L.decorations.faded,pe=L.contextValue||"";return{rawResource:[k,x,X,j,Q,ae,pe,N],handle:k}});return{start:I.start,deleteCount:I.deleteCount,toInsert:B}}),y=h.map(({start:I,deleteCount:B,toInsert:L})=>[I,B,L.map(k=>k.rawResource)]),R=h.reverse();for(const{start:I,deleteCount:B,toInsert:L}of R){const k=L.map(N=>N.handle),x=this._handlesSnapshot.splice(I,B,...k);for(const N of x)this._resourceStatesMap.delete(N),this._resourceStatesCommandsMap.delete(N),this._resourceStatesDisposablesMap.get(N)?.dispose(),this._resourceStatesDisposablesMap.delete(N)}return this._resourceSnapshot=c,y}dispose(){this._disposed=!0,this._onDidDispose.fire()}}s._handlePool=0;class n{constructor(c,b,h,y,R,I){this._extension=c,this._proxy=b,this._commands=h,this._id=y,this._label=R,this._rootUri=I,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new P.MutableDisposable,this._statusBarDisposables=new P.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new M.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new w(c,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,y,R,I)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(c){this._count!==c&&(this._count=c,this._proxy.$updateSourceControl(this.handle,{count:c}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(c){this._quickDiffProvider=c,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!c})}get commitTemplate(){return this._commitTemplate}set commitTemplate(c){c!==this._commitTemplate&&(this._commitTemplate=c,this._proxy.$updateSourceControl(this.handle,{commitTemplate:c}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(c){this._acceptInputDisposables.value=new P.DisposableStore,this._acceptInputCommand=c;const b=this._commands.converter.toInternal(c,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:b})}get actionButton(){return(0,i.checkProposedApiEnabled)(this._extension),this._actionButton}set actionButton(c){(0,i.checkProposedApiEnabled)(this._extension),this._actionButtonDisposables.value=new P.DisposableStore,this._actionButton=c;const b=c!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;this._proxy.$updateSourceControl(this.handle,{actionButton:b??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(c){if(this._statusBarCommands&&c&&r(this._statusBarCommands,c))return;this._statusBarDisposables.value=new P.DisposableStore,this._statusBarCommands=c;const b=(c||[]).map(h=>this._commands.converter.toInternal(h,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:b})}get selected(){return this._selected}createResourceGroup(c,b){const h=new s(this._proxy,this._commands,this.handle,c,b),y=M.Event.once(h.onDidDispose)(()=>this.createdResourceGroups.delete(h));return this.createdResourceGroups.set(h,y),this.eventuallyAddResourceGroups(),h}eventuallyAddResourceGroups(){const c=[],b=[];for(const[h,y]of this.createdResourceGroups){y.dispose();const R=h.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(h),this.eventuallyUpdateResourceStates()});M.Event.once(h.onDidDispose)(()=>{this.updatedResourceGroups.delete(h),R.dispose(),this._groups.delete(h.handle),this._proxy.$unregisterGroup(this.handle,h.handle)}),c.push([h.handle,h.id,h.label,h.features]);const I=h._takeResourceStateSnapshot();I.length>0&&b.push([h.handle,I]),this._groups.set(h.handle,h)}this._proxy.$registerGroups(this.handle,c,b),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const c=[];this.updatedResourceGroups.forEach(b=>{const h=b._takeResourceStateSnapshot();h.length!==0&&c.push([b.handle,h])}),c.length>0&&this._proxy.$spliceResourceStates(this.handle,c),this.updatedResourceGroups.clear()}getResourceGroup(c){return this._groups.get(c)}setSelectionState(c){this._selected=c,this._onDidChangeSelection.fire(c)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(c=>c.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}n._handlePool=0,Ue([(0,E.debounce)(100)],n.prototype,"eventuallyAddResourceGroups",null),Ue([(0,E.debounce)(100)],n.prototype,"eventuallyUpdateResourceStates",null);let g=class Bi{constructor(c,b,h){this._commands=b,this.logService=h,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new M.Emitter,this._proxy=c.getProxy(T.MainContext.MainThreadSCM),this._telemetry=c.getProxy(T.MainContext.MainThreadTelemetry),b.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===3){const R=this._sourceControls.get(y.sourceControlHandle);if(!R)return y;const I=R.getResourceGroup(y.groupHandle);return I?I.getResourceState(y.handle):y}else if(y&&y.$mid===4){const R=this._sourceControls.get(y.sourceControlHandle);return R?R.getResourceGroup(y.groupHandle):y}else if(y&&y.$mid===5){const R=this._sourceControls.get(y.handle);return R||y}return y}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(c,b,h,y){this.logService.trace("ExtHostSCM#createSourceControl",c.identifier.value,b,h,y),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:c.identifier.value});const R=Bi._handlePool++,I=new n(c,this._proxy,this._commands,b,h,y);this._sourceControls.set(R,I);const B=this._sourceControlsByExtension.get(_.ExtensionIdentifier.toKey(c.identifier))||[];return B.push(I),this._sourceControlsByExtension.set(_.ExtensionIdentifier.toKey(c.identifier),B),I}getLastInputBox(c){this.logService.trace("ExtHostSCM#getLastInputBox",c.identifier.value);const b=this._sourceControlsByExtension.get(_.ExtensionIdentifier.toKey(c.identifier)),h=b&&b[b.length-1];return h&&h.inputBox}$provideOriginalResource(c,b,h){const y=u.URI.revive(b);this.logService.trace("ExtHostSCM#$provideOriginalResource",c,y.toString());const R=this._sourceControls.get(c);return!R||!R.quickDiffProvider||!R.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,F.asPromise)(()=>R.quickDiffProvider.provideOriginalResource(y,h)).then(I=>I||null)}$onInputBoxValueChange(c,b){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",c);const h=this._sourceControls.get(c);return h&&h.inputBox.$onInputBoxValueChange(b),Promise.resolve(void 0)}$executeResourceCommand(c,b,h,y){this.logService.trace("ExtHostSCM#$executeResourceCommand",c,b,h);const R=this._sourceControls.get(c);if(!R)return Promise.resolve(void 0);const I=R.getResourceGroup(b);return I?I.$executeResourceCommand(h,y):Promise.resolve(void 0)}$validateInput(c,b,h){this.logService.trace("ExtHostSCM#$validateInput",c);const y=this._sourceControls.get(c);return!y||!y.inputBox.validateInput?Promise.resolve(void 0):(0,F.asPromise)(()=>y.inputBox.validateInput(b,h)).then(R=>{if(!R)return Promise.resolve(void 0);const I=a.MarkdownString.fromStrict(R.message);return I?Promise.resolve([I,R.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(c){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",c),c!==void 0&&this._sourceControls.get(c)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=c,Promise.resolve(void 0)}};g._handlePool=0,g=Ue([Be(2,t.ILogService)],g),e.ExtHostSCM=g});var Ze=this&&this.__classPrivateFieldSet||function(re,e,u,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,u):E?E.value=u:e.set(re,u),u},Te=this&&this.__classPrivateFieldGet||function(re,e,u,M){if(u==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?M:u==="a"?M.call(re):M?M.value:e.get(re)};define(we[208],be([0,1,7,5,128,6,8,10]),function(re,e,u,M,E,P,F,T){"use strict";var C,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class t{constructor(a,f,p,S,v=u.StatusBarAlignment.Left,o){C.set(this,void 0),A.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new P.DisposableStore,Ze(this,C,a,"f"),Ze(this,A,f,"f"),this._entryId=t.ID_GEN++,this._extension=p,this._id=S,this._alignment=v,this._priority=this.validatePriority(o)}validatePriority(a){if(!!(0,T.isNumber)(a))return a===Number.POSITIVE_INFINITY?Number.MAX_VALUE:a===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:a}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(a){this._text=a,this.update()}set name(a){this._name=a,this.update()}set tooltip(a){this._tooltip=a,this.update()}set color(a){this._color=a,this.update()}set backgroundColor(a){a&&!t.ALLOWED_BACKGROUND_COLORS.has(a.id)&&(a=void 0),this._backgroundColor=a,this.update()}set command(a){this._command?.fromApi!==a&&(this._internalCommandRegistration.clear(),typeof a=="string"?this._command={fromApi:a,internal:Te(this,A,"f").toInternal({title:"",command:a},this._internalCommandRegistration)}:a?this._command={fromApi:a,internal:Te(this,A,"f").toInternal(a,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(a){this._accessibilityInformation=a,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Te(this,C,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let a;this._extension?this._id?a=`${this._extension.identifier.value}.${this._id}`:a=this._extension.identifier.value:a=this._id;let f;this._name?f=this._name:f=(0,E.localize)(0,null,this._extension.displayName||this._extension.name);let p=this._color;this._backgroundColor&&(p=t.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const S=this._tooltip?F.MarkdownString.fromStrict(this._tooltip):void 0;Te(this,C,"f").$setEntry(this._entryId,a,f,this._text,S,this._command?.internal,p,this._backgroundColor,this._alignment===u.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=t,C=new WeakMap,A=new WeakMap,t.ID_GEN=0,t.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new u.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new u.ThemeColor("statusBarItem.warningForeground")]]);class _{constructor(a){this._messages=[],this._item=a.createStatusBarEntry(void 0,"status.extensionMessage",u.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,E.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(a){const f={message:a};return this._messages.unshift(f),this._update(),new u.Disposable(()=>{const p=this._messages.indexOf(f);p>=0&&(this._messages.splice(p,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class i{constructor(a,f){this._proxy=a.getProxy(M.MainContext.MainThreadStatusBar),this._commands=f,this._statusMessage=new _(this)}createStatusBarEntry(a,f,p,S){return new t(this._proxy,this._commands,a,f,p,S)}setStatusBarMessage(a,f){const p=this._statusMessage.setMessage(a);let S;return typeof f=="number"?S=setTimeout(()=>p.dispose(),f):typeof f!="undefined"&&f.then(()=>p.dispose(),()=>p.dispose()),new u.Disposable(()=>{p.dispose(),clearTimeout(S)})}}e.ExtHostStatusBar=i}),define(we[73],be([0,1,5,3,4]),function(re,e,u,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class P{constructor(T){this._onDidChangeStorage=new M.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=T.getProxy(u.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(T,C){this._proxy.$registerExtensionStorageKeysToSync(T,C)}getValue(T,C,A){return this._proxy.$getValue(T,C).then(t=>t||A)}setValue(T,C,A){return this._proxy.$setValue(T,C,A)}$acceptValue(T,C,A){this._onDidChangeStorage.fire({shared:T,key:C,value:A})}}e.ExtHostStorage=P,e.IExtHostStorage=(0,E.createDecorator)("IExtHostStorage")}),define(we[74],be([0,1,4,27,12,52,2]),function(re,e,u,M,E,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,u.createDecorator)("IExtensionStoragePaths");let T=class{constructor(A,t,_){this._logService=t,this._extHostFileSystem=_,this._workspace=A.workspace??void 0,this._environment=A.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(i=>this._value=i)}async _getWorkspaceStorageURI(A){return F.URI.joinPath(this._environment.workspaceStorageHome,A)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const A=this._workspace.id,t=await this._getWorkspaceStorageURI(A);try{return await this._extHostFileSystem.value.stat(t),this._logService.trace("[ExtHostStorage] storage dir already exists",t),t}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",t),await this._extHostFileSystem.value.createDirectory(t),await this._extHostFileSystem.value.writeFile(F.URI.joinPath(t,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:F.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),t}catch(_){this._logService.error("[ExtHostStorage]",_);return}}workspaceValue(A){if(this._value)return F.URI.joinPath(this._value,A.identifier.value)}globalValue(A){return F.URI.joinPath(this._environment.globalStorageHome,A.identifier.value.toLowerCase())}onWillDeactivateAll(){}};T=Ue([Be(0,M.IExtHostInitDataService),Be(1,E.ILogService),Be(2,P.IExtHostConsumerFileSystem)],T),e.ExtensionStoragePaths=T}),define(we[41],be([0,1,3,5,4,2,14,6,7,129,16,171,21,37,151,48,10,13]),function(re,e,u,M,E,P,F,T,C,A,t,_,i,m,a,f,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,E.createDecorator)("IExtHostTerminalService");class v{constructor(l,c,b,h){this._proxy=l,this._id=c,this._creationOptions=b,this._name=h,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(R=>this._pidPromiseComplete=R);const y=this;this.value={get name(){return y._name||""},get processId(){return y._pidPromise},get creationOptions(){return y._creationOptions},get exitStatus(){return y._exitStatus},get state(){return y._state},sendText(R,I=!0){y._checkDisposed(),y._proxy.$sendText(y._id,R,I)},show(R){y._checkDisposed(),y._proxy.$show(y._id,R)},hide(){y._checkDisposed(),y._proxy.$hide(y._id)},dispose(){y._disposed||(y._disposed=!0,y._proxy.$dispose(y._id))},get dimensions(){if(!(y._cols===void 0||y._rows===void 0))return{columns:y._cols,rows:y._rows}}}}async create(l,c){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:l.name,shellPath:(0,p.withNullAsUndefined)(l.shellPath),shellArgs:(0,p.withNullAsUndefined)(l.shellArgs),cwd:(0,p.withNullAsUndefined)(l.cwd),env:(0,p.withNullAsUndefined)(l.env),icon:(0,p.withNullAsUndefined)(s(l.iconPath)),color:f.ThemeColor.isThemeColor(l.color)?l.color.id:void 0,initialText:(0,p.withNullAsUndefined)(l.message),strictEnv:(0,p.withNullAsUndefined)(l.strictEnv),hideFromUser:(0,p.withNullAsUndefined)(l.hideFromUser),isFeatureTerminal:(0,p.withNullAsUndefined)(c?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,p.withNullAsUndefined)(c?.useShellEnvironment),location:c?.location||this._serializeParentTerminal(l.location,c?.resolvedExtHostIdentifier)})}async createExtensionTerminal(l,c,b,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:b,color:f.ThemeColor.isThemeColor(h)?h.id:void 0,location:this._serializeParentTerminal(l,c)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(l,c){return typeof l=="object"?"parentTerminal"in l&&l.parentTerminal&&c?{parentTerminal:c}:"viewColumn"in l?{viewColumn:l.viewColumn,preserveFocus:l.preserveFocus}:void 0:l}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(l){this._name=l}setExitCode(l){this._exitStatus=Object.freeze({code:l})}setDimensions(l,c){return l===this._cols&&c===this._rows||l===0||c===0?!1:(this._cols=l,this._rows=c,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(l){this._pidPromiseComplete?(this._pidPromiseComplete(l),this._pidPromiseComplete=void 0):this._pidPromise.then(c=>{c!==l&&(this._pidPromise=Promise.resolve(l))})}}e.ExtHostTerminal=v;class o{constructor(l){this._pty=l,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new u.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new u.Emitter,this._onDidChangeProperty=new u.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new u.Emitter,this.onProcessExit=this._onProcessExit.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}refreshProperty(l){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${l}`)}updateProperty(l,c){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${l}, value: ${c}`)}async start(){}shutdown(){this._pty.close()}input(l){this._pty.handleInput&&this._pty.handleInput(l)}resize(l,c){this._pty.setDimensions&&this._pty.setDimensions({columns:l,rows:c})}async processBinary(l){}acknowledgeDataEvent(l){}async setUnicodeVersion(l){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(l){this._pty.onDidWrite(c=>this._onProcessData.fire(c)),this._pty.onDidClose&&this._pty.onDidClose((c=void 0)=>{this._onProcessExit.fire(c===void 0?void 0:c)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(c=>{c&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:c.columns,rows:c.rows}})}),this._pty.onDidChangeName&&this._pty.onDidChangeName(c=>{this._onDidChangeProperty.fire({type:"title",value:c})}),this._pty.open(l||void 0),this._pty.setDimensions&&l&&this._pty.setDimensions(l),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=o;let d=1,D=class extends T.Disposable{constructor(l,c){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new u.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new u.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new u.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new u.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new u.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=c.getProxy(M.MainContext.MainThreadTerminalService),this._bufferer=new a.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new u.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(l),this._register({dispose:()=>{for(const[b,h]of this._terminalProcesses)h.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(l=>l.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(l){return(l?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(l){return(l?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(l,c){const b=new v(this._proxy,(0,m.generateUuid)(),l,l.name),h=new o(l.pty);return b.createExtensionTerminal(l.location,this._serializeParentTerminal(l,c).resolvedExtHostIdentifier,s(l.iconPath),n(l.color)).then(y=>{const R=this._setupExtHostProcessListeners(y,h);this._terminalProcessDisposables[y]=R}),this._terminals.push(b),b.value}_serializeParentTerminal(l,c){if(c=c||{},l.location&&typeof l.location=="object"&&"parentTerminal"in l.location){const b=l.location.parentTerminal;if(b){const h=this._terminals.find(y=>y.value===b);h&&(c.resolvedExtHostIdentifier=h._id)}}else l.location&&typeof l.location!="object"?c.location=l.location:c.location&&typeof c.location=="object"&&"splitActiveTerminal"in c.location&&(c.location={splitActiveTerminal:!0});return c}attachPtyToTerminal(l,c){if(!this._getTerminalById(l))throw new Error(`Cannot resolve terminal with id ${l} for virtual process`);const h=new o(c),y=this._setupExtHostProcessListeners(l,h);this._terminalProcessDisposables[l]=y}async $acceptActiveTerminalChanged(l){const c=this._activeTerminal;if(l===null){this._activeTerminal=void 0,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const b=this._getTerminalById(l);b&&(this._activeTerminal=b,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(l,c){const b=this._getTerminalById(l);b&&this._onDidWriteTerminalData.fire({terminal:b.value,data:c})}async $acceptTerminalDimensions(l,c,b){const h=this._getTerminalById(l);h&&h.setDimensions(c,b)&&this._onDidChangeTerminalDimensions.fire({terminal:h.value,dimensions:h.value.dimensions})}async $acceptTerminalMaximumDimensions(l,c,b){this._terminalProcesses.get(l)?.resize(c,b)}async $acceptTerminalTitleChange(l,c){const b=this._getTerminalById(l);b&&(b.name=c)}async $acceptTerminalClosed(l,c){const b=this._getTerminalObjectIndexById(this._terminals,l);if(b!==null){const h=this._terminals.splice(b,1)[0];h.setExitCode(c),this._onDidCloseTerminal.fire(h.value)}}$acceptTerminalOpened(l,c,b,h){if(c){const I=this._getTerminalObjectIndexById(this._terminals,c);if(I!==null){this._terminals[I]._id=l,this._onDidOpenTerminal.fire(this.terminals[I]),this._terminals[I].isOpen=!0;return}}const y={name:h.name,shellPath:h.executable,shellArgs:h.args,cwd:typeof h.cwd=="string"?h.cwd:P.URI.revive(h.cwd),env:h.env,hideFromUser:h.hideFromUser},R=new v(this._proxy,l,y,b);this._terminals.push(R),this._onDidOpenTerminal.fire(R.value),R.isOpen=!0}async $acceptTerminalProcessId(l,c){const b=this._getTerminalById(l);b&&b._setProcessId(c)}async $startExtensionTerminal(l,c){const b=this._getTerminalById(l);if(!b)return{message:(0,A.localize)(0,null,l)};b.isOpen||await new Promise(y=>{const R=this.onDidOpenTerminal(async I=>{I===b.value&&(R.dispose(),y())})});const h=this._terminalProcesses.get(l);h?h.startSendingEvents(c):this._extensionTerminalAwaitingStart[l]={initialDimensions:c}}_setupExtHostProcessListeners(l,c){const b=new T.DisposableStore;b.add(c.onProcessReady(y=>this._proxy.$sendProcessReady(l,y.pid,y.cwd))),b.add(c.onDidChangeProperty(y=>this._proxy.$sendProcessProperty(l,y))),this._bufferer.startBuffering(l,c.onProcessData),b.add(c.onProcessExit(y=>this._onProcessExit(l,y))),this._terminalProcesses.set(l,c);const h=this._extensionTerminalAwaitingStart[l];return h&&c instanceof o&&(c.startSendingEvents(h.initialDimensions),delete this._extensionTerminalAwaitingStart[l]),b}$acceptProcessAckDataEvent(l,c){this._terminalProcesses.get(l)?.acknowledgeDataEvent(c)}$acceptProcessInput(l,c){this._terminalProcesses.get(l)?.input(c)}$acceptTerminalInteraction(l){const c=this._getTerminalById(l);c?.setInteractedWith()&&this._onDidChangeTerminalState.fire(c.value)}$acceptProcessResize(l,c,b){try{this._terminalProcesses.get(l)?.resize(c,b)}catch(h){if(h.code!=="EPIPE"&&h.code!=="ERR_IPC_CHANNEL_CLOSED")throw h}}$acceptProcessShutdown(l,c){this._terminalProcesses.get(l)?.shutdown(c)}$acceptProcessRequestInitialCwd(l){this._terminalProcesses.get(l)?.getInitialCwd().then(c=>this._proxy.$sendProcessProperty(l,{type:"initialCwd",value:c}))}$acceptProcessRequestCwd(l){this._terminalProcesses.get(l)?.getCwd().then(c=>this._proxy.$sendProcessProperty(l,{type:"cwd",value:c}))}$acceptProcessRequestLatency(l){return l}registerLinkProvider(l){return this._linkProviders.add(l),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new C.Disposable(()=>{this._linkProviders.delete(l),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(l,c,b){if(this._profileProviders.has(c))throw new Error(`Terminal profile provider "${c}" already registered`);return this._profileProviders.set(c,b),this._proxy.$registerProfileProvider(c,l.identifier.value),new C.Disposable(()=>{this._profileProviders.delete(c),this._proxy.$unregisterProfileProvider(c)})}async $createContributedProfileTerminal(l,c){const b=new i.CancellationTokenSource().token;let h=await this._profileProviders.get(l)?.provideTerminalProfile(b);if(!b.isCancellationRequested){if(h&&!("options"in h)&&(h={options:h}),!h||!("options"in h))throw new Error(`No terminal profile options provided for id "${l}"`);if("pty"in h.options){this.createExtensionTerminal(h.options,c);return}this.createTerminalFromOptions(h.options,c)}}async $provideLinks(l,c){const b=this._getTerminalById(l);if(!b)return[];this._terminalLinkCache.delete(l);const h=this._terminalLinkCancellationSource.get(l);h&&h.dispose(!0);const y=new i.CancellationTokenSource;this._terminalLinkCancellationSource.set(l,y);const R=[],I={terminal:b.value,line:c},B=[];for(const x of this._linkProviders)B.push(S.Promises.withAsyncBody(async N=>{y.token.onCancellationRequested(()=>N({provider:x,links:[]}));const V=await x.provideTerminalLinks(I,y.token)||[];y.token.isCancellationRequested||N({provider:x,links:V})}));const L=await Promise.all(B);if(y.token.isCancellationRequested)return[];const k=new Map;for(const x of L)x&&x.links.length>0&&R.push(...x.links.map(N=>{const V={id:d++,startIndex:N.startIndex,length:N.length,label:N.tooltip};return k.set(V.id,{provider:x.provider,link:N}),V}));return this._terminalLinkCache.set(l,k),R}$activateLink(l,c){const b=this._terminalLinkCache.get(l)?.get(c);!b||b.provider.handleTerminalLink(b.link)}_onProcessExit(l,c){this._bufferer.stopBuffering(l),this._terminalProcesses.delete(l),delete this._extensionTerminalAwaitingStart[l];const b=this._terminalProcessDisposables[l];b&&(b.dispose(),delete this._terminalProcessDisposables[l]),this._proxy.$sendProcessExit(l,c)}_getTerminalById(l){return this._getTerminalObjectById(this._terminals,l)}_getTerminalObjectById(l,c){const b=this._getTerminalObjectIndexById(l,c);return b!==null?l[b]:null}_getTerminalObjectIndexById(l,c){let b=null;return l.some((h,y)=>h._id===c?(b=y,!0):!1),b}getEnvironmentVariableCollection(l){let c=this._environmentVariableCollections.get(l.identifier.value);return c||(c=new r,this._setEnvironmentVariableCollection(l.identifier.value,c)),c}_syncEnvironmentVariableCollection(l,c){const b=(0,_.serializeEnvironmentVariableCollection)(c.map);this._proxy.$setEnvironmentVariableCollection(l,c.persistent,b.length===0?void 0:b)}$initEnvironmentVariableCollections(l){l.forEach(c=>{const b=c[0],h=new r(c[1]);this._setEnvironmentVariableCollection(b,h)})}$acceptDefaultProfile(l,c){this._defaultProfile=l,this._defaultAutomationProfile=c}_setEnvironmentVariableCollection(l,c){this._environmentVariableCollections.set(l,c),c.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(l,c)})}};D=Ue([Be(1,F.IExtHostRpcService)],D),e.BaseExtHostTerminalService=D;class r{constructor(l){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new u.Emitter,this.map=new Map(l)}get persistent(){return this._persistent}set persistent(l){this._persistent=l,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(l,c){this._setIfDiffers(l,{value:c,type:C.EnvironmentVariableMutatorType.Replace})}append(l,c){this._setIfDiffers(l,{value:c,type:C.EnvironmentVariableMutatorType.Append})}prepend(l,c){this._setIfDiffers(l,{value:c,type:C.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(l,c){const b=this.map.get(l);(!b||b.value!==c.value||b.type!==c.type)&&(this.map.set(l,c),this._onDidChangeCollection.fire())}get(l){return this.map.get(l)}forEach(l,c){this.map.forEach((b,h)=>l.call(c,h,b,this))}delete(l){this.map.delete(l),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=r;let w=class extends D{constructor(l){super(!1,l)}createTerminal(l,c,b){throw new t.NotSupportedError}createTerminalFromOptions(l,c){throw new t.NotSupportedError}};w=Ue([Be(0,F.IExtHostRpcService)],w),e.WorkerExtHostTerminalService=w;function s(g){if(!(!g||typeof g=="string"))return"id"in g?{id:g.id,color:g.color}:g}function n(g){return f.ThemeColor.isThemeColor(g)?g:void 0}});var Ze=this&&this.__classPrivateFieldSet||function(re,e,u,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,u):E?E.value=u:e.set(re,u),u},Te=this&&this.__classPrivateFieldGet||function(re,e,u,M){if(u==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?M:u==="a"?M.call(re):M?M.value:e.get(re)};define(we[209],be([0,1,15,22,21,3,238,60,6,23,10,37,5,14,50,8,7,179,90,69]),function(re,e,u,M,E,P,F,T,C,A,t,_,i,m,a,f,p,S,v,o){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let D=class{constructor(I,B){this.resultsChangedEmitter=new P.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=I.getProxy(i.MainContext.MainThreadTesting),this.observer=new b(this.proxy),this.runTracker=new w(this.proxy),B.registerArgumentProcessor({processArgument:L=>L?.$mid===13?f.TestItem.toItemFromContext(L):L})}createTestController(I,B){if(this.controllers.has(I))throw new Error(`Attempt to insert a duplicate controller with ID "${I}"`);const L=new C.DisposableStore,k=L.add(new S.SingleUseTestCollection(I));k.root.label=B;const x=new Map,N=this.proxy,V={items:k.root.children,get label(){return B},set label($){B=$,k.root.label=$,N.$updateControllerLabel(I,B)},get id(){return I},createRunProfile:($,X,j,Q,ae)=>{let pe=(0,T.hash)($);for(;x.has(pe);)pe++;const ce=new h(this.proxy,I,pe,$,X,j,Q,ae);return x.set(pe,ce),ce},createTestItem($,X,j){return new a.TestItemImpl(I,$,X,j)},createTestRun:($,X,j=!0)=>this.runTracker.createTestRun(I,k,$,X,j),set resolveHandler($){k.resolveHandler=$},get resolveHandler(){return k.resolveHandler},dispose:()=>{L.dispose()}};V.createRunConfiguration=V.createRunProfile,N.$registerTestController(I,B),L.add((0,C.toDisposable)(()=>N.$unregisterTestController(I)));const W={controller:V,collection:k,profiles:x};return this.controllers.set(I,W),L.add((0,C.toDisposable)(()=>this.controllers.delete(I))),L.add(k.onDidGenerateDiff($=>N.$publishDiff(I,$))),V}createTestObserver(){return this.observer.checkout()}async runTests(I,B=E.CancellationToken.None){const L=s(I);if(!L)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const k=this.controllers.get(L.controllerId);if(!k)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:I.include?.map(x=>x.id)??[k.collection.root.id],profileGroup:y[L.kind],profileId:L.profileId,controllerId:L.controllerId}],exclude:I.exclude?.map(x=>x.id)},B)}$provideFileCoverage(I,B,L){return(0,u.mapFind)(this.runTracker.trackers,x=>x.id===I?x.getCoverage(B):void 0)?.provideFileCoverage(L)??Promise.resolve([])}$resolveFileCoverage(I,B,L,k){return(0,u.mapFind)(this.runTracker.trackers,N=>N.id===I?N.getCoverage(B):void 0)?.resolveFileCoverage(L,k)??Promise.resolve([])}$configureRunProfile(I,B){this.controllers.get(I)?.profiles.get(B)?.configureHandler?.()}$publishTestResults(I){this.results=Object.freeze(I.map(B=>(0,A.deepFreeze)(f.TestResults.to(B))).concat(this.results).sort((B,L)=>L.completedAt-B.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(I,B){const L=this.controllers.get(o.TestId.fromString(I).controllerId)?.collection;L&&(await L.expand(I,B<0?Infinity:B),L.flushDiff())}$acceptDiff(I){this.observer.applyDiff(I)}async $runControllerTests(I,B){const L=this.controllers.get(I.controllerId);if(!L)return;const{collection:k,profiles:x}=L,N=x.get(I.profileId);if(!N)return;const V=I.testIds.map(j=>k.tree.get(j)).filter(t.isDefined),W=I.excludeExtIds.map(j=>L.collection.tree.get(j)).filter(t.isDefined).filter(j=>V.some(Q=>Q.fullId.compare(j.fullId)===2));if(!V.length)return;const $=new p.TestRunRequest(V.some(j=>j.actual instanceof a.TestItemRootImpl)?void 0:V.map(j=>j.actual),W.map(j=>j.actual),N),X=this.runTracker.prepareForMainThreadTestRun($,n.fromInternal(I,L.collection),B);try{await N.runHandler($,B)}finally{X.isRunning&&!B.isCancellationRequested&&await P.Event.toPromise(X.onEnd),X.dispose()}}$cancelExtensionTestRun(I){I===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(I)}};D=Ue([Be(0,m.IExtHostRpcService)],D),e.ExtHostTesting=D;class r extends C.Disposable{constructor(I,B,L){super();this.dto=I,this.proxy=B,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new P.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new E.CancellationTokenSource(L)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:k}of this.tasks.values())k.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(I){return this.tasks.get(I)?.coverage}createRun(I){const B=this.dto.id,L=this.dto.controllerId,k=(0,_.generateUuid)(),x=new g(this.proxy,B,k),N=X=>(j,...Q)=>{if(W){console.warn(`Setting the state of test "${j.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(j)||(this.ensureTestIsKnown(j),X(j,...Q))},V=(X,j)=>{const Q=j instanceof Array?j.map(f.TestMessage.from):[f.TestMessage.from(j)];if(X.uri&&X.range){const ae={range:f.Range.from(X.range),uri:X.uri};for(const pe of Q)pe.location=pe.location||ae}this.proxy.$appendTestMessagesInRun(B,k,o.TestId.fromExtHostTestItem(X,L).toString(),Q)};let W=!1;const $={isPersisted:this.dto.isPersisted,token:this.cts.token,name:I,get coverageProvider(){return x.coverageProvider},set coverageProvider(X){x.coverageProvider=X},enqueued:N(X=>{this.proxy.$updateTestStateInRun(B,k,o.TestId.fromExtHostTestItem(X,L).toString(),1)}),skipped:N(X=>{this.proxy.$updateTestStateInRun(B,k,o.TestId.fromExtHostTestItem(X,L).toString(),5)}),started:N(X=>{this.proxy.$updateTestStateInRun(B,k,o.TestId.fromExtHostTestItem(X,L).toString(),2)}),errored:N((X,j,Q)=>{V(X,j),this.proxy.$updateTestStateInRun(B,k,o.TestId.fromExtHostTestItem(X,L).toString(),6,Q)}),failed:N((X,j,Q)=>{V(X,j),this.proxy.$updateTestStateInRun(B,k,o.TestId.fromExtHostTestItem(X,L).toString(),4,Q)}),passed:N((X,j)=>{this.proxy.$updateTestStateInRun(B,k,o.TestId.fromExtHostTestItem(X,this.dto.controllerId).toString(),3,j)}),appendOutput:(X,j,Q)=>{W||(Q&&(this.dto.isIncluded(Q)?this.ensureTestIsKnown(Q):Q=void 0),this.proxy.$appendOutputToRun(B,k,M.VSBuffer.fromString(X),j&&f.location.from(j),Q&&o.TestId.fromExtHostTestItem(Q,L).toString()))},end:()=>{W||(W=!0,this.proxy.$finishedTestRunTask(B,k),this.tasks.delete(k),this.isRunning||this.dispose())}};return this.tasks.set(k,{run:$,coverage:x}),this.proxy.$startedTestRunTask(B,{id:k,name:I,running:!0}),$}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(I){if(!(I instanceof a.TestItemImpl))throw new a.InvalidTestItemError(I.id);if(this.sharedTestIds.has(o.TestId.fromExtHostTestItem(I,this.dto.controllerId).toString()))return;const B=[],L=this.dto.colllection.root;for(;;){const k=f.TestItem.from(I);if(B.unshift(k),this.sharedTestIds.has(k.extId)||(this.sharedTestIds.add(k.extId),I===L))break;I=I.parent||L}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,B)}}class w{constructor(I){this.proxy=I,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(I,B,L){return this.getTracker(I,B,L)}cancelRunById(I){for(const B of this.tracked.values())if(B.id===I){B.dispose();return}}cancelAllRuns(){for(const I of this.tracked.values())I.dispose()}createTestRun(I,B,L,k,x){const N=this.tracked.get(L);if(N)return N.createRun(k);const V=n.fromPublic(I,B,L,x),W=s(L);this.proxy.$startedExtensionTestRun({controllerId:I,profile:W&&{group:y[W.kind],id:W.profileId},exclude:L.exclude?.map(X=>X.id)??[],id:V.id,include:L.include?.map(X=>X.id)??[B.root.id],persist:x});const $=this.getTracker(L,V);return $.onEnd(()=>this.proxy.$finishedExtensionTestRun(V.id)),$.createRun(k)}getTracker(I,B,L){const k=new r(B,this.proxy,L);return this.tracked.set(I,k),k.onEnd(()=>this.tracked.delete(I)),k}}e.TestRunCoordinator=w;const s=R=>{if(!!R.profile){if(!(R.profile instanceof h))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return R.profile}};class n{constructor(I,B,L,k,x,N){this.controllerId=I,this.id=B,this.isPersisted=x,this.colllection=N,this.includePrefix=L.map(V=>V+"\0"),this.excludePrefix=k.map(V=>V+"\0")}static fromPublic(I,B,L,k){return new n(I,(0,_.generateUuid)(),L.include?.map(x=>o.TestId.fromExtHostTestItem(x,I).toString())??[I],L.exclude?.map(x=>o.TestId.fromExtHostTestItem(x,I).toString())??[],k,B)}static fromInternal(I,B){return new n(I.controllerId,I.runId,I.testIds,I.excludeExtIds,!0,B)}isIncluded(I){const B=o.TestId.fromExtHostTestItem(I,this.controllerId).toString()+"\0";for(const L of this.excludePrefix)if(B===L||B.startsWith(L))return!1;for(const L of this.includePrefix)if(B===L||B.startsWith(L))return!0;return!1}}e.TestRunDto=n;class g{constructor(I,B,L){this.proxy=I,this.runId=B,this.taskId=L}set coverageProvider(I){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!I||(this._coverageProvider=I,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(I){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(I))());try{return(await this.fileCoverage)?.map(f.TestCoverage.fromFile)??[]}catch(B){throw this.fileCoverage=void 0,B}}async resolveFileCoverage(I,B){const L=await this.fileCoverage;let k=L?.[I];return!this._coverageProvider||!L||!k?[]:(k.detailedCoverage||(k=L[I]=await this._coverageProvider.resolveFileCoverage?.(k,B)??k),k.detailedCoverage?.map(f.TestCoverage.fromDetailed)??[])}}class l extends v.IncrementalChangeCollector{constructor(I){super();this.emitter=I,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(I){this.added.add(I)}update(I){Object.assign(I.revived,f.TestItem.toPlain(I.item)),this.added.has(I)||this.updated.add(I)}remove(I){if(this.added.has(I)){this.added.delete(I);return}if(this.updated.delete(I),I.parent&&this.alreadyRemoved.has(I.parent)){this.alreadyRemoved.add(I.item.extId);return}this.removed.add(I)}getChangeEvent(){const{added:I,updated:B,removed:L}=this;return{get added(){return[...I].map(k=>k.revived)},get updated(){return[...B].map(k=>k.revived)},get removed(){return[...L].map(k=>k.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class c extends v.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new P.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(I){return this.items.get(I)}getMirroredTestDataByReference(I){return this.items.get(I.id)}createItem(I,B){return{...I,revived:f.TestItem.toPlain(I.item),depth:B?B.depth+1:0,children:new Set}}createChangeCollector(){return new l(this.changeEmitter)}}e.MirroredTestCollection=c;class b{constructor(I){this.proxy=I}checkout(){this.current||(this.current=this.createObserverData());const I=this.current;return I.observers++,{onDidChangeTest:I.tests.onDidChangeTests,get tests(){return[...I.tests.rootTests].map(B=>B.revived)},dispose:(0,F.once)(()=>{--I.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(I){return this.current?.tests.getMirroredTestDataByReference(I)}applyDiff(I){this.current?.tests.apply(I)}createObserverData(){const I=new c;return this.proxy.$subscribeToDiffs(),{observers:0,tests:I}}}class h{constructor(I,B,L,k,x,N,V=!1,W=void 0){this.controllerId=B,this.profileId=L,this._label=k,this.kind=x,this.runHandler=N,this._isDefault=V,this._tag=W,d.set(this,void 0),Ze(this,d,I,"f");const $=y[x];if(typeof $!="number")throw new Error(`Unknown TestRunProfile.group ${x}`);Te(this,d,"f").$publishTestRunProfile({profileId:L,controllerId:B,tag:W?f.TestTag.namespace(this.controllerId,W.id):null,label:k,group:$,isDefault:V,hasConfigurationHandler:!1})}get label(){return this._label}set label(I){I!==this._label&&(this._label=I,Te(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:I}))}get isDefault(){return this._isDefault}set isDefault(I){I!==this._isDefault&&(this._isDefault=I,Te(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:I}))}get tag(){return this._tag}set tag(I){I?.id!==this._tag?.id&&(this._tag=I,Te(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:I?f.TestTag.namespace(this.controllerId,I.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(I){I!==this._configureHandler&&(this._configureHandler=I,Te(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!I}))}dispose(){Te(this,d,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=h,d=new WeakMap;const y={[p.TestRunProfileKind.Coverage]:8,[p.TestRunProfileKind.Debug]:4,[p.TestRunProfileKind.Run]:2}}),define(we[210],be([0,1,3,15,5,94,8,7]),function(re,e,u,M,E,P,F,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class C{constructor(t,_){this._extHostDocumentsAndEditors=_,this._onDidChangeTextEditorSelection=new u.Emitter,this._onDidChangeTextEditorOptions=new u.Emitter,this._onDidChangeTextEditorVisibleRanges=new u.Emitter,this._onDidChangeTextEditorViewColumn=new u.Emitter,this._onDidChangeActiveTextEditor=new u.Emitter,this._onDidChangeVisibleTextEditors=new u.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=t.getProxy(E.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(i=>this._onDidChangeVisibleTextEditors.fire(i)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(i=>this._onDidChangeActiveTextEditor.fire(i))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(t){const _=this._extHostDocumentsAndEditors.allEditors();return t?_:_.map(i=>i.value)}async showTextDocument(t,_,i){let m;typeof _=="number"?m={position:F.ViewColumn.from(_),preserveFocus:i}:typeof _=="object"?m={position:F.ViewColumn.from(_.viewColumn),preserveFocus:_.preserveFocus,selection:typeof _.selection=="object"?F.Range.from(_.selection):void 0,pinned:typeof _.preview=="boolean"?!_.preview:void 0}:m={preserveFocus:!1};const a=await this._proxy.$tryShowTextDocument(t.uri,m),f=a&&this._extHostDocumentsAndEditors.getEditor(a);if(f)return f.value;throw a?new Error(`Could NOT open editor for "${t.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${t.uri.toString()}".`)}createTextEditorDecorationType(t,_){return new P.TextEditorDecorationType(this._proxy,t,_).value}$acceptEditorPropertiesChanged(t,_){const i=this._extHostDocumentsAndEditors.getEditor(t);if(!i)throw new Error("unknown text editor");if(_.options&&i._acceptOptions(_.options),_.selections){const m=_.selections.selections.map(F.Selection.to);i._acceptSelections(m)}if(_.visibleRanges){const m=M.coalesce(_.visibleRanges.map(F.Range.to));i._acceptVisibleRanges(m)}if(_.options&&this._onDidChangeTextEditorOptions.fire({textEditor:i.value,options:{..._.options,lineNumbers:F.TextEditorLineNumbersStyle.to(_.options.lineNumbers)}}),_.selections){const m=T.TextEditorSelectionChangeKind.fromValue(_.selections.source),a=_.selections.selections.map(F.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:i.value,selections:a,kind:m})}if(_.visibleRanges){const m=M.coalesce(_.visibleRanges.map(F.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:i.value,visibleRanges:m})}}$acceptEditorPositionData(t){for(const _ in t){const i=this._extHostDocumentsAndEditors.getEditor(_);if(!i)throw new Error("Unknown text editor");const m=F.ViewColumn.to(t[_]);i.value.viewColumn!==m&&(i._acceptViewColumn(m),this._onDidChangeTextEditorViewColumn.fire({textEditor:i.value,viewColumn:m}))}}getDiffInformation(t){return Promise.resolve(this._proxy.$getDiffInformation(t))}}e.ExtHostEditors=C}),define(we[211],be([0,1,2,4,5,6,7]),function(re,e,u,M,E,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,M.createDecorator)("IExtHostTimeline");class T{constructor(t,_){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=t.getProxy(E.MainContext.MainThreadTimeline),_.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===11){const m=i.uri===void 0?void 0:u.URI.revive(i.uri);return this._itemsBySourceAndUriMap.get(i.source)?.get(C(m))?.get(i.handle)}return i}})}async $getTimeline(t,_,i,m,a){return this._providers.get(t)?.provideTimeline(u.URI.revive(_),i,m,a)}registerTimelineProvider(t,_,i,m){const a=new P.DisposableStore,f=this.convertTimelineItem(_.id,m,a).bind(this);let p;_.onDidChange&&(p=_.onDidChange(v=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...v,id:_.id}),this));const S=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({..._,scheme:t,onDidChange:void 0,async provideTimeline(v,o,d,D){D?.resetCache&&(a.clear(),S.get(_.id)?.clear());const r=await _.provideTimeline(v,o,d);if(r==null)return;const w=f(v,D);return{...r,source:_.id,items:r.items.map(w)}},dispose(){for(const v of S.values())v.get(_.id)?.clear();p?.dispose(),a.dispose()}})}convertTimelineItem(t,_,i){return(m,a)=>{let f;if(a?.cacheResults){let p=this._itemsBySourceAndUriMap.get(t);p===void 0&&(p=new Map,this._itemsBySourceAndUriMap.set(t,p));const S=C(m);f=p.get(S),f===void 0&&(f=new Map,p.set(S,f))}return p=>{const{iconPath:S,...v}=p,o=`${t}|${p.id??p.timestamp}`;f?.set(o,p);let d,D,r;return p.iconPath&&(S instanceof F.ThemeIcon?r={id:S.id,color:S.color}:u.URI.isUri(S)?(d=S,D=S):{light:d,dark:D}=S),{...v,id:v.id??void 0,handle:o,source:t,command:p.command?_.toInternal(p.command,i):void 0,icon:d,iconDark:D,themeIcon:r,accessibilityInformation:p.accessibilityInformation}}}}registerTimelineProviderCore(t){if(this._providers.get(t.id))throw new Error(`Timeline Provider ${t.id} already exists.`);return this._proxy.$registerTimelineProvider({id:t.id,label:t.label,scheme:t.scheme}),this._providers.set(t.id,t),(0,P.toDisposable)(()=>{for(const i of this._itemsBySourceAndUriMap.values())i.get(t.id)?.clear();this._providers.delete(t.id),this._proxy.$unregisterTimelineProvider(t.id),t.dispose()})}}e.ExtHostTimeline=T;function C(A){return A?.toString()}}),define(we[212],be([0,1,6,11,2,5]),function(re,e,u,M,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class F{constructor(C){this._openers=new Map,this._proxy=C.getProxy(P.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(C,A,t,_){if(this._openers.has(A))throw new Error(`Opener with id '${A}' already registered`);const i=_.schemes.find(m=>!F.supportedSchemes.has(m));if(i)throw new Error(`Scheme '${i}' is not supported. Only http and https are currently supported.`);return this._openers.set(A,t),this._proxy.$registerUriOpener(A,_.schemes,C,_.label),(0,u.toDisposable)(()=>{this._openers.delete(A),this._proxy.$unregisterUriOpener(A)})}async $canOpenUri(C,A,t){const _=this._openers.get(C);if(!_)throw new Error(`Unknown opener with id: ${C}`);const i=E.URI.revive(A);return _.canOpenExternalUri(i,t)}async $openUri(C,A,t){const _=this._openers.get(C);if(!_)throw new Error(`Unknown opener id: '${C}'`);return _.openExternalUri(E.URI.revive(A.resolvedUri),{sourceUri:E.URI.revive(A.sourceUri)},t)}}e.ExtHostUriOpeners=F,F.supportedSchemes=new Set([M.Schemas.http,M.Schemas.https])}),define(we[213],be([0,1,5,2,6,16,26]),function(re,e,u,M,E,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class T{constructor(A){this.handles=new Set,this.handlers=new Map,this._proxy=A.getProxy(u.MainContext.MainThreadUrls)}registerUriHandler(A,t){if(this.handles.has(F.ExtensionIdentifier.toKey(A)))throw new Error(`Protocol handler already registered for extension ${A}`);const _=T.HandlePool++;return this.handles.add(F.ExtensionIdentifier.toKey(A)),this.handlers.set(_,t),this._proxy.$registerUriHandler(_,A),(0,E.toDisposable)(()=>{this.handles.delete(F.ExtensionIdentifier.toKey(A)),this.handlers.delete(_),this._proxy.$unregisterUriHandler(_)})}$handleExternalUri(A,t){const _=this.handlers.get(A);if(!_)return Promise.resolve(void 0);try{_.handleUri(M.URI.revive(t))}catch(i){(0,P.onUnexpectedError)(i)}return Promise.resolve(void 0)}async createAppUri(A){return M.URI.revive(await this._proxy.$createAppUri(A))}}e.ExtHostUrls=T,T.HandlePool=0});var Ze=this&&this.__classPrivateFieldSet||function(re,e,u,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,u):E?E.value=u:e.set(re,u),u},Te=this&&this.__classPrivateFieldGet||function(re,e,u,M){if(u==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?M:u==="a"?M.call(re):M?M.value:e.get(re)};define(we[53],be([0,1,3,11,2,139,160,68,5]),function(re,e,u,M,E,P,F,T,C){"use strict";var A,t,_,i,m,a,f,p,S,v,o,d;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class D{constructor(b,h,y,R,I,B,L){A.set(this,void 0),t.set(this,void 0),_.set(this,void 0),i.set(this,void 0),m.set(this,void 0),a.set(this,void 0),f.set(this,""),p.set(this,void 0),S.set(this,!1),v.set(this,!1),o.set(this,!1),this._onMessageEmitter=new u.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,d.set(this,new u.Emitter),this._onDidDispose=Te(this,d,"f").event,Ze(this,A,b,"f"),Ze(this,t,h,"f"),Ze(this,p,y,"f"),Ze(this,i,R,"f"),Ze(this,m,I,"f"),Ze(this,a,B,"f"),Ze(this,o,r(B),"f"),Ze(this,_,L,"f")}dispose(){Ze(this,S,!0,"f"),Te(this,d,"f").fire(),Te(this,d,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(b){return Ze(this,v,!0,"f"),(0,T.asWebviewUri)(b,Te(this,i,"f").remote)}get cspSource(){const b=Te(this,a,"f").extensionLocation;if(b.scheme===M.Schemas.https||b.scheme===M.Schemas.http){let h=b.toString();return h.endsWith("/")||(h+="/"),h+" "+T.webviewGenericCspSource}return T.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Te(this,f,"f")}set html(b){this.assertNotDisposed(),Te(this,f,"f")!==b&&(Ze(this,f,b,"f"),!Te(this,v,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(b)&&(Ze(this,v,!0,"f"),Te(this,_,"f").report("Webview vscode-resource: uris",Te(this,a,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Te(this,t,"f").$setHtml(Te(this,A,"f"),b))}get options(){return this.assertNotDisposed(),Te(this,p,"f")}set options(b){this.assertNotDisposed(),Te(this,t,"f").$setOptions(Te(this,A,"f"),n(Te(this,a,"f"),Te(this,m,"f"),b)),Ze(this,p,b,"f")}async postMessage(b){if(Te(this,S,"f"))return!1;const h=(0,F.serializeWebviewMessage)(b,{serializeBuffersForPostMessage:Te(this,o,"f")});return Te(this,t,"f").$postMessage(Te(this,A,"f"),h.message,...h.buffers)}assertNotDisposed(){if(Te(this,S,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=D,A=new WeakMap,t=new WeakMap,_=new WeakMap,i=new WeakMap,m=new WeakMap,a=new WeakMap,f=new WeakMap,p=new WeakMap,S=new WeakMap,v=new WeakMap,o=new WeakMap,d=new WeakMap;function r(c){try{const b=(0,P.normalizeVersion)((0,P.parseVersion)(c.engines.vscode));return!!b&&b.majorBase>=1&&b.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=r;class w{constructor(b,h,y,R,I){this.initData=h,this.workspace=y,this._logService=R,this._deprecationService=I,this._webviews=new Map,this._webviewProxy=b.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(b,h,...y){const R=this.getWebview(b);if(R){const{message:I}=(0,F.deserializeWebviewMessage)(h,y);R._onMessageEmitter.fire(I)}}$onMissingCsp(b,h){this._logService.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(b,h,y){const R=new D(b,this._webviewProxy,g(h),this.initData,this.workspace,y,this._deprecationService);return this._webviews.set(b,R),R._onDidDispose(()=>{this._webviews.delete(b)}),R}deleteWebview(b){this._webviews.delete(b)}getWebview(b){return this._webviews.get(b)}}e.ExtHostWebviews=w;function s(c){return{id:c.identifier,location:c.extensionLocation}}e.toExtensionData=s;function n(c,b,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||l(c,b)}}e.serializeWebviewOptions=n;function g(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(b=>E.URI.from(b))}}e.reviveOptions=g;function l(c,b){return[...(b?.getWorkspaceFolders()||[]).map(h=>h.uri),c.extensionLocation]}}),define(we[214],be([0,1,21,60,6,11,24,2,8,53,65,5,7]),function(re,e,u,M,E,P,F,T,C,A,t,_,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class m{constructor(r,w){this.document=r,this._storagePath=w,this._backupCounter=1,this._edits=new t.Cache("custom documents")}addEdit(r){return this._edits.add([r])}async undo(r,w){await this.getEdit(r).undo(),w||this.disposeBackup()}async redo(r,w){await this.getEdit(r).redo(),w||this.disposeBackup()}disposeEdits(r){for(const w of r)this._edits.delete(w)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const r=d(this.document.uri)+this._backupCounter++;return(0,F.joinPath)(this._storagePath,r)}updateBackup(r){this._backup?.delete(),this._backup=r}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(r){const w=this._edits.get(r,0);if(!w)throw new Error("No edit found");return w}}class a{constructor(){this._documents=new Map}get(r,w){return this._documents.get(this.key(r,w))}add(r,w,s){const n=this.key(r,w.uri);if(this._documents.has(n))throw new Error(`Document already exists for viewType:${r} resource:${w.uri}`);const g=new m(w,s);return this._documents.set(n,g),g}delete(r,w){const s=this.key(r,w.uri);this._documents.delete(s)}key(r,w){return`${r}@@@${w}`}}var f;(function(D){D[D.Text=0]="Text",D[D.Custom=1]="Custom"})(f||(f={}));class p{constructor(){this._providers=new Map}addTextProvider(r,w,s){return this.add(0,r,w,s)}addCustomProvider(r,w,s){return this.add(1,r,w,s)}get(r){return this._providers.get(r)}add(r,w,s,n){if(this._providers.has(w))throw new Error(`Provider for viewType:${w} already registered`);return this._providers.set(w,{type:r,extension:s,provider:n}),new i.Disposable(()=>this._providers.delete(w))}}class S{constructor(r,w,s,n,g){this._extHostDocuments=w,this._extensionStoragePaths=s,this._extHostWebview=n,this._extHostWebviewPanels=g,this._editorProviders=new p,this._documents=new a,this._proxy=r.getProxy(_.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(r,w,s,n){const g=new E.DisposableStore;return v(s)?(g.add(this._editorProviders.addTextProvider(w,r,s)),this._proxy.$registerTextEditorProvider((0,A.toExtensionData)(r),w,n.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,A.shouldSerializeBuffersForPostMessage)(r))):(g.add(this._editorProviders.addCustomProvider(w,r,s)),this.supportEditing(s)&&g.add(s.onDidChangeCustomDocument(l=>{const c=this.getCustomDocumentEntry(w,l.document.uri);if(o(l)){const b=c.addEdit(l);this._proxy.$onDidEdit(l.document.uri,w,b,l.label)}else this._proxy.$onContentChange(l.document.uri,w)})),this._proxy.$registerCustomEditorProvider((0,A.toExtensionData)(r),w,n.webviewOptions||{},!!n.supportsMultipleEditorsPerDocument,(0,A.shouldSerializeBuffersForPostMessage)(r))),i.Disposable.from(g,new i.Disposable(()=>{this._proxy.$unregisterEditorProvider(w)}))}async $createCustomDocument(r,w,s,n,g){const l=this._editorProviders.get(w);if(!l)throw new Error(`No provider found for '${w}'`);if(l.type!==1)throw new Error(`Invalid provide type for '${w}'`);const c=T.URI.revive(r),b=await l.provider.openCustomDocument(c,{backupId:s,untitledDocumentData:n?.buffer},g);let h;return this.supportEditing(l.provider)&&this._extensionStoragePaths&&(h=this._extensionStoragePaths.workspaceValue(l.extension)??this._extensionStoragePaths.globalValue(l.extension)),this._documents.add(w,b,h),{editable:this.supportEditing(l.provider)}}async $disposeCustomDocument(r,w){const s=this._editorProviders.get(w);if(!s)throw new Error(`No provider found for '${w}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${w}'`);const n=T.URI.revive(r),{document:g}=this.getCustomDocumentEntry(w,n);this._documents.delete(w,g),g.dispose()}async $resolveWebviewEditor(r,w,s,n,g,l){const c=this._editorProviders.get(s);if(!c)throw new Error(`No provider found for '${s}'`);const b=C.ViewColumn.to(g),h=this._extHostWebview.createNewWebview(w,n.webviewOptions,c.extension),y=this._extHostWebviewPanels.createNewWebviewPanel(w,s,n.title,b,n.panelOptions,h),R=T.URI.revive(r);switch(c.type){case 1:{const{document:I}=this.getCustomDocumentEntry(s,R);return c.provider.resolveCustomEditor(I,y,l)}case 0:{const I=this._extHostDocuments.getDocument(R);return c.provider.resolveCustomTextEditor(I,y,l)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,w,s){this.getCustomDocumentEntry(w,r).disposeEdits(s)}async $onMoveCustomEditor(r,w,s){const n=this._editorProviders.get(s);if(!n)throw new Error(`No provider found for '${s}'`);if(!n.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const g=this._extHostWebviewPanels.getWebviewPanel(r);if(!g)throw new Error("No webview found");const l=T.URI.revive(w),c=this._extHostDocuments.getDocument(l);await n.provider.moveCustomTextEditor(c,g,u.CancellationToken.None)}async $undo(r,w,s,n){return this.getCustomDocumentEntry(w,r).undo(s,n)}async $redo(r,w,s,n){return this.getCustomDocumentEntry(w,r).redo(s,n)}async $revert(r,w,s){const n=this.getCustomDocumentEntry(w,r);await this.getCustomEditorProvider(w).revertCustomDocument(n.document,s),n.disposeBackup()}async $onSave(r,w,s){const n=this.getCustomDocumentEntry(w,r);await this.getCustomEditorProvider(w).saveCustomDocument(n.document,s),n.disposeBackup()}async $onSaveAs(r,w,s,n){const g=this.getCustomDocumentEntry(w,r);return this.getCustomEditorProvider(w).saveCustomDocumentAs(g.document,T.URI.revive(s),n)}async $backup(r,w,s){const n=this.getCustomDocumentEntry(w,r),l=await this.getCustomEditorProvider(w).backupCustomDocument(n.document,{destination:n.getNewBackupUri()},s);return n.updateBackup(l),l.id}getCustomDocumentEntry(r,w){const s=this._documents.get(r,T.URI.revive(w));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(r){const s=this._editorProviders.get(r)?.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(r){return!!r.onDidChangeCustomDocument}}e.ExtHostCustomEditors=S;function v(D){return typeof D.resolveCustomTextEditor=="function"}function o(D){return typeof D.undo=="function"&&typeof D.redo=="function"}function d(D){const r=D.scheme===P.Schemas.file||D.scheme===P.Schemas.untitled?D.fsPath:D.toString();return(0,M.hash)(r)+""}});var Ze=this&&this.__classPrivateFieldSet||function(re,e,u,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,u):E?E.value=u:e.set(re,u),u},Te=this&&this.__classPrivateFieldGet||function(re,e,u,M){if(u==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?M:u==="a"?M.call(re):M?M.value:e.get(re)};define(we[215],be([0,1,3,6,2,37,8,53,5,7]),function(re,e,u,M,E,P,F,T,C,A){"use strict";var t,_,i,m,a,f,p,S,v,o,d,D,r;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class w extends M.Disposable{constructor(l,c,b,h,y,R,I){super();t.set(this,void 0),_.set(this,void 0),i.set(this,void 0),m.set(this,void 0),a.set(this,void 0),f.set(this,void 0),p.set(this,void 0),S.set(this,void 0),v.set(this,!0),o.set(this,!0),d.set(this,!1),D.set(this,this._register(new u.Emitter)),this.onDidDispose=Te(this,D,"f").event,r.set(this,this._register(new u.Emitter)),this.onDidChangeViewState=Te(this,r,"f").event,Ze(this,t,l,"f"),Ze(this,_,c,"f"),Ze(this,i,b,"f"),Ze(this,a,R,"f"),Ze(this,S,y,"f"),Ze(this,f,h,"f"),Ze(this,m,I,"f")}dispose(){Te(this,d,"f")||(Ze(this,d,!0,"f"),Te(this,D,"f").fire(),Te(this,_,"f").$disposeWebview(Te(this,t,"f")),Te(this,m,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Te(this,m,"f")}get viewType(){return this.assertNotDisposed(),Te(this,i,"f")}get title(){return this.assertNotDisposed(),Te(this,f,"f")}set title(l){this.assertNotDisposed(),Te(this,f,"f")!==l&&(Ze(this,f,l,"f"),Te(this,_,"f").$setTitle(Te(this,t,"f"),l))}get iconPath(){return this.assertNotDisposed(),Te(this,p,"f")}set iconPath(l){this.assertNotDisposed(),Te(this,p,"f")!==l&&(Ze(this,p,l,"f"),Te(this,_,"f").$setIconPath(Te(this,t,"f"),E.URI.isUri(l)?{light:l,dark:l}:l))}get options(){return Te(this,a,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Te(this,S,"f")=="number"&&Te(this,S,"f")<0))return Te(this,S,"f")}get active(){return this.assertNotDisposed(),Te(this,o,"f")}get visible(){return this.assertNotDisposed(),Te(this,v,"f")}_updateViewState(l){Te(this,d,"f")||(this.active!==l.active||this.visible!==l.visible||this.viewColumn!==l.viewColumn)&&(Ze(this,o,l.active,"f"),Ze(this,v,l.visible,"f"),Ze(this,S,l.viewColumn,"f"),Te(this,r,"f").fire({webviewPanel:this}))}reveal(l,c){this.assertNotDisposed(),Te(this,_,"f").$reveal(Te(this,t,"f"),{viewColumn:l?F.ViewColumn.from(l):void 0,preserveFocus:!!c})}assertNotDisposed(){if(Te(this,d,"f"))throw new Error("Webview is disposed")}}t=new WeakMap,_=new WeakMap,i=new WeakMap,m=new WeakMap,a=new WeakMap,f=new WeakMap,p=new WeakMap,S=new WeakMap,v=new WeakMap,o=new WeakMap,d=new WeakMap,D=new WeakMap,r=new WeakMap;class s{constructor(l,c,b){this.webviews=c,this.workspace=b,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=l.getProxy(C.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,P.generateUuid)()}createWebviewPanel(l,c,b,h,y={}){const R=typeof h=="object"?h.viewColumn:h,I={viewColumn:F.ViewColumn.from(R),preserveFocus:typeof h=="object"&&!!h.preserveFocus},B=(0,T.shouldSerializeBuffersForPostMessage)(l),L=s.newHandle();this._proxy.$createWebviewPanel((0,T.toExtensionData)(l),L,c,{title:b,panelOptions:n(y),webviewOptions:(0,T.serializeWebviewOptions)(l,this.workspace,y),serializeBuffersForPostMessage:B},I);const k=this.webviews.createNewWebview(L,y,l);return this.createNewWebviewPanel(L,c,b,R,y,k)}$onDidChangeWebviewPanelViewStates(l){const c=Object.keys(l);c.sort((b,h)=>{const y=l[b],R=l[h];return y.active?1:R.active?-1:+y.visible-+R.visible});for(const b of c){const h=this.getWebviewPanel(b);if(!h)continue;const y=l[b];h._updateViewState({active:y.active,visible:y.visible,viewColumn:F.ViewColumn.to(y.position)})}}async $onDidDisposeWebviewPanel(l){this.getWebviewPanel(l)?.dispose(),this._webviewPanels.delete(l),this.webviews.deleteWebview(l)}registerWebviewPanelSerializer(l,c,b){if(this._serializers.has(c))throw new Error(`Serializer for '${c}' already registered`);return this._serializers.set(c,{serializer:b,extension:l}),this._proxy.$registerSerializer(c,{serializeBuffersForPostMessage:(0,T.shouldSerializeBuffersForPostMessage)(l)}),new A.Disposable(()=>{this._serializers.delete(c),this._proxy.$unregisterSerializer(c)})}async $deserializeWebviewPanel(l,c,b,h){const y=this._serializers.get(c);if(!y)throw new Error(`No serializer found for '${c}'`);const{serializer:R,extension:I}=y,B=this.webviews.createNewWebview(l,b.webviewOptions,I),L=this.createNewWebviewPanel(l,c,b.title,h,b.panelOptions,B);await R.deserializeWebviewPanel(L,b.state)}createNewWebviewPanel(l,c,b,h,y,R){const I=new w(l,this._proxy,c,b,h,y,R);return this._webviewPanels.set(l,I),I}getWebviewPanel(l){return this._webviewPanels.get(l)}}e.ExtHostWebviewPanels=s;function n(g){return{enableFindWidget:g.enableFindWidget,retainContextWhenHidden:g.retainContextWhenHidden}}});var Ze=this&&this.__classPrivateFieldSet||function(re,e,u,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,u):E?E.value=u:e.set(re,u),u},Te=this&&this.__classPrivateFieldGet||function(re,e,u,M){if(u==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?M:u==="a"?M.call(re):M?M.value:e.get(re)};define(we[216],be([0,1,3,6,53,5,7]),function(re,e,u,M,E,P,F){"use strict";var T,C,A,t,_,i,m,a,f,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class S extends M.Disposable{constructor(d,D,r,w,s,n){super();T.set(this,void 0),C.set(this,void 0),A.set(this,void 0),t.set(this,void 0),_.set(this,!1),i.set(this,void 0),m.set(this,void 0),a.set(this,void 0),f.set(this,this._register(new u.Emitter)),this.onDidChangeVisibility=Te(this,f,"f").event,p.set(this,this._register(new u.Emitter)),this.onDidDispose=Te(this,p,"f").event,Ze(this,A,r,"f"),Ze(this,m,w,"f"),Ze(this,T,d,"f"),Ze(this,C,D,"f"),Ze(this,t,s,"f"),Ze(this,i,n,"f")}dispose(){Te(this,_,"f")||(Ze(this,_,!0,"f"),Te(this,p,"f").fire(),Te(this,t,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Te(this,m,"f")}set title(d){this.assertNotDisposed(),Te(this,m,"f")!==d&&(Ze(this,m,d,"f"),Te(this,C,"f").$setWebviewViewTitle(Te(this,T,"f"),d))}get description(){return this.assertNotDisposed(),Te(this,a,"f")}set description(d){this.assertNotDisposed(),Te(this,a,"f")!==d&&(Ze(this,a,d,"f"),Te(this,C,"f").$setWebviewViewDescription(Te(this,T,"f"),d))}get visible(){return Te(this,i,"f")}get webview(){return Te(this,t,"f")}get viewType(){return Te(this,A,"f")}_setVisible(d){d===Te(this,i,"f")||Te(this,_,"f")||(Ze(this,i,d,"f"),Te(this,f,"f").fire())}show(d){this.assertNotDisposed(),Te(this,C,"f").$show(Te(this,T,"f"),!!d)}assertNotDisposed(){if(Te(this,_,"f"))throw new Error("Webview is disposed")}}T=new WeakMap,C=new WeakMap,A=new WeakMap,t=new WeakMap,_=new WeakMap,i=new WeakMap,m=new WeakMap,a=new WeakMap,f=new WeakMap,p=new WeakMap;class v{constructor(d,D){this._extHostWebview=D,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=d.getProxy(P.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(d,D,r,w){if(this._viewProviders.has(D))throw new Error(`View provider for '${D}' already registered`);return this._viewProviders.set(D,{provider:r,extension:d}),this._proxy.$registerWebviewViewProvider((0,E.toExtensionData)(d),D,{retainContextWhenHidden:w?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new F.Disposable(()=>{this._viewProviders.delete(D),this._proxy.$unregisterWebviewViewProvider(D)})}async $resolveWebviewView(d,D,r,w,s){const n=this._viewProviders.get(D);if(!n)throw new Error(`No view provider found for '${D}'`);const{provider:g,extension:l}=n,c=this._extHostWebview.createNewWebview(d,{},l),b=new S(d,this._proxy,D,r,c,!0);this._webviewViews.set(d,b),await g.resolveWebviewView(b,{state:w},s)}async $onDidChangeWebviewViewVisibility(d,D){this.getWebviewView(d)._setVisible(D)}async $disposeWebviewView(d){const D=this.getWebviewView(d);this._webviewViews.delete(d),D.dispose(),this._extHostWebview.deleteWebview(d)}getWebviewView(d){const D=this._webviewViews.get(d);if(!D)throw new Error("No webview found");return D}}e.ExtHostWebviewViews=v}),define(we[97],be([0,1,3,5,2,11,9,4,14]),function(re,e,u,M,E,P,F,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let A=class $i{constructor(_){this._onDidChangeWindowState=new u.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=$i.InitialState,this._proxy=_.getProxy(M.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(i=>this.$onDidChangeWindowFocus(i))}get state(){return this._state}$onDidChangeWindowFocus(_){_!==this._state.focused&&(this._state={...this._state,focused:_},this._onDidChangeWindowState.fire(this._state))}openUri(_,i){let m;if(typeof _=="string"){m=_;try{_=E.URI.parse(_)}catch(a){return Promise.reject(`Invalid uri - '${_}'`)}}return(0,F.isFalsyOrWhitespace)(_.scheme)?Promise.reject("Invalid scheme - cannot be empty"):_.scheme===P.Schemas.command?Promise.reject(`Invalid scheme '${_.scheme}'`):this._proxy.$openUri(_,m,i)}async asExternalUri(_,i){if((0,F.isFalsyOrWhitespace)(_.scheme))return Promise.reject("Invalid scheme - cannot be empty");const m=await this._proxy.$asExternalUri(_,i);return E.URI.from(m)}};A.InitialState={focused:!0},A=Ue([Be(0,C.IExtHostRpcService)],A),e.ExtHostWindow=A,e.IExtHostWindow=(0,T.createDecorator)("IExtHostWindow")}),define(we[217],be([0,1,13,22,21,16,3,6,108,184,39]),function(re,e,u,M,E,P,F,T,C,A,t){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function i(y,R){try{return JSON.stringify(y,R)}catch(I){return"null"}}const m="$$ref$$",a={[m]:-1};class f{constructor(R,I){this.jsonString=R,this.referencedBuffers=I}}function p(y,R=null,I=!1){const B=[];return{jsonString:(I?i:JSON.stringify)(y,(k,x)=>{if(typeof x=="undefined")return a;if(typeof x=="object"){if(x instanceof M.VSBuffer){const N=B.push(x)-1;return{[m]:N}}if(R)return R(k,x)}return x}),referencedBuffers:B}}e.stringifyJsonWithBufferRefs=p;function S(y,R,I){return JSON.parse(y,(B,L)=>{if(L){const k=L[m];if(typeof k=="number")return R[k];if(I&&L.$mid===1)return I.transformIncoming(L)}return L})}e.parseJsonAndRestoreBufferRefs=S;function v(y,R){return JSON.stringify(y,R)}function o(y){return y?(R,I)=>I&&I.$mid===1?y.transformOutgoing(I):I:null}var d;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));var D;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(D=e.ResponsiveState||(e.ResponsiveState={}));const r=()=>{},w=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class n extends T.Disposable{constructor(R,I=null,B=null){super();this[_]=!0,this._onDidChangeResponsiveState=this._register(new F.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=R,this._logger=I,this._uriTransformer=B,this._uriReplacer=o(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let L=0,k=t.ProxyIdentifier.count;L<k;L++)this._locals[L]=null,this._proxies[L]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new u.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(L=>this._receiveOneMessage(L))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(R=>{this._pendingRPCReplies[R].resolveErr(P.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(R){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+n.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(R){this._unresponsiveTime=Date.now()+n.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(R){this._responsiveState!==R&&(this._responsiveState=R,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(R){return this._uriTransformer?(0,C.transformIncomingURIs)(R,this._uriTransformer):R}getProxy(R){const{nid:I,sid:B}=R;return this._proxies[I]||(this._proxies[I]=this._createProxy(I,B)),this._proxies[I]}_createProxy(R,I){let B={get:(L,k)=>(typeof k=="string"&&!L[k]&&k.charCodeAt(0)===36&&(L[k]=(...x)=>this._remoteCall(R,k,x)),k===s?I:L[k])};return new Proxy(Object.create(null),B)}set(R,I){return this._locals[R.nid]=I,I}assertRegistered(R){for(let I=0,B=R.length;I<B;I++){const L=R[I];if(!this._locals[L.nid])throw new Error(`Missing actor ${L.sid} (isMain: ${L.isMain})`)}}_receiveOneMessage(R){if(this._isDisposed)return;const I=R.byteLength,B=g.read(R,0),L=B.readUInt8(),k=B.readUInt32();switch(L){case 1:case 2:{let{rpcId:x,method:N,args:V}=c.deserializeRequestJSONArgs(B);this._uriTransformer&&(V=(0,C.transformIncomingURIs)(V,this._uriTransformer)),this._receiveRequest(I,k,x,N,V,L===2);break}case 3:case 4:{let{rpcId:x,method:N,args:V}=c.deserializeRequestMixedArgs(B);this._uriTransformer&&(V=(0,C.transformIncomingURIs)(V,this._uriTransformer)),this._receiveRequest(I,k,x,N,V,L===4);break}case 5:{this._logger&&this._logger.logIncoming(I,k,0,"ack"),this._onDidReceiveAcknowledge(k);break}case 6:{this._receiveCancel(I,k);break}case 7:{this._receiveReply(I,k,void 0);break}case 9:{let x=c.deserializeReplyOKJSON(B);this._uriTransformer&&(x=(0,C.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReply(I,k,x);break}case 10:{const x=c.deserializeReplyOKJSONWithBuffers(B,this._uriTransformer);this._receiveReply(I,k,x);break}case 8:{let x=c.deserializeReplyOKVSBuffer(B);this._receiveReply(I,k,x);break}case 11:{let x=c.deserializeReplyErrError(B);this._uriTransformer&&(x=(0,C.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReplyErr(I,k,x);break}case 12:{this._receiveReplyErr(I,k,void 0);break}default:console.error("received unexpected message"),console.error(R)}}_receiveRequest(R,I,B,L,k,x){this._logger&&this._logger.logIncoming(R,I,1,`receiveRequest ${(0,t.getStringIdentifierForProxy)(B)}.${L}(`,k);const N=String(I);let V,W;if(x){const X=new E.CancellationTokenSource;k.push(X.token),V=this._invokeHandler(B,L,k),W=()=>X.cancel()}else V=this._invokeHandler(B,L,k),W=r;this._cancelInvokedHandlers[N]=W;const $=c.serializeAcknowledged(I);this._logger&&this._logger.logOutgoing($.byteLength,I,1,"ack"),this._protocol.send($),V.then(X=>{delete this._cancelInvokedHandlers[N];const j=c.serializeReplyOK(I,X,this._uriReplacer);this._logger&&this._logger.logOutgoing(j.byteLength,I,1,"reply:",X),this._protocol.send(j)},X=>{delete this._cancelInvokedHandlers[N];const j=c.serializeReplyErr(I,X);this._logger&&this._logger.logOutgoing(j.byteLength,I,1,"replyErr:",X),this._protocol.send(j)})}_receiveCancel(R,I){this._logger&&this._logger.logIncoming(R,I,1,"receiveCancel");const B=String(I);this._cancelInvokedHandlers[B]&&this._cancelInvokedHandlers[B]()}_receiveReply(R,I,B){this._logger&&this._logger.logIncoming(R,I,0,"receiveReply:",B);const L=String(I);if(!this._pendingRPCReplies.hasOwnProperty(L))return;const k=this._pendingRPCReplies[L];delete this._pendingRPCReplies[L],k.resolveOk(B)}_receiveReplyErr(R,I,B){this._logger&&this._logger.logIncoming(R,I,0,"receiveReplyErr:",B);const L=String(I);if(!this._pendingRPCReplies.hasOwnProperty(L))return;const k=this._pendingRPCReplies[L];delete this._pendingRPCReplies[L];let x;B&&(B.$isError?(x=new Error,x.name=B.name,x.message=B.message,x.stack=B.stack):x=B),k.resolveErr(x)}_invokeHandler(R,I,B){try{return Promise.resolve(this._doInvokeHandler(R,I,B))}catch(L){return Promise.reject(L)}}_doInvokeHandler(R,I,B){const L=this._locals[R];if(!L)throw new Error("Unknown actor "+(0,t.getStringIdentifierForProxy)(R));let k=L[I];if(typeof k!="function")throw new Error("Unknown method "+I+" on actor "+(0,t.getStringIdentifierForProxy)(R));return k.apply(L,B)}_remoteCall(R,I,B){if(this._isDisposed)return Promise.reject(P.canceled());let L=null;if(B.length>0&&E.CancellationToken.isCancellationToken(B[B.length-1])&&(L=B.pop()),L&&L.isCancellationRequested)return Promise.reject(P.canceled());const k=c.serializeRequestArguments(B,this._uriReplacer),x=++this._lastMessageId,N=String(x),V=new A.LazyPromise;L&&L.onCancellationRequested(()=>{const $=c.serializeCancel(x);this._logger&&this._logger.logOutgoing($.byteLength,x,0,"cancel"),this._protocol.send(c.serializeCancel(x))}),this._pendingRPCReplies[N]=V,this._onWillSendRequest(x);const W=c.serializeRequest(x,R,I,k,!!L);return this._logger&&this._logger.logOutgoing(W.byteLength,x,0,`request: ${(0,t.getStringIdentifierForProxy)(R)}.${I}(`,B),this._protocol.send(W),V}}e.RPCProtocol=n,_=w,n.UNRESPONSIVE_TIME=3*1e3;class g{constructor(R,I){this._buff=R,this._offset=I}static alloc(R,I,B){let L=new g(M.VSBuffer.alloc(B+1+4),0);return L.writeUInt8(R),L.writeUInt32(I),L}static read(R,I){return new g(R,I)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(R){this._buff.writeUInt8(R,this._offset),this._offset+=1}readUInt8(){const R=this._buff.readUInt8(this._offset);return this._offset+=1,R}writeUInt32(R){this._buff.writeUInt32BE(R,this._offset),this._offset+=4}readUInt32(){const R=this._buff.readUInt32BE(this._offset);return this._offset+=4,R}static sizeShortString(R){return 1+R.byteLength}writeShortString(R){this._buff.writeUInt8(R.byteLength,this._offset),this._offset+=1,this._buff.set(R,this._offset),this._offset+=R.byteLength}readShortString(){const R=this._buff.readUInt8(this._offset);this._offset+=1;const B=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,B}static sizeLongString(R){return 4+R.byteLength}writeLongString(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readLongString(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const B=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,B}writeBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}static sizeVSBuffer(R){return 4+R.byteLength}writeVSBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readVSBuffer(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const I=this._buff.slice(this._offset,this._offset+R);return this._offset+=R,I}static sizeMixedArray(R){let I=0;I+=1;for(let B=0,L=R.length;B<L;B++){const k=R[B];switch(I+=1,k.type){case 1:I+=this.sizeLongString(k.value);break;case 2:I+=this.sizeVSBuffer(k.value);break;case 3:I+=this.sizeUInt32,I+=this.sizeLongString(k.value);for(let x=0;x<k.buffers.length;++x)I+=this.sizeVSBuffer(k.buffers[x]);break;case 4:break}}return I}writeMixedArray(R){this._buff.writeUInt8(R.length,this._offset),this._offset+=1;for(let I=0,B=R.length;I<B;I++){const L=R[I];switch(L.type){case 1:this.writeUInt8(1),this.writeLongString(L.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(L.value);break;case 3:this.writeUInt8(3),this.writeUInt32(L.buffers.length),this.writeLongString(L.value);for(let k=0;k<L.buffers.length;++k)this.writeBuffer(L.buffers[k]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const R=this._buff.readUInt8(this._offset);this._offset+=1;let I=new Array(R);for(let B=0;B<R;B++)switch(this.readUInt8()){case 1:I[B]=this.readLongString();break;case 2:I[B]=this.readVSBuffer();break;case 3:const k=this.readUInt32(),x=this.readLongString(),N=[];for(let V=0;V<k;++V)N.push(this.readVSBuffer());I[B]=new t.SerializableObjectWithBuffers(S(x,N,null));break;case 4:I[B]=void 0;break}return I}}g.sizeUInt32=4;var l;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(l||(l={}));class c{static _useMixedArgSerialization(R){for(let I=0,B=R.length;I<B;I++)if(R[I]instanceof M.VSBuffer||R[I]instanceof t.SerializableObjectWithBuffers||typeof R[I]=="undefined")return!0;return!1}static serializeRequestArguments(R,I){if(this._useMixedArgSerialization(R)){const B=[];for(let L=0,k=R.length;L<k;L++){const x=R[L];if(x instanceof M.VSBuffer)B[L]={type:2,value:x};else if(typeof x=="undefined")B[L]={type:4};else if(x instanceof t.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:V}=p(x.value,I);B[L]={type:3,value:M.VSBuffer.fromString(N),buffers:V}}else B[L]={type:1,value:M.VSBuffer.fromString(v(x,I))}}return{type:1,args:B}}return{type:0,args:v(R,I)}}static serializeRequest(R,I,B,L,k){switch(L.type){case 0:return this._requestJSONArgs(R,I,B,L.args,k);case 1:return this._requestMixedArgs(R,I,B,L.args,k)}}static _requestJSONArgs(R,I,B,L,k){const x=M.VSBuffer.fromString(B),N=M.VSBuffer.fromString(L);let V=0;V+=g.sizeUInt8(),V+=g.sizeShortString(x),V+=g.sizeLongString(N);let W=g.alloc(k?2:1,R,V);return W.writeUInt8(I),W.writeShortString(x),W.writeLongString(N),W.buffer}static deserializeRequestJSONArgs(R){const I=R.readUInt8(),B=R.readShortString(),L=R.readLongString();return{rpcId:I,method:B,args:JSON.parse(L)}}static _requestMixedArgs(R,I,B,L,k){const x=M.VSBuffer.fromString(B);let N=0;N+=g.sizeUInt8(),N+=g.sizeShortString(x),N+=g.sizeMixedArray(L);let V=g.alloc(k?4:3,R,N);return V.writeUInt8(I),V.writeShortString(x),V.writeMixedArray(L),V.buffer}static deserializeRequestMixedArgs(R){const I=R.readUInt8(),B=R.readShortString(),L=R.readMixedArray(),k=new Array(L.length);for(let x=0,N=L.length;x<N;x++){const V=L[x];typeof V=="string"?k[x]=JSON.parse(V):k[x]=V}return{rpcId:I,method:B,args:k}}static serializeAcknowledged(R){return g.alloc(5,R,0).buffer}static serializeCancel(R){return g.alloc(6,R,0).buffer}static serializeReplyOK(R,I,B){if(typeof I=="undefined")return this._serializeReplyOKEmpty(R);if(I instanceof M.VSBuffer)return this._serializeReplyOKVSBuffer(R,I);if(I instanceof t.SerializableObjectWithBuffers){const{jsonString:L,referencedBuffers:k}=p(I.value,B,!0);return this._serializeReplyOKJSONWithBuffers(R,L,k)}else return this._serializeReplyOKJSON(R,i(I,B))}static _serializeReplyOKEmpty(R){return g.alloc(7,R,0).buffer}static _serializeReplyOKVSBuffer(R,I){let B=0;B+=g.sizeVSBuffer(I);let L=g.alloc(8,R,B);return L.writeVSBuffer(I),L.buffer}static deserializeReplyOKVSBuffer(R){return R.readVSBuffer()}static _serializeReplyOKJSON(R,I){const B=M.VSBuffer.fromString(I);let L=0;L+=g.sizeLongString(B);let k=g.alloc(9,R,L);return k.writeLongString(B),k.buffer}static _serializeReplyOKJSONWithBuffers(R,I,B){const L=M.VSBuffer.fromString(I);let k=0;k+=g.sizeUInt32,k+=g.sizeLongString(L);for(const N of B)k+=g.sizeVSBuffer(N);let x=g.alloc(10,R,k);x.writeUInt32(B.length),x.writeLongString(L);for(const N of B)x.writeBuffer(N);return x.buffer}static deserializeReplyOKJSON(R){const I=R.readLongString();return JSON.parse(I)}static deserializeReplyOKJSONWithBuffers(R,I){const B=R.readUInt32(),L=R.readLongString(),k=[];for(let x=0;x<B;++x)k.push(R.readVSBuffer());return new t.SerializableObjectWithBuffers(S(L,k,I))}static serializeReplyErr(R,I){return I?this._serializeReplyErrEror(R,I):this._serializeReplyErrEmpty(R)}static _serializeReplyErrEror(R,I){const B=M.VSBuffer.fromString(i(P.transformErrorForSerialization(I),null));let L=0;L+=g.sizeLongString(B);let k=g.alloc(11,R,L);return k.writeLongString(B),k.buffer}static deserializeReplyErrError(R){const I=R.readLongString();return JSON.parse(I)}static _serializeReplyErrEmpty(R){return g.alloc(12,R,0).buffer}}var b;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(b||(b={}));var h;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(h||(h={}))}),define(we[218],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const u=function(P){const F=T=>{self.removeEventListener("message",F);const C=T.data;Object.defineProperties(self,{postMessage:{value(A,t){C.postMessage(A,t)}},onmessage:{get(){return C.onmessage},set(A){C.onmessage=A}}}),C.addEventListener("message",A=>{self.dispatchEvent(new MessageEvent("message",{data:A.data}))}),C.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(P)};self.addEventListener("message",F)}.toString();class M extends EventTarget{constructor(P,F,T){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const C=`((${u})('${F}'))`,A=new Blob([C],{type:"application/javascript"}),t=URL.createObjectURL(A),_=new MessageChannel,i=t,m={type:"_newWorker",id:i,port:_.port2,url:t,options:T};P(m,[_.port2]),this.postMessage=_.port1.postMessage.bind(_.port1),this.terminate=()=>{const a={type:"_terminateWorker",id:i};_.port1.postMessage(a),URL.revokeObjectURL(t),_.port1.close(),_.port2.close()},Object.defineProperties(this,{onmessage:{get(){return _.port1.onmessage},set(a){_.port1.onmessage=a}},onmessageerror:{get(){return _.port1.onmessageerror},set(a){_.port1.onmessageerror=a}}}),_.port1.addEventListener("messageerror",a=>{const f=new MessageEvent("messageerror",{data:a.data});this.dispatchEvent(f)}),_.port1.addEventListener("message",a=>{const f=new MessageEvent("message",{data:a.data});this.dispatchEvent(f)}),_.port1.start()}}e.NestedWorker=M}),define(we[219],be([0,1,4]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,u.createDecorator)("remoteAgentService")}),define(we[220],be([0,1,11,17,25,2,4,64,49,180,219]),function(re,e,u,M,E,P,F,T,C,A,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,F.createDecorator)("pathService");let _=class Wi{constructor(m,a,f,p){this.localUserHome=m,this.remoteAgentService=a,this.environmentService=f,this.contextService=p,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||E.OS)(),this.resolveUserHome=(async()=>{const S=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=S?.userHome||m})()}get defaultUriScheme(){return Wi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(m,a){if(m.remoteAuthority)return u.Schemas.vscodeRemote;const f=(0,T.getVirtualWorkspaceScheme)(a.getWorkspace());if(f)return f;const p=a.getWorkspace().folders[0];if(p)return p.uri.scheme;const S=a.getWorkspace().configuration;return S?S.scheme:u.Schemas.file}async userHome(m){return m?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(m=>m===1?M.win32:M.posix)}async fileURI(m){let a="";if(await this.resolveOS===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const p=m.indexOf("/",2);p===-1?(a=m.substring(2),m="/"):(a=m.substring(2,p),m=m.substring(p)||"/")}return P.URI.from({scheme:u.Schemas.file,authority:a,path:m,query:"",fragment:""})}};_=Ue([Be(1,t.IRemoteAgentService),Be(2,A.IWorkbenchEnvironmentService),Be(3,C.IWorkspaceContextService)],_),e.AbstractPathService=_}),define(we[98],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class u{constructor(F,T){this.line=F,this.character=T}isBefore(F){return!1}isBeforeOrEqual(F){return!1}isAfter(F){return!1}isAfterOrEqual(F){return!1}isEqual(F){return!1}compareTo(F){return 0}translate(F,T){return new u(0,0)}with(F){return new u(0,0)}}e.Position=u;class M{constructor(F,T,C,A){this.isEmpty=!1,this.isSingleLine=!1,this.start=new u(F,T),this.end=new u(C,A)}contains(F){return!1}isEqual(F){return!1}intersection(F){}union(F){return new M(0,0,0,0)}with(F){return new M(0,0,0,0)}}e.Range=M;var E;(function(P){P[P.Information=1]="Information",P[P.Warning=2]="Warning"})(E=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(we[42],be([0,1,15,28,23,44,9,4,17,16,98,10]),function(re,e,u,M,E,P,F,T,C,A,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return t.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const i="\u27EA ",m=" characters skipped \u27EB",a=(i.length+m.length+5)*2;e.ISearchService=(0,T.createDecorator)("searchService");var f;(function($){$[$.file=0]="file",$[$.text=1]="text"})(f=e.SearchProviderType||(e.SearchProviderType={}));var p;(function($){$[$.File=1]="File",$[$.Text=2]="Text"})(p=e.QueryType||(e.QueryType={}));function S($){return!!$.preview}e.resultIsMatch=S;function v($){return!!$.resource}e.isFileMatch=v;function o($){return!!$.message}e.isProgressMessage=o;var d;(function($){$[$.Normal=0]="Normal",$[$.NewSearchStarted=1]="NewSearchStarted"})(d=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class D{constructor(X){this.resource=X,this.results=[]}}e.FileMatch=D;class r{constructor(X,j,Q){this.ranges=j;const ae=Array.isArray(j)?j:[j];if(Q&&Q.matchLines===1&&w(ae)){X=(0,F.getNLines)(X,Q.matchLines);let pe="",ce=0,Fe=0;const Qe=Math.floor(Q.charsPerLine/5),Oe=[];for(const He of ae){const Je=Math.max(He.startColumn-Qe,0),Ye=He.startColumn+Q.charsPerLine;if(Je>Fe+Qe+a){const qe=i+(Je-Fe)+m;pe+=qe+X.slice(Je,Ye),ce+=Je-(Fe+qe.length)}else pe+=X.slice(Fe,Ye);Oe.push(new n(0,He.startColumn-ce,He.endColumn-ce)),Fe=Ye}this.preview={text:pe,matches:Array.isArray(this.ranges)?Oe:Oe[0]}}else{const pe=Array.isArray(j)?j[0].startLineNumber:j.startLineNumber;this.preview={text:X,matches:(0,u.mapArrayOrNot)(j,ce=>new s(ce.startLineNumber-pe,ce.startColumn,ce.endLineNumber-pe,ce.endColumn))}}}}e.TextSearchMatch=r;function w($){const X=$[0].startLineNumber;for(const j of $)if(j.startLineNumber!==X||j.endLineNumber!==X)return!1;return!0}class s{constructor(X,j,Q,ae){this.startLineNumber=X,this.startColumn=j,this.endLineNumber=Q,this.endColumn=ae}}e.SearchRange=s;class n extends s{constructor(X,j,Q){super(X,j,X,Q)}}e.OneLineRange=n;var g;(function($){$.Default="default",$.FileNames="fileNames",$.Type="type",$.Modified="modified",$.CountDescending="countDescending",$.CountAscending="countAscending"})(g=e.SearchSortOrder||(e.SearchSortOrder={}));function l($,X=!0){const j=$&&$.files&&$.files.exclude,Q=X&&$&&$.search&&$.search.exclude;if(!j&&!Q)return;if(!j||!Q)return j||Q;let ae=Object.create(null);return ae=E.mixin(ae,E.deepClone(j)),ae=E.mixin(ae,E.deepClone(Q),!0),ae}e.getExcludes=l;function c($,X){return $.excludePattern&&M.match($.excludePattern,X)?!1:$.includePattern||$.usingSearchPaths?$.includePattern&&M.match($.includePattern,X)?!0:$.usingSearchPaths?!!$.folderQueries&&$.folderQueries.some(j=>{const Q=j.folder.fsPath;if(P.isEqualOrParent(X,Q)){const ae=C.relative(Q,X);return!j.includePattern||!!M.match(j.includePattern,ae)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var b;(function($){$[$.unknownEncoding=1]="unknownEncoding",$[$.regexParseError=2]="regexParseError",$[$.globParseError=3]="globParseError",$[$.invalidLiteral=4]="invalidLiteral",$[$.rgProcessError=5]="rgProcessError",$[$.other=6]="other",$[$.canceled=7]="canceled"})(b=e.SearchErrorCode||(e.SearchErrorCode={}));class h extends Error{constructor(X,j){super(X);this.code=j}}e.SearchError=h;function y($){const X=$.message;if((0,A.isPromiseCanceledError)($))return new h(X,b.canceled);try{const j=JSON.parse(X);return new h(j.message,j.code)}catch(j){return new h(X,b.other)}}e.deserializeSearchError=y;function R($){const X={message:$.message,code:$.code};return new Error(JSON.stringify(X))}e.serializeSearchError=R;function I($){return $.type==="error"?!0:$.type==="success"}e.isSerializedSearchComplete=I;function B($){return $.type==="success"}e.isSerializedSearchSuccess=B;function L($){return!!$.path}e.isSerializedFileMatch=L;function k($,X){const j=$.searchPath?$.searchPath:$.relativePath;return(0,F.fuzzyContains)(j,X)}e.isFilePatternMatch=k;class x{constructor(X){this.path=X,this.results=[]}addMatch(X){this.results.push(X)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=x;function N($,X){const j={...$||{},...X||{}};return Object.keys(j).filter(Q=>{const ae=j[Q];return typeof ae=="boolean"&&ae})}e.resolvePatternsForProvider=N;class V{constructor(X,j){this._parsedIncludeExpression=null,this._excludeExpression={...X.excludePattern||{},...j.excludePattern||{}},this._parsedExcludeExpression=M.parse(this._excludeExpression);let Q=X.includePattern;j.includePattern&&(Q?Q={...Q,...j.includePattern}:Q=j.includePattern),Q&&(this._parsedIncludeExpression=M.parse(Q))}matchesExcludesSync(X,j,Q){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(X,j,Q))}includedInQuerySync(X,j,Q){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(X,j,Q)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(X,j,Q))}includedInQuery(X,j,Q){const ae=this._parsedExcludeExpression(X,j,Q),pe=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(X,j,Q):!0;return(0,_.isPromise)(ae)?ae.then(ce=>ce?!1:pe()):pe()}hasSiblingExcludeClauses(){return W(this._excludeExpression)}}e.QueryGlobTester=V;function W($){for(const X in $)if(typeof $[X]!="boolean")return!0;return!1}}),define(we[32],be([0,1,15,13,21,3,20,11,76,24,9,10,2,131,4,12,145,49,31,27,14,7,42,5]),function(re,e,u,M,E,P,F,T,C,A,t,_,i,m,a,f,p,S,v,o,d,D,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(R,I,B){return new A.ExtUri(L=>c(L,B)).isEqual(R,I)}function n(R,I,B){return s(R.uri,I.uri,B)?0:(0,t.compare)(R.uri.toString(),I.uri.toString())}function g(R,I,B){return R.index!==I.index?R.index<I.index?-1:1:s(R.uri,I.uri,B)?(0,t.compare)(R.name,I.name):(0,t.compare)(R.uri.toString(),I.uri.toString())}function l(R,I,B,L){const k=R.slice(0).sort((N,V)=>B(N,V,L)),x=I.slice(0).sort((N,V)=>B(N,V,L));return(0,u.delta)(k,x,(N,V)=>B(N,V,L))}function c(R,I){const B=I.getCapabilities(R.scheme);return!(B&&B&1024)}class b extends S.Workspace{constructor(I,B,L,k,x,N,V){super(I,L.map(W=>new S.WorkspaceFolder(W)),k,x,V);this._name=B,this._isUntitled=N,this._workspaceFolders=[],this._structure=F.TernarySearchTree.forUris(V),L.forEach(W=>{this._workspaceFolders.push(W),this._structure.set(W.uri,W)})}static toExtHostWorkspace(I,B,L,k){if(!I)return{workspace:null,added:[],removed:[]};const{id:x,name:N,folders:V,configuration:W,transient:$,isUntitled:X}=I,j=[],Q=B;B?V.forEach((Fe,Qe)=>{const Oe=i.URI.revive(Fe.uri),He=b._findFolder(L||B,Oe,k);He?(He.name=Fe.name,He.index=Fe.index,j.push(He)):j.push({uri:Oe,name:Fe.name,index:Qe})}):j.push(...V.map(({uri:Fe,name:Qe,index:Oe})=>({uri:i.URI.revive(Fe),name:Qe,index:Oe}))),j.sort((Fe,Qe)=>Fe.index<Qe.index?-1:1);const ae=new b(x,N,j,!!$,W?i.URI.revive(W):null,!!X,Fe=>c(Fe,k)),{added:pe,removed:ce}=l(Q?Q.workspaceFolders:[],ae.workspaceFolders,n,k);return{workspace:ae,added:pe,removed:ce}}static _findFolder(I,B,L){for(let k=0;k<I.folders.length;k++){const x=I.workspaceFolders[k];if(s(x.uri,B,L))return x}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(I,B){return B&&this._structure.get(I)&&(I=(0,A.dirname)(I)),this._structure.findSubstr(I)}resolveWorkspaceFolder(I){return this._structure.get(I)}}let h=class{constructor(I,B,L,k){this._onDidChangeWorkspace=new P.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new P.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=k,this._extHostFileSystemInfo=L,this._requestIdProvider=new C.Counter,this._barrier=new M.Barrier,this._proxy=I.getProxy(w.MainContext.MainThreadWorkspace),this._messageService=I.getProxy(w.MainContext.MainThreadMessageService);const x=B.workspace;this._confirmedWorkspace=x?new b(x.id,x.name,[],!!x.transient,x.configuration?i.URI.revive(x.configuration):null,!!x.isUntitled,N=>c(N,L)):void 0}$initializeWorkspace(I,B){this._trusted=B,this.$acceptWorkspaceData(I),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?i.URI.from({scheme:T.Schemas.untitled,path:(0,A.basename)((0,A.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(I,B,L,...k){const x=[];if(Array.isArray(k)&&k.forEach(X=>{i.URI.isUri(X.uri)&&!x.some(j=>s(j.uri,X.uri,this._extHostFileSystemInfo))&&x.push({uri:X.uri,name:X.name||(0,A.basenameOrAuthority)(X.uri)})}),this._unconfirmedWorkspace||[B,L].some(X=>typeof X!="number"||X<0)||L===0&&x.length===0)return!1;const N=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(B+L>N.length)return!1;const V=N.slice(0);V.splice(B,L,...x.map(X=>({uri:X.uri,name:X.name||(0,A.basenameOrAuthority)(X.uri),index:void 0})));for(let X=0;X<V.length;X++){const j=V[X];if(V.some((Q,ae)=>ae!==X&&s(j.uri,Q.uri,this._extHostFileSystemInfo)))return!1}V.forEach((X,j)=>X.index=j);const{added:W,removed:$}=l(N,V,g,this._extHostFileSystemInfo);if(W.length===0&&$.length===0)return!1;if(this._proxy){const X=I.displayName||I.name;this._proxy.$updateWorkspaceFolders(X,B,L,x).then(void 0,j=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(p.Severity.Error,(0,m.localize)(0,null,X,j.toString()),{extension:I},[])})}return this.trySetWorkspaceFolders(V),!0}getWorkspaceFolder(I,B){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(I,B)}async getWorkspaceFolder2(I,B){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(I,B)}async resolveWorkspaceFolder(I){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(I)}getPath(){if(!this._actualWorkspace)return;const{folders:I}=this._actualWorkspace;if(I.length!==0)return I[0].uri.fsPath}getRelativePath(I,B){let L,k="";if(typeof I=="string"?(L=i.URI.file(I),k=I):typeof I!="undefined"&&(L=I,k=I.fsPath),!L)return k;const x=this.getWorkspaceFolder(L,!0);if(!x)return k;typeof B=="undefined"&&this._actualWorkspace&&(B=this._actualWorkspace.folders.length>1);let N=(0,A.relativePath)(x.uri,L);return B&&x.name&&(N=`${x.name}/${N}`),N}trySetWorkspaceFolders(I){this._actualWorkspace&&(this._unconfirmedWorkspace=b.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:I,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(I){const{workspace:B,added:L,removed:k}=b.toExtHostWorkspace(I,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=B||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:L,removed:k}))}findFiles(I,B,L,k,x=E.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${k.value}, entryPoint: findFiles`);let N;if(B===null?N=!1:B&&(typeof B=="string"?N=B:N=B.pattern),x&&x.isCancellationRequested)return Promise.resolve([]);const{includePattern:V,folder:W}=y(I);return this._proxy.$startFileSearch((0,_.withUndefinedAsNull)(V),(0,_.withUndefinedAsNull)(W),(0,_.withUndefinedAsNull)(N),(0,_.withUndefinedAsNull)(L),x).then($=>Array.isArray($)?$.map(X=>i.URI.revive(X)):[])}async findTextInFiles(I,B,L,k,x=E.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${k.value}, entryPoint: findTextInFiles`);const N=this._requestIdProvider.getNext(),V=typeof B.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:W,folder:$}=y(B.include),X=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,j={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:V,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:W,excludePattern:X},Q=!1;if(this._activeSearchCallbacks[N]=ae=>{if(Q)return;const pe=i.URI.revive(ae.resource);ae.results.forEach(ce=>{(0,r.resultIsMatch)(ce)?L({uri:pe,preview:{text:ce.preview.text,matches:(0,u.mapArrayOrNot)(ce.preview.matches,Fe=>new D.Range(Fe.startLineNumber,Fe.startColumn,Fe.endLineNumber,Fe.endColumn))},ranges:(0,u.mapArrayOrNot)(ce.ranges,Fe=>new D.Range(Fe.startLineNumber,Fe.startColumn,Fe.endLineNumber,Fe.endColumn))}):L({uri:pe,text:ce.text,lineNumber:ce.lineNumber})})},x.isCancellationRequested)return{};try{const ae=await this._proxy.$startTextSearch(I,(0,_.withUndefinedAsNull)($),j,N,x);return delete this._activeSearchCallbacks[N],ae||{}}catch(ae){throw delete this._activeSearchCallbacks[N],ae}}$handleTextSearchResult(I,B){this._activeSearchCallbacks[B]&&this._activeSearchCallbacks[B](I)}saveAll(I){return this._proxy.$saveAll(I)}resolveProxy(I){return this._proxy.$resolveProxy(I)}get trusted(){return this._trusted}requestWorkspaceTrust(I){return this._proxy.$requestWorkspaceTrust(I)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};h=Ue([Be(0,d.IExtHostRpcService),Be(1,o.IExtHostInitDataService),Be(2,v.IExtHostFileSystemInfo),Be(3,f.ILogService)],h),e.ExtHostWorkspace=h,e.IExtHostWorkspace=(0,a.createDecorator)("IExtHostWorkspace");function y(R){let I,B;return R&&(typeof R=="string"?I=R:(I=R.pattern,B=R.baseFolder||i.URI.file(R.base))),{includePattern:I,folder:B}}}),define(we[33],be([0,1,23,3,32,5,7,148,63,10,13,4,14,12,2]),function(re,e,u,M,E,P,F,T,C,A,t,_,i,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function f(w,s){if(s){const n=s.split(".");let g=w;for(let l=0;g&&l<n.length;l++)g=g[n[l]];return g}}function p(w){return w instanceof a.URI}function S(w){return w&&w.uri instanceof a.URI&&w.languageId&&typeof w.languageId=="string"}function v(w){return w&&!w.uri&&w.languageId&&typeof w.languageId=="string"}function o(w){return w&&w.uri instanceof a.URI&&(!w.name||typeof w.name=="string")&&(!w.index||typeof w.index=="number")}function d(w){if(p(w))return{resource:w};if(S(w))return{resource:w.uri,overrideIdentifier:w.languageId};if(v(w))return{overrideIdentifier:w.languageId};if(o(w))return{resource:w.uri};if(w===null)return{resource:null}}let D=class{constructor(s,n,g){this._proxy=s.getProxy(P.MainContext.MainThreadConfiguration),this._extHostWorkspace=n,this._logService=g,this._barrier=new t.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new r(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,n){this.getConfigProvider().then(g=>g.$acceptConfigurationChanged(s,n))}};D=Ue([Be(0,i.IExtHostRpcService),Be(1,E.IExtHostWorkspace),Be(2,m.ILogService)],D),e.ExtHostConfiguration=D;class r{constructor(s,n,g,l){this._onDidChangeConfiguration=new M.Emitter,this._proxy=s,this._logService=l,this._extHostWorkspace=n,this._configuration=T.Configuration.parse(g),this._configurationScopes=this._toMap(g.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,n){const g={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=T.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(n,g))}getConfiguration(s,n,g){const l=d(n)||{},c=this._toReadonlyValue(s?f(this._configuration.getValue(void 0,l,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,l,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,l,g?.identifier);function b(y){if(y==null)return null;if(typeof y=="boolean")return y?1:4;switch(y){case F.ConfigurationTarget.Global:return 1;case F.ConfigurationTarget.Workspace:return 4;case F.ConfigurationTarget.WorkspaceFolder:return 5}}const h={has(y){return typeof f(c,y)!="undefined"},get:(y,R)=>{this._validateConfigurationAccess(s?`${s}.${y}`:y,l,g?.identifier);let I=f(c,y);if(typeof I=="undefined")I=R;else{let B;const L=(k,x)=>{let N;const V=()=>{B=B||(0,u.deepClone)(c),N=N||f(B,x)};return(0,A.isObject)(k)?new Proxy(k,{get:(W,$)=>{if(typeof $=="string"&&$.toLowerCase()==="tojson")return V(),()=>N;if(B)return N=N||f(B,x),N[$];const X=W[$];return typeof $=="string"?L(X,`${x}.${$}`):X},set:(W,$,X)=>(V(),N&&(N[$]=X),!0),deleteProperty:(W,$)=>(V(),N&&delete N[$],!0),defineProperty:(W,$,X)=>(V(),N&&Object.defineProperty(N,$,X),!0)}):k};I=L(I,y)}return I},update:(y,R,I,B)=>{y=s?`${s}.${y}`:y;const L=b(I);return R!==void 0?this._proxy.$updateConfigurationOption(L,y,R,l,B):this._proxy.$removeConfigurationOption(L,y,l,B)},inspect:y=>{y=s?`${s}.${y}`:y;const R=(0,u.deepClone)(this._configuration.inspect(y,l,this._extHostWorkspace.workspace));if(R)return{key:y,defaultValue:R.default?.value,globalValue:R.user?.value,workspaceValue:R.workspace?.value,workspaceFolderValue:R.workspaceFolder?.value,defaultLanguageValue:R.default?.override,globalLanguageValue:R.user?.override,workspaceLanguageValue:R.workspace?.override,workspaceFolderLanguageValue:R.workspaceFolder?.override,languageIds:R.overrideIdentifiers}}};return typeof c=="object"&&(0,u.mixin)(h,c,!1),Object.freeze(h)}_toReadonlyValue(s){const n=g=>(0,A.isObject)(g)?new Proxy(g,{get:(l,c)=>n(l[c]),set:(l,c,b)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(c)}' of object`)},deleteProperty:(l,c)=>{throw new Error(`TypeError: Cannot delete read only property '${String(c)}' of object`)},defineProperty:(l,c)=>{throw new Error(`TypeError: Cannot define property '${String(c)}' for a readonly object`)},setPrototypeOf:l=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):g;return n(s)}_validateConfigurationAccess(s,n,g){const l=C.OVERRIDE_PROPERTY_PATTERN.test(s)?4:this._configurationScopes.get(s),c=g?`[${g.value}] `:"";if(l===4){typeof n?.resource=="undefined"&&this._logService.warn(`${c}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(l===3){n?.resource&&this._logService.warn(`${c}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,n){const g=new T.ConfigurationChangeEvent(s,n,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(l,c)=>g.affectsConfiguration(l,d(c))})}_toMap(s){return s.reduce((n,g)=>(n.set(g[0],g[1]),n),new Map)}}e.ExtHostConfigProvider=r,e.IExtHostConfiguration=(0,_.createDecorator)("IExtHostConfiguration")});var Ze=this&&this.__classPrivateFieldSet||function(re,e,u,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,u):E?E.value=u:e.set(re,u),u},Te=this&&this.__classPrivateFieldGet||function(re,e,u,M){if(u==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?M:u==="a"?M.call(re):M?M.value:e.get(re)};define(we[99],be([0,1,2,13,3,5,7,32,51,33,21,41,14,27,4,11,25,12,71,170,16]),function(re,e,u,M,E,P,F,T,C,A,t,_,i,m,a,f,p,S,v,o,d){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var r;(function(x){function N(W){if(W!=null)return W}x.from=N;function V(W){if(W!=null)return W}x.to=V})(r=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var w;(function(x){function N(W){if(W!=null)return W}x.from=N;function V(W){if(W!=null)return W}x.to=V})(w=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(x){function N(W){if(W!=null)return W}x.from=N;function V(W){if(W!=null)return W}x.to=V})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var n;(function(x){function N($){if($){const X=$;return X&&!!X.process}else return!1}x.is=N;function V($){if($==null)return;const X={process:$.process,args:$.args};return $.options&&(X.options=s.from($.options)),X}x.from=V;function W($){if($!=null)return new F.ProcessExecution($.process,$.args,$.options)}x.to=W})(n=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var g;(function(x){function N(W){if(W!=null)return W}x.from=N;function V(W){if(W!=null)return W}x.to=V})(g=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var l;(function(x){function N($){if($){const X=$;return X&&(!!X.commandLine||!!X.command)}else return!1}x.is=N;function V($){if($==null)return;const X={};return $.commandLine!==void 0?X.commandLine=$.commandLine:(X.command=$.command,X.args=$.args),$.options&&(X.options=g.from($.options)),X}x.from=V;function W($){if(!($==null||$.command===void 0&&$.commandLine===void 0))return $.commandLine?new F.ShellExecution($.commandLine,$.options):new F.ShellExecution($.command,$.args?$.args:[],$.options)}x.to=W})(l=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var c;(function(x){function N($){if($){let X=$;return X&&X.customExecution==="customExecution"}else return!1}x.is=N;function V($){return{customExecution:"customExecution"}}x.from=V;function W($,X){return X.get($)}x.to=W})(c=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var b;(function(x){function N(V,W){let $;return V.scope!==void 0&&typeof V.scope!="number"?$=V.scope.uri:V.scope!==void 0&&typeof V.scope=="number"&&(V.scope===F.TaskScope.Workspace&&W&&W.workspaceFile?$=W.workspaceFile:$=o.USER_TASKS_GROUP_KEY),{id:V._id,workspaceFolder:$}}x.from=N})(b=e.TaskHandleDTO||(e.TaskHandleDTO={}));var h;(function(x){function N(V){if(V!=null)return{_id:V.id,isDefault:V.isDefault}}x.from=N})(h=e.TaskGroupDTO||(e.TaskGroupDTO={}));var y;(function(x){function N($,X){if($==null)return[];const j=[];for(let Q of $){const ae=V(Q,X);ae&&j.push(ae)}return j}x.fromMany=N;function V($,X){if($==null)return;let j;$.execution instanceof F.ProcessExecution?j=n.from($.execution):$.execution instanceof F.ShellExecution?j=l.from($.execution):$.execution&&$.execution instanceof F.CustomExecution&&(j=c.from($.execution));const Q=r.from($.definition);let ae;return $.scope?typeof $.scope=="number"?ae=$.scope:ae=$.scope.uri:ae=F.TaskScope.Workspace,!Q||!ae?void 0:{_id:$._id,definition:Q,name:$.name,source:{extensionId:X.identifier.value,label:$.source,scope:ae},execution:j,isBackground:$.isBackground,group:h.from($.group),presentationOptions:w.from($.presentationOptions),problemMatchers:$.problemMatchers,hasDefinedMatchers:$.hasDefinedMatchers,runOptions:$.runOptions?$.runOptions:{reevaluateOnRerun:!0},detail:$.detail}}x.from=V;async function W($,X,j){if($==null)return;let Q;n.is($.execution)?Q=n.to($.execution):l.is($.execution)?Q=l.to($.execution):c.is($.execution)&&(Q=c.to($._id,j));const ae=r.to($.definition);let pe;if($.source&&($.source.scope!==void 0?typeof $.source.scope=="number"?pe=$.source.scope:pe=await X.resolveWorkspaceFolder(u.URI.revive($.source.scope)):pe=F.TaskScope.Workspace),!ae||!pe)return;const ce=new F.Task(ae,pe,$.name,$.source.label,Q,$.problemMatchers);return $.isBackground!==void 0&&(ce.isBackground=$.isBackground),$.group!==void 0&&(ce.group=F.TaskGroup.from($.group._id),ce.group&&$.group.isDefault&&(ce.group=new F.TaskGroup(ce.group.id,ce.group.label),$.group.isDefault&&(ce.group.isDefault=$.group.isDefault))),$.presentationOptions&&(ce.presentationOptions=w.to($.presentationOptions)),$._id&&(ce._id=$._id),$.detail&&(ce.detail=$.detail),ce}x.to=W})(y=e.TaskDTO||(e.TaskDTO={}));var R;(function(x){function N(W){return W}x.from=N;function V(W){if(!!W)return Object.assign(Object.create(null),W)}x.to=V})(R=e.TaskFilterDTO||(e.TaskFilterDTO={}));class I{constructor(N,V,W){this._id=V,this._task=W,D.set(this,void 0),Ze(this,D,N,"f")}get task(){return this._task}terminate(){Te(this,D,"f").terminateTask(this)}fireDidStartProcess(N){}fireDidEndProcess(N){}}D=new WeakMap;var B;(function(x){function N(V){return{id:V._id,task:void 0}}x.from=N})(B=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let L=class{constructor(N,V,W,$,X,j,Q,ae){this._onDidExecuteTask=new E.Emitter,this._onDidTerminateTask=new E.Emitter,this._onDidTaskProcessStarted=new E.Emitter,this._onDidTaskProcessEnded=new E.Emitter,this._proxy=N.getProxy(P.MainContext.MainThreadTask),this._workspaceProvider=W,this._editorService=$,this._configurationService=X,this._terminalService=j,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=Q,this._deprecationService=ae,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(N,V,W){if(!W)return new F.Disposable(()=>{});const $=this.nextHandle();return this._handlers.set($,{type:V,provider:W,extension:N}),this._proxy.$registerTaskProvider($,V),new F.Disposable(()=>{this._handlers.delete($),this._proxy.$unregisterTaskProvider($)})}registerTaskSystem(N,V){this._proxy.$registerTaskSystem(N,V)}fetchTasks(N){return this._proxy.$fetchTasks(R.from(N)).then(async V=>{const W=[];for(let $ of V){const X=await y.to($,this._workspaceProvider,this._providedCustomExecutions2);X&&W.push(X)}return W})}get taskExecutions(){const N=[];return this._taskExecutions.forEach(V=>N.push(V)),N}terminateTask(N){if(!(N instanceof I))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(N._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(N,V,W){const $=this._providedCustomExecutions2.get(N.id);$&&(this._activeCustomExecutions2.set(N.id,$),this._terminalService.attachPtyToTerminal(V,await $.callback(W))),this._lastStartedTask=N.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(N)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(N){const V=await this.getTaskExecution(N);this._taskExecutionPromises.delete(N.id),this._taskExecutions.delete(N.id),this.customExecutionComplete(N),this._onDidTerminateTask.fire({execution:V})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(N){const V=await this.getTaskExecution(N.id);this._onDidTaskProcessStarted.fire({execution:V,processId:N.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(N){const V=await this.getTaskExecution(N.id);this._onDidTaskProcessEnded.fire({execution:V,exitCode:N.exitCode})}$provideTasks(N,V){const W=this._handlers.get(N);if(!W)return Promise.reject(new Error("no handler found"));const $=[],X=(0,M.asPromise)(()=>W.provider.provideTasks(t.CancellationToken.None)).then(j=>this.provideTasksInternal(V,$,W,j));return new Promise(j=>{X.then(Q=>{Promise.all($).then(()=>{j(Q)})})})}async $resolveTask(N,V){const W=this._handlers.get(N);if(!W)return Promise.reject(new Error("no handler found"));if(V.definition.type!==W.type)throw new Error(`Unexpected: Task of type [${V.definition.type}] cannot be resolved by provider of type [${W.type}].`);const $=await y.to(V,this._workspaceProvider,this._providedCustomExecutions2);if(!$)throw new Error("Unexpected: Task cannot be resolved.");const X=await W.provider.resolveTask($,t.CancellationToken.None);if(!X)return;this.checkDeprecation(X,W);const j=y.from(X,W.extension);if(!j)throw new Error("Unexpected: Task cannot be resolved.");if(X.definition!==$.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return c.is(j.execution)&&await this.addCustomExecution(j,X,!0),await this.resolveTaskInternal(j)}nextHandle(){return this._handleCounter++}async addCustomExecution(N,V,W){const $=await this._proxy.$createTaskId(N);!W&&!this._providedCustomExecutions2.has($)&&(this._notProvidedCustomExecutions.add($),this._activeCustomExecutions2.set($,V.execution)),this._providedCustomExecutions2.set($,V.execution)}async getTaskExecution(N,V){if(typeof N=="string"){const X=this._taskExecutionPromises.get(N);if(!X)throw new Error("Unexpected: The specified task is missing an execution");return X}let W=this._taskExecutionPromises.get(N.id);if(W)return W;const $=new Promise((X,j)=>{function Q(ae,pe,ce){ce?X(new I(ae,pe.id,ce)):j("Unexpected: Task does not exist.")}V?Q(this,N,V):y.to(N.task,this._workspaceProvider,this._providedCustomExecutions2).then(ae=>Q(this,N,ae))});return this._taskExecutionPromises.set(N.id,$),$.then(X=>(this._taskExecutions.set(N.id,X),X),X=>Promise.reject(X))}checkDeprecation(N,V){N._deprecated&&this._deprecationService.report("Task.constructor",V.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(N){this._activeCustomExecutions2.get(N.id)&&this._activeCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.has(N.id)&&this._lastStartedTask!==N.id&&(this._providedCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.delete(N.id));let W=this._notProvidedCustomExecutions.values(),$=W.next();for(;!$.done;)!this._activeCustomExecutions2.has($.value)&&this._lastStartedTask!==$.value&&(this._providedCustomExecutions2.delete($.value),this._notProvidedCustomExecutions.delete($.value)),$=W.next()}};L=Ue([Be(0,i.IExtHostRpcService),Be(1,m.IExtHostInitDataService),Be(2,T.IExtHostWorkspace),Be(3,C.IExtHostDocumentsAndEditors),Be(4,A.IExtHostConfiguration),Be(5,_.IExtHostTerminalService),Be(6,S.ILogService),Be(7,v.IExtHostApiDeprecationService)],L),e.ExtHostTaskBase=L;let k=class extends L{constructor(N,V,W,$,X,j,Q,ae){super(N,V,W,$,X,j,Q,ae);this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:"",platform:p.PlatformToString(0)})}async executeTask(N,V){if(!V.execution)throw new Error("Tasks to execute must include an execution");const W=y.from(V,N);if(W===void 0)throw new Error("Task is not valid");if(c.is(W.execution))await this.addCustomExecution(W,V,!1);else throw new d.NotSupportedError;const $=await this.getTaskExecution(await this._proxy.$getTaskExecution(W),V);return this._proxy.$executeTask(W).catch(X=>{throw new Error(X)}),$}provideTasksInternal(N,V,W,$){const X=[];if($)for(let j of $){this.checkDeprecation(j,W),(!j.definition||!N[j.definition.type])&&this._logService.warn(`The task [${j.source}, ${j.name}] uses an undefined task type. The task will be ignored in the future.`);const Q=y.from(j,W.extension);Q&&c.is(Q.execution)?(X.push(Q),V.push(this.addCustomExecution(Q,j,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:X,extension:W.extension}}async resolveTaskInternal(N){if(c.is(N.execution))return N;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(N,V){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(N,V,W){}};k=Ue([Be(0,i.IExtHostRpcService),Be(1,m.IExtHostInitDataService),Be(2,T.IExtHostWorkspace),Be(3,C.IExtHostDocumentsAndEditors),Be(4,A.IExtHostConfiguration),Be(5,_.IExtHostTerminalService),Be(6,S.ILogService),Be(7,v.IExtHostApiDeprecationService)],k),e.WorkerExtHostTask=k,e.IExtHostTask=(0,a.createDecorator)("IExtHostTask")}),define(we[221],be([0,1,15,54,28,78,20,11,17,24,9,10,2,110,135,85,49,92,220,42]),function(re,e,u,M,E,P,F,T,C,A,t,_,i,m,a,f,p,S,v,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let d=class{constructor(b,h,y,R){this.configurationService=b,this.workspaceContextService=h,this.editorGroupsService=y,this.pathService=R}text(b,h,y={}){b=this.getContentPattern(b,y);const R=this.configurationService.getValue(),I=h&&h.some(L=>!this.configurationService.getValue({resource:L}).search.useRipgrep);return{...this.commonQuery(h?.map(p.toWorkspaceFolder),y),type:2,contentPattern:b,previewOptions:y.previewOptions,maxFileSize:y.maxFileSize,usePCRE2:R.search.usePCRE2||I||!1,beforeContext:y.beforeContext,afterContext:y.afterContext,userDisabledExcludesAndIgnoreFiles:y.disregardExcludeSettings&&y.disregardIgnoreFiles}}getContentPattern(b,h){const y=this.configurationService.getValue();b.isRegExp&&(b.pattern=b.pattern.replace(/\r?\n/g,"\\n"));const R={...b,wordSeparators:y.editor.wordSeparators};return this.isCaseSensitive(b,h)&&(R.isCaseSensitive=!0),this.isMultiline(b)&&(R.isMultiline=!0),R}file(b,h={}){return{...this.commonQuery(b,h),type:1,filePattern:h.filePattern?h.filePattern.trim():h.filePattern,exists:h.exists,sortByScore:h.sortByScore,cacheKey:h.cacheKey}}handleIncludeExclude(b,h){return b?(b=Array.isArray(b)?b.map(n):n(b),h?this.parseSearchPaths(b):{pattern:r(...Array.isArray(b)?b:[b])}):{}}commonQuery(b=[],h={}){const y=this.handleIncludeExclude(h.includePattern,h.expandPatterns),R=this.handleIncludeExclude(h.excludePattern,h.expandPatterns),I=b.length>1,B=(y.searchPaths&&y.searchPaths.length?y.searchPaths.map(x=>this.getFolderQueryForSearchPath(x,h,R)):b.map(x=>this.getFolderQueryForRoot(x,h,R,I))).filter(x=>!!x),L={_reason:h._reason,folderQueries:B,usingSearchPaths:!!(y.searchPaths&&y.searchPaths.length),extraFileResources:h.extraFileResources,excludePattern:R.pattern,includePattern:y.pattern,onlyOpenEditors:h.onlyOpenEditors,maxResults:h.maxResults};if(h.onlyOpenEditors){const N=u.coalesce(u.flatten(this.editorGroupsService.groups.map(W=>W.editors.map($=>$.resource)))).filter(W=>(0,o.pathIncludedInQuery)(L,W.fsPath)),V=this.commonQueryFromFileList(N);return{...L,...V}}const k=h.extraFileResources&&h.extraFileResources.filter(x=>(0,o.pathIncludedInQuery)(L,x.fsPath));return L.extraFileResources=k&&k.length?k:void 0,L}commonQueryFromFileList(b){const h=[],y=new F.ResourceMap,R={};let I=!1;return b.forEach(B=>{if(B.scheme===T.Schemas.walkThrough)return;if((0,A.isAbsolutePath)(B)){const k=this.workspaceContextService.getWorkspaceFolder(B)?.uri??B.with({path:C.dirname(B.fsPath)});let x=y.get(k);x||(I=!0,x={folder:k,includePattern:{}},h.push(x),y.set(k,x));const N=C.relative(k.fsPath,B.fsPath);(0,_.assertIsDefined)(x.includePattern)[N.replace(/\\/g,"/")]=!0}else B.fsPath&&(I=!0,R[B.fsPath]=!0)}),{folderQueries:h,includePattern:R,usingSearchPaths:!0,excludePattern:I?void 0:{"**/*":!0}}}isCaseSensitive(b,h){if(h.isSmartCase){if(b.isRegExp){if(t.containsUppercaseCharacter(b.pattern,!0))return!0}else if(t.containsUppercaseCharacter(b.pattern))return!0}return!!b.isCaseSensitive}isMultiline(b){return b.isMultiline||b.isRegExp&&(0,m.isMultilineRegexSource)(b.pattern)||b.pattern.indexOf(`
`)>=0?!0:!!b.isMultiline}parseSearchPaths(b){const h=V=>C.isAbsolute(V)||/^\.\.?([\/\\]|$)/.test(V),R=(Array.isArray(b)?b:w(b)).map(V=>{const W=this.pathService.resolvedUserHome;return W?(0,P.untildify)(V,W.scheme===T.Schemas.file?W.fsPath:W.path):V}),I=M.groupBy(R,V=>h(V)?"searchPaths":"exprSegments"),B=(I.exprSegments||[]).map(V=>t.rtrim(V,"/")).map(V=>t.rtrim(V,"\\")).map(V=>(V[0]==="."&&(V="*"+V),s(V))),L={},k=this.expandSearchPathPatterns(I.searchPaths||[]);k&&k.length&&(L.searchPaths=k);const x=u.flatten(B),N=r(...x);return N&&(L.pattern=N),L}getExcludesForFolder(b,h){return h.disregardExcludeSettings?void 0:(0,o.getExcludes)(b,!h.disregardSearchExcludeSettings)}expandSearchPathPatterns(b){if(!b||!b.length)return[];const h=u.flatten(b.map(R=>{let{pathPortion:I,globPortion:B}=D(R);B&&(B=g(B));const L=this.expandOneSearchPath(I);return u.flatten(L.map(k=>this.resolveOneSearchPathPattern(k,B)))})),y=new Map;return h.forEach(R=>{const I=R.searchPath.toString(),B=y.get(I);B?R.pattern&&(B.pattern=B.pattern||{},B.pattern[R.pattern]=!0):y.set(I,{searchPath:R.searchPath,pattern:R.pattern?r(R.pattern):void 0})}),Array.from(y.values())}expandOneSearchPath(b){if(C.isAbsolute(b)){const h=this.workspaceContextService.getWorkspace().folders;return h[0]&&h[0].uri.scheme!==T.Schemas.file?[{searchPath:h[0].uri.with({path:b})}]:[{searchPath:i.URI.file(C.normalize(b))}]}if(this.workspaceContextService.getWorkbenchState()===2){const h=this.workspaceContextService.getWorkspace().folders[0].uri;if(b=n(b),b.startsWith("../")||b===".."){const R=C.posix.resolve(h.path,b);return[{searchPath:h.with({path:R})}]}const y=g(b);return[{searchPath:h,pattern:y}]}else{if(b==="./"||b===".\\")return[];{const h=b.replace(/^\.[\/\\]/,""),R=this.workspaceContextService.getWorkspace().folders.map(I=>{const B=h.match(new RegExp(`^${t.escapeRegExpCharacters(I.name)}(?:/(.*)|$)`));return B?{match:B,folder:I}:null}).filter(_.isDefined);if(R.length)return R.map(I=>{const B=I.match[1];return{searchPath:I.folder.uri,pattern:B&&g(B)}});{const I=b.match(/\.[\/\\](.+)[\/\\]?/),B=I?I[1]:b,L=a.localize(0,null,B);throw new Error(L)}}}}resolveOneSearchPathPattern(b,h){const y=b.pattern&&h?`${b.pattern}/${h}`:b.pattern||h,R=[{searchPath:b.searchPath,pattern:y}];return y&&!y.endsWith("**")&&R.push({searchPath:b.searchPath,pattern:y+"/**"}),R}getFolderQueryForSearchPath(b,h,y){const R=this.getFolderQueryForRoot((0,p.toWorkspaceFolder)(b.searchPath),h,y,!1);return R?{...R,includePattern:b.pattern}:null}getFolderQueryForRoot(b,h,y,R){let I;const B=i.URI.isUri(b)?b:b.uri;if(y.searchPaths){const V=y.searchPaths.filter(W=>(0,A.isEqual)(W.searchPath,B))[0];if(V&&!V.pattern)return null;V&&(I=V.pattern)}const L=this.configurationService.getValue({resource:B}),x={...this.getExcludesForFolder(L,h)||{},...I||{}},N=i.URI.isUri(b)?(0,A.basename)(b):b.name;return{folder:B,folderName:R?N:void 0,excludePattern:Object.keys(x).length>0?x:void 0,fileEncoding:L.files&&L.files.encoding,disregardIgnoreFiles:typeof h.disregardIgnoreFiles=="boolean"?h.disregardIgnoreFiles:!L.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof h.disregardGlobalIgnoreFiles=="boolean"?h.disregardGlobalIgnoreFiles:!L.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof h.ignoreSymlinks=="boolean"?h.ignoreSymlinks:!L.search.followSymlinks}}};d=Ue([Be(0,f.IConfigurationService),Be(1,p.IWorkspaceContextService),Be(2,S.IEditorGroupsService),Be(3,v.IPathService)],d),e.QueryBuilder=d;function D(c){const b=c.match(/[\*\{\}\(\)\[\]\?]/);if(b){const h=b.index,y=c.substr(0,h).match(/[/|\\][^/\\]*$/);if(y){let R=c.substr(0,y.index);return R.match(/[/\\]/)||(R+="/"),{pathPortion:R,globPortion:c.substr((y.index||0)+1)}}}return{pathPortion:c}}function r(...c){return c.length?c.reduce((b,h)=>(b[h]=!0,b),Object.create(null)):void 0}function w(c){return E.splitGlobAware(c,",").map(b=>b.trim()).filter(b=>!!b.length)}function s(c){return[`**/${c}/**`,`**/${c}`].map(h=>h.replace(/\*\*\/\*\*/g,"**"))}function n(c){return c.replace(/\\/g,"/")}function g(c){return n(c).replace(/^\.\//,"").replace(/\/+$/g,"")}function l(c,b){c=u.distinct(c,R=>R.toString());const h=[],y=b.getWorkspace();return c&&c.forEach(R=>{let I;if(b.getWorkbenchState()===2)I=(0,A.relativePath)(y.folders[0].uri,R),I&&I!=="."&&(I="./"+I);else{const B=b.getWorkspaceFolder(R);if(B){const L=B.name;if(y.folders.filter(x=>x.name===L).length===1){const x=(0,A.relativePath)(B.uri,R);x===""?I=`./${B.name}`:I=`./${B.name}/${x}`}else I=R.fsPath}}I&&h.push(I)}),h}e.resolveResourcesForSearchIncludes=l}),define(we[222],be([0,1,24,2,21,16,4,221,42,49]),function(re,e,u,M,E,P,F,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const t=7e3;function _(f,p){const S=p.activationEvents;if(!S)return Promise.resolve(void 0);const v=[],o=[];for(const n of S)if(/^workspaceContains:/.test(n)){const g=n.substr("workspaceContains:".length);g.indexOf("*")>=0||g.indexOf("?")>=0||f.forceUsingSearch?o.push(g):v.push(g)}if(v.length===0&&o.length===0)return Promise.resolve(void 0);let d;const D=new Promise((n,g)=>{d=n}),r=n=>d({activationEvent:n}),w=Promise.all(v.map(n=>i(f,n,r))).then(()=>{}),s=m(f,p.identifier,o,r);return Promise.all([w,s]).then(()=>{d(void 0)}),D}e.checkActivateWorkspaceContainsExtension=_;async function i(f,p,S){for(const v of f.folders)if(await f.exists(u.joinPath(M.URI.revive(v),p))){S(`workspaceContains:${p}`);return}}async function m(f,p,S,v){if(S.length===0)return Promise.resolve(void 0);const o=new E.CancellationTokenSource,d=f.checkExists(f.folders,S,o.token),D=setTimeout(async()=>{o.cancel(),v(`workspaceContainsTimeout:${S.join(",")}`)},t);let r=!1;try{r=await d}catch(w){P.isPromiseCanceledError(w)||P.onUnexpectedError(w)}o.dispose(),clearTimeout(D),r&&v(`workspaceContains:${S.join(",")}`)}function a(f,p,S,v){const o=f.get(F.IInstantiationService),d=f.get(C.ISearchService),r=o.createInstance(T.QueryBuilder).file(p.map(w=>(0,A.toWorkspaceFolder)(M.URI.revive(w))),{_reason:"checkExists",includePattern:S,exists:!0});return d.fileSearch(r,v).then(w=>!!w.limitHit,w=>P.isPromiseCanceledError(w)?!1:Promise.reject(w))}e.checkGlobFileExists=a});var Ze=this&&this.__classPrivateFieldSet||function(re,e,u,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,u):E?E.value=u:e.set(re,u),u},Te=this&&this.__classPrivateFieldGet||function(re,e,u,M){if(u==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?M:u==="a"?M.call(re):M?M.value:e.get(re)};define(we[34],be([0,1,126,17,75,24,13,6,20,2,12,5,33,183,73,32,30,181,16,26,22,155,7,86,4,27,74,14,62,66,41,3,222,70,157,11]),function(re,e,u,M,E,P,F,T,C,A,t,_,i,m,a,f,p,S,v,o,d,D,r,w,s,n,g,l,c,b,h,y,R,I,B,L){"use strict";var k,x,N;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let V=class zi extends T.Disposable{constructor(j,Q,ae,pe,ce,Fe,Qe,Oe,He,Je){super();this._onDidChangeRemoteConnectionData=this._register(new y.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=Q,this._extHostContext=ae,this._initData=Qe,this._extHostWorkspace=pe,this._extHostConfiguration=ce,this._logService=Fe,this._extHostTunnelService=He,this._extHostTerminalService=Je,this._disposables=new T.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(_.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(_.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(_.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new F.Barrier,this._readyToStartExtensionHost=new F.Barrier,this._readyToRunExtensions=new F.Barrier,this._eagerExtensionsActivated=new F.Barrier,this._registry=new S.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new a.ExtHostStorage(this._extHostContext),this._secretState=new I.ExtHostSecretState(this._extHostContext),this._storagePath=Oe,this._instaService=j.createChild(new c.ServiceCollection([a.IExtHostStorage,this._storage],[I.IExtHostSecretState,this._secretState]));const Ye=new Set;this._initData.hostExtensions.forEach(qe=>Ye.add(o.ExtensionIdentifier.toKey(qe))),this._activator=new m.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(qe,z,K)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(qe,v.transformErrorForSerialization(z),K)},actualActivateExtension:async(qe,z)=>{if(Ye.has(o.ExtensionIdentifier.toKey(qe)))return await this._mainThreadExtensionsProxy.$activateExtension(qe,z),new m.HostExtension;const K=this._registry.getExtensionDescription(qe);return this._activateExtension(K,z)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),E.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(j){v.onUnexpectedError(j)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let j=[];try{j=this._registry.getAllExtensionDescriptions().map(ce=>ce.identifier).filter(ce=>this.isActivated(ce)).map(ce=>this._deactivate(ce))}catch(Q){}await Promise.all(j)}isActivated(j){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(j):!1}_activateByEvent(j,Q){return this._activator.activateByEvent(j,Q)}_activateById(j,Q){return this._activator.activateById(j,Q)}activateByIdWithErrors(j,Q){return this._activateById(j,Q).then(()=>{const ae=this._activator.getActivatedExtension(j);if(ae.activationFailed)return Promise.reject(ae.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(j=>this._registry)}getExtensionExports(j){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(j).exports:null}async _realPathExtensionUri(j){if(j.scheme!==L.Schemas.file)return j;const Q=await this._hostUtils.realpath(j.fsPath);return A.URI.file(Q)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const j=C.TernarySearchTree.forUris(Q=>P.extUriBiasedIgnorePathCase.ignorePathCasing(Q));for(const Q of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(Q)){const ae=await this._realPathExtensionUri(Q.extensionLocation);j.set(ae,Q)}return j})()),this._extensionPathIndex}_deactivate(j){let Q=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(j))return Q;const ae=this._activator.getActivatedExtension(j);if(!ae)return Q;try{typeof ae.module.deactivate=="function"&&(Q=Promise.resolve(ae.module.deactivate()).then(void 0,pe=>(this._logService.error(pe),Promise.resolve(void 0))))}catch(pe){this._logService.error(pe)}try{(0,T.dispose)(ae.subscriptions)}catch(pe){this._logService.error(pe)}return Q}async _activateExtension(j,Q){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(j.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(j.identifier),this._doActivateExtension(j,Q).then(ae=>{const pe=ae.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(j.identifier,pe.codeLoadingTime,pe.activateCallTime,pe.activateResolvedTime,Q),this._logExtensionActivationTimes(j,Q,"success",pe),ae},ae=>{throw this._logExtensionActivationTimes(j,Q,"failure"),ae})}_logExtensionActivationTimes(j,Q,ae,pe){const ce=W(j,Q);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ce,...pe||{},outcome:ae})}_doActivateExtension(j,Q){const ae=W(j,Q);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ae);const pe=this._getEntryPoint(j);if(!pe)return Promise.resolve(new m.EmptyExtension(m.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${j.identifier.value}, startup: ${Q.startup}, activationEvent: '${Q.activationEvent}'${j.identifier.value!==Q.extensionId.value?`, root cause: ${Q.extensionId.value}`:""}`),this._logService.flush();const ce=new m.ExtensionActivationTimesBuilder(Q.startup);return Promise.all([this._loadCommonJSModule(j.identifier,(0,P.joinPath)(j.extensionLocation,pe),ce),this._loadExtensionContext(j)]).then(Fe=>(E.mark(`code/extHost/willActivateExtension/${j.identifier.value}`),zi._callActivate(this._logService,j.identifier,Fe[0],Fe[1],ce))).then(Fe=>(E.mark(`code/extHost/didActivateExtension/${j.identifier.value}`),Fe))}_loadExtensionContext(j){const Q=new D.ExtensionGlobalMemento(j,this._storage),ae=new D.ExtensionMemento(j.identifier.value,!1,this._storage),pe=new B.ExtensionSecrets(j,this._secretState),ce=j.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production,Fe=this._initData.remote.isRemote?r.ExtensionKind.Workspace:r.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${j.identifier.value}`),Promise.all([Q.whenReady,ae.whenReady,this._storagePath.whenReady]).then(()=>{const Qe=this;let Oe;return Object.freeze({globalState:Q,workspaceState:ae,secrets:pe,subscriptions:[],get extensionUri(){return j.extensionLocation},get extensionPath(){return j.extensionLocation.fsPath},asAbsolutePath(He){return M.join(j.extensionLocation.fsPath,He)},get storagePath(){return Qe._storagePath.workspaceValue(j)?.fsPath},get globalStoragePath(){return Qe._storagePath.globalValue(j).fsPath},get logPath(){return M.join(Qe._initData.logsLocation.fsPath,j.identifier.value)},get logUri(){return A.URI.joinPath(Qe._initData.logsLocation,j.identifier.value)},get storageUri(){return Qe._storagePath.workspaceValue(j)},get globalStorageUri(){return Qe._storagePath.globalValue(j)},get extensionMode(){return ce},get extension(){return Oe===void 0&&(Oe=new $(Qe,j.identifier,j,Fe)),Oe},get extensionRuntime(){return(0,p.checkProposedApiEnabled)(j),Qe.extensionRuntime},get environmentVariableCollection(){return Qe._extHostTerminalService.getEnvironmentVariableCollection(j)}})})}static _callActivate(j,Q,ae,pe,ce){return ae=ae||{activate:void 0,deactivate:void 0},this._callActivateOptional(j,Q,ae,pe,ce).then(Fe=>new m.ActivatedExtension(!1,null,ce.build(),ae,Fe,pe.subscriptions))}static _callActivateOptional(j,Q,ae,pe,ce){if(typeof ae.activate=="function")try{ce.activateCallStart(),j.trace(`ExtensionService#_callActivateOptional ${Q.value}`);const Fe=typeof global=="object"?global:self,Qe=ae.activate.apply(Fe,[pe]);return ce.activateCallStop(),ce.activateResolveStart(),Promise.resolve(Qe).then(Oe=>(ce.activateResolveStop(),Oe))}catch(Fe){return Promise.reject(Fe)}else return Promise.resolve(ae)}_activateOneStartupFinished(j,Q){this._activateById(j.identifier,{startup:!1,extensionId:j.identifier,activationEvent:Q}).then(void 0,ae=>{this._logService.error(ae)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(E.getMarks());for(const j of this._registry.getAllExtensionDescriptions())if(j.activationEvents)for(const Q of j.activationEvents)Q==="onStartupFinished"&&this._activateOneStartupFinished(j,Q)}_handleEagerExtensions(){const j=this._activateByEvent("*",!0).then(void 0,ce=>{this._logService.error(ce)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(ce=>this._handleWorkspaceContainsEagerExtensions(ce.added)));const Q=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ae=this._handleWorkspaceContainsEagerExtensions(Q),pe=Promise.all([j,ae]).then(()=>{});return Promise.race([pe,(0,F.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),pe}_handleWorkspaceContainsEagerExtensions(j){return j.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(Q=>this._handleWorkspaceContainsEagerExtension(j,Q))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(j,Q){if(this.isActivated(Q.identifier))return;const ae=!this._initData.remote.isRemote&&!!this._initData.remote.authority,pe={folders:j.map(Fe=>Fe.uri),forceUsingSearch:ae,exists:Fe=>this._hostUtils.exists(Fe.fsPath),checkExists:(Fe,Qe,Oe)=>this._mainThreadWorkspaceProxy.$checkExists(Fe,Qe,Oe)},ce=await(0,R.checkActivateWorkspaceContainsExtension)(pe,Q);if(!!ce)return this._activateById(Q.identifier,{startup:!0,extensionId:Q.identifier,activationEvent:ce.activationEvent}).then(void 0,Fe=>this._logService.error(Fe))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(j){throw console.error(j),j}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:j,extensionTestsLocationURI:Q}=this._initData.environment;if(!j||!Q)throw new Error(u.localize(0,null));const ae=await this._loadCommonJSModule(null,Q,new m.ExtensionActivationTimesBuilder(!1));if(!ae||typeof ae.run!="function")throw new Error(u.localize(1,null,Q.toString()));return new Promise((pe,ce)=>{const Fe=(He,Je)=>{He?ce(He):pe(typeof Je=="number"&&Je>0?1:0)},Qe=(0,P.originalFSPath)(Q),Oe=ae.run(Qe,Fe);Oe&&Oe.then&&Oe.then(()=>{pe(0)}).catch(He=>{ce(He.toString())})})}async $extensionTestsExit(j){this._logService.info(`Extension host terminating: test runner requested exit with code ${j}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${j}`),this._logService.flush(),this._hostUtils.exit(j)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(j,Q){return this._resolvers[j]=Q,(0,T.toDisposable)(()=>{delete this._resolvers[j]})}async _activateAndGetResolver(j){const Q=j.indexOf("+");if(Q===-1)throw new Error("Not an authority that can be resolved!");const ae=j.substr(0,Q);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ae}`,!1),{authorityPrefix:ae,resolver:this._resolvers[ae]}}async $resolveAuthority(j,Q){const{authorityPrefix:ae,resolver:pe}=await this._activateAndGetResolver(j);if(!pe)return{type:"error",error:{code:w.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ae}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(pe)),E.mark(`code/extHost/willResolveAuthority/${ae}`);const ce=await pe.resolve(j,{resolveAttempt:Q});E.mark(`code/extHost/didResolveAuthorityOK/${ae}`);const Fe={authority:j,host:ce.host,port:ce.port,connectionToken:ce.connectionToken},Qe={extensionHostEnv:ce.extensionHostEnv,isTrusted:ce.isTrusted};return{type:"ok",value:{authority:Fe,options:Qe,tunnelInformation:{environmentTunnels:ce.environmentTunnels}}}}catch(ce){if(E.mark(`code/extHost/didResolveAuthorityError/${ae}`),ce instanceof r.RemoteAuthorityResolverError)return{type:"error",error:{code:ce._code,message:ce._message,detail:ce._detail}};throw ce}}async $getCanonicalURI(j,Q){const{authorityPrefix:ae,resolver:pe}=await this._activateAndGetResolver(j);if(!pe)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${ae}`);const ce=A.URI.revive(Q);if(typeof pe.getCanonicalURI=="undefined")return ce;const Fe=await(0,F.asPromise)(()=>pe.getCanonicalURI(ce));return Fe||ce}$startExtensionHost(j){return this._registry.keepOnly(j),this._startExtensionHost()}$activateByEvent(j,Q){return Q===1?this._activateByEvent(j,!1):this._readyToRunExtensions.wait().then(ae=>this._activateByEvent(j,!1))}async $activate(j,Q){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(j)?(await this._activateById(j,Q),!0):!1}async $deltaExtensions(j,Q){j.forEach(pe=>pe.extensionLocation=A.URI.revive(pe.extensionLocation));const ae=await this.getExtensionPathIndex();return await Promise.all(Q.map(async pe=>{const ce=this._registry.getExtensionDescription(pe);ce&&ae.delete(await this._realPathExtensionUri(ce.extensionLocation))})),await Promise.all(j.map(async pe=>{const ce=await this._realPathExtensionUri(pe.extensionLocation);ae.set(ce,pe)})),this._registry.deltaExtensions(j,Q),Promise.resolve(void 0)}async $test_latency(j){return j}async $test_up(j){return j.byteLength}async $test_down(j){let Q=d.VSBuffer.alloc(j),ae=Math.random()%256;for(let pe=0;pe<j;pe++)Q.writeUInt8(ae,pe);return Q}async $updateRemoteConnectionData(j){this._remoteConnectionData=j,this._onDidChangeRemoteConnectionData.fire()}};V=Ue([Be(0,s.IInstantiationService),Be(1,e.IHostUtils),Be(2,l.IExtHostRpcService),Be(3,f.IExtHostWorkspace),Be(4,i.IExtHostConfiguration),Be(5,t.ILogService),Be(6,n.IExtHostInitDataService),Be(7,g.IExtensionStoragePaths),Be(8,b.IExtHostTunnelService),Be(9,h.IExtHostTerminalService)],V),e.AbstractExtHostExtensionService=V;function W(X,j){return{id:X.identifier.value,name:X.name,extensionVersion:X.version,publisherDisplayName:X.publisher,activationEvents:X.activationEvents?X.activationEvents.join(","):null,isBuiltin:X.isBuiltin,reason:j.activationEvent,reasonId:j.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class ${constructor(j,Q,ae,pe){k.set(this,void 0),x.set(this,void 0),N.set(this,void 0),Ze(this,k,j,"f"),Ze(this,x,Q,"f"),Ze(this,N,ae.identifier,"f"),this.id=ae.identifier.value,this.extensionUri=ae.extensionLocation,this.extensionPath=M.normalize((0,P.originalFSPath)(ae.extensionLocation)),this.packageJSON=ae,this.extensionKind=pe}get isActive(){return Te(this,k,"f").isActivated(Te(this,N,"f"))}get exports(){if(this.packageJSON.api!=="none")return Te(this,k,"f").getExtensionExports(Te(this,N,"f"))}activate(){return Te(this,k,"f").activateByIdWithErrors(Te(this,N,"f"),{startup:!1,extensionId:Te(this,x,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=$,k=new WeakMap,x=new WeakMap,N=new WeakMap}),define(we[100],be([0,1,17,2,3,13,5,7,165,32,34,51,172,33,166,14,4,10,91,72]),function(re,e,u,M,E,P,F,T,C,A,t,_,i,m,a,f,p,S,v,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,p.createDecorator)("IExtHostDebugService");let d=class{constructor(c,b,h,y,R,I){this._workspaceService=b,this._extensionService=h,this._editorsService=y,this._configurationService=R,this._editorTabs=I,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new E.Emitter,this._onDidTerminateDebugSession=new E.Emitter,this._onDidChangeActiveDebugSession=new E.Emitter,this._onDidReceiveDebugSessionCustomEvent=new E.Emitter,this._debugServiceProxy=c.getProxy(F.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new E.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new r(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(B=>{B.onDidChange(L=>{this.registerAllDebugTypes(B)}),this.registerAllDebugTypes(B)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(c,b){const h=c;if(typeof h.sourceReference=="number"&&h.sourceReference>0){let y=`debug:${encodeURIComponent(h.path||"")}`,R="?";return b&&(y+=`${R}session=${encodeURIComponent(b.id)}`,R="&"),y+=`${R}ref=${h.sourceReference}`,M.URI.parse(y)}else{if(h.path)return M.URI.file(h.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(c){const b=[];for(const h of c.getAllExtensionDescriptions())if(h.contributes){const y=h.contributes.debuggers;if(y&&y.length>0)for(const R of y)(0,a.isDebuggerMainContribution)(R)&&b.push(R.type)}this._debugServiceProxy.$registerDebugTypes(b)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const c=[];return this._breakpoints.forEach(b=>c.push(b)),c}addBreakpoints(c){this.startBreakpoints();const b=c.filter(R=>{const I=R.id;return this._breakpoints.has(I)?!1:(this._breakpoints.set(I,R),!0)});this.fireBreakpointChanges(b,[],[]);const h=[],y=new Map;for(const R of b)if(R instanceof T.SourceBreakpoint){let I=y.get(R.location.uri.toString());I||(I={type:"sourceMulti",uri:R.location.uri,lines:[]},y.set(R.location.uri.toString(),I),h.push(I)),I.lines.push({id:R.id,enabled:R.enabled,condition:R.condition,hitCondition:R.hitCondition,logMessage:R.logMessage,line:R.location.range.start.line,character:R.location.range.start.character})}else R instanceof T.FunctionBreakpoint&&h.push({type:"function",id:R.id,enabled:R.enabled,hitCondition:R.hitCondition,logMessage:R.logMessage,condition:R.condition,functionName:R.functionName});return this._debugServiceProxy.$registerBreakpoints(h)}removeBreakpoints(c){this.startBreakpoints();const b=c.filter(I=>this._breakpoints.delete(I.id));this.fireBreakpointChanges([],b,[]);const h=b.filter(I=>I instanceof T.SourceBreakpoint).map(I=>I.id),y=b.filter(I=>I instanceof T.FunctionBreakpoint).map(I=>I.id),R=b.filter(I=>I instanceof T.DataBreakpoint).map(I=>I.id);return this._debugServiceProxy.$unregisterBreakpoints(h,y,R)}startDebugging(c,b,h){return this._debugServiceProxy.$startDebugging(c?c.uri:void 0,b,{parentSessionID:h.parentSession?h.parentSession.id:void 0,lifecycleManagedByParent:h.lifecycleManagedByParent,repl:h.consoleMode===T.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:h.noDebug,compact:h.compact,debugUI:h.debugUI,suppressSaveBeforeStart:h.suppressSaveBeforeStart})}stopDebugging(c){return this._debugServiceProxy.$stopDebugging(c?c.id:void 0)}registerDebugConfigurationProvider(c,b,h){if(!b)return new T.Disposable(()=>{});const y=this._configProviderHandleCounter++;return this._configProviders.push({type:c,handle:y,provider:b}),this._debugServiceProxy.$registerDebugConfigurationProvider(c,h,!!b.provideDebugConfigurations,!!b.resolveDebugConfiguration,!!b.resolveDebugConfigurationWithSubstitutedVariables,y),new T.Disposable(()=>{this._configProviders=this._configProviders.filter(R=>R.provider!==b),this._debugServiceProxy.$unregisterDebugConfigurationProvider(y)})}registerDebugAdapterDescriptorFactory(c,b,h){if(!h)return new T.Disposable(()=>{});if(!this.definesDebugType(c,b))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${b}' debugger.`);if(this.getAdapterDescriptorFactoryByType(b))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const y=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:b,handle:y,factory:h}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(b,y),new T.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(R=>R.factory!==h),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(y)})}registerDebugAdapterTrackerFactory(c,b){if(!b)return new T.Disposable(()=>{});const h=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:c,handle:h,factory:b}),new T.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(y=>y.factory!==b)})}async $runInTerminal(c,b){return Promise.resolve(void 0)}async $substituteVariables(c,b){if(!this._variableResolver){const[R,I]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(R||[],this._editorsService,I)}let h;const y=await this.getFolder(c);return y&&(h={uri:y.uri,name:y.name,index:y.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(h,b)}createDebugAdapter(c,b){if(c.type==="implementation")return new n(c.implementation)}createSignService(){}async $startDASession(c,b){const h=this,y=await this.getSession(b);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(y.type),y).then(R=>{if(!R)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${y.type}' (extension might have failed to activate)`);const I=this.convertToDto(R),B=this.createDebugAdapter(I,y);if(!B)throw new Error(`Couldn't create a debug adapter for type '${y.type}'.`);const L=B;return this._debugAdapters.set(c,L),this.getDebugAdapterTrackers(y).then(k=>(k&&this._debugAdaptersTrackers.set(c,k),L.onMessage(async x=>{if(x.type==="request"&&x.command==="handshake"){const N=x,V={type:"response",seq:0,command:N.command,request_seq:N.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const W=await this._signService.sign(N.arguments.value);V.body={signature:W},L.sendResponse(V)}else throw new Error("no signer")}catch(W){V.success=!1,V.message=W.message,L.sendResponse(V)}}else k&&k.onDidSendMessage&&k.onDidSendMessage(x),x=(0,a.convertToVSCPaths)(x,!0),h._debugServiceProxy.$acceptDAMessage(c,x)}),L.onError(x=>{k&&k.onError&&k.onError(x),this._debugServiceProxy.$acceptDAError(c,x.name,x.message,x.stack)}),L.onExit(x=>{k&&k.onExit&&k.onExit((0,S.withNullAsUndefined)(x),void 0),this._debugServiceProxy.$acceptDAExit(c,(0,S.withNullAsUndefined)(x),void 0)}),k&&k.onWillStartSession&&k.onWillStartSession(),L.startSession()))})}$sendDAMessage(c,b){b=(0,a.convertToDAPaths)(b,!1);const h=this._debugAdaptersTrackers.get(c);h&&h.onWillReceiveMessage&&h.onWillReceiveMessage(b);const y=this._debugAdapters.get(c);y&&y.sendMessage(b)}$stopDASession(c){const b=this._debugAdaptersTrackers.get(c);this._debugAdaptersTrackers.delete(c),b&&b.onWillStopSession&&b.onWillStopSession();const h=this._debugAdapters.get(c);return this._debugAdapters.delete(c),h?h.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(c){const b=[],h=[],y=[];if(c.added)for(const R of c.added){const I=R.id;if(I&&!this._breakpoints.has(I)){let B;if(R.type==="function")B=new T.FunctionBreakpoint(R.functionName,R.enabled,R.condition,R.hitCondition,R.logMessage);else if(R.type==="data")B=new T.DataBreakpoint(R.label,R.dataId,R.canPersist,R.enabled,R.hitCondition,R.condition,R.logMessage);else{const L=M.URI.revive(R.uri);B=new T.SourceBreakpoint(new T.Location(L,new T.Position(R.line,R.character)),R.enabled,R.condition,R.hitCondition,R.logMessage)}B._id=I,this._breakpoints.set(I,B),b.push(B)}}if(c.removed)for(const R of c.removed){const I=this._breakpoints.get(R);I&&(this._breakpoints.delete(R),h.push(I))}if(c.changed){for(const R of c.changed)if(R.id){const I=this._breakpoints.get(R.id);if(I){if(I instanceof T.FunctionBreakpoint&&R.type==="function"){const B=I;B.enabled=R.enabled,B.condition=R.condition,B.hitCondition=R.hitCondition,B.logMessage=R.logMessage,B.functionName=R.functionName}else if(I instanceof T.SourceBreakpoint&&R.type==="source"){const B=I;B.enabled=R.enabled,B.condition=R.condition,B.hitCondition=R.hitCondition,B.logMessage=R.logMessage,B.location=new T.Location(M.URI.revive(R.uri),new T.Position(R.line,R.character))}y.push(I)}}}this.fireBreakpointChanges(b,h,y)}$provideDebugConfigurations(c,b,h){return(0,P.asPromise)(async()=>{const y=this.getConfigProviderByHandle(c);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const R=await this.getFolder(b);return y.provideDebugConfigurations(R,h)}).then(y=>{if(!y)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return y})}$resolveDebugConfiguration(c,b,h,y){return(0,P.asPromise)(async()=>{const R=this.getConfigProviderByHandle(c);if(!R)throw new Error("no DebugConfigurationProvider found");if(!R.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const I=await this.getFolder(b);return R.resolveDebugConfiguration(I,h,y)})}$resolveDebugConfigurationWithSubstitutedVariables(c,b,h,y){return(0,P.asPromise)(async()=>{const R=this.getConfigProviderByHandle(c);if(!R)throw new Error("no DebugConfigurationProvider found");if(!R.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const I=await this.getFolder(b);return R.resolveDebugConfigurationWithSubstitutedVariables(I,h,y)})}async $provideDebugAdapter(c,b){const h=this.getAdapterDescriptorFactoryByHandle(c);if(!h)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const y=await this.getSession(b);return this.getAdapterDescriptor(h,y).then(R=>{if(!R)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${y.type}'`);return this.convertToDto(R)})}async $acceptDebugSessionStarted(c){const b=await this.getSession(c);this._onDidStartDebugSession.fire(b)}async $acceptDebugSessionTerminated(c){const b=await this.getSession(c);b&&(this._onDidTerminateDebugSession.fire(b),this._debugSessions.delete(b.id))}async $acceptDebugSessionActiveChanged(c){this._activeDebugSession=c?await this.getSession(c):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(c,b){const h=await this.getSession(c);h&&h._acceptNameChanged(b)}async $acceptDebugSessionCustomEvent(c,b){const y={session:await this.getSession(c),event:b.event,body:b.body};this._onDidReceiveDebugSessionCustomEvent.fire(y)}convertToDto(c){if(c instanceof T.DebugAdapterExecutable)return{type:"executable",command:c.command,args:c.args,options:c.options};if(c instanceof T.DebugAdapterServer)return{type:"server",port:c.port,host:c.host};if(c instanceof T.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:c.path};if(c instanceof T.DebugAdapterInlineImplementation)return{type:"implementation",implementation:c.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(c){const b=this._adapterFactories.filter(h=>h.type===c);if(b.length>0)return b[0].factory}getAdapterDescriptorFactoryByHandle(c){const b=this._adapterFactories.filter(h=>h.handle===c);if(b.length>0)return b[0].factory}getConfigProviderByHandle(c){const b=this._configProviders.filter(h=>h.handle===c);if(b.length>0)return b[0].provider}definesDebugType(c,b){if(c.contributes){const h=c.contributes.debuggers;if(h&&h.length>0){for(const y of h)if(y.label&&y.type&&y.type===b)return!0}}return!1}getDebugAdapterTrackers(c){const h=c.configuration.type,y=this._trackerFactories.filter(R=>R.type===h||R.type==="*").map(R=>(0,P.asPromise)(()=>R.factory.createDebugAdapterTracker(c)).then(I=>I,I=>null));return Promise.race([Promise.all(y).then(R=>{const I=R.filter(B=>!!B);if(I.length>0)return new s(I)}),new Promise((R,I)=>{const B=setTimeout(()=>{clearTimeout(B),I(new Error("timeout"))},1e3)})]).catch(R=>{})}async getAdapterDescriptor(c,b){const h=b.configuration.debugServer;if(typeof h=="number")return Promise.resolve(new T.DebugAdapterServer(h));if(c){const R=await this._extensionService.getExtensionRegistry();return(0,P.asPromise)(()=>c.createDebugAdapterDescriptor(b,this.daExecutableFromPackage(b,R))).then(I=>{if(I)return I})}const y=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(b,y))}daExecutableFromPackage(c,b){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(c,b,h){(c.length>0||b.length>0||h.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:c,removed:b,changed:h}))}async getSession(c){if(c)if(typeof c=="string"){const b=this._debugSessions.get(c);if(b)return b}else{let b=this._debugSessions.get(c.id);if(!b){const h=await this.getFolder(c.folderUri),y=c.parent?this._debugSessions.get(c.parent):void 0;b=new D(this._debugServiceProxy,c.id,c.type,c.name,h,c.configuration,y),this._debugSessions.set(b.id,b),this._debugServiceProxy.$sessionCached(b.id)}return b}throw new Error("cannot find session")}getFolder(c){if(c){const b=M.URI.revive(c);return this._workspaceService.resolveWorkspaceFolder(b)}return Promise.resolve(void 0)}};d=Ue([Be(0,f.IExtHostRpcService),Be(1,A.IExtHostWorkspace),Be(2,t.IExtHostExtensionService),Be(3,_.IExtHostDocumentsAndEditors),Be(4,m.IExtHostConfiguration),Be(5,o.IExtHostEditorTabs)],d),e.ExtHostDebugServiceBase=d;class D{constructor(c,b,h,y,R,I,B){this._debugServiceProxy=c,this._id=b,this._type=h,this._name=y,this._workspaceFolder=R,this._configuration=I,this._parentSession=B}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(c){this._name=c,this._debugServiceProxy.$setDebugSessionName(this._id,c)}get parentSession(){return this._parentSession}_acceptNameChanged(c){this._name=c}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(c,b){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,c,b)}getDebugProtocolBreakpoint(c){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,c.id)}}e.ExtHostDebugSession=D;class r{constructor(c){this.value=Object.freeze({append(b){c.$appendDebugConsole(b)},appendLine(b){this.append(b+`
`)}})}}e.ExtHostDebugConsole=r;class w extends i.AbstractVariableResolverService{constructor(c,b,h,y,R){function I(){if(b){const B=b.activeEditor();if(B)return B.document.uri;const L=y.tabs.filter(k=>k.isActive);if(L.length>0){const k=L[0].resource;return k&&(k.primary||k.secondary)?k.primary??k.secondary:L[0].resource}}}super({getFolderUri:B=>{const L=c.filter(k=>k.name===B);if(L&&L.length>0)return L[0].uri},getWorkspaceFolderCount:()=>c.length,getConfigurationValue:(B,L)=>h.getConfiguration(void 0,B).get(L),getAppRoot:()=>v.cwd(),getExecPath:()=>v.env.VSCODE_EXEC_PATH,getFilePath:()=>{const B=I();if(B)return u.normalize(B.fsPath)},getWorkspaceFolderPathForFile:()=>{if(R){const B=I();if(B){const L=R.getWorkspaceFolder(B);if(L)return u.normalize(L.uri.fsPath)}}},getSelectedText:()=>{if(b){const B=b.activeEditor();if(B&&!B.selection.isEmpty)return B.document.getText(B.selection)}},getLineNumber:()=>{if(b){const B=b.activeEditor();if(B)return String(B.selection.end.line+1)}}},void 0,Promise.resolve(v.env))}}e.ExtHostVariableResolverService=w;class s{constructor(c){this.trackers=c}onWillStartSession(){this.trackers.forEach(c=>c.onWillStartSession?c.onWillStartSession():void 0)}onWillReceiveMessage(c){this.trackers.forEach(b=>b.onWillReceiveMessage?b.onWillReceiveMessage(c):void 0)}onDidSendMessage(c){this.trackers.forEach(b=>b.onDidSendMessage?b.onDidSendMessage(c):void 0)}onWillStopSession(){this.trackers.forEach(c=>c.onWillStopSession?c.onWillStopSession():void 0)}onError(c){this.trackers.forEach(b=>b.onError?b.onError(c):void 0)}onExit(c,b){this.trackers.forEach(h=>h.onExit?h.onExit(c,b):void 0)}}class n extends C.AbstractDebugAdapter{constructor(c){super();this.implementation=c,c.onDidSendMessage(b=>{this.acceptMessage(b)})}startSession(){return Promise.resolve(void 0)}sendMessage(c){this.implementation.handleMessage(c)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let g=class extends d{constructor(c,b,h,y,R,I){super(c,b,h,y,R,I)}createVariableResolver(c,b,h){return new w(c,b,h,this._editorTabs)}};g=Ue([Be(0,f.IExtHostRpcService),Be(1,A.IExtHostWorkspace),Be(2,t.IExtHostExtensionService),Be(3,_.IExtHostDocumentsAndEditors),Be(4,m.IExtHostConfiguration),Be(5,o.IExtHostEditorTabs)],g),e.WorkerExtHostDebugService=g}),define(we[223],be([0,1,75,2,5,33,30,26,14,27,4,34,91,12]),function(re,e,u,M,E,P,F,T,C,A,t,_,i,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let a=class{constructor(o,d,D,r,w,s,n){this._apiFactory=o,this._extensionRegistry=d,this._instaService=D,this._extHostConfiguration=r,this._extHostExtensionService=w,this._initData=s,this._logService=n,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),u.mark("code/extHost/willWaitForConfig");const o=await this._extHostConfiguration.getConfigProvider();u.mark("code/extHost/didWaitForConfig");const d=await this._extHostExtensionService.getExtensionPathIndex();this.register(new f(this._apiFactory,d,this._extensionRegistry,o,this._logService)),this.register(this._instaService.createInstance(p,d)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(S,d,this._initData.environment.appUriScheme))}register(o){if(Array.isArray(o.nodeModuleName))for(let d of o.nodeModuleName)this._factories.set(d,o);else this._factories.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this._alternatives.push(d=>o.alternativeModuleName(d))}};a=Ue([Be(2,t.IInstantiationService),Be(3,P.IExtHostConfiguration),Be(4,_.IExtHostExtensionService),Be(5,A.IExtHostInitDataService),Be(6,m.ILogService)],a),e.RequireInterceptor=a;class f{constructor(o,d,D,r,w){this._apiFactory=o,this._extensionPaths=d,this._extensionRegistry=D,this._configProvider=r,this._logService=w,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(o,d){const D=this._extensionPaths.findSubstr(d);if(D){let r=this._extApiImpl.get(T.ExtensionIdentifier.toKey(D.identifier));return r||(r=this._apiFactory(D,this._extensionRegistry,this._configProvider),this._extApiImpl.set(T.ExtensionIdentifier.toKey(D.identifier),r)),r}if(!this._defaultApiImpl){let r="";this._extensionPaths.forEach((w,s)=>r+=`	${s} -> ${w.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${d}. These are the extension path mappings: 
${r}`),this._defaultApiImpl=this._apiFactory(F.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let p=class{constructor(o,d,D){this._extensionPaths=o,this.nodeModuleName="keytar",this._mainThreadTelemetry=d.getProxy(E.MainContext.MainThreadTelemetry);const{environment:r}=D,w=d.getProxy(E.MainContext.MainThreadKeytar);if(r.appRoot){let s=r.appRoot.fsPath;i.platform==="win32"&&(s=s.replace(/\\/g,"/")),s[s.length-1]==="/"&&(s=s.substr(0,s.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${s}/node_modules.asar/keytar`),this.alternativeNames.add(`${s}/node_modules/keytar`)}this._impl={getPassword:(s,n)=>w.$getPassword(s,n),setPassword:(s,n,g)=>w.$setPassword(s,n,g),deletePassword:(s,n)=>w.$deletePassword(s,n),findPassword:s=>w.$findPassword(s),findCredentials(s){return w.$findCredentials(s)}}}load(o,d){const D=this._extensionPaths.findSubstr(d);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:D?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(o){const d=o.length;if(d<=7||!this.alternativeNames)return;const D=d-7;if((o.charAt(D)==="/"||o.charAt(D)==="\\")&&o.endsWith("keytar")&&(o=o.replace(/\\/g,"/"),this.alternativeNames.has(o)))return"keytar"}};p=Ue([Be(1,C.IExtHostRpcService),Be(2,A.IExtHostInitDataService)],p);let S=class{constructor(o,d,D){this._extensionPaths=o,this._appUriScheme=d,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=D.getProxy(E.MainContext.MainThreadTelemetry);const r=D.getProxy(E.MainContext.MainThreadWindow);this._impl=(w,s)=>{const n=M.URI.parse(w);return s?this.callOriginal(w,s):n.scheme==="http"||n.scheme==="https"?r.$openUri(n,w,{allowTunneling:!0}):n.scheme==="mailto"||n.scheme===this._appUriScheme?r.$openUri(n,w,{}):this.callOriginal(w,s)}}load(o,d,D){const r=this._extensionPaths.findSubstr(d);return r&&(this._extensionId=r.identifier.value,this.sendShimmingTelemetry()),this._original=D(o),this._impl}callOriginal(o,d){return this.sendNoForwardTelemetry(),this._original(o,d)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};S=Ue([Be(2,C.IExtHostRpcService)],S)}),define(we[224],be([0,1,13,16,75,6,2,5,217,12,59,62,27,144,14,67,34,41]),function(re,e,u,M,E,P,F,T,C,A,t,_,i,m,a,f,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class v{constructor(d,D,r,w){this._disposables=new P.DisposableStore,this._isTerminating=!1,this._hostUtils=r,this._rpcProtocol=new C.RPCProtocol(d,null,w),D=v._transform(D,this._rpcProtocol);const s=new _.ServiceCollection(...(0,t.getSingletonServiceDescriptors)());s.set(i.IExtHostInitDataService,{_serviceBrand:void 0,...D}),s.set(a.IExtHostRpcService,new a.ExtHostRpcService(this._rpcProtocol)),s.set(f.IURITransformerService,new f.URITransformerService(w)),s.set(p.IHostUtils,r);const n=new m.InstantiationService(s,!0),g=n.invokeFunction(h=>h.get(S.IExtHostTerminalService));this._disposables.add(g),this._logService=n.invokeFunction(h=>h.get(A.ILogService)),E.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",D),this._extensionService=n.invokeFunction(h=>h.get(p.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const l=new WeakMap;this._extensionService.getExtensionPathIndex().then(h=>{Error.prepareStackTrace=(y,R)=>{let I="",B,L;for(const k of R)I+=`
	at ${k.toString()}`,L=k.getFileName(),!B&&L&&(B=h.findSubstr(F.URI.file(L)));return l.set(y,B),`${y.name||"Error"}: ${y.message||""}${I}`}});const c=this._rpcProtocol.getProxy(T.MainContext.MainThreadExtensionService),b=this._rpcProtocol.getProxy(T.MainContext.MainThreadErrors);M.setUnexpectedErrorHandler(h=>{const y=M.transformErrorForSerialization(h),R=l.get(h);R?c.$onExtensionRuntimeError(R.identifier,y):b.$onUnexpectedError(y)})}terminate(d){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${d}`),this._logService.flush(),this._disposables.dispose(),M.setUnexpectedErrorHandler(r=>{this._logService.error(r)}),this._rpcProtocol.dispose();const D=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,u.timeout)(4e3),D]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(d,D){d.extensions.forEach(w=>w.extensionLocation=F.URI.revive(D.transformIncomingURIs(w.extensionLocation))),d.environment.appRoot=F.URI.revive(D.transformIncomingURIs(d.environment.appRoot));const r=d.environment.extensionDevelopmentLocationURI;return r&&(d.environment.extensionDevelopmentLocationURI=r.map(w=>F.URI.revive(D.transformIncomingURIs(w)))),d.environment.extensionTestsLocationURI=F.URI.revive(D.transformIncomingURIs(d.environment.extensionTestsLocationURI)),d.environment.globalStorageHome=F.URI.revive(D.transformIncomingURIs(d.environment.globalStorageHome)),d.environment.workspaceStorageHome=F.URI.revive(D.transformIncomingURIs(d.environment.workspaceStorageHome)),d.logsLocation=F.URI.revive(D.transformIncomingURIs(d.logsLocation)),d.logFile=F.URI.revive(D.transformIncomingURIs(d.logFile)),d.workspace=D.transformIncomingURIs(d.workspace),d}}e.ExtensionHostMain=v}),define(we[225],be([0,1,17,21,46,28,24,198,42]),function(re,e,u,M,E,P,F,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class A{constructor(i,m,a){this.config=i,this.provider=m,this.sessionToken=a,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=i.filePattern,this.includePattern=i.includePattern&&P.parse(i.includePattern),this.maxResults=i.maxResults||void 0,this.exists=i.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=i.excludePattern&&P.parse(i.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(i=>i.cancel()),this.activeCancellationTokens=new Set}search(i){const m=this.config.folderQueries||[];return new Promise((a,f)=>{const p=S=>{this.resultCount++,i(S)};if(this.isCanceled)return a({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(S=>{const v=S.toString(),o=u.basename(v);this.globalExcludePattern&&this.globalExcludePattern(v,o)||this.matchFile(p,{base:S,basename:o})}),Promise.all(m.map(S=>this.searchInFolder(S,p))).then(S=>{a({limitHit:this.isLimitHit,stats:S[0]||void 0})},S=>{f(new Error((0,E.toErrorMessage)(S)))})})}async searchInFolder(i,m){const a=new M.CancellationTokenSource,f=this.getSearchOptionsForFolder(i),p=this.initDirectoryTree(),S=new C.QueryGlobTester(this.config,i),v=!S.hasSiblingExcludeClauses();let o;try{this.activeCancellationTokens.add(a),o=T.StopWatch.create();const d=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},f,a.token),D=o.elapsed(),r=T.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(d&&d.forEach(w=>{const s=u.posix.relative(i.folder.path,w.path);if(v){const n=u.basename(w.path);this.matchFile(m,{base:i.folder,relativePath:s,basename:n});return}this.addDirectoryEntries(p,i.folder,s,m)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(p,S,m),{providerTime:D,postProcessTime:r.elapsed()})}finally{a.dispose(),this.activeCancellationTokens.delete(a)}}getSearchOptionsForFolder(i){const m=(0,C.resolvePatternsForProvider)(this.config.includePattern,i.includePattern),a=(0,C.resolvePatternsForProvider)(this.config.excludePattern,i.excludePattern);return{folder:i.folder,excludes:a,includes:m,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,followSymlinks:!i.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries({pathToEntries:i},m,a,f){if(a===this.filePattern){const S=u.basename(this.filePattern);this.matchFile(f,{base:m,relativePath:this.filePattern,basename:S})}function p(S){const v=u.basename(S),o=u.dirname(S);let d=i[o];d||(d=i[o]=[],p(o)),d.push({base:m,relativePath:S,basename:v})}p(a)}matchDirectoryTree({rootEntries:i,pathToEntries:m},a,f){const p=this,S=this.filePattern;function v(o){const d=P.hasSiblingFn(()=>o.map(D=>D.basename));for(let D=0,r=o.length;D<r;D++){const w=o[D],{relativePath:s,basename:n}=w;if(a.matchesExcludesSync(s,n,S!==n?d:void 0))continue;const g=m[s];if(g)v(g);else{if(s===S)continue;p.matchFile(f,w)}if(p.isLimitHit)break}}v(i)}matchFile(i,m){(!this.includePattern||m.relativePath&&this.includePattern(m.relativePath,m.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||i(m))}}class t{constructor(){this.sessions=new Map}fileSearch(i,m,a,f){const p=this.getSessionTokenSource(i.cacheKey),S=new A(i,m,p&&p.token);let v=0;const o=d=>{v+=d.length,a(d.map(D=>this.rawMatchToSearchItem(D)))};return this.doSearch(S,t.BATCH_SIZE,o,f).then(d=>({limitHit:d.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:v,detailStats:d.stats}}))}clearCache(i){const m=this.getSessionTokenSource(i);m&&m.cancel()}getSessionTokenSource(i){if(!!i)return this.sessions.has(i)||this.sessions.set(i,new M.CancellationTokenSource),this.sessions.get(i)}rawMatchToSearchItem(i){return i.relativePath?{resource:F.joinPath(i.base,i.relativePath)}:{resource:i.base}}doSearch(i,m,a,f){f.onCancellationRequested(()=>{i.cancel()});const p=v=>{v&&(S.push(v),m>0&&S.length>=m&&(a(S),S=[]))};let S=[];return i.search(p).then(v=>(S.length&&a(S),v),v=>(S.length&&a(S),Promise.reject(v)))}}e.FileSearchManager=t,t.BATCH_SIZE=512}),define(we[226],be([0,1,15,21,46,28,11,17,24,10,2,42]),function(re,e,u,M,E,P,F,T,C,A,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class i{constructor(o,d,D,r){this.query=o,this.provider=d,this.fileUtils=D,this.processType=r,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(o,d){const D=this.query.folderQueries||[],r=new M.CancellationTokenSource;return d.onCancellationRequested(()=>r.cancel()),new Promise((w,s)=>{this.collector=new a(o);let n=!1;const g=(l,c)=>{if(!n&&!this.isLimitHit){const b=this.resultSize(l);p(l)&&typeof this.query.maxResults=="number"&&this.resultCount+b>this.query.maxResults&&(this.isLimitHit=!0,n=!0,r.cancel(),l=this.trimResultToSize(l,this.query.maxResults-this.resultCount));const h=this.resultSize(l);this.resultCount+=h,(h>0||!p(l))&&this.collector.add(l,c)}};Promise.all(D.map((l,c)=>this.searchInFolder(l,b=>g(b,c),r.token))).then(l=>{r.dispose(),this.collector.flush();const c=l.some(b=>!!b&&!!b.limitHit);w({limitHit:this.isLimitHit||c,messages:(0,u.flatten)(l.map(b=>b?.message?(0,A.isArray)(b.message)?b.message:[b.message]:[])),stats:{type:this.processType}})},l=>{r.dispose();const c=(0,E.toErrorMessage)(l);s(new Error(c))})})}resultSize(o){return p(o)?Array.isArray(o.ranges)?o.ranges.length:1:0}trimResultToSize(o,d){const D=Array.isArray(o.ranges)?o.ranges:[o.ranges],r=Array.isArray(o.preview.matches)?o.preview.matches:[o.preview.matches];return{ranges:D.slice(0,d),preview:{matches:r.slice(0,d),text:o.preview.text},uri:o.uri}}async searchInFolder(o,d,D){const r=new _.QueryGlobTester(this.query,o),w=[],s={report:l=>{if(!this.validateProviderResult(l))return;const c=o.folder.scheme===F.Schemas.file?P.hasSiblingPromiseFn(()=>this.fileUtils.readdir(C.dirname(l.uri))):void 0,b=C.relativePath(o.folder,l.uri);if(b){const h=r.includedInQuery(b,T.basename(b),c);(0,A.isPromise)(h)?w.push(h.then(y=>{y&&d(l)})):h&&d(l)}}},n=this.getSearchOptionsForFolder(o),g=await this.provider.provideTextSearchResults(m(this.query.contentPattern),n,s,D);return w.length&&await Promise.all(w),g}validateProviderResult(o){if(p(o)){if(Array.isArray(o.ranges)){if(!Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(o.preview.matches.length!==o.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(o){const d=(0,_.resolvePatternsForProvider)(this.query.includePattern,o.includePattern),D=(0,_.resolvePatternsForProvider)(this.query.excludePattern,o.excludePattern),r={folder:t.URI.from(o.folder),excludes:D,includes:d,useIgnoreFiles:!o.disregardIgnoreFiles,useGlobalIgnoreFiles:!o.disregardGlobalIgnoreFiles,followSymlinks:!o.ignoreSymlinks,encoding:o.fileEncoding&&this.fileUtils.toCanonicalName(o.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return r.usePCRE2=this.query.usePCRE2,r}}e.TextSearchManager=i;function m(v){return{isCaseSensitive:v.isCaseSensitive||!1,isRegExp:v.isRegExp||!1,isWordMatch:v.isWordMatch||!1,isMultiline:v.isMultiline||!1,pattern:v.pattern}}class a{constructor(o){this._onResult=o,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new S(512,d=>this.sendItems(d))}add(o,d){this._currentFileMatch&&(this._currentFolderIdx!==d||!C.isEqual(this._currentUri,o.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=d,this._currentFileMatch={resource:o.uri,results:[]}),this._currentFileMatch.results.push(f(o))}pushToCollector(){const o=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,o)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(o){this._onResult(o)}}e.TextSearchResultsCollector=a;function f(v){return p(v)?{preview:{matches:(0,u.mapArrayOrNot)(v.preview.matches,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character})),text:v.preview.text},ranges:(0,u.mapArrayOrNot)(v.ranges,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character}))}:{text:v.text,lineNumber:v.lineNumber}}function p(v){return!!v.preview}e.extensionResultIsMatch=p;class S{constructor(o,d){this.maxBatchSize=o,this.cb=d,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(o,d){!o||this.addItemToBatch(o,d)}addItems(o,d){!o||this.addItemsToBatch(o,d)}addItemToBatch(o,d){this.batch.push(o),this.batchSize+=d,this.onUpdate()}addItemsToBatch(o,d){this.batch=this.batch.concat(o),this.batchSize+=d,this.onUpdate()}onUpdate(){this.totalNumberCompleted<S.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},S.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=S,S.TIMEOUT=4e3,S.START_BATCH_AFTER_COUNT=50}),define(we[101],be([0,1,6,5,4,225,14,67,12,2,226]),function(re,e,u,M,E,P,F,T,C,A,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,E.createDecorator)("IExtHostSearch");let _=class{constructor(f,p,S){this.extHostRpc=f,this._uriTransformer=p,this._logService=S,this._proxy=this.extHostRpc.getProxy(M.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new P.FileSearchManager}_transformScheme(f){return this._uriTransformer.transformOutgoingScheme(f)}registerTextSearchProvider(f,p){if(this._textSearchUsedSchemes.has(f))throw new Error(`a text search provider for the scheme '${f}' is already registered`);this._textSearchUsedSchemes.add(f);const S=this._handlePool++;return this._textSearchProvider.set(S,p),this._proxy.$registerTextSearchProvider(S,this._transformScheme(f)),(0,u.toDisposable)(()=>{this._textSearchUsedSchemes.delete(f),this._textSearchProvider.delete(S),this._proxy.$unregisterProvider(S)})}registerFileSearchProvider(f,p){if(this._fileSearchUsedSchemes.has(f))throw new Error(`a file search provider for the scheme '${f}' is already registered`);this._fileSearchUsedSchemes.add(f);const S=this._handlePool++;return this._fileSearchProvider.set(S,p),this._proxy.$registerFileSearchProvider(S,this._transformScheme(f)),(0,u.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(f),this._fileSearchProvider.delete(S),this._proxy.$unregisterProvider(S)})}$provideFileSearchResults(f,p,S,v){const o=i(S),d=this._fileSearchProvider.get(f);if(d)return this._fileSearchManager.fileSearch(o,d,D=>{this._proxy.$handleFileMatch(f,p,D.map(r=>r.resource))},v);throw new Error("unknown provider: "+f)}$clearCache(f){return this._fileSearchManager.clearCache(f),Promise.resolve(void 0)}$provideTextSearchResults(f,p,S,v){const o=this._textSearchProvider.get(f);if(!o||!o.provideTextSearchResults)throw new Error(`Unknown provider ${f}`);const d=i(S);return this.createTextSearchManager(d,o).search(r=>this._proxy.$handleTextMatch(f,p,r),v)}$enableExtensionHostSearch(){}createTextSearchManager(f,p){return new t.TextSearchManager(f,p,{readdir:S=>Promise.resolve([]),toCanonicalName:S=>S},"textSearchProvider")}};_=Ue([Be(0,F.IExtHostRpcService),Be(1,T.IURITransformerService),Be(2,C.ILogService)],_),e.ExtHostSearch=_;function i(a){return{...a,folderQueries:a.folderQueries&&a.folderQueries.map(m),extraFileResources:a.extraFileResources&&a.extraFileResources.map(f=>A.URI.revive(f))}}e.reviveQuery=i;function m(a){return{...a,folder:A.URI.revive(a.folder)}}}),define(we[227],be([0,1,21,16,3,36,2,118,80,112,58,47,5,188,187,40,189,33,190,191,192,174,193,51,34,194,175,197,199,201,96,177,206,207,208,73,41,210,178,8,7,213,53,97,32,30,54,162,196,64,95,99,100,101,12,67,14,27,202,159,66,71,185,211,158,74,52,216,214,215,186,31,209,212,70,72,87,204,98,205,11,146,203,156,195]),function(re,e,u,M,E,P,F,T,C,A,t,_,i,m,a,f,p,S,v,o,d,D,r,w,s,n,g,l,c,b,h,y,R,I,B,L,k,x,N,V,W,$,X,j,Q,ae,pe,ce,Fe,Qe,Oe,He,Je,Ye,qe,z,K,Z,se,G,ie,de,Pe,Ne,We,je,et,ot,_e,nt,q,J,ge,$e,Ge,rt,ft,ht,Dt,Tt,It,Xe,pt,Ie,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function De(ee){const oe=ee.get(Z.IExtHostInitDataService),fe=ee.get(J.IExtHostFileSystemInfo),he=ee.get(et.IExtHostConsumerFileSystem),ke=ee.get(s.IExtHostExtensionService),Le=ee.get(Q.IExtHostWorkspace),Me=ee.get(ft.IExtHostTelemetry),ze=ee.get(S.IExtHostConfiguration),it=ee.get(z.IURITransformerService),Re=ee.get(K.IExtHostRpcService),ue=ee.get(L.IExtHostStorage),me=ee.get(je.IExtensionStoragePaths),ne=ee.get(qe.ILoggerService),H=ee.get(qe.ILogService),ve=ee.get(ie.IExtHostTunnelService),Ce=ee.get(de.IExtHostApiDeprecationService),Ke=ee.get(j.IExtHostWindow),xe=ee.get(Ge.IExtHostSecretState),lt=ee.get(rt.IExtHostEditorTabs);Re.set(i.ExtHostContext.ExtHostFileSystemInfo,fe),Re.set(i.ExtHostContext.ExtHostLogLevelServiceShape,ne),Re.set(i.ExtHostContext.ExtHostWorkspace,Le),Re.set(i.ExtHostContext.ExtHostConfiguration,ze),Re.set(i.ExtHostContext.ExtHostExtensionService,ke),Re.set(i.ExtHostContext.ExtHostStorage,ue),Re.set(i.ExtHostContext.ExtHostTunnelService,ve),Re.set(i.ExtHostContext.ExtHostWindow,Ke),Re.set(i.ExtHostContext.ExtHostSecretState,xe),Re.set(i.ExtHostContext.ExtHostTelemetry,Me),Re.set(i.ExtHostContext.ExtHostEditorTabs,lt);const Et=Re.set(i.ExtHostContext.ExtHostDecorations,ee.get(Oe.IExtHostDecorations)),vt=Re.set(i.ExtHostContext.ExtHostDocumentsAndEditors,ee.get(w.IExtHostDocumentsAndEditors)),ut=Re.set(i.ExtHostContext.ExtHostCommands,ee.get(f.IExtHostCommands)),gt=Re.set(i.ExtHostContext.ExtHostTerminalService,ee.get(k.IExtHostTerminalService)),dt=Re.set(i.ExtHostContext.ExtHostDebugService,ee.get(Je.IExtHostDebugService)),Pt=Re.set(i.ExtHostContext.ExtHostSearch,ee.get(Ye.IExtHostSearch)),_t=Re.set(i.ExtHostContext.ExtHostTask,ee.get(He.IExtHostTask)),$t=Re.set(i.ExtHostContext.ExtHostOutputService,ee.get(h.IExtHostOutputService)),jt=Re.set(i.ExtHostContext.ExtHostUrls,new $.ExtHostUrls(Re)),St=Re.set(i.ExtHostContext.ExtHostDocuments,new r.ExtHostDocuments(Re,vt)),Wt=Re.set(i.ExtHostContext.ExtHostDocumentContentProviders,new d.ExtHostDocumentContentProvider(Re,vt,H)),ii=Re.set(i.ExtHostContext.ExtHostDocumentSaveParticipant,new D.ExtHostDocumentSaveParticipant(H,St,Re.getProxy(i.MainContext.MainThreadBulkEdits))),wt=Re.set(i.ExtHostContext.ExtHostNotebook,new se.ExtHostNotebookController(Re,ut,vt,St,me)),Yt=Re.set(i.ExtHostContext.ExtHostNotebookDocuments,new Ie.ExtHostNotebookDocuments(H,wt)),qt=Re.set(i.ExtHostContext.ExtHostNotebookEditors,new pt.ExtHostNotebookEditors(H,Re,wt)),ni=Re.set(i.ExtHostContext.ExtHostNotebookKernels,new ht.ExtHostNotebookKernels(Re,oe,wt,ut,H)),ri=Re.set(i.ExtHostContext.ExtHostNotebookRenderers,new Tt.ExtHostNotebookRenderers(Re,wt)),At=Re.set(i.ExtHostContext.ExtHostEditors,new x.ExtHostEditors(Re,vt)),Jt=Re.set(i.ExtHostContext.ExtHostTreeViews,new N.ExtHostTreeViews(Re.getProxy(i.MainContext.MainThreadTreeViews),ut,H)),bi=Re.set(i.ExtHostContext.ExtHostEditorInsets,new ce.ExtHostEditorInsets(Re.getProxy(i.MainContext.MainThreadEditorInsets),At,oe)),zt=Re.set(i.ExtHostContext.ExtHostDiagnostics,new v.ExtHostDiagnostics(Re,H,fe)),Ht=Re.set(i.ExtHostContext.ExtHostLanguages,new c.ExtHostLanguages(Re,St,ut.converter,it)),mt=Re.set(i.ExtHostContext.ExtHostLanguageFeatures,new l.ExtHostLanguageFeatures(Re,it,St,ut,zt,H,Ce)),si=Re.set(i.ExtHostContext.ExtHostFileSystem,new n.ExtHostFileSystem(Re,mt)),Nt=Re.set(i.ExtHostContext.ExtHostFileSystemEventService,new g.ExtHostFileSystemEventService(Re,H,vt)),xt=Re.set(i.ExtHostContext.ExtHostQuickOpen,(0,R.createExtHostQuickOpen)(Re,Le,ut)),Xt=Re.set(i.ExtHostContext.ExtHostSCM,new I.ExtHostSCM(Re,ut,H)),Ei=Re.set(i.ExtHostContext.ExtHostComments,(0,p.createExtHostComments)(Re,ut,St)),fi=Re.set(i.ExtHostContext.ExtHostProgress,new y.ExtHostProgress(Re.getProxy(i.MainContext.MainThreadProgress))),_i=Re.set(i.ExtHostContext.ExtHosLabelService,new Fe.ExtHostLabelService(Re)),mi=Re.set(i.ExtHostContext.ExtHostTheming,new G.ExtHostTheming(Re)),Zt=Re.set(i.ExtHostContext.ExtHostAuthentication,new Pe.ExtHostAuthentication(Re)),oi=Re.set(i.ExtHostContext.ExtHostTimeline,new Ne.ExtHostTimeline(Re,ut)),Gt=Re.set(i.ExtHostContext.ExtHostWebviews,new X.ExtHostWebviews(Re,{remote:oe.remote},Le,H,Ce)),ai=Re.set(i.ExtHostContext.ExtHostWebviewPanels,new nt.ExtHostWebviewPanels(Re,Gt,Le)),yi=Re.set(i.ExtHostContext.ExtHostCustomEditors,new _e.ExtHostCustomEditors(Re,St,me,Gt,ai)),Si=Re.set(i.ExtHostContext.ExtHostWebviewViews,new ot.ExtHostWebviewViews(Re,Gt)),Kt=Re.set(i.ExtHostContext.ExtHostTesting,new ge.ExtHostTesting(Re,ut)),ei=Re.set(i.ExtHostContext.ExtHostUriOpeners,new $e.ExtHostUriOpeners(Re));Re.set(i.ExtHostContext.ExtHostInteractive,new ye.ExtHostInteractive(Re,wt,vt,ut));const Di=(0,pe.values)(i.ExtHostContext);Re.assertRegistered(Di);const Ci=new q.ExtHostBulkEdits(Re,vt),li=new a.ExtHostClipboard(Re),ui=new b.ExtHostMessageService(Re,H),Vt=new o.ExtHostDialogs(Re),Lt=new B.ExtHostStatusBar(Re,ut.converter);return m.ExtHostApiCommands.register(ut),function(Ae,Ft,Qt){const bt=function(){let Y=!Ae.isUnderDevelopment;function le(Se){Y||(H.info(`Extension '${Ae.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),Y=!0)}return function Se(st){if(Array.isArray(st))st.forEach(Se);else if(typeof st=="string")le(st);else{const yt=st;typeof yt.scheme=="undefined"&&le(st),!Ae.enableProposedApi&&typeof yt.exclusive=="boolean"&&(0,ae.throwProposedApiError)(Ae)}return st}}(),ki={getSession(Y,le,Se){return(Se?.forceNewSession||Se?.silent)&&(0,ae.checkProposedApiEnabled)(Ae),Zt.getSession(Ae,Y,le,Se)},async hasSession(Y,le){return(0,ae.checkProposedApiEnabled)(Ae),!!await Zt.getSession(Ae,Y,le,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(Y,le,Se,st){return Zt.registerAuthenticationProvider(Y,le,Se,st)}},Ii={registerCommand(Y,le,Se){return ut.registerCommand(!0,Y,le,Se,void 0,Ae)},registerTextEditorCommand(Y,le,Se){return ut.registerCommand(!0,Y,(...st)=>{const yt=At.getActiveTextEditor();if(!yt){H.warn("Cannot execute "+Y+" because there is no active text editor.");return}return yt.edit(kt=>{le.apply(Se,[yt,kt,...st])}).then(kt=>{kt||H.warn("Edits from command "+Y+" were not applied.")},kt=>{H.warn("An error occurred while running command "+Y,kt)})},void 0,void 0,Ae)},registerDiffInformationCommand:(Y,le,Se)=>((0,ae.checkProposedApiEnabled)(Ae),ut.registerCommand(!0,Y,async(...st)=>{const yt=vt.activeEditor(!0);if(!yt){H.warn("Cannot execute "+Y+" because there is no active text editor.");return}const kt=await At.getDiffInformation(yt.id);le.apply(Se,[kt,...st])},void 0,void 0,Ae)),executeCommand(Y,...le){return ut.executeCommand(Y,...le)},getCommands(Y=!1){return ut.getCommands(Y)}},gi={get machineId(){return oe.telemetryInfo.machineId},get sessionId(){return oe.telemetryInfo.sessionId},get language(){return oe.environment.appLanguage},get appName(){return oe.environment.appName},get appRoot(){return oe.environment.appRoot?.fsPath??""},get appHost(){return oe.environment.appHost},get uriScheme(){return oe.environment.appUriScheme},get clipboard(){return li.value},get shell(){return gt.getDefaultShell(!1)},get isTelemetryEnabled(){return Me.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Me.onDidChangeTelemetryEnabled},get isNewAppInstall(){const Y=Date.now()-new Date(oe.telemetryInfo.firstSessionDate).getTime();return isNaN(Y)?!1:Y<1e3*60*60*24},openExternal(Y,le){return Ke.openUri(Y,{allowTunneling:!!oe.remote.authority,allowContributedOpeners:le?.allowContributedOpeners})},async asExternalUri(Y){if(Y.scheme===oe.environment.appUriScheme)return jt.createAppUri(Y);try{return await Ke.asExternalUri(Y,{allowTunneling:!!oe.remote.authority})}catch(le){if((0,Xe.matchesScheme)(Y,It.Schemas.http)||(0,Xe.matchesScheme)(Y,It.Schemas.https))return Y;throw le}},get remoteName(){return(0,Qe.getRemoteName)(oe.remote.authority)},get remoteAuthority(){return(0,ae.checkProposedApiEnabled)(Ae),oe.remote.authority},get uiKind(){return oe.uiKind}};oe.environment.extensionTestsLocationURI||Object.freeze(gi);const pi=oe.remote.isRemote?W.ExtensionKind.Workspace:W.ExtensionKind.UI,Pi={createTestController(Y,le){return Kt.createTestController(Y,le)},createTestObserver(){return(0,ae.checkProposedApiEnabled)(Ae),Kt.createTestObserver()},runTests(Y){return(0,ae.checkProposedApiEnabled)(Ae),Kt.runTests(Y)},get onDidChangeTestResults(){return(0,ae.checkProposedApiEnabled)(Ae),Kt.onResultsChanged},get testResults(){return(0,ae.checkProposedApiEnabled)(Ae),Kt.results}},Ti={getExtension(Y){const le=Ft.getExtensionDescription(Y);if(le)return new s.Extension(ke,Ae.identifier,le,pi)},get all(){return Ft.getAllExtensionDescriptions().map(Y=>new s.Extension(ke,Ae.identifier,Y,pi))},get onDidChange(){return Ft.onDidChange}},ci={createDiagnosticCollection(Y){return zt.createDiagnosticCollection(Ae.identifier,Y)},get onDidChangeDiagnostics(){return zt.onDidChangeDiagnostics},getDiagnostics:Y=>zt.getDiagnostics(Y),getLanguages(){return Ht.getLanguages()},setTextDocumentLanguage(Y,le){return Ht.changeLanguage(Y.uri,le)},match(Y,le){return(0,t.score)(V.LanguageSelector.from(Y),le.uri,le.languageId,!0)},registerCodeActionsProvider(Y,le,Se){return mt.registerCodeActionProvider(Ae,bt(Y),le,Se)},registerCodeLensProvider(Y,le){return mt.registerCodeLensProvider(Ae,bt(Y),le)},registerDefinitionProvider(Y,le){return mt.registerDefinitionProvider(Ae,bt(Y),le)},registerDeclarationProvider(Y,le){return mt.registerDeclarationProvider(Ae,bt(Y),le)},registerImplementationProvider(Y,le){return mt.registerImplementationProvider(Ae,bt(Y),le)},registerTypeDefinitionProvider(Y,le){return mt.registerTypeDefinitionProvider(Ae,bt(Y),le)},registerHoverProvider(Y,le){return mt.registerHoverProvider(Ae,bt(Y),le,Ae.identifier)},registerEvaluatableExpressionProvider(Y,le){return mt.registerEvaluatableExpressionProvider(Ae,bt(Y),le,Ae.identifier)},registerInlineValuesProvider(Y,le){return mt.registerInlineValuesProvider(Ae,bt(Y),le,Ae.identifier)},registerDocumentHighlightProvider(Y,le){return mt.registerDocumentHighlightProvider(Ae,bt(Y),le)},registerLinkedEditingRangeProvider(Y,le){return mt.registerLinkedEditingRangeProvider(Ae,bt(Y),le)},registerReferenceProvider(Y,le){return mt.registerReferenceProvider(Ae,bt(Y),le)},registerRenameProvider(Y,le){return mt.registerRenameProvider(Ae,bt(Y),le)},registerDocumentSymbolProvider(Y,le,Se){return mt.registerDocumentSymbolProvider(Ae,bt(Y),le,Se)},registerWorkspaceSymbolProvider(Y){return mt.registerWorkspaceSymbolProvider(Ae,Y)},registerDocumentFormattingEditProvider(Y,le){return mt.registerDocumentFormattingEditProvider(Ae,bt(Y),le)},registerDocumentRangeFormattingEditProvider(Y,le){return mt.registerDocumentRangeFormattingEditProvider(Ae,bt(Y),le)},registerOnTypeFormattingEditProvider(Y,le,Se,...st){return mt.registerOnTypeFormattingEditProvider(Ae,bt(Y),le,[Se].concat(st))},registerDocumentSemanticTokensProvider(Y,le,Se){return mt.registerDocumentSemanticTokensProvider(Ae,bt(Y),le,Se)},registerDocumentRangeSemanticTokensProvider(Y,le,Se){return mt.registerDocumentRangeSemanticTokensProvider(Ae,bt(Y),le,Se)},registerSignatureHelpProvider(Y,le,Se,...st){return typeof Se=="object"?mt.registerSignatureHelpProvider(Ae,bt(Y),le,Se):mt.registerSignatureHelpProvider(Ae,bt(Y),le,typeof Se=="undefined"?[]:[Se,...st])},registerCompletionItemProvider(Y,le,...Se){return mt.registerCompletionItemProvider(Ae,bt(Y),le,Se)},registerInlineCompletionItemProvider(Y,le){return(0,ae.checkProposedApiEnabled)(Ae),mt.registerInlineCompletionsProvider(Ae,bt(Y),le)},registerDocumentLinkProvider(Y,le){return mt.registerDocumentLinkProvider(Ae,bt(Y),le)},registerColorProvider(Y,le){return mt.registerColorProvider(Ae,bt(Y),le)},registerFoldingRangeProvider(Y,le){return mt.registerFoldingRangeProvider(Ae,bt(Y),le)},registerSelectionRangeProvider(Y,le){return mt.registerSelectionRangeProvider(Ae,Y,le)},registerCallHierarchyProvider(Y,le){return mt.registerCallHierarchyProvider(Ae,Y,le)},registerTypeHierarchyProvider(Y,le){return mt.registerTypeHierarchyProvider(Ae,Y,le)},setLanguageConfiguration:(Y,le)=>mt.setLanguageConfiguration(Ae,Y,le),getTokenInformationAtPosition(Y,le){return(0,ae.checkProposedApiEnabled)(Ae),Ht.tokenAtPosition(Y,le)},registerInlayHintsProvider(Y,le){return(0,ae.checkProposedApiEnabled)(Ae),mt.registerInlayHintsProvider(Ae,Y,le)},createLanguageStatusItem(Y,le){return(0,ae.checkProposedApiEnabled)(Ae),Ht.createLanguageStatusItem(Ae,Y,le)}},Ai={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return gt.activeTerminal},get terminals(){return gt.terminals},async showTextDocument(Y,le,Se){const st=await(F.URI.isUri(Y)?Promise.resolve(vi.openTextDocument(Y)):Promise.resolve(Y));return At.showTextDocument(st,le,Se)},createTextEditorDecorationType(Y){return At.createTextEditorDecorationType(Ae,Y)},onDidChangeActiveTextEditor(Y,le,Se){return At.onDidChangeActiveTextEditor(Y,le,Se)},onDidChangeVisibleTextEditors(Y,le,Se){return At.onDidChangeVisibleTextEditors(Y,le,Se)},onDidChangeTextEditorSelection(Y,le,Se){return At.onDidChangeTextEditorSelection(Y,le,Se)},onDidChangeTextEditorOptions(Y,le,Se){return At.onDidChangeTextEditorOptions(Y,le,Se)},onDidChangeTextEditorVisibleRanges(Y,le,Se){return At.onDidChangeTextEditorVisibleRanges(Y,le,Se)},onDidChangeTextEditorViewColumn(Y,le,Se){return At.onDidChangeTextEditorViewColumn(Y,le,Se)},onDidCloseTerminal(Y,le,Se){return gt.onDidCloseTerminal(Y,le,Se)},onDidOpenTerminal(Y,le,Se){return gt.onDidOpenTerminal(Y,le,Se)},onDidChangeActiveTerminal(Y,le,Se){return gt.onDidChangeActiveTerminal(Y,le,Se)},onDidChangeTerminalDimensions(Y,le,Se){return(0,ae.checkProposedApiEnabled)(Ae),gt.onDidChangeTerminalDimensions(Y,le,Se)},onDidChangeTerminalState(Y,le,Se){return gt.onDidChangeTerminalState(Y,le,Se)},onDidWriteTerminalData(Y,le,Se){return(0,ae.checkProposedApiEnabled)(Ae),gt.onDidWriteTerminalData(Y,le,Se)},get state(){return Ke.state},onDidChangeWindowState(Y,le,Se){return Ke.onDidChangeWindowState(Y,le,Se)},showInformationMessage(Y,...le){return ui.showMessage(Ae,P.default.Info,Y,le[0],le.slice(1))},showWarningMessage(Y,...le){return ui.showMessage(Ae,P.default.Warning,Y,le[0],le.slice(1))},showErrorMessage(Y,...le){return ui.showMessage(Ae,P.default.Error,Y,le[0],le.slice(1))},showQuickPick(Y,le,Se){return xt.showQuickPick(Y,!!Ae.enableProposedApi,le,Se)},showWorkspaceFolderPick(Y){return xt.showWorkspaceFolderPick(Y)},showInputBox(Y,le){return xt.showInput(Y,le)},showOpenDialog(Y){return Vt.showOpenDialog(Y)},showSaveDialog(Y){return Vt.showSaveDialog(Y)},createStatusBarItem(Y,le,Se){let st,yt,kt;return typeof Y=="string"?(st=Y,yt=le,kt=Se):(yt=Y,kt=le),Lt.createStatusBarEntry(Ae,st,yt,kt)},setStatusBarMessage(Y,le){return Lt.setStatusBarMessage(Y,le)},withScmProgress(Y){return Ce.report("window.withScmProgress",Ae,"Use 'withProgress' instead."),fi.withProgress(Ae,{location:W.ProgressLocation.SourceControl},(le,Se)=>Y({report(st){}}))},withProgress(Y,le){return fi.withProgress(Ae,Y,le)},createOutputChannel(Y){return $t.createOutputChannel(Y,Ae)},createWebviewPanel(Y,le,Se,st){return ai.createWebviewPanel(Ae,Y,le,Se,st)},createWebviewTextEditorInset(Y,le,Se,st){return(0,ae.checkProposedApiEnabled)(Ae),bi.createWebviewEditorInset(Y,le,Se,st,Ae)},createTerminal(Y,le,Se){return typeof Y=="object"?("location"in Y&&(0,ae.checkProposedApiEnabled)(Ae),"pty"in Y?gt.createExtensionTerminal(Y):gt.createTerminalFromOptions(Y)):gt.createTerminal(Y,le,Se)},registerTerminalLinkProvider(Y){return gt.registerLinkProvider(Y)},registerTerminalProfileProvider(Y,le){return gt.registerProfileProvider(Ae,Y,le)},registerTreeDataProvider(Y,le){return Jt.registerTreeDataProvider(Y,le,Ae)},createTreeView(Y,le){return Jt.createTreeView(Y,le,Ae)},registerWebviewPanelSerializer:(Y,le)=>ai.registerWebviewPanelSerializer(Ae,Y,le),registerCustomEditorProvider:(Y,le,Se={})=>yi.registerCustomEditorProvider(Ae,Y,le,Se),registerFileDecorationProvider(Y){return Et.registerFileDecorationProvider(Y,Ae.identifier)},registerUriHandler(Y){return jt.registerUriHandler(Ae.identifier,Y)},createQuickPick(){return xt.createQuickPick(Ae.identifier,!!Ae.enableProposedApi)},createInputBox(){return xt.createInputBox(Ae.identifier)},get activeColorTheme(){return mi.activeColorTheme},onDidChangeActiveColorTheme(Y,le,Se){return mi.onDidChangeActiveColorTheme(Y,le,Se)},registerWebviewViewProvider(Y,le,Se){return Si.registerWebviewViewProvider(Ae,Y,le,Se?.webviewOptions)},get activeNotebookEditor(){return(0,ae.checkProposedApiEnabled)(Ae),wt.activeNotebookEditor},onDidChangeActiveNotebookEditor(Y,le,Se){return(0,ae.checkProposedApiEnabled)(Ae),wt.onDidChangeActiveNotebookEditor(Y,le,Se)},get visibleNotebookEditors(){return(0,ae.checkProposedApiEnabled)(Ae),wt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,ae.checkProposedApiEnabled)(Ae),wt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(Y,le,Se){return(0,ae.checkProposedApiEnabled)(Ae),qt.onDidChangeNotebookEditorSelection(Y,le,Se)},onDidChangeNotebookEditorVisibleRanges(Y,le,Se){return(0,ae.checkProposedApiEnabled)(Ae),qt.onDidChangeNotebookEditorVisibleRanges(Y,le,Se)},showNotebookDocument(Y,le){return(0,ae.checkProposedApiEnabled)(Ae),wt.showNotebookDocument(Y,le)},registerExternalUriOpener(Y,le,Se){return(0,ae.checkProposedApiEnabled)(Ae),ei.registerExternalUriOpener(Ae.identifier,Y,le,Se)},get tabs(){return(0,ae.checkProposedApiEnabled)(Ae),lt.tabs},get activeTab(){return(0,ae.checkProposedApiEnabled)(Ae),lt.activeTab},get onDidChangeTabs(){return(0,ae.checkProposedApiEnabled)(Ae),lt.onDidChangeTabs},get onDidChangeActiveTab(){return(0,ae.checkProposedApiEnabled)(Ae),lt.onDidChangeActiveTab},getInlineCompletionItemController(Y){return(0,ae.checkProposedApiEnabled)(Ae),l.InlineCompletionController.get(Y)}},vi={get rootPath(){return Ce.report("workspace.rootPath",Ae,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Le.getPath()},set rootPath(Y){throw M.readonly()},getWorkspaceFolder(Y){return Le.getWorkspaceFolder(Y)},get workspaceFolders(){return Le.getWorkspaceFolders()},get name(){return Le.name},set name(Y){throw M.readonly()},get workspaceFile(){return Le.workspaceFile},set workspaceFile(Y){throw M.readonly()},updateWorkspaceFolders:(Y,le,...Se)=>Le.updateWorkspaceFolders(Ae,Y,le||0,...Se),onDidChangeWorkspaceFolders:function(Y,le,Se){return Le.onDidChangeWorkspace(Y,le,Se)},asRelativePath:(Y,le)=>Le.getRelativePath(Y,le),findFiles:(Y,le,Se,st)=>Le.findFiles(V.GlobPattern.from(Y),V.GlobPattern.from(le),Se,Ae.identifier,st),findTextInFiles:(Y,le,Se,st)=>{let yt,kt;return typeof le=="object"?(yt=le,kt=Se):(yt={},kt=le,st=Se),Le.findTextInFiles(Y,yt||{},kt,Ae.identifier,st)},saveAll:Y=>Le.saveAll(Y),applyEdit(Y){return Ci.applyWorkspaceEdit(Y)},createFileSystemWatcher:(Y,le,Se,st)=>Nt.createFileSystemWatcher(V.GlobPattern.from(Y),le,Se,st),get textDocuments(){return St.getAllDocumentData().map(Y=>Y.document)},set textDocuments(Y){throw M.readonly()},openTextDocument(Y){let le;const Se=Y;if(typeof Y=="string")le=Promise.resolve(F.URI.file(Y));else if(F.URI.isUri(Y))le=Promise.resolve(Y);else if(!Se||typeof Se=="object")le=St.createDocumentData(Se);else throw new Error("illegal argument - uriOrFileNameOrOptions");return le.then(st=>St.ensureDocumentData(st).then(yt=>yt.document))},onDidOpenTextDocument:(Y,le,Se)=>St.onDidAddDocument(Y,le,Se),onDidCloseTextDocument:(Y,le,Se)=>St.onDidRemoveDocument(Y,le,Se),onDidChangeTextDocument:(Y,le,Se)=>St.onDidChangeDocument(Y,le,Se),onDidSaveTextDocument:(Y,le,Se)=>St.onDidSaveDocument(Y,le,Se),onWillSaveTextDocument:(Y,le,Se)=>ii.getOnWillSaveTextDocumentEvent(Ae)(Y,le,Se),get notebookDocuments(){return wt.notebookDocuments.map(Y=>Y.apiNotebook)},async openNotebookDocument(Y,le){let Se;if(F.URI.isUri(Y))Se=Y,await wt.openNotebookDocument(Y);else if(typeof Y=="string")Se=F.URI.revive(await wt.createNotebookDocument({viewType:Y,content:le}));else throw new Error("Invalid arguments");return wt.getNotebookDocument(Se).apiNotebook},get onDidOpenNotebookDocument(){return wt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return wt.onDidCloseNotebookDocument},registerNotebookSerializer(Y,le,Se,st){return wt.registerNotebookSerializer(Ae,Y,le,Se,Ae.enableProposedApi?st:void 0)},registerNotebookContentProvider:(Y,le,Se,st)=>((0,ae.checkProposedApiEnabled)(Ae),wt.registerNotebookContentProvider(Ae,Y,le,Se,Ae.enableProposedApi?st:void 0)),onDidChangeConfiguration:(Y,le,Se)=>Qt.onDidChangeConfiguration(Y,le,Se),getConfiguration(Y,le){return le=arguments.length===1?void 0:le,Qt.getConfiguration(Y,le,Ae)},registerTextDocumentContentProvider(Y,le){return Wt.registerTextDocumentContentProvider(Y,le)},registerTaskProvider:(Y,le)=>(Ce.report("window.registerTaskProvider",Ae,"Use the corresponding function on the 'tasks' namespace instead"),_t.registerTaskProvider(Ae,Y,le)),registerFileSystemProvider(Y,le,Se){return si.registerFileSystemProvider(Ae.identifier,Y,le,Se)},get fs(){return he.value},registerFileSearchProvider:(Y,le)=>((0,ae.checkProposedApiEnabled)(Ae),Pt.registerFileSearchProvider(Y,le)),registerTextSearchProvider:(Y,le)=>((0,ae.checkProposedApiEnabled)(Ae),Pt.registerTextSearchProvider(Y,le)),registerRemoteAuthorityResolver:(Y,le)=>((0,ae.checkProposedApiEnabled)(Ae),ke.registerRemoteAuthorityResolver(Y,le)),registerResourceLabelFormatter:Y=>((0,ae.checkProposedApiEnabled)(Ae),_i.$registerResourceLabelFormatter(Y)),onDidCreateFiles:(Y,le,Se)=>Nt.onDidCreateFile(Y,le,Se),onDidDeleteFiles:(Y,le,Se)=>Nt.onDidDeleteFile(Y,le,Se),onDidRenameFiles:(Y,le,Se)=>Nt.onDidRenameFile(Y,le,Se),onWillCreateFiles:(Y,le,Se)=>Nt.getOnWillCreateFileEvent(Ae)(Y,le,Se),onWillDeleteFiles:(Y,le,Se)=>Nt.getOnWillDeleteFileEvent(Ae)(Y,le,Se),onWillRenameFiles:(Y,le,Se)=>Nt.getOnWillRenameFileEvent(Ae)(Y,le,Se),openTunnel:Y=>((0,ae.checkProposedApiEnabled)(Ae),ve.openTunnel(Ae,Y).then(le=>{if(!le)throw new Error("cannot open tunnel");return le})),get tunnels(){return(0,ae.checkProposedApiEnabled)(Ae),ve.getTunnels()},onDidChangeTunnels:(Y,le,Se)=>((0,ae.checkProposedApiEnabled)(Ae),ve.onDidChangeTunnels(Y,le,Se)),registerPortAttributesProvider:(Y,le)=>((0,ae.checkProposedApiEnabled)(Ae),ve.registerPortsAttributesProvider(Y,le)),registerTimelineProvider:(Y,le)=>((0,ae.checkProposedApiEnabled)(Ae),oi.registerTimelineProvider(Y,le,Ae.identifier,ut.converter)),get isTrusted(){return Le.trusted},requestWorkspaceTrust:Y=>((0,ae.checkProposedApiEnabled)(Ae),Le.requestWorkspaceTrust(Y)),onDidGrantWorkspaceTrust:(Y,le,Se)=>Le.onDidGrantWorkspaceTrust(Y,le,Se)},Ri={get inputBox(){return Ce.report("scm.inputBox",Ae,"Use 'SourceControl.inputBox' instead"),Xt.getLastInputBox(Ae)},createSourceControl(Y,le,Se){return Xt.createSourceControl(Ae,Y,le,Se)}},Fi={createCommentController(Y,le){return Ei.createCommentController(Ae,Y,le)}},Mi={get activeDebugSession(){return dt.activeDebugSession},get activeDebugConsole(){return dt.activeDebugConsole},get breakpoints(){return dt.breakpoints},onDidStartDebugSession(Y,le,Se){return dt.onDidStartDebugSession(Y,le,Se)},onDidTerminateDebugSession(Y,le,Se){return dt.onDidTerminateDebugSession(Y,le,Se)},onDidChangeActiveDebugSession(Y,le,Se){return dt.onDidChangeActiveDebugSession(Y,le,Se)},onDidReceiveDebugSessionCustomEvent(Y,le,Se){return dt.onDidReceiveDebugSessionCustomEvent(Y,le,Se)},onDidChangeBreakpoints(Y,le,Se){return dt.onDidChangeBreakpoints(Y,le,Se)},registerDebugConfigurationProvider(Y,le,Se){return dt.registerDebugConfigurationProvider(Y,le,Se||W.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(Y,le){return dt.registerDebugAdapterDescriptorFactory(Ae,Y,le)},registerDebugAdapterTrackerFactory(Y,le){return dt.registerDebugAdapterTrackerFactory(Y,le)},startDebugging(Y,le,Se){return!Se||typeof Se=="object"&&"configuration"in Se?dt.startDebugging(Y,le,{parentSession:Se}):dt.startDebugging(Y,le,Se||{})},stopDebugging(Y){return dt.stopDebugging(Y)},addBreakpoints(Y){return dt.addBreakpoints(Y)},removeBreakpoints(Y){return dt.removeBreakpoints(Y)},asDebugSourceUri(Y,le){return dt.asDebugSourceUri(Y,le)}},Li={registerTaskProvider:(Y,le)=>_t.registerTaskProvider(Ae,Y,le),fetchTasks:Y=>_t.fetchTasks(Y),executeTask:Y=>_t.executeTask(Ae,Y),get taskExecutions(){return _t.taskExecutions},onDidStartTask:(Y,le,Se)=>_t.onDidStartTask(Y,le,Se),onDidEndTask:(Y,le,Se)=>_t.onDidEndTask(Y,le,Se),onDidStartTaskProcess:(Y,le,Se)=>_t.onDidStartTaskProcess(Y,le,Se),onDidEndTaskProcess:(Y,le,Se)=>_t.onDidEndTaskProcess(Y,le,Se)},Oi={createNotebookController(Y,le,Se,st,yt){return ni.createNotebookController(Ae,Y,le,Se,st,Ae.enableProposedApi?yt:void 0)},registerNotebookCellStatusBarItemProvider:(Y,le)=>wt.registerNotebookCellStatusBarItemProvider(Ae,Y,le),get onDidSaveNotebookDocument(){return(0,ae.checkProposedApiEnabled)(Ae),Yt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(Y){return(0,ae.checkProposedApiEnabled)(Ae),qt.createNotebookEditorDecorationType(Y)},createRendererMessaging(Y){return ri.createRendererMessaging(Ae,Y)},onDidChangeNotebookDocumentMetadata(Y,le,Se){return(0,ae.checkProposedApiEnabled)(Ae),Yt.onDidChangeNotebookDocumentMetadata(Y,le,Se)},onDidChangeNotebookCells(Y,le,Se){return(0,ae.checkProposedApiEnabled)(Ae),wt.onDidChangeNotebookCells(Y,le,Se)},onDidChangeNotebookCellExecutionState(Y,le,Se){return(0,ae.checkProposedApiEnabled)(Ae),wt.onDidChangeNotebookCellExecutionState(Y,le,Se)},onDidChangeCellOutputs(Y,le,Se){return(0,ae.checkProposedApiEnabled)(Ae),wt.onDidChangeCellOutputs(Y,le,Se)},onDidChangeCellMetadata(Y,le,Se){return(0,ae.checkProposedApiEnabled)(Ae),wt.onDidChangeCellMetadata(Y,le,Se)},createConcatTextDocument(Y,le){return(0,ae.checkProposedApiEnabled)(Ae),new We.ExtHostNotebookConcatDocument(wt,St,Y,le)}};return{version:oe.version,authentication:ki,commands:Ii,comments:Fi,debug:Mi,env:gi,extensions:Ti,languages:ci,notebooks:Oi,scm:Ri,tasks:Li,tests:Pi,window:Ai,workspace:vi,Breakpoint:W.Breakpoint,CallHierarchyIncomingCall:W.CallHierarchyIncomingCall,CallHierarchyItem:W.CallHierarchyItem,CallHierarchyOutgoingCall:W.CallHierarchyOutgoingCall,CancellationError:M.CancellationError,CancellationTokenSource:u.CancellationTokenSource,CandidatePortSource:i.CandidatePortSource,CodeAction:W.CodeAction,CodeActionKind:W.CodeActionKind,CodeActionTriggerKind:W.CodeActionTriggerKind,CodeLens:W.CodeLens,Color:W.Color,ColorInformation:W.ColorInformation,ColorPresentation:W.ColorPresentation,ColorThemeKind:W.ColorThemeKind,CommentMode:W.CommentMode,CommentThreadCollapsibleState:W.CommentThreadCollapsibleState,CompletionItem:W.CompletionItem,CompletionItemKind:W.CompletionItemKind,CompletionItemTag:W.CompletionItemTag,CompletionList:W.CompletionList,CompletionTriggerKind:W.CompletionTriggerKind,ConfigurationTarget:W.ConfigurationTarget,CustomExecution:W.CustomExecution,DebugAdapterExecutable:W.DebugAdapterExecutable,DebugAdapterInlineImplementation:W.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:W.DebugAdapterNamedPipeServer,DebugAdapterServer:W.DebugAdapterServer,DebugConfigurationProviderTriggerKind:W.DebugConfigurationProviderTriggerKind,DebugConsoleMode:W.DebugConsoleMode,DecorationRangeBehavior:W.DecorationRangeBehavior,Diagnostic:W.Diagnostic,DiagnosticRelatedInformation:W.DiagnosticRelatedInformation,DiagnosticSeverity:W.DiagnosticSeverity,DiagnosticTag:W.DiagnosticTag,Disposable:W.Disposable,DocumentHighlight:W.DocumentHighlight,DocumentHighlightKind:W.DocumentHighlightKind,DocumentLink:W.DocumentLink,DocumentSymbol:W.DocumentSymbol,EndOfLine:W.EndOfLine,EnvironmentVariableMutatorType:W.EnvironmentVariableMutatorType,EvaluatableExpression:W.EvaluatableExpression,InlineValueText:W.InlineValueText,InlineValueVariableLookup:W.InlineValueVariableLookup,InlineValueEvaluatableExpression:W.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:W.InlineCompletionTriggerKind,EventEmitter:E.Emitter,ExtensionKind:W.ExtensionKind,ExtensionMode:W.ExtensionMode,ExternalUriOpenerPriority:W.ExternalUriOpenerPriority,FileChangeType:W.FileChangeType,FileDecoration:W.FileDecoration,FileSystemError:W.FileSystemError,FileType:_.FileType,FilePermission:_.FilePermission,FoldingRange:W.FoldingRange,FoldingRangeKind:W.FoldingRangeKind,FunctionBreakpoint:W.FunctionBreakpoint,InlineCompletionItem:W.InlineSuggestion,InlineCompletionList:W.InlineSuggestions,Hover:W.Hover,IndentAction:A.IndentAction,Location:W.Location,MarkdownString:W.MarkdownString,OverviewRulerLane:C.OverviewRulerLane,ParameterInformation:W.ParameterInformation,PortAutoForwardAction:W.PortAutoForwardAction,Position:W.Position,ProcessExecution:W.ProcessExecution,ProgressLocation:W.ProgressLocation,QuickInputButtons:W.QuickInputButtons,Range:W.Range,RelativePattern:W.RelativePattern,Selection:W.Selection,SelectionRange:W.SelectionRange,SemanticTokens:W.SemanticTokens,SemanticTokensBuilder:W.SemanticTokensBuilder,SemanticTokensEdit:W.SemanticTokensEdit,SemanticTokensEdits:W.SemanticTokensEdits,SemanticTokensLegend:W.SemanticTokensLegend,ShellExecution:W.ShellExecution,ShellQuoting:W.ShellQuoting,SignatureHelp:W.SignatureHelp,SignatureHelpTriggerKind:W.SignatureHelpTriggerKind,SignatureInformation:W.SignatureInformation,SnippetString:W.SnippetString,SourceBreakpoint:W.SourceBreakpoint,StandardTokenType:W.StandardTokenType,StatusBarAlignment:W.StatusBarAlignment,SymbolInformation:W.SymbolInformation,SymbolKind:W.SymbolKind,SymbolTag:W.SymbolTag,Task:W.Task,TaskGroup:W.TaskGroup,TaskPanelKind:W.TaskPanelKind,TaskRevealKind:W.TaskRevealKind,TaskScope:W.TaskScope,TerminalLink:W.TerminalLink,TerminalLocation:W.TerminalLocation,TerminalProfile:W.TerminalProfile,TextDocumentSaveReason:W.TextDocumentSaveReason,TextEdit:W.TextEdit,TextEditorCursorStyle:T.TextEditorCursorStyle,TextEditorLineNumbersStyle:W.TextEditorLineNumbersStyle,TextEditorRevealType:W.TextEditorRevealType,TextEditorSelectionChangeKind:W.TextEditorSelectionChangeKind,TextDocumentChangeReason:W.TextDocumentChangeReason,ThemeColor:W.ThemeColor,ThemeIcon:W.ThemeIcon,TreeItem:W.TreeItem,TreeItemCollapsibleState:W.TreeItemCollapsibleState,TypeHierarchyItem:W.TypeHierarchyItem,UIKind:i.UIKind,Uri:F.URI,ViewColumn:W.ViewColumn,WorkspaceEdit:W.WorkspaceEdit,InlayHint:W.InlayHint,InlayHintKind:W.InlayHintKind,RemoteAuthorityResolverError:W.RemoteAuthorityResolverError,ResolvedAuthority:W.ResolvedAuthority,SourceControlInputBoxValidationType:W.SourceControlInputBoxValidationType,ExtensionRuntime:W.ExtensionRuntime,TimelineItem:W.TimelineItem,NotebookRange:W.NotebookRange,NotebookCellKind:W.NotebookCellKind,NotebookCellExecutionState:W.NotebookCellExecutionState,NotebookCellData:W.NotebookCellData,NotebookData:W.NotebookData,NotebookRendererScript:W.NotebookRendererScript,NotebookCellStatusBarAlignment:W.NotebookCellStatusBarAlignment,NotebookEditorRevealType:W.NotebookEditorRevealType,NotebookCellOutput:W.NotebookCellOutput,NotebookCellOutputItem:W.NotebookCellOutputItem,NotebookCellStatusBarItem:W.NotebookCellStatusBarItem,NotebookControllerAffinity:W.NotebookControllerAffinity,PortAttributes:W.PortAttributes,LinkedEditingRanges:W.LinkedEditingRanges,TestResultState:W.TestResultState,TestRunRequest:W.TestRunRequest,TestMessage:W.TestMessage,TestTag:W.TestTag,TestRunProfileKind:W.TestRunProfileKind,TextSearchCompleteMessageType:Dt.TextSearchCompleteMessageType,CoveredCount:W.CoveredCount,FileCoverage:W.FileCoverage,StatementCoverage:W.StatementCoverage,BranchCoverage:W.BranchCoverage,FunctionCoverage:W.FunctionCoverage,WorkspaceTrustState:W.WorkspaceTrustState,LanguageStatusSeverity:W.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=De}),define(we[228],be([0,1,59,96,32,95,33,40,51,41,99,100,101,73,66,71,97,52,31,70,87,72,200,12,154]),function(re,e,u,M,E,P,F,T,C,A,t,_,i,m,a,f,p,S,v,o,d,D,r,w,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.registerSingleton)(w.ILoggerService,r.ExtHostLoggerService),(0,u.registerSingleton)(w.ILogService,s.ExtHostLogService),(0,u.registerSingleton)(f.IExtHostApiDeprecationService,f.ExtHostApiDeprecationService),(0,u.registerSingleton)(T.IExtHostCommands,T.ExtHostCommands),(0,u.registerSingleton)(F.IExtHostConfiguration,F.ExtHostConfiguration),(0,u.registerSingleton)(S.IExtHostConsumerFileSystem,S.ExtHostConsumerFileSystem),(0,u.registerSingleton)(_.IExtHostDebugService,_.WorkerExtHostDebugService),(0,u.registerSingleton)(P.IExtHostDecorations,P.ExtHostDecorations),(0,u.registerSingleton)(C.IExtHostDocumentsAndEditors,C.ExtHostDocumentsAndEditors),(0,u.registerSingleton)(v.IExtHostFileSystemInfo,v.ExtHostFileSystemInfo),(0,u.registerSingleton)(M.IExtHostOutputService,M.ExtHostOutputService),(0,u.registerSingleton)(i.IExtHostSearch,i.ExtHostSearch),(0,u.registerSingleton)(m.IExtHostStorage,m.ExtHostStorage),(0,u.registerSingleton)(t.IExtHostTask,t.WorkerExtHostTask),(0,u.registerSingleton)(A.IExtHostTerminalService,A.WorkerExtHostTerminalService),(0,u.registerSingleton)(a.IExtHostTunnelService,a.ExtHostTunnelService),(0,u.registerSingleton)(p.IExtHostWindow,p.ExtHostWindow),(0,u.registerSingleton)(E.IExtHostWorkspace,E.ExtHostWorkspace),(0,u.registerSingleton)(o.IExtHostSecretState,o.ExtHostSecretState),(0,u.registerSingleton)(d.IExtHostTelemetry,d.ExtHostTelemetry),(0,u.registerSingleton)(D.IExtHostEditorTabs,D.ExtHostEditorTabs)}),define(we[229],be([0,1,227,34,223,7,13,5,11]),function(re,e,u,M,E,P,F,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var A;(function(a){const f=self.trustedTypes?.createPolicy("TrustedFunctionWorkaround",{createScript:(S,...v)=>{v.forEach(r=>{if(!self.trustedTypes?.isScript(r))throw new Error("TrustedScripts only, please")});const o=v.slice(0,-1).join(","),d=v.pop().toString();return`(function anonymous(${o}) {${d}
})`}});function p(...S){return f?self.eval(f.createScript("",...S)):new Function(...S)}a.create=p})(A||(A={}));class t extends E.RequireInterceptor{_installInterceptor(){}getModule(f,p){for(let S of this._alternatives){let v=S(f);if(v){f=v;break}}if(this._factories.has(f))return this._factories.get(f).load(f,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class _ extends M.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=P.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const f=this._extHostContext.getProxy(T.MainContext.MainThreadConsole);m(f,this._initData.environment.isExtensionDevelopmentDebug);const p=this._instaService.invokeFunction(u.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(t,p,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(f){return f.browser}async _loadCommonJSModule(f,p,S){p=p.with({path:i(p.path,".js")}),f&&performance.mark(`code/extHost/willFetchExtensionCode/${f.value}`);const v=await fetch(C.FileAccess.asBrowserUri(p).toString(!0));if(f&&performance.mark(`code/extHost/didFetchExtensionCode/${f.value}`),v.status!==200)throw new Error(v.statusText);const o=await v.text(),d=`${p.toString(!0)}#vscode-extension`,D=`${o}
//# sourceURL=${d}`;let r;try{r=A.create(_._ttpExtensionScripts?.createScript("module")??"module",_._ttpExtensionScripts?.createScript("exports")??"exports",_._ttpExtensionScripts?.createScript("require")??"require",_._ttpExtensionScripts?.createScript(D)??D)}catch(g){throw console.error(f?`Loading code for extension ${f.value} failed: ${g.message}`:`Loading code failed: ${g.message}`),console.error(`${p.toString(!0)}${typeof g.line=="number"?` line ${g.line}`:""}${typeof g.column=="number"?` column ${g.column}`:""}`),console.error(g),g}const w={},s={exports:w},n=g=>{const l=this._fakeModules.getModule(g,p);if(l===void 0)throw new Error(`Cannot load module '${g}'`);return l};try{return S.codeLoadingStart(),f&&performance.mark(`code/extHost/willLoadExtensionCode/${f.value}`),r(s,w,n),s.exports!==w?s.exports:w}finally{f&&performance.mark(`code/extHost/didLoadExtensionCode/${f.value}`),S.codeLoadingStop()}}async $setRemoteEnvironment(f){}async _waitForDebuggerAttachment(f=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const p=Date.now()+f;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,F.timeout)(10)}}e.ExtHostExtensionService=_,_._ttpExtensionScripts=self.trustedTypes?.createPolicy("ExtensionScripts",{createScript:a=>a});function i(a,f){return a.endsWith(f)?a:a+f}function m(a,f){p("info","log"),p("log","log"),p("warn","warn"),p("error","error");function p(o,d){const D=console[o];console[o]=function(){a.$logExtensionHostMessage({type:"__$console",severity:d,arguments:v(arguments)}),f&&D.apply(console,arguments)}}const S=1e5;function v(o){const d=[],D=[];if(o.length)for(let r=0;r<o.length;r++){if(typeof o[r]=="undefined")o[r]="undefined";else if(o[r]instanceof Error){const w=o[r];w.stack?o[r]=w.stack:o[r]=w.toString()}D.push(o[r])}try{const r=JSON.stringify(D,function(w,s){if(s&&typeof s=="object"){if(d.indexOf(s)!==-1)return"[Circular]";d.push(s)}return s});return r.length>S?"Output omitted for a large object that exceeds the limits":r}catch(r){return`Output omitted for an object that cannot be inspected ('${r.toString()}')`}}}}),define(we[230],be([0,1,59,34,74,229]),function(re,e,u,M,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.registerSingleton)(M.IExtHostExtensionService,P.ExtHostExtensionService),(0,u.registerSingleton)(E.IExtensionStoragePaths,E.ExtensionStoragePaths)}),define(we[239],be([0,1,22,3,182,224,218,17,75,11,2,228,230]),function(re,e,u,M,E,P,F,T,C,A,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const _=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const i=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");const m=fetch.bind(self);if(self.fetch=function(o,d){return o instanceof Request||/^file:/i.test(String(o))&&(o=A.FileAccess.asBrowserUri(t.URI.parse(String(o))).toString(!0)),m(o,d)},self.XMLHttpRequest=class extends XMLHttpRequest{open(o,d,D,r,w){return/^file:/i.test(d.toString())&&(d=A.FileAccess.asBrowserUri(t.URI.parse(d.toString())).toString(!0)),super.open(o,d,D??!0,r,w)}},self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const o=self.trustedTypes?.createPolicy("extensionHostWorker",{createScriptURL:D=>D}),d=self.Worker;Worker=function(D,r){/^file:/i.test(D.toString())&&(D=A.FileAccess.asBrowserUri(t.URI.parse(D.toString())).toString(!0));const s=`(${function(c){function b(I){return typeof I=="string"||I instanceof URL?String(I).replace(/^file:\/\//i,"vscode-file://vscode-app"):I}const h=fetch.bind(self);self.fetch=function(I,B){return I instanceof Request?h(I,B):h(b(I),B)},self.XMLHttpRequest=class extends XMLHttpRequest{open(I,B,L,k,x){return super.open(I,b(B),L??!0,k,x)}};const y=importScripts.bind(self);self.importScripts=(...I)=>{y(...I.map(b))};const R=self.trustedTypes?self.trustedTypes.createPolicy("extensionHostWorker",{createScriptURL:I=>I}):void 0;y(R?R.createScriptURL(c):c)}.toString()}('${D}'))`;r=r||{},r.name=r.name||T.basename(D.toString());const n=new Blob([s],{type:"application/javascript"}),g=URL.createObjectURL(n);return new d(o?o.createScriptURL(g):g,r)}}else self.Worker=class extends F.NestedWorker{constructor(o,d){super(i,o,{name:T.basename(o.toString()),...d})}};const a=new class{constructor(){this.pid=void 0}exit(o){_()}async exists(o){return!0}async realpath(o){return o}};class f{constructor(){const d=new MessageChannel,D=new M.Emitter;let r=!1;i(d.port2,[d.port2]),d.port1.onmessage=w=>{const{data:s}=w;if(!(s instanceof ArrayBuffer)){console.warn("UNKNOWN data received",s);return}const n=u.VSBuffer.wrap(new Uint8Array(s,0,s.byteLength));if((0,E.isMessageOfType)(n,2)){r=!0,S("received terminate message from renderer");return}D.fire(n)},this.protocol={onMessage:D.event,send:w=>{if(!r){const s=w.buffer.buffer.slice(w.buffer.byteOffset,w.buffer.byteOffset+w.buffer.byteLength);d.port1.postMessage(s,[s])}}}}}function p(o){return new Promise(d=>{const D=o.onMessage(r=>{D.dispose();const w=JSON.parse(r.toString());o.send((0,E.createMessageOfType)(0)),d({protocol:o,initData:w})});o.send((0,E.createMessageOfType)(1))})}let S=o=>_();function v(){const o=new f;C.mark("code/extHost/willConnectToRenderer"),p(o.protocol).then(d=>{C.mark("code/extHost/didWaitForInitData");const D=new P.ExtensionHostMain(d.protocol,d.initData,a,null);S=r=>D.terminate(r)})}e.create=v})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b614fb5db84b3ac07fc3e8b12c69c1dd581924ce/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
